(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.Babel = {}));
}(this, (function (exports) { 'use strict';

	var context = /*#__PURE__*/Object.freeze({
		__proto__: null,
		get version () { return version$3; },
		get DEFAULT_EXTENSIONS () { return DEFAULT_EXTENSIONS; },
		get OptionManager () { return OptionManager; },
		get Plugin () { return Plugin; },
		get File () { return File; },
		get buildExternalHelpers () { return babelBuildExternalHelpers; },
		get resolvePlugin () { return resolvePlugin; },
		get resolvePreset () { return resolvePreset; },
		get getEnv () { return getEnv; },
		get types () { return _t; },
		get tokTypes () { return tokTypes; },
		get traverse () { return traverse; },
		get template () { return template; },
		get createConfigItem () { return createConfigItem; },
		get createConfigItemSync () { return createConfigItemSync; },
		get createConfigItemAsync () { return createConfigItemAsync; },
		get loadPartialConfig () { return loadPartialConfig; },
		get loadPartialConfigSync () { return loadPartialConfigSync; },
		get loadPartialConfigAsync () { return loadPartialConfigAsync; },
		get loadOptions () { return loadOptions; },
		get loadOptionsSync () { return loadOptionsSync; },
		get loadOptionsAsync () { return loadOptionsAsync; },
		get transform () { return transform$3; },
		get transformSync () { return transformSync; },
		get transformAsync () { return transformAsync; },
		get transformFile () { return transformFile; },
		get transformFileSync () { return transformFileSync; },
		get transformFileAsync () { return transformFileAsync; },
		get transformFromAst () { return transformFromAst$1; },
		get transformFromAstSync () { return transformFromAstSync; },
		get transformFromAstAsync () { return transformFromAstAsync; },
		get parse () { return parse$1; },
		get parseSync () { return parseSync; },
		get parseAsync () { return parseAsync; }
	});

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function getAugmentedNamespace(n) {
		if (n.__esModule) return n;
		var a = Object.defineProperty({}, '__esModule', {value: true});
		Object.keys(n).forEach(function (k) {
			var d = Object.getOwnPropertyDescriptor(n, k);
			Object.defineProperty(a, k, d.get ? d : {
				enumerable: true,
				get: function () {
					return n[k];
				}
			});
		});
		return a;
	}

	function createCommonjsModule(fn, basedir, module) {
		return module = {
			path: basedir,
			exports: {},
			require: function (path, base) {
				return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
			}
		}, fn(module, module.exports), module.exports;
	}

	function commonjsRegister (path, loader) {
		DYNAMIC_REQUIRE_LOADERS[path] = loader;
	}

	const DYNAMIC_REQUIRE_LOADERS = Object.create(null);
	const DYNAMIC_REQUIRE_CACHE = Object.create(null);
	const DEFAULT_PARENT_MODULE = {
		id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []
	};
	const CHECKED_EXTENSIONS = ['', '.js', '.json'];

	function normalize$2 (path) {
		path = path.replace(/\\/g, '/');
		const parts = path.split('/');
		const slashed = parts[0] === '';
		for (let i = 1; i < parts.length; i++) {
			if (parts[i] === '.' || parts[i] === '') {
				parts.splice(i--, 1);
			}
		}
		for (let i = 1; i < parts.length; i++) {
			if (parts[i] !== '..') continue;
			if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {
				parts.splice(--i, 2);
				i--;
			}
		}
		path = parts.join('/');
		if (slashed && path[0] !== '/')
		  path = '/' + path;
		else if (path.length === 0)
		  path = '.';
		return path;
	}

	function join$1 () {
		if (arguments.length === 0)
		  return '.';
		let joined;
		for (let i = 0; i < arguments.length; ++i) {
		  let arg = arguments[i];
		  if (arg.length > 0) {
			if (joined === undefined)
			  joined = arg;
			else
			  joined += '/' + arg;
		  }
		}
		if (joined === undefined)
		  return '.';

		return joined;
	}

	function isPossibleNodeModulesPath (modulePath) {
		let c0 = modulePath[0];
		if (c0 === '/' || c0 === '\\') return false;
		let c1 = modulePath[1], c2 = modulePath[2];
		if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\')) ||
			(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\'))) return false;
		if (c1 === ':' && (c2 === '/' || c2 === '\\'))
			return false;
		return true;
	}

	function dirname$1 (path) {
	  if (path.length === 0)
	    return '.';

	  let i = path.length - 1;
	  while (i > 0) {
	    const c = path.charCodeAt(i);
	    if ((c === 47 || c === 92) && i !== path.length - 1)
	      break;
	    i--;
	  }

	  if (i > 0)
	    return path.substr(0, i);

	  if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)
	    return path.charAt(0);

	  return '.';
	}

	function commonjsResolveImpl (path, originalModuleDir, testCache) {
		const shouldTryNodeModules = isPossibleNodeModulesPath(path);
		path = normalize$2(path);
		let relPath;
		if (path[0] === '/') {
			originalModuleDir = '/';
		}
		while (true) {
			if (!shouldTryNodeModules) {
				relPath = originalModuleDir ? normalize$2(originalModuleDir + '/' + path) : path;
			} else if (originalModuleDir) {
				relPath = normalize$2(originalModuleDir + '/node_modules/' + path);
			} else {
				relPath = normalize$2(join$1('node_modules', path));
			}

			if (relPath.endsWith('/..')) {
				break; // Travelled too far up, avoid infinite loop
			}

			for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {
				const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];
				if (DYNAMIC_REQUIRE_CACHE[resolvedPath]) {
					return resolvedPath;
				}			if (DYNAMIC_REQUIRE_LOADERS[resolvedPath]) {
					return resolvedPath;
				}		}
			if (!shouldTryNodeModules) break;
			const nextDir = normalize$2(originalModuleDir + '/..');
			if (nextDir === originalModuleDir) break;
			originalModuleDir = nextDir;
		}
		return null;
	}

	function commonjsResolve (path, originalModuleDir) {
		const resolvedPath = commonjsResolveImpl(path, originalModuleDir);
		if (resolvedPath !== null) {
			return resolvedPath;
		}
		return require.resolve(path);
	}

	function commonjsRequire (path, originalModuleDir) {
		const resolvedPath = commonjsResolveImpl(path, originalModuleDir);
		if (resolvedPath !== null) {
	    let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];
	    if (cachedModule) return cachedModule.exports;
	    const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];
	    if (loader) {
	      DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {
	        id: resolvedPath,
	        filename: resolvedPath,
	        path: dirname$1(resolvedPath),
	        exports: {},
	        parent: DEFAULT_PARENT_MODULE,
	        loaded: false,
	        children: [],
	        paths: [],
	        require: function (path, base) {
	          return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);
	        }
	      };
	      try {
	        loader.call(commonjsGlobal, cachedModule, cachedModule.exports);
	      } catch (error) {
	        delete DYNAMIC_REQUIRE_CACHE[resolvedPath];
	        throw error;
	      }
	      cachedModule.loaded = true;
	      return cachedModule.exports;
	    }	}
		return require(path);
	}

	commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;
	commonjsRequire.resolve = commonjsResolve;

	var regenerate = createCommonjsModule(function (module, exports) {

	  (function (root) {
	    var freeExports = exports;
	    var freeModule = module && module.exports == freeExports && module;
	    var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal;

	    if (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal) {
	      root = freeGlobal;
	    }

	    var ERRORS = {
	      'rangeOrder': 'A range\u2019s `stop` value must be greater than or equal ' + 'to the `start` value.',
	      'codePointRange': 'Invalid code point value. Code points range from ' + 'U+000000 to U+10FFFF.'
	    };
	    var HIGH_SURROGATE_MIN = 0xD800;
	    var HIGH_SURROGATE_MAX = 0xDBFF;
	    var LOW_SURROGATE_MIN = 0xDC00;
	    var LOW_SURROGATE_MAX = 0xDFFF;
	    var regexNull = /\\x00([^0123456789]|$)/g;
	    var object = {};
	    var hasOwnProperty = object.hasOwnProperty;

	    var extend = function (destination, source) {
	      var key;

	      for (key in source) {
	        if (hasOwnProperty.call(source, key)) {
	          destination[key] = source[key];
	        }
	      }

	      return destination;
	    };

	    var forEach = function (array, callback) {
	      var index = -1;
	      var length = array.length;

	      while (++index < length) {
	        callback(array[index], index);
	      }
	    };

	    var toString = object.toString;

	    var isArray = function (value) {
	      return toString.call(value) == '[object Array]';
	    };

	    var isNumber = function (value) {
	      return typeof value == 'number' || toString.call(value) == '[object Number]';
	    };

	    var zeroes = '0000';

	    var pad = function (number, totalCharacters) {
	      var string = String(number);
	      return string.length < totalCharacters ? (zeroes + string).slice(-totalCharacters) : string;
	    };

	    var hex = function (number) {
	      return Number(number).toString(16).toUpperCase();
	    };

	    var slice = [].slice;

	    var dataFromCodePoints = function (codePoints) {
	      var index = -1;
	      var length = codePoints.length;
	      var max = length - 1;
	      var result = [];
	      var isStart = true;
	      var tmp;
	      var previous = 0;

	      while (++index < length) {
	        tmp = codePoints[index];

	        if (isStart) {
	          result.push(tmp);
	          previous = tmp;
	          isStart = false;
	        } else {
	          if (tmp == previous + 1) {
	            if (index != max) {
	              previous = tmp;
	              continue;
	            } else {
	              isStart = true;
	              result.push(tmp + 1);
	            }
	          } else {
	            result.push(previous + 1, tmp);
	            previous = tmp;
	          }
	        }
	      }

	      if (!isStart) {
	        result.push(tmp + 1);
	      }

	      return result;
	    };

	    var dataRemove = function (data, codePoint) {
	      var index = 0;
	      var start;
	      var end;
	      var length = data.length;

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1];

	        if (codePoint >= start && codePoint < end) {
	          if (codePoint == start) {
	            if (end == start + 1) {
	              data.splice(index, 2);
	              return data;
	            } else {
	              data[index] = codePoint + 1;
	              return data;
	            }
	          } else if (codePoint == end - 1) {
	            data[index + 1] = codePoint;
	            return data;
	          } else {
	            data.splice(index, 2, start, codePoint, codePoint + 1, end);
	            return data;
	          }
	        }

	        index += 2;
	      }

	      return data;
	    };

	    var dataRemoveRange = function (data, rangeStart, rangeEnd) {
	      if (rangeEnd < rangeStart) {
	        throw Error(ERRORS.rangeOrder);
	      }

	      var index = 0;
	      var start;
	      var end;

	      while (index < data.length) {
	        start = data[index];
	        end = data[index + 1] - 1;

	        if (start > rangeEnd) {
	          return data;
	        }

	        if (rangeStart <= start && rangeEnd >= end) {
	          data.splice(index, 2);
	          continue;
	        }

	        if (rangeStart >= start && rangeEnd < end) {
	          if (rangeStart == start) {
	            data[index] = rangeEnd + 1;
	            data[index + 1] = end + 1;
	            return data;
	          }

	          data.splice(index, 2, start, rangeStart, rangeEnd + 1, end + 1);
	          return data;
	        }

	        if (rangeStart >= start && rangeStart <= end) {
	          data[index + 1] = rangeStart;
	        } else if (rangeEnd >= start && rangeEnd <= end) {
	          data[index] = rangeEnd + 1;
	          return data;
	        }

	        index += 2;
	      }

	      return data;
	    };

	    var dataAdd = function (data, codePoint) {
	      var index = 0;
	      var start;
	      var end;
	      var lastIndex = null;
	      var length = data.length;

	      if (codePoint < 0x0 || codePoint > 0x10FFFF) {
	        throw RangeError(ERRORS.codePointRange);
	      }

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1];

	        if (codePoint >= start && codePoint < end) {
	          return data;
	        }

	        if (codePoint == start - 1) {
	          data[index] = codePoint;
	          return data;
	        }

	        if (start > codePoint) {
	          data.splice(lastIndex != null ? lastIndex + 2 : 0, 0, codePoint, codePoint + 1);
	          return data;
	        }

	        if (codePoint == end) {
	          if (codePoint + 1 == data[index + 2]) {
	            data.splice(index, 4, start, data[index + 3]);
	            return data;
	          }

	          data[index + 1] = codePoint + 1;
	          return data;
	        }

	        lastIndex = index;
	        index += 2;
	      }

	      data.push(codePoint, codePoint + 1);
	      return data;
	    };

	    var dataAddData = function (dataA, dataB) {
	      var index = 0;
	      var start;
	      var end;
	      var data = dataA.slice();
	      var length = dataB.length;

	      while (index < length) {
	        start = dataB[index];
	        end = dataB[index + 1] - 1;

	        if (start == end) {
	          data = dataAdd(data, start);
	        } else {
	          data = dataAddRange(data, start, end);
	        }

	        index += 2;
	      }

	      return data;
	    };

	    var dataRemoveData = function (dataA, dataB) {
	      var index = 0;
	      var start;
	      var end;
	      var data = dataA.slice();
	      var length = dataB.length;

	      while (index < length) {
	        start = dataB[index];
	        end = dataB[index + 1] - 1;

	        if (start == end) {
	          data = dataRemove(data, start);
	        } else {
	          data = dataRemoveRange(data, start, end);
	        }

	        index += 2;
	      }

	      return data;
	    };

	    var dataAddRange = function (data, rangeStart, rangeEnd) {
	      if (rangeEnd < rangeStart) {
	        throw Error(ERRORS.rangeOrder);
	      }

	      if (rangeStart < 0x0 || rangeStart > 0x10FFFF || rangeEnd < 0x0 || rangeEnd > 0x10FFFF) {
	        throw RangeError(ERRORS.codePointRange);
	      }

	      var index = 0;
	      var start;
	      var end;
	      var added = false;
	      var length = data.length;

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1];

	        if (added) {
	          if (start == rangeEnd + 1) {
	            data.splice(index - 1, 2);
	            return data;
	          }

	          if (start > rangeEnd) {
	            return data;
	          }

	          if (start >= rangeStart && start <= rangeEnd) {
	            if (end > rangeStart && end - 1 <= rangeEnd) {
	              data.splice(index, 2);
	              index -= 2;
	            } else {
	              data.splice(index - 1, 2);
	              index -= 2;
	            }
	          }
	        } else if (start == rangeEnd + 1 || start == rangeEnd) {
	          data[index] = rangeStart;
	          return data;
	        } else if (start > rangeEnd) {
	          data.splice(index, 0, rangeStart, rangeEnd + 1);
	          return data;
	        } else if (rangeStart >= start && rangeStart < end && rangeEnd + 1 <= end) {
	          return data;
	        } else if (rangeStart >= start && rangeStart < end || end == rangeStart) {
	          data[index + 1] = rangeEnd + 1;
	          added = true;
	        } else if (rangeStart <= start && rangeEnd + 1 >= end) {
	          data[index] = rangeStart;
	          data[index + 1] = rangeEnd + 1;
	          added = true;
	        }

	        index += 2;
	      }

	      if (!added) {
	        data.push(rangeStart, rangeEnd + 1);
	      }

	      return data;
	    };

	    var dataContains = function (data, codePoint) {
	      var index = 0;
	      var length = data.length;
	      var start = data[index];
	      var end = data[length - 1];

	      if (length >= 2) {
	        if (codePoint < start || codePoint > end) {
	          return false;
	        }
	      }

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1];

	        if (codePoint >= start && codePoint < end) {
	          return true;
	        }

	        index += 2;
	      }

	      return false;
	    };

	    var dataIntersection = function (data, codePoints) {
	      var index = 0;
	      var length = codePoints.length;
	      var codePoint;
	      var result = [];

	      while (index < length) {
	        codePoint = codePoints[index];

	        if (dataContains(data, codePoint)) {
	          result.push(codePoint);
	        }

	        ++index;
	      }

	      return dataFromCodePoints(result);
	    };

	    var dataIsEmpty = function (data) {
	      return !data.length;
	    };

	    var dataIsSingleton = function (data) {
	      return data.length == 2 && data[0] + 1 == data[1];
	    };

	    var dataToArray = function (data) {
	      var index = 0;
	      var start;
	      var end;
	      var result = [];
	      var length = data.length;

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1];

	        while (start < end) {
	          result.push(start);
	          ++start;
	        }

	        index += 2;
	      }

	      return result;
	    };

	    var floor = Math.floor;

	    var highSurrogate = function (codePoint) {
	      return parseInt(floor((codePoint - 0x10000) / 0x400) + HIGH_SURROGATE_MIN, 10);
	    };

	    var lowSurrogate = function (codePoint) {
	      return parseInt((codePoint - 0x10000) % 0x400 + LOW_SURROGATE_MIN, 10);
	    };

	    var stringFromCharCode = String.fromCharCode;

	    var codePointToString = function (codePoint) {
	      var string;

	      if (codePoint == 0x09) {
	        string = '\\t';
	      } else if (codePoint == 0x0A) {
	        string = '\\n';
	      } else if (codePoint == 0x0C) {
	        string = '\\f';
	      } else if (codePoint == 0x0D) {
	        string = '\\r';
	      } else if (codePoint == 0x2D) {
	        string = '\\x2D';
	      } else if (codePoint == 0x5C) {
	        string = '\\\\';
	      } else if (codePoint == 0x24 || codePoint >= 0x28 && codePoint <= 0x2B || codePoint == 0x2E || codePoint == 0x2F || codePoint == 0x3F || codePoint >= 0x5B && codePoint <= 0x5E || codePoint >= 0x7B && codePoint <= 0x7D) {
	        string = '\\' + stringFromCharCode(codePoint);
	      } else if (codePoint >= 0x20 && codePoint <= 0x7E) {
	        string = stringFromCharCode(codePoint);
	      } else if (codePoint <= 0xFF) {
	        string = '\\x' + pad(hex(codePoint), 2);
	      } else {
	        string = '\\u' + pad(hex(codePoint), 4);
	      }

	      return string;
	    };

	    var codePointToStringUnicode = function (codePoint) {
	      if (codePoint <= 0xFFFF) {
	        return codePointToString(codePoint);
	      }

	      return '\\u{' + codePoint.toString(16).toUpperCase() + '}';
	    };

	    var symbolToCodePoint = function (symbol) {
	      var length = symbol.length;
	      var first = symbol.charCodeAt(0);
	      var second;

	      if (first >= HIGH_SURROGATE_MIN && first <= HIGH_SURROGATE_MAX && length > 1) {
	        second = symbol.charCodeAt(1);
	        return (first - HIGH_SURROGATE_MIN) * 0x400 + second - LOW_SURROGATE_MIN + 0x10000;
	      }

	      return first;
	    };

	    var createBMPCharacterClasses = function (data) {
	      var result = '';
	      var index = 0;
	      var start;
	      var end;
	      var length = data.length;

	      if (dataIsSingleton(data)) {
	        return codePointToString(data[0]);
	      }

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1] - 1;

	        if (start == end) {
	          result += codePointToString(start);
	        } else if (start + 1 == end) {
	          result += codePointToString(start) + codePointToString(end);
	        } else {
	          result += codePointToString(start) + '-' + codePointToString(end);
	        }

	        index += 2;
	      }

	      return '[' + result + ']';
	    };

	    var createUnicodeCharacterClasses = function (data) {
	      var result = '';
	      var index = 0;
	      var start;
	      var end;
	      var length = data.length;

	      if (dataIsSingleton(data)) {
	        return codePointToStringUnicode(data[0]);
	      }

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1] - 1;

	        if (start == end) {
	          result += codePointToStringUnicode(start);
	        } else if (start + 1 == end) {
	          result += codePointToStringUnicode(start) + codePointToStringUnicode(end);
	        } else {
	          result += codePointToStringUnicode(start) + '-' + codePointToStringUnicode(end);
	        }

	        index += 2;
	      }

	      return '[' + result + ']';
	    };

	    var splitAtBMP = function (data) {
	      var loneHighSurrogates = [];
	      var loneLowSurrogates = [];
	      var bmp = [];
	      var astral = [];
	      var index = 0;
	      var start;
	      var end;
	      var length = data.length;

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1] - 1;

	        if (start < HIGH_SURROGATE_MIN) {
	          if (end < HIGH_SURROGATE_MIN) {
	            bmp.push(start, end + 1);
	          }

	          if (end >= HIGH_SURROGATE_MIN && end <= HIGH_SURROGATE_MAX) {
	            bmp.push(start, HIGH_SURROGATE_MIN);
	            loneHighSurrogates.push(HIGH_SURROGATE_MIN, end + 1);
	          }

	          if (end >= LOW_SURROGATE_MIN && end <= LOW_SURROGATE_MAX) {
	            bmp.push(start, HIGH_SURROGATE_MIN);
	            loneHighSurrogates.push(HIGH_SURROGATE_MIN, HIGH_SURROGATE_MAX + 1);
	            loneLowSurrogates.push(LOW_SURROGATE_MIN, end + 1);
	          }

	          if (end > LOW_SURROGATE_MAX) {
	            bmp.push(start, HIGH_SURROGATE_MIN);
	            loneHighSurrogates.push(HIGH_SURROGATE_MIN, HIGH_SURROGATE_MAX + 1);
	            loneLowSurrogates.push(LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1);

	            if (end <= 0xFFFF) {
	              bmp.push(LOW_SURROGATE_MAX + 1, end + 1);
	            } else {
	              bmp.push(LOW_SURROGATE_MAX + 1, 0xFFFF + 1);
	              astral.push(0xFFFF + 1, end + 1);
	            }
	          }
	        } else if (start >= HIGH_SURROGATE_MIN && start <= HIGH_SURROGATE_MAX) {
	          if (end >= HIGH_SURROGATE_MIN && end <= HIGH_SURROGATE_MAX) {
	            loneHighSurrogates.push(start, end + 1);
	          }

	          if (end >= LOW_SURROGATE_MIN && end <= LOW_SURROGATE_MAX) {
	            loneHighSurrogates.push(start, HIGH_SURROGATE_MAX + 1);
	            loneLowSurrogates.push(LOW_SURROGATE_MIN, end + 1);
	          }

	          if (end > LOW_SURROGATE_MAX) {
	            loneHighSurrogates.push(start, HIGH_SURROGATE_MAX + 1);
	            loneLowSurrogates.push(LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1);

	            if (end <= 0xFFFF) {
	              bmp.push(LOW_SURROGATE_MAX + 1, end + 1);
	            } else {
	              bmp.push(LOW_SURROGATE_MAX + 1, 0xFFFF + 1);
	              astral.push(0xFFFF + 1, end + 1);
	            }
	          }
	        } else if (start >= LOW_SURROGATE_MIN && start <= LOW_SURROGATE_MAX) {
	          if (end >= LOW_SURROGATE_MIN && end <= LOW_SURROGATE_MAX) {
	            loneLowSurrogates.push(start, end + 1);
	          }

	          if (end > LOW_SURROGATE_MAX) {
	            loneLowSurrogates.push(start, LOW_SURROGATE_MAX + 1);

	            if (end <= 0xFFFF) {
	              bmp.push(LOW_SURROGATE_MAX + 1, end + 1);
	            } else {
	              bmp.push(LOW_SURROGATE_MAX + 1, 0xFFFF + 1);
	              astral.push(0xFFFF + 1, end + 1);
	            }
	          }
	        } else if (start > LOW_SURROGATE_MAX && start <= 0xFFFF) {
	          if (end <= 0xFFFF) {
	            bmp.push(start, end + 1);
	          } else {
	            bmp.push(start, 0xFFFF + 1);
	            astral.push(0xFFFF + 1, end + 1);
	          }
	        } else {
	          astral.push(start, end + 1);
	        }

	        index += 2;
	      }

	      return {
	        'loneHighSurrogates': loneHighSurrogates,
	        'loneLowSurrogates': loneLowSurrogates,
	        'bmp': bmp,
	        'astral': astral
	      };
	    };

	    var optimizeSurrogateMappings = function (surrogateMappings) {
	      var result = [];
	      var tmpLow = [];
	      var addLow = false;
	      var mapping;
	      var nextMapping;
	      var highSurrogates;
	      var lowSurrogates;
	      var nextHighSurrogates;
	      var nextLowSurrogates;
	      var index = -1;
	      var length = surrogateMappings.length;

	      while (++index < length) {
	        mapping = surrogateMappings[index];
	        nextMapping = surrogateMappings[index + 1];

	        if (!nextMapping) {
	          result.push(mapping);
	          continue;
	        }

	        highSurrogates = mapping[0];
	        lowSurrogates = mapping[1];
	        nextHighSurrogates = nextMapping[0];
	        nextLowSurrogates = nextMapping[1];
	        tmpLow = lowSurrogates;

	        while (nextHighSurrogates && highSurrogates[0] == nextHighSurrogates[0] && highSurrogates[1] == nextHighSurrogates[1]) {
	          if (dataIsSingleton(nextLowSurrogates)) {
	            tmpLow = dataAdd(tmpLow, nextLowSurrogates[0]);
	          } else {
	            tmpLow = dataAddRange(tmpLow, nextLowSurrogates[0], nextLowSurrogates[1] - 1);
	          }

	          ++index;
	          mapping = surrogateMappings[index];
	          highSurrogates = mapping[0];
	          lowSurrogates = mapping[1];
	          nextMapping = surrogateMappings[index + 1];
	          nextHighSurrogates = nextMapping && nextMapping[0];
	          nextLowSurrogates = nextMapping && nextMapping[1];
	          addLow = true;
	        }

	        result.push([highSurrogates, addLow ? tmpLow : lowSurrogates]);
	        addLow = false;
	      }

	      return optimizeByLowSurrogates(result);
	    };

	    var optimizeByLowSurrogates = function (surrogateMappings) {
	      if (surrogateMappings.length == 1) {
	        return surrogateMappings;
	      }

	      var index = -1;
	      var innerIndex = -1;

	      while (++index < surrogateMappings.length) {
	        var mapping = surrogateMappings[index];
	        var lowSurrogates = mapping[1];
	        var lowSurrogateStart = lowSurrogates[0];
	        var lowSurrogateEnd = lowSurrogates[1];
	        innerIndex = index;

	        while (++innerIndex < surrogateMappings.length) {
	          var otherMapping = surrogateMappings[innerIndex];
	          var otherLowSurrogates = otherMapping[1];
	          var otherLowSurrogateStart = otherLowSurrogates[0];
	          var otherLowSurrogateEnd = otherLowSurrogates[1];

	          if (lowSurrogateStart == otherLowSurrogateStart && lowSurrogateEnd == otherLowSurrogateEnd && otherLowSurrogates.length === 2) {
	            if (dataIsSingleton(otherMapping[0])) {
	              mapping[0] = dataAdd(mapping[0], otherMapping[0][0]);
	            } else {
	              mapping[0] = dataAddRange(mapping[0], otherMapping[0][0], otherMapping[0][1] - 1);
	            }

	            surrogateMappings.splice(innerIndex, 1);
	            --innerIndex;
	          }
	        }
	      }

	      return surrogateMappings;
	    };

	    var surrogateSet = function (data) {
	      if (!data.length) {
	        return [];
	      }

	      var index = 0;
	      var start;
	      var end;
	      var startHigh;
	      var startLow;
	      var endHigh;
	      var endLow;
	      var surrogateMappings = [];
	      var length = data.length;

	      while (index < length) {
	        start = data[index];
	        end = data[index + 1] - 1;
	        startHigh = highSurrogate(start);
	        startLow = lowSurrogate(start);
	        endHigh = highSurrogate(end);
	        endLow = lowSurrogate(end);
	        var startsWithLowestLowSurrogate = startLow == LOW_SURROGATE_MIN;
	        var endsWithHighestLowSurrogate = endLow == LOW_SURROGATE_MAX;
	        var complete = false;

	        if (startHigh == endHigh || startsWithLowestLowSurrogate && endsWithHighestLowSurrogate) {
	          surrogateMappings.push([[startHigh, endHigh + 1], [startLow, endLow + 1]]);
	          complete = true;
	        } else {
	          surrogateMappings.push([[startHigh, startHigh + 1], [startLow, LOW_SURROGATE_MAX + 1]]);
	        }

	        if (!complete && startHigh + 1 < endHigh) {
	          if (endsWithHighestLowSurrogate) {
	            surrogateMappings.push([[startHigh + 1, endHigh + 1], [LOW_SURROGATE_MIN, endLow + 1]]);
	            complete = true;
	          } else {
	            surrogateMappings.push([[startHigh + 1, endHigh], [LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1]]);
	          }
	        }

	        if (!complete) {
	          surrogateMappings.push([[endHigh, endHigh + 1], [LOW_SURROGATE_MIN, endLow + 1]]);
	        }

	        index += 2;
	      }

	      return optimizeSurrogateMappings(surrogateMappings);
	    };

	    var createSurrogateCharacterClasses = function (surrogateMappings) {
	      var result = [];
	      forEach(surrogateMappings, function (surrogateMapping) {
	        var highSurrogates = surrogateMapping[0];
	        var lowSurrogates = surrogateMapping[1];
	        result.push(createBMPCharacterClasses(highSurrogates) + createBMPCharacterClasses(lowSurrogates));
	      });
	      return result.join('|');
	    };

	    var createCharacterClassesFromData = function (data, bmpOnly, hasUnicodeFlag) {
	      if (hasUnicodeFlag) {
	        return createUnicodeCharacterClasses(data);
	      }

	      var result = [];
	      var parts = splitAtBMP(data);
	      var loneHighSurrogates = parts.loneHighSurrogates;
	      var loneLowSurrogates = parts.loneLowSurrogates;
	      var bmp = parts.bmp;
	      var astral = parts.astral;
	      var hasLoneHighSurrogates = !dataIsEmpty(loneHighSurrogates);
	      var hasLoneLowSurrogates = !dataIsEmpty(loneLowSurrogates);
	      var surrogateMappings = surrogateSet(astral);

	      if (bmpOnly) {
	        bmp = dataAddData(bmp, loneHighSurrogates);
	        hasLoneHighSurrogates = false;
	        bmp = dataAddData(bmp, loneLowSurrogates);
	        hasLoneLowSurrogates = false;
	      }

	      if (!dataIsEmpty(bmp)) {
	        result.push(createBMPCharacterClasses(bmp));
	      }

	      if (surrogateMappings.length) {
	        result.push(createSurrogateCharacterClasses(surrogateMappings));
	      }

	      if (hasLoneHighSurrogates) {
	        result.push(createBMPCharacterClasses(loneHighSurrogates) + '(?![\\uDC00-\\uDFFF])');
	      }

	      if (hasLoneLowSurrogates) {
	        result.push('(?:[^\\uD800-\\uDBFF]|^)' + createBMPCharacterClasses(loneLowSurrogates));
	      }

	      return result.join('|');
	    };

	    var regenerate = function (value) {
	      if (arguments.length > 1) {
	        value = slice.call(arguments);
	      }

	      if (this instanceof regenerate) {
	        this.data = [];
	        return value ? this.add(value) : this;
	      }

	      return new regenerate().add(value);
	    };

	    regenerate.version = '1.4.2';
	    var proto = regenerate.prototype;
	    extend(proto, {
	      'add': function (value) {
	        var $this = this;

	        if (value == null) {
	          return $this;
	        }

	        if (value instanceof regenerate) {
	          $this.data = dataAddData($this.data, value.data);
	          return $this;
	        }

	        if (arguments.length > 1) {
	          value = slice.call(arguments);
	        }

	        if (isArray(value)) {
	          forEach(value, function (item) {
	            $this.add(item);
	          });
	          return $this;
	        }

	        $this.data = dataAdd($this.data, isNumber(value) ? value : symbolToCodePoint(value));
	        return $this;
	      },
	      'remove': function (value) {
	        var $this = this;

	        if (value == null) {
	          return $this;
	        }

	        if (value instanceof regenerate) {
	          $this.data = dataRemoveData($this.data, value.data);
	          return $this;
	        }

	        if (arguments.length > 1) {
	          value = slice.call(arguments);
	        }

	        if (isArray(value)) {
	          forEach(value, function (item) {
	            $this.remove(item);
	          });
	          return $this;
	        }

	        $this.data = dataRemove($this.data, isNumber(value) ? value : symbolToCodePoint(value));
	        return $this;
	      },
	      'addRange': function (start, end) {
	        var $this = this;
	        $this.data = dataAddRange($this.data, isNumber(start) ? start : symbolToCodePoint(start), isNumber(end) ? end : symbolToCodePoint(end));
	        return $this;
	      },
	      'removeRange': function (start, end) {
	        var $this = this;
	        var startCodePoint = isNumber(start) ? start : symbolToCodePoint(start);
	        var endCodePoint = isNumber(end) ? end : symbolToCodePoint(end);
	        $this.data = dataRemoveRange($this.data, startCodePoint, endCodePoint);
	        return $this;
	      },
	      'intersection': function (argument) {
	        var $this = this;
	        var array = argument instanceof regenerate ? dataToArray(argument.data) : argument;
	        $this.data = dataIntersection($this.data, array);
	        return $this;
	      },
	      'contains': function (codePoint) {
	        return dataContains(this.data, isNumber(codePoint) ? codePoint : symbolToCodePoint(codePoint));
	      },
	      'clone': function () {
	        var set = new regenerate();
	        set.data = this.data.slice(0);
	        return set;
	      },
	      'toString': function (options) {
	        var result = createCharacterClassesFromData(this.data, options ? options.bmpOnly : false, options ? options.hasUnicodeFlag : false);

	        if (!result) {
	          return '[]';
	        }

	        return result.replace(regexNull, '\\0$1');
	      },
	      'toRegExp': function (flags) {
	        var pattern = this.toString(flags && flags.indexOf('u') != -1 ? {
	          'hasUnicodeFlag': true
	        } : null);
	        return RegExp(pattern, flags || '');
	      },
	      'valueOf': function () {
	        return dataToArray(this.data);
	      }
	    });
	    proto.toArray = proto.valueOf;

	    if (freeExports && !freeExports.nodeType) {
	      if (freeModule) {
	        freeModule.exports = regenerate;
	      } else {
	        freeExports.regenerate = regenerate;
	      }
	    } else {
	      root.regenerate = regenerate;
	    }
	  })(commonjsGlobal);
	}, "/$$rollup_base$$/node_modules/regenerate");

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Alphabetic.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xB5, 0xBA, 0x2EC, 0x2EE, 0x345, 0x37F, 0x386, 0x38C, 0x559, 0x5BF, 0x5C7, 0x6FF, 0x7FA, 0x9B2, 0x9CE, 0x9D7, 0x9FC, 0xA51, 0xA5E, 0xAD0, 0xB71, 0xB9C, 0xBD0, 0xBD7, 0xC5D, 0xD4E, 0xDBD, 0xDD6, 0xE4D, 0xE84, 0xEA5, 0xEC6, 0xECD, 0xF00, 0x1038, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x17DC, 0x1AA7, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0x2E2F, 0xA7D3, 0xA8C5, 0xA8FB, 0xA9CF, 0xAAC0, 0xAAC2, 0xFB3E, 0x10808, 0x1083C, 0x10F27, 0x110C2, 0x11176, 0x111DA, 0x111DC, 0x11237, 0x1123E, 0x11288, 0x11350, 0x11357, 0x114C7, 0x11640, 0x11644, 0x116B8, 0x11909, 0x119E1, 0x11A9D, 0x11C40, 0x11D3A, 0x11D43, 0x11D98, 0x11FB0, 0x16FE3, 0x1BC9E, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E14E, 0x1E947, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x374).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x5B0, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x610, 0x61A).addRange(0x620, 0x657).addRange(0x659, 0x65F).addRange(0x66E, 0x6D3).addRange(0x6D5, 0x6DC).addRange(0x6E1, 0x6E8).addRange(0x6ED, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x710, 0x73F).addRange(0x74D, 0x7B1).addRange(0x7CA, 0x7EA).addRange(0x7F4, 0x7F5).addRange(0x800, 0x817).addRange(0x81A, 0x82C).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x8D4, 0x8DF).addRange(0x8E3, 0x8E9).addRange(0x8F0, 0x93B).addRange(0x93D, 0x94C).addRange(0x94E, 0x950).addRange(0x955, 0x963).addRange(0x971, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8);
	set.addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BD, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CC).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E3).addRange(0x9F0, 0x9F1).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4C).addRange(0xA59, 0xA5C).addRange(0xA70, 0xA75).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABD, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACC).addRange(0xAE0, 0xAE3).addRange(0xAF9, 0xAFC).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3D, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4C).addRange(0xB56, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A);
	set.addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCC).addRange(0xC00, 0xC03).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3D, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4C).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC80, 0xC83).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBD, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCC).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCF1, 0xCF2).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD3D, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4C).addRange(0xD54, 0xD57).addRange(0xD5F, 0xD63).addRange(0xD7A, 0xD7F).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDF2, 0xDF3).addRange(0xE01, 0xE3A).addRange(0xE40, 0xE46).addRange(0xE81, 0xE82);
	set.addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB9).addRange(0xEBB, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF81).addRange(0xF88, 0xF97).addRange(0xF99, 0xFBC).addRange(0x1000, 0x1036).addRange(0x103B, 0x103F).addRange(0x1050, 0x108F).addRange(0x109A, 0x109D).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1713).addRange(0x171F, 0x1733).addRange(0x1740, 0x1753).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773).addRange(0x1780, 0x17B3).addRange(0x17B6, 0x17C8).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E);
	set.addRange(0x1920, 0x192B).addRange(0x1930, 0x1938).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A1B).addRange(0x1A20, 0x1A5E).addRange(0x1A61, 0x1A74).addRange(0x1ABF, 0x1AC0).addRange(0x1ACC, 0x1ACE).addRange(0x1B00, 0x1B33).addRange(0x1B35, 0x1B43).addRange(0x1B45, 0x1B4C).addRange(0x1B80, 0x1BA9).addRange(0x1BAC, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1BE7, 0x1BF1).addRange(0x1C00, 0x1C36).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6).addRange(0x1D00, 0x1DBF).addRange(0x1DE7, 0x1DF4).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x212F, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149);
	set.addRange(0x2160, 0x2188).addRange(0x24B6, 0x24E9).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2DE0, 0x2DFF).addRange(0x3005, 0x3007).addRange(0x3021, 0x3029).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x309D, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA674, 0xA67B).addRange(0xA67F, 0xA6EF).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA805).addRange(0xA807, 0xA827).addRange(0xA840, 0xA873).addRange(0xA880, 0xA8C3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FF).addRange(0xA90A, 0xA92A).addRange(0xA930, 0xA952);
	set.addRange(0xA960, 0xA97C).addRange(0xA980, 0xA9B2).addRange(0xA9B4, 0xA9BF).addRange(0xA9E0, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA60, 0xAA76).addRange(0xAA7A, 0xAABE).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEF).addRange(0xAAF2, 0xAAF5).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABEA).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1D, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D);
	set.addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x1037A).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7);
	set.addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D27).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAC).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11000, 0x11045).addRange(0x11071, 0x11075).addRange(0x11082, 0x110B8).addRange(0x110D0, 0x110E8).addRange(0x11100, 0x11132).addRange(0x11144, 0x11147).addRange(0x11150, 0x11172).addRange(0x11180, 0x111BF).addRange(0x111C1, 0x111C4).addRange(0x111CE, 0x111CF).addRange(0x11200, 0x11211).addRange(0x11213, 0x11234).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112E8).addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133D, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134C).addRange(0x1135D, 0x11363).addRange(0x11400, 0x11441).addRange(0x11443, 0x11445).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114C1).addRange(0x114C4, 0x114C5);
	set.addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115BE).addRange(0x115D8, 0x115DD).addRange(0x11600, 0x1163E).addRange(0x11680, 0x116B5).addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172A).addRange(0x11740, 0x11746).addRange(0x11800, 0x11838).addRange(0x118A0, 0x118DF).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x1193C).addRange(0x1193F, 0x11942).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119DF).addRange(0x119E3, 0x119E4).addRange(0x11A00, 0x11A32).addRange(0x11A35, 0x11A3E).addRange(0x11A50, 0x11A97).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C3E).addRange(0x11C72, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D41).addRange(0x11D46, 0x11D47).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D96).addRange(0x11EE0, 0x11EF6).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342E).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E);
	set.addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B40, 0x16B43).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8);
	set.addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF1E).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E900, 0x1E943).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1F130, 0x1F149).addRange(0x1F150, 0x1F169).addRange(0x1F170, 0x1F189).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Any.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x0, 0x10FFFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/ASCII_Hex_Digit.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x30, 0x39).addRange(0x41, 0x46).addRange(0x61, 0x66);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/ASCII.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x0, 0x7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Assigned.js", function (module, exports) {
	  const set = regenerate(0x38C, 0x85E, 0x9B2, 0x9D7, 0xA3C, 0xA51, 0xA5E, 0xAD0, 0xB9C, 0xBD0, 0xBD7, 0xC5D, 0xDBD, 0xDCA, 0xDD6, 0xE84, 0xEA5, 0xEC6, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x1940, 0x1F59, 0x1F5B, 0x1F5D, 0x2D27, 0x2D2D, 0xA7D3, 0xFB3E, 0xFDCF, 0xFEFF, 0x101A0, 0x10808, 0x1083C, 0x1093F, 0x110CD, 0x11288, 0x11350, 0x11357, 0x11909, 0x11D3A, 0x11FB0, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E2FF, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E, 0x1F7F0, 0xE0001);
	set.addRange(0x0, 0x377).addRange(0x37A, 0x37F).addRange(0x384, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x52F).addRange(0x531, 0x556).addRange(0x559, 0x58A).addRange(0x58D, 0x58F).addRange(0x591, 0x5C7).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F4).addRange(0x600, 0x70D).addRange(0x70F, 0x74A).addRange(0x74D, 0x7B1).addRange(0x7C0, 0x7FA).addRange(0x7FD, 0x82D).addRange(0x830, 0x83E).addRange(0x840, 0x85B).addRange(0x860, 0x86A).addRange(0x870, 0x88E).addRange(0x890, 0x891).addRange(0x898, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9FE).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA76).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0);
	set.addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAF1).addRange(0xAF9, 0xAFF).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB77).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBFA).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC77, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9);
	set.addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF2).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4F).addRange(0xD54, 0xD63).addRange(0xD66, 0xD7F).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF4).addRange(0xE01, 0xE3A).addRange(0xE3F, 0xE5B).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECD).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF).addRange(0xF00, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF97).addRange(0xF99, 0xFBC).addRange(0xFBE, 0xFCC).addRange(0xFCE, 0xFDA).addRange(0x1000, 0x10C5).addRange(0x10D0, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5);
	set.addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x137C).addRange(0x1380, 0x1399).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1400, 0x169C).addRange(0x16A0, 0x16F8).addRange(0x1700, 0x1715).addRange(0x171F, 0x1736).addRange(0x1740, 0x1753).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773).addRange(0x1780, 0x17DD).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x1800, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1944, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x19DE, 0x1A1B).addRange(0x1A1E, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AA0, 0x1AAD).addRange(0x1AB0, 0x1ACE).addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B7E).addRange(0x1B80, 0x1BF3).addRange(0x1BFC, 0x1C37).addRange(0x1C3B, 0x1C49).addRange(0x1C4D, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CC7).addRange(0x1CD0, 0x1CFA).addRange(0x1D00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D);
	set.addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FC4).addRange(0x1FC6, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FDD, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFE).addRange(0x2000, 0x2064).addRange(0x2066, 0x2071).addRange(0x2074, 0x208E).addRange(0x2090, 0x209C).addRange(0x20A0, 0x20C0).addRange(0x20D0, 0x20F0).addRange(0x2100, 0x218B).addRange(0x2190, 0x2426).addRange(0x2440, 0x244A).addRange(0x2460, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2CF3).addRange(0x2CF9, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D6F, 0x2D70).addRange(0x2D7F, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2DE0, 0x2E5D).addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x2FF0, 0x2FFB).addRange(0x3000, 0x303F).addRange(0x3041, 0x3096).addRange(0x3099, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x3190, 0x31E3).addRange(0x31F0, 0x321E).addRange(0x3220, 0xA48C).addRange(0xA490, 0xA4C6).addRange(0xA4D0, 0xA62B).addRange(0xA640, 0xA6F7).addRange(0xA700, 0xA7CA).addRange(0xA7D0, 0xA7D1);
	set.addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA82C).addRange(0xA830, 0xA839).addRange(0xA840, 0xA877).addRange(0xA880, 0xA8C5).addRange(0xA8CE, 0xA8D9).addRange(0xA8E0, 0xA953).addRange(0xA95F, 0xA97C).addRange(0xA980, 0xA9CD).addRange(0xA9CF, 0xA9D9).addRange(0xA9DE, 0xA9FE).addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA5C, 0xAAC2).addRange(0xAADB, 0xAAF6).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB6B).addRange(0xAB70, 0xABED).addRange(0xABF0, 0xABF9).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xD800, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1D, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBC2).addRange(0xFBD3, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFE19).addRange(0xFE20, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF01, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE);
	set.addRange(0xFFF9, 0xFFFD).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1018E).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FD).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x102E0, 0x102FB).addRange(0x10300, 0x10323).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x1037A).addRange(0x10380, 0x1039D).addRange(0x1039F, 0x103C3).addRange(0x103C8, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104A0, 0x104A9).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x1056F, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10857, 0x1089E).addRange(0x108A7, 0x108AF).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x108FB, 0x1091B);
	set.addRange(0x1091F, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BC, 0x109CF).addRange(0x109D2, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A3F, 0x10A48).addRange(0x10A50, 0x10A58).addRange(0x10A60, 0x10A9F).addRange(0x10AC0, 0x10AE6).addRange(0x10AEB, 0x10AF6).addRange(0x10B00, 0x10B35).addRange(0x10B39, 0x10B55).addRange(0x10B58, 0x10B72).addRange(0x10B78, 0x10B91).addRange(0x10B99, 0x10B9C).addRange(0x10BA9, 0x10BAF).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10CFA, 0x10D27).addRange(0x10D30, 0x10D39).addRange(0x10E60, 0x10E7E).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAD).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F27).addRange(0x10F30, 0x10F59).addRange(0x10F70, 0x10F89).addRange(0x10FB0, 0x10FCB).addRange(0x10FE0, 0x10FF6).addRange(0x11000, 0x1104D).addRange(0x11052, 0x11075).addRange(0x1107F, 0x110C2).addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9).addRange(0x11100, 0x11134).addRange(0x11136, 0x11147).addRange(0x11150, 0x11176).addRange(0x11180, 0x111DF).addRange(0x111E1, 0x111F4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1123E).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A9).addRange(0x112B0, 0x112EA);
	set.addRange(0x112F0, 0x112F9).addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133B, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11400, 0x1145B).addRange(0x1145D, 0x11461).addRange(0x11480, 0x114C7).addRange(0x114D0, 0x114D9).addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115DD).addRange(0x11600, 0x11644).addRange(0x11650, 0x11659).addRange(0x11660, 0x1166C).addRange(0x11680, 0x116B9).addRange(0x116C0, 0x116C9).addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11746).addRange(0x11800, 0x1183B).addRange(0x118A0, 0x118F2).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11946).addRange(0x11950, 0x11959).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E4).addRange(0x11A00, 0x11A47).addRange(0x11A50, 0x11AA2).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C45).addRange(0x11C50, 0x11C6C).addRange(0x11C70, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D00, 0x11D06);
	set.addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9).addRange(0x11EE0, 0x11EF8).addRange(0x11FC0, 0x11FF1).addRange(0x11FFF, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12470, 0x12474).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF2).addRange(0x13000, 0x1342E).addRange(0x13430, 0x13438).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A6E, 0x16ABE).addRange(0x16AC0, 0x16AC9).addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF5).addRange(0x16B00, 0x16B45).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E9A).addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE4).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C);
	set.addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9C, 0x1BCA3).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D1EA).addRange(0x1D200, 0x1D245).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D300, 0x1D356).addRange(0x1D360, 0x1D378).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1DA8B).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1DF00, 0x1DF1E).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E14E, 0x1E14F).addRange(0x1E290, 0x1E2AE).addRange(0x1E2C0, 0x1E2F9).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E8C7, 0x1E8D6);
	set.addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1E95E, 0x1E95F).addRange(0x1EC71, 0x1ECB4).addRange(0x1ED01, 0x1ED3D).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F100, 0x1F1AD).addRange(0x1F1E6, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DD, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F773).addRange(0x1F780, 0x1F7D8).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C);
	set.addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA).addRange(0x1FBF0, 0x1FBF9).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0xE0020, 0xE007F).addRange(0xE0100, 0xE01EF).addRange(0xF0000, 0xFFFFD).addRange(0x100000, 0x10FFFD);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Bidi_Control.js", function (module, exports) {
	  const set = regenerate(0x61C);
	set.addRange(0x200E, 0x200F).addRange(0x202A, 0x202E).addRange(0x2066, 0x2069);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Bidi_Mirrored.js", function (module, exports) {
	  const set = regenerate(0x3C, 0x3E, 0x5B, 0x5D, 0x7B, 0x7D, 0xAB, 0xBB, 0x2140, 0x2211, 0x2224, 0x2226, 0x2239, 0x2262, 0x2298, 0x27C0, 0x29B8, 0x29C9, 0x29E1, 0x2A24, 0x2A26, 0x2A29, 0x2ADC, 0x2ADE, 0x2AF3, 0x2AFD, 0x2BFE, 0xFF1C, 0xFF1E, 0xFF3B, 0xFF3D, 0xFF5B, 0xFF5D, 0x1D6DB, 0x1D715, 0x1D74F, 0x1D789, 0x1D7C3);
	set.addRange(0x28, 0x29).addRange(0xF3A, 0xF3D).addRange(0x169B, 0x169C).addRange(0x2039, 0x203A).addRange(0x2045, 0x2046).addRange(0x207D, 0x207E).addRange(0x208D, 0x208E).addRange(0x2201, 0x2204).addRange(0x2208, 0x220D).addRange(0x2215, 0x2216).addRange(0x221A, 0x221D).addRange(0x221F, 0x2222).addRange(0x222B, 0x2233).addRange(0x223B, 0x224C).addRange(0x2252, 0x2255).addRange(0x225F, 0x2260).addRange(0x2264, 0x226B).addRange(0x226E, 0x228C).addRange(0x228F, 0x2292).addRange(0x22A2, 0x22A3).addRange(0x22A6, 0x22B8).addRange(0x22BE, 0x22BF).addRange(0x22C9, 0x22CD).addRange(0x22D0, 0x22D1).addRange(0x22D6, 0x22ED).addRange(0x22F0, 0x22FF).addRange(0x2308, 0x230B).addRange(0x2320, 0x2321).addRange(0x2329, 0x232A).addRange(0x2768, 0x2775).addRange(0x27C3, 0x27C6).addRange(0x27C8, 0x27C9).addRange(0x27CB, 0x27CD).addRange(0x27D3, 0x27D6).addRange(0x27DC, 0x27DE).addRange(0x27E2, 0x27EF).addRange(0x2983, 0x2998).addRange(0x299B, 0x29A0).addRange(0x29A2, 0x29AF).addRange(0x29C0, 0x29C5).addRange(0x29CE, 0x29D2).addRange(0x29D4, 0x29D5).addRange(0x29D8, 0x29DC).addRange(0x29E3, 0x29E5).addRange(0x29E8, 0x29E9).addRange(0x29F4, 0x29F9).addRange(0x29FC, 0x29FD).addRange(0x2A0A, 0x2A1C).addRange(0x2A1E, 0x2A21).addRange(0x2A2B, 0x2A2E).addRange(0x2A34, 0x2A35);
	set.addRange(0x2A3C, 0x2A3E).addRange(0x2A57, 0x2A58).addRange(0x2A64, 0x2A65).addRange(0x2A6A, 0x2A6D).addRange(0x2A6F, 0x2A70).addRange(0x2A73, 0x2A74).addRange(0x2A79, 0x2AA3).addRange(0x2AA6, 0x2AAD).addRange(0x2AAF, 0x2AD6).addRange(0x2AE2, 0x2AE6).addRange(0x2AEC, 0x2AEE).addRange(0x2AF7, 0x2AFB).addRange(0x2E02, 0x2E05).addRange(0x2E09, 0x2E0A).addRange(0x2E0C, 0x2E0D).addRange(0x2E1C, 0x2E1D).addRange(0x2E20, 0x2E29).addRange(0x2E55, 0x2E5C).addRange(0x3008, 0x3011).addRange(0x3014, 0x301B).addRange(0xFE59, 0xFE5E).addRange(0xFE64, 0xFE65).addRange(0xFF08, 0xFF09).addRange(0xFF5F, 0xFF60).addRange(0xFF62, 0xFF63);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Case_Ignorable.js", function (module, exports) {
	  const set = regenerate(0x27, 0x2E, 0x3A, 0x5E, 0x60, 0xA8, 0xAD, 0xAF, 0xB4, 0x37A, 0x387, 0x559, 0x55F, 0x5BF, 0x5C7, 0x5F4, 0x61C, 0x640, 0x670, 0x70F, 0x711, 0x7FA, 0x7FD, 0x888, 0x93A, 0x93C, 0x94D, 0x971, 0x981, 0x9BC, 0x9CD, 0x9FE, 0xA3C, 0xA51, 0xA75, 0xABC, 0xACD, 0xB01, 0xB3C, 0xB3F, 0xB4D, 0xB82, 0xBC0, 0xBCD, 0xC00, 0xC04, 0xC3C, 0xC81, 0xCBC, 0xCBF, 0xCC6, 0xD4D, 0xD81, 0xDCA, 0xDD6, 0xE31, 0xEB1, 0xEC6, 0xF35, 0xF37, 0xF39, 0xFC6, 0x1082, 0x108D, 0x109D, 0x10FC, 0x17C6, 0x17D7, 0x17DD, 0x1843, 0x18A9, 0x1932, 0x1A1B, 0x1A56, 0x1A60, 0x1A62, 0x1A7F, 0x1AA7, 0x1B34, 0x1B3C, 0x1B42, 0x1BE6, 0x1BED, 0x1CED, 0x1CF4, 0x1D78, 0x1FBD, 0x2024, 0x2027, 0x2071, 0x207F, 0x2D6F, 0x2D7F, 0x2E2F, 0x3005, 0x303B, 0xA015, 0xA60C, 0xA67F, 0xA770, 0xA802, 0xA806, 0xA80B, 0xA82C, 0xA8FF, 0xA9B3, 0xA9CF, 0xAA43, 0xAA4C, 0xAA70, 0xAA7C, 0xAAB0, 0xAAC1, 0xAADD, 0xAAF6, 0xABE5, 0xABE8, 0xABED, 0xFB1E, 0xFE13, 0xFE52, 0xFE55, 0xFEFF, 0xFF07, 0xFF0E, 0xFF1A, 0xFF3E, 0xFF40, 0xFF70, 0xFFE3, 0x101FD, 0x102E0, 0x10A3F, 0x11001, 0x11070, 0x110BD, 0x110C2, 0x110CD, 0x11173, 0x111CF, 0x11234, 0x1123E, 0x112DF, 0x11340, 0x11446, 0x1145E, 0x114BA, 0x1163D, 0x116AB, 0x116AD, 0x116B7, 0x1193E, 0x11943, 0x119E0, 0x11A47, 0x11C3F, 0x11D3A, 0x11D47, 0x11D95, 0x11D97, 0x16F4F, 0x1DA75, 0x1DA84, 0x1E2AE, 0xE0001);
	set.addRange(0xB7, 0xB8).addRange(0x2B0, 0x36F).addRange(0x374, 0x375).addRange(0x384, 0x385).addRange(0x483, 0x489).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x600, 0x605).addRange(0x610, 0x61A).addRange(0x64B, 0x65F).addRange(0x6D6, 0x6DD).addRange(0x6DF, 0x6E8).addRange(0x6EA, 0x6ED).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F5).addRange(0x816, 0x82D).addRange(0x859, 0x85B).addRange(0x890, 0x891).addRange(0x898, 0x89F).addRange(0x8C9, 0x902).addRange(0x941, 0x948).addRange(0x951, 0x957).addRange(0x962, 0x963).addRange(0x9C1, 0x9C4).addRange(0x9E2, 0x9E3).addRange(0xA01, 0xA02).addRange(0xA41, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA70, 0xA71).addRange(0xA81, 0xA82).addRange(0xAC1, 0xAC5).addRange(0xAC7, 0xAC8).addRange(0xAE2, 0xAE3).addRange(0xAFA, 0xAFF).addRange(0xB41, 0xB44).addRange(0xB55, 0xB56).addRange(0xB62, 0xB63).addRange(0xC3E, 0xC40).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC62, 0xC63).addRange(0xCCC, 0xCCD).addRange(0xCE2, 0xCE3).addRange(0xD00, 0xD01).addRange(0xD3B, 0xD3C).addRange(0xD41, 0xD44).addRange(0xD62, 0xD63);
	set.addRange(0xDD2, 0xDD4).addRange(0xE34, 0xE3A).addRange(0xE46, 0xE4E).addRange(0xEB4, 0xEBC).addRange(0xEC8, 0xECD).addRange(0xF18, 0xF19).addRange(0xF71, 0xF7E).addRange(0xF80, 0xF84).addRange(0xF86, 0xF87).addRange(0xF8D, 0xF97).addRange(0xF99, 0xFBC).addRange(0x102D, 0x1030).addRange(0x1032, 0x1037).addRange(0x1039, 0x103A).addRange(0x103D, 0x103E).addRange(0x1058, 0x1059).addRange(0x105E, 0x1060).addRange(0x1071, 0x1074).addRange(0x1085, 0x1086).addRange(0x135D, 0x135F).addRange(0x1712, 0x1714).addRange(0x1732, 0x1733).addRange(0x1752, 0x1753).addRange(0x1772, 0x1773).addRange(0x17B4, 0x17B5).addRange(0x17B7, 0x17BD).addRange(0x17C9, 0x17D3).addRange(0x180B, 0x180F).addRange(0x1885, 0x1886).addRange(0x1920, 0x1922).addRange(0x1927, 0x1928).addRange(0x1939, 0x193B).addRange(0x1A17, 0x1A18).addRange(0x1A58, 0x1A5E).addRange(0x1A65, 0x1A6C).addRange(0x1A73, 0x1A7C).addRange(0x1AB0, 0x1ACE).addRange(0x1B00, 0x1B03).addRange(0x1B36, 0x1B3A).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1B81).addRange(0x1BA2, 0x1BA5).addRange(0x1BA8, 0x1BA9).addRange(0x1BAB, 0x1BAD).addRange(0x1BE8, 0x1BE9).addRange(0x1BEF, 0x1BF1).addRange(0x1C2C, 0x1C33).addRange(0x1C36, 0x1C37).addRange(0x1C78, 0x1C7D).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CE0);
	set.addRange(0x1CE2, 0x1CE8).addRange(0x1CF8, 0x1CF9).addRange(0x1D2C, 0x1D6A).addRange(0x1D9B, 0x1DFF).addRange(0x1FBF, 0x1FC1).addRange(0x1FCD, 0x1FCF).addRange(0x1FDD, 0x1FDF).addRange(0x1FED, 0x1FEF).addRange(0x1FFD, 0x1FFE).addRange(0x200B, 0x200F).addRange(0x2018, 0x2019).addRange(0x202A, 0x202E).addRange(0x2060, 0x2064).addRange(0x2066, 0x206F).addRange(0x2090, 0x209C).addRange(0x20D0, 0x20F0).addRange(0x2C7C, 0x2C7D).addRange(0x2CEF, 0x2CF1).addRange(0x2DE0, 0x2DFF).addRange(0x302A, 0x302D).addRange(0x3031, 0x3035).addRange(0x3099, 0x309E).addRange(0x30FC, 0x30FE).addRange(0xA4F8, 0xA4FD).addRange(0xA66F, 0xA672).addRange(0xA674, 0xA67D).addRange(0xA69C, 0xA69F).addRange(0xA6F0, 0xA6F1).addRange(0xA700, 0xA721).addRange(0xA788, 0xA78A).addRange(0xA7F2, 0xA7F4).addRange(0xA7F8, 0xA7F9).addRange(0xA825, 0xA826).addRange(0xA8C4, 0xA8C5).addRange(0xA8E0, 0xA8F1).addRange(0xA926, 0xA92D).addRange(0xA947, 0xA951).addRange(0xA980, 0xA982).addRange(0xA9B6, 0xA9B9).addRange(0xA9BC, 0xA9BD).addRange(0xA9E5, 0xA9E6).addRange(0xAA29, 0xAA2E).addRange(0xAA31, 0xAA32).addRange(0xAA35, 0xAA36).addRange(0xAAB2, 0xAAB4).addRange(0xAAB7, 0xAAB8).addRange(0xAABE, 0xAABF).addRange(0xAAEC, 0xAAED).addRange(0xAAF3, 0xAAF4).addRange(0xAB5B, 0xAB5F).addRange(0xAB69, 0xAB6B);
	set.addRange(0xFBB2, 0xFBC2).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0xFF9E, 0xFF9F).addRange(0xFFF9, 0xFFFB).addRange(0x10376, 0x1037A).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10A01, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A0F).addRange(0x10A38, 0x10A3A).addRange(0x10AE5, 0x10AE6).addRange(0x10D24, 0x10D27).addRange(0x10EAB, 0x10EAC).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x11038, 0x11046).addRange(0x11073, 0x11074).addRange(0x1107F, 0x11081).addRange(0x110B3, 0x110B6).addRange(0x110B9, 0x110BA).addRange(0x11100, 0x11102).addRange(0x11127, 0x1112B).addRange(0x1112D, 0x11134).addRange(0x11180, 0x11181).addRange(0x111B6, 0x111BE).addRange(0x111C9, 0x111CC).addRange(0x1122F, 0x11231).addRange(0x11236, 0x11237).addRange(0x112E3, 0x112EA).addRange(0x11300, 0x11301).addRange(0x1133B, 0x1133C).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11438, 0x1143F).addRange(0x11442, 0x11444).addRange(0x114B3, 0x114B8).addRange(0x114BF, 0x114C0).addRange(0x114C2, 0x114C3).addRange(0x115B2, 0x115B5).addRange(0x115BC, 0x115BD).addRange(0x115BF, 0x115C0).addRange(0x115DC, 0x115DD).addRange(0x11633, 0x1163A).addRange(0x1163F, 0x11640).addRange(0x116B0, 0x116B5).addRange(0x1171D, 0x1171F).addRange(0x11722, 0x11725).addRange(0x11727, 0x1172B);
	set.addRange(0x1182F, 0x11837).addRange(0x11839, 0x1183A).addRange(0x1193B, 0x1193C).addRange(0x119D4, 0x119D7).addRange(0x119DA, 0x119DB).addRange(0x11A01, 0x11A0A).addRange(0x11A33, 0x11A38).addRange(0x11A3B, 0x11A3E).addRange(0x11A51, 0x11A56).addRange(0x11A59, 0x11A5B).addRange(0x11A8A, 0x11A96).addRange(0x11A98, 0x11A99).addRange(0x11C30, 0x11C36).addRange(0x11C38, 0x11C3D).addRange(0x11C92, 0x11CA7).addRange(0x11CAA, 0x11CB0).addRange(0x11CB2, 0x11CB3).addRange(0x11CB5, 0x11CB6).addRange(0x11D31, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D45).addRange(0x11D90, 0x11D91).addRange(0x11EF3, 0x11EF4).addRange(0x13430, 0x13438).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16B40, 0x16B43).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x16FE3, 0x16FE4).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1BC9D, 0x1BC9E).addRange(0x1BCA0, 0x1BCA3).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D173, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A);
	set.addRange(0x1E130, 0x1E13D).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E94B).addRange(0x1F3FB, 0x1F3FF).addRange(0xE0020, 0xE007F).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Cased.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xB5, 0xBA, 0x345, 0x37F, 0x386, 0x38C, 0x10C7, 0x10CD, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x2139, 0x214E, 0x2D27, 0x2D2D, 0xA7D3, 0x10780, 0x1D4A2, 0x1D4BB, 0x1D546);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x1BA).addRange(0x1BC, 0x1BF).addRange(0x1C4, 0x293).addRange(0x295, 0x2B8).addRange(0x2C0, 0x2C1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x373).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x212F, 0x2134).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149);
	set.addRange(0x2160, 0x217F).addRange(0x2183, 0x2184).addRange(0x24B6, 0x24E9).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0xA640, 0xA66D).addRange(0xA680, 0xA69D).addRange(0xA722, 0xA787).addRange(0xA78B, 0xA78E).addRange(0xA790, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F5, 0xA7F6).addRange(0xA7F8, 0xA7FA).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB68).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10400, 0x1044F).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10783, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x118A0, 0x118DF).addRange(0x16E40, 0x16E7F).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514);
	set.addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF09).addRange(0x1DF0B, 0x1DF1E).addRange(0x1E900, 0x1E943).addRange(0x1F130, 0x1F149).addRange(0x1F150, 0x1F169).addRange(0x1F170, 0x1F189);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Casefolded.js", function (module, exports) {
	  const set = regenerate(0xB5, 0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x17F, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1CD, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1F4, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x345, 0x370, 0x372, 0x376, 0x37F, 0x386, 0x38C, 0x3C2, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x587, 0x10C7, 0x10CD, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x2126, 0x2132, 0x2183, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xA7F5);
	set.addRange(0x41, 0x5A).addRange(0xC0, 0xD6).addRange(0xD8, 0xDF).addRange(0x149, 0x14A).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1C4, 0x1C5).addRange(0x1C7, 0x1C8).addRange(0x1CA, 0x1CB).addRange(0x1F1, 0x1F2).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x388, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3CF, 0x3D1).addRange(0x3D5, 0x3D6).addRange(0x3F0, 0x3F1).addRange(0x3F4, 0x3F5).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x10A0, 0x10C5).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1E9A, 0x1E9B).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1F80, 0x1FAF).addRange(0x1FB2, 0x1FB4);
	set.addRange(0x1FB7, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC7, 0x1FCC).addRange(0x1FD8, 0x1FDB).addRange(0x1FE8, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF7, 0x1FFC).addRange(0x212A, 0x212B).addRange(0x2160, 0x216F).addRange(0x24B6, 0x24CF).addRange(0x2C00, 0x2C2F).addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7E, 0x2C80).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF21, 0xFF3A).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1E900, 0x1E921);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Casemapped.js", function (module, exports) {
	  const set = regenerate(0xB5, 0x1BF, 0x259, 0x263, 0x26F, 0x275, 0x27D, 0x280, 0x292, 0x345, 0x37F, 0x386, 0x38C, 0x10C7, 0x10CD, 0x1D79, 0x1D7D, 0x1D8E, 0x1E9E, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2126, 0x2132, 0x214E, 0x2D27, 0x2D2D, 0xAB53);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x137).addRange(0x139, 0x18C).addRange(0x18E, 0x19A).addRange(0x19C, 0x1A9).addRange(0x1AC, 0x1B9).addRange(0x1BC, 0x1BD).addRange(0x1C4, 0x220).addRange(0x222, 0x233).addRange(0x23A, 0x254).addRange(0x256, 0x257).addRange(0x25B, 0x25C).addRange(0x260, 0x261).addRange(0x265, 0x266).addRange(0x268, 0x26C).addRange(0x271, 0x272).addRange(0x282, 0x283).addRange(0x287, 0x28C).addRange(0x29D, 0x29E).addRange(0x370, 0x373).addRange(0x376, 0x377).addRange(0x37B, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3D1).addRange(0x3D5, 0x3F5).addRange(0x3F7, 0x3FB).addRange(0x3FD, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x561, 0x587).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1E00, 0x1E9B).addRange(0x1EA0, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC);
	set.addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x212A, 0x212B).addRange(0x2160, 0x217F).addRange(0x2183, 0x2184).addRange(0x24B6, 0x24E9).addRange(0x2C00, 0x2C70).addRange(0x2C72, 0x2C73).addRange(0x2C75, 0x2C76).addRange(0x2C7E, 0x2CE3).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0xA640, 0xA66D).addRange(0xA680, 0xA69B).addRange(0xA722, 0xA72F).addRange(0xA732, 0xA76F).addRange(0xA779, 0xA787).addRange(0xA78B, 0xA78D).addRange(0xA790, 0xA794).addRange(0xA796, 0xA7AE).addRange(0xA7B0, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D6, 0xA7D9).addRange(0xA7F5, 0xA7F6).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10400, 0x1044F).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x118A0, 0x118DF).addRange(0x16E40, 0x16E7F).addRange(0x1E900, 0x1E943);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Lowercased.js", function (module, exports) {
	  const set = regenerate(0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14A, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1CD, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1F4, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x370, 0x372, 0x376, 0x37F, 0x386, 0x38C, 0x3CF, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F4, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x10C7, 0x10CD, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x2126, 0x2132, 0x2183, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xA7F5);
	set.addRange(0x41, 0x5A).addRange(0xC0, 0xD6).addRange(0xD8, 0xDE).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1C4, 0x1C5).addRange(0x1C7, 0x1C8).addRange(0x1CA, 0x1CB).addRange(0x1F1, 0x1F2).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x388, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x10A0, 0x10C5).addRange(0x13A0, 0x13F5).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1F88, 0x1F8F).addRange(0x1F98, 0x1F9F).addRange(0x1FA8, 0x1FAF).addRange(0x1FB8, 0x1FBC).addRange(0x1FC8, 0x1FCC).addRange(0x1FD8, 0x1FDB).addRange(0x1FE8, 0x1FEC).addRange(0x1FF8, 0x1FFC).addRange(0x212A, 0x212B);
	set.addRange(0x2160, 0x216F).addRange(0x24B6, 0x24CF).addRange(0x2C00, 0x2C2F).addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7E, 0x2C80).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xFF21, 0xFF3A).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1E900, 0x1E921);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_NFKC_Casefolded.js", function (module, exports) {
	  const set = regenerate(0xA0, 0xA8, 0xAA, 0xAD, 0xAF, 0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x136, 0x139, 0x13B, 0x13D, 0x143, 0x145, 0x147, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x17F, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x34F, 0x370, 0x372, 0x374, 0x376, 0x37A, 0x38C, 0x3C2, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x587, 0x61C, 0x9DF, 0xA33, 0xA36, 0xA5E, 0xE33, 0xEB3, 0xF0C, 0xF43, 0xF4D, 0xF52, 0xF57, 0xF5C, 0xF69, 0xF73, 0xF81, 0xF93, 0xF9D, 0xFA2, 0xFA7, 0xFAC, 0xFB9, 0x10C7, 0x10CD, 0x10FC, 0x1D78, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x1F71, 0x1F73, 0x1F75, 0x1F77, 0x1F79, 0x1F7B, 0x1F7D, 0x1FD3, 0x1FE3, 0x2011, 0x2017, 0x203C, 0x203E, 0x2057, 0x20A8, 0x2124, 0x2126, 0x2128, 0x2183, 0x2189, 0x2A0C, 0x2ADC, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0x2D6F, 0x2E9F, 0x2EF3, 0x3000, 0x3036, 0x309F, 0x30FF, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA770, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xAB69, 0xFA10, 0xFA12, 0xFA20, 0xFA22, 0xFB1D, 0xFB3E, 0xFE74, 0xFEFF, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E, 0x1F190);
	set.addRange(0x41, 0x5A).addRange(0xB2, 0xB5).addRange(0xB8, 0xBA).addRange(0xBC, 0xBE).addRange(0xC0, 0xD6).addRange(0xD8, 0xDF).addRange(0x132, 0x134).addRange(0x13F, 0x141).addRange(0x149, 0x14A).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1C4, 0x1CD).addRange(0x1F1, 0x1F4).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x2B0, 0x2B8).addRange(0x2D8, 0x2DD).addRange(0x2E0, 0x2E4).addRange(0x340, 0x341).addRange(0x343, 0x345).addRange(0x37E, 0x37F).addRange(0x384, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3CF, 0x3D6).addRange(0x3F0, 0x3F2).addRange(0x3F4, 0x3F5).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x675, 0x678).addRange(0x958, 0x95F).addRange(0x9DC, 0x9DD).addRange(0xA59, 0xA5B).addRange(0xB5C, 0xB5D).addRange(0xEDC, 0xEDD);
	set.addRange(0xF75, 0xF79).addRange(0x10A0, 0x10C5).addRange(0x115F, 0x1160).addRange(0x13F8, 0x13FD).addRange(0x17B4, 0x17B5).addRange(0x180B, 0x180F).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1D2C, 0x1D2E).addRange(0x1D30, 0x1D3A).addRange(0x1D3C, 0x1D4D).addRange(0x1D4F, 0x1D6A).addRange(0x1D9B, 0x1DBF).addRange(0x1E9A, 0x1E9B).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1F80, 0x1FAF).addRange(0x1FB2, 0x1FB4).addRange(0x1FB7, 0x1FC4).addRange(0x1FC7, 0x1FCF).addRange(0x1FD8, 0x1FDB).addRange(0x1FDD, 0x1FDF).addRange(0x1FE8, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF7, 0x1FFE).addRange(0x2000, 0x200F).addRange(0x2024, 0x2026).addRange(0x202A, 0x202F).addRange(0x2033, 0x2034).addRange(0x2036, 0x2037).addRange(0x2047, 0x2049).addRange(0x205F, 0x2071).addRange(0x2074, 0x208E).addRange(0x2090, 0x209C).addRange(0x2100, 0x2103).addRange(0x2105, 0x2107).addRange(0x2109, 0x2113).addRange(0x2115, 0x2116).addRange(0x2119, 0x211D).addRange(0x2120, 0x2122).addRange(0x212A, 0x212D).addRange(0x212F, 0x2139).addRange(0x213B, 0x2140).addRange(0x2145, 0x2149).addRange(0x2150, 0x217F).addRange(0x222C, 0x222D);
	set.addRange(0x222F, 0x2230).addRange(0x2329, 0x232A).addRange(0x2460, 0x24EA).addRange(0x2A74, 0x2A76).addRange(0x2C00, 0x2C2F).addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7C, 0x2C80).addRange(0x2F00, 0x2FD5).addRange(0x3038, 0x303A).addRange(0x309B, 0x309C).addRange(0x3131, 0x318E).addRange(0x3192, 0x319F).addRange(0x3200, 0x321E).addRange(0x3220, 0x3247).addRange(0x3250, 0x327E).addRange(0x3280, 0x33FF).addRange(0xA69C, 0xA69D).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xA7F2, 0xA7F5).addRange(0xA7F8, 0xA7F9).addRange(0xAB5C, 0xAB5F).addRange(0xAB70, 0xABBF).addRange(0xF900, 0xFA0D).addRange(0xFA15, 0xFA1E).addRange(0xFA25, 0xFA26).addRange(0xFA2A, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFC).addRange(0xFE00, 0xFE19).addRange(0xFE30, 0xFE44).addRange(0xFE47, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFE70, 0xFE72).addRange(0xFE76, 0xFEFC).addRange(0xFF01, 0xFFBE).addRange(0xFFC2, 0xFFC7);
	set.addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFF0, 0xFFF8).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10781, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1BCA0, 0x1BCA3).addRange(0x1D15E, 0x1D164).addRange(0x1D173, 0x1D17A).addRange(0x1D1BB, 0x1D1C0).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1E900, 0x1E921).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72);
	set.addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1F100, 0x1F10A).addRange(0x1F110, 0x1F12E).addRange(0x1F130, 0x1F14F).addRange(0x1F16A, 0x1F16C).addRange(0x1F200, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1FBF0, 0x1FBF9).addRange(0x2F800, 0x2FA1D).addRange(0xE0000, 0xE0FFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Titlecased.js", function (module, exports) {
	  const set = regenerate(0xB5, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x137, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x183, 0x185, 0x188, 0x18C, 0x192, 0x195, 0x19E, 0x1A1, 0x1A3, 0x1A5, 0x1A8, 0x1AD, 0x1B0, 0x1B4, 0x1B6, 0x1B9, 0x1BD, 0x1BF, 0x1C4, 0x1CC, 0x1CE, 0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DF, 0x1E1, 0x1E3, 0x1E5, 0x1E7, 0x1E9, 0x1EB, 0x1ED, 0x1F3, 0x1F5, 0x1F9, 0x1FB, 0x1FD, 0x1FF, 0x201, 0x203, 0x205, 0x207, 0x209, 0x20B, 0x20D, 0x20F, 0x211, 0x213, 0x215, 0x217, 0x219, 0x21B, 0x21D, 0x21F, 0x223, 0x225, 0x227, 0x229, 0x22B, 0x22D, 0x22F, 0x231, 0x233, 0x23C, 0x242, 0x247, 0x249, 0x24B, 0x24D, 0x259, 0x263, 0x26F, 0x275, 0x27D, 0x280, 0x292, 0x345, 0x371, 0x373, 0x377, 0x390, 0x3D9, 0x3DB, 0x3DD, 0x3DF, 0x3E1, 0x3E3, 0x3E5, 0x3E7, 0x3E9, 0x3EB, 0x3ED, 0x3F5, 0x3F8, 0x3FB, 0x461, 0x463, 0x465, 0x467, 0x469, 0x46B, 0x46D, 0x46F, 0x471, 0x473, 0x475, 0x477, 0x479, 0x47B, 0x47D, 0x47F, 0x481, 0x48B, 0x48D, 0x48F, 0x491, 0x493, 0x495, 0x497, 0x499, 0x49B, 0x49D, 0x49F, 0x4A1, 0x4A3, 0x4A5, 0x4A7, 0x4A9, 0x4AB, 0x4AD, 0x4AF, 0x4B1, 0x4B3, 0x4B5, 0x4B7, 0x4B9, 0x4BB, 0x4BD, 0x4BF, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4D1, 0x4D3, 0x4D5, 0x4D7, 0x4D9, 0x4DB, 0x4DD, 0x4DF, 0x4E1, 0x4E3, 0x4E5, 0x4E7, 0x4E9, 0x4EB, 0x4ED, 0x4EF, 0x4F1, 0x4F3, 0x4F5, 0x4F7, 0x4F9, 0x4FB, 0x4FD, 0x4FF, 0x501, 0x503, 0x505, 0x507, 0x509, 0x50B, 0x50D, 0x50F, 0x511, 0x513, 0x515, 0x517, 0x519, 0x51B, 0x51D, 0x51F, 0x521, 0x523, 0x525, 0x527, 0x529, 0x52B, 0x52D, 0x52F, 0x1D79, 0x1D7D, 0x1D8E, 0x1E01, 0x1E03, 0x1E05, 0x1E07, 0x1E09, 0x1E0B, 0x1E0D, 0x1E0F, 0x1E11, 0x1E13, 0x1E15, 0x1E17, 0x1E19, 0x1E1B, 0x1E1D, 0x1E1F, 0x1E21, 0x1E23, 0x1E25, 0x1E27, 0x1E29, 0x1E2B, 0x1E2D, 0x1E2F, 0x1E31, 0x1E33, 0x1E35, 0x1E37, 0x1E39, 0x1E3B, 0x1E3D, 0x1E3F, 0x1E41, 0x1E43, 0x1E45, 0x1E47, 0x1E49, 0x1E4B, 0x1E4D, 0x1E4F, 0x1E51, 0x1E53, 0x1E55, 0x1E57, 0x1E59, 0x1E5B, 0x1E5D, 0x1E5F, 0x1E61, 0x1E63, 0x1E65, 0x1E67, 0x1E69, 0x1E6B, 0x1E6D, 0x1E6F, 0x1E71, 0x1E73, 0x1E75, 0x1E77, 0x1E79, 0x1E7B, 0x1E7D, 0x1E7F, 0x1E81, 0x1E83, 0x1E85, 0x1E87, 0x1E89, 0x1E8B, 0x1E8D, 0x1E8F, 0x1E91, 0x1E93, 0x1EA1, 0x1EA3, 0x1EA5, 0x1EA7, 0x1EA9, 0x1EAB, 0x1EAD, 0x1EAF, 0x1EB1, 0x1EB3, 0x1EB5, 0x1EB7, 0x1EB9, 0x1EBB, 0x1EBD, 0x1EBF, 0x1EC1, 0x1EC3, 0x1EC5, 0x1EC7, 0x1EC9, 0x1ECB, 0x1ECD, 0x1ECF, 0x1ED1, 0x1ED3, 0x1ED5, 0x1ED7, 0x1ED9, 0x1EDB, 0x1EDD, 0x1EDF, 0x1EE1, 0x1EE3, 0x1EE5, 0x1EE7, 0x1EE9, 0x1EEB, 0x1EED, 0x1EEF, 0x1EF1, 0x1EF3, 0x1EF5, 0x1EF7, 0x1EF9, 0x1EFB, 0x1EFD, 0x1FBE, 0x214E, 0x2184, 0x2C61, 0x2C68, 0x2C6A, 0x2C6C, 0x2C73, 0x2C76, 0x2C81, 0x2C83, 0x2C85, 0x2C87, 0x2C89, 0x2C8B, 0x2C8D, 0x2C8F, 0x2C91, 0x2C93, 0x2C95, 0x2C97, 0x2C99, 0x2C9B, 0x2C9D, 0x2C9F, 0x2CA1, 0x2CA3, 0x2CA5, 0x2CA7, 0x2CA9, 0x2CAB, 0x2CAD, 0x2CAF, 0x2CB1, 0x2CB3, 0x2CB5, 0x2CB7, 0x2CB9, 0x2CBB, 0x2CBD, 0x2CBF, 0x2CC1, 0x2CC3, 0x2CC5, 0x2CC7, 0x2CC9, 0x2CCB, 0x2CCD, 0x2CCF, 0x2CD1, 0x2CD3, 0x2CD5, 0x2CD7, 0x2CD9, 0x2CDB, 0x2CDD, 0x2CDF, 0x2CE1, 0x2CE3, 0x2CEC, 0x2CEE, 0x2CF3, 0x2D27, 0x2D2D, 0xA641, 0xA643, 0xA645, 0xA647, 0xA649, 0xA64B, 0xA64D, 0xA64F, 0xA651, 0xA653, 0xA655, 0xA657, 0xA659, 0xA65B, 0xA65D, 0xA65F, 0xA661, 0xA663, 0xA665, 0xA667, 0xA669, 0xA66B, 0xA66D, 0xA681, 0xA683, 0xA685, 0xA687, 0xA689, 0xA68B, 0xA68D, 0xA68F, 0xA691, 0xA693, 0xA695, 0xA697, 0xA699, 0xA69B, 0xA723, 0xA725, 0xA727, 0xA729, 0xA72B, 0xA72D, 0xA72F, 0xA733, 0xA735, 0xA737, 0xA739, 0xA73B, 0xA73D, 0xA73F, 0xA741, 0xA743, 0xA745, 0xA747, 0xA749, 0xA74B, 0xA74D, 0xA74F, 0xA751, 0xA753, 0xA755, 0xA757, 0xA759, 0xA75B, 0xA75D, 0xA75F, 0xA761, 0xA763, 0xA765, 0xA767, 0xA769, 0xA76B, 0xA76D, 0xA76F, 0xA77A, 0xA77C, 0xA77F, 0xA781, 0xA783, 0xA785, 0xA787, 0xA78C, 0xA791, 0xA797, 0xA799, 0xA79B, 0xA79D, 0xA79F, 0xA7A1, 0xA7A3, 0xA7A5, 0xA7A7, 0xA7A9, 0xA7B5, 0xA7B7, 0xA7B9, 0xA7BB, 0xA7BD, 0xA7BF, 0xA7C1, 0xA7C3, 0xA7C8, 0xA7CA, 0xA7D1, 0xA7D7, 0xA7D9, 0xA7F6, 0xAB53);
	set.addRange(0x61, 0x7A).addRange(0xDF, 0xF6).addRange(0xF8, 0xFF).addRange(0x148, 0x149).addRange(0x17E, 0x180).addRange(0x199, 0x19A).addRange(0x1C6, 0x1C7).addRange(0x1C9, 0x1CA).addRange(0x1DC, 0x1DD).addRange(0x1EF, 0x1F1).addRange(0x23F, 0x240).addRange(0x24F, 0x254).addRange(0x256, 0x257).addRange(0x25B, 0x25C).addRange(0x260, 0x261).addRange(0x265, 0x266).addRange(0x268, 0x26C).addRange(0x271, 0x272).addRange(0x282, 0x283).addRange(0x287, 0x28C).addRange(0x29D, 0x29E).addRange(0x37B, 0x37D).addRange(0x3AC, 0x3CE).addRange(0x3D0, 0x3D1).addRange(0x3D5, 0x3D7).addRange(0x3EF, 0x3F3).addRange(0x430, 0x45F).addRange(0x4CE, 0x4CF).addRange(0x561, 0x587).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1E95, 0x1E9B).addRange(0x1EFF, 0x1F07).addRange(0x1F10, 0x1F15).addRange(0x1F20, 0x1F27).addRange(0x1F30, 0x1F37).addRange(0x1F40, 0x1F45).addRange(0x1F50, 0x1F57).addRange(0x1F60, 0x1F67).addRange(0x1F70, 0x1F7D).addRange(0x1F80, 0x1F87).addRange(0x1F90, 0x1F97).addRange(0x1FA0, 0x1FA7).addRange(0x1FB0, 0x1FB4).addRange(0x1FB6, 0x1FB7).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FC7).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FD7).addRange(0x1FE0, 0x1FE7).addRange(0x1FF2, 0x1FF4);
	set.addRange(0x1FF6, 0x1FF7).addRange(0x2170, 0x217F).addRange(0x24D0, 0x24E9).addRange(0x2C30, 0x2C5F).addRange(0x2C65, 0x2C66).addRange(0x2D00, 0x2D25).addRange(0xA793, 0xA794).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF41, 0xFF5A).addRange(0x10428, 0x1044F).addRange(0x104D8, 0x104FB).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10CC0, 0x10CF2).addRange(0x118C0, 0x118DF).addRange(0x16E60, 0x16E7F).addRange(0x1E922, 0x1E943);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Uppercased.js", function (module, exports) {
	  const set = regenerate(0xB5, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x137, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x183, 0x185, 0x188, 0x18C, 0x192, 0x195, 0x19E, 0x1A1, 0x1A3, 0x1A5, 0x1A8, 0x1AD, 0x1B0, 0x1B4, 0x1B6, 0x1B9, 0x1BD, 0x1BF, 0x1CE, 0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DF, 0x1E1, 0x1E3, 0x1E5, 0x1E7, 0x1E9, 0x1EB, 0x1ED, 0x1F5, 0x1F9, 0x1FB, 0x1FD, 0x1FF, 0x201, 0x203, 0x205, 0x207, 0x209, 0x20B, 0x20D, 0x20F, 0x211, 0x213, 0x215, 0x217, 0x219, 0x21B, 0x21D, 0x21F, 0x223, 0x225, 0x227, 0x229, 0x22B, 0x22D, 0x22F, 0x231, 0x233, 0x23C, 0x242, 0x247, 0x249, 0x24B, 0x24D, 0x259, 0x263, 0x26F, 0x275, 0x27D, 0x280, 0x292, 0x345, 0x371, 0x373, 0x377, 0x390, 0x3D9, 0x3DB, 0x3DD, 0x3DF, 0x3E1, 0x3E3, 0x3E5, 0x3E7, 0x3E9, 0x3EB, 0x3ED, 0x3F5, 0x3F8, 0x3FB, 0x461, 0x463, 0x465, 0x467, 0x469, 0x46B, 0x46D, 0x46F, 0x471, 0x473, 0x475, 0x477, 0x479, 0x47B, 0x47D, 0x47F, 0x481, 0x48B, 0x48D, 0x48F, 0x491, 0x493, 0x495, 0x497, 0x499, 0x49B, 0x49D, 0x49F, 0x4A1, 0x4A3, 0x4A5, 0x4A7, 0x4A9, 0x4AB, 0x4AD, 0x4AF, 0x4B1, 0x4B3, 0x4B5, 0x4B7, 0x4B9, 0x4BB, 0x4BD, 0x4BF, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4D1, 0x4D3, 0x4D5, 0x4D7, 0x4D9, 0x4DB, 0x4DD, 0x4DF, 0x4E1, 0x4E3, 0x4E5, 0x4E7, 0x4E9, 0x4EB, 0x4ED, 0x4EF, 0x4F1, 0x4F3, 0x4F5, 0x4F7, 0x4F9, 0x4FB, 0x4FD, 0x4FF, 0x501, 0x503, 0x505, 0x507, 0x509, 0x50B, 0x50D, 0x50F, 0x511, 0x513, 0x515, 0x517, 0x519, 0x51B, 0x51D, 0x51F, 0x521, 0x523, 0x525, 0x527, 0x529, 0x52B, 0x52D, 0x52F, 0x1D79, 0x1D7D, 0x1D8E, 0x1E01, 0x1E03, 0x1E05, 0x1E07, 0x1E09, 0x1E0B, 0x1E0D, 0x1E0F, 0x1E11, 0x1E13, 0x1E15, 0x1E17, 0x1E19, 0x1E1B, 0x1E1D, 0x1E1F, 0x1E21, 0x1E23, 0x1E25, 0x1E27, 0x1E29, 0x1E2B, 0x1E2D, 0x1E2F, 0x1E31, 0x1E33, 0x1E35, 0x1E37, 0x1E39, 0x1E3B, 0x1E3D, 0x1E3F, 0x1E41, 0x1E43, 0x1E45, 0x1E47, 0x1E49, 0x1E4B, 0x1E4D, 0x1E4F, 0x1E51, 0x1E53, 0x1E55, 0x1E57, 0x1E59, 0x1E5B, 0x1E5D, 0x1E5F, 0x1E61, 0x1E63, 0x1E65, 0x1E67, 0x1E69, 0x1E6B, 0x1E6D, 0x1E6F, 0x1E71, 0x1E73, 0x1E75, 0x1E77, 0x1E79, 0x1E7B, 0x1E7D, 0x1E7F, 0x1E81, 0x1E83, 0x1E85, 0x1E87, 0x1E89, 0x1E8B, 0x1E8D, 0x1E8F, 0x1E91, 0x1E93, 0x1EA1, 0x1EA3, 0x1EA5, 0x1EA7, 0x1EA9, 0x1EAB, 0x1EAD, 0x1EAF, 0x1EB1, 0x1EB3, 0x1EB5, 0x1EB7, 0x1EB9, 0x1EBB, 0x1EBD, 0x1EBF, 0x1EC1, 0x1EC3, 0x1EC5, 0x1EC7, 0x1EC9, 0x1ECB, 0x1ECD, 0x1ECF, 0x1ED1, 0x1ED3, 0x1ED5, 0x1ED7, 0x1ED9, 0x1EDB, 0x1EDD, 0x1EDF, 0x1EE1, 0x1EE3, 0x1EE5, 0x1EE7, 0x1EE9, 0x1EEB, 0x1EED, 0x1EEF, 0x1EF1, 0x1EF3, 0x1EF5, 0x1EF7, 0x1EF9, 0x1EFB, 0x1EFD, 0x1FBC, 0x1FBE, 0x1FCC, 0x1FFC, 0x214E, 0x2184, 0x2C61, 0x2C68, 0x2C6A, 0x2C6C, 0x2C73, 0x2C76, 0x2C81, 0x2C83, 0x2C85, 0x2C87, 0x2C89, 0x2C8B, 0x2C8D, 0x2C8F, 0x2C91, 0x2C93, 0x2C95, 0x2C97, 0x2C99, 0x2C9B, 0x2C9D, 0x2C9F, 0x2CA1, 0x2CA3, 0x2CA5, 0x2CA7, 0x2CA9, 0x2CAB, 0x2CAD, 0x2CAF, 0x2CB1, 0x2CB3, 0x2CB5, 0x2CB7, 0x2CB9, 0x2CBB, 0x2CBD, 0x2CBF, 0x2CC1, 0x2CC3, 0x2CC5, 0x2CC7, 0x2CC9, 0x2CCB, 0x2CCD, 0x2CCF, 0x2CD1, 0x2CD3, 0x2CD5, 0x2CD7, 0x2CD9, 0x2CDB, 0x2CDD, 0x2CDF, 0x2CE1, 0x2CE3, 0x2CEC, 0x2CEE, 0x2CF3, 0x2D27, 0x2D2D, 0xA641, 0xA643, 0xA645, 0xA647, 0xA649, 0xA64B, 0xA64D, 0xA64F, 0xA651, 0xA653, 0xA655, 0xA657, 0xA659, 0xA65B, 0xA65D, 0xA65F, 0xA661, 0xA663, 0xA665, 0xA667, 0xA669, 0xA66B, 0xA66D, 0xA681, 0xA683, 0xA685, 0xA687, 0xA689, 0xA68B, 0xA68D, 0xA68F, 0xA691, 0xA693, 0xA695, 0xA697, 0xA699, 0xA69B, 0xA723, 0xA725, 0xA727, 0xA729, 0xA72B, 0xA72D, 0xA72F, 0xA733, 0xA735, 0xA737, 0xA739, 0xA73B, 0xA73D, 0xA73F, 0xA741, 0xA743, 0xA745, 0xA747, 0xA749, 0xA74B, 0xA74D, 0xA74F, 0xA751, 0xA753, 0xA755, 0xA757, 0xA759, 0xA75B, 0xA75D, 0xA75F, 0xA761, 0xA763, 0xA765, 0xA767, 0xA769, 0xA76B, 0xA76D, 0xA76F, 0xA77A, 0xA77C, 0xA77F, 0xA781, 0xA783, 0xA785, 0xA787, 0xA78C, 0xA791, 0xA797, 0xA799, 0xA79B, 0xA79D, 0xA79F, 0xA7A1, 0xA7A3, 0xA7A5, 0xA7A7, 0xA7A9, 0xA7B5, 0xA7B7, 0xA7B9, 0xA7BB, 0xA7BD, 0xA7BF, 0xA7C1, 0xA7C3, 0xA7C8, 0xA7CA, 0xA7D1, 0xA7D7, 0xA7D9, 0xA7F6, 0xAB53);
	set.addRange(0x61, 0x7A).addRange(0xDF, 0xF6).addRange(0xF8, 0xFF).addRange(0x148, 0x149).addRange(0x17E, 0x180).addRange(0x199, 0x19A).addRange(0x1C5, 0x1C6).addRange(0x1C8, 0x1C9).addRange(0x1CB, 0x1CC).addRange(0x1DC, 0x1DD).addRange(0x1EF, 0x1F0).addRange(0x1F2, 0x1F3).addRange(0x23F, 0x240).addRange(0x24F, 0x254).addRange(0x256, 0x257).addRange(0x25B, 0x25C).addRange(0x260, 0x261).addRange(0x265, 0x266).addRange(0x268, 0x26C).addRange(0x271, 0x272).addRange(0x282, 0x283).addRange(0x287, 0x28C).addRange(0x29D, 0x29E).addRange(0x37B, 0x37D).addRange(0x3AC, 0x3CE).addRange(0x3D0, 0x3D1).addRange(0x3D5, 0x3D7).addRange(0x3EF, 0x3F3).addRange(0x430, 0x45F).addRange(0x4CE, 0x4CF).addRange(0x561, 0x587).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1E95, 0x1E9B).addRange(0x1EFF, 0x1F07).addRange(0x1F10, 0x1F15).addRange(0x1F20, 0x1F27).addRange(0x1F30, 0x1F37).addRange(0x1F40, 0x1F45).addRange(0x1F50, 0x1F57).addRange(0x1F60, 0x1F67).addRange(0x1F70, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FB7).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FC7).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FD7).addRange(0x1FE0, 0x1FE7);
	set.addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FF7).addRange(0x2170, 0x217F).addRange(0x24D0, 0x24E9).addRange(0x2C30, 0x2C5F).addRange(0x2C65, 0x2C66).addRange(0x2D00, 0x2D25).addRange(0xA793, 0xA794).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF41, 0xFF5A).addRange(0x10428, 0x1044F).addRange(0x104D8, 0x104FB).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10CC0, 0x10CF2).addRange(0x118C0, 0x118DF).addRange(0x16E60, 0x16E7F).addRange(0x1E922, 0x1E943);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Dash.js", function (module, exports) {
	  const set = regenerate(0x2D, 0x58A, 0x5BE, 0x1400, 0x1806, 0x2053, 0x207B, 0x208B, 0x2212, 0x2E17, 0x2E1A, 0x2E40, 0x2E5D, 0x301C, 0x3030, 0x30A0, 0xFE58, 0xFE63, 0xFF0D, 0x10EAD);
	set.addRange(0x2010, 0x2015).addRange(0x2E3A, 0x2E3B).addRange(0xFE31, 0xFE32);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Default_Ignorable_Code_Point.js", function (module, exports) {
	  const set = regenerate(0xAD, 0x34F, 0x61C, 0x3164, 0xFEFF, 0xFFA0);
	set.addRange(0x115F, 0x1160).addRange(0x17B4, 0x17B5).addRange(0x180B, 0x180F).addRange(0x200B, 0x200F).addRange(0x202A, 0x202E).addRange(0x2060, 0x206F).addRange(0xFE00, 0xFE0F).addRange(0xFFF0, 0xFFF8).addRange(0x1BCA0, 0x1BCA3).addRange(0x1D173, 0x1D17A).addRange(0xE0000, 0xE0FFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Deprecated.js", function (module, exports) {
	  const set = regenerate(0x149, 0x673, 0xF77, 0xF79, 0xE0001);
	set.addRange(0x17A3, 0x17A4).addRange(0x206A, 0x206F).addRange(0x2329, 0x232A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Diacritic.js", function (module, exports) {
	  const set = regenerate(0x5E, 0x60, 0xA8, 0xAF, 0xB4, 0x37A, 0x559, 0x5BF, 0x5C4, 0x93C, 0x94D, 0x971, 0x9BC, 0x9CD, 0xA3C, 0xA4D, 0xABC, 0xACD, 0xB3C, 0xB4D, 0xB55, 0xBCD, 0xC3C, 0xC4D, 0xCBC, 0xCCD, 0xD4D, 0xDCA, 0xE4E, 0xEBA, 0xF35, 0xF37, 0xF39, 0xFC6, 0x1037, 0x108F, 0x17DD, 0x1A7F, 0x1B34, 0x1B44, 0x1CED, 0x1CF4, 0x1FBD, 0x2E2F, 0x30FC, 0xA66F, 0xA67F, 0xA8C4, 0xA953, 0xA9B3, 0xA9C0, 0xA9E5, 0xAAF6, 0xFB1E, 0xFF3E, 0xFF40, 0xFF70, 0xFFE3, 0x102E0, 0x11046, 0x11070, 0x11173, 0x111C0, 0x1133C, 0x1134D, 0x11442, 0x11446, 0x1163F, 0x1172B, 0x11943, 0x119E0, 0x11A34, 0x11A47, 0x11A99, 0x11C3F, 0x11D42, 0x11D97, 0x1E2AE);
	set.addRange(0xB7, 0xB8).addRange(0x2B0, 0x34E).addRange(0x350, 0x357).addRange(0x35D, 0x362).addRange(0x374, 0x375).addRange(0x384, 0x385).addRange(0x483, 0x487).addRange(0x591, 0x5A1).addRange(0x5A3, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x64B, 0x652).addRange(0x657, 0x658).addRange(0x6DF, 0x6E0).addRange(0x6E5, 0x6E6).addRange(0x6EA, 0x6EC).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F5).addRange(0x818, 0x819).addRange(0x898, 0x89F).addRange(0x8C9, 0x8D2).addRange(0x8E3, 0x8FE).addRange(0x951, 0x954).addRange(0xAFD, 0xAFF).addRange(0xD3B, 0xD3C).addRange(0xE47, 0xE4C).addRange(0xEC8, 0xECC).addRange(0xF18, 0xF19).addRange(0xF3E, 0xF3F).addRange(0xF82, 0xF84).addRange(0xF86, 0xF87).addRange(0x1039, 0x103A).addRange(0x1063, 0x1064).addRange(0x1069, 0x106D).addRange(0x1087, 0x108D).addRange(0x109A, 0x109B).addRange(0x135D, 0x135F).addRange(0x1714, 0x1715).addRange(0x17C9, 0x17D3).addRange(0x1939, 0x193B).addRange(0x1A75, 0x1A7C).addRange(0x1AB0, 0x1ABE).addRange(0x1AC1, 0x1ACB).addRange(0x1B6B, 0x1B73).addRange(0x1BAA, 0x1BAB).addRange(0x1C36, 0x1C37).addRange(0x1C78, 0x1C7D).addRange(0x1CD0, 0x1CE8).addRange(0x1CF7, 0x1CF9).addRange(0x1D2C, 0x1D6A).addRange(0x1DC4, 0x1DCF);
	set.addRange(0x1DF5, 0x1DFF).addRange(0x1FBF, 0x1FC1).addRange(0x1FCD, 0x1FCF).addRange(0x1FDD, 0x1FDF).addRange(0x1FED, 0x1FEF).addRange(0x1FFD, 0x1FFE).addRange(0x2CEF, 0x2CF1).addRange(0x302A, 0x302F).addRange(0x3099, 0x309C).addRange(0xA67C, 0xA67D).addRange(0xA69C, 0xA69D).addRange(0xA6F0, 0xA6F1).addRange(0xA700, 0xA721).addRange(0xA788, 0xA78A).addRange(0xA7F8, 0xA7F9).addRange(0xA8E0, 0xA8F1).addRange(0xA92B, 0xA92E).addRange(0xAA7B, 0xAA7D).addRange(0xAABF, 0xAAC2).addRange(0xAB5B, 0xAB5F).addRange(0xAB69, 0xAB6B).addRange(0xABEC, 0xABED).addRange(0xFE20, 0xFE2F).addRange(0xFF9E, 0xFF9F).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10AE5, 0x10AE6).addRange(0x10D22, 0x10D27).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x110B9, 0x110BA).addRange(0x11133, 0x11134).addRange(0x111CA, 0x111CC).addRange(0x11235, 0x11236).addRange(0x112E9, 0x112EA).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x114C2, 0x114C3).addRange(0x115BF, 0x115C0).addRange(0x116B6, 0x116B7).addRange(0x11839, 0x1183A).addRange(0x1193D, 0x1193E).addRange(0x11D44, 0x11D45).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16F8F, 0x16F9F).addRange(0x16FF0, 0x16FF1).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE);
	set.addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D16D, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1E130, 0x1E136).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E946).addRange(0x1E948, 0x1E94A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Component.js", function (module, exports) {
	  const set = regenerate(0x23, 0x2A, 0x200D, 0x20E3, 0xFE0F);
	set.addRange(0x30, 0x39).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F3FB, 0x1F3FF).addRange(0x1F9B0, 0x1F9B3).addRange(0xE0020, 0xE007F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Modifier_Base.js", function (module, exports) {
	  const set = regenerate(0x261D, 0x26F9, 0x1F385, 0x1F3C7, 0x1F47C, 0x1F48F, 0x1F491, 0x1F4AA, 0x1F57A, 0x1F590, 0x1F6A3, 0x1F6C0, 0x1F6CC, 0x1F90C, 0x1F90F, 0x1F926, 0x1F977, 0x1F9BB);
	set.addRange(0x270A, 0x270D).addRange(0x1F3C2, 0x1F3C4).addRange(0x1F3CA, 0x1F3CC).addRange(0x1F442, 0x1F443).addRange(0x1F446, 0x1F450).addRange(0x1F466, 0x1F478).addRange(0x1F481, 0x1F483).addRange(0x1F485, 0x1F487).addRange(0x1F574, 0x1F575).addRange(0x1F595, 0x1F596).addRange(0x1F645, 0x1F647).addRange(0x1F64B, 0x1F64F).addRange(0x1F6B4, 0x1F6B6).addRange(0x1F918, 0x1F91F).addRange(0x1F930, 0x1F939).addRange(0x1F93C, 0x1F93E).addRange(0x1F9B5, 0x1F9B6).addRange(0x1F9B8, 0x1F9B9).addRange(0x1F9CD, 0x1F9CF).addRange(0x1F9D1, 0x1F9DD).addRange(0x1FAC3, 0x1FAC5).addRange(0x1FAF0, 0x1FAF6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Modifier.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1F3FB, 0x1F3FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Presentation.js", function (module, exports) {
	  const set = regenerate(0x23F0, 0x23F3, 0x267F, 0x2693, 0x26A1, 0x26CE, 0x26D4, 0x26EA, 0x26F5, 0x26FA, 0x26FD, 0x2705, 0x2728, 0x274C, 0x274E, 0x2757, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x1F004, 0x1F0CF, 0x1F18E, 0x1F201, 0x1F21A, 0x1F22F, 0x1F3F4, 0x1F440, 0x1F57A, 0x1F5A4, 0x1F6CC, 0x1F7F0);
	set.addRange(0x231A, 0x231B).addRange(0x23E9, 0x23EC).addRange(0x25FD, 0x25FE).addRange(0x2614, 0x2615).addRange(0x2648, 0x2653).addRange(0x26AA, 0x26AB).addRange(0x26BD, 0x26BE).addRange(0x26C4, 0x26C5).addRange(0x26F2, 0x26F3).addRange(0x270A, 0x270B).addRange(0x2753, 0x2755).addRange(0x2795, 0x2797).addRange(0x2B1B, 0x2B1C).addRange(0x1F191, 0x1F19A).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F232, 0x1F236).addRange(0x1F238, 0x1F23A).addRange(0x1F250, 0x1F251).addRange(0x1F300, 0x1F320).addRange(0x1F32D, 0x1F335).addRange(0x1F337, 0x1F37C).addRange(0x1F37E, 0x1F393).addRange(0x1F3A0, 0x1F3CA).addRange(0x1F3CF, 0x1F3D3).addRange(0x1F3E0, 0x1F3F0).addRange(0x1F3F8, 0x1F43E).addRange(0x1F442, 0x1F4FC).addRange(0x1F4FF, 0x1F53D).addRange(0x1F54B, 0x1F54E).addRange(0x1F550, 0x1F567).addRange(0x1F595, 0x1F596).addRange(0x1F5FB, 0x1F64F).addRange(0x1F680, 0x1F6C5).addRange(0x1F6D0, 0x1F6D2).addRange(0x1F6D5, 0x1F6D7).addRange(0x1F6DD, 0x1F6DF).addRange(0x1F6EB, 0x1F6EC).addRange(0x1F6F4, 0x1F6FC).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1F9FF).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Emoji.js", function (module, exports) {
	  const set = regenerate(0x23, 0x2A, 0xA9, 0xAE, 0x203C, 0x2049, 0x2122, 0x2139, 0x2328, 0x23CF, 0x24C2, 0x25B6, 0x25C0, 0x260E, 0x2611, 0x2618, 0x261D, 0x2620, 0x2626, 0x262A, 0x2640, 0x2642, 0x2663, 0x2668, 0x267B, 0x2699, 0x26A7, 0x26C8, 0x26D1, 0x26FD, 0x2702, 0x2705, 0x270F, 0x2712, 0x2714, 0x2716, 0x271D, 0x2721, 0x2728, 0x2744, 0x2747, 0x274C, 0x274E, 0x2757, 0x27A1, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x3030, 0x303D, 0x3297, 0x3299, 0x1F004, 0x1F0CF, 0x1F18E, 0x1F21A, 0x1F22F, 0x1F587, 0x1F590, 0x1F5A8, 0x1F5BC, 0x1F5E1, 0x1F5E3, 0x1F5E8, 0x1F5EF, 0x1F5F3, 0x1F6E9, 0x1F6F0, 0x1F7F0);
	set.addRange(0x30, 0x39).addRange(0x2194, 0x2199).addRange(0x21A9, 0x21AA).addRange(0x231A, 0x231B).addRange(0x23E9, 0x23F3).addRange(0x23F8, 0x23FA).addRange(0x25AA, 0x25AB).addRange(0x25FB, 0x25FE).addRange(0x2600, 0x2604).addRange(0x2614, 0x2615).addRange(0x2622, 0x2623).addRange(0x262E, 0x262F).addRange(0x2638, 0x263A).addRange(0x2648, 0x2653).addRange(0x265F, 0x2660).addRange(0x2665, 0x2666).addRange(0x267E, 0x267F).addRange(0x2692, 0x2697).addRange(0x269B, 0x269C).addRange(0x26A0, 0x26A1).addRange(0x26AA, 0x26AB).addRange(0x26B0, 0x26B1).addRange(0x26BD, 0x26BE).addRange(0x26C4, 0x26C5).addRange(0x26CE, 0x26CF).addRange(0x26D3, 0x26D4).addRange(0x26E9, 0x26EA).addRange(0x26F0, 0x26F5).addRange(0x26F7, 0x26FA).addRange(0x2708, 0x270D).addRange(0x2733, 0x2734).addRange(0x2753, 0x2755).addRange(0x2763, 0x2764).addRange(0x2795, 0x2797).addRange(0x2934, 0x2935).addRange(0x2B05, 0x2B07).addRange(0x2B1B, 0x2B1C).addRange(0x1F170, 0x1F171).addRange(0x1F17E, 0x1F17F).addRange(0x1F191, 0x1F19A).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F201, 0x1F202).addRange(0x1F232, 0x1F23A).addRange(0x1F250, 0x1F251).addRange(0x1F300, 0x1F321).addRange(0x1F324, 0x1F393).addRange(0x1F396, 0x1F397).addRange(0x1F399, 0x1F39B).addRange(0x1F39E, 0x1F3F0).addRange(0x1F3F3, 0x1F3F5).addRange(0x1F3F7, 0x1F4FD);
	set.addRange(0x1F4FF, 0x1F53D).addRange(0x1F549, 0x1F54E).addRange(0x1F550, 0x1F567).addRange(0x1F56F, 0x1F570).addRange(0x1F573, 0x1F57A).addRange(0x1F58A, 0x1F58D).addRange(0x1F595, 0x1F596).addRange(0x1F5A4, 0x1F5A5).addRange(0x1F5B1, 0x1F5B2).addRange(0x1F5C2, 0x1F5C4).addRange(0x1F5D1, 0x1F5D3).addRange(0x1F5DC, 0x1F5DE).addRange(0x1F5FA, 0x1F64F).addRange(0x1F680, 0x1F6C5).addRange(0x1F6CB, 0x1F6D2).addRange(0x1F6D5, 0x1F6D7).addRange(0x1F6DD, 0x1F6E5).addRange(0x1F6EB, 0x1F6EC).addRange(0x1F6F3, 0x1F6FC).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1F9FF).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Extended_Pictographic.js", function (module, exports) {
	  const set = regenerate(0xA9, 0xAE, 0x203C, 0x2049, 0x2122, 0x2139, 0x2328, 0x2388, 0x23CF, 0x24C2, 0x25B6, 0x25C0, 0x2714, 0x2716, 0x271D, 0x2721, 0x2728, 0x2744, 0x2747, 0x274C, 0x274E, 0x2757, 0x27A1, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x3030, 0x303D, 0x3297, 0x3299, 0x1F12F, 0x1F18E, 0x1F21A, 0x1F22F);
	set.addRange(0x2194, 0x2199).addRange(0x21A9, 0x21AA).addRange(0x231A, 0x231B).addRange(0x23E9, 0x23F3).addRange(0x23F8, 0x23FA).addRange(0x25AA, 0x25AB).addRange(0x25FB, 0x25FE).addRange(0x2600, 0x2605).addRange(0x2607, 0x2612).addRange(0x2614, 0x2685).addRange(0x2690, 0x2705).addRange(0x2708, 0x2712).addRange(0x2733, 0x2734).addRange(0x2753, 0x2755).addRange(0x2763, 0x2767).addRange(0x2795, 0x2797).addRange(0x2934, 0x2935).addRange(0x2B05, 0x2B07).addRange(0x2B1B, 0x2B1C).addRange(0x1F000, 0x1F0FF).addRange(0x1F10D, 0x1F10F).addRange(0x1F16C, 0x1F171).addRange(0x1F17E, 0x1F17F).addRange(0x1F191, 0x1F19A).addRange(0x1F1AD, 0x1F1E5).addRange(0x1F201, 0x1F20F).addRange(0x1F232, 0x1F23A).addRange(0x1F23C, 0x1F23F).addRange(0x1F249, 0x1F3FA).addRange(0x1F400, 0x1F53D).addRange(0x1F546, 0x1F64F).addRange(0x1F680, 0x1F6FF).addRange(0x1F774, 0x1F77F).addRange(0x1F7D5, 0x1F7FF).addRange(0x1F80C, 0x1F80F).addRange(0x1F848, 0x1F84F).addRange(0x1F85A, 0x1F85F).addRange(0x1F888, 0x1F88F).addRange(0x1F8AE, 0x1F8FF).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1FAFF).addRange(0x1FC00, 0x1FFFD);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Extender.js", function (module, exports) {
	  const set = regenerate(0xB7, 0x640, 0x7FA, 0xB55, 0xE46, 0xEC6, 0x180A, 0x1843, 0x1AA7, 0x1C36, 0x1C7B, 0x3005, 0xA015, 0xA60C, 0xA9CF, 0xA9E6, 0xAA70, 0xAADD, 0xFF70, 0x1135D, 0x11A98, 0x16FE3);
	set.addRange(0x2D0, 0x2D1).addRange(0x3031, 0x3035).addRange(0x309D, 0x309E).addRange(0x30FC, 0x30FE).addRange(0xAAF3, 0xAAF4).addRange(0x10781, 0x10782).addRange(0x115C6, 0x115C8).addRange(0x16B42, 0x16B43).addRange(0x16FE0, 0x16FE1).addRange(0x1E13C, 0x1E13D).addRange(0x1E944, 0x1E946);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Grapheme_Base.js", function (module, exports) {
	  const set = regenerate(0x38C, 0x5BE, 0x5C0, 0x5C3, 0x5C6, 0x61B, 0x6DE, 0x6E9, 0x710, 0x7B1, 0x81A, 0x824, 0x828, 0x85E, 0x93B, 0x9B2, 0x9BD, 0x9CE, 0xA03, 0xA5E, 0xA76, 0xA83, 0xAC9, 0xAD0, 0xAF9, 0xB3D, 0xB40, 0xB83, 0xB9C, 0xBBF, 0xBD0, 0xC3D, 0xC5D, 0xD3D, 0xDBD, 0xE84, 0xEA5, 0xEBD, 0xEC6, 0xF36, 0xF38, 0xF7F, 0xF85, 0x1031, 0x1038, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x1715, 0x17B6, 0x18AA, 0x1940, 0x1A57, 0x1A61, 0x1B3B, 0x1BAA, 0x1BE7, 0x1BEE, 0x1CD3, 0x1CE1, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x2D27, 0x2D2D, 0xA673, 0xA7D3, 0xAA4D, 0xAAB1, 0xAAC0, 0xAAC2, 0xFB1D, 0xFB3E, 0xFDCF, 0x101A0, 0x10808, 0x1083C, 0x1093F, 0x10EAD, 0x11000, 0x11075, 0x1112C, 0x11235, 0x11288, 0x1133D, 0x1133F, 0x11350, 0x11445, 0x1145D, 0x114B9, 0x114BE, 0x114C1, 0x115BE, 0x1163E, 0x116AC, 0x116B6, 0x11726, 0x11838, 0x1183B, 0x11909, 0x1193D, 0x11A00, 0x11A50, 0x11A97, 0x11C3E, 0x11CA9, 0x11CB1, 0x11CB4, 0x11D46, 0x11D96, 0x11D98, 0x11FB0, 0x16AF5, 0x1BC9C, 0x1BC9F, 0x1D166, 0x1D245, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E2FF, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E, 0x1F7F0);
	set.addRange(0x20, 0x7E).addRange(0xA0, 0xAC).addRange(0xAE, 0x2FF).addRange(0x370, 0x377).addRange(0x37A, 0x37F).addRange(0x384, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x482).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x559, 0x58A).addRange(0x58D, 0x58F).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F4).addRange(0x606, 0x60F).addRange(0x61D, 0x64A).addRange(0x660, 0x66F).addRange(0x671, 0x6D5).addRange(0x6E5, 0x6E6).addRange(0x6EE, 0x70D).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7C0, 0x7EA).addRange(0x7F4, 0x7FA).addRange(0x7FE, 0x815).addRange(0x830, 0x83E).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x903, 0x939).addRange(0x93D, 0x940).addRange(0x949, 0x94C).addRange(0x94E, 0x950).addRange(0x958, 0x961).addRange(0x964, 0x980).addRange(0x982, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BF, 0x9C0).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CC).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9E6, 0x9FD).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28);
	set.addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA40).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA6F).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABD, 0xAC0).addRange(0xACB, 0xACC).addRange(0xAE0, 0xAE1).addRange(0xAE6, 0xAF1).addRange(0xB02, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4C).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB66, 0xB77).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBC1, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCC).addRange(0xBE6, 0xBFA).addRange(0xC01, 0xC03).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC41, 0xC44).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC66, 0xC6F);
	set.addRange(0xC77, 0xC80).addRange(0xC82, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBD, 0xCBE).addRange(0xCC0, 0xCC1).addRange(0xCC3, 0xCC4).addRange(0xCC7, 0xCC8).addRange(0xCCA, 0xCCB).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF2).addRange(0xD02, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD3F, 0xD40).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4C).addRange(0xD4E, 0xD4F).addRange(0xD54, 0xD56).addRange(0xD58, 0xD61).addRange(0xD66, 0xD7F).addRange(0xD82, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDD0, 0xDD1).addRange(0xDD8, 0xDDE).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF4).addRange(0xE01, 0xE30).addRange(0xE32, 0xE33).addRange(0xE3F, 0xE46).addRange(0xE4F, 0xE5B).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEB2, 0xEB3).addRange(0xEC0, 0xEC4).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF).addRange(0xF00, 0xF17).addRange(0xF1A, 0xF34).addRange(0xF3A, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C);
	set.addRange(0xFBE, 0xFC5).addRange(0xFC7, 0xFCC).addRange(0xFCE, 0xFDA).addRange(0x1000, 0x102C).addRange(0x103B, 0x103C).addRange(0x103F, 0x1057).addRange(0x105A, 0x105D).addRange(0x1061, 0x1070).addRange(0x1075, 0x1081).addRange(0x1083, 0x1084).addRange(0x1087, 0x108C).addRange(0x108E, 0x109C).addRange(0x109E, 0x10C5).addRange(0x10D0, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1360, 0x137C).addRange(0x1380, 0x1399).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1400, 0x169C).addRange(0x16A0, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1734, 0x1736).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x17BE, 0x17C5).addRange(0x17C7, 0x17C8).addRange(0x17D4, 0x17DC).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x1800, 0x180A).addRange(0x1810, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x1884).addRange(0x1887, 0x18A8).addRange(0x18B0, 0x18F5);
	set.addRange(0x1900, 0x191E).addRange(0x1923, 0x1926).addRange(0x1929, 0x192B).addRange(0x1930, 0x1931).addRange(0x1933, 0x1938).addRange(0x1944, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x19DE, 0x1A16).addRange(0x1A19, 0x1A1A).addRange(0x1A1E, 0x1A55).addRange(0x1A63, 0x1A64).addRange(0x1A6D, 0x1A72).addRange(0x1A80, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AA0, 0x1AAD).addRange(0x1B04, 0x1B33).addRange(0x1B3D, 0x1B41).addRange(0x1B43, 0x1B4C).addRange(0x1B50, 0x1B6A).addRange(0x1B74, 0x1B7E).addRange(0x1B82, 0x1BA1).addRange(0x1BA6, 0x1BA7).addRange(0x1BAE, 0x1BE5).addRange(0x1BEA, 0x1BEC).addRange(0x1BF2, 0x1BF3).addRange(0x1BFC, 0x1C2B).addRange(0x1C34, 0x1C35).addRange(0x1C3B, 0x1C49).addRange(0x1C4D, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CC7).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF7).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FC4).addRange(0x1FC6, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FDD, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFE);
	set.addRange(0x2000, 0x200A).addRange(0x2010, 0x2027).addRange(0x202F, 0x205F).addRange(0x2070, 0x2071).addRange(0x2074, 0x208E).addRange(0x2090, 0x209C).addRange(0x20A0, 0x20C0).addRange(0x2100, 0x218B).addRange(0x2190, 0x2426).addRange(0x2440, 0x244A).addRange(0x2460, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2CF9, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D6F, 0x2D70).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2E00, 0x2E5D).addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x2FF0, 0x2FFB).addRange(0x3000, 0x3029).addRange(0x3030, 0x303F).addRange(0x3041, 0x3096).addRange(0x309B, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x3190, 0x31E3).addRange(0x31F0, 0x321E).addRange(0x3220, 0xA48C).addRange(0xA490, 0xA4C6).addRange(0xA4D0, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA67E, 0xA69D).addRange(0xA6A0, 0xA6EF).addRange(0xA6F2, 0xA6F7).addRange(0xA700, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA801).addRange(0xA803, 0xA805);
	set.addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA824).addRange(0xA827, 0xA82B).addRange(0xA830, 0xA839).addRange(0xA840, 0xA877).addRange(0xA880, 0xA8C3).addRange(0xA8CE, 0xA8D9).addRange(0xA8F2, 0xA8FE).addRange(0xA900, 0xA925).addRange(0xA92E, 0xA946).addRange(0xA952, 0xA953).addRange(0xA95F, 0xA97C).addRange(0xA983, 0xA9B2).addRange(0xA9B4, 0xA9B5).addRange(0xA9BA, 0xA9BB).addRange(0xA9BE, 0xA9CD).addRange(0xA9CF, 0xA9D9).addRange(0xA9DE, 0xA9E4).addRange(0xA9E6, 0xA9FE).addRange(0xAA00, 0xAA28).addRange(0xAA2F, 0xAA30).addRange(0xAA33, 0xAA34).addRange(0xAA40, 0xAA42).addRange(0xAA44, 0xAA4B).addRange(0xAA50, 0xAA59).addRange(0xAA5C, 0xAA7B).addRange(0xAA7D, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAAEB).addRange(0xAAEE, 0xAAF5).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB6B).addRange(0xAB70, 0xABE4).addRange(0xABE6, 0xABE7).addRange(0xABE9, 0xABEC).addRange(0xABF0, 0xABF9).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41);
	set.addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBC2).addRange(0xFBD3, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFF).addRange(0xFE10, 0xFE19).addRange(0xFE30, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF01, 0xFF9D).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFFC, 0xFFFD).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1018E).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x102E1, 0x102FB).addRange(0x10300, 0x10323).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x1039F, 0x103C3).addRange(0x103C8, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104A0, 0x104A9).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x1056F, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595);
	set.addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10857, 0x1089E).addRange(0x108A7, 0x108AF).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x108FB, 0x1091B).addRange(0x1091F, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BC, 0x109CF).addRange(0x109D2, 0x10A00).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A40, 0x10A48).addRange(0x10A50, 0x10A58).addRange(0x10A60, 0x10A9F).addRange(0x10AC0, 0x10AE4).addRange(0x10AEB, 0x10AF6).addRange(0x10B00, 0x10B35).addRange(0x10B39, 0x10B55).addRange(0x10B58, 0x10B72).addRange(0x10B78, 0x10B91).addRange(0x10B99, 0x10B9C).addRange(0x10BA9, 0x10BAF).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10CFA, 0x10D23).addRange(0x10D30, 0x10D39).addRange(0x10E60, 0x10E7E).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F27).addRange(0x10F30, 0x10F45).addRange(0x10F51, 0x10F59).addRange(0x10F70, 0x10F81).addRange(0x10F86, 0x10F89).addRange(0x10FB0, 0x10FCB);
	set.addRange(0x10FE0, 0x10FF6).addRange(0x11002, 0x11037).addRange(0x11047, 0x1104D).addRange(0x11052, 0x1106F).addRange(0x11071, 0x11072).addRange(0x11082, 0x110B2).addRange(0x110B7, 0x110B8).addRange(0x110BB, 0x110BC).addRange(0x110BE, 0x110C1).addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9).addRange(0x11103, 0x11126).addRange(0x11136, 0x11147).addRange(0x11150, 0x11172).addRange(0x11174, 0x11176).addRange(0x11182, 0x111B5).addRange(0x111BF, 0x111C8).addRange(0x111CD, 0x111CE).addRange(0x111D0, 0x111DF).addRange(0x111E1, 0x111F4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122E).addRange(0x11232, 0x11233).addRange(0x11238, 0x1123D).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A9).addRange(0x112B0, 0x112DE).addRange(0x112E0, 0x112E2).addRange(0x112F0, 0x112F9).addRange(0x11302, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x11341, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11400, 0x11437).addRange(0x11440, 0x11441).addRange(0x11447, 0x1145B).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114B1, 0x114B2).addRange(0x114BB, 0x114BC).addRange(0x114C4, 0x114C7).addRange(0x114D0, 0x114D9);
	set.addRange(0x11580, 0x115AE).addRange(0x115B0, 0x115B1).addRange(0x115B8, 0x115BB).addRange(0x115C1, 0x115DB).addRange(0x11600, 0x11632).addRange(0x1163B, 0x1163C).addRange(0x11641, 0x11644).addRange(0x11650, 0x11659).addRange(0x11660, 0x1166C).addRange(0x11680, 0x116AA).addRange(0x116AE, 0x116AF).addRange(0x116B8, 0x116B9).addRange(0x116C0, 0x116C9).addRange(0x11700, 0x1171A).addRange(0x11720, 0x11721).addRange(0x11730, 0x11746).addRange(0x11800, 0x1182E).addRange(0x118A0, 0x118F2).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x11931, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193F, 0x11942).addRange(0x11944, 0x11946).addRange(0x11950, 0x11959).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D3).addRange(0x119DC, 0x119DF).addRange(0x119E1, 0x119E4).addRange(0x11A0B, 0x11A32).addRange(0x11A39, 0x11A3A).addRange(0x11A3F, 0x11A46).addRange(0x11A57, 0x11A58).addRange(0x11A5C, 0x11A89).addRange(0x11A9A, 0x11AA2).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2F).addRange(0x11C40, 0x11C45).addRange(0x11C50, 0x11C6C).addRange(0x11C70, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D50, 0x11D59).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D93, 0x11D94);
	set.addRange(0x11DA0, 0x11DA9).addRange(0x11EE0, 0x11EF2).addRange(0x11EF5, 0x11EF8).addRange(0x11FC0, 0x11FF1).addRange(0x11FFF, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12470, 0x12474).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF2).addRange(0x13000, 0x1342E).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A6E, 0x16ABE).addRange(0x16AC0, 0x16AC9).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B37, 0x16B45).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E9A).addRange(0x16F00, 0x16F4A).addRange(0x16F50, 0x16F87).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE3).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D164).addRange(0x1D16A, 0x1D16D).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA);
	set.addRange(0x1D200, 0x1D241).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D300, 0x1D356).addRange(0x1D360, 0x1D378).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D9FF).addRange(0x1DA37, 0x1DA3A).addRange(0x1DA6D, 0x1DA74).addRange(0x1DA76, 0x1DA83).addRange(0x1DA85, 0x1DA8B).addRange(0x1DF00, 0x1DF1E).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E14E, 0x1E14F).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E2F0, 0x1E2F9).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E8C7, 0x1E8CF).addRange(0x1E900, 0x1E943).addRange(0x1E950, 0x1E959).addRange(0x1E95E, 0x1E95F).addRange(0x1EC71, 0x1ECB4).addRange(0x1ED01, 0x1ED3D).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F);
	set.addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F100, 0x1F1AD).addRange(0x1F1E6, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DD, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F773).addRange(0x1F780, 0x1F7D8).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA).addRange(0x1FBF0, 0x1FBF9).addRange(0x20000, 0x2A6DF);
	set.addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Grapheme_Extend.js", function (module, exports) {
	  const set = regenerate(0x5BF, 0x5C7, 0x670, 0x711, 0x7FD, 0x93A, 0x93C, 0x94D, 0x981, 0x9BC, 0x9BE, 0x9CD, 0x9D7, 0x9FE, 0xA3C, 0xA51, 0xA75, 0xABC, 0xACD, 0xB01, 0xB3C, 0xB4D, 0xB82, 0xBBE, 0xBC0, 0xBCD, 0xBD7, 0xC00, 0xC04, 0xC3C, 0xC81, 0xCBC, 0xCBF, 0xCC2, 0xCC6, 0xD3E, 0xD4D, 0xD57, 0xD81, 0xDCA, 0xDCF, 0xDD6, 0xDDF, 0xE31, 0xEB1, 0xF35, 0xF37, 0xF39, 0xFC6, 0x1082, 0x108D, 0x109D, 0x17C6, 0x17DD, 0x180F, 0x18A9, 0x1932, 0x1A1B, 0x1A56, 0x1A60, 0x1A62, 0x1A7F, 0x1B3C, 0x1B42, 0x1BE6, 0x1BED, 0x1CED, 0x1CF4, 0x200C, 0x2D7F, 0xA802, 0xA806, 0xA80B, 0xA82C, 0xA8FF, 0xA9B3, 0xA9E5, 0xAA43, 0xAA4C, 0xAA7C, 0xAAB0, 0xAAC1, 0xAAF6, 0xABE5, 0xABE8, 0xABED, 0xFB1E, 0x101FD, 0x102E0, 0x10A3F, 0x11001, 0x11070, 0x110C2, 0x11173, 0x111CF, 0x11234, 0x1123E, 0x112DF, 0x1133E, 0x11340, 0x11357, 0x11446, 0x1145E, 0x114B0, 0x114BA, 0x114BD, 0x115AF, 0x1163D, 0x116AB, 0x116AD, 0x116B7, 0x11930, 0x1193E, 0x11943, 0x119E0, 0x11A47, 0x11C3F, 0x11D3A, 0x11D47, 0x11D95, 0x11D97, 0x16F4F, 0x16FE4, 0x1D165, 0x1DA75, 0x1DA84, 0x1E2AE);
	set.addRange(0x300, 0x36F).addRange(0x483, 0x489).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x610, 0x61A).addRange(0x64B, 0x65F).addRange(0x6D6, 0x6DC).addRange(0x6DF, 0x6E4).addRange(0x6E7, 0x6E8).addRange(0x6EA, 0x6ED).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F3).addRange(0x816, 0x819).addRange(0x81B, 0x823).addRange(0x825, 0x827).addRange(0x829, 0x82D).addRange(0x859, 0x85B).addRange(0x898, 0x89F).addRange(0x8CA, 0x8E1).addRange(0x8E3, 0x902).addRange(0x941, 0x948).addRange(0x951, 0x957).addRange(0x962, 0x963).addRange(0x9C1, 0x9C4).addRange(0x9E2, 0x9E3).addRange(0xA01, 0xA02).addRange(0xA41, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA70, 0xA71).addRange(0xA81, 0xA82).addRange(0xAC1, 0xAC5).addRange(0xAC7, 0xAC8).addRange(0xAE2, 0xAE3).addRange(0xAFA, 0xAFF).addRange(0xB3E, 0xB3F).addRange(0xB41, 0xB44).addRange(0xB55, 0xB57).addRange(0xB62, 0xB63).addRange(0xC3E, 0xC40).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC62, 0xC63).addRange(0xCCC, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCE2, 0xCE3).addRange(0xD00, 0xD01).addRange(0xD3B, 0xD3C);
	set.addRange(0xD41, 0xD44).addRange(0xD62, 0xD63).addRange(0xDD2, 0xDD4).addRange(0xE34, 0xE3A).addRange(0xE47, 0xE4E).addRange(0xEB4, 0xEBC).addRange(0xEC8, 0xECD).addRange(0xF18, 0xF19).addRange(0xF71, 0xF7E).addRange(0xF80, 0xF84).addRange(0xF86, 0xF87).addRange(0xF8D, 0xF97).addRange(0xF99, 0xFBC).addRange(0x102D, 0x1030).addRange(0x1032, 0x1037).addRange(0x1039, 0x103A).addRange(0x103D, 0x103E).addRange(0x1058, 0x1059).addRange(0x105E, 0x1060).addRange(0x1071, 0x1074).addRange(0x1085, 0x1086).addRange(0x135D, 0x135F).addRange(0x1712, 0x1714).addRange(0x1732, 0x1733).addRange(0x1752, 0x1753).addRange(0x1772, 0x1773).addRange(0x17B4, 0x17B5).addRange(0x17B7, 0x17BD).addRange(0x17C9, 0x17D3).addRange(0x180B, 0x180D).addRange(0x1885, 0x1886).addRange(0x1920, 0x1922).addRange(0x1927, 0x1928).addRange(0x1939, 0x193B).addRange(0x1A17, 0x1A18).addRange(0x1A58, 0x1A5E).addRange(0x1A65, 0x1A6C).addRange(0x1A73, 0x1A7C).addRange(0x1AB0, 0x1ACE).addRange(0x1B00, 0x1B03).addRange(0x1B34, 0x1B3A).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1B81).addRange(0x1BA2, 0x1BA5).addRange(0x1BA8, 0x1BA9).addRange(0x1BAB, 0x1BAD).addRange(0x1BE8, 0x1BE9).addRange(0x1BEF, 0x1BF1).addRange(0x1C2C, 0x1C33).addRange(0x1C36, 0x1C37).addRange(0x1CD0, 0x1CD2);
	set.addRange(0x1CD4, 0x1CE0).addRange(0x1CE2, 0x1CE8).addRange(0x1CF8, 0x1CF9).addRange(0x1DC0, 0x1DFF).addRange(0x20D0, 0x20F0).addRange(0x2CEF, 0x2CF1).addRange(0x2DE0, 0x2DFF).addRange(0x302A, 0x302F).addRange(0x3099, 0x309A).addRange(0xA66F, 0xA672).addRange(0xA674, 0xA67D).addRange(0xA69E, 0xA69F).addRange(0xA6F0, 0xA6F1).addRange(0xA825, 0xA826).addRange(0xA8C4, 0xA8C5).addRange(0xA8E0, 0xA8F1).addRange(0xA926, 0xA92D).addRange(0xA947, 0xA951).addRange(0xA980, 0xA982).addRange(0xA9B6, 0xA9B9).addRange(0xA9BC, 0xA9BD).addRange(0xAA29, 0xAA2E).addRange(0xAA31, 0xAA32).addRange(0xAA35, 0xAA36).addRange(0xAAB2, 0xAAB4).addRange(0xAAB7, 0xAAB8).addRange(0xAABE, 0xAABF).addRange(0xAAEC, 0xAAED).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0xFF9E, 0xFF9F).addRange(0x10376, 0x1037A).addRange(0x10A01, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A0F).addRange(0x10A38, 0x10A3A).addRange(0x10AE5, 0x10AE6).addRange(0x10D24, 0x10D27).addRange(0x10EAB, 0x10EAC).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x11038, 0x11046).addRange(0x11073, 0x11074).addRange(0x1107F, 0x11081).addRange(0x110B3, 0x110B6).addRange(0x110B9, 0x110BA).addRange(0x11100, 0x11102).addRange(0x11127, 0x1112B).addRange(0x1112D, 0x11134).addRange(0x11180, 0x11181).addRange(0x111B6, 0x111BE);
	set.addRange(0x111C9, 0x111CC).addRange(0x1122F, 0x11231).addRange(0x11236, 0x11237).addRange(0x112E3, 0x112EA).addRange(0x11300, 0x11301).addRange(0x1133B, 0x1133C).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11438, 0x1143F).addRange(0x11442, 0x11444).addRange(0x114B3, 0x114B8).addRange(0x114BF, 0x114C0).addRange(0x114C2, 0x114C3).addRange(0x115B2, 0x115B5).addRange(0x115BC, 0x115BD).addRange(0x115BF, 0x115C0).addRange(0x115DC, 0x115DD).addRange(0x11633, 0x1163A).addRange(0x1163F, 0x11640).addRange(0x116B0, 0x116B5).addRange(0x1171D, 0x1171F).addRange(0x11722, 0x11725).addRange(0x11727, 0x1172B).addRange(0x1182F, 0x11837).addRange(0x11839, 0x1183A).addRange(0x1193B, 0x1193C).addRange(0x119D4, 0x119D7).addRange(0x119DA, 0x119DB).addRange(0x11A01, 0x11A0A).addRange(0x11A33, 0x11A38).addRange(0x11A3B, 0x11A3E).addRange(0x11A51, 0x11A56).addRange(0x11A59, 0x11A5B).addRange(0x11A8A, 0x11A96).addRange(0x11A98, 0x11A99).addRange(0x11C30, 0x11C36).addRange(0x11C38, 0x11C3D).addRange(0x11C92, 0x11CA7).addRange(0x11CAA, 0x11CB0).addRange(0x11CB2, 0x11CB3).addRange(0x11CB5, 0x11CB6).addRange(0x11D31, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D45).addRange(0x11D90, 0x11D91).addRange(0x11EF3, 0x11EF4).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16F8F, 0x16F92).addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D);
	set.addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D16E, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E130, 0x1E136).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E94A).addRange(0xE0020, 0xE007F).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Hex_Digit.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x30, 0x39).addRange(0x41, 0x46).addRange(0x61, 0x66).addRange(0xFF10, 0xFF19).addRange(0xFF21, 0xFF26).addRange(0xFF41, 0xFF46);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/ID_Continue.js", function (module, exports) {
	  const set = regenerate(0x5F, 0xAA, 0xB5, 0xB7, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x38C, 0x559, 0x5BF, 0x5C7, 0x6FF, 0x7FA, 0x7FD, 0x9B2, 0x9D7, 0x9FC, 0x9FE, 0xA3C, 0xA51, 0xA5E, 0xAD0, 0xB71, 0xB9C, 0xBD0, 0xBD7, 0xC5D, 0xDBD, 0xDCA, 0xDD6, 0xE84, 0xEA5, 0xEC6, 0xF00, 0xF35, 0xF37, 0xF39, 0xFC6, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x1AA7, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2054, 0x2071, 0x207F, 0x20E1, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0xA7D3, 0xA82C, 0xA8FB, 0xFB3E, 0xFF3F, 0x101FD, 0x102E0, 0x10808, 0x1083C, 0x10A3F, 0x10F27, 0x110C2, 0x11176, 0x111DC, 0x1123E, 0x11288, 0x11350, 0x11357, 0x114C7, 0x11644, 0x11909, 0x11A47, 0x11A9D, 0x11D3A, 0x11FB0, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1DA75, 0x1DA84, 0x1E14E, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x300, 0x374).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x386, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x483, 0x487).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x610, 0x61A).addRange(0x620, 0x669).addRange(0x66E, 0x6D3).addRange(0x6D5, 0x6DC).addRange(0x6DF, 0x6E8).addRange(0x6EA, 0x6FC).addRange(0x710, 0x74A).addRange(0x74D, 0x7B1).addRange(0x7C0, 0x7F5).addRange(0x800, 0x82D).addRange(0x840, 0x85B).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x898, 0x8E1).addRange(0x8E3, 0x963).addRange(0x966, 0x96F).addRange(0x971, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD);
	set.addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9F1).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA75).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAEF).addRange(0xAF9, 0xAFF).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB6F).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9);
	set.addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBEF).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC80, 0xC83).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF2).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4E).addRange(0xD54, 0xD57).addRange(0xD5F, 0xD63).addRange(0xD66, 0xD6F).addRange(0xD7A, 0xD7F).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF3).addRange(0xE01, 0xE3A).addRange(0xE40, 0xE4E).addRange(0xE50, 0xE59).addRange(0xE81, 0xE82);
	set.addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECD).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF).addRange(0xF18, 0xF19).addRange(0xF20, 0xF29).addRange(0xF3E, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF84).addRange(0xF86, 0xF97).addRange(0xF99, 0xFBC).addRange(0x1000, 0x1049).addRange(0x1050, 0x109D).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x135F).addRange(0x1369, 0x1371).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1715).addRange(0x171F, 0x1734).addRange(0x1740, 0x1753).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773).addRange(0x1780, 0x17D3).addRange(0x17DC, 0x17DD).addRange(0x17E0, 0x17E9);
	set.addRange(0x180B, 0x180D).addRange(0x180F, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1946, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x1A00, 0x1A1B).addRange(0x1A20, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AB0, 0x1ABD).addRange(0x1ABF, 0x1ACE).addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B59).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1BF3).addRange(0x1C00, 0x1C37).addRange(0x1C40, 0x1C49).addRange(0x1C4D, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CFA).addRange(0x1D00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x203F, 0x2040).addRange(0x2090, 0x209C).addRange(0x20D0, 0x20DC).addRange(0x20E5, 0x20F0);
	set.addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x212A, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D7F, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2DE0, 0x2DFF).addRange(0x3005, 0x3007).addRange(0x3021, 0x302F).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x3099, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA62B).addRange(0xA640, 0xA66F).addRange(0xA674, 0xA67D).addRange(0xA67F, 0xA6F1).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA827).addRange(0xA840, 0xA873).addRange(0xA880, 0xA8C5).addRange(0xA8D0, 0xA8D9).addRange(0xA8E0, 0xA8F7).addRange(0xA8FD, 0xA92D);
	set.addRange(0xA930, 0xA953).addRange(0xA960, 0xA97C).addRange(0xA980, 0xA9C0).addRange(0xA9CF, 0xA9D9).addRange(0xA9E0, 0xA9FE).addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA60, 0xAA76).addRange(0xAA7A, 0xAAC2).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEF).addRange(0xAAF2, 0xAAF6).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABEA).addRange(0xABEC, 0xABED).addRange(0xABF0, 0xABF9).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1D, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0xFE33, 0xFE34).addRange(0xFE4D, 0xFE4F).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF10, 0xFF19).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFFBE).addRange(0xFFC2, 0xFFC7);
	set.addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x1037A).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104A0, 0x104A9).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7);
	set.addRange(0x109BE, 0x109BF).addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE6).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D27).addRange(0x10D30, 0x10D39).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAC).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F50).addRange(0x10F70, 0x10F85).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11000, 0x11046).addRange(0x11066, 0x11075).addRange(0x1107F, 0x110BA).addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9).addRange(0x11100, 0x11134).addRange(0x11136, 0x1113F).addRange(0x11144, 0x11147).addRange(0x11150, 0x11173).addRange(0x11180, 0x111C4).addRange(0x111C9, 0x111CC).addRange(0x111CE, 0x111DA).addRange(0x11200, 0x11211).addRange(0x11213, 0x11237).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9).addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310);
	set.addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133B, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11400, 0x1144A).addRange(0x11450, 0x11459).addRange(0x1145E, 0x11461).addRange(0x11480, 0x114C5).addRange(0x114D0, 0x114D9).addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115C0).addRange(0x115D8, 0x115DD).addRange(0x11600, 0x11640).addRange(0x11650, 0x11659).addRange(0x11680, 0x116B8).addRange(0x116C0, 0x116C9).addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11739).addRange(0x11740, 0x11746).addRange(0x11800, 0x1183A).addRange(0x118A0, 0x118E9).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11943).addRange(0x11950, 0x11959).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E1).addRange(0x119E3, 0x119E4).addRange(0x11A00, 0x11A3E).addRange(0x11A50, 0x11A99).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C40).addRange(0x11C50, 0x11C59).addRange(0x11C72, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09);
	set.addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9).addRange(0x11EE0, 0x11EF6).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342E).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A70, 0x16ABE).addRange(0x16AC0, 0x16AC9).addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF4).addRange(0x16B00, 0x16B36).addRange(0x16B40, 0x16B43).addRange(0x16B50, 0x16B59).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x16FE3, 0x16FE4).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9D, 0x1BC9E);
	set.addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D165, 0x1D169).addRange(0x1D16D, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1DF00, 0x1DF1E).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E290, 0x1E2AE).addRange(0x1E2C0, 0x1E2F9);
	set.addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1FBF0, 0x1FBF9).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/ID_Start.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xB5, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x386, 0x38C, 0x559, 0x6D5, 0x6FF, 0x710, 0x7B1, 0x7FA, 0x81A, 0x824, 0x828, 0x93D, 0x950, 0x9B2, 0x9BD, 0x9CE, 0x9FC, 0xA5E, 0xABD, 0xAD0, 0xAF9, 0xB3D, 0xB71, 0xB83, 0xB9C, 0xBD0, 0xC3D, 0xC5D, 0xC80, 0xCBD, 0xD3D, 0xD4E, 0xDBD, 0xE84, 0xEA5, 0xEBD, 0xEC6, 0xF00, 0x103F, 0x1061, 0x108E, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x17DC, 0x18AA, 0x1AA7, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0xA7D3, 0xA8FB, 0xA9CF, 0xAA7A, 0xAAB1, 0xAAC0, 0xAAC2, 0xFB1D, 0xFB3E, 0x10808, 0x1083C, 0x10A00, 0x10F27, 0x11075, 0x11144, 0x11147, 0x11176, 0x111DA, 0x111DC, 0x11288, 0x1133D, 0x11350, 0x114C7, 0x11644, 0x116B8, 0x11909, 0x1193F, 0x11941, 0x119E1, 0x119E3, 0x11A00, 0x11A3A, 0x11A50, 0x11A9D, 0x11C40, 0x11D46, 0x11D98, 0x11FB0, 0x16F50, 0x16FE3, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E14E, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x374).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x620, 0x64A).addRange(0x66E, 0x66F).addRange(0x671, 0x6D3).addRange(0x6E5, 0x6E6).addRange(0x6EE, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7CA, 0x7EA).addRange(0x7F4, 0x7F5).addRange(0x800, 0x815).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x904, 0x939).addRange(0x958, 0x961).addRange(0x971, 0x980).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9F0, 0x9F1).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33);
	set.addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA59, 0xA5C).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xAE0, 0xAE1).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCF1, 0xCF2).addRange(0xD04, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD54, 0xD56).addRange(0xD5F, 0xD61).addRange(0xD7A, 0xD7F).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6);
	set.addRange(0xE01, 0xE30).addRange(0xE32, 0xE33).addRange(0xE40, 0xE46).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEB2, 0xEB3).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C).addRange(0x1000, 0x102A).addRange(0x1050, 0x1055).addRange(0x105A, 0x105D).addRange(0x1065, 0x1066).addRange(0x106E, 0x1070).addRange(0x1075, 0x1081).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x1820, 0x1878).addRange(0x1880, 0x18A8);
	set.addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A16).addRange(0x1A20, 0x1A54).addRange(0x1B05, 0x1B33).addRange(0x1B45, 0x1B4C).addRange(0x1B83, 0x1BA0).addRange(0x1BAE, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1C00, 0x1C23).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x212A, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96);
	set.addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x3005, 0x3007).addRange(0x3021, 0x3029).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x309B, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA67F, 0xA69D).addRange(0xA6A0, 0xA6EF).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA822).addRange(0xA840, 0xA873).addRange(0xA882, 0xA8B3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FE).addRange(0xA90A, 0xA925).addRange(0xA930, 0xA946).addRange(0xA960, 0xA97C).addRange(0xA984, 0xA9B2).addRange(0xA9E0, 0xA9E4).addRange(0xA9E6, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA28).addRange(0xAA40, 0xAA42);
	set.addRange(0xAA44, 0xAA4B).addRange(0xAA60, 0xAA76).addRange(0xAA7E, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEA).addRange(0xAAF2, 0xAAF4).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABE2).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C);
	set.addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48);
	set.addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D23).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11003, 0x11037).addRange(0x11071, 0x11072).addRange(0x11083, 0x110AF).addRange(0x110D0, 0x110E8).addRange(0x11103, 0x11126).addRange(0x11150, 0x11172).addRange(0x11183, 0x111B2).addRange(0x111C1, 0x111C4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122B).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112DE).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1135D, 0x11361).addRange(0x11400, 0x11434).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114C4, 0x114C5).addRange(0x11580, 0x115AE).addRange(0x115D8, 0x115DB).addRange(0x11600, 0x1162F).addRange(0x11680, 0x116AA).addRange(0x11700, 0x1171A).addRange(0x11740, 0x11746).addRange(0x11800, 0x1182B).addRange(0x118A0, 0x118DF).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D0);
	set.addRange(0x11A0B, 0x11A32).addRange(0x11A5C, 0x11A89).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2E).addRange(0x11C72, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D89).addRange(0x11EE0, 0x11EF2).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342E).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B40, 0x16B43).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9);
	set.addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF1E).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E900, 0x1E943).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738);
	set.addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Ideographic.js", function (module, exports) {
	  const set = regenerate(0x16FE4);
	set.addRange(0x3006, 0x3007).addRange(0x3021, 0x3029).addRange(0x3038, 0x303A).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0x9FFF).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1B170, 0x1B2FB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/IDS_Binary_Operator.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x2FF0, 0x2FF1).addRange(0x2FF4, 0x2FFB);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/IDS_Trinary_Operator.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x2FF2, 0x2FF3);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Join_Control.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x200C, 0x200D);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Logical_Order_Exception.js", function (module, exports) {
	  const set = regenerate(0x19BA, 0xAAB9);
	set.addRange(0xE40, 0xE44).addRange(0xEC0, 0xEC4).addRange(0x19B5, 0x19B7).addRange(0xAAB5, 0xAAB6).addRange(0xAABB, 0xAABC);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Lowercase.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xB5, 0xBA, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x183, 0x185, 0x188, 0x192, 0x195, 0x19E, 0x1A1, 0x1A3, 0x1A5, 0x1A8, 0x1AD, 0x1B0, 0x1B4, 0x1B6, 0x1C6, 0x1C9, 0x1CC, 0x1CE, 0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DF, 0x1E1, 0x1E3, 0x1E5, 0x1E7, 0x1E9, 0x1EB, 0x1ED, 0x1F3, 0x1F5, 0x1F9, 0x1FB, 0x1FD, 0x1FF, 0x201, 0x203, 0x205, 0x207, 0x209, 0x20B, 0x20D, 0x20F, 0x211, 0x213, 0x215, 0x217, 0x219, 0x21B, 0x21D, 0x21F, 0x221, 0x223, 0x225, 0x227, 0x229, 0x22B, 0x22D, 0x22F, 0x231, 0x23C, 0x242, 0x247, 0x249, 0x24B, 0x24D, 0x345, 0x371, 0x373, 0x377, 0x390, 0x3D9, 0x3DB, 0x3DD, 0x3DF, 0x3E1, 0x3E3, 0x3E5, 0x3E7, 0x3E9, 0x3EB, 0x3ED, 0x3F5, 0x3F8, 0x461, 0x463, 0x465, 0x467, 0x469, 0x46B, 0x46D, 0x46F, 0x471, 0x473, 0x475, 0x477, 0x479, 0x47B, 0x47D, 0x47F, 0x481, 0x48B, 0x48D, 0x48F, 0x491, 0x493, 0x495, 0x497, 0x499, 0x49B, 0x49D, 0x49F, 0x4A1, 0x4A3, 0x4A5, 0x4A7, 0x4A9, 0x4AB, 0x4AD, 0x4AF, 0x4B1, 0x4B3, 0x4B5, 0x4B7, 0x4B9, 0x4BB, 0x4BD, 0x4BF, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4D1, 0x4D3, 0x4D5, 0x4D7, 0x4D9, 0x4DB, 0x4DD, 0x4DF, 0x4E1, 0x4E3, 0x4E5, 0x4E7, 0x4E9, 0x4EB, 0x4ED, 0x4EF, 0x4F1, 0x4F3, 0x4F5, 0x4F7, 0x4F9, 0x4FB, 0x4FD, 0x4FF, 0x501, 0x503, 0x505, 0x507, 0x509, 0x50B, 0x50D, 0x50F, 0x511, 0x513, 0x515, 0x517, 0x519, 0x51B, 0x51D, 0x51F, 0x521, 0x523, 0x525, 0x527, 0x529, 0x52B, 0x52D, 0x52F, 0x1E01, 0x1E03, 0x1E05, 0x1E07, 0x1E09, 0x1E0B, 0x1E0D, 0x1E0F, 0x1E11, 0x1E13, 0x1E15, 0x1E17, 0x1E19, 0x1E1B, 0x1E1D, 0x1E1F, 0x1E21, 0x1E23, 0x1E25, 0x1E27, 0x1E29, 0x1E2B, 0x1E2D, 0x1E2F, 0x1E31, 0x1E33, 0x1E35, 0x1E37, 0x1E39, 0x1E3B, 0x1E3D, 0x1E3F, 0x1E41, 0x1E43, 0x1E45, 0x1E47, 0x1E49, 0x1E4B, 0x1E4D, 0x1E4F, 0x1E51, 0x1E53, 0x1E55, 0x1E57, 0x1E59, 0x1E5B, 0x1E5D, 0x1E5F, 0x1E61, 0x1E63, 0x1E65, 0x1E67, 0x1E69, 0x1E6B, 0x1E6D, 0x1E6F, 0x1E71, 0x1E73, 0x1E75, 0x1E77, 0x1E79, 0x1E7B, 0x1E7D, 0x1E7F, 0x1E81, 0x1E83, 0x1E85, 0x1E87, 0x1E89, 0x1E8B, 0x1E8D, 0x1E8F, 0x1E91, 0x1E93, 0x1E9F, 0x1EA1, 0x1EA3, 0x1EA5, 0x1EA7, 0x1EA9, 0x1EAB, 0x1EAD, 0x1EAF, 0x1EB1, 0x1EB3, 0x1EB5, 0x1EB7, 0x1EB9, 0x1EBB, 0x1EBD, 0x1EBF, 0x1EC1, 0x1EC3, 0x1EC5, 0x1EC7, 0x1EC9, 0x1ECB, 0x1ECD, 0x1ECF, 0x1ED1, 0x1ED3, 0x1ED5, 0x1ED7, 0x1ED9, 0x1EDB, 0x1EDD, 0x1EDF, 0x1EE1, 0x1EE3, 0x1EE5, 0x1EE7, 0x1EE9, 0x1EEB, 0x1EED, 0x1EEF, 0x1EF1, 0x1EF3, 0x1EF5, 0x1EF7, 0x1EF9, 0x1EFB, 0x1EFD, 0x1FBE, 0x2071, 0x207F, 0x210A, 0x2113, 0x212F, 0x2134, 0x2139, 0x214E, 0x2184, 0x2C61, 0x2C68, 0x2C6A, 0x2C6C, 0x2C71, 0x2C81, 0x2C83, 0x2C85, 0x2C87, 0x2C89, 0x2C8B, 0x2C8D, 0x2C8F, 0x2C91, 0x2C93, 0x2C95, 0x2C97, 0x2C99, 0x2C9B, 0x2C9D, 0x2C9F, 0x2CA1, 0x2CA3, 0x2CA5, 0x2CA7, 0x2CA9, 0x2CAB, 0x2CAD, 0x2CAF, 0x2CB1, 0x2CB3, 0x2CB5, 0x2CB7, 0x2CB9, 0x2CBB, 0x2CBD, 0x2CBF, 0x2CC1, 0x2CC3, 0x2CC5, 0x2CC7, 0x2CC9, 0x2CCB, 0x2CCD, 0x2CCF, 0x2CD1, 0x2CD3, 0x2CD5, 0x2CD7, 0x2CD9, 0x2CDB, 0x2CDD, 0x2CDF, 0x2CE1, 0x2CEC, 0x2CEE, 0x2CF3, 0x2D27, 0x2D2D, 0xA641, 0xA643, 0xA645, 0xA647, 0xA649, 0xA64B, 0xA64D, 0xA64F, 0xA651, 0xA653, 0xA655, 0xA657, 0xA659, 0xA65B, 0xA65D, 0xA65F, 0xA661, 0xA663, 0xA665, 0xA667, 0xA669, 0xA66B, 0xA66D, 0xA681, 0xA683, 0xA685, 0xA687, 0xA689, 0xA68B, 0xA68D, 0xA68F, 0xA691, 0xA693, 0xA695, 0xA697, 0xA699, 0xA723, 0xA725, 0xA727, 0xA729, 0xA72B, 0xA72D, 0xA733, 0xA735, 0xA737, 0xA739, 0xA73B, 0xA73D, 0xA73F, 0xA741, 0xA743, 0xA745, 0xA747, 0xA749, 0xA74B, 0xA74D, 0xA74F, 0xA751, 0xA753, 0xA755, 0xA757, 0xA759, 0xA75B, 0xA75D, 0xA75F, 0xA761, 0xA763, 0xA765, 0xA767, 0xA769, 0xA76B, 0xA76D, 0xA77A, 0xA77C, 0xA77F, 0xA781, 0xA783, 0xA785, 0xA787, 0xA78C, 0xA78E, 0xA791, 0xA797, 0xA799, 0xA79B, 0xA79D, 0xA79F, 0xA7A1, 0xA7A3, 0xA7A5, 0xA7A7, 0xA7A9, 0xA7AF, 0xA7B5, 0xA7B7, 0xA7B9, 0xA7BB, 0xA7BD, 0xA7BF, 0xA7C1, 0xA7C3, 0xA7C8, 0xA7CA, 0xA7D1, 0xA7D3, 0xA7D5, 0xA7D7, 0xA7D9, 0xA7F6, 0x10780, 0x1D4BB, 0x1D7CB);
	set.addRange(0x61, 0x7A).addRange(0xDF, 0xF6).addRange(0xF8, 0xFF).addRange(0x137, 0x138).addRange(0x148, 0x149).addRange(0x17E, 0x180).addRange(0x18C, 0x18D).addRange(0x199, 0x19B).addRange(0x1AA, 0x1AB).addRange(0x1B9, 0x1BA).addRange(0x1BD, 0x1BF).addRange(0x1DC, 0x1DD).addRange(0x1EF, 0x1F0).addRange(0x233, 0x239).addRange(0x23F, 0x240).addRange(0x24F, 0x293).addRange(0x295, 0x2B8).addRange(0x2C0, 0x2C1).addRange(0x2E0, 0x2E4).addRange(0x37A, 0x37D).addRange(0x3AC, 0x3CE).addRange(0x3D0, 0x3D1).addRange(0x3D5, 0x3D7).addRange(0x3EF, 0x3F3).addRange(0x3FB, 0x3FC).addRange(0x430, 0x45F).addRange(0x4CE, 0x4CF).addRange(0x560, 0x588).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1D00, 0x1DBF).addRange(0x1E95, 0x1E9D).addRange(0x1EFF, 0x1F07).addRange(0x1F10, 0x1F15).addRange(0x1F20, 0x1F27).addRange(0x1F30, 0x1F37).addRange(0x1F40, 0x1F45).addRange(0x1F50, 0x1F57).addRange(0x1F60, 0x1F67).addRange(0x1F70, 0x1F7D).addRange(0x1F80, 0x1F87).addRange(0x1F90, 0x1F97).addRange(0x1FA0, 0x1FA7).addRange(0x1FB0, 0x1FB4).addRange(0x1FB6, 0x1FB7).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FC7).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FD7);
	set.addRange(0x1FE0, 0x1FE7).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FF7).addRange(0x2090, 0x209C).addRange(0x210E, 0x210F).addRange(0x213C, 0x213D).addRange(0x2146, 0x2149).addRange(0x2170, 0x217F).addRange(0x24D0, 0x24E9).addRange(0x2C30, 0x2C5F).addRange(0x2C65, 0x2C66).addRange(0x2C73, 0x2C74).addRange(0x2C76, 0x2C7D).addRange(0x2CE3, 0x2CE4).addRange(0x2D00, 0x2D25).addRange(0xA69B, 0xA69D).addRange(0xA72F, 0xA731).addRange(0xA76F, 0xA778).addRange(0xA793, 0xA795).addRange(0xA7F8, 0xA7FA).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB68).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF41, 0xFF5A).addRange(0x10428, 0x1044F).addRange(0x104D8, 0x104FB).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10783, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10CC0, 0x10CF2).addRange(0x118C0, 0x118DF).addRange(0x16E60, 0x16E7F).addRange(0x1D41A, 0x1D433).addRange(0x1D44E, 0x1D454).addRange(0x1D456, 0x1D467).addRange(0x1D482, 0x1D49B).addRange(0x1D4B6, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D4CF).addRange(0x1D4EA, 0x1D503).addRange(0x1D51E, 0x1D537).addRange(0x1D552, 0x1D56B).addRange(0x1D586, 0x1D59F).addRange(0x1D5BA, 0x1D5D3).addRange(0x1D5EE, 0x1D607);
	set.addRange(0x1D622, 0x1D63B).addRange(0x1D656, 0x1D66F).addRange(0x1D68A, 0x1D6A5).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6E1).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D71B).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D755).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D78F).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7C9).addRange(0x1DF00, 0x1DF09).addRange(0x1DF0B, 0x1DF1E).addRange(0x1E922, 0x1E943);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Math.js", function (module, exports) {
	  const set = regenerate(0x2B, 0x5E, 0x7C, 0x7E, 0xAC, 0xB1, 0xD7, 0xF7, 0x3D5, 0x2016, 0x2040, 0x2044, 0x2052, 0x20E1, 0x2102, 0x2107, 0x2115, 0x2124, 0x214B, 0x21DD, 0x237C, 0x23B7, 0x23D0, 0x25E2, 0x25E4, 0x2640, 0x2642, 0xFB29, 0xFE68, 0xFF0B, 0xFF3C, 0xFF3E, 0xFF5C, 0xFF5E, 0xFFE2, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x3C, 0x3E).addRange(0x3D0, 0x3D2).addRange(0x3F0, 0x3F1).addRange(0x3F4, 0x3F6).addRange(0x606, 0x608).addRange(0x2032, 0x2034).addRange(0x2061, 0x2064).addRange(0x207A, 0x207E).addRange(0x208A, 0x208E).addRange(0x20D0, 0x20DC).addRange(0x20E5, 0x20E6).addRange(0x20EB, 0x20EF).addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x2128, 0x2129).addRange(0x212C, 0x212D).addRange(0x212F, 0x2131).addRange(0x2133, 0x2138).addRange(0x213C, 0x2149).addRange(0x2190, 0x21A7).addRange(0x21A9, 0x21AE).addRange(0x21B0, 0x21B1).addRange(0x21B6, 0x21B7).addRange(0x21BC, 0x21DB).addRange(0x21E4, 0x21E5).addRange(0x21F4, 0x22FF).addRange(0x2308, 0x230B).addRange(0x2320, 0x2321).addRange(0x239B, 0x23B5).addRange(0x23DC, 0x23E2).addRange(0x25A0, 0x25A1).addRange(0x25AE, 0x25B7).addRange(0x25BC, 0x25C1).addRange(0x25C6, 0x25C7).addRange(0x25CA, 0x25CB).addRange(0x25CF, 0x25D3).addRange(0x25E7, 0x25EC).addRange(0x25F8, 0x25FF).addRange(0x2605, 0x2606).addRange(0x2660, 0x2663).addRange(0x266D, 0x266F).addRange(0x27C0, 0x27FF).addRange(0x2900, 0x2AFF).addRange(0x2B30, 0x2B44).addRange(0x2B47, 0x2B4C).addRange(0xFE61, 0xFE66).addRange(0xFF1C, 0xFF1E).addRange(0xFFE9, 0xFFEC).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F);
	set.addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Noncharacter_Code_Point.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xFDD0, 0xFDEF).addRange(0xFFFE, 0xFFFF).addRange(0x1FFFE, 0x1FFFF).addRange(0x2FFFE, 0x2FFFF).addRange(0x3FFFE, 0x3FFFF).addRange(0x4FFFE, 0x4FFFF).addRange(0x5FFFE, 0x5FFFF).addRange(0x6FFFE, 0x6FFFF).addRange(0x7FFFE, 0x7FFFF).addRange(0x8FFFE, 0x8FFFF).addRange(0x9FFFE, 0x9FFFF).addRange(0xAFFFE, 0xAFFFF).addRange(0xBFFFE, 0xBFFFF).addRange(0xCFFFE, 0xCFFFF).addRange(0xDFFFE, 0xDFFFF).addRange(0xEFFFE, 0xEFFFF).addRange(0xFFFFE, 0xFFFFF).addRange(0x10FFFE, 0x10FFFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Pattern_Syntax.js", function (module, exports) {
	  const set = regenerate(0x60, 0xA9, 0xAE, 0xB6, 0xBB, 0xBF, 0xD7, 0xF7, 0x3030);
	set.addRange(0x21, 0x2F).addRange(0x3A, 0x40).addRange(0x5B, 0x5E).addRange(0x7B, 0x7E).addRange(0xA1, 0xA7).addRange(0xAB, 0xAC).addRange(0xB0, 0xB1).addRange(0x2010, 0x2027).addRange(0x2030, 0x203E).addRange(0x2041, 0x2053).addRange(0x2055, 0x205E).addRange(0x2190, 0x245F).addRange(0x2500, 0x2775).addRange(0x2794, 0x2BFF).addRange(0x2E00, 0x2E7F).addRange(0x3001, 0x3003).addRange(0x3008, 0x3020).addRange(0xFD3E, 0xFD3F).addRange(0xFE45, 0xFE46);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Pattern_White_Space.js", function (module, exports) {
	  const set = regenerate(0x20, 0x85);
	set.addRange(0x9, 0xD).addRange(0x200E, 0x200F).addRange(0x2028, 0x2029);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Quotation_Mark.js", function (module, exports) {
	  const set = regenerate(0x22, 0x27, 0xAB, 0xBB, 0x2E42, 0xFF02, 0xFF07);
	set.addRange(0x2018, 0x201F).addRange(0x2039, 0x203A).addRange(0x300C, 0x300F).addRange(0x301D, 0x301F).addRange(0xFE41, 0xFE44).addRange(0xFF62, 0xFF63);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Radical.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Regional_Indicator.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1F1E6, 0x1F1FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Sentence_Terminal.js", function (module, exports) {
	  const set = regenerate(0x21, 0x2E, 0x3F, 0x589, 0x6D4, 0x7F9, 0x837, 0x839, 0x1362, 0x166E, 0x1803, 0x1809, 0x2E2E, 0x2E3C, 0x3002, 0xA4FF, 0xA6F3, 0xA6F7, 0xA92F, 0xABEB, 0xFE52, 0xFF01, 0xFF0E, 0xFF1F, 0xFF61, 0x111CD, 0x112A9, 0x11944, 0x11946, 0x16AF5, 0x16B44, 0x16E98, 0x1BC9F, 0x1DA88);
	set.addRange(0x61D, 0x61F).addRange(0x700, 0x702).addRange(0x83D, 0x83E).addRange(0x964, 0x965).addRange(0x104A, 0x104B).addRange(0x1367, 0x1368).addRange(0x1735, 0x1736).addRange(0x1944, 0x1945).addRange(0x1AA8, 0x1AAB).addRange(0x1B5A, 0x1B5B).addRange(0x1B5E, 0x1B5F).addRange(0x1B7D, 0x1B7E).addRange(0x1C3B, 0x1C3C).addRange(0x1C7E, 0x1C7F).addRange(0x203C, 0x203D).addRange(0x2047, 0x2049).addRange(0x2E53, 0x2E54).addRange(0xA60E, 0xA60F).addRange(0xA876, 0xA877).addRange(0xA8CE, 0xA8CF).addRange(0xA9C8, 0xA9C9).addRange(0xAA5D, 0xAA5F).addRange(0xAAF0, 0xAAF1).addRange(0xFE56, 0xFE57).addRange(0x10A56, 0x10A57).addRange(0x10F55, 0x10F59).addRange(0x10F86, 0x10F89).addRange(0x11047, 0x11048).addRange(0x110BE, 0x110C1).addRange(0x11141, 0x11143).addRange(0x111C5, 0x111C6).addRange(0x111DE, 0x111DF).addRange(0x11238, 0x11239).addRange(0x1123B, 0x1123C).addRange(0x1144B, 0x1144C).addRange(0x115C2, 0x115C3).addRange(0x115C9, 0x115D7).addRange(0x11641, 0x11642).addRange(0x1173C, 0x1173E).addRange(0x11A42, 0x11A43).addRange(0x11A9B, 0x11A9C).addRange(0x11C41, 0x11C42).addRange(0x11EF7, 0x11EF8).addRange(0x16A6E, 0x16A6F).addRange(0x16B37, 0x16B38);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Soft_Dotted.js", function (module, exports) {
	  const set = regenerate(0x12F, 0x249, 0x268, 0x29D, 0x2B2, 0x3F3, 0x456, 0x458, 0x1D62, 0x1D96, 0x1DA4, 0x1DA8, 0x1E2D, 0x1ECB, 0x2071, 0x2C7C, 0x1DF1A);
	set.addRange(0x69, 0x6A).addRange(0x2148, 0x2149).addRange(0x1D422, 0x1D423).addRange(0x1D456, 0x1D457).addRange(0x1D48A, 0x1D48B).addRange(0x1D4BE, 0x1D4BF).addRange(0x1D4F2, 0x1D4F3).addRange(0x1D526, 0x1D527).addRange(0x1D55A, 0x1D55B).addRange(0x1D58E, 0x1D58F).addRange(0x1D5C2, 0x1D5C3).addRange(0x1D5F6, 0x1D5F7).addRange(0x1D62A, 0x1D62B).addRange(0x1D65E, 0x1D65F).addRange(0x1D692, 0x1D693);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Terminal_Punctuation.js", function (module, exports) {
	  const set = regenerate(0x21, 0x2C, 0x2E, 0x3F, 0x37E, 0x387, 0x589, 0x5C3, 0x60C, 0x61B, 0x6D4, 0x70C, 0x85E, 0xF08, 0x166E, 0x17DA, 0x2E2E, 0x2E3C, 0x2E41, 0x2E4C, 0xA92F, 0xAADF, 0xABEB, 0xFF01, 0xFF0C, 0xFF0E, 0xFF1F, 0xFF61, 0xFF64, 0x1039F, 0x103D0, 0x10857, 0x1091F, 0x111CD, 0x112A9, 0x11944, 0x11946, 0x11C71, 0x16AF5, 0x16B44, 0x1BC9F);
	set.addRange(0x3A, 0x3B).addRange(0x61D, 0x61F).addRange(0x700, 0x70A).addRange(0x7F8, 0x7F9).addRange(0x830, 0x83E).addRange(0x964, 0x965).addRange(0xE5A, 0xE5B).addRange(0xF0D, 0xF12).addRange(0x104A, 0x104B).addRange(0x1361, 0x1368).addRange(0x16EB, 0x16ED).addRange(0x1735, 0x1736).addRange(0x17D4, 0x17D6).addRange(0x1802, 0x1805).addRange(0x1808, 0x1809).addRange(0x1944, 0x1945).addRange(0x1AA8, 0x1AAB).addRange(0x1B5A, 0x1B5B).addRange(0x1B5D, 0x1B5F).addRange(0x1B7D, 0x1B7E).addRange(0x1C3B, 0x1C3F).addRange(0x1C7E, 0x1C7F).addRange(0x203C, 0x203D).addRange(0x2047, 0x2049).addRange(0x2E4E, 0x2E4F).addRange(0x2E53, 0x2E54).addRange(0x3001, 0x3002).addRange(0xA4FE, 0xA4FF).addRange(0xA60D, 0xA60F).addRange(0xA6F3, 0xA6F7).addRange(0xA876, 0xA877).addRange(0xA8CE, 0xA8CF).addRange(0xA9C7, 0xA9C9).addRange(0xAA5D, 0xAA5F).addRange(0xAAF0, 0xAAF1).addRange(0xFE50, 0xFE52).addRange(0xFE54, 0xFE57).addRange(0xFF1A, 0xFF1B).addRange(0x10A56, 0x10A57).addRange(0x10AF0, 0x10AF5).addRange(0x10B3A, 0x10B3F).addRange(0x10B99, 0x10B9C).addRange(0x10F55, 0x10F59).addRange(0x10F86, 0x10F89).addRange(0x11047, 0x1104D).addRange(0x110BE, 0x110C1).addRange(0x11141, 0x11143).addRange(0x111C5, 0x111C6).addRange(0x111DE, 0x111DF).addRange(0x11238, 0x1123C).addRange(0x1144B, 0x1144D);
	set.addRange(0x1145A, 0x1145B).addRange(0x115C2, 0x115C5).addRange(0x115C9, 0x115D7).addRange(0x11641, 0x11642).addRange(0x1173C, 0x1173E).addRange(0x11A42, 0x11A43).addRange(0x11A9B, 0x11A9C).addRange(0x11AA1, 0x11AA2).addRange(0x11C41, 0x11C43).addRange(0x11EF7, 0x11EF8).addRange(0x12470, 0x12474).addRange(0x16A6E, 0x16A6F).addRange(0x16B37, 0x16B39).addRange(0x16E97, 0x16E98).addRange(0x1DA87, 0x1DA8A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Unified_Ideograph.js", function (module, exports) {
	  const set = regenerate(0xFA11, 0xFA1F, 0xFA21);
	set.addRange(0x3400, 0x4DBF).addRange(0x4E00, 0x9FFF).addRange(0xFA0E, 0xFA0F).addRange(0xFA13, 0xFA14).addRange(0xFA23, 0xFA24).addRange(0xFA27, 0xFA29).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Uppercase.js", function (module, exports) {
	  const set = regenerate(0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14A, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1C4, 0x1C7, 0x1CA, 0x1CD, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1F1, 0x1F4, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x370, 0x372, 0x376, 0x37F, 0x386, 0x38C, 0x3CF, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F4, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x10C7, 0x10CD, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x2145, 0x2183, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xA7F5, 0x1D49C, 0x1D4A2, 0x1D546, 0x1D7CA);
	set.addRange(0x41, 0x5A).addRange(0xC0, 0xD6).addRange(0xD8, 0xDE).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x388, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3D2, 0x3D4).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x10A0, 0x10C5).addRange(0x13A0, 0x13F5).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1FB8, 0x1FBB).addRange(0x1FC8, 0x1FCB).addRange(0x1FD8, 0x1FDB).addRange(0x1FE8, 0x1FEC).addRange(0x1FF8, 0x1FFB).addRange(0x210B, 0x210D).addRange(0x2110, 0x2112).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x2130, 0x2133).addRange(0x213E, 0x213F).addRange(0x2160, 0x216F);
	set.addRange(0x24B6, 0x24CF).addRange(0x2C00, 0x2C2F).addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7E, 0x2C80).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xFF21, 0xFF3A).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1D400, 0x1D419).addRange(0x1D434, 0x1D44D).addRange(0x1D468, 0x1D481).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B5).addRange(0x1D4D0, 0x1D4E9).addRange(0x1D504, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D538, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D56C, 0x1D585).addRange(0x1D5A0, 0x1D5B9).addRange(0x1D5D4, 0x1D5ED).addRange(0x1D608, 0x1D621).addRange(0x1D63C, 0x1D655).addRange(0x1D670, 0x1D689).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6E2, 0x1D6FA).addRange(0x1D71C, 0x1D734).addRange(0x1D756, 0x1D76E).addRange(0x1D790, 0x1D7A8).addRange(0x1E900, 0x1E921).addRange(0x1F130, 0x1F149).addRange(0x1F150, 0x1F169).addRange(0x1F170, 0x1F189);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/Variation_Selector.js", function (module, exports) {
	  const set = regenerate(0x180F);
	set.addRange(0x180B, 0x180D).addRange(0xFE00, 0xFE0F).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/White_Space.js", function (module, exports) {
	  const set = regenerate(0x20, 0x85, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000);
	set.addRange(0x9, 0xD).addRange(0x2000, 0x200A).addRange(0x2028, 0x2029);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/XID_Continue.js", function (module, exports) {
	  const set = regenerate(0x5F, 0xAA, 0xB5, 0xB7, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x38C, 0x559, 0x5BF, 0x5C7, 0x6FF, 0x7FA, 0x7FD, 0x9B2, 0x9D7, 0x9FC, 0x9FE, 0xA3C, 0xA51, 0xA5E, 0xAD0, 0xB71, 0xB9C, 0xBD0, 0xBD7, 0xC5D, 0xDBD, 0xDCA, 0xDD6, 0xE84, 0xEA5, 0xEC6, 0xF00, 0xF35, 0xF37, 0xF39, 0xFC6, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x1AA7, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2054, 0x2071, 0x207F, 0x20E1, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0xA7D3, 0xA82C, 0xA8FB, 0xFB3E, 0xFE71, 0xFE73, 0xFE77, 0xFE79, 0xFE7B, 0xFE7D, 0xFF3F, 0x101FD, 0x102E0, 0x10808, 0x1083C, 0x10A3F, 0x10F27, 0x110C2, 0x11176, 0x111DC, 0x1123E, 0x11288, 0x11350, 0x11357, 0x114C7, 0x11644, 0x11909, 0x11A47, 0x11A9D, 0x11D3A, 0x11FB0, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1DA75, 0x1DA84, 0x1E14E, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x300, 0x374).addRange(0x376, 0x377).addRange(0x37B, 0x37D).addRange(0x386, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x483, 0x487).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x610, 0x61A).addRange(0x620, 0x669).addRange(0x66E, 0x6D3).addRange(0x6D5, 0x6DC).addRange(0x6DF, 0x6E8).addRange(0x6EA, 0x6FC).addRange(0x710, 0x74A).addRange(0x74D, 0x7B1).addRange(0x7C0, 0x7F5).addRange(0x800, 0x82D).addRange(0x840, 0x85B).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x898, 0x8E1).addRange(0x8E3, 0x963).addRange(0x966, 0x96F).addRange(0x971, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD);
	set.addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9F1).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA75).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAEF).addRange(0xAF9, 0xAFF).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB6F).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9);
	set.addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBEF).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC80, 0xC83).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF2).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4E).addRange(0xD54, 0xD57).addRange(0xD5F, 0xD63).addRange(0xD66, 0xD6F).addRange(0xD7A, 0xD7F).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF3).addRange(0xE01, 0xE3A).addRange(0xE40, 0xE4E).addRange(0xE50, 0xE59).addRange(0xE81, 0xE82);
	set.addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECD).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF).addRange(0xF18, 0xF19).addRange(0xF20, 0xF29).addRange(0xF3E, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF84).addRange(0xF86, 0xF97).addRange(0xF99, 0xFBC).addRange(0x1000, 0x1049).addRange(0x1050, 0x109D).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x135F).addRange(0x1369, 0x1371).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1715).addRange(0x171F, 0x1734).addRange(0x1740, 0x1753).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773).addRange(0x1780, 0x17D3).addRange(0x17DC, 0x17DD).addRange(0x17E0, 0x17E9);
	set.addRange(0x180B, 0x180D).addRange(0x180F, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1946, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x1A00, 0x1A1B).addRange(0x1A20, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AB0, 0x1ABD).addRange(0x1ABF, 0x1ACE).addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B59).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1BF3).addRange(0x1C00, 0x1C37).addRange(0x1C40, 0x1C49).addRange(0x1C4D, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CFA).addRange(0x1D00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x203F, 0x2040).addRange(0x2090, 0x209C).addRange(0x20D0, 0x20DC).addRange(0x20E5, 0x20F0);
	set.addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x212A, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D7F, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2DE0, 0x2DFF).addRange(0x3005, 0x3007).addRange(0x3021, 0x302F).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x3099, 0x309A).addRange(0x309D, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA62B).addRange(0xA640, 0xA66F).addRange(0xA674, 0xA67D).addRange(0xA67F, 0xA6F1).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA827).addRange(0xA840, 0xA873).addRange(0xA880, 0xA8C5).addRange(0xA8D0, 0xA8D9).addRange(0xA8E0, 0xA8F7);
	set.addRange(0xA8FD, 0xA92D).addRange(0xA930, 0xA953).addRange(0xA960, 0xA97C).addRange(0xA980, 0xA9C0).addRange(0xA9CF, 0xA9D9).addRange(0xA9E0, 0xA9FE).addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA60, 0xAA76).addRange(0xAA7A, 0xAAC2).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEF).addRange(0xAAF2, 0xAAF6).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABEA).addRange(0xABEC, 0xABED).addRange(0xABF0, 0xABF9).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1D, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFC5D).addRange(0xFC64, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDF9).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0xFE33, 0xFE34).addRange(0xFE4D, 0xFE4F).addRange(0xFE7F, 0xFEFC).addRange(0xFF10, 0xFF19).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFFBE);
	set.addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x1037A).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104A0, 0x104A9).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939);
	set.addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE6).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D27).addRange(0x10D30, 0x10D39).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAC).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F50).addRange(0x10F70, 0x10F85).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11000, 0x11046).addRange(0x11066, 0x11075).addRange(0x1107F, 0x110BA).addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9).addRange(0x11100, 0x11134).addRange(0x11136, 0x1113F).addRange(0x11144, 0x11147).addRange(0x11150, 0x11173).addRange(0x11180, 0x111C4).addRange(0x111C9, 0x111CC).addRange(0x111CE, 0x111DA).addRange(0x11200, 0x11211).addRange(0x11213, 0x11237).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9).addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C);
	set.addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133B, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11400, 0x1144A).addRange(0x11450, 0x11459).addRange(0x1145E, 0x11461).addRange(0x11480, 0x114C5).addRange(0x114D0, 0x114D9).addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115C0).addRange(0x115D8, 0x115DD).addRange(0x11600, 0x11640).addRange(0x11650, 0x11659).addRange(0x11680, 0x116B8).addRange(0x116C0, 0x116C9).addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11739).addRange(0x11740, 0x11746).addRange(0x11800, 0x1183A).addRange(0x118A0, 0x118E9).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11943).addRange(0x11950, 0x11959).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E1).addRange(0x119E3, 0x119E4).addRange(0x11A00, 0x11A3E).addRange(0x11A50, 0x11A99).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C40).addRange(0x11C50, 0x11C59).addRange(0x11C72, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D00, 0x11D06);
	set.addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9).addRange(0x11EE0, 0x11EF6).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342E).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A70, 0x16ABE).addRange(0x16AC0, 0x16AC9).addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF4).addRange(0x16B00, 0x16B36).addRange(0x16B40, 0x16B43).addRange(0x16B50, 0x16B59).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x16FE3, 0x16FE4).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99);
	set.addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D165, 0x1D169).addRange(0x1D16D, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1DF00, 0x1DF1E).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E290, 0x1E2AE);
	set.addRange(0x1E2C0, 0x1E2F9).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1FBF0, 0x1FBF9).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Binary_Property/XID_Start.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xB5, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x386, 0x38C, 0x559, 0x6D5, 0x6FF, 0x710, 0x7B1, 0x7FA, 0x81A, 0x824, 0x828, 0x93D, 0x950, 0x9B2, 0x9BD, 0x9CE, 0x9FC, 0xA5E, 0xABD, 0xAD0, 0xAF9, 0xB3D, 0xB71, 0xB83, 0xB9C, 0xBD0, 0xC3D, 0xC5D, 0xC80, 0xCBD, 0xD3D, 0xD4E, 0xDBD, 0xE32, 0xE84, 0xEA5, 0xEB2, 0xEBD, 0xEC6, 0xF00, 0x103F, 0x1061, 0x108E, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x17DC, 0x18AA, 0x1AA7, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0xA7D3, 0xA8FB, 0xA9CF, 0xAA7A, 0xAAB1, 0xAAC0, 0xAAC2, 0xFB1D, 0xFB3E, 0xFE71, 0xFE73, 0xFE77, 0xFE79, 0xFE7B, 0xFE7D, 0x10808, 0x1083C, 0x10A00, 0x10F27, 0x11075, 0x11144, 0x11147, 0x11176, 0x111DA, 0x111DC, 0x11288, 0x1133D, 0x11350, 0x114C7, 0x11644, 0x116B8, 0x11909, 0x1193F, 0x11941, 0x119E1, 0x119E3, 0x11A00, 0x11A3A, 0x11A50, 0x11A9D, 0x11C40, 0x11D46, 0x11D98, 0x11FB0, 0x16F50, 0x16FE3, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E14E, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x374).addRange(0x376, 0x377).addRange(0x37B, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x620, 0x64A).addRange(0x66E, 0x66F).addRange(0x671, 0x6D3).addRange(0x6E5, 0x6E6).addRange(0x6EE, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7CA, 0x7EA).addRange(0x7F4, 0x7F5).addRange(0x800, 0x815).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x904, 0x939).addRange(0x958, 0x961).addRange(0x971, 0x980).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9F0, 0x9F1).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33);
	set.addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA59, 0xA5C).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xAE0, 0xAE1).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCF1, 0xCF2).addRange(0xD04, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD54, 0xD56).addRange(0xD5F, 0xD61).addRange(0xD7A, 0xD7F).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6);
	set.addRange(0xE01, 0xE30).addRange(0xE40, 0xE46).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C).addRange(0x1000, 0x102A).addRange(0x1050, 0x1055).addRange(0x105A, 0x105D).addRange(0x1065, 0x1066).addRange(0x106E, 0x1070).addRange(0x1075, 0x1081).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x1820, 0x1878).addRange(0x1880, 0x18A8).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E);
	set.addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A16).addRange(0x1A20, 0x1A54).addRange(0x1B05, 0x1B33).addRange(0x1B45, 0x1B4C).addRange(0x1B83, 0x1BA0).addRange(0x1BAE, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1C00, 0x1C23).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x212A, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE);
	set.addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x3005, 0x3007).addRange(0x3021, 0x3029).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x309D, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA67F, 0xA69D).addRange(0xA6A0, 0xA6EF).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA822).addRange(0xA840, 0xA873).addRange(0xA882, 0xA8B3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FE).addRange(0xA90A, 0xA925).addRange(0xA930, 0xA946).addRange(0xA960, 0xA97C).addRange(0xA984, 0xA9B2).addRange(0xA9E0, 0xA9E4).addRange(0xA9E6, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA28).addRange(0xAA40, 0xAA42).addRange(0xAA44, 0xAA4B).addRange(0xAA60, 0xAA76);
	set.addRange(0xAA7E, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEA).addRange(0xAAF2, 0xAAF4).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABE2).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFC5D).addRange(0xFC64, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDF9).addRange(0xFE7F, 0xFEFC).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFF9D).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0);
	set.addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2);
	set.addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D23).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11003, 0x11037).addRange(0x11071, 0x11072).addRange(0x11083, 0x110AF).addRange(0x110D0, 0x110E8).addRange(0x11103, 0x11126).addRange(0x11150, 0x11172).addRange(0x11183, 0x111B2).addRange(0x111C1, 0x111C4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122B).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112DE).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1135D, 0x11361).addRange(0x11400, 0x11434).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114C4, 0x114C5).addRange(0x11580, 0x115AE).addRange(0x115D8, 0x115DB).addRange(0x11600, 0x1162F).addRange(0x11680, 0x116AA).addRange(0x11700, 0x1171A).addRange(0x11740, 0x11746).addRange(0x11800, 0x1182B).addRange(0x118A0, 0x118DF).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D0).addRange(0x11A0B, 0x11A32);
	set.addRange(0x11A5C, 0x11A89).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2E).addRange(0x11C72, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D89).addRange(0x11EE0, 0x11EF2).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342E).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B40, 0x16B43).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3);
	set.addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF1E).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E900, 0x1E943).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D);
	set.addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Cased_Letter.js", function (module, exports) {
	  const set = regenerate(0xB5, 0x37F, 0x386, 0x38C, 0x10C7, 0x10CD, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x2139, 0x214E, 0x2D27, 0x2D2D, 0xA7D3, 0xA7FA, 0x1D4A2, 0x1D4BB, 0x1D546);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x1BA).addRange(0x1BC, 0x1BF).addRange(0x1C4, 0x293).addRange(0x295, 0x2AF).addRange(0x370, 0x373).addRange(0x376, 0x377).addRange(0x37B, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1D00, 0x1D2B).addRange(0x1D6B, 0x1D77).addRange(0x1D79, 0x1D9A).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x210A, 0x2113).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x212F, 0x2134).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2183, 0x2184);
	set.addRange(0x2C00, 0x2C7B).addRange(0x2C7E, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0xA640, 0xA66D).addRange(0xA680, 0xA69B).addRange(0xA722, 0xA76F).addRange(0xA771, 0xA787).addRange(0xA78B, 0xA78E).addRange(0xA790, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F5, 0xA7F6).addRange(0xAB30, 0xAB5A).addRange(0xAB60, 0xAB68).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10400, 0x1044F).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x118A0, 0x118DF).addRange(0x16E40, 0x16E7F).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550);
	set.addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF09).addRange(0x1DF0B, 0x1DF1E).addRange(0x1E900, 0x1E943);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Close_Punctuation.js", function (module, exports) {
	  const set = regenerate(0x29, 0x5D, 0x7D, 0xF3B, 0xF3D, 0x169C, 0x2046, 0x207E, 0x208E, 0x2309, 0x230B, 0x232A, 0x2769, 0x276B, 0x276D, 0x276F, 0x2771, 0x2773, 0x2775, 0x27C6, 0x27E7, 0x27E9, 0x27EB, 0x27ED, 0x27EF, 0x2984, 0x2986, 0x2988, 0x298A, 0x298C, 0x298E, 0x2990, 0x2992, 0x2994, 0x2996, 0x2998, 0x29D9, 0x29DB, 0x29FD, 0x2E23, 0x2E25, 0x2E27, 0x2E29, 0x2E56, 0x2E58, 0x2E5A, 0x2E5C, 0x3009, 0x300B, 0x300D, 0x300F, 0x3011, 0x3015, 0x3017, 0x3019, 0x301B, 0xFD3E, 0xFE18, 0xFE36, 0xFE38, 0xFE3A, 0xFE3C, 0xFE3E, 0xFE40, 0xFE42, 0xFE44, 0xFE48, 0xFE5A, 0xFE5C, 0xFE5E, 0xFF09, 0xFF3D, 0xFF5D, 0xFF60, 0xFF63);
	set.addRange(0x301E, 0x301F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Connector_Punctuation.js", function (module, exports) {
	  const set = regenerate(0x5F, 0x2054, 0xFF3F);
	set.addRange(0x203F, 0x2040).addRange(0xFE33, 0xFE34).addRange(0xFE4D, 0xFE4F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Control.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x0, 0x1F).addRange(0x7F, 0x9F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Currency_Symbol.js", function (module, exports) {
	  const set = regenerate(0x24, 0x58F, 0x60B, 0x9FB, 0xAF1, 0xBF9, 0xE3F, 0x17DB, 0xA838, 0xFDFC, 0xFE69, 0xFF04, 0x1E2FF, 0x1ECB0);
	set.addRange(0xA2, 0xA5).addRange(0x7FE, 0x7FF).addRange(0x9F2, 0x9F3).addRange(0x20A0, 0x20C0).addRange(0xFFE0, 0xFFE1).addRange(0xFFE5, 0xFFE6).addRange(0x11FDD, 0x11FE0);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Dash_Punctuation.js", function (module, exports) {
	  const set = regenerate(0x2D, 0x58A, 0x5BE, 0x1400, 0x1806, 0x2E17, 0x2E1A, 0x2E40, 0x2E5D, 0x301C, 0x3030, 0x30A0, 0xFE58, 0xFE63, 0xFF0D, 0x10EAD);
	set.addRange(0x2010, 0x2015).addRange(0x2E3A, 0x2E3B).addRange(0xFE31, 0xFE32);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Decimal_Number.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x30, 0x39).addRange(0x660, 0x669).addRange(0x6F0, 0x6F9).addRange(0x7C0, 0x7C9).addRange(0x966, 0x96F).addRange(0x9E6, 0x9EF).addRange(0xA66, 0xA6F).addRange(0xAE6, 0xAEF).addRange(0xB66, 0xB6F).addRange(0xBE6, 0xBEF).addRange(0xC66, 0xC6F).addRange(0xCE6, 0xCEF).addRange(0xD66, 0xD6F).addRange(0xDE6, 0xDEF).addRange(0xE50, 0xE59).addRange(0xED0, 0xED9).addRange(0xF20, 0xF29).addRange(0x1040, 0x1049).addRange(0x1090, 0x1099).addRange(0x17E0, 0x17E9).addRange(0x1810, 0x1819).addRange(0x1946, 0x194F).addRange(0x19D0, 0x19D9).addRange(0x1A80, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1B50, 0x1B59).addRange(0x1BB0, 0x1BB9).addRange(0x1C40, 0x1C49).addRange(0x1C50, 0x1C59).addRange(0xA620, 0xA629).addRange(0xA8D0, 0xA8D9).addRange(0xA900, 0xA909).addRange(0xA9D0, 0xA9D9).addRange(0xA9F0, 0xA9F9).addRange(0xAA50, 0xAA59).addRange(0xABF0, 0xABF9).addRange(0xFF10, 0xFF19).addRange(0x104A0, 0x104A9).addRange(0x10D30, 0x10D39).addRange(0x11066, 0x1106F).addRange(0x110F0, 0x110F9).addRange(0x11136, 0x1113F).addRange(0x111D0, 0x111D9).addRange(0x112F0, 0x112F9).addRange(0x11450, 0x11459).addRange(0x114D0, 0x114D9).addRange(0x11650, 0x11659).addRange(0x116C0, 0x116C9).addRange(0x11730, 0x11739).addRange(0x118E0, 0x118E9).addRange(0x11950, 0x11959);
	set.addRange(0x11C50, 0x11C59).addRange(0x11D50, 0x11D59).addRange(0x11DA0, 0x11DA9).addRange(0x16A60, 0x16A69).addRange(0x16AC0, 0x16AC9).addRange(0x16B50, 0x16B59).addRange(0x1D7CE, 0x1D7FF).addRange(0x1E140, 0x1E149).addRange(0x1E2F0, 0x1E2F9).addRange(0x1E950, 0x1E959).addRange(0x1FBF0, 0x1FBF9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Enclosing_Mark.js", function (module, exports) {
	  const set = regenerate(0x1ABE);
	set.addRange(0x488, 0x489).addRange(0x20DD, 0x20E0).addRange(0x20E2, 0x20E4).addRange(0xA670, 0xA672);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Final_Punctuation.js", function (module, exports) {
	  const set = regenerate(0xBB, 0x2019, 0x201D, 0x203A, 0x2E03, 0x2E05, 0x2E0A, 0x2E0D, 0x2E1D, 0x2E21);

	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Format.js", function (module, exports) {
	  const set = regenerate(0xAD, 0x61C, 0x6DD, 0x70F, 0x8E2, 0x180E, 0xFEFF, 0x110BD, 0x110CD, 0xE0001);
	set.addRange(0x600, 0x605).addRange(0x890, 0x891).addRange(0x200B, 0x200F).addRange(0x202A, 0x202E).addRange(0x2060, 0x2064).addRange(0x2066, 0x206F).addRange(0xFFF9, 0xFFFB).addRange(0x13430, 0x13438).addRange(0x1BCA0, 0x1BCA3).addRange(0x1D173, 0x1D17A).addRange(0xE0020, 0xE007F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Initial_Punctuation.js", function (module, exports) {
	  const set = regenerate(0xAB, 0x2018, 0x201F, 0x2039, 0x2E02, 0x2E04, 0x2E09, 0x2E0C, 0x2E1C, 0x2E20);
	set.addRange(0x201B, 0x201C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Letter_Number.js", function (module, exports) {
	  const set = regenerate(0x3007, 0x10341, 0x1034A);
	set.addRange(0x16EE, 0x16F0).addRange(0x2160, 0x2182).addRange(0x2185, 0x2188).addRange(0x3021, 0x3029).addRange(0x3038, 0x303A).addRange(0xA6E6, 0xA6EF).addRange(0x10140, 0x10174).addRange(0x103D1, 0x103D5).addRange(0x12400, 0x1246E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Letter.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xB5, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x386, 0x38C, 0x559, 0x6D5, 0x6FF, 0x710, 0x7B1, 0x7FA, 0x81A, 0x824, 0x828, 0x93D, 0x950, 0x9B2, 0x9BD, 0x9CE, 0x9FC, 0xA5E, 0xABD, 0xAD0, 0xAF9, 0xB3D, 0xB71, 0xB83, 0xB9C, 0xBD0, 0xC3D, 0xC5D, 0xC80, 0xCBD, 0xD3D, 0xD4E, 0xDBD, 0xE84, 0xEA5, 0xEBD, 0xEC6, 0xF00, 0x103F, 0x1061, 0x108E, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x17DC, 0x18AA, 0x1AA7, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0x2E2F, 0xA7D3, 0xA8FB, 0xA9CF, 0xAA7A, 0xAAB1, 0xAAC0, 0xAAC2, 0xFB1D, 0xFB3E, 0x10808, 0x1083C, 0x10A00, 0x10F27, 0x11075, 0x11144, 0x11147, 0x11176, 0x111DA, 0x111DC, 0x11288, 0x1133D, 0x11350, 0x114C7, 0x11644, 0x116B8, 0x11909, 0x1193F, 0x11941, 0x119E1, 0x119E3, 0x11A00, 0x11A3A, 0x11A50, 0x11A9D, 0x11C40, 0x11D46, 0x11D98, 0x11FB0, 0x16F50, 0x16FE3, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E14E, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x374).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x620, 0x64A).addRange(0x66E, 0x66F).addRange(0x671, 0x6D3).addRange(0x6E5, 0x6E6).addRange(0x6EE, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7CA, 0x7EA).addRange(0x7F4, 0x7F5).addRange(0x800, 0x815).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x904, 0x939).addRange(0x958, 0x961).addRange(0x971, 0x980).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9F0, 0x9F1).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33);
	set.addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA59, 0xA5C).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xAE0, 0xAE1).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCF1, 0xCF2).addRange(0xD04, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD54, 0xD56).addRange(0xD5F, 0xD61).addRange(0xD7A, 0xD7F).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6);
	set.addRange(0xE01, 0xE30).addRange(0xE32, 0xE33).addRange(0xE40, 0xE46).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEB2, 0xEB3).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C).addRange(0x1000, 0x102A).addRange(0x1050, 0x1055).addRange(0x105A, 0x105D).addRange(0x1065, 0x1066).addRange(0x106E, 0x1070).addRange(0x1075, 0x1081).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16F1, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x1820, 0x1878).addRange(0x1880, 0x1884);
	set.addRange(0x1887, 0x18A8).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A16).addRange(0x1A20, 0x1A54).addRange(0x1B05, 0x1B33).addRange(0x1B45, 0x1B4C).addRange(0x1B83, 0x1BA0).addRange(0x1BAE, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1C00, 0x1C23).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x212F, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2183, 0x2184).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25);
	set.addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x3005, 0x3006).addRange(0x3031, 0x3035).addRange(0x303B, 0x303C).addRange(0x3041, 0x3096).addRange(0x309D, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA67F, 0xA69D).addRange(0xA6A0, 0xA6E5).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA822).addRange(0xA840, 0xA873).addRange(0xA882, 0xA8B3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FE).addRange(0xA90A, 0xA925).addRange(0xA930, 0xA946).addRange(0xA960, 0xA97C).addRange(0xA984, 0xA9B2).addRange(0xA9E0, 0xA9E4).addRange(0xA9E6, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA28);
	set.addRange(0xAA40, 0xAA42).addRange(0xAA44, 0xAA4B).addRange(0xAA60, 0xAA76).addRange(0xAA7E, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEA).addRange(0xAAF2, 0xAAF4).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABE2).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10280, 0x1029C);
	set.addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x10340).addRange(0x10342, 0x10349).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x10400, 0x1049D).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48);
	set.addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D23).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11003, 0x11037).addRange(0x11071, 0x11072).addRange(0x11083, 0x110AF).addRange(0x110D0, 0x110E8).addRange(0x11103, 0x11126).addRange(0x11150, 0x11172).addRange(0x11183, 0x111B2).addRange(0x111C1, 0x111C4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122B).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112DE).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1135D, 0x11361).addRange(0x11400, 0x11434).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114C4, 0x114C5).addRange(0x11580, 0x115AE).addRange(0x115D8, 0x115DB).addRange(0x11600, 0x1162F).addRange(0x11680, 0x116AA).addRange(0x11700, 0x1171A).addRange(0x11740, 0x11746).addRange(0x11800, 0x1182B).addRange(0x118A0, 0x118DF).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D0);
	set.addRange(0x11A0B, 0x11A32).addRange(0x11A5C, 0x11A89).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2E).addRange(0x11C72, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D89).addRange(0x11EE0, 0x11EF2).addRange(0x12000, 0x12399).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342E).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B40, 0x16B43).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3);
	set.addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF1E).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E900, 0x1E943).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D);
	set.addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Line_Separator.js", function (module, exports) {
	  const set = regenerate(0x2028);

	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Lowercase_Letter.js", function (module, exports) {
	  const set = regenerate(0xB5, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x183, 0x185, 0x188, 0x192, 0x195, 0x19E, 0x1A1, 0x1A3, 0x1A5, 0x1A8, 0x1AD, 0x1B0, 0x1B4, 0x1B6, 0x1C6, 0x1C9, 0x1CC, 0x1CE, 0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DF, 0x1E1, 0x1E3, 0x1E5, 0x1E7, 0x1E9, 0x1EB, 0x1ED, 0x1F3, 0x1F5, 0x1F9, 0x1FB, 0x1FD, 0x1FF, 0x201, 0x203, 0x205, 0x207, 0x209, 0x20B, 0x20D, 0x20F, 0x211, 0x213, 0x215, 0x217, 0x219, 0x21B, 0x21D, 0x21F, 0x221, 0x223, 0x225, 0x227, 0x229, 0x22B, 0x22D, 0x22F, 0x231, 0x23C, 0x242, 0x247, 0x249, 0x24B, 0x24D, 0x371, 0x373, 0x377, 0x390, 0x3D9, 0x3DB, 0x3DD, 0x3DF, 0x3E1, 0x3E3, 0x3E5, 0x3E7, 0x3E9, 0x3EB, 0x3ED, 0x3F5, 0x3F8, 0x461, 0x463, 0x465, 0x467, 0x469, 0x46B, 0x46D, 0x46F, 0x471, 0x473, 0x475, 0x477, 0x479, 0x47B, 0x47D, 0x47F, 0x481, 0x48B, 0x48D, 0x48F, 0x491, 0x493, 0x495, 0x497, 0x499, 0x49B, 0x49D, 0x49F, 0x4A1, 0x4A3, 0x4A5, 0x4A7, 0x4A9, 0x4AB, 0x4AD, 0x4AF, 0x4B1, 0x4B3, 0x4B5, 0x4B7, 0x4B9, 0x4BB, 0x4BD, 0x4BF, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4D1, 0x4D3, 0x4D5, 0x4D7, 0x4D9, 0x4DB, 0x4DD, 0x4DF, 0x4E1, 0x4E3, 0x4E5, 0x4E7, 0x4E9, 0x4EB, 0x4ED, 0x4EF, 0x4F1, 0x4F3, 0x4F5, 0x4F7, 0x4F9, 0x4FB, 0x4FD, 0x4FF, 0x501, 0x503, 0x505, 0x507, 0x509, 0x50B, 0x50D, 0x50F, 0x511, 0x513, 0x515, 0x517, 0x519, 0x51B, 0x51D, 0x51F, 0x521, 0x523, 0x525, 0x527, 0x529, 0x52B, 0x52D, 0x52F, 0x1E01, 0x1E03, 0x1E05, 0x1E07, 0x1E09, 0x1E0B, 0x1E0D, 0x1E0F, 0x1E11, 0x1E13, 0x1E15, 0x1E17, 0x1E19, 0x1E1B, 0x1E1D, 0x1E1F, 0x1E21, 0x1E23, 0x1E25, 0x1E27, 0x1E29, 0x1E2B, 0x1E2D, 0x1E2F, 0x1E31, 0x1E33, 0x1E35, 0x1E37, 0x1E39, 0x1E3B, 0x1E3D, 0x1E3F, 0x1E41, 0x1E43, 0x1E45, 0x1E47, 0x1E49, 0x1E4B, 0x1E4D, 0x1E4F, 0x1E51, 0x1E53, 0x1E55, 0x1E57, 0x1E59, 0x1E5B, 0x1E5D, 0x1E5F, 0x1E61, 0x1E63, 0x1E65, 0x1E67, 0x1E69, 0x1E6B, 0x1E6D, 0x1E6F, 0x1E71, 0x1E73, 0x1E75, 0x1E77, 0x1E79, 0x1E7B, 0x1E7D, 0x1E7F, 0x1E81, 0x1E83, 0x1E85, 0x1E87, 0x1E89, 0x1E8B, 0x1E8D, 0x1E8F, 0x1E91, 0x1E93, 0x1E9F, 0x1EA1, 0x1EA3, 0x1EA5, 0x1EA7, 0x1EA9, 0x1EAB, 0x1EAD, 0x1EAF, 0x1EB1, 0x1EB3, 0x1EB5, 0x1EB7, 0x1EB9, 0x1EBB, 0x1EBD, 0x1EBF, 0x1EC1, 0x1EC3, 0x1EC5, 0x1EC7, 0x1EC9, 0x1ECB, 0x1ECD, 0x1ECF, 0x1ED1, 0x1ED3, 0x1ED5, 0x1ED7, 0x1ED9, 0x1EDB, 0x1EDD, 0x1EDF, 0x1EE1, 0x1EE3, 0x1EE5, 0x1EE7, 0x1EE9, 0x1EEB, 0x1EED, 0x1EEF, 0x1EF1, 0x1EF3, 0x1EF5, 0x1EF7, 0x1EF9, 0x1EFB, 0x1EFD, 0x1FBE, 0x210A, 0x2113, 0x212F, 0x2134, 0x2139, 0x214E, 0x2184, 0x2C61, 0x2C68, 0x2C6A, 0x2C6C, 0x2C71, 0x2C81, 0x2C83, 0x2C85, 0x2C87, 0x2C89, 0x2C8B, 0x2C8D, 0x2C8F, 0x2C91, 0x2C93, 0x2C95, 0x2C97, 0x2C99, 0x2C9B, 0x2C9D, 0x2C9F, 0x2CA1, 0x2CA3, 0x2CA5, 0x2CA7, 0x2CA9, 0x2CAB, 0x2CAD, 0x2CAF, 0x2CB1, 0x2CB3, 0x2CB5, 0x2CB7, 0x2CB9, 0x2CBB, 0x2CBD, 0x2CBF, 0x2CC1, 0x2CC3, 0x2CC5, 0x2CC7, 0x2CC9, 0x2CCB, 0x2CCD, 0x2CCF, 0x2CD1, 0x2CD3, 0x2CD5, 0x2CD7, 0x2CD9, 0x2CDB, 0x2CDD, 0x2CDF, 0x2CE1, 0x2CEC, 0x2CEE, 0x2CF3, 0x2D27, 0x2D2D, 0xA641, 0xA643, 0xA645, 0xA647, 0xA649, 0xA64B, 0xA64D, 0xA64F, 0xA651, 0xA653, 0xA655, 0xA657, 0xA659, 0xA65B, 0xA65D, 0xA65F, 0xA661, 0xA663, 0xA665, 0xA667, 0xA669, 0xA66B, 0xA66D, 0xA681, 0xA683, 0xA685, 0xA687, 0xA689, 0xA68B, 0xA68D, 0xA68F, 0xA691, 0xA693, 0xA695, 0xA697, 0xA699, 0xA69B, 0xA723, 0xA725, 0xA727, 0xA729, 0xA72B, 0xA72D, 0xA733, 0xA735, 0xA737, 0xA739, 0xA73B, 0xA73D, 0xA73F, 0xA741, 0xA743, 0xA745, 0xA747, 0xA749, 0xA74B, 0xA74D, 0xA74F, 0xA751, 0xA753, 0xA755, 0xA757, 0xA759, 0xA75B, 0xA75D, 0xA75F, 0xA761, 0xA763, 0xA765, 0xA767, 0xA769, 0xA76B, 0xA76D, 0xA76F, 0xA77A, 0xA77C, 0xA77F, 0xA781, 0xA783, 0xA785, 0xA787, 0xA78C, 0xA78E, 0xA791, 0xA797, 0xA799, 0xA79B, 0xA79D, 0xA79F, 0xA7A1, 0xA7A3, 0xA7A5, 0xA7A7, 0xA7A9, 0xA7AF, 0xA7B5, 0xA7B7, 0xA7B9, 0xA7BB, 0xA7BD, 0xA7BF, 0xA7C1, 0xA7C3, 0xA7C8, 0xA7CA, 0xA7D1, 0xA7D3, 0xA7D5, 0xA7D7, 0xA7D9, 0xA7F6, 0xA7FA, 0x1D4BB, 0x1D7CB);
	set.addRange(0x61, 0x7A).addRange(0xDF, 0xF6).addRange(0xF8, 0xFF).addRange(0x137, 0x138).addRange(0x148, 0x149).addRange(0x17E, 0x180).addRange(0x18C, 0x18D).addRange(0x199, 0x19B).addRange(0x1AA, 0x1AB).addRange(0x1B9, 0x1BA).addRange(0x1BD, 0x1BF).addRange(0x1DC, 0x1DD).addRange(0x1EF, 0x1F0).addRange(0x233, 0x239).addRange(0x23F, 0x240).addRange(0x24F, 0x293).addRange(0x295, 0x2AF).addRange(0x37B, 0x37D).addRange(0x3AC, 0x3CE).addRange(0x3D0, 0x3D1).addRange(0x3D5, 0x3D7).addRange(0x3EF, 0x3F3).addRange(0x3FB, 0x3FC).addRange(0x430, 0x45F).addRange(0x4CE, 0x4CF).addRange(0x560, 0x588).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1D00, 0x1D2B).addRange(0x1D6B, 0x1D77).addRange(0x1D79, 0x1D9A).addRange(0x1E95, 0x1E9D).addRange(0x1EFF, 0x1F07).addRange(0x1F10, 0x1F15).addRange(0x1F20, 0x1F27).addRange(0x1F30, 0x1F37).addRange(0x1F40, 0x1F45).addRange(0x1F50, 0x1F57).addRange(0x1F60, 0x1F67).addRange(0x1F70, 0x1F7D).addRange(0x1F80, 0x1F87).addRange(0x1F90, 0x1F97).addRange(0x1FA0, 0x1FA7).addRange(0x1FB0, 0x1FB4).addRange(0x1FB6, 0x1FB7).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FC7).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FD7);
	set.addRange(0x1FE0, 0x1FE7).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FF7).addRange(0x210E, 0x210F).addRange(0x213C, 0x213D).addRange(0x2146, 0x2149).addRange(0x2C30, 0x2C5F).addRange(0x2C65, 0x2C66).addRange(0x2C73, 0x2C74).addRange(0x2C76, 0x2C7B).addRange(0x2CE3, 0x2CE4).addRange(0x2D00, 0x2D25).addRange(0xA72F, 0xA731).addRange(0xA771, 0xA778).addRange(0xA793, 0xA795).addRange(0xAB30, 0xAB5A).addRange(0xAB60, 0xAB68).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF41, 0xFF5A).addRange(0x10428, 0x1044F).addRange(0x104D8, 0x104FB).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10CC0, 0x10CF2).addRange(0x118C0, 0x118DF).addRange(0x16E60, 0x16E7F).addRange(0x1D41A, 0x1D433).addRange(0x1D44E, 0x1D454).addRange(0x1D456, 0x1D467).addRange(0x1D482, 0x1D49B).addRange(0x1D4B6, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D4CF).addRange(0x1D4EA, 0x1D503).addRange(0x1D51E, 0x1D537).addRange(0x1D552, 0x1D56B).addRange(0x1D586, 0x1D59F).addRange(0x1D5BA, 0x1D5D3).addRange(0x1D5EE, 0x1D607).addRange(0x1D622, 0x1D63B).addRange(0x1D656, 0x1D66F).addRange(0x1D68A, 0x1D6A5).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6E1).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D71B).addRange(0x1D736, 0x1D74E);
	set.addRange(0x1D750, 0x1D755).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D78F).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7C9).addRange(0x1DF00, 0x1DF09).addRange(0x1DF0B, 0x1DF1E).addRange(0x1E922, 0x1E943);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Mark.js", function (module, exports) {
	  const set = regenerate(0x5BF, 0x5C7, 0x670, 0x711, 0x7FD, 0x9BC, 0x9D7, 0x9FE, 0xA3C, 0xA51, 0xA75, 0xABC, 0xB3C, 0xB82, 0xBD7, 0xC3C, 0xCBC, 0xD57, 0xDCA, 0xDD6, 0xE31, 0xEB1, 0xF35, 0xF37, 0xF39, 0xFC6, 0x108F, 0x17DD, 0x180F, 0x18A9, 0x1A7F, 0x1CED, 0x1CF4, 0x2D7F, 0xA802, 0xA806, 0xA80B, 0xA82C, 0xA8FF, 0xA9E5, 0xAA43, 0xAAB0, 0xAAC1, 0xFB1E, 0x101FD, 0x102E0, 0x10A3F, 0x11070, 0x110C2, 0x11173, 0x1123E, 0x11357, 0x1145E, 0x11940, 0x119E4, 0x11A47, 0x11D3A, 0x11D47, 0x16F4F, 0x16FE4, 0x1DA75, 0x1DA84, 0x1E2AE);
	set.addRange(0x300, 0x36F).addRange(0x483, 0x489).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x610, 0x61A).addRange(0x64B, 0x65F).addRange(0x6D6, 0x6DC).addRange(0x6DF, 0x6E4).addRange(0x6E7, 0x6E8).addRange(0x6EA, 0x6ED).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F3).addRange(0x816, 0x819).addRange(0x81B, 0x823).addRange(0x825, 0x827).addRange(0x829, 0x82D).addRange(0x859, 0x85B).addRange(0x898, 0x89F).addRange(0x8CA, 0x8E1).addRange(0x8E3, 0x903).addRange(0x93A, 0x93C).addRange(0x93E, 0x94F).addRange(0x951, 0x957).addRange(0x962, 0x963).addRange(0x981, 0x983).addRange(0x9BE, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CD).addRange(0x9E2, 0x9E3).addRange(0xA01, 0xA03).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA70, 0xA71).addRange(0xA81, 0xA83).addRange(0xABE, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE2, 0xAE3).addRange(0xAFA, 0xAFF).addRange(0xB01, 0xB03).addRange(0xB3E, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB62, 0xB63).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD);
	set.addRange(0xC00, 0xC04).addRange(0xC3E, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC62, 0xC63).addRange(0xC81, 0xC83).addRange(0xCBE, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCE2, 0xCE3).addRange(0xD00, 0xD03).addRange(0xD3B, 0xD3C).addRange(0xD3E, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4D).addRange(0xD62, 0xD63).addRange(0xD81, 0xD83).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDF2, 0xDF3).addRange(0xE34, 0xE3A).addRange(0xE47, 0xE4E).addRange(0xEB4, 0xEBC).addRange(0xEC8, 0xECD).addRange(0xF18, 0xF19).addRange(0xF3E, 0xF3F).addRange(0xF71, 0xF84).addRange(0xF86, 0xF87).addRange(0xF8D, 0xF97).addRange(0xF99, 0xFBC).addRange(0x102B, 0x103E).addRange(0x1056, 0x1059).addRange(0x105E, 0x1060).addRange(0x1062, 0x1064).addRange(0x1067, 0x106D).addRange(0x1071, 0x1074).addRange(0x1082, 0x108D).addRange(0x109A, 0x109D).addRange(0x135D, 0x135F).addRange(0x1712, 0x1715).addRange(0x1732, 0x1734).addRange(0x1752, 0x1753).addRange(0x1772, 0x1773).addRange(0x17B4, 0x17D3).addRange(0x180B, 0x180D).addRange(0x1885, 0x1886).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1A17, 0x1A1B);
	set.addRange(0x1A55, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1AB0, 0x1ACE).addRange(0x1B00, 0x1B04).addRange(0x1B34, 0x1B44).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1B82).addRange(0x1BA1, 0x1BAD).addRange(0x1BE6, 0x1BF3).addRange(0x1C24, 0x1C37).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CE8).addRange(0x1CF7, 0x1CF9).addRange(0x1DC0, 0x1DFF).addRange(0x20D0, 0x20F0).addRange(0x2CEF, 0x2CF1).addRange(0x2DE0, 0x2DFF).addRange(0x302A, 0x302F).addRange(0x3099, 0x309A).addRange(0xA66F, 0xA672).addRange(0xA674, 0xA67D).addRange(0xA69E, 0xA69F).addRange(0xA6F0, 0xA6F1).addRange(0xA823, 0xA827).addRange(0xA880, 0xA881).addRange(0xA8B4, 0xA8C5).addRange(0xA8E0, 0xA8F1).addRange(0xA926, 0xA92D).addRange(0xA947, 0xA953).addRange(0xA980, 0xA983).addRange(0xA9B3, 0xA9C0).addRange(0xAA29, 0xAA36).addRange(0xAA4C, 0xAA4D).addRange(0xAA7B, 0xAA7D).addRange(0xAAB2, 0xAAB4).addRange(0xAAB7, 0xAAB8).addRange(0xAABE, 0xAABF).addRange(0xAAEB, 0xAAEF).addRange(0xAAF5, 0xAAF6).addRange(0xABE3, 0xABEA).addRange(0xABEC, 0xABED).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0x10376, 0x1037A).addRange(0x10A01, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A0F).addRange(0x10A38, 0x10A3A).addRange(0x10AE5, 0x10AE6).addRange(0x10D24, 0x10D27).addRange(0x10EAB, 0x10EAC);
	set.addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x11000, 0x11002).addRange(0x11038, 0x11046).addRange(0x11073, 0x11074).addRange(0x1107F, 0x11082).addRange(0x110B0, 0x110BA).addRange(0x11100, 0x11102).addRange(0x11127, 0x11134).addRange(0x11145, 0x11146).addRange(0x11180, 0x11182).addRange(0x111B3, 0x111C0).addRange(0x111C9, 0x111CC).addRange(0x111CE, 0x111CF).addRange(0x1122C, 0x11237).addRange(0x112DF, 0x112EA).addRange(0x11300, 0x11303).addRange(0x1133B, 0x1133C).addRange(0x1133E, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x11362, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11435, 0x11446).addRange(0x114B0, 0x114C3).addRange(0x115AF, 0x115B5).addRange(0x115B8, 0x115C0).addRange(0x115DC, 0x115DD).addRange(0x11630, 0x11640).addRange(0x116AB, 0x116B7).addRange(0x1171D, 0x1172B).addRange(0x1182C, 0x1183A).addRange(0x11930, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x1193E).addRange(0x11942, 0x11943).addRange(0x119D1, 0x119D7).addRange(0x119DA, 0x119E0).addRange(0x11A01, 0x11A0A).addRange(0x11A33, 0x11A39).addRange(0x11A3B, 0x11A3E).addRange(0x11A51, 0x11A5B).addRange(0x11A8A, 0x11A99).addRange(0x11C2F, 0x11C36).addRange(0x11C38, 0x11C3F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D31, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D45);
	set.addRange(0x11D8A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D97).addRange(0x11EF3, 0x11EF6).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16F51, 0x16F87).addRange(0x16F8F, 0x16F92).addRange(0x16FF0, 0x16FF1).addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D165, 0x1D169).addRange(0x1D16D, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E130, 0x1E136).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E94A).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Math_Symbol.js", function (module, exports) {
	  const set = regenerate(0x2B, 0x7C, 0x7E, 0xAC, 0xB1, 0xD7, 0xF7, 0x3F6, 0x2044, 0x2052, 0x2118, 0x214B, 0x21A0, 0x21A3, 0x21A6, 0x21AE, 0x21D2, 0x21D4, 0x237C, 0x25B7, 0x25C1, 0x266F, 0xFB29, 0xFE62, 0xFF0B, 0xFF5C, 0xFF5E, 0xFFE2, 0x1D6C1, 0x1D6DB, 0x1D6FB, 0x1D715, 0x1D735, 0x1D74F, 0x1D76F, 0x1D789, 0x1D7A9, 0x1D7C3);
	set.addRange(0x3C, 0x3E).addRange(0x606, 0x608).addRange(0x207A, 0x207C).addRange(0x208A, 0x208C).addRange(0x2140, 0x2144).addRange(0x2190, 0x2194).addRange(0x219A, 0x219B).addRange(0x21CE, 0x21CF).addRange(0x21F4, 0x22FF).addRange(0x2320, 0x2321).addRange(0x239B, 0x23B3).addRange(0x23DC, 0x23E1).addRange(0x25F8, 0x25FF).addRange(0x27C0, 0x27C4).addRange(0x27C7, 0x27E5).addRange(0x27F0, 0x27FF).addRange(0x2900, 0x2982).addRange(0x2999, 0x29D7).addRange(0x29DC, 0x29FB).addRange(0x29FE, 0x2AFF).addRange(0x2B30, 0x2B44).addRange(0x2B47, 0x2B4C).addRange(0xFE64, 0xFE66).addRange(0xFF1C, 0xFF1E).addRange(0xFFE9, 0xFFEC).addRange(0x1EEF0, 0x1EEF1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Modifier_Letter.js", function (module, exports) {
	  const set = regenerate(0x2EC, 0x2EE, 0x374, 0x37A, 0x559, 0x640, 0x7FA, 0x81A, 0x824, 0x828, 0x8C9, 0x971, 0xE46, 0xEC6, 0x10FC, 0x17D7, 0x1843, 0x1AA7, 0x1D78, 0x2071, 0x207F, 0x2D6F, 0x2E2F, 0x3005, 0x303B, 0xA015, 0xA60C, 0xA67F, 0xA770, 0xA788, 0xA9CF, 0xA9E6, 0xAA70, 0xAADD, 0xAB69, 0xFF70, 0x16FE3, 0x1E94B);
	set.addRange(0x2B0, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x6E5, 0x6E6).addRange(0x7F4, 0x7F5).addRange(0x1C78, 0x1C7D).addRange(0x1D2C, 0x1D6A).addRange(0x1D9B, 0x1DBF).addRange(0x2090, 0x209C).addRange(0x2C7C, 0x2C7D).addRange(0x3031, 0x3035).addRange(0x309D, 0x309E).addRange(0x30FC, 0x30FE).addRange(0xA4F8, 0xA4FD).addRange(0xA69C, 0xA69D).addRange(0xA717, 0xA71F).addRange(0xA7F2, 0xA7F4).addRange(0xA7F8, 0xA7F9).addRange(0xAAF3, 0xAAF4).addRange(0xAB5C, 0xAB5F).addRange(0xFF9E, 0xFF9F).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x16B40, 0x16B43).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1E137, 0x1E13D);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Modifier_Symbol.js", function (module, exports) {
	  const set = regenerate(0x5E, 0x60, 0xA8, 0xAF, 0xB4, 0xB8, 0x2ED, 0x375, 0x888, 0x1FBD, 0xAB5B, 0xFF3E, 0xFF40, 0xFFE3);
	set.addRange(0x2C2, 0x2C5).addRange(0x2D2, 0x2DF).addRange(0x2E5, 0x2EB).addRange(0x2EF, 0x2FF).addRange(0x384, 0x385).addRange(0x1FBF, 0x1FC1).addRange(0x1FCD, 0x1FCF).addRange(0x1FDD, 0x1FDF).addRange(0x1FED, 0x1FEF).addRange(0x1FFD, 0x1FFE).addRange(0x309B, 0x309C).addRange(0xA700, 0xA716).addRange(0xA720, 0xA721).addRange(0xA789, 0xA78A).addRange(0xAB6A, 0xAB6B).addRange(0xFBB2, 0xFBC2).addRange(0x1F3FB, 0x1F3FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Nonspacing_Mark.js", function (module, exports) {
	  const set = regenerate(0x5BF, 0x5C7, 0x670, 0x711, 0x7FD, 0x93A, 0x93C, 0x94D, 0x981, 0x9BC, 0x9CD, 0x9FE, 0xA3C, 0xA51, 0xA75, 0xABC, 0xACD, 0xB01, 0xB3C, 0xB3F, 0xB4D, 0xB82, 0xBC0, 0xBCD, 0xC00, 0xC04, 0xC3C, 0xC81, 0xCBC, 0xCBF, 0xCC6, 0xD4D, 0xD81, 0xDCA, 0xDD6, 0xE31, 0xEB1, 0xF35, 0xF37, 0xF39, 0xFC6, 0x1082, 0x108D, 0x109D, 0x17C6, 0x17DD, 0x180F, 0x18A9, 0x1932, 0x1A1B, 0x1A56, 0x1A60, 0x1A62, 0x1A7F, 0x1B34, 0x1B3C, 0x1B42, 0x1BE6, 0x1BED, 0x1CED, 0x1CF4, 0x20E1, 0x2D7F, 0xA66F, 0xA802, 0xA806, 0xA80B, 0xA82C, 0xA8FF, 0xA9B3, 0xA9E5, 0xAA43, 0xAA4C, 0xAA7C, 0xAAB0, 0xAAC1, 0xAAF6, 0xABE5, 0xABE8, 0xABED, 0xFB1E, 0x101FD, 0x102E0, 0x10A3F, 0x11001, 0x11070, 0x110C2, 0x11173, 0x111CF, 0x11234, 0x1123E, 0x112DF, 0x11340, 0x11446, 0x1145E, 0x114BA, 0x1163D, 0x116AB, 0x116AD, 0x116B7, 0x1193E, 0x11943, 0x119E0, 0x11A47, 0x11C3F, 0x11D3A, 0x11D47, 0x11D95, 0x11D97, 0x16F4F, 0x16FE4, 0x1DA75, 0x1DA84, 0x1E2AE);
	set.addRange(0x300, 0x36F).addRange(0x483, 0x487).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x610, 0x61A).addRange(0x64B, 0x65F).addRange(0x6D6, 0x6DC).addRange(0x6DF, 0x6E4).addRange(0x6E7, 0x6E8).addRange(0x6EA, 0x6ED).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F3).addRange(0x816, 0x819).addRange(0x81B, 0x823).addRange(0x825, 0x827).addRange(0x829, 0x82D).addRange(0x859, 0x85B).addRange(0x898, 0x89F).addRange(0x8CA, 0x8E1).addRange(0x8E3, 0x902).addRange(0x941, 0x948).addRange(0x951, 0x957).addRange(0x962, 0x963).addRange(0x9C1, 0x9C4).addRange(0x9E2, 0x9E3).addRange(0xA01, 0xA02).addRange(0xA41, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA70, 0xA71).addRange(0xA81, 0xA82).addRange(0xAC1, 0xAC5).addRange(0xAC7, 0xAC8).addRange(0xAE2, 0xAE3).addRange(0xAFA, 0xAFF).addRange(0xB41, 0xB44).addRange(0xB55, 0xB56).addRange(0xB62, 0xB63).addRange(0xC3E, 0xC40).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC62, 0xC63).addRange(0xCCC, 0xCCD).addRange(0xCE2, 0xCE3).addRange(0xD00, 0xD01).addRange(0xD3B, 0xD3C).addRange(0xD41, 0xD44).addRange(0xD62, 0xD63);
	set.addRange(0xDD2, 0xDD4).addRange(0xE34, 0xE3A).addRange(0xE47, 0xE4E).addRange(0xEB4, 0xEBC).addRange(0xEC8, 0xECD).addRange(0xF18, 0xF19).addRange(0xF71, 0xF7E).addRange(0xF80, 0xF84).addRange(0xF86, 0xF87).addRange(0xF8D, 0xF97).addRange(0xF99, 0xFBC).addRange(0x102D, 0x1030).addRange(0x1032, 0x1037).addRange(0x1039, 0x103A).addRange(0x103D, 0x103E).addRange(0x1058, 0x1059).addRange(0x105E, 0x1060).addRange(0x1071, 0x1074).addRange(0x1085, 0x1086).addRange(0x135D, 0x135F).addRange(0x1712, 0x1714).addRange(0x1732, 0x1733).addRange(0x1752, 0x1753).addRange(0x1772, 0x1773).addRange(0x17B4, 0x17B5).addRange(0x17B7, 0x17BD).addRange(0x17C9, 0x17D3).addRange(0x180B, 0x180D).addRange(0x1885, 0x1886).addRange(0x1920, 0x1922).addRange(0x1927, 0x1928).addRange(0x1939, 0x193B).addRange(0x1A17, 0x1A18).addRange(0x1A58, 0x1A5E).addRange(0x1A65, 0x1A6C).addRange(0x1A73, 0x1A7C).addRange(0x1AB0, 0x1ABD).addRange(0x1ABF, 0x1ACE).addRange(0x1B00, 0x1B03).addRange(0x1B36, 0x1B3A).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1B81).addRange(0x1BA2, 0x1BA5).addRange(0x1BA8, 0x1BA9).addRange(0x1BAB, 0x1BAD).addRange(0x1BE8, 0x1BE9).addRange(0x1BEF, 0x1BF1).addRange(0x1C2C, 0x1C33).addRange(0x1C36, 0x1C37).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CE0);
	set.addRange(0x1CE2, 0x1CE8).addRange(0x1CF8, 0x1CF9).addRange(0x1DC0, 0x1DFF).addRange(0x20D0, 0x20DC).addRange(0x20E5, 0x20F0).addRange(0x2CEF, 0x2CF1).addRange(0x2DE0, 0x2DFF).addRange(0x302A, 0x302D).addRange(0x3099, 0x309A).addRange(0xA674, 0xA67D).addRange(0xA69E, 0xA69F).addRange(0xA6F0, 0xA6F1).addRange(0xA825, 0xA826).addRange(0xA8C4, 0xA8C5).addRange(0xA8E0, 0xA8F1).addRange(0xA926, 0xA92D).addRange(0xA947, 0xA951).addRange(0xA980, 0xA982).addRange(0xA9B6, 0xA9B9).addRange(0xA9BC, 0xA9BD).addRange(0xAA29, 0xAA2E).addRange(0xAA31, 0xAA32).addRange(0xAA35, 0xAA36).addRange(0xAAB2, 0xAAB4).addRange(0xAAB7, 0xAAB8).addRange(0xAABE, 0xAABF).addRange(0xAAEC, 0xAAED).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0x10376, 0x1037A).addRange(0x10A01, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A0F).addRange(0x10A38, 0x10A3A).addRange(0x10AE5, 0x10AE6).addRange(0x10D24, 0x10D27).addRange(0x10EAB, 0x10EAC).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x11038, 0x11046).addRange(0x11073, 0x11074).addRange(0x1107F, 0x11081).addRange(0x110B3, 0x110B6).addRange(0x110B9, 0x110BA).addRange(0x11100, 0x11102).addRange(0x11127, 0x1112B).addRange(0x1112D, 0x11134).addRange(0x11180, 0x11181).addRange(0x111B6, 0x111BE).addRange(0x111C9, 0x111CC).addRange(0x1122F, 0x11231);
	set.addRange(0x11236, 0x11237).addRange(0x112E3, 0x112EA).addRange(0x11300, 0x11301).addRange(0x1133B, 0x1133C).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11438, 0x1143F).addRange(0x11442, 0x11444).addRange(0x114B3, 0x114B8).addRange(0x114BF, 0x114C0).addRange(0x114C2, 0x114C3).addRange(0x115B2, 0x115B5).addRange(0x115BC, 0x115BD).addRange(0x115BF, 0x115C0).addRange(0x115DC, 0x115DD).addRange(0x11633, 0x1163A).addRange(0x1163F, 0x11640).addRange(0x116B0, 0x116B5).addRange(0x1171D, 0x1171F).addRange(0x11722, 0x11725).addRange(0x11727, 0x1172B).addRange(0x1182F, 0x11837).addRange(0x11839, 0x1183A).addRange(0x1193B, 0x1193C).addRange(0x119D4, 0x119D7).addRange(0x119DA, 0x119DB).addRange(0x11A01, 0x11A0A).addRange(0x11A33, 0x11A38).addRange(0x11A3B, 0x11A3E).addRange(0x11A51, 0x11A56).addRange(0x11A59, 0x11A5B).addRange(0x11A8A, 0x11A96).addRange(0x11A98, 0x11A99).addRange(0x11C30, 0x11C36).addRange(0x11C38, 0x11C3D).addRange(0x11C92, 0x11CA7).addRange(0x11CAA, 0x11CB0).addRange(0x11CB2, 0x11CB3).addRange(0x11CB5, 0x11CB6).addRange(0x11D31, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D45).addRange(0x11D90, 0x11D91).addRange(0x11EF3, 0x11EF4).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16F8F, 0x16F92).addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169);
	set.addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E130, 0x1E136).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E94A).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Number.js", function (module, exports) {
	  const set = regenerate(0xB9, 0x2070, 0x2CFD, 0x3007, 0x10341, 0x1034A);
	set.addRange(0x30, 0x39).addRange(0xB2, 0xB3).addRange(0xBC, 0xBE).addRange(0x660, 0x669).addRange(0x6F0, 0x6F9).addRange(0x7C0, 0x7C9).addRange(0x966, 0x96F).addRange(0x9E6, 0x9EF).addRange(0x9F4, 0x9F9).addRange(0xA66, 0xA6F).addRange(0xAE6, 0xAEF).addRange(0xB66, 0xB6F).addRange(0xB72, 0xB77).addRange(0xBE6, 0xBF2).addRange(0xC66, 0xC6F).addRange(0xC78, 0xC7E).addRange(0xCE6, 0xCEF).addRange(0xD58, 0xD5E).addRange(0xD66, 0xD78).addRange(0xDE6, 0xDEF).addRange(0xE50, 0xE59).addRange(0xED0, 0xED9).addRange(0xF20, 0xF33).addRange(0x1040, 0x1049).addRange(0x1090, 0x1099).addRange(0x1369, 0x137C).addRange(0x16EE, 0x16F0).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x1810, 0x1819).addRange(0x1946, 0x194F).addRange(0x19D0, 0x19DA).addRange(0x1A80, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1B50, 0x1B59).addRange(0x1BB0, 0x1BB9).addRange(0x1C40, 0x1C49).addRange(0x1C50, 0x1C59).addRange(0x2074, 0x2079).addRange(0x2080, 0x2089).addRange(0x2150, 0x2182).addRange(0x2185, 0x2189).addRange(0x2460, 0x249B).addRange(0x24EA, 0x24FF).addRange(0x2776, 0x2793).addRange(0x3021, 0x3029).addRange(0x3038, 0x303A).addRange(0x3192, 0x3195).addRange(0x3220, 0x3229).addRange(0x3248, 0x324F).addRange(0x3251, 0x325F);
	set.addRange(0x3280, 0x3289).addRange(0x32B1, 0x32BF).addRange(0xA620, 0xA629).addRange(0xA6E6, 0xA6EF).addRange(0xA830, 0xA835).addRange(0xA8D0, 0xA8D9).addRange(0xA900, 0xA909).addRange(0xA9D0, 0xA9D9).addRange(0xA9F0, 0xA9F9).addRange(0xAA50, 0xAA59).addRange(0xABF0, 0xABF9).addRange(0xFF10, 0xFF19).addRange(0x10107, 0x10133).addRange(0x10140, 0x10178).addRange(0x1018A, 0x1018B).addRange(0x102E1, 0x102FB).addRange(0x10320, 0x10323).addRange(0x103D1, 0x103D5).addRange(0x104A0, 0x104A9).addRange(0x10858, 0x1085F).addRange(0x10879, 0x1087F).addRange(0x108A7, 0x108AF).addRange(0x108FB, 0x108FF).addRange(0x10916, 0x1091B).addRange(0x109BC, 0x109BD).addRange(0x109C0, 0x109CF).addRange(0x109D2, 0x109FF).addRange(0x10A40, 0x10A48).addRange(0x10A7D, 0x10A7E).addRange(0x10A9D, 0x10A9F).addRange(0x10AEB, 0x10AEF).addRange(0x10B58, 0x10B5F).addRange(0x10B78, 0x10B7F).addRange(0x10BA9, 0x10BAF).addRange(0x10CFA, 0x10CFF).addRange(0x10D30, 0x10D39).addRange(0x10E60, 0x10E7E).addRange(0x10F1D, 0x10F26).addRange(0x10F51, 0x10F54).addRange(0x10FC5, 0x10FCB).addRange(0x11052, 0x1106F).addRange(0x110F0, 0x110F9).addRange(0x11136, 0x1113F).addRange(0x111D0, 0x111D9).addRange(0x111E1, 0x111F4).addRange(0x112F0, 0x112F9).addRange(0x11450, 0x11459).addRange(0x114D0, 0x114D9).addRange(0x11650, 0x11659).addRange(0x116C0, 0x116C9).addRange(0x11730, 0x1173B);
	set.addRange(0x118E0, 0x118F2).addRange(0x11950, 0x11959).addRange(0x11C50, 0x11C6C).addRange(0x11D50, 0x11D59).addRange(0x11DA0, 0x11DA9).addRange(0x11FC0, 0x11FD4).addRange(0x12400, 0x1246E).addRange(0x16A60, 0x16A69).addRange(0x16AC0, 0x16AC9).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16E80, 0x16E96).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D360, 0x1D378).addRange(0x1D7CE, 0x1D7FF).addRange(0x1E140, 0x1E149).addRange(0x1E2F0, 0x1E2F9).addRange(0x1E8C7, 0x1E8CF).addRange(0x1E950, 0x1E959).addRange(0x1EC71, 0x1ECAB).addRange(0x1ECAD, 0x1ECAF).addRange(0x1ECB1, 0x1ECB4).addRange(0x1ED01, 0x1ED2D).addRange(0x1ED2F, 0x1ED3D).addRange(0x1F100, 0x1F10C).addRange(0x1FBF0, 0x1FBF9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Open_Punctuation.js", function (module, exports) {
	  const set = regenerate(0x28, 0x5B, 0x7B, 0xF3A, 0xF3C, 0x169B, 0x201A, 0x201E, 0x2045, 0x207D, 0x208D, 0x2308, 0x230A, 0x2329, 0x2768, 0x276A, 0x276C, 0x276E, 0x2770, 0x2772, 0x2774, 0x27C5, 0x27E6, 0x27E8, 0x27EA, 0x27EC, 0x27EE, 0x2983, 0x2985, 0x2987, 0x2989, 0x298B, 0x298D, 0x298F, 0x2991, 0x2993, 0x2995, 0x2997, 0x29D8, 0x29DA, 0x29FC, 0x2E22, 0x2E24, 0x2E26, 0x2E28, 0x2E42, 0x2E55, 0x2E57, 0x2E59, 0x2E5B, 0x3008, 0x300A, 0x300C, 0x300E, 0x3010, 0x3014, 0x3016, 0x3018, 0x301A, 0x301D, 0xFD3F, 0xFE17, 0xFE35, 0xFE37, 0xFE39, 0xFE3B, 0xFE3D, 0xFE3F, 0xFE41, 0xFE43, 0xFE47, 0xFE59, 0xFE5B, 0xFE5D, 0xFF08, 0xFF3B, 0xFF5B, 0xFF5F, 0xFF62);

	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Other_Letter.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xBA, 0x1BB, 0x294, 0x6D5, 0x6FF, 0x710, 0x7B1, 0x93D, 0x950, 0x9B2, 0x9BD, 0x9CE, 0x9FC, 0xA5E, 0xABD, 0xAD0, 0xAF9, 0xB3D, 0xB71, 0xB83, 0xB9C, 0xBD0, 0xC3D, 0xC5D, 0xC80, 0xCBD, 0xD3D, 0xD4E, 0xDBD, 0xE84, 0xEA5, 0xEBD, 0xF00, 0x103F, 0x1061, 0x108E, 0x1258, 0x12C0, 0x17DC, 0x18AA, 0x1CFA, 0x3006, 0x303C, 0x309F, 0x30FF, 0xA66E, 0xA78F, 0xA7F7, 0xA8FB, 0xAA7A, 0xAAB1, 0xAAC0, 0xAAC2, 0xAAF2, 0xFB1D, 0xFB3E, 0x10808, 0x1083C, 0x10A00, 0x10F27, 0x11075, 0x11144, 0x11147, 0x11176, 0x111DA, 0x111DC, 0x11288, 0x1133D, 0x11350, 0x114C7, 0x11644, 0x116B8, 0x11909, 0x1193F, 0x11941, 0x119E1, 0x119E3, 0x11A00, 0x11A3A, 0x11A50, 0x11A9D, 0x11C40, 0x11D46, 0x11D98, 0x11FB0, 0x16F50, 0x1DF0A, 0x1E14E, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x1C0, 0x1C3).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x620, 0x63F).addRange(0x641, 0x64A).addRange(0x66E, 0x66F).addRange(0x671, 0x6D3).addRange(0x6EE, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7CA, 0x7EA).addRange(0x800, 0x815).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C8).addRange(0x904, 0x939).addRange(0x958, 0x961).addRange(0x972, 0x980).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9F0, 0x9F1).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA59, 0xA5C).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xAE0, 0xAE1).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39);
	set.addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCF1, 0xCF2).addRange(0xD04, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD54, 0xD56).addRange(0xD5F, 0xD61).addRange(0xD7A, 0xD7F).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xE01, 0xE30).addRange(0xE32, 0xE33).addRange(0xE40, 0xE45).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEB2, 0xEB3).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C).addRange(0x1000, 0x102A).addRange(0x1050, 0x1055).addRange(0x105A, 0x105D).addRange(0x1065, 0x1066);
	set.addRange(0x106E, 0x1070).addRange(0x1075, 0x1081).addRange(0x1100, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16F1, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x1820, 0x1842).addRange(0x1844, 0x1878).addRange(0x1880, 0x1884).addRange(0x1887, 0x18A8).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A16).addRange(0x1A20, 0x1A54).addRange(0x1B05, 0x1B33).addRange(0x1B45, 0x1B4C).addRange(0x1B83, 0x1BA0).addRange(0x1BAE, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1C00, 0x1C23).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C77).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6);
	set.addRange(0x2135, 0x2138).addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x3041, 0x3096).addRange(0x30A1, 0x30FA).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA014).addRange(0xA016, 0xA48C).addRange(0xA4D0, 0xA4F7).addRange(0xA500, 0xA60B).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA6A0, 0xA6E5).addRange(0xA7FB, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA822).addRange(0xA840, 0xA873).addRange(0xA882, 0xA8B3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FE).addRange(0xA90A, 0xA925).addRange(0xA930, 0xA946).addRange(0xA960, 0xA97C).addRange(0xA984, 0xA9B2).addRange(0xA9E0, 0xA9E4).addRange(0xA9E7, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA28).addRange(0xAA40, 0xAA42).addRange(0xAA44, 0xAA4B).addRange(0xAA60, 0xAA6F).addRange(0xAA71, 0xAA76).addRange(0xAA7E, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAADC).addRange(0xAAE0, 0xAAEA).addRange(0xAB01, 0xAB06);
	set.addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xABC0, 0xABE2).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB1F, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF66, 0xFF6F).addRange(0xFF71, 0xFF9D).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x10340).addRange(0x10342, 0x10349).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x10450, 0x1049D).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767);
	set.addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10D00, 0x10D23).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11003, 0x11037).addRange(0x11071, 0x11072).addRange(0x11083, 0x110AF).addRange(0x110D0, 0x110E8).addRange(0x11103, 0x11126).addRange(0x11150, 0x11172).addRange(0x11183, 0x111B2).addRange(0x111C1, 0x111C4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122B).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112DE).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330);
	set.addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1135D, 0x11361).addRange(0x11400, 0x11434).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114C4, 0x114C5).addRange(0x11580, 0x115AE).addRange(0x115D8, 0x115DB).addRange(0x11600, 0x1162F).addRange(0x11680, 0x116AA).addRange(0x11700, 0x1171A).addRange(0x11740, 0x11746).addRange(0x11800, 0x1182B).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D0).addRange(0x11A0B, 0x11A32).addRange(0x11A5C, 0x11A89).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2E).addRange(0x11C72, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D89).addRange(0x11EE0, 0x11EF2).addRange(0x12000, 0x12399).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342E).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16F00, 0x16F4A).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1B000, 0x1B122);
	set.addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1E100, 0x1E12C).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Other_Number.js", function (module, exports) {
	  const set = regenerate(0xB9, 0x19DA, 0x2070, 0x2189, 0x2CFD);
	set.addRange(0xB2, 0xB3).addRange(0xBC, 0xBE).addRange(0x9F4, 0x9F9).addRange(0xB72, 0xB77).addRange(0xBF0, 0xBF2).addRange(0xC78, 0xC7E).addRange(0xD58, 0xD5E).addRange(0xD70, 0xD78).addRange(0xF2A, 0xF33).addRange(0x1369, 0x137C).addRange(0x17F0, 0x17F9).addRange(0x2074, 0x2079).addRange(0x2080, 0x2089).addRange(0x2150, 0x215F).addRange(0x2460, 0x249B).addRange(0x24EA, 0x24FF).addRange(0x2776, 0x2793).addRange(0x3192, 0x3195).addRange(0x3220, 0x3229).addRange(0x3248, 0x324F).addRange(0x3251, 0x325F).addRange(0x3280, 0x3289).addRange(0x32B1, 0x32BF).addRange(0xA830, 0xA835).addRange(0x10107, 0x10133).addRange(0x10175, 0x10178).addRange(0x1018A, 0x1018B).addRange(0x102E1, 0x102FB).addRange(0x10320, 0x10323).addRange(0x10858, 0x1085F).addRange(0x10879, 0x1087F).addRange(0x108A7, 0x108AF).addRange(0x108FB, 0x108FF).addRange(0x10916, 0x1091B).addRange(0x109BC, 0x109BD).addRange(0x109C0, 0x109CF).addRange(0x109D2, 0x109FF).addRange(0x10A40, 0x10A48).addRange(0x10A7D, 0x10A7E).addRange(0x10A9D, 0x10A9F).addRange(0x10AEB, 0x10AEF).addRange(0x10B58, 0x10B5F).addRange(0x10B78, 0x10B7F).addRange(0x10BA9, 0x10BAF).addRange(0x10CFA, 0x10CFF).addRange(0x10E60, 0x10E7E).addRange(0x10F1D, 0x10F26).addRange(0x10F51, 0x10F54).addRange(0x10FC5, 0x10FCB).addRange(0x11052, 0x11065).addRange(0x111E1, 0x111F4);
	set.addRange(0x1173A, 0x1173B).addRange(0x118EA, 0x118F2).addRange(0x11C5A, 0x11C6C).addRange(0x11FC0, 0x11FD4).addRange(0x16B5B, 0x16B61).addRange(0x16E80, 0x16E96).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D360, 0x1D378).addRange(0x1E8C7, 0x1E8CF).addRange(0x1EC71, 0x1ECAB).addRange(0x1ECAD, 0x1ECAF).addRange(0x1ECB1, 0x1ECB4).addRange(0x1ED01, 0x1ED2D).addRange(0x1ED2F, 0x1ED3D).addRange(0x1F100, 0x1F10C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Other_Punctuation.js", function (module, exports) {
	  const set = regenerate(0x2A, 0x2C, 0x5C, 0xA1, 0xA7, 0xBF, 0x37E, 0x387, 0x589, 0x5C0, 0x5C3, 0x5C6, 0x61B, 0x6D4, 0x85E, 0x970, 0x9FD, 0xA76, 0xAF0, 0xC77, 0xC84, 0xDF4, 0xE4F, 0xF14, 0xF85, 0x10FB, 0x166E, 0x1CD3, 0x2053, 0x2D70, 0x2E0B, 0x2E1B, 0x2E41, 0x303D, 0x30FB, 0xA673, 0xA67E, 0xA8FC, 0xA95F, 0xABEB, 0xFE19, 0xFE30, 0xFE68, 0xFF0A, 0xFF0C, 0xFF3C, 0xFF61, 0x1039F, 0x103D0, 0x1056F, 0x10857, 0x1091F, 0x1093F, 0x10A7F, 0x111CD, 0x111DB, 0x112A9, 0x1145D, 0x114C6, 0x116B9, 0x1183B, 0x119E2, 0x11FFF, 0x16AF5, 0x16B44, 0x16FE2, 0x1BC9F);
	set.addRange(0x21, 0x23).addRange(0x25, 0x27).addRange(0x2E, 0x2F).addRange(0x3A, 0x3B).addRange(0x3F, 0x40).addRange(0xB6, 0xB7).addRange(0x55A, 0x55F).addRange(0x5F3, 0x5F4).addRange(0x609, 0x60A).addRange(0x60C, 0x60D).addRange(0x61D, 0x61F).addRange(0x66A, 0x66D).addRange(0x700, 0x70D).addRange(0x7F7, 0x7F9).addRange(0x830, 0x83E).addRange(0x964, 0x965).addRange(0xE5A, 0xE5B).addRange(0xF04, 0xF12).addRange(0xFD0, 0xFD4).addRange(0xFD9, 0xFDA).addRange(0x104A, 0x104F).addRange(0x1360, 0x1368).addRange(0x16EB, 0x16ED).addRange(0x1735, 0x1736).addRange(0x17D4, 0x17D6).addRange(0x17D8, 0x17DA).addRange(0x1800, 0x1805).addRange(0x1807, 0x180A).addRange(0x1944, 0x1945).addRange(0x1A1E, 0x1A1F).addRange(0x1AA0, 0x1AA6).addRange(0x1AA8, 0x1AAD).addRange(0x1B5A, 0x1B60).addRange(0x1B7D, 0x1B7E).addRange(0x1BFC, 0x1BFF).addRange(0x1C3B, 0x1C3F).addRange(0x1C7E, 0x1C7F).addRange(0x1CC0, 0x1CC7).addRange(0x2016, 0x2017).addRange(0x2020, 0x2027).addRange(0x2030, 0x2038).addRange(0x203B, 0x203E).addRange(0x2041, 0x2043).addRange(0x2047, 0x2051).addRange(0x2055, 0x205E).addRange(0x2CF9, 0x2CFC).addRange(0x2CFE, 0x2CFF).addRange(0x2E00, 0x2E01).addRange(0x2E06, 0x2E08).addRange(0x2E0E, 0x2E16).addRange(0x2E18, 0x2E19);
	set.addRange(0x2E1E, 0x2E1F).addRange(0x2E2A, 0x2E2E).addRange(0x2E30, 0x2E39).addRange(0x2E3C, 0x2E3F).addRange(0x2E43, 0x2E4F).addRange(0x2E52, 0x2E54).addRange(0x3001, 0x3003).addRange(0xA4FE, 0xA4FF).addRange(0xA60D, 0xA60F).addRange(0xA6F2, 0xA6F7).addRange(0xA874, 0xA877).addRange(0xA8CE, 0xA8CF).addRange(0xA8F8, 0xA8FA).addRange(0xA92E, 0xA92F).addRange(0xA9C1, 0xA9CD).addRange(0xA9DE, 0xA9DF).addRange(0xAA5C, 0xAA5F).addRange(0xAADE, 0xAADF).addRange(0xAAF0, 0xAAF1).addRange(0xFE10, 0xFE16).addRange(0xFE45, 0xFE46).addRange(0xFE49, 0xFE4C).addRange(0xFE50, 0xFE52).addRange(0xFE54, 0xFE57).addRange(0xFE5F, 0xFE61).addRange(0xFE6A, 0xFE6B).addRange(0xFF01, 0xFF03).addRange(0xFF05, 0xFF07).addRange(0xFF0E, 0xFF0F).addRange(0xFF1A, 0xFF1B).addRange(0xFF1F, 0xFF20).addRange(0xFF64, 0xFF65).addRange(0x10100, 0x10102).addRange(0x10A50, 0x10A58).addRange(0x10AF0, 0x10AF6).addRange(0x10B39, 0x10B3F).addRange(0x10B99, 0x10B9C).addRange(0x10F55, 0x10F59).addRange(0x10F86, 0x10F89).addRange(0x11047, 0x1104D).addRange(0x110BB, 0x110BC).addRange(0x110BE, 0x110C1).addRange(0x11140, 0x11143).addRange(0x11174, 0x11175).addRange(0x111C5, 0x111C8).addRange(0x111DD, 0x111DF).addRange(0x11238, 0x1123D).addRange(0x1144B, 0x1144F).addRange(0x1145A, 0x1145B).addRange(0x115C1, 0x115D7).addRange(0x11641, 0x11643);
	set.addRange(0x11660, 0x1166C).addRange(0x1173C, 0x1173E).addRange(0x11944, 0x11946).addRange(0x11A3F, 0x11A46).addRange(0x11A9A, 0x11A9C).addRange(0x11A9E, 0x11AA2).addRange(0x11C41, 0x11C45).addRange(0x11C70, 0x11C71).addRange(0x11EF7, 0x11EF8).addRange(0x12470, 0x12474).addRange(0x12FF1, 0x12FF2).addRange(0x16A6E, 0x16A6F).addRange(0x16B37, 0x16B3B).addRange(0x16E97, 0x16E9A).addRange(0x1DA87, 0x1DA8B).addRange(0x1E95E, 0x1E95F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Other_Symbol.js", function (module, exports) {
	  const set = regenerate(0xA6, 0xA9, 0xAE, 0xB0, 0x482, 0x6DE, 0x6E9, 0x7F6, 0x9FA, 0xB70, 0xBFA, 0xC7F, 0xD4F, 0xD79, 0xF13, 0xF34, 0xF36, 0xF38, 0x166D, 0x1940, 0x2114, 0x2125, 0x2127, 0x2129, 0x212E, 0x214A, 0x214F, 0x21D3, 0x3004, 0x3020, 0x3250, 0xA839, 0xFDCF, 0xFFE4, 0xFFE8, 0x101A0, 0x10AC8, 0x1173F, 0x16B45, 0x1BC9C, 0x1D245, 0x1E14F, 0x1ECAC, 0x1ED2E, 0x1F7F0);
	set.addRange(0x58D, 0x58E).addRange(0x60E, 0x60F).addRange(0x6FD, 0x6FE).addRange(0xBF3, 0xBF8).addRange(0xF01, 0xF03).addRange(0xF15, 0xF17).addRange(0xF1A, 0xF1F).addRange(0xFBE, 0xFC5).addRange(0xFC7, 0xFCC).addRange(0xFCE, 0xFCF).addRange(0xFD5, 0xFD8).addRange(0x109E, 0x109F).addRange(0x1390, 0x1399).addRange(0x19DE, 0x19FF).addRange(0x1B61, 0x1B6A).addRange(0x1B74, 0x1B7C).addRange(0x2100, 0x2101).addRange(0x2103, 0x2106).addRange(0x2108, 0x2109).addRange(0x2116, 0x2117).addRange(0x211E, 0x2123).addRange(0x213A, 0x213B).addRange(0x214C, 0x214D).addRange(0x218A, 0x218B).addRange(0x2195, 0x2199).addRange(0x219C, 0x219F).addRange(0x21A1, 0x21A2).addRange(0x21A4, 0x21A5).addRange(0x21A7, 0x21AD).addRange(0x21AF, 0x21CD).addRange(0x21D0, 0x21D1).addRange(0x21D5, 0x21F3).addRange(0x2300, 0x2307).addRange(0x230C, 0x231F).addRange(0x2322, 0x2328).addRange(0x232B, 0x237B).addRange(0x237D, 0x239A).addRange(0x23B4, 0x23DB).addRange(0x23E2, 0x2426).addRange(0x2440, 0x244A).addRange(0x249C, 0x24E9).addRange(0x2500, 0x25B6).addRange(0x25B8, 0x25C0).addRange(0x25C2, 0x25F7).addRange(0x2600, 0x266E).addRange(0x2670, 0x2767).addRange(0x2794, 0x27BF).addRange(0x2800, 0x28FF).addRange(0x2B00, 0x2B2F).addRange(0x2B45, 0x2B46).addRange(0x2B4D, 0x2B73);
	set.addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2BFF).addRange(0x2CE5, 0x2CEA).addRange(0x2E50, 0x2E51).addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x2FF0, 0x2FFB).addRange(0x3012, 0x3013).addRange(0x3036, 0x3037).addRange(0x303E, 0x303F).addRange(0x3190, 0x3191).addRange(0x3196, 0x319F).addRange(0x31C0, 0x31E3).addRange(0x3200, 0x321E).addRange(0x322A, 0x3247).addRange(0x3260, 0x327F).addRange(0x328A, 0x32B0).addRange(0x32C0, 0x33FF).addRange(0x4DC0, 0x4DFF).addRange(0xA490, 0xA4C6).addRange(0xA828, 0xA82B).addRange(0xA836, 0xA837).addRange(0xAA77, 0xAA79).addRange(0xFD40, 0xFD4F).addRange(0xFDFD, 0xFDFF).addRange(0xFFED, 0xFFEE).addRange(0xFFFC, 0xFFFD).addRange(0x10137, 0x1013F).addRange(0x10179, 0x10189).addRange(0x1018C, 0x1018E).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x10877, 0x10878).addRange(0x11FD5, 0x11FDC).addRange(0x11FE1, 0x11FF1).addRange(0x16B3C, 0x16B3F).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D164).addRange(0x1D16A, 0x1D16C).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D200, 0x1D241).addRange(0x1D300, 0x1D356).addRange(0x1D800, 0x1D9FF).addRange(0x1DA37, 0x1DA3A).addRange(0x1DA6D, 0x1DA74).addRange(0x1DA76, 0x1DA83);
	set.addRange(0x1DA85, 0x1DA86).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F10D, 0x1F1AD).addRange(0x1F1E6, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F3FA).addRange(0x1F400, 0x1F6D7).addRange(0x1F6DD, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F773).addRange(0x1F780, 0x1F7D8).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Other.js", function (module, exports) {
	  const set = regenerate(0xAD, 0x38B, 0x38D, 0x3A2, 0x530, 0x590, 0x61C, 0x6DD, 0x83F, 0x85F, 0x8E2, 0x984, 0x9A9, 0x9B1, 0x9DE, 0xA04, 0xA29, 0xA31, 0xA34, 0xA37, 0xA3D, 0xA5D, 0xA84, 0xA8E, 0xA92, 0xAA9, 0xAB1, 0xAB4, 0xAC6, 0xACA, 0xB00, 0xB04, 0xB29, 0xB31, 0xB34, 0xB5E, 0xB84, 0xB91, 0xB9B, 0xB9D, 0xBC9, 0xC0D, 0xC11, 0xC29, 0xC45, 0xC49, 0xC57, 0xC8D, 0xC91, 0xCA9, 0xCB4, 0xCC5, 0xCC9, 0xCDF, 0xCF0, 0xD0D, 0xD11, 0xD45, 0xD49, 0xD80, 0xD84, 0xDB2, 0xDBC, 0xDD5, 0xDD7, 0xE83, 0xE85, 0xE8B, 0xEA4, 0xEA6, 0xEC5, 0xEC7, 0xF48, 0xF98, 0xFBD, 0xFCD, 0x10C6, 0x1249, 0x1257, 0x1259, 0x1289, 0x12B1, 0x12BF, 0x12C1, 0x12D7, 0x1311, 0x176D, 0x1771, 0x180E, 0x191F, 0x1A5F, 0x1B7F, 0x1F58, 0x1F5A, 0x1F5C, 0x1F5E, 0x1FB5, 0x1FC5, 0x1FDC, 0x1FF5, 0x1FFF, 0x208F, 0x2B96, 0x2D26, 0x2DA7, 0x2DAF, 0x2DB7, 0x2DBF, 0x2DC7, 0x2DCF, 0x2DD7, 0x2DDF, 0x2E9A, 0x3040, 0x3130, 0x318F, 0x321F, 0xA7D2, 0xA7D4, 0xA9CE, 0xA9FF, 0xAB27, 0xAB2F, 0xFB37, 0xFB3D, 0xFB3F, 0xFB42, 0xFB45, 0xFE53, 0xFE67, 0xFE75, 0xFFE7, 0x1000C, 0x10027, 0x1003B, 0x1003E, 0x1018F, 0x1039E, 0x1057B, 0x1058B, 0x10593, 0x10596, 0x105A2, 0x105B2, 0x105BA, 0x10786, 0x107B1, 0x10809, 0x10836, 0x10856, 0x108F3, 0x10A04, 0x10A14, 0x10A18, 0x10E7F, 0x10EAA, 0x110BD, 0x11135, 0x111E0, 0x11212, 0x11287, 0x11289, 0x1128E, 0x1129E, 0x11304, 0x11329, 0x11331, 0x11334, 0x1133A, 0x1145C, 0x11914, 0x11917, 0x11936, 0x11C09, 0x11C37, 0x11CA8, 0x11D07, 0x11D0A, 0x11D3B, 0x11D3E, 0x11D66, 0x11D69, 0x11D8F, 0x11D92, 0x1246F, 0x16A5F, 0x16ABF, 0x16B5A, 0x16B62, 0x1AFF4, 0x1AFFC, 0x1AFFF, 0x1D455, 0x1D49D, 0x1D4AD, 0x1D4BA, 0x1D4BC, 0x1D4C4, 0x1D506, 0x1D515, 0x1D51D, 0x1D53A, 0x1D53F, 0x1D545, 0x1D551, 0x1DAA0, 0x1E007, 0x1E022, 0x1E025, 0x1E7E7, 0x1E7EC, 0x1E7EF, 0x1E7FF, 0x1EE04, 0x1EE20, 0x1EE23, 0x1EE28, 0x1EE33, 0x1EE38, 0x1EE3A, 0x1EE48, 0x1EE4A, 0x1EE4C, 0x1EE50, 0x1EE53, 0x1EE58, 0x1EE5A, 0x1EE5C, 0x1EE5E, 0x1EE60, 0x1EE63, 0x1EE6B, 0x1EE73, 0x1EE78, 0x1EE7D, 0x1EE7F, 0x1EE8A, 0x1EEA4, 0x1EEAA, 0x1F0C0, 0x1F0D0, 0x1FB93);
	set.addRange(0x0, 0x1F).addRange(0x7F, 0x9F).addRange(0x378, 0x379).addRange(0x380, 0x383).addRange(0x557, 0x558).addRange(0x58B, 0x58C).addRange(0x5C8, 0x5CF).addRange(0x5EB, 0x5EE).addRange(0x5F5, 0x605).addRange(0x70E, 0x70F).addRange(0x74B, 0x74C).addRange(0x7B2, 0x7BF).addRange(0x7FB, 0x7FC).addRange(0x82E, 0x82F).addRange(0x85C, 0x85D).addRange(0x86B, 0x86F).addRange(0x88F, 0x897).addRange(0x98D, 0x98E).addRange(0x991, 0x992).addRange(0x9B3, 0x9B5).addRange(0x9BA, 0x9BB).addRange(0x9C5, 0x9C6).addRange(0x9C9, 0x9CA).addRange(0x9CF, 0x9D6).addRange(0x9D8, 0x9DB).addRange(0x9E4, 0x9E5).addRange(0x9FF, 0xA00).addRange(0xA0B, 0xA0E).addRange(0xA11, 0xA12).addRange(0xA3A, 0xA3B).addRange(0xA43, 0xA46).addRange(0xA49, 0xA4A).addRange(0xA4E, 0xA50).addRange(0xA52, 0xA58).addRange(0xA5F, 0xA65).addRange(0xA77, 0xA80).addRange(0xABA, 0xABB).addRange(0xACE, 0xACF).addRange(0xAD1, 0xADF).addRange(0xAE4, 0xAE5).addRange(0xAF2, 0xAF8).addRange(0xB0D, 0xB0E).addRange(0xB11, 0xB12).addRange(0xB3A, 0xB3B).addRange(0xB45, 0xB46).addRange(0xB49, 0xB4A).addRange(0xB4E, 0xB54).addRange(0xB58, 0xB5B).addRange(0xB64, 0xB65).addRange(0xB78, 0xB81).addRange(0xB8B, 0xB8D);
	set.addRange(0xB96, 0xB98).addRange(0xBA0, 0xBA2).addRange(0xBA5, 0xBA7).addRange(0xBAB, 0xBAD).addRange(0xBBA, 0xBBD).addRange(0xBC3, 0xBC5).addRange(0xBCE, 0xBCF).addRange(0xBD1, 0xBD6).addRange(0xBD8, 0xBE5).addRange(0xBFB, 0xBFF).addRange(0xC3A, 0xC3B).addRange(0xC4E, 0xC54).addRange(0xC5B, 0xC5C).addRange(0xC5E, 0xC5F).addRange(0xC64, 0xC65).addRange(0xC70, 0xC76).addRange(0xCBA, 0xCBB).addRange(0xCCE, 0xCD4).addRange(0xCD7, 0xCDC).addRange(0xCE4, 0xCE5).addRange(0xCF3, 0xCFF).addRange(0xD50, 0xD53).addRange(0xD64, 0xD65).addRange(0xD97, 0xD99).addRange(0xDBE, 0xDBF).addRange(0xDC7, 0xDC9).addRange(0xDCB, 0xDCE).addRange(0xDE0, 0xDE5).addRange(0xDF0, 0xDF1).addRange(0xDF5, 0xE00).addRange(0xE3B, 0xE3E).addRange(0xE5C, 0xE80).addRange(0xEBE, 0xEBF).addRange(0xECE, 0xECF).addRange(0xEDA, 0xEDB).addRange(0xEE0, 0xEFF).addRange(0xF6D, 0xF70).addRange(0xFDB, 0xFFF).addRange(0x10C8, 0x10CC).addRange(0x10CE, 0x10CF).addRange(0x124E, 0x124F).addRange(0x125E, 0x125F).addRange(0x128E, 0x128F).addRange(0x12B6, 0x12B7).addRange(0x12C6, 0x12C7).addRange(0x1316, 0x1317).addRange(0x135B, 0x135C).addRange(0x137D, 0x137F).addRange(0x139A, 0x139F).addRange(0x13F6, 0x13F7).addRange(0x13FE, 0x13FF);
	set.addRange(0x169D, 0x169F).addRange(0x16F9, 0x16FF).addRange(0x1716, 0x171E).addRange(0x1737, 0x173F).addRange(0x1754, 0x175F).addRange(0x1774, 0x177F).addRange(0x17DE, 0x17DF).addRange(0x17EA, 0x17EF).addRange(0x17FA, 0x17FF).addRange(0x181A, 0x181F).addRange(0x1879, 0x187F).addRange(0x18AB, 0x18AF).addRange(0x18F6, 0x18FF).addRange(0x192C, 0x192F).addRange(0x193C, 0x193F).addRange(0x1941, 0x1943).addRange(0x196E, 0x196F).addRange(0x1975, 0x197F).addRange(0x19AC, 0x19AF).addRange(0x19CA, 0x19CF).addRange(0x19DB, 0x19DD).addRange(0x1A1C, 0x1A1D).addRange(0x1A7D, 0x1A7E).addRange(0x1A8A, 0x1A8F).addRange(0x1A9A, 0x1A9F).addRange(0x1AAE, 0x1AAF).addRange(0x1ACF, 0x1AFF).addRange(0x1B4D, 0x1B4F).addRange(0x1BF4, 0x1BFB).addRange(0x1C38, 0x1C3A).addRange(0x1C4A, 0x1C4C).addRange(0x1C89, 0x1C8F).addRange(0x1CBB, 0x1CBC).addRange(0x1CC8, 0x1CCF).addRange(0x1CFB, 0x1CFF).addRange(0x1F16, 0x1F17).addRange(0x1F1E, 0x1F1F).addRange(0x1F46, 0x1F47).addRange(0x1F4E, 0x1F4F).addRange(0x1F7E, 0x1F7F).addRange(0x1FD4, 0x1FD5).addRange(0x1FF0, 0x1FF1).addRange(0x200B, 0x200F).addRange(0x202A, 0x202E).addRange(0x2060, 0x206F).addRange(0x2072, 0x2073).addRange(0x209D, 0x209F).addRange(0x20C1, 0x20CF).addRange(0x20F1, 0x20FF).addRange(0x218C, 0x218F).addRange(0x2427, 0x243F);
	set.addRange(0x244B, 0x245F).addRange(0x2B74, 0x2B75).addRange(0x2CF4, 0x2CF8).addRange(0x2D28, 0x2D2C).addRange(0x2D2E, 0x2D2F).addRange(0x2D68, 0x2D6E).addRange(0x2D71, 0x2D7E).addRange(0x2D97, 0x2D9F).addRange(0x2E5E, 0x2E7F).addRange(0x2EF4, 0x2EFF).addRange(0x2FD6, 0x2FEF).addRange(0x2FFC, 0x2FFF).addRange(0x3097, 0x3098).addRange(0x3100, 0x3104).addRange(0x31E4, 0x31EF).addRange(0xA48D, 0xA48F).addRange(0xA4C7, 0xA4CF).addRange(0xA62C, 0xA63F).addRange(0xA6F8, 0xA6FF).addRange(0xA7CB, 0xA7CF).addRange(0xA7DA, 0xA7F1).addRange(0xA82D, 0xA82F).addRange(0xA83A, 0xA83F).addRange(0xA878, 0xA87F).addRange(0xA8C6, 0xA8CD).addRange(0xA8DA, 0xA8DF).addRange(0xA954, 0xA95E).addRange(0xA97D, 0xA97F).addRange(0xA9DA, 0xA9DD).addRange(0xAA37, 0xAA3F).addRange(0xAA4E, 0xAA4F).addRange(0xAA5A, 0xAA5B).addRange(0xAAC3, 0xAADA).addRange(0xAAF7, 0xAB00).addRange(0xAB07, 0xAB08).addRange(0xAB0F, 0xAB10).addRange(0xAB17, 0xAB1F).addRange(0xAB6C, 0xAB6F).addRange(0xABEE, 0xABEF).addRange(0xABFA, 0xABFF).addRange(0xD7A4, 0xD7AF).addRange(0xD7C7, 0xD7CA).addRange(0xD7FC, 0xF8FF).addRange(0xFA6E, 0xFA6F).addRange(0xFADA, 0xFAFF).addRange(0xFB07, 0xFB12).addRange(0xFB18, 0xFB1C).addRange(0xFBC3, 0xFBD2).addRange(0xFD90, 0xFD91).addRange(0xFDC8, 0xFDCE).addRange(0xFDD0, 0xFDEF);
	set.addRange(0xFE1A, 0xFE1F).addRange(0xFE6C, 0xFE6F).addRange(0xFEFD, 0xFF00).addRange(0xFFBF, 0xFFC1).addRange(0xFFC8, 0xFFC9).addRange(0xFFD0, 0xFFD1).addRange(0xFFD8, 0xFFD9).addRange(0xFFDD, 0xFFDF).addRange(0xFFEF, 0xFFFB).addRange(0xFFFE, 0xFFFF).addRange(0x1004E, 0x1004F).addRange(0x1005E, 0x1007F).addRange(0x100FB, 0x100FF).addRange(0x10103, 0x10106).addRange(0x10134, 0x10136).addRange(0x1019D, 0x1019F).addRange(0x101A1, 0x101CF).addRange(0x101FE, 0x1027F).addRange(0x1029D, 0x1029F).addRange(0x102D1, 0x102DF).addRange(0x102FC, 0x102FF).addRange(0x10324, 0x1032C).addRange(0x1034B, 0x1034F).addRange(0x1037B, 0x1037F).addRange(0x103C4, 0x103C7).addRange(0x103D6, 0x103FF).addRange(0x1049E, 0x1049F).addRange(0x104AA, 0x104AF).addRange(0x104D4, 0x104D7).addRange(0x104FC, 0x104FF).addRange(0x10528, 0x1052F).addRange(0x10564, 0x1056E).addRange(0x105BD, 0x105FF).addRange(0x10737, 0x1073F).addRange(0x10756, 0x1075F).addRange(0x10768, 0x1077F).addRange(0x107BB, 0x107FF).addRange(0x10806, 0x10807).addRange(0x10839, 0x1083B).addRange(0x1083D, 0x1083E).addRange(0x1089F, 0x108A6).addRange(0x108B0, 0x108DF).addRange(0x108F6, 0x108FA).addRange(0x1091C, 0x1091E).addRange(0x1093A, 0x1093E).addRange(0x10940, 0x1097F).addRange(0x109B8, 0x109BB).addRange(0x109D0, 0x109D1).addRange(0x10A07, 0x10A0B).addRange(0x10A36, 0x10A37).addRange(0x10A3B, 0x10A3E);
	set.addRange(0x10A49, 0x10A4F).addRange(0x10A59, 0x10A5F).addRange(0x10AA0, 0x10ABF).addRange(0x10AE7, 0x10AEA).addRange(0x10AF7, 0x10AFF).addRange(0x10B36, 0x10B38).addRange(0x10B56, 0x10B57).addRange(0x10B73, 0x10B77).addRange(0x10B92, 0x10B98).addRange(0x10B9D, 0x10BA8).addRange(0x10BB0, 0x10BFF).addRange(0x10C49, 0x10C7F).addRange(0x10CB3, 0x10CBF).addRange(0x10CF3, 0x10CF9).addRange(0x10D28, 0x10D2F).addRange(0x10D3A, 0x10E5F).addRange(0x10EAE, 0x10EAF).addRange(0x10EB2, 0x10EFF).addRange(0x10F28, 0x10F2F).addRange(0x10F5A, 0x10F6F).addRange(0x10F8A, 0x10FAF).addRange(0x10FCC, 0x10FDF).addRange(0x10FF7, 0x10FFF).addRange(0x1104E, 0x11051).addRange(0x11076, 0x1107E).addRange(0x110C3, 0x110CF).addRange(0x110E9, 0x110EF).addRange(0x110FA, 0x110FF).addRange(0x11148, 0x1114F).addRange(0x11177, 0x1117F).addRange(0x111F5, 0x111FF).addRange(0x1123F, 0x1127F).addRange(0x112AA, 0x112AF).addRange(0x112EB, 0x112EF).addRange(0x112FA, 0x112FF).addRange(0x1130D, 0x1130E).addRange(0x11311, 0x11312).addRange(0x11345, 0x11346).addRange(0x11349, 0x1134A).addRange(0x1134E, 0x1134F).addRange(0x11351, 0x11356).addRange(0x11358, 0x1135C).addRange(0x11364, 0x11365).addRange(0x1136D, 0x1136F).addRange(0x11375, 0x113FF).addRange(0x11462, 0x1147F).addRange(0x114C8, 0x114CF).addRange(0x114DA, 0x1157F).addRange(0x115B6, 0x115B7).addRange(0x115DE, 0x115FF).addRange(0x11645, 0x1164F);
	set.addRange(0x1165A, 0x1165F).addRange(0x1166D, 0x1167F).addRange(0x116BA, 0x116BF).addRange(0x116CA, 0x116FF).addRange(0x1171B, 0x1171C).addRange(0x1172C, 0x1172F).addRange(0x11747, 0x117FF).addRange(0x1183C, 0x1189F).addRange(0x118F3, 0x118FE).addRange(0x11907, 0x11908).addRange(0x1190A, 0x1190B).addRange(0x11939, 0x1193A).addRange(0x11947, 0x1194F).addRange(0x1195A, 0x1199F).addRange(0x119A8, 0x119A9).addRange(0x119D8, 0x119D9).addRange(0x119E5, 0x119FF).addRange(0x11A48, 0x11A4F).addRange(0x11AA3, 0x11AAF).addRange(0x11AF9, 0x11BFF).addRange(0x11C46, 0x11C4F).addRange(0x11C6D, 0x11C6F).addRange(0x11C90, 0x11C91).addRange(0x11CB7, 0x11CFF).addRange(0x11D37, 0x11D39).addRange(0x11D48, 0x11D4F).addRange(0x11D5A, 0x11D5F).addRange(0x11D99, 0x11D9F).addRange(0x11DAA, 0x11EDF).addRange(0x11EF9, 0x11FAF).addRange(0x11FB1, 0x11FBF).addRange(0x11FF2, 0x11FFE).addRange(0x1239A, 0x123FF).addRange(0x12475, 0x1247F).addRange(0x12544, 0x12F8F).addRange(0x12FF3, 0x12FFF).addRange(0x1342F, 0x143FF).addRange(0x14647, 0x167FF).addRange(0x16A39, 0x16A3F).addRange(0x16A6A, 0x16A6D).addRange(0x16ACA, 0x16ACF).addRange(0x16AEE, 0x16AEF).addRange(0x16AF6, 0x16AFF).addRange(0x16B46, 0x16B4F).addRange(0x16B78, 0x16B7C).addRange(0x16B90, 0x16E3F).addRange(0x16E9B, 0x16EFF).addRange(0x16F4B, 0x16F4E).addRange(0x16F88, 0x16F8E).addRange(0x16FA0, 0x16FDF).addRange(0x16FE5, 0x16FEF);
	set.addRange(0x16FF2, 0x16FFF).addRange(0x187F8, 0x187FF).addRange(0x18CD6, 0x18CFF).addRange(0x18D09, 0x1AFEF).addRange(0x1B123, 0x1B14F).addRange(0x1B153, 0x1B163).addRange(0x1B168, 0x1B16F).addRange(0x1B2FC, 0x1BBFF).addRange(0x1BC6B, 0x1BC6F).addRange(0x1BC7D, 0x1BC7F).addRange(0x1BC89, 0x1BC8F).addRange(0x1BC9A, 0x1BC9B).addRange(0x1BCA0, 0x1CEFF).addRange(0x1CF2E, 0x1CF2F).addRange(0x1CF47, 0x1CF4F).addRange(0x1CFC4, 0x1CFFF).addRange(0x1D0F6, 0x1D0FF).addRange(0x1D127, 0x1D128).addRange(0x1D173, 0x1D17A).addRange(0x1D1EB, 0x1D1FF).addRange(0x1D246, 0x1D2DF).addRange(0x1D2F4, 0x1D2FF).addRange(0x1D357, 0x1D35F).addRange(0x1D379, 0x1D3FF).addRange(0x1D4A0, 0x1D4A1).addRange(0x1D4A3, 0x1D4A4).addRange(0x1D4A7, 0x1D4A8).addRange(0x1D50B, 0x1D50C).addRange(0x1D547, 0x1D549).addRange(0x1D6A6, 0x1D6A7).addRange(0x1D7CC, 0x1D7CD).addRange(0x1DA8C, 0x1DA9A).addRange(0x1DAB0, 0x1DEFF).addRange(0x1DF1F, 0x1DFFF).addRange(0x1E019, 0x1E01A).addRange(0x1E02B, 0x1E0FF).addRange(0x1E12D, 0x1E12F).addRange(0x1E13E, 0x1E13F).addRange(0x1E14A, 0x1E14D).addRange(0x1E150, 0x1E28F).addRange(0x1E2AF, 0x1E2BF).addRange(0x1E2FA, 0x1E2FE).addRange(0x1E300, 0x1E7DF).addRange(0x1E8C5, 0x1E8C6).addRange(0x1E8D7, 0x1E8FF).addRange(0x1E94C, 0x1E94F).addRange(0x1E95A, 0x1E95D).addRange(0x1E960, 0x1EC70).addRange(0x1ECB5, 0x1ED00).addRange(0x1ED3E, 0x1EDFF).addRange(0x1EE25, 0x1EE26);
	set.addRange(0x1EE3C, 0x1EE41).addRange(0x1EE43, 0x1EE46).addRange(0x1EE55, 0x1EE56).addRange(0x1EE65, 0x1EE66).addRange(0x1EE9C, 0x1EEA0).addRange(0x1EEBC, 0x1EEEF).addRange(0x1EEF2, 0x1EFFF).addRange(0x1F02C, 0x1F02F).addRange(0x1F094, 0x1F09F).addRange(0x1F0AF, 0x1F0B0).addRange(0x1F0F6, 0x1F0FF).addRange(0x1F1AE, 0x1F1E5).addRange(0x1F203, 0x1F20F).addRange(0x1F23C, 0x1F23F).addRange(0x1F249, 0x1F24F).addRange(0x1F252, 0x1F25F).addRange(0x1F266, 0x1F2FF).addRange(0x1F6D8, 0x1F6DC).addRange(0x1F6ED, 0x1F6EF).addRange(0x1F6FD, 0x1F6FF).addRange(0x1F774, 0x1F77F).addRange(0x1F7D9, 0x1F7DF).addRange(0x1F7EC, 0x1F7EF).addRange(0x1F7F1, 0x1F7FF).addRange(0x1F80C, 0x1F80F).addRange(0x1F848, 0x1F84F).addRange(0x1F85A, 0x1F85F).addRange(0x1F888, 0x1F88F).addRange(0x1F8AE, 0x1F8AF).addRange(0x1F8B2, 0x1F8FF).addRange(0x1FA54, 0x1FA5F).addRange(0x1FA6E, 0x1FA6F).addRange(0x1FA75, 0x1FA77).addRange(0x1FA7D, 0x1FA7F).addRange(0x1FA87, 0x1FA8F).addRange(0x1FAAD, 0x1FAAF).addRange(0x1FABB, 0x1FABF).addRange(0x1FAC6, 0x1FACF).addRange(0x1FADA, 0x1FADF).addRange(0x1FAE8, 0x1FAEF).addRange(0x1FAF7, 0x1FAFF).addRange(0x1FBCB, 0x1FBEF).addRange(0x1FBFA, 0x1FFFF).addRange(0x2A6E0, 0x2A6FF).addRange(0x2B739, 0x2B73F).addRange(0x2B81E, 0x2B81F).addRange(0x2CEA2, 0x2CEAF).addRange(0x2EBE1, 0x2F7FF).addRange(0x2FA1E, 0x2FFFF).addRange(0x3134B, 0xE00FF).addRange(0xE01F0, 0x10FFFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Paragraph_Separator.js", function (module, exports) {
	  const set = regenerate(0x2029);

	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Private_Use.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xE000, 0xF8FF).addRange(0xF0000, 0xFFFFD).addRange(0x100000, 0x10FFFD);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Punctuation.js", function (module, exports) {
	  const set = regenerate(0x5F, 0x7B, 0x7D, 0xA1, 0xA7, 0xAB, 0xBB, 0xBF, 0x37E, 0x387, 0x5BE, 0x5C0, 0x5C3, 0x5C6, 0x61B, 0x6D4, 0x85E, 0x970, 0x9FD, 0xA76, 0xAF0, 0xC77, 0xC84, 0xDF4, 0xE4F, 0xF14, 0xF85, 0x10FB, 0x1400, 0x166E, 0x1CD3, 0x2D70, 0x3030, 0x303D, 0x30A0, 0x30FB, 0xA673, 0xA67E, 0xA8FC, 0xA95F, 0xABEB, 0xFE63, 0xFE68, 0xFF3F, 0xFF5B, 0xFF5D, 0x1039F, 0x103D0, 0x1056F, 0x10857, 0x1091F, 0x1093F, 0x10A7F, 0x10EAD, 0x111CD, 0x111DB, 0x112A9, 0x1145D, 0x114C6, 0x116B9, 0x1183B, 0x119E2, 0x11FFF, 0x16AF5, 0x16B44, 0x16FE2, 0x1BC9F);
	set.addRange(0x21, 0x23).addRange(0x25, 0x2A).addRange(0x2C, 0x2F).addRange(0x3A, 0x3B).addRange(0x3F, 0x40).addRange(0x5B, 0x5D).addRange(0xB6, 0xB7).addRange(0x55A, 0x55F).addRange(0x589, 0x58A).addRange(0x5F3, 0x5F4).addRange(0x609, 0x60A).addRange(0x60C, 0x60D).addRange(0x61D, 0x61F).addRange(0x66A, 0x66D).addRange(0x700, 0x70D).addRange(0x7F7, 0x7F9).addRange(0x830, 0x83E).addRange(0x964, 0x965).addRange(0xE5A, 0xE5B).addRange(0xF04, 0xF12).addRange(0xF3A, 0xF3D).addRange(0xFD0, 0xFD4).addRange(0xFD9, 0xFDA).addRange(0x104A, 0x104F).addRange(0x1360, 0x1368).addRange(0x169B, 0x169C).addRange(0x16EB, 0x16ED).addRange(0x1735, 0x1736).addRange(0x17D4, 0x17D6).addRange(0x17D8, 0x17DA).addRange(0x1800, 0x180A).addRange(0x1944, 0x1945).addRange(0x1A1E, 0x1A1F).addRange(0x1AA0, 0x1AA6).addRange(0x1AA8, 0x1AAD).addRange(0x1B5A, 0x1B60).addRange(0x1B7D, 0x1B7E).addRange(0x1BFC, 0x1BFF).addRange(0x1C3B, 0x1C3F).addRange(0x1C7E, 0x1C7F).addRange(0x1CC0, 0x1CC7).addRange(0x2010, 0x2027).addRange(0x2030, 0x2043).addRange(0x2045, 0x2051).addRange(0x2053, 0x205E).addRange(0x207D, 0x207E).addRange(0x208D, 0x208E).addRange(0x2308, 0x230B).addRange(0x2329, 0x232A).addRange(0x2768, 0x2775).addRange(0x27C5, 0x27C6);
	set.addRange(0x27E6, 0x27EF).addRange(0x2983, 0x2998).addRange(0x29D8, 0x29DB).addRange(0x29FC, 0x29FD).addRange(0x2CF9, 0x2CFC).addRange(0x2CFE, 0x2CFF).addRange(0x2E00, 0x2E2E).addRange(0x2E30, 0x2E4F).addRange(0x2E52, 0x2E5D).addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3014, 0x301F).addRange(0xA4FE, 0xA4FF).addRange(0xA60D, 0xA60F).addRange(0xA6F2, 0xA6F7).addRange(0xA874, 0xA877).addRange(0xA8CE, 0xA8CF).addRange(0xA8F8, 0xA8FA).addRange(0xA92E, 0xA92F).addRange(0xA9C1, 0xA9CD).addRange(0xA9DE, 0xA9DF).addRange(0xAA5C, 0xAA5F).addRange(0xAADE, 0xAADF).addRange(0xAAF0, 0xAAF1).addRange(0xFD3E, 0xFD3F).addRange(0xFE10, 0xFE19).addRange(0xFE30, 0xFE52).addRange(0xFE54, 0xFE61).addRange(0xFE6A, 0xFE6B).addRange(0xFF01, 0xFF03).addRange(0xFF05, 0xFF0A).addRange(0xFF0C, 0xFF0F).addRange(0xFF1A, 0xFF1B).addRange(0xFF1F, 0xFF20).addRange(0xFF3B, 0xFF3D).addRange(0xFF5F, 0xFF65).addRange(0x10100, 0x10102).addRange(0x10A50, 0x10A58).addRange(0x10AF0, 0x10AF6).addRange(0x10B39, 0x10B3F).addRange(0x10B99, 0x10B9C).addRange(0x10F55, 0x10F59).addRange(0x10F86, 0x10F89).addRange(0x11047, 0x1104D).addRange(0x110BB, 0x110BC).addRange(0x110BE, 0x110C1).addRange(0x11140, 0x11143).addRange(0x11174, 0x11175).addRange(0x111C5, 0x111C8).addRange(0x111DD, 0x111DF).addRange(0x11238, 0x1123D);
	set.addRange(0x1144B, 0x1144F).addRange(0x1145A, 0x1145B).addRange(0x115C1, 0x115D7).addRange(0x11641, 0x11643).addRange(0x11660, 0x1166C).addRange(0x1173C, 0x1173E).addRange(0x11944, 0x11946).addRange(0x11A3F, 0x11A46).addRange(0x11A9A, 0x11A9C).addRange(0x11A9E, 0x11AA2).addRange(0x11C41, 0x11C45).addRange(0x11C70, 0x11C71).addRange(0x11EF7, 0x11EF8).addRange(0x12470, 0x12474).addRange(0x12FF1, 0x12FF2).addRange(0x16A6E, 0x16A6F).addRange(0x16B37, 0x16B3B).addRange(0x16E97, 0x16E9A).addRange(0x1DA87, 0x1DA8B).addRange(0x1E95E, 0x1E95F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Separator.js", function (module, exports) {
	  const set = regenerate(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000);
	set.addRange(0x2000, 0x200A).addRange(0x2028, 0x2029);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Space_Separator.js", function (module, exports) {
	  const set = regenerate(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000);
	set.addRange(0x2000, 0x200A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Spacing_Mark.js", function (module, exports) {
	  const set = regenerate(0x903, 0x93B, 0x9D7, 0xA03, 0xA83, 0xAC9, 0xB3E, 0xB40, 0xB57, 0xBD7, 0xCBE, 0xD57, 0xF7F, 0x1031, 0x1038, 0x108F, 0x1715, 0x1734, 0x17B6, 0x1A55, 0x1A57, 0x1A61, 0x1B04, 0x1B35, 0x1B3B, 0x1B82, 0x1BA1, 0x1BAA, 0x1BE7, 0x1BEE, 0x1CE1, 0x1CF7, 0xA827, 0xA983, 0xAA4D, 0xAA7B, 0xAA7D, 0xAAEB, 0xAAF5, 0xABEC, 0x11000, 0x11002, 0x11082, 0x1112C, 0x11182, 0x111CE, 0x11235, 0x11357, 0x11445, 0x114B9, 0x114C1, 0x115BE, 0x1163E, 0x116AC, 0x116B6, 0x11726, 0x11838, 0x1193D, 0x11940, 0x11942, 0x119E4, 0x11A39, 0x11A97, 0x11C2F, 0x11C3E, 0x11CA9, 0x11CB1, 0x11CB4, 0x11D96);
	set.addRange(0x93E, 0x940).addRange(0x949, 0x94C).addRange(0x94E, 0x94F).addRange(0x982, 0x983).addRange(0x9BE, 0x9C0).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CC).addRange(0xA3E, 0xA40).addRange(0xABE, 0xAC0).addRange(0xACB, 0xACC).addRange(0xB02, 0xB03).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4C).addRange(0xBBE, 0xBBF).addRange(0xBC1, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCC).addRange(0xC01, 0xC03).addRange(0xC41, 0xC44).addRange(0xC82, 0xC83).addRange(0xCC0, 0xCC4).addRange(0xCC7, 0xCC8).addRange(0xCCA, 0xCCB).addRange(0xCD5, 0xCD6).addRange(0xD02, 0xD03).addRange(0xD3E, 0xD40).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4C).addRange(0xD82, 0xD83).addRange(0xDCF, 0xDD1).addRange(0xDD8, 0xDDF).addRange(0xDF2, 0xDF3).addRange(0xF3E, 0xF3F).addRange(0x102B, 0x102C).addRange(0x103B, 0x103C).addRange(0x1056, 0x1057).addRange(0x1062, 0x1064).addRange(0x1067, 0x106D).addRange(0x1083, 0x1084).addRange(0x1087, 0x108C).addRange(0x109A, 0x109C).addRange(0x17BE, 0x17C5).addRange(0x17C7, 0x17C8).addRange(0x1923, 0x1926).addRange(0x1929, 0x192B).addRange(0x1930, 0x1931).addRange(0x1933, 0x1938).addRange(0x1A19, 0x1A1A).addRange(0x1A63, 0x1A64).addRange(0x1A6D, 0x1A72).addRange(0x1B3D, 0x1B41);
	set.addRange(0x1B43, 0x1B44).addRange(0x1BA6, 0x1BA7).addRange(0x1BEA, 0x1BEC).addRange(0x1BF2, 0x1BF3).addRange(0x1C24, 0x1C2B).addRange(0x1C34, 0x1C35).addRange(0x302E, 0x302F).addRange(0xA823, 0xA824).addRange(0xA880, 0xA881).addRange(0xA8B4, 0xA8C3).addRange(0xA952, 0xA953).addRange(0xA9B4, 0xA9B5).addRange(0xA9BA, 0xA9BB).addRange(0xA9BE, 0xA9C0).addRange(0xAA2F, 0xAA30).addRange(0xAA33, 0xAA34).addRange(0xAAEE, 0xAAEF).addRange(0xABE3, 0xABE4).addRange(0xABE6, 0xABE7).addRange(0xABE9, 0xABEA).addRange(0x110B0, 0x110B2).addRange(0x110B7, 0x110B8).addRange(0x11145, 0x11146).addRange(0x111B3, 0x111B5).addRange(0x111BF, 0x111C0).addRange(0x1122C, 0x1122E).addRange(0x11232, 0x11233).addRange(0x112E0, 0x112E2).addRange(0x11302, 0x11303).addRange(0x1133E, 0x1133F).addRange(0x11341, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x11362, 0x11363).addRange(0x11435, 0x11437).addRange(0x11440, 0x11441).addRange(0x114B0, 0x114B2).addRange(0x114BB, 0x114BE).addRange(0x115AF, 0x115B1).addRange(0x115B8, 0x115BB).addRange(0x11630, 0x11632).addRange(0x1163B, 0x1163C).addRange(0x116AE, 0x116AF).addRange(0x11720, 0x11721).addRange(0x1182C, 0x1182E).addRange(0x11930, 0x11935).addRange(0x11937, 0x11938).addRange(0x119D1, 0x119D3).addRange(0x119DC, 0x119DF).addRange(0x11A57, 0x11A58).addRange(0x11D8A, 0x11D8E);
	set.addRange(0x11D93, 0x11D94).addRange(0x11EF5, 0x11EF6).addRange(0x16F51, 0x16F87).addRange(0x16FF0, 0x16FF1).addRange(0x1D165, 0x1D166).addRange(0x1D16D, 0x1D172);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Surrogate.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xD800, 0xDFFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Symbol.js", function (module, exports) {
	  const set = regenerate(0x24, 0x2B, 0x5E, 0x60, 0x7C, 0x7E, 0xAC, 0xB4, 0xB8, 0xD7, 0xF7, 0x2ED, 0x375, 0x3F6, 0x482, 0x60B, 0x6DE, 0x6E9, 0x7F6, 0x888, 0xAF1, 0xB70, 0xC7F, 0xD4F, 0xD79, 0xE3F, 0xF13, 0xF34, 0xF36, 0xF38, 0x166D, 0x17DB, 0x1940, 0x1FBD, 0x2044, 0x2052, 0x2114, 0x2125, 0x2127, 0x2129, 0x212E, 0x214F, 0x3004, 0x3020, 0x3250, 0xAB5B, 0xFB29, 0xFDCF, 0xFE62, 0xFE69, 0xFF04, 0xFF0B, 0xFF3E, 0xFF40, 0xFF5C, 0xFF5E, 0x101A0, 0x10AC8, 0x1173F, 0x16B45, 0x1BC9C, 0x1D245, 0x1D6C1, 0x1D6DB, 0x1D6FB, 0x1D715, 0x1D735, 0x1D74F, 0x1D76F, 0x1D789, 0x1D7A9, 0x1D7C3, 0x1E14F, 0x1E2FF, 0x1ECAC, 0x1ECB0, 0x1ED2E, 0x1F7F0);
	set.addRange(0x3C, 0x3E).addRange(0xA2, 0xA6).addRange(0xA8, 0xA9).addRange(0xAE, 0xB1).addRange(0x2C2, 0x2C5).addRange(0x2D2, 0x2DF).addRange(0x2E5, 0x2EB).addRange(0x2EF, 0x2FF).addRange(0x384, 0x385).addRange(0x58D, 0x58F).addRange(0x606, 0x608).addRange(0x60E, 0x60F).addRange(0x6FD, 0x6FE).addRange(0x7FE, 0x7FF).addRange(0x9F2, 0x9F3).addRange(0x9FA, 0x9FB).addRange(0xBF3, 0xBFA).addRange(0xF01, 0xF03).addRange(0xF15, 0xF17).addRange(0xF1A, 0xF1F).addRange(0xFBE, 0xFC5).addRange(0xFC7, 0xFCC).addRange(0xFCE, 0xFCF).addRange(0xFD5, 0xFD8).addRange(0x109E, 0x109F).addRange(0x1390, 0x1399).addRange(0x19DE, 0x19FF).addRange(0x1B61, 0x1B6A).addRange(0x1B74, 0x1B7C).addRange(0x1FBF, 0x1FC1).addRange(0x1FCD, 0x1FCF).addRange(0x1FDD, 0x1FDF).addRange(0x1FED, 0x1FEF).addRange(0x1FFD, 0x1FFE).addRange(0x207A, 0x207C).addRange(0x208A, 0x208C).addRange(0x20A0, 0x20C0).addRange(0x2100, 0x2101).addRange(0x2103, 0x2106).addRange(0x2108, 0x2109).addRange(0x2116, 0x2118).addRange(0x211E, 0x2123).addRange(0x213A, 0x213B).addRange(0x2140, 0x2144).addRange(0x214A, 0x214D).addRange(0x218A, 0x218B).addRange(0x2190, 0x2307).addRange(0x230C, 0x2328).addRange(0x232B, 0x2426).addRange(0x2440, 0x244A).addRange(0x249C, 0x24E9);
	set.addRange(0x2500, 0x2767).addRange(0x2794, 0x27C4).addRange(0x27C7, 0x27E5).addRange(0x27F0, 0x2982).addRange(0x2999, 0x29D7).addRange(0x29DC, 0x29FB).addRange(0x29FE, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2BFF).addRange(0x2CE5, 0x2CEA).addRange(0x2E50, 0x2E51).addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x2FF0, 0x2FFB).addRange(0x3012, 0x3013).addRange(0x3036, 0x3037).addRange(0x303E, 0x303F).addRange(0x309B, 0x309C).addRange(0x3190, 0x3191).addRange(0x3196, 0x319F).addRange(0x31C0, 0x31E3).addRange(0x3200, 0x321E).addRange(0x322A, 0x3247).addRange(0x3260, 0x327F).addRange(0x328A, 0x32B0).addRange(0x32C0, 0x33FF).addRange(0x4DC0, 0x4DFF).addRange(0xA490, 0xA4C6).addRange(0xA700, 0xA716).addRange(0xA720, 0xA721).addRange(0xA789, 0xA78A).addRange(0xA828, 0xA82B).addRange(0xA836, 0xA839).addRange(0xAA77, 0xAA79).addRange(0xAB6A, 0xAB6B).addRange(0xFBB2, 0xFBC2).addRange(0xFD40, 0xFD4F).addRange(0xFDFC, 0xFDFF).addRange(0xFE64, 0xFE66).addRange(0xFF1C, 0xFF1E).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFFC, 0xFFFD).addRange(0x10137, 0x1013F).addRange(0x10179, 0x10189).addRange(0x1018C, 0x1018E).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x10877, 0x10878).addRange(0x11FD5, 0x11FF1);
	set.addRange(0x16B3C, 0x16B3F).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D164).addRange(0x1D16A, 0x1D16C).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D200, 0x1D241).addRange(0x1D300, 0x1D356).addRange(0x1D800, 0x1D9FF).addRange(0x1DA37, 0x1DA3A).addRange(0x1DA6D, 0x1DA74).addRange(0x1DA76, 0x1DA83).addRange(0x1DA85, 0x1DA86).addRange(0x1EEF0, 0x1EEF1).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F10D, 0x1F1AD).addRange(0x1F1E6, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DD, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F773).addRange(0x1F780, 0x1F7D8).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7);
	set.addRange(0x1FAF0, 0x1FAF6).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Titlecase_Letter.js", function (module, exports) {
	  const set = regenerate(0x1C5, 0x1C8, 0x1CB, 0x1F2, 0x1FBC, 0x1FCC, 0x1FFC);
	set.addRange(0x1F88, 0x1F8F).addRange(0x1F98, 0x1F9F).addRange(0x1FA8, 0x1FAF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Unassigned.js", function (module, exports) {
	  const set = regenerate(0x38B, 0x38D, 0x3A2, 0x530, 0x590, 0x70E, 0x83F, 0x85F, 0x88F, 0x984, 0x9A9, 0x9B1, 0x9DE, 0xA04, 0xA29, 0xA31, 0xA34, 0xA37, 0xA3D, 0xA5D, 0xA84, 0xA8E, 0xA92, 0xAA9, 0xAB1, 0xAB4, 0xAC6, 0xACA, 0xB00, 0xB04, 0xB29, 0xB31, 0xB34, 0xB5E, 0xB84, 0xB91, 0xB9B, 0xB9D, 0xBC9, 0xC0D, 0xC11, 0xC29, 0xC45, 0xC49, 0xC57, 0xC8D, 0xC91, 0xCA9, 0xCB4, 0xCC5, 0xCC9, 0xCDF, 0xCF0, 0xD0D, 0xD11, 0xD45, 0xD49, 0xD80, 0xD84, 0xDB2, 0xDBC, 0xDD5, 0xDD7, 0xE83, 0xE85, 0xE8B, 0xEA4, 0xEA6, 0xEC5, 0xEC7, 0xF48, 0xF98, 0xFBD, 0xFCD, 0x10C6, 0x1249, 0x1257, 0x1259, 0x1289, 0x12B1, 0x12BF, 0x12C1, 0x12D7, 0x1311, 0x176D, 0x1771, 0x191F, 0x1A5F, 0x1B7F, 0x1F58, 0x1F5A, 0x1F5C, 0x1F5E, 0x1FB5, 0x1FC5, 0x1FDC, 0x1FF5, 0x1FFF, 0x2065, 0x208F, 0x2B96, 0x2D26, 0x2DA7, 0x2DAF, 0x2DB7, 0x2DBF, 0x2DC7, 0x2DCF, 0x2DD7, 0x2DDF, 0x2E9A, 0x3040, 0x3130, 0x318F, 0x321F, 0xA7D2, 0xA7D4, 0xA9CE, 0xA9FF, 0xAB27, 0xAB2F, 0xFB37, 0xFB3D, 0xFB3F, 0xFB42, 0xFB45, 0xFE53, 0xFE67, 0xFE75, 0xFF00, 0xFFE7, 0x1000C, 0x10027, 0x1003B, 0x1003E, 0x1018F, 0x1039E, 0x1057B, 0x1058B, 0x10593, 0x10596, 0x105A2, 0x105B2, 0x105BA, 0x10786, 0x107B1, 0x10809, 0x10836, 0x10856, 0x108F3, 0x10A04, 0x10A14, 0x10A18, 0x10E7F, 0x10EAA, 0x11135, 0x111E0, 0x11212, 0x11287, 0x11289, 0x1128E, 0x1129E, 0x11304, 0x11329, 0x11331, 0x11334, 0x1133A, 0x1145C, 0x11914, 0x11917, 0x11936, 0x11C09, 0x11C37, 0x11CA8, 0x11D07, 0x11D0A, 0x11D3B, 0x11D3E, 0x11D66, 0x11D69, 0x11D8F, 0x11D92, 0x1246F, 0x1342F, 0x16A5F, 0x16ABF, 0x16B5A, 0x16B62, 0x1AFF4, 0x1AFFC, 0x1AFFF, 0x1D455, 0x1D49D, 0x1D4AD, 0x1D4BA, 0x1D4BC, 0x1D4C4, 0x1D506, 0x1D515, 0x1D51D, 0x1D53A, 0x1D53F, 0x1D545, 0x1D551, 0x1DAA0, 0x1E007, 0x1E022, 0x1E025, 0x1E7E7, 0x1E7EC, 0x1E7EF, 0x1E7FF, 0x1EE04, 0x1EE20, 0x1EE23, 0x1EE28, 0x1EE33, 0x1EE38, 0x1EE3A, 0x1EE48, 0x1EE4A, 0x1EE4C, 0x1EE50, 0x1EE53, 0x1EE58, 0x1EE5A, 0x1EE5C, 0x1EE5E, 0x1EE60, 0x1EE63, 0x1EE6B, 0x1EE73, 0x1EE78, 0x1EE7D, 0x1EE7F, 0x1EE8A, 0x1EEA4, 0x1EEAA, 0x1F0C0, 0x1F0D0, 0x1FB93);
	set.addRange(0x378, 0x379).addRange(0x380, 0x383).addRange(0x557, 0x558).addRange(0x58B, 0x58C).addRange(0x5C8, 0x5CF).addRange(0x5EB, 0x5EE).addRange(0x5F5, 0x5FF).addRange(0x74B, 0x74C).addRange(0x7B2, 0x7BF).addRange(0x7FB, 0x7FC).addRange(0x82E, 0x82F).addRange(0x85C, 0x85D).addRange(0x86B, 0x86F).addRange(0x892, 0x897).addRange(0x98D, 0x98E).addRange(0x991, 0x992).addRange(0x9B3, 0x9B5).addRange(0x9BA, 0x9BB).addRange(0x9C5, 0x9C6).addRange(0x9C9, 0x9CA).addRange(0x9CF, 0x9D6).addRange(0x9D8, 0x9DB).addRange(0x9E4, 0x9E5).addRange(0x9FF, 0xA00).addRange(0xA0B, 0xA0E).addRange(0xA11, 0xA12).addRange(0xA3A, 0xA3B).addRange(0xA43, 0xA46).addRange(0xA49, 0xA4A).addRange(0xA4E, 0xA50).addRange(0xA52, 0xA58).addRange(0xA5F, 0xA65).addRange(0xA77, 0xA80).addRange(0xABA, 0xABB).addRange(0xACE, 0xACF).addRange(0xAD1, 0xADF).addRange(0xAE4, 0xAE5).addRange(0xAF2, 0xAF8).addRange(0xB0D, 0xB0E).addRange(0xB11, 0xB12).addRange(0xB3A, 0xB3B).addRange(0xB45, 0xB46).addRange(0xB49, 0xB4A).addRange(0xB4E, 0xB54).addRange(0xB58, 0xB5B).addRange(0xB64, 0xB65).addRange(0xB78, 0xB81).addRange(0xB8B, 0xB8D).addRange(0xB96, 0xB98).addRange(0xBA0, 0xBA2).addRange(0xBA5, 0xBA7);
	set.addRange(0xBAB, 0xBAD).addRange(0xBBA, 0xBBD).addRange(0xBC3, 0xBC5).addRange(0xBCE, 0xBCF).addRange(0xBD1, 0xBD6).addRange(0xBD8, 0xBE5).addRange(0xBFB, 0xBFF).addRange(0xC3A, 0xC3B).addRange(0xC4E, 0xC54).addRange(0xC5B, 0xC5C).addRange(0xC5E, 0xC5F).addRange(0xC64, 0xC65).addRange(0xC70, 0xC76).addRange(0xCBA, 0xCBB).addRange(0xCCE, 0xCD4).addRange(0xCD7, 0xCDC).addRange(0xCE4, 0xCE5).addRange(0xCF3, 0xCFF).addRange(0xD50, 0xD53).addRange(0xD64, 0xD65).addRange(0xD97, 0xD99).addRange(0xDBE, 0xDBF).addRange(0xDC7, 0xDC9).addRange(0xDCB, 0xDCE).addRange(0xDE0, 0xDE5).addRange(0xDF0, 0xDF1).addRange(0xDF5, 0xE00).addRange(0xE3B, 0xE3E).addRange(0xE5C, 0xE80).addRange(0xEBE, 0xEBF).addRange(0xECE, 0xECF).addRange(0xEDA, 0xEDB).addRange(0xEE0, 0xEFF).addRange(0xF6D, 0xF70).addRange(0xFDB, 0xFFF).addRange(0x10C8, 0x10CC).addRange(0x10CE, 0x10CF).addRange(0x124E, 0x124F).addRange(0x125E, 0x125F).addRange(0x128E, 0x128F).addRange(0x12B6, 0x12B7).addRange(0x12C6, 0x12C7).addRange(0x1316, 0x1317).addRange(0x135B, 0x135C).addRange(0x137D, 0x137F).addRange(0x139A, 0x139F).addRange(0x13F6, 0x13F7).addRange(0x13FE, 0x13FF).addRange(0x169D, 0x169F).addRange(0x16F9, 0x16FF).addRange(0x1716, 0x171E);
	set.addRange(0x1737, 0x173F).addRange(0x1754, 0x175F).addRange(0x1774, 0x177F).addRange(0x17DE, 0x17DF).addRange(0x17EA, 0x17EF).addRange(0x17FA, 0x17FF).addRange(0x181A, 0x181F).addRange(0x1879, 0x187F).addRange(0x18AB, 0x18AF).addRange(0x18F6, 0x18FF).addRange(0x192C, 0x192F).addRange(0x193C, 0x193F).addRange(0x1941, 0x1943).addRange(0x196E, 0x196F).addRange(0x1975, 0x197F).addRange(0x19AC, 0x19AF).addRange(0x19CA, 0x19CF).addRange(0x19DB, 0x19DD).addRange(0x1A1C, 0x1A1D).addRange(0x1A7D, 0x1A7E).addRange(0x1A8A, 0x1A8F).addRange(0x1A9A, 0x1A9F).addRange(0x1AAE, 0x1AAF).addRange(0x1ACF, 0x1AFF).addRange(0x1B4D, 0x1B4F).addRange(0x1BF4, 0x1BFB).addRange(0x1C38, 0x1C3A).addRange(0x1C4A, 0x1C4C).addRange(0x1C89, 0x1C8F).addRange(0x1CBB, 0x1CBC).addRange(0x1CC8, 0x1CCF).addRange(0x1CFB, 0x1CFF).addRange(0x1F16, 0x1F17).addRange(0x1F1E, 0x1F1F).addRange(0x1F46, 0x1F47).addRange(0x1F4E, 0x1F4F).addRange(0x1F7E, 0x1F7F).addRange(0x1FD4, 0x1FD5).addRange(0x1FF0, 0x1FF1).addRange(0x2072, 0x2073).addRange(0x209D, 0x209F).addRange(0x20C1, 0x20CF).addRange(0x20F1, 0x20FF).addRange(0x218C, 0x218F).addRange(0x2427, 0x243F).addRange(0x244B, 0x245F).addRange(0x2B74, 0x2B75).addRange(0x2CF4, 0x2CF8).addRange(0x2D28, 0x2D2C).addRange(0x2D2E, 0x2D2F).addRange(0x2D68, 0x2D6E);
	set.addRange(0x2D71, 0x2D7E).addRange(0x2D97, 0x2D9F).addRange(0x2E5E, 0x2E7F).addRange(0x2EF4, 0x2EFF).addRange(0x2FD6, 0x2FEF).addRange(0x2FFC, 0x2FFF).addRange(0x3097, 0x3098).addRange(0x3100, 0x3104).addRange(0x31E4, 0x31EF).addRange(0xA48D, 0xA48F).addRange(0xA4C7, 0xA4CF).addRange(0xA62C, 0xA63F).addRange(0xA6F8, 0xA6FF).addRange(0xA7CB, 0xA7CF).addRange(0xA7DA, 0xA7F1).addRange(0xA82D, 0xA82F).addRange(0xA83A, 0xA83F).addRange(0xA878, 0xA87F).addRange(0xA8C6, 0xA8CD).addRange(0xA8DA, 0xA8DF).addRange(0xA954, 0xA95E).addRange(0xA97D, 0xA97F).addRange(0xA9DA, 0xA9DD).addRange(0xAA37, 0xAA3F).addRange(0xAA4E, 0xAA4F).addRange(0xAA5A, 0xAA5B).addRange(0xAAC3, 0xAADA).addRange(0xAAF7, 0xAB00).addRange(0xAB07, 0xAB08).addRange(0xAB0F, 0xAB10).addRange(0xAB17, 0xAB1F).addRange(0xAB6C, 0xAB6F).addRange(0xABEE, 0xABEF).addRange(0xABFA, 0xABFF).addRange(0xD7A4, 0xD7AF).addRange(0xD7C7, 0xD7CA).addRange(0xD7FC, 0xD7FF).addRange(0xFA6E, 0xFA6F).addRange(0xFADA, 0xFAFF).addRange(0xFB07, 0xFB12).addRange(0xFB18, 0xFB1C).addRange(0xFBC3, 0xFBD2).addRange(0xFD90, 0xFD91).addRange(0xFDC8, 0xFDCE).addRange(0xFDD0, 0xFDEF).addRange(0xFE1A, 0xFE1F).addRange(0xFE6C, 0xFE6F).addRange(0xFEFD, 0xFEFE).addRange(0xFFBF, 0xFFC1).addRange(0xFFC8, 0xFFC9).addRange(0xFFD0, 0xFFD1);
	set.addRange(0xFFD8, 0xFFD9).addRange(0xFFDD, 0xFFDF).addRange(0xFFEF, 0xFFF8).addRange(0xFFFE, 0xFFFF).addRange(0x1004E, 0x1004F).addRange(0x1005E, 0x1007F).addRange(0x100FB, 0x100FF).addRange(0x10103, 0x10106).addRange(0x10134, 0x10136).addRange(0x1019D, 0x1019F).addRange(0x101A1, 0x101CF).addRange(0x101FE, 0x1027F).addRange(0x1029D, 0x1029F).addRange(0x102D1, 0x102DF).addRange(0x102FC, 0x102FF).addRange(0x10324, 0x1032C).addRange(0x1034B, 0x1034F).addRange(0x1037B, 0x1037F).addRange(0x103C4, 0x103C7).addRange(0x103D6, 0x103FF).addRange(0x1049E, 0x1049F).addRange(0x104AA, 0x104AF).addRange(0x104D4, 0x104D7).addRange(0x104FC, 0x104FF).addRange(0x10528, 0x1052F).addRange(0x10564, 0x1056E).addRange(0x105BD, 0x105FF).addRange(0x10737, 0x1073F).addRange(0x10756, 0x1075F).addRange(0x10768, 0x1077F).addRange(0x107BB, 0x107FF).addRange(0x10806, 0x10807).addRange(0x10839, 0x1083B).addRange(0x1083D, 0x1083E).addRange(0x1089F, 0x108A6).addRange(0x108B0, 0x108DF).addRange(0x108F6, 0x108FA).addRange(0x1091C, 0x1091E).addRange(0x1093A, 0x1093E).addRange(0x10940, 0x1097F).addRange(0x109B8, 0x109BB).addRange(0x109D0, 0x109D1).addRange(0x10A07, 0x10A0B).addRange(0x10A36, 0x10A37).addRange(0x10A3B, 0x10A3E).addRange(0x10A49, 0x10A4F).addRange(0x10A59, 0x10A5F).addRange(0x10AA0, 0x10ABF).addRange(0x10AE7, 0x10AEA).addRange(0x10AF7, 0x10AFF).addRange(0x10B36, 0x10B38);
	set.addRange(0x10B56, 0x10B57).addRange(0x10B73, 0x10B77).addRange(0x10B92, 0x10B98).addRange(0x10B9D, 0x10BA8).addRange(0x10BB0, 0x10BFF).addRange(0x10C49, 0x10C7F).addRange(0x10CB3, 0x10CBF).addRange(0x10CF3, 0x10CF9).addRange(0x10D28, 0x10D2F).addRange(0x10D3A, 0x10E5F).addRange(0x10EAE, 0x10EAF).addRange(0x10EB2, 0x10EFF).addRange(0x10F28, 0x10F2F).addRange(0x10F5A, 0x10F6F).addRange(0x10F8A, 0x10FAF).addRange(0x10FCC, 0x10FDF).addRange(0x10FF7, 0x10FFF).addRange(0x1104E, 0x11051).addRange(0x11076, 0x1107E).addRange(0x110C3, 0x110CC).addRange(0x110CE, 0x110CF).addRange(0x110E9, 0x110EF).addRange(0x110FA, 0x110FF).addRange(0x11148, 0x1114F).addRange(0x11177, 0x1117F).addRange(0x111F5, 0x111FF).addRange(0x1123F, 0x1127F).addRange(0x112AA, 0x112AF).addRange(0x112EB, 0x112EF).addRange(0x112FA, 0x112FF).addRange(0x1130D, 0x1130E).addRange(0x11311, 0x11312).addRange(0x11345, 0x11346).addRange(0x11349, 0x1134A).addRange(0x1134E, 0x1134F).addRange(0x11351, 0x11356).addRange(0x11358, 0x1135C).addRange(0x11364, 0x11365).addRange(0x1136D, 0x1136F).addRange(0x11375, 0x113FF).addRange(0x11462, 0x1147F).addRange(0x114C8, 0x114CF).addRange(0x114DA, 0x1157F).addRange(0x115B6, 0x115B7).addRange(0x115DE, 0x115FF).addRange(0x11645, 0x1164F).addRange(0x1165A, 0x1165F).addRange(0x1166D, 0x1167F).addRange(0x116BA, 0x116BF).addRange(0x116CA, 0x116FF).addRange(0x1171B, 0x1171C);
	set.addRange(0x1172C, 0x1172F).addRange(0x11747, 0x117FF).addRange(0x1183C, 0x1189F).addRange(0x118F3, 0x118FE).addRange(0x11907, 0x11908).addRange(0x1190A, 0x1190B).addRange(0x11939, 0x1193A).addRange(0x11947, 0x1194F).addRange(0x1195A, 0x1199F).addRange(0x119A8, 0x119A9).addRange(0x119D8, 0x119D9).addRange(0x119E5, 0x119FF).addRange(0x11A48, 0x11A4F).addRange(0x11AA3, 0x11AAF).addRange(0x11AF9, 0x11BFF).addRange(0x11C46, 0x11C4F).addRange(0x11C6D, 0x11C6F).addRange(0x11C90, 0x11C91).addRange(0x11CB7, 0x11CFF).addRange(0x11D37, 0x11D39).addRange(0x11D48, 0x11D4F).addRange(0x11D5A, 0x11D5F).addRange(0x11D99, 0x11D9F).addRange(0x11DAA, 0x11EDF).addRange(0x11EF9, 0x11FAF).addRange(0x11FB1, 0x11FBF).addRange(0x11FF2, 0x11FFE).addRange(0x1239A, 0x123FF).addRange(0x12475, 0x1247F).addRange(0x12544, 0x12F8F).addRange(0x12FF3, 0x12FFF).addRange(0x13439, 0x143FF).addRange(0x14647, 0x167FF).addRange(0x16A39, 0x16A3F).addRange(0x16A6A, 0x16A6D).addRange(0x16ACA, 0x16ACF).addRange(0x16AEE, 0x16AEF).addRange(0x16AF6, 0x16AFF).addRange(0x16B46, 0x16B4F).addRange(0x16B78, 0x16B7C).addRange(0x16B90, 0x16E3F).addRange(0x16E9B, 0x16EFF).addRange(0x16F4B, 0x16F4E).addRange(0x16F88, 0x16F8E).addRange(0x16FA0, 0x16FDF).addRange(0x16FE5, 0x16FEF).addRange(0x16FF2, 0x16FFF).addRange(0x187F8, 0x187FF).addRange(0x18CD6, 0x18CFF).addRange(0x18D09, 0x1AFEF).addRange(0x1B123, 0x1B14F);
	set.addRange(0x1B153, 0x1B163).addRange(0x1B168, 0x1B16F).addRange(0x1B2FC, 0x1BBFF).addRange(0x1BC6B, 0x1BC6F).addRange(0x1BC7D, 0x1BC7F).addRange(0x1BC89, 0x1BC8F).addRange(0x1BC9A, 0x1BC9B).addRange(0x1BCA4, 0x1CEFF).addRange(0x1CF2E, 0x1CF2F).addRange(0x1CF47, 0x1CF4F).addRange(0x1CFC4, 0x1CFFF).addRange(0x1D0F6, 0x1D0FF).addRange(0x1D127, 0x1D128).addRange(0x1D1EB, 0x1D1FF).addRange(0x1D246, 0x1D2DF).addRange(0x1D2F4, 0x1D2FF).addRange(0x1D357, 0x1D35F).addRange(0x1D379, 0x1D3FF).addRange(0x1D4A0, 0x1D4A1).addRange(0x1D4A3, 0x1D4A4).addRange(0x1D4A7, 0x1D4A8).addRange(0x1D50B, 0x1D50C).addRange(0x1D547, 0x1D549).addRange(0x1D6A6, 0x1D6A7).addRange(0x1D7CC, 0x1D7CD).addRange(0x1DA8C, 0x1DA9A).addRange(0x1DAB0, 0x1DEFF).addRange(0x1DF1F, 0x1DFFF).addRange(0x1E019, 0x1E01A).addRange(0x1E02B, 0x1E0FF).addRange(0x1E12D, 0x1E12F).addRange(0x1E13E, 0x1E13F).addRange(0x1E14A, 0x1E14D).addRange(0x1E150, 0x1E28F).addRange(0x1E2AF, 0x1E2BF).addRange(0x1E2FA, 0x1E2FE).addRange(0x1E300, 0x1E7DF).addRange(0x1E8C5, 0x1E8C6).addRange(0x1E8D7, 0x1E8FF).addRange(0x1E94C, 0x1E94F).addRange(0x1E95A, 0x1E95D).addRange(0x1E960, 0x1EC70).addRange(0x1ECB5, 0x1ED00).addRange(0x1ED3E, 0x1EDFF).addRange(0x1EE25, 0x1EE26).addRange(0x1EE3C, 0x1EE41).addRange(0x1EE43, 0x1EE46).addRange(0x1EE55, 0x1EE56).addRange(0x1EE65, 0x1EE66).addRange(0x1EE9C, 0x1EEA0).addRange(0x1EEBC, 0x1EEEF);
	set.addRange(0x1EEF2, 0x1EFFF).addRange(0x1F02C, 0x1F02F).addRange(0x1F094, 0x1F09F).addRange(0x1F0AF, 0x1F0B0).addRange(0x1F0F6, 0x1F0FF).addRange(0x1F1AE, 0x1F1E5).addRange(0x1F203, 0x1F20F).addRange(0x1F23C, 0x1F23F).addRange(0x1F249, 0x1F24F).addRange(0x1F252, 0x1F25F).addRange(0x1F266, 0x1F2FF).addRange(0x1F6D8, 0x1F6DC).addRange(0x1F6ED, 0x1F6EF).addRange(0x1F6FD, 0x1F6FF).addRange(0x1F774, 0x1F77F).addRange(0x1F7D9, 0x1F7DF).addRange(0x1F7EC, 0x1F7EF).addRange(0x1F7F1, 0x1F7FF).addRange(0x1F80C, 0x1F80F).addRange(0x1F848, 0x1F84F).addRange(0x1F85A, 0x1F85F).addRange(0x1F888, 0x1F88F).addRange(0x1F8AE, 0x1F8AF).addRange(0x1F8B2, 0x1F8FF).addRange(0x1FA54, 0x1FA5F).addRange(0x1FA6E, 0x1FA6F).addRange(0x1FA75, 0x1FA77).addRange(0x1FA7D, 0x1FA7F).addRange(0x1FA87, 0x1FA8F).addRange(0x1FAAD, 0x1FAAF).addRange(0x1FABB, 0x1FABF).addRange(0x1FAC6, 0x1FACF).addRange(0x1FADA, 0x1FADF).addRange(0x1FAE8, 0x1FAEF).addRange(0x1FAF7, 0x1FAFF).addRange(0x1FBCB, 0x1FBEF).addRange(0x1FBFA, 0x1FFFF).addRange(0x2A6E0, 0x2A6FF).addRange(0x2B739, 0x2B73F).addRange(0x2B81E, 0x2B81F).addRange(0x2CEA2, 0x2CEAF).addRange(0x2EBE1, 0x2F7FF).addRange(0x2FA1E, 0x2FFFF).addRange(0x3134B, 0xE0000).addRange(0xE0002, 0xE001F).addRange(0xE0080, 0xE00FF).addRange(0xE01F0, 0xEFFFF).addRange(0xFFFFE, 0xFFFFF).addRange(0x10FFFE, 0x10FFFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/General_Category/Uppercase_Letter.js", function (module, exports) {
	  const set = regenerate(0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14A, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1C4, 0x1C7, 0x1CA, 0x1CD, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1F1, 0x1F4, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x370, 0x372, 0x376, 0x37F, 0x386, 0x38C, 0x3CF, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F4, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x10C7, 0x10CD, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x2145, 0x2183, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xA7F5, 0x1D49C, 0x1D4A2, 0x1D546, 0x1D7CA);
	set.addRange(0x41, 0x5A).addRange(0xC0, 0xD6).addRange(0xD8, 0xDE).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x388, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3D2, 0x3D4).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x10A0, 0x10C5).addRange(0x13A0, 0x13F5).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1FB8, 0x1FBB).addRange(0x1FC8, 0x1FCB).addRange(0x1FD8, 0x1FDB).addRange(0x1FE8, 0x1FEC).addRange(0x1FF8, 0x1FFB).addRange(0x210B, 0x210D).addRange(0x2110, 0x2112).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x2130, 0x2133).addRange(0x213E, 0x213F).addRange(0x2C00, 0x2C2F);
	set.addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7E, 0x2C80).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xFF21, 0xFF3A).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1D400, 0x1D419).addRange(0x1D434, 0x1D44D).addRange(0x1D468, 0x1D481).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B5).addRange(0x1D4D0, 0x1D4E9).addRange(0x1D504, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D538, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D56C, 0x1D585).addRange(0x1D5A0, 0x1D5B9).addRange(0x1D5D4, 0x1D5ED).addRange(0x1D608, 0x1D621).addRange(0x1D63C, 0x1D655).addRange(0x1D670, 0x1D689).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6E2, 0x1D6FA).addRange(0x1D71C, 0x1D734).addRange(0x1D756, 0x1D76E).addRange(0x1D790, 0x1D7A8).addRange(0x1E900, 0x1E921);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/index.js", function (module, exports) {
	  module.exports = new Map([
		['General_Category', [
			'Cased_Letter',
			'Close_Punctuation',
			'Connector_Punctuation',
			'Control',
			'Currency_Symbol',
			'Dash_Punctuation',
			'Decimal_Number',
			'Enclosing_Mark',
			'Final_Punctuation',
			'Format',
			'Initial_Punctuation',
			'Letter',
			'Letter_Number',
			'Line_Separator',
			'Lowercase_Letter',
			'Mark',
			'Math_Symbol',
			'Modifier_Letter',
			'Modifier_Symbol',
			'Nonspacing_Mark',
			'Number',
			'Open_Punctuation',
			'Other',
			'Other_Letter',
			'Other_Number',
			'Other_Punctuation',
			'Other_Symbol',
			'Paragraph_Separator',
			'Private_Use',
			'Punctuation',
			'Separator',
			'Space_Separator',
			'Spacing_Mark',
			'Surrogate',
			'Symbol',
			'Titlecase_Letter',
			'Unassigned',
			'Uppercase_Letter'
		]],
		['Script', [
			'Adlam',
			'Ahom',
			'Anatolian_Hieroglyphs',
			'Arabic',
			'Armenian',
			'Avestan',
			'Balinese',
			'Bamum',
			'Bassa_Vah',
			'Batak',
			'Bengali',
			'Bhaiksuki',
			'Bopomofo',
			'Brahmi',
			'Braille',
			'Buginese',
			'Buhid',
			'Canadian_Aboriginal',
			'Carian',
			'Caucasian_Albanian',
			'Chakma',
			'Cham',
			'Cherokee',
			'Chorasmian',
			'Common',
			'Coptic',
			'Cuneiform',
			'Cypriot',
			'Cypro_Minoan',
			'Cyrillic',
			'Deseret',
			'Devanagari',
			'Dives_Akuru',
			'Dogra',
			'Duployan',
			'Egyptian_Hieroglyphs',
			'Elbasan',
			'Elymaic',
			'Ethiopic',
			'Georgian',
			'Glagolitic',
			'Gothic',
			'Grantha',
			'Greek',
			'Gujarati',
			'Gunjala_Gondi',
			'Gurmukhi',
			'Han',
			'Hangul',
			'Hanifi_Rohingya',
			'Hanunoo',
			'Hatran',
			'Hebrew',
			'Hiragana',
			'Imperial_Aramaic',
			'Inherited',
			'Inscriptional_Pahlavi',
			'Inscriptional_Parthian',
			'Javanese',
			'Kaithi',
			'Kannada',
			'Katakana',
			'Kayah_Li',
			'Kharoshthi',
			'Khitan_Small_Script',
			'Khmer',
			'Khojki',
			'Khudawadi',
			'Lao',
			'Latin',
			'Lepcha',
			'Limbu',
			'Linear_A',
			'Linear_B',
			'Lisu',
			'Lycian',
			'Lydian',
			'Mahajani',
			'Makasar',
			'Malayalam',
			'Mandaic',
			'Manichaean',
			'Marchen',
			'Masaram_Gondi',
			'Medefaidrin',
			'Meetei_Mayek',
			'Mende_Kikakui',
			'Meroitic_Cursive',
			'Meroitic_Hieroglyphs',
			'Miao',
			'Modi',
			'Mongolian',
			'Mro',
			'Multani',
			'Myanmar',
			'Nabataean',
			'Nandinagari',
			'New_Tai_Lue',
			'Newa',
			'Nko',
			'Nushu',
			'Nyiakeng_Puachue_Hmong',
			'Ogham',
			'Ol_Chiki',
			'Old_Hungarian',
			'Old_Italic',
			'Old_North_Arabian',
			'Old_Permic',
			'Old_Persian',
			'Old_Sogdian',
			'Old_South_Arabian',
			'Old_Turkic',
			'Old_Uyghur',
			'Oriya',
			'Osage',
			'Osmanya',
			'Pahawh_Hmong',
			'Palmyrene',
			'Pau_Cin_Hau',
			'Phags_Pa',
			'Phoenician',
			'Psalter_Pahlavi',
			'Rejang',
			'Runic',
			'Samaritan',
			'Saurashtra',
			'Sharada',
			'Shavian',
			'Siddham',
			'SignWriting',
			'Sinhala',
			'Sogdian',
			'Sora_Sompeng',
			'Soyombo',
			'Sundanese',
			'Syloti_Nagri',
			'Syriac',
			'Tagalog',
			'Tagbanwa',
			'Tai_Le',
			'Tai_Tham',
			'Tai_Viet',
			'Takri',
			'Tamil',
			'Tangsa',
			'Tangut',
			'Telugu',
			'Thaana',
			'Thai',
			'Tibetan',
			'Tifinagh',
			'Tirhuta',
			'Toto',
			'Ugaritic',
			'Vai',
			'Vithkuqi',
			'Wancho',
			'Warang_Citi',
			'Yezidi',
			'Yi',
			'Zanabazar_Square'
		]],
		['Script_Extensions', [
			'Adlam',
			'Ahom',
			'Anatolian_Hieroglyphs',
			'Arabic',
			'Armenian',
			'Avestan',
			'Balinese',
			'Bamum',
			'Bassa_Vah',
			'Batak',
			'Bengali',
			'Bhaiksuki',
			'Bopomofo',
			'Brahmi',
			'Braille',
			'Buginese',
			'Buhid',
			'Canadian_Aboriginal',
			'Carian',
			'Caucasian_Albanian',
			'Chakma',
			'Cham',
			'Cherokee',
			'Chorasmian',
			'Common',
			'Coptic',
			'Cuneiform',
			'Cypriot',
			'Cypro_Minoan',
			'Cyrillic',
			'Deseret',
			'Devanagari',
			'Dives_Akuru',
			'Dogra',
			'Duployan',
			'Egyptian_Hieroglyphs',
			'Elbasan',
			'Elymaic',
			'Ethiopic',
			'Georgian',
			'Glagolitic',
			'Gothic',
			'Grantha',
			'Greek',
			'Gujarati',
			'Gunjala_Gondi',
			'Gurmukhi',
			'Han',
			'Hangul',
			'Hanifi_Rohingya',
			'Hanunoo',
			'Hatran',
			'Hebrew',
			'Hiragana',
			'Imperial_Aramaic',
			'Inherited',
			'Inscriptional_Pahlavi',
			'Inscriptional_Parthian',
			'Javanese',
			'Kaithi',
			'Kannada',
			'Katakana',
			'Kayah_Li',
			'Kharoshthi',
			'Khitan_Small_Script',
			'Khmer',
			'Khojki',
			'Khudawadi',
			'Lao',
			'Latin',
			'Lepcha',
			'Limbu',
			'Linear_A',
			'Linear_B',
			'Lisu',
			'Lycian',
			'Lydian',
			'Mahajani',
			'Makasar',
			'Malayalam',
			'Mandaic',
			'Manichaean',
			'Marchen',
			'Masaram_Gondi',
			'Medefaidrin',
			'Meetei_Mayek',
			'Mende_Kikakui',
			'Meroitic_Cursive',
			'Meroitic_Hieroglyphs',
			'Miao',
			'Modi',
			'Mongolian',
			'Mro',
			'Multani',
			'Myanmar',
			'Nabataean',
			'Nandinagari',
			'New_Tai_Lue',
			'Newa',
			'Nko',
			'Nushu',
			'Nyiakeng_Puachue_Hmong',
			'Ogham',
			'Ol_Chiki',
			'Old_Hungarian',
			'Old_Italic',
			'Old_North_Arabian',
			'Old_Permic',
			'Old_Persian',
			'Old_Sogdian',
			'Old_South_Arabian',
			'Old_Turkic',
			'Old_Uyghur',
			'Oriya',
			'Osage',
			'Osmanya',
			'Pahawh_Hmong',
			'Palmyrene',
			'Pau_Cin_Hau',
			'Phags_Pa',
			'Phoenician',
			'Psalter_Pahlavi',
			'Rejang',
			'Runic',
			'Samaritan',
			'Saurashtra',
			'Sharada',
			'Shavian',
			'Siddham',
			'SignWriting',
			'Sinhala',
			'Sogdian',
			'Sora_Sompeng',
			'Soyombo',
			'Sundanese',
			'Syloti_Nagri',
			'Syriac',
			'Tagalog',
			'Tagbanwa',
			'Tai_Le',
			'Tai_Tham',
			'Tai_Viet',
			'Takri',
			'Tamil',
			'Tangsa',
			'Tangut',
			'Telugu',
			'Thaana',
			'Thai',
			'Tibetan',
			'Tifinagh',
			'Tirhuta',
			'Toto',
			'Ugaritic',
			'Vai',
			'Vithkuqi',
			'Wancho',
			'Warang_Citi',
			'Yezidi',
			'Yi',
			'Zanabazar_Square'
		]],
		['Binary_Property', [
			'ASCII',
			'ASCII_Hex_Digit',
			'Alphabetic',
			'Any',
			'Assigned',
			'Bidi_Control',
			'Bidi_Mirrored',
			'Case_Ignorable',
			'Cased',
			'Changes_When_Casefolded',
			'Changes_When_Casemapped',
			'Changes_When_Lowercased',
			'Changes_When_NFKC_Casefolded',
			'Changes_When_Titlecased',
			'Changes_When_Uppercased',
			'Dash',
			'Default_Ignorable_Code_Point',
			'Deprecated',
			'Diacritic',
			'Emoji',
			'Emoji_Component',
			'Emoji_Modifier',
			'Emoji_Modifier_Base',
			'Emoji_Presentation',
			'Extended_Pictographic',
			'Extender',
			'Grapheme_Base',
			'Grapheme_Extend',
			'Hex_Digit',
			'IDS_Binary_Operator',
			'IDS_Trinary_Operator',
			'ID_Continue',
			'ID_Start',
			'Ideographic',
			'Join_Control',
			'Logical_Order_Exception',
			'Lowercase',
			'Math',
			'Noncharacter_Code_Point',
			'Pattern_Syntax',
			'Pattern_White_Space',
			'Quotation_Mark',
			'Radical',
			'Regional_Indicator',
			'Sentence_Terminal',
			'Soft_Dotted',
			'Terminal_Punctuation',
			'Unified_Ideograph',
			'Uppercase',
			'Variation_Selector',
			'White_Space',
			'XID_Continue',
			'XID_Start'
		]],
		['Property_of_Strings', [
			'Basic_Emoji',
			'Emoji_Keycap_Sequence',
			'RGI_Emoji',
			'RGI_Emoji_Flag_Sequence',
			'RGI_Emoji_Modifier_Sequence',
			'RGI_Emoji_Tag_Sequence',
			'RGI_Emoji_ZWJ_Sequence'
		]]
	]);

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Property_of_Strings/Basic_Emoji.js", function (module, exports) {
	  const set = regenerate(0x23F0, 0x23F3, 0x267F, 0x2693, 0x26A1, 0x26CE, 0x26D4, 0x26EA, 0x26F5, 0x26FA, 0x26FD, 0x2705, 0x2728, 0x274C, 0x274E, 0x2757, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x1F004, 0x1F0CF, 0x1F18E, 0x1F201, 0x1F21A, 0x1F22F, 0x1F3F4, 0x1F440, 0x1F57A, 0x1F5A4, 0x1F6CC, 0x1F7F0);
	set.addRange(0x231A, 0x231B).addRange(0x23E9, 0x23EC).addRange(0x25FD, 0x25FE).addRange(0x2614, 0x2615).addRange(0x2648, 0x2653).addRange(0x26AA, 0x26AB).addRange(0x26BD, 0x26BE).addRange(0x26C4, 0x26C5).addRange(0x26F2, 0x26F3).addRange(0x270A, 0x270B).addRange(0x2753, 0x2755).addRange(0x2795, 0x2797).addRange(0x2B1B, 0x2B1C).addRange(0x1F191, 0x1F19A).addRange(0x1F232, 0x1F236).addRange(0x1F238, 0x1F23A).addRange(0x1F250, 0x1F251).addRange(0x1F300, 0x1F320).addRange(0x1F32D, 0x1F335).addRange(0x1F337, 0x1F37C).addRange(0x1F37E, 0x1F393).addRange(0x1F3A0, 0x1F3CA).addRange(0x1F3CF, 0x1F3D3).addRange(0x1F3E0, 0x1F3F0).addRange(0x1F3F8, 0x1F43E).addRange(0x1F442, 0x1F4FC).addRange(0x1F4FF, 0x1F53D).addRange(0x1F54B, 0x1F54E).addRange(0x1F550, 0x1F567).addRange(0x1F595, 0x1F596).addRange(0x1F5FB, 0x1F64F).addRange(0x1F680, 0x1F6C5).addRange(0x1F6D0, 0x1F6D2).addRange(0x1F6D5, 0x1F6D7).addRange(0x1F6DD, 0x1F6DF).addRange(0x1F6EB, 0x1F6EC).addRange(0x1F6F4, 0x1F6FC).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1F9FF).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6);
	exports.characters = set;
	exports.strings = ['\xA9\uFE0F','\xAE\uFE0F','\u203C\uFE0F','\u2049\uFE0F','\u2122\uFE0F','\u2139\uFE0F','\u2194\uFE0F','\u2195\uFE0F','\u2196\uFE0F','\u2197\uFE0F','\u2198\uFE0F','\u2199\uFE0F','\u21A9\uFE0F','\u21AA\uFE0F','\u2328\uFE0F','\u23CF\uFE0F','\u23ED\uFE0F','\u23EE\uFE0F','\u23EF\uFE0F','\u23F1\uFE0F','\u23F2\uFE0F','\u23F8\uFE0F','\u23F9\uFE0F','\u23FA\uFE0F','\u24C2\uFE0F','\u25AA\uFE0F','\u25AB\uFE0F','\u25B6\uFE0F','\u25C0\uFE0F','\u25FB\uFE0F','\u25FC\uFE0F','\u2600\uFE0F','\u2601\uFE0F','\u2602\uFE0F','\u2603\uFE0F','\u2604\uFE0F','\u260E\uFE0F','\u2611\uFE0F','\u2618\uFE0F','\u261D\uFE0F','\u2620\uFE0F','\u2622\uFE0F','\u2623\uFE0F','\u2626\uFE0F','\u262A\uFE0F','\u262E\uFE0F','\u262F\uFE0F','\u2638\uFE0F','\u2639\uFE0F','\u263A\uFE0F','\u2640\uFE0F','\u2642\uFE0F','\u265F\uFE0F','\u2660\uFE0F','\u2663\uFE0F','\u2665\uFE0F','\u2666\uFE0F','\u2668\uFE0F','\u267B\uFE0F','\u267E\uFE0F','\u2692\uFE0F','\u2694\uFE0F','\u2695\uFE0F','\u2696\uFE0F','\u2697\uFE0F','\u2699\uFE0F','\u269B\uFE0F','\u269C\uFE0F','\u26A0\uFE0F','\u26A7\uFE0F','\u26B0\uFE0F','\u26B1\uFE0F','\u26C8\uFE0F','\u26CF\uFE0F','\u26D1\uFE0F','\u26D3\uFE0F','\u26E9\uFE0F','\u26F0\uFE0F','\u26F1\uFE0F','\u26F4\uFE0F','\u26F7\uFE0F','\u26F8\uFE0F','\u26F9\uFE0F','\u2702\uFE0F','\u2708\uFE0F','\u2709\uFE0F','\u270C\uFE0F','\u270D\uFE0F','\u270F\uFE0F','\u2712\uFE0F','\u2714\uFE0F','\u2716\uFE0F','\u271D\uFE0F','\u2721\uFE0F','\u2733\uFE0F','\u2734\uFE0F','\u2744\uFE0F','\u2747\uFE0F','\u2763\uFE0F','\u2764\uFE0F','\u27A1\uFE0F','\u2934\uFE0F','\u2935\uFE0F','\u2B05\uFE0F','\u2B06\uFE0F','\u2B07\uFE0F','\u3030\uFE0F','\u303D\uFE0F','\u3297\uFE0F','\u3299\uFE0F','\u{1F170}\uFE0F','\u{1F171}\uFE0F','\u{1F17E}\uFE0F','\u{1F17F}\uFE0F','\u{1F202}\uFE0F','\u{1F237}\uFE0F','\u{1F321}\uFE0F','\u{1F324}\uFE0F','\u{1F325}\uFE0F','\u{1F326}\uFE0F','\u{1F327}\uFE0F','\u{1F328}\uFE0F','\u{1F329}\uFE0F','\u{1F32A}\uFE0F','\u{1F32B}\uFE0F','\u{1F32C}\uFE0F','\u{1F336}\uFE0F','\u{1F37D}\uFE0F','\u{1F396}\uFE0F','\u{1F397}\uFE0F','\u{1F399}\uFE0F','\u{1F39A}\uFE0F','\u{1F39B}\uFE0F','\u{1F39E}\uFE0F','\u{1F39F}\uFE0F','\u{1F3CB}\uFE0F','\u{1F3CC}\uFE0F','\u{1F3CD}\uFE0F','\u{1F3CE}\uFE0F','\u{1F3D4}\uFE0F','\u{1F3D5}\uFE0F','\u{1F3D6}\uFE0F','\u{1F3D7}\uFE0F','\u{1F3D8}\uFE0F','\u{1F3D9}\uFE0F','\u{1F3DA}\uFE0F','\u{1F3DB}\uFE0F','\u{1F3DC}\uFE0F','\u{1F3DD}\uFE0F','\u{1F3DE}\uFE0F','\u{1F3DF}\uFE0F','\u{1F3F3}\uFE0F','\u{1F3F5}\uFE0F','\u{1F3F7}\uFE0F','\u{1F43F}\uFE0F','\u{1F441}\uFE0F','\u{1F4FD}\uFE0F','\u{1F549}\uFE0F','\u{1F54A}\uFE0F','\u{1F56F}\uFE0F','\u{1F570}\uFE0F','\u{1F573}\uFE0F','\u{1F574}\uFE0F','\u{1F575}\uFE0F','\u{1F576}\uFE0F','\u{1F577}\uFE0F','\u{1F578}\uFE0F','\u{1F579}\uFE0F','\u{1F587}\uFE0F','\u{1F58A}\uFE0F','\u{1F58B}\uFE0F','\u{1F58C}\uFE0F','\u{1F58D}\uFE0F','\u{1F590}\uFE0F','\u{1F5A5}\uFE0F','\u{1F5A8}\uFE0F','\u{1F5B1}\uFE0F','\u{1F5B2}\uFE0F','\u{1F5BC}\uFE0F','\u{1F5C2}\uFE0F','\u{1F5C3}\uFE0F','\u{1F5C4}\uFE0F','\u{1F5D1}\uFE0F','\u{1F5D2}\uFE0F','\u{1F5D3}\uFE0F','\u{1F5DC}\uFE0F','\u{1F5DD}\uFE0F','\u{1F5DE}\uFE0F','\u{1F5E1}\uFE0F','\u{1F5E3}\uFE0F','\u{1F5E8}\uFE0F','\u{1F5EF}\uFE0F','\u{1F5F3}\uFE0F','\u{1F5FA}\uFE0F','\u{1F6CB}\uFE0F','\u{1F6CD}\uFE0F','\u{1F6CE}\uFE0F','\u{1F6CF}\uFE0F','\u{1F6E0}\uFE0F','\u{1F6E1}\uFE0F','\u{1F6E2}\uFE0F','\u{1F6E3}\uFE0F','\u{1F6E4}\uFE0F','\u{1F6E5}\uFE0F','\u{1F6E9}\uFE0F','\u{1F6F0}\uFE0F','\u{1F6F3}\uFE0F'];

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Property_of_Strings/Emoji_Keycap_Sequence.js", function (module, exports) {
	  const set = regenerate();

	exports.characters = set;
	exports.strings = ['#\uFE0F\u20E3','*\uFE0F\u20E3','0\uFE0F\u20E3','1\uFE0F\u20E3','2\uFE0F\u20E3','3\uFE0F\u20E3','4\uFE0F\u20E3','5\uFE0F\u20E3','6\uFE0F\u20E3','7\uFE0F\u20E3','8\uFE0F\u20E3','9\uFE0F\u20E3'];

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Flag_Sequence.js", function (module, exports) {
	  const set = regenerate();

	exports.characters = set;
	exports.strings = ['\u{1F1E6}\u{1F1E8}','\u{1F1E6}\u{1F1E9}','\u{1F1E6}\u{1F1EA}','\u{1F1E6}\u{1F1EB}','\u{1F1E6}\u{1F1EC}','\u{1F1E6}\u{1F1EE}','\u{1F1E6}\u{1F1F1}','\u{1F1E6}\u{1F1F2}','\u{1F1E6}\u{1F1F4}','\u{1F1E6}\u{1F1F6}','\u{1F1E6}\u{1F1F7}','\u{1F1E6}\u{1F1F8}','\u{1F1E6}\u{1F1F9}','\u{1F1E6}\u{1F1FA}','\u{1F1E6}\u{1F1FC}','\u{1F1E6}\u{1F1FD}','\u{1F1E6}\u{1F1FF}','\u{1F1E7}\u{1F1E6}','\u{1F1E7}\u{1F1E7}','\u{1F1E7}\u{1F1E9}','\u{1F1E7}\u{1F1EA}','\u{1F1E7}\u{1F1EB}','\u{1F1E7}\u{1F1EC}','\u{1F1E7}\u{1F1ED}','\u{1F1E7}\u{1F1EE}','\u{1F1E7}\u{1F1EF}','\u{1F1E7}\u{1F1F1}','\u{1F1E7}\u{1F1F2}','\u{1F1E7}\u{1F1F3}','\u{1F1E7}\u{1F1F4}','\u{1F1E7}\u{1F1F6}','\u{1F1E7}\u{1F1F7}','\u{1F1E7}\u{1F1F8}','\u{1F1E7}\u{1F1F9}','\u{1F1E7}\u{1F1FB}','\u{1F1E7}\u{1F1FC}','\u{1F1E7}\u{1F1FE}','\u{1F1E7}\u{1F1FF}','\u{1F1E8}\u{1F1E6}','\u{1F1E8}\u{1F1E8}','\u{1F1E8}\u{1F1E9}','\u{1F1E8}\u{1F1EB}','\u{1F1E8}\u{1F1EC}','\u{1F1E8}\u{1F1ED}','\u{1F1E8}\u{1F1EE}','\u{1F1E8}\u{1F1F0}','\u{1F1E8}\u{1F1F1}','\u{1F1E8}\u{1F1F2}','\u{1F1E8}\u{1F1F3}','\u{1F1E8}\u{1F1F4}','\u{1F1E8}\u{1F1F5}','\u{1F1E8}\u{1F1F7}','\u{1F1E8}\u{1F1FA}','\u{1F1E8}\u{1F1FB}','\u{1F1E8}\u{1F1FC}','\u{1F1E8}\u{1F1FD}','\u{1F1E8}\u{1F1FE}','\u{1F1E8}\u{1F1FF}','\u{1F1E9}\u{1F1EA}','\u{1F1E9}\u{1F1EC}','\u{1F1E9}\u{1F1EF}','\u{1F1E9}\u{1F1F0}','\u{1F1E9}\u{1F1F2}','\u{1F1E9}\u{1F1F4}','\u{1F1E9}\u{1F1FF}','\u{1F1EA}\u{1F1E6}','\u{1F1EA}\u{1F1E8}','\u{1F1EA}\u{1F1EA}','\u{1F1EA}\u{1F1EC}','\u{1F1EA}\u{1F1ED}','\u{1F1EA}\u{1F1F7}','\u{1F1EA}\u{1F1F8}','\u{1F1EA}\u{1F1F9}','\u{1F1EA}\u{1F1FA}','\u{1F1EB}\u{1F1EE}','\u{1F1EB}\u{1F1EF}','\u{1F1EB}\u{1F1F0}','\u{1F1EB}\u{1F1F2}','\u{1F1EB}\u{1F1F4}','\u{1F1EB}\u{1F1F7}','\u{1F1EC}\u{1F1E6}','\u{1F1EC}\u{1F1E7}','\u{1F1EC}\u{1F1E9}','\u{1F1EC}\u{1F1EA}','\u{1F1EC}\u{1F1EB}','\u{1F1EC}\u{1F1EC}','\u{1F1EC}\u{1F1ED}','\u{1F1EC}\u{1F1EE}','\u{1F1EC}\u{1F1F1}','\u{1F1EC}\u{1F1F2}','\u{1F1EC}\u{1F1F3}','\u{1F1EC}\u{1F1F5}','\u{1F1EC}\u{1F1F6}','\u{1F1EC}\u{1F1F7}','\u{1F1EC}\u{1F1F8}','\u{1F1EC}\u{1F1F9}','\u{1F1EC}\u{1F1FA}','\u{1F1EC}\u{1F1FC}','\u{1F1EC}\u{1F1FE}','\u{1F1ED}\u{1F1F0}','\u{1F1ED}\u{1F1F2}','\u{1F1ED}\u{1F1F3}','\u{1F1ED}\u{1F1F7}','\u{1F1ED}\u{1F1F9}','\u{1F1ED}\u{1F1FA}','\u{1F1EE}\u{1F1E8}','\u{1F1EE}\u{1F1E9}','\u{1F1EE}\u{1F1EA}','\u{1F1EE}\u{1F1F1}','\u{1F1EE}\u{1F1F2}','\u{1F1EE}\u{1F1F3}','\u{1F1EE}\u{1F1F4}','\u{1F1EE}\u{1F1F6}','\u{1F1EE}\u{1F1F7}','\u{1F1EE}\u{1F1F8}','\u{1F1EE}\u{1F1F9}','\u{1F1EF}\u{1F1EA}','\u{1F1EF}\u{1F1F2}','\u{1F1EF}\u{1F1F4}','\u{1F1EF}\u{1F1F5}','\u{1F1F0}\u{1F1EA}','\u{1F1F0}\u{1F1EC}','\u{1F1F0}\u{1F1ED}','\u{1F1F0}\u{1F1EE}','\u{1F1F0}\u{1F1F2}','\u{1F1F0}\u{1F1F3}','\u{1F1F0}\u{1F1F5}','\u{1F1F0}\u{1F1F7}','\u{1F1F0}\u{1F1FC}','\u{1F1F0}\u{1F1FE}','\u{1F1F0}\u{1F1FF}','\u{1F1F1}\u{1F1E6}','\u{1F1F1}\u{1F1E7}','\u{1F1F1}\u{1F1E8}','\u{1F1F1}\u{1F1EE}','\u{1F1F1}\u{1F1F0}','\u{1F1F1}\u{1F1F7}','\u{1F1F1}\u{1F1F8}','\u{1F1F1}\u{1F1F9}','\u{1F1F1}\u{1F1FA}','\u{1F1F1}\u{1F1FB}','\u{1F1F1}\u{1F1FE}','\u{1F1F2}\u{1F1E6}','\u{1F1F2}\u{1F1E8}','\u{1F1F2}\u{1F1E9}','\u{1F1F2}\u{1F1EA}','\u{1F1F2}\u{1F1EB}','\u{1F1F2}\u{1F1EC}','\u{1F1F2}\u{1F1ED}','\u{1F1F2}\u{1F1F0}','\u{1F1F2}\u{1F1F1}','\u{1F1F2}\u{1F1F2}','\u{1F1F2}\u{1F1F3}','\u{1F1F2}\u{1F1F4}','\u{1F1F2}\u{1F1F5}','\u{1F1F2}\u{1F1F6}','\u{1F1F2}\u{1F1F7}','\u{1F1F2}\u{1F1F8}','\u{1F1F2}\u{1F1F9}','\u{1F1F2}\u{1F1FA}','\u{1F1F2}\u{1F1FB}','\u{1F1F2}\u{1F1FC}','\u{1F1F2}\u{1F1FD}','\u{1F1F2}\u{1F1FE}','\u{1F1F2}\u{1F1FF}','\u{1F1F3}\u{1F1E6}','\u{1F1F3}\u{1F1E8}','\u{1F1F3}\u{1F1EA}','\u{1F1F3}\u{1F1EB}','\u{1F1F3}\u{1F1EC}','\u{1F1F3}\u{1F1EE}','\u{1F1F3}\u{1F1F1}','\u{1F1F3}\u{1F1F4}','\u{1F1F3}\u{1F1F5}','\u{1F1F3}\u{1F1F7}','\u{1F1F3}\u{1F1FA}','\u{1F1F3}\u{1F1FF}','\u{1F1F4}\u{1F1F2}','\u{1F1F5}\u{1F1E6}','\u{1F1F5}\u{1F1EA}','\u{1F1F5}\u{1F1EB}','\u{1F1F5}\u{1F1EC}','\u{1F1F5}\u{1F1ED}','\u{1F1F5}\u{1F1F0}','\u{1F1F5}\u{1F1F1}','\u{1F1F5}\u{1F1F2}','\u{1F1F5}\u{1F1F3}','\u{1F1F5}\u{1F1F7}','\u{1F1F5}\u{1F1F8}','\u{1F1F5}\u{1F1F9}','\u{1F1F5}\u{1F1FC}','\u{1F1F5}\u{1F1FE}','\u{1F1F6}\u{1F1E6}','\u{1F1F7}\u{1F1EA}','\u{1F1F7}\u{1F1F4}','\u{1F1F7}\u{1F1F8}','\u{1F1F7}\u{1F1FA}','\u{1F1F7}\u{1F1FC}','\u{1F1F8}\u{1F1E6}','\u{1F1F8}\u{1F1E7}','\u{1F1F8}\u{1F1E8}','\u{1F1F8}\u{1F1E9}','\u{1F1F8}\u{1F1EA}','\u{1F1F8}\u{1F1EC}','\u{1F1F8}\u{1F1ED}','\u{1F1F8}\u{1F1EE}','\u{1F1F8}\u{1F1EF}','\u{1F1F8}\u{1F1F0}','\u{1F1F8}\u{1F1F1}','\u{1F1F8}\u{1F1F2}','\u{1F1F8}\u{1F1F3}','\u{1F1F8}\u{1F1F4}','\u{1F1F8}\u{1F1F7}','\u{1F1F8}\u{1F1F8}','\u{1F1F8}\u{1F1F9}','\u{1F1F8}\u{1F1FB}','\u{1F1F8}\u{1F1FD}','\u{1F1F8}\u{1F1FE}','\u{1F1F8}\u{1F1FF}','\u{1F1F9}\u{1F1E6}','\u{1F1F9}\u{1F1E8}','\u{1F1F9}\u{1F1E9}','\u{1F1F9}\u{1F1EB}','\u{1F1F9}\u{1F1EC}','\u{1F1F9}\u{1F1ED}','\u{1F1F9}\u{1F1EF}','\u{1F1F9}\u{1F1F0}','\u{1F1F9}\u{1F1F1}','\u{1F1F9}\u{1F1F2}','\u{1F1F9}\u{1F1F3}','\u{1F1F9}\u{1F1F4}','\u{1F1F9}\u{1F1F7}','\u{1F1F9}\u{1F1F9}','\u{1F1F9}\u{1F1FB}','\u{1F1F9}\u{1F1FC}','\u{1F1F9}\u{1F1FF}','\u{1F1FA}\u{1F1E6}','\u{1F1FA}\u{1F1EC}','\u{1F1FA}\u{1F1F2}','\u{1F1FA}\u{1F1F3}','\u{1F1FA}\u{1F1F8}','\u{1F1FA}\u{1F1FE}','\u{1F1FA}\u{1F1FF}','\u{1F1FB}\u{1F1E6}','\u{1F1FB}\u{1F1E8}','\u{1F1FB}\u{1F1EA}','\u{1F1FB}\u{1F1EC}','\u{1F1FB}\u{1F1EE}','\u{1F1FB}\u{1F1F3}','\u{1F1FB}\u{1F1FA}','\u{1F1FC}\u{1F1EB}','\u{1F1FC}\u{1F1F8}','\u{1F1FD}\u{1F1F0}','\u{1F1FE}\u{1F1EA}','\u{1F1FE}\u{1F1F9}','\u{1F1FF}\u{1F1E6}','\u{1F1FF}\u{1F1F2}','\u{1F1FF}\u{1F1FC}'];

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Modifier_Sequence.js", function (module, exports) {
	  const set = regenerate();

	exports.characters = set;
	exports.strings = ['\u261D\u{1F3FB}','\u261D\u{1F3FC}','\u261D\u{1F3FD}','\u261D\u{1F3FE}','\u261D\u{1F3FF}','\u26F9\u{1F3FB}','\u26F9\u{1F3FC}','\u26F9\u{1F3FD}','\u26F9\u{1F3FE}','\u26F9\u{1F3FF}','\u270A\u{1F3FB}','\u270A\u{1F3FC}','\u270A\u{1F3FD}','\u270A\u{1F3FE}','\u270A\u{1F3FF}','\u270B\u{1F3FB}','\u270B\u{1F3FC}','\u270B\u{1F3FD}','\u270B\u{1F3FE}','\u270B\u{1F3FF}','\u270C\u{1F3FB}','\u270C\u{1F3FC}','\u270C\u{1F3FD}','\u270C\u{1F3FE}','\u270C\u{1F3FF}','\u270D\u{1F3FB}','\u270D\u{1F3FC}','\u270D\u{1F3FD}','\u270D\u{1F3FE}','\u270D\u{1F3FF}','\u{1F385}\u{1F3FB}','\u{1F385}\u{1F3FC}','\u{1F385}\u{1F3FD}','\u{1F385}\u{1F3FE}','\u{1F385}\u{1F3FF}','\u{1F3C2}\u{1F3FB}','\u{1F3C2}\u{1F3FC}','\u{1F3C2}\u{1F3FD}','\u{1F3C2}\u{1F3FE}','\u{1F3C2}\u{1F3FF}','\u{1F3C3}\u{1F3FB}','\u{1F3C3}\u{1F3FC}','\u{1F3C3}\u{1F3FD}','\u{1F3C3}\u{1F3FE}','\u{1F3C3}\u{1F3FF}','\u{1F3C4}\u{1F3FB}','\u{1F3C4}\u{1F3FC}','\u{1F3C4}\u{1F3FD}','\u{1F3C4}\u{1F3FE}','\u{1F3C4}\u{1F3FF}','\u{1F3C7}\u{1F3FB}','\u{1F3C7}\u{1F3FC}','\u{1F3C7}\u{1F3FD}','\u{1F3C7}\u{1F3FE}','\u{1F3C7}\u{1F3FF}','\u{1F3CA}\u{1F3FB}','\u{1F3CA}\u{1F3FC}','\u{1F3CA}\u{1F3FD}','\u{1F3CA}\u{1F3FE}','\u{1F3CA}\u{1F3FF}','\u{1F3CB}\u{1F3FB}','\u{1F3CB}\u{1F3FC}','\u{1F3CB}\u{1F3FD}','\u{1F3CB}\u{1F3FE}','\u{1F3CB}\u{1F3FF}','\u{1F3CC}\u{1F3FB}','\u{1F3CC}\u{1F3FC}','\u{1F3CC}\u{1F3FD}','\u{1F3CC}\u{1F3FE}','\u{1F3CC}\u{1F3FF}','\u{1F442}\u{1F3FB}','\u{1F442}\u{1F3FC}','\u{1F442}\u{1F3FD}','\u{1F442}\u{1F3FE}','\u{1F442}\u{1F3FF}','\u{1F443}\u{1F3FB}','\u{1F443}\u{1F3FC}','\u{1F443}\u{1F3FD}','\u{1F443}\u{1F3FE}','\u{1F443}\u{1F3FF}','\u{1F446}\u{1F3FB}','\u{1F446}\u{1F3FC}','\u{1F446}\u{1F3FD}','\u{1F446}\u{1F3FE}','\u{1F446}\u{1F3FF}','\u{1F447}\u{1F3FB}','\u{1F447}\u{1F3FC}','\u{1F447}\u{1F3FD}','\u{1F447}\u{1F3FE}','\u{1F447}\u{1F3FF}','\u{1F448}\u{1F3FB}','\u{1F448}\u{1F3FC}','\u{1F448}\u{1F3FD}','\u{1F448}\u{1F3FE}','\u{1F448}\u{1F3FF}','\u{1F449}\u{1F3FB}','\u{1F449}\u{1F3FC}','\u{1F449}\u{1F3FD}','\u{1F449}\u{1F3FE}','\u{1F449}\u{1F3FF}','\u{1F44A}\u{1F3FB}','\u{1F44A}\u{1F3FC}','\u{1F44A}\u{1F3FD}','\u{1F44A}\u{1F3FE}','\u{1F44A}\u{1F3FF}','\u{1F44B}\u{1F3FB}','\u{1F44B}\u{1F3FC}','\u{1F44B}\u{1F3FD}','\u{1F44B}\u{1F3FE}','\u{1F44B}\u{1F3FF}','\u{1F44C}\u{1F3FB}','\u{1F44C}\u{1F3FC}','\u{1F44C}\u{1F3FD}','\u{1F44C}\u{1F3FE}','\u{1F44C}\u{1F3FF}','\u{1F44D}\u{1F3FB}','\u{1F44D}\u{1F3FC}','\u{1F44D}\u{1F3FD}','\u{1F44D}\u{1F3FE}','\u{1F44D}\u{1F3FF}','\u{1F44E}\u{1F3FB}','\u{1F44E}\u{1F3FC}','\u{1F44E}\u{1F3FD}','\u{1F44E}\u{1F3FE}','\u{1F44E}\u{1F3FF}','\u{1F44F}\u{1F3FB}','\u{1F44F}\u{1F3FC}','\u{1F44F}\u{1F3FD}','\u{1F44F}\u{1F3FE}','\u{1F44F}\u{1F3FF}','\u{1F450}\u{1F3FB}','\u{1F450}\u{1F3FC}','\u{1F450}\u{1F3FD}','\u{1F450}\u{1F3FE}','\u{1F450}\u{1F3FF}','\u{1F466}\u{1F3FB}','\u{1F466}\u{1F3FC}','\u{1F466}\u{1F3FD}','\u{1F466}\u{1F3FE}','\u{1F466}\u{1F3FF}','\u{1F467}\u{1F3FB}','\u{1F467}\u{1F3FC}','\u{1F467}\u{1F3FD}','\u{1F467}\u{1F3FE}','\u{1F467}\u{1F3FF}','\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FF}','\u{1F46B}\u{1F3FB}','\u{1F46B}\u{1F3FC}','\u{1F46B}\u{1F3FD}','\u{1F46B}\u{1F3FE}','\u{1F46B}\u{1F3FF}','\u{1F46C}\u{1F3FB}','\u{1F46C}\u{1F3FC}','\u{1F46C}\u{1F3FD}','\u{1F46C}\u{1F3FE}','\u{1F46C}\u{1F3FF}','\u{1F46D}\u{1F3FB}','\u{1F46D}\u{1F3FC}','\u{1F46D}\u{1F3FD}','\u{1F46D}\u{1F3FE}','\u{1F46D}\u{1F3FF}','\u{1F46E}\u{1F3FB}','\u{1F46E}\u{1F3FC}','\u{1F46E}\u{1F3FD}','\u{1F46E}\u{1F3FE}','\u{1F46E}\u{1F3FF}','\u{1F470}\u{1F3FB}','\u{1F470}\u{1F3FC}','\u{1F470}\u{1F3FD}','\u{1F470}\u{1F3FE}','\u{1F470}\u{1F3FF}','\u{1F471}\u{1F3FB}','\u{1F471}\u{1F3FC}','\u{1F471}\u{1F3FD}','\u{1F471}\u{1F3FE}','\u{1F471}\u{1F3FF}','\u{1F472}\u{1F3FB}','\u{1F472}\u{1F3FC}','\u{1F472}\u{1F3FD}','\u{1F472}\u{1F3FE}','\u{1F472}\u{1F3FF}','\u{1F473}\u{1F3FB}','\u{1F473}\u{1F3FC}','\u{1F473}\u{1F3FD}','\u{1F473}\u{1F3FE}','\u{1F473}\u{1F3FF}','\u{1F474}\u{1F3FB}','\u{1F474}\u{1F3FC}','\u{1F474}\u{1F3FD}','\u{1F474}\u{1F3FE}','\u{1F474}\u{1F3FF}','\u{1F475}\u{1F3FB}','\u{1F475}\u{1F3FC}','\u{1F475}\u{1F3FD}','\u{1F475}\u{1F3FE}','\u{1F475}\u{1F3FF}','\u{1F476}\u{1F3FB}','\u{1F476}\u{1F3FC}','\u{1F476}\u{1F3FD}','\u{1F476}\u{1F3FE}','\u{1F476}\u{1F3FF}','\u{1F477}\u{1F3FB}','\u{1F477}\u{1F3FC}','\u{1F477}\u{1F3FD}','\u{1F477}\u{1F3FE}','\u{1F477}\u{1F3FF}','\u{1F478}\u{1F3FB}','\u{1F478}\u{1F3FC}','\u{1F478}\u{1F3FD}','\u{1F478}\u{1F3FE}','\u{1F478}\u{1F3FF}','\u{1F47C}\u{1F3FB}','\u{1F47C}\u{1F3FC}','\u{1F47C}\u{1F3FD}','\u{1F47C}\u{1F3FE}','\u{1F47C}\u{1F3FF}','\u{1F481}\u{1F3FB}','\u{1F481}\u{1F3FC}','\u{1F481}\u{1F3FD}','\u{1F481}\u{1F3FE}','\u{1F481}\u{1F3FF}','\u{1F482}\u{1F3FB}','\u{1F482}\u{1F3FC}','\u{1F482}\u{1F3FD}','\u{1F482}\u{1F3FE}','\u{1F482}\u{1F3FF}','\u{1F483}\u{1F3FB}','\u{1F483}\u{1F3FC}','\u{1F483}\u{1F3FD}','\u{1F483}\u{1F3FE}','\u{1F483}\u{1F3FF}','\u{1F485}\u{1F3FB}','\u{1F485}\u{1F3FC}','\u{1F485}\u{1F3FD}','\u{1F485}\u{1F3FE}','\u{1F485}\u{1F3FF}','\u{1F486}\u{1F3FB}','\u{1F486}\u{1F3FC}','\u{1F486}\u{1F3FD}','\u{1F486}\u{1F3FE}','\u{1F486}\u{1F3FF}','\u{1F487}\u{1F3FB}','\u{1F487}\u{1F3FC}','\u{1F487}\u{1F3FD}','\u{1F487}\u{1F3FE}','\u{1F487}\u{1F3FF}','\u{1F48F}\u{1F3FB}','\u{1F48F}\u{1F3FC}','\u{1F48F}\u{1F3FD}','\u{1F48F}\u{1F3FE}','\u{1F48F}\u{1F3FF}','\u{1F491}\u{1F3FB}','\u{1F491}\u{1F3FC}','\u{1F491}\u{1F3FD}','\u{1F491}\u{1F3FE}','\u{1F491}\u{1F3FF}','\u{1F4AA}\u{1F3FB}','\u{1F4AA}\u{1F3FC}','\u{1F4AA}\u{1F3FD}','\u{1F4AA}\u{1F3FE}','\u{1F4AA}\u{1F3FF}','\u{1F574}\u{1F3FB}','\u{1F574}\u{1F3FC}','\u{1F574}\u{1F3FD}','\u{1F574}\u{1F3FE}','\u{1F574}\u{1F3FF}','\u{1F575}\u{1F3FB}','\u{1F575}\u{1F3FC}','\u{1F575}\u{1F3FD}','\u{1F575}\u{1F3FE}','\u{1F575}\u{1F3FF}','\u{1F57A}\u{1F3FB}','\u{1F57A}\u{1F3FC}','\u{1F57A}\u{1F3FD}','\u{1F57A}\u{1F3FE}','\u{1F57A}\u{1F3FF}','\u{1F590}\u{1F3FB}','\u{1F590}\u{1F3FC}','\u{1F590}\u{1F3FD}','\u{1F590}\u{1F3FE}','\u{1F590}\u{1F3FF}','\u{1F595}\u{1F3FB}','\u{1F595}\u{1F3FC}','\u{1F595}\u{1F3FD}','\u{1F595}\u{1F3FE}','\u{1F595}\u{1F3FF}','\u{1F596}\u{1F3FB}','\u{1F596}\u{1F3FC}','\u{1F596}\u{1F3FD}','\u{1F596}\u{1F3FE}','\u{1F596}\u{1F3FF}','\u{1F645}\u{1F3FB}','\u{1F645}\u{1F3FC}','\u{1F645}\u{1F3FD}','\u{1F645}\u{1F3FE}','\u{1F645}\u{1F3FF}','\u{1F646}\u{1F3FB}','\u{1F646}\u{1F3FC}','\u{1F646}\u{1F3FD}','\u{1F646}\u{1F3FE}','\u{1F646}\u{1F3FF}','\u{1F647}\u{1F3FB}','\u{1F647}\u{1F3FC}','\u{1F647}\u{1F3FD}','\u{1F647}\u{1F3FE}','\u{1F647}\u{1F3FF}','\u{1F64B}\u{1F3FB}','\u{1F64B}\u{1F3FC}','\u{1F64B}\u{1F3FD}','\u{1F64B}\u{1F3FE}','\u{1F64B}\u{1F3FF}','\u{1F64C}\u{1F3FB}','\u{1F64C}\u{1F3FC}','\u{1F64C}\u{1F3FD}','\u{1F64C}\u{1F3FE}','\u{1F64C}\u{1F3FF}','\u{1F64D}\u{1F3FB}','\u{1F64D}\u{1F3FC}','\u{1F64D}\u{1F3FD}','\u{1F64D}\u{1F3FE}','\u{1F64D}\u{1F3FF}','\u{1F64E}\u{1F3FB}','\u{1F64E}\u{1F3FC}','\u{1F64E}\u{1F3FD}','\u{1F64E}\u{1F3FE}','\u{1F64E}\u{1F3FF}','\u{1F64F}\u{1F3FB}','\u{1F64F}\u{1F3FC}','\u{1F64F}\u{1F3FD}','\u{1F64F}\u{1F3FE}','\u{1F64F}\u{1F3FF}','\u{1F6A3}\u{1F3FB}','\u{1F6A3}\u{1F3FC}','\u{1F6A3}\u{1F3FD}','\u{1F6A3}\u{1F3FE}','\u{1F6A3}\u{1F3FF}','\u{1F6B4}\u{1F3FB}','\u{1F6B4}\u{1F3FC}','\u{1F6B4}\u{1F3FD}','\u{1F6B4}\u{1F3FE}','\u{1F6B4}\u{1F3FF}','\u{1F6B5}\u{1F3FB}','\u{1F6B5}\u{1F3FC}','\u{1F6B5}\u{1F3FD}','\u{1F6B5}\u{1F3FE}','\u{1F6B5}\u{1F3FF}','\u{1F6B6}\u{1F3FB}','\u{1F6B6}\u{1F3FC}','\u{1F6B6}\u{1F3FD}','\u{1F6B6}\u{1F3FE}','\u{1F6B6}\u{1F3FF}','\u{1F6C0}\u{1F3FB}','\u{1F6C0}\u{1F3FC}','\u{1F6C0}\u{1F3FD}','\u{1F6C0}\u{1F3FE}','\u{1F6C0}\u{1F3FF}','\u{1F6CC}\u{1F3FB}','\u{1F6CC}\u{1F3FC}','\u{1F6CC}\u{1F3FD}','\u{1F6CC}\u{1F3FE}','\u{1F6CC}\u{1F3FF}','\u{1F90C}\u{1F3FB}','\u{1F90C}\u{1F3FC}','\u{1F90C}\u{1F3FD}','\u{1F90C}\u{1F3FE}','\u{1F90C}\u{1F3FF}','\u{1F90F}\u{1F3FB}','\u{1F90F}\u{1F3FC}','\u{1F90F}\u{1F3FD}','\u{1F90F}\u{1F3FE}','\u{1F90F}\u{1F3FF}','\u{1F918}\u{1F3FB}','\u{1F918}\u{1F3FC}','\u{1F918}\u{1F3FD}','\u{1F918}\u{1F3FE}','\u{1F918}\u{1F3FF}','\u{1F919}\u{1F3FB}','\u{1F919}\u{1F3FC}','\u{1F919}\u{1F3FD}','\u{1F919}\u{1F3FE}','\u{1F919}\u{1F3FF}','\u{1F91A}\u{1F3FB}','\u{1F91A}\u{1F3FC}','\u{1F91A}\u{1F3FD}','\u{1F91A}\u{1F3FE}','\u{1F91A}\u{1F3FF}','\u{1F91B}\u{1F3FB}','\u{1F91B}\u{1F3FC}','\u{1F91B}\u{1F3FD}','\u{1F91B}\u{1F3FE}','\u{1F91B}\u{1F3FF}','\u{1F91C}\u{1F3FB}','\u{1F91C}\u{1F3FC}','\u{1F91C}\u{1F3FD}','\u{1F91C}\u{1F3FE}','\u{1F91C}\u{1F3FF}','\u{1F91D}\u{1F3FB}','\u{1F91D}\u{1F3FC}','\u{1F91D}\u{1F3FD}','\u{1F91D}\u{1F3FE}','\u{1F91D}\u{1F3FF}','\u{1F91E}\u{1F3FB}','\u{1F91E}\u{1F3FC}','\u{1F91E}\u{1F3FD}','\u{1F91E}\u{1F3FE}','\u{1F91E}\u{1F3FF}','\u{1F91F}\u{1F3FB}','\u{1F91F}\u{1F3FC}','\u{1F91F}\u{1F3FD}','\u{1F91F}\u{1F3FE}','\u{1F91F}\u{1F3FF}','\u{1F926}\u{1F3FB}','\u{1F926}\u{1F3FC}','\u{1F926}\u{1F3FD}','\u{1F926}\u{1F3FE}','\u{1F926}\u{1F3FF}','\u{1F930}\u{1F3FB}','\u{1F930}\u{1F3FC}','\u{1F930}\u{1F3FD}','\u{1F930}\u{1F3FE}','\u{1F930}\u{1F3FF}','\u{1F931}\u{1F3FB}','\u{1F931}\u{1F3FC}','\u{1F931}\u{1F3FD}','\u{1F931}\u{1F3FE}','\u{1F931}\u{1F3FF}','\u{1F932}\u{1F3FB}','\u{1F932}\u{1F3FC}','\u{1F932}\u{1F3FD}','\u{1F932}\u{1F3FE}','\u{1F932}\u{1F3FF}','\u{1F933}\u{1F3FB}','\u{1F933}\u{1F3FC}','\u{1F933}\u{1F3FD}','\u{1F933}\u{1F3FE}','\u{1F933}\u{1F3FF}','\u{1F934}\u{1F3FB}','\u{1F934}\u{1F3FC}','\u{1F934}\u{1F3FD}','\u{1F934}\u{1F3FE}','\u{1F934}\u{1F3FF}','\u{1F935}\u{1F3FB}','\u{1F935}\u{1F3FC}','\u{1F935}\u{1F3FD}','\u{1F935}\u{1F3FE}','\u{1F935}\u{1F3FF}','\u{1F936}\u{1F3FB}','\u{1F936}\u{1F3FC}','\u{1F936}\u{1F3FD}','\u{1F936}\u{1F3FE}','\u{1F936}\u{1F3FF}','\u{1F937}\u{1F3FB}','\u{1F937}\u{1F3FC}','\u{1F937}\u{1F3FD}','\u{1F937}\u{1F3FE}','\u{1F937}\u{1F3FF}','\u{1F938}\u{1F3FB}','\u{1F938}\u{1F3FC}','\u{1F938}\u{1F3FD}','\u{1F938}\u{1F3FE}','\u{1F938}\u{1F3FF}','\u{1F939}\u{1F3FB}','\u{1F939}\u{1F3FC}','\u{1F939}\u{1F3FD}','\u{1F939}\u{1F3FE}','\u{1F939}\u{1F3FF}','\u{1F93D}\u{1F3FB}','\u{1F93D}\u{1F3FC}','\u{1F93D}\u{1F3FD}','\u{1F93D}\u{1F3FE}','\u{1F93D}\u{1F3FF}','\u{1F93E}\u{1F3FB}','\u{1F93E}\u{1F3FC}','\u{1F93E}\u{1F3FD}','\u{1F93E}\u{1F3FE}','\u{1F93E}\u{1F3FF}','\u{1F977}\u{1F3FB}','\u{1F977}\u{1F3FC}','\u{1F977}\u{1F3FD}','\u{1F977}\u{1F3FE}','\u{1F977}\u{1F3FF}','\u{1F9B5}\u{1F3FB}','\u{1F9B5}\u{1F3FC}','\u{1F9B5}\u{1F3FD}','\u{1F9B5}\u{1F3FE}','\u{1F9B5}\u{1F3FF}','\u{1F9B6}\u{1F3FB}','\u{1F9B6}\u{1F3FC}','\u{1F9B6}\u{1F3FD}','\u{1F9B6}\u{1F3FE}','\u{1F9B6}\u{1F3FF}','\u{1F9B8}\u{1F3FB}','\u{1F9B8}\u{1F3FC}','\u{1F9B8}\u{1F3FD}','\u{1F9B8}\u{1F3FE}','\u{1F9B8}\u{1F3FF}','\u{1F9B9}\u{1F3FB}','\u{1F9B9}\u{1F3FC}','\u{1F9B9}\u{1F3FD}','\u{1F9B9}\u{1F3FE}','\u{1F9B9}\u{1F3FF}','\u{1F9BB}\u{1F3FB}','\u{1F9BB}\u{1F3FC}','\u{1F9BB}\u{1F3FD}','\u{1F9BB}\u{1F3FE}','\u{1F9BB}\u{1F3FF}','\u{1F9CD}\u{1F3FB}','\u{1F9CD}\u{1F3FC}','\u{1F9CD}\u{1F3FD}','\u{1F9CD}\u{1F3FE}','\u{1F9CD}\u{1F3FF}','\u{1F9CE}\u{1F3FB}','\u{1F9CE}\u{1F3FC}','\u{1F9CE}\u{1F3FD}','\u{1F9CE}\u{1F3FE}','\u{1F9CE}\u{1F3FF}','\u{1F9CF}\u{1F3FB}','\u{1F9CF}\u{1F3FC}','\u{1F9CF}\u{1F3FD}','\u{1F9CF}\u{1F3FE}','\u{1F9CF}\u{1F3FF}','\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FF}','\u{1F9D2}\u{1F3FB}','\u{1F9D2}\u{1F3FC}','\u{1F9D2}\u{1F3FD}','\u{1F9D2}\u{1F3FE}','\u{1F9D2}\u{1F3FF}','\u{1F9D3}\u{1F3FB}','\u{1F9D3}\u{1F3FC}','\u{1F9D3}\u{1F3FD}','\u{1F9D3}\u{1F3FE}','\u{1F9D3}\u{1F3FF}','\u{1F9D4}\u{1F3FB}','\u{1F9D4}\u{1F3FC}','\u{1F9D4}\u{1F3FD}','\u{1F9D4}\u{1F3FE}','\u{1F9D4}\u{1F3FF}','\u{1F9D5}\u{1F3FB}','\u{1F9D5}\u{1F3FC}','\u{1F9D5}\u{1F3FD}','\u{1F9D5}\u{1F3FE}','\u{1F9D5}\u{1F3FF}','\u{1F9D6}\u{1F3FB}','\u{1F9D6}\u{1F3FC}','\u{1F9D6}\u{1F3FD}','\u{1F9D6}\u{1F3FE}','\u{1F9D6}\u{1F3FF}','\u{1F9D7}\u{1F3FB}','\u{1F9D7}\u{1F3FC}','\u{1F9D7}\u{1F3FD}','\u{1F9D7}\u{1F3FE}','\u{1F9D7}\u{1F3FF}','\u{1F9D8}\u{1F3FB}','\u{1F9D8}\u{1F3FC}','\u{1F9D8}\u{1F3FD}','\u{1F9D8}\u{1F3FE}','\u{1F9D8}\u{1F3FF}','\u{1F9D9}\u{1F3FB}','\u{1F9D9}\u{1F3FC}','\u{1F9D9}\u{1F3FD}','\u{1F9D9}\u{1F3FE}','\u{1F9D9}\u{1F3FF}','\u{1F9DA}\u{1F3FB}','\u{1F9DA}\u{1F3FC}','\u{1F9DA}\u{1F3FD}','\u{1F9DA}\u{1F3FE}','\u{1F9DA}\u{1F3FF}','\u{1F9DB}\u{1F3FB}','\u{1F9DB}\u{1F3FC}','\u{1F9DB}\u{1F3FD}','\u{1F9DB}\u{1F3FE}','\u{1F9DB}\u{1F3FF}','\u{1F9DC}\u{1F3FB}','\u{1F9DC}\u{1F3FC}','\u{1F9DC}\u{1F3FD}','\u{1F9DC}\u{1F3FE}','\u{1F9DC}\u{1F3FF}','\u{1F9DD}\u{1F3FB}','\u{1F9DD}\u{1F3FC}','\u{1F9DD}\u{1F3FD}','\u{1F9DD}\u{1F3FE}','\u{1F9DD}\u{1F3FF}','\u{1FAC3}\u{1F3FB}','\u{1FAC3}\u{1F3FC}','\u{1FAC3}\u{1F3FD}','\u{1FAC3}\u{1F3FE}','\u{1FAC3}\u{1F3FF}','\u{1FAC4}\u{1F3FB}','\u{1FAC4}\u{1F3FC}','\u{1FAC4}\u{1F3FD}','\u{1FAC4}\u{1F3FE}','\u{1FAC4}\u{1F3FF}','\u{1FAC5}\u{1F3FB}','\u{1FAC5}\u{1F3FC}','\u{1FAC5}\u{1F3FD}','\u{1FAC5}\u{1F3FE}','\u{1FAC5}\u{1F3FF}','\u{1FAF0}\u{1F3FB}','\u{1FAF0}\u{1F3FC}','\u{1FAF0}\u{1F3FD}','\u{1FAF0}\u{1F3FE}','\u{1FAF0}\u{1F3FF}','\u{1FAF1}\u{1F3FB}','\u{1FAF1}\u{1F3FC}','\u{1FAF1}\u{1F3FD}','\u{1FAF1}\u{1F3FE}','\u{1FAF1}\u{1F3FF}','\u{1FAF2}\u{1F3FB}','\u{1FAF2}\u{1F3FC}','\u{1FAF2}\u{1F3FD}','\u{1FAF2}\u{1F3FE}','\u{1FAF2}\u{1F3FF}','\u{1FAF3}\u{1F3FB}','\u{1FAF3}\u{1F3FC}','\u{1FAF3}\u{1F3FD}','\u{1FAF3}\u{1F3FE}','\u{1FAF3}\u{1F3FF}','\u{1FAF4}\u{1F3FB}','\u{1FAF4}\u{1F3FC}','\u{1FAF4}\u{1F3FD}','\u{1FAF4}\u{1F3FE}','\u{1FAF4}\u{1F3FF}','\u{1FAF5}\u{1F3FB}','\u{1FAF5}\u{1F3FC}','\u{1FAF5}\u{1F3FD}','\u{1FAF5}\u{1F3FE}','\u{1FAF5}\u{1F3FF}','\u{1FAF6}\u{1F3FB}','\u{1FAF6}\u{1F3FC}','\u{1FAF6}\u{1F3FD}','\u{1FAF6}\u{1F3FE}','\u{1FAF6}\u{1F3FF}'];

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Tag_Sequence.js", function (module, exports) {
	  const set = regenerate();

	exports.characters = set;
	exports.strings = ['\u{1F3F4}\u{E0067}\u{E0062}\u{E0065}\u{E006E}\u{E0067}\u{E007F}','\u{1F3F4}\u{E0067}\u{E0062}\u{E0073}\u{E0063}\u{E0074}\u{E007F}','\u{1F3F4}\u{E0067}\u{E0062}\u{E0077}\u{E006C}\u{E0073}\u{E007F}'];

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_ZWJ_Sequence.js", function (module, exports) {
	  const set = regenerate();

	exports.characters = set;
	exports.strings = ['\u{1F468}\u200D\u2764\uFE0F\u200D\u{1F468}','\u{1F468}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}','\u{1F468}\u200D\u{1F466}','\u{1F468}\u200D\u{1F466}\u200D\u{1F466}','\u{1F468}\u200D\u{1F467}','\u{1F468}\u200D\u{1F467}\u200D\u{1F466}','\u{1F468}\u200D\u{1F467}\u200D\u{1F467}','\u{1F468}\u200D\u{1F468}\u200D\u{1F466}','\u{1F468}\u200D\u{1F468}\u200D\u{1F466}\u200D\u{1F466}','\u{1F468}\u200D\u{1F468}\u200D\u{1F467}','\u{1F468}\u200D\u{1F468}\u200D\u{1F467}\u200D\u{1F466}','\u{1F468}\u200D\u{1F468}\u200D\u{1F467}\u200D\u{1F467}','\u{1F468}\u200D\u{1F469}\u200D\u{1F466}','\u{1F468}\u200D\u{1F469}\u200D\u{1F466}\u200D\u{1F466}','\u{1F468}\u200D\u{1F469}\u200D\u{1F467}','\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}','\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F467}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F468}','\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F469}','\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}','\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}','\u{1F469}\u200D\u{1F466}','\u{1F469}\u200D\u{1F466}\u200D\u{1F466}','\u{1F469}\u200D\u{1F467}','\u{1F469}\u200D\u{1F467}\u200D\u{1F466}','\u{1F469}\u200D\u{1F467}\u200D\u{1F467}','\u{1F469}\u200D\u{1F469}\u200D\u{1F466}','\u{1F469}\u200D\u{1F469}\u200D\u{1F466}\u200D\u{1F466}','\u{1F469}\u200D\u{1F469}\u200D\u{1F467}','\u{1F469}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}','\u{1F469}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F467}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}','\u{1F9D1}\u200D\u{1F91D}\u200D\u{1F9D1}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FB}\u200D\u{1F384}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FC}\u200D\u{1F384}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FD}\u200D\u{1F384}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FE}\u200D\u{1F384}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FF}\u200D\u{1F384}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FC}','\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FD}','\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FE}','\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FF}','\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FB}','\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FD}','\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FE}','\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FF}','\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FB}','\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FC}','\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FE}','\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FF}','\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FB}','\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FC}','\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FD}','\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FF}','\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FB}','\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FC}','\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FD}','\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FE}','\u{1F468}\u200D\u2695\uFE0F','\u{1F468}\u200D\u2696\uFE0F','\u{1F468}\u200D\u2708\uFE0F','\u{1F468}\u200D\u{1F33E}','\u{1F468}\u200D\u{1F373}','\u{1F468}\u200D\u{1F37C}','\u{1F468}\u200D\u{1F393}','\u{1F468}\u200D\u{1F3A4}','\u{1F468}\u200D\u{1F3A8}','\u{1F468}\u200D\u{1F3EB}','\u{1F468}\u200D\u{1F3ED}','\u{1F468}\u200D\u{1F4BB}','\u{1F468}\u200D\u{1F4BC}','\u{1F468}\u200D\u{1F527}','\u{1F468}\u200D\u{1F52C}','\u{1F468}\u200D\u{1F680}','\u{1F468}\u200D\u{1F692}','\u{1F468}\u200D\u{1F9AF}','\u{1F468}\u200D\u{1F9BC}','\u{1F468}\u200D\u{1F9BD}','\u{1F468}\u{1F3FB}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FB}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FB}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FB}\u200D\u{1F33E}','\u{1F468}\u{1F3FB}\u200D\u{1F373}','\u{1F468}\u{1F3FB}\u200D\u{1F37C}','\u{1F468}\u{1F3FB}\u200D\u{1F393}','\u{1F468}\u{1F3FB}\u200D\u{1F3A4}','\u{1F468}\u{1F3FB}\u200D\u{1F3A8}','\u{1F468}\u{1F3FB}\u200D\u{1F3EB}','\u{1F468}\u{1F3FB}\u200D\u{1F3ED}','\u{1F468}\u{1F3FB}\u200D\u{1F4BB}','\u{1F468}\u{1F3FB}\u200D\u{1F4BC}','\u{1F468}\u{1F3FB}\u200D\u{1F527}','\u{1F468}\u{1F3FB}\u200D\u{1F52C}','\u{1F468}\u{1F3FB}\u200D\u{1F680}','\u{1F468}\u{1F3FB}\u200D\u{1F692}','\u{1F468}\u{1F3FB}\u200D\u{1F9AF}','\u{1F468}\u{1F3FB}\u200D\u{1F9BC}','\u{1F468}\u{1F3FB}\u200D\u{1F9BD}','\u{1F468}\u{1F3FC}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FC}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FC}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FC}\u200D\u{1F33E}','\u{1F468}\u{1F3FC}\u200D\u{1F373}','\u{1F468}\u{1F3FC}\u200D\u{1F37C}','\u{1F468}\u{1F3FC}\u200D\u{1F393}','\u{1F468}\u{1F3FC}\u200D\u{1F3A4}','\u{1F468}\u{1F3FC}\u200D\u{1F3A8}','\u{1F468}\u{1F3FC}\u200D\u{1F3EB}','\u{1F468}\u{1F3FC}\u200D\u{1F3ED}','\u{1F468}\u{1F3FC}\u200D\u{1F4BB}','\u{1F468}\u{1F3FC}\u200D\u{1F4BC}','\u{1F468}\u{1F3FC}\u200D\u{1F527}','\u{1F468}\u{1F3FC}\u200D\u{1F52C}','\u{1F468}\u{1F3FC}\u200D\u{1F680}','\u{1F468}\u{1F3FC}\u200D\u{1F692}','\u{1F468}\u{1F3FC}\u200D\u{1F9AF}','\u{1F468}\u{1F3FC}\u200D\u{1F9BC}','\u{1F468}\u{1F3FC}\u200D\u{1F9BD}','\u{1F468}\u{1F3FD}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FD}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FD}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FD}\u200D\u{1F33E}','\u{1F468}\u{1F3FD}\u200D\u{1F373}','\u{1F468}\u{1F3FD}\u200D\u{1F37C}','\u{1F468}\u{1F3FD}\u200D\u{1F393}','\u{1F468}\u{1F3FD}\u200D\u{1F3A4}','\u{1F468}\u{1F3FD}\u200D\u{1F3A8}','\u{1F468}\u{1F3FD}\u200D\u{1F3EB}','\u{1F468}\u{1F3FD}\u200D\u{1F3ED}','\u{1F468}\u{1F3FD}\u200D\u{1F4BB}','\u{1F468}\u{1F3FD}\u200D\u{1F4BC}','\u{1F468}\u{1F3FD}\u200D\u{1F527}','\u{1F468}\u{1F3FD}\u200D\u{1F52C}','\u{1F468}\u{1F3FD}\u200D\u{1F680}','\u{1F468}\u{1F3FD}\u200D\u{1F692}','\u{1F468}\u{1F3FD}\u200D\u{1F9AF}','\u{1F468}\u{1F3FD}\u200D\u{1F9BC}','\u{1F468}\u{1F3FD}\u200D\u{1F9BD}','\u{1F468}\u{1F3FE}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FE}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FE}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FE}\u200D\u{1F33E}','\u{1F468}\u{1F3FE}\u200D\u{1F373}','\u{1F468}\u{1F3FE}\u200D\u{1F37C}','\u{1F468}\u{1F3FE}\u200D\u{1F393}','\u{1F468}\u{1F3FE}\u200D\u{1F3A4}','\u{1F468}\u{1F3FE}\u200D\u{1F3A8}','\u{1F468}\u{1F3FE}\u200D\u{1F3EB}','\u{1F468}\u{1F3FE}\u200D\u{1F3ED}','\u{1F468}\u{1F3FE}\u200D\u{1F4BB}','\u{1F468}\u{1F3FE}\u200D\u{1F4BC}','\u{1F468}\u{1F3FE}\u200D\u{1F527}','\u{1F468}\u{1F3FE}\u200D\u{1F52C}','\u{1F468}\u{1F3FE}\u200D\u{1F680}','\u{1F468}\u{1F3FE}\u200D\u{1F692}','\u{1F468}\u{1F3FE}\u200D\u{1F9AF}','\u{1F468}\u{1F3FE}\u200D\u{1F9BC}','\u{1F468}\u{1F3FE}\u200D\u{1F9BD}','\u{1F468}\u{1F3FF}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FF}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FF}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FF}\u200D\u{1F33E}','\u{1F468}\u{1F3FF}\u200D\u{1F373}','\u{1F468}\u{1F3FF}\u200D\u{1F37C}','\u{1F468}\u{1F3FF}\u200D\u{1F393}','\u{1F468}\u{1F3FF}\u200D\u{1F3A4}','\u{1F468}\u{1F3FF}\u200D\u{1F3A8}','\u{1F468}\u{1F3FF}\u200D\u{1F3EB}','\u{1F468}\u{1F3FF}\u200D\u{1F3ED}','\u{1F468}\u{1F3FF}\u200D\u{1F4BB}','\u{1F468}\u{1F3FF}\u200D\u{1F4BC}','\u{1F468}\u{1F3FF}\u200D\u{1F527}','\u{1F468}\u{1F3FF}\u200D\u{1F52C}','\u{1F468}\u{1F3FF}\u200D\u{1F680}','\u{1F468}\u{1F3FF}\u200D\u{1F692}','\u{1F468}\u{1F3FF}\u200D\u{1F9AF}','\u{1F468}\u{1F3FF}\u200D\u{1F9BC}','\u{1F468}\u{1F3FF}\u200D\u{1F9BD}','\u{1F469}\u200D\u2695\uFE0F','\u{1F469}\u200D\u2696\uFE0F','\u{1F469}\u200D\u2708\uFE0F','\u{1F469}\u200D\u{1F33E}','\u{1F469}\u200D\u{1F373}','\u{1F469}\u200D\u{1F37C}','\u{1F469}\u200D\u{1F393}','\u{1F469}\u200D\u{1F3A4}','\u{1F469}\u200D\u{1F3A8}','\u{1F469}\u200D\u{1F3EB}','\u{1F469}\u200D\u{1F3ED}','\u{1F469}\u200D\u{1F4BB}','\u{1F469}\u200D\u{1F4BC}','\u{1F469}\u200D\u{1F527}','\u{1F469}\u200D\u{1F52C}','\u{1F469}\u200D\u{1F680}','\u{1F469}\u200D\u{1F692}','\u{1F469}\u200D\u{1F9AF}','\u{1F469}\u200D\u{1F9BC}','\u{1F469}\u200D\u{1F9BD}','\u{1F469}\u{1F3FB}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FB}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FB}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FB}\u200D\u{1F33E}','\u{1F469}\u{1F3FB}\u200D\u{1F373}','\u{1F469}\u{1F3FB}\u200D\u{1F37C}','\u{1F469}\u{1F3FB}\u200D\u{1F393}','\u{1F469}\u{1F3FB}\u200D\u{1F3A4}','\u{1F469}\u{1F3FB}\u200D\u{1F3A8}','\u{1F469}\u{1F3FB}\u200D\u{1F3EB}','\u{1F469}\u{1F3FB}\u200D\u{1F3ED}','\u{1F469}\u{1F3FB}\u200D\u{1F4BB}','\u{1F469}\u{1F3FB}\u200D\u{1F4BC}','\u{1F469}\u{1F3FB}\u200D\u{1F527}','\u{1F469}\u{1F3FB}\u200D\u{1F52C}','\u{1F469}\u{1F3FB}\u200D\u{1F680}','\u{1F469}\u{1F3FB}\u200D\u{1F692}','\u{1F469}\u{1F3FB}\u200D\u{1F9AF}','\u{1F469}\u{1F3FB}\u200D\u{1F9BC}','\u{1F469}\u{1F3FB}\u200D\u{1F9BD}','\u{1F469}\u{1F3FC}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FC}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FC}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FC}\u200D\u{1F33E}','\u{1F469}\u{1F3FC}\u200D\u{1F373}','\u{1F469}\u{1F3FC}\u200D\u{1F37C}','\u{1F469}\u{1F3FC}\u200D\u{1F393}','\u{1F469}\u{1F3FC}\u200D\u{1F3A4}','\u{1F469}\u{1F3FC}\u200D\u{1F3A8}','\u{1F469}\u{1F3FC}\u200D\u{1F3EB}','\u{1F469}\u{1F3FC}\u200D\u{1F3ED}','\u{1F469}\u{1F3FC}\u200D\u{1F4BB}','\u{1F469}\u{1F3FC}\u200D\u{1F4BC}','\u{1F469}\u{1F3FC}\u200D\u{1F527}','\u{1F469}\u{1F3FC}\u200D\u{1F52C}','\u{1F469}\u{1F3FC}\u200D\u{1F680}','\u{1F469}\u{1F3FC}\u200D\u{1F692}','\u{1F469}\u{1F3FC}\u200D\u{1F9AF}','\u{1F469}\u{1F3FC}\u200D\u{1F9BC}','\u{1F469}\u{1F3FC}\u200D\u{1F9BD}','\u{1F469}\u{1F3FD}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FD}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FD}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FD}\u200D\u{1F33E}','\u{1F469}\u{1F3FD}\u200D\u{1F373}','\u{1F469}\u{1F3FD}\u200D\u{1F37C}','\u{1F469}\u{1F3FD}\u200D\u{1F393}','\u{1F469}\u{1F3FD}\u200D\u{1F3A4}','\u{1F469}\u{1F3FD}\u200D\u{1F3A8}','\u{1F469}\u{1F3FD}\u200D\u{1F3EB}','\u{1F469}\u{1F3FD}\u200D\u{1F3ED}','\u{1F469}\u{1F3FD}\u200D\u{1F4BB}','\u{1F469}\u{1F3FD}\u200D\u{1F4BC}','\u{1F469}\u{1F3FD}\u200D\u{1F527}','\u{1F469}\u{1F3FD}\u200D\u{1F52C}','\u{1F469}\u{1F3FD}\u200D\u{1F680}','\u{1F469}\u{1F3FD}\u200D\u{1F692}','\u{1F469}\u{1F3FD}\u200D\u{1F9AF}','\u{1F469}\u{1F3FD}\u200D\u{1F9BC}','\u{1F469}\u{1F3FD}\u200D\u{1F9BD}','\u{1F469}\u{1F3FE}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FE}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FE}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FE}\u200D\u{1F33E}','\u{1F469}\u{1F3FE}\u200D\u{1F373}','\u{1F469}\u{1F3FE}\u200D\u{1F37C}','\u{1F469}\u{1F3FE}\u200D\u{1F393}','\u{1F469}\u{1F3FE}\u200D\u{1F3A4}','\u{1F469}\u{1F3FE}\u200D\u{1F3A8}','\u{1F469}\u{1F3FE}\u200D\u{1F3EB}','\u{1F469}\u{1F3FE}\u200D\u{1F3ED}','\u{1F469}\u{1F3FE}\u200D\u{1F4BB}','\u{1F469}\u{1F3FE}\u200D\u{1F4BC}','\u{1F469}\u{1F3FE}\u200D\u{1F527}','\u{1F469}\u{1F3FE}\u200D\u{1F52C}','\u{1F469}\u{1F3FE}\u200D\u{1F680}','\u{1F469}\u{1F3FE}\u200D\u{1F692}','\u{1F469}\u{1F3FE}\u200D\u{1F9AF}','\u{1F469}\u{1F3FE}\u200D\u{1F9BC}','\u{1F469}\u{1F3FE}\u200D\u{1F9BD}','\u{1F469}\u{1F3FF}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FF}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FF}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FF}\u200D\u{1F33E}','\u{1F469}\u{1F3FF}\u200D\u{1F373}','\u{1F469}\u{1F3FF}\u200D\u{1F37C}','\u{1F469}\u{1F3FF}\u200D\u{1F393}','\u{1F469}\u{1F3FF}\u200D\u{1F3A4}','\u{1F469}\u{1F3FF}\u200D\u{1F3A8}','\u{1F469}\u{1F3FF}\u200D\u{1F3EB}','\u{1F469}\u{1F3FF}\u200D\u{1F3ED}','\u{1F469}\u{1F3FF}\u200D\u{1F4BB}','\u{1F469}\u{1F3FF}\u200D\u{1F4BC}','\u{1F469}\u{1F3FF}\u200D\u{1F527}','\u{1F469}\u{1F3FF}\u200D\u{1F52C}','\u{1F469}\u{1F3FF}\u200D\u{1F680}','\u{1F469}\u{1F3FF}\u200D\u{1F692}','\u{1F469}\u{1F3FF}\u200D\u{1F9AF}','\u{1F469}\u{1F3FF}\u200D\u{1F9BC}','\u{1F469}\u{1F3FF}\u200D\u{1F9BD}','\u{1F9D1}\u200D\u2695\uFE0F','\u{1F9D1}\u200D\u2696\uFE0F','\u{1F9D1}\u200D\u2708\uFE0F','\u{1F9D1}\u200D\u{1F33E}','\u{1F9D1}\u200D\u{1F373}','\u{1F9D1}\u200D\u{1F37C}','\u{1F9D1}\u200D\u{1F393}','\u{1F9D1}\u200D\u{1F3A4}','\u{1F9D1}\u200D\u{1F3A8}','\u{1F9D1}\u200D\u{1F3EB}','\u{1F9D1}\u200D\u{1F3ED}','\u{1F9D1}\u200D\u{1F4BB}','\u{1F9D1}\u200D\u{1F4BC}','\u{1F9D1}\u200D\u{1F527}','\u{1F9D1}\u200D\u{1F52C}','\u{1F9D1}\u200D\u{1F680}','\u{1F9D1}\u200D\u{1F692}','\u{1F9D1}\u200D\u{1F9AF}','\u{1F9D1}\u200D\u{1F9BC}','\u{1F9D1}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FB}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FB}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FB}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FB}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FB}\u200D\u{1F373}','\u{1F9D1}\u{1F3FB}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FB}\u200D\u{1F393}','\u{1F9D1}\u{1F3FB}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FB}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FB}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FB}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FB}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FB}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FB}\u200D\u{1F527}','\u{1F9D1}\u{1F3FB}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FB}\u200D\u{1F680}','\u{1F9D1}\u{1F3FB}\u200D\u{1F692}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FC}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FC}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FC}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FC}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FC}\u200D\u{1F373}','\u{1F9D1}\u{1F3FC}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FC}\u200D\u{1F393}','\u{1F9D1}\u{1F3FC}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FC}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FC}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FC}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FC}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FC}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FC}\u200D\u{1F527}','\u{1F9D1}\u{1F3FC}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FC}\u200D\u{1F680}','\u{1F9D1}\u{1F3FC}\u200D\u{1F692}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FD}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FD}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FD}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FD}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FD}\u200D\u{1F373}','\u{1F9D1}\u{1F3FD}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FD}\u200D\u{1F393}','\u{1F9D1}\u{1F3FD}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FD}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FD}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FD}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FD}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FD}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FD}\u200D\u{1F527}','\u{1F9D1}\u{1F3FD}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FD}\u200D\u{1F680}','\u{1F9D1}\u{1F3FD}\u200D\u{1F692}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FE}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FE}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FE}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FE}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FE}\u200D\u{1F373}','\u{1F9D1}\u{1F3FE}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FE}\u200D\u{1F393}','\u{1F9D1}\u{1F3FE}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FE}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FE}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FE}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FE}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FE}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FE}\u200D\u{1F527}','\u{1F9D1}\u{1F3FE}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FE}\u200D\u{1F680}','\u{1F9D1}\u{1F3FE}\u200D\u{1F692}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FF}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FF}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FF}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FF}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FF}\u200D\u{1F373}','\u{1F9D1}\u{1F3FF}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FF}\u200D\u{1F393}','\u{1F9D1}\u{1F3FF}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FF}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FF}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FF}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FF}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FF}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FF}\u200D\u{1F527}','\u{1F9D1}\u{1F3FF}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FF}\u200D\u{1F680}','\u{1F9D1}\u{1F3FF}\u200D\u{1F692}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9BD}','\u26F9\u{1F3FB}\u200D\u2640\uFE0F','\u26F9\u{1F3FB}\u200D\u2642\uFE0F','\u26F9\u{1F3FC}\u200D\u2640\uFE0F','\u26F9\u{1F3FC}\u200D\u2642\uFE0F','\u26F9\u{1F3FD}\u200D\u2640\uFE0F','\u26F9\u{1F3FD}\u200D\u2642\uFE0F','\u26F9\u{1F3FE}\u200D\u2640\uFE0F','\u26F9\u{1F3FE}\u200D\u2642\uFE0F','\u26F9\u{1F3FF}\u200D\u2640\uFE0F','\u26F9\u{1F3FF}\u200D\u2642\uFE0F','\u26F9\uFE0F\u200D\u2640\uFE0F','\u26F9\uFE0F\u200D\u2642\uFE0F','\u{1F3C3}\u200D\u2640\uFE0F','\u{1F3C3}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3C4}\u200D\u2640\uFE0F','\u{1F3C4}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3CA}\u200D\u2640\uFE0F','\u{1F3CA}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3CB}\uFE0F\u200D\u2640\uFE0F','\u{1F3CB}\uFE0F\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3CC}\uFE0F\u200D\u2640\uFE0F','\u{1F3CC}\uFE0F\u200D\u2642\uFE0F','\u{1F46E}\u200D\u2640\uFE0F','\u{1F46E}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F46F}\u200D\u2640\uFE0F','\u{1F46F}\u200D\u2642\uFE0F','\u{1F470}\u200D\u2640\uFE0F','\u{1F470}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F471}\u200D\u2640\uFE0F','\u{1F471}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F473}\u200D\u2640\uFE0F','\u{1F473}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F477}\u200D\u2640\uFE0F','\u{1F477}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F481}\u200D\u2640\uFE0F','\u{1F481}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F482}\u200D\u2640\uFE0F','\u{1F482}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F486}\u200D\u2640\uFE0F','\u{1F486}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F487}\u200D\u2640\uFE0F','\u{1F487}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F575}\uFE0F\u200D\u2640\uFE0F','\u{1F575}\uFE0F\u200D\u2642\uFE0F','\u{1F645}\u200D\u2640\uFE0F','\u{1F645}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F646}\u200D\u2640\uFE0F','\u{1F646}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F647}\u200D\u2640\uFE0F','\u{1F647}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F64B}\u200D\u2640\uFE0F','\u{1F64B}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F64D}\u200D\u2640\uFE0F','\u{1F64D}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F64E}\u200D\u2640\uFE0F','\u{1F64E}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F6A3}\u200D\u2640\uFE0F','\u{1F6A3}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F6B4}\u200D\u2640\uFE0F','\u{1F6B4}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F6B5}\u200D\u2640\uFE0F','\u{1F6B5}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F6B6}\u200D\u2640\uFE0F','\u{1F6B6}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F926}\u200D\u2640\uFE0F','\u{1F926}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F935}\u200D\u2640\uFE0F','\u{1F935}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F937}\u200D\u2640\uFE0F','\u{1F937}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F938}\u200D\u2640\uFE0F','\u{1F938}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F939}\u200D\u2640\uFE0F','\u{1F939}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F93C}\u200D\u2640\uFE0F','\u{1F93C}\u200D\u2642\uFE0F','\u{1F93D}\u200D\u2640\uFE0F','\u{1F93D}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F93E}\u200D\u2640\uFE0F','\u{1F93E}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9B8}\u200D\u2640\uFE0F','\u{1F9B8}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9B9}\u200D\u2640\uFE0F','\u{1F9B9}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9CD}\u200D\u2640\uFE0F','\u{1F9CD}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9CE}\u200D\u2640\uFE0F','\u{1F9CE}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9CF}\u200D\u2640\uFE0F','\u{1F9CF}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D4}\u200D\u2640\uFE0F','\u{1F9D4}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D6}\u200D\u2640\uFE0F','\u{1F9D6}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D7}\u200D\u2640\uFE0F','\u{1F9D7}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D8}\u200D\u2640\uFE0F','\u{1F9D8}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D9}\u200D\u2640\uFE0F','\u{1F9D9}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DA}\u200D\u2640\uFE0F','\u{1F9DA}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DB}\u200D\u2640\uFE0F','\u{1F9DB}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DC}\u200D\u2640\uFE0F','\u{1F9DC}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DD}\u200D\u2640\uFE0F','\u{1F9DD}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DE}\u200D\u2640\uFE0F','\u{1F9DE}\u200D\u2642\uFE0F','\u{1F9DF}\u200D\u2640\uFE0F','\u{1F9DF}\u200D\u2642\uFE0F','\u{1F468}\u200D\u{1F9B0}','\u{1F468}\u200D\u{1F9B1}','\u{1F468}\u200D\u{1F9B2}','\u{1F468}\u200D\u{1F9B3}','\u{1F468}\u{1F3FB}\u200D\u{1F9B0}','\u{1F468}\u{1F3FB}\u200D\u{1F9B1}','\u{1F468}\u{1F3FB}\u200D\u{1F9B2}','\u{1F468}\u{1F3FB}\u200D\u{1F9B3}','\u{1F468}\u{1F3FC}\u200D\u{1F9B0}','\u{1F468}\u{1F3FC}\u200D\u{1F9B1}','\u{1F468}\u{1F3FC}\u200D\u{1F9B2}','\u{1F468}\u{1F3FC}\u200D\u{1F9B3}','\u{1F468}\u{1F3FD}\u200D\u{1F9B0}','\u{1F468}\u{1F3FD}\u200D\u{1F9B1}','\u{1F468}\u{1F3FD}\u200D\u{1F9B2}','\u{1F468}\u{1F3FD}\u200D\u{1F9B3}','\u{1F468}\u{1F3FE}\u200D\u{1F9B0}','\u{1F468}\u{1F3FE}\u200D\u{1F9B1}','\u{1F468}\u{1F3FE}\u200D\u{1F9B2}','\u{1F468}\u{1F3FE}\u200D\u{1F9B3}','\u{1F468}\u{1F3FF}\u200D\u{1F9B0}','\u{1F468}\u{1F3FF}\u200D\u{1F9B1}','\u{1F468}\u{1F3FF}\u200D\u{1F9B2}','\u{1F468}\u{1F3FF}\u200D\u{1F9B3}','\u{1F469}\u200D\u{1F9B0}','\u{1F469}\u200D\u{1F9B1}','\u{1F469}\u200D\u{1F9B2}','\u{1F469}\u200D\u{1F9B3}','\u{1F469}\u{1F3FB}\u200D\u{1F9B0}','\u{1F469}\u{1F3FB}\u200D\u{1F9B1}','\u{1F469}\u{1F3FB}\u200D\u{1F9B2}','\u{1F469}\u{1F3FB}\u200D\u{1F9B3}','\u{1F469}\u{1F3FC}\u200D\u{1F9B0}','\u{1F469}\u{1F3FC}\u200D\u{1F9B1}','\u{1F469}\u{1F3FC}\u200D\u{1F9B2}','\u{1F469}\u{1F3FC}\u200D\u{1F9B3}','\u{1F469}\u{1F3FD}\u200D\u{1F9B0}','\u{1F469}\u{1F3FD}\u200D\u{1F9B1}','\u{1F469}\u{1F3FD}\u200D\u{1F9B2}','\u{1F469}\u{1F3FD}\u200D\u{1F9B3}','\u{1F469}\u{1F3FE}\u200D\u{1F9B0}','\u{1F469}\u{1F3FE}\u200D\u{1F9B1}','\u{1F469}\u{1F3FE}\u200D\u{1F9B2}','\u{1F469}\u{1F3FE}\u200D\u{1F9B3}','\u{1F469}\u{1F3FF}\u200D\u{1F9B0}','\u{1F469}\u{1F3FF}\u200D\u{1F9B1}','\u{1F469}\u{1F3FF}\u200D\u{1F9B2}','\u{1F469}\u{1F3FF}\u200D\u{1F9B3}','\u{1F9D1}\u200D\u{1F9B0}','\u{1F9D1}\u200D\u{1F9B1}','\u{1F9D1}\u200D\u{1F9B2}','\u{1F9D1}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9B3}','\u2764\uFE0F\u200D\u{1F525}','\u2764\uFE0F\u200D\u{1FA79}','\u{1F3F3}\uFE0F\u200D\u26A7\uFE0F','\u{1F3F3}\uFE0F\u200D\u{1F308}','\u{1F3F4}\u200D\u2620\uFE0F','\u{1F408}\u200D\u2B1B','\u{1F415}\u200D\u{1F9BA}','\u{1F43B}\u200D\u2744\uFE0F','\u{1F441}\uFE0F\u200D\u{1F5E8}\uFE0F','\u{1F62E}\u200D\u{1F4A8}','\u{1F635}\u200D\u{1F4AB}','\u{1F636}\u200D\u{1F32B}\uFE0F','\u{1F9D1}\u200D\u{1F384}'];

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji.js", function (module, exports) {
	  const set = regenerate(0x23F0, 0x23F3, 0x267F, 0x2693, 0x26A1, 0x26CE, 0x26D4, 0x26EA, 0x26F5, 0x26FA, 0x26FD, 0x2705, 0x2728, 0x274C, 0x274E, 0x2757, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x1F004, 0x1F0CF, 0x1F18E, 0x1F201, 0x1F21A, 0x1F22F, 0x1F3F4, 0x1F440, 0x1F57A, 0x1F5A4, 0x1F6CC, 0x1F7F0);
	set.addRange(0x231A, 0x231B).addRange(0x23E9, 0x23EC).addRange(0x25FD, 0x25FE).addRange(0x2614, 0x2615).addRange(0x2648, 0x2653).addRange(0x26AA, 0x26AB).addRange(0x26BD, 0x26BE).addRange(0x26C4, 0x26C5).addRange(0x26F2, 0x26F3).addRange(0x270A, 0x270B).addRange(0x2753, 0x2755).addRange(0x2795, 0x2797).addRange(0x2B1B, 0x2B1C).addRange(0x1F191, 0x1F19A).addRange(0x1F232, 0x1F236).addRange(0x1F238, 0x1F23A).addRange(0x1F250, 0x1F251).addRange(0x1F300, 0x1F320).addRange(0x1F32D, 0x1F335).addRange(0x1F337, 0x1F37C).addRange(0x1F37E, 0x1F393).addRange(0x1F3A0, 0x1F3CA).addRange(0x1F3CF, 0x1F3D3).addRange(0x1F3E0, 0x1F3F0).addRange(0x1F3F8, 0x1F43E).addRange(0x1F442, 0x1F4FC).addRange(0x1F4FF, 0x1F53D).addRange(0x1F54B, 0x1F54E).addRange(0x1F550, 0x1F567).addRange(0x1F595, 0x1F596).addRange(0x1F5FB, 0x1F64F).addRange(0x1F680, 0x1F6C5).addRange(0x1F6D0, 0x1F6D2).addRange(0x1F6D5, 0x1F6D7).addRange(0x1F6DD, 0x1F6DF).addRange(0x1F6EB, 0x1F6EC).addRange(0x1F6F4, 0x1F6FC).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1F9FF).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6);
	exports.characters = set;
	exports.strings = ['#\uFE0F\u20E3','*\uFE0F\u20E3','0\uFE0F\u20E3','1\uFE0F\u20E3','2\uFE0F\u20E3','3\uFE0F\u20E3','4\uFE0F\u20E3','5\uFE0F\u20E3','6\uFE0F\u20E3','7\uFE0F\u20E3','8\uFE0F\u20E3','9\uFE0F\u20E3','\xA9\uFE0F','\xAE\uFE0F','\u203C\uFE0F','\u2049\uFE0F','\u2122\uFE0F','\u2139\uFE0F','\u2194\uFE0F','\u2195\uFE0F','\u2196\uFE0F','\u2197\uFE0F','\u2198\uFE0F','\u2199\uFE0F','\u21A9\uFE0F','\u21AA\uFE0F','\u2328\uFE0F','\u23CF\uFE0F','\u23ED\uFE0F','\u23EE\uFE0F','\u23EF\uFE0F','\u23F1\uFE0F','\u23F2\uFE0F','\u23F8\uFE0F','\u23F9\uFE0F','\u23FA\uFE0F','\u24C2\uFE0F','\u25AA\uFE0F','\u25AB\uFE0F','\u25B6\uFE0F','\u25C0\uFE0F','\u25FB\uFE0F','\u25FC\uFE0F','\u2600\uFE0F','\u2601\uFE0F','\u2602\uFE0F','\u2603\uFE0F','\u2604\uFE0F','\u260E\uFE0F','\u2611\uFE0F','\u2618\uFE0F','\u261D\u{1F3FB}','\u261D\u{1F3FC}','\u261D\u{1F3FD}','\u261D\u{1F3FE}','\u261D\u{1F3FF}','\u261D\uFE0F','\u2620\uFE0F','\u2622\uFE0F','\u2623\uFE0F','\u2626\uFE0F','\u262A\uFE0F','\u262E\uFE0F','\u262F\uFE0F','\u2638\uFE0F','\u2639\uFE0F','\u263A\uFE0F','\u2640\uFE0F','\u2642\uFE0F','\u265F\uFE0F','\u2660\uFE0F','\u2663\uFE0F','\u2665\uFE0F','\u2666\uFE0F','\u2668\uFE0F','\u267B\uFE0F','\u267E\uFE0F','\u2692\uFE0F','\u2694\uFE0F','\u2695\uFE0F','\u2696\uFE0F','\u2697\uFE0F','\u2699\uFE0F','\u269B\uFE0F','\u269C\uFE0F','\u26A0\uFE0F','\u26A7\uFE0F','\u26B0\uFE0F','\u26B1\uFE0F','\u26C8\uFE0F','\u26CF\uFE0F','\u26D1\uFE0F','\u26D3\uFE0F','\u26E9\uFE0F','\u26F0\uFE0F','\u26F1\uFE0F','\u26F4\uFE0F','\u26F7\uFE0F','\u26F8\uFE0F','\u26F9\u{1F3FB}','\u26F9\u{1F3FB}\u200D\u2640\uFE0F','\u26F9\u{1F3FB}\u200D\u2642\uFE0F','\u26F9\u{1F3FC}','\u26F9\u{1F3FC}\u200D\u2640\uFE0F','\u26F9\u{1F3FC}\u200D\u2642\uFE0F','\u26F9\u{1F3FD}','\u26F9\u{1F3FD}\u200D\u2640\uFE0F','\u26F9\u{1F3FD}\u200D\u2642\uFE0F','\u26F9\u{1F3FE}','\u26F9\u{1F3FE}\u200D\u2640\uFE0F','\u26F9\u{1F3FE}\u200D\u2642\uFE0F','\u26F9\u{1F3FF}','\u26F9\u{1F3FF}\u200D\u2640\uFE0F','\u26F9\u{1F3FF}\u200D\u2642\uFE0F','\u26F9\uFE0F','\u26F9\uFE0F\u200D\u2640\uFE0F','\u26F9\uFE0F\u200D\u2642\uFE0F','\u2702\uFE0F','\u2708\uFE0F','\u2709\uFE0F','\u270A\u{1F3FB}','\u270A\u{1F3FC}','\u270A\u{1F3FD}','\u270A\u{1F3FE}','\u270A\u{1F3FF}','\u270B\u{1F3FB}','\u270B\u{1F3FC}','\u270B\u{1F3FD}','\u270B\u{1F3FE}','\u270B\u{1F3FF}','\u270C\u{1F3FB}','\u270C\u{1F3FC}','\u270C\u{1F3FD}','\u270C\u{1F3FE}','\u270C\u{1F3FF}','\u270C\uFE0F','\u270D\u{1F3FB}','\u270D\u{1F3FC}','\u270D\u{1F3FD}','\u270D\u{1F3FE}','\u270D\u{1F3FF}','\u270D\uFE0F','\u270F\uFE0F','\u2712\uFE0F','\u2714\uFE0F','\u2716\uFE0F','\u271D\uFE0F','\u2721\uFE0F','\u2733\uFE0F','\u2734\uFE0F','\u2744\uFE0F','\u2747\uFE0F','\u2763\uFE0F','\u2764\uFE0F','\u2764\uFE0F\u200D\u{1F525}','\u2764\uFE0F\u200D\u{1FA79}','\u27A1\uFE0F','\u2934\uFE0F','\u2935\uFE0F','\u2B05\uFE0F','\u2B06\uFE0F','\u2B07\uFE0F','\u3030\uFE0F','\u303D\uFE0F','\u3297\uFE0F','\u3299\uFE0F','\u{1F170}\uFE0F','\u{1F171}\uFE0F','\u{1F17E}\uFE0F','\u{1F17F}\uFE0F','\u{1F1E6}\u{1F1E8}','\u{1F1E6}\u{1F1E9}','\u{1F1E6}\u{1F1EA}','\u{1F1E6}\u{1F1EB}','\u{1F1E6}\u{1F1EC}','\u{1F1E6}\u{1F1EE}','\u{1F1E6}\u{1F1F1}','\u{1F1E6}\u{1F1F2}','\u{1F1E6}\u{1F1F4}','\u{1F1E6}\u{1F1F6}','\u{1F1E6}\u{1F1F7}','\u{1F1E6}\u{1F1F8}','\u{1F1E6}\u{1F1F9}','\u{1F1E6}\u{1F1FA}','\u{1F1E6}\u{1F1FC}','\u{1F1E6}\u{1F1FD}','\u{1F1E6}\u{1F1FF}','\u{1F1E7}\u{1F1E6}','\u{1F1E7}\u{1F1E7}','\u{1F1E7}\u{1F1E9}','\u{1F1E7}\u{1F1EA}','\u{1F1E7}\u{1F1EB}','\u{1F1E7}\u{1F1EC}','\u{1F1E7}\u{1F1ED}','\u{1F1E7}\u{1F1EE}','\u{1F1E7}\u{1F1EF}','\u{1F1E7}\u{1F1F1}','\u{1F1E7}\u{1F1F2}','\u{1F1E7}\u{1F1F3}','\u{1F1E7}\u{1F1F4}','\u{1F1E7}\u{1F1F6}','\u{1F1E7}\u{1F1F7}','\u{1F1E7}\u{1F1F8}','\u{1F1E7}\u{1F1F9}','\u{1F1E7}\u{1F1FB}','\u{1F1E7}\u{1F1FC}','\u{1F1E7}\u{1F1FE}','\u{1F1E7}\u{1F1FF}','\u{1F1E8}\u{1F1E6}','\u{1F1E8}\u{1F1E8}','\u{1F1E8}\u{1F1E9}','\u{1F1E8}\u{1F1EB}','\u{1F1E8}\u{1F1EC}','\u{1F1E8}\u{1F1ED}','\u{1F1E8}\u{1F1EE}','\u{1F1E8}\u{1F1F0}','\u{1F1E8}\u{1F1F1}','\u{1F1E8}\u{1F1F2}','\u{1F1E8}\u{1F1F3}','\u{1F1E8}\u{1F1F4}','\u{1F1E8}\u{1F1F5}','\u{1F1E8}\u{1F1F7}','\u{1F1E8}\u{1F1FA}','\u{1F1E8}\u{1F1FB}','\u{1F1E8}\u{1F1FC}','\u{1F1E8}\u{1F1FD}','\u{1F1E8}\u{1F1FE}','\u{1F1E8}\u{1F1FF}','\u{1F1E9}\u{1F1EA}','\u{1F1E9}\u{1F1EC}','\u{1F1E9}\u{1F1EF}','\u{1F1E9}\u{1F1F0}','\u{1F1E9}\u{1F1F2}','\u{1F1E9}\u{1F1F4}','\u{1F1E9}\u{1F1FF}','\u{1F1EA}\u{1F1E6}','\u{1F1EA}\u{1F1E8}','\u{1F1EA}\u{1F1EA}','\u{1F1EA}\u{1F1EC}','\u{1F1EA}\u{1F1ED}','\u{1F1EA}\u{1F1F7}','\u{1F1EA}\u{1F1F8}','\u{1F1EA}\u{1F1F9}','\u{1F1EA}\u{1F1FA}','\u{1F1EB}\u{1F1EE}','\u{1F1EB}\u{1F1EF}','\u{1F1EB}\u{1F1F0}','\u{1F1EB}\u{1F1F2}','\u{1F1EB}\u{1F1F4}','\u{1F1EB}\u{1F1F7}','\u{1F1EC}\u{1F1E6}','\u{1F1EC}\u{1F1E7}','\u{1F1EC}\u{1F1E9}','\u{1F1EC}\u{1F1EA}','\u{1F1EC}\u{1F1EB}','\u{1F1EC}\u{1F1EC}','\u{1F1EC}\u{1F1ED}','\u{1F1EC}\u{1F1EE}','\u{1F1EC}\u{1F1F1}','\u{1F1EC}\u{1F1F2}','\u{1F1EC}\u{1F1F3}','\u{1F1EC}\u{1F1F5}','\u{1F1EC}\u{1F1F6}','\u{1F1EC}\u{1F1F7}','\u{1F1EC}\u{1F1F8}','\u{1F1EC}\u{1F1F9}','\u{1F1EC}\u{1F1FA}','\u{1F1EC}\u{1F1FC}','\u{1F1EC}\u{1F1FE}','\u{1F1ED}\u{1F1F0}','\u{1F1ED}\u{1F1F2}','\u{1F1ED}\u{1F1F3}','\u{1F1ED}\u{1F1F7}','\u{1F1ED}\u{1F1F9}','\u{1F1ED}\u{1F1FA}','\u{1F1EE}\u{1F1E8}','\u{1F1EE}\u{1F1E9}','\u{1F1EE}\u{1F1EA}','\u{1F1EE}\u{1F1F1}','\u{1F1EE}\u{1F1F2}','\u{1F1EE}\u{1F1F3}','\u{1F1EE}\u{1F1F4}','\u{1F1EE}\u{1F1F6}','\u{1F1EE}\u{1F1F7}','\u{1F1EE}\u{1F1F8}','\u{1F1EE}\u{1F1F9}','\u{1F1EF}\u{1F1EA}','\u{1F1EF}\u{1F1F2}','\u{1F1EF}\u{1F1F4}','\u{1F1EF}\u{1F1F5}','\u{1F1F0}\u{1F1EA}','\u{1F1F0}\u{1F1EC}','\u{1F1F0}\u{1F1ED}','\u{1F1F0}\u{1F1EE}','\u{1F1F0}\u{1F1F2}','\u{1F1F0}\u{1F1F3}','\u{1F1F0}\u{1F1F5}','\u{1F1F0}\u{1F1F7}','\u{1F1F0}\u{1F1FC}','\u{1F1F0}\u{1F1FE}','\u{1F1F0}\u{1F1FF}','\u{1F1F1}\u{1F1E6}','\u{1F1F1}\u{1F1E7}','\u{1F1F1}\u{1F1E8}','\u{1F1F1}\u{1F1EE}','\u{1F1F1}\u{1F1F0}','\u{1F1F1}\u{1F1F7}','\u{1F1F1}\u{1F1F8}','\u{1F1F1}\u{1F1F9}','\u{1F1F1}\u{1F1FA}','\u{1F1F1}\u{1F1FB}','\u{1F1F1}\u{1F1FE}','\u{1F1F2}\u{1F1E6}','\u{1F1F2}\u{1F1E8}','\u{1F1F2}\u{1F1E9}','\u{1F1F2}\u{1F1EA}','\u{1F1F2}\u{1F1EB}','\u{1F1F2}\u{1F1EC}','\u{1F1F2}\u{1F1ED}','\u{1F1F2}\u{1F1F0}','\u{1F1F2}\u{1F1F1}','\u{1F1F2}\u{1F1F2}','\u{1F1F2}\u{1F1F3}','\u{1F1F2}\u{1F1F4}','\u{1F1F2}\u{1F1F5}','\u{1F1F2}\u{1F1F6}','\u{1F1F2}\u{1F1F7}','\u{1F1F2}\u{1F1F8}','\u{1F1F2}\u{1F1F9}','\u{1F1F2}\u{1F1FA}','\u{1F1F2}\u{1F1FB}','\u{1F1F2}\u{1F1FC}','\u{1F1F2}\u{1F1FD}','\u{1F1F2}\u{1F1FE}','\u{1F1F2}\u{1F1FF}','\u{1F1F3}\u{1F1E6}','\u{1F1F3}\u{1F1E8}','\u{1F1F3}\u{1F1EA}','\u{1F1F3}\u{1F1EB}','\u{1F1F3}\u{1F1EC}','\u{1F1F3}\u{1F1EE}','\u{1F1F3}\u{1F1F1}','\u{1F1F3}\u{1F1F4}','\u{1F1F3}\u{1F1F5}','\u{1F1F3}\u{1F1F7}','\u{1F1F3}\u{1F1FA}','\u{1F1F3}\u{1F1FF}','\u{1F1F4}\u{1F1F2}','\u{1F1F5}\u{1F1E6}','\u{1F1F5}\u{1F1EA}','\u{1F1F5}\u{1F1EB}','\u{1F1F5}\u{1F1EC}','\u{1F1F5}\u{1F1ED}','\u{1F1F5}\u{1F1F0}','\u{1F1F5}\u{1F1F1}','\u{1F1F5}\u{1F1F2}','\u{1F1F5}\u{1F1F3}','\u{1F1F5}\u{1F1F7}','\u{1F1F5}\u{1F1F8}','\u{1F1F5}\u{1F1F9}','\u{1F1F5}\u{1F1FC}','\u{1F1F5}\u{1F1FE}','\u{1F1F6}\u{1F1E6}','\u{1F1F7}\u{1F1EA}','\u{1F1F7}\u{1F1F4}','\u{1F1F7}\u{1F1F8}','\u{1F1F7}\u{1F1FA}','\u{1F1F7}\u{1F1FC}','\u{1F1F8}\u{1F1E6}','\u{1F1F8}\u{1F1E7}','\u{1F1F8}\u{1F1E8}','\u{1F1F8}\u{1F1E9}','\u{1F1F8}\u{1F1EA}','\u{1F1F8}\u{1F1EC}','\u{1F1F8}\u{1F1ED}','\u{1F1F8}\u{1F1EE}','\u{1F1F8}\u{1F1EF}','\u{1F1F8}\u{1F1F0}','\u{1F1F8}\u{1F1F1}','\u{1F1F8}\u{1F1F2}','\u{1F1F8}\u{1F1F3}','\u{1F1F8}\u{1F1F4}','\u{1F1F8}\u{1F1F7}','\u{1F1F8}\u{1F1F8}','\u{1F1F8}\u{1F1F9}','\u{1F1F8}\u{1F1FB}','\u{1F1F8}\u{1F1FD}','\u{1F1F8}\u{1F1FE}','\u{1F1F8}\u{1F1FF}','\u{1F1F9}\u{1F1E6}','\u{1F1F9}\u{1F1E8}','\u{1F1F9}\u{1F1E9}','\u{1F1F9}\u{1F1EB}','\u{1F1F9}\u{1F1EC}','\u{1F1F9}\u{1F1ED}','\u{1F1F9}\u{1F1EF}','\u{1F1F9}\u{1F1F0}','\u{1F1F9}\u{1F1F1}','\u{1F1F9}\u{1F1F2}','\u{1F1F9}\u{1F1F3}','\u{1F1F9}\u{1F1F4}','\u{1F1F9}\u{1F1F7}','\u{1F1F9}\u{1F1F9}','\u{1F1F9}\u{1F1FB}','\u{1F1F9}\u{1F1FC}','\u{1F1F9}\u{1F1FF}','\u{1F1FA}\u{1F1E6}','\u{1F1FA}\u{1F1EC}','\u{1F1FA}\u{1F1F2}','\u{1F1FA}\u{1F1F3}','\u{1F1FA}\u{1F1F8}','\u{1F1FA}\u{1F1FE}','\u{1F1FA}\u{1F1FF}','\u{1F1FB}\u{1F1E6}','\u{1F1FB}\u{1F1E8}','\u{1F1FB}\u{1F1EA}','\u{1F1FB}\u{1F1EC}','\u{1F1FB}\u{1F1EE}','\u{1F1FB}\u{1F1F3}','\u{1F1FB}\u{1F1FA}','\u{1F1FC}\u{1F1EB}','\u{1F1FC}\u{1F1F8}','\u{1F1FD}\u{1F1F0}','\u{1F1FE}\u{1F1EA}','\u{1F1FE}\u{1F1F9}','\u{1F1FF}\u{1F1E6}','\u{1F1FF}\u{1F1F2}','\u{1F1FF}\u{1F1FC}','\u{1F202}\uFE0F','\u{1F237}\uFE0F','\u{1F321}\uFE0F','\u{1F324}\uFE0F','\u{1F325}\uFE0F','\u{1F326}\uFE0F','\u{1F327}\uFE0F','\u{1F328}\uFE0F','\u{1F329}\uFE0F','\u{1F32A}\uFE0F','\u{1F32B}\uFE0F','\u{1F32C}\uFE0F','\u{1F336}\uFE0F','\u{1F37D}\uFE0F','\u{1F385}\u{1F3FB}','\u{1F385}\u{1F3FC}','\u{1F385}\u{1F3FD}','\u{1F385}\u{1F3FE}','\u{1F385}\u{1F3FF}','\u{1F396}\uFE0F','\u{1F397}\uFE0F','\u{1F399}\uFE0F','\u{1F39A}\uFE0F','\u{1F39B}\uFE0F','\u{1F39E}\uFE0F','\u{1F39F}\uFE0F','\u{1F3C2}\u{1F3FB}','\u{1F3C2}\u{1F3FC}','\u{1F3C2}\u{1F3FD}','\u{1F3C2}\u{1F3FE}','\u{1F3C2}\u{1F3FF}','\u{1F3C3}\u200D\u2640\uFE0F','\u{1F3C3}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FB}','\u{1F3C3}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FC}','\u{1F3C3}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FD}','\u{1F3C3}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FE}','\u{1F3C3}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3C3}\u{1F3FF}','\u{1F3C3}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3C3}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3C4}\u200D\u2640\uFE0F','\u{1F3C4}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FB}','\u{1F3C4}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FC}','\u{1F3C4}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FD}','\u{1F3C4}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FE}','\u{1F3C4}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3C4}\u{1F3FF}','\u{1F3C4}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3C4}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3C7}\u{1F3FB}','\u{1F3C7}\u{1F3FC}','\u{1F3C7}\u{1F3FD}','\u{1F3C7}\u{1F3FE}','\u{1F3C7}\u{1F3FF}','\u{1F3CA}\u200D\u2640\uFE0F','\u{1F3CA}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FB}','\u{1F3CA}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FC}','\u{1F3CA}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FD}','\u{1F3CA}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FE}','\u{1F3CA}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3CA}\u{1F3FF}','\u{1F3CA}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3CA}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FB}','\u{1F3CB}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FC}','\u{1F3CB}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FD}','\u{1F3CB}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FE}','\u{1F3CB}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3CB}\u{1F3FF}','\u{1F3CB}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3CB}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3CB}\uFE0F','\u{1F3CB}\uFE0F\u200D\u2640\uFE0F','\u{1F3CB}\uFE0F\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FB}','\u{1F3CC}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FC}','\u{1F3CC}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FD}','\u{1F3CC}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FE}','\u{1F3CC}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F3CC}\u{1F3FF}','\u{1F3CC}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F3CC}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F3CC}\uFE0F','\u{1F3CC}\uFE0F\u200D\u2640\uFE0F','\u{1F3CC}\uFE0F\u200D\u2642\uFE0F','\u{1F3CD}\uFE0F','\u{1F3CE}\uFE0F','\u{1F3D4}\uFE0F','\u{1F3D5}\uFE0F','\u{1F3D6}\uFE0F','\u{1F3D7}\uFE0F','\u{1F3D8}\uFE0F','\u{1F3D9}\uFE0F','\u{1F3DA}\uFE0F','\u{1F3DB}\uFE0F','\u{1F3DC}\uFE0F','\u{1F3DD}\uFE0F','\u{1F3DE}\uFE0F','\u{1F3DF}\uFE0F','\u{1F3F3}\uFE0F','\u{1F3F3}\uFE0F\u200D\u26A7\uFE0F','\u{1F3F3}\uFE0F\u200D\u{1F308}','\u{1F3F4}\u200D\u2620\uFE0F','\u{1F3F4}\u{E0067}\u{E0062}\u{E0065}\u{E006E}\u{E0067}\u{E007F}','\u{1F3F4}\u{E0067}\u{E0062}\u{E0073}\u{E0063}\u{E0074}\u{E007F}','\u{1F3F4}\u{E0067}\u{E0062}\u{E0077}\u{E006C}\u{E0073}\u{E007F}','\u{1F3F5}\uFE0F','\u{1F3F7}\uFE0F','\u{1F408}\u200D\u2B1B','\u{1F415}\u200D\u{1F9BA}','\u{1F43B}\u200D\u2744\uFE0F','\u{1F43F}\uFE0F','\u{1F441}\uFE0F','\u{1F441}\uFE0F\u200D\u{1F5E8}\uFE0F','\u{1F442}\u{1F3FB}','\u{1F442}\u{1F3FC}','\u{1F442}\u{1F3FD}','\u{1F442}\u{1F3FE}','\u{1F442}\u{1F3FF}','\u{1F443}\u{1F3FB}','\u{1F443}\u{1F3FC}','\u{1F443}\u{1F3FD}','\u{1F443}\u{1F3FE}','\u{1F443}\u{1F3FF}','\u{1F446}\u{1F3FB}','\u{1F446}\u{1F3FC}','\u{1F446}\u{1F3FD}','\u{1F446}\u{1F3FE}','\u{1F446}\u{1F3FF}','\u{1F447}\u{1F3FB}','\u{1F447}\u{1F3FC}','\u{1F447}\u{1F3FD}','\u{1F447}\u{1F3FE}','\u{1F447}\u{1F3FF}','\u{1F448}\u{1F3FB}','\u{1F448}\u{1F3FC}','\u{1F448}\u{1F3FD}','\u{1F448}\u{1F3FE}','\u{1F448}\u{1F3FF}','\u{1F449}\u{1F3FB}','\u{1F449}\u{1F3FC}','\u{1F449}\u{1F3FD}','\u{1F449}\u{1F3FE}','\u{1F449}\u{1F3FF}','\u{1F44A}\u{1F3FB}','\u{1F44A}\u{1F3FC}','\u{1F44A}\u{1F3FD}','\u{1F44A}\u{1F3FE}','\u{1F44A}\u{1F3FF}','\u{1F44B}\u{1F3FB}','\u{1F44B}\u{1F3FC}','\u{1F44B}\u{1F3FD}','\u{1F44B}\u{1F3FE}','\u{1F44B}\u{1F3FF}','\u{1F44C}\u{1F3FB}','\u{1F44C}\u{1F3FC}','\u{1F44C}\u{1F3FD}','\u{1F44C}\u{1F3FE}','\u{1F44C}\u{1F3FF}','\u{1F44D}\u{1F3FB}','\u{1F44D}\u{1F3FC}','\u{1F44D}\u{1F3FD}','\u{1F44D}\u{1F3FE}','\u{1F44D}\u{1F3FF}','\u{1F44E}\u{1F3FB}','\u{1F44E}\u{1F3FC}','\u{1F44E}\u{1F3FD}','\u{1F44E}\u{1F3FE}','\u{1F44E}\u{1F3FF}','\u{1F44F}\u{1F3FB}','\u{1F44F}\u{1F3FC}','\u{1F44F}\u{1F3FD}','\u{1F44F}\u{1F3FE}','\u{1F44F}\u{1F3FF}','\u{1F450}\u{1F3FB}','\u{1F450}\u{1F3FC}','\u{1F450}\u{1F3FD}','\u{1F450}\u{1F3FE}','\u{1F450}\u{1F3FF}','\u{1F466}\u{1F3FB}','\u{1F466}\u{1F3FC}','\u{1F466}\u{1F3FD}','\u{1F466}\u{1F3FE}','\u{1F466}\u{1F3FF}','\u{1F467}\u{1F3FB}','\u{1F467}\u{1F3FC}','\u{1F467}\u{1F3FD}','\u{1F467}\u{1F3FE}','\u{1F467}\u{1F3FF}','\u{1F468}\u200D\u2695\uFE0F','\u{1F468}\u200D\u2696\uFE0F','\u{1F468}\u200D\u2708\uFE0F','\u{1F468}\u200D\u2764\uFE0F\u200D\u{1F468}','\u{1F468}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}','\u{1F468}\u200D\u{1F33E}','\u{1F468}\u200D\u{1F373}','\u{1F468}\u200D\u{1F37C}','\u{1F468}\u200D\u{1F393}','\u{1F468}\u200D\u{1F3A4}','\u{1F468}\u200D\u{1F3A8}','\u{1F468}\u200D\u{1F3EB}','\u{1F468}\u200D\u{1F3ED}','\u{1F468}\u200D\u{1F466}','\u{1F468}\u200D\u{1F466}\u200D\u{1F466}','\u{1F468}\u200D\u{1F467}','\u{1F468}\u200D\u{1F467}\u200D\u{1F466}','\u{1F468}\u200D\u{1F467}\u200D\u{1F467}','\u{1F468}\u200D\u{1F468}\u200D\u{1F466}','\u{1F468}\u200D\u{1F468}\u200D\u{1F466}\u200D\u{1F466}','\u{1F468}\u200D\u{1F468}\u200D\u{1F467}','\u{1F468}\u200D\u{1F468}\u200D\u{1F467}\u200D\u{1F466}','\u{1F468}\u200D\u{1F468}\u200D\u{1F467}\u200D\u{1F467}','\u{1F468}\u200D\u{1F469}\u200D\u{1F466}','\u{1F468}\u200D\u{1F469}\u200D\u{1F466}\u200D\u{1F466}','\u{1F468}\u200D\u{1F469}\u200D\u{1F467}','\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}','\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F467}','\u{1F468}\u200D\u{1F4BB}','\u{1F468}\u200D\u{1F4BC}','\u{1F468}\u200D\u{1F527}','\u{1F468}\u200D\u{1F52C}','\u{1F468}\u200D\u{1F680}','\u{1F468}\u200D\u{1F692}','\u{1F468}\u200D\u{1F9AF}','\u{1F468}\u200D\u{1F9B0}','\u{1F468}\u200D\u{1F9B1}','\u{1F468}\u200D\u{1F9B2}','\u{1F468}\u200D\u{1F9B3}','\u{1F468}\u200D\u{1F9BC}','\u{1F468}\u200D\u{1F9BD}','\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FB}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FB}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FB}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FB}\u200D\u{1F33E}','\u{1F468}\u{1F3FB}\u200D\u{1F373}','\u{1F468}\u{1F3FB}\u200D\u{1F37C}','\u{1F468}\u{1F3FB}\u200D\u{1F393}','\u{1F468}\u{1F3FB}\u200D\u{1F3A4}','\u{1F468}\u{1F3FB}\u200D\u{1F3A8}','\u{1F468}\u{1F3FB}\u200D\u{1F3EB}','\u{1F468}\u{1F3FB}\u200D\u{1F3ED}','\u{1F468}\u{1F3FB}\u200D\u{1F4BB}','\u{1F468}\u{1F3FB}\u200D\u{1F4BC}','\u{1F468}\u{1F3FB}\u200D\u{1F527}','\u{1F468}\u{1F3FB}\u200D\u{1F52C}','\u{1F468}\u{1F3FB}\u200D\u{1F680}','\u{1F468}\u{1F3FB}\u200D\u{1F692}','\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FB}\u200D\u{1F9AF}','\u{1F468}\u{1F3FB}\u200D\u{1F9B0}','\u{1F468}\u{1F3FB}\u200D\u{1F9B1}','\u{1F468}\u{1F3FB}\u200D\u{1F9B2}','\u{1F468}\u{1F3FB}\u200D\u{1F9B3}','\u{1F468}\u{1F3FB}\u200D\u{1F9BC}','\u{1F468}\u{1F3FB}\u200D\u{1F9BD}','\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FC}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FC}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FC}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FC}\u200D\u{1F33E}','\u{1F468}\u{1F3FC}\u200D\u{1F373}','\u{1F468}\u{1F3FC}\u200D\u{1F37C}','\u{1F468}\u{1F3FC}\u200D\u{1F393}','\u{1F468}\u{1F3FC}\u200D\u{1F3A4}','\u{1F468}\u{1F3FC}\u200D\u{1F3A8}','\u{1F468}\u{1F3FC}\u200D\u{1F3EB}','\u{1F468}\u{1F3FC}\u200D\u{1F3ED}','\u{1F468}\u{1F3FC}\u200D\u{1F4BB}','\u{1F468}\u{1F3FC}\u200D\u{1F4BC}','\u{1F468}\u{1F3FC}\u200D\u{1F527}','\u{1F468}\u{1F3FC}\u200D\u{1F52C}','\u{1F468}\u{1F3FC}\u200D\u{1F680}','\u{1F468}\u{1F3FC}\u200D\u{1F692}','\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FC}\u200D\u{1F9AF}','\u{1F468}\u{1F3FC}\u200D\u{1F9B0}','\u{1F468}\u{1F3FC}\u200D\u{1F9B1}','\u{1F468}\u{1F3FC}\u200D\u{1F9B2}','\u{1F468}\u{1F3FC}\u200D\u{1F9B3}','\u{1F468}\u{1F3FC}\u200D\u{1F9BC}','\u{1F468}\u{1F3FC}\u200D\u{1F9BD}','\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FD}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FD}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FD}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FD}\u200D\u{1F33E}','\u{1F468}\u{1F3FD}\u200D\u{1F373}','\u{1F468}\u{1F3FD}\u200D\u{1F37C}','\u{1F468}\u{1F3FD}\u200D\u{1F393}','\u{1F468}\u{1F3FD}\u200D\u{1F3A4}','\u{1F468}\u{1F3FD}\u200D\u{1F3A8}','\u{1F468}\u{1F3FD}\u200D\u{1F3EB}','\u{1F468}\u{1F3FD}\u200D\u{1F3ED}','\u{1F468}\u{1F3FD}\u200D\u{1F4BB}','\u{1F468}\u{1F3FD}\u200D\u{1F4BC}','\u{1F468}\u{1F3FD}\u200D\u{1F527}','\u{1F468}\u{1F3FD}\u200D\u{1F52C}','\u{1F468}\u{1F3FD}\u200D\u{1F680}','\u{1F468}\u{1F3FD}\u200D\u{1F692}','\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FD}\u200D\u{1F9AF}','\u{1F468}\u{1F3FD}\u200D\u{1F9B0}','\u{1F468}\u{1F3FD}\u200D\u{1F9B1}','\u{1F468}\u{1F3FD}\u200D\u{1F9B2}','\u{1F468}\u{1F3FD}\u200D\u{1F9B3}','\u{1F468}\u{1F3FD}\u200D\u{1F9BC}','\u{1F468}\u{1F3FD}\u200D\u{1F9BD}','\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FE}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FE}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FE}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FE}\u200D\u{1F33E}','\u{1F468}\u{1F3FE}\u200D\u{1F373}','\u{1F468}\u{1F3FE}\u200D\u{1F37C}','\u{1F468}\u{1F3FE}\u200D\u{1F393}','\u{1F468}\u{1F3FE}\u200D\u{1F3A4}','\u{1F468}\u{1F3FE}\u200D\u{1F3A8}','\u{1F468}\u{1F3FE}\u200D\u{1F3EB}','\u{1F468}\u{1F3FE}\u200D\u{1F3ED}','\u{1F468}\u{1F3FE}\u200D\u{1F4BB}','\u{1F468}\u{1F3FE}\u200D\u{1F4BC}','\u{1F468}\u{1F3FE}\u200D\u{1F527}','\u{1F468}\u{1F3FE}\u200D\u{1F52C}','\u{1F468}\u{1F3FE}\u200D\u{1F680}','\u{1F468}\u{1F3FE}\u200D\u{1F692}','\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FE}\u200D\u{1F9AF}','\u{1F468}\u{1F3FE}\u200D\u{1F9B0}','\u{1F468}\u{1F3FE}\u200D\u{1F9B1}','\u{1F468}\u{1F3FE}\u200D\u{1F9B2}','\u{1F468}\u{1F3FE}\u200D\u{1F9B3}','\u{1F468}\u{1F3FE}\u200D\u{1F9BC}','\u{1F468}\u{1F3FE}\u200D\u{1F9BD}','\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FF}\u200D\u2695\uFE0F','\u{1F468}\u{1F3FF}\u200D\u2696\uFE0F','\u{1F468}\u{1F3FF}\u200D\u2708\uFE0F','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F468}\u{1F3FF}\u200D\u{1F33E}','\u{1F468}\u{1F3FF}\u200D\u{1F373}','\u{1F468}\u{1F3FF}\u200D\u{1F37C}','\u{1F468}\u{1F3FF}\u200D\u{1F393}','\u{1F468}\u{1F3FF}\u200D\u{1F3A4}','\u{1F468}\u{1F3FF}\u200D\u{1F3A8}','\u{1F468}\u{1F3FF}\u200D\u{1F3EB}','\u{1F468}\u{1F3FF}\u200D\u{1F3ED}','\u{1F468}\u{1F3FF}\u200D\u{1F4BB}','\u{1F468}\u{1F3FF}\u200D\u{1F4BC}','\u{1F468}\u{1F3FF}\u200D\u{1F527}','\u{1F468}\u{1F3FF}\u200D\u{1F52C}','\u{1F468}\u{1F3FF}\u200D\u{1F680}','\u{1F468}\u{1F3FF}\u200D\u{1F692}','\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F468}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F468}\u{1F3FF}\u200D\u{1F9AF}','\u{1F468}\u{1F3FF}\u200D\u{1F9B0}','\u{1F468}\u{1F3FF}\u200D\u{1F9B1}','\u{1F468}\u{1F3FF}\u200D\u{1F9B2}','\u{1F468}\u{1F3FF}\u200D\u{1F9B3}','\u{1F468}\u{1F3FF}\u200D\u{1F9BC}','\u{1F468}\u{1F3FF}\u200D\u{1F9BD}','\u{1F469}\u200D\u2695\uFE0F','\u{1F469}\u200D\u2696\uFE0F','\u{1F469}\u200D\u2708\uFE0F','\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F468}','\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F469}','\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}','\u{1F469}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}','\u{1F469}\u200D\u{1F33E}','\u{1F469}\u200D\u{1F373}','\u{1F469}\u200D\u{1F37C}','\u{1F469}\u200D\u{1F393}','\u{1F469}\u200D\u{1F3A4}','\u{1F469}\u200D\u{1F3A8}','\u{1F469}\u200D\u{1F3EB}','\u{1F469}\u200D\u{1F3ED}','\u{1F469}\u200D\u{1F466}','\u{1F469}\u200D\u{1F466}\u200D\u{1F466}','\u{1F469}\u200D\u{1F467}','\u{1F469}\u200D\u{1F467}\u200D\u{1F466}','\u{1F469}\u200D\u{1F467}\u200D\u{1F467}','\u{1F469}\u200D\u{1F469}\u200D\u{1F466}','\u{1F469}\u200D\u{1F469}\u200D\u{1F466}\u200D\u{1F466}','\u{1F469}\u200D\u{1F469}\u200D\u{1F467}','\u{1F469}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}','\u{1F469}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F467}','\u{1F469}\u200D\u{1F4BB}','\u{1F469}\u200D\u{1F4BC}','\u{1F469}\u200D\u{1F527}','\u{1F469}\u200D\u{1F52C}','\u{1F469}\u200D\u{1F680}','\u{1F469}\u200D\u{1F692}','\u{1F469}\u200D\u{1F9AF}','\u{1F469}\u200D\u{1F9B0}','\u{1F469}\u200D\u{1F9B1}','\u{1F469}\u200D\u{1F9B2}','\u{1F469}\u200D\u{1F9B3}','\u{1F469}\u200D\u{1F9BC}','\u{1F469}\u200D\u{1F9BD}','\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FB}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FB}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u{1F33E}','\u{1F469}\u{1F3FB}\u200D\u{1F373}','\u{1F469}\u{1F3FB}\u200D\u{1F37C}','\u{1F469}\u{1F3FB}\u200D\u{1F393}','\u{1F469}\u{1F3FB}\u200D\u{1F3A4}','\u{1F469}\u{1F3FB}\u200D\u{1F3A8}','\u{1F469}\u{1F3FB}\u200D\u{1F3EB}','\u{1F469}\u{1F3FB}\u200D\u{1F3ED}','\u{1F469}\u{1F3FB}\u200D\u{1F4BB}','\u{1F469}\u{1F3FB}\u200D\u{1F4BC}','\u{1F469}\u{1F3FB}\u200D\u{1F527}','\u{1F469}\u{1F3FB}\u200D\u{1F52C}','\u{1F469}\u{1F3FB}\u200D\u{1F680}','\u{1F469}\u{1F3FB}\u200D\u{1F692}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FB}\u200D\u{1F9AF}','\u{1F469}\u{1F3FB}\u200D\u{1F9B0}','\u{1F469}\u{1F3FB}\u200D\u{1F9B1}','\u{1F469}\u{1F3FB}\u200D\u{1F9B2}','\u{1F469}\u{1F3FB}\u200D\u{1F9B3}','\u{1F469}\u{1F3FB}\u200D\u{1F9BC}','\u{1F469}\u{1F3FB}\u200D\u{1F9BD}','\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FC}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FC}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u{1F33E}','\u{1F469}\u{1F3FC}\u200D\u{1F373}','\u{1F469}\u{1F3FC}\u200D\u{1F37C}','\u{1F469}\u{1F3FC}\u200D\u{1F393}','\u{1F469}\u{1F3FC}\u200D\u{1F3A4}','\u{1F469}\u{1F3FC}\u200D\u{1F3A8}','\u{1F469}\u{1F3FC}\u200D\u{1F3EB}','\u{1F469}\u{1F3FC}\u200D\u{1F3ED}','\u{1F469}\u{1F3FC}\u200D\u{1F4BB}','\u{1F469}\u{1F3FC}\u200D\u{1F4BC}','\u{1F469}\u{1F3FC}\u200D\u{1F527}','\u{1F469}\u{1F3FC}\u200D\u{1F52C}','\u{1F469}\u{1F3FC}\u200D\u{1F680}','\u{1F469}\u{1F3FC}\u200D\u{1F692}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FC}\u200D\u{1F9AF}','\u{1F469}\u{1F3FC}\u200D\u{1F9B0}','\u{1F469}\u{1F3FC}\u200D\u{1F9B1}','\u{1F469}\u{1F3FC}\u200D\u{1F9B2}','\u{1F469}\u{1F3FC}\u200D\u{1F9B3}','\u{1F469}\u{1F3FC}\u200D\u{1F9BC}','\u{1F469}\u{1F3FC}\u200D\u{1F9BD}','\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FD}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FD}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u{1F33E}','\u{1F469}\u{1F3FD}\u200D\u{1F373}','\u{1F469}\u{1F3FD}\u200D\u{1F37C}','\u{1F469}\u{1F3FD}\u200D\u{1F393}','\u{1F469}\u{1F3FD}\u200D\u{1F3A4}','\u{1F469}\u{1F3FD}\u200D\u{1F3A8}','\u{1F469}\u{1F3FD}\u200D\u{1F3EB}','\u{1F469}\u{1F3FD}\u200D\u{1F3ED}','\u{1F469}\u{1F3FD}\u200D\u{1F4BB}','\u{1F469}\u{1F3FD}\u200D\u{1F4BC}','\u{1F469}\u{1F3FD}\u200D\u{1F527}','\u{1F469}\u{1F3FD}\u200D\u{1F52C}','\u{1F469}\u{1F3FD}\u200D\u{1F680}','\u{1F469}\u{1F3FD}\u200D\u{1F692}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FD}\u200D\u{1F9AF}','\u{1F469}\u{1F3FD}\u200D\u{1F9B0}','\u{1F469}\u{1F3FD}\u200D\u{1F9B1}','\u{1F469}\u{1F3FD}\u200D\u{1F9B2}','\u{1F469}\u{1F3FD}\u200D\u{1F9B3}','\u{1F469}\u{1F3FD}\u200D\u{1F9BC}','\u{1F469}\u{1F3FD}\u200D\u{1F9BD}','\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FE}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FE}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u{1F33E}','\u{1F469}\u{1F3FE}\u200D\u{1F373}','\u{1F469}\u{1F3FE}\u200D\u{1F37C}','\u{1F469}\u{1F3FE}\u200D\u{1F393}','\u{1F469}\u{1F3FE}\u200D\u{1F3A4}','\u{1F469}\u{1F3FE}\u200D\u{1F3A8}','\u{1F469}\u{1F3FE}\u200D\u{1F3EB}','\u{1F469}\u{1F3FE}\u200D\u{1F3ED}','\u{1F469}\u{1F3FE}\u200D\u{1F4BB}','\u{1F469}\u{1F3FE}\u200D\u{1F4BC}','\u{1F469}\u{1F3FE}\u200D\u{1F527}','\u{1F469}\u{1F3FE}\u200D\u{1F52C}','\u{1F469}\u{1F3FE}\u200D\u{1F680}','\u{1F469}\u{1F3FE}\u200D\u{1F692}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FE}\u200D\u{1F9AF}','\u{1F469}\u{1F3FE}\u200D\u{1F9B0}','\u{1F469}\u{1F3FE}\u200D\u{1F9B1}','\u{1F469}\u{1F3FE}\u200D\u{1F9B2}','\u{1F469}\u{1F3FE}\u200D\u{1F9B3}','\u{1F469}\u{1F3FE}\u200D\u{1F9BC}','\u{1F469}\u{1F3FE}\u200D\u{1F9BD}','\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u2695\uFE0F','\u{1F469}\u{1F3FF}\u200D\u2696\uFE0F','\u{1F469}\u{1F3FF}\u200D\u2708\uFE0F','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F468}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F469}\u{1F3FF}','\u{1F469}\u{1F3FF}\u200D\u{1F33E}','\u{1F469}\u{1F3FF}\u200D\u{1F373}','\u{1F469}\u{1F3FF}\u200D\u{1F37C}','\u{1F469}\u{1F3FF}\u200D\u{1F393}','\u{1F469}\u{1F3FF}\u200D\u{1F3A4}','\u{1F469}\u{1F3FF}\u200D\u{1F3A8}','\u{1F469}\u{1F3FF}\u200D\u{1F3EB}','\u{1F469}\u{1F3FF}\u200D\u{1F3ED}','\u{1F469}\u{1F3FF}\u200D\u{1F4BB}','\u{1F469}\u{1F3FF}\u200D\u{1F4BC}','\u{1F469}\u{1F3FF}\u200D\u{1F527}','\u{1F469}\u{1F3FF}\u200D\u{1F52C}','\u{1F469}\u{1F3FF}\u200D\u{1F680}','\u{1F469}\u{1F3FF}\u200D\u{1F692}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F468}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FB}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FC}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FD}','\u{1F469}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F469}\u{1F3FE}','\u{1F469}\u{1F3FF}\u200D\u{1F9AF}','\u{1F469}\u{1F3FF}\u200D\u{1F9B0}','\u{1F469}\u{1F3FF}\u200D\u{1F9B1}','\u{1F469}\u{1F3FF}\u200D\u{1F9B2}','\u{1F469}\u{1F3FF}\u200D\u{1F9B3}','\u{1F469}\u{1F3FF}\u200D\u{1F9BC}','\u{1F469}\u{1F3FF}\u200D\u{1F9BD}','\u{1F46B}\u{1F3FB}','\u{1F46B}\u{1F3FC}','\u{1F46B}\u{1F3FD}','\u{1F46B}\u{1F3FE}','\u{1F46B}\u{1F3FF}','\u{1F46C}\u{1F3FB}','\u{1F46C}\u{1F3FC}','\u{1F46C}\u{1F3FD}','\u{1F46C}\u{1F3FE}','\u{1F46C}\u{1F3FF}','\u{1F46D}\u{1F3FB}','\u{1F46D}\u{1F3FC}','\u{1F46D}\u{1F3FD}','\u{1F46D}\u{1F3FE}','\u{1F46D}\u{1F3FF}','\u{1F46E}\u200D\u2640\uFE0F','\u{1F46E}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FB}','\u{1F46E}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FC}','\u{1F46E}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FD}','\u{1F46E}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FE}','\u{1F46E}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F46E}\u{1F3FF}','\u{1F46E}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F46E}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F46F}\u200D\u2640\uFE0F','\u{1F46F}\u200D\u2642\uFE0F','\u{1F470}\u200D\u2640\uFE0F','\u{1F470}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FB}','\u{1F470}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FC}','\u{1F470}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FD}','\u{1F470}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FE}','\u{1F470}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F470}\u{1F3FF}','\u{1F470}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F470}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F471}\u200D\u2640\uFE0F','\u{1F471}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FB}','\u{1F471}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FC}','\u{1F471}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FD}','\u{1F471}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FE}','\u{1F471}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F471}\u{1F3FF}','\u{1F471}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F471}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F472}\u{1F3FB}','\u{1F472}\u{1F3FC}','\u{1F472}\u{1F3FD}','\u{1F472}\u{1F3FE}','\u{1F472}\u{1F3FF}','\u{1F473}\u200D\u2640\uFE0F','\u{1F473}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FB}','\u{1F473}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FC}','\u{1F473}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FD}','\u{1F473}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FE}','\u{1F473}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F473}\u{1F3FF}','\u{1F473}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F473}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F474}\u{1F3FB}','\u{1F474}\u{1F3FC}','\u{1F474}\u{1F3FD}','\u{1F474}\u{1F3FE}','\u{1F474}\u{1F3FF}','\u{1F475}\u{1F3FB}','\u{1F475}\u{1F3FC}','\u{1F475}\u{1F3FD}','\u{1F475}\u{1F3FE}','\u{1F475}\u{1F3FF}','\u{1F476}\u{1F3FB}','\u{1F476}\u{1F3FC}','\u{1F476}\u{1F3FD}','\u{1F476}\u{1F3FE}','\u{1F476}\u{1F3FF}','\u{1F477}\u200D\u2640\uFE0F','\u{1F477}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FB}','\u{1F477}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FC}','\u{1F477}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FD}','\u{1F477}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FE}','\u{1F477}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F477}\u{1F3FF}','\u{1F477}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F477}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F478}\u{1F3FB}','\u{1F478}\u{1F3FC}','\u{1F478}\u{1F3FD}','\u{1F478}\u{1F3FE}','\u{1F478}\u{1F3FF}','\u{1F47C}\u{1F3FB}','\u{1F47C}\u{1F3FC}','\u{1F47C}\u{1F3FD}','\u{1F47C}\u{1F3FE}','\u{1F47C}\u{1F3FF}','\u{1F481}\u200D\u2640\uFE0F','\u{1F481}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FB}','\u{1F481}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FC}','\u{1F481}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FD}','\u{1F481}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FE}','\u{1F481}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F481}\u{1F3FF}','\u{1F481}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F481}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F482}\u200D\u2640\uFE0F','\u{1F482}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FB}','\u{1F482}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FC}','\u{1F482}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FD}','\u{1F482}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FE}','\u{1F482}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F482}\u{1F3FF}','\u{1F482}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F482}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F483}\u{1F3FB}','\u{1F483}\u{1F3FC}','\u{1F483}\u{1F3FD}','\u{1F483}\u{1F3FE}','\u{1F483}\u{1F3FF}','\u{1F485}\u{1F3FB}','\u{1F485}\u{1F3FC}','\u{1F485}\u{1F3FD}','\u{1F485}\u{1F3FE}','\u{1F485}\u{1F3FF}','\u{1F486}\u200D\u2640\uFE0F','\u{1F486}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FB}','\u{1F486}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FC}','\u{1F486}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FD}','\u{1F486}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FE}','\u{1F486}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F486}\u{1F3FF}','\u{1F486}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F486}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F487}\u200D\u2640\uFE0F','\u{1F487}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FB}','\u{1F487}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FC}','\u{1F487}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FD}','\u{1F487}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FE}','\u{1F487}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F487}\u{1F3FF}','\u{1F487}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F487}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F48F}\u{1F3FB}','\u{1F48F}\u{1F3FC}','\u{1F48F}\u{1F3FD}','\u{1F48F}\u{1F3FE}','\u{1F48F}\u{1F3FF}','\u{1F491}\u{1F3FB}','\u{1F491}\u{1F3FC}','\u{1F491}\u{1F3FD}','\u{1F491}\u{1F3FE}','\u{1F491}\u{1F3FF}','\u{1F4AA}\u{1F3FB}','\u{1F4AA}\u{1F3FC}','\u{1F4AA}\u{1F3FD}','\u{1F4AA}\u{1F3FE}','\u{1F4AA}\u{1F3FF}','\u{1F4FD}\uFE0F','\u{1F549}\uFE0F','\u{1F54A}\uFE0F','\u{1F56F}\uFE0F','\u{1F570}\uFE0F','\u{1F573}\uFE0F','\u{1F574}\u{1F3FB}','\u{1F574}\u{1F3FC}','\u{1F574}\u{1F3FD}','\u{1F574}\u{1F3FE}','\u{1F574}\u{1F3FF}','\u{1F574}\uFE0F','\u{1F575}\u{1F3FB}','\u{1F575}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FC}','\u{1F575}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FD}','\u{1F575}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FE}','\u{1F575}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F575}\u{1F3FF}','\u{1F575}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F575}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F575}\uFE0F','\u{1F575}\uFE0F\u200D\u2640\uFE0F','\u{1F575}\uFE0F\u200D\u2642\uFE0F','\u{1F576}\uFE0F','\u{1F577}\uFE0F','\u{1F578}\uFE0F','\u{1F579}\uFE0F','\u{1F57A}\u{1F3FB}','\u{1F57A}\u{1F3FC}','\u{1F57A}\u{1F3FD}','\u{1F57A}\u{1F3FE}','\u{1F57A}\u{1F3FF}','\u{1F587}\uFE0F','\u{1F58A}\uFE0F','\u{1F58B}\uFE0F','\u{1F58C}\uFE0F','\u{1F58D}\uFE0F','\u{1F590}\u{1F3FB}','\u{1F590}\u{1F3FC}','\u{1F590}\u{1F3FD}','\u{1F590}\u{1F3FE}','\u{1F590}\u{1F3FF}','\u{1F590}\uFE0F','\u{1F595}\u{1F3FB}','\u{1F595}\u{1F3FC}','\u{1F595}\u{1F3FD}','\u{1F595}\u{1F3FE}','\u{1F595}\u{1F3FF}','\u{1F596}\u{1F3FB}','\u{1F596}\u{1F3FC}','\u{1F596}\u{1F3FD}','\u{1F596}\u{1F3FE}','\u{1F596}\u{1F3FF}','\u{1F5A5}\uFE0F','\u{1F5A8}\uFE0F','\u{1F5B1}\uFE0F','\u{1F5B2}\uFE0F','\u{1F5BC}\uFE0F','\u{1F5C2}\uFE0F','\u{1F5C3}\uFE0F','\u{1F5C4}\uFE0F','\u{1F5D1}\uFE0F','\u{1F5D2}\uFE0F','\u{1F5D3}\uFE0F','\u{1F5DC}\uFE0F','\u{1F5DD}\uFE0F','\u{1F5DE}\uFE0F','\u{1F5E1}\uFE0F','\u{1F5E3}\uFE0F','\u{1F5E8}\uFE0F','\u{1F5EF}\uFE0F','\u{1F5F3}\uFE0F','\u{1F5FA}\uFE0F','\u{1F62E}\u200D\u{1F4A8}','\u{1F635}\u200D\u{1F4AB}','\u{1F636}\u200D\u{1F32B}\uFE0F','\u{1F645}\u200D\u2640\uFE0F','\u{1F645}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FB}','\u{1F645}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FC}','\u{1F645}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FD}','\u{1F645}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FE}','\u{1F645}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F645}\u{1F3FF}','\u{1F645}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F645}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F646}\u200D\u2640\uFE0F','\u{1F646}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FB}','\u{1F646}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FC}','\u{1F646}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FD}','\u{1F646}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FE}','\u{1F646}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F646}\u{1F3FF}','\u{1F646}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F646}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F647}\u200D\u2640\uFE0F','\u{1F647}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FB}','\u{1F647}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FC}','\u{1F647}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FD}','\u{1F647}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FE}','\u{1F647}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F647}\u{1F3FF}','\u{1F647}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F647}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F64B}\u200D\u2640\uFE0F','\u{1F64B}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FB}','\u{1F64B}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FC}','\u{1F64B}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FD}','\u{1F64B}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FE}','\u{1F64B}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F64B}\u{1F3FF}','\u{1F64B}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F64B}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F64C}\u{1F3FB}','\u{1F64C}\u{1F3FC}','\u{1F64C}\u{1F3FD}','\u{1F64C}\u{1F3FE}','\u{1F64C}\u{1F3FF}','\u{1F64D}\u200D\u2640\uFE0F','\u{1F64D}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FB}','\u{1F64D}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FC}','\u{1F64D}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FD}','\u{1F64D}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FE}','\u{1F64D}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F64D}\u{1F3FF}','\u{1F64D}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F64D}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F64E}\u200D\u2640\uFE0F','\u{1F64E}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FB}','\u{1F64E}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FC}','\u{1F64E}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FD}','\u{1F64E}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FE}','\u{1F64E}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F64E}\u{1F3FF}','\u{1F64E}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F64E}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F64F}\u{1F3FB}','\u{1F64F}\u{1F3FC}','\u{1F64F}\u{1F3FD}','\u{1F64F}\u{1F3FE}','\u{1F64F}\u{1F3FF}','\u{1F6A3}\u200D\u2640\uFE0F','\u{1F6A3}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FB}','\u{1F6A3}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FC}','\u{1F6A3}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FD}','\u{1F6A3}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FE}','\u{1F6A3}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F6A3}\u{1F3FF}','\u{1F6A3}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F6A3}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F6B4}\u200D\u2640\uFE0F','\u{1F6B4}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FB}','\u{1F6B4}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FC}','\u{1F6B4}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FD}','\u{1F6B4}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FE}','\u{1F6B4}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F6B4}\u{1F3FF}','\u{1F6B4}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F6B4}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F6B5}\u200D\u2640\uFE0F','\u{1F6B5}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FB}','\u{1F6B5}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FC}','\u{1F6B5}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FD}','\u{1F6B5}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FE}','\u{1F6B5}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F6B5}\u{1F3FF}','\u{1F6B5}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F6B5}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F6B6}\u200D\u2640\uFE0F','\u{1F6B6}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FB}','\u{1F6B6}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FC}','\u{1F6B6}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FD}','\u{1F6B6}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FE}','\u{1F6B6}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F6B6}\u{1F3FF}','\u{1F6B6}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F6B6}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F6C0}\u{1F3FB}','\u{1F6C0}\u{1F3FC}','\u{1F6C0}\u{1F3FD}','\u{1F6C0}\u{1F3FE}','\u{1F6C0}\u{1F3FF}','\u{1F6CB}\uFE0F','\u{1F6CC}\u{1F3FB}','\u{1F6CC}\u{1F3FC}','\u{1F6CC}\u{1F3FD}','\u{1F6CC}\u{1F3FE}','\u{1F6CC}\u{1F3FF}','\u{1F6CD}\uFE0F','\u{1F6CE}\uFE0F','\u{1F6CF}\uFE0F','\u{1F6E0}\uFE0F','\u{1F6E1}\uFE0F','\u{1F6E2}\uFE0F','\u{1F6E3}\uFE0F','\u{1F6E4}\uFE0F','\u{1F6E5}\uFE0F','\u{1F6E9}\uFE0F','\u{1F6F0}\uFE0F','\u{1F6F3}\uFE0F','\u{1F90C}\u{1F3FB}','\u{1F90C}\u{1F3FC}','\u{1F90C}\u{1F3FD}','\u{1F90C}\u{1F3FE}','\u{1F90C}\u{1F3FF}','\u{1F90F}\u{1F3FB}','\u{1F90F}\u{1F3FC}','\u{1F90F}\u{1F3FD}','\u{1F90F}\u{1F3FE}','\u{1F90F}\u{1F3FF}','\u{1F918}\u{1F3FB}','\u{1F918}\u{1F3FC}','\u{1F918}\u{1F3FD}','\u{1F918}\u{1F3FE}','\u{1F918}\u{1F3FF}','\u{1F919}\u{1F3FB}','\u{1F919}\u{1F3FC}','\u{1F919}\u{1F3FD}','\u{1F919}\u{1F3FE}','\u{1F919}\u{1F3FF}','\u{1F91A}\u{1F3FB}','\u{1F91A}\u{1F3FC}','\u{1F91A}\u{1F3FD}','\u{1F91A}\u{1F3FE}','\u{1F91A}\u{1F3FF}','\u{1F91B}\u{1F3FB}','\u{1F91B}\u{1F3FC}','\u{1F91B}\u{1F3FD}','\u{1F91B}\u{1F3FE}','\u{1F91B}\u{1F3FF}','\u{1F91C}\u{1F3FB}','\u{1F91C}\u{1F3FC}','\u{1F91C}\u{1F3FD}','\u{1F91C}\u{1F3FE}','\u{1F91C}\u{1F3FF}','\u{1F91D}\u{1F3FB}','\u{1F91D}\u{1F3FC}','\u{1F91D}\u{1F3FD}','\u{1F91D}\u{1F3FE}','\u{1F91D}\u{1F3FF}','\u{1F91E}\u{1F3FB}','\u{1F91E}\u{1F3FC}','\u{1F91E}\u{1F3FD}','\u{1F91E}\u{1F3FE}','\u{1F91E}\u{1F3FF}','\u{1F91F}\u{1F3FB}','\u{1F91F}\u{1F3FC}','\u{1F91F}\u{1F3FD}','\u{1F91F}\u{1F3FE}','\u{1F91F}\u{1F3FF}','\u{1F926}\u200D\u2640\uFE0F','\u{1F926}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FB}','\u{1F926}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FC}','\u{1F926}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FD}','\u{1F926}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FE}','\u{1F926}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F926}\u{1F3FF}','\u{1F926}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F926}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F930}\u{1F3FB}','\u{1F930}\u{1F3FC}','\u{1F930}\u{1F3FD}','\u{1F930}\u{1F3FE}','\u{1F930}\u{1F3FF}','\u{1F931}\u{1F3FB}','\u{1F931}\u{1F3FC}','\u{1F931}\u{1F3FD}','\u{1F931}\u{1F3FE}','\u{1F931}\u{1F3FF}','\u{1F932}\u{1F3FB}','\u{1F932}\u{1F3FC}','\u{1F932}\u{1F3FD}','\u{1F932}\u{1F3FE}','\u{1F932}\u{1F3FF}','\u{1F933}\u{1F3FB}','\u{1F933}\u{1F3FC}','\u{1F933}\u{1F3FD}','\u{1F933}\u{1F3FE}','\u{1F933}\u{1F3FF}','\u{1F934}\u{1F3FB}','\u{1F934}\u{1F3FC}','\u{1F934}\u{1F3FD}','\u{1F934}\u{1F3FE}','\u{1F934}\u{1F3FF}','\u{1F935}\u200D\u2640\uFE0F','\u{1F935}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FB}','\u{1F935}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FC}','\u{1F935}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FD}','\u{1F935}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FE}','\u{1F935}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F935}\u{1F3FF}','\u{1F935}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F935}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F936}\u{1F3FB}','\u{1F936}\u{1F3FC}','\u{1F936}\u{1F3FD}','\u{1F936}\u{1F3FE}','\u{1F936}\u{1F3FF}','\u{1F937}\u200D\u2640\uFE0F','\u{1F937}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FB}','\u{1F937}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FC}','\u{1F937}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FD}','\u{1F937}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FE}','\u{1F937}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F937}\u{1F3FF}','\u{1F937}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F937}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F938}\u200D\u2640\uFE0F','\u{1F938}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FB}','\u{1F938}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FC}','\u{1F938}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FD}','\u{1F938}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FE}','\u{1F938}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F938}\u{1F3FF}','\u{1F938}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F938}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F939}\u200D\u2640\uFE0F','\u{1F939}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FB}','\u{1F939}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FC}','\u{1F939}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FD}','\u{1F939}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FE}','\u{1F939}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F939}\u{1F3FF}','\u{1F939}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F939}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F93C}\u200D\u2640\uFE0F','\u{1F93C}\u200D\u2642\uFE0F','\u{1F93D}\u200D\u2640\uFE0F','\u{1F93D}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FB}','\u{1F93D}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FC}','\u{1F93D}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FD}','\u{1F93D}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FE}','\u{1F93D}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F93D}\u{1F3FF}','\u{1F93D}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F93D}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F93E}\u200D\u2640\uFE0F','\u{1F93E}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FB}','\u{1F93E}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FC}','\u{1F93E}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FD}','\u{1F93E}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FE}','\u{1F93E}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F93E}\u{1F3FF}','\u{1F93E}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F93E}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F977}\u{1F3FB}','\u{1F977}\u{1F3FC}','\u{1F977}\u{1F3FD}','\u{1F977}\u{1F3FE}','\u{1F977}\u{1F3FF}','\u{1F9B5}\u{1F3FB}','\u{1F9B5}\u{1F3FC}','\u{1F9B5}\u{1F3FD}','\u{1F9B5}\u{1F3FE}','\u{1F9B5}\u{1F3FF}','\u{1F9B6}\u{1F3FB}','\u{1F9B6}\u{1F3FC}','\u{1F9B6}\u{1F3FD}','\u{1F9B6}\u{1F3FE}','\u{1F9B6}\u{1F3FF}','\u{1F9B8}\u200D\u2640\uFE0F','\u{1F9B8}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FB}','\u{1F9B8}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FC}','\u{1F9B8}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FD}','\u{1F9B8}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FE}','\u{1F9B8}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9B8}\u{1F3FF}','\u{1F9B8}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9B8}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9B9}\u200D\u2640\uFE0F','\u{1F9B9}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FB}','\u{1F9B9}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FC}','\u{1F9B9}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FD}','\u{1F9B9}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FE}','\u{1F9B9}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9B9}\u{1F3FF}','\u{1F9B9}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9B9}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9BB}\u{1F3FB}','\u{1F9BB}\u{1F3FC}','\u{1F9BB}\u{1F3FD}','\u{1F9BB}\u{1F3FE}','\u{1F9BB}\u{1F3FF}','\u{1F9CD}\u200D\u2640\uFE0F','\u{1F9CD}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FB}','\u{1F9CD}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FC}','\u{1F9CD}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FD}','\u{1F9CD}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FE}','\u{1F9CD}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9CD}\u{1F3FF}','\u{1F9CD}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9CD}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9CE}\u200D\u2640\uFE0F','\u{1F9CE}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FB}','\u{1F9CE}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FC}','\u{1F9CE}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FD}','\u{1F9CE}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FE}','\u{1F9CE}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9CE}\u{1F3FF}','\u{1F9CE}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9CE}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9CF}\u200D\u2640\uFE0F','\u{1F9CF}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FB}','\u{1F9CF}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FC}','\u{1F9CF}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FD}','\u{1F9CF}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FE}','\u{1F9CF}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9CF}\u{1F3FF}','\u{1F9CF}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9CF}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D1}\u200D\u2695\uFE0F','\u{1F9D1}\u200D\u2696\uFE0F','\u{1F9D1}\u200D\u2708\uFE0F','\u{1F9D1}\u200D\u{1F33E}','\u{1F9D1}\u200D\u{1F373}','\u{1F9D1}\u200D\u{1F37C}','\u{1F9D1}\u200D\u{1F384}','\u{1F9D1}\u200D\u{1F393}','\u{1F9D1}\u200D\u{1F3A4}','\u{1F9D1}\u200D\u{1F3A8}','\u{1F9D1}\u200D\u{1F3EB}','\u{1F9D1}\u200D\u{1F3ED}','\u{1F9D1}\u200D\u{1F4BB}','\u{1F9D1}\u200D\u{1F4BC}','\u{1F9D1}\u200D\u{1F527}','\u{1F9D1}\u200D\u{1F52C}','\u{1F9D1}\u200D\u{1F680}','\u{1F9D1}\u200D\u{1F692}','\u{1F9D1}\u200D\u{1F91D}\u200D\u{1F9D1}','\u{1F9D1}\u200D\u{1F9AF}','\u{1F9D1}\u200D\u{1F9B0}','\u{1F9D1}\u200D\u{1F9B1}','\u{1F9D1}\u200D\u{1F9B2}','\u{1F9D1}\u200D\u{1F9B3}','\u{1F9D1}\u200D\u{1F9BC}','\u{1F9D1}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FB}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FB}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FB}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FB}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FB}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FB}\u200D\u{1F373}','\u{1F9D1}\u{1F3FB}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FB}\u200D\u{1F384}','\u{1F9D1}\u{1F3FB}\u200D\u{1F393}','\u{1F9D1}\u{1F3FB}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FB}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FB}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FB}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FB}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FB}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FB}\u200D\u{1F527}','\u{1F9D1}\u{1F3FB}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FB}\u200D\u{1F680}','\u{1F9D1}\u{1F3FB}\u200D\u{1F692}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FB}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FB}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FC}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FC}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FC}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FC}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FC}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FC}\u200D\u{1F373}','\u{1F9D1}\u{1F3FC}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FC}\u200D\u{1F384}','\u{1F9D1}\u{1F3FC}\u200D\u{1F393}','\u{1F9D1}\u{1F3FC}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FC}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FC}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FC}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FC}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FC}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FC}\u200D\u{1F527}','\u{1F9D1}\u{1F3FC}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FC}\u200D\u{1F680}','\u{1F9D1}\u{1F3FC}\u200D\u{1F692}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FC}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FC}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FD}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FD}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FD}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FD}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FD}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FD}\u200D\u{1F373}','\u{1F9D1}\u{1F3FD}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FD}\u200D\u{1F384}','\u{1F9D1}\u{1F3FD}\u200D\u{1F393}','\u{1F9D1}\u{1F3FD}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FD}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FD}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FD}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FD}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FD}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FD}\u200D\u{1F527}','\u{1F9D1}\u{1F3FD}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FD}\u200D\u{1F680}','\u{1F9D1}\u{1F3FD}\u200D\u{1F692}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FD}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FD}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FE}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FE}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FE}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FE}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FE}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FE}\u200D\u{1F373}','\u{1F9D1}\u{1F3FE}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FE}\u200D\u{1F384}','\u{1F9D1}\u{1F3FE}\u200D\u{1F393}','\u{1F9D1}\u{1F3FE}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FE}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FE}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FE}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FE}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FE}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FE}\u200D\u{1F527}','\u{1F9D1}\u{1F3FE}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FE}\u200D\u{1F680}','\u{1F9D1}\u{1F3FE}\u200D\u{1F692}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FE}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FE}\u200D\u{1F9BD}','\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FF}\u200D\u2695\uFE0F','\u{1F9D1}\u{1F3FF}\u200D\u2696\uFE0F','\u{1F9D1}\u{1F3FF}\u200D\u2708\uFE0F','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F48B}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FF}\u200D\u2764\uFE0F\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FF}\u200D\u{1F33E}','\u{1F9D1}\u{1F3FF}\u200D\u{1F373}','\u{1F9D1}\u{1F3FF}\u200D\u{1F37C}','\u{1F9D1}\u{1F3FF}\u200D\u{1F384}','\u{1F9D1}\u{1F3FF}\u200D\u{1F393}','\u{1F9D1}\u{1F3FF}\u200D\u{1F3A4}','\u{1F9D1}\u{1F3FF}\u200D\u{1F3A8}','\u{1F9D1}\u{1F3FF}\u200D\u{1F3EB}','\u{1F9D1}\u{1F3FF}\u200D\u{1F3ED}','\u{1F9D1}\u{1F3FF}\u200D\u{1F4BB}','\u{1F9D1}\u{1F3FF}\u200D\u{1F4BC}','\u{1F9D1}\u{1F3FF}\u200D\u{1F527}','\u{1F9D1}\u{1F3FF}\u200D\u{1F52C}','\u{1F9D1}\u{1F3FF}\u200D\u{1F680}','\u{1F9D1}\u{1F3FF}\u200D\u{1F692}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FB}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FC}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FD}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FE}','\u{1F9D1}\u{1F3FF}\u200D\u{1F91D}\u200D\u{1F9D1}\u{1F3FF}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9AF}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9B0}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9B1}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9B2}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9B3}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9BC}','\u{1F9D1}\u{1F3FF}\u200D\u{1F9BD}','\u{1F9D2}\u{1F3FB}','\u{1F9D2}\u{1F3FC}','\u{1F9D2}\u{1F3FD}','\u{1F9D2}\u{1F3FE}','\u{1F9D2}\u{1F3FF}','\u{1F9D3}\u{1F3FB}','\u{1F9D3}\u{1F3FC}','\u{1F9D3}\u{1F3FD}','\u{1F9D3}\u{1F3FE}','\u{1F9D3}\u{1F3FF}','\u{1F9D4}\u200D\u2640\uFE0F','\u{1F9D4}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FB}','\u{1F9D4}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FC}','\u{1F9D4}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FD}','\u{1F9D4}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FE}','\u{1F9D4}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D4}\u{1F3FF}','\u{1F9D4}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D4}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D5}\u{1F3FB}','\u{1F9D5}\u{1F3FC}','\u{1F9D5}\u{1F3FD}','\u{1F9D5}\u{1F3FE}','\u{1F9D5}\u{1F3FF}','\u{1F9D6}\u200D\u2640\uFE0F','\u{1F9D6}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FB}','\u{1F9D6}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FC}','\u{1F9D6}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FD}','\u{1F9D6}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FE}','\u{1F9D6}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D6}\u{1F3FF}','\u{1F9D6}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D6}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D7}\u200D\u2640\uFE0F','\u{1F9D7}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FB}','\u{1F9D7}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FC}','\u{1F9D7}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FD}','\u{1F9D7}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FE}','\u{1F9D7}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D7}\u{1F3FF}','\u{1F9D7}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D7}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D8}\u200D\u2640\uFE0F','\u{1F9D8}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FB}','\u{1F9D8}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FC}','\u{1F9D8}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FD}','\u{1F9D8}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FE}','\u{1F9D8}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D8}\u{1F3FF}','\u{1F9D8}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D8}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9D9}\u200D\u2640\uFE0F','\u{1F9D9}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FB}','\u{1F9D9}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FC}','\u{1F9D9}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FD}','\u{1F9D9}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FE}','\u{1F9D9}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9D9}\u{1F3FF}','\u{1F9D9}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9D9}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DA}\u200D\u2640\uFE0F','\u{1F9DA}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FB}','\u{1F9DA}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FC}','\u{1F9DA}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FD}','\u{1F9DA}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FE}','\u{1F9DA}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9DA}\u{1F3FF}','\u{1F9DA}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9DA}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DB}\u200D\u2640\uFE0F','\u{1F9DB}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FB}','\u{1F9DB}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FC}','\u{1F9DB}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FD}','\u{1F9DB}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FE}','\u{1F9DB}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9DB}\u{1F3FF}','\u{1F9DB}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9DB}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DC}\u200D\u2640\uFE0F','\u{1F9DC}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FB}','\u{1F9DC}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FC}','\u{1F9DC}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FD}','\u{1F9DC}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FE}','\u{1F9DC}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9DC}\u{1F3FF}','\u{1F9DC}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9DC}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DD}\u200D\u2640\uFE0F','\u{1F9DD}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FB}','\u{1F9DD}\u{1F3FB}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FB}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FC}','\u{1F9DD}\u{1F3FC}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FC}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FD}','\u{1F9DD}\u{1F3FD}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FD}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FE}','\u{1F9DD}\u{1F3FE}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FE}\u200D\u2642\uFE0F','\u{1F9DD}\u{1F3FF}','\u{1F9DD}\u{1F3FF}\u200D\u2640\uFE0F','\u{1F9DD}\u{1F3FF}\u200D\u2642\uFE0F','\u{1F9DE}\u200D\u2640\uFE0F','\u{1F9DE}\u200D\u2642\uFE0F','\u{1F9DF}\u200D\u2640\uFE0F','\u{1F9DF}\u200D\u2642\uFE0F','\u{1FAC3}\u{1F3FB}','\u{1FAC3}\u{1F3FC}','\u{1FAC3}\u{1F3FD}','\u{1FAC3}\u{1F3FE}','\u{1FAC3}\u{1F3FF}','\u{1FAC4}\u{1F3FB}','\u{1FAC4}\u{1F3FC}','\u{1FAC4}\u{1F3FD}','\u{1FAC4}\u{1F3FE}','\u{1FAC4}\u{1F3FF}','\u{1FAC5}\u{1F3FB}','\u{1FAC5}\u{1F3FC}','\u{1FAC5}\u{1F3FD}','\u{1FAC5}\u{1F3FE}','\u{1FAC5}\u{1F3FF}','\u{1FAF0}\u{1F3FB}','\u{1FAF0}\u{1F3FC}','\u{1FAF0}\u{1F3FD}','\u{1FAF0}\u{1F3FE}','\u{1FAF0}\u{1F3FF}','\u{1FAF1}\u{1F3FB}','\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FC}','\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FD}','\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FE}','\u{1FAF1}\u{1F3FB}\u200D\u{1FAF2}\u{1F3FF}','\u{1FAF1}\u{1F3FC}','\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FB}','\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FD}','\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FE}','\u{1FAF1}\u{1F3FC}\u200D\u{1FAF2}\u{1F3FF}','\u{1FAF1}\u{1F3FD}','\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FB}','\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FC}','\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FE}','\u{1FAF1}\u{1F3FD}\u200D\u{1FAF2}\u{1F3FF}','\u{1FAF1}\u{1F3FE}','\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FB}','\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FC}','\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FD}','\u{1FAF1}\u{1F3FE}\u200D\u{1FAF2}\u{1F3FF}','\u{1FAF1}\u{1F3FF}','\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FB}','\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FC}','\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FD}','\u{1FAF1}\u{1F3FF}\u200D\u{1FAF2}\u{1F3FE}','\u{1FAF2}\u{1F3FB}','\u{1FAF2}\u{1F3FC}','\u{1FAF2}\u{1F3FD}','\u{1FAF2}\u{1F3FE}','\u{1FAF2}\u{1F3FF}','\u{1FAF3}\u{1F3FB}','\u{1FAF3}\u{1F3FC}','\u{1FAF3}\u{1F3FD}','\u{1FAF3}\u{1F3FE}','\u{1FAF3}\u{1F3FF}','\u{1FAF4}\u{1F3FB}','\u{1FAF4}\u{1F3FC}','\u{1FAF4}\u{1F3FD}','\u{1FAF4}\u{1F3FE}','\u{1FAF4}\u{1F3FF}','\u{1FAF5}\u{1F3FB}','\u{1FAF5}\u{1F3FC}','\u{1FAF5}\u{1F3FD}','\u{1FAF5}\u{1F3FE}','\u{1FAF5}\u{1F3FF}','\u{1FAF6}\u{1F3FB}','\u{1FAF6}\u{1F3FC}','\u{1FAF6}\u{1F3FD}','\u{1FAF6}\u{1F3FE}','\u{1FAF6}\u{1F3FF}'];

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Adlam.js", function (module, exports) {
	  const set = regenerate(0x61F, 0x640);
	set.addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1E95E, 0x1E95F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Ahom.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11746);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Anatolian_Hieroglyphs.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x14400, 0x14646);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Arabic.js", function (module, exports) {
	  const set = regenerate(0xFDCF, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x600, 0x604).addRange(0x606, 0x6DC).addRange(0x6DE, 0x6FF).addRange(0x750, 0x77F).addRange(0x870, 0x88E).addRange(0x890, 0x891).addRange(0x898, 0x8E1).addRange(0x8E3, 0x8FF).addRange(0xFB50, 0xFBC2).addRange(0xFBD3, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFF).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0x102E0, 0x102FB).addRange(0x10E60, 0x10E7E).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Armenian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x531, 0x556).addRange(0x559, 0x58A).addRange(0x58D, 0x58F).addRange(0xFB13, 0xFB17);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Avestan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10B00, 0x10B35).addRange(0x10B39, 0x10B3F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Balinese.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B7E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Bamum.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA6A0, 0xA6F7).addRange(0x16800, 0x16A38);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Bassa_Vah.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF5);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Batak.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1BC0, 0x1BF3).addRange(0x1BFC, 0x1BFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Bengali.js", function (module, exports) {
	  const set = regenerate(0x9B2, 0x9D7, 0x1CD0, 0x1CD2, 0x1CD8, 0x1CE1, 0x1CEA, 0x1CED, 0x1CF2, 0xA8F1);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0x980, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9FE).addRange(0x1CD5, 0x1CD6).addRange(0x1CF5, 0x1CF7);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Bhaiksuki.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C45).addRange(0x11C50, 0x11C6C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Bopomofo.js", function (module, exports) {
	  const set = regenerate(0x3030, 0x3037, 0x30FB);
	set.addRange(0x2EA, 0x2EB).addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3013, 0x301F).addRange(0x302A, 0x302D).addRange(0x3105, 0x312F).addRange(0x31A0, 0x31BF).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF65);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Brahmi.js", function (module, exports) {
	  const set = regenerate(0x1107F);
	set.addRange(0x11000, 0x1104D).addRange(0x11052, 0x11075);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Braille.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x2800, 0x28FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Buginese.js", function (module, exports) {
	  const set = regenerate(0xA9CF);
	set.addRange(0x1A00, 0x1A1B).addRange(0x1A1E, 0x1A1F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Buhid.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1735, 0x1736).addRange(0x1740, 0x1753);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Canadian_Aboriginal.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1400, 0x167F).addRange(0x18B0, 0x18F5).addRange(0x11AB0, 0x11ABF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Carian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x102A0, 0x102D0);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Caucasian_Albanian.js", function (module, exports) {
	  const set = regenerate(0x1056F);
	set.addRange(0x10530, 0x10563);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Chakma.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x9E6, 0x9EF).addRange(0x1040, 0x1049).addRange(0x11100, 0x11134).addRange(0x11136, 0x11147);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Cham.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA5C, 0xAA5F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Cherokee.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0xAB70, 0xABBF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Chorasmian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10FB0, 0x10FCB);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Common.js", function (module, exports) {
	  const set = regenerate(0xD7, 0xF7, 0x374, 0x37E, 0x385, 0x387, 0x605, 0x6DD, 0x8E2, 0xE3F, 0x3000, 0x3004, 0x3012, 0x3020, 0x3036, 0x327F, 0x33FF, 0xAB5B, 0xFEFF, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1F7F0, 0xE0001);
	set.addRange(0x0, 0x40).addRange(0x5B, 0x60).addRange(0x7B, 0xA9).addRange(0xAB, 0xB9).addRange(0xBB, 0xBF).addRange(0x2B9, 0x2DF).addRange(0x2E5, 0x2E9).addRange(0x2EC, 0x2FF).addRange(0xFD5, 0xFD8).addRange(0x16EB, 0x16ED).addRange(0x2000, 0x200B).addRange(0x200E, 0x202E).addRange(0x2030, 0x2064).addRange(0x2066, 0x2070).addRange(0x2074, 0x207E).addRange(0x2080, 0x208E).addRange(0x20A0, 0x20C0).addRange(0x2100, 0x2125).addRange(0x2127, 0x2129).addRange(0x212C, 0x2131).addRange(0x2133, 0x214D).addRange(0x214F, 0x215F).addRange(0x2189, 0x218B).addRange(0x2190, 0x2426).addRange(0x2440, 0x244A).addRange(0x2460, 0x27FF).addRange(0x2900, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2BFF).addRange(0x2E00, 0x2E42).addRange(0x2E44, 0x2E5D).addRange(0x2FF0, 0x2FFB).addRange(0x3248, 0x325F).addRange(0x32B1, 0x32BF).addRange(0x32CC, 0x32CF).addRange(0x3371, 0x337A).addRange(0x3380, 0x33DF).addRange(0x4DC0, 0x4DFF).addRange(0xA708, 0xA721).addRange(0xA788, 0xA78A).addRange(0xAB6A, 0xAB6B).addRange(0xFE10, 0xFE19).addRange(0xFE30, 0xFE44).addRange(0xFE47, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFF01, 0xFF20).addRange(0xFF3B, 0xFF40).addRange(0xFF5B, 0xFF60).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE);
	set.addRange(0xFFF9, 0xFFFD).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D166).addRange(0x1D16A, 0x1D17A).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D300, 0x1D356).addRange(0x1D372, 0x1D378).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1EC71, 0x1ECB4).addRange(0x1ED01, 0x1ED3D).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F100, 0x1F1AD).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F201, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DD, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F773).addRange(0x1F780, 0x1F7D8);
	set.addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA).addRange(0x1FBF0, 0x1FBF9).addRange(0xE0020, 0xE007F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Coptic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x3E2, 0x3EF).addRange(0x2C80, 0x2CF3).addRange(0x2CF9, 0x2CFF).addRange(0x102E0, 0x102FB);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Cuneiform.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12470, 0x12474).addRange(0x12480, 0x12543);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Cypriot.js", function (module, exports) {
	  const set = regenerate(0x10808, 0x1083C, 0x1083F);
	set.addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1013F).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Cypro_Minoan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10100, 0x10101).addRange(0x12F90, 0x12FF2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Cyrillic.js", function (module, exports) {
	  const set = regenerate(0x1D2B, 0x1D78, 0x1DF8, 0x2E43);
	set.addRange(0x400, 0x52F).addRange(0x1C80, 0x1C88).addRange(0x2DE0, 0x2DFF).addRange(0xA640, 0xA69F).addRange(0xFE2E, 0xFE2F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Deseret.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10400, 0x1044F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Devanagari.js", function (module, exports) {
	  const set = regenerate(0x20F0);
	set.addRange(0x900, 0x952).addRange(0x955, 0x97F).addRange(0x1CD0, 0x1CF6).addRange(0x1CF8, 0x1CF9).addRange(0xA830, 0xA839).addRange(0xA8E0, 0xA8FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Dives_Akuru.js", function (module, exports) {
	  const set = regenerate(0x11909);
	set.addRange(0x11900, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11946).addRange(0x11950, 0x11959);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Dogra.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x964, 0x96F).addRange(0xA830, 0xA839).addRange(0x11800, 0x1183B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Duployan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9C, 0x1BCA3);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Egyptian_Hieroglyphs.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x13000, 0x1342E).addRange(0x13430, 0x13438);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Elbasan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10500, 0x10527);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Elymaic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10FE0, 0x10FF6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Ethiopic.js", function (module, exports) {
	  const set = regenerate(0x1258, 0x12C0);
	set.addRange(0x1200, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x137C).addRange(0x1380, 0x1399).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Georgian.js", function (module, exports) {
	  const set = regenerate(0x10C7, 0x10CD, 0x2D27, 0x2D2D);
	set.addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FF).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x2D00, 0x2D25);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Glagolitic.js", function (module, exports) {
	  const set = regenerate(0x484, 0x487, 0x2E43, 0xA66F);
	set.addRange(0x2C00, 0x2C5F).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Gothic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10330, 0x1034A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Grantha.js", function (module, exports) {
	  const set = regenerate(0x1CD0, 0x20F0, 0x11350, 0x11357, 0x11FD3);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xBE6, 0xBF3).addRange(0x1CD2, 0x1CD3).addRange(0x1CF2, 0x1CF4).addRange(0x1CF8, 0x1CF9).addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133B, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11FD0, 0x11FD1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Greek.js", function (module, exports) {
	  const set = regenerate(0x342, 0x345, 0x37F, 0x384, 0x386, 0x38C, 0x1F59, 0x1F5B, 0x1F5D, 0x2126, 0xAB65, 0x101A0);
	set.addRange(0x370, 0x373).addRange(0x375, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3E1).addRange(0x3F0, 0x3FF).addRange(0x1D26, 0x1D2A).addRange(0x1D5D, 0x1D61).addRange(0x1D66, 0x1D6A).addRange(0x1DBF, 0x1DC1).addRange(0x1F00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FC4).addRange(0x1FC6, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FDD, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFE).addRange(0x10140, 0x1018E).addRange(0x1D200, 0x1D245);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Gujarati.js", function (module, exports) {
	  const set = regenerate(0xAD0);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAF1).addRange(0xAF9, 0xAFF).addRange(0xA830, 0xA839);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Gunjala_Gondi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x964, 0x965).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Gurmukhi.js", function (module, exports) {
	  const set = regenerate(0xA3C, 0xA51, 0xA5E);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA76).addRange(0xA830, 0xA839);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Han.js", function (module, exports) {
	  const set = regenerate(0x3030, 0x30FB, 0x32FF);
	set.addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x3001, 0x3003).addRange(0x3005, 0x3011).addRange(0x3013, 0x301F).addRange(0x3021, 0x302D).addRange(0x3037, 0x303F).addRange(0x3190, 0x319F).addRange(0x31C0, 0x31E3).addRange(0x3220, 0x3247).addRange(0x3280, 0x32B0).addRange(0x32C0, 0x32CB).addRange(0x3358, 0x3370).addRange(0x337B, 0x337F).addRange(0x33E0, 0x33FE).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0x9FFF).addRange(0xA700, 0xA707).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF65).addRange(0x16FE2, 0x16FE3).addRange(0x16FF0, 0x16FF1).addRange(0x1D360, 0x1D371).addRange(0x1F250, 0x1F251).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Hangul.js", function (module, exports) {
	  const set = regenerate(0x3037, 0x30FB);
	set.addRange(0x1100, 0x11FF).addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3013, 0x301F).addRange(0x302E, 0x3030).addRange(0x3131, 0x318E).addRange(0x3200, 0x321E).addRange(0x3260, 0x327E).addRange(0xA960, 0xA97C).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF65).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Hanifi_Rohingya.js", function (module, exports) {
	  const set = regenerate(0x60C, 0x61B, 0x61F, 0x640, 0x6D4);
	set.addRange(0x10D00, 0x10D27).addRange(0x10D30, 0x10D39);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Hanunoo.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1720, 0x1736);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Hatran.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x108FB, 0x108FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Hebrew.js", function (module, exports) {
	  const set = regenerate(0xFB3E);
	set.addRange(0x591, 0x5C7).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F4).addRange(0xFB1D, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFB4F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Hiragana.js", function (module, exports) {
	  const set = regenerate(0x3037, 0xFF70, 0x1F200);
	set.addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3013, 0x301F).addRange(0x3030, 0x3035).addRange(0x303C, 0x303D).addRange(0x3041, 0x3096).addRange(0x3099, 0x30A0).addRange(0x30FB, 0x30FC).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF65).addRange(0xFF9E, 0xFF9F).addRange(0x1B001, 0x1B11F).addRange(0x1B150, 0x1B152);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Imperial_Aramaic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10840, 0x10855).addRange(0x10857, 0x1085F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Inherited.js", function (module, exports) {
	  const set = regenerate(0x1DF9, 0x101FD);
	set.addRange(0x300, 0x341).addRange(0x343, 0x344).addRange(0x346, 0x362).addRange(0x953, 0x954).addRange(0x1AB0, 0x1ACE).addRange(0x1DC2, 0x1DF7).addRange(0x1DFB, 0x1DFF).addRange(0x200C, 0x200D).addRange(0x20D0, 0x20EF).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2D).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Inscriptional_Pahlavi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10B60, 0x10B72).addRange(0x10B78, 0x10B7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Inscriptional_Parthian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10B40, 0x10B55).addRange(0x10B58, 0x10B5F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Javanese.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA980, 0xA9CD).addRange(0xA9CF, 0xA9D9).addRange(0xA9DE, 0xA9DF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Kaithi.js", function (module, exports) {
	  const set = regenerate(0x110CD);
	set.addRange(0x966, 0x96F).addRange(0xA830, 0xA839).addRange(0x11080, 0x110C2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Kannada.js", function (module, exports) {
	  const set = regenerate(0x1CD0, 0x1CD2, 0x1CDA, 0x1CF2, 0x1CF4);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xC80, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF2).addRange(0xA830, 0xA835);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Katakana.js", function (module, exports) {
	  const set = regenerate(0x3037, 0x1B000);
	set.addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3013, 0x301F).addRange(0x3030, 0x3035).addRange(0x303C, 0x303D).addRange(0x3099, 0x309C).addRange(0x30A0, 0x30FF).addRange(0x31F0, 0x31FF).addRange(0x32D0, 0x32FE).addRange(0x3300, 0x3357).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF9F).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B120, 0x1B122).addRange(0x1B164, 0x1B167);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Kayah_Li.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA900, 0xA92F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Kharoshthi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A3F, 0x10A48).addRange(0x10A50, 0x10A58);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Khitan_Small_Script.js", function (module, exports) {
	  const set = regenerate(0x16FE4);
	set.addRange(0x18B00, 0x18CD5);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Khmer.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1780, 0x17DD).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x19E0, 0x19FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Khojki.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xAE6, 0xAEF).addRange(0xA830, 0xA839).addRange(0x11200, 0x11211).addRange(0x11213, 0x1123E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Khudawadi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x964, 0x965).addRange(0xA830, 0xA839).addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Lao.js", function (module, exports) {
	  const set = regenerate(0xE84, 0xEA5, 0xEC6);
	set.addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECD).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Latin.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xBA, 0x10FB, 0x202F, 0x2071, 0x207F, 0x20F0, 0x2132, 0x214E, 0xA7D3, 0xA92E);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2B8).addRange(0x2E0, 0x2E4).addRange(0x363, 0x36F).addRange(0x485, 0x486).addRange(0x951, 0x952).addRange(0x1D00, 0x1D25).addRange(0x1D2C, 0x1D5C).addRange(0x1D62, 0x1D65).addRange(0x1D6B, 0x1D77).addRange(0x1D79, 0x1DBE).addRange(0x1E00, 0x1EFF).addRange(0x2090, 0x209C).addRange(0x212A, 0x212B).addRange(0x2160, 0x2188).addRange(0x2C60, 0x2C7F).addRange(0xA700, 0xA707).addRange(0xA722, 0xA787).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA7FF).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB64).addRange(0xAB66, 0xAB69).addRange(0xFB00, 0xFB06).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x1DF00, 0x1DF1E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Lepcha.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1C00, 0x1C37).addRange(0x1C3B, 0x1C49).addRange(0x1C4D, 0x1C4F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Limbu.js", function (module, exports) {
	  const set = regenerate(0x965, 0x1940);
	set.addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1944, 0x194F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Linear_A.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10107, 0x10133).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Linear_B.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1013F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Lisu.js", function (module, exports) {
	  const set = regenerate(0x11FB0);
	set.addRange(0xA4D0, 0xA4FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Lycian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10280, 0x1029C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Lydian.js", function (module, exports) {
	  const set = regenerate(0x1093F);
	set.addRange(0x10920, 0x10939);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Mahajani.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x964, 0x96F).addRange(0xA830, 0xA839).addRange(0x11150, 0x11176);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Makasar.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11EE0, 0x11EF8);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Malayalam.js", function (module, exports) {
	  const set = regenerate(0x1CDA);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4F).addRange(0xD54, 0xD63).addRange(0xD66, 0xD7F).addRange(0xA830, 0xA832);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Mandaic.js", function (module, exports) {
	  const set = regenerate(0x640, 0x85E);
	set.addRange(0x840, 0x85B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Manichaean.js", function (module, exports) {
	  const set = regenerate(0x640);
	set.addRange(0x10AC0, 0x10AE6).addRange(0x10AEB, 0x10AF6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Marchen.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11C70, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Masaram_Gondi.js", function (module, exports) {
	  const set = regenerate(0x11D3A);
	set.addRange(0x964, 0x965).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Medefaidrin.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16E40, 0x16E9A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Meetei_Mayek.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xAAE0, 0xAAF6).addRange(0xABC0, 0xABED).addRange(0xABF0, 0xABF9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Mende_Kikakui.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1E800, 0x1E8C4).addRange(0x1E8C7, 0x1E8D6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Meroitic_Cursive.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x109A0, 0x109B7).addRange(0x109BC, 0x109CF).addRange(0x109D2, 0x109FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Meroitic_Hieroglyphs.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10980, 0x1099F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Miao.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Modi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA830, 0xA839).addRange(0x11600, 0x11644).addRange(0x11650, 0x11659);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Mongolian.js", function (module, exports) {
	  const set = regenerate(0x202F);
	set.addRange(0x1800, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x11660, 0x1166C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Mro.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A6E, 0x16A6F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Multani.js", function (module, exports) {
	  const set = regenerate(0x11288);
	set.addRange(0xA66, 0xA6F).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Myanmar.js", function (module, exports) {
	  const set = regenerate(0xA92E);
	set.addRange(0x1000, 0x109F).addRange(0xA9E0, 0xA9FE).addRange(0xAA60, 0xAA7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Nabataean.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10880, 0x1089E).addRange(0x108A7, 0x108AF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Nandinagari.js", function (module, exports) {
	  const set = regenerate(0x1CE9, 0x1CF2, 0x1CFA);
	set.addRange(0x964, 0x965).addRange(0xCE6, 0xCEF).addRange(0xA830, 0xA835).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E4);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/New_Tai_Lue.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x19DE, 0x19DF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Newa.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11400, 0x1145B).addRange(0x1145D, 0x11461);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Nko.js", function (module, exports) {
	  const set = regenerate(0x60C, 0x61B, 0x61F);
	set.addRange(0x7C0, 0x7FA).addRange(0x7FD, 0x7FF).addRange(0xFD3E, 0xFD3F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Nushu.js", function (module, exports) {
	  const set = regenerate(0x16FE1);
	set.addRange(0x1B170, 0x1B2FB);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Nyiakeng_Puachue_Hmong.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E14E, 0x1E14F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Ogham.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1680, 0x169C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Ol_Chiki.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1C50, 0x1C7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Hungarian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10CFA, 0x10CFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Italic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10300, 0x10323).addRange(0x1032D, 0x1032F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_North_Arabian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10A80, 0x10A9F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Permic.js", function (module, exports) {
	  const set = regenerate(0x483);
	set.addRange(0x10350, 0x1037A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Persian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103D5);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Sogdian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10F00, 0x10F27);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_South_Arabian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10A60, 0x10A7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Turkic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10C00, 0x10C48);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Uyghur.js", function (module, exports) {
	  const set = regenerate(0x640, 0x10AF2);
	set.addRange(0x10F70, 0x10F89);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Oriya.js", function (module, exports) {
	  const set = regenerate(0x1CDA, 0x1CF2);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB77);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Osage.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Osmanya.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10480, 0x1049D).addRange(0x104A0, 0x104A9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Pahawh_Hmong.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16B00, 0x16B45).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Palmyrene.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10860, 0x1087F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Pau_Cin_Hau.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11AC0, 0x11AF8);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Phags_Pa.js", function (module, exports) {
	  const set = regenerate(0x1805);
	set.addRange(0x1802, 0x1803).addRange(0xA840, 0xA877);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Phoenician.js", function (module, exports) {
	  const set = regenerate(0x1091F);
	set.addRange(0x10900, 0x1091B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Psalter_Pahlavi.js", function (module, exports) {
	  const set = regenerate(0x640);
	set.addRange(0x10B80, 0x10B91).addRange(0x10B99, 0x10B9C).addRange(0x10BA9, 0x10BAF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Rejang.js", function (module, exports) {
	  const set = regenerate(0xA95F);
	set.addRange(0xA930, 0xA953);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Runic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Samaritan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x800, 0x82D).addRange(0x830, 0x83E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Saurashtra.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA880, 0xA8C5).addRange(0xA8CE, 0xA8D9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Sharada.js", function (module, exports) {
	  const set = regenerate(0x951, 0x1CD7, 0x1CD9, 0x1CE0);
	set.addRange(0x1CDC, 0x1CDD).addRange(0x11180, 0x111DF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Shavian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10450, 0x1047F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Siddham.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115DD);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/SignWriting.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1D800, 0x1DA8B).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Sinhala.js", function (module, exports) {
	  const set = regenerate(0xDBD, 0xDCA, 0xDD6);
	set.addRange(0x964, 0x965).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF4).addRange(0x111E1, 0x111F4);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Sogdian.js", function (module, exports) {
	  const set = regenerate(0x640);
	set.addRange(0x10F30, 0x10F59);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Sora_Sompeng.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Soyombo.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11A50, 0x11AA2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Sundanese.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1B80, 0x1BBF).addRange(0x1CC0, 0x1CC7);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Syloti_Nagri.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x964, 0x965).addRange(0x9E6, 0x9EF).addRange(0xA800, 0xA82C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Syriac.js", function (module, exports) {
	  const set = regenerate(0x60C, 0x61F, 0x640, 0x670, 0x1DF8, 0x1DFA);
	set.addRange(0x61B, 0x61C).addRange(0x64B, 0x655).addRange(0x700, 0x70D).addRange(0x70F, 0x74A).addRange(0x74D, 0x74F).addRange(0x860, 0x86A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tagalog.js", function (module, exports) {
	  const set = regenerate(0x171F);
	set.addRange(0x1700, 0x1715).addRange(0x1735, 0x1736);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tagbanwa.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1735, 0x1736).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Le.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1040, 0x1049).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Tham.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1A20, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AA0, 0x1AAD);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Viet.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xAA80, 0xAAC2).addRange(0xAADB, 0xAADF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Takri.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x964, 0x965).addRange(0xA830, 0xA839).addRange(0x11680, 0x116B9).addRange(0x116C0, 0x116C9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tamil.js", function (module, exports) {
	  const set = regenerate(0xB9C, 0xBD0, 0xBD7, 0x1CDA, 0xA8F3, 0x11301, 0x11303, 0x11FFF);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBFA).addRange(0x1133B, 0x1133C).addRange(0x11FC0, 0x11FF1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tangsa.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16A70, 0x16ABE).addRange(0x16AC0, 0x16AC9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tangut.js", function (module, exports) {
	  const set = regenerate(0x16FE0);
	set.addRange(0x17000, 0x187F7).addRange(0x18800, 0x18AFF).addRange(0x18D00, 0x18D08);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Telugu.js", function (module, exports) {
	  const set = regenerate(0xC5D, 0x1CDA, 0x1CF2);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC77, 0xC7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Thaana.js", function (module, exports) {
	  const set = regenerate(0x60C, 0x61F, 0xFDF2, 0xFDFD);
	set.addRange(0x61B, 0x61C).addRange(0x660, 0x669).addRange(0x780, 0x7B1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Thai.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xE01, 0xE3A).addRange(0xE40, 0xE5B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tibetan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xF00, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF97).addRange(0xF99, 0xFBC).addRange(0xFBE, 0xFCC).addRange(0xFCE, 0xFD4).addRange(0xFD9, 0xFDA);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tifinagh.js", function (module, exports) {
	  const set = regenerate(0x2D7F);
	set.addRange(0x2D30, 0x2D67).addRange(0x2D6F, 0x2D70);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Tirhuta.js", function (module, exports) {
	  const set = regenerate(0x1CF2);
	set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xA830, 0xA839).addRange(0x11480, 0x114C7).addRange(0x114D0, 0x114D9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Toto.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1E290, 0x1E2AE);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Ugaritic.js", function (module, exports) {
	  const set = regenerate(0x1039F);
	set.addRange(0x10380, 0x1039D);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Vai.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA500, 0xA62B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Vithkuqi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Wancho.js", function (module, exports) {
	  const set = regenerate(0x1E2FF);
	set.addRange(0x1E2C0, 0x1E2F9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Warang_Citi.js", function (module, exports) {
	  const set = regenerate(0x118FF);
	set.addRange(0x118A0, 0x118F2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Yezidi.js", function (module, exports) {
	  const set = regenerate(0x60C, 0x61B, 0x61F);
	set.addRange(0x660, 0x669).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAD).addRange(0x10EB0, 0x10EB1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Yi.js", function (module, exports) {
	  const set = regenerate(0x30FB);
	set.addRange(0x3001, 0x3002).addRange(0x3008, 0x3011).addRange(0x3014, 0x301B).addRange(0xA000, 0xA48C).addRange(0xA490, 0xA4C6).addRange(0xFF61, 0xFF65);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script_Extensions/Zanabazar_Square.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11A00, 0x11A47);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Adlam.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1E95E, 0x1E95F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Ahom.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11746);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Anatolian_Hieroglyphs.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x14400, 0x14646);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Arabic.js", function (module, exports) {
	  const set = regenerate(0xFDCF, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
	set.addRange(0x600, 0x604).addRange(0x606, 0x60B).addRange(0x60D, 0x61A).addRange(0x61C, 0x61E).addRange(0x620, 0x63F).addRange(0x641, 0x64A).addRange(0x656, 0x66F).addRange(0x671, 0x6DC).addRange(0x6DE, 0x6FF).addRange(0x750, 0x77F).addRange(0x870, 0x88E).addRange(0x890, 0x891).addRange(0x898, 0x8E1).addRange(0x8E3, 0x8FF).addRange(0xFB50, 0xFBC2).addRange(0xFBD3, 0xFD3D).addRange(0xFD40, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFF).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0x10E60, 0x10E7E).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Armenian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x531, 0x556).addRange(0x559, 0x58A).addRange(0x58D, 0x58F).addRange(0xFB13, 0xFB17);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Avestan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10B00, 0x10B35).addRange(0x10B39, 0x10B3F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Balinese.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B7E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Bamum.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA6A0, 0xA6F7).addRange(0x16800, 0x16A38);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Bassa_Vah.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF5);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Batak.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1BC0, 0x1BF3).addRange(0x1BFC, 0x1BFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Bengali.js", function (module, exports) {
	  const set = regenerate(0x9B2, 0x9D7);
	set.addRange(0x980, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9FE);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Bhaiksuki.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C45).addRange(0x11C50, 0x11C6C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Bopomofo.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x2EA, 0x2EB).addRange(0x3105, 0x312F).addRange(0x31A0, 0x31BF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Brahmi.js", function (module, exports) {
	  const set = regenerate(0x1107F);
	set.addRange(0x11000, 0x1104D).addRange(0x11052, 0x11075);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Braille.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x2800, 0x28FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Buginese.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1A00, 0x1A1B).addRange(0x1A1E, 0x1A1F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Buhid.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1740, 0x1753);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Canadian_Aboriginal.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1400, 0x167F).addRange(0x18B0, 0x18F5).addRange(0x11AB0, 0x11ABF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Carian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x102A0, 0x102D0);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Caucasian_Albanian.js", function (module, exports) {
	  const set = regenerate(0x1056F);
	set.addRange(0x10530, 0x10563);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Chakma.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11100, 0x11134).addRange(0x11136, 0x11147);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Cham.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA5C, 0xAA5F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Cherokee.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0xAB70, 0xABBF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Chorasmian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10FB0, 0x10FCB);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Common.js", function (module, exports) {
	  const set = regenerate(0xD7, 0xF7, 0x374, 0x37E, 0x385, 0x387, 0x605, 0x60C, 0x61B, 0x61F, 0x640, 0x6DD, 0x8E2, 0xE3F, 0x10FB, 0x1805, 0x1CD3, 0x1CE1, 0x1CFA, 0x3006, 0x30A0, 0x32FF, 0xA92E, 0xA9CF, 0xAB5B, 0xFEFF, 0xFF70, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1F7F0, 0xE0001);
	set.addRange(0x0, 0x40).addRange(0x5B, 0x60).addRange(0x7B, 0xA9).addRange(0xAB, 0xB9).addRange(0xBB, 0xBF).addRange(0x2B9, 0x2DF).addRange(0x2E5, 0x2E9).addRange(0x2EC, 0x2FF).addRange(0x964, 0x965).addRange(0xFD5, 0xFD8).addRange(0x16EB, 0x16ED).addRange(0x1735, 0x1736).addRange(0x1802, 0x1803).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF7).addRange(0x2000, 0x200B).addRange(0x200E, 0x2064).addRange(0x2066, 0x2070).addRange(0x2074, 0x207E).addRange(0x2080, 0x208E).addRange(0x20A0, 0x20C0).addRange(0x2100, 0x2125).addRange(0x2127, 0x2129).addRange(0x212C, 0x2131).addRange(0x2133, 0x214D).addRange(0x214F, 0x215F).addRange(0x2189, 0x218B).addRange(0x2190, 0x2426).addRange(0x2440, 0x244A).addRange(0x2460, 0x27FF).addRange(0x2900, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2BFF).addRange(0x2E00, 0x2E5D).addRange(0x2FF0, 0x2FFB).addRange(0x3000, 0x3004).addRange(0x3008, 0x3020).addRange(0x3030, 0x3037).addRange(0x303C, 0x303F).addRange(0x309B, 0x309C).addRange(0x30FB, 0x30FC).addRange(0x3190, 0x319F).addRange(0x31C0, 0x31E3).addRange(0x3220, 0x325F).addRange(0x327F, 0x32CF).addRange(0x3358, 0x33FF).addRange(0x4DC0, 0x4DFF).addRange(0xA700, 0xA721).addRange(0xA788, 0xA78A).addRange(0xA830, 0xA839);
	set.addRange(0xAB6A, 0xAB6B).addRange(0xFD3E, 0xFD3F).addRange(0xFE10, 0xFE19).addRange(0xFE30, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFF01, 0xFF20).addRange(0xFF3B, 0xFF40).addRange(0xFF5B, 0xFF65).addRange(0xFF9E, 0xFF9F).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFF9, 0xFFFD).addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1013F).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x102E1, 0x102FB).addRange(0x1BCA0, 0x1BCA3).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D166).addRange(0x1D16A, 0x1D17A).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D300, 0x1D356).addRange(0x1D360, 0x1D378).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1EC71, 0x1ECB4).addRange(0x1ED01, 0x1ED3D);
	set.addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F100, 0x1F1AD).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F201, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DD, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F773).addRange(0x1F780, 0x1F7D8).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA74).addRange(0x1FA78, 0x1FA7C).addRange(0x1FA80, 0x1FA86).addRange(0x1FA90, 0x1FAAC).addRange(0x1FAB0, 0x1FABA).addRange(0x1FAC0, 0x1FAC5).addRange(0x1FAD0, 0x1FAD9).addRange(0x1FAE0, 0x1FAE7).addRange(0x1FAF0, 0x1FAF6).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA).addRange(0x1FBF0, 0x1FBF9).addRange(0xE0020, 0xE007F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Coptic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x3E2, 0x3EF).addRange(0x2C80, 0x2CF3).addRange(0x2CF9, 0x2CFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Cuneiform.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12470, 0x12474).addRange(0x12480, 0x12543);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Cypriot.js", function (module, exports) {
	  const set = regenerate(0x10808, 0x1083C, 0x1083F);
	set.addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Cypro_Minoan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x12F90, 0x12FF2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Cyrillic.js", function (module, exports) {
	  const set = regenerate(0x1D2B, 0x1D78);
	set.addRange(0x400, 0x484).addRange(0x487, 0x52F).addRange(0x1C80, 0x1C88).addRange(0x2DE0, 0x2DFF).addRange(0xA640, 0xA69F).addRange(0xFE2E, 0xFE2F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Deseret.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10400, 0x1044F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Devanagari.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x900, 0x950).addRange(0x955, 0x963).addRange(0x966, 0x97F).addRange(0xA8E0, 0xA8FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Dives_Akuru.js", function (module, exports) {
	  const set = regenerate(0x11909);
	set.addRange(0x11900, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11946).addRange(0x11950, 0x11959);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Dogra.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11800, 0x1183B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Duployan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9C, 0x1BC9F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Egyptian_Hieroglyphs.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x13000, 0x1342E).addRange(0x13430, 0x13438);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Elbasan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10500, 0x10527);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Elymaic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10FE0, 0x10FF6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Ethiopic.js", function (module, exports) {
	  const set = regenerate(0x1258, 0x12C0);
	set.addRange(0x1200, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x137C).addRange(0x1380, 0x1399).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Georgian.js", function (module, exports) {
	  const set = regenerate(0x10C7, 0x10CD, 0x2D27, 0x2D2D);
	set.addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x10FF).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x2D00, 0x2D25);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Glagolitic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x2C00, 0x2C5F).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Gothic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10330, 0x1034A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Grantha.js", function (module, exports) {
	  const set = regenerate(0x11350, 0x11357);
	set.addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133C, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Greek.js", function (module, exports) {
	  const set = regenerate(0x37F, 0x384, 0x386, 0x38C, 0x1DBF, 0x1F59, 0x1F5B, 0x1F5D, 0x2126, 0xAB65, 0x101A0);
	set.addRange(0x370, 0x373).addRange(0x375, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3E1).addRange(0x3F0, 0x3FF).addRange(0x1D26, 0x1D2A).addRange(0x1D5D, 0x1D61).addRange(0x1D66, 0x1D6A).addRange(0x1F00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FC4).addRange(0x1FC6, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FDD, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFE).addRange(0x10140, 0x1018E).addRange(0x1D200, 0x1D245);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Gujarati.js", function (module, exports) {
	  const set = regenerate(0xAD0);
	set.addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAF1).addRange(0xAF9, 0xAFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Gunjala_Gondi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Gurmukhi.js", function (module, exports) {
	  const set = regenerate(0xA3C, 0xA51, 0xA5E);
	set.addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA76);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Han.js", function (module, exports) {
	  const set = regenerate(0x3005, 0x3007);
	set.addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x3021, 0x3029).addRange(0x3038, 0x303B).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0x9FFF).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0x16FE2, 0x16FE3).addRange(0x16FF0, 0x16FF1).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B738).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Hangul.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1100, 0x11FF).addRange(0x302E, 0x302F).addRange(0x3131, 0x318E).addRange(0x3200, 0x321E).addRange(0x3260, 0x327E).addRange(0xA960, 0xA97C).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Hanifi_Rohingya.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10D00, 0x10D27).addRange(0x10D30, 0x10D39);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Hanunoo.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1720, 0x1734);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Hatran.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x108FB, 0x108FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Hebrew.js", function (module, exports) {
	  const set = regenerate(0xFB3E);
	set.addRange(0x591, 0x5C7).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F4).addRange(0xFB1D, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFB4F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Hiragana.js", function (module, exports) {
	  const set = regenerate(0x1F200);
	set.addRange(0x3041, 0x3096).addRange(0x309D, 0x309F).addRange(0x1B001, 0x1B11F).addRange(0x1B150, 0x1B152);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Imperial_Aramaic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10840, 0x10855).addRange(0x10857, 0x1085F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Inherited.js", function (module, exports) {
	  const set = regenerate(0x670, 0x1CED, 0x1CF4, 0x101FD, 0x102E0, 0x1133B);
	set.addRange(0x300, 0x36F).addRange(0x485, 0x486).addRange(0x64B, 0x655).addRange(0x951, 0x954).addRange(0x1AB0, 0x1ACE).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CE0).addRange(0x1CE2, 0x1CE8).addRange(0x1CF8, 0x1CF9).addRange(0x1DC0, 0x1DFF).addRange(0x200C, 0x200D).addRange(0x20D0, 0x20F0).addRange(0x302A, 0x302D).addRange(0x3099, 0x309A).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2D).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0xE0100, 0xE01EF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Inscriptional_Pahlavi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10B60, 0x10B72).addRange(0x10B78, 0x10B7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Inscriptional_Parthian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10B40, 0x10B55).addRange(0x10B58, 0x10B5F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Javanese.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA980, 0xA9CD).addRange(0xA9D0, 0xA9D9).addRange(0xA9DE, 0xA9DF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Kaithi.js", function (module, exports) {
	  const set = regenerate(0x110CD);
	set.addRange(0x11080, 0x110C2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Kannada.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xC80, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Katakana.js", function (module, exports) {
	  const set = regenerate(0x1B000);
	set.addRange(0x30A1, 0x30FA).addRange(0x30FD, 0x30FF).addRange(0x31F0, 0x31FF).addRange(0x32D0, 0x32FE).addRange(0x3300, 0x3357).addRange(0xFF66, 0xFF6F).addRange(0xFF71, 0xFF9D).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B120, 0x1B122).addRange(0x1B164, 0x1B167);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Kayah_Li.js", function (module, exports) {
	  const set = regenerate(0xA92F);
	set.addRange(0xA900, 0xA92D);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Kharoshthi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A3F, 0x10A48).addRange(0x10A50, 0x10A58);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Khitan_Small_Script.js", function (module, exports) {
	  const set = regenerate(0x16FE4);
	set.addRange(0x18B00, 0x18CD5);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Khmer.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1780, 0x17DD).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x19E0, 0x19FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Khojki.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11200, 0x11211).addRange(0x11213, 0x1123E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Khudawadi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Lao.js", function (module, exports) {
	  const set = regenerate(0xE84, 0xEA5, 0xEC6);
	set.addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECD).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Latin.js", function (module, exports) {
	  const set = regenerate(0xAA, 0xBA, 0x2071, 0x207F, 0x2132, 0x214E, 0xA7D3);
	set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2B8).addRange(0x2E0, 0x2E4).addRange(0x1D00, 0x1D25).addRange(0x1D2C, 0x1D5C).addRange(0x1D62, 0x1D65).addRange(0x1D6B, 0x1D77).addRange(0x1D79, 0x1DBE).addRange(0x1E00, 0x1EFF).addRange(0x2090, 0x209C).addRange(0x212A, 0x212B).addRange(0x2160, 0x2188).addRange(0x2C60, 0x2C7F).addRange(0xA722, 0xA787).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA7FF).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB64).addRange(0xAB66, 0xAB69).addRange(0xFB00, 0xFB06).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x1DF00, 0x1DF1E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Lepcha.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1C00, 0x1C37).addRange(0x1C3B, 0x1C49).addRange(0x1C4D, 0x1C4F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Limbu.js", function (module, exports) {
	  const set = regenerate(0x1940);
	set.addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1944, 0x194F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Linear_A.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Linear_B.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Lisu.js", function (module, exports) {
	  const set = regenerate(0x11FB0);
	set.addRange(0xA4D0, 0xA4FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Lycian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10280, 0x1029C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Lydian.js", function (module, exports) {
	  const set = regenerate(0x1093F);
	set.addRange(0x10920, 0x10939);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Mahajani.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11150, 0x11176);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Makasar.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11EE0, 0x11EF8);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Malayalam.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4F).addRange(0xD54, 0xD63).addRange(0xD66, 0xD7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Mandaic.js", function (module, exports) {
	  const set = regenerate(0x85E);
	set.addRange(0x840, 0x85B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Manichaean.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10AC0, 0x10AE6).addRange(0x10AEB, 0x10AF6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Marchen.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11C70, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Masaram_Gondi.js", function (module, exports) {
	  const set = regenerate(0x11D3A);
	set.addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Medefaidrin.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16E40, 0x16E9A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Meetei_Mayek.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xAAE0, 0xAAF6).addRange(0xABC0, 0xABED).addRange(0xABF0, 0xABF9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Mende_Kikakui.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1E800, 0x1E8C4).addRange(0x1E8C7, 0x1E8D6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Meroitic_Cursive.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x109A0, 0x109B7).addRange(0x109BC, 0x109CF).addRange(0x109D2, 0x109FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Meroitic_Hieroglyphs.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10980, 0x1099F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Miao.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Modi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11600, 0x11644).addRange(0x11650, 0x11659);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Mongolian.js", function (module, exports) {
	  const set = regenerate(0x1804);
	set.addRange(0x1800, 0x1801).addRange(0x1806, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x11660, 0x1166C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Mro.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A6E, 0x16A6F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Multani.js", function (module, exports) {
	  const set = regenerate(0x11288);
	set.addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Myanmar.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1000, 0x109F).addRange(0xA9E0, 0xA9FE).addRange(0xAA60, 0xAA7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Nabataean.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10880, 0x1089E).addRange(0x108A7, 0x108AF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Nandinagari.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E4);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/New_Tai_Lue.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x19DE, 0x19DF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Newa.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11400, 0x1145B).addRange(0x1145D, 0x11461);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Nko.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x7C0, 0x7FA).addRange(0x7FD, 0x7FF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Nushu.js", function (module, exports) {
	  const set = regenerate(0x16FE1);
	set.addRange(0x1B170, 0x1B2FB);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Nyiakeng_Puachue_Hmong.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E14E, 0x1E14F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Ogham.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1680, 0x169C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Ol_Chiki.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1C50, 0x1C7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_Hungarian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10CFA, 0x10CFF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_Italic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10300, 0x10323).addRange(0x1032D, 0x1032F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_North_Arabian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10A80, 0x10A9F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_Permic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10350, 0x1037A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_Persian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103D5);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_Sogdian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10F00, 0x10F27);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_South_Arabian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10A60, 0x10A7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_Turkic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10C00, 0x10C48);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Old_Uyghur.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10F70, 0x10F89);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Oriya.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB77);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Osage.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Osmanya.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10480, 0x1049D).addRange(0x104A0, 0x104A9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Pahawh_Hmong.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16B00, 0x16B45).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Palmyrene.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10860, 0x1087F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Pau_Cin_Hau.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11AC0, 0x11AF8);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Phags_Pa.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA840, 0xA877);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Phoenician.js", function (module, exports) {
	  const set = regenerate(0x1091F);
	set.addRange(0x10900, 0x1091B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Psalter_Pahlavi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10B80, 0x10B91).addRange(0x10B99, 0x10B9C).addRange(0x10BA9, 0x10BAF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Rejang.js", function (module, exports) {
	  const set = regenerate(0xA95F);
	set.addRange(0xA930, 0xA953);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Runic.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Samaritan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x800, 0x82D).addRange(0x830, 0x83E);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Saurashtra.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA880, 0xA8C5).addRange(0xA8CE, 0xA8D9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Sharada.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11180, 0x111DF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Shavian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10450, 0x1047F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Siddham.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115DD);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/SignWriting.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1D800, 0x1DA8B).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Sinhala.js", function (module, exports) {
	  const set = regenerate(0xDBD, 0xDCA, 0xDD6);
	set.addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF4).addRange(0x111E1, 0x111F4);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Sogdian.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10F30, 0x10F59);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Sora_Sompeng.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Soyombo.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11A50, 0x11AA2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Sundanese.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1B80, 0x1BBF).addRange(0x1CC0, 0x1CC7);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Syloti_Nagri.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA800, 0xA82C);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Syriac.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x700, 0x70D).addRange(0x70F, 0x74A).addRange(0x74D, 0x74F).addRange(0x860, 0x86A);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tagalog.js", function (module, exports) {
	  const set = regenerate(0x171F);
	set.addRange(0x1700, 0x1715);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tagbanwa.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tai_Le.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1950, 0x196D).addRange(0x1970, 0x1974);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tai_Tham.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1A20, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AA0, 0x1AAD);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tai_Viet.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xAA80, 0xAAC2).addRange(0xAADB, 0xAADF);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Takri.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11680, 0x116B9).addRange(0x116C0, 0x116C9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tamil.js", function (module, exports) {
	  const set = regenerate(0xB9C, 0xBD0, 0xBD7, 0x11FFF);
	set.addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBFA).addRange(0x11FC0, 0x11FF1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tangsa.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x16A70, 0x16ABE).addRange(0x16AC0, 0x16AC9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tangut.js", function (module, exports) {
	  const set = regenerate(0x16FE0);
	set.addRange(0x17000, 0x187F7).addRange(0x18800, 0x18AFF).addRange(0x18D00, 0x18D08);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Telugu.js", function (module, exports) {
	  const set = regenerate(0xC5D);
	set.addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC77, 0xC7F);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Thaana.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x780, 0x7B1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Thai.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xE01, 0xE3A).addRange(0xE40, 0xE5B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tibetan.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xF00, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF97).addRange(0xF99, 0xFBC).addRange(0xFBE, 0xFCC).addRange(0xFCE, 0xFD4).addRange(0xFD9, 0xFDA);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tifinagh.js", function (module, exports) {
	  const set = regenerate(0x2D7F);
	set.addRange(0x2D30, 0x2D67).addRange(0x2D6F, 0x2D70);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Tirhuta.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11480, 0x114C7).addRange(0x114D0, 0x114D9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Toto.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x1E290, 0x1E2AE);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Ugaritic.js", function (module, exports) {
	  const set = regenerate(0x1039F);
	set.addRange(0x10380, 0x1039D);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Vai.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA500, 0xA62B);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Vithkuqi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Wancho.js", function (module, exports) {
	  const set = regenerate(0x1E2FF);
	set.addRange(0x1E2C0, 0x1E2F9);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Warang_Citi.js", function (module, exports) {
	  const set = regenerate(0x118FF);
	set.addRange(0x118A0, 0x118F2);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Yezidi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAD).addRange(0x10EB0, 0x10EB1);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Yi.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0xA000, 0xA48C).addRange(0xA490, 0xA4C6);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/Script/Zanabazar_Square.js", function (module, exports) {
	  const set = regenerate();
	set.addRange(0x11A00, 0x11A47);
	exports.characters = set;

	});

	commonjsRegister("/$$rollup_base$$/node_modules/regenerate-unicode-properties/unicode-version.js", function (module, exports) {
	  module.exports = '14.0.0';

	});

	function shallowEqual(actual, expected) {
	  const keys = Object.keys(expected);

	  for (const key of keys) {
	    if (actual[key] !== expected[key]) {
	      return false;
	    }
	  }

	  return true;
	}

	function isArrayExpression$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ArrayExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isAssignmentExpression$4(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "AssignmentExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBinaryExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "BinaryExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isInterpreterDirective(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "InterpreterDirective") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDirective(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Directive") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDirectiveLiteral(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DirectiveLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBlockStatement$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "BlockStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBreakStatement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "BreakStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isCallExpression$6(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "CallExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isCatchClause(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "CatchClause") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isConditionalExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ConditionalExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isContinueStatement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ContinueStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDebuggerStatement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DebuggerStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDoWhileStatement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DoWhileStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEmptyStatement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EmptyStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExpressionStatement$3(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ExpressionStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFile$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "File") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isForInStatement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ForInStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isForStatement$3(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ForStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFunctionDeclaration$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "FunctionDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFunctionExpression(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "FunctionExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isIdentifier$c(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Identifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isIfStatement$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "IfStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isLabeledStatement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "LabeledStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isStringLiteral$4(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "StringLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNumericLiteral(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "NumericLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNullLiteral$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "NullLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBooleanLiteral(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "BooleanLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isRegExpLiteral$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "RegExpLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isLogicalExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "LogicalExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isMemberExpression$6(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "MemberExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNewExpression$4(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "NewExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isProgram$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Program") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectExpression$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectMethod$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectMethod") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectProperty$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isRestElement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "RestElement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isReturnStatement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ReturnStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isSequenceExpression$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "SequenceExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isParenthesizedExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ParenthesizedExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isSwitchCase(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "SwitchCase") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isSwitchStatement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "SwitchStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isThisExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ThisExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isThrowStatement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ThrowStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTryStatement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TryStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isUnaryExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "UnaryExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isUpdateExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "UpdateExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isVariableDeclaration$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "VariableDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isVariableDeclarator$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "VariableDeclarator") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isWhileStatement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "WhileStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isWithStatement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "WithStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isAssignmentPattern$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "AssignmentPattern") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isArrayPattern(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ArrayPattern") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isArrowFunctionExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ArrowFunctionExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassBody$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassBody") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassDeclaration$3(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExportAllDeclaration$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ExportAllDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExportDefaultDeclaration$3(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ExportDefaultDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExportNamedDeclaration$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ExportNamedDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExportSpecifier(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ExportSpecifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isForOfStatement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ForOfStatement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isImportDeclaration$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ImportDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isImportDefaultSpecifier$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ImportDefaultSpecifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isImportNamespaceSpecifier$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ImportNamespaceSpecifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isImportSpecifier$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ImportSpecifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isMetaProperty(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "MetaProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassMethod(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassMethod") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectPattern$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectPattern") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isSpreadElement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "SpreadElement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isSuper$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Super") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTaggedTemplateExpression$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TaggedTemplateExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTemplateElement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TemplateElement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTemplateLiteral$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TemplateLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isYieldExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "YieldExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isAwaitExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "AwaitExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isImport(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Import") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBigIntLiteral(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "BigIntLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExportNamespaceSpecifier$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ExportNamespaceSpecifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isOptionalMemberExpression$3(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "OptionalMemberExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isOptionalCallExpression$3(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "OptionalCallExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassProperty(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassAccessorProperty(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassAccessorProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassPrivateProperty(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassPrivateProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassPrivateMethod(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassPrivateMethod") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPrivateName(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "PrivateName") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isStaticBlock(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "StaticBlock") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isAnyTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "AnyTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isArrayTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ArrayTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBooleanTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "BooleanTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBooleanLiteralTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "BooleanLiteralTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNullLiteralTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "NullLiteralTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClassImplements(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ClassImplements") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareClass(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareClass") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareFunction(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareFunction") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareInterface(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareInterface") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareModule(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareModule") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareModuleExports(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareModuleExports") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareTypeAlias(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareTypeAlias") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareOpaqueType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareOpaqueType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareVariable(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareVariable") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareExportDeclaration$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareExportDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclareExportAllDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclareExportAllDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclaredPredicate(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DeclaredPredicate") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExistsTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ExistsTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFunctionTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "FunctionTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFunctionTypeParam(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "FunctionTypeParam") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isGenericTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "GenericTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isInferredPredicate(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "InferredPredicate") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isInterfaceExtends(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "InterfaceExtends") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isInterfaceDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "InterfaceDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isInterfaceTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "InterfaceTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isIntersectionTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "IntersectionTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isMixedTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "MixedTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEmptyTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EmptyTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNullableTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "NullableTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNumberLiteralTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "NumberLiteralTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNumberTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "NumberTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectTypeInternalSlot(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectTypeInternalSlot") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectTypeCallProperty(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectTypeCallProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectTypeIndexer(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectTypeIndexer") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectTypeProperty(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectTypeProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectTypeSpreadProperty(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ObjectTypeSpreadProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isOpaqueType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "OpaqueType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isQualifiedTypeIdentifier(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "QualifiedTypeIdentifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isStringLiteralTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "StringLiteralTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isStringTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "StringTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isSymbolTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "SymbolTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isThisTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ThisTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTupleTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TupleTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTypeofTypeAnnotation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TypeofTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTypeAlias(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TypeAlias") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTypeAnnotation$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTypeCastExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TypeCastExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTypeParameter(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TypeParameter") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTypeParameterDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TypeParameterDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTypeParameterInstantiation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TypeParameterInstantiation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isUnionTypeAnnotation$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "UnionTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isVariance(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Variance") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isVoidTypeAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "VoidTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumBooleanBody(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumBooleanBody") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumNumberBody(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumNumberBody") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumStringBody(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumStringBody") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumSymbolBody(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumSymbolBody") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumBooleanMember(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumBooleanMember") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumNumberMember(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumNumberMember") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumStringMember(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumStringMember") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumDefaultedMember(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "EnumDefaultedMember") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isIndexedAccessType$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "IndexedAccessType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isOptionalIndexedAccessType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "OptionalIndexedAccessType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXAttribute(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXAttribute") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXClosingElement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXClosingElement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXElement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXElement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXEmptyExpression(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXEmptyExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXExpressionContainer(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXExpressionContainer") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXSpreadChild(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXSpreadChild") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXIdentifier$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXIdentifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXMemberExpression$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXMemberExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXNamespacedName(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXNamespacedName") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXOpeningElement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXOpeningElement") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXSpreadAttribute(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXSpreadAttribute") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXText(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXText") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXFragment(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXFragment") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXOpeningFragment(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXOpeningFragment") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSXClosingFragment(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "JSXClosingFragment") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNoop(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Noop") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPlaceholder$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Placeholder") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isV8IntrinsicIdentifier(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "V8IntrinsicIdentifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isArgumentPlaceholder(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ArgumentPlaceholder") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBindExpression(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "BindExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isImportAttribute(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ImportAttribute") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDecorator(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "Decorator") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDoExpression(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DoExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExportDefaultSpecifier$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ExportDefaultSpecifier") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isRecordExpression(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "RecordExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTupleExpression(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TupleExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDecimalLiteral(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "DecimalLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isModuleExpression(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "ModuleExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTopicReference(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TopicReference") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPipelineTopicExpression(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "PipelineTopicExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPipelineBareFunction(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "PipelineBareFunction") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPipelinePrimaryTopicReference(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "PipelinePrimaryTopicReference") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSParameterProperty(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSParameterProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSDeclareFunction(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSDeclareFunction") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSDeclareMethod(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSDeclareMethod") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSQualifiedName(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSQualifiedName") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSCallSignatureDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSCallSignatureDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSConstructSignatureDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSConstructSignatureDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSPropertySignature(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSPropertySignature") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSMethodSignature(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSMethodSignature") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSIndexSignature(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSIndexSignature") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSAnyKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSAnyKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSBooleanKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSBooleanKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSBigIntKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSBigIntKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSIntrinsicKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSIntrinsicKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSNeverKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSNeverKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSNullKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSNullKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSNumberKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSNumberKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSObjectKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSObjectKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSStringKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSStringKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSSymbolKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSSymbolKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSUndefinedKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSUndefinedKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSUnknownKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSUnknownKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSVoidKeyword(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSVoidKeyword") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSThisType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSThisType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSFunctionType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSFunctionType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSConstructorType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSConstructorType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeReference(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeReference") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypePredicate(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypePredicate") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeQuery(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeQuery") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeLiteral(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSArrayType$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSArrayType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTupleType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTupleType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSOptionalType$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSOptionalType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSRestType$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSRestType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSNamedTupleMember(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSNamedTupleMember") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSUnionType$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSUnionType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSIntersectionType$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSIntersectionType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSConditionalType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSConditionalType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSInferType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSInferType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSParenthesizedType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSParenthesizedType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeOperator(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeOperator") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSIndexedAccessType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSIndexedAccessType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSMappedType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSMappedType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSLiteralType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSLiteralType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSExpressionWithTypeArguments(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSExpressionWithTypeArguments") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSInterfaceDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSInterfaceDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSInterfaceBody(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSInterfaceBody") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeAliasDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeAliasDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSAsExpression$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSAsExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeAssertion$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeAssertion") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSEnumDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSEnumDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSEnumMember(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSEnumMember") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSModuleDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSModuleDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSModuleBlock(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSModuleBlock") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSImportType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSImportType") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSImportEqualsDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSImportEqualsDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSExternalModuleReference(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSExternalModuleReference") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSNonNullExpression$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSNonNullExpression") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSExportAssignment(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSExportAssignment") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSNamespaceExportDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSNamespaceExportDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeAnnotation$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeAnnotation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeParameterInstantiation(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeParameterInstantiation") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeParameterDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeParameterDeclaration") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeParameter(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "TSTypeParameter") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isStandardized(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ArrayExpression" === nodeType || "AssignmentExpression" === nodeType || "BinaryExpression" === nodeType || "InterpreterDirective" === nodeType || "Directive" === nodeType || "DirectiveLiteral" === nodeType || "BlockStatement" === nodeType || "BreakStatement" === nodeType || "CallExpression" === nodeType || "CatchClause" === nodeType || "ConditionalExpression" === nodeType || "ContinueStatement" === nodeType || "DebuggerStatement" === nodeType || "DoWhileStatement" === nodeType || "EmptyStatement" === nodeType || "ExpressionStatement" === nodeType || "File" === nodeType || "ForInStatement" === nodeType || "ForStatement" === nodeType || "FunctionDeclaration" === nodeType || "FunctionExpression" === nodeType || "Identifier" === nodeType || "IfStatement" === nodeType || "LabeledStatement" === nodeType || "StringLiteral" === nodeType || "NumericLiteral" === nodeType || "NullLiteral" === nodeType || "BooleanLiteral" === nodeType || "RegExpLiteral" === nodeType || "LogicalExpression" === nodeType || "MemberExpression" === nodeType || "NewExpression" === nodeType || "Program" === nodeType || "ObjectExpression" === nodeType || "ObjectMethod" === nodeType || "ObjectProperty" === nodeType || "RestElement" === nodeType || "ReturnStatement" === nodeType || "SequenceExpression" === nodeType || "ParenthesizedExpression" === nodeType || "SwitchCase" === nodeType || "SwitchStatement" === nodeType || "ThisExpression" === nodeType || "ThrowStatement" === nodeType || "TryStatement" === nodeType || "UnaryExpression" === nodeType || "UpdateExpression" === nodeType || "VariableDeclaration" === nodeType || "VariableDeclarator" === nodeType || "WhileStatement" === nodeType || "WithStatement" === nodeType || "AssignmentPattern" === nodeType || "ArrayPattern" === nodeType || "ArrowFunctionExpression" === nodeType || "ClassBody" === nodeType || "ClassExpression" === nodeType || "ClassDeclaration" === nodeType || "ExportAllDeclaration" === nodeType || "ExportDefaultDeclaration" === nodeType || "ExportNamedDeclaration" === nodeType || "ExportSpecifier" === nodeType || "ForOfStatement" === nodeType || "ImportDeclaration" === nodeType || "ImportDefaultSpecifier" === nodeType || "ImportNamespaceSpecifier" === nodeType || "ImportSpecifier" === nodeType || "MetaProperty" === nodeType || "ClassMethod" === nodeType || "ObjectPattern" === nodeType || "SpreadElement" === nodeType || "Super" === nodeType || "TaggedTemplateExpression" === nodeType || "TemplateElement" === nodeType || "TemplateLiteral" === nodeType || "YieldExpression" === nodeType || "AwaitExpression" === nodeType || "Import" === nodeType || "BigIntLiteral" === nodeType || "ExportNamespaceSpecifier" === nodeType || "OptionalMemberExpression" === nodeType || "OptionalCallExpression" === nodeType || "ClassProperty" === nodeType || "ClassAccessorProperty" === nodeType || "ClassPrivateProperty" === nodeType || "ClassPrivateMethod" === nodeType || "PrivateName" === nodeType || "StaticBlock" === nodeType || nodeType === "Placeholder" && ("Identifier" === node.expectedNode || "StringLiteral" === node.expectedNode || "BlockStatement" === node.expectedNode || "ClassBody" === node.expectedNode)) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExpression$4(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ArrayExpression" === nodeType || "AssignmentExpression" === nodeType || "BinaryExpression" === nodeType || "CallExpression" === nodeType || "ConditionalExpression" === nodeType || "FunctionExpression" === nodeType || "Identifier" === nodeType || "StringLiteral" === nodeType || "NumericLiteral" === nodeType || "NullLiteral" === nodeType || "BooleanLiteral" === nodeType || "RegExpLiteral" === nodeType || "LogicalExpression" === nodeType || "MemberExpression" === nodeType || "NewExpression" === nodeType || "ObjectExpression" === nodeType || "SequenceExpression" === nodeType || "ParenthesizedExpression" === nodeType || "ThisExpression" === nodeType || "UnaryExpression" === nodeType || "UpdateExpression" === nodeType || "ArrowFunctionExpression" === nodeType || "ClassExpression" === nodeType || "MetaProperty" === nodeType || "Super" === nodeType || "TaggedTemplateExpression" === nodeType || "TemplateLiteral" === nodeType || "YieldExpression" === nodeType || "AwaitExpression" === nodeType || "Import" === nodeType || "BigIntLiteral" === nodeType || "OptionalMemberExpression" === nodeType || "OptionalCallExpression" === nodeType || "TypeCastExpression" === nodeType || "JSXElement" === nodeType || "JSXFragment" === nodeType || "BindExpression" === nodeType || "DoExpression" === nodeType || "RecordExpression" === nodeType || "TupleExpression" === nodeType || "DecimalLiteral" === nodeType || "ModuleExpression" === nodeType || "TopicReference" === nodeType || "PipelineTopicExpression" === nodeType || "PipelineBareFunction" === nodeType || "PipelinePrimaryTopicReference" === nodeType || "TSAsExpression" === nodeType || "TSTypeAssertion" === nodeType || "TSNonNullExpression" === nodeType || nodeType === "Placeholder" && ("Expression" === node.expectedNode || "Identifier" === node.expectedNode || "StringLiteral" === node.expectedNode)) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBinary$3(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("BinaryExpression" === nodeType || "LogicalExpression" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isScopable(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("BlockStatement" === nodeType || "CatchClause" === nodeType || "DoWhileStatement" === nodeType || "ForInStatement" === nodeType || "ForStatement" === nodeType || "FunctionDeclaration" === nodeType || "FunctionExpression" === nodeType || "Program" === nodeType || "ObjectMethod" === nodeType || "SwitchStatement" === nodeType || "WhileStatement" === nodeType || "ArrowFunctionExpression" === nodeType || "ClassExpression" === nodeType || "ClassDeclaration" === nodeType || "ForOfStatement" === nodeType || "ClassMethod" === nodeType || "ClassPrivateMethod" === nodeType || "StaticBlock" === nodeType || "TSModuleBlock" === nodeType || nodeType === "Placeholder" && "BlockStatement" === node.expectedNode) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBlockParent(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("BlockStatement" === nodeType || "CatchClause" === nodeType || "DoWhileStatement" === nodeType || "ForInStatement" === nodeType || "ForStatement" === nodeType || "FunctionDeclaration" === nodeType || "FunctionExpression" === nodeType || "Program" === nodeType || "ObjectMethod" === nodeType || "SwitchStatement" === nodeType || "WhileStatement" === nodeType || "ArrowFunctionExpression" === nodeType || "ForOfStatement" === nodeType || "ClassMethod" === nodeType || "ClassPrivateMethod" === nodeType || "StaticBlock" === nodeType || "TSModuleBlock" === nodeType || nodeType === "Placeholder" && "BlockStatement" === node.expectedNode) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isBlock(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("BlockStatement" === nodeType || "Program" === nodeType || "TSModuleBlock" === nodeType || nodeType === "Placeholder" && "BlockStatement" === node.expectedNode) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isStatement$7(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("BlockStatement" === nodeType || "BreakStatement" === nodeType || "ContinueStatement" === nodeType || "DebuggerStatement" === nodeType || "DoWhileStatement" === nodeType || "EmptyStatement" === nodeType || "ExpressionStatement" === nodeType || "ForInStatement" === nodeType || "ForStatement" === nodeType || "FunctionDeclaration" === nodeType || "IfStatement" === nodeType || "LabeledStatement" === nodeType || "ReturnStatement" === nodeType || "SwitchStatement" === nodeType || "ThrowStatement" === nodeType || "TryStatement" === nodeType || "VariableDeclaration" === nodeType || "WhileStatement" === nodeType || "WithStatement" === nodeType || "ClassDeclaration" === nodeType || "ExportAllDeclaration" === nodeType || "ExportDefaultDeclaration" === nodeType || "ExportNamedDeclaration" === nodeType || "ForOfStatement" === nodeType || "ImportDeclaration" === nodeType || "DeclareClass" === nodeType || "DeclareFunction" === nodeType || "DeclareInterface" === nodeType || "DeclareModule" === nodeType || "DeclareModuleExports" === nodeType || "DeclareTypeAlias" === nodeType || "DeclareOpaqueType" === nodeType || "DeclareVariable" === nodeType || "DeclareExportDeclaration" === nodeType || "DeclareExportAllDeclaration" === nodeType || "InterfaceDeclaration" === nodeType || "OpaqueType" === nodeType || "TypeAlias" === nodeType || "EnumDeclaration" === nodeType || "TSDeclareFunction" === nodeType || "TSInterfaceDeclaration" === nodeType || "TSTypeAliasDeclaration" === nodeType || "TSEnumDeclaration" === nodeType || "TSModuleDeclaration" === nodeType || "TSImportEqualsDeclaration" === nodeType || "TSExportAssignment" === nodeType || "TSNamespaceExportDeclaration" === nodeType || nodeType === "Placeholder" && ("Statement" === node.expectedNode || "Declaration" === node.expectedNode || "BlockStatement" === node.expectedNode)) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTerminatorless(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("BreakStatement" === nodeType || "ContinueStatement" === nodeType || "ReturnStatement" === nodeType || "ThrowStatement" === nodeType || "YieldExpression" === nodeType || "AwaitExpression" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isCompletionStatement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("BreakStatement" === nodeType || "ContinueStatement" === nodeType || "ReturnStatement" === nodeType || "ThrowStatement" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isConditional$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ConditionalExpression" === nodeType || "IfStatement" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isLoop$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("DoWhileStatement" === nodeType || "ForInStatement" === nodeType || "ForStatement" === nodeType || "WhileStatement" === nodeType || "ForOfStatement" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isWhile(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("DoWhileStatement" === nodeType || "WhileStatement" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExpressionWrapper(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ExpressionStatement" === nodeType || "ParenthesizedExpression" === nodeType || "TypeCastExpression" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFor$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ForInStatement" === nodeType || "ForStatement" === nodeType || "ForOfStatement" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isForXStatement$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ForInStatement" === nodeType || "ForOfStatement" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFunction$5(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("FunctionDeclaration" === nodeType || "FunctionExpression" === nodeType || "ObjectMethod" === nodeType || "ArrowFunctionExpression" === nodeType || "ClassMethod" === nodeType || "ClassPrivateMethod" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFunctionParent(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("FunctionDeclaration" === nodeType || "FunctionExpression" === nodeType || "ObjectMethod" === nodeType || "ArrowFunctionExpression" === nodeType || "ClassMethod" === nodeType || "ClassPrivateMethod" === nodeType || "StaticBlock" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPureish$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("FunctionDeclaration" === nodeType || "FunctionExpression" === nodeType || "StringLiteral" === nodeType || "NumericLiteral" === nodeType || "NullLiteral" === nodeType || "BooleanLiteral" === nodeType || "RegExpLiteral" === nodeType || "ArrowFunctionExpression" === nodeType || "BigIntLiteral" === nodeType || "DecimalLiteral" === nodeType || nodeType === "Placeholder" && "StringLiteral" === node.expectedNode) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isDeclaration$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("FunctionDeclaration" === nodeType || "VariableDeclaration" === nodeType || "ClassDeclaration" === nodeType || "ExportAllDeclaration" === nodeType || "ExportDefaultDeclaration" === nodeType || "ExportNamedDeclaration" === nodeType || "ImportDeclaration" === nodeType || "DeclareClass" === nodeType || "DeclareFunction" === nodeType || "DeclareInterface" === nodeType || "DeclareModule" === nodeType || "DeclareModuleExports" === nodeType || "DeclareTypeAlias" === nodeType || "DeclareOpaqueType" === nodeType || "DeclareVariable" === nodeType || "DeclareExportDeclaration" === nodeType || "DeclareExportAllDeclaration" === nodeType || "InterfaceDeclaration" === nodeType || "OpaqueType" === nodeType || "TypeAlias" === nodeType || "EnumDeclaration" === nodeType || "TSDeclareFunction" === nodeType || "TSInterfaceDeclaration" === nodeType || "TSTypeAliasDeclaration" === nodeType || "TSEnumDeclaration" === nodeType || "TSModuleDeclaration" === nodeType || nodeType === "Placeholder" && "Declaration" === node.expectedNode) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPatternLike(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("Identifier" === nodeType || "RestElement" === nodeType || "AssignmentPattern" === nodeType || "ArrayPattern" === nodeType || "ObjectPattern" === nodeType || nodeType === "Placeholder" && ("Pattern" === node.expectedNode || "Identifier" === node.expectedNode)) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isLVal(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("Identifier" === nodeType || "MemberExpression" === nodeType || "RestElement" === nodeType || "AssignmentPattern" === nodeType || "ArrayPattern" === nodeType || "ObjectPattern" === nodeType || "TSParameterProperty" === nodeType || nodeType === "Placeholder" && ("Pattern" === node.expectedNode || "Identifier" === node.expectedNode)) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSEntityName(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("Identifier" === nodeType || "TSQualifiedName" === nodeType || nodeType === "Placeholder" && "Identifier" === node.expectedNode) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isLiteral$5(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("StringLiteral" === nodeType || "NumericLiteral" === nodeType || "NullLiteral" === nodeType || "BooleanLiteral" === nodeType || "RegExpLiteral" === nodeType || "TemplateLiteral" === nodeType || "BigIntLiteral" === nodeType || "DecimalLiteral" === nodeType || nodeType === "Placeholder" && "StringLiteral" === node.expectedNode) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isUserWhitespacable(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ObjectMethod" === nodeType || "ObjectProperty" === nodeType || "ObjectTypeInternalSlot" === nodeType || "ObjectTypeCallProperty" === nodeType || "ObjectTypeIndexer" === nodeType || "ObjectTypeProperty" === nodeType || "ObjectTypeSpreadProperty" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isMethod$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ObjectMethod" === nodeType || "ClassMethod" === nodeType || "ClassPrivateMethod" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isObjectMember(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ObjectMethod" === nodeType || "ObjectProperty" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isProperty$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ObjectProperty" === nodeType || "ClassProperty" === nodeType || "ClassAccessorProperty" === nodeType || "ClassPrivateProperty" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isUnaryLike$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("UnaryExpression" === nodeType || "SpreadElement" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPattern(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("AssignmentPattern" === nodeType || "ArrayPattern" === nodeType || "ObjectPattern" === nodeType || nodeType === "Placeholder" && "Pattern" === node.expectedNode) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isClass$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ClassExpression" === nodeType || "ClassDeclaration" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isModuleDeclaration$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ExportAllDeclaration" === nodeType || "ExportDefaultDeclaration" === nodeType || "ExportNamedDeclaration" === nodeType || "ImportDeclaration" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isExportDeclaration$2(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ExportAllDeclaration" === nodeType || "ExportDefaultDeclaration" === nodeType || "ExportNamedDeclaration" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isModuleSpecifier$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ExportSpecifier" === nodeType || "ImportDefaultSpecifier" === nodeType || "ImportNamespaceSpecifier" === nodeType || "ImportSpecifier" === nodeType || "ExportNamespaceSpecifier" === nodeType || "ExportDefaultSpecifier" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isAccessor(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ClassAccessorProperty" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isPrivate(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("ClassPrivateProperty" === nodeType || "ClassPrivateMethod" === nodeType || "PrivateName" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFlow$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("AnyTypeAnnotation" === nodeType || "ArrayTypeAnnotation" === nodeType || "BooleanTypeAnnotation" === nodeType || "BooleanLiteralTypeAnnotation" === nodeType || "NullLiteralTypeAnnotation" === nodeType || "ClassImplements" === nodeType || "DeclareClass" === nodeType || "DeclareFunction" === nodeType || "DeclareInterface" === nodeType || "DeclareModule" === nodeType || "DeclareModuleExports" === nodeType || "DeclareTypeAlias" === nodeType || "DeclareOpaqueType" === nodeType || "DeclareVariable" === nodeType || "DeclareExportDeclaration" === nodeType || "DeclareExportAllDeclaration" === nodeType || "DeclaredPredicate" === nodeType || "ExistsTypeAnnotation" === nodeType || "FunctionTypeAnnotation" === nodeType || "FunctionTypeParam" === nodeType || "GenericTypeAnnotation" === nodeType || "InferredPredicate" === nodeType || "InterfaceExtends" === nodeType || "InterfaceDeclaration" === nodeType || "InterfaceTypeAnnotation" === nodeType || "IntersectionTypeAnnotation" === nodeType || "MixedTypeAnnotation" === nodeType || "EmptyTypeAnnotation" === nodeType || "NullableTypeAnnotation" === nodeType || "NumberLiteralTypeAnnotation" === nodeType || "NumberTypeAnnotation" === nodeType || "ObjectTypeAnnotation" === nodeType || "ObjectTypeInternalSlot" === nodeType || "ObjectTypeCallProperty" === nodeType || "ObjectTypeIndexer" === nodeType || "ObjectTypeProperty" === nodeType || "ObjectTypeSpreadProperty" === nodeType || "OpaqueType" === nodeType || "QualifiedTypeIdentifier" === nodeType || "StringLiteralTypeAnnotation" === nodeType || "StringTypeAnnotation" === nodeType || "SymbolTypeAnnotation" === nodeType || "ThisTypeAnnotation" === nodeType || "TupleTypeAnnotation" === nodeType || "TypeofTypeAnnotation" === nodeType || "TypeAlias" === nodeType || "TypeAnnotation" === nodeType || "TypeCastExpression" === nodeType || "TypeParameter" === nodeType || "TypeParameterDeclaration" === nodeType || "TypeParameterInstantiation" === nodeType || "UnionTypeAnnotation" === nodeType || "Variance" === nodeType || "VoidTypeAnnotation" === nodeType || "EnumDeclaration" === nodeType || "EnumBooleanBody" === nodeType || "EnumNumberBody" === nodeType || "EnumStringBody" === nodeType || "EnumSymbolBody" === nodeType || "EnumBooleanMember" === nodeType || "EnumNumberMember" === nodeType || "EnumStringMember" === nodeType || "EnumDefaultedMember" === nodeType || "IndexedAccessType" === nodeType || "OptionalIndexedAccessType" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFlowType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("AnyTypeAnnotation" === nodeType || "ArrayTypeAnnotation" === nodeType || "BooleanTypeAnnotation" === nodeType || "BooleanLiteralTypeAnnotation" === nodeType || "NullLiteralTypeAnnotation" === nodeType || "ExistsTypeAnnotation" === nodeType || "FunctionTypeAnnotation" === nodeType || "GenericTypeAnnotation" === nodeType || "InterfaceTypeAnnotation" === nodeType || "IntersectionTypeAnnotation" === nodeType || "MixedTypeAnnotation" === nodeType || "EmptyTypeAnnotation" === nodeType || "NullableTypeAnnotation" === nodeType || "NumberLiteralTypeAnnotation" === nodeType || "NumberTypeAnnotation" === nodeType || "ObjectTypeAnnotation" === nodeType || "StringLiteralTypeAnnotation" === nodeType || "StringTypeAnnotation" === nodeType || "SymbolTypeAnnotation" === nodeType || "ThisTypeAnnotation" === nodeType || "TupleTypeAnnotation" === nodeType || "TypeofTypeAnnotation" === nodeType || "UnionTypeAnnotation" === nodeType || "VoidTypeAnnotation" === nodeType || "IndexedAccessType" === nodeType || "OptionalIndexedAccessType" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFlowBaseAnnotation$1(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("AnyTypeAnnotation" === nodeType || "BooleanTypeAnnotation" === nodeType || "NullLiteralTypeAnnotation" === nodeType || "MixedTypeAnnotation" === nodeType || "EmptyTypeAnnotation" === nodeType || "NumberTypeAnnotation" === nodeType || "StringTypeAnnotation" === nodeType || "SymbolTypeAnnotation" === nodeType || "ThisTypeAnnotation" === nodeType || "VoidTypeAnnotation" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFlowDeclaration(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("DeclareClass" === nodeType || "DeclareFunction" === nodeType || "DeclareInterface" === nodeType || "DeclareModule" === nodeType || "DeclareModuleExports" === nodeType || "DeclareTypeAlias" === nodeType || "DeclareOpaqueType" === nodeType || "DeclareVariable" === nodeType || "DeclareExportDeclaration" === nodeType || "DeclareExportAllDeclaration" === nodeType || "InterfaceDeclaration" === nodeType || "OpaqueType" === nodeType || "TypeAlias" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isFlowPredicate(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("DeclaredPredicate" === nodeType || "InferredPredicate" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumBody(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("EnumBooleanBody" === nodeType || "EnumNumberBody" === nodeType || "EnumStringBody" === nodeType || "EnumSymbolBody" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isEnumMember(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("EnumBooleanMember" === nodeType || "EnumNumberMember" === nodeType || "EnumStringMember" === nodeType || "EnumDefaultedMember" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isJSX(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("JSXAttribute" === nodeType || "JSXClosingElement" === nodeType || "JSXElement" === nodeType || "JSXEmptyExpression" === nodeType || "JSXExpressionContainer" === nodeType || "JSXSpreadChild" === nodeType || "JSXIdentifier" === nodeType || "JSXMemberExpression" === nodeType || "JSXNamespacedName" === nodeType || "JSXOpeningElement" === nodeType || "JSXSpreadAttribute" === nodeType || "JSXText" === nodeType || "JSXFragment" === nodeType || "JSXOpeningFragment" === nodeType || "JSXClosingFragment" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isMiscellaneous(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("Noop" === nodeType || "Placeholder" === nodeType || "V8IntrinsicIdentifier" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTypeScript(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("TSParameterProperty" === nodeType || "TSDeclareFunction" === nodeType || "TSDeclareMethod" === nodeType || "TSQualifiedName" === nodeType || "TSCallSignatureDeclaration" === nodeType || "TSConstructSignatureDeclaration" === nodeType || "TSPropertySignature" === nodeType || "TSMethodSignature" === nodeType || "TSIndexSignature" === nodeType || "TSAnyKeyword" === nodeType || "TSBooleanKeyword" === nodeType || "TSBigIntKeyword" === nodeType || "TSIntrinsicKeyword" === nodeType || "TSNeverKeyword" === nodeType || "TSNullKeyword" === nodeType || "TSNumberKeyword" === nodeType || "TSObjectKeyword" === nodeType || "TSStringKeyword" === nodeType || "TSSymbolKeyword" === nodeType || "TSUndefinedKeyword" === nodeType || "TSUnknownKeyword" === nodeType || "TSVoidKeyword" === nodeType || "TSThisType" === nodeType || "TSFunctionType" === nodeType || "TSConstructorType" === nodeType || "TSTypeReference" === nodeType || "TSTypePredicate" === nodeType || "TSTypeQuery" === nodeType || "TSTypeLiteral" === nodeType || "TSArrayType" === nodeType || "TSTupleType" === nodeType || "TSOptionalType" === nodeType || "TSRestType" === nodeType || "TSNamedTupleMember" === nodeType || "TSUnionType" === nodeType || "TSIntersectionType" === nodeType || "TSConditionalType" === nodeType || "TSInferType" === nodeType || "TSParenthesizedType" === nodeType || "TSTypeOperator" === nodeType || "TSIndexedAccessType" === nodeType || "TSMappedType" === nodeType || "TSLiteralType" === nodeType || "TSExpressionWithTypeArguments" === nodeType || "TSInterfaceDeclaration" === nodeType || "TSInterfaceBody" === nodeType || "TSTypeAliasDeclaration" === nodeType || "TSAsExpression" === nodeType || "TSTypeAssertion" === nodeType || "TSEnumDeclaration" === nodeType || "TSEnumMember" === nodeType || "TSModuleDeclaration" === nodeType || "TSModuleBlock" === nodeType || "TSImportType" === nodeType || "TSImportEqualsDeclaration" === nodeType || "TSExternalModuleReference" === nodeType || "TSNonNullExpression" === nodeType || "TSExportAssignment" === nodeType || "TSNamespaceExportDeclaration" === nodeType || "TSTypeAnnotation" === nodeType || "TSTypeParameterInstantiation" === nodeType || "TSTypeParameterDeclaration" === nodeType || "TSTypeParameter" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSTypeElement(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("TSCallSignatureDeclaration" === nodeType || "TSConstructSignatureDeclaration" === nodeType || "TSPropertySignature" === nodeType || "TSMethodSignature" === nodeType || "TSIndexSignature" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("TSAnyKeyword" === nodeType || "TSBooleanKeyword" === nodeType || "TSBigIntKeyword" === nodeType || "TSIntrinsicKeyword" === nodeType || "TSNeverKeyword" === nodeType || "TSNullKeyword" === nodeType || "TSNumberKeyword" === nodeType || "TSObjectKeyword" === nodeType || "TSStringKeyword" === nodeType || "TSSymbolKeyword" === nodeType || "TSUndefinedKeyword" === nodeType || "TSUnknownKeyword" === nodeType || "TSVoidKeyword" === nodeType || "TSThisType" === nodeType || "TSFunctionType" === nodeType || "TSConstructorType" === nodeType || "TSTypeReference" === nodeType || "TSTypePredicate" === nodeType || "TSTypeQuery" === nodeType || "TSTypeLiteral" === nodeType || "TSArrayType" === nodeType || "TSTupleType" === nodeType || "TSOptionalType" === nodeType || "TSRestType" === nodeType || "TSUnionType" === nodeType || "TSIntersectionType" === nodeType || "TSConditionalType" === nodeType || "TSInferType" === nodeType || "TSParenthesizedType" === nodeType || "TSTypeOperator" === nodeType || "TSIndexedAccessType" === nodeType || "TSMappedType" === nodeType || "TSLiteralType" === nodeType || "TSExpressionWithTypeArguments" === nodeType || "TSImportType" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isTSBaseType(node, opts) {
	  if (!node) return false;
	  const nodeType = node.type;

	  if ("TSAnyKeyword" === nodeType || "TSBooleanKeyword" === nodeType || "TSBigIntKeyword" === nodeType || "TSIntrinsicKeyword" === nodeType || "TSNeverKeyword" === nodeType || "TSNullKeyword" === nodeType || "TSNumberKeyword" === nodeType || "TSObjectKeyword" === nodeType || "TSStringKeyword" === nodeType || "TSSymbolKeyword" === nodeType || "TSUndefinedKeyword" === nodeType || "TSUnknownKeyword" === nodeType || "TSVoidKeyword" === nodeType || "TSThisType" === nodeType || "TSLiteralType" === nodeType) {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isNumberLiteral(node, opts) {
	  console.trace("The node type NumberLiteral has been renamed to NumericLiteral");
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "NumberLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isRegexLiteral(node, opts) {
	  console.trace("The node type RegexLiteral has been renamed to RegExpLiteral");
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "RegexLiteral") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isRestProperty(node, opts) {
	  console.trace("The node type RestProperty has been renamed to RestElement");
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "RestProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}
	function isSpreadProperty(node, opts) {
	  console.trace("The node type SpreadProperty has been renamed to SpreadElement");
	  if (!node) return false;
	  const nodeType = node.type;

	  if (nodeType === "SpreadProperty") {
	    if (typeof opts === "undefined") {
	      return true;
	    } else {
	      return shallowEqual(node, opts);
	    }
	  }

	  return false;
	}

	function matchesPattern$2(member, match, allowPartial) {
	  if (!isMemberExpression$6(member)) return false;
	  const parts = Array.isArray(match) ? match : match.split(".");
	  const nodes = [];
	  let node;

	  for (node = member; isMemberExpression$6(node); node = node.object) {
	    nodes.push(node.property);
	  }

	  nodes.push(node);
	  if (nodes.length < parts.length) return false;
	  if (!allowPartial && nodes.length > parts.length) return false;

	  for (let i = 0, j = nodes.length - 1; i < parts.length; i++, j--) {
	    const node = nodes[j];
	    let value;

	    if (isIdentifier$c(node)) {
	      value = node.name;
	    } else if (isStringLiteral$4(node)) {
	      value = node.value;
	    } else if (isThisExpression$1(node)) {
	      value = "this";
	    } else {
	      return false;
	    }

	    if (parts[i] !== value) return false;
	  }

	  return true;
	}

	function buildMatchMemberExpression$1(match, allowPartial) {
	  const parts = match.split(".");
	  return member => matchesPattern$2(member, parts, allowPartial);
	}

	const isReactComponent = buildMatchMemberExpression$1("React.Component");

	function isCompatTag$1(tagName) {
	  return !!tagName && /^[a-z]/.test(tagName);
	}

	let fastProto = null;

	function FastObject(o) {
	  if (fastProto !== null && typeof fastProto.property) {
	    const result = fastProto;
	    fastProto = FastObject.prototype = null;
	    return result;
	  }

	  fastProto = FastObject.prototype = o == null ? Object.create(null) : o;
	  return new FastObject();
	}

	FastObject();

	var toFastProperties = function toFastproperties(o) {
	  return FastObject(o);
	};

	var browser$5 = createCommonjsModule(function (module) {
	  var process = module.exports = {};
	  var cachedSetTimeout;
	  var cachedClearTimeout;

	  function defaultSetTimout() {
	    throw new Error('setTimeout has not been defined');
	  }

	  function defaultClearTimeout() {
	    throw new Error('clearTimeout has not been defined');
	  }

	  (function () {
	    try {
	      if (typeof setTimeout === 'function') {
	        cachedSetTimeout = setTimeout;
	      } else {
	        cachedSetTimeout = defaultSetTimout;
	      }
	    } catch (e) {
	      cachedSetTimeout = defaultSetTimout;
	    }

	    try {
	      if (typeof clearTimeout === 'function') {
	        cachedClearTimeout = clearTimeout;
	      } else {
	        cachedClearTimeout = defaultClearTimeout;
	      }
	    } catch (e) {
	      cachedClearTimeout = defaultClearTimeout;
	    }
	  })();

	  function runTimeout(fun) {
	    if (cachedSetTimeout === setTimeout) {
	      return setTimeout(fun, 0);
	    }

	    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
	      cachedSetTimeout = setTimeout;
	      return setTimeout(fun, 0);
	    }

	    try {
	      return cachedSetTimeout(fun, 0);
	    } catch (e) {
	      try {
	        return cachedSetTimeout.call(null, fun, 0);
	      } catch (e) {
	        return cachedSetTimeout.call(this, fun, 0);
	      }
	    }
	  }

	  function runClearTimeout(marker) {
	    if (cachedClearTimeout === clearTimeout) {
	      return clearTimeout(marker);
	    }

	    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
	      cachedClearTimeout = clearTimeout;
	      return clearTimeout(marker);
	    }

	    try {
	      return cachedClearTimeout(marker);
	    } catch (e) {
	      try {
	        return cachedClearTimeout.call(null, marker);
	      } catch (e) {
	        return cachedClearTimeout.call(this, marker);
	      }
	    }
	  }

	  var queue = [];
	  var draining = false;
	  var currentQueue;
	  var queueIndex = -1;

	  function cleanUpNextTick() {
	    if (!draining || !currentQueue) {
	      return;
	    }

	    draining = false;

	    if (currentQueue.length) {
	      queue = currentQueue.concat(queue);
	    } else {
	      queueIndex = -1;
	    }

	    if (queue.length) {
	      drainQueue();
	    }
	  }

	  function drainQueue() {
	    if (draining) {
	      return;
	    }

	    var timeout = runTimeout(cleanUpNextTick);
	    draining = true;
	    var len = queue.length;

	    while (len) {
	      currentQueue = queue;
	      queue = [];

	      while (++queueIndex < len) {
	        if (currentQueue) {
	          currentQueue[queueIndex].run();
	        }
	      }

	      queueIndex = -1;
	      len = queue.length;
	    }

	    currentQueue = null;
	    draining = false;
	    runClearTimeout(timeout);
	  }

	  process.nextTick = function (fun) {
	    var args = new Array(arguments.length - 1);

	    if (arguments.length > 1) {
	      for (var i = 1; i < arguments.length; i++) {
	        args[i - 1] = arguments[i];
	      }
	    }

	    queue.push(new Item(fun, args));

	    if (queue.length === 1 && !draining) {
	      runTimeout(drainQueue);
	    }
	  };

	  function Item(fun, array) {
	    this.fun = fun;
	    this.array = array;
	  }

	  Item.prototype.run = function () {
	    this.fun.apply(null, this.array);
	  };

	  process.title = 'browser';
	  process.browser = true;
	  process.env = {};
	  process.argv = [];
	  process.version = '';
	  process.versions = {};

	  function noop() {}

	  process.on = noop;
	  process.addListener = noop;
	  process.once = noop;
	  process.off = noop;
	  process.removeListener = noop;
	  process.removeAllListeners = noop;
	  process.emit = noop;
	  process.prependListener = noop;
	  process.prependOnceListener = noop;

	  process.listeners = function (name) {
	    return [];
	  };

	  process.binding = function (name) {
	    throw new Error('process.binding is not supported');
	  };

	  process.cwd = function () {
	    return '/';
	  };

	  process.chdir = function (dir) {
	    throw new Error('process.chdir is not supported');
	  };

	  process.umask = function () {
	    return 0;
	  };
	}, "/$$rollup_base$$/node_modules/process");

	function isType$2(nodeType, targetType) {
	  if (nodeType === targetType) return true;
	  if (ALIAS_KEYS[targetType]) return false;
	  const aliases = FLIPPED_ALIAS_KEYS$3[targetType];

	  if (aliases) {
	    if (aliases[0] === nodeType) return true;

	    for (const alias of aliases) {
	      if (nodeType === alias) return true;
	    }
	  }

	  return false;
	}

	function isPlaceholderType(placeholderType, targetType) {
	  if (placeholderType === targetType) return true;
	  const aliases = PLACEHOLDERS_ALIAS[placeholderType];

	  if (aliases) {
	    for (const alias of aliases) {
	      if (targetType === alias) return true;
	    }
	  }

	  return false;
	}

	function is$1(type, node, opts) {
	  if (!node) return false;
	  const matches = isType$2(node.type, type);

	  if (!matches) {
	    if (!opts && node.type === "Placeholder" && type in FLIPPED_ALIAS_KEYS$3) {
	      return isPlaceholderType(node.expectedNode, type);
	    }

	    return false;
	  }

	  if (typeof opts === "undefined") {
	    return true;
	  } else {
	    return shallowEqual(node, opts);
	  }
	}

	let nonASCIIidentifierStartChars = "\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0370-\u0374\u0376\u0377\u037a-\u037d\u037f\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481\u048a-\u052f\u0531-\u0556\u0559\u0560-\u0588\u05d0-\u05ea\u05ef-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5\u07fa\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u0860-\u086a\u0870-\u0887\u0889-\u088e\u08a0-\u08c9\u0904-\u0939\u093d\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u09fc\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0af9\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c39\u0c3d\u0c58-\u0c5a\u0c5d\u0c60\u0c61\u0c80\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cdd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d04-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d54-\u0d56\u0d5f-\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82\u0e84\u0e86-\u0e8a\u0e8c-\u0ea3\u0ea5\u0ea7-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f5\u13f8-\u13fd\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f8\u1700-\u1711\u171f-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1878\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191e\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19b0-\u19c9\u1a00-\u1a16\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4c\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c7d\u1c80-\u1c88\u1c90-\u1cba\u1cbd-\u1cbf\u1ce9-\u1cec\u1cee-\u1cf3\u1cf5\u1cf6\u1cfa\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115\u2118-\u211d\u2124\u2126\u2128\u212a-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2ce4\u2ceb-\u2cee\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303c\u3041-\u3096\u309b-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312f\u3131-\u318e\u31a0-\u31bf\u31f0-\u31ff\u3400-\u4dbf\u4e00-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f\ua62a\ua62b\ua640-\ua66e\ua67f-\ua69d\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua7ca\ua7d0\ua7d1\ua7d3\ua7d5-\ua7d9\ua7f2-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua8fd\ua8fe\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\ua9cf\ua9e0-\ua9e4\ua9e6-\ua9ef\ua9fa-\ua9fe\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa7e-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uab30-\uab5a\uab5c-\uab69\uab70-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d\ufa70-\ufad9\ufb00-\ufb06\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a\uff66-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc";
	let nonASCIIidentifierChars = "\u200c\u200d\xb7\u0300-\u036f\u0387\u0483-\u0487\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u0669\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed\u06f0-\u06f9\u0711\u0730-\u074a\u07a6-\u07b0\u07c0-\u07c9\u07eb-\u07f3\u07fd\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0859-\u085b\u0898-\u089f\u08ca-\u08e1\u08e3-\u0903\u093a-\u093c\u093e-\u094f\u0951-\u0957\u0962\u0963\u0966-\u096f\u0981-\u0983\u09bc\u09be-\u09c4\u09c7\u09c8\u09cb-\u09cd\u09d7\u09e2\u09e3\u09e6-\u09ef\u09fe\u0a01-\u0a03\u0a3c\u0a3e-\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a66-\u0a71\u0a75\u0a81-\u0a83\u0abc\u0abe-\u0ac5\u0ac7-\u0ac9\u0acb-\u0acd\u0ae2\u0ae3\u0ae6-\u0aef\u0afa-\u0aff\u0b01-\u0b03\u0b3c\u0b3e-\u0b44\u0b47\u0b48\u0b4b-\u0b4d\u0b55-\u0b57\u0b62\u0b63\u0b66-\u0b6f\u0b82\u0bbe-\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcd\u0bd7\u0be6-\u0bef\u0c00-\u0c04\u0c3c\u0c3e-\u0c44\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0c66-\u0c6f\u0c81-\u0c83\u0cbc\u0cbe-\u0cc4\u0cc6-\u0cc8\u0cca-\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0ce6-\u0cef\u0d00-\u0d03\u0d3b\u0d3c\u0d3e-\u0d44\u0d46-\u0d48\u0d4a-\u0d4d\u0d57\u0d62\u0d63\u0d66-\u0d6f\u0d81-\u0d83\u0dca\u0dcf-\u0dd4\u0dd6\u0dd8-\u0ddf\u0de6-\u0def\u0df2\u0df3\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0e50-\u0e59\u0eb1\u0eb4-\u0ebc\u0ec8-\u0ecd\u0ed0-\u0ed9\u0f18\u0f19\u0f20-\u0f29\u0f35\u0f37\u0f39\u0f3e\u0f3f\u0f71-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102b-\u103e\u1040-\u1049\u1056-\u1059\u105e-\u1060\u1062-\u1064\u1067-\u106d\u1071-\u1074\u1082-\u108d\u108f-\u109d\u135d-\u135f\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17b4-\u17d3\u17dd\u17e0-\u17e9\u180b-\u180d\u180f-\u1819\u18a9\u1920-\u192b\u1930-\u193b\u1946-\u194f\u19d0-\u19da\u1a17-\u1a1b\u1a55-\u1a5e\u1a60-\u1a7c\u1a7f-\u1a89\u1a90-\u1a99\u1ab0-\u1abd\u1abf-\u1ace\u1b00-\u1b04\u1b34-\u1b44\u1b50-\u1b59\u1b6b-\u1b73\u1b80-\u1b82\u1ba1-\u1bad\u1bb0-\u1bb9\u1be6-\u1bf3\u1c24-\u1c37\u1c40-\u1c49\u1c50-\u1c59\u1cd0-\u1cd2\u1cd4-\u1ce8\u1ced\u1cf4\u1cf7-\u1cf9\u1dc0-\u1dff\u203f\u2040\u2054\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua620-\ua629\ua66f\ua674-\ua67d\ua69e\ua69f\ua6f0\ua6f1\ua802\ua806\ua80b\ua823-\ua827\ua82c\ua880\ua881\ua8b4-\ua8c5\ua8d0-\ua8d9\ua8e0-\ua8f1\ua8ff-\ua909\ua926-\ua92d\ua947-\ua953\ua980-\ua983\ua9b3-\ua9c0\ua9d0-\ua9d9\ua9e5\ua9f0-\ua9f9\uaa29-\uaa36\uaa43\uaa4c\uaa4d\uaa50-\uaa59\uaa7b-\uaa7d\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uaaeb-\uaaef\uaaf5\uaaf6\uabe3-\uabea\uabec\uabed\uabf0-\uabf9\ufb1e\ufe00-\ufe0f\ufe20-\ufe2f\ufe33\ufe34\ufe4d-\ufe4f\uff10-\uff19\uff3f";
	const nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
	const nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
	nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
	const astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938];
	const astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];

	function isInAstralSet(code, set) {
	  let pos = 0x10000;

	  for (let i = 0, length = set.length; i < length; i += 2) {
	    pos += set[i];
	    if (pos > code) return false;
	    pos += set[i + 1];
	    if (pos >= code) return true;
	  }

	  return false;
	}

	function isIdentifierStart(code) {
	  if (code < 65) return code === 36;
	  if (code <= 90) return true;
	  if (code < 97) return code === 95;
	  if (code <= 122) return true;

	  if (code <= 0xffff) {
	    return code >= 0xaa && nonASCIIidentifierStart.test(String.fromCharCode(code));
	  }

	  return isInAstralSet(code, astralIdentifierStartCodes);
	}
	function isIdentifierChar(code) {
	  if (code < 48) return code === 36;
	  if (code < 58) return true;
	  if (code < 65) return false;
	  if (code <= 90) return true;
	  if (code < 97) return code === 95;
	  if (code <= 122) return true;

	  if (code <= 0xffff) {
	    return code >= 0xaa && nonASCIIidentifier.test(String.fromCharCode(code));
	  }

	  return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
	}
	function isIdentifierName(name) {
	  let isFirst = true;

	  for (let i = 0; i < name.length; i++) {
	    let cp = name.charCodeAt(i);

	    if ((cp & 0xfc00) === 0xd800 && i + 1 < name.length) {
	      const trail = name.charCodeAt(++i);

	      if ((trail & 0xfc00) === 0xdc00) {
	        cp = 0x10000 + ((cp & 0x3ff) << 10) + (trail & 0x3ff);
	      }
	    }

	    if (isFirst) {
	      isFirst = false;

	      if (!isIdentifierStart(cp)) {
	        return false;
	      }
	    } else if (!isIdentifierChar(cp)) {
	      return false;
	    }
	  }

	  return !isFirst;
	}

	const reservedWords = {
	  keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
	  strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
	  strictBind: ["eval", "arguments"]
	};
	const keywords$1 = new Set(reservedWords.keyword);
	const reservedWordsStrictSet = new Set(reservedWords.strict);
	const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
	function isReservedWord(word, inModule) {
	  return inModule && word === "await" || word === "enum";
	}
	function isStrictReservedWord(word, inModule) {
	  return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
	}
	function isStrictBindOnlyReservedWord(word) {
	  return reservedWordsStrictBindSet.has(word);
	}
	function isStrictBindReservedWord(word, inModule) {
	  return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
	}
	function isKeyword(word) {
	  return keywords$1.has(word);
	}

	function isValidIdentifier(name, reserved = true) {
	  if (typeof name !== "string") return false;

	  if (reserved) {
	    if (isKeyword(name) || isStrictReservedWord(name, true)) {
	      return false;
	    }
	  }

	  return isIdentifierName(name);
	}

	const STATEMENT_OR_BLOCK_KEYS$1 = ["consequent", "body", "alternate"];
	const FLATTENABLE_KEYS = ["body", "expressions"];
	const FOR_INIT_KEYS = ["left", "init"];
	const COMMENT_KEYS = ["leadingComments", "trailingComments", "innerComments"];
	const LOGICAL_OPERATORS$2 = ["||", "&&", "??"];
	const UPDATE_OPERATORS = ["++", "--"];
	const BOOLEAN_NUMBER_BINARY_OPERATORS$1 = [">", "<", ">=", "<="];
	const EQUALITY_BINARY_OPERATORS = ["==", "===", "!=", "!=="];
	const COMPARISON_BINARY_OPERATORS = [...EQUALITY_BINARY_OPERATORS, "in", "instanceof"];
	const BOOLEAN_BINARY_OPERATORS$1 = [...COMPARISON_BINARY_OPERATORS, ...BOOLEAN_NUMBER_BINARY_OPERATORS$1];
	const NUMBER_BINARY_OPERATORS$1 = ["-", "/", "%", "*", "**", "&", "|", ">>", ">>>", "<<", "^"];
	const BINARY_OPERATORS = ["+", ...NUMBER_BINARY_OPERATORS$1, ...BOOLEAN_BINARY_OPERATORS$1];
	const ASSIGNMENT_OPERATORS = ["=", "+=", ...NUMBER_BINARY_OPERATORS$1.map(op => op + "="), ...LOGICAL_OPERATORS$2.map(op => op + "=")];
	const BOOLEAN_UNARY_OPERATORS$1 = ["delete", "!"];
	const NUMBER_UNARY_OPERATORS$1 = ["+", "-", "~"];
	const STRING_UNARY_OPERATORS$1 = ["typeof"];
	const UNARY_OPERATORS = ["void", "throw", ...BOOLEAN_UNARY_OPERATORS$1, ...NUMBER_UNARY_OPERATORS$1, ...STRING_UNARY_OPERATORS$1];
	const INHERIT_KEYS = {
	  optional: ["typeAnnotation", "typeParameters", "returnType"],
	  force: ["start", "loc", "end"]
	};
	const BLOCK_SCOPED_SYMBOL = Symbol.for("var used to be block scoped");
	const NOT_LOCAL_BINDING$2 = Symbol.for("should not be considered a local binding");

	function validate$6(node, key, val) {
	  if (!node) return;
	  const fields = NODE_FIELDS[node.type];
	  if (!fields) return;
	  const field = fields[key];
	  validateField(node, key, val, field);
	  validateChild(node, key, val);
	}
	function validateField(node, key, val, field) {
	  if (!field?.validate) return;
	  if (field.optional && val == null) return;
	  field.validate(node, key, val);
	}
	function validateChild(node, key, val) {
	  if (val == null) return;
	  const validate = NODE_PARENT_VALIDATIONS[val.type];
	  if (!validate) return;
	  validate(node, key, val);
	}

	const VISITOR_KEYS$7 = {};
	const ALIAS_KEYS = {};
	const FLIPPED_ALIAS_KEYS$3 = {};
	const NODE_FIELDS = {};
	const BUILDER_KEYS = {};
	const DEPRECATED_KEYS$1 = {};
	const NODE_PARENT_VALIDATIONS = {};

	function getType(val) {
	  if (Array.isArray(val)) {
	    return "array";
	  } else if (val === null) {
	    return "null";
	  } else {
	    return typeof val;
	  }
	}

	function validate$5(validate) {
	  return {
	    validate
	  };
	}
	function typeIs(typeName) {
	  return typeof typeName === "string" ? assertNodeType(typeName) : assertNodeType(...typeName);
	}
	function validateType(typeName) {
	  return validate$5(typeIs(typeName));
	}
	function validateOptional(validate) {
	  return {
	    validate,
	    optional: true
	  };
	}
	function validateOptionalType(typeName) {
	  return {
	    validate: typeIs(typeName),
	    optional: true
	  };
	}
	function arrayOf(elementType) {
	  return chain$1(assertValueType("array"), assertEach(elementType));
	}
	function arrayOfType(typeName) {
	  return arrayOf(typeIs(typeName));
	}
	function validateArrayOfType(typeName) {
	  return validate$5(arrayOfType(typeName));
	}
	function assertEach(callback) {
	  function validator(node, key, val) {
	    if (!Array.isArray(val)) return;

	    for (let i = 0; i < val.length; i++) {
	      const subkey = `${key}[${i}]`;
	      const v = val[i];
	      callback(node, subkey, v);
	      if (browser$5.env.BABEL_TYPES_8_BREAKING) validateChild(node, subkey, v);
	    }
	  }

	  validator.each = callback;
	  return validator;
	}
	function assertOneOf(...values) {
	  function validate(node, key, val) {
	    if (values.indexOf(val) < 0) {
	      throw new TypeError(`Property ${key} expected value to be one of ${JSON.stringify(values)} but got ${JSON.stringify(val)}`);
	    }
	  }

	  validate.oneOf = values;
	  return validate;
	}
	function assertNodeType(...types) {
	  function validate(node, key, val) {
	    for (const type of types) {
	      if (is$1(type, val)) {
	        validateChild(node, key, val);
	        return;
	      }
	    }

	    throw new TypeError(`Property ${key} of ${node.type} expected node to be of a type ${JSON.stringify(types)} but instead got ${JSON.stringify(val?.type)}`);
	  }

	  validate.oneOfNodeTypes = types;
	  return validate;
	}
	function assertNodeOrValueType(...types) {
	  function validate(node, key, val) {
	    for (const type of types) {
	      if (getType(val) === type || is$1(type, val)) {
	        validateChild(node, key, val);
	        return;
	      }
	    }

	    throw new TypeError(`Property ${key} of ${node.type} expected node to be of a type ${JSON.stringify(types)} but instead got ${JSON.stringify(val?.type)}`);
	  }

	  validate.oneOfNodeOrValueTypes = types;
	  return validate;
	}
	function assertValueType(type) {
	  function validate(node, key, val) {
	    const valid = getType(val) === type;

	    if (!valid) {
	      throw new TypeError(`Property ${key} expected type of ${type} but got ${getType(val)}`);
	    }
	  }

	  validate.type = type;
	  return validate;
	}
	function assertShape(shape) {
	  function validate(node, key, val) {
	    const errors = [];

	    for (const property of Object.keys(shape)) {
	      try {
	        validateField(node, property, val[property], shape[property]);
	      } catch (error) {
	        if (error instanceof TypeError) {
	          errors.push(error.message);
	          continue;
	        }

	        throw error;
	      }
	    }

	    if (errors.length) {
	      throw new TypeError(`Property ${key} of ${node.type} expected to have the following:\n${errors.join("\n")}`);
	    }
	  }

	  validate.shapeOf = shape;
	  return validate;
	}
	function assertOptionalChainStart() {
	  function validate(node) {
	    let current = node;

	    while (node) {
	      const {
	        type
	      } = current;

	      if (type === "OptionalCallExpression") {
	        if (current.optional) return;
	        current = current.callee;
	        continue;
	      }

	      if (type === "OptionalMemberExpression") {
	        if (current.optional) return;
	        current = current.object;
	        continue;
	      }

	      break;
	    }

	    throw new TypeError(`Non-optional ${node.type} must chain from an optional OptionalMemberExpression or OptionalCallExpression. Found chain from ${current?.type}`);
	  }

	  return validate;
	}
	function chain$1(...fns) {
	  function validate(...args) {
	    for (const fn of fns) {
	      fn(...args);
	    }
	  }

	  validate.chainOf = fns;

	  if (fns.length >= 2 && "type" in fns[0] && fns[0].type === "array" && !("each" in fns[1])) {
	    throw new Error(`An assertValueType("array") validator can only be followed by an assertEach(...) validator.`);
	  }

	  return validate;
	}
	const validTypeOpts = ["aliases", "builder", "deprecatedAlias", "fields", "inherits", "visitor", "validate"];
	const validFieldKeys = ["default", "optional", "validate"];
	function defineAliasedType(...aliases) {
	  return (type, opts = {}) => {
	    let defined = opts.aliases;

	    if (!defined) {
	      if (opts.inherits) defined = store[opts.inherits].aliases?.slice();
	      defined ??= [];
	      opts.aliases = defined;
	    }

	    const additional = aliases.filter(a => !defined.includes(a));
	    defined.unshift(...additional);
	    return defineType$5(type, opts);
	  };
	}
	function defineType$5(type, opts = {}) {
	  const inherits = opts.inherits && store[opts.inherits] || {};
	  let fields = opts.fields;

	  if (!fields) {
	    fields = {};

	    if (inherits.fields) {
	      const keys = Object.getOwnPropertyNames(inherits.fields);

	      for (const key of keys) {
	        const field = inherits.fields[key];
	        const def = field.default;

	        if (Array.isArray(def) ? def.length > 0 : def && typeof def === "object") {
	          throw new Error("field defaults can only be primitives or empty arrays currently");
	        }

	        fields[key] = {
	          default: Array.isArray(def) ? [] : def,
	          optional: field.optional,
	          validate: field.validate
	        };
	      }
	    }
	  }

	  const visitor = opts.visitor || inherits.visitor || [];
	  const aliases = opts.aliases || inherits.aliases || [];
	  const builder = opts.builder || inherits.builder || opts.visitor || [];

	  for (const k of Object.keys(opts)) {
	    if (validTypeOpts.indexOf(k) === -1) {
	      throw new Error(`Unknown type option "${k}" on ${type}`);
	    }
	  }

	  if (opts.deprecatedAlias) {
	    DEPRECATED_KEYS$1[opts.deprecatedAlias] = type;
	  }

	  for (const key of visitor.concat(builder)) {
	    fields[key] = fields[key] || {};
	  }

	  for (const key of Object.keys(fields)) {
	    const field = fields[key];

	    if (field.default !== undefined && builder.indexOf(key) === -1) {
	      field.optional = true;
	    }

	    if (field.default === undefined) {
	      field.default = null;
	    } else if (!field.validate && field.default != null) {
	      field.validate = assertValueType(getType(field.default));
	    }

	    for (const k of Object.keys(field)) {
	      if (validFieldKeys.indexOf(k) === -1) {
	        throw new Error(`Unknown field key "${k}" on ${type}.${key}`);
	      }
	    }
	  }

	  VISITOR_KEYS$7[type] = opts.visitor = visitor;
	  BUILDER_KEYS[type] = opts.builder = builder;
	  NODE_FIELDS[type] = opts.fields = fields;
	  ALIAS_KEYS[type] = opts.aliases = aliases;
	  aliases.forEach(alias => {
	    FLIPPED_ALIAS_KEYS$3[alias] = FLIPPED_ALIAS_KEYS$3[alias] || [];
	    FLIPPED_ALIAS_KEYS$3[alias].push(type);
	  });

	  if (opts.validate) {
	    NODE_PARENT_VALIDATIONS[type] = opts.validate;
	  }

	  store[type] = opts;
	}
	const store = {};

	const defineType$4 = defineAliasedType("Standardized");
	defineType$4("ArrayExpression", {
	  fields: {
	    elements: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeOrValueType("null", "Expression", "SpreadElement"))),
	      default: !browser$5.env.BABEL_TYPES_8_BREAKING ? [] : undefined
	    }
	  },
	  visitor: ["elements"],
	  aliases: ["Expression"]
	});
	defineType$4("AssignmentExpression", {
	  fields: {
	    operator: {
	      validate: function () {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) {
	          return assertValueType("string");
	        }

	        const identifier = assertOneOf(...ASSIGNMENT_OPERATORS);
	        const pattern = assertOneOf("=");
	        return function (node, key, val) {
	          const validator = is$1("Pattern", node.left) ? pattern : identifier;
	          validator(node, key, val);
	        };
	      }()
	    },
	    left: {
	      validate: !browser$5.env.BABEL_TYPES_8_BREAKING ? assertNodeType("LVal") : assertNodeType("Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern")
	    },
	    right: {
	      validate: assertNodeType("Expression")
	    }
	  },
	  builder: ["operator", "left", "right"],
	  visitor: ["left", "right"],
	  aliases: ["Expression"]
	});
	defineType$4("BinaryExpression", {
	  builder: ["operator", "left", "right"],
	  fields: {
	    operator: {
	      validate: assertOneOf(...BINARY_OPERATORS)
	    },
	    left: {
	      validate: function () {
	        const expression = assertNodeType("Expression");
	        const inOp = assertNodeType("Expression", "PrivateName");

	        const validator = function (node, key, val) {
	          const validator = node.operator === "in" ? inOp : expression;
	          validator(node, key, val);
	        };

	        validator.oneOfNodeTypes = ["Expression", "PrivateName"];
	        return validator;
	      }()
	    },
	    right: {
	      validate: assertNodeType("Expression")
	    }
	  },
	  visitor: ["left", "right"],
	  aliases: ["Binary", "Expression"]
	});
	defineType$4("InterpreterDirective", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: assertValueType("string")
	    }
	  }
	});
	defineType$4("Directive", {
	  visitor: ["value"],
	  fields: {
	    value: {
	      validate: assertNodeType("DirectiveLiteral")
	    }
	  }
	});
	defineType$4("DirectiveLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: assertValueType("string")
	    }
	  }
	});
	defineType$4("BlockStatement", {
	  builder: ["body", "directives"],
	  visitor: ["directives", "body"],
	  fields: {
	    directives: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Directive"))),
	      default: []
	    },
	    body: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
	    }
	  },
	  aliases: ["Scopable", "BlockParent", "Block", "Statement"]
	});
	defineType$4("BreakStatement", {
	  visitor: ["label"],
	  fields: {
	    label: {
	      validate: assertNodeType("Identifier"),
	      optional: true
	    }
	  },
	  aliases: ["Statement", "Terminatorless", "CompletionStatement"]
	});
	defineType$4("CallExpression", {
	  visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
	  builder: ["callee", "arguments"],
	  aliases: ["Expression"],
	  fields: {
	    callee: {
	      validate: assertNodeType("Expression", "V8IntrinsicIdentifier")
	    },
	    arguments: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement", "JSXNamespacedName", "ArgumentPlaceholder")))
	    },
	    ...(!browser$5.env.BABEL_TYPES_8_BREAKING ? {
	      optional: {
	        validate: assertOneOf(true, false),
	        optional: true
	      }
	    } : {}),
	    typeArguments: {
	      validate: assertNodeType("TypeParameterInstantiation"),
	      optional: true
	    },
	    typeParameters: {
	      validate: assertNodeType("TSTypeParameterInstantiation"),
	      optional: true
	    }
	  }
	});
	defineType$4("CatchClause", {
	  visitor: ["param", "body"],
	  fields: {
	    param: {
	      validate: assertNodeType("Identifier", "ArrayPattern", "ObjectPattern"),
	      optional: true
	    },
	    body: {
	      validate: assertNodeType("BlockStatement")
	    }
	  },
	  aliases: ["Scopable", "BlockParent"]
	});
	defineType$4("ConditionalExpression", {
	  visitor: ["test", "consequent", "alternate"],
	  fields: {
	    test: {
	      validate: assertNodeType("Expression")
	    },
	    consequent: {
	      validate: assertNodeType("Expression")
	    },
	    alternate: {
	      validate: assertNodeType("Expression")
	    }
	  },
	  aliases: ["Expression", "Conditional"]
	});
	defineType$4("ContinueStatement", {
	  visitor: ["label"],
	  fields: {
	    label: {
	      validate: assertNodeType("Identifier"),
	      optional: true
	    }
	  },
	  aliases: ["Statement", "Terminatorless", "CompletionStatement"]
	});
	defineType$4("DebuggerStatement", {
	  aliases: ["Statement"]
	});
	defineType$4("DoWhileStatement", {
	  visitor: ["test", "body"],
	  fields: {
	    test: {
	      validate: assertNodeType("Expression")
	    },
	    body: {
	      validate: assertNodeType("Statement")
	    }
	  },
	  aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"]
	});
	defineType$4("EmptyStatement", {
	  aliases: ["Statement"]
	});
	defineType$4("ExpressionStatement", {
	  visitor: ["expression"],
	  fields: {
	    expression: {
	      validate: assertNodeType("Expression")
	    }
	  },
	  aliases: ["Statement", "ExpressionWrapper"]
	});
	defineType$4("File", {
	  builder: ["program", "comments", "tokens"],
	  visitor: ["program"],
	  fields: {
	    program: {
	      validate: assertNodeType("Program")
	    },
	    comments: {
	      validate: !browser$5.env.BABEL_TYPES_8_BREAKING ? Object.assign(() => {}, {
	        each: {
	          oneOfNodeTypes: ["CommentBlock", "CommentLine"]
	        }
	      }) : assertEach(assertNodeType("CommentBlock", "CommentLine")),
	      optional: true
	    },
	    tokens: {
	      validate: assertEach(Object.assign(() => {}, {
	        type: "any"
	      })),
	      optional: true
	    }
	  }
	});
	defineType$4("ForInStatement", {
	  visitor: ["left", "right", "body"],
	  aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
	  fields: {
	    left: {
	      validate: !browser$5.env.BABEL_TYPES_8_BREAKING ? assertNodeType("VariableDeclaration", "LVal") : assertNodeType("VariableDeclaration", "Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern")
	    },
	    right: {
	      validate: assertNodeType("Expression")
	    },
	    body: {
	      validate: assertNodeType("Statement")
	    }
	  }
	});
	defineType$4("ForStatement", {
	  visitor: ["init", "test", "update", "body"],
	  aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop"],
	  fields: {
	    init: {
	      validate: assertNodeType("VariableDeclaration", "Expression"),
	      optional: true
	    },
	    test: {
	      validate: assertNodeType("Expression"),
	      optional: true
	    },
	    update: {
	      validate: assertNodeType("Expression"),
	      optional: true
	    },
	    body: {
	      validate: assertNodeType("Statement")
	    }
	  }
	});
	const functionCommon = {
	  params: {
	    validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Identifier", "Pattern", "RestElement")))
	  },
	  generator: {
	    default: false
	  },
	  async: {
	    default: false
	  }
	};
	const functionTypeAnnotationCommon = {
	  returnType: {
	    validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TypeAnnotation", "TSTypeAnnotation") : assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	    optional: true
	  },
	  typeParameters: {
	    validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration") : assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
	    optional: true
	  }
	};
	const functionDeclarationCommon = { ...functionCommon,
	  declare: {
	    validate: assertValueType("boolean"),
	    optional: true
	  },
	  id: {
	    validate: assertNodeType("Identifier"),
	    optional: true
	  }
	};
	defineType$4("FunctionDeclaration", {
	  builder: ["id", "params", "body", "generator", "async"],
	  visitor: ["id", "params", "body", "returnType", "typeParameters"],
	  fields: { ...functionDeclarationCommon,
	    ...functionTypeAnnotationCommon,
	    body: {
	      validate: assertNodeType("BlockStatement")
	    }
	  },
	  aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Statement", "Pureish", "Declaration"],
	  validate: function () {
	    if (!browser$5.env.BABEL_TYPES_8_BREAKING) return () => {};
	    const identifier = assertNodeType("Identifier");
	    return function (parent, key, node) {
	      if (!is$1("ExportDefaultDeclaration", parent)) {
	        identifier(node, "id", node.id);
	      }
	    };
	  }()
	});
	defineType$4("FunctionExpression", {
	  inherits: "FunctionDeclaration",
	  aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
	  fields: { ...functionCommon,
	    ...functionTypeAnnotationCommon,
	    id: {
	      validate: assertNodeType("Identifier"),
	      optional: true
	    },
	    body: {
	      validate: assertNodeType("BlockStatement")
	    }
	  }
	});
	const patternLikeCommon = {
	  typeAnnotation: {
	    validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TypeAnnotation", "TSTypeAnnotation") : assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	    optional: true
	  },
	  decorators: {
	    validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator")))
	  }
	};
	defineType$4("Identifier", {
	  builder: ["name"],
	  visitor: ["typeAnnotation", "decorators"],
	  aliases: ["Expression", "PatternLike", "LVal", "TSEntityName"],
	  fields: { ...patternLikeCommon,
	    name: {
	      validate: chain$1(assertValueType("string"), Object.assign(function (node, key, val) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;

	        if (!isValidIdentifier(val, false)) {
	          throw new TypeError(`"${val}" is not a valid identifier name`);
	        }
	      }, {
	        type: "string"
	      }))
	    },
	    optional: {
	      validate: assertValueType("boolean"),
	      optional: true
	    }
	  },

	  validate(parent, key, node) {
	    if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;
	    const match = /\.(\w+)$/.exec(key);
	    if (!match) return;
	    const [, parentKey] = match;
	    const nonComp = {
	      computed: false
	    };

	    if (parentKey === "property") {
	      if (is$1("MemberExpression", parent, nonComp)) return;
	      if (is$1("OptionalMemberExpression", parent, nonComp)) return;
	    } else if (parentKey === "key") {
	      if (is$1("Property", parent, nonComp)) return;
	      if (is$1("Method", parent, nonComp)) return;
	    } else if (parentKey === "exported") {
	      if (is$1("ExportSpecifier", parent)) return;
	    } else if (parentKey === "imported") {
	      if (is$1("ImportSpecifier", parent, {
	        imported: node
	      })) return;
	    } else if (parentKey === "meta") {
	      if (is$1("MetaProperty", parent, {
	        meta: node
	      })) return;
	    }

	    if ((isKeyword(node.name) || isReservedWord(node.name, false)) && node.name !== "this") {
	      throw new TypeError(`"${node.name}" is not a valid identifier`);
	    }
	  }

	});
	defineType$4("IfStatement", {
	  visitor: ["test", "consequent", "alternate"],
	  aliases: ["Statement", "Conditional"],
	  fields: {
	    test: {
	      validate: assertNodeType("Expression")
	    },
	    consequent: {
	      validate: assertNodeType("Statement")
	    },
	    alternate: {
	      optional: true,
	      validate: assertNodeType("Statement")
	    }
	  }
	});
	defineType$4("LabeledStatement", {
	  visitor: ["label", "body"],
	  aliases: ["Statement"],
	  fields: {
	    label: {
	      validate: assertNodeType("Identifier")
	    },
	    body: {
	      validate: assertNodeType("Statement")
	    }
	  }
	});
	defineType$4("StringLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: assertValueType("string")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType$4("NumericLiteral", {
	  builder: ["value"],
	  deprecatedAlias: "NumberLiteral",
	  fields: {
	    value: {
	      validate: assertValueType("number")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType$4("NullLiteral", {
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType$4("BooleanLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: assertValueType("boolean")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType$4("RegExpLiteral", {
	  builder: ["pattern", "flags"],
	  deprecatedAlias: "RegexLiteral",
	  aliases: ["Expression", "Pureish", "Literal"],
	  fields: {
	    pattern: {
	      validate: assertValueType("string")
	    },
	    flags: {
	      validate: chain$1(assertValueType("string"), Object.assign(function (node, key, val) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;
	        const invalid = /[^gimsuy]/.exec(val);

	        if (invalid) {
	          throw new TypeError(`"${invalid[0]}" is not a valid RegExp flag`);
	        }
	      }, {
	        type: "string"
	      })),
	      default: ""
	    }
	  }
	});
	defineType$4("LogicalExpression", {
	  builder: ["operator", "left", "right"],
	  visitor: ["left", "right"],
	  aliases: ["Binary", "Expression"],
	  fields: {
	    operator: {
	      validate: assertOneOf(...LOGICAL_OPERATORS$2)
	    },
	    left: {
	      validate: assertNodeType("Expression")
	    },
	    right: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$4("MemberExpression", {
	  builder: ["object", "property", "computed", ...(!browser$5.env.BABEL_TYPES_8_BREAKING ? ["optional"] : [])],
	  visitor: ["object", "property"],
	  aliases: ["Expression", "LVal"],
	  fields: {
	    object: {
	      validate: assertNodeType("Expression")
	    },
	    property: {
	      validate: function () {
	        const normal = assertNodeType("Identifier", "PrivateName");
	        const computed = assertNodeType("Expression");

	        const validator = function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        };

	        validator.oneOfNodeTypes = ["Expression", "Identifier", "PrivateName"];
	        return validator;
	      }()
	    },
	    computed: {
	      default: false
	    },
	    ...(!browser$5.env.BABEL_TYPES_8_BREAKING ? {
	      optional: {
	        validate: assertOneOf(true, false),
	        optional: true
	      }
	    } : {})
	  }
	});
	defineType$4("NewExpression", {
	  inherits: "CallExpression"
	});
	defineType$4("Program", {
	  visitor: ["directives", "body"],
	  builder: ["body", "directives", "sourceType", "interpreter"],
	  fields: {
	    sourceFile: {
	      validate: assertValueType("string")
	    },
	    sourceType: {
	      validate: assertOneOf("script", "module"),
	      default: "script"
	    },
	    interpreter: {
	      validate: assertNodeType("InterpreterDirective"),
	      default: null,
	      optional: true
	    },
	    directives: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Directive"))),
	      default: []
	    },
	    body: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
	    }
	  },
	  aliases: ["Scopable", "BlockParent", "Block"]
	});
	defineType$4("ObjectExpression", {
	  visitor: ["properties"],
	  aliases: ["Expression"],
	  fields: {
	    properties: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ObjectMethod", "ObjectProperty", "SpreadElement")))
	    }
	  }
	});
	defineType$4("ObjectMethod", {
	  builder: ["kind", "key", "params", "body", "computed", "generator", "async"],
	  fields: { ...functionCommon,
	    ...functionTypeAnnotationCommon,
	    kind: {
	      validate: assertOneOf("method", "get", "set"),
	      ...(!browser$5.env.BABEL_TYPES_8_BREAKING ? {
	        default: "method"
	      } : {})
	    },
	    computed: {
	      default: false
	    },
	    key: {
	      validate: function () {
	        const normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral");
	        const computed = assertNodeType("Expression");

	        const validator = function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        };

	        validator.oneOfNodeTypes = ["Expression", "Identifier", "StringLiteral", "NumericLiteral"];
	        return validator;
	      }()
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    },
	    body: {
	      validate: assertNodeType("BlockStatement")
	    }
	  },
	  visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
	  aliases: ["UserWhitespacable", "Function", "Scopable", "BlockParent", "FunctionParent", "Method", "ObjectMember"]
	});
	defineType$4("ObjectProperty", {
	  builder: ["key", "value", "computed", "shorthand", ...(!browser$5.env.BABEL_TYPES_8_BREAKING ? ["decorators"] : [])],
	  fields: {
	    computed: {
	      default: false
	    },
	    key: {
	      validate: function () {
	        const normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral");
	        const computed = assertNodeType("Expression");

	        const validator = function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        };

	        validator.oneOfNodeTypes = ["Expression", "Identifier", "StringLiteral", "NumericLiteral"];
	        return validator;
	      }()
	    },
	    value: {
	      validate: assertNodeType("Expression", "PatternLike")
	    },
	    shorthand: {
	      validate: chain$1(assertValueType("boolean"), Object.assign(function (node, key, val) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;

	        if (val && node.computed) {
	          throw new TypeError("Property shorthand of ObjectProperty cannot be true if computed is true");
	        }
	      }, {
	        type: "boolean"
	      }), function (node, key, val) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;

	        if (val && !is$1("Identifier", node.key)) {
	          throw new TypeError("Property shorthand of ObjectProperty cannot be true if key is not an Identifier");
	        }
	      }),
	      default: false
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    }
	  },
	  visitor: ["key", "value", "decorators"],
	  aliases: ["UserWhitespacable", "Property", "ObjectMember"],
	  validate: function () {
	    const pattern = assertNodeType("Identifier", "Pattern");
	    const expression = assertNodeType("Expression");
	    return function (parent, key, node) {
	      if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;
	      const validator = is$1("ObjectPattern", parent) ? pattern : expression;
	      validator(node, "value", node.value);
	    };
	  }()
	});
	defineType$4("RestElement", {
	  visitor: ["argument", "typeAnnotation"],
	  builder: ["argument"],
	  aliases: ["LVal", "PatternLike"],
	  deprecatedAlias: "RestProperty",
	  fields: { ...patternLikeCommon,
	    argument: {
	      validate: !browser$5.env.BABEL_TYPES_8_BREAKING ? assertNodeType("LVal") : assertNodeType("Identifier", "ArrayPattern", "ObjectPattern", "MemberExpression")
	    },
	    optional: {
	      validate: assertValueType("boolean"),
	      optional: true
	    }
	  },

	  validate(parent, key) {
	    if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;
	    const match = /(\w+)\[(\d+)\]/.exec(key);
	    if (!match) throw new Error("Internal Babel error: malformed key.");
	    const [, listKey, index] = match;

	    if (parent[listKey].length > index + 1) {
	      throw new TypeError(`RestElement must be last element of ${listKey}`);
	    }
	  }

	});
	defineType$4("ReturnStatement", {
	  visitor: ["argument"],
	  aliases: ["Statement", "Terminatorless", "CompletionStatement"],
	  fields: {
	    argument: {
	      validate: assertNodeType("Expression"),
	      optional: true
	    }
	  }
	});
	defineType$4("SequenceExpression", {
	  visitor: ["expressions"],
	  fields: {
	    expressions: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression")))
	    }
	  },
	  aliases: ["Expression"]
	});
	defineType$4("ParenthesizedExpression", {
	  visitor: ["expression"],
	  aliases: ["Expression", "ExpressionWrapper"],
	  fields: {
	    expression: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$4("SwitchCase", {
	  visitor: ["test", "consequent"],
	  fields: {
	    test: {
	      validate: assertNodeType("Expression"),
	      optional: true
	    },
	    consequent: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
	    }
	  }
	});
	defineType$4("SwitchStatement", {
	  visitor: ["discriminant", "cases"],
	  aliases: ["Statement", "BlockParent", "Scopable"],
	  fields: {
	    discriminant: {
	      validate: assertNodeType("Expression")
	    },
	    cases: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("SwitchCase")))
	    }
	  }
	});
	defineType$4("ThisExpression", {
	  aliases: ["Expression"]
	});
	defineType$4("ThrowStatement", {
	  visitor: ["argument"],
	  aliases: ["Statement", "Terminatorless", "CompletionStatement"],
	  fields: {
	    argument: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$4("TryStatement", {
	  visitor: ["block", "handler", "finalizer"],
	  aliases: ["Statement"],
	  fields: {
	    block: {
	      validate: chain$1(assertNodeType("BlockStatement"), Object.assign(function (node) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;

	        if (!node.handler && !node.finalizer) {
	          throw new TypeError("TryStatement expects either a handler or finalizer, or both");
	        }
	      }, {
	        oneOfNodeTypes: ["BlockStatement"]
	      }))
	    },
	    handler: {
	      optional: true,
	      validate: assertNodeType("CatchClause")
	    },
	    finalizer: {
	      optional: true,
	      validate: assertNodeType("BlockStatement")
	    }
	  }
	});
	defineType$4("UnaryExpression", {
	  builder: ["operator", "argument", "prefix"],
	  fields: {
	    prefix: {
	      default: true
	    },
	    argument: {
	      validate: assertNodeType("Expression")
	    },
	    operator: {
	      validate: assertOneOf(...UNARY_OPERATORS)
	    }
	  },
	  visitor: ["argument"],
	  aliases: ["UnaryLike", "Expression"]
	});
	defineType$4("UpdateExpression", {
	  builder: ["operator", "argument", "prefix"],
	  fields: {
	    prefix: {
	      default: false
	    },
	    argument: {
	      validate: !browser$5.env.BABEL_TYPES_8_BREAKING ? assertNodeType("Expression") : assertNodeType("Identifier", "MemberExpression")
	    },
	    operator: {
	      validate: assertOneOf(...UPDATE_OPERATORS)
	    }
	  },
	  visitor: ["argument"],
	  aliases: ["Expression"]
	});
	defineType$4("VariableDeclaration", {
	  builder: ["kind", "declarations"],
	  visitor: ["declarations"],
	  aliases: ["Statement", "Declaration"],
	  fields: {
	    declare: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    kind: {
	      validate: assertOneOf("var", "let", "const")
	    },
	    declarations: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("VariableDeclarator")))
	    }
	  },

	  validate(parent, key, node) {
	    if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;
	    if (!is$1("ForXStatement", parent, {
	      left: node
	    })) return;

	    if (node.declarations.length !== 1) {
	      throw new TypeError(`Exactly one VariableDeclarator is required in the VariableDeclaration of a ${parent.type}`);
	    }
	  }

	});
	defineType$4("VariableDeclarator", {
	  visitor: ["id", "init"],
	  fields: {
	    id: {
	      validate: function () {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) {
	          return assertNodeType("LVal");
	        }

	        const normal = assertNodeType("Identifier", "ArrayPattern", "ObjectPattern");
	        const without = assertNodeType("Identifier");
	        return function (node, key, val) {
	          const validator = node.init ? normal : without;
	          validator(node, key, val);
	        };
	      }()
	    },
	    definite: {
	      optional: true,
	      validate: assertValueType("boolean")
	    },
	    init: {
	      optional: true,
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$4("WhileStatement", {
	  visitor: ["test", "body"],
	  aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"],
	  fields: {
	    test: {
	      validate: assertNodeType("Expression")
	    },
	    body: {
	      validate: assertNodeType("Statement")
	    }
	  }
	});
	defineType$4("WithStatement", {
	  visitor: ["object", "body"],
	  aliases: ["Statement"],
	  fields: {
	    object: {
	      validate: assertNodeType("Expression")
	    },
	    body: {
	      validate: assertNodeType("Statement")
	    }
	  }
	});
	defineType$4("AssignmentPattern", {
	  visitor: ["left", "right", "decorators"],
	  builder: ["left", "right"],
	  aliases: ["Pattern", "PatternLike", "LVal"],
	  fields: { ...patternLikeCommon,
	    left: {
	      validate: assertNodeType("Identifier", "ObjectPattern", "ArrayPattern", "MemberExpression")
	    },
	    right: {
	      validate: assertNodeType("Expression")
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    }
	  }
	});
	defineType$4("ArrayPattern", {
	  visitor: ["elements", "typeAnnotation"],
	  builder: ["elements"],
	  aliases: ["Pattern", "PatternLike", "LVal"],
	  fields: { ...patternLikeCommon,
	    elements: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeOrValueType("null", "PatternLike")))
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    },
	    optional: {
	      validate: assertValueType("boolean"),
	      optional: true
	    }
	  }
	});
	defineType$4("ArrowFunctionExpression", {
	  builder: ["params", "body", "async"],
	  visitor: ["params", "body", "returnType", "typeParameters"],
	  aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
	  fields: { ...functionCommon,
	    ...functionTypeAnnotationCommon,
	    expression: {
	      validate: assertValueType("boolean")
	    },
	    body: {
	      validate: assertNodeType("BlockStatement", "Expression")
	    }
	  }
	});
	defineType$4("ClassBody", {
	  visitor: ["body"],
	  fields: {
	    body: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ClassMethod", "ClassPrivateMethod", "ClassProperty", "ClassPrivateProperty", "ClassAccessorProperty", "TSDeclareMethod", "TSIndexSignature", "StaticBlock")))
	    }
	  }
	});
	defineType$4("ClassExpression", {
	  builder: ["id", "superClass", "body", "decorators"],
	  visitor: ["id", "body", "superClass", "mixins", "typeParameters", "superTypeParameters", "implements", "decorators"],
	  aliases: ["Scopable", "Class", "Expression"],
	  fields: {
	    id: {
	      validate: assertNodeType("Identifier"),
	      optional: true
	    },
	    typeParameters: {
	      validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration") : assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
	      optional: true
	    },
	    body: {
	      validate: assertNodeType("ClassBody")
	    },
	    superClass: {
	      optional: true,
	      validate: assertNodeType("Expression")
	    },
	    superTypeParameters: {
	      validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
	      optional: true
	    },
	    implements: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSExpressionWithTypeArguments", "ClassImplements"))),
	      optional: true
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    },
	    mixins: {
	      validate: assertNodeType("InterfaceExtends"),
	      optional: true
	    }
	  }
	});
	defineType$4("ClassDeclaration", {
	  inherits: "ClassExpression",
	  aliases: ["Scopable", "Class", "Statement", "Declaration"],
	  fields: {
	    id: {
	      validate: assertNodeType("Identifier")
	    },
	    typeParameters: {
	      validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration") : assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
	      optional: true
	    },
	    body: {
	      validate: assertNodeType("ClassBody")
	    },
	    superClass: {
	      optional: true,
	      validate: assertNodeType("Expression")
	    },
	    superTypeParameters: {
	      validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
	      optional: true
	    },
	    implements: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSExpressionWithTypeArguments", "ClassImplements"))),
	      optional: true
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    },
	    mixins: {
	      validate: assertNodeType("InterfaceExtends"),
	      optional: true
	    },
	    declare: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    abstract: {
	      validate: assertValueType("boolean"),
	      optional: true
	    }
	  },
	  validate: function () {
	    const identifier = assertNodeType("Identifier");
	    return function (parent, key, node) {
	      if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;

	      if (!is$1("ExportDefaultDeclaration", parent)) {
	        identifier(node, "id", node.id);
	      }
	    };
	  }()
	});
	defineType$4("ExportAllDeclaration", {
	  visitor: ["source"],
	  aliases: ["Statement", "Declaration", "ModuleDeclaration", "ExportDeclaration"],
	  fields: {
	    source: {
	      validate: assertNodeType("StringLiteral")
	    },
	    exportKind: validateOptional(assertOneOf("type", "value")),
	    assertions: {
	      optional: true,
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
	    }
	  }
	});
	defineType$4("ExportDefaultDeclaration", {
	  visitor: ["declaration"],
	  aliases: ["Statement", "Declaration", "ModuleDeclaration", "ExportDeclaration"],
	  fields: {
	    declaration: {
	      validate: assertNodeType("FunctionDeclaration", "TSDeclareFunction", "ClassDeclaration", "Expression")
	    },
	    exportKind: validateOptional(assertOneOf("value"))
	  }
	});
	defineType$4("ExportNamedDeclaration", {
	  visitor: ["declaration", "specifiers", "source"],
	  aliases: ["Statement", "Declaration", "ModuleDeclaration", "ExportDeclaration"],
	  fields: {
	    declaration: {
	      optional: true,
	      validate: chain$1(assertNodeType("Declaration"), Object.assign(function (node, key, val) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;

	        if (val && node.specifiers.length) {
	          throw new TypeError("Only declaration or specifiers is allowed on ExportNamedDeclaration");
	        }
	      }, {
	        oneOfNodeTypes: ["Declaration"]
	      }), function (node, key, val) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;

	        if (val && node.source) {
	          throw new TypeError("Cannot export a declaration from a source");
	        }
	      })
	    },
	    assertions: {
	      optional: true,
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
	    },
	    specifiers: {
	      default: [],
	      validate: chain$1(assertValueType("array"), assertEach(function () {
	        const sourced = assertNodeType("ExportSpecifier", "ExportDefaultSpecifier", "ExportNamespaceSpecifier");
	        const sourceless = assertNodeType("ExportSpecifier");
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return sourced;
	        return function (node, key, val) {
	          const validator = node.source ? sourced : sourceless;
	          validator(node, key, val);
	        };
	      }()))
	    },
	    source: {
	      validate: assertNodeType("StringLiteral"),
	      optional: true
	    },
	    exportKind: validateOptional(assertOneOf("type", "value"))
	  }
	});
	defineType$4("ExportSpecifier", {
	  visitor: ["local", "exported"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    local: {
	      validate: assertNodeType("Identifier")
	    },
	    exported: {
	      validate: assertNodeType("Identifier", "StringLiteral")
	    },
	    exportKind: {
	      validate: assertOneOf("type", "value"),
	      optional: true
	    }
	  }
	});
	defineType$4("ForOfStatement", {
	  visitor: ["left", "right", "body"],
	  builder: ["left", "right", "body", "await"],
	  aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
	  fields: {
	    left: {
	      validate: function () {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) {
	          return assertNodeType("VariableDeclaration", "LVal");
	        }

	        const declaration = assertNodeType("VariableDeclaration");
	        const lval = assertNodeType("Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern");
	        return function (node, key, val) {
	          if (is$1("VariableDeclaration", val)) {
	            declaration(node, key, val);
	          } else {
	            lval(node, key, val);
	          }
	        };
	      }()
	    },
	    right: {
	      validate: assertNodeType("Expression")
	    },
	    body: {
	      validate: assertNodeType("Statement")
	    },
	    await: {
	      default: false
	    }
	  }
	});
	defineType$4("ImportDeclaration", {
	  visitor: ["specifiers", "source"],
	  aliases: ["Statement", "Declaration", "ModuleDeclaration"],
	  fields: {
	    assertions: {
	      optional: true,
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
	    },
	    specifiers: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportSpecifier", "ImportDefaultSpecifier", "ImportNamespaceSpecifier")))
	    },
	    source: {
	      validate: assertNodeType("StringLiteral")
	    },
	    importKind: {
	      validate: assertOneOf("type", "typeof", "value"),
	      optional: true
	    }
	  }
	});
	defineType$4("ImportDefaultSpecifier", {
	  visitor: ["local"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    local: {
	      validate: assertNodeType("Identifier")
	    }
	  }
	});
	defineType$4("ImportNamespaceSpecifier", {
	  visitor: ["local"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    local: {
	      validate: assertNodeType("Identifier")
	    }
	  }
	});
	defineType$4("ImportSpecifier", {
	  visitor: ["local", "imported"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    local: {
	      validate: assertNodeType("Identifier")
	    },
	    imported: {
	      validate: assertNodeType("Identifier", "StringLiteral")
	    },
	    importKind: {
	      validate: assertOneOf("type", "typeof", "value"),
	      optional: true
	    }
	  }
	});
	defineType$4("MetaProperty", {
	  visitor: ["meta", "property"],
	  aliases: ["Expression"],
	  fields: {
	    meta: {
	      validate: chain$1(assertNodeType("Identifier"), Object.assign(function (node, key, val) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;
	        let property;

	        switch (val.name) {
	          case "function":
	            property = "sent";
	            break;

	          case "new":
	            property = "target";
	            break;

	          case "import":
	            property = "meta";
	            break;
	        }

	        if (!is$1("Identifier", node.property, {
	          name: property
	        })) {
	          throw new TypeError("Unrecognised MetaProperty");
	        }
	      }, {
	        oneOfNodeTypes: ["Identifier"]
	      }))
	    },
	    property: {
	      validate: assertNodeType("Identifier")
	    }
	  }
	});
	const classMethodOrPropertyCommon = {
	  abstract: {
	    validate: assertValueType("boolean"),
	    optional: true
	  },
	  accessibility: {
	    validate: assertOneOf("public", "private", "protected"),
	    optional: true
	  },
	  static: {
	    default: false
	  },
	  override: {
	    default: false
	  },
	  computed: {
	    default: false
	  },
	  optional: {
	    validate: assertValueType("boolean"),
	    optional: true
	  },
	  key: {
	    validate: chain$1(function () {
	      const normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral");
	      const computed = assertNodeType("Expression");
	      return function (node, key, val) {
	        const validator = node.computed ? computed : normal;
	        validator(node, key, val);
	      };
	    }(), assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "Expression"))
	  }
	};
	const classMethodOrDeclareMethodCommon = { ...functionCommon,
	  ...classMethodOrPropertyCommon,
	  params: {
	    validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Identifier", "Pattern", "RestElement", "TSParameterProperty")))
	  },
	  kind: {
	    validate: assertOneOf("get", "set", "method", "constructor"),
	    default: "method"
	  },
	  access: {
	    validate: chain$1(assertValueType("string"), assertOneOf("public", "private", "protected")),
	    optional: true
	  },
	  decorators: {
	    validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	    optional: true
	  }
	};
	defineType$4("ClassMethod", {
	  aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method"],
	  builder: ["kind", "key", "params", "body", "computed", "static", "generator", "async"],
	  visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
	  fields: { ...classMethodOrDeclareMethodCommon,
	    ...functionTypeAnnotationCommon,
	    body: {
	      validate: assertNodeType("BlockStatement")
	    }
	  }
	});
	defineType$4("ObjectPattern", {
	  visitor: ["properties", "typeAnnotation", "decorators"],
	  builder: ["properties"],
	  aliases: ["Pattern", "PatternLike", "LVal"],
	  fields: { ...patternLikeCommon,
	    properties: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("RestElement", "ObjectProperty")))
	    }
	  }
	});
	defineType$4("SpreadElement", {
	  visitor: ["argument"],
	  aliases: ["UnaryLike"],
	  deprecatedAlias: "SpreadProperty",
	  fields: {
	    argument: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$4("Super", {
	  aliases: ["Expression"]
	});
	defineType$4("TaggedTemplateExpression", {
	  visitor: ["tag", "quasi", "typeParameters"],
	  builder: ["tag", "quasi"],
	  aliases: ["Expression"],
	  fields: {
	    tag: {
	      validate: assertNodeType("Expression")
	    },
	    quasi: {
	      validate: assertNodeType("TemplateLiteral")
	    },
	    typeParameters: {
	      validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
	      optional: true
	    }
	  }
	});
	defineType$4("TemplateElement", {
	  builder: ["value", "tail"],
	  fields: {
	    value: {
	      validate: assertShape({
	        raw: {
	          validate: assertValueType("string")
	        },
	        cooked: {
	          validate: assertValueType("string"),
	          optional: true
	        }
	      })
	    },
	    tail: {
	      default: false
	    }
	  }
	});
	defineType$4("TemplateLiteral", {
	  visitor: ["quasis", "expressions"],
	  aliases: ["Expression", "Literal"],
	  fields: {
	    quasis: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TemplateElement")))
	    },
	    expressions: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "TSType")), function (node, key, val) {
	        if (node.quasis.length !== val.length + 1) {
	          throw new TypeError(`Number of ${node.type} quasis should be exactly one more than the number of expressions.\nExpected ${val.length + 1} quasis but got ${node.quasis.length}`);
	        }
	      })
	    }
	  }
	});
	defineType$4("YieldExpression", {
	  builder: ["argument", "delegate"],
	  visitor: ["argument"],
	  aliases: ["Expression", "Terminatorless"],
	  fields: {
	    delegate: {
	      validate: chain$1(assertValueType("boolean"), Object.assign(function (node, key, val) {
	        if (!browser$5.env.BABEL_TYPES_8_BREAKING) return;

	        if (val && !node.argument) {
	          throw new TypeError("Property delegate of YieldExpression cannot be true if there is no argument");
	        }
	      }, {
	        type: "boolean"
	      })),
	      default: false
	    },
	    argument: {
	      optional: true,
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$4("AwaitExpression", {
	  builder: ["argument"],
	  visitor: ["argument"],
	  aliases: ["Expression", "Terminatorless"],
	  fields: {
	    argument: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$4("Import", {
	  aliases: ["Expression"]
	});
	defineType$4("BigIntLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: assertValueType("string")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType$4("ExportNamespaceSpecifier", {
	  visitor: ["exported"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    exported: {
	      validate: assertNodeType("Identifier")
	    }
	  }
	});
	defineType$4("OptionalMemberExpression", {
	  builder: ["object", "property", "computed", "optional"],
	  visitor: ["object", "property"],
	  aliases: ["Expression"],
	  fields: {
	    object: {
	      validate: assertNodeType("Expression")
	    },
	    property: {
	      validate: function () {
	        const normal = assertNodeType("Identifier");
	        const computed = assertNodeType("Expression");

	        const validator = function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        };

	        validator.oneOfNodeTypes = ["Expression", "Identifier"];
	        return validator;
	      }()
	    },
	    computed: {
	      default: false
	    },
	    optional: {
	      validate: !browser$5.env.BABEL_TYPES_8_BREAKING ? assertValueType("boolean") : chain$1(assertValueType("boolean"), assertOptionalChainStart())
	    }
	  }
	});
	defineType$4("OptionalCallExpression", {
	  visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
	  builder: ["callee", "arguments", "optional"],
	  aliases: ["Expression"],
	  fields: {
	    callee: {
	      validate: assertNodeType("Expression")
	    },
	    arguments: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement", "JSXNamespacedName", "ArgumentPlaceholder")))
	    },
	    optional: {
	      validate: !browser$5.env.BABEL_TYPES_8_BREAKING ? assertValueType("boolean") : chain$1(assertValueType("boolean"), assertOptionalChainStart())
	    },
	    typeArguments: {
	      validate: assertNodeType("TypeParameterInstantiation"),
	      optional: true
	    },
	    typeParameters: {
	      validate: assertNodeType("TSTypeParameterInstantiation"),
	      optional: true
	    }
	  }
	});
	defineType$4("ClassProperty", {
	  visitor: ["key", "value", "typeAnnotation", "decorators"],
	  builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
	  aliases: ["Property"],
	  fields: { ...classMethodOrPropertyCommon,
	    value: {
	      validate: assertNodeType("Expression"),
	      optional: true
	    },
	    definite: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    typeAnnotation: {
	      validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TypeAnnotation", "TSTypeAnnotation") : assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	      optional: true
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    },
	    readonly: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    declare: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    variance: {
	      validate: assertNodeType("Variance"),
	      optional: true
	    }
	  }
	});
	defineType$4("ClassAccessorProperty", {
	  visitor: ["key", "value", "typeAnnotation", "decorators"],
	  builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
	  aliases: ["Property", "Accessor"],
	  fields: { ...classMethodOrPropertyCommon,
	    key: {
	      validate: chain$1(function () {
	        const normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "PrivateName");
	        const computed = assertNodeType("Expression");
	        return function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        };
	      }(), assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "Expression", "PrivateName"))
	    },
	    value: {
	      validate: assertNodeType("Expression"),
	      optional: true
	    },
	    definite: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    typeAnnotation: {
	      validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TypeAnnotation", "TSTypeAnnotation") : assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	      optional: true
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    },
	    readonly: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    declare: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    variance: {
	      validate: assertNodeType("Variance"),
	      optional: true
	    }
	  }
	});
	defineType$4("ClassPrivateProperty", {
	  visitor: ["key", "value", "decorators", "typeAnnotation"],
	  builder: ["key", "value", "decorators", "static"],
	  aliases: ["Property", "Private"],
	  fields: {
	    key: {
	      validate: assertNodeType("PrivateName")
	    },
	    value: {
	      validate: assertNodeType("Expression"),
	      optional: true
	    },
	    typeAnnotation: {
	      validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TypeAnnotation", "TSTypeAnnotation") : assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	      optional: true
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    },
	    readonly: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    definite: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    variance: {
	      validate: assertNodeType("Variance"),
	      optional: true
	    }
	  }
	});
	defineType$4("ClassPrivateMethod", {
	  builder: ["kind", "key", "params", "body", "static"],
	  visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
	  aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method", "Private"],
	  fields: { ...classMethodOrDeclareMethodCommon,
	    ...functionTypeAnnotationCommon,
	    key: {
	      validate: assertNodeType("PrivateName")
	    },
	    body: {
	      validate: assertNodeType("BlockStatement")
	    }
	  }
	});
	defineType$4("PrivateName", {
	  visitor: ["id"],
	  aliases: ["Private"],
	  fields: {
	    id: {
	      validate: assertNodeType("Identifier")
	    }
	  }
	});
	defineType$4("StaticBlock", {
	  visitor: ["body"],
	  fields: {
	    body: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
	    }
	  },
	  aliases: ["Scopable", "BlockParent", "FunctionParent"]
	});

	const defineType$3 = defineAliasedType("Flow");

	const defineInterfaceishType = (name, typeParameterType = "TypeParameterDeclaration") => {
	  defineType$3(name, {
	    builder: ["id", "typeParameters", "extends", "body"],
	    visitor: ["id", "typeParameters", "extends", "mixins", "implements", "body"],
	    aliases: ["FlowDeclaration", "Statement", "Declaration"],
	    fields: {
	      id: validateType("Identifier"),
	      typeParameters: validateOptionalType(typeParameterType),
	      extends: validateOptional(arrayOfType("InterfaceExtends")),
	      mixins: validateOptional(arrayOfType("InterfaceExtends")),
	      implements: validateOptional(arrayOfType("ClassImplements")),
	      body: validateType("ObjectTypeAnnotation")
	    }
	  });
	};

	defineType$3("AnyTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("ArrayTypeAnnotation", {
	  visitor: ["elementType"],
	  aliases: ["FlowType"],
	  fields: {
	    elementType: validateType("FlowType")
	  }
	});
	defineType$3("BooleanTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("BooleanLiteralTypeAnnotation", {
	  builder: ["value"],
	  aliases: ["FlowType"],
	  fields: {
	    value: validate$5(assertValueType("boolean"))
	  }
	});
	defineType$3("NullLiteralTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("ClassImplements", {
	  visitor: ["id", "typeParameters"],
	  fields: {
	    id: validateType("Identifier"),
	    typeParameters: validateOptionalType("TypeParameterInstantiation")
	  }
	});
	defineInterfaceishType("DeclareClass");
	defineType$3("DeclareFunction", {
	  visitor: ["id"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: validateType("Identifier"),
	    predicate: validateOptionalType("DeclaredPredicate")
	  }
	});
	defineInterfaceishType("DeclareInterface");
	defineType$3("DeclareModule", {
	  builder: ["id", "body", "kind"],
	  visitor: ["id", "body"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: validateType(["Identifier", "StringLiteral"]),
	    body: validateType("BlockStatement"),
	    kind: validateOptional(assertOneOf("CommonJS", "ES"))
	  }
	});
	defineType$3("DeclareModuleExports", {
	  visitor: ["typeAnnotation"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    typeAnnotation: validateType("TypeAnnotation")
	  }
	});
	defineType$3("DeclareTypeAlias", {
	  visitor: ["id", "typeParameters", "right"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: validateType("Identifier"),
	    typeParameters: validateOptionalType("TypeParameterDeclaration"),
	    right: validateType("FlowType")
	  }
	});
	defineType$3("DeclareOpaqueType", {
	  visitor: ["id", "typeParameters", "supertype"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: validateType("Identifier"),
	    typeParameters: validateOptionalType("TypeParameterDeclaration"),
	    supertype: validateOptionalType("FlowType"),
	    impltype: validateOptionalType("FlowType")
	  }
	});
	defineType$3("DeclareVariable", {
	  visitor: ["id"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: validateType("Identifier")
	  }
	});
	defineType$3("DeclareExportDeclaration", {
	  visitor: ["declaration", "specifiers", "source"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    declaration: validateOptionalType("Flow"),
	    specifiers: validateOptional(arrayOfType(["ExportSpecifier", "ExportNamespaceSpecifier"])),
	    source: validateOptionalType("StringLiteral"),
	    default: validateOptional(assertValueType("boolean"))
	  }
	});
	defineType$3("DeclareExportAllDeclaration", {
	  visitor: ["source"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    source: validateType("StringLiteral"),
	    exportKind: validateOptional(assertOneOf("type", "value"))
	  }
	});
	defineType$3("DeclaredPredicate", {
	  visitor: ["value"],
	  aliases: ["FlowPredicate"],
	  fields: {
	    value: validateType("Flow")
	  }
	});
	defineType$3("ExistsTypeAnnotation", {
	  aliases: ["FlowType"]
	});
	defineType$3("FunctionTypeAnnotation", {
	  visitor: ["typeParameters", "params", "rest", "returnType"],
	  aliases: ["FlowType"],
	  fields: {
	    typeParameters: validateOptionalType("TypeParameterDeclaration"),
	    params: validate$5(arrayOfType("FunctionTypeParam")),
	    rest: validateOptionalType("FunctionTypeParam"),
	    this: validateOptionalType("FunctionTypeParam"),
	    returnType: validateType("FlowType")
	  }
	});
	defineType$3("FunctionTypeParam", {
	  visitor: ["name", "typeAnnotation"],
	  fields: {
	    name: validateOptionalType("Identifier"),
	    typeAnnotation: validateType("FlowType"),
	    optional: validateOptional(assertValueType("boolean"))
	  }
	});
	defineType$3("GenericTypeAnnotation", {
	  visitor: ["id", "typeParameters"],
	  aliases: ["FlowType"],
	  fields: {
	    id: validateType(["Identifier", "QualifiedTypeIdentifier"]),
	    typeParameters: validateOptionalType("TypeParameterInstantiation")
	  }
	});
	defineType$3("InferredPredicate", {
	  aliases: ["FlowPredicate"]
	});
	defineType$3("InterfaceExtends", {
	  visitor: ["id", "typeParameters"],
	  fields: {
	    id: validateType(["Identifier", "QualifiedTypeIdentifier"]),
	    typeParameters: validateOptionalType("TypeParameterInstantiation")
	  }
	});
	defineInterfaceishType("InterfaceDeclaration");
	defineType$3("InterfaceTypeAnnotation", {
	  visitor: ["extends", "body"],
	  aliases: ["FlowType"],
	  fields: {
	    extends: validateOptional(arrayOfType("InterfaceExtends")),
	    body: validateType("ObjectTypeAnnotation")
	  }
	});
	defineType$3("IntersectionTypeAnnotation", {
	  visitor: ["types"],
	  aliases: ["FlowType"],
	  fields: {
	    types: validate$5(arrayOfType("FlowType"))
	  }
	});
	defineType$3("MixedTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("EmptyTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("NullableTypeAnnotation", {
	  visitor: ["typeAnnotation"],
	  aliases: ["FlowType"],
	  fields: {
	    typeAnnotation: validateType("FlowType")
	  }
	});
	defineType$3("NumberLiteralTypeAnnotation", {
	  builder: ["value"],
	  aliases: ["FlowType"],
	  fields: {
	    value: validate$5(assertValueType("number"))
	  }
	});
	defineType$3("NumberTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("ObjectTypeAnnotation", {
	  visitor: ["properties", "indexers", "callProperties", "internalSlots"],
	  aliases: ["FlowType"],
	  builder: ["properties", "indexers", "callProperties", "internalSlots", "exact"],
	  fields: {
	    properties: validate$5(arrayOfType(["ObjectTypeProperty", "ObjectTypeSpreadProperty"])),
	    indexers: validateOptional(arrayOfType("ObjectTypeIndexer")),
	    callProperties: validateOptional(arrayOfType("ObjectTypeCallProperty")),
	    internalSlots: validateOptional(arrayOfType("ObjectTypeInternalSlot")),
	    exact: {
	      validate: assertValueType("boolean"),
	      default: false
	    },
	    inexact: validateOptional(assertValueType("boolean"))
	  }
	});
	defineType$3("ObjectTypeInternalSlot", {
	  visitor: ["id", "value", "optional", "static", "method"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    id: validateType("Identifier"),
	    value: validateType("FlowType"),
	    optional: validate$5(assertValueType("boolean")),
	    static: validate$5(assertValueType("boolean")),
	    method: validate$5(assertValueType("boolean"))
	  }
	});
	defineType$3("ObjectTypeCallProperty", {
	  visitor: ["value"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    value: validateType("FlowType"),
	    static: validate$5(assertValueType("boolean"))
	  }
	});
	defineType$3("ObjectTypeIndexer", {
	  visitor: ["id", "key", "value", "variance"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    id: validateOptionalType("Identifier"),
	    key: validateType("FlowType"),
	    value: validateType("FlowType"),
	    static: validate$5(assertValueType("boolean")),
	    variance: validateOptionalType("Variance")
	  }
	});
	defineType$3("ObjectTypeProperty", {
	  visitor: ["key", "value", "variance"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    key: validateType(["Identifier", "StringLiteral"]),
	    value: validateType("FlowType"),
	    kind: validate$5(assertOneOf("init", "get", "set")),
	    static: validate$5(assertValueType("boolean")),
	    proto: validate$5(assertValueType("boolean")),
	    optional: validate$5(assertValueType("boolean")),
	    variance: validateOptionalType("Variance"),
	    method: validate$5(assertValueType("boolean"))
	  }
	});
	defineType$3("ObjectTypeSpreadProperty", {
	  visitor: ["argument"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    argument: validateType("FlowType")
	  }
	});
	defineType$3("OpaqueType", {
	  visitor: ["id", "typeParameters", "supertype", "impltype"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: validateType("Identifier"),
	    typeParameters: validateOptionalType("TypeParameterDeclaration"),
	    supertype: validateOptionalType("FlowType"),
	    impltype: validateType("FlowType")
	  }
	});
	defineType$3("QualifiedTypeIdentifier", {
	  visitor: ["id", "qualification"],
	  fields: {
	    id: validateType("Identifier"),
	    qualification: validateType(["Identifier", "QualifiedTypeIdentifier"])
	  }
	});
	defineType$3("StringLiteralTypeAnnotation", {
	  builder: ["value"],
	  aliases: ["FlowType"],
	  fields: {
	    value: validate$5(assertValueType("string"))
	  }
	});
	defineType$3("StringTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("SymbolTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("ThisTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("TupleTypeAnnotation", {
	  visitor: ["types"],
	  aliases: ["FlowType"],
	  fields: {
	    types: validate$5(arrayOfType("FlowType"))
	  }
	});
	defineType$3("TypeofTypeAnnotation", {
	  visitor: ["argument"],
	  aliases: ["FlowType"],
	  fields: {
	    argument: validateType("FlowType")
	  }
	});
	defineType$3("TypeAlias", {
	  visitor: ["id", "typeParameters", "right"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: validateType("Identifier"),
	    typeParameters: validateOptionalType("TypeParameterDeclaration"),
	    right: validateType("FlowType")
	  }
	});
	defineType$3("TypeAnnotation", {
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: validateType("FlowType")
	  }
	});
	defineType$3("TypeCastExpression", {
	  visitor: ["expression", "typeAnnotation"],
	  aliases: ["ExpressionWrapper", "Expression"],
	  fields: {
	    expression: validateType("Expression"),
	    typeAnnotation: validateType("TypeAnnotation")
	  }
	});
	defineType$3("TypeParameter", {
	  visitor: ["bound", "default", "variance"],
	  fields: {
	    name: validate$5(assertValueType("string")),
	    bound: validateOptionalType("TypeAnnotation"),
	    default: validateOptionalType("FlowType"),
	    variance: validateOptionalType("Variance")
	  }
	});
	defineType$3("TypeParameterDeclaration", {
	  visitor: ["params"],
	  fields: {
	    params: validate$5(arrayOfType("TypeParameter"))
	  }
	});
	defineType$3("TypeParameterInstantiation", {
	  visitor: ["params"],
	  fields: {
	    params: validate$5(arrayOfType("FlowType"))
	  }
	});
	defineType$3("UnionTypeAnnotation", {
	  visitor: ["types"],
	  aliases: ["FlowType"],
	  fields: {
	    types: validate$5(arrayOfType("FlowType"))
	  }
	});
	defineType$3("Variance", {
	  builder: ["kind"],
	  fields: {
	    kind: validate$5(assertOneOf("minus", "plus"))
	  }
	});
	defineType$3("VoidTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType$3("EnumDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "body"],
	  fields: {
	    id: validateType("Identifier"),
	    body: validateType(["EnumBooleanBody", "EnumNumberBody", "EnumStringBody", "EnumSymbolBody"])
	  }
	});
	defineType$3("EnumBooleanBody", {
	  aliases: ["EnumBody"],
	  visitor: ["members"],
	  fields: {
	    explicitType: validate$5(assertValueType("boolean")),
	    members: validateArrayOfType("EnumBooleanMember"),
	    hasUnknownMembers: validate$5(assertValueType("boolean"))
	  }
	});
	defineType$3("EnumNumberBody", {
	  aliases: ["EnumBody"],
	  visitor: ["members"],
	  fields: {
	    explicitType: validate$5(assertValueType("boolean")),
	    members: validateArrayOfType("EnumNumberMember"),
	    hasUnknownMembers: validate$5(assertValueType("boolean"))
	  }
	});
	defineType$3("EnumStringBody", {
	  aliases: ["EnumBody"],
	  visitor: ["members"],
	  fields: {
	    explicitType: validate$5(assertValueType("boolean")),
	    members: validateArrayOfType(["EnumStringMember", "EnumDefaultedMember"]),
	    hasUnknownMembers: validate$5(assertValueType("boolean"))
	  }
	});
	defineType$3("EnumSymbolBody", {
	  aliases: ["EnumBody"],
	  visitor: ["members"],
	  fields: {
	    members: validateArrayOfType("EnumDefaultedMember"),
	    hasUnknownMembers: validate$5(assertValueType("boolean"))
	  }
	});
	defineType$3("EnumBooleanMember", {
	  aliases: ["EnumMember"],
	  visitor: ["id"],
	  fields: {
	    id: validateType("Identifier"),
	    init: validateType("BooleanLiteral")
	  }
	});
	defineType$3("EnumNumberMember", {
	  aliases: ["EnumMember"],
	  visitor: ["id", "init"],
	  fields: {
	    id: validateType("Identifier"),
	    init: validateType("NumericLiteral")
	  }
	});
	defineType$3("EnumStringMember", {
	  aliases: ["EnumMember"],
	  visitor: ["id", "init"],
	  fields: {
	    id: validateType("Identifier"),
	    init: validateType("StringLiteral")
	  }
	});
	defineType$3("EnumDefaultedMember", {
	  aliases: ["EnumMember"],
	  visitor: ["id"],
	  fields: {
	    id: validateType("Identifier")
	  }
	});
	defineType$3("IndexedAccessType", {
	  visitor: ["objectType", "indexType"],
	  aliases: ["FlowType"],
	  fields: {
	    objectType: validateType("FlowType"),
	    indexType: validateType("FlowType")
	  }
	});
	defineType$3("OptionalIndexedAccessType", {
	  visitor: ["objectType", "indexType"],
	  aliases: ["FlowType"],
	  fields: {
	    objectType: validateType("FlowType"),
	    indexType: validateType("FlowType"),
	    optional: validate$5(assertValueType("boolean"))
	  }
	});

	const defineType$2 = defineAliasedType("JSX");
	defineType$2("JSXAttribute", {
	  visitor: ["name", "value"],
	  aliases: ["Immutable"],
	  fields: {
	    name: {
	      validate: assertNodeType("JSXIdentifier", "JSXNamespacedName")
	    },
	    value: {
	      optional: true,
	      validate: assertNodeType("JSXElement", "JSXFragment", "StringLiteral", "JSXExpressionContainer")
	    }
	  }
	});
	defineType$2("JSXClosingElement", {
	  visitor: ["name"],
	  aliases: ["Immutable"],
	  fields: {
	    name: {
	      validate: assertNodeType("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
	    }
	  }
	});
	defineType$2("JSXElement", {
	  builder: ["openingElement", "closingElement", "children", "selfClosing"],
	  visitor: ["openingElement", "children", "closingElement"],
	  aliases: ["Immutable", "Expression"],
	  fields: {
	    openingElement: {
	      validate: assertNodeType("JSXOpeningElement")
	    },
	    closingElement: {
	      optional: true,
	      validate: assertNodeType("JSXClosingElement")
	    },
	    children: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
	    },
	    selfClosing: {
	      validate: assertValueType("boolean"),
	      optional: true
	    }
	  }
	});
	defineType$2("JSXEmptyExpression", {});
	defineType$2("JSXExpressionContainer", {
	  visitor: ["expression"],
	  aliases: ["Immutable"],
	  fields: {
	    expression: {
	      validate: assertNodeType("Expression", "JSXEmptyExpression")
	    }
	  }
	});
	defineType$2("JSXSpreadChild", {
	  visitor: ["expression"],
	  aliases: ["Immutable"],
	  fields: {
	    expression: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$2("JSXIdentifier", {
	  builder: ["name"],
	  fields: {
	    name: {
	      validate: assertValueType("string")
	    }
	  }
	});
	defineType$2("JSXMemberExpression", {
	  visitor: ["object", "property"],
	  fields: {
	    object: {
	      validate: assertNodeType("JSXMemberExpression", "JSXIdentifier")
	    },
	    property: {
	      validate: assertNodeType("JSXIdentifier")
	    }
	  }
	});
	defineType$2("JSXNamespacedName", {
	  visitor: ["namespace", "name"],
	  fields: {
	    namespace: {
	      validate: assertNodeType("JSXIdentifier")
	    },
	    name: {
	      validate: assertNodeType("JSXIdentifier")
	    }
	  }
	});
	defineType$2("JSXOpeningElement", {
	  builder: ["name", "attributes", "selfClosing"],
	  visitor: ["name", "attributes"],
	  aliases: ["Immutable"],
	  fields: {
	    name: {
	      validate: assertNodeType("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
	    },
	    selfClosing: {
	      default: false
	    },
	    attributes: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXAttribute", "JSXSpreadAttribute")))
	    },
	    typeParameters: {
	      validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
	      optional: true
	    }
	  }
	});
	defineType$2("JSXSpreadAttribute", {
	  visitor: ["argument"],
	  fields: {
	    argument: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$2("JSXText", {
	  aliases: ["Immutable"],
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: assertValueType("string")
	    }
	  }
	});
	defineType$2("JSXFragment", {
	  builder: ["openingFragment", "closingFragment", "children"],
	  visitor: ["openingFragment", "children", "closingFragment"],
	  aliases: ["Immutable", "Expression"],
	  fields: {
	    openingFragment: {
	      validate: assertNodeType("JSXOpeningFragment")
	    },
	    closingFragment: {
	      validate: assertNodeType("JSXClosingFragment")
	    },
	    children: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
	    }
	  }
	});
	defineType$2("JSXOpeningFragment", {
	  aliases: ["Immutable"]
	});
	defineType$2("JSXClosingFragment", {
	  aliases: ["Immutable"]
	});

	const PLACEHOLDERS = ["Identifier", "StringLiteral", "Expression", "Statement", "Declaration", "BlockStatement", "ClassBody", "Pattern"];
	const PLACEHOLDERS_ALIAS = {
	  Declaration: ["Statement"],
	  Pattern: ["PatternLike", "LVal"]
	};

	for (const type of PLACEHOLDERS) {
	  const alias = ALIAS_KEYS[type];
	  if (alias?.length) PLACEHOLDERS_ALIAS[type] = alias;
	}

	const PLACEHOLDERS_FLIPPED_ALIAS = {};
	Object.keys(PLACEHOLDERS_ALIAS).forEach(type => {
	  PLACEHOLDERS_ALIAS[type].forEach(alias => {
	    if (!Object.hasOwnProperty.call(PLACEHOLDERS_FLIPPED_ALIAS, alias)) {
	      PLACEHOLDERS_FLIPPED_ALIAS[alias] = [];
	    }

	    PLACEHOLDERS_FLIPPED_ALIAS[alias].push(type);
	  });
	});

	const defineType$1 = defineAliasedType("Miscellaneous");

	if (!browser$5.env.BABEL_8_BREAKING) {
	  defineType$1("Noop", {
	    visitor: []
	  });
	}

	defineType$1("Placeholder", {
	  visitor: [],
	  builder: ["expectedNode", "name"],
	  fields: {
	    name: {
	      validate: assertNodeType("Identifier")
	    },
	    expectedNode: {
	      validate: assertOneOf(...PLACEHOLDERS)
	    }
	  }
	});
	defineType$1("V8IntrinsicIdentifier", {
	  builder: ["name"],
	  fields: {
	    name: {
	      validate: assertValueType("string")
	    }
	  }
	});

	defineType$5("ArgumentPlaceholder", {});
	defineType$5("BindExpression", {
	  visitor: ["object", "callee"],
	  aliases: ["Expression"],
	  fields: !browser$5.env.BABEL_TYPES_8_BREAKING ? {
	    object: {
	      validate: Object.assign(() => {}, {
	        oneOfNodeTypes: ["Expression"]
	      })
	    },
	    callee: {
	      validate: Object.assign(() => {}, {
	        oneOfNodeTypes: ["Expression"]
	      })
	    }
	  } : {
	    object: {
	      validate: assertNodeType("Expression")
	    },
	    callee: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$5("ImportAttribute", {
	  visitor: ["key", "value"],
	  fields: {
	    key: {
	      validate: assertNodeType("Identifier", "StringLiteral")
	    },
	    value: {
	      validate: assertNodeType("StringLiteral")
	    }
	  }
	});
	defineType$5("Decorator", {
	  visitor: ["expression"],
	  fields: {
	    expression: {
	      validate: assertNodeType("Expression")
	    }
	  }
	});
	defineType$5("DoExpression", {
	  visitor: ["body"],
	  builder: ["body", "async"],
	  aliases: ["Expression"],
	  fields: {
	    body: {
	      validate: assertNodeType("BlockStatement")
	    },
	    async: {
	      validate: assertValueType("boolean"),
	      default: false
	    }
	  }
	});
	defineType$5("ExportDefaultSpecifier", {
	  visitor: ["exported"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    exported: {
	      validate: assertNodeType("Identifier")
	    }
	  }
	});
	defineType$5("RecordExpression", {
	  visitor: ["properties"],
	  aliases: ["Expression"],
	  fields: {
	    properties: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ObjectProperty", "SpreadElement")))
	    }
	  }
	});
	defineType$5("TupleExpression", {
	  fields: {
	    elements: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement"))),
	      default: []
	    }
	  },
	  visitor: ["elements"],
	  aliases: ["Expression"]
	});
	defineType$5("DecimalLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: assertValueType("string")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType$5("ModuleExpression", {
	  visitor: ["body"],
	  fields: {
	    body: {
	      validate: assertNodeType("Program")
	    }
	  },
	  aliases: ["Expression"]
	});
	defineType$5("TopicReference", {
	  aliases: ["Expression"]
	});
	defineType$5("PipelineTopicExpression", {
	  builder: ["expression"],
	  visitor: ["expression"],
	  fields: {
	    expression: {
	      validate: assertNodeType("Expression")
	    }
	  },
	  aliases: ["Expression"]
	});
	defineType$5("PipelineBareFunction", {
	  builder: ["callee"],
	  visitor: ["callee"],
	  fields: {
	    callee: {
	      validate: assertNodeType("Expression")
	    }
	  },
	  aliases: ["Expression"]
	});
	defineType$5("PipelinePrimaryTopicReference", {
	  aliases: ["Expression"]
	});

	const defineType = defineAliasedType("TypeScript");
	const bool$5 = assertValueType("boolean");
	const tSFunctionTypeAnnotationCommon = {
	  returnType: {
	    validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TSTypeAnnotation") : assertNodeType("TSTypeAnnotation", "Noop"),
	    optional: true
	  },
	  typeParameters: {
	    validate: browser$5.env.BABEL_8_BREAKING ? assertNodeType("TSTypeParameterDeclaration") : assertNodeType("TSTypeParameterDeclaration", "Noop"),
	    optional: true
	  }
	};
	defineType("TSParameterProperty", {
	  aliases: ["LVal"],
	  visitor: ["parameter"],
	  fields: {
	    accessibility: {
	      validate: assertOneOf("public", "private", "protected"),
	      optional: true
	    },
	    readonly: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    parameter: {
	      validate: assertNodeType("Identifier", "AssignmentPattern")
	    },
	    override: {
	      validate: assertValueType("boolean"),
	      optional: true
	    },
	    decorators: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
	      optional: true
	    }
	  }
	});
	defineType("TSDeclareFunction", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "typeParameters", "params", "returnType"],
	  fields: { ...functionDeclarationCommon,
	    ...tSFunctionTypeAnnotationCommon
	  }
	});
	defineType("TSDeclareMethod", {
	  visitor: ["decorators", "key", "typeParameters", "params", "returnType"],
	  fields: { ...classMethodOrDeclareMethodCommon,
	    ...tSFunctionTypeAnnotationCommon
	  }
	});
	defineType("TSQualifiedName", {
	  aliases: ["TSEntityName"],
	  visitor: ["left", "right"],
	  fields: {
	    left: validateType("TSEntityName"),
	    right: validateType("Identifier")
	  }
	});
	const signatureDeclarationCommon = {
	  typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
	  [browser$5.env.BABEL_8_BREAKING ? "params" : "parameters"]: validateArrayOfType(["Identifier", "RestElement"]),
	  [browser$5.env.BABEL_8_BREAKING ? "returnType" : "typeAnnotation"]: validateOptionalType("TSTypeAnnotation")
	};
	const callConstructSignatureDeclaration = {
	  aliases: ["TSTypeElement"],
	  visitor: ["typeParameters", browser$5.env.BABEL_8_BREAKING ? "params" : "parameters", browser$5.env.BABEL_8_BREAKING ? "returnType" : "typeAnnotation"],
	  fields: signatureDeclarationCommon
	};
	defineType("TSCallSignatureDeclaration", callConstructSignatureDeclaration);
	defineType("TSConstructSignatureDeclaration", callConstructSignatureDeclaration);
	const namedTypeElementCommon = {
	  key: validateType("Expression"),
	  computed: validate$5(bool$5),
	  optional: validateOptional(bool$5)
	};
	defineType("TSPropertySignature", {
	  aliases: ["TSTypeElement"],
	  visitor: ["key", "typeAnnotation", "initializer"],
	  fields: { ...namedTypeElementCommon,
	    readonly: validateOptional(bool$5),
	    typeAnnotation: validateOptionalType("TSTypeAnnotation"),
	    initializer: validateOptionalType("Expression"),
	    kind: {
	      validate: assertOneOf("get", "set")
	    }
	  }
	});
	defineType("TSMethodSignature", {
	  aliases: ["TSTypeElement"],
	  visitor: ["key", "typeParameters", browser$5.env.BABEL_8_BREAKING ? "params" : "parameters", browser$5.env.BABEL_8_BREAKING ? "returnType" : "typeAnnotation"],
	  fields: { ...signatureDeclarationCommon,
	    ...namedTypeElementCommon,
	    kind: {
	      validate: assertOneOf("method", "get", "set")
	    }
	  }
	});
	defineType("TSIndexSignature", {
	  aliases: ["TSTypeElement"],
	  visitor: ["parameters", "typeAnnotation"],
	  fields: {
	    readonly: validateOptional(bool$5),
	    static: validateOptional(bool$5),
	    parameters: validateArrayOfType("Identifier"),
	    typeAnnotation: validateOptionalType("TSTypeAnnotation")
	  }
	});
	const tsKeywordTypes = ["TSAnyKeyword", "TSBooleanKeyword", "TSBigIntKeyword", "TSIntrinsicKeyword", "TSNeverKeyword", "TSNullKeyword", "TSNumberKeyword", "TSObjectKeyword", "TSStringKeyword", "TSSymbolKeyword", "TSUndefinedKeyword", "TSUnknownKeyword", "TSVoidKeyword"];

	for (const type of tsKeywordTypes) {
	  defineType(type, {
	    aliases: ["TSType", "TSBaseType"],
	    visitor: [],
	    fields: {}
	  });
	}

	defineType("TSThisType", {
	  aliases: ["TSType", "TSBaseType"],
	  visitor: [],
	  fields: {}
	});
	const fnOrCtrBase = {
	  aliases: ["TSType"],
	  visitor: ["typeParameters", browser$5.env.BABEL_8_BREAKING ? "params" : "parameters", browser$5.env.BABEL_8_BREAKING ? "returnType" : "typeAnnotation"]
	};
	defineType("TSFunctionType", { ...fnOrCtrBase,
	  fields: signatureDeclarationCommon
	});
	defineType("TSConstructorType", { ...fnOrCtrBase,
	  fields: { ...signatureDeclarationCommon,
	    abstract: validateOptional(bool$5)
	  }
	});
	defineType("TSTypeReference", {
	  aliases: ["TSType"],
	  visitor: ["typeName", "typeParameters"],
	  fields: {
	    typeName: validateType("TSEntityName"),
	    typeParameters: validateOptionalType("TSTypeParameterInstantiation")
	  }
	});
	defineType("TSTypePredicate", {
	  aliases: ["TSType"],
	  visitor: ["parameterName", "typeAnnotation"],
	  builder: ["parameterName", "typeAnnotation", "asserts"],
	  fields: {
	    parameterName: validateType(["Identifier", "TSThisType"]),
	    typeAnnotation: validateOptionalType("TSTypeAnnotation"),
	    asserts: validateOptional(bool$5)
	  }
	});
	defineType("TSTypeQuery", {
	  aliases: ["TSType"],
	  visitor: ["exprName"],
	  fields: {
	    exprName: validateType(["TSEntityName", "TSImportType"])
	  }
	});
	defineType("TSTypeLiteral", {
	  aliases: ["TSType"],
	  visitor: ["members"],
	  fields: {
	    members: validateArrayOfType("TSTypeElement")
	  }
	});
	defineType("TSArrayType", {
	  aliases: ["TSType"],
	  visitor: ["elementType"],
	  fields: {
	    elementType: validateType("TSType")
	  }
	});
	defineType("TSTupleType", {
	  aliases: ["TSType"],
	  visitor: ["elementTypes"],
	  fields: {
	    elementTypes: validateArrayOfType(["TSType", "TSNamedTupleMember"])
	  }
	});
	defineType("TSOptionalType", {
	  aliases: ["TSType"],
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: validateType("TSType")
	  }
	});
	defineType("TSRestType", {
	  aliases: ["TSType"],
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: validateType("TSType")
	  }
	});
	defineType("TSNamedTupleMember", {
	  visitor: ["label", "elementType"],
	  builder: ["label", "elementType", "optional"],
	  fields: {
	    label: validateType("Identifier"),
	    optional: {
	      validate: bool$5,
	      default: false
	    },
	    elementType: validateType("TSType")
	  }
	});
	const unionOrIntersection = {
	  aliases: ["TSType"],
	  visitor: ["types"],
	  fields: {
	    types: validateArrayOfType("TSType")
	  }
	};
	defineType("TSUnionType", unionOrIntersection);
	defineType("TSIntersectionType", unionOrIntersection);
	defineType("TSConditionalType", {
	  aliases: ["TSType"],
	  visitor: ["checkType", "extendsType", "trueType", "falseType"],
	  fields: {
	    checkType: validateType("TSType"),
	    extendsType: validateType("TSType"),
	    trueType: validateType("TSType"),
	    falseType: validateType("TSType")
	  }
	});
	defineType("TSInferType", {
	  aliases: ["TSType"],
	  visitor: ["typeParameter"],
	  fields: {
	    typeParameter: validateType("TSTypeParameter")
	  }
	});
	defineType("TSParenthesizedType", {
	  aliases: ["TSType"],
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: validateType("TSType")
	  }
	});
	defineType("TSTypeOperator", {
	  aliases: ["TSType"],
	  visitor: ["typeAnnotation"],
	  fields: {
	    operator: validate$5(assertValueType("string")),
	    typeAnnotation: validateType("TSType")
	  }
	});
	defineType("TSIndexedAccessType", {
	  aliases: ["TSType"],
	  visitor: ["objectType", "indexType"],
	  fields: {
	    objectType: validateType("TSType"),
	    indexType: validateType("TSType")
	  }
	});
	defineType("TSMappedType", {
	  aliases: ["TSType"],
	  visitor: ["typeParameter", "typeAnnotation", "nameType"],
	  fields: {
	    readonly: validateOptional(bool$5),
	    typeParameter: validateType("TSTypeParameter"),
	    optional: validateOptional(bool$5),
	    typeAnnotation: validateOptionalType("TSType"),
	    nameType: validateOptionalType("TSType")
	  }
	});
	defineType("TSLiteralType", {
	  aliases: ["TSType", "TSBaseType"],
	  visitor: ["literal"],
	  fields: {
	    literal: {
	      validate: function () {
	        const unaryExpression = assertNodeType("NumericLiteral", "BigIntLiteral");
	        const unaryOperator = assertOneOf("-");
	        const literal = assertNodeType("NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral");

	        function validator(parent, key, node) {
	          if (is$1("UnaryExpression", node)) {
	            unaryOperator(node, "operator", node.operator);
	            unaryExpression(node, "argument", node.argument);
	          } else {
	            literal(parent, key, node);
	          }
	        }

	        validator.oneOfNodeTypes = ["NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "UnaryExpression"];
	        return validator;
	      }()
	    }
	  }
	});
	defineType("TSExpressionWithTypeArguments", {
	  aliases: ["TSType"],
	  visitor: ["expression", "typeParameters"],
	  fields: {
	    expression: validateType("TSEntityName"),
	    typeParameters: validateOptionalType("TSTypeParameterInstantiation")
	  }
	});
	defineType("TSInterfaceDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "typeParameters", "extends", "body"],
	  fields: {
	    declare: validateOptional(bool$5),
	    id: validateType("Identifier"),
	    typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
	    extends: validateOptional(arrayOfType("TSExpressionWithTypeArguments")),
	    body: validateType("TSInterfaceBody")
	  }
	});
	defineType("TSInterfaceBody", {
	  visitor: ["body"],
	  fields: {
	    body: validateArrayOfType("TSTypeElement")
	  }
	});
	defineType("TSTypeAliasDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "typeParameters", "typeAnnotation"],
	  fields: {
	    declare: validateOptional(bool$5),
	    id: validateType("Identifier"),
	    typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
	    typeAnnotation: validateType("TSType")
	  }
	});
	defineType("TSAsExpression", {
	  aliases: ["Expression"],
	  visitor: ["expression", "typeAnnotation"],
	  fields: {
	    expression: validateType("Expression"),
	    typeAnnotation: validateType("TSType")
	  }
	});
	defineType("TSTypeAssertion", {
	  aliases: ["Expression"],
	  visitor: ["typeAnnotation", "expression"],
	  fields: {
	    typeAnnotation: validateType("TSType"),
	    expression: validateType("Expression")
	  }
	});
	defineType("TSEnumDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "members"],
	  fields: {
	    declare: validateOptional(bool$5),
	    const: validateOptional(bool$5),
	    id: validateType("Identifier"),
	    members: validateArrayOfType("TSEnumMember"),
	    initializer: validateOptionalType("Expression")
	  }
	});
	defineType("TSEnumMember", {
	  visitor: ["id", "initializer"],
	  fields: {
	    id: validateType(["Identifier", "StringLiteral"]),
	    initializer: validateOptionalType("Expression")
	  }
	});
	defineType("TSModuleDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "body"],
	  fields: {
	    declare: validateOptional(bool$5),
	    global: validateOptional(bool$5),
	    id: validateType(["Identifier", "StringLiteral"]),
	    body: validateType(["TSModuleBlock", "TSModuleDeclaration"])
	  }
	});
	defineType("TSModuleBlock", {
	  aliases: ["Scopable", "Block", "BlockParent"],
	  visitor: ["body"],
	  fields: {
	    body: validateArrayOfType("Statement")
	  }
	});
	defineType("TSImportType", {
	  aliases: ["TSType"],
	  visitor: ["argument", "qualifier", "typeParameters"],
	  fields: {
	    argument: validateType("StringLiteral"),
	    qualifier: validateOptionalType("TSEntityName"),
	    typeParameters: validateOptionalType("TSTypeParameterInstantiation")
	  }
	});
	defineType("TSImportEqualsDeclaration", {
	  aliases: ["Statement"],
	  visitor: ["id", "moduleReference"],
	  fields: {
	    isExport: validate$5(bool$5),
	    id: validateType("Identifier"),
	    moduleReference: validateType(["TSEntityName", "TSExternalModuleReference"]),
	    importKind: {
	      validate: assertOneOf("type", "value"),
	      optional: true
	    }
	  }
	});
	defineType("TSExternalModuleReference", {
	  visitor: ["expression"],
	  fields: {
	    expression: validateType("StringLiteral")
	  }
	});
	defineType("TSNonNullExpression", {
	  aliases: ["Expression"],
	  visitor: ["expression"],
	  fields: {
	    expression: validateType("Expression")
	  }
	});
	defineType("TSExportAssignment", {
	  aliases: ["Statement"],
	  visitor: ["expression"],
	  fields: {
	    expression: validateType("Expression")
	  }
	});
	defineType("TSNamespaceExportDeclaration", {
	  aliases: ["Statement"],
	  visitor: ["id"],
	  fields: {
	    id: validateType("Identifier")
	  }
	});
	defineType("TSTypeAnnotation", {
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: {
	      validate: assertNodeType("TSType")
	    }
	  }
	});
	defineType("TSTypeParameterInstantiation", {
	  visitor: ["params"],
	  fields: {
	    params: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSType")))
	    }
	  }
	});
	defineType("TSTypeParameterDeclaration", {
	  visitor: ["params"],
	  fields: {
	    params: {
	      validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSTypeParameter")))
	    }
	  }
	});
	defineType("TSTypeParameter", {
	  builder: ["constraint", "default", "name"],
	  visitor: ["constraint", "default"],
	  fields: {
	    name: {
	      validate: !browser$5.env.BABEL_8_BREAKING ? assertValueType("string") : assertNodeType("Identifier")
	    },
	    constraint: {
	      validate: assertNodeType("TSType"),
	      optional: true
	    },
	    default: {
	      validate: assertNodeType("TSType"),
	      optional: true
	    }
	  }
	});

	toFastProperties(VISITOR_KEYS$7);
	toFastProperties(ALIAS_KEYS);
	toFastProperties(FLIPPED_ALIAS_KEYS$3);
	toFastProperties(NODE_FIELDS);
	toFastProperties(BUILDER_KEYS);
	toFastProperties(DEPRECATED_KEYS$1);
	toFastProperties(PLACEHOLDERS_ALIAS);
	toFastProperties(PLACEHOLDERS_FLIPPED_ALIAS);
	const TYPES$1 = [].concat(Object.keys(VISITOR_KEYS$7), Object.keys(FLIPPED_ALIAS_KEYS$3), Object.keys(DEPRECATED_KEYS$1));

	function builder() {
	  const type = this;
	  const keys = BUILDER_KEYS[type];
	  const countArgs = arguments.length;

	  if (countArgs > keys.length) {
	    throw new Error(`${type}: Too many arguments passed. Received ${countArgs} but can receive no more than ${keys.length}`);
	  }

	  const node = {
	    type
	  };

	  for (let i = 0; i < keys.length; ++i) {
	    const key = keys[i];
	    const field = NODE_FIELDS[type][key];
	    let arg;
	    if (i < countArgs) arg = arguments[i];

	    if (arg === undefined) {
	      arg = Array.isArray(field.default) ? [] : field.default;
	    }

	    node[key] = arg;
	  }

	  for (const key in node) {
	    validate$6(node, key, node[key]);
	  }

	  return node;
	}

	function arrayExpression$1(elements) {
	  return builder.apply("ArrayExpression", arguments);
	}
	function assignmentExpression$9(operator, left, right) {
	  return builder.apply("AssignmentExpression", arguments);
	}
	function binaryExpression$3(operator, left, right) {
	  return builder.apply("BinaryExpression", arguments);
	}
	function interpreterDirective$1(value) {
	  return builder.apply("InterpreterDirective", arguments);
	}
	function directive(value) {
	  return builder.apply("Directive", arguments);
	}
	function directiveLiteral(value) {
	  return builder.apply("DirectiveLiteral", arguments);
	}
	function blockStatement$5(body, directives) {
	  return builder.apply("BlockStatement", arguments);
	}
	function breakStatement(label) {
	  return builder.apply("BreakStatement", arguments);
	}
	function callExpression$8(callee, _arguments) {
	  return builder.apply("CallExpression", arguments);
	}
	function catchClause(param, body) {
	  return builder.apply("CatchClause", arguments);
	}
	function conditionalExpression$3(test, consequent, alternate) {
	  return builder.apply("ConditionalExpression", arguments);
	}
	function continueStatement(label) {
	  return builder.apply("ContinueStatement", arguments);
	}
	function debuggerStatement() {
	  return builder.apply("DebuggerStatement", arguments);
	}
	function doWhileStatement(test, body) {
	  return builder.apply("DoWhileStatement", arguments);
	}
	function emptyStatement$1() {
	  return builder.apply("EmptyStatement", arguments);
	}
	function expressionStatement$7(expression) {
	  return builder.apply("ExpressionStatement", arguments);
	}
	function file$1(program, comments, tokens) {
	  return builder.apply("File", arguments);
	}
	function forInStatement(left, right, body) {
	  return builder.apply("ForInStatement", arguments);
	}
	function forStatement(init, test, update, body) {
	  return builder.apply("ForStatement", arguments);
	}
	function functionDeclaration(id, params, body, generator, async) {
	  return builder.apply("FunctionDeclaration", arguments);
	}
	function functionExpression$1(id, params, body, generator, async) {
	  return builder.apply("FunctionExpression", arguments);
	}
	function identifier$e(name) {
	  return builder.apply("Identifier", arguments);
	}
	function ifStatement(test, consequent, alternate) {
	  return builder.apply("IfStatement", arguments);
	}
	function labeledStatement(label, body) {
	  return builder.apply("LabeledStatement", arguments);
	}
	function stringLiteral$4(value) {
	  return builder.apply("StringLiteral", arguments);
	}
	function numericLiteral$5(value) {
	  return builder.apply("NumericLiteral", arguments);
	}
	function nullLiteral$1() {
	  return builder.apply("NullLiteral", arguments);
	}
	function booleanLiteral$2(value) {
	  return builder.apply("BooleanLiteral", arguments);
	}
	function regExpLiteral(pattern, flags) {
	  return builder.apply("RegExpLiteral", arguments);
	}
	function logicalExpression$2(operator, left, right) {
	  return builder.apply("LogicalExpression", arguments);
	}
	function memberExpression$6(object, property, computed, optional) {
	  return builder.apply("MemberExpression", arguments);
	}
	function newExpression(callee, _arguments) {
	  return builder.apply("NewExpression", arguments);
	}
	function program$3(body, directives, sourceType, interpreter) {
	  return builder.apply("Program", arguments);
	}
	function objectExpression$2(properties) {
	  return builder.apply("ObjectExpression", arguments);
	}
	function objectMethod(kind, key, params, body, computed, generator, async) {
	  return builder.apply("ObjectMethod", arguments);
	}
	function objectProperty(key, value, computed, shorthand, decorators) {
	  return builder.apply("ObjectProperty", arguments);
	}
	function restElement$1(argument) {
	  return builder.apply("RestElement", arguments);
	}
	function returnStatement$2(argument) {
	  return builder.apply("ReturnStatement", arguments);
	}
	function sequenceExpression$3(expressions) {
	  return builder.apply("SequenceExpression", arguments);
	}
	function parenthesizedExpression(expression) {
	  return builder.apply("ParenthesizedExpression", arguments);
	}
	function switchCase(test, consequent) {
	  return builder.apply("SwitchCase", arguments);
	}
	function switchStatement(discriminant, cases) {
	  return builder.apply("SwitchStatement", arguments);
	}
	function thisExpression$3() {
	  return builder.apply("ThisExpression", arguments);
	}
	function throwStatement(argument) {
	  return builder.apply("ThrowStatement", arguments);
	}
	function tryStatement(block, handler, finalizer) {
	  return builder.apply("TryStatement", arguments);
	}
	function unaryExpression$6(operator, argument, prefix) {
	  return builder.apply("UnaryExpression", arguments);
	}
	function updateExpression(operator, argument, prefix) {
	  return builder.apply("UpdateExpression", arguments);
	}
	function variableDeclaration$6(kind, declarations) {
	  return builder.apply("VariableDeclaration", arguments);
	}
	function variableDeclarator$6(id, init) {
	  return builder.apply("VariableDeclarator", arguments);
	}
	function whileStatement(test, body) {
	  return builder.apply("WhileStatement", arguments);
	}
	function withStatement(object, body) {
	  return builder.apply("WithStatement", arguments);
	}
	function assignmentPattern(left, right) {
	  return builder.apply("AssignmentPattern", arguments);
	}
	function arrayPattern(elements) {
	  return builder.apply("ArrayPattern", arguments);
	}
	function arrowFunctionExpression$4(params, body, async) {
	  return builder.apply("ArrowFunctionExpression", arguments);
	}
	function classBody(body) {
	  return builder.apply("ClassBody", arguments);
	}
	function classExpression(id, superClass, body, decorators) {
	  return builder.apply("ClassExpression", arguments);
	}
	function classDeclaration(id, superClass, body, decorators) {
	  return builder.apply("ClassDeclaration", arguments);
	}
	function exportAllDeclaration(source) {
	  return builder.apply("ExportAllDeclaration", arguments);
	}
	function exportDefaultDeclaration(declaration) {
	  return builder.apply("ExportDefaultDeclaration", arguments);
	}
	function exportNamedDeclaration$2(declaration, specifiers, source) {
	  return builder.apply("ExportNamedDeclaration", arguments);
	}
	function exportSpecifier$2(local, exported) {
	  return builder.apply("ExportSpecifier", arguments);
	}
	function forOfStatement(left, right, body, _await) {
	  return builder.apply("ForOfStatement", arguments);
	}
	function importDeclaration(specifiers, source) {
	  return builder.apply("ImportDeclaration", arguments);
	}
	function importDefaultSpecifier(local) {
	  return builder.apply("ImportDefaultSpecifier", arguments);
	}
	function importNamespaceSpecifier(local) {
	  return builder.apply("ImportNamespaceSpecifier", arguments);
	}
	function importSpecifier(local, imported) {
	  return builder.apply("ImportSpecifier", arguments);
	}
	function metaProperty$1(meta, property) {
	  return builder.apply("MetaProperty", arguments);
	}
	function classMethod(kind, key, params, body, computed, _static, generator, async) {
	  return builder.apply("ClassMethod", arguments);
	}
	function objectPattern(properties) {
	  return builder.apply("ObjectPattern", arguments);
	}
	function spreadElement$1(argument) {
	  return builder.apply("SpreadElement", arguments);
	}

	function _super$1() {
	  return builder.apply("Super", arguments);
	}
	function taggedTemplateExpression(tag, quasi) {
	  return builder.apply("TaggedTemplateExpression", arguments);
	}
	function templateElement(value, tail) {
	  return builder.apply("TemplateElement", arguments);
	}
	function templateLiteral(quasis, expressions) {
	  return builder.apply("TemplateLiteral", arguments);
	}
	function yieldExpression$1(argument, delegate) {
	  return builder.apply("YieldExpression", arguments);
	}
	function awaitExpression$1(argument) {
	  return builder.apply("AwaitExpression", arguments);
	}

	function _import() {
	  return builder.apply("Import", arguments);
	}
	function bigIntLiteral(value) {
	  return builder.apply("BigIntLiteral", arguments);
	}
	function exportNamespaceSpecifier(exported) {
	  return builder.apply("ExportNamespaceSpecifier", arguments);
	}
	function optionalMemberExpression$2(object, property, computed, optional) {
	  return builder.apply("OptionalMemberExpression", arguments);
	}
	function optionalCallExpression$2(callee, _arguments, optional) {
	  return builder.apply("OptionalCallExpression", arguments);
	}
	function classProperty(key, value, typeAnnotation, decorators, computed, _static) {
	  return builder.apply("ClassProperty", arguments);
	}
	function classAccessorProperty(key, value, typeAnnotation, decorators, computed, _static) {
	  return builder.apply("ClassAccessorProperty", arguments);
	}
	function classPrivateProperty(key, value, decorators, _static) {
	  return builder.apply("ClassPrivateProperty", arguments);
	}
	function classPrivateMethod(kind, key, params, body, _static) {
	  return builder.apply("ClassPrivateMethod", arguments);
	}
	function privateName(id) {
	  return builder.apply("PrivateName", arguments);
	}
	function staticBlock$1(body) {
	  return builder.apply("StaticBlock", arguments);
	}
	function anyTypeAnnotation$2() {
	  return builder.apply("AnyTypeAnnotation", arguments);
	}
	function arrayTypeAnnotation$1(elementType) {
	  return builder.apply("ArrayTypeAnnotation", arguments);
	}
	function booleanTypeAnnotation$1() {
	  return builder.apply("BooleanTypeAnnotation", arguments);
	}
	function booleanLiteralTypeAnnotation(value) {
	  return builder.apply("BooleanLiteralTypeAnnotation", arguments);
	}
	function nullLiteralTypeAnnotation$1() {
	  return builder.apply("NullLiteralTypeAnnotation", arguments);
	}
	function classImplements(id, typeParameters) {
	  return builder.apply("ClassImplements", arguments);
	}
	function declareClass(id, typeParameters, _extends, body) {
	  return builder.apply("DeclareClass", arguments);
	}
	function declareFunction(id) {
	  return builder.apply("DeclareFunction", arguments);
	}
	function declareInterface(id, typeParameters, _extends, body) {
	  return builder.apply("DeclareInterface", arguments);
	}
	function declareModule(id, body, kind) {
	  return builder.apply("DeclareModule", arguments);
	}
	function declareModuleExports(typeAnnotation) {
	  return builder.apply("DeclareModuleExports", arguments);
	}
	function declareTypeAlias(id, typeParameters, right) {
	  return builder.apply("DeclareTypeAlias", arguments);
	}
	function declareOpaqueType(id, typeParameters, supertype) {
	  return builder.apply("DeclareOpaqueType", arguments);
	}
	function declareVariable(id) {
	  return builder.apply("DeclareVariable", arguments);
	}
	function declareExportDeclaration(declaration, specifiers, source) {
	  return builder.apply("DeclareExportDeclaration", arguments);
	}
	function declareExportAllDeclaration(source) {
	  return builder.apply("DeclareExportAllDeclaration", arguments);
	}
	function declaredPredicate(value) {
	  return builder.apply("DeclaredPredicate", arguments);
	}
	function existsTypeAnnotation() {
	  return builder.apply("ExistsTypeAnnotation", arguments);
	}
	function functionTypeAnnotation(typeParameters, params, rest, returnType) {
	  return builder.apply("FunctionTypeAnnotation", arguments);
	}
	function functionTypeParam(name, typeAnnotation) {
	  return builder.apply("FunctionTypeParam", arguments);
	}
	function genericTypeAnnotation$1(id, typeParameters) {
	  return builder.apply("GenericTypeAnnotation", arguments);
	}
	function inferredPredicate() {
	  return builder.apply("InferredPredicate", arguments);
	}
	function interfaceExtends(id, typeParameters) {
	  return builder.apply("InterfaceExtends", arguments);
	}
	function interfaceDeclaration(id, typeParameters, _extends, body) {
	  return builder.apply("InterfaceDeclaration", arguments);
	}
	function interfaceTypeAnnotation(_extends, body) {
	  return builder.apply("InterfaceTypeAnnotation", arguments);
	}
	function intersectionTypeAnnotation(types) {
	  return builder.apply("IntersectionTypeAnnotation", arguments);
	}
	function mixedTypeAnnotation() {
	  return builder.apply("MixedTypeAnnotation", arguments);
	}
	function emptyTypeAnnotation() {
	  return builder.apply("EmptyTypeAnnotation", arguments);
	}
	function nullableTypeAnnotation(typeAnnotation) {
	  return builder.apply("NullableTypeAnnotation", arguments);
	}
	function numberLiteralTypeAnnotation(value) {
	  return builder.apply("NumberLiteralTypeAnnotation", arguments);
	}
	function numberTypeAnnotation$2() {
	  return builder.apply("NumberTypeAnnotation", arguments);
	}
	function objectTypeAnnotation(properties, indexers, callProperties, internalSlots, exact) {
	  return builder.apply("ObjectTypeAnnotation", arguments);
	}
	function objectTypeInternalSlot(id, value, optional, _static, method) {
	  return builder.apply("ObjectTypeInternalSlot", arguments);
	}
	function objectTypeCallProperty(value) {
	  return builder.apply("ObjectTypeCallProperty", arguments);
	}
	function objectTypeIndexer(id, key, value, variance) {
	  return builder.apply("ObjectTypeIndexer", arguments);
	}
	function objectTypeProperty(key, value, variance) {
	  return builder.apply("ObjectTypeProperty", arguments);
	}
	function objectTypeSpreadProperty(argument) {
	  return builder.apply("ObjectTypeSpreadProperty", arguments);
	}
	function opaqueType(id, typeParameters, supertype, impltype) {
	  return builder.apply("OpaqueType", arguments);
	}
	function qualifiedTypeIdentifier(id, qualification) {
	  return builder.apply("QualifiedTypeIdentifier", arguments);
	}
	function stringLiteralTypeAnnotation(value) {
	  return builder.apply("StringLiteralTypeAnnotation", arguments);
	}
	function stringTypeAnnotation$2() {
	  return builder.apply("StringTypeAnnotation", arguments);
	}
	function symbolTypeAnnotation() {
	  return builder.apply("SymbolTypeAnnotation", arguments);
	}
	function thisTypeAnnotation() {
	  return builder.apply("ThisTypeAnnotation", arguments);
	}
	function tupleTypeAnnotation$1(types) {
	  return builder.apply("TupleTypeAnnotation", arguments);
	}
	function typeofTypeAnnotation(argument) {
	  return builder.apply("TypeofTypeAnnotation", arguments);
	}
	function typeAlias(id, typeParameters, right) {
	  return builder.apply("TypeAlias", arguments);
	}
	function typeAnnotation(typeAnnotation) {
	  return builder.apply("TypeAnnotation", arguments);
	}
	function typeCastExpression(expression, typeAnnotation) {
	  return builder.apply("TypeCastExpression", arguments);
	}
	function typeParameter(bound, _default, variance) {
	  return builder.apply("TypeParameter", arguments);
	}
	function typeParameterDeclaration(params) {
	  return builder.apply("TypeParameterDeclaration", arguments);
	}
	function typeParameterInstantiation(params) {
	  return builder.apply("TypeParameterInstantiation", arguments);
	}
	function unionTypeAnnotation$1(types) {
	  return builder.apply("UnionTypeAnnotation", arguments);
	}
	function variance(kind) {
	  return builder.apply("Variance", arguments);
	}
	function voidTypeAnnotation$3() {
	  return builder.apply("VoidTypeAnnotation", arguments);
	}
	function enumDeclaration(id, body) {
	  return builder.apply("EnumDeclaration", arguments);
	}
	function enumBooleanBody(members) {
	  return builder.apply("EnumBooleanBody", arguments);
	}
	function enumNumberBody(members) {
	  return builder.apply("EnumNumberBody", arguments);
	}
	function enumStringBody(members) {
	  return builder.apply("EnumStringBody", arguments);
	}
	function enumSymbolBody(members) {
	  return builder.apply("EnumSymbolBody", arguments);
	}
	function enumBooleanMember(id) {
	  return builder.apply("EnumBooleanMember", arguments);
	}
	function enumNumberMember(id, init) {
	  return builder.apply("EnumNumberMember", arguments);
	}
	function enumStringMember(id, init) {
	  return builder.apply("EnumStringMember", arguments);
	}
	function enumDefaultedMember(id) {
	  return builder.apply("EnumDefaultedMember", arguments);
	}
	function indexedAccessType(objectType, indexType) {
	  return builder.apply("IndexedAccessType", arguments);
	}
	function optionalIndexedAccessType(objectType, indexType) {
	  return builder.apply("OptionalIndexedAccessType", arguments);
	}
	function jsxAttribute(name, value) {
	  return builder.apply("JSXAttribute", arguments);
	}
	function jsxClosingElement(name) {
	  return builder.apply("JSXClosingElement", arguments);
	}
	function jsxElement(openingElement, closingElement, children, selfClosing) {
	  return builder.apply("JSXElement", arguments);
	}
	function jsxEmptyExpression() {
	  return builder.apply("JSXEmptyExpression", arguments);
	}
	function jsxExpressionContainer$1(expression) {
	  return builder.apply("JSXExpressionContainer", arguments);
	}
	function jsxSpreadChild(expression) {
	  return builder.apply("JSXSpreadChild", arguments);
	}
	function jsxIdentifier$1(name) {
	  return builder.apply("JSXIdentifier", arguments);
	}
	function jsxMemberExpression(object, property) {
	  return builder.apply("JSXMemberExpression", arguments);
	}
	function jsxNamespacedName(namespace, name) {
	  return builder.apply("JSXNamespacedName", arguments);
	}
	function jsxOpeningElement(name, attributes, selfClosing) {
	  return builder.apply("JSXOpeningElement", arguments);
	}
	function jsxSpreadAttribute(argument) {
	  return builder.apply("JSXSpreadAttribute", arguments);
	}
	function jsxText(value) {
	  return builder.apply("JSXText", arguments);
	}
	function jsxFragment(openingFragment, closingFragment, children) {
	  return builder.apply("JSXFragment", arguments);
	}
	function jsxOpeningFragment() {
	  return builder.apply("JSXOpeningFragment", arguments);
	}
	function jsxClosingFragment() {
	  return builder.apply("JSXClosingFragment", arguments);
	}
	function noop$1() {
	  return builder.apply("Noop", arguments);
	}
	function placeholder(expectedNode, name) {
	  return builder.apply("Placeholder", arguments);
	}
	function v8IntrinsicIdentifier(name) {
	  return builder.apply("V8IntrinsicIdentifier", arguments);
	}
	function argumentPlaceholder() {
	  return builder.apply("ArgumentPlaceholder", arguments);
	}
	function bindExpression(object, callee) {
	  return builder.apply("BindExpression", arguments);
	}
	function importAttribute(key, value) {
	  return builder.apply("ImportAttribute", arguments);
	}
	function decorator(expression) {
	  return builder.apply("Decorator", arguments);
	}
	function doExpression(body, async) {
	  return builder.apply("DoExpression", arguments);
	}
	function exportDefaultSpecifier(exported) {
	  return builder.apply("ExportDefaultSpecifier", arguments);
	}
	function recordExpression(properties) {
	  return builder.apply("RecordExpression", arguments);
	}
	function tupleExpression(elements) {
	  return builder.apply("TupleExpression", arguments);
	}
	function decimalLiteral(value) {
	  return builder.apply("DecimalLiteral", arguments);
	}
	function moduleExpression(body) {
	  return builder.apply("ModuleExpression", arguments);
	}
	function topicReference() {
	  return builder.apply("TopicReference", arguments);
	}
	function pipelineTopicExpression(expression) {
	  return builder.apply("PipelineTopicExpression", arguments);
	}
	function pipelineBareFunction(callee) {
	  return builder.apply("PipelineBareFunction", arguments);
	}
	function pipelinePrimaryTopicReference() {
	  return builder.apply("PipelinePrimaryTopicReference", arguments);
	}
	function tsParameterProperty(parameter) {
	  return builder.apply("TSParameterProperty", arguments);
	}
	function tsDeclareFunction(id, typeParameters, params, returnType) {
	  return builder.apply("TSDeclareFunction", arguments);
	}
	function tsDeclareMethod(decorators, key, typeParameters, params, returnType) {
	  return builder.apply("TSDeclareMethod", arguments);
	}
	function tsQualifiedName(left, right) {
	  return builder.apply("TSQualifiedName", arguments);
	}
	function tsCallSignatureDeclaration(typeParameters, parameters, typeAnnotation) {
	  return builder.apply("TSCallSignatureDeclaration", arguments);
	}
	function tsConstructSignatureDeclaration(typeParameters, parameters, typeAnnotation) {
	  return builder.apply("TSConstructSignatureDeclaration", arguments);
	}
	function tsPropertySignature(key, typeAnnotation, initializer) {
	  return builder.apply("TSPropertySignature", arguments);
	}
	function tsMethodSignature(key, typeParameters, parameters, typeAnnotation) {
	  return builder.apply("TSMethodSignature", arguments);
	}
	function tsIndexSignature(parameters, typeAnnotation) {
	  return builder.apply("TSIndexSignature", arguments);
	}
	function tsAnyKeyword() {
	  return builder.apply("TSAnyKeyword", arguments);
	}
	function tsBooleanKeyword() {
	  return builder.apply("TSBooleanKeyword", arguments);
	}
	function tsBigIntKeyword() {
	  return builder.apply("TSBigIntKeyword", arguments);
	}
	function tsIntrinsicKeyword() {
	  return builder.apply("TSIntrinsicKeyword", arguments);
	}
	function tsNeverKeyword() {
	  return builder.apply("TSNeverKeyword", arguments);
	}
	function tsNullKeyword() {
	  return builder.apply("TSNullKeyword", arguments);
	}
	function tsNumberKeyword() {
	  return builder.apply("TSNumberKeyword", arguments);
	}
	function tsObjectKeyword() {
	  return builder.apply("TSObjectKeyword", arguments);
	}
	function tsStringKeyword() {
	  return builder.apply("TSStringKeyword", arguments);
	}
	function tsSymbolKeyword() {
	  return builder.apply("TSSymbolKeyword", arguments);
	}
	function tsUndefinedKeyword() {
	  return builder.apply("TSUndefinedKeyword", arguments);
	}
	function tsUnknownKeyword() {
	  return builder.apply("TSUnknownKeyword", arguments);
	}
	function tsVoidKeyword() {
	  return builder.apply("TSVoidKeyword", arguments);
	}
	function tsThisType() {
	  return builder.apply("TSThisType", arguments);
	}
	function tsFunctionType(typeParameters, parameters, typeAnnotation) {
	  return builder.apply("TSFunctionType", arguments);
	}
	function tsConstructorType(typeParameters, parameters, typeAnnotation) {
	  return builder.apply("TSConstructorType", arguments);
	}
	function tsTypeReference(typeName, typeParameters) {
	  return builder.apply("TSTypeReference", arguments);
	}
	function tsTypePredicate(parameterName, typeAnnotation, asserts) {
	  return builder.apply("TSTypePredicate", arguments);
	}
	function tsTypeQuery(exprName) {
	  return builder.apply("TSTypeQuery", arguments);
	}
	function tsTypeLiteral(members) {
	  return builder.apply("TSTypeLiteral", arguments);
	}
	function tsArrayType(elementType) {
	  return builder.apply("TSArrayType", arguments);
	}
	function tsTupleType(elementTypes) {
	  return builder.apply("TSTupleType", arguments);
	}
	function tsOptionalType(typeAnnotation) {
	  return builder.apply("TSOptionalType", arguments);
	}
	function tsRestType(typeAnnotation) {
	  return builder.apply("TSRestType", arguments);
	}
	function tsNamedTupleMember(label, elementType, optional) {
	  return builder.apply("TSNamedTupleMember", arguments);
	}
	function tsUnionType(types) {
	  return builder.apply("TSUnionType", arguments);
	}
	function tsIntersectionType(types) {
	  return builder.apply("TSIntersectionType", arguments);
	}
	function tsConditionalType(checkType, extendsType, trueType, falseType) {
	  return builder.apply("TSConditionalType", arguments);
	}
	function tsInferType(typeParameter) {
	  return builder.apply("TSInferType", arguments);
	}
	function tsParenthesizedType(typeAnnotation) {
	  return builder.apply("TSParenthesizedType", arguments);
	}
	function tsTypeOperator(typeAnnotation) {
	  return builder.apply("TSTypeOperator", arguments);
	}
	function tsIndexedAccessType(objectType, indexType) {
	  return builder.apply("TSIndexedAccessType", arguments);
	}
	function tsMappedType(typeParameter, typeAnnotation, nameType) {
	  return builder.apply("TSMappedType", arguments);
	}
	function tsLiteralType(literal) {
	  return builder.apply("TSLiteralType", arguments);
	}
	function tsExpressionWithTypeArguments(expression, typeParameters) {
	  return builder.apply("TSExpressionWithTypeArguments", arguments);
	}
	function tsInterfaceDeclaration(id, typeParameters, _extends, body) {
	  return builder.apply("TSInterfaceDeclaration", arguments);
	}
	function tsInterfaceBody(body) {
	  return builder.apply("TSInterfaceBody", arguments);
	}
	function tsTypeAliasDeclaration(id, typeParameters, typeAnnotation) {
	  return builder.apply("TSTypeAliasDeclaration", arguments);
	}
	function tsAsExpression(expression, typeAnnotation) {
	  return builder.apply("TSAsExpression", arguments);
	}
	function tsTypeAssertion(typeAnnotation, expression) {
	  return builder.apply("TSTypeAssertion", arguments);
	}
	function tsEnumDeclaration(id, members) {
	  return builder.apply("TSEnumDeclaration", arguments);
	}
	function tsEnumMember(id, initializer) {
	  return builder.apply("TSEnumMember", arguments);
	}
	function tsModuleDeclaration(id, body) {
	  return builder.apply("TSModuleDeclaration", arguments);
	}
	function tsModuleBlock(body) {
	  return builder.apply("TSModuleBlock", arguments);
	}
	function tsImportType(argument, qualifier, typeParameters) {
	  return builder.apply("TSImportType", arguments);
	}
	function tsImportEqualsDeclaration(id, moduleReference) {
	  return builder.apply("TSImportEqualsDeclaration", arguments);
	}
	function tsExternalModuleReference(expression) {
	  return builder.apply("TSExternalModuleReference", arguments);
	}
	function tsNonNullExpression(expression) {
	  return builder.apply("TSNonNullExpression", arguments);
	}
	function tsExportAssignment(expression) {
	  return builder.apply("TSExportAssignment", arguments);
	}
	function tsNamespaceExportDeclaration(id) {
	  return builder.apply("TSNamespaceExportDeclaration", arguments);
	}
	function tsTypeAnnotation(typeAnnotation) {
	  return builder.apply("TSTypeAnnotation", arguments);
	}
	function tsTypeParameterInstantiation(params) {
	  return builder.apply("TSTypeParameterInstantiation", arguments);
	}
	function tsTypeParameterDeclaration(params) {
	  return builder.apply("TSTypeParameterDeclaration", arguments);
	}
	function tsTypeParameter(constraint, _default, name) {
	  return builder.apply("TSTypeParameter", arguments);
	}

	function NumberLiteral(value) {
	  console.trace("The node type NumberLiteral has been renamed to NumericLiteral");
	  return builder.apply("NumberLiteral", arguments);
	}

	function RegexLiteral(pattern, flags) {
	  console.trace("The node type RegexLiteral has been renamed to RegExpLiteral");
	  return builder.apply("RegexLiteral", arguments);
	}

	function RestProperty$1(argument) {
	  console.trace("The node type RestProperty has been renamed to RestElement");
	  return builder.apply("RestProperty", arguments);
	}

	function SpreadProperty$1(argument) {
	  console.trace("The node type SpreadProperty has been renamed to SpreadElement");
	  return builder.apply("SpreadProperty", arguments);
	}

	function cleanJSXElementLiteralChild(child, args) {
	  const lines = child.value.split(/\r\n|\n|\r/);
	  let lastNonEmptyLine = 0;

	  for (let i = 0; i < lines.length; i++) {
	    if (lines[i].match(/[^ \t]/)) {
	      lastNonEmptyLine = i;
	    }
	  }

	  let str = "";

	  for (let i = 0; i < lines.length; i++) {
	    const line = lines[i];
	    const isFirstLine = i === 0;
	    const isLastLine = i === lines.length - 1;
	    const isLastNonEmptyLine = i === lastNonEmptyLine;
	    let trimmedLine = line.replace(/\t/g, " ");

	    if (!isFirstLine) {
	      trimmedLine = trimmedLine.replace(/^[ ]+/, "");
	    }

	    if (!isLastLine) {
	      trimmedLine = trimmedLine.replace(/[ ]+$/, "");
	    }

	    if (trimmedLine) {
	      if (!isLastNonEmptyLine) {
	        trimmedLine += " ";
	      }

	      str += trimmedLine;
	    }
	  }

	  if (str) args.push(stringLiteral$4(str));
	}

	function buildChildren(node) {
	  const elements = [];

	  for (let i = 0; i < node.children.length; i++) {
	    let child = node.children[i];

	    if (isJSXText(child)) {
	      cleanJSXElementLiteralChild(child, elements);
	      continue;
	    }

	    if (isJSXExpressionContainer(child)) child = child.expression;
	    if (isJSXEmptyExpression(child)) continue;
	    elements.push(child);
	  }

	  return elements;
	}

	function isNode(node) {
	  return !!(node && VISITOR_KEYS$7[node.type]);
	}

	function assertNode(node) {
	  if (!isNode(node)) {
	    const type = node?.type ?? JSON.stringify(node);
	    throw new TypeError(`Not a valid node of type "${type}"`);
	  }
	}

	function assert$1(type, node, opts) {
	  if (!is$1(type, node, opts)) {
	    throw new Error(`Expected type "${type}" with option ${JSON.stringify(opts)}, ` + `but instead got "${node.type}".`);
	  }
	}

	function assertArrayExpression(node, opts) {
	  assert$1("ArrayExpression", node, opts);
	}
	function assertAssignmentExpression(node, opts) {
	  assert$1("AssignmentExpression", node, opts);
	}
	function assertBinaryExpression(node, opts) {
	  assert$1("BinaryExpression", node, opts);
	}
	function assertInterpreterDirective(node, opts) {
	  assert$1("InterpreterDirective", node, opts);
	}
	function assertDirective(node, opts) {
	  assert$1("Directive", node, opts);
	}
	function assertDirectiveLiteral(node, opts) {
	  assert$1("DirectiveLiteral", node, opts);
	}
	function assertBlockStatement(node, opts) {
	  assert$1("BlockStatement", node, opts);
	}
	function assertBreakStatement(node, opts) {
	  assert$1("BreakStatement", node, opts);
	}
	function assertCallExpression(node, opts) {
	  assert$1("CallExpression", node, opts);
	}
	function assertCatchClause(node, opts) {
	  assert$1("CatchClause", node, opts);
	}
	function assertConditionalExpression(node, opts) {
	  assert$1("ConditionalExpression", node, opts);
	}
	function assertContinueStatement(node, opts) {
	  assert$1("ContinueStatement", node, opts);
	}
	function assertDebuggerStatement(node, opts) {
	  assert$1("DebuggerStatement", node, opts);
	}
	function assertDoWhileStatement(node, opts) {
	  assert$1("DoWhileStatement", node, opts);
	}
	function assertEmptyStatement(node, opts) {
	  assert$1("EmptyStatement", node, opts);
	}
	function assertExpressionStatement$1(node, opts) {
	  assert$1("ExpressionStatement", node, opts);
	}
	function assertFile(node, opts) {
	  assert$1("File", node, opts);
	}
	function assertForInStatement(node, opts) {
	  assert$1("ForInStatement", node, opts);
	}
	function assertForStatement(node, opts) {
	  assert$1("ForStatement", node, opts);
	}
	function assertFunctionDeclaration(node, opts) {
	  assert$1("FunctionDeclaration", node, opts);
	}
	function assertFunctionExpression(node, opts) {
	  assert$1("FunctionExpression", node, opts);
	}
	function assertIdentifier(node, opts) {
	  assert$1("Identifier", node, opts);
	}
	function assertIfStatement(node, opts) {
	  assert$1("IfStatement", node, opts);
	}
	function assertLabeledStatement(node, opts) {
	  assert$1("LabeledStatement", node, opts);
	}
	function assertStringLiteral(node, opts) {
	  assert$1("StringLiteral", node, opts);
	}
	function assertNumericLiteral(node, opts) {
	  assert$1("NumericLiteral", node, opts);
	}
	function assertNullLiteral(node, opts) {
	  assert$1("NullLiteral", node, opts);
	}
	function assertBooleanLiteral(node, opts) {
	  assert$1("BooleanLiteral", node, opts);
	}
	function assertRegExpLiteral(node, opts) {
	  assert$1("RegExpLiteral", node, opts);
	}
	function assertLogicalExpression(node, opts) {
	  assert$1("LogicalExpression", node, opts);
	}
	function assertMemberExpression(node, opts) {
	  assert$1("MemberExpression", node, opts);
	}
	function assertNewExpression(node, opts) {
	  assert$1("NewExpression", node, opts);
	}
	function assertProgram(node, opts) {
	  assert$1("Program", node, opts);
	}
	function assertObjectExpression(node, opts) {
	  assert$1("ObjectExpression", node, opts);
	}
	function assertObjectMethod(node, opts) {
	  assert$1("ObjectMethod", node, opts);
	}
	function assertObjectProperty(node, opts) {
	  assert$1("ObjectProperty", node, opts);
	}
	function assertRestElement(node, opts) {
	  assert$1("RestElement", node, opts);
	}
	function assertReturnStatement(node, opts) {
	  assert$1("ReturnStatement", node, opts);
	}
	function assertSequenceExpression(node, opts) {
	  assert$1("SequenceExpression", node, opts);
	}
	function assertParenthesizedExpression(node, opts) {
	  assert$1("ParenthesizedExpression", node, opts);
	}
	function assertSwitchCase(node, opts) {
	  assert$1("SwitchCase", node, opts);
	}
	function assertSwitchStatement(node, opts) {
	  assert$1("SwitchStatement", node, opts);
	}
	function assertThisExpression(node, opts) {
	  assert$1("ThisExpression", node, opts);
	}
	function assertThrowStatement(node, opts) {
	  assert$1("ThrowStatement", node, opts);
	}
	function assertTryStatement(node, opts) {
	  assert$1("TryStatement", node, opts);
	}
	function assertUnaryExpression(node, opts) {
	  assert$1("UnaryExpression", node, opts);
	}
	function assertUpdateExpression(node, opts) {
	  assert$1("UpdateExpression", node, opts);
	}
	function assertVariableDeclaration(node, opts) {
	  assert$1("VariableDeclaration", node, opts);
	}
	function assertVariableDeclarator(node, opts) {
	  assert$1("VariableDeclarator", node, opts);
	}
	function assertWhileStatement(node, opts) {
	  assert$1("WhileStatement", node, opts);
	}
	function assertWithStatement(node, opts) {
	  assert$1("WithStatement", node, opts);
	}
	function assertAssignmentPattern(node, opts) {
	  assert$1("AssignmentPattern", node, opts);
	}
	function assertArrayPattern(node, opts) {
	  assert$1("ArrayPattern", node, opts);
	}
	function assertArrowFunctionExpression(node, opts) {
	  assert$1("ArrowFunctionExpression", node, opts);
	}
	function assertClassBody(node, opts) {
	  assert$1("ClassBody", node, opts);
	}
	function assertClassExpression(node, opts) {
	  assert$1("ClassExpression", node, opts);
	}
	function assertClassDeclaration(node, opts) {
	  assert$1("ClassDeclaration", node, opts);
	}
	function assertExportAllDeclaration(node, opts) {
	  assert$1("ExportAllDeclaration", node, opts);
	}
	function assertExportDefaultDeclaration(node, opts) {
	  assert$1("ExportDefaultDeclaration", node, opts);
	}
	function assertExportNamedDeclaration(node, opts) {
	  assert$1("ExportNamedDeclaration", node, opts);
	}
	function assertExportSpecifier(node, opts) {
	  assert$1("ExportSpecifier", node, opts);
	}
	function assertForOfStatement(node, opts) {
	  assert$1("ForOfStatement", node, opts);
	}
	function assertImportDeclaration(node, opts) {
	  assert$1("ImportDeclaration", node, opts);
	}
	function assertImportDefaultSpecifier(node, opts) {
	  assert$1("ImportDefaultSpecifier", node, opts);
	}
	function assertImportNamespaceSpecifier(node, opts) {
	  assert$1("ImportNamespaceSpecifier", node, opts);
	}
	function assertImportSpecifier(node, opts) {
	  assert$1("ImportSpecifier", node, opts);
	}
	function assertMetaProperty(node, opts) {
	  assert$1("MetaProperty", node, opts);
	}
	function assertClassMethod(node, opts) {
	  assert$1("ClassMethod", node, opts);
	}
	function assertObjectPattern(node, opts) {
	  assert$1("ObjectPattern", node, opts);
	}
	function assertSpreadElement(node, opts) {
	  assert$1("SpreadElement", node, opts);
	}
	function assertSuper(node, opts) {
	  assert$1("Super", node, opts);
	}
	function assertTaggedTemplateExpression(node, opts) {
	  assert$1("TaggedTemplateExpression", node, opts);
	}
	function assertTemplateElement(node, opts) {
	  assert$1("TemplateElement", node, opts);
	}
	function assertTemplateLiteral(node, opts) {
	  assert$1("TemplateLiteral", node, opts);
	}
	function assertYieldExpression(node, opts) {
	  assert$1("YieldExpression", node, opts);
	}
	function assertAwaitExpression(node, opts) {
	  assert$1("AwaitExpression", node, opts);
	}
	function assertImport(node, opts) {
	  assert$1("Import", node, opts);
	}
	function assertBigIntLiteral(node, opts) {
	  assert$1("BigIntLiteral", node, opts);
	}
	function assertExportNamespaceSpecifier(node, opts) {
	  assert$1("ExportNamespaceSpecifier", node, opts);
	}
	function assertOptionalMemberExpression(node, opts) {
	  assert$1("OptionalMemberExpression", node, opts);
	}
	function assertOptionalCallExpression(node, opts) {
	  assert$1("OptionalCallExpression", node, opts);
	}
	function assertClassProperty(node, opts) {
	  assert$1("ClassProperty", node, opts);
	}
	function assertClassAccessorProperty(node, opts) {
	  assert$1("ClassAccessorProperty", node, opts);
	}
	function assertClassPrivateProperty(node, opts) {
	  assert$1("ClassPrivateProperty", node, opts);
	}
	function assertClassPrivateMethod(node, opts) {
	  assert$1("ClassPrivateMethod", node, opts);
	}
	function assertPrivateName(node, opts) {
	  assert$1("PrivateName", node, opts);
	}
	function assertStaticBlock(node, opts) {
	  assert$1("StaticBlock", node, opts);
	}
	function assertAnyTypeAnnotation(node, opts) {
	  assert$1("AnyTypeAnnotation", node, opts);
	}
	function assertArrayTypeAnnotation(node, opts) {
	  assert$1("ArrayTypeAnnotation", node, opts);
	}
	function assertBooleanTypeAnnotation(node, opts) {
	  assert$1("BooleanTypeAnnotation", node, opts);
	}
	function assertBooleanLiteralTypeAnnotation(node, opts) {
	  assert$1("BooleanLiteralTypeAnnotation", node, opts);
	}
	function assertNullLiteralTypeAnnotation(node, opts) {
	  assert$1("NullLiteralTypeAnnotation", node, opts);
	}
	function assertClassImplements(node, opts) {
	  assert$1("ClassImplements", node, opts);
	}
	function assertDeclareClass(node, opts) {
	  assert$1("DeclareClass", node, opts);
	}
	function assertDeclareFunction(node, opts) {
	  assert$1("DeclareFunction", node, opts);
	}
	function assertDeclareInterface(node, opts) {
	  assert$1("DeclareInterface", node, opts);
	}
	function assertDeclareModule(node, opts) {
	  assert$1("DeclareModule", node, opts);
	}
	function assertDeclareModuleExports(node, opts) {
	  assert$1("DeclareModuleExports", node, opts);
	}
	function assertDeclareTypeAlias(node, opts) {
	  assert$1("DeclareTypeAlias", node, opts);
	}
	function assertDeclareOpaqueType(node, opts) {
	  assert$1("DeclareOpaqueType", node, opts);
	}
	function assertDeclareVariable(node, opts) {
	  assert$1("DeclareVariable", node, opts);
	}
	function assertDeclareExportDeclaration(node, opts) {
	  assert$1("DeclareExportDeclaration", node, opts);
	}
	function assertDeclareExportAllDeclaration(node, opts) {
	  assert$1("DeclareExportAllDeclaration", node, opts);
	}
	function assertDeclaredPredicate(node, opts) {
	  assert$1("DeclaredPredicate", node, opts);
	}
	function assertExistsTypeAnnotation(node, opts) {
	  assert$1("ExistsTypeAnnotation", node, opts);
	}
	function assertFunctionTypeAnnotation(node, opts) {
	  assert$1("FunctionTypeAnnotation", node, opts);
	}
	function assertFunctionTypeParam(node, opts) {
	  assert$1("FunctionTypeParam", node, opts);
	}
	function assertGenericTypeAnnotation(node, opts) {
	  assert$1("GenericTypeAnnotation", node, opts);
	}
	function assertInferredPredicate(node, opts) {
	  assert$1("InferredPredicate", node, opts);
	}
	function assertInterfaceExtends(node, opts) {
	  assert$1("InterfaceExtends", node, opts);
	}
	function assertInterfaceDeclaration(node, opts) {
	  assert$1("InterfaceDeclaration", node, opts);
	}
	function assertInterfaceTypeAnnotation(node, opts) {
	  assert$1("InterfaceTypeAnnotation", node, opts);
	}
	function assertIntersectionTypeAnnotation(node, opts) {
	  assert$1("IntersectionTypeAnnotation", node, opts);
	}
	function assertMixedTypeAnnotation(node, opts) {
	  assert$1("MixedTypeAnnotation", node, opts);
	}
	function assertEmptyTypeAnnotation(node, opts) {
	  assert$1("EmptyTypeAnnotation", node, opts);
	}
	function assertNullableTypeAnnotation(node, opts) {
	  assert$1("NullableTypeAnnotation", node, opts);
	}
	function assertNumberLiteralTypeAnnotation(node, opts) {
	  assert$1("NumberLiteralTypeAnnotation", node, opts);
	}
	function assertNumberTypeAnnotation(node, opts) {
	  assert$1("NumberTypeAnnotation", node, opts);
	}
	function assertObjectTypeAnnotation(node, opts) {
	  assert$1("ObjectTypeAnnotation", node, opts);
	}
	function assertObjectTypeInternalSlot(node, opts) {
	  assert$1("ObjectTypeInternalSlot", node, opts);
	}
	function assertObjectTypeCallProperty(node, opts) {
	  assert$1("ObjectTypeCallProperty", node, opts);
	}
	function assertObjectTypeIndexer(node, opts) {
	  assert$1("ObjectTypeIndexer", node, opts);
	}
	function assertObjectTypeProperty(node, opts) {
	  assert$1("ObjectTypeProperty", node, opts);
	}
	function assertObjectTypeSpreadProperty(node, opts) {
	  assert$1("ObjectTypeSpreadProperty", node, opts);
	}
	function assertOpaqueType(node, opts) {
	  assert$1("OpaqueType", node, opts);
	}
	function assertQualifiedTypeIdentifier(node, opts) {
	  assert$1("QualifiedTypeIdentifier", node, opts);
	}
	function assertStringLiteralTypeAnnotation(node, opts) {
	  assert$1("StringLiteralTypeAnnotation", node, opts);
	}
	function assertStringTypeAnnotation(node, opts) {
	  assert$1("StringTypeAnnotation", node, opts);
	}
	function assertSymbolTypeAnnotation(node, opts) {
	  assert$1("SymbolTypeAnnotation", node, opts);
	}
	function assertThisTypeAnnotation(node, opts) {
	  assert$1("ThisTypeAnnotation", node, opts);
	}
	function assertTupleTypeAnnotation(node, opts) {
	  assert$1("TupleTypeAnnotation", node, opts);
	}
	function assertTypeofTypeAnnotation(node, opts) {
	  assert$1("TypeofTypeAnnotation", node, opts);
	}
	function assertTypeAlias(node, opts) {
	  assert$1("TypeAlias", node, opts);
	}
	function assertTypeAnnotation(node, opts) {
	  assert$1("TypeAnnotation", node, opts);
	}
	function assertTypeCastExpression(node, opts) {
	  assert$1("TypeCastExpression", node, opts);
	}
	function assertTypeParameter(node, opts) {
	  assert$1("TypeParameter", node, opts);
	}
	function assertTypeParameterDeclaration(node, opts) {
	  assert$1("TypeParameterDeclaration", node, opts);
	}
	function assertTypeParameterInstantiation(node, opts) {
	  assert$1("TypeParameterInstantiation", node, opts);
	}
	function assertUnionTypeAnnotation(node, opts) {
	  assert$1("UnionTypeAnnotation", node, opts);
	}
	function assertVariance(node, opts) {
	  assert$1("Variance", node, opts);
	}
	function assertVoidTypeAnnotation(node, opts) {
	  assert$1("VoidTypeAnnotation", node, opts);
	}
	function assertEnumDeclaration(node, opts) {
	  assert$1("EnumDeclaration", node, opts);
	}
	function assertEnumBooleanBody(node, opts) {
	  assert$1("EnumBooleanBody", node, opts);
	}
	function assertEnumNumberBody(node, opts) {
	  assert$1("EnumNumberBody", node, opts);
	}
	function assertEnumStringBody(node, opts) {
	  assert$1("EnumStringBody", node, opts);
	}
	function assertEnumSymbolBody(node, opts) {
	  assert$1("EnumSymbolBody", node, opts);
	}
	function assertEnumBooleanMember(node, opts) {
	  assert$1("EnumBooleanMember", node, opts);
	}
	function assertEnumNumberMember(node, opts) {
	  assert$1("EnumNumberMember", node, opts);
	}
	function assertEnumStringMember(node, opts) {
	  assert$1("EnumStringMember", node, opts);
	}
	function assertEnumDefaultedMember(node, opts) {
	  assert$1("EnumDefaultedMember", node, opts);
	}
	function assertIndexedAccessType(node, opts) {
	  assert$1("IndexedAccessType", node, opts);
	}
	function assertOptionalIndexedAccessType(node, opts) {
	  assert$1("OptionalIndexedAccessType", node, opts);
	}
	function assertJSXAttribute(node, opts) {
	  assert$1("JSXAttribute", node, opts);
	}
	function assertJSXClosingElement(node, opts) {
	  assert$1("JSXClosingElement", node, opts);
	}
	function assertJSXElement(node, opts) {
	  assert$1("JSXElement", node, opts);
	}
	function assertJSXEmptyExpression(node, opts) {
	  assert$1("JSXEmptyExpression", node, opts);
	}
	function assertJSXExpressionContainer(node, opts) {
	  assert$1("JSXExpressionContainer", node, opts);
	}
	function assertJSXSpreadChild(node, opts) {
	  assert$1("JSXSpreadChild", node, opts);
	}
	function assertJSXIdentifier(node, opts) {
	  assert$1("JSXIdentifier", node, opts);
	}
	function assertJSXMemberExpression(node, opts) {
	  assert$1("JSXMemberExpression", node, opts);
	}
	function assertJSXNamespacedName(node, opts) {
	  assert$1("JSXNamespacedName", node, opts);
	}
	function assertJSXOpeningElement(node, opts) {
	  assert$1("JSXOpeningElement", node, opts);
	}
	function assertJSXSpreadAttribute(node, opts) {
	  assert$1("JSXSpreadAttribute", node, opts);
	}
	function assertJSXText(node, opts) {
	  assert$1("JSXText", node, opts);
	}
	function assertJSXFragment(node, opts) {
	  assert$1("JSXFragment", node, opts);
	}
	function assertJSXOpeningFragment(node, opts) {
	  assert$1("JSXOpeningFragment", node, opts);
	}
	function assertJSXClosingFragment(node, opts) {
	  assert$1("JSXClosingFragment", node, opts);
	}
	function assertNoop(node, opts) {
	  assert$1("Noop", node, opts);
	}
	function assertPlaceholder(node, opts) {
	  assert$1("Placeholder", node, opts);
	}
	function assertV8IntrinsicIdentifier(node, opts) {
	  assert$1("V8IntrinsicIdentifier", node, opts);
	}
	function assertArgumentPlaceholder(node, opts) {
	  assert$1("ArgumentPlaceholder", node, opts);
	}
	function assertBindExpression(node, opts) {
	  assert$1("BindExpression", node, opts);
	}
	function assertImportAttribute(node, opts) {
	  assert$1("ImportAttribute", node, opts);
	}
	function assertDecorator(node, opts) {
	  assert$1("Decorator", node, opts);
	}
	function assertDoExpression(node, opts) {
	  assert$1("DoExpression", node, opts);
	}
	function assertExportDefaultSpecifier(node, opts) {
	  assert$1("ExportDefaultSpecifier", node, opts);
	}
	function assertRecordExpression(node, opts) {
	  assert$1("RecordExpression", node, opts);
	}
	function assertTupleExpression(node, opts) {
	  assert$1("TupleExpression", node, opts);
	}
	function assertDecimalLiteral(node, opts) {
	  assert$1("DecimalLiteral", node, opts);
	}
	function assertModuleExpression(node, opts) {
	  assert$1("ModuleExpression", node, opts);
	}
	function assertTopicReference(node, opts) {
	  assert$1("TopicReference", node, opts);
	}
	function assertPipelineTopicExpression(node, opts) {
	  assert$1("PipelineTopicExpression", node, opts);
	}
	function assertPipelineBareFunction(node, opts) {
	  assert$1("PipelineBareFunction", node, opts);
	}
	function assertPipelinePrimaryTopicReference(node, opts) {
	  assert$1("PipelinePrimaryTopicReference", node, opts);
	}
	function assertTSParameterProperty(node, opts) {
	  assert$1("TSParameterProperty", node, opts);
	}
	function assertTSDeclareFunction(node, opts) {
	  assert$1("TSDeclareFunction", node, opts);
	}
	function assertTSDeclareMethod(node, opts) {
	  assert$1("TSDeclareMethod", node, opts);
	}
	function assertTSQualifiedName(node, opts) {
	  assert$1("TSQualifiedName", node, opts);
	}
	function assertTSCallSignatureDeclaration(node, opts) {
	  assert$1("TSCallSignatureDeclaration", node, opts);
	}
	function assertTSConstructSignatureDeclaration(node, opts) {
	  assert$1("TSConstructSignatureDeclaration", node, opts);
	}
	function assertTSPropertySignature(node, opts) {
	  assert$1("TSPropertySignature", node, opts);
	}
	function assertTSMethodSignature(node, opts) {
	  assert$1("TSMethodSignature", node, opts);
	}
	function assertTSIndexSignature(node, opts) {
	  assert$1("TSIndexSignature", node, opts);
	}
	function assertTSAnyKeyword(node, opts) {
	  assert$1("TSAnyKeyword", node, opts);
	}
	function assertTSBooleanKeyword(node, opts) {
	  assert$1("TSBooleanKeyword", node, opts);
	}
	function assertTSBigIntKeyword(node, opts) {
	  assert$1("TSBigIntKeyword", node, opts);
	}
	function assertTSIntrinsicKeyword(node, opts) {
	  assert$1("TSIntrinsicKeyword", node, opts);
	}
	function assertTSNeverKeyword(node, opts) {
	  assert$1("TSNeverKeyword", node, opts);
	}
	function assertTSNullKeyword(node, opts) {
	  assert$1("TSNullKeyword", node, opts);
	}
	function assertTSNumberKeyword(node, opts) {
	  assert$1("TSNumberKeyword", node, opts);
	}
	function assertTSObjectKeyword(node, opts) {
	  assert$1("TSObjectKeyword", node, opts);
	}
	function assertTSStringKeyword(node, opts) {
	  assert$1("TSStringKeyword", node, opts);
	}
	function assertTSSymbolKeyword(node, opts) {
	  assert$1("TSSymbolKeyword", node, opts);
	}
	function assertTSUndefinedKeyword(node, opts) {
	  assert$1("TSUndefinedKeyword", node, opts);
	}
	function assertTSUnknownKeyword(node, opts) {
	  assert$1("TSUnknownKeyword", node, opts);
	}
	function assertTSVoidKeyword(node, opts) {
	  assert$1("TSVoidKeyword", node, opts);
	}
	function assertTSThisType(node, opts) {
	  assert$1("TSThisType", node, opts);
	}
	function assertTSFunctionType(node, opts) {
	  assert$1("TSFunctionType", node, opts);
	}
	function assertTSConstructorType(node, opts) {
	  assert$1("TSConstructorType", node, opts);
	}
	function assertTSTypeReference(node, opts) {
	  assert$1("TSTypeReference", node, opts);
	}
	function assertTSTypePredicate(node, opts) {
	  assert$1("TSTypePredicate", node, opts);
	}
	function assertTSTypeQuery(node, opts) {
	  assert$1("TSTypeQuery", node, opts);
	}
	function assertTSTypeLiteral(node, opts) {
	  assert$1("TSTypeLiteral", node, opts);
	}
	function assertTSArrayType(node, opts) {
	  assert$1("TSArrayType", node, opts);
	}
	function assertTSTupleType(node, opts) {
	  assert$1("TSTupleType", node, opts);
	}
	function assertTSOptionalType(node, opts) {
	  assert$1("TSOptionalType", node, opts);
	}
	function assertTSRestType(node, opts) {
	  assert$1("TSRestType", node, opts);
	}
	function assertTSNamedTupleMember(node, opts) {
	  assert$1("TSNamedTupleMember", node, opts);
	}
	function assertTSUnionType(node, opts) {
	  assert$1("TSUnionType", node, opts);
	}
	function assertTSIntersectionType(node, opts) {
	  assert$1("TSIntersectionType", node, opts);
	}
	function assertTSConditionalType(node, opts) {
	  assert$1("TSConditionalType", node, opts);
	}
	function assertTSInferType(node, opts) {
	  assert$1("TSInferType", node, opts);
	}
	function assertTSParenthesizedType(node, opts) {
	  assert$1("TSParenthesizedType", node, opts);
	}
	function assertTSTypeOperator(node, opts) {
	  assert$1("TSTypeOperator", node, opts);
	}
	function assertTSIndexedAccessType(node, opts) {
	  assert$1("TSIndexedAccessType", node, opts);
	}
	function assertTSMappedType(node, opts) {
	  assert$1("TSMappedType", node, opts);
	}
	function assertTSLiteralType(node, opts) {
	  assert$1("TSLiteralType", node, opts);
	}
	function assertTSExpressionWithTypeArguments(node, opts) {
	  assert$1("TSExpressionWithTypeArguments", node, opts);
	}
	function assertTSInterfaceDeclaration(node, opts) {
	  assert$1("TSInterfaceDeclaration", node, opts);
	}
	function assertTSInterfaceBody(node, opts) {
	  assert$1("TSInterfaceBody", node, opts);
	}
	function assertTSTypeAliasDeclaration(node, opts) {
	  assert$1("TSTypeAliasDeclaration", node, opts);
	}
	function assertTSAsExpression(node, opts) {
	  assert$1("TSAsExpression", node, opts);
	}
	function assertTSTypeAssertion(node, opts) {
	  assert$1("TSTypeAssertion", node, opts);
	}
	function assertTSEnumDeclaration(node, opts) {
	  assert$1("TSEnumDeclaration", node, opts);
	}
	function assertTSEnumMember(node, opts) {
	  assert$1("TSEnumMember", node, opts);
	}
	function assertTSModuleDeclaration(node, opts) {
	  assert$1("TSModuleDeclaration", node, opts);
	}
	function assertTSModuleBlock(node, opts) {
	  assert$1("TSModuleBlock", node, opts);
	}
	function assertTSImportType(node, opts) {
	  assert$1("TSImportType", node, opts);
	}
	function assertTSImportEqualsDeclaration(node, opts) {
	  assert$1("TSImportEqualsDeclaration", node, opts);
	}
	function assertTSExternalModuleReference(node, opts) {
	  assert$1("TSExternalModuleReference", node, opts);
	}
	function assertTSNonNullExpression(node, opts) {
	  assert$1("TSNonNullExpression", node, opts);
	}
	function assertTSExportAssignment(node, opts) {
	  assert$1("TSExportAssignment", node, opts);
	}
	function assertTSNamespaceExportDeclaration(node, opts) {
	  assert$1("TSNamespaceExportDeclaration", node, opts);
	}
	function assertTSTypeAnnotation(node, opts) {
	  assert$1("TSTypeAnnotation", node, opts);
	}
	function assertTSTypeParameterInstantiation(node, opts) {
	  assert$1("TSTypeParameterInstantiation", node, opts);
	}
	function assertTSTypeParameterDeclaration(node, opts) {
	  assert$1("TSTypeParameterDeclaration", node, opts);
	}
	function assertTSTypeParameter(node, opts) {
	  assert$1("TSTypeParameter", node, opts);
	}
	function assertStandardized(node, opts) {
	  assert$1("Standardized", node, opts);
	}
	function assertExpression$1(node, opts) {
	  assert$1("Expression", node, opts);
	}
	function assertBinary(node, opts) {
	  assert$1("Binary", node, opts);
	}
	function assertScopable(node, opts) {
	  assert$1("Scopable", node, opts);
	}
	function assertBlockParent(node, opts) {
	  assert$1("BlockParent", node, opts);
	}
	function assertBlock(node, opts) {
	  assert$1("Block", node, opts);
	}
	function assertStatement(node, opts) {
	  assert$1("Statement", node, opts);
	}
	function assertTerminatorless(node, opts) {
	  assert$1("Terminatorless", node, opts);
	}
	function assertCompletionStatement(node, opts) {
	  assert$1("CompletionStatement", node, opts);
	}
	function assertConditional(node, opts) {
	  assert$1("Conditional", node, opts);
	}
	function assertLoop(node, opts) {
	  assert$1("Loop", node, opts);
	}
	function assertWhile(node, opts) {
	  assert$1("While", node, opts);
	}
	function assertExpressionWrapper(node, opts) {
	  assert$1("ExpressionWrapper", node, opts);
	}
	function assertFor(node, opts) {
	  assert$1("For", node, opts);
	}
	function assertForXStatement(node, opts) {
	  assert$1("ForXStatement", node, opts);
	}
	function assertFunction$1(node, opts) {
	  assert$1("Function", node, opts);
	}
	function assertFunctionParent(node, opts) {
	  assert$1("FunctionParent", node, opts);
	}
	function assertPureish(node, opts) {
	  assert$1("Pureish", node, opts);
	}
	function assertDeclaration(node, opts) {
	  assert$1("Declaration", node, opts);
	}
	function assertPatternLike(node, opts) {
	  assert$1("PatternLike", node, opts);
	}
	function assertLVal(node, opts) {
	  assert$1("LVal", node, opts);
	}
	function assertTSEntityName(node, opts) {
	  assert$1("TSEntityName", node, opts);
	}
	function assertLiteral(node, opts) {
	  assert$1("Literal", node, opts);
	}
	function assertImmutable(node, opts) {
	  assert$1("Immutable", node, opts);
	}
	function assertUserWhitespacable(node, opts) {
	  assert$1("UserWhitespacable", node, opts);
	}
	function assertMethod(node, opts) {
	  assert$1("Method", node, opts);
	}
	function assertObjectMember(node, opts) {
	  assert$1("ObjectMember", node, opts);
	}
	function assertProperty(node, opts) {
	  assert$1("Property", node, opts);
	}
	function assertUnaryLike(node, opts) {
	  assert$1("UnaryLike", node, opts);
	}
	function assertPattern(node, opts) {
	  assert$1("Pattern", node, opts);
	}
	function assertClass(node, opts) {
	  assert$1("Class", node, opts);
	}
	function assertModuleDeclaration(node, opts) {
	  assert$1("ModuleDeclaration", node, opts);
	}
	function assertExportDeclaration(node, opts) {
	  assert$1("ExportDeclaration", node, opts);
	}
	function assertModuleSpecifier(node, opts) {
	  assert$1("ModuleSpecifier", node, opts);
	}
	function assertAccessor(node, opts) {
	  assert$1("Accessor", node, opts);
	}
	function assertPrivate(node, opts) {
	  assert$1("Private", node, opts);
	}
	function assertFlow(node, opts) {
	  assert$1("Flow", node, opts);
	}
	function assertFlowType(node, opts) {
	  assert$1("FlowType", node, opts);
	}
	function assertFlowBaseAnnotation(node, opts) {
	  assert$1("FlowBaseAnnotation", node, opts);
	}
	function assertFlowDeclaration(node, opts) {
	  assert$1("FlowDeclaration", node, opts);
	}
	function assertFlowPredicate(node, opts) {
	  assert$1("FlowPredicate", node, opts);
	}
	function assertEnumBody(node, opts) {
	  assert$1("EnumBody", node, opts);
	}
	function assertEnumMember(node, opts) {
	  assert$1("EnumMember", node, opts);
	}
	function assertJSX(node, opts) {
	  assert$1("JSX", node, opts);
	}
	function assertMiscellaneous(node, opts) {
	  assert$1("Miscellaneous", node, opts);
	}
	function assertTypeScript(node, opts) {
	  assert$1("TypeScript", node, opts);
	}
	function assertTSTypeElement(node, opts) {
	  assert$1("TSTypeElement", node, opts);
	}
	function assertTSType(node, opts) {
	  assert$1("TSType", node, opts);
	}
	function assertTSBaseType(node, opts) {
	  assert$1("TSBaseType", node, opts);
	}
	function assertNumberLiteral(node, opts) {
	  console.trace("The node type NumberLiteral has been renamed to NumericLiteral");
	  assert$1("NumberLiteral", node, opts);
	}
	function assertRegexLiteral(node, opts) {
	  console.trace("The node type RegexLiteral has been renamed to RegExpLiteral");
	  assert$1("RegexLiteral", node, opts);
	}
	function assertRestProperty(node, opts) {
	  console.trace("The node type RestProperty has been renamed to RestElement");
	  assert$1("RestProperty", node, opts);
	}
	function assertSpreadProperty(node, opts) {
	  console.trace("The node type SpreadProperty has been renamed to SpreadElement");
	  assert$1("SpreadProperty", node, opts);
	}

	function createTypeAnnotationBasedOnTypeof$1(type) {
	  switch (type) {
	    case "string":
	      return stringTypeAnnotation$2();

	    case "number":
	      return numberTypeAnnotation$2();

	    case "undefined":
	      return voidTypeAnnotation$3();

	    case "boolean":
	      return booleanTypeAnnotation$1();

	    case "function":
	      return genericTypeAnnotation$1(identifier$e("Function"));

	    case "object":
	      return genericTypeAnnotation$1(identifier$e("Object"));

	    case "symbol":
	      return genericTypeAnnotation$1(identifier$e("Symbol"));

	    case "bigint":
	      return anyTypeAnnotation$2();
	  }

	  throw new Error("Invalid typeof value: " + type);
	}

	function getQualifiedName(node) {
	  return isIdentifier$c(node) ? node.name : `${node.id.name}.${getQualifiedName(node.qualification)}`;
	}

	function removeTypeDuplicates$1(nodes) {
	  const generics = {};
	  const bases = {};
	  const typeGroups = new Set();
	  const types = [];

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];
	    if (!node) continue;

	    if (types.indexOf(node) >= 0) {
	      continue;
	    }

	    if (isAnyTypeAnnotation$1(node)) {
	      return [node];
	    }

	    if (isFlowBaseAnnotation$1(node)) {
	      bases[node.type] = node;
	      continue;
	    }

	    if (isUnionTypeAnnotation$2(node)) {
	      if (!typeGroups.has(node.types)) {
	        nodes = nodes.concat(node.types);
	        typeGroups.add(node.types);
	      }

	      continue;
	    }

	    if (isGenericTypeAnnotation$1(node)) {
	      const name = getQualifiedName(node.id);

	      if (generics[name]) {
	        let existing = generics[name];

	        if (existing.typeParameters) {
	          if (node.typeParameters) {
	            existing.typeParameters.params = removeTypeDuplicates$1(existing.typeParameters.params.concat(node.typeParameters.params));
	          }
	        } else {
	          existing = node.typeParameters;
	        }
	      } else {
	        generics[name] = node;
	      }

	      continue;
	    }

	    types.push(node);
	  }

	  for (const type of Object.keys(bases)) {
	    types.push(bases[type]);
	  }

	  for (const name of Object.keys(generics)) {
	    types.push(generics[name]);
	  }

	  return types;
	}

	function createFlowUnionType$2(types) {
	  const flattened = removeTypeDuplicates$1(types);

	  if (flattened.length === 1) {
	    return flattened[0];
	  } else {
	    return unionTypeAnnotation$1(flattened);
	  }
	}

	function removeTypeDuplicates(nodes) {
	  const generics = {};
	  const bases = {};
	  const typeGroups = new Set();
	  const types = [];

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];
	    if (!node) continue;

	    if (types.indexOf(node) >= 0) {
	      continue;
	    }

	    if (isTSAnyKeyword(node)) {
	      return [node];
	    }

	    if (isTSBaseType(node)) {
	      bases[node.type] = node;
	      continue;
	    }

	    if (isTSUnionType$1(node)) {
	      if (!typeGroups.has(node.types)) {
	        nodes.push(...node.types);
	        typeGroups.add(node.types);
	      }

	      continue;
	    }

	    types.push(node);
	  }

	  for (const type of Object.keys(bases)) {
	    types.push(bases[type]);
	  }

	  for (const name of Object.keys(generics)) {
	    types.push(generics[name]);
	  }

	  return types;
	}

	function createTSUnionType$2(typeAnnotations) {
	  const types = typeAnnotations.map(type => type.typeAnnotation);
	  const flattened = removeTypeDuplicates(types);

	  if (flattened.length === 1) {
	    return flattened[0];
	  } else {
	    return tsUnionType(flattened);
	  }
	}

	const has$4 = Function.call.bind(Object.prototype.hasOwnProperty);

	function cloneIfNode(obj, deep, withoutLoc) {
	  if (obj && typeof obj.type === "string") {
	    return cloneNode$c(obj, deep, withoutLoc);
	  }

	  return obj;
	}

	function cloneIfNodeOrArray(obj, deep, withoutLoc) {
	  if (Array.isArray(obj)) {
	    return obj.map(node => cloneIfNode(node, deep, withoutLoc));
	  }

	  return cloneIfNode(obj, deep, withoutLoc);
	}

	function cloneNode$c(node, deep = true, withoutLoc = false) {
	  if (!node) return node;
	  const {
	    type
	  } = node;
	  const newNode = {
	    type: node.type
	  };

	  if (isIdentifier$c(node)) {
	    newNode.name = node.name;

	    if (has$4(node, "optional") && typeof node.optional === "boolean") {
	      newNode.optional = node.optional;
	    }

	    if (has$4(node, "typeAnnotation")) {
	      newNode.typeAnnotation = deep ? cloneIfNodeOrArray(node.typeAnnotation, true, withoutLoc) : node.typeAnnotation;
	    }
	  } else if (!has$4(NODE_FIELDS, type)) {
	    throw new Error(`Unknown node type: "${type}"`);
	  } else {
	    for (const field of Object.keys(NODE_FIELDS[type])) {
	      if (has$4(node, field)) {
	        if (deep) {
	          newNode[field] = isFile$1(node) && field === "comments" ? maybeCloneComments(node.comments, deep, withoutLoc) : cloneIfNodeOrArray(node[field], true, withoutLoc);
	        } else {
	          newNode[field] = node[field];
	        }
	      }
	    }
	  }

	  if (has$4(node, "loc")) {
	    if (withoutLoc) {
	      newNode.loc = null;
	    } else {
	      newNode.loc = node.loc;
	    }
	  }

	  if (has$4(node, "leadingComments")) {
	    newNode.leadingComments = maybeCloneComments(node.leadingComments, deep, withoutLoc);
	  }

	  if (has$4(node, "innerComments")) {
	    newNode.innerComments = maybeCloneComments(node.innerComments, deep, withoutLoc);
	  }

	  if (has$4(node, "trailingComments")) {
	    newNode.trailingComments = maybeCloneComments(node.trailingComments, deep, withoutLoc);
	  }

	  if (has$4(node, "extra")) {
	    newNode.extra = { ...node.extra
	    };
	  }

	  return newNode;
	}

	function maybeCloneComments(comments, deep, withoutLoc) {
	  if (!comments || !deep) {
	    return comments;
	  }

	  return comments.map(({
	    type,
	    value,
	    loc
	  }) => {
	    if (withoutLoc) {
	      return {
	        type,
	        value,
	        loc: null
	      };
	    }

	    return {
	      type,
	      value,
	      loc
	    };
	  });
	}

	function clone(node) {
	  return cloneNode$c(node, false);
	}

	function cloneDeep$1(node) {
	  return cloneNode$c(node);
	}

	function cloneDeepWithoutLoc(node) {
	  return cloneNode$c(node, true, true);
	}

	function cloneWithoutLoc(node) {
	  return cloneNode$c(node, false, true);
	}

	function addComments$1(node, type, comments) {
	  if (!comments || !node) return node;
	  const key = `${type}Comments`;

	  if (node[key]) {
	    if (type === "leading") {
	      node[key] = comments.concat(node[key]);
	    } else {
	      node[key].push(...comments);
	    }
	  } else {
	    node[key] = comments;
	  }

	  return node;
	}

	function addComment$2(node, type, content, line) {
	  return addComments$1(node, type, [{
	    type: line ? "CommentLine" : "CommentBlock",
	    value: content
	  }]);
	}

	function inherit(key, child, parent) {
	  if (child && parent) {
	    child[key] = Array.from(new Set([].concat(child[key], parent[key]).filter(Boolean)));
	  }
	}

	function inheritInnerComments(child, parent) {
	  inherit("innerComments", child, parent);
	}

	function inheritLeadingComments$1(child, parent) {
	  inherit("leadingComments", child, parent);
	}

	function inheritTrailingComments$1(child, parent) {
	  inherit("trailingComments", child, parent);
	}

	function inheritsComments$1(child, parent) {
	  inheritTrailingComments$1(child, parent);
	  inheritLeadingComments$1(child, parent);
	  inheritInnerComments(child, parent);
	  return child;
	}

	function removeComments$1(node) {
	  COMMENT_KEYS.forEach(key => {
	    node[key] = null;
	  });
	  return node;
	}

	const STANDARDIZED_TYPES = FLIPPED_ALIAS_KEYS$3["Standardized"];
	const EXPRESSION_TYPES = FLIPPED_ALIAS_KEYS$3["Expression"];
	const BINARY_TYPES = FLIPPED_ALIAS_KEYS$3["Binary"];
	const SCOPABLE_TYPES = FLIPPED_ALIAS_KEYS$3["Scopable"];
	const BLOCKPARENT_TYPES = FLIPPED_ALIAS_KEYS$3["BlockParent"];
	const BLOCK_TYPES = FLIPPED_ALIAS_KEYS$3["Block"];
	const STATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["Statement"];
	const TERMINATORLESS_TYPES = FLIPPED_ALIAS_KEYS$3["Terminatorless"];
	const COMPLETIONSTATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["CompletionStatement"];
	const CONDITIONAL_TYPES = FLIPPED_ALIAS_KEYS$3["Conditional"];
	const LOOP_TYPES = FLIPPED_ALIAS_KEYS$3["Loop"];
	const WHILE_TYPES = FLIPPED_ALIAS_KEYS$3["While"];
	const EXPRESSIONWRAPPER_TYPES = FLIPPED_ALIAS_KEYS$3["ExpressionWrapper"];
	const FOR_TYPES = FLIPPED_ALIAS_KEYS$3["For"];
	const FORXSTATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["ForXStatement"];
	const FUNCTION_TYPES$1 = FLIPPED_ALIAS_KEYS$3["Function"];
	const FUNCTIONPARENT_TYPES = FLIPPED_ALIAS_KEYS$3["FunctionParent"];
	const PUREISH_TYPES = FLIPPED_ALIAS_KEYS$3["Pureish"];
	const DECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["Declaration"];
	const PATTERNLIKE_TYPES = FLIPPED_ALIAS_KEYS$3["PatternLike"];
	const LVAL_TYPES = FLIPPED_ALIAS_KEYS$3["LVal"];
	const TSENTITYNAME_TYPES = FLIPPED_ALIAS_KEYS$3["TSEntityName"];
	const LITERAL_TYPES = FLIPPED_ALIAS_KEYS$3["Literal"];
	const IMMUTABLE_TYPES = FLIPPED_ALIAS_KEYS$3["Immutable"];
	const USERWHITESPACABLE_TYPES = FLIPPED_ALIAS_KEYS$3["UserWhitespacable"];
	const METHOD_TYPES = FLIPPED_ALIAS_KEYS$3["Method"];
	const OBJECTMEMBER_TYPES = FLIPPED_ALIAS_KEYS$3["ObjectMember"];
	const PROPERTY_TYPES = FLIPPED_ALIAS_KEYS$3["Property"];
	const UNARYLIKE_TYPES = FLIPPED_ALIAS_KEYS$3["UnaryLike"];
	const PATTERN_TYPES = FLIPPED_ALIAS_KEYS$3["Pattern"];
	const CLASS_TYPES = FLIPPED_ALIAS_KEYS$3["Class"];
	const MODULEDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["ModuleDeclaration"];
	const EXPORTDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["ExportDeclaration"];
	const MODULESPECIFIER_TYPES = FLIPPED_ALIAS_KEYS$3["ModuleSpecifier"];
	const ACCESSOR_TYPES = FLIPPED_ALIAS_KEYS$3["Accessor"];
	const PRIVATE_TYPES = FLIPPED_ALIAS_KEYS$3["Private"];
	const FLOW_TYPES = FLIPPED_ALIAS_KEYS$3["Flow"];
	const FLOWTYPE_TYPES = FLIPPED_ALIAS_KEYS$3["FlowType"];
	const FLOWBASEANNOTATION_TYPES = FLIPPED_ALIAS_KEYS$3["FlowBaseAnnotation"];
	const FLOWDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["FlowDeclaration"];
	const FLOWPREDICATE_TYPES = FLIPPED_ALIAS_KEYS$3["FlowPredicate"];
	const ENUMBODY_TYPES = FLIPPED_ALIAS_KEYS$3["EnumBody"];
	const ENUMMEMBER_TYPES = FLIPPED_ALIAS_KEYS$3["EnumMember"];
	const JSX_TYPES = FLIPPED_ALIAS_KEYS$3["JSX"];
	const MISCELLANEOUS_TYPES = FLIPPED_ALIAS_KEYS$3["Miscellaneous"];
	const TYPESCRIPT_TYPES = FLIPPED_ALIAS_KEYS$3["TypeScript"];
	const TSTYPEELEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["TSTypeElement"];
	const TSTYPE_TYPES = FLIPPED_ALIAS_KEYS$3["TSType"];
	const TSBASETYPE_TYPES = FLIPPED_ALIAS_KEYS$3["TSBaseType"];

	function toBlock(node, parent) {
	  if (isBlockStatement$2(node)) {
	    return node;
	  }

	  let blockNodes = [];

	  if (isEmptyStatement$1(node)) {
	    blockNodes = [];
	  } else {
	    if (!isStatement$7(node)) {
	      if (isFunction$5(parent)) {
	        node = returnStatement$2(node);
	      } else {
	        node = expressionStatement$7(node);
	      }
	    }

	    blockNodes = [node];
	  }

	  return blockStatement$5(blockNodes);
	}

	function ensureBlock$1(node, key = "body") {
	  return node[key] = toBlock(node[key], node);
	}

	function toIdentifier$1(input) {
	  input = input + "";
	  let name = "";

	  for (const c of input) {
	    name += isIdentifierChar(c.codePointAt(0)) ? c : "-";
	  }

	  name = name.replace(/^[-0-9]+/, "");
	  name = name.replace(/[-\s]+(.)?/g, function (match, c) {
	    return c ? c.toUpperCase() : "";
	  });

	  if (!isValidIdentifier(name)) {
	    name = `_${name}`;
	  }

	  return name || "_";
	}

	function toBindingIdentifierName$1(name) {
	  name = toIdentifier$1(name);
	  if (name === "eval" || name === "arguments") name = "_" + name;
	  return name;
	}

	function toComputedKey$1(node, key = node.key || node.property) {
	  if (!node.computed && isIdentifier$c(key)) key = stringLiteral$4(key.name);
	  return key;
	}

	function toExpression$2(node) {
	  if (isExpressionStatement$3(node)) {
	    node = node.expression;
	  }

	  if (isExpression$4(node)) {
	    return node;
	  }

	  if (isClass$1(node)) {
	    node.type = "ClassExpression";
	  } else if (isFunction$5(node)) {
	    node.type = "FunctionExpression";
	  }

	  if (!isExpression$4(node)) {
	    throw new Error(`cannot turn ${node.type} to an expression`);
	  }

	  return node;
	}

	function traverseFast$2(node, enter, opts) {
	  if (!node) return;
	  const keys = VISITOR_KEYS$7[node.type];
	  if (!keys) return;
	  opts = opts || {};
	  enter(node, opts);

	  for (const key of keys) {
	    const subNode = node[key];

	    if (Array.isArray(subNode)) {
	      for (const node of subNode) {
	        traverseFast$2(node, enter, opts);
	      }
	    } else {
	      traverseFast$2(subNode, enter, opts);
	    }
	  }
	}

	const CLEAR_KEYS = ["tokens", "start", "end", "loc", "raw", "rawValue"];
	const CLEAR_KEYS_PLUS_COMMENTS = COMMENT_KEYS.concat(["comments"]).concat(CLEAR_KEYS);
	function removeProperties$1(node, opts = {}) {
	  const map = opts.preserveComments ? CLEAR_KEYS : CLEAR_KEYS_PLUS_COMMENTS;

	  for (const key of map) {
	    if (node[key] != null) node[key] = undefined;
	  }

	  for (const key of Object.keys(node)) {
	    if (key[0] === "_" && node[key] != null) node[key] = undefined;
	  }

	  const symbols = Object.getOwnPropertySymbols(node);

	  for (const sym of symbols) {
	    node[sym] = null;
	  }
	}

	function removePropertiesDeep$1(tree, opts) {
	  traverseFast$2(tree, removeProperties$1, opts);
	  return tree;
	}

	function toKeyAlias(node, key = node.key) {
	  let alias;

	  if (node.kind === "method") {
	    return toKeyAlias.increment() + "";
	  } else if (isIdentifier$c(key)) {
	    alias = key.name;
	  } else if (isStringLiteral$4(key)) {
	    alias = JSON.stringify(key.value);
	  } else {
	    alias = JSON.stringify(removePropertiesDeep$1(cloneNode$c(key)));
	  }

	  if (node.computed) {
	    alias = `[${alias}]`;
	  }

	  if (node.static) {
	    alias = `static:${alias}`;
	  }

	  return alias;
	}
	toKeyAlias.uid = 0;

	toKeyAlias.increment = function () {
	  if (toKeyAlias.uid >= Number.MAX_SAFE_INTEGER) {
	    return toKeyAlias.uid = 0;
	  } else {
	    return toKeyAlias.uid++;
	  }
	};

	function getBindingIdentifiers$2(node, duplicates, outerOnly) {
	  let search = [].concat(node);
	  const ids = Object.create(null);

	  while (search.length) {
	    const id = search.shift();
	    if (!id) continue;
	    const keys = getBindingIdentifiers$2.keys[id.type];

	    if (isIdentifier$c(id)) {
	      if (duplicates) {
	        const _ids = ids[id.name] = ids[id.name] || [];

	        _ids.push(id);
	      } else {
	        ids[id.name] = id;
	      }

	      continue;
	    }

	    if (isExportDeclaration$2(id) && !isExportAllDeclaration$1(id)) {
	      if (isDeclaration$1(id.declaration)) {
	        search.push(id.declaration);
	      }

	      continue;
	    }

	    if (outerOnly) {
	      if (isFunctionDeclaration$1(id)) {
	        search.push(id.id);
	        continue;
	      }

	      if (isFunctionExpression(id)) {
	        continue;
	      }
	    }

	    if (keys) {
	      for (let i = 0; i < keys.length; i++) {
	        const key = keys[i];

	        if (id[key]) {
	          search = search.concat(id[key]);
	        }
	      }
	    }
	  }

	  return ids;
	}

	getBindingIdentifiers$2.keys = {
	  DeclareClass: ["id"],
	  DeclareFunction: ["id"],
	  DeclareModule: ["id"],
	  DeclareVariable: ["id"],
	  DeclareInterface: ["id"],
	  DeclareTypeAlias: ["id"],
	  DeclareOpaqueType: ["id"],
	  InterfaceDeclaration: ["id"],
	  TypeAlias: ["id"],
	  OpaqueType: ["id"],
	  CatchClause: ["param"],
	  LabeledStatement: ["label"],
	  UnaryExpression: ["argument"],
	  AssignmentExpression: ["left"],
	  ImportSpecifier: ["local"],
	  ImportNamespaceSpecifier: ["local"],
	  ImportDefaultSpecifier: ["local"],
	  ImportDeclaration: ["specifiers"],
	  ExportSpecifier: ["exported"],
	  ExportNamespaceSpecifier: ["exported"],
	  ExportDefaultSpecifier: ["exported"],
	  FunctionDeclaration: ["id", "params"],
	  FunctionExpression: ["id", "params"],
	  ArrowFunctionExpression: ["params"],
	  ObjectMethod: ["params"],
	  ClassMethod: ["params"],
	  ClassPrivateMethod: ["params"],
	  ForInStatement: ["left"],
	  ForOfStatement: ["left"],
	  ClassDeclaration: ["id"],
	  ClassExpression: ["id"],
	  RestElement: ["argument"],
	  UpdateExpression: ["argument"],
	  ObjectProperty: ["value"],
	  AssignmentPattern: ["left"],
	  ArrayPattern: ["elements"],
	  ObjectPattern: ["properties"],
	  VariableDeclaration: ["declarations"],
	  VariableDeclarator: ["id"]
	};

	function gatherSequenceExpressions(nodes, scope, declars) {
	  const exprs = [];
	  let ensureLastUndefined = true;

	  for (const node of nodes) {
	    if (!isEmptyStatement$1(node)) {
	      ensureLastUndefined = false;
	    }

	    if (isExpression$4(node)) {
	      exprs.push(node);
	    } else if (isExpressionStatement$3(node)) {
	      exprs.push(node.expression);
	    } else if (isVariableDeclaration$2(node)) {
	      if (node.kind !== "var") return;

	      for (const declar of node.declarations) {
	        const bindings = getBindingIdentifiers$2(declar);

	        for (const key of Object.keys(bindings)) {
	          declars.push({
	            kind: node.kind,
	            id: cloneNode$c(bindings[key])
	          });
	        }

	        if (declar.init) {
	          exprs.push(assignmentExpression$9("=", declar.id, declar.init));
	        }
	      }

	      ensureLastUndefined = true;
	    } else if (isIfStatement$2(node)) {
	      const consequent = node.consequent ? gatherSequenceExpressions([node.consequent], scope, declars) : scope.buildUndefinedNode();
	      const alternate = node.alternate ? gatherSequenceExpressions([node.alternate], scope, declars) : scope.buildUndefinedNode();
	      if (!consequent || !alternate) return;
	      exprs.push(conditionalExpression$3(node.test, consequent, alternate));
	    } else if (isBlockStatement$2(node)) {
	      const body = gatherSequenceExpressions(node.body, scope, declars);
	      if (!body) return;
	      exprs.push(body);
	    } else if (isEmptyStatement$1(node)) {
	      if (nodes.indexOf(node) === 0) {
	        ensureLastUndefined = true;
	      }
	    } else {
	      return;
	    }
	  }

	  if (ensureLastUndefined) {
	    exprs.push(scope.buildUndefinedNode());
	  }

	  if (exprs.length === 1) {
	    return exprs[0];
	  } else {
	    return sequenceExpression$3(exprs);
	  }
	}

	function toSequenceExpression$1(nodes, scope) {
	  if (!nodes?.length) return;
	  const declars = [];
	  const result = gatherSequenceExpressions(nodes, scope, declars);
	  if (!result) return;

	  for (const declar of declars) {
	    scope.push(declar);
	  }

	  return result;
	}

	function toStatement(node, ignore) {
	  if (isStatement$7(node)) {
	    return node;
	  }

	  let mustHaveId = false;
	  let newType;

	  if (isClass$1(node)) {
	    mustHaveId = true;
	    newType = "ClassDeclaration";
	  } else if (isFunction$5(node)) {
	    mustHaveId = true;
	    newType = "FunctionDeclaration";
	  } else if (isAssignmentExpression$4(node)) {
	    return expressionStatement$7(node);
	  }

	  if (mustHaveId && !node.id) {
	    newType = false;
	  }

	  if (!newType) {
	    if (ignore) {
	      return false;
	    } else {
	      throw new Error(`cannot turn ${node.type} to a statement`);
	    }
	  }

	  node.type = newType;
	  return node;
	}

	const objectToString = Function.call.bind(Object.prototype.toString);

	function isRegExp(value) {
	  return objectToString(value) === "[object RegExp]";
	}

	function isPlainObject(value) {
	  if (typeof value !== "object" || value === null || Object.prototype.toString.call(value) !== "[object Object]") {
	    return false;
	  }

	  const proto = Object.getPrototypeOf(value);
	  return proto === null || Object.getPrototypeOf(proto) === null;
	}

	function valueToNode(value) {
	  if (value === undefined) {
	    return identifier$e("undefined");
	  }

	  if (value === true || value === false) {
	    return booleanLiteral$2(value);
	  }

	  if (value === null) {
	    return nullLiteral$1();
	  }

	  if (typeof value === "string") {
	    return stringLiteral$4(value);
	  }

	  if (typeof value === "number") {
	    let result;

	    if (Number.isFinite(value)) {
	      result = numericLiteral$5(Math.abs(value));
	    } else {
	      let numerator;

	      if (Number.isNaN(value)) {
	        numerator = numericLiteral$5(0);
	      } else {
	        numerator = numericLiteral$5(1);
	      }

	      result = binaryExpression$3("/", numerator, numericLiteral$5(0));
	    }

	    if (value < 0 || Object.is(value, -0)) {
	      result = unaryExpression$6("-", result);
	    }

	    return result;
	  }

	  if (isRegExp(value)) {
	    const pattern = value.source;
	    const flags = value.toString().match(/\/([a-z]+|)$/)[1];
	    return regExpLiteral(pattern, flags);
	  }

	  if (Array.isArray(value)) {
	    return arrayExpression$1(value.map(valueToNode));
	  }

	  if (isPlainObject(value)) {
	    const props = [];

	    for (const key of Object.keys(value)) {
	      let nodeKey;

	      if (isValidIdentifier(key)) {
	        nodeKey = identifier$e(key);
	      } else {
	        nodeKey = stringLiteral$4(key);
	      }

	      props.push(objectProperty(nodeKey, valueToNode(value[key])));
	    }

	    return objectExpression$2(props);
	  }

	  throw new Error("don't know how to turn this value into a node");
	}

	function appendToMemberExpression(member, append, computed = false) {
	  member.object = memberExpression$6(member.object, member.property, member.computed);
	  member.property = append;
	  member.computed = !!computed;
	  return member;
	}

	function inherits(child, parent) {
	  if (!child || !parent) return child;

	  for (const key of INHERIT_KEYS.optional) {
	    if (child[key] == null) {
	      child[key] = parent[key];
	    }
	  }

	  for (const key of Object.keys(parent)) {
	    if (key[0] === "_" && key !== "__clone") child[key] = parent[key];
	  }

	  for (const key of INHERIT_KEYS.force) {
	    child[key] = parent[key];
	  }

	  inheritsComments$1(child, parent);
	  return child;
	}

	function prependToMemberExpression(member, prepend) {
	  member.object = memberExpression$6(prepend, member.object);
	  return member;
	}

	function getOuterBindingIdentifiers$1(node, duplicates) {
	  return getBindingIdentifiers$2(node, duplicates, true);
	}

	function traverse$2(node, handlers, state) {
	  if (typeof handlers === "function") {
	    handlers = {
	      enter: handlers
	    };
	  }

	  const {
	    enter,
	    exit
	  } = handlers;
	  traverseSimpleImpl(node, enter, exit, state, []);
	}

	function traverseSimpleImpl(node, enter, exit, state, ancestors) {
	  const keys = VISITOR_KEYS$7[node.type];
	  if (!keys) return;
	  if (enter) enter(node, ancestors, state);

	  for (const key of keys) {
	    const subNode = node[key];

	    if (Array.isArray(subNode)) {
	      for (let i = 0; i < subNode.length; i++) {
	        const child = subNode[i];
	        if (!child) continue;
	        ancestors.push({
	          node,
	          key,
	          index: i
	        });
	        traverseSimpleImpl(child, enter, exit, state, ancestors);
	        ancestors.pop();
	      }
	    } else if (subNode) {
	      ancestors.push({
	        node,
	        key
	      });
	      traverseSimpleImpl(subNode, enter, exit, state, ancestors);
	      ancestors.pop();
	    }
	  }

	  if (exit) exit(node, ancestors, state);
	}

	function isBinding$1(node, parent, grandparent) {
	  if (grandparent && node.type === "Identifier" && parent.type === "ObjectProperty" && grandparent.type === "ObjectExpression") {
	    return false;
	  }

	  const keys = getBindingIdentifiers$2.keys[parent.type];

	  if (keys) {
	    for (let i = 0; i < keys.length; i++) {
	      const key = keys[i];
	      const val = parent[key];

	      if (Array.isArray(val)) {
	        if (val.indexOf(node) >= 0) return true;
	      } else {
	        if (val === node) return true;
	      }
	    }
	  }

	  return false;
	}

	function isLet(node) {
	  return isVariableDeclaration$2(node) && (node.kind !== "var" || node[BLOCK_SCOPED_SYMBOL]);
	}

	function isBlockScoped$1(node) {
	  return isFunctionDeclaration$1(node) || isClassDeclaration$3(node) || isLet(node);
	}

	function isImmutable(node) {
	  if (isType$2(node.type, "Immutable")) return true;

	  if (isIdentifier$c(node)) {
	    if (node.name === "undefined") {
	      return true;
	    } else {
	      return false;
	    }
	  }

	  return false;
	}

	function isNodesEquivalent(a, b) {
	  if (typeof a !== "object" || typeof b !== "object" || a == null || b == null) {
	    return a === b;
	  }

	  if (a.type !== b.type) {
	    return false;
	  }

	  const fields = Object.keys(NODE_FIELDS[a.type] || a.type);
	  const visitorKeys = VISITOR_KEYS$7[a.type];

	  for (const field of fields) {
	    if (typeof a[field] !== typeof b[field]) {
	      return false;
	    }

	    if (a[field] == null && b[field] == null) {
	      continue;
	    } else if (a[field] == null || b[field] == null) {
	      return false;
	    }

	    if (Array.isArray(a[field])) {
	      if (!Array.isArray(b[field])) {
	        return false;
	      }

	      if (a[field].length !== b[field].length) {
	        return false;
	      }

	      for (let i = 0; i < a[field].length; i++) {
	        if (!isNodesEquivalent(a[field][i], b[field][i])) {
	          return false;
	        }
	      }

	      continue;
	    }

	    if (typeof a[field] === "object" && !visitorKeys?.includes(field)) {
	      for (const key of Object.keys(a[field])) {
	        if (a[field][key] !== b[field][key]) {
	          return false;
	        }
	      }

	      continue;
	    }

	    if (!isNodesEquivalent(a[field], b[field])) {
	      return false;
	    }
	  }

	  return true;
	}

	function isReferenced$1(node, parent, grandparent) {
	  switch (parent.type) {
	    case "MemberExpression":
	    case "OptionalMemberExpression":
	      if (parent.property === node) {
	        return !!parent.computed;
	      }

	      return parent.object === node;

	    case "JSXMemberExpression":
	      return parent.object === node;

	    case "VariableDeclarator":
	      return parent.init === node;

	    case "ArrowFunctionExpression":
	      return parent.body === node;

	    case "PrivateName":
	      return false;

	    case "ClassMethod":
	    case "ClassPrivateMethod":
	    case "ObjectMethod":
	      if (parent.key === node) {
	        return !!parent.computed;
	      }

	      return false;

	    case "ObjectProperty":
	      if (parent.key === node) {
	        return !!parent.computed;
	      }

	      return !grandparent || grandparent.type !== "ObjectPattern";

	    case "ClassProperty":
	    case "ClassAccessorProperty":
	      if (parent.key === node) {
	        return !!parent.computed;
	      }

	      return true;

	    case "ClassPrivateProperty":
	      return parent.key !== node;

	    case "ClassDeclaration":
	    case "ClassExpression":
	      return parent.superClass === node;

	    case "AssignmentExpression":
	      return parent.right === node;

	    case "AssignmentPattern":
	      return parent.right === node;

	    case "LabeledStatement":
	      return false;

	    case "CatchClause":
	      return false;

	    case "RestElement":
	      return false;

	    case "BreakStatement":
	    case "ContinueStatement":
	      return false;

	    case "FunctionDeclaration":
	    case "FunctionExpression":
	      return false;

	    case "ExportNamespaceSpecifier":
	    case "ExportDefaultSpecifier":
	      return false;

	    case "ExportSpecifier":
	      if (grandparent?.source) {
	        return false;
	      }

	      return parent.local === node;

	    case "ImportDefaultSpecifier":
	    case "ImportNamespaceSpecifier":
	    case "ImportSpecifier":
	      return false;

	    case "ImportAttribute":
	      return false;

	    case "JSXAttribute":
	      return false;

	    case "ObjectPattern":
	    case "ArrayPattern":
	      return false;

	    case "MetaProperty":
	      return false;

	    case "ObjectTypeProperty":
	      return parent.key !== node;

	    case "TSEnumMember":
	      return parent.id !== node;

	    case "TSPropertySignature":
	      if (parent.key === node) {
	        return !!parent.computed;
	      }

	      return true;
	  }

	  return true;
	}

	function isScope$1(node, parent) {
	  if (isBlockStatement$2(node) && (isFunction$5(parent) || isCatchClause(parent))) {
	    return false;
	  }

	  if (isPattern(node) && (isFunction$5(parent) || isCatchClause(parent))) {
	    return true;
	  }

	  return isScopable(node);
	}

	function isSpecifierDefault(specifier) {
	  return isImportDefaultSpecifier$1(specifier) || isIdentifier$c(specifier.imported || specifier.exported, {
	    name: "default"
	  });
	}

	const RESERVED_WORDS_ES3_ONLY = new Set(["abstract", "boolean", "byte", "char", "double", "enum", "final", "float", "goto", "implements", "int", "interface", "long", "native", "package", "private", "protected", "public", "short", "static", "synchronized", "throws", "transient", "volatile"]);
	function isValidES3Identifier(name) {
	  return isValidIdentifier(name) && !RESERVED_WORDS_ES3_ONLY.has(name);
	}

	function isVar$1(node) {
	  return isVariableDeclaration$2(node, {
	    kind: "var"
	  }) && !node[BLOCK_SCOPED_SYMBOL];
	}

	const react$2 = {
	  isReactComponent,
	  isCompatTag: isCompatTag$1,
	  buildChildren
	};

	var _t = /*#__PURE__*/Object.freeze({
		__proto__: null,
		react: react$2,
		assertNode: assertNode,
		createTypeAnnotationBasedOnTypeof: createTypeAnnotationBasedOnTypeof$1,
		createUnionTypeAnnotation: createFlowUnionType$2,
		createFlowUnionType: createFlowUnionType$2,
		createTSUnionType: createTSUnionType$2,
		cloneNode: cloneNode$c,
		clone: clone,
		cloneDeep: cloneDeep$1,
		cloneDeepWithoutLoc: cloneDeepWithoutLoc,
		cloneWithoutLoc: cloneWithoutLoc,
		addComment: addComment$2,
		addComments: addComments$1,
		inheritInnerComments: inheritInnerComments,
		inheritLeadingComments: inheritLeadingComments$1,
		inheritsComments: inheritsComments$1,
		inheritTrailingComments: inheritTrailingComments$1,
		removeComments: removeComments$1,
		ensureBlock: ensureBlock$1,
		toBindingIdentifierName: toBindingIdentifierName$1,
		toBlock: toBlock,
		toComputedKey: toComputedKey$1,
		toExpression: toExpression$2,
		toIdentifier: toIdentifier$1,
		toKeyAlias: toKeyAlias,
		toSequenceExpression: toSequenceExpression$1,
		toStatement: toStatement,
		valueToNode: valueToNode,
		appendToMemberExpression: appendToMemberExpression,
		inherits: inherits,
		prependToMemberExpression: prependToMemberExpression,
		removeProperties: removeProperties$1,
		removePropertiesDeep: removePropertiesDeep$1,
		removeTypeDuplicates: removeTypeDuplicates$1,
		getBindingIdentifiers: getBindingIdentifiers$2,
		getOuterBindingIdentifiers: getOuterBindingIdentifiers$1,
		traverse: traverse$2,
		traverseFast: traverseFast$2,
		shallowEqual: shallowEqual,
		is: is$1,
		isBinding: isBinding$1,
		isBlockScoped: isBlockScoped$1,
		isImmutable: isImmutable,
		isLet: isLet,
		isNode: isNode,
		isNodesEquivalent: isNodesEquivalent,
		isPlaceholderType: isPlaceholderType,
		isReferenced: isReferenced$1,
		isScope: isScope$1,
		isSpecifierDefault: isSpecifierDefault,
		isType: isType$2,
		isValidES3Identifier: isValidES3Identifier,
		isValidIdentifier: isValidIdentifier,
		isVar: isVar$1,
		matchesPattern: matchesPattern$2,
		validate: validate$6,
		buildMatchMemberExpression: buildMatchMemberExpression$1,
		assertArrayExpression: assertArrayExpression,
		assertAssignmentExpression: assertAssignmentExpression,
		assertBinaryExpression: assertBinaryExpression,
		assertInterpreterDirective: assertInterpreterDirective,
		assertDirective: assertDirective,
		assertDirectiveLiteral: assertDirectiveLiteral,
		assertBlockStatement: assertBlockStatement,
		assertBreakStatement: assertBreakStatement,
		assertCallExpression: assertCallExpression,
		assertCatchClause: assertCatchClause,
		assertConditionalExpression: assertConditionalExpression,
		assertContinueStatement: assertContinueStatement,
		assertDebuggerStatement: assertDebuggerStatement,
		assertDoWhileStatement: assertDoWhileStatement,
		assertEmptyStatement: assertEmptyStatement,
		assertExpressionStatement: assertExpressionStatement$1,
		assertFile: assertFile,
		assertForInStatement: assertForInStatement,
		assertForStatement: assertForStatement,
		assertFunctionDeclaration: assertFunctionDeclaration,
		assertFunctionExpression: assertFunctionExpression,
		assertIdentifier: assertIdentifier,
		assertIfStatement: assertIfStatement,
		assertLabeledStatement: assertLabeledStatement,
		assertStringLiteral: assertStringLiteral,
		assertNumericLiteral: assertNumericLiteral,
		assertNullLiteral: assertNullLiteral,
		assertBooleanLiteral: assertBooleanLiteral,
		assertRegExpLiteral: assertRegExpLiteral,
		assertLogicalExpression: assertLogicalExpression,
		assertMemberExpression: assertMemberExpression,
		assertNewExpression: assertNewExpression,
		assertProgram: assertProgram,
		assertObjectExpression: assertObjectExpression,
		assertObjectMethod: assertObjectMethod,
		assertObjectProperty: assertObjectProperty,
		assertRestElement: assertRestElement,
		assertReturnStatement: assertReturnStatement,
		assertSequenceExpression: assertSequenceExpression,
		assertParenthesizedExpression: assertParenthesizedExpression,
		assertSwitchCase: assertSwitchCase,
		assertSwitchStatement: assertSwitchStatement,
		assertThisExpression: assertThisExpression,
		assertThrowStatement: assertThrowStatement,
		assertTryStatement: assertTryStatement,
		assertUnaryExpression: assertUnaryExpression,
		assertUpdateExpression: assertUpdateExpression,
		assertVariableDeclaration: assertVariableDeclaration,
		assertVariableDeclarator: assertVariableDeclarator,
		assertWhileStatement: assertWhileStatement,
		assertWithStatement: assertWithStatement,
		assertAssignmentPattern: assertAssignmentPattern,
		assertArrayPattern: assertArrayPattern,
		assertArrowFunctionExpression: assertArrowFunctionExpression,
		assertClassBody: assertClassBody,
		assertClassExpression: assertClassExpression,
		assertClassDeclaration: assertClassDeclaration,
		assertExportAllDeclaration: assertExportAllDeclaration,
		assertExportDefaultDeclaration: assertExportDefaultDeclaration,
		assertExportNamedDeclaration: assertExportNamedDeclaration,
		assertExportSpecifier: assertExportSpecifier,
		assertForOfStatement: assertForOfStatement,
		assertImportDeclaration: assertImportDeclaration,
		assertImportDefaultSpecifier: assertImportDefaultSpecifier,
		assertImportNamespaceSpecifier: assertImportNamespaceSpecifier,
		assertImportSpecifier: assertImportSpecifier,
		assertMetaProperty: assertMetaProperty,
		assertClassMethod: assertClassMethod,
		assertObjectPattern: assertObjectPattern,
		assertSpreadElement: assertSpreadElement,
		assertSuper: assertSuper,
		assertTaggedTemplateExpression: assertTaggedTemplateExpression,
		assertTemplateElement: assertTemplateElement,
		assertTemplateLiteral: assertTemplateLiteral,
		assertYieldExpression: assertYieldExpression,
		assertAwaitExpression: assertAwaitExpression,
		assertImport: assertImport,
		assertBigIntLiteral: assertBigIntLiteral,
		assertExportNamespaceSpecifier: assertExportNamespaceSpecifier,
		assertOptionalMemberExpression: assertOptionalMemberExpression,
		assertOptionalCallExpression: assertOptionalCallExpression,
		assertClassProperty: assertClassProperty,
		assertClassAccessorProperty: assertClassAccessorProperty,
		assertClassPrivateProperty: assertClassPrivateProperty,
		assertClassPrivateMethod: assertClassPrivateMethod,
		assertPrivateName: assertPrivateName,
		assertStaticBlock: assertStaticBlock,
		assertAnyTypeAnnotation: assertAnyTypeAnnotation,
		assertArrayTypeAnnotation: assertArrayTypeAnnotation,
		assertBooleanTypeAnnotation: assertBooleanTypeAnnotation,
		assertBooleanLiteralTypeAnnotation: assertBooleanLiteralTypeAnnotation,
		assertNullLiteralTypeAnnotation: assertNullLiteralTypeAnnotation,
		assertClassImplements: assertClassImplements,
		assertDeclareClass: assertDeclareClass,
		assertDeclareFunction: assertDeclareFunction,
		assertDeclareInterface: assertDeclareInterface,
		assertDeclareModule: assertDeclareModule,
		assertDeclareModuleExports: assertDeclareModuleExports,
		assertDeclareTypeAlias: assertDeclareTypeAlias,
		assertDeclareOpaqueType: assertDeclareOpaqueType,
		assertDeclareVariable: assertDeclareVariable,
		assertDeclareExportDeclaration: assertDeclareExportDeclaration,
		assertDeclareExportAllDeclaration: assertDeclareExportAllDeclaration,
		assertDeclaredPredicate: assertDeclaredPredicate,
		assertExistsTypeAnnotation: assertExistsTypeAnnotation,
		assertFunctionTypeAnnotation: assertFunctionTypeAnnotation,
		assertFunctionTypeParam: assertFunctionTypeParam,
		assertGenericTypeAnnotation: assertGenericTypeAnnotation,
		assertInferredPredicate: assertInferredPredicate,
		assertInterfaceExtends: assertInterfaceExtends,
		assertInterfaceDeclaration: assertInterfaceDeclaration,
		assertInterfaceTypeAnnotation: assertInterfaceTypeAnnotation,
		assertIntersectionTypeAnnotation: assertIntersectionTypeAnnotation,
		assertMixedTypeAnnotation: assertMixedTypeAnnotation,
		assertEmptyTypeAnnotation: assertEmptyTypeAnnotation,
		assertNullableTypeAnnotation: assertNullableTypeAnnotation,
		assertNumberLiteralTypeAnnotation: assertNumberLiteralTypeAnnotation,
		assertNumberTypeAnnotation: assertNumberTypeAnnotation,
		assertObjectTypeAnnotation: assertObjectTypeAnnotation,
		assertObjectTypeInternalSlot: assertObjectTypeInternalSlot,
		assertObjectTypeCallProperty: assertObjectTypeCallProperty,
		assertObjectTypeIndexer: assertObjectTypeIndexer,
		assertObjectTypeProperty: assertObjectTypeProperty,
		assertObjectTypeSpreadProperty: assertObjectTypeSpreadProperty,
		assertOpaqueType: assertOpaqueType,
		assertQualifiedTypeIdentifier: assertQualifiedTypeIdentifier,
		assertStringLiteralTypeAnnotation: assertStringLiteralTypeAnnotation,
		assertStringTypeAnnotation: assertStringTypeAnnotation,
		assertSymbolTypeAnnotation: assertSymbolTypeAnnotation,
		assertThisTypeAnnotation: assertThisTypeAnnotation,
		assertTupleTypeAnnotation: assertTupleTypeAnnotation,
		assertTypeofTypeAnnotation: assertTypeofTypeAnnotation,
		assertTypeAlias: assertTypeAlias,
		assertTypeAnnotation: assertTypeAnnotation,
		assertTypeCastExpression: assertTypeCastExpression,
		assertTypeParameter: assertTypeParameter,
		assertTypeParameterDeclaration: assertTypeParameterDeclaration,
		assertTypeParameterInstantiation: assertTypeParameterInstantiation,
		assertUnionTypeAnnotation: assertUnionTypeAnnotation,
		assertVariance: assertVariance,
		assertVoidTypeAnnotation: assertVoidTypeAnnotation,
		assertEnumDeclaration: assertEnumDeclaration,
		assertEnumBooleanBody: assertEnumBooleanBody,
		assertEnumNumberBody: assertEnumNumberBody,
		assertEnumStringBody: assertEnumStringBody,
		assertEnumSymbolBody: assertEnumSymbolBody,
		assertEnumBooleanMember: assertEnumBooleanMember,
		assertEnumNumberMember: assertEnumNumberMember,
		assertEnumStringMember: assertEnumStringMember,
		assertEnumDefaultedMember: assertEnumDefaultedMember,
		assertIndexedAccessType: assertIndexedAccessType,
		assertOptionalIndexedAccessType: assertOptionalIndexedAccessType,
		assertJSXAttribute: assertJSXAttribute,
		assertJSXClosingElement: assertJSXClosingElement,
		assertJSXElement: assertJSXElement,
		assertJSXEmptyExpression: assertJSXEmptyExpression,
		assertJSXExpressionContainer: assertJSXExpressionContainer,
		assertJSXSpreadChild: assertJSXSpreadChild,
		assertJSXIdentifier: assertJSXIdentifier,
		assertJSXMemberExpression: assertJSXMemberExpression,
		assertJSXNamespacedName: assertJSXNamespacedName,
		assertJSXOpeningElement: assertJSXOpeningElement,
		assertJSXSpreadAttribute: assertJSXSpreadAttribute,
		assertJSXText: assertJSXText,
		assertJSXFragment: assertJSXFragment,
		assertJSXOpeningFragment: assertJSXOpeningFragment,
		assertJSXClosingFragment: assertJSXClosingFragment,
		assertNoop: assertNoop,
		assertPlaceholder: assertPlaceholder,
		assertV8IntrinsicIdentifier: assertV8IntrinsicIdentifier,
		assertArgumentPlaceholder: assertArgumentPlaceholder,
		assertBindExpression: assertBindExpression,
		assertImportAttribute: assertImportAttribute,
		assertDecorator: assertDecorator,
		assertDoExpression: assertDoExpression,
		assertExportDefaultSpecifier: assertExportDefaultSpecifier,
		assertRecordExpression: assertRecordExpression,
		assertTupleExpression: assertTupleExpression,
		assertDecimalLiteral: assertDecimalLiteral,
		assertModuleExpression: assertModuleExpression,
		assertTopicReference: assertTopicReference,
		assertPipelineTopicExpression: assertPipelineTopicExpression,
		assertPipelineBareFunction: assertPipelineBareFunction,
		assertPipelinePrimaryTopicReference: assertPipelinePrimaryTopicReference,
		assertTSParameterProperty: assertTSParameterProperty,
		assertTSDeclareFunction: assertTSDeclareFunction,
		assertTSDeclareMethod: assertTSDeclareMethod,
		assertTSQualifiedName: assertTSQualifiedName,
		assertTSCallSignatureDeclaration: assertTSCallSignatureDeclaration,
		assertTSConstructSignatureDeclaration: assertTSConstructSignatureDeclaration,
		assertTSPropertySignature: assertTSPropertySignature,
		assertTSMethodSignature: assertTSMethodSignature,
		assertTSIndexSignature: assertTSIndexSignature,
		assertTSAnyKeyword: assertTSAnyKeyword,
		assertTSBooleanKeyword: assertTSBooleanKeyword,
		assertTSBigIntKeyword: assertTSBigIntKeyword,
		assertTSIntrinsicKeyword: assertTSIntrinsicKeyword,
		assertTSNeverKeyword: assertTSNeverKeyword,
		assertTSNullKeyword: assertTSNullKeyword,
		assertTSNumberKeyword: assertTSNumberKeyword,
		assertTSObjectKeyword: assertTSObjectKeyword,
		assertTSStringKeyword: assertTSStringKeyword,
		assertTSSymbolKeyword: assertTSSymbolKeyword,
		assertTSUndefinedKeyword: assertTSUndefinedKeyword,
		assertTSUnknownKeyword: assertTSUnknownKeyword,
		assertTSVoidKeyword: assertTSVoidKeyword,
		assertTSThisType: assertTSThisType,
		assertTSFunctionType: assertTSFunctionType,
		assertTSConstructorType: assertTSConstructorType,
		assertTSTypeReference: assertTSTypeReference,
		assertTSTypePredicate: assertTSTypePredicate,
		assertTSTypeQuery: assertTSTypeQuery,
		assertTSTypeLiteral: assertTSTypeLiteral,
		assertTSArrayType: assertTSArrayType,
		assertTSTupleType: assertTSTupleType,
		assertTSOptionalType: assertTSOptionalType,
		assertTSRestType: assertTSRestType,
		assertTSNamedTupleMember: assertTSNamedTupleMember,
		assertTSUnionType: assertTSUnionType,
		assertTSIntersectionType: assertTSIntersectionType,
		assertTSConditionalType: assertTSConditionalType,
		assertTSInferType: assertTSInferType,
		assertTSParenthesizedType: assertTSParenthesizedType,
		assertTSTypeOperator: assertTSTypeOperator,
		assertTSIndexedAccessType: assertTSIndexedAccessType,
		assertTSMappedType: assertTSMappedType,
		assertTSLiteralType: assertTSLiteralType,
		assertTSExpressionWithTypeArguments: assertTSExpressionWithTypeArguments,
		assertTSInterfaceDeclaration: assertTSInterfaceDeclaration,
		assertTSInterfaceBody: assertTSInterfaceBody,
		assertTSTypeAliasDeclaration: assertTSTypeAliasDeclaration,
		assertTSAsExpression: assertTSAsExpression,
		assertTSTypeAssertion: assertTSTypeAssertion,
		assertTSEnumDeclaration: assertTSEnumDeclaration,
		assertTSEnumMember: assertTSEnumMember,
		assertTSModuleDeclaration: assertTSModuleDeclaration,
		assertTSModuleBlock: assertTSModuleBlock,
		assertTSImportType: assertTSImportType,
		assertTSImportEqualsDeclaration: assertTSImportEqualsDeclaration,
		assertTSExternalModuleReference: assertTSExternalModuleReference,
		assertTSNonNullExpression: assertTSNonNullExpression,
		assertTSExportAssignment: assertTSExportAssignment,
		assertTSNamespaceExportDeclaration: assertTSNamespaceExportDeclaration,
		assertTSTypeAnnotation: assertTSTypeAnnotation,
		assertTSTypeParameterInstantiation: assertTSTypeParameterInstantiation,
		assertTSTypeParameterDeclaration: assertTSTypeParameterDeclaration,
		assertTSTypeParameter: assertTSTypeParameter,
		assertStandardized: assertStandardized,
		assertExpression: assertExpression$1,
		assertBinary: assertBinary,
		assertScopable: assertScopable,
		assertBlockParent: assertBlockParent,
		assertBlock: assertBlock,
		assertStatement: assertStatement,
		assertTerminatorless: assertTerminatorless,
		assertCompletionStatement: assertCompletionStatement,
		assertConditional: assertConditional,
		assertLoop: assertLoop,
		assertWhile: assertWhile,
		assertExpressionWrapper: assertExpressionWrapper,
		assertFor: assertFor,
		assertForXStatement: assertForXStatement,
		assertFunction: assertFunction$1,
		assertFunctionParent: assertFunctionParent,
		assertPureish: assertPureish,
		assertDeclaration: assertDeclaration,
		assertPatternLike: assertPatternLike,
		assertLVal: assertLVal,
		assertTSEntityName: assertTSEntityName,
		assertLiteral: assertLiteral,
		assertImmutable: assertImmutable,
		assertUserWhitespacable: assertUserWhitespacable,
		assertMethod: assertMethod,
		assertObjectMember: assertObjectMember,
		assertProperty: assertProperty,
		assertUnaryLike: assertUnaryLike,
		assertPattern: assertPattern,
		assertClass: assertClass,
		assertModuleDeclaration: assertModuleDeclaration,
		assertExportDeclaration: assertExportDeclaration,
		assertModuleSpecifier: assertModuleSpecifier,
		assertAccessor: assertAccessor,
		assertPrivate: assertPrivate,
		assertFlow: assertFlow,
		assertFlowType: assertFlowType,
		assertFlowBaseAnnotation: assertFlowBaseAnnotation,
		assertFlowDeclaration: assertFlowDeclaration,
		assertFlowPredicate: assertFlowPredicate,
		assertEnumBody: assertEnumBody,
		assertEnumMember: assertEnumMember,
		assertJSX: assertJSX,
		assertMiscellaneous: assertMiscellaneous,
		assertTypeScript: assertTypeScript,
		assertTSTypeElement: assertTSTypeElement,
		assertTSType: assertTSType,
		assertTSBaseType: assertTSBaseType,
		assertNumberLiteral: assertNumberLiteral,
		assertRegexLiteral: assertRegexLiteral,
		assertRestProperty: assertRestProperty,
		assertSpreadProperty: assertSpreadProperty,
		arrayExpression: arrayExpression$1,
		assignmentExpression: assignmentExpression$9,
		binaryExpression: binaryExpression$3,
		interpreterDirective: interpreterDirective$1,
		directive: directive,
		directiveLiteral: directiveLiteral,
		blockStatement: blockStatement$5,
		breakStatement: breakStatement,
		callExpression: callExpression$8,
		catchClause: catchClause,
		conditionalExpression: conditionalExpression$3,
		continueStatement: continueStatement,
		debuggerStatement: debuggerStatement,
		doWhileStatement: doWhileStatement,
		emptyStatement: emptyStatement$1,
		expressionStatement: expressionStatement$7,
		file: file$1,
		forInStatement: forInStatement,
		forStatement: forStatement,
		functionDeclaration: functionDeclaration,
		functionExpression: functionExpression$1,
		identifier: identifier$e,
		ifStatement: ifStatement,
		labeledStatement: labeledStatement,
		stringLiteral: stringLiteral$4,
		numericLiteral: numericLiteral$5,
		nullLiteral: nullLiteral$1,
		booleanLiteral: booleanLiteral$2,
		regExpLiteral: regExpLiteral,
		logicalExpression: logicalExpression$2,
		memberExpression: memberExpression$6,
		newExpression: newExpression,
		program: program$3,
		objectExpression: objectExpression$2,
		objectMethod: objectMethod,
		objectProperty: objectProperty,
		restElement: restElement$1,
		returnStatement: returnStatement$2,
		sequenceExpression: sequenceExpression$3,
		parenthesizedExpression: parenthesizedExpression,
		switchCase: switchCase,
		switchStatement: switchStatement,
		thisExpression: thisExpression$3,
		throwStatement: throwStatement,
		tryStatement: tryStatement,
		unaryExpression: unaryExpression$6,
		updateExpression: updateExpression,
		variableDeclaration: variableDeclaration$6,
		variableDeclarator: variableDeclarator$6,
		whileStatement: whileStatement,
		withStatement: withStatement,
		assignmentPattern: assignmentPattern,
		arrayPattern: arrayPattern,
		arrowFunctionExpression: arrowFunctionExpression$4,
		classBody: classBody,
		classExpression: classExpression,
		classDeclaration: classDeclaration,
		exportAllDeclaration: exportAllDeclaration,
		exportDefaultDeclaration: exportDefaultDeclaration,
		exportNamedDeclaration: exportNamedDeclaration$2,
		exportSpecifier: exportSpecifier$2,
		forOfStatement: forOfStatement,
		importDeclaration: importDeclaration,
		importDefaultSpecifier: importDefaultSpecifier,
		importNamespaceSpecifier: importNamespaceSpecifier,
		importSpecifier: importSpecifier,
		metaProperty: metaProperty$1,
		classMethod: classMethod,
		objectPattern: objectPattern,
		spreadElement: spreadElement$1,
		'super': _super$1,
		taggedTemplateExpression: taggedTemplateExpression,
		templateElement: templateElement,
		templateLiteral: templateLiteral,
		yieldExpression: yieldExpression$1,
		awaitExpression: awaitExpression$1,
		'import': _import,
		bigIntLiteral: bigIntLiteral,
		exportNamespaceSpecifier: exportNamespaceSpecifier,
		optionalMemberExpression: optionalMemberExpression$2,
		optionalCallExpression: optionalCallExpression$2,
		classProperty: classProperty,
		classAccessorProperty: classAccessorProperty,
		classPrivateProperty: classPrivateProperty,
		classPrivateMethod: classPrivateMethod,
		privateName: privateName,
		staticBlock: staticBlock$1,
		anyTypeAnnotation: anyTypeAnnotation$2,
		arrayTypeAnnotation: arrayTypeAnnotation$1,
		booleanTypeAnnotation: booleanTypeAnnotation$1,
		booleanLiteralTypeAnnotation: booleanLiteralTypeAnnotation,
		nullLiteralTypeAnnotation: nullLiteralTypeAnnotation$1,
		classImplements: classImplements,
		declareClass: declareClass,
		declareFunction: declareFunction,
		declareInterface: declareInterface,
		declareModule: declareModule,
		declareModuleExports: declareModuleExports,
		declareTypeAlias: declareTypeAlias,
		declareOpaqueType: declareOpaqueType,
		declareVariable: declareVariable,
		declareExportDeclaration: declareExportDeclaration,
		declareExportAllDeclaration: declareExportAllDeclaration,
		declaredPredicate: declaredPredicate,
		existsTypeAnnotation: existsTypeAnnotation,
		functionTypeAnnotation: functionTypeAnnotation,
		functionTypeParam: functionTypeParam,
		genericTypeAnnotation: genericTypeAnnotation$1,
		inferredPredicate: inferredPredicate,
		interfaceExtends: interfaceExtends,
		interfaceDeclaration: interfaceDeclaration,
		interfaceTypeAnnotation: interfaceTypeAnnotation,
		intersectionTypeAnnotation: intersectionTypeAnnotation,
		mixedTypeAnnotation: mixedTypeAnnotation,
		emptyTypeAnnotation: emptyTypeAnnotation,
		nullableTypeAnnotation: nullableTypeAnnotation,
		numberLiteralTypeAnnotation: numberLiteralTypeAnnotation,
		numberTypeAnnotation: numberTypeAnnotation$2,
		objectTypeAnnotation: objectTypeAnnotation,
		objectTypeInternalSlot: objectTypeInternalSlot,
		objectTypeCallProperty: objectTypeCallProperty,
		objectTypeIndexer: objectTypeIndexer,
		objectTypeProperty: objectTypeProperty,
		objectTypeSpreadProperty: objectTypeSpreadProperty,
		opaqueType: opaqueType,
		qualifiedTypeIdentifier: qualifiedTypeIdentifier,
		stringLiteralTypeAnnotation: stringLiteralTypeAnnotation,
		stringTypeAnnotation: stringTypeAnnotation$2,
		symbolTypeAnnotation: symbolTypeAnnotation,
		thisTypeAnnotation: thisTypeAnnotation,
		tupleTypeAnnotation: tupleTypeAnnotation$1,
		typeofTypeAnnotation: typeofTypeAnnotation,
		typeAlias: typeAlias,
		typeAnnotation: typeAnnotation,
		typeCastExpression: typeCastExpression,
		typeParameter: typeParameter,
		typeParameterDeclaration: typeParameterDeclaration,
		typeParameterInstantiation: typeParameterInstantiation,
		unionTypeAnnotation: unionTypeAnnotation$1,
		variance: variance,
		voidTypeAnnotation: voidTypeAnnotation$3,
		enumDeclaration: enumDeclaration,
		enumBooleanBody: enumBooleanBody,
		enumNumberBody: enumNumberBody,
		enumStringBody: enumStringBody,
		enumSymbolBody: enumSymbolBody,
		enumBooleanMember: enumBooleanMember,
		enumNumberMember: enumNumberMember,
		enumStringMember: enumStringMember,
		enumDefaultedMember: enumDefaultedMember,
		indexedAccessType: indexedAccessType,
		optionalIndexedAccessType: optionalIndexedAccessType,
		jsxAttribute: jsxAttribute,
		jSXAttribute: jsxAttribute,
		jsxClosingElement: jsxClosingElement,
		jSXClosingElement: jsxClosingElement,
		jsxElement: jsxElement,
		jSXElement: jsxElement,
		jsxEmptyExpression: jsxEmptyExpression,
		jSXEmptyExpression: jsxEmptyExpression,
		jsxExpressionContainer: jsxExpressionContainer$1,
		jSXExpressionContainer: jsxExpressionContainer$1,
		jsxSpreadChild: jsxSpreadChild,
		jSXSpreadChild: jsxSpreadChild,
		jsxIdentifier: jsxIdentifier$1,
		jSXIdentifier: jsxIdentifier$1,
		jsxMemberExpression: jsxMemberExpression,
		jSXMemberExpression: jsxMemberExpression,
		jsxNamespacedName: jsxNamespacedName,
		jSXNamespacedName: jsxNamespacedName,
		jsxOpeningElement: jsxOpeningElement,
		jSXOpeningElement: jsxOpeningElement,
		jsxSpreadAttribute: jsxSpreadAttribute,
		jSXSpreadAttribute: jsxSpreadAttribute,
		jsxText: jsxText,
		jSXText: jsxText,
		jsxFragment: jsxFragment,
		jSXFragment: jsxFragment,
		jsxOpeningFragment: jsxOpeningFragment,
		jSXOpeningFragment: jsxOpeningFragment,
		jsxClosingFragment: jsxClosingFragment,
		jSXClosingFragment: jsxClosingFragment,
		noop: noop$1,
		placeholder: placeholder,
		v8IntrinsicIdentifier: v8IntrinsicIdentifier,
		argumentPlaceholder: argumentPlaceholder,
		bindExpression: bindExpression,
		importAttribute: importAttribute,
		decorator: decorator,
		doExpression: doExpression,
		exportDefaultSpecifier: exportDefaultSpecifier,
		recordExpression: recordExpression,
		tupleExpression: tupleExpression,
		decimalLiteral: decimalLiteral,
		moduleExpression: moduleExpression,
		topicReference: topicReference,
		pipelineTopicExpression: pipelineTopicExpression,
		pipelineBareFunction: pipelineBareFunction,
		pipelinePrimaryTopicReference: pipelinePrimaryTopicReference,
		tsParameterProperty: tsParameterProperty,
		tSParameterProperty: tsParameterProperty,
		tsDeclareFunction: tsDeclareFunction,
		tSDeclareFunction: tsDeclareFunction,
		tsDeclareMethod: tsDeclareMethod,
		tSDeclareMethod: tsDeclareMethod,
		tsQualifiedName: tsQualifiedName,
		tSQualifiedName: tsQualifiedName,
		tsCallSignatureDeclaration: tsCallSignatureDeclaration,
		tSCallSignatureDeclaration: tsCallSignatureDeclaration,
		tsConstructSignatureDeclaration: tsConstructSignatureDeclaration,
		tSConstructSignatureDeclaration: tsConstructSignatureDeclaration,
		tsPropertySignature: tsPropertySignature,
		tSPropertySignature: tsPropertySignature,
		tsMethodSignature: tsMethodSignature,
		tSMethodSignature: tsMethodSignature,
		tsIndexSignature: tsIndexSignature,
		tSIndexSignature: tsIndexSignature,
		tsAnyKeyword: tsAnyKeyword,
		tSAnyKeyword: tsAnyKeyword,
		tsBooleanKeyword: tsBooleanKeyword,
		tSBooleanKeyword: tsBooleanKeyword,
		tsBigIntKeyword: tsBigIntKeyword,
		tSBigIntKeyword: tsBigIntKeyword,
		tsIntrinsicKeyword: tsIntrinsicKeyword,
		tSIntrinsicKeyword: tsIntrinsicKeyword,
		tsNeverKeyword: tsNeverKeyword,
		tSNeverKeyword: tsNeverKeyword,
		tsNullKeyword: tsNullKeyword,
		tSNullKeyword: tsNullKeyword,
		tsNumberKeyword: tsNumberKeyword,
		tSNumberKeyword: tsNumberKeyword,
		tsObjectKeyword: tsObjectKeyword,
		tSObjectKeyword: tsObjectKeyword,
		tsStringKeyword: tsStringKeyword,
		tSStringKeyword: tsStringKeyword,
		tsSymbolKeyword: tsSymbolKeyword,
		tSSymbolKeyword: tsSymbolKeyword,
		tsUndefinedKeyword: tsUndefinedKeyword,
		tSUndefinedKeyword: tsUndefinedKeyword,
		tsUnknownKeyword: tsUnknownKeyword,
		tSUnknownKeyword: tsUnknownKeyword,
		tsVoidKeyword: tsVoidKeyword,
		tSVoidKeyword: tsVoidKeyword,
		tsThisType: tsThisType,
		tSThisType: tsThisType,
		tsFunctionType: tsFunctionType,
		tSFunctionType: tsFunctionType,
		tsConstructorType: tsConstructorType,
		tSConstructorType: tsConstructorType,
		tsTypeReference: tsTypeReference,
		tSTypeReference: tsTypeReference,
		tsTypePredicate: tsTypePredicate,
		tSTypePredicate: tsTypePredicate,
		tsTypeQuery: tsTypeQuery,
		tSTypeQuery: tsTypeQuery,
		tsTypeLiteral: tsTypeLiteral,
		tSTypeLiteral: tsTypeLiteral,
		tsArrayType: tsArrayType,
		tSArrayType: tsArrayType,
		tsTupleType: tsTupleType,
		tSTupleType: tsTupleType,
		tsOptionalType: tsOptionalType,
		tSOptionalType: tsOptionalType,
		tsRestType: tsRestType,
		tSRestType: tsRestType,
		tsNamedTupleMember: tsNamedTupleMember,
		tSNamedTupleMember: tsNamedTupleMember,
		tsUnionType: tsUnionType,
		tSUnionType: tsUnionType,
		tsIntersectionType: tsIntersectionType,
		tSIntersectionType: tsIntersectionType,
		tsConditionalType: tsConditionalType,
		tSConditionalType: tsConditionalType,
		tsInferType: tsInferType,
		tSInferType: tsInferType,
		tsParenthesizedType: tsParenthesizedType,
		tSParenthesizedType: tsParenthesizedType,
		tsTypeOperator: tsTypeOperator,
		tSTypeOperator: tsTypeOperator,
		tsIndexedAccessType: tsIndexedAccessType,
		tSIndexedAccessType: tsIndexedAccessType,
		tsMappedType: tsMappedType,
		tSMappedType: tsMappedType,
		tsLiteralType: tsLiteralType,
		tSLiteralType: tsLiteralType,
		tsExpressionWithTypeArguments: tsExpressionWithTypeArguments,
		tSExpressionWithTypeArguments: tsExpressionWithTypeArguments,
		tsInterfaceDeclaration: tsInterfaceDeclaration,
		tSInterfaceDeclaration: tsInterfaceDeclaration,
		tsInterfaceBody: tsInterfaceBody,
		tSInterfaceBody: tsInterfaceBody,
		tsTypeAliasDeclaration: tsTypeAliasDeclaration,
		tSTypeAliasDeclaration: tsTypeAliasDeclaration,
		tsAsExpression: tsAsExpression,
		tSAsExpression: tsAsExpression,
		tsTypeAssertion: tsTypeAssertion,
		tSTypeAssertion: tsTypeAssertion,
		tsEnumDeclaration: tsEnumDeclaration,
		tSEnumDeclaration: tsEnumDeclaration,
		tsEnumMember: tsEnumMember,
		tSEnumMember: tsEnumMember,
		tsModuleDeclaration: tsModuleDeclaration,
		tSModuleDeclaration: tsModuleDeclaration,
		tsModuleBlock: tsModuleBlock,
		tSModuleBlock: tsModuleBlock,
		tsImportType: tsImportType,
		tSImportType: tsImportType,
		tsImportEqualsDeclaration: tsImportEqualsDeclaration,
		tSImportEqualsDeclaration: tsImportEqualsDeclaration,
		tsExternalModuleReference: tsExternalModuleReference,
		tSExternalModuleReference: tsExternalModuleReference,
		tsNonNullExpression: tsNonNullExpression,
		tSNonNullExpression: tsNonNullExpression,
		tsExportAssignment: tsExportAssignment,
		tSExportAssignment: tsExportAssignment,
		tsNamespaceExportDeclaration: tsNamespaceExportDeclaration,
		tSNamespaceExportDeclaration: tsNamespaceExportDeclaration,
		tsTypeAnnotation: tsTypeAnnotation,
		tSTypeAnnotation: tsTypeAnnotation,
		tsTypeParameterInstantiation: tsTypeParameterInstantiation,
		tSTypeParameterInstantiation: tsTypeParameterInstantiation,
		tsTypeParameterDeclaration: tsTypeParameterDeclaration,
		tSTypeParameterDeclaration: tsTypeParameterDeclaration,
		tsTypeParameter: tsTypeParameter,
		tSTypeParameter: tsTypeParameter,
		numberLiteral: NumberLiteral,
		regexLiteral: RegexLiteral,
		restProperty: RestProperty$1,
		spreadProperty: SpreadProperty$1,
		ArrayExpression: arrayExpression$1,
		AssignmentExpression: assignmentExpression$9,
		BinaryExpression: binaryExpression$3,
		InterpreterDirective: interpreterDirective$1,
		Directive: directive,
		DirectiveLiteral: directiveLiteral,
		BlockStatement: blockStatement$5,
		BreakStatement: breakStatement,
		CallExpression: callExpression$8,
		CatchClause: catchClause,
		ConditionalExpression: conditionalExpression$3,
		ContinueStatement: continueStatement,
		DebuggerStatement: debuggerStatement,
		DoWhileStatement: doWhileStatement,
		EmptyStatement: emptyStatement$1,
		ExpressionStatement: expressionStatement$7,
		File: file$1,
		ForInStatement: forInStatement,
		ForStatement: forStatement,
		FunctionDeclaration: functionDeclaration,
		FunctionExpression: functionExpression$1,
		Identifier: identifier$e,
		IfStatement: ifStatement,
		LabeledStatement: labeledStatement,
		StringLiteral: stringLiteral$4,
		NumericLiteral: numericLiteral$5,
		NullLiteral: nullLiteral$1,
		BooleanLiteral: booleanLiteral$2,
		RegExpLiteral: regExpLiteral,
		LogicalExpression: logicalExpression$2,
		MemberExpression: memberExpression$6,
		NewExpression: newExpression,
		Program: program$3,
		ObjectExpression: objectExpression$2,
		ObjectMethod: objectMethod,
		ObjectProperty: objectProperty,
		RestElement: restElement$1,
		ReturnStatement: returnStatement$2,
		SequenceExpression: sequenceExpression$3,
		ParenthesizedExpression: parenthesizedExpression,
		SwitchCase: switchCase,
		SwitchStatement: switchStatement,
		ThisExpression: thisExpression$3,
		ThrowStatement: throwStatement,
		TryStatement: tryStatement,
		UnaryExpression: unaryExpression$6,
		UpdateExpression: updateExpression,
		VariableDeclaration: variableDeclaration$6,
		VariableDeclarator: variableDeclarator$6,
		WhileStatement: whileStatement,
		WithStatement: withStatement,
		AssignmentPattern: assignmentPattern,
		ArrayPattern: arrayPattern,
		ArrowFunctionExpression: arrowFunctionExpression$4,
		ClassBody: classBody,
		ClassExpression: classExpression,
		ClassDeclaration: classDeclaration,
		ExportAllDeclaration: exportAllDeclaration,
		ExportDefaultDeclaration: exportDefaultDeclaration,
		ExportNamedDeclaration: exportNamedDeclaration$2,
		ExportSpecifier: exportSpecifier$2,
		ForOfStatement: forOfStatement,
		ImportDeclaration: importDeclaration,
		ImportDefaultSpecifier: importDefaultSpecifier,
		ImportNamespaceSpecifier: importNamespaceSpecifier,
		ImportSpecifier: importSpecifier,
		MetaProperty: metaProperty$1,
		ClassMethod: classMethod,
		ObjectPattern: objectPattern,
		SpreadElement: spreadElement$1,
		Super: _super$1,
		TaggedTemplateExpression: taggedTemplateExpression,
		TemplateElement: templateElement,
		TemplateLiteral: templateLiteral,
		YieldExpression: yieldExpression$1,
		AwaitExpression: awaitExpression$1,
		Import: _import,
		BigIntLiteral: bigIntLiteral,
		ExportNamespaceSpecifier: exportNamespaceSpecifier,
		OptionalMemberExpression: optionalMemberExpression$2,
		OptionalCallExpression: optionalCallExpression$2,
		ClassProperty: classProperty,
		ClassAccessorProperty: classAccessorProperty,
		ClassPrivateProperty: classPrivateProperty,
		ClassPrivateMethod: classPrivateMethod,
		PrivateName: privateName,
		StaticBlock: staticBlock$1,
		AnyTypeAnnotation: anyTypeAnnotation$2,
		ArrayTypeAnnotation: arrayTypeAnnotation$1,
		BooleanTypeAnnotation: booleanTypeAnnotation$1,
		BooleanLiteralTypeAnnotation: booleanLiteralTypeAnnotation,
		NullLiteralTypeAnnotation: nullLiteralTypeAnnotation$1,
		ClassImplements: classImplements,
		DeclareClass: declareClass,
		DeclareFunction: declareFunction,
		DeclareInterface: declareInterface,
		DeclareModule: declareModule,
		DeclareModuleExports: declareModuleExports,
		DeclareTypeAlias: declareTypeAlias,
		DeclareOpaqueType: declareOpaqueType,
		DeclareVariable: declareVariable,
		DeclareExportDeclaration: declareExportDeclaration,
		DeclareExportAllDeclaration: declareExportAllDeclaration,
		DeclaredPredicate: declaredPredicate,
		ExistsTypeAnnotation: existsTypeAnnotation,
		FunctionTypeAnnotation: functionTypeAnnotation,
		FunctionTypeParam: functionTypeParam,
		GenericTypeAnnotation: genericTypeAnnotation$1,
		InferredPredicate: inferredPredicate,
		InterfaceExtends: interfaceExtends,
		InterfaceDeclaration: interfaceDeclaration,
		InterfaceTypeAnnotation: interfaceTypeAnnotation,
		IntersectionTypeAnnotation: intersectionTypeAnnotation,
		MixedTypeAnnotation: mixedTypeAnnotation,
		EmptyTypeAnnotation: emptyTypeAnnotation,
		NullableTypeAnnotation: nullableTypeAnnotation,
		NumberLiteralTypeAnnotation: numberLiteralTypeAnnotation,
		NumberTypeAnnotation: numberTypeAnnotation$2,
		ObjectTypeAnnotation: objectTypeAnnotation,
		ObjectTypeInternalSlot: objectTypeInternalSlot,
		ObjectTypeCallProperty: objectTypeCallProperty,
		ObjectTypeIndexer: objectTypeIndexer,
		ObjectTypeProperty: objectTypeProperty,
		ObjectTypeSpreadProperty: objectTypeSpreadProperty,
		OpaqueType: opaqueType,
		QualifiedTypeIdentifier: qualifiedTypeIdentifier,
		StringLiteralTypeAnnotation: stringLiteralTypeAnnotation,
		StringTypeAnnotation: stringTypeAnnotation$2,
		SymbolTypeAnnotation: symbolTypeAnnotation,
		ThisTypeAnnotation: thisTypeAnnotation,
		TupleTypeAnnotation: tupleTypeAnnotation$1,
		TypeofTypeAnnotation: typeofTypeAnnotation,
		TypeAlias: typeAlias,
		TypeAnnotation: typeAnnotation,
		TypeCastExpression: typeCastExpression,
		TypeParameter: typeParameter,
		TypeParameterDeclaration: typeParameterDeclaration,
		TypeParameterInstantiation: typeParameterInstantiation,
		UnionTypeAnnotation: unionTypeAnnotation$1,
		Variance: variance,
		VoidTypeAnnotation: voidTypeAnnotation$3,
		EnumDeclaration: enumDeclaration,
		EnumBooleanBody: enumBooleanBody,
		EnumNumberBody: enumNumberBody,
		EnumStringBody: enumStringBody,
		EnumSymbolBody: enumSymbolBody,
		EnumBooleanMember: enumBooleanMember,
		EnumNumberMember: enumNumberMember,
		EnumStringMember: enumStringMember,
		EnumDefaultedMember: enumDefaultedMember,
		IndexedAccessType: indexedAccessType,
		OptionalIndexedAccessType: optionalIndexedAccessType,
		JSXAttribute: jsxAttribute,
		JSXClosingElement: jsxClosingElement,
		JSXElement: jsxElement,
		JSXEmptyExpression: jsxEmptyExpression,
		JSXExpressionContainer: jsxExpressionContainer$1,
		JSXSpreadChild: jsxSpreadChild,
		JSXIdentifier: jsxIdentifier$1,
		JSXMemberExpression: jsxMemberExpression,
		JSXNamespacedName: jsxNamespacedName,
		JSXOpeningElement: jsxOpeningElement,
		JSXSpreadAttribute: jsxSpreadAttribute,
		JSXText: jsxText,
		JSXFragment: jsxFragment,
		JSXOpeningFragment: jsxOpeningFragment,
		JSXClosingFragment: jsxClosingFragment,
		Noop: noop$1,
		Placeholder: placeholder,
		V8IntrinsicIdentifier: v8IntrinsicIdentifier,
		ArgumentPlaceholder: argumentPlaceholder,
		BindExpression: bindExpression,
		ImportAttribute: importAttribute,
		Decorator: decorator,
		DoExpression: doExpression,
		ExportDefaultSpecifier: exportDefaultSpecifier,
		RecordExpression: recordExpression,
		TupleExpression: tupleExpression,
		DecimalLiteral: decimalLiteral,
		ModuleExpression: moduleExpression,
		TopicReference: topicReference,
		PipelineTopicExpression: pipelineTopicExpression,
		PipelineBareFunction: pipelineBareFunction,
		PipelinePrimaryTopicReference: pipelinePrimaryTopicReference,
		TSParameterProperty: tsParameterProperty,
		TSDeclareFunction: tsDeclareFunction,
		TSDeclareMethod: tsDeclareMethod,
		TSQualifiedName: tsQualifiedName,
		TSCallSignatureDeclaration: tsCallSignatureDeclaration,
		TSConstructSignatureDeclaration: tsConstructSignatureDeclaration,
		TSPropertySignature: tsPropertySignature,
		TSMethodSignature: tsMethodSignature,
		TSIndexSignature: tsIndexSignature,
		TSAnyKeyword: tsAnyKeyword,
		TSBooleanKeyword: tsBooleanKeyword,
		TSBigIntKeyword: tsBigIntKeyword,
		TSIntrinsicKeyword: tsIntrinsicKeyword,
		TSNeverKeyword: tsNeverKeyword,
		TSNullKeyword: tsNullKeyword,
		TSNumberKeyword: tsNumberKeyword,
		TSObjectKeyword: tsObjectKeyword,
		TSStringKeyword: tsStringKeyword,
		TSSymbolKeyword: tsSymbolKeyword,
		TSUndefinedKeyword: tsUndefinedKeyword,
		TSUnknownKeyword: tsUnknownKeyword,
		TSVoidKeyword: tsVoidKeyword,
		TSThisType: tsThisType,
		TSFunctionType: tsFunctionType,
		TSConstructorType: tsConstructorType,
		TSTypeReference: tsTypeReference,
		TSTypePredicate: tsTypePredicate,
		TSTypeQuery: tsTypeQuery,
		TSTypeLiteral: tsTypeLiteral,
		TSArrayType: tsArrayType,
		TSTupleType: tsTupleType,
		TSOptionalType: tsOptionalType,
		TSRestType: tsRestType,
		TSNamedTupleMember: tsNamedTupleMember,
		TSUnionType: tsUnionType,
		TSIntersectionType: tsIntersectionType,
		TSConditionalType: tsConditionalType,
		TSInferType: tsInferType,
		TSParenthesizedType: tsParenthesizedType,
		TSTypeOperator: tsTypeOperator,
		TSIndexedAccessType: tsIndexedAccessType,
		TSMappedType: tsMappedType,
		TSLiteralType: tsLiteralType,
		TSExpressionWithTypeArguments: tsExpressionWithTypeArguments,
		TSInterfaceDeclaration: tsInterfaceDeclaration,
		TSInterfaceBody: tsInterfaceBody,
		TSTypeAliasDeclaration: tsTypeAliasDeclaration,
		TSAsExpression: tsAsExpression,
		TSTypeAssertion: tsTypeAssertion,
		TSEnumDeclaration: tsEnumDeclaration,
		TSEnumMember: tsEnumMember,
		TSModuleDeclaration: tsModuleDeclaration,
		TSModuleBlock: tsModuleBlock,
		TSImportType: tsImportType,
		TSImportEqualsDeclaration: tsImportEqualsDeclaration,
		TSExternalModuleReference: tsExternalModuleReference,
		TSNonNullExpression: tsNonNullExpression,
		TSExportAssignment: tsExportAssignment,
		TSNamespaceExportDeclaration: tsNamespaceExportDeclaration,
		TSTypeAnnotation: tsTypeAnnotation,
		TSTypeParameterInstantiation: tsTypeParameterInstantiation,
		TSTypeParameterDeclaration: tsTypeParameterDeclaration,
		TSTypeParameter: tsTypeParameter,
		NumberLiteral: NumberLiteral,
		RegexLiteral: RegexLiteral,
		RestProperty: RestProperty$1,
		SpreadProperty: SpreadProperty$1,
		STANDARDIZED_TYPES: STANDARDIZED_TYPES,
		EXPRESSION_TYPES: EXPRESSION_TYPES,
		BINARY_TYPES: BINARY_TYPES,
		SCOPABLE_TYPES: SCOPABLE_TYPES,
		BLOCKPARENT_TYPES: BLOCKPARENT_TYPES,
		BLOCK_TYPES: BLOCK_TYPES,
		STATEMENT_TYPES: STATEMENT_TYPES,
		TERMINATORLESS_TYPES: TERMINATORLESS_TYPES,
		COMPLETIONSTATEMENT_TYPES: COMPLETIONSTATEMENT_TYPES,
		CONDITIONAL_TYPES: CONDITIONAL_TYPES,
		LOOP_TYPES: LOOP_TYPES,
		WHILE_TYPES: WHILE_TYPES,
		EXPRESSIONWRAPPER_TYPES: EXPRESSIONWRAPPER_TYPES,
		FOR_TYPES: FOR_TYPES,
		FORXSTATEMENT_TYPES: FORXSTATEMENT_TYPES,
		FUNCTION_TYPES: FUNCTION_TYPES$1,
		FUNCTIONPARENT_TYPES: FUNCTIONPARENT_TYPES,
		PUREISH_TYPES: PUREISH_TYPES,
		DECLARATION_TYPES: DECLARATION_TYPES,
		PATTERNLIKE_TYPES: PATTERNLIKE_TYPES,
		LVAL_TYPES: LVAL_TYPES,
		TSENTITYNAME_TYPES: TSENTITYNAME_TYPES,
		LITERAL_TYPES: LITERAL_TYPES,
		IMMUTABLE_TYPES: IMMUTABLE_TYPES,
		USERWHITESPACABLE_TYPES: USERWHITESPACABLE_TYPES,
		METHOD_TYPES: METHOD_TYPES,
		OBJECTMEMBER_TYPES: OBJECTMEMBER_TYPES,
		PROPERTY_TYPES: PROPERTY_TYPES,
		UNARYLIKE_TYPES: UNARYLIKE_TYPES,
		PATTERN_TYPES: PATTERN_TYPES,
		CLASS_TYPES: CLASS_TYPES,
		MODULEDECLARATION_TYPES: MODULEDECLARATION_TYPES,
		EXPORTDECLARATION_TYPES: EXPORTDECLARATION_TYPES,
		MODULESPECIFIER_TYPES: MODULESPECIFIER_TYPES,
		ACCESSOR_TYPES: ACCESSOR_TYPES,
		PRIVATE_TYPES: PRIVATE_TYPES,
		FLOW_TYPES: FLOW_TYPES,
		FLOWTYPE_TYPES: FLOWTYPE_TYPES,
		FLOWBASEANNOTATION_TYPES: FLOWBASEANNOTATION_TYPES,
		FLOWDECLARATION_TYPES: FLOWDECLARATION_TYPES,
		FLOWPREDICATE_TYPES: FLOWPREDICATE_TYPES,
		ENUMBODY_TYPES: ENUMBODY_TYPES,
		ENUMMEMBER_TYPES: ENUMMEMBER_TYPES,
		JSX_TYPES: JSX_TYPES,
		MISCELLANEOUS_TYPES: MISCELLANEOUS_TYPES,
		TYPESCRIPT_TYPES: TYPESCRIPT_TYPES,
		TSTYPEELEMENT_TYPES: TSTYPEELEMENT_TYPES,
		TSTYPE_TYPES: TSTYPE_TYPES,
		TSBASETYPE_TYPES: TSBASETYPE_TYPES,
		STATEMENT_OR_BLOCK_KEYS: STATEMENT_OR_BLOCK_KEYS$1,
		FLATTENABLE_KEYS: FLATTENABLE_KEYS,
		FOR_INIT_KEYS: FOR_INIT_KEYS,
		COMMENT_KEYS: COMMENT_KEYS,
		LOGICAL_OPERATORS: LOGICAL_OPERATORS$2,
		UPDATE_OPERATORS: UPDATE_OPERATORS,
		BOOLEAN_NUMBER_BINARY_OPERATORS: BOOLEAN_NUMBER_BINARY_OPERATORS$1,
		EQUALITY_BINARY_OPERATORS: EQUALITY_BINARY_OPERATORS,
		COMPARISON_BINARY_OPERATORS: COMPARISON_BINARY_OPERATORS,
		BOOLEAN_BINARY_OPERATORS: BOOLEAN_BINARY_OPERATORS$1,
		NUMBER_BINARY_OPERATORS: NUMBER_BINARY_OPERATORS$1,
		BINARY_OPERATORS: BINARY_OPERATORS,
		ASSIGNMENT_OPERATORS: ASSIGNMENT_OPERATORS,
		BOOLEAN_UNARY_OPERATORS: BOOLEAN_UNARY_OPERATORS$1,
		NUMBER_UNARY_OPERATORS: NUMBER_UNARY_OPERATORS$1,
		STRING_UNARY_OPERATORS: STRING_UNARY_OPERATORS$1,
		UNARY_OPERATORS: UNARY_OPERATORS,
		INHERIT_KEYS: INHERIT_KEYS,
		BLOCK_SCOPED_SYMBOL: BLOCK_SCOPED_SYMBOL,
		NOT_LOCAL_BINDING: NOT_LOCAL_BINDING$2,
		VISITOR_KEYS: VISITOR_KEYS$7,
		ALIAS_KEYS: ALIAS_KEYS,
		FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS$3,
		NODE_FIELDS: NODE_FIELDS,
		BUILDER_KEYS: BUILDER_KEYS,
		DEPRECATED_KEYS: DEPRECATED_KEYS$1,
		NODE_PARENT_VALIDATIONS: NODE_PARENT_VALIDATIONS,
		PLACEHOLDERS: PLACEHOLDERS,
		PLACEHOLDERS_ALIAS: PLACEHOLDERS_ALIAS,
		PLACEHOLDERS_FLIPPED_ALIAS: PLACEHOLDERS_FLIPPED_ALIAS,
		TYPES: TYPES$1,
		isArrayExpression: isArrayExpression$2,
		isAssignmentExpression: isAssignmentExpression$4,
		isBinaryExpression: isBinaryExpression$1,
		isInterpreterDirective: isInterpreterDirective,
		isDirective: isDirective,
		isDirectiveLiteral: isDirectiveLiteral,
		isBlockStatement: isBlockStatement$2,
		isBreakStatement: isBreakStatement,
		isCallExpression: isCallExpression$6,
		isCatchClause: isCatchClause,
		isConditionalExpression: isConditionalExpression$1,
		isContinueStatement: isContinueStatement,
		isDebuggerStatement: isDebuggerStatement,
		isDoWhileStatement: isDoWhileStatement,
		isEmptyStatement: isEmptyStatement$1,
		isExpressionStatement: isExpressionStatement$3,
		isFile: isFile$1,
		isForInStatement: isForInStatement$1,
		isForStatement: isForStatement$3,
		isFunctionDeclaration: isFunctionDeclaration$1,
		isFunctionExpression: isFunctionExpression,
		isIdentifier: isIdentifier$c,
		isIfStatement: isIfStatement$2,
		isLabeledStatement: isLabeledStatement,
		isStringLiteral: isStringLiteral$4,
		isNumericLiteral: isNumericLiteral,
		isNullLiteral: isNullLiteral$1,
		isBooleanLiteral: isBooleanLiteral,
		isRegExpLiteral: isRegExpLiteral$1,
		isLogicalExpression: isLogicalExpression$1,
		isMemberExpression: isMemberExpression$6,
		isNewExpression: isNewExpression$4,
		isProgram: isProgram$2,
		isObjectExpression: isObjectExpression$2,
		isObjectMethod: isObjectMethod$1,
		isObjectProperty: isObjectProperty$1,
		isRestElement: isRestElement$1,
		isReturnStatement: isReturnStatement$1,
		isSequenceExpression: isSequenceExpression$2,
		isParenthesizedExpression: isParenthesizedExpression$1,
		isSwitchCase: isSwitchCase,
		isSwitchStatement: isSwitchStatement$1,
		isThisExpression: isThisExpression$1,
		isThrowStatement: isThrowStatement$1,
		isTryStatement: isTryStatement,
		isUnaryExpression: isUnaryExpression$1,
		isUpdateExpression: isUpdateExpression$1,
		isVariableDeclaration: isVariableDeclaration$2,
		isVariableDeclarator: isVariableDeclarator$2,
		isWhileStatement: isWhileStatement$1,
		isWithStatement: isWithStatement,
		isAssignmentPattern: isAssignmentPattern$2,
		isArrayPattern: isArrayPattern,
		isArrowFunctionExpression: isArrowFunctionExpression$1,
		isClassBody: isClassBody$1,
		isClassExpression: isClassExpression$1,
		isClassDeclaration: isClassDeclaration$3,
		isExportAllDeclaration: isExportAllDeclaration$1,
		isExportDefaultDeclaration: isExportDefaultDeclaration$3,
		isExportNamedDeclaration: isExportNamedDeclaration$2,
		isExportSpecifier: isExportSpecifier,
		isForOfStatement: isForOfStatement$1,
		isImportDeclaration: isImportDeclaration$2,
		isImportDefaultSpecifier: isImportDefaultSpecifier$1,
		isImportNamespaceSpecifier: isImportNamespaceSpecifier$1,
		isImportSpecifier: isImportSpecifier$1,
		isMetaProperty: isMetaProperty,
		isClassMethod: isClassMethod,
		isObjectPattern: isObjectPattern$1,
		isSpreadElement: isSpreadElement$1,
		isSuper: isSuper$2,
		isTaggedTemplateExpression: isTaggedTemplateExpression$2,
		isTemplateElement: isTemplateElement,
		isTemplateLiteral: isTemplateLiteral$2,
		isYieldExpression: isYieldExpression$1,
		isAwaitExpression: isAwaitExpression$1,
		isImport: isImport,
		isBigIntLiteral: isBigIntLiteral,
		isExportNamespaceSpecifier: isExportNamespaceSpecifier$1,
		isOptionalMemberExpression: isOptionalMemberExpression$3,
		isOptionalCallExpression: isOptionalCallExpression$3,
		isClassProperty: isClassProperty,
		isClassAccessorProperty: isClassAccessorProperty,
		isClassPrivateProperty: isClassPrivateProperty,
		isClassPrivateMethod: isClassPrivateMethod,
		isPrivateName: isPrivateName,
		isStaticBlock: isStaticBlock,
		isAnyTypeAnnotation: isAnyTypeAnnotation$1,
		isArrayTypeAnnotation: isArrayTypeAnnotation$1,
		isBooleanTypeAnnotation: isBooleanTypeAnnotation$1,
		isBooleanLiteralTypeAnnotation: isBooleanLiteralTypeAnnotation,
		isNullLiteralTypeAnnotation: isNullLiteralTypeAnnotation,
		isClassImplements: isClassImplements,
		isDeclareClass: isDeclareClass,
		isDeclareFunction: isDeclareFunction,
		isDeclareInterface: isDeclareInterface,
		isDeclareModule: isDeclareModule,
		isDeclareModuleExports: isDeclareModuleExports,
		isDeclareTypeAlias: isDeclareTypeAlias,
		isDeclareOpaqueType: isDeclareOpaqueType,
		isDeclareVariable: isDeclareVariable,
		isDeclareExportDeclaration: isDeclareExportDeclaration$1,
		isDeclareExportAllDeclaration: isDeclareExportAllDeclaration,
		isDeclaredPredicate: isDeclaredPredicate,
		isExistsTypeAnnotation: isExistsTypeAnnotation,
		isFunctionTypeAnnotation: isFunctionTypeAnnotation,
		isFunctionTypeParam: isFunctionTypeParam,
		isGenericTypeAnnotation: isGenericTypeAnnotation$1,
		isInferredPredicate: isInferredPredicate,
		isInterfaceExtends: isInterfaceExtends,
		isInterfaceDeclaration: isInterfaceDeclaration,
		isInterfaceTypeAnnotation: isInterfaceTypeAnnotation,
		isIntersectionTypeAnnotation: isIntersectionTypeAnnotation$1,
		isMixedTypeAnnotation: isMixedTypeAnnotation$1,
		isEmptyTypeAnnotation: isEmptyTypeAnnotation$1,
		isNullableTypeAnnotation: isNullableTypeAnnotation$1,
		isNumberLiteralTypeAnnotation: isNumberLiteralTypeAnnotation,
		isNumberTypeAnnotation: isNumberTypeAnnotation$1,
		isObjectTypeAnnotation: isObjectTypeAnnotation,
		isObjectTypeInternalSlot: isObjectTypeInternalSlot,
		isObjectTypeCallProperty: isObjectTypeCallProperty,
		isObjectTypeIndexer: isObjectTypeIndexer,
		isObjectTypeProperty: isObjectTypeProperty,
		isObjectTypeSpreadProperty: isObjectTypeSpreadProperty,
		isOpaqueType: isOpaqueType,
		isQualifiedTypeIdentifier: isQualifiedTypeIdentifier,
		isStringLiteralTypeAnnotation: isStringLiteralTypeAnnotation,
		isStringTypeAnnotation: isStringTypeAnnotation$1,
		isSymbolTypeAnnotation: isSymbolTypeAnnotation,
		isThisTypeAnnotation: isThisTypeAnnotation,
		isTupleTypeAnnotation: isTupleTypeAnnotation,
		isTypeofTypeAnnotation: isTypeofTypeAnnotation,
		isTypeAlias: isTypeAlias,
		isTypeAnnotation: isTypeAnnotation$2,
		isTypeCastExpression: isTypeCastExpression$1,
		isTypeParameter: isTypeParameter,
		isTypeParameterDeclaration: isTypeParameterDeclaration,
		isTypeParameterInstantiation: isTypeParameterInstantiation,
		isUnionTypeAnnotation: isUnionTypeAnnotation$2,
		isVariance: isVariance,
		isVoidTypeAnnotation: isVoidTypeAnnotation$1,
		isEnumDeclaration: isEnumDeclaration,
		isEnumBooleanBody: isEnumBooleanBody,
		isEnumNumberBody: isEnumNumberBody,
		isEnumStringBody: isEnumStringBody,
		isEnumSymbolBody: isEnumSymbolBody,
		isEnumBooleanMember: isEnumBooleanMember,
		isEnumNumberMember: isEnumNumberMember,
		isEnumStringMember: isEnumStringMember,
		isEnumDefaultedMember: isEnumDefaultedMember,
		isIndexedAccessType: isIndexedAccessType$1,
		isOptionalIndexedAccessType: isOptionalIndexedAccessType,
		isJSXAttribute: isJSXAttribute,
		isJSXClosingElement: isJSXClosingElement,
		isJSXElement: isJSXElement,
		isJSXEmptyExpression: isJSXEmptyExpression,
		isJSXExpressionContainer: isJSXExpressionContainer,
		isJSXSpreadChild: isJSXSpreadChild,
		isJSXIdentifier: isJSXIdentifier$2,
		isJSXMemberExpression: isJSXMemberExpression$1,
		isJSXNamespacedName: isJSXNamespacedName,
		isJSXOpeningElement: isJSXOpeningElement,
		isJSXSpreadAttribute: isJSXSpreadAttribute,
		isJSXText: isJSXText,
		isJSXFragment: isJSXFragment,
		isJSXOpeningFragment: isJSXOpeningFragment,
		isJSXClosingFragment: isJSXClosingFragment,
		isNoop: isNoop,
		isPlaceholder: isPlaceholder$1,
		isV8IntrinsicIdentifier: isV8IntrinsicIdentifier,
		isArgumentPlaceholder: isArgumentPlaceholder,
		isBindExpression: isBindExpression,
		isImportAttribute: isImportAttribute,
		isDecorator: isDecorator,
		isDoExpression: isDoExpression,
		isExportDefaultSpecifier: isExportDefaultSpecifier$1,
		isRecordExpression: isRecordExpression,
		isTupleExpression: isTupleExpression,
		isDecimalLiteral: isDecimalLiteral,
		isModuleExpression: isModuleExpression,
		isTopicReference: isTopicReference,
		isPipelineTopicExpression: isPipelineTopicExpression,
		isPipelineBareFunction: isPipelineBareFunction,
		isPipelinePrimaryTopicReference: isPipelinePrimaryTopicReference,
		isTSParameterProperty: isTSParameterProperty,
		isTSDeclareFunction: isTSDeclareFunction,
		isTSDeclareMethod: isTSDeclareMethod,
		isTSQualifiedName: isTSQualifiedName,
		isTSCallSignatureDeclaration: isTSCallSignatureDeclaration,
		isTSConstructSignatureDeclaration: isTSConstructSignatureDeclaration,
		isTSPropertySignature: isTSPropertySignature,
		isTSMethodSignature: isTSMethodSignature,
		isTSIndexSignature: isTSIndexSignature,
		isTSAnyKeyword: isTSAnyKeyword,
		isTSBooleanKeyword: isTSBooleanKeyword,
		isTSBigIntKeyword: isTSBigIntKeyword,
		isTSIntrinsicKeyword: isTSIntrinsicKeyword,
		isTSNeverKeyword: isTSNeverKeyword,
		isTSNullKeyword: isTSNullKeyword,
		isTSNumberKeyword: isTSNumberKeyword,
		isTSObjectKeyword: isTSObjectKeyword,
		isTSStringKeyword: isTSStringKeyword,
		isTSSymbolKeyword: isTSSymbolKeyword,
		isTSUndefinedKeyword: isTSUndefinedKeyword,
		isTSUnknownKeyword: isTSUnknownKeyword,
		isTSVoidKeyword: isTSVoidKeyword,
		isTSThisType: isTSThisType,
		isTSFunctionType: isTSFunctionType,
		isTSConstructorType: isTSConstructorType,
		isTSTypeReference: isTSTypeReference,
		isTSTypePredicate: isTSTypePredicate,
		isTSTypeQuery: isTSTypeQuery,
		isTSTypeLiteral: isTSTypeLiteral,
		isTSArrayType: isTSArrayType$1,
		isTSTupleType: isTSTupleType,
		isTSOptionalType: isTSOptionalType$1,
		isTSRestType: isTSRestType$1,
		isTSNamedTupleMember: isTSNamedTupleMember,
		isTSUnionType: isTSUnionType$1,
		isTSIntersectionType: isTSIntersectionType$1,
		isTSConditionalType: isTSConditionalType,
		isTSInferType: isTSInferType,
		isTSParenthesizedType: isTSParenthesizedType,
		isTSTypeOperator: isTSTypeOperator,
		isTSIndexedAccessType: isTSIndexedAccessType,
		isTSMappedType: isTSMappedType,
		isTSLiteralType: isTSLiteralType,
		isTSExpressionWithTypeArguments: isTSExpressionWithTypeArguments,
		isTSInterfaceDeclaration: isTSInterfaceDeclaration,
		isTSInterfaceBody: isTSInterfaceBody,
		isTSTypeAliasDeclaration: isTSTypeAliasDeclaration,
		isTSAsExpression: isTSAsExpression$2,
		isTSTypeAssertion: isTSTypeAssertion$2,
		isTSEnumDeclaration: isTSEnumDeclaration,
		isTSEnumMember: isTSEnumMember,
		isTSModuleDeclaration: isTSModuleDeclaration,
		isTSModuleBlock: isTSModuleBlock,
		isTSImportType: isTSImportType,
		isTSImportEqualsDeclaration: isTSImportEqualsDeclaration,
		isTSExternalModuleReference: isTSExternalModuleReference,
		isTSNonNullExpression: isTSNonNullExpression$2,
		isTSExportAssignment: isTSExportAssignment,
		isTSNamespaceExportDeclaration: isTSNamespaceExportDeclaration,
		isTSTypeAnnotation: isTSTypeAnnotation$2,
		isTSTypeParameterInstantiation: isTSTypeParameterInstantiation,
		isTSTypeParameterDeclaration: isTSTypeParameterDeclaration,
		isTSTypeParameter: isTSTypeParameter,
		isStandardized: isStandardized,
		isExpression: isExpression$4,
		isBinary: isBinary$3,
		isScopable: isScopable,
		isBlockParent: isBlockParent,
		isBlock: isBlock,
		isStatement: isStatement$7,
		isTerminatorless: isTerminatorless,
		isCompletionStatement: isCompletionStatement,
		isConditional: isConditional$1,
		isLoop: isLoop$1,
		isWhile: isWhile,
		isExpressionWrapper: isExpressionWrapper,
		isFor: isFor$2,
		isForXStatement: isForXStatement$1,
		isFunction: isFunction$5,
		isFunctionParent: isFunctionParent,
		isPureish: isPureish$1,
		isDeclaration: isDeclaration$1,
		isPatternLike: isPatternLike,
		isLVal: isLVal,
		isTSEntityName: isTSEntityName,
		isLiteral: isLiteral$5,
		isUserWhitespacable: isUserWhitespacable,
		isMethod: isMethod$1,
		isObjectMember: isObjectMember,
		isProperty: isProperty$1,
		isUnaryLike: isUnaryLike$1,
		isPattern: isPattern,
		isClass: isClass$1,
		isModuleDeclaration: isModuleDeclaration$1,
		isExportDeclaration: isExportDeclaration$2,
		isModuleSpecifier: isModuleSpecifier$1,
		isAccessor: isAccessor,
		isPrivate: isPrivate,
		isFlow: isFlow$1,
		isFlowType: isFlowType,
		isFlowBaseAnnotation: isFlowBaseAnnotation$1,
		isFlowDeclaration: isFlowDeclaration,
		isFlowPredicate: isFlowPredicate,
		isEnumBody: isEnumBody,
		isEnumMember: isEnumMember,
		isJSX: isJSX,
		isMiscellaneous: isMiscellaneous,
		isTypeScript: isTypeScript,
		isTSTypeElement: isTSTypeElement,
		isTSType: isTSType,
		isTSBaseType: isTSBaseType,
		isNumberLiteral: isNumberLiteral,
		isRegexLiteral: isRegexLiteral,
		isRestProperty: isRestProperty,
		isSpreadProperty: isSpreadProperty
	});

	const {
	  isBinding,
	  isBlockScoped,
	  isExportDeclaration: isExportDeclaration$1,
	  isExpression: isExpression$3,
	  isFlow,
	  isForStatement: isForStatement$2,
	  isForXStatement,
	  isIdentifier: isIdentifier$b,
	  isImportDeclaration: isImportDeclaration$1,
	  isImportSpecifier,
	  isJSXIdentifier: isJSXIdentifier$1,
	  isJSXMemberExpression,
	  isMemberExpression: isMemberExpression$5,
	  isReferenced,
	  isScope,
	  isStatement: isStatement$6,
	  isVar,
	  isVariableDeclaration: isVariableDeclaration$1,
	  react: react$1
	} = _t;
	const {
	  isCompatTag
	} = react$1;
	const ReferencedIdentifier = {
	  types: ["Identifier", "JSXIdentifier"],

	  checkPath(path, opts) {
	    const {
	      node,
	      parent
	    } = path;

	    if (!isIdentifier$b(node, opts) && !isJSXMemberExpression(parent, opts)) {
	      if (isJSXIdentifier$1(node, opts)) {
	        if (isCompatTag(node.name)) return false;
	      } else {
	        return false;
	      }
	    }

	    return isReferenced(node, parent, path.parentPath.parent);
	  }

	};
	const ReferencedMemberExpression = {
	  types: ["MemberExpression"],

	  checkPath({
	    node,
	    parent
	  }) {
	    return isMemberExpression$5(node) && isReferenced(node, parent);
	  }

	};
	const BindingIdentifier = {
	  types: ["Identifier"],

	  checkPath(path) {
	    const {
	      node,
	      parent
	    } = path;
	    const grandparent = path.parentPath.parent;
	    return isIdentifier$b(node) && isBinding(node, parent, grandparent);
	  }

	};
	const Statement = {
	  types: ["Statement"],

	  checkPath({
	    node,
	    parent
	  }) {
	    if (isStatement$6(node)) {
	      if (isVariableDeclaration$1(node)) {
	        if (isForXStatement(parent, {
	          left: node
	        })) return false;
	        if (isForStatement$2(parent, {
	          init: node
	        })) return false;
	      }

	      return true;
	    } else {
	      return false;
	    }
	  }

	};
	const Expression = {
	  types: ["Expression"],

	  checkPath(path) {
	    if (path.isIdentifier()) {
	      return path.isReferencedIdentifier();
	    } else {
	      return isExpression$3(path.node);
	    }
	  }

	};
	const Scope$2 = {
	  types: ["Scopable", "Pattern"],

	  checkPath(path) {
	    return isScope(path.node, path.parent);
	  }

	};
	const Referenced = {
	  checkPath(path) {
	    return isReferenced(path.node, path.parent);
	  }

	};
	const BlockScoped = {
	  checkPath(path) {
	    return isBlockScoped(path.node);
	  }

	};
	const Var = {
	  types: ["VariableDeclaration"],

	  checkPath(path) {
	    return isVar(path.node);
	  }

	};
	const User = {
	  checkPath(path) {
	    return path.node && !!path.node.loc;
	  }

	};
	const Generated = {
	  checkPath(path) {
	    return !path.isUser();
	  }

	};
	const Pure = {
	  checkPath(path, opts) {
	    return path.scope.isPure(path.node, opts);
	  }

	};
	const Flow = {
	  types: ["Flow", "ImportDeclaration", "ExportDeclaration", "ImportSpecifier"],

	  checkPath({
	    node
	  }) {
	    if (isFlow(node)) {
	      return true;
	    } else if (isImportDeclaration$1(node)) {
	      return node.importKind === "type" || node.importKind === "typeof";
	    } else if (isExportDeclaration$1(node)) {
	      return node.exportKind === "type";
	    } else if (isImportSpecifier(node)) {
	      return node.importKind === "type" || node.importKind === "typeof";
	    } else {
	      return false;
	    }
	  }

	};
	const RestProperty = {
	  types: ["RestElement"],

	  checkPath(path) {
	    return path.parentPath && path.parentPath.isObjectPattern();
	  }

	};
	const SpreadProperty = {
	  types: ["RestElement"],

	  checkPath(path) {
	    return path.parentPath && path.parentPath.isObjectExpression();
	  }

	};
	const ExistentialTypeParam = {
	  types: ["ExistsTypeAnnotation"]
	};
	const NumericLiteralTypeAnnotation = {
	  types: ["NumberLiteralTypeAnnotation"]
	};
	const ForAwaitStatement = {
	  types: ["ForOfStatement"],

	  checkPath({
	    node
	  }) {
	    return node.await === true;
	  }

	};

	var virtualTypes = /*#__PURE__*/Object.freeze({
		__proto__: null,
		ReferencedIdentifier: ReferencedIdentifier,
		ReferencedMemberExpression: ReferencedMemberExpression,
		BindingIdentifier: BindingIdentifier,
		Statement: Statement,
		Expression: Expression,
		Scope: Scope$2,
		Referenced: Referenced,
		BlockScoped: BlockScoped,
		Var: Var,
		User: User,
		Generated: Generated,
		Pure: Pure,
		Flow: Flow,
		RestProperty: RestProperty,
		SpreadProperty: SpreadProperty,
		ExistentialTypeParam: ExistentialTypeParam,
		NumericLiteralTypeAnnotation: NumericLiteralTypeAnnotation,
		ForAwaitStatement: ForAwaitStatement
	});

	const {
	  DEPRECATED_KEYS,
	  FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS$2,
	  TYPES
	} = _t;
	function explode(visitor) {
	  if (visitor._exploded) return visitor;
	  visitor._exploded = true;

	  for (const nodeType of Object.keys(visitor)) {
	    if (shouldIgnoreKey(nodeType)) continue;
	    const parts = nodeType.split("|");
	    if (parts.length === 1) continue;
	    const fns = visitor[nodeType];
	    delete visitor[nodeType];

	    for (const part of parts) {
	      visitor[part] = fns;
	    }
	  }

	  verify(visitor);
	  delete visitor.__esModule;
	  ensureEntranceObjects(visitor);
	  ensureCallbackArrays(visitor);

	  for (const nodeType of Object.keys(visitor)) {
	    if (shouldIgnoreKey(nodeType)) continue;
	    const wrapper = virtualTypes[nodeType];
	    if (!wrapper) continue;
	    const fns = visitor[nodeType];

	    for (const type of Object.keys(fns)) {
	      fns[type] = wrapCheck(wrapper, fns[type]);
	    }

	    delete visitor[nodeType];

	    if (wrapper.types) {
	      for (const type of wrapper.types) {
	        if (visitor[type]) {
	          mergePair(visitor[type], fns);
	        } else {
	          visitor[type] = fns;
	        }
	      }
	    } else {
	      mergePair(visitor, fns);
	    }
	  }

	  for (const nodeType of Object.keys(visitor)) {
	    if (shouldIgnoreKey(nodeType)) continue;
	    const fns = visitor[nodeType];
	    let aliases = FLIPPED_ALIAS_KEYS$2[nodeType];
	    const deprecatedKey = DEPRECATED_KEYS[nodeType];

	    if (deprecatedKey) {
	      console.trace(`Visitor defined for ${nodeType} but it has been renamed to ${deprecatedKey}`);
	      aliases = [deprecatedKey];
	    }

	    if (!aliases) continue;
	    delete visitor[nodeType];

	    for (const alias of aliases) {
	      const existing = visitor[alias];

	      if (existing) {
	        mergePair(existing, fns);
	      } else {
	        visitor[alias] = { ...fns
	        };
	      }
	    }
	  }

	  for (const nodeType of Object.keys(visitor)) {
	    if (shouldIgnoreKey(nodeType)) continue;
	    ensureCallbackArrays(visitor[nodeType]);
	  }

	  return visitor;
	}
	function verify(visitor) {
	  if (visitor._verified) return;

	  if (typeof visitor === "function") {
	    throw new Error("You passed `traverse()` a function when it expected a visitor object, " + "are you sure you didn't mean `{ enter: Function }`?");
	  }

	  for (const nodeType of Object.keys(visitor)) {
	    if (nodeType === "enter" || nodeType === "exit") {
	      validateVisitorMethods(nodeType, visitor[nodeType]);
	    }

	    if (shouldIgnoreKey(nodeType)) continue;

	    if (TYPES.indexOf(nodeType) < 0) {
	      throw new Error(`You gave us a visitor for the node type ${nodeType} but it's not a valid type`);
	    }

	    const visitors = visitor[nodeType];

	    if (typeof visitors === "object") {
	      for (const visitorKey of Object.keys(visitors)) {
	        if (visitorKey === "enter" || visitorKey === "exit") {
	          validateVisitorMethods(`${nodeType}.${visitorKey}`, visitors[visitorKey]);
	        } else {
	          throw new Error("You passed `traverse()` a visitor object with the property " + `${nodeType} that has the invalid property ${visitorKey}`);
	        }
	      }
	    }
	  }

	  visitor._verified = true;
	}

	function validateVisitorMethods(path, val) {
	  const fns = [].concat(val);

	  for (const fn of fns) {
	    if (typeof fn !== "function") {
	      throw new TypeError(`Non-function found defined in ${path} with type ${typeof fn}`);
	    }
	  }
	}

	function merge$1(visitors, states = [], wrapper) {
	  const rootVisitor = {};

	  for (let i = 0; i < visitors.length; i++) {
	    const visitor = visitors[i];
	    const state = states[i];
	    explode(visitor);

	    for (const type of Object.keys(visitor)) {
	      let visitorType = visitor[type];

	      if (state || wrapper) {
	        visitorType = wrapWithStateOrWrapper(visitorType, state, wrapper);
	      }

	      const nodeVisitor = rootVisitor[type] = rootVisitor[type] || {};
	      mergePair(nodeVisitor, visitorType);
	    }
	  }

	  return rootVisitor;
	}

	function wrapWithStateOrWrapper(oldVisitor, state, wrapper) {
	  const newVisitor = {};

	  for (const key of Object.keys(oldVisitor)) {
	    let fns = oldVisitor[key];
	    if (!Array.isArray(fns)) continue;
	    fns = fns.map(function (fn) {
	      let newFn = fn;

	      if (state) {
	        newFn = function (path) {
	          return fn.call(state, path, state);
	        };
	      }

	      if (wrapper) {
	        newFn = wrapper(state.key, key, newFn);
	      }

	      if (newFn !== fn) {
	        newFn.toString = () => fn.toString();
	      }

	      return newFn;
	    });
	    newVisitor[key] = fns;
	  }

	  return newVisitor;
	}

	function ensureEntranceObjects(obj) {
	  for (const key of Object.keys(obj)) {
	    if (shouldIgnoreKey(key)) continue;
	    const fns = obj[key];

	    if (typeof fns === "function") {
	      obj[key] = {
	        enter: fns
	      };
	    }
	  }
	}

	function ensureCallbackArrays(obj) {
	  if (obj.enter && !Array.isArray(obj.enter)) obj.enter = [obj.enter];
	  if (obj.exit && !Array.isArray(obj.exit)) obj.exit = [obj.exit];
	}

	function wrapCheck(wrapper, fn) {
	  const newFn = function (path) {
	    if (wrapper.checkPath(path)) {
	      return fn.apply(this, arguments);
	    }
	  };

	  newFn.toString = () => fn.toString();

	  return newFn;
	}

	function shouldIgnoreKey(key) {
	  if (key[0] === "_") return true;
	  if (key === "enter" || key === "exit" || key === "shouldSkip") return true;

	  if (key === "denylist" || key === "noScope" || key === "skipKeys" || key === "blacklist") {
	    return true;
	  }

	  return false;
	}

	function mergePair(dest, src) {
	  for (const key of Object.keys(src)) {
	    dest[key] = [].concat(dest[key] || [], src[key]);
	  }
	}

	var visitors = /*#__PURE__*/Object.freeze({
		__proto__: null,
		explode: explode,
		verify: verify,
		merge: merge$1
	});

	let path$3 = new WeakMap();
	let scope = new WeakMap();
	function clear() {
	  clearPath();
	  clearScope();
	}
	function clearPath() {
	  path$3 = new WeakMap();
	}
	function clearScope() {
	  scope = new WeakMap();
	}

	var cache$2 = /*#__PURE__*/Object.freeze({
		__proto__: null,
		get path () { return path$3; },
		get scope () { return scope; },
		clear: clear,
		clearPath: clearPath,
		clearScope: clearScope
	});

	var s = 1000;
	var m = s * 60;
	var h = m * 60;
	var d = h * 24;
	var w = d * 7;
	var y = d * 365.25;

	var ms = function (val, options) {
	  options = options || {};
	  var type = typeof val;

	  if (type === 'string' && val.length > 0) {
	    return parse$5(val);
	  } else if (type === 'number' && isFinite(val)) {
	    return options.long ? fmtLong(val) : fmtShort(val);
	  }

	  throw new Error('val is not a non-empty string or a valid number. val=' + JSON.stringify(val));
	};

	function parse$5(str) {
	  str = String(str);

	  if (str.length > 100) {
	    return;
	  }

	  var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(str);

	  if (!match) {
	    return;
	  }

	  var n = parseFloat(match[1]);
	  var type = (match[2] || 'ms').toLowerCase();

	  switch (type) {
	    case 'years':
	    case 'year':
	    case 'yrs':
	    case 'yr':
	    case 'y':
	      return n * y;

	    case 'weeks':
	    case 'week':
	    case 'w':
	      return n * w;

	    case 'days':
	    case 'day':
	    case 'd':
	      return n * d;

	    case 'hours':
	    case 'hour':
	    case 'hrs':
	    case 'hr':
	    case 'h':
	      return n * h;

	    case 'minutes':
	    case 'minute':
	    case 'mins':
	    case 'min':
	    case 'm':
	      return n * m;

	    case 'seconds':
	    case 'second':
	    case 'secs':
	    case 'sec':
	    case 's':
	      return n * s;

	    case 'milliseconds':
	    case 'millisecond':
	    case 'msecs':
	    case 'msec':
	    case 'ms':
	      return n;

	    default:
	      return undefined;
	  }
	}

	function fmtShort(ms) {
	  var msAbs = Math.abs(ms);

	  if (msAbs >= d) {
	    return Math.round(ms / d) + 'd';
	  }

	  if (msAbs >= h) {
	    return Math.round(ms / h) + 'h';
	  }

	  if (msAbs >= m) {
	    return Math.round(ms / m) + 'm';
	  }

	  if (msAbs >= s) {
	    return Math.round(ms / s) + 's';
	  }

	  return ms + 'ms';
	}

	function fmtLong(ms) {
	  var msAbs = Math.abs(ms);

	  if (msAbs >= d) {
	    return plural(ms, msAbs, d, 'day');
	  }

	  if (msAbs >= h) {
	    return plural(ms, msAbs, h, 'hour');
	  }

	  if (msAbs >= m) {
	    return plural(ms, msAbs, m, 'minute');
	  }

	  if (msAbs >= s) {
	    return plural(ms, msAbs, s, 'second');
	  }

	  return ms + ' ms';
	}

	function plural(ms, msAbs, n, name) {
	  var isPlural = msAbs >= n * 1.5;
	  return Math.round(ms / n) + ' ' + name + (isPlural ? 's' : '');
	}

	function setup$1(env) {
	  createDebug.debug = createDebug;
	  createDebug.default = createDebug;
	  createDebug.coerce = coerce;
	  createDebug.disable = disable;
	  createDebug.enable = enable;
	  createDebug.enabled = enabled;
	  createDebug.humanize = ms;
	  createDebug.destroy = destroy;
	  Object.keys(env).forEach(key => {
	    createDebug[key] = env[key];
	  });
	  createDebug.names = [];
	  createDebug.skips = [];
	  createDebug.formatters = {};

	  function selectColor(namespace) {
	    let hash = 0;

	    for (let i = 0; i < namespace.length; i++) {
	      hash = (hash << 5) - hash + namespace.charCodeAt(i);
	      hash |= 0;
	    }

	    return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
	  }

	  createDebug.selectColor = selectColor;

	  function createDebug(namespace) {
	    let prevTime;
	    let enableOverride = null;
	    let namespacesCache;
	    let enabledCache;

	    function debug(...args) {
	      if (!debug.enabled) {
	        return;
	      }

	      const self = debug;
	      const curr = Number(new Date());
	      const ms = curr - (prevTime || curr);
	      self.diff = ms;
	      self.prev = prevTime;
	      self.curr = curr;
	      prevTime = curr;
	      args[0] = createDebug.coerce(args[0]);

	      if (typeof args[0] !== 'string') {
	        args.unshift('%O');
	      }

	      let index = 0;
	      args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format) => {
	        if (match === '%%') {
	          return '%';
	        }

	        index++;
	        const formatter = createDebug.formatters[format];

	        if (typeof formatter === 'function') {
	          const val = args[index];
	          match = formatter.call(self, val);
	          args.splice(index, 1);
	          index--;
	        }

	        return match;
	      });
	      createDebug.formatArgs.call(self, args);
	      const logFn = self.log || createDebug.log;
	      logFn.apply(self, args);
	    }

	    debug.namespace = namespace;
	    debug.useColors = createDebug.useColors();
	    debug.color = createDebug.selectColor(namespace);
	    debug.extend = extend;
	    debug.destroy = createDebug.destroy;
	    Object.defineProperty(debug, 'enabled', {
	      enumerable: true,
	      configurable: false,
	      get: () => {
	        if (enableOverride !== null) {
	          return enableOverride;
	        }

	        if (namespacesCache !== createDebug.namespaces) {
	          namespacesCache = createDebug.namespaces;
	          enabledCache = createDebug.enabled(namespace);
	        }

	        return enabledCache;
	      },
	      set: v => {
	        enableOverride = v;
	      }
	    });

	    if (typeof createDebug.init === 'function') {
	      createDebug.init(debug);
	    }

	    return debug;
	  }

	  function extend(namespace, delimiter) {
	    const newDebug = createDebug(this.namespace + (typeof delimiter === 'undefined' ? ':' : delimiter) + namespace);
	    newDebug.log = this.log;
	    return newDebug;
	  }

	  function enable(namespaces) {
	    createDebug.save(namespaces);
	    createDebug.namespaces = namespaces;
	    createDebug.names = [];
	    createDebug.skips = [];
	    let i;
	    const split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
	    const len = split.length;

	    for (i = 0; i < len; i++) {
	      if (!split[i]) {
	        continue;
	      }

	      namespaces = split[i].replace(/\*/g, '.*?');

	      if (namespaces[0] === '-') {
	        createDebug.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
	      } else {
	        createDebug.names.push(new RegExp('^' + namespaces + '$'));
	      }
	    }
	  }

	  function disable() {
	    const namespaces = [...createDebug.names.map(toNamespace), ...createDebug.skips.map(toNamespace).map(namespace => '-' + namespace)].join(',');
	    createDebug.enable('');
	    return namespaces;
	  }

	  function enabled(name) {
	    if (name[name.length - 1] === '*') {
	      return true;
	    }

	    let i;
	    let len;

	    for (i = 0, len = createDebug.skips.length; i < len; i++) {
	      if (createDebug.skips[i].test(name)) {
	        return false;
	      }
	    }

	    for (i = 0, len = createDebug.names.length; i < len; i++) {
	      if (createDebug.names[i].test(name)) {
	        return true;
	      }
	    }

	    return false;
	  }

	  function toNamespace(regexp) {
	    return regexp.toString().substring(2, regexp.toString().length - 2).replace(/\.\*\?$/, '*');
	  }

	  function coerce(val) {
	    if (val instanceof Error) {
	      return val.stack || val.message;
	    }

	    return val;
	  }

	  function destroy() {
	    console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
	  }

	  createDebug.enable(createDebug.load());
	  return createDebug;
	}

	var common = setup$1;

	var browser$4 = createCommonjsModule(function (module, exports) {
	  exports.formatArgs = formatArgs;
	  exports.save = save;
	  exports.load = load;
	  exports.useColors = useColors;
	  exports.storage = localstorage();

	  exports.destroy = (() => {
	    let warned = false;
	    return () => {
	      if (!warned) {
	        warned = true;
	        console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
	      }
	    };
	  })();

	  exports.colors = ['#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC', '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF', '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC', '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF', '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC', '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033', '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366', '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933', '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC', '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF', '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'];

	  function useColors() {
	    if (typeof window !== 'undefined' && window.process && (window.process.type === 'renderer' || window.process.__nwjs)) {
	      return true;
	    }

	    if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
	      return false;
	    }

	    return typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== 'undefined' && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
	  }

	  function formatArgs(args) {
	    args[0] = (this.useColors ? '%c' : '') + this.namespace + (this.useColors ? ' %c' : ' ') + args[0] + (this.useColors ? '%c ' : ' ') + '+' + module.exports.humanize(this.diff);

	    if (!this.useColors) {
	      return;
	    }

	    const c = 'color: ' + this.color;
	    args.splice(1, 0, c, 'color: inherit');
	    let index = 0;
	    let lastC = 0;
	    args[0].replace(/%[a-zA-Z%]/g, match => {
	      if (match === '%%') {
	        return;
	      }

	      index++;

	      if (match === '%c') {
	        lastC = index;
	      }
	    });
	    args.splice(lastC, 0, c);
	  }

	  exports.log = console.debug || console.log || (() => {});

	  function save(namespaces) {
	    try {
	      if (namespaces) {
	        exports.storage.setItem('debug', namespaces);
	      } else {
	        exports.storage.removeItem('debug');
	      }
	    } catch (error) {}
	  }

	  function load() {
	    let r;

	    try {
	      r = exports.storage.getItem('debug');
	    } catch (error) {}

	    if (!r && typeof browser$5 !== 'undefined' && 'env' in browser$5) {
	      r = browser$5.env.DEBUG;
	    }

	    return r;
	  }

	  function localstorage() {
	    try {
	      return localStorage;
	    } catch (error) {}
	  }

	  module.exports = common(exports);
	  const {
	    formatters
	  } = module.exports;

	  formatters.j = function (v) {
	    try {
	      return JSON.stringify(v);
	    } catch (error) {
	      return '[UnexpectedJSONParseError]: ' + error.message;
	    }
	  };
	}, "/$$rollup_base$$/node_modules/debug/src");

	class Binding {
	  identifier;
	  scope;
	  path;
	  kind;

	  constructor({
	    identifier,
	    scope,
	    path,
	    kind
	  }) {
	    this.identifier = identifier;
	    this.scope = scope;
	    this.path = path;
	    this.kind = kind;
	    this.clearValue();
	  }

	  constantViolations = [];
	  constant = true;
	  referencePaths = [];
	  referenced = false;
	  references = 0;

	  deoptValue() {
	    this.clearValue();
	    this.hasDeoptedValue = true;
	  }

	  setValue(value) {
	    if (this.hasDeoptedValue) return;
	    this.hasValue = true;
	    this.value = value;
	  }

	  clearValue() {
	    this.hasDeoptedValue = false;
	    this.hasValue = false;
	    this.value = null;
	  }

	  reassign(path) {
	    this.constant = false;

	    if (this.constantViolations.indexOf(path) !== -1) {
	      return;
	    }

	    this.constantViolations.push(path);
	  }

	  reference(path) {
	    if (this.referencePaths.indexOf(path) !== -1) {
	      return;
	    }

	    this.referenced = true;
	    this.references++;
	    this.referencePaths.push(path);
	  }

	  dereference() {
	    this.references--;
	    this.referenced = !!this.references;
	  }

	}

	const {
	  cloneNode: cloneNode$b,
	  exportNamedDeclaration: exportNamedDeclaration$1,
	  exportSpecifier: exportSpecifier$1,
	  identifier: identifier$d,
	  variableDeclaration: variableDeclaration$5,
	  variableDeclarator: variableDeclarator$5
	} = _t;
	function splitExportDeclaration(exportDeclaration) {
	  if (!exportDeclaration.isExportDeclaration()) {
	    throw new Error("Only export declarations can be split.");
	  }

	  const isDefault = exportDeclaration.isExportDefaultDeclaration();
	  const declaration = exportDeclaration.get("declaration");
	  const isClassDeclaration = declaration.isClassDeclaration();

	  if (isDefault) {
	    const standaloneDeclaration = declaration.isFunctionDeclaration() || isClassDeclaration;
	    const scope = declaration.isScope() ? declaration.scope.parent : declaration.scope;
	    let id = declaration.node.id;
	    let needBindingRegistration = false;

	    if (!id) {
	      needBindingRegistration = true;
	      id = scope.generateUidIdentifier("default");

	      if (standaloneDeclaration || declaration.isFunctionExpression() || declaration.isClassExpression()) {
	        declaration.node.id = cloneNode$b(id);
	      }
	    }

	    const updatedDeclaration = standaloneDeclaration ? declaration : variableDeclaration$5("var", [variableDeclarator$5(cloneNode$b(id), declaration.node)]);
	    const updatedExportDeclaration = exportNamedDeclaration$1(null, [exportSpecifier$1(cloneNode$b(id), identifier$d("default"))]);
	    exportDeclaration.insertAfter(updatedExportDeclaration);
	    exportDeclaration.replaceWith(updatedDeclaration);

	    if (needBindingRegistration) {
	      scope.registerDeclaration(exportDeclaration);
	    }

	    return exportDeclaration;
	  }

	  if (exportDeclaration.get("specifiers").length > 0) {
	    throw new Error("It doesn't make sense to split exported specifiers.");
	  }

	  const bindingIdentifiers = declaration.getOuterBindingIdentifiers();
	  const specifiers = Object.keys(bindingIdentifiers).map(name => {
	    return exportSpecifier$1(identifier$d(name), identifier$d(name));
	  });
	  const aliasDeclar = exportNamedDeclaration$1(null, specifiers);
	  exportDeclaration.insertAfter(aliasDeclar);
	  exportDeclaration.replaceWith(declaration.node);
	  return exportDeclaration;
	}

	const {
	  VISITOR_KEYS: VISITOR_KEYS$6,
	  assignmentExpression: assignmentExpression$8,
	  identifier: identifier$c,
	  toExpression: toExpression$1,
	  variableDeclaration: variableDeclaration$4,
	  variableDeclarator: variableDeclarator$4
	} = _t;
	const renameVisitor = {
	  ReferencedIdentifier({
	    node
	  }, state) {
	    if (node.name === state.oldName) {
	      node.name = state.newName;
	    }
	  },

	  Scope(path, state) {
	    if (!path.scope.bindingIdentifierEquals(state.oldName, state.binding.identifier)) {
	      skipAllButComputedMethodKey(path);
	    }
	  },

	  "AssignmentExpression|Declaration|VariableDeclarator"(path, state) {
	    if (path.isVariableDeclaration()) return;
	    const ids = path.getOuterBindingIdentifiers();

	    for (const name in ids) {
	      if (name === state.oldName) ids[name].name = state.newName;
	    }
	  }

	};
	class Renamer {
	  constructor(binding, oldName, newName) {
	    this.newName = newName;
	    this.oldName = oldName;
	    this.binding = binding;
	  }

	  maybeConvertFromExportDeclaration(parentDeclar) {
	    const maybeExportDeclar = parentDeclar.parentPath;

	    if (!maybeExportDeclar.isExportDeclaration()) {
	      return;
	    }

	    if (maybeExportDeclar.isExportDefaultDeclaration() && !maybeExportDeclar.get("declaration").node.id) {
	      return;
	    }

	    splitExportDeclaration(maybeExportDeclar);
	  }

	  maybeConvertFromClassFunctionDeclaration(path) {
	    return;
	  }

	  maybeConvertFromClassFunctionExpression(path) {
	    return;
	  }

	  rename(block) {
	    const {
	      binding,
	      oldName,
	      newName
	    } = this;
	    const {
	      scope,
	      path
	    } = binding;
	    const parentDeclar = path.find(path => path.isDeclaration() || path.isFunctionExpression() || path.isClassExpression());

	    if (parentDeclar) {
	      const bindingIds = parentDeclar.getOuterBindingIdentifiers();

	      if (bindingIds[oldName] === binding.identifier) {
	        this.maybeConvertFromExportDeclaration(parentDeclar);
	      }
	    }

	    const blockToTraverse = block || scope.block;

	    if (blockToTraverse?.type === "SwitchStatement") {
	      blockToTraverse.cases.forEach(c => {
	        scope.traverse(c, renameVisitor, this);
	      });
	    } else {
	      scope.traverse(blockToTraverse, renameVisitor, this);
	    }

	    if (!block) {
	      scope.removeOwnBinding(oldName);
	      scope.bindings[newName] = binding;
	      this.binding.identifier.name = newName;
	    }

	    if (parentDeclar) {
	      this.maybeConvertFromClassFunctionDeclaration(parentDeclar);
	      this.maybeConvertFromClassFunctionExpression(parentDeclar);
	    }
	  }

	}

	function skipAllButComputedMethodKey(path) {
	  if (!path.isMethod() || !path.node.computed) {
	    path.skip();
	    return;
	  }

	  const keys = VISITOR_KEYS$6[path.type];

	  for (const key of keys) {
	    if (key !== "key") path.skipKey(key);
	  }
	}

	var builtin$1 = {
		"Array": false,
		"ArrayBuffer": false,
		Atomics: false,
		BigInt: false,
		BigInt64Array: false,
		BigUint64Array: false,
		"Boolean": false,
		constructor: false,
		"DataView": false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		FinalizationRegistry: false,
		"Float32Array": false,
		"Float64Array": false,
		"Function": false,
		globalThis: false,
		hasOwnProperty: false,
		"Infinity": false,
		"Int16Array": false,
		"Int32Array": false,
		"Int8Array": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Map": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		"Promise": false,
		propertyIsEnumerable: false,
		"Proxy": false,
		"RangeError": false,
		"ReferenceError": false,
		"Reflect": false,
		"RegExp": false,
		"Set": false,
		SharedArrayBuffer: false,
		"String": false,
		"Symbol": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"Uint16Array": false,
		"Uint32Array": false,
		"Uint8Array": false,
		"Uint8ClampedArray": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false,
		"WeakMap": false,
		WeakRef: false,
		"WeakSet": false
	};
	var es5$1 = {
		"Array": false,
		"Boolean": false,
		constructor: false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		"Function": false,
		hasOwnProperty: false,
		"Infinity": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		propertyIsEnumerable: false,
		"RangeError": false,
		"ReferenceError": false,
		"RegExp": false,
		"String": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false
	};
	var es2015$1 = {
		"Array": false,
		"ArrayBuffer": false,
		"Boolean": false,
		constructor: false,
		"DataView": false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		"Float32Array": false,
		"Float64Array": false,
		"Function": false,
		hasOwnProperty: false,
		"Infinity": false,
		"Int16Array": false,
		"Int32Array": false,
		"Int8Array": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Map": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		"Promise": false,
		propertyIsEnumerable: false,
		"Proxy": false,
		"RangeError": false,
		"ReferenceError": false,
		"Reflect": false,
		"RegExp": false,
		"Set": false,
		"String": false,
		"Symbol": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"Uint16Array": false,
		"Uint32Array": false,
		"Uint8Array": false,
		"Uint8ClampedArray": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false,
		"WeakMap": false,
		"WeakSet": false
	};
	var es2017$1 = {
		"Array": false,
		"ArrayBuffer": false,
		Atomics: false,
		"Boolean": false,
		constructor: false,
		"DataView": false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		"Float32Array": false,
		"Float64Array": false,
		"Function": false,
		hasOwnProperty: false,
		"Infinity": false,
		"Int16Array": false,
		"Int32Array": false,
		"Int8Array": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Map": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		"Promise": false,
		propertyIsEnumerable: false,
		"Proxy": false,
		"RangeError": false,
		"ReferenceError": false,
		"Reflect": false,
		"RegExp": false,
		"Set": false,
		SharedArrayBuffer: false,
		"String": false,
		"Symbol": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"Uint16Array": false,
		"Uint32Array": false,
		"Uint8Array": false,
		"Uint8ClampedArray": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false,
		"WeakMap": false,
		"WeakSet": false
	};
	var es2020 = {
		"Array": false,
		"ArrayBuffer": false,
		Atomics: false,
		BigInt: false,
		BigInt64Array: false,
		BigUint64Array: false,
		"Boolean": false,
		constructor: false,
		"DataView": false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		"Float32Array": false,
		"Float64Array": false,
		"Function": false,
		globalThis: false,
		hasOwnProperty: false,
		"Infinity": false,
		"Int16Array": false,
		"Int32Array": false,
		"Int8Array": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Map": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		"Promise": false,
		propertyIsEnumerable: false,
		"Proxy": false,
		"RangeError": false,
		"ReferenceError": false,
		"Reflect": false,
		"RegExp": false,
		"Set": false,
		SharedArrayBuffer: false,
		"String": false,
		"Symbol": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"Uint16Array": false,
		"Uint32Array": false,
		"Uint8Array": false,
		"Uint8ClampedArray": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false,
		"WeakMap": false,
		"WeakSet": false
	};
	var es2021 = {
		"Array": false,
		"ArrayBuffer": false,
		Atomics: false,
		BigInt: false,
		BigInt64Array: false,
		BigUint64Array: false,
		"Boolean": false,
		constructor: false,
		"DataView": false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		FinalizationRegistry: false,
		"Float32Array": false,
		"Float64Array": false,
		"Function": false,
		globalThis: false,
		hasOwnProperty: false,
		"Infinity": false,
		"Int16Array": false,
		"Int32Array": false,
		"Int8Array": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Map": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		"Promise": false,
		propertyIsEnumerable: false,
		"Proxy": false,
		"RangeError": false,
		"ReferenceError": false,
		"Reflect": false,
		"RegExp": false,
		"Set": false,
		SharedArrayBuffer: false,
		"String": false,
		"Symbol": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"Uint16Array": false,
		"Uint32Array": false,
		"Uint8Array": false,
		"Uint8ClampedArray": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false,
		"WeakMap": false,
		WeakRef: false,
		"WeakSet": false
	};
	var browser$3 = {
		AbortController: false,
		AbortSignal: false,
		addEventListener: false,
		alert: false,
		AnalyserNode: false,
		Animation: false,
		AnimationEffectReadOnly: false,
		AnimationEffectTiming: false,
		AnimationEffectTimingReadOnly: false,
		AnimationEvent: false,
		AnimationPlaybackEvent: false,
		AnimationTimeline: false,
		applicationCache: false,
		ApplicationCache: false,
		ApplicationCacheErrorEvent: false,
		atob: false,
		Attr: false,
		Audio: false,
		AudioBuffer: false,
		AudioBufferSourceNode: false,
		AudioContext: false,
		AudioDestinationNode: false,
		AudioListener: false,
		AudioNode: false,
		AudioParam: false,
		AudioProcessingEvent: false,
		AudioScheduledSourceNode: false,
		"AudioWorkletGlobalScope ": false,
		AudioWorkletNode: false,
		AudioWorkletProcessor: false,
		BarProp: false,
		BaseAudioContext: false,
		BatteryManager: false,
		BeforeUnloadEvent: false,
		BiquadFilterNode: false,
		Blob: false,
		BlobEvent: false,
		blur: false,
		BroadcastChannel: false,
		btoa: false,
		BudgetService: false,
		ByteLengthQueuingStrategy: false,
		Cache: false,
		caches: false,
		CacheStorage: false,
		cancelAnimationFrame: false,
		cancelIdleCallback: false,
		CanvasCaptureMediaStreamTrack: false,
		CanvasGradient: false,
		CanvasPattern: false,
		CanvasRenderingContext2D: false,
		ChannelMergerNode: false,
		ChannelSplitterNode: false,
		CharacterData: false,
		clearInterval: false,
		clearTimeout: false,
		clientInformation: false,
		ClipboardEvent: false,
		close: false,
		closed: false,
		CloseEvent: false,
		Comment: false,
		CompositionEvent: false,
		confirm: false,
		console: false,
		ConstantSourceNode: false,
		ConvolverNode: false,
		CountQueuingStrategy: false,
		createImageBitmap: false,
		Credential: false,
		CredentialsContainer: false,
		crypto: false,
		Crypto: false,
		CryptoKey: false,
		CSS: false,
		CSSConditionRule: false,
		CSSFontFaceRule: false,
		CSSGroupingRule: false,
		CSSImportRule: false,
		CSSKeyframeRule: false,
		CSSKeyframesRule: false,
		CSSMediaRule: false,
		CSSNamespaceRule: false,
		CSSPageRule: false,
		CSSRule: false,
		CSSRuleList: false,
		CSSStyleDeclaration: false,
		CSSStyleRule: false,
		CSSStyleSheet: false,
		CSSSupportsRule: false,
		CustomElementRegistry: false,
		customElements: false,
		CustomEvent: false,
		DataTransfer: false,
		DataTransferItem: false,
		DataTransferItemList: false,
		defaultstatus: false,
		defaultStatus: false,
		DelayNode: false,
		DeviceMotionEvent: false,
		DeviceOrientationEvent: false,
		devicePixelRatio: false,
		dispatchEvent: false,
		document: false,
		Document: false,
		DocumentFragment: false,
		DocumentType: false,
		DOMError: false,
		DOMException: false,
		DOMImplementation: false,
		DOMMatrix: false,
		DOMMatrixReadOnly: false,
		DOMParser: false,
		DOMPoint: false,
		DOMPointReadOnly: false,
		DOMQuad: false,
		DOMRect: false,
		DOMRectReadOnly: false,
		DOMStringList: false,
		DOMStringMap: false,
		DOMTokenList: false,
		DragEvent: false,
		DynamicsCompressorNode: false,
		Element: false,
		ErrorEvent: false,
		event: false,
		Event: false,
		EventSource: false,
		EventTarget: false,
		external: false,
		fetch: false,
		File: false,
		FileList: false,
		FileReader: false,
		find: false,
		focus: false,
		FocusEvent: false,
		FontFace: false,
		FontFaceSetLoadEvent: false,
		FormData: false,
		frameElement: false,
		frames: false,
		GainNode: false,
		Gamepad: false,
		GamepadButton: false,
		GamepadEvent: false,
		getComputedStyle: false,
		getSelection: false,
		HashChangeEvent: false,
		Headers: false,
		history: false,
		History: false,
		HTMLAllCollection: false,
		HTMLAnchorElement: false,
		HTMLAreaElement: false,
		HTMLAudioElement: false,
		HTMLBaseElement: false,
		HTMLBodyElement: false,
		HTMLBRElement: false,
		HTMLButtonElement: false,
		HTMLCanvasElement: false,
		HTMLCollection: false,
		HTMLContentElement: false,
		HTMLDataElement: false,
		HTMLDataListElement: false,
		HTMLDetailsElement: false,
		HTMLDialogElement: false,
		HTMLDirectoryElement: false,
		HTMLDivElement: false,
		HTMLDListElement: false,
		HTMLDocument: false,
		HTMLElement: false,
		HTMLEmbedElement: false,
		HTMLFieldSetElement: false,
		HTMLFontElement: false,
		HTMLFormControlsCollection: false,
		HTMLFormElement: false,
		HTMLFrameElement: false,
		HTMLFrameSetElement: false,
		HTMLHeadElement: false,
		HTMLHeadingElement: false,
		HTMLHRElement: false,
		HTMLHtmlElement: false,
		HTMLIFrameElement: false,
		HTMLImageElement: false,
		HTMLInputElement: false,
		HTMLLabelElement: false,
		HTMLLegendElement: false,
		HTMLLIElement: false,
		HTMLLinkElement: false,
		HTMLMapElement: false,
		HTMLMarqueeElement: false,
		HTMLMediaElement: false,
		HTMLMenuElement: false,
		HTMLMetaElement: false,
		HTMLMeterElement: false,
		HTMLModElement: false,
		HTMLObjectElement: false,
		HTMLOListElement: false,
		HTMLOptGroupElement: false,
		HTMLOptionElement: false,
		HTMLOptionsCollection: false,
		HTMLOutputElement: false,
		HTMLParagraphElement: false,
		HTMLParamElement: false,
		HTMLPictureElement: false,
		HTMLPreElement: false,
		HTMLProgressElement: false,
		HTMLQuoteElement: false,
		HTMLScriptElement: false,
		HTMLSelectElement: false,
		HTMLShadowElement: false,
		HTMLSlotElement: false,
		HTMLSourceElement: false,
		HTMLSpanElement: false,
		HTMLStyleElement: false,
		HTMLTableCaptionElement: false,
		HTMLTableCellElement: false,
		HTMLTableColElement: false,
		HTMLTableElement: false,
		HTMLTableRowElement: false,
		HTMLTableSectionElement: false,
		HTMLTemplateElement: false,
		HTMLTextAreaElement: false,
		HTMLTimeElement: false,
		HTMLTitleElement: false,
		HTMLTrackElement: false,
		HTMLUListElement: false,
		HTMLUnknownElement: false,
		HTMLVideoElement: false,
		IDBCursor: false,
		IDBCursorWithValue: false,
		IDBDatabase: false,
		IDBFactory: false,
		IDBIndex: false,
		IDBKeyRange: false,
		IDBObjectStore: false,
		IDBOpenDBRequest: false,
		IDBRequest: false,
		IDBTransaction: false,
		IDBVersionChangeEvent: false,
		IdleDeadline: false,
		IIRFilterNode: false,
		Image: false,
		ImageBitmap: false,
		ImageBitmapRenderingContext: false,
		ImageCapture: false,
		ImageData: false,
		indexedDB: false,
		innerHeight: false,
		innerWidth: false,
		InputEvent: false,
		IntersectionObserver: false,
		IntersectionObserverEntry: false,
		"Intl": false,
		isSecureContext: false,
		KeyboardEvent: false,
		KeyframeEffect: false,
		KeyframeEffectReadOnly: false,
		length: false,
		localStorage: false,
		location: true,
		Location: false,
		locationbar: false,
		matchMedia: false,
		MediaDeviceInfo: false,
		MediaDevices: false,
		MediaElementAudioSourceNode: false,
		MediaEncryptedEvent: false,
		MediaError: false,
		MediaKeyMessageEvent: false,
		MediaKeySession: false,
		MediaKeyStatusMap: false,
		MediaKeySystemAccess: false,
		MediaList: false,
		MediaQueryList: false,
		MediaQueryListEvent: false,
		MediaRecorder: false,
		MediaSettingsRange: false,
		MediaSource: false,
		MediaStream: false,
		MediaStreamAudioDestinationNode: false,
		MediaStreamAudioSourceNode: false,
		MediaStreamEvent: false,
		MediaStreamTrack: false,
		MediaStreamTrackEvent: false,
		menubar: false,
		MessageChannel: false,
		MessageEvent: false,
		MessagePort: false,
		MIDIAccess: false,
		MIDIConnectionEvent: false,
		MIDIInput: false,
		MIDIInputMap: false,
		MIDIMessageEvent: false,
		MIDIOutput: false,
		MIDIOutputMap: false,
		MIDIPort: false,
		MimeType: false,
		MimeTypeArray: false,
		MouseEvent: false,
		moveBy: false,
		moveTo: false,
		MutationEvent: false,
		MutationObserver: false,
		MutationRecord: false,
		name: false,
		NamedNodeMap: false,
		NavigationPreloadManager: false,
		navigator: false,
		Navigator: false,
		NetworkInformation: false,
		Node: false,
		NodeFilter: false,
		NodeIterator: false,
		NodeList: false,
		Notification: false,
		OfflineAudioCompletionEvent: false,
		OfflineAudioContext: false,
		offscreenBuffering: false,
		OffscreenCanvas: true,
		OffscreenCanvasRenderingContext2D: false,
		onabort: true,
		onafterprint: true,
		onanimationend: true,
		onanimationiteration: true,
		onanimationstart: true,
		onappinstalled: true,
		onauxclick: true,
		onbeforeinstallprompt: true,
		onbeforeprint: true,
		onbeforeunload: true,
		onblur: true,
		oncancel: true,
		oncanplay: true,
		oncanplaythrough: true,
		onchange: true,
		onclick: true,
		onclose: true,
		oncontextmenu: true,
		oncuechange: true,
		ondblclick: true,
		ondevicemotion: true,
		ondeviceorientation: true,
		ondeviceorientationabsolute: true,
		ondrag: true,
		ondragend: true,
		ondragenter: true,
		ondragleave: true,
		ondragover: true,
		ondragstart: true,
		ondrop: true,
		ondurationchange: true,
		onemptied: true,
		onended: true,
		onerror: true,
		onfocus: true,
		ongotpointercapture: true,
		onhashchange: true,
		oninput: true,
		oninvalid: true,
		onkeydown: true,
		onkeypress: true,
		onkeyup: true,
		onlanguagechange: true,
		onload: true,
		onloadeddata: true,
		onloadedmetadata: true,
		onloadstart: true,
		onlostpointercapture: true,
		onmessage: true,
		onmessageerror: true,
		onmousedown: true,
		onmouseenter: true,
		onmouseleave: true,
		onmousemove: true,
		onmouseout: true,
		onmouseover: true,
		onmouseup: true,
		onmousewheel: true,
		onoffline: true,
		ononline: true,
		onpagehide: true,
		onpageshow: true,
		onpause: true,
		onplay: true,
		onplaying: true,
		onpointercancel: true,
		onpointerdown: true,
		onpointerenter: true,
		onpointerleave: true,
		onpointermove: true,
		onpointerout: true,
		onpointerover: true,
		onpointerup: true,
		onpopstate: true,
		onprogress: true,
		onratechange: true,
		onrejectionhandled: true,
		onreset: true,
		onresize: true,
		onscroll: true,
		onsearch: true,
		onseeked: true,
		onseeking: true,
		onselect: true,
		onstalled: true,
		onstorage: true,
		onsubmit: true,
		onsuspend: true,
		ontimeupdate: true,
		ontoggle: true,
		ontransitionend: true,
		onunhandledrejection: true,
		onunload: true,
		onvolumechange: true,
		onwaiting: true,
		onwheel: true,
		open: false,
		openDatabase: false,
		opener: false,
		Option: false,
		origin: false,
		OscillatorNode: false,
		outerHeight: false,
		outerWidth: false,
		PageTransitionEvent: false,
		pageXOffset: false,
		pageYOffset: false,
		PannerNode: false,
		parent: false,
		Path2D: false,
		PaymentAddress: false,
		PaymentRequest: false,
		PaymentRequestUpdateEvent: false,
		PaymentResponse: false,
		performance: false,
		Performance: false,
		PerformanceEntry: false,
		PerformanceLongTaskTiming: false,
		PerformanceMark: false,
		PerformanceMeasure: false,
		PerformanceNavigation: false,
		PerformanceNavigationTiming: false,
		PerformanceObserver: false,
		PerformanceObserverEntryList: false,
		PerformancePaintTiming: false,
		PerformanceResourceTiming: false,
		PerformanceTiming: false,
		PeriodicWave: false,
		Permissions: false,
		PermissionStatus: false,
		personalbar: false,
		PhotoCapabilities: false,
		Plugin: false,
		PluginArray: false,
		PointerEvent: false,
		PopStateEvent: false,
		postMessage: false,
		Presentation: false,
		PresentationAvailability: false,
		PresentationConnection: false,
		PresentationConnectionAvailableEvent: false,
		PresentationConnectionCloseEvent: false,
		PresentationConnectionList: false,
		PresentationReceiver: false,
		PresentationRequest: false,
		print: false,
		ProcessingInstruction: false,
		ProgressEvent: false,
		PromiseRejectionEvent: false,
		prompt: false,
		PushManager: false,
		PushSubscription: false,
		PushSubscriptionOptions: false,
		queueMicrotask: false,
		RadioNodeList: false,
		Range: false,
		ReadableStream: false,
		registerProcessor: false,
		RemotePlayback: false,
		removeEventListener: false,
		Request: false,
		requestAnimationFrame: false,
		requestIdleCallback: false,
		resizeBy: false,
		ResizeObserver: false,
		ResizeObserverEntry: false,
		resizeTo: false,
		Response: false,
		RTCCertificate: false,
		RTCDataChannel: false,
		RTCDataChannelEvent: false,
		RTCDtlsTransport: false,
		RTCIceCandidate: false,
		RTCIceGatherer: false,
		RTCIceTransport: false,
		RTCPeerConnection: false,
		RTCPeerConnectionIceEvent: false,
		RTCRtpContributingSource: false,
		RTCRtpReceiver: false,
		RTCRtpSender: false,
		RTCSctpTransport: false,
		RTCSessionDescription: false,
		RTCStatsReport: false,
		RTCTrackEvent: false,
		screen: false,
		Screen: false,
		screenLeft: false,
		ScreenOrientation: false,
		screenTop: false,
		screenX: false,
		screenY: false,
		ScriptProcessorNode: false,
		scroll: false,
		scrollbars: false,
		scrollBy: false,
		scrollTo: false,
		scrollX: false,
		scrollY: false,
		SecurityPolicyViolationEvent: false,
		Selection: false,
		self: false,
		ServiceWorker: false,
		ServiceWorkerContainer: false,
		ServiceWorkerRegistration: false,
		sessionStorage: false,
		setInterval: false,
		setTimeout: false,
		ShadowRoot: false,
		SharedWorker: false,
		SourceBuffer: false,
		SourceBufferList: false,
		speechSynthesis: false,
		SpeechSynthesisEvent: false,
		SpeechSynthesisUtterance: false,
		StaticRange: false,
		status: false,
		statusbar: false,
		StereoPannerNode: false,
		stop: false,
		Storage: false,
		StorageEvent: false,
		StorageManager: false,
		styleMedia: false,
		StyleSheet: false,
		StyleSheetList: false,
		SubtleCrypto: false,
		SVGAElement: false,
		SVGAngle: false,
		SVGAnimatedAngle: false,
		SVGAnimatedBoolean: false,
		SVGAnimatedEnumeration: false,
		SVGAnimatedInteger: false,
		SVGAnimatedLength: false,
		SVGAnimatedLengthList: false,
		SVGAnimatedNumber: false,
		SVGAnimatedNumberList: false,
		SVGAnimatedPreserveAspectRatio: false,
		SVGAnimatedRect: false,
		SVGAnimatedString: false,
		SVGAnimatedTransformList: false,
		SVGAnimateElement: false,
		SVGAnimateMotionElement: false,
		SVGAnimateTransformElement: false,
		SVGAnimationElement: false,
		SVGCircleElement: false,
		SVGClipPathElement: false,
		SVGComponentTransferFunctionElement: false,
		SVGDefsElement: false,
		SVGDescElement: false,
		SVGDiscardElement: false,
		SVGElement: false,
		SVGEllipseElement: false,
		SVGFEBlendElement: false,
		SVGFEColorMatrixElement: false,
		SVGFEComponentTransferElement: false,
		SVGFECompositeElement: false,
		SVGFEConvolveMatrixElement: false,
		SVGFEDiffuseLightingElement: false,
		SVGFEDisplacementMapElement: false,
		SVGFEDistantLightElement: false,
		SVGFEDropShadowElement: false,
		SVGFEFloodElement: false,
		SVGFEFuncAElement: false,
		SVGFEFuncBElement: false,
		SVGFEFuncGElement: false,
		SVGFEFuncRElement: false,
		SVGFEGaussianBlurElement: false,
		SVGFEImageElement: false,
		SVGFEMergeElement: false,
		SVGFEMergeNodeElement: false,
		SVGFEMorphologyElement: false,
		SVGFEOffsetElement: false,
		SVGFEPointLightElement: false,
		SVGFESpecularLightingElement: false,
		SVGFESpotLightElement: false,
		SVGFETileElement: false,
		SVGFETurbulenceElement: false,
		SVGFilterElement: false,
		SVGForeignObjectElement: false,
		SVGGElement: false,
		SVGGeometryElement: false,
		SVGGradientElement: false,
		SVGGraphicsElement: false,
		SVGImageElement: false,
		SVGLength: false,
		SVGLengthList: false,
		SVGLinearGradientElement: false,
		SVGLineElement: false,
		SVGMarkerElement: false,
		SVGMaskElement: false,
		SVGMatrix: false,
		SVGMetadataElement: false,
		SVGMPathElement: false,
		SVGNumber: false,
		SVGNumberList: false,
		SVGPathElement: false,
		SVGPatternElement: false,
		SVGPoint: false,
		SVGPointList: false,
		SVGPolygonElement: false,
		SVGPolylineElement: false,
		SVGPreserveAspectRatio: false,
		SVGRadialGradientElement: false,
		SVGRect: false,
		SVGRectElement: false,
		SVGScriptElement: false,
		SVGSetElement: false,
		SVGStopElement: false,
		SVGStringList: false,
		SVGStyleElement: false,
		SVGSVGElement: false,
		SVGSwitchElement: false,
		SVGSymbolElement: false,
		SVGTextContentElement: false,
		SVGTextElement: false,
		SVGTextPathElement: false,
		SVGTextPositioningElement: false,
		SVGTitleElement: false,
		SVGTransform: false,
		SVGTransformList: false,
		SVGTSpanElement: false,
		SVGUnitTypes: false,
		SVGUseElement: false,
		SVGViewElement: false,
		TaskAttributionTiming: false,
		Text: false,
		TextDecoder: false,
		TextEncoder: false,
		TextEvent: false,
		TextMetrics: false,
		TextTrack: false,
		TextTrackCue: false,
		TextTrackCueList: false,
		TextTrackList: false,
		TimeRanges: false,
		toolbar: false,
		top: false,
		Touch: false,
		TouchEvent: false,
		TouchList: false,
		TrackEvent: false,
		TransitionEvent: false,
		TreeWalker: false,
		UIEvent: false,
		URL: false,
		URLSearchParams: false,
		ValidityState: false,
		visualViewport: false,
		VisualViewport: false,
		VTTCue: false,
		WaveShaperNode: false,
		WebAssembly: false,
		WebGL2RenderingContext: false,
		WebGLActiveInfo: false,
		WebGLBuffer: false,
		WebGLContextEvent: false,
		WebGLFramebuffer: false,
		WebGLProgram: false,
		WebGLQuery: false,
		WebGLRenderbuffer: false,
		WebGLRenderingContext: false,
		WebGLSampler: false,
		WebGLShader: false,
		WebGLShaderPrecisionFormat: false,
		WebGLSync: false,
		WebGLTexture: false,
		WebGLTransformFeedback: false,
		WebGLUniformLocation: false,
		WebGLVertexArrayObject: false,
		WebSocket: false,
		WheelEvent: false,
		window: false,
		Window: false,
		Worker: false,
		WritableStream: false,
		XMLDocument: false,
		XMLHttpRequest: false,
		XMLHttpRequestEventTarget: false,
		XMLHttpRequestUpload: false,
		XMLSerializer: false,
		XPathEvaluator: false,
		XPathExpression: false,
		XPathResult: false,
		XSLTProcessor: false
	};
	var worker$1 = {
		addEventListener: false,
		applicationCache: false,
		atob: false,
		Blob: false,
		BroadcastChannel: false,
		btoa: false,
		Cache: false,
		caches: false,
		clearInterval: false,
		clearTimeout: false,
		close: true,
		console: false,
		fetch: false,
		FileReaderSync: false,
		FormData: false,
		Headers: false,
		IDBCursor: false,
		IDBCursorWithValue: false,
		IDBDatabase: false,
		IDBFactory: false,
		IDBIndex: false,
		IDBKeyRange: false,
		IDBObjectStore: false,
		IDBOpenDBRequest: false,
		IDBRequest: false,
		IDBTransaction: false,
		IDBVersionChangeEvent: false,
		ImageData: false,
		importScripts: true,
		indexedDB: false,
		location: false,
		MessageChannel: false,
		MessagePort: false,
		name: false,
		navigator: false,
		Notification: false,
		onclose: true,
		onconnect: true,
		onerror: true,
		onlanguagechange: true,
		onmessage: true,
		onoffline: true,
		ononline: true,
		onrejectionhandled: true,
		onunhandledrejection: true,
		performance: false,
		Performance: false,
		PerformanceEntry: false,
		PerformanceMark: false,
		PerformanceMeasure: false,
		PerformanceNavigation: false,
		PerformanceResourceTiming: false,
		PerformanceTiming: false,
		postMessage: true,
		"Promise": false,
		queueMicrotask: false,
		removeEventListener: false,
		Request: false,
		Response: false,
		self: true,
		ServiceWorkerRegistration: false,
		setInterval: false,
		setTimeout: false,
		TextDecoder: false,
		TextEncoder: false,
		URL: false,
		URLSearchParams: false,
		WebSocket: false,
		Worker: false,
		WorkerGlobalScope: false,
		XMLHttpRequest: false
	};
	var node$1 = {
		__dirname: false,
		__filename: false,
		Buffer: false,
		clearImmediate: false,
		clearInterval: false,
		clearTimeout: false,
		console: false,
		exports: true,
		global: false,
		"Intl": false,
		module: false,
		process: false,
		queueMicrotask: false,
		require: false,
		setImmediate: false,
		setInterval: false,
		setTimeout: false,
		TextDecoder: false,
		TextEncoder: false,
		URL: false,
		URLSearchParams: false
	};
	var nodeBuiltin = {
		Buffer: false,
		clearImmediate: false,
		clearInterval: false,
		clearTimeout: false,
		console: false,
		global: false,
		"Intl": false,
		process: false,
		queueMicrotask: false,
		setImmediate: false,
		setInterval: false,
		setTimeout: false,
		TextDecoder: false,
		TextEncoder: false,
		URL: false,
		URLSearchParams: false
	};
	var commonjs$1 = {
		exports: true,
		global: false,
		module: false,
		require: false
	};
	var amd$1 = {
		define: false,
		require: false
	};
	var mocha$1 = {
		after: false,
		afterEach: false,
		before: false,
		beforeEach: false,
		context: false,
		describe: false,
		it: false,
		mocha: false,
		run: false,
		setup: false,
		specify: false,
		suite: false,
		suiteSetup: false,
		suiteTeardown: false,
		teardown: false,
		test: false,
		xcontext: false,
		xdescribe: false,
		xit: false,
		xspecify: false
	};
	var jasmine$1 = {
		afterAll: false,
		afterEach: false,
		beforeAll: false,
		beforeEach: false,
		describe: false,
		expect: false,
		expectAsync: false,
		fail: false,
		fdescribe: false,
		fit: false,
		it: false,
		jasmine: false,
		pending: false,
		runs: false,
		spyOn: false,
		spyOnAllFunctions: false,
		spyOnProperty: false,
		waits: false,
		waitsFor: false,
		xdescribe: false,
		xit: false
	};
	var jest$1 = {
		afterAll: false,
		afterEach: false,
		beforeAll: false,
		beforeEach: false,
		describe: false,
		expect: false,
		fdescribe: false,
		fit: false,
		it: false,
		jest: false,
		pit: false,
		require: false,
		test: false,
		xdescribe: false,
		xit: false,
		xtest: false
	};
	var qunit$1 = {
		asyncTest: false,
		deepEqual: false,
		equal: false,
		expect: false,
		module: false,
		notDeepEqual: false,
		notEqual: false,
		notOk: false,
		notPropEqual: false,
		notStrictEqual: false,
		ok: false,
		propEqual: false,
		QUnit: false,
		raises: false,
		start: false,
		stop: false,
		strictEqual: false,
		test: false,
		throws: false
	};
	var phantomjs$1 = {
		console: true,
		exports: true,
		phantom: true,
		require: true,
		WebPage: true
	};
	var couch$1 = {
		emit: false,
		exports: false,
		getRow: false,
		log: false,
		module: false,
		provides: false,
		require: false,
		respond: false,
		send: false,
		start: false,
		sum: false
	};
	var rhino$1 = {
		defineClass: false,
		deserialize: false,
		gc: false,
		help: false,
		importClass: false,
		importPackage: false,
		java: false,
		load: false,
		loadClass: false,
		Packages: false,
		print: false,
		quit: false,
		readFile: false,
		readUrl: false,
		runCommand: false,
		seal: false,
		serialize: false,
		spawn: false,
		sync: false,
		toint32: false,
		version: false
	};
	var nashorn$1 = {
		__DIR__: false,
		__FILE__: false,
		__LINE__: false,
		com: false,
		edu: false,
		exit: false,
		java: false,
		Java: false,
		javafx: false,
		JavaImporter: false,
		javax: false,
		JSAdapter: false,
		load: false,
		loadWithNewGlobal: false,
		org: false,
		Packages: false,
		print: false,
		quit: false
	};
	var wsh$1 = {
		ActiveXObject: false,
		CollectGarbage: false,
		Debug: false,
		Enumerator: false,
		GetObject: false,
		RuntimeObject: false,
		ScriptEngine: false,
		ScriptEngineBuildVersion: false,
		ScriptEngineMajorVersion: false,
		ScriptEngineMinorVersion: false,
		VBArray: false,
		WScript: false,
		WSH: false
	};
	var jquery$1 = {
		$: false,
		jQuery: false
	};
	var yui$1 = {
		YAHOO: false,
		YAHOO_config: false,
		YUI: false,
		YUI_config: false
	};
	var shelljs$1 = {
		cat: false,
		cd: false,
		chmod: false,
		config: false,
		cp: false,
		dirs: false,
		echo: false,
		env: false,
		error: false,
		exec: false,
		exit: false,
		find: false,
		grep: false,
		ln: false,
		ls: false,
		mkdir: false,
		mv: false,
		popd: false,
		pushd: false,
		pwd: false,
		rm: false,
		sed: false,
		set: false,
		target: false,
		tempdir: false,
		test: false,
		touch: false,
		which: false
	};
	var prototypejs$1 = {
		$: false,
		$$: false,
		$A: false,
		$break: false,
		$continue: false,
		$F: false,
		$H: false,
		$R: false,
		$w: false,
		Abstract: false,
		Ajax: false,
		Autocompleter: false,
		Builder: false,
		Class: false,
		Control: false,
		Draggable: false,
		Draggables: false,
		Droppables: false,
		Effect: false,
		Element: false,
		Enumerable: false,
		Event: false,
		Field: false,
		Form: false,
		Hash: false,
		Insertion: false,
		ObjectRange: false,
		PeriodicalExecuter: false,
		Position: false,
		Prototype: false,
		Scriptaculous: false,
		Selector: false,
		Sortable: false,
		SortableObserver: false,
		Sound: false,
		Template: false,
		Toggle: false,
		Try: false
	};
	var meteor$1 = {
		$: false,
		Accounts: false,
		AccountsClient: false,
		AccountsCommon: false,
		AccountsServer: false,
		App: false,
		Assets: false,
		Blaze: false,
		check: false,
		Cordova: false,
		DDP: false,
		DDPRateLimiter: false,
		DDPServer: false,
		Deps: false,
		EJSON: false,
		Email: false,
		HTTP: false,
		Log: false,
		Match: false,
		Meteor: false,
		Mongo: false,
		MongoInternals: false,
		Npm: false,
		Package: false,
		Plugin: false,
		process: false,
		Random: false,
		ReactiveDict: false,
		ReactiveVar: false,
		Router: false,
		ServiceConfiguration: false,
		Session: false,
		share: false,
		Spacebars: false,
		Template: false,
		Tinytest: false,
		Tracker: false,
		UI: false,
		Utils: false,
		WebApp: false,
		WebAppInternals: false
	};
	var mongo$1 = {
		_isWindows: false,
		_rand: false,
		BulkWriteResult: false,
		cat: false,
		cd: false,
		connect: false,
		db: false,
		getHostName: false,
		getMemInfo: false,
		hostname: false,
		ISODate: false,
		listFiles: false,
		load: false,
		ls: false,
		md5sumFile: false,
		mkdir: false,
		Mongo: false,
		NumberInt: false,
		NumberLong: false,
		ObjectId: false,
		PlanCache: false,
		print: false,
		printjson: false,
		pwd: false,
		quit: false,
		removeFile: false,
		rs: false,
		sh: false,
		UUID: false,
		version: false,
		WriteResult: false
	};
	var applescript$1 = {
		$: false,
		Application: false,
		Automation: false,
		console: false,
		delay: false,
		Library: false,
		ObjC: false,
		ObjectSpecifier: false,
		Path: false,
		Progress: false,
		Ref: false
	};
	var serviceworker$1 = {
		addEventListener: false,
		applicationCache: false,
		atob: false,
		Blob: false,
		BroadcastChannel: false,
		btoa: false,
		Cache: false,
		caches: false,
		CacheStorage: false,
		clearInterval: false,
		clearTimeout: false,
		Client: false,
		clients: false,
		Clients: false,
		close: true,
		console: false,
		ExtendableEvent: false,
		ExtendableMessageEvent: false,
		fetch: false,
		FetchEvent: false,
		FileReaderSync: false,
		FormData: false,
		Headers: false,
		IDBCursor: false,
		IDBCursorWithValue: false,
		IDBDatabase: false,
		IDBFactory: false,
		IDBIndex: false,
		IDBKeyRange: false,
		IDBObjectStore: false,
		IDBOpenDBRequest: false,
		IDBRequest: false,
		IDBTransaction: false,
		IDBVersionChangeEvent: false,
		ImageData: false,
		importScripts: false,
		indexedDB: false,
		location: false,
		MessageChannel: false,
		MessagePort: false,
		name: false,
		navigator: false,
		Notification: false,
		onclose: true,
		onconnect: true,
		onerror: true,
		onfetch: true,
		oninstall: true,
		onlanguagechange: true,
		onmessage: true,
		onmessageerror: true,
		onnotificationclick: true,
		onnotificationclose: true,
		onoffline: true,
		ononline: true,
		onpush: true,
		onpushsubscriptionchange: true,
		onrejectionhandled: true,
		onsync: true,
		onunhandledrejection: true,
		performance: false,
		Performance: false,
		PerformanceEntry: false,
		PerformanceMark: false,
		PerformanceMeasure: false,
		PerformanceNavigation: false,
		PerformanceResourceTiming: false,
		PerformanceTiming: false,
		postMessage: true,
		"Promise": false,
		queueMicrotask: false,
		registration: false,
		removeEventListener: false,
		Request: false,
		Response: false,
		self: false,
		ServiceWorker: false,
		ServiceWorkerContainer: false,
		ServiceWorkerGlobalScope: false,
		ServiceWorkerMessageEvent: false,
		ServiceWorkerRegistration: false,
		setInterval: false,
		setTimeout: false,
		skipWaiting: false,
		TextDecoder: false,
		TextEncoder: false,
		URL: false,
		URLSearchParams: false,
		WebSocket: false,
		WindowClient: false,
		Worker: false,
		WorkerGlobalScope: false,
		XMLHttpRequest: false
	};
	var atomtest$1 = {
		advanceClock: false,
		atom: false,
		fakeClearInterval: false,
		fakeClearTimeout: false,
		fakeSetInterval: false,
		fakeSetTimeout: false,
		resetTimeouts: false,
		waitsForPromise: false
	};
	var embertest$1 = {
		andThen: false,
		click: false,
		currentPath: false,
		currentRouteName: false,
		currentURL: false,
		fillIn: false,
		find: false,
		findAll: false,
		findWithAssert: false,
		keyEvent: false,
		pauseTest: false,
		resumeTest: false,
		triggerEvent: false,
		visit: false,
		wait: false
	};
	var protractor$1 = {
		$: false,
		$$: false,
		browser: false,
		by: false,
		By: false,
		DartObject: false,
		element: false,
		protractor: false
	};
	var webextensions$1 = {
		browser: false,
		chrome: false,
		opr: false
	};
	var greasemonkey$1 = {
		cloneInto: false,
		createObjectIn: false,
		exportFunction: false,
		GM: false,
		GM_addStyle: false,
		GM_addValueChangeListener: false,
		GM_deleteValue: false,
		GM_download: false,
		GM_getResourceText: false,
		GM_getResourceURL: false,
		GM_getTab: false,
		GM_getTabs: false,
		GM_getValue: false,
		GM_info: false,
		GM_listValues: false,
		GM_log: false,
		GM_notification: false,
		GM_openInTab: false,
		GM_registerMenuCommand: false,
		GM_removeValueChangeListener: false,
		GM_saveTab: false,
		GM_setClipboard: false,
		GM_setValue: false,
		GM_unregisterMenuCommand: false,
		GM_xmlhttpRequest: false,
		unsafeWindow: false
	};
	var devtools$1 = {
		$: false,
		$_: false,
		$$: false,
		$0: false,
		$1: false,
		$2: false,
		$3: false,
		$4: false,
		$x: false,
		chrome: false,
		clear: false,
		copy: false,
		debug: false,
		dir: false,
		dirxml: false,
		getEventListeners: false,
		inspect: false,
		keys: false,
		monitor: false,
		monitorEvents: false,
		profile: false,
		profileEnd: false,
		queryObjects: false,
		table: false,
		undebug: false,
		unmonitor: false,
		unmonitorEvents: false,
		values: false
	};
	var require$$0$2 = {
		builtin: builtin$1,
		es5: es5$1,
		es2015: es2015$1,
		es2017: es2017$1,
		es2020: es2020,
		es2021: es2021,
		browser: browser$3,
		worker: worker$1,
		node: node$1,
		nodeBuiltin: nodeBuiltin,
		commonjs: commonjs$1,
		amd: amd$1,
		mocha: mocha$1,
		jasmine: jasmine$1,
		jest: jest$1,
		qunit: qunit$1,
		phantomjs: phantomjs$1,
		couch: couch$1,
		rhino: rhino$1,
		nashorn: nashorn$1,
		wsh: wsh$1,
		jquery: jquery$1,
		yui: yui$1,
		shelljs: shelljs$1,
		prototypejs: prototypejs$1,
		meteor: meteor$1,
		mongo: mongo$1,
		applescript: applescript$1,
		serviceworker: serviceworker$1,
		atomtest: atomtest$1,
		embertest: embertest$1,
		protractor: protractor$1,
		"shared-node-browser": {
		clearInterval: false,
		clearTimeout: false,
		console: false,
		setInterval: false,
		setTimeout: false,
		URL: false,
		URLSearchParams: false
	},
		webextensions: webextensions$1,
		greasemonkey: greasemonkey$1,
		devtools: devtools$1
	};

	var globalsBABEL_8_BREAKINGTrue = require$$0$2;

	var builtin = {
		"Array": false,
		"ArrayBuffer": false,
		Atomics: false,
		BigInt: false,
		BigInt64Array: false,
		BigUint64Array: false,
		"Boolean": false,
		constructor: false,
		"DataView": false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		"Float32Array": false,
		"Float64Array": false,
		"Function": false,
		globalThis: false,
		hasOwnProperty: false,
		"Infinity": false,
		"Int16Array": false,
		"Int32Array": false,
		"Int8Array": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Map": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		"Promise": false,
		propertyIsEnumerable: false,
		"Proxy": false,
		"RangeError": false,
		"ReferenceError": false,
		"Reflect": false,
		"RegExp": false,
		"Set": false,
		SharedArrayBuffer: false,
		"String": false,
		"Symbol": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"Uint16Array": false,
		"Uint32Array": false,
		"Uint8Array": false,
		"Uint8ClampedArray": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false,
		"WeakMap": false,
		"WeakSet": false
	};
	var es5 = {
		"Array": false,
		"Boolean": false,
		constructor: false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		"Function": false,
		hasOwnProperty: false,
		"Infinity": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		propertyIsEnumerable: false,
		"RangeError": false,
		"ReferenceError": false,
		"RegExp": false,
		"String": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false
	};
	var es2015 = {
		"Array": false,
		"ArrayBuffer": false,
		"Boolean": false,
		constructor: false,
		"DataView": false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		"Float32Array": false,
		"Float64Array": false,
		"Function": false,
		hasOwnProperty: false,
		"Infinity": false,
		"Int16Array": false,
		"Int32Array": false,
		"Int8Array": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Map": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		"Promise": false,
		propertyIsEnumerable: false,
		"Proxy": false,
		"RangeError": false,
		"ReferenceError": false,
		"Reflect": false,
		"RegExp": false,
		"Set": false,
		"String": false,
		"Symbol": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"Uint16Array": false,
		"Uint32Array": false,
		"Uint8Array": false,
		"Uint8ClampedArray": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false,
		"WeakMap": false,
		"WeakSet": false
	};
	var es2017 = {
		"Array": false,
		"ArrayBuffer": false,
		Atomics: false,
		"Boolean": false,
		constructor: false,
		"DataView": false,
		"Date": false,
		"decodeURI": false,
		"decodeURIComponent": false,
		"encodeURI": false,
		"encodeURIComponent": false,
		"Error": false,
		"escape": false,
		"eval": false,
		"EvalError": false,
		"Float32Array": false,
		"Float64Array": false,
		"Function": false,
		hasOwnProperty: false,
		"Infinity": false,
		"Int16Array": false,
		"Int32Array": false,
		"Int8Array": false,
		"isFinite": false,
		"isNaN": false,
		isPrototypeOf: false,
		"JSON": false,
		"Map": false,
		"Math": false,
		"NaN": false,
		"Number": false,
		"Object": false,
		"parseFloat": false,
		"parseInt": false,
		"Promise": false,
		propertyIsEnumerable: false,
		"Proxy": false,
		"RangeError": false,
		"ReferenceError": false,
		"Reflect": false,
		"RegExp": false,
		"Set": false,
		SharedArrayBuffer: false,
		"String": false,
		"Symbol": false,
		"SyntaxError": false,
		toLocaleString: false,
		toString: false,
		"TypeError": false,
		"Uint16Array": false,
		"Uint32Array": false,
		"Uint8Array": false,
		"Uint8ClampedArray": false,
		"undefined": false,
		"unescape": false,
		"URIError": false,
		valueOf: false,
		"WeakMap": false,
		"WeakSet": false
	};
	var browser$2 = {
		AbortController: false,
		AbortSignal: false,
		addEventListener: false,
		alert: false,
		AnalyserNode: false,
		Animation: false,
		AnimationEffectReadOnly: false,
		AnimationEffectTiming: false,
		AnimationEffectTimingReadOnly: false,
		AnimationEvent: false,
		AnimationPlaybackEvent: false,
		AnimationTimeline: false,
		applicationCache: false,
		ApplicationCache: false,
		ApplicationCacheErrorEvent: false,
		atob: false,
		Attr: false,
		Audio: false,
		AudioBuffer: false,
		AudioBufferSourceNode: false,
		AudioContext: false,
		AudioDestinationNode: false,
		AudioListener: false,
		AudioNode: false,
		AudioParam: false,
		AudioProcessingEvent: false,
		AudioScheduledSourceNode: false,
		"AudioWorkletGlobalScope ": false,
		AudioWorkletNode: false,
		AudioWorkletProcessor: false,
		BarProp: false,
		BaseAudioContext: false,
		BatteryManager: false,
		BeforeUnloadEvent: false,
		BiquadFilterNode: false,
		Blob: false,
		BlobEvent: false,
		blur: false,
		BroadcastChannel: false,
		btoa: false,
		BudgetService: false,
		ByteLengthQueuingStrategy: false,
		Cache: false,
		caches: false,
		CacheStorage: false,
		cancelAnimationFrame: false,
		cancelIdleCallback: false,
		CanvasCaptureMediaStreamTrack: false,
		CanvasGradient: false,
		CanvasPattern: false,
		CanvasRenderingContext2D: false,
		ChannelMergerNode: false,
		ChannelSplitterNode: false,
		CharacterData: false,
		clearInterval: false,
		clearTimeout: false,
		clientInformation: false,
		ClipboardEvent: false,
		close: false,
		closed: false,
		CloseEvent: false,
		Comment: false,
		CompositionEvent: false,
		confirm: false,
		console: false,
		ConstantSourceNode: false,
		ConvolverNode: false,
		CountQueuingStrategy: false,
		createImageBitmap: false,
		Credential: false,
		CredentialsContainer: false,
		crypto: false,
		Crypto: false,
		CryptoKey: false,
		CSS: false,
		CSSConditionRule: false,
		CSSFontFaceRule: false,
		CSSGroupingRule: false,
		CSSImportRule: false,
		CSSKeyframeRule: false,
		CSSKeyframesRule: false,
		CSSMediaRule: false,
		CSSNamespaceRule: false,
		CSSPageRule: false,
		CSSRule: false,
		CSSRuleList: false,
		CSSStyleDeclaration: false,
		CSSStyleRule: false,
		CSSStyleSheet: false,
		CSSSupportsRule: false,
		CustomElementRegistry: false,
		customElements: false,
		CustomEvent: false,
		DataTransfer: false,
		DataTransferItem: false,
		DataTransferItemList: false,
		defaultstatus: false,
		defaultStatus: false,
		DelayNode: false,
		DeviceMotionEvent: false,
		DeviceOrientationEvent: false,
		devicePixelRatio: false,
		dispatchEvent: false,
		document: false,
		Document: false,
		DocumentFragment: false,
		DocumentType: false,
		DOMError: false,
		DOMException: false,
		DOMImplementation: false,
		DOMMatrix: false,
		DOMMatrixReadOnly: false,
		DOMParser: false,
		DOMPoint: false,
		DOMPointReadOnly: false,
		DOMQuad: false,
		DOMRect: false,
		DOMRectReadOnly: false,
		DOMStringList: false,
		DOMStringMap: false,
		DOMTokenList: false,
		DragEvent: false,
		DynamicsCompressorNode: false,
		Element: false,
		ErrorEvent: false,
		event: false,
		Event: false,
		EventSource: false,
		EventTarget: false,
		external: false,
		fetch: false,
		File: false,
		FileList: false,
		FileReader: false,
		find: false,
		focus: false,
		FocusEvent: false,
		FontFace: false,
		FontFaceSetLoadEvent: false,
		FormData: false,
		frameElement: false,
		frames: false,
		GainNode: false,
		Gamepad: false,
		GamepadButton: false,
		GamepadEvent: false,
		getComputedStyle: false,
		getSelection: false,
		HashChangeEvent: false,
		Headers: false,
		history: false,
		History: false,
		HTMLAllCollection: false,
		HTMLAnchorElement: false,
		HTMLAreaElement: false,
		HTMLAudioElement: false,
		HTMLBaseElement: false,
		HTMLBodyElement: false,
		HTMLBRElement: false,
		HTMLButtonElement: false,
		HTMLCanvasElement: false,
		HTMLCollection: false,
		HTMLContentElement: false,
		HTMLDataElement: false,
		HTMLDataListElement: false,
		HTMLDetailsElement: false,
		HTMLDialogElement: false,
		HTMLDirectoryElement: false,
		HTMLDivElement: false,
		HTMLDListElement: false,
		HTMLDocument: false,
		HTMLElement: false,
		HTMLEmbedElement: false,
		HTMLFieldSetElement: false,
		HTMLFontElement: false,
		HTMLFormControlsCollection: false,
		HTMLFormElement: false,
		HTMLFrameElement: false,
		HTMLFrameSetElement: false,
		HTMLHeadElement: false,
		HTMLHeadingElement: false,
		HTMLHRElement: false,
		HTMLHtmlElement: false,
		HTMLIFrameElement: false,
		HTMLImageElement: false,
		HTMLInputElement: false,
		HTMLLabelElement: false,
		HTMLLegendElement: false,
		HTMLLIElement: false,
		HTMLLinkElement: false,
		HTMLMapElement: false,
		HTMLMarqueeElement: false,
		HTMLMediaElement: false,
		HTMLMenuElement: false,
		HTMLMetaElement: false,
		HTMLMeterElement: false,
		HTMLModElement: false,
		HTMLObjectElement: false,
		HTMLOListElement: false,
		HTMLOptGroupElement: false,
		HTMLOptionElement: false,
		HTMLOptionsCollection: false,
		HTMLOutputElement: false,
		HTMLParagraphElement: false,
		HTMLParamElement: false,
		HTMLPictureElement: false,
		HTMLPreElement: false,
		HTMLProgressElement: false,
		HTMLQuoteElement: false,
		HTMLScriptElement: false,
		HTMLSelectElement: false,
		HTMLShadowElement: false,
		HTMLSlotElement: false,
		HTMLSourceElement: false,
		HTMLSpanElement: false,
		HTMLStyleElement: false,
		HTMLTableCaptionElement: false,
		HTMLTableCellElement: false,
		HTMLTableColElement: false,
		HTMLTableElement: false,
		HTMLTableRowElement: false,
		HTMLTableSectionElement: false,
		HTMLTemplateElement: false,
		HTMLTextAreaElement: false,
		HTMLTimeElement: false,
		HTMLTitleElement: false,
		HTMLTrackElement: false,
		HTMLUListElement: false,
		HTMLUnknownElement: false,
		HTMLVideoElement: false,
		IDBCursor: false,
		IDBCursorWithValue: false,
		IDBDatabase: false,
		IDBFactory: false,
		IDBIndex: false,
		IDBKeyRange: false,
		IDBObjectStore: false,
		IDBOpenDBRequest: false,
		IDBRequest: false,
		IDBTransaction: false,
		IDBVersionChangeEvent: false,
		IdleDeadline: false,
		IIRFilterNode: false,
		Image: false,
		ImageBitmap: false,
		ImageBitmapRenderingContext: false,
		ImageCapture: false,
		ImageData: false,
		indexedDB: false,
		innerHeight: false,
		innerWidth: false,
		InputEvent: false,
		IntersectionObserver: false,
		IntersectionObserverEntry: false,
		"Intl": false,
		isSecureContext: false,
		KeyboardEvent: false,
		KeyframeEffect: false,
		KeyframeEffectReadOnly: false,
		length: false,
		localStorage: false,
		location: true,
		Location: false,
		locationbar: false,
		matchMedia: false,
		MediaDeviceInfo: false,
		MediaDevices: false,
		MediaElementAudioSourceNode: false,
		MediaEncryptedEvent: false,
		MediaError: false,
		MediaKeyMessageEvent: false,
		MediaKeySession: false,
		MediaKeyStatusMap: false,
		MediaKeySystemAccess: false,
		MediaList: false,
		MediaQueryList: false,
		MediaQueryListEvent: false,
		MediaRecorder: false,
		MediaSettingsRange: false,
		MediaSource: false,
		MediaStream: false,
		MediaStreamAudioDestinationNode: false,
		MediaStreamAudioSourceNode: false,
		MediaStreamEvent: false,
		MediaStreamTrack: false,
		MediaStreamTrackEvent: false,
		menubar: false,
		MessageChannel: false,
		MessageEvent: false,
		MessagePort: false,
		MIDIAccess: false,
		MIDIConnectionEvent: false,
		MIDIInput: false,
		MIDIInputMap: false,
		MIDIMessageEvent: false,
		MIDIOutput: false,
		MIDIOutputMap: false,
		MIDIPort: false,
		MimeType: false,
		MimeTypeArray: false,
		MouseEvent: false,
		moveBy: false,
		moveTo: false,
		MutationEvent: false,
		MutationObserver: false,
		MutationRecord: false,
		name: false,
		NamedNodeMap: false,
		NavigationPreloadManager: false,
		navigator: false,
		Navigator: false,
		NetworkInformation: false,
		Node: false,
		NodeFilter: false,
		NodeIterator: false,
		NodeList: false,
		Notification: false,
		OfflineAudioCompletionEvent: false,
		OfflineAudioContext: false,
		offscreenBuffering: false,
		OffscreenCanvas: true,
		onabort: true,
		onafterprint: true,
		onanimationend: true,
		onanimationiteration: true,
		onanimationstart: true,
		onappinstalled: true,
		onauxclick: true,
		onbeforeinstallprompt: true,
		onbeforeprint: true,
		onbeforeunload: true,
		onblur: true,
		oncancel: true,
		oncanplay: true,
		oncanplaythrough: true,
		onchange: true,
		onclick: true,
		onclose: true,
		oncontextmenu: true,
		oncuechange: true,
		ondblclick: true,
		ondevicemotion: true,
		ondeviceorientation: true,
		ondeviceorientationabsolute: true,
		ondrag: true,
		ondragend: true,
		ondragenter: true,
		ondragleave: true,
		ondragover: true,
		ondragstart: true,
		ondrop: true,
		ondurationchange: true,
		onemptied: true,
		onended: true,
		onerror: true,
		onfocus: true,
		ongotpointercapture: true,
		onhashchange: true,
		oninput: true,
		oninvalid: true,
		onkeydown: true,
		onkeypress: true,
		onkeyup: true,
		onlanguagechange: true,
		onload: true,
		onloadeddata: true,
		onloadedmetadata: true,
		onloadstart: true,
		onlostpointercapture: true,
		onmessage: true,
		onmessageerror: true,
		onmousedown: true,
		onmouseenter: true,
		onmouseleave: true,
		onmousemove: true,
		onmouseout: true,
		onmouseover: true,
		onmouseup: true,
		onmousewheel: true,
		onoffline: true,
		ononline: true,
		onpagehide: true,
		onpageshow: true,
		onpause: true,
		onplay: true,
		onplaying: true,
		onpointercancel: true,
		onpointerdown: true,
		onpointerenter: true,
		onpointerleave: true,
		onpointermove: true,
		onpointerout: true,
		onpointerover: true,
		onpointerup: true,
		onpopstate: true,
		onprogress: true,
		onratechange: true,
		onrejectionhandled: true,
		onreset: true,
		onresize: true,
		onscroll: true,
		onsearch: true,
		onseeked: true,
		onseeking: true,
		onselect: true,
		onstalled: true,
		onstorage: true,
		onsubmit: true,
		onsuspend: true,
		ontimeupdate: true,
		ontoggle: true,
		ontransitionend: true,
		onunhandledrejection: true,
		onunload: true,
		onvolumechange: true,
		onwaiting: true,
		onwheel: true,
		open: false,
		openDatabase: false,
		opener: false,
		Option: false,
		origin: false,
		OscillatorNode: false,
		outerHeight: false,
		outerWidth: false,
		PageTransitionEvent: false,
		pageXOffset: false,
		pageYOffset: false,
		PannerNode: false,
		parent: false,
		Path2D: false,
		PaymentAddress: false,
		PaymentRequest: false,
		PaymentRequestUpdateEvent: false,
		PaymentResponse: false,
		performance: false,
		Performance: false,
		PerformanceEntry: false,
		PerformanceLongTaskTiming: false,
		PerformanceMark: false,
		PerformanceMeasure: false,
		PerformanceNavigation: false,
		PerformanceNavigationTiming: false,
		PerformanceObserver: false,
		PerformanceObserverEntryList: false,
		PerformancePaintTiming: false,
		PerformanceResourceTiming: false,
		PerformanceTiming: false,
		PeriodicWave: false,
		Permissions: false,
		PermissionStatus: false,
		personalbar: false,
		PhotoCapabilities: false,
		Plugin: false,
		PluginArray: false,
		PointerEvent: false,
		PopStateEvent: false,
		postMessage: false,
		Presentation: false,
		PresentationAvailability: false,
		PresentationConnection: false,
		PresentationConnectionAvailableEvent: false,
		PresentationConnectionCloseEvent: false,
		PresentationConnectionList: false,
		PresentationReceiver: false,
		PresentationRequest: false,
		print: false,
		ProcessingInstruction: false,
		ProgressEvent: false,
		PromiseRejectionEvent: false,
		prompt: false,
		PushManager: false,
		PushSubscription: false,
		PushSubscriptionOptions: false,
		queueMicrotask: false,
		RadioNodeList: false,
		Range: false,
		ReadableStream: false,
		registerProcessor: false,
		RemotePlayback: false,
		removeEventListener: false,
		Request: false,
		requestAnimationFrame: false,
		requestIdleCallback: false,
		resizeBy: false,
		ResizeObserver: false,
		ResizeObserverEntry: false,
		resizeTo: false,
		Response: false,
		RTCCertificate: false,
		RTCDataChannel: false,
		RTCDataChannelEvent: false,
		RTCDtlsTransport: false,
		RTCIceCandidate: false,
		RTCIceGatherer: false,
		RTCIceTransport: false,
		RTCPeerConnection: false,
		RTCPeerConnectionIceEvent: false,
		RTCRtpContributingSource: false,
		RTCRtpReceiver: false,
		RTCRtpSender: false,
		RTCSctpTransport: false,
		RTCSessionDescription: false,
		RTCStatsReport: false,
		RTCTrackEvent: false,
		screen: false,
		Screen: false,
		screenLeft: false,
		ScreenOrientation: false,
		screenTop: false,
		screenX: false,
		screenY: false,
		ScriptProcessorNode: false,
		scroll: false,
		scrollbars: false,
		scrollBy: false,
		scrollTo: false,
		scrollX: false,
		scrollY: false,
		SecurityPolicyViolationEvent: false,
		Selection: false,
		self: false,
		ServiceWorker: false,
		ServiceWorkerContainer: false,
		ServiceWorkerRegistration: false,
		sessionStorage: false,
		setInterval: false,
		setTimeout: false,
		ShadowRoot: false,
		SharedWorker: false,
		SourceBuffer: false,
		SourceBufferList: false,
		speechSynthesis: false,
		SpeechSynthesisEvent: false,
		SpeechSynthesisUtterance: false,
		StaticRange: false,
		status: false,
		statusbar: false,
		StereoPannerNode: false,
		stop: false,
		Storage: false,
		StorageEvent: false,
		StorageManager: false,
		styleMedia: false,
		StyleSheet: false,
		StyleSheetList: false,
		SubtleCrypto: false,
		SVGAElement: false,
		SVGAngle: false,
		SVGAnimatedAngle: false,
		SVGAnimatedBoolean: false,
		SVGAnimatedEnumeration: false,
		SVGAnimatedInteger: false,
		SVGAnimatedLength: false,
		SVGAnimatedLengthList: false,
		SVGAnimatedNumber: false,
		SVGAnimatedNumberList: false,
		SVGAnimatedPreserveAspectRatio: false,
		SVGAnimatedRect: false,
		SVGAnimatedString: false,
		SVGAnimatedTransformList: false,
		SVGAnimateElement: false,
		SVGAnimateMotionElement: false,
		SVGAnimateTransformElement: false,
		SVGAnimationElement: false,
		SVGCircleElement: false,
		SVGClipPathElement: false,
		SVGComponentTransferFunctionElement: false,
		SVGDefsElement: false,
		SVGDescElement: false,
		SVGDiscardElement: false,
		SVGElement: false,
		SVGEllipseElement: false,
		SVGFEBlendElement: false,
		SVGFEColorMatrixElement: false,
		SVGFEComponentTransferElement: false,
		SVGFECompositeElement: false,
		SVGFEConvolveMatrixElement: false,
		SVGFEDiffuseLightingElement: false,
		SVGFEDisplacementMapElement: false,
		SVGFEDistantLightElement: false,
		SVGFEDropShadowElement: false,
		SVGFEFloodElement: false,
		SVGFEFuncAElement: false,
		SVGFEFuncBElement: false,
		SVGFEFuncGElement: false,
		SVGFEFuncRElement: false,
		SVGFEGaussianBlurElement: false,
		SVGFEImageElement: false,
		SVGFEMergeElement: false,
		SVGFEMergeNodeElement: false,
		SVGFEMorphologyElement: false,
		SVGFEOffsetElement: false,
		SVGFEPointLightElement: false,
		SVGFESpecularLightingElement: false,
		SVGFESpotLightElement: false,
		SVGFETileElement: false,
		SVGFETurbulenceElement: false,
		SVGFilterElement: false,
		SVGForeignObjectElement: false,
		SVGGElement: false,
		SVGGeometryElement: false,
		SVGGradientElement: false,
		SVGGraphicsElement: false,
		SVGImageElement: false,
		SVGLength: false,
		SVGLengthList: false,
		SVGLinearGradientElement: false,
		SVGLineElement: false,
		SVGMarkerElement: false,
		SVGMaskElement: false,
		SVGMatrix: false,
		SVGMetadataElement: false,
		SVGMPathElement: false,
		SVGNumber: false,
		SVGNumberList: false,
		SVGPathElement: false,
		SVGPatternElement: false,
		SVGPoint: false,
		SVGPointList: false,
		SVGPolygonElement: false,
		SVGPolylineElement: false,
		SVGPreserveAspectRatio: false,
		SVGRadialGradientElement: false,
		SVGRect: false,
		SVGRectElement: false,
		SVGScriptElement: false,
		SVGSetElement: false,
		SVGStopElement: false,
		SVGStringList: false,
		SVGStyleElement: false,
		SVGSVGElement: false,
		SVGSwitchElement: false,
		SVGSymbolElement: false,
		SVGTextContentElement: false,
		SVGTextElement: false,
		SVGTextPathElement: false,
		SVGTextPositioningElement: false,
		SVGTitleElement: false,
		SVGTransform: false,
		SVGTransformList: false,
		SVGTSpanElement: false,
		SVGUnitTypes: false,
		SVGUseElement: false,
		SVGViewElement: false,
		TaskAttributionTiming: false,
		Text: false,
		TextDecoder: false,
		TextEncoder: false,
		TextEvent: false,
		TextMetrics: false,
		TextTrack: false,
		TextTrackCue: false,
		TextTrackCueList: false,
		TextTrackList: false,
		TimeRanges: false,
		toolbar: false,
		top: false,
		Touch: false,
		TouchEvent: false,
		TouchList: false,
		TrackEvent: false,
		TransitionEvent: false,
		TreeWalker: false,
		UIEvent: false,
		URL: false,
		URLSearchParams: false,
		ValidityState: false,
		visualViewport: false,
		VisualViewport: false,
		VTTCue: false,
		WaveShaperNode: false,
		WebAssembly: false,
		WebGL2RenderingContext: false,
		WebGLActiveInfo: false,
		WebGLBuffer: false,
		WebGLContextEvent: false,
		WebGLFramebuffer: false,
		WebGLProgram: false,
		WebGLQuery: false,
		WebGLRenderbuffer: false,
		WebGLRenderingContext: false,
		WebGLSampler: false,
		WebGLShader: false,
		WebGLShaderPrecisionFormat: false,
		WebGLSync: false,
		WebGLTexture: false,
		WebGLTransformFeedback: false,
		WebGLUniformLocation: false,
		WebGLVertexArrayObject: false,
		WebSocket: false,
		WheelEvent: false,
		window: false,
		Window: false,
		Worker: false,
		WritableStream: false,
		XMLDocument: false,
		XMLHttpRequest: false,
		XMLHttpRequestEventTarget: false,
		XMLHttpRequestUpload: false,
		XMLSerializer: false,
		XPathEvaluator: false,
		XPathExpression: false,
		XPathResult: false,
		XSLTProcessor: false
	};
	var worker = {
		addEventListener: false,
		applicationCache: false,
		atob: false,
		Blob: false,
		BroadcastChannel: false,
		btoa: false,
		Cache: false,
		caches: false,
		clearInterval: false,
		clearTimeout: false,
		close: true,
		console: false,
		fetch: false,
		FileReaderSync: false,
		FormData: false,
		Headers: false,
		IDBCursor: false,
		IDBCursorWithValue: false,
		IDBDatabase: false,
		IDBFactory: false,
		IDBIndex: false,
		IDBKeyRange: false,
		IDBObjectStore: false,
		IDBOpenDBRequest: false,
		IDBRequest: false,
		IDBTransaction: false,
		IDBVersionChangeEvent: false,
		ImageData: false,
		importScripts: true,
		indexedDB: false,
		location: false,
		MessageChannel: false,
		MessagePort: false,
		name: false,
		navigator: false,
		Notification: false,
		onclose: true,
		onconnect: true,
		onerror: true,
		onlanguagechange: true,
		onmessage: true,
		onoffline: true,
		ononline: true,
		onrejectionhandled: true,
		onunhandledrejection: true,
		performance: false,
		Performance: false,
		PerformanceEntry: false,
		PerformanceMark: false,
		PerformanceMeasure: false,
		PerformanceNavigation: false,
		PerformanceResourceTiming: false,
		PerformanceTiming: false,
		postMessage: true,
		"Promise": false,
		queueMicrotask: false,
		removeEventListener: false,
		Request: false,
		Response: false,
		self: true,
		ServiceWorkerRegistration: false,
		setInterval: false,
		setTimeout: false,
		TextDecoder: false,
		TextEncoder: false,
		URL: false,
		URLSearchParams: false,
		WebSocket: false,
		Worker: false,
		WorkerGlobalScope: false,
		XMLHttpRequest: false
	};
	var node = {
		__dirname: false,
		__filename: false,
		Buffer: false,
		clearImmediate: false,
		clearInterval: false,
		clearTimeout: false,
		console: false,
		exports: true,
		global: false,
		"Intl": false,
		module: false,
		process: false,
		queueMicrotask: false,
		require: false,
		setImmediate: false,
		setInterval: false,
		setTimeout: false,
		TextDecoder: false,
		TextEncoder: false,
		URL: false,
		URLSearchParams: false
	};
	var commonjs = {
		exports: true,
		global: false,
		module: false,
		require: false
	};
	var amd = {
		define: false,
		require: false
	};
	var mocha = {
		after: false,
		afterEach: false,
		before: false,
		beforeEach: false,
		context: false,
		describe: false,
		it: false,
		mocha: false,
		run: false,
		setup: false,
		specify: false,
		suite: false,
		suiteSetup: false,
		suiteTeardown: false,
		teardown: false,
		test: false,
		xcontext: false,
		xdescribe: false,
		xit: false,
		xspecify: false
	};
	var jasmine = {
		afterAll: false,
		afterEach: false,
		beforeAll: false,
		beforeEach: false,
		describe: false,
		expect: false,
		fail: false,
		fdescribe: false,
		fit: false,
		it: false,
		jasmine: false,
		pending: false,
		runs: false,
		spyOn: false,
		spyOnProperty: false,
		waits: false,
		waitsFor: false,
		xdescribe: false,
		xit: false
	};
	var jest = {
		afterAll: false,
		afterEach: false,
		beforeAll: false,
		beforeEach: false,
		describe: false,
		expect: false,
		fdescribe: false,
		fit: false,
		it: false,
		jest: false,
		pit: false,
		require: false,
		test: false,
		xdescribe: false,
		xit: false,
		xtest: false
	};
	var qunit = {
		asyncTest: false,
		deepEqual: false,
		equal: false,
		expect: false,
		module: false,
		notDeepEqual: false,
		notEqual: false,
		notOk: false,
		notPropEqual: false,
		notStrictEqual: false,
		ok: false,
		propEqual: false,
		QUnit: false,
		raises: false,
		start: false,
		stop: false,
		strictEqual: false,
		test: false,
		throws: false
	};
	var phantomjs = {
		console: true,
		exports: true,
		phantom: true,
		require: true,
		WebPage: true
	};
	var couch = {
		emit: false,
		exports: false,
		getRow: false,
		log: false,
		module: false,
		provides: false,
		require: false,
		respond: false,
		send: false,
		start: false,
		sum: false
	};
	var rhino = {
		defineClass: false,
		deserialize: false,
		gc: false,
		help: false,
		importClass: false,
		importPackage: false,
		java: false,
		load: false,
		loadClass: false,
		Packages: false,
		print: false,
		quit: false,
		readFile: false,
		readUrl: false,
		runCommand: false,
		seal: false,
		serialize: false,
		spawn: false,
		sync: false,
		toint32: false,
		version: false
	};
	var nashorn = {
		__DIR__: false,
		__FILE__: false,
		__LINE__: false,
		com: false,
		edu: false,
		exit: false,
		java: false,
		Java: false,
		javafx: false,
		JavaImporter: false,
		javax: false,
		JSAdapter: false,
		load: false,
		loadWithNewGlobal: false,
		org: false,
		Packages: false,
		print: false,
		quit: false
	};
	var wsh = {
		ActiveXObject: true,
		Enumerator: true,
		GetObject: true,
		ScriptEngine: true,
		ScriptEngineBuildVersion: true,
		ScriptEngineMajorVersion: true,
		ScriptEngineMinorVersion: true,
		VBArray: true,
		WScript: true,
		WSH: true,
		XDomainRequest: true
	};
	var jquery = {
		$: false,
		jQuery: false
	};
	var yui = {
		YAHOO: false,
		YAHOO_config: false,
		YUI: false,
		YUI_config: false
	};
	var shelljs = {
		cat: false,
		cd: false,
		chmod: false,
		config: false,
		cp: false,
		dirs: false,
		echo: false,
		env: false,
		error: false,
		exec: false,
		exit: false,
		find: false,
		grep: false,
		ln: false,
		ls: false,
		mkdir: false,
		mv: false,
		popd: false,
		pushd: false,
		pwd: false,
		rm: false,
		sed: false,
		set: false,
		target: false,
		tempdir: false,
		test: false,
		touch: false,
		which: false
	};
	var prototypejs = {
		$: false,
		$$: false,
		$A: false,
		$break: false,
		$continue: false,
		$F: false,
		$H: false,
		$R: false,
		$w: false,
		Abstract: false,
		Ajax: false,
		Autocompleter: false,
		Builder: false,
		Class: false,
		Control: false,
		Draggable: false,
		Draggables: false,
		Droppables: false,
		Effect: false,
		Element: false,
		Enumerable: false,
		Event: false,
		Field: false,
		Form: false,
		Hash: false,
		Insertion: false,
		ObjectRange: false,
		PeriodicalExecuter: false,
		Position: false,
		Prototype: false,
		Scriptaculous: false,
		Selector: false,
		Sortable: false,
		SortableObserver: false,
		Sound: false,
		Template: false,
		Toggle: false,
		Try: false
	};
	var meteor = {
		_: false,
		$: false,
		Accounts: false,
		AccountsClient: false,
		AccountsCommon: false,
		AccountsServer: false,
		App: false,
		Assets: false,
		Blaze: false,
		check: false,
		Cordova: false,
		DDP: false,
		DDPRateLimiter: false,
		DDPServer: false,
		Deps: false,
		EJSON: false,
		Email: false,
		HTTP: false,
		Log: false,
		Match: false,
		Meteor: false,
		Mongo: false,
		MongoInternals: false,
		Npm: false,
		Package: false,
		Plugin: false,
		process: false,
		Random: false,
		ReactiveDict: false,
		ReactiveVar: false,
		Router: false,
		ServiceConfiguration: false,
		Session: false,
		share: false,
		Spacebars: false,
		Template: false,
		Tinytest: false,
		Tracker: false,
		UI: false,
		Utils: false,
		WebApp: false,
		WebAppInternals: false
	};
	var mongo = {
		_isWindows: false,
		_rand: false,
		BulkWriteResult: false,
		cat: false,
		cd: false,
		connect: false,
		db: false,
		getHostName: false,
		getMemInfo: false,
		hostname: false,
		ISODate: false,
		listFiles: false,
		load: false,
		ls: false,
		md5sumFile: false,
		mkdir: false,
		Mongo: false,
		NumberInt: false,
		NumberLong: false,
		ObjectId: false,
		PlanCache: false,
		print: false,
		printjson: false,
		pwd: false,
		quit: false,
		removeFile: false,
		rs: false,
		sh: false,
		UUID: false,
		version: false,
		WriteResult: false
	};
	var applescript = {
		$: false,
		Application: false,
		Automation: false,
		console: false,
		delay: false,
		Library: false,
		ObjC: false,
		ObjectSpecifier: false,
		Path: false,
		Progress: false,
		Ref: false
	};
	var serviceworker = {
		addEventListener: false,
		applicationCache: false,
		atob: false,
		Blob: false,
		BroadcastChannel: false,
		btoa: false,
		Cache: false,
		caches: false,
		CacheStorage: false,
		clearInterval: false,
		clearTimeout: false,
		Client: false,
		clients: false,
		Clients: false,
		close: true,
		console: false,
		ExtendableEvent: false,
		ExtendableMessageEvent: false,
		fetch: false,
		FetchEvent: false,
		FileReaderSync: false,
		FormData: false,
		Headers: false,
		IDBCursor: false,
		IDBCursorWithValue: false,
		IDBDatabase: false,
		IDBFactory: false,
		IDBIndex: false,
		IDBKeyRange: false,
		IDBObjectStore: false,
		IDBOpenDBRequest: false,
		IDBRequest: false,
		IDBTransaction: false,
		IDBVersionChangeEvent: false,
		ImageData: false,
		importScripts: false,
		indexedDB: false,
		location: false,
		MessageChannel: false,
		MessagePort: false,
		name: false,
		navigator: false,
		Notification: false,
		onclose: true,
		onconnect: true,
		onerror: true,
		onfetch: true,
		oninstall: true,
		onlanguagechange: true,
		onmessage: true,
		onmessageerror: true,
		onnotificationclick: true,
		onnotificationclose: true,
		onoffline: true,
		ononline: true,
		onpush: true,
		onpushsubscriptionchange: true,
		onrejectionhandled: true,
		onsync: true,
		onunhandledrejection: true,
		performance: false,
		Performance: false,
		PerformanceEntry: false,
		PerformanceMark: false,
		PerformanceMeasure: false,
		PerformanceNavigation: false,
		PerformanceResourceTiming: false,
		PerformanceTiming: false,
		postMessage: true,
		"Promise": false,
		queueMicrotask: false,
		registration: false,
		removeEventListener: false,
		Request: false,
		Response: false,
		self: false,
		ServiceWorker: false,
		ServiceWorkerContainer: false,
		ServiceWorkerGlobalScope: false,
		ServiceWorkerMessageEvent: false,
		ServiceWorkerRegistration: false,
		setInterval: false,
		setTimeout: false,
		skipWaiting: false,
		TextDecoder: false,
		TextEncoder: false,
		URL: false,
		URLSearchParams: false,
		WebSocket: false,
		WindowClient: false,
		Worker: false,
		WorkerGlobalScope: false,
		XMLHttpRequest: false
	};
	var atomtest = {
		advanceClock: false,
		fakeClearInterval: false,
		fakeClearTimeout: false,
		fakeSetInterval: false,
		fakeSetTimeout: false,
		resetTimeouts: false,
		waitsForPromise: false
	};
	var embertest = {
		andThen: false,
		click: false,
		currentPath: false,
		currentRouteName: false,
		currentURL: false,
		fillIn: false,
		find: false,
		findAll: false,
		findWithAssert: false,
		keyEvent: false,
		pauseTest: false,
		resumeTest: false,
		triggerEvent: false,
		visit: false,
		wait: false
	};
	var protractor = {
		$: false,
		$$: false,
		browser: false,
		by: false,
		By: false,
		DartObject: false,
		element: false,
		protractor: false
	};
	var webextensions = {
		browser: false,
		chrome: false,
		opr: false
	};
	var greasemonkey = {
		cloneInto: false,
		createObjectIn: false,
		exportFunction: false,
		GM: false,
		GM_addStyle: false,
		GM_deleteValue: false,
		GM_getResourceText: false,
		GM_getResourceURL: false,
		GM_getValue: false,
		GM_info: false,
		GM_listValues: false,
		GM_log: false,
		GM_openInTab: false,
		GM_registerMenuCommand: false,
		GM_setClipboard: false,
		GM_setValue: false,
		GM_xmlhttpRequest: false,
		unsafeWindow: false
	};
	var devtools = {
		$: false,
		$_: false,
		$$: false,
		$0: false,
		$1: false,
		$2: false,
		$3: false,
		$4: false,
		$x: false,
		chrome: false,
		clear: false,
		copy: false,
		debug: false,
		dir: false,
		dirxml: false,
		getEventListeners: false,
		inspect: false,
		keys: false,
		monitor: false,
		monitorEvents: false,
		profile: false,
		profileEnd: false,
		queryObjects: false,
		table: false,
		undebug: false,
		unmonitor: false,
		unmonitorEvents: false,
		values: false
	};
	var require$$0$1 = {
		builtin: builtin,
		es5: es5,
		es2015: es2015,
		es2017: es2017,
		browser: browser$2,
		worker: worker,
		node: node,
		commonjs: commonjs,
		amd: amd,
		mocha: mocha,
		jasmine: jasmine,
		jest: jest,
		qunit: qunit,
		phantomjs: phantomjs,
		couch: couch,
		rhino: rhino,
		nashorn: nashorn,
		wsh: wsh,
		jquery: jquery,
		yui: yui,
		shelljs: shelljs,
		prototypejs: prototypejs,
		meteor: meteor,
		mongo: mongo,
		applescript: applescript,
		serviceworker: serviceworker,
		atomtest: atomtest,
		embertest: embertest,
		protractor: protractor,
		"shared-node-browser": {
		clearInterval: false,
		clearTimeout: false,
		console: false,
		setInterval: false,
		setTimeout: false,
		URL: false,
		URLSearchParams: false
	},
		webextensions: webextensions,
		greasemonkey: greasemonkey,
		devtools: devtools
	};

	var globalsBABEL_8_BREAKINGFalse = require$$0$1;

	function bool$4(value) {
	  if (value == null) return false;
	  return value && value !== "false" && value !== "0";
	}

	var globals = bool$4(browser$5.env["BABEL_8_BREAKING"]) ? globalsBABEL_8_BREAKINGTrue : globalsBABEL_8_BREAKINGFalse;

	const {
	  NOT_LOCAL_BINDING: NOT_LOCAL_BINDING$1,
	  callExpression: callExpression$7,
	  cloneNode: cloneNode$a,
	  getBindingIdentifiers: getBindingIdentifiers$1,
	  identifier: identifier$b,
	  isArrayExpression: isArrayExpression$1,
	  isBinary: isBinary$2,
	  isClass,
	  isClassBody,
	  isClassDeclaration: isClassDeclaration$2,
	  isExportAllDeclaration,
	  isExportDefaultDeclaration: isExportDefaultDeclaration$2,
	  isExportNamedDeclaration: isExportNamedDeclaration$1,
	  isFunctionDeclaration,
	  isIdentifier: isIdentifier$a,
	  isImportDeclaration,
	  isLiteral: isLiteral$4,
	  isMethod,
	  isModuleDeclaration,
	  isModuleSpecifier,
	  isObjectExpression: isObjectExpression$1,
	  isProperty,
	  isPureish,
	  isSuper: isSuper$1,
	  isTaggedTemplateExpression: isTaggedTemplateExpression$1,
	  isTemplateLiteral: isTemplateLiteral$1,
	  isThisExpression,
	  isUnaryExpression,
	  isVariableDeclaration,
	  matchesPattern: matchesPattern$1,
	  memberExpression: memberExpression$5,
	  numericLiteral: numericLiteral$4,
	  toIdentifier,
	  unaryExpression: unaryExpression$5,
	  variableDeclaration: variableDeclaration$3,
	  variableDeclarator: variableDeclarator$3
	} = _t;

	function gatherNodeParts(node, parts) {
	  switch (node?.type) {
	    default:
	      if (isModuleDeclaration(node)) {
	        if ((isExportAllDeclaration(node) || isExportNamedDeclaration$1(node) || isImportDeclaration(node)) && node.source) {
	          gatherNodeParts(node.source, parts);
	        } else if ((isExportNamedDeclaration$1(node) || isImportDeclaration(node)) && node.specifiers && node.specifiers.length) {
	          for (const e of node.specifiers) gatherNodeParts(e, parts);
	        } else if ((isExportDefaultDeclaration$2(node) || isExportNamedDeclaration$1(node)) && node.declaration) {
	          gatherNodeParts(node.declaration, parts);
	        }
	      } else if (isModuleSpecifier(node)) {
	        gatherNodeParts(node.local, parts);
	      } else if (isLiteral$4(node)) {
	        parts.push(node.value);
	      }

	      break;

	    case "MemberExpression":
	    case "OptionalMemberExpression":
	    case "JSXMemberExpression":
	      gatherNodeParts(node.object, parts);
	      gatherNodeParts(node.property, parts);
	      break;

	    case "Identifier":
	    case "JSXIdentifier":
	      parts.push(node.name);
	      break;

	    case "CallExpression":
	    case "OptionalCallExpression":
	    case "NewExpression":
	      gatherNodeParts(node.callee, parts);
	      break;

	    case "ObjectExpression":
	    case "ObjectPattern":
	      for (const e of node.properties) {
	        gatherNodeParts(e, parts);
	      }

	      break;

	    case "SpreadElement":
	    case "RestElement":
	      gatherNodeParts(node.argument, parts);
	      break;

	    case "ObjectProperty":
	    case "ObjectMethod":
	    case "ClassProperty":
	    case "ClassMethod":
	    case "ClassPrivateProperty":
	    case "ClassPrivateMethod":
	      gatherNodeParts(node.key, parts);
	      break;

	    case "ThisExpression":
	      parts.push("this");
	      break;

	    case "Super":
	      parts.push("super");
	      break;

	    case "Import":
	      parts.push("import");
	      break;

	    case "DoExpression":
	      parts.push("do");
	      break;

	    case "YieldExpression":
	      parts.push("yield");
	      gatherNodeParts(node.argument, parts);
	      break;

	    case "AwaitExpression":
	      parts.push("await");
	      gatherNodeParts(node.argument, parts);
	      break;

	    case "AssignmentExpression":
	      gatherNodeParts(node.left, parts);
	      break;

	    case "VariableDeclarator":
	      gatherNodeParts(node.id, parts);
	      break;

	    case "FunctionExpression":
	    case "FunctionDeclaration":
	    case "ClassExpression":
	    case "ClassDeclaration":
	      gatherNodeParts(node.id, parts);
	      break;

	    case "PrivateName":
	      gatherNodeParts(node.id, parts);
	      break;

	    case "ParenthesizedExpression":
	      gatherNodeParts(node.expression, parts);
	      break;

	    case "UnaryExpression":
	    case "UpdateExpression":
	      gatherNodeParts(node.argument, parts);
	      break;

	    case "MetaProperty":
	      gatherNodeParts(node.meta, parts);
	      gatherNodeParts(node.property, parts);
	      break;

	    case "JSXElement":
	      gatherNodeParts(node.openingElement, parts);
	      break;

	    case "JSXOpeningElement":
	      parts.push(node.name);
	      break;

	    case "JSXFragment":
	      gatherNodeParts(node.openingFragment, parts);
	      break;

	    case "JSXOpeningFragment":
	      parts.push("Fragment");
	      break;

	    case "JSXNamespacedName":
	      gatherNodeParts(node.namespace, parts);
	      gatherNodeParts(node.name, parts);
	      break;
	  }
	}

	const collectorVisitor = {
	  ForStatement(path) {
	    const declar = path.get("init");

	    if (declar.isVar()) {
	      const {
	        scope
	      } = path;
	      const parentScope = scope.getFunctionParent() || scope.getProgramParent();
	      parentScope.registerBinding("var", declar);
	    }
	  },

	  Declaration(path) {
	    if (path.isBlockScoped()) return;
	    if (path.isImportDeclaration()) return;
	    if (path.isExportDeclaration()) return;
	    const parent = path.scope.getFunctionParent() || path.scope.getProgramParent();
	    parent.registerDeclaration(path);
	  },

	  ImportDeclaration(path) {
	    const parent = path.scope.getBlockParent();
	    parent.registerDeclaration(path);
	  },

	  ReferencedIdentifier(path, state) {
	    state.references.push(path);
	  },

	  ForXStatement(path, state) {
	    const left = path.get("left");

	    if (left.isPattern() || left.isIdentifier()) {
	      state.constantViolations.push(path);
	    } else if (left.isVar()) {
	      const {
	        scope
	      } = path;
	      const parentScope = scope.getFunctionParent() || scope.getProgramParent();
	      parentScope.registerBinding("var", left);
	    }
	  },

	  ExportDeclaration: {
	    exit(path) {
	      const {
	        node,
	        scope
	      } = path;
	      if (isExportAllDeclaration(node)) return;
	      const declar = node.declaration;

	      if (isClassDeclaration$2(declar) || isFunctionDeclaration(declar)) {
	        const id = declar.id;
	        if (!id) return;
	        const binding = scope.getBinding(id.name);
	        binding?.reference(path);
	      } else if (isVariableDeclaration(declar)) {
	        for (const decl of declar.declarations) {
	          for (const name of Object.keys(getBindingIdentifiers$1(decl))) {
	            const binding = scope.getBinding(name);
	            binding?.reference(path);
	          }
	        }
	      }
	    }

	  },

	  LabeledStatement(path) {
	    path.scope.getBlockParent().registerDeclaration(path);
	  },

	  AssignmentExpression(path, state) {
	    state.assignments.push(path);
	  },

	  UpdateExpression(path, state) {
	    state.constantViolations.push(path);
	  },

	  UnaryExpression(path, state) {
	    if (path.node.operator === "delete") {
	      state.constantViolations.push(path);
	    }
	  },

	  BlockScoped(path) {
	    let scope = path.scope;
	    if (scope.path === path) scope = scope.parent;
	    const parent = scope.getBlockParent();
	    parent.registerDeclaration(path);

	    if (path.isClassDeclaration() && path.node.id) {
	      const id = path.node.id;
	      const name = id.name;
	      path.scope.bindings[name] = path.scope.parent.getBinding(name);
	    }
	  },

	  CatchClause(path) {
	    path.scope.registerBinding("let", path);
	  },

	  Function(path) {
	    const params = path.get("params");

	    for (const param of params) {
	      path.scope.registerBinding("param", param);
	    }

	    if (path.isFunctionExpression() && path.has("id") && !path.get("id").node[NOT_LOCAL_BINDING$1]) {
	      path.scope.registerBinding("local", path.get("id"), path);
	    }
	  },

	  ClassExpression(path) {
	    if (path.has("id") && !path.get("id").node[NOT_LOCAL_BINDING$1]) {
	      path.scope.registerBinding("local", path);
	    }
	  }

	};
	let uid = 0;
	class Scope$1 {
	  uid;
	  path;
	  block;
	  labels;
	  inited;
	  bindings;
	  references;
	  globals;
	  uids;
	  data;
	  crawling;

	  constructor(path) {
	    const {
	      node
	    } = path;
	    const cached = scope.get(node);

	    if (cached?.path === path) {
	      return cached;
	    }

	    scope.set(node, this);
	    this.uid = uid++;
	    this.block = node;
	    this.path = path;
	    this.labels = new Map();
	    this.inited = false;
	  }

	  static globals = Object.keys(globals.builtin);
	  static contextVariables = ["arguments", "undefined", "Infinity", "NaN"];

	  get parent() {
	    let parent,
	        path = this.path;

	    do {
	      const isKey = path.key === "key";
	      path = path.parentPath;
	      if (isKey && path.isMethod()) path = path.parentPath;
	      if (path && path.isScope()) parent = path;
	    } while (path && !parent);

	    return parent?.scope;
	  }

	  get parentBlock() {
	    return this.path.parent;
	  }

	  get hub() {
	    return this.path.hub;
	  }

	  traverse(node, opts, state) {
	    traverse(node, opts, this, state, this.path);
	  }

	  generateDeclaredUidIdentifier(name) {
	    const id = this.generateUidIdentifier(name);
	    this.push({
	      id
	    });
	    return cloneNode$a(id);
	  }

	  generateUidIdentifier(name) {
	    return identifier$b(this.generateUid(name));
	  }

	  generateUid(name = "temp") {
	    name = toIdentifier(name).replace(/^_+/, "").replace(/[0-9]+$/g, "");
	    let uid;
	    let i = 1;

	    do {
	      uid = this._generateUid(name, i);
	      i++;
	    } while (this.hasLabel(uid) || this.hasBinding(uid) || this.hasGlobal(uid) || this.hasReference(uid));

	    const program = this.getProgramParent();
	    program.references[uid] = true;
	    program.uids[uid] = true;
	    return uid;
	  }

	  _generateUid(name, i) {
	    let id = name;
	    if (i > 1) id += i;
	    return `_${id}`;
	  }

	  generateUidBasedOnNode(node, defaultName) {
	    const parts = [];
	    gatherNodeParts(node, parts);
	    let id = parts.join("$");
	    id = id.replace(/^_/, "") || defaultName || "ref";
	    return this.generateUid(id.slice(0, 20));
	  }

	  generateUidIdentifierBasedOnNode(node, defaultName) {
	    return identifier$b(this.generateUidBasedOnNode(node, defaultName));
	  }

	  isStatic(node) {
	    if (isThisExpression(node) || isSuper$1(node)) {
	      return true;
	    }

	    if (isIdentifier$a(node)) {
	      const binding = this.getBinding(node.name);

	      if (binding) {
	        return binding.constant;
	      } else {
	        return this.hasBinding(node.name);
	      }
	    }

	    return false;
	  }

	  maybeGenerateMemoised(node, dontPush) {
	    if (this.isStatic(node)) {
	      return null;
	    } else {
	      const id = this.generateUidIdentifierBasedOnNode(node);

	      if (!dontPush) {
	        this.push({
	          id
	        });
	        return cloneNode$a(id);
	      }

	      return id;
	    }
	  }

	  checkBlockScopedCollisions(local, kind, name, id) {
	    if (kind === "param") return;
	    if (local.kind === "local") return;
	    const duplicate = kind === "let" || local.kind === "let" || local.kind === "const" || local.kind === "module" || local.kind === "param" && kind === "const";

	    if (duplicate) {
	      throw this.hub.buildError(id, `Duplicate declaration "${name}"`, TypeError);
	    }
	  }

	  rename(oldName, newName, block) {
	    const binding = this.getBinding(oldName);

	    if (binding) {
	      newName = newName || this.generateUidIdentifier(oldName).name;
	      return new Renamer(binding, oldName, newName).rename(block);
	    }
	  }

	  _renameFromMap(map, oldName, newName, value) {
	    if (map[oldName]) {
	      map[newName] = value;
	      map[oldName] = null;
	    }
	  }

	  dump() {
	    const sep = "-".repeat(60);
	    console.log(sep);
	    let scope = this;

	    do {
	      console.log("#", scope.block.type);

	      for (const name of Object.keys(scope.bindings)) {
	        const binding = scope.bindings[name];
	        console.log(" -", name, {
	          constant: binding.constant,
	          references: binding.references,
	          violations: binding.constantViolations.length,
	          kind: binding.kind
	        });
	      }
	    } while (scope = scope.parent);

	    console.log(sep);
	  }

	  toArray(node, i, arrayLikeIsIterable) {
	    if (isIdentifier$a(node)) {
	      const binding = this.getBinding(node.name);

	      if (binding?.constant && binding.path.isGenericType("Array")) {
	        return node;
	      }
	    }

	    if (isArrayExpression$1(node)) {
	      return node;
	    }

	    if (isIdentifier$a(node, {
	      name: "arguments"
	    })) {
	      return callExpression$7(memberExpression$5(memberExpression$5(memberExpression$5(identifier$b("Array"), identifier$b("prototype")), identifier$b("slice")), identifier$b("call")), [node]);
	    }

	    let helperName;
	    const args = [node];

	    if (i === true) {
	      helperName = "toConsumableArray";
	    } else if (i) {
	      args.push(numericLiteral$4(i));
	      helperName = "slicedToArray";
	    } else {
	      helperName = "toArray";
	    }

	    if (arrayLikeIsIterable) {
	      args.unshift(this.hub.addHelper(helperName));
	      helperName = "maybeArrayLike";
	    }

	    return callExpression$7(this.hub.addHelper(helperName), args);
	  }

	  hasLabel(name) {
	    return !!this.getLabel(name);
	  }

	  getLabel(name) {
	    return this.labels.get(name);
	  }

	  registerLabel(path) {
	    this.labels.set(path.node.label.name, path);
	  }

	  registerDeclaration(path) {
	    if (path.isLabeledStatement()) {
	      this.registerLabel(path);
	    } else if (path.isFunctionDeclaration()) {
	      this.registerBinding("hoisted", path.get("id"), path);
	    } else if (path.isVariableDeclaration()) {
	      const declarations = path.get("declarations");

	      for (const declar of declarations) {
	        this.registerBinding(path.node.kind, declar);
	      }
	    } else if (path.isClassDeclaration()) {
	      if (path.node.declare) return;
	      this.registerBinding("let", path);
	    } else if (path.isImportDeclaration()) {
	      const specifiers = path.get("specifiers");

	      for (const specifier of specifiers) {
	        this.registerBinding("module", specifier);
	      }
	    } else if (path.isExportDeclaration()) {
	      const declar = path.get("declaration");

	      if (declar.isClassDeclaration() || declar.isFunctionDeclaration() || declar.isVariableDeclaration()) {
	        this.registerDeclaration(declar);
	      }
	    } else {
	      this.registerBinding("unknown", path);
	    }
	  }

	  buildUndefinedNode() {
	    return unaryExpression$5("void", numericLiteral$4(0), true);
	  }

	  registerConstantViolation(path) {
	    const ids = path.getBindingIdentifiers();

	    for (const name of Object.keys(ids)) {
	      const binding = this.getBinding(name);
	      if (binding) binding.reassign(path);
	    }
	  }

	  registerBinding(kind, path, bindingPath = path) {
	    if (!kind) throw new ReferenceError("no `kind`");

	    if (path.isVariableDeclaration()) {
	      const declarators = path.get("declarations");

	      for (const declar of declarators) {
	        this.registerBinding(kind, declar);
	      }

	      return;
	    }

	    const parent = this.getProgramParent();
	    const ids = path.getOuterBindingIdentifiers(true);

	    for (const name of Object.keys(ids)) {
	      parent.references[name] = true;

	      for (const id of ids[name]) {
	        const local = this.getOwnBinding(name);

	        if (local) {
	          if (local.identifier === id) continue;
	          this.checkBlockScopedCollisions(local, kind, name, id);
	        }

	        if (local) {
	          this.registerConstantViolation(bindingPath);
	        } else {
	          this.bindings[name] = new Binding({
	            identifier: id,
	            scope: this,
	            path: bindingPath,
	            kind: kind
	          });
	        }
	      }
	    }
	  }

	  addGlobal(node) {
	    this.globals[node.name] = node;
	  }

	  hasUid(name) {
	    let scope = this;

	    do {
	      if (scope.uids[name]) return true;
	    } while (scope = scope.parent);

	    return false;
	  }

	  hasGlobal(name) {
	    let scope = this;

	    do {
	      if (scope.globals[name]) return true;
	    } while (scope = scope.parent);

	    return false;
	  }

	  hasReference(name) {
	    return !!this.getProgramParent().references[name];
	  }

	  isPure(node, constantsOnly) {
	    if (isIdentifier$a(node)) {
	      const binding = this.getBinding(node.name);
	      if (!binding) return false;
	      if (constantsOnly) return binding.constant;
	      return true;
	    } else if (isClass(node)) {
	      if (node.superClass && !this.isPure(node.superClass, constantsOnly)) {
	        return false;
	      }

	      return this.isPure(node.body, constantsOnly);
	    } else if (isClassBody(node)) {
	      for (const method of node.body) {
	        if (!this.isPure(method, constantsOnly)) return false;
	      }

	      return true;
	    } else if (isBinary$2(node)) {
	      return this.isPure(node.left, constantsOnly) && this.isPure(node.right, constantsOnly);
	    } else if (isArrayExpression$1(node)) {
	      for (const elem of node.elements) {
	        if (!this.isPure(elem, constantsOnly)) return false;
	      }

	      return true;
	    } else if (isObjectExpression$1(node)) {
	      for (const prop of node.properties) {
	        if (!this.isPure(prop, constantsOnly)) return false;
	      }

	      return true;
	    } else if (isMethod(node)) {
	      if (node.computed && !this.isPure(node.key, constantsOnly)) return false;
	      if (node.kind === "get" || node.kind === "set") return false;
	      return true;
	    } else if (isProperty(node)) {
	      if (node.computed && !this.isPure(node.key, constantsOnly)) return false;
	      return this.isPure(node.value, constantsOnly);
	    } else if (isUnaryExpression(node)) {
	      return this.isPure(node.argument, constantsOnly);
	    } else if (isTaggedTemplateExpression$1(node)) {
	      return matchesPattern$1(node.tag, "String.raw") && !this.hasBinding("String", true) && this.isPure(node.quasi, constantsOnly);
	    } else if (isTemplateLiteral$1(node)) {
	      for (const expression of node.expressions) {
	        if (!this.isPure(expression, constantsOnly)) return false;
	      }

	      return true;
	    } else {
	      return isPureish(node);
	    }
	  }

	  setData(key, val) {
	    return this.data[key] = val;
	  }

	  getData(key) {
	    let scope = this;

	    do {
	      const data = scope.data[key];
	      if (data != null) return data;
	    } while (scope = scope.parent);
	  }

	  removeData(key) {
	    let scope = this;

	    do {
	      const data = scope.data[key];
	      if (data != null) scope.data[key] = null;
	    } while (scope = scope.parent);
	  }

	  init() {
	    if (!this.inited) {
	      this.inited = true;
	      this.crawl();
	    }
	  }

	  crawl() {
	    const path = this.path;
	    this.references = Object.create(null);
	    this.bindings = Object.create(null);
	    this.globals = Object.create(null);
	    this.uids = Object.create(null);
	    this.data = Object.create(null);
	    const programParent = this.getProgramParent();
	    if (programParent.crawling) return;
	    const state = {
	      references: [],
	      constantViolations: [],
	      assignments: []
	    };
	    this.crawling = true;

	    if (path.type !== "Program" && collectorVisitor._exploded) {
	      for (const visit of collectorVisitor.enter) {
	        visit(path, state);
	      }

	      const typeVisitors = collectorVisitor[path.type];

	      if (typeVisitors) {
	        for (const visit of typeVisitors.enter) {
	          visit(path, state);
	        }
	      }
	    }

	    path.traverse(collectorVisitor, state);
	    this.crawling = false;

	    for (const path of state.assignments) {
	      const ids = path.getBindingIdentifiers();

	      for (const name of Object.keys(ids)) {
	        if (path.scope.getBinding(name)) continue;
	        programParent.addGlobal(ids[name]);
	      }

	      path.scope.registerConstantViolation(path);
	    }

	    for (const ref of state.references) {
	      const binding = ref.scope.getBinding(ref.node.name);

	      if (binding) {
	        binding.reference(ref);
	      } else {
	        programParent.addGlobal(ref.node);
	      }
	    }

	    for (const path of state.constantViolations) {
	      path.scope.registerConstantViolation(path);
	    }
	  }

	  push(opts) {
	    let path = this.path;

	    if (!path.isBlockStatement() && !path.isProgram()) {
	      path = this.getBlockParent().path;
	    }

	    if (path.isSwitchStatement()) {
	      path = (this.getFunctionParent() || this.getProgramParent()).path;
	    }

	    if (path.isLoop() || path.isCatchClause() || path.isFunction()) {
	      path.ensureBlock();
	      path = path.get("body");
	    }

	    const unique = opts.unique;
	    const kind = opts.kind || "var";
	    const blockHoist = opts._blockHoist == null ? 2 : opts._blockHoist;
	    const dataKey = `declaration:${kind}:${blockHoist}`;
	    let declarPath = !unique && path.getData(dataKey);

	    if (!declarPath) {
	      const declar = variableDeclaration$3(kind, []);
	      declar._blockHoist = blockHoist;
	      [declarPath] = path.unshiftContainer("body", [declar]);
	      if (!unique) path.setData(dataKey, declarPath);
	    }

	    const declarator = variableDeclarator$3(opts.id, opts.init);
	    const len = declarPath.node.declarations.push(declarator);
	    path.scope.registerBinding(kind, declarPath.get("declarations")[len - 1]);
	  }

	  getProgramParent() {
	    let scope = this;

	    do {
	      if (scope.path.isProgram()) {
	        return scope;
	      }
	    } while (scope = scope.parent);

	    throw new Error("Couldn't find a Program");
	  }

	  getFunctionParent() {
	    let scope = this;

	    do {
	      if (scope.path.isFunctionParent()) {
	        return scope;
	      }
	    } while (scope = scope.parent);

	    return null;
	  }

	  getBlockParent() {
	    let scope = this;

	    do {
	      if (scope.path.isBlockParent()) {
	        return scope;
	      }
	    } while (scope = scope.parent);

	    throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
	  }

	  getAllBindings() {
	    const ids = Object.create(null);
	    let scope = this;

	    do {
	      for (const key of Object.keys(scope.bindings)) {
	        if (key in ids === false) {
	          ids[key] = scope.bindings[key];
	        }
	      }

	      scope = scope.parent;
	    } while (scope);

	    return ids;
	  }

	  getAllBindingsOfKind(...kinds) {
	    const ids = Object.create(null);

	    for (const kind of kinds) {
	      let scope = this;

	      do {
	        for (const name of Object.keys(scope.bindings)) {
	          const binding = scope.bindings[name];
	          if (binding.kind === kind) ids[name] = binding;
	        }

	        scope = scope.parent;
	      } while (scope);
	    }

	    return ids;
	  }

	  bindingIdentifierEquals(name, node) {
	    return this.getBindingIdentifier(name) === node;
	  }

	  getBinding(name) {
	    let scope = this;
	    let previousPath;

	    do {
	      const binding = scope.getOwnBinding(name);

	      if (binding) {
	        if (previousPath?.isPattern() && binding.kind !== "param" && binding.kind !== "local") ; else {
	          return binding;
	        }
	      } else if (!binding && name === "arguments" && scope.path.isFunction() && !scope.path.isArrowFunctionExpression()) {
	        break;
	      }

	      previousPath = scope.path;
	    } while (scope = scope.parent);
	  }

	  getOwnBinding(name) {
	    return this.bindings[name];
	  }

	  getBindingIdentifier(name) {
	    return this.getBinding(name)?.identifier;
	  }

	  getOwnBindingIdentifier(name) {
	    const binding = this.bindings[name];
	    return binding?.identifier;
	  }

	  hasOwnBinding(name) {
	    return !!this.getOwnBinding(name);
	  }

	  hasBinding(name, noGlobals) {
	    if (!name) return false;
	    if (this.hasOwnBinding(name)) return true;
	    if (this.parentHasBinding(name, noGlobals)) return true;
	    if (this.hasUid(name)) return true;
	    if (!noGlobals && Scope$1.globals.includes(name)) return true;
	    if (!noGlobals && Scope$1.contextVariables.includes(name)) return true;
	    return false;
	  }

	  parentHasBinding(name, noGlobals) {
	    return this.parent?.hasBinding(name, noGlobals);
	  }

	  moveBindingTo(name, scope) {
	    const info = this.getBinding(name);

	    if (info) {
	      info.scope.removeOwnBinding(name);
	      info.scope = scope;
	      scope.bindings[name] = info;
	    }
	  }

	  removeOwnBinding(name) {
	    delete this.bindings[name];
	  }

	  removeBinding(name) {
	    this.getBinding(name)?.scope.removeOwnBinding(name);
	    let scope = this;

	    do {
	      if (scope.uids[name]) {
	        scope.uids[name] = false;
	      }
	    } while (scope = scope.parent);
	  }

	}

	var intToCharMap = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.split('');

	var encode$1 = function (number) {
	  if (0 <= number && number < intToCharMap.length) {
	    return intToCharMap[number];
	  }

	  throw new TypeError("Must be between 0 and 63: " + number);
	};

	var decode$1 = function (charCode) {
	  var bigA = 65;
	  var bigZ = 90;
	  var littleA = 97;
	  var littleZ = 122;
	  var zero = 48;
	  var nine = 57;
	  var plus = 43;
	  var slash = 47;
	  var littleOffset = 26;
	  var numberOffset = 52;

	  if (bigA <= charCode && charCode <= bigZ) {
	    return charCode - bigA;
	  }

	  if (littleA <= charCode && charCode <= littleZ) {
	    return charCode - littleA + littleOffset;
	  }

	  if (zero <= charCode && charCode <= nine) {
	    return charCode - zero + numberOffset;
	  }

	  if (charCode == plus) {
	    return 62;
	  }

	  if (charCode == slash) {
	    return 63;
	  }

	  return -1;
	};

	var base64 = {
	  encode: encode$1,
	  decode: decode$1
	};

	var VLQ_BASE_SHIFT = 5;
	var VLQ_BASE = 1 << VLQ_BASE_SHIFT;
	var VLQ_BASE_MASK = VLQ_BASE - 1;
	var VLQ_CONTINUATION_BIT = VLQ_BASE;

	function toVLQSigned(aValue) {
	  return aValue < 0 ? (-aValue << 1) + 1 : (aValue << 1) + 0;
	}

	function fromVLQSigned(aValue) {
	  var isNegative = (aValue & 1) === 1;
	  var shifted = aValue >> 1;
	  return isNegative ? -shifted : shifted;
	}

	var encode = function base64VLQ_encode(aValue) {
	  var encoded = "";
	  var digit;
	  var vlq = toVLQSigned(aValue);

	  do {
	    digit = vlq & VLQ_BASE_MASK;
	    vlq >>>= VLQ_BASE_SHIFT;

	    if (vlq > 0) {
	      digit |= VLQ_CONTINUATION_BIT;
	    }

	    encoded += base64.encode(digit);
	  } while (vlq > 0);

	  return encoded;
	};

	var decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
	  var strLen = aStr.length;
	  var result = 0;
	  var shift = 0;
	  var continuation, digit;

	  do {
	    if (aIndex >= strLen) {
	      throw new Error("Expected more digits in base 64 VLQ value.");
	    }

	    digit = base64.decode(aStr.charCodeAt(aIndex++));

	    if (digit === -1) {
	      throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
	    }

	    continuation = !!(digit & VLQ_CONTINUATION_BIT);
	    digit &= VLQ_BASE_MASK;
	    result = result + (digit << shift);
	    shift += VLQ_BASE_SHIFT;
	  } while (continuation);

	  aOutParam.value = fromVLQSigned(result);
	  aOutParam.rest = aIndex;
	};

	var base64Vlq = {
	  encode: encode,
	  decode: decode
	};

	var util$1 = createCommonjsModule(function (module, exports) {
	  function getArg(aArgs, aName, aDefaultValue) {
	    if (aName in aArgs) {
	      return aArgs[aName];
	    } else if (arguments.length === 3) {
	      return aDefaultValue;
	    } else {
	      throw new Error('"' + aName + '" is a required argument.');
	    }
	  }

	  exports.getArg = getArg;
	  var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.]*)(?::(\d+))?(\S*)$/;
	  var dataUrlRegexp = /^data:.+\,.+$/;

	  function urlParse(aUrl) {
	    var match = aUrl.match(urlRegexp);

	    if (!match) {
	      return null;
	    }

	    return {
	      scheme: match[1],
	      auth: match[2],
	      host: match[3],
	      port: match[4],
	      path: match[5]
	    };
	  }

	  exports.urlParse = urlParse;

	  function urlGenerate(aParsedUrl) {
	    var url = '';

	    if (aParsedUrl.scheme) {
	      url += aParsedUrl.scheme + ':';
	    }

	    url += '//';

	    if (aParsedUrl.auth) {
	      url += aParsedUrl.auth + '@';
	    }

	    if (aParsedUrl.host) {
	      url += aParsedUrl.host;
	    }

	    if (aParsedUrl.port) {
	      url += ":" + aParsedUrl.port;
	    }

	    if (aParsedUrl.path) {
	      url += aParsedUrl.path;
	    }

	    return url;
	  }

	  exports.urlGenerate = urlGenerate;

	  function normalize(aPath) {
	    var path = aPath;
	    var url = urlParse(aPath);

	    if (url) {
	      if (!url.path) {
	        return aPath;
	      }

	      path = url.path;
	    }

	    var isAbsolute = exports.isAbsolute(path);
	    var parts = path.split(/\/+/);

	    for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
	      part = parts[i];

	      if (part === '.') {
	        parts.splice(i, 1);
	      } else if (part === '..') {
	        up++;
	      } else if (up > 0) {
	        if (part === '') {
	          parts.splice(i + 1, up);
	          up = 0;
	        } else {
	          parts.splice(i, 2);
	          up--;
	        }
	      }
	    }

	    path = parts.join('/');

	    if (path === '') {
	      path = isAbsolute ? '/' : '.';
	    }

	    if (url) {
	      url.path = path;
	      return urlGenerate(url);
	    }

	    return path;
	  }

	  exports.normalize = normalize;

	  function join(aRoot, aPath) {
	    if (aRoot === "") {
	      aRoot = ".";
	    }

	    if (aPath === "") {
	      aPath = ".";
	    }

	    var aPathUrl = urlParse(aPath);
	    var aRootUrl = urlParse(aRoot);

	    if (aRootUrl) {
	      aRoot = aRootUrl.path || '/';
	    }

	    if (aPathUrl && !aPathUrl.scheme) {
	      if (aRootUrl) {
	        aPathUrl.scheme = aRootUrl.scheme;
	      }

	      return urlGenerate(aPathUrl);
	    }

	    if (aPathUrl || aPath.match(dataUrlRegexp)) {
	      return aPath;
	    }

	    if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
	      aRootUrl.host = aPath;
	      return urlGenerate(aRootUrl);
	    }

	    var joined = aPath.charAt(0) === '/' ? aPath : normalize(aRoot.replace(/\/+$/, '') + '/' + aPath);

	    if (aRootUrl) {
	      aRootUrl.path = joined;
	      return urlGenerate(aRootUrl);
	    }

	    return joined;
	  }

	  exports.join = join;

	  exports.isAbsolute = function (aPath) {
	    return aPath.charAt(0) === '/' || !!aPath.match(urlRegexp);
	  };

	  function relative(aRoot, aPath) {
	    if (aRoot === "") {
	      aRoot = ".";
	    }

	    aRoot = aRoot.replace(/\/$/, '');
	    var level = 0;

	    while (aPath.indexOf(aRoot + '/') !== 0) {
	      var index = aRoot.lastIndexOf("/");

	      if (index < 0) {
	        return aPath;
	      }

	      aRoot = aRoot.slice(0, index);

	      if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
	        return aPath;
	      }

	      ++level;
	    }

	    return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
	  }

	  exports.relative = relative;

	  var supportsNullProto = function () {
	    var obj = Object.create(null);
	    return !('__proto__' in obj);
	  }();

	  function identity(s) {
	    return s;
	  }

	  function toSetString(aStr) {
	    if (isProtoString(aStr)) {
	      return '$' + aStr;
	    }

	    return aStr;
	  }

	  exports.toSetString = supportsNullProto ? identity : toSetString;

	  function fromSetString(aStr) {
	    if (isProtoString(aStr)) {
	      return aStr.slice(1);
	    }

	    return aStr;
	  }

	  exports.fromSetString = supportsNullProto ? identity : fromSetString;

	  function isProtoString(s) {
	    if (!s) {
	      return false;
	    }

	    var length = s.length;

	    if (length < 9) {
	      return false;
	    }

	    if (s.charCodeAt(length - 1) !== 95 || s.charCodeAt(length - 2) !== 95 || s.charCodeAt(length - 3) !== 111 || s.charCodeAt(length - 4) !== 116 || s.charCodeAt(length - 5) !== 111 || s.charCodeAt(length - 6) !== 114 || s.charCodeAt(length - 7) !== 112 || s.charCodeAt(length - 8) !== 95 || s.charCodeAt(length - 9) !== 95) {
	      return false;
	    }

	    for (var i = length - 10; i >= 0; i--) {
	      if (s.charCodeAt(i) !== 36) {
	        return false;
	      }
	    }

	    return true;
	  }

	  function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
	    var cmp = mappingA.source - mappingB.source;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.originalLine - mappingB.originalLine;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.originalColumn - mappingB.originalColumn;

	    if (cmp !== 0 || onlyCompareOriginal) {
	      return cmp;
	    }

	    cmp = mappingA.generatedColumn - mappingB.generatedColumn;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.generatedLine - mappingB.generatedLine;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    return mappingA.name - mappingB.name;
	  }

	  exports.compareByOriginalPositions = compareByOriginalPositions;

	  function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
	    var cmp = mappingA.generatedLine - mappingB.generatedLine;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.generatedColumn - mappingB.generatedColumn;

	    if (cmp !== 0 || onlyCompareGenerated) {
	      return cmp;
	    }

	    cmp = mappingA.source - mappingB.source;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.originalLine - mappingB.originalLine;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.originalColumn - mappingB.originalColumn;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    return mappingA.name - mappingB.name;
	  }

	  exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;

	  function strcmp(aStr1, aStr2) {
	    if (aStr1 === aStr2) {
	      return 0;
	    }

	    if (aStr1 > aStr2) {
	      return 1;
	    }

	    return -1;
	  }

	  function compareByGeneratedPositionsInflated(mappingA, mappingB) {
	    var cmp = mappingA.generatedLine - mappingB.generatedLine;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.generatedColumn - mappingB.generatedColumn;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = strcmp(mappingA.source, mappingB.source);

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.originalLine - mappingB.originalLine;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    cmp = mappingA.originalColumn - mappingB.originalColumn;

	    if (cmp !== 0) {
	      return cmp;
	    }

	    return strcmp(mappingA.name, mappingB.name);
	  }

	  exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
	}, "/$$rollup_base$$/node_modules/source-map/lib");

	var has$3 = Object.prototype.hasOwnProperty;
	var hasNativeMap = typeof Map !== "undefined";

	function ArraySet$2() {
	  this._array = [];
	  this._set = hasNativeMap ? new Map() : Object.create(null);
	}

	ArraySet$2.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
	  var set = new ArraySet$2();

	  for (var i = 0, len = aArray.length; i < len; i++) {
	    set.add(aArray[i], aAllowDuplicates);
	  }

	  return set;
	};

	ArraySet$2.prototype.size = function ArraySet_size() {
	  return hasNativeMap ? this._set.size : Object.getOwnPropertyNames(this._set).length;
	};

	ArraySet$2.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
	  var sStr = hasNativeMap ? aStr : util$1.toSetString(aStr);
	  var isDuplicate = hasNativeMap ? this.has(aStr) : has$3.call(this._set, sStr);
	  var idx = this._array.length;

	  if (!isDuplicate || aAllowDuplicates) {
	    this._array.push(aStr);
	  }

	  if (!isDuplicate) {
	    if (hasNativeMap) {
	      this._set.set(aStr, idx);
	    } else {
	      this._set[sStr] = idx;
	    }
	  }
	};

	ArraySet$2.prototype.has = function ArraySet_has(aStr) {
	  if (hasNativeMap) {
	    return this._set.has(aStr);
	  } else {
	    var sStr = util$1.toSetString(aStr);
	    return has$3.call(this._set, sStr);
	  }
	};

	ArraySet$2.prototype.indexOf = function ArraySet_indexOf(aStr) {
	  if (hasNativeMap) {
	    var idx = this._set.get(aStr);

	    if (idx >= 0) {
	      return idx;
	    }
	  } else {
	    var sStr = util$1.toSetString(aStr);

	    if (has$3.call(this._set, sStr)) {
	      return this._set[sStr];
	    }
	  }

	  throw new Error('"' + aStr + '" is not in the set.');
	};

	ArraySet$2.prototype.at = function ArraySet_at(aIdx) {
	  if (aIdx >= 0 && aIdx < this._array.length) {
	    return this._array[aIdx];
	  }

	  throw new Error('No element indexed by ' + aIdx);
	};

	ArraySet$2.prototype.toArray = function ArraySet_toArray() {
	  return this._array.slice();
	};

	var ArraySet_1 = ArraySet$2;
	var arraySet = {
	  ArraySet: ArraySet_1
	};

	function generatedPositionAfter(mappingA, mappingB) {
	  var lineA = mappingA.generatedLine;
	  var lineB = mappingB.generatedLine;
	  var columnA = mappingA.generatedColumn;
	  var columnB = mappingB.generatedColumn;
	  return lineB > lineA || lineB == lineA && columnB >= columnA || util$1.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
	}

	function MappingList$1() {
	  this._array = [];
	  this._sorted = true;
	  this._last = {
	    generatedLine: -1,
	    generatedColumn: 0
	  };
	}

	MappingList$1.prototype.unsortedForEach = function MappingList_forEach(aCallback, aThisArg) {
	  this._array.forEach(aCallback, aThisArg);
	};

	MappingList$1.prototype.add = function MappingList_add(aMapping) {
	  if (generatedPositionAfter(this._last, aMapping)) {
	    this._last = aMapping;

	    this._array.push(aMapping);
	  } else {
	    this._sorted = false;

	    this._array.push(aMapping);
	  }
	};

	MappingList$1.prototype.toArray = function MappingList_toArray() {
	  if (!this._sorted) {
	    this._array.sort(util$1.compareByGeneratedPositionsInflated);

	    this._sorted = true;
	  }

	  return this._array;
	};

	var MappingList_1 = MappingList$1;
	var mappingList = {
	  MappingList: MappingList_1
	};

	var ArraySet$1 = arraySet.ArraySet;
	var MappingList = mappingList.MappingList;

	function SourceMapGenerator$2(aArgs) {
	  if (!aArgs) {
	    aArgs = {};
	  }

	  this._file = util$1.getArg(aArgs, 'file', null);
	  this._sourceRoot = util$1.getArg(aArgs, 'sourceRoot', null);
	  this._skipValidation = util$1.getArg(aArgs, 'skipValidation', false);
	  this._sources = new ArraySet$1();
	  this._names = new ArraySet$1();
	  this._mappings = new MappingList();
	  this._sourcesContents = null;
	}

	SourceMapGenerator$2.prototype._version = 3;

	SourceMapGenerator$2.fromSourceMap = function SourceMapGenerator_fromSourceMap(aSourceMapConsumer) {
	  var sourceRoot = aSourceMapConsumer.sourceRoot;
	  var generator = new SourceMapGenerator$2({
	    file: aSourceMapConsumer.file,
	    sourceRoot: sourceRoot
	  });
	  aSourceMapConsumer.eachMapping(function (mapping) {
	    var newMapping = {
	      generated: {
	        line: mapping.generatedLine,
	        column: mapping.generatedColumn
	      }
	    };

	    if (mapping.source != null) {
	      newMapping.source = mapping.source;

	      if (sourceRoot != null) {
	        newMapping.source = util$1.relative(sourceRoot, newMapping.source);
	      }

	      newMapping.original = {
	        line: mapping.originalLine,
	        column: mapping.originalColumn
	      };

	      if (mapping.name != null) {
	        newMapping.name = mapping.name;
	      }
	    }

	    generator.addMapping(newMapping);
	  });
	  aSourceMapConsumer.sources.forEach(function (sourceFile) {
	    var content = aSourceMapConsumer.sourceContentFor(sourceFile);

	    if (content != null) {
	      generator.setSourceContent(sourceFile, content);
	    }
	  });
	  return generator;
	};

	SourceMapGenerator$2.prototype.addMapping = function SourceMapGenerator_addMapping(aArgs) {
	  var generated = util$1.getArg(aArgs, 'generated');
	  var original = util$1.getArg(aArgs, 'original', null);
	  var source = util$1.getArg(aArgs, 'source', null);
	  var name = util$1.getArg(aArgs, 'name', null);

	  if (!this._skipValidation) {
	    this._validateMapping(generated, original, source, name);
	  }

	  if (source != null) {
	    source = String(source);

	    if (!this._sources.has(source)) {
	      this._sources.add(source);
	    }
	  }

	  if (name != null) {
	    name = String(name);

	    if (!this._names.has(name)) {
	      this._names.add(name);
	    }
	  }

	  this._mappings.add({
	    generatedLine: generated.line,
	    generatedColumn: generated.column,
	    originalLine: original != null && original.line,
	    originalColumn: original != null && original.column,
	    source: source,
	    name: name
	  });
	};

	SourceMapGenerator$2.prototype.setSourceContent = function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
	  var source = aSourceFile;

	  if (this._sourceRoot != null) {
	    source = util$1.relative(this._sourceRoot, source);
	  }

	  if (aSourceContent != null) {
	    if (!this._sourcesContents) {
	      this._sourcesContents = Object.create(null);
	    }

	    this._sourcesContents[util$1.toSetString(source)] = aSourceContent;
	  } else if (this._sourcesContents) {
	    delete this._sourcesContents[util$1.toSetString(source)];

	    if (Object.keys(this._sourcesContents).length === 0) {
	      this._sourcesContents = null;
	    }
	  }
	};

	SourceMapGenerator$2.prototype.applySourceMap = function SourceMapGenerator_applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
	  var sourceFile = aSourceFile;

	  if (aSourceFile == null) {
	    if (aSourceMapConsumer.file == null) {
	      throw new Error('SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, ' + 'or the source map\'s "file" property. Both were omitted.');
	    }

	    sourceFile = aSourceMapConsumer.file;
	  }

	  var sourceRoot = this._sourceRoot;

	  if (sourceRoot != null) {
	    sourceFile = util$1.relative(sourceRoot, sourceFile);
	  }

	  var newSources = new ArraySet$1();
	  var newNames = new ArraySet$1();

	  this._mappings.unsortedForEach(function (mapping) {
	    if (mapping.source === sourceFile && mapping.originalLine != null) {
	      var original = aSourceMapConsumer.originalPositionFor({
	        line: mapping.originalLine,
	        column: mapping.originalColumn
	      });

	      if (original.source != null) {
	        mapping.source = original.source;

	        if (aSourceMapPath != null) {
	          mapping.source = util$1.join(aSourceMapPath, mapping.source);
	        }

	        if (sourceRoot != null) {
	          mapping.source = util$1.relative(sourceRoot, mapping.source);
	        }

	        mapping.originalLine = original.line;
	        mapping.originalColumn = original.column;

	        if (original.name != null) {
	          mapping.name = original.name;
	        }
	      }
	    }

	    var source = mapping.source;

	    if (source != null && !newSources.has(source)) {
	      newSources.add(source);
	    }

	    var name = mapping.name;

	    if (name != null && !newNames.has(name)) {
	      newNames.add(name);
	    }
	  }, this);

	  this._sources = newSources;
	  this._names = newNames;
	  aSourceMapConsumer.sources.forEach(function (sourceFile) {
	    var content = aSourceMapConsumer.sourceContentFor(sourceFile);

	    if (content != null) {
	      if (aSourceMapPath != null) {
	        sourceFile = util$1.join(aSourceMapPath, sourceFile);
	      }

	      if (sourceRoot != null) {
	        sourceFile = util$1.relative(sourceRoot, sourceFile);
	      }

	      this.setSourceContent(sourceFile, content);
	    }
	  }, this);
	};

	SourceMapGenerator$2.prototype._validateMapping = function SourceMapGenerator_validateMapping(aGenerated, aOriginal, aSource, aName) {
	  if (aOriginal && typeof aOriginal.line !== 'number' && typeof aOriginal.column !== 'number') {
	    throw new Error('original.line and original.column are not numbers -- you probably meant to omit ' + 'the original mapping entirely and only map the generated position. If so, pass ' + 'null for the original mapping instead of an object with empty or null values.');
	  }

	  if (aGenerated && 'line' in aGenerated && 'column' in aGenerated && aGenerated.line > 0 && aGenerated.column >= 0 && !aOriginal && !aSource && !aName) {
	    return;
	  } else if (aGenerated && 'line' in aGenerated && 'column' in aGenerated && aOriginal && 'line' in aOriginal && 'column' in aOriginal && aGenerated.line > 0 && aGenerated.column >= 0 && aOriginal.line > 0 && aOriginal.column >= 0 && aSource) {
	    return;
	  } else {
	    throw new Error('Invalid mapping: ' + JSON.stringify({
	      generated: aGenerated,
	      source: aSource,
	      original: aOriginal,
	      name: aName
	    }));
	  }
	};

	SourceMapGenerator$2.prototype._serializeMappings = function SourceMapGenerator_serializeMappings() {
	  var previousGeneratedColumn = 0;
	  var previousGeneratedLine = 1;
	  var previousOriginalColumn = 0;
	  var previousOriginalLine = 0;
	  var previousName = 0;
	  var previousSource = 0;
	  var result = '';
	  var next;
	  var mapping;
	  var nameIdx;
	  var sourceIdx;

	  var mappings = this._mappings.toArray();

	  for (var i = 0, len = mappings.length; i < len; i++) {
	    mapping = mappings[i];
	    next = '';

	    if (mapping.generatedLine !== previousGeneratedLine) {
	      previousGeneratedColumn = 0;

	      while (mapping.generatedLine !== previousGeneratedLine) {
	        next += ';';
	        previousGeneratedLine++;
	      }
	    } else {
	      if (i > 0) {
	        if (!util$1.compareByGeneratedPositionsInflated(mapping, mappings[i - 1])) {
	          continue;
	        }

	        next += ',';
	      }
	    }

	    next += base64Vlq.encode(mapping.generatedColumn - previousGeneratedColumn);
	    previousGeneratedColumn = mapping.generatedColumn;

	    if (mapping.source != null) {
	      sourceIdx = this._sources.indexOf(mapping.source);
	      next += base64Vlq.encode(sourceIdx - previousSource);
	      previousSource = sourceIdx;
	      next += base64Vlq.encode(mapping.originalLine - 1 - previousOriginalLine);
	      previousOriginalLine = mapping.originalLine - 1;
	      next += base64Vlq.encode(mapping.originalColumn - previousOriginalColumn);
	      previousOriginalColumn = mapping.originalColumn;

	      if (mapping.name != null) {
	        nameIdx = this._names.indexOf(mapping.name);
	        next += base64Vlq.encode(nameIdx - previousName);
	        previousName = nameIdx;
	      }
	    }

	    result += next;
	  }

	  return result;
	};

	SourceMapGenerator$2.prototype._generateSourcesContent = function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
	  return aSources.map(function (source) {
	    if (!this._sourcesContents) {
	      return null;
	    }

	    if (aSourceRoot != null) {
	      source = util$1.relative(aSourceRoot, source);
	    }

	    var key = util$1.toSetString(source);
	    return Object.prototype.hasOwnProperty.call(this._sourcesContents, key) ? this._sourcesContents[key] : null;
	  }, this);
	};

	SourceMapGenerator$2.prototype.toJSON = function SourceMapGenerator_toJSON() {
	  var map = {
	    version: this._version,
	    sources: this._sources.toArray(),
	    names: this._names.toArray(),
	    mappings: this._serializeMappings()
	  };

	  if (this._file != null) {
	    map.file = this._file;
	  }

	  if (this._sourceRoot != null) {
	    map.sourceRoot = this._sourceRoot;
	  }

	  if (this._sourcesContents) {
	    map.sourcesContent = this._generateSourcesContent(map.sources, map.sourceRoot);
	  }

	  return map;
	};

	SourceMapGenerator$2.prototype.toString = function SourceMapGenerator_toString() {
	  return JSON.stringify(this.toJSON());
	};

	var SourceMapGenerator_1 = SourceMapGenerator$2;
	var sourceMapGenerator = {
	  SourceMapGenerator: SourceMapGenerator_1
	};

	var binarySearch = createCommonjsModule(function (module, exports) {
	  exports.GREATEST_LOWER_BOUND = 1;
	  exports.LEAST_UPPER_BOUND = 2;

	  function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
	    var mid = Math.floor((aHigh - aLow) / 2) + aLow;
	    var cmp = aCompare(aNeedle, aHaystack[mid], true);

	    if (cmp === 0) {
	      return mid;
	    } else if (cmp > 0) {
	      if (aHigh - mid > 1) {
	        return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
	      }

	      if (aBias == exports.LEAST_UPPER_BOUND) {
	        return aHigh < aHaystack.length ? aHigh : -1;
	      } else {
	        return mid;
	      }
	    } else {
	      if (mid - aLow > 1) {
	        return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
	      }

	      if (aBias == exports.LEAST_UPPER_BOUND) {
	        return mid;
	      } else {
	        return aLow < 0 ? -1 : aLow;
	      }
	    }
	  }

	  exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
	    if (aHaystack.length === 0) {
	      return -1;
	    }

	    var index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack, aCompare, aBias || exports.GREATEST_LOWER_BOUND);

	    if (index < 0) {
	      return -1;
	    }

	    while (index - 1 >= 0) {
	      if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
	        break;
	      }

	      --index;
	    }

	    return index;
	  };
	}, "/$$rollup_base$$/node_modules/source-map/lib");

	function swap(ary, x, y) {
	  var temp = ary[x];
	  ary[x] = ary[y];
	  ary[y] = temp;
	}

	function randomIntInRange(low, high) {
	  return Math.round(low + Math.random() * (high - low));
	}

	function doQuickSort(ary, comparator, p, r) {
	  if (p < r) {
	    var pivotIndex = randomIntInRange(p, r);
	    var i = p - 1;
	    swap(ary, pivotIndex, r);
	    var pivot = ary[r];

	    for (var j = p; j < r; j++) {
	      if (comparator(ary[j], pivot) <= 0) {
	        i += 1;
	        swap(ary, i, j);
	      }
	    }

	    swap(ary, i + 1, j);
	    var q = i + 1;
	    doQuickSort(ary, comparator, p, q - 1);
	    doQuickSort(ary, comparator, q + 1, r);
	  }
	}

	var quickSort_1 = function (ary, comparator) {
	  doQuickSort(ary, comparator, 0, ary.length - 1);
	};

	var quickSort$1 = {
	  quickSort: quickSort_1
	};

	var ArraySet = arraySet.ArraySet;
	var quickSort = quickSort$1.quickSort;

	function SourceMapConsumer$1(aSourceMap) {
	  var sourceMap = aSourceMap;

	  if (typeof aSourceMap === 'string') {
	    sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
	  }

	  return sourceMap.sections != null ? new IndexedSourceMapConsumer(sourceMap) : new BasicSourceMapConsumer(sourceMap);
	}

	SourceMapConsumer$1.fromSourceMap = function (aSourceMap) {
	  return BasicSourceMapConsumer.fromSourceMap(aSourceMap);
	};

	SourceMapConsumer$1.prototype._version = 3;
	SourceMapConsumer$1.prototype.__generatedMappings = null;
	Object.defineProperty(SourceMapConsumer$1.prototype, '_generatedMappings', {
	  get: function () {
	    if (!this.__generatedMappings) {
	      this._parseMappings(this._mappings, this.sourceRoot);
	    }

	    return this.__generatedMappings;
	  }
	});
	SourceMapConsumer$1.prototype.__originalMappings = null;
	Object.defineProperty(SourceMapConsumer$1.prototype, '_originalMappings', {
	  get: function () {
	    if (!this.__originalMappings) {
	      this._parseMappings(this._mappings, this.sourceRoot);
	    }

	    return this.__originalMappings;
	  }
	});

	SourceMapConsumer$1.prototype._charIsMappingSeparator = function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
	  var c = aStr.charAt(index);
	  return c === ";" || c === ",";
	};

	SourceMapConsumer$1.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
	  throw new Error("Subclasses must implement _parseMappings");
	};

	SourceMapConsumer$1.GENERATED_ORDER = 1;
	SourceMapConsumer$1.ORIGINAL_ORDER = 2;
	SourceMapConsumer$1.GREATEST_LOWER_BOUND = 1;
	SourceMapConsumer$1.LEAST_UPPER_BOUND = 2;

	SourceMapConsumer$1.prototype.eachMapping = function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
	  var context = aContext || null;
	  var order = aOrder || SourceMapConsumer$1.GENERATED_ORDER;
	  var mappings;

	  switch (order) {
	    case SourceMapConsumer$1.GENERATED_ORDER:
	      mappings = this._generatedMappings;
	      break;

	    case SourceMapConsumer$1.ORIGINAL_ORDER:
	      mappings = this._originalMappings;
	      break;

	    default:
	      throw new Error("Unknown order of iteration.");
	  }

	  var sourceRoot = this.sourceRoot;
	  mappings.map(function (mapping) {
	    var source = mapping.source === null ? null : this._sources.at(mapping.source);

	    if (source != null && sourceRoot != null) {
	      source = util$1.join(sourceRoot, source);
	    }

	    return {
	      source: source,
	      generatedLine: mapping.generatedLine,
	      generatedColumn: mapping.generatedColumn,
	      originalLine: mapping.originalLine,
	      originalColumn: mapping.originalColumn,
	      name: mapping.name === null ? null : this._names.at(mapping.name)
	    };
	  }, this).forEach(aCallback, context);
	};

	SourceMapConsumer$1.prototype.allGeneratedPositionsFor = function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
	  var line = util$1.getArg(aArgs, 'line');
	  var needle = {
	    source: util$1.getArg(aArgs, 'source'),
	    originalLine: line,
	    originalColumn: util$1.getArg(aArgs, 'column', 0)
	  };

	  if (this.sourceRoot != null) {
	    needle.source = util$1.relative(this.sourceRoot, needle.source);
	  }

	  if (!this._sources.has(needle.source)) {
	    return [];
	  }

	  needle.source = this._sources.indexOf(needle.source);
	  var mappings = [];

	  var index = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util$1.compareByOriginalPositions, binarySearch.LEAST_UPPER_BOUND);

	  if (index >= 0) {
	    var mapping = this._originalMappings[index];

	    if (aArgs.column === undefined) {
	      var originalLine = mapping.originalLine;

	      while (mapping && mapping.originalLine === originalLine) {
	        mappings.push({
	          line: util$1.getArg(mapping, 'generatedLine', null),
	          column: util$1.getArg(mapping, 'generatedColumn', null),
	          lastColumn: util$1.getArg(mapping, 'lastGeneratedColumn', null)
	        });
	        mapping = this._originalMappings[++index];
	      }
	    } else {
	      var originalColumn = mapping.originalColumn;

	      while (mapping && mapping.originalLine === line && mapping.originalColumn == originalColumn) {
	        mappings.push({
	          line: util$1.getArg(mapping, 'generatedLine', null),
	          column: util$1.getArg(mapping, 'generatedColumn', null),
	          lastColumn: util$1.getArg(mapping, 'lastGeneratedColumn', null)
	        });
	        mapping = this._originalMappings[++index];
	      }
	    }
	  }

	  return mappings;
	};

	var SourceMapConsumer_1 = SourceMapConsumer$1;

	function BasicSourceMapConsumer(aSourceMap) {
	  var sourceMap = aSourceMap;

	  if (typeof aSourceMap === 'string') {
	    sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
	  }

	  var version = util$1.getArg(sourceMap, 'version');
	  var sources = util$1.getArg(sourceMap, 'sources');
	  var names = util$1.getArg(sourceMap, 'names', []);
	  var sourceRoot = util$1.getArg(sourceMap, 'sourceRoot', null);
	  var sourcesContent = util$1.getArg(sourceMap, 'sourcesContent', null);
	  var mappings = util$1.getArg(sourceMap, 'mappings');
	  var file = util$1.getArg(sourceMap, 'file', null);

	  if (version != this._version) {
	    throw new Error('Unsupported version: ' + version);
	  }

	  sources = sources.map(String).map(util$1.normalize).map(function (source) {
	    return sourceRoot && util$1.isAbsolute(sourceRoot) && util$1.isAbsolute(source) ? util$1.relative(sourceRoot, source) : source;
	  });
	  this._names = ArraySet.fromArray(names.map(String), true);
	  this._sources = ArraySet.fromArray(sources, true);
	  this.sourceRoot = sourceRoot;
	  this.sourcesContent = sourcesContent;
	  this._mappings = mappings;
	  this.file = file;
	}

	BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer$1.prototype);
	BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer$1;

	BasicSourceMapConsumer.fromSourceMap = function SourceMapConsumer_fromSourceMap(aSourceMap) {
	  var smc = Object.create(BasicSourceMapConsumer.prototype);
	  var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
	  var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
	  smc.sourceRoot = aSourceMap._sourceRoot;
	  smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(), smc.sourceRoot);
	  smc.file = aSourceMap._file;

	  var generatedMappings = aSourceMap._mappings.toArray().slice();

	  var destGeneratedMappings = smc.__generatedMappings = [];
	  var destOriginalMappings = smc.__originalMappings = [];

	  for (var i = 0, length = generatedMappings.length; i < length; i++) {
	    var srcMapping = generatedMappings[i];
	    var destMapping = new Mapping();
	    destMapping.generatedLine = srcMapping.generatedLine;
	    destMapping.generatedColumn = srcMapping.generatedColumn;

	    if (srcMapping.source) {
	      destMapping.source = sources.indexOf(srcMapping.source);
	      destMapping.originalLine = srcMapping.originalLine;
	      destMapping.originalColumn = srcMapping.originalColumn;

	      if (srcMapping.name) {
	        destMapping.name = names.indexOf(srcMapping.name);
	      }

	      destOriginalMappings.push(destMapping);
	    }

	    destGeneratedMappings.push(destMapping);
	  }

	  quickSort(smc.__originalMappings, util$1.compareByOriginalPositions);
	  return smc;
	};

	BasicSourceMapConsumer.prototype._version = 3;
	Object.defineProperty(BasicSourceMapConsumer.prototype, 'sources', {
	  get: function () {
	    return this._sources.toArray().map(function (s) {
	      return this.sourceRoot != null ? util$1.join(this.sourceRoot, s) : s;
	    }, this);
	  }
	});

	function Mapping() {
	  this.generatedLine = 0;
	  this.generatedColumn = 0;
	  this.source = null;
	  this.originalLine = null;
	  this.originalColumn = null;
	  this.name = null;
	}

	BasicSourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
	  var generatedLine = 1;
	  var previousGeneratedColumn = 0;
	  var previousOriginalLine = 0;
	  var previousOriginalColumn = 0;
	  var previousSource = 0;
	  var previousName = 0;
	  var length = aStr.length;
	  var index = 0;
	  var cachedSegments = {};
	  var temp = {};
	  var originalMappings = [];
	  var generatedMappings = [];
	  var mapping, str, segment, end, value;

	  while (index < length) {
	    if (aStr.charAt(index) === ';') {
	      generatedLine++;
	      index++;
	      previousGeneratedColumn = 0;
	    } else if (aStr.charAt(index) === ',') {
	      index++;
	    } else {
	      mapping = new Mapping();
	      mapping.generatedLine = generatedLine;

	      for (end = index; end < length; end++) {
	        if (this._charIsMappingSeparator(aStr, end)) {
	          break;
	        }
	      }

	      str = aStr.slice(index, end);
	      segment = cachedSegments[str];

	      if (segment) {
	        index += str.length;
	      } else {
	        segment = [];

	        while (index < end) {
	          base64Vlq.decode(aStr, index, temp);
	          value = temp.value;
	          index = temp.rest;
	          segment.push(value);
	        }

	        if (segment.length === 2) {
	          throw new Error('Found a source, but no line and column');
	        }

	        if (segment.length === 3) {
	          throw new Error('Found a source and line, but no column');
	        }

	        cachedSegments[str] = segment;
	      }

	      mapping.generatedColumn = previousGeneratedColumn + segment[0];
	      previousGeneratedColumn = mapping.generatedColumn;

	      if (segment.length > 1) {
	        mapping.source = previousSource + segment[1];
	        previousSource += segment[1];
	        mapping.originalLine = previousOriginalLine + segment[2];
	        previousOriginalLine = mapping.originalLine;
	        mapping.originalLine += 1;
	        mapping.originalColumn = previousOriginalColumn + segment[3];
	        previousOriginalColumn = mapping.originalColumn;

	        if (segment.length > 4) {
	          mapping.name = previousName + segment[4];
	          previousName += segment[4];
	        }
	      }

	      generatedMappings.push(mapping);

	      if (typeof mapping.originalLine === 'number') {
	        originalMappings.push(mapping);
	      }
	    }
	  }

	  quickSort(generatedMappings, util$1.compareByGeneratedPositionsDeflated);
	  this.__generatedMappings = generatedMappings;
	  quickSort(originalMappings, util$1.compareByOriginalPositions);
	  this.__originalMappings = originalMappings;
	};

	BasicSourceMapConsumer.prototype._findMapping = function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName, aColumnName, aComparator, aBias) {
	  if (aNeedle[aLineName] <= 0) {
	    throw new TypeError('Line must be greater than or equal to 1, got ' + aNeedle[aLineName]);
	  }

	  if (aNeedle[aColumnName] < 0) {
	    throw new TypeError('Column must be greater than or equal to 0, got ' + aNeedle[aColumnName]);
	  }

	  return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
	};

	BasicSourceMapConsumer.prototype.computeColumnSpans = function SourceMapConsumer_computeColumnSpans() {
	  for (var index = 0; index < this._generatedMappings.length; ++index) {
	    var mapping = this._generatedMappings[index];

	    if (index + 1 < this._generatedMappings.length) {
	      var nextMapping = this._generatedMappings[index + 1];

	      if (mapping.generatedLine === nextMapping.generatedLine) {
	        mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
	        continue;
	      }
	    }

	    mapping.lastGeneratedColumn = Infinity;
	  }
	};

	BasicSourceMapConsumer.prototype.originalPositionFor = function SourceMapConsumer_originalPositionFor(aArgs) {
	  var needle = {
	    generatedLine: util$1.getArg(aArgs, 'line'),
	    generatedColumn: util$1.getArg(aArgs, 'column')
	  };

	  var index = this._findMapping(needle, this._generatedMappings, "generatedLine", "generatedColumn", util$1.compareByGeneratedPositionsDeflated, util$1.getArg(aArgs, 'bias', SourceMapConsumer$1.GREATEST_LOWER_BOUND));

	  if (index >= 0) {
	    var mapping = this._generatedMappings[index];

	    if (mapping.generatedLine === needle.generatedLine) {
	      var source = util$1.getArg(mapping, 'source', null);

	      if (source !== null) {
	        source = this._sources.at(source);

	        if (this.sourceRoot != null) {
	          source = util$1.join(this.sourceRoot, source);
	        }
	      }

	      var name = util$1.getArg(mapping, 'name', null);

	      if (name !== null) {
	        name = this._names.at(name);
	      }

	      return {
	        source: source,
	        line: util$1.getArg(mapping, 'originalLine', null),
	        column: util$1.getArg(mapping, 'originalColumn', null),
	        name: name
	      };
	    }
	  }

	  return {
	    source: null,
	    line: null,
	    column: null,
	    name: null
	  };
	};

	BasicSourceMapConsumer.prototype.hasContentsOfAllSources = function BasicSourceMapConsumer_hasContentsOfAllSources() {
	  if (!this.sourcesContent) {
	    return false;
	  }

	  return this.sourcesContent.length >= this._sources.size() && !this.sourcesContent.some(function (sc) {
	    return sc == null;
	  });
	};

	BasicSourceMapConsumer.prototype.sourceContentFor = function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
	  if (!this.sourcesContent) {
	    return null;
	  }

	  if (this.sourceRoot != null) {
	    aSource = util$1.relative(this.sourceRoot, aSource);
	  }

	  if (this._sources.has(aSource)) {
	    return this.sourcesContent[this._sources.indexOf(aSource)];
	  }

	  var url;

	  if (this.sourceRoot != null && (url = util$1.urlParse(this.sourceRoot))) {
	    var fileUriAbsPath = aSource.replace(/^file:\/\//, "");

	    if (url.scheme == "file" && this._sources.has(fileUriAbsPath)) {
	      return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];
	    }

	    if ((!url.path || url.path == "/") && this._sources.has("/" + aSource)) {
	      return this.sourcesContent[this._sources.indexOf("/" + aSource)];
	    }
	  }

	  if (nullOnMissing) {
	    return null;
	  } else {
	    throw new Error('"' + aSource + '" is not in the SourceMap.');
	  }
	};

	BasicSourceMapConsumer.prototype.generatedPositionFor = function SourceMapConsumer_generatedPositionFor(aArgs) {
	  var source = util$1.getArg(aArgs, 'source');

	  if (this.sourceRoot != null) {
	    source = util$1.relative(this.sourceRoot, source);
	  }

	  if (!this._sources.has(source)) {
	    return {
	      line: null,
	      column: null,
	      lastColumn: null
	    };
	  }

	  source = this._sources.indexOf(source);
	  var needle = {
	    source: source,
	    originalLine: util$1.getArg(aArgs, 'line'),
	    originalColumn: util$1.getArg(aArgs, 'column')
	  };

	  var index = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util$1.compareByOriginalPositions, util$1.getArg(aArgs, 'bias', SourceMapConsumer$1.GREATEST_LOWER_BOUND));

	  if (index >= 0) {
	    var mapping = this._originalMappings[index];

	    if (mapping.source === needle.source) {
	      return {
	        line: util$1.getArg(mapping, 'generatedLine', null),
	        column: util$1.getArg(mapping, 'generatedColumn', null),
	        lastColumn: util$1.getArg(mapping, 'lastGeneratedColumn', null)
	      };
	    }
	  }

	  return {
	    line: null,
	    column: null,
	    lastColumn: null
	  };
	};

	var BasicSourceMapConsumer_1 = BasicSourceMapConsumer;

	function IndexedSourceMapConsumer(aSourceMap) {
	  var sourceMap = aSourceMap;

	  if (typeof aSourceMap === 'string') {
	    sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
	  }

	  var version = util$1.getArg(sourceMap, 'version');
	  var sections = util$1.getArg(sourceMap, 'sections');

	  if (version != this._version) {
	    throw new Error('Unsupported version: ' + version);
	  }

	  this._sources = new ArraySet();
	  this._names = new ArraySet();
	  var lastOffset = {
	    line: -1,
	    column: 0
	  };
	  this._sections = sections.map(function (s) {
	    if (s.url) {
	      throw new Error('Support for url field in sections not implemented.');
	    }

	    var offset = util$1.getArg(s, 'offset');
	    var offsetLine = util$1.getArg(offset, 'line');
	    var offsetColumn = util$1.getArg(offset, 'column');

	    if (offsetLine < lastOffset.line || offsetLine === lastOffset.line && offsetColumn < lastOffset.column) {
	      throw new Error('Section offsets must be ordered and non-overlapping.');
	    }

	    lastOffset = offset;
	    return {
	      generatedOffset: {
	        generatedLine: offsetLine + 1,
	        generatedColumn: offsetColumn + 1
	      },
	      consumer: new SourceMapConsumer$1(util$1.getArg(s, 'map'))
	    };
	  });
	}

	IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer$1.prototype);
	IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer$1;
	IndexedSourceMapConsumer.prototype._version = 3;
	Object.defineProperty(IndexedSourceMapConsumer.prototype, 'sources', {
	  get: function () {
	    var sources = [];

	    for (var i = 0; i < this._sections.length; i++) {
	      for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
	        sources.push(this._sections[i].consumer.sources[j]);
	      }
	    }

	    return sources;
	  }
	});

	IndexedSourceMapConsumer.prototype.originalPositionFor = function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
	  var needle = {
	    generatedLine: util$1.getArg(aArgs, 'line'),
	    generatedColumn: util$1.getArg(aArgs, 'column')
	  };
	  var sectionIndex = binarySearch.search(needle, this._sections, function (needle, section) {
	    var cmp = needle.generatedLine - section.generatedOffset.generatedLine;

	    if (cmp) {
	      return cmp;
	    }

	    return needle.generatedColumn - section.generatedOffset.generatedColumn;
	  });
	  var section = this._sections[sectionIndex];

	  if (!section) {
	    return {
	      source: null,
	      line: null,
	      column: null,
	      name: null
	    };
	  }

	  return section.consumer.originalPositionFor({
	    line: needle.generatedLine - (section.generatedOffset.generatedLine - 1),
	    column: needle.generatedColumn - (section.generatedOffset.generatedLine === needle.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
	    bias: aArgs.bias
	  });
	};

	IndexedSourceMapConsumer.prototype.hasContentsOfAllSources = function IndexedSourceMapConsumer_hasContentsOfAllSources() {
	  return this._sections.every(function (s) {
	    return s.consumer.hasContentsOfAllSources();
	  });
	};

	IndexedSourceMapConsumer.prototype.sourceContentFor = function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
	  for (var i = 0; i < this._sections.length; i++) {
	    var section = this._sections[i];
	    var content = section.consumer.sourceContentFor(aSource, true);

	    if (content) {
	      return content;
	    }
	  }

	  if (nullOnMissing) {
	    return null;
	  } else {
	    throw new Error('"' + aSource + '" is not in the SourceMap.');
	  }
	};

	IndexedSourceMapConsumer.prototype.generatedPositionFor = function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
	  for (var i = 0; i < this._sections.length; i++) {
	    var section = this._sections[i];

	    if (section.consumer.sources.indexOf(util$1.getArg(aArgs, 'source')) === -1) {
	      continue;
	    }

	    var generatedPosition = section.consumer.generatedPositionFor(aArgs);

	    if (generatedPosition) {
	      var ret = {
	        line: generatedPosition.line + (section.generatedOffset.generatedLine - 1),
	        column: generatedPosition.column + (section.generatedOffset.generatedLine === generatedPosition.line ? section.generatedOffset.generatedColumn - 1 : 0)
	      };
	      return ret;
	    }
	  }

	  return {
	    line: null,
	    column: null
	  };
	};

	IndexedSourceMapConsumer.prototype._parseMappings = function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
	  this.__generatedMappings = [];
	  this.__originalMappings = [];

	  for (var i = 0; i < this._sections.length; i++) {
	    var section = this._sections[i];
	    var sectionMappings = section.consumer._generatedMappings;

	    for (var j = 0; j < sectionMappings.length; j++) {
	      var mapping = sectionMappings[j];

	      var source = section.consumer._sources.at(mapping.source);

	      if (section.consumer.sourceRoot !== null) {
	        source = util$1.join(section.consumer.sourceRoot, source);
	      }

	      this._sources.add(source);

	      source = this._sources.indexOf(source);

	      var name = section.consumer._names.at(mapping.name);

	      this._names.add(name);

	      name = this._names.indexOf(name);
	      var adjustedMapping = {
	        source: source,
	        generatedLine: mapping.generatedLine + (section.generatedOffset.generatedLine - 1),
	        generatedColumn: mapping.generatedColumn + (section.generatedOffset.generatedLine === mapping.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
	        originalLine: mapping.originalLine,
	        originalColumn: mapping.originalColumn,
	        name: name
	      };

	      this.__generatedMappings.push(adjustedMapping);

	      if (typeof adjustedMapping.originalLine === 'number') {
	        this.__originalMappings.push(adjustedMapping);
	      }
	    }
	  }

	  quickSort(this.__generatedMappings, util$1.compareByGeneratedPositionsDeflated);
	  quickSort(this.__originalMappings, util$1.compareByOriginalPositions);
	};

	var IndexedSourceMapConsumer_1 = IndexedSourceMapConsumer;
	var sourceMapConsumer = {
	  SourceMapConsumer: SourceMapConsumer_1,
	  BasicSourceMapConsumer: BasicSourceMapConsumer_1,
	  IndexedSourceMapConsumer: IndexedSourceMapConsumer_1
	};

	var SourceMapGenerator$1 = sourceMapGenerator.SourceMapGenerator;
	var REGEX_NEWLINE = /(\r?\n)/;
	var NEWLINE_CODE = 10;
	var isSourceNode = "$$$isSourceNode$$$";

	function SourceNode$1(aLine, aColumn, aSource, aChunks, aName) {
	  this.children = [];
	  this.sourceContents = {};
	  this.line = aLine == null ? null : aLine;
	  this.column = aColumn == null ? null : aColumn;
	  this.source = aSource == null ? null : aSource;
	  this.name = aName == null ? null : aName;
	  this[isSourceNode] = true;
	  if (aChunks != null) this.add(aChunks);
	}

	SourceNode$1.fromStringWithSourceMap = function SourceNode_fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
	  var node = new SourceNode$1();
	  var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
	  var remainingLinesIndex = 0;

	  var shiftNextLine = function () {
	    var lineContents = getNextLine();
	    var newLine = getNextLine() || "";
	    return lineContents + newLine;

	    function getNextLine() {
	      return remainingLinesIndex < remainingLines.length ? remainingLines[remainingLinesIndex++] : undefined;
	    }
	  };

	  var lastGeneratedLine = 1,
	      lastGeneratedColumn = 0;
	  var lastMapping = null;
	  aSourceMapConsumer.eachMapping(function (mapping) {
	    if (lastMapping !== null) {
	      if (lastGeneratedLine < mapping.generatedLine) {
	        addMappingWithCode(lastMapping, shiftNextLine());
	        lastGeneratedLine++;
	        lastGeneratedColumn = 0;
	      } else {
	        var nextLine = remainingLines[remainingLinesIndex];
	        var code = nextLine.substr(0, mapping.generatedColumn - lastGeneratedColumn);
	        remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn - lastGeneratedColumn);
	        lastGeneratedColumn = mapping.generatedColumn;
	        addMappingWithCode(lastMapping, code);
	        lastMapping = mapping;
	        return;
	      }
	    }

	    while (lastGeneratedLine < mapping.generatedLine) {
	      node.add(shiftNextLine());
	      lastGeneratedLine++;
	    }

	    if (lastGeneratedColumn < mapping.generatedColumn) {
	      var nextLine = remainingLines[remainingLinesIndex];
	      node.add(nextLine.substr(0, mapping.generatedColumn));
	      remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn);
	      lastGeneratedColumn = mapping.generatedColumn;
	    }

	    lastMapping = mapping;
	  }, this);

	  if (remainingLinesIndex < remainingLines.length) {
	    if (lastMapping) {
	      addMappingWithCode(lastMapping, shiftNextLine());
	    }

	    node.add(remainingLines.splice(remainingLinesIndex).join(""));
	  }

	  aSourceMapConsumer.sources.forEach(function (sourceFile) {
	    var content = aSourceMapConsumer.sourceContentFor(sourceFile);

	    if (content != null) {
	      if (aRelativePath != null) {
	        sourceFile = util$1.join(aRelativePath, sourceFile);
	      }

	      node.setSourceContent(sourceFile, content);
	    }
	  });
	  return node;

	  function addMappingWithCode(mapping, code) {
	    if (mapping === null || mapping.source === undefined) {
	      node.add(code);
	    } else {
	      var source = aRelativePath ? util$1.join(aRelativePath, mapping.source) : mapping.source;
	      node.add(new SourceNode$1(mapping.originalLine, mapping.originalColumn, source, code, mapping.name));
	    }
	  }
	};

	SourceNode$1.prototype.add = function SourceNode_add(aChunk) {
	  if (Array.isArray(aChunk)) {
	    aChunk.forEach(function (chunk) {
	      this.add(chunk);
	    }, this);
	  } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
	    if (aChunk) {
	      this.children.push(aChunk);
	    }
	  } else {
	    throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
	  }

	  return this;
	};

	SourceNode$1.prototype.prepend = function SourceNode_prepend(aChunk) {
	  if (Array.isArray(aChunk)) {
	    for (var i = aChunk.length - 1; i >= 0; i--) {
	      this.prepend(aChunk[i]);
	    }
	  } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
	    this.children.unshift(aChunk);
	  } else {
	    throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
	  }

	  return this;
	};

	SourceNode$1.prototype.walk = function SourceNode_walk(aFn) {
	  var chunk;

	  for (var i = 0, len = this.children.length; i < len; i++) {
	    chunk = this.children[i];

	    if (chunk[isSourceNode]) {
	      chunk.walk(aFn);
	    } else {
	      if (chunk !== '') {
	        aFn(chunk, {
	          source: this.source,
	          line: this.line,
	          column: this.column,
	          name: this.name
	        });
	      }
	    }
	  }
	};

	SourceNode$1.prototype.join = function SourceNode_join(aSep) {
	  var newChildren;
	  var i;
	  var len = this.children.length;

	  if (len > 0) {
	    newChildren = [];

	    for (i = 0; i < len - 1; i++) {
	      newChildren.push(this.children[i]);
	      newChildren.push(aSep);
	    }

	    newChildren.push(this.children[i]);
	    this.children = newChildren;
	  }

	  return this;
	};

	SourceNode$1.prototype.replaceRight = function SourceNode_replaceRight(aPattern, aReplacement) {
	  var lastChild = this.children[this.children.length - 1];

	  if (lastChild[isSourceNode]) {
	    lastChild.replaceRight(aPattern, aReplacement);
	  } else if (typeof lastChild === 'string') {
	    this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
	  } else {
	    this.children.push(''.replace(aPattern, aReplacement));
	  }

	  return this;
	};

	SourceNode$1.prototype.setSourceContent = function SourceNode_setSourceContent(aSourceFile, aSourceContent) {
	  this.sourceContents[util$1.toSetString(aSourceFile)] = aSourceContent;
	};

	SourceNode$1.prototype.walkSourceContents = function SourceNode_walkSourceContents(aFn) {
	  for (var i = 0, len = this.children.length; i < len; i++) {
	    if (this.children[i][isSourceNode]) {
	      this.children[i].walkSourceContents(aFn);
	    }
	  }

	  var sources = Object.keys(this.sourceContents);

	  for (var i = 0, len = sources.length; i < len; i++) {
	    aFn(util$1.fromSetString(sources[i]), this.sourceContents[sources[i]]);
	  }
	};

	SourceNode$1.prototype.toString = function SourceNode_toString() {
	  var str = "";
	  this.walk(function (chunk) {
	    str += chunk;
	  });
	  return str;
	};

	SourceNode$1.prototype.toStringWithSourceMap = function SourceNode_toStringWithSourceMap(aArgs) {
	  var generated = {
	    code: "",
	    line: 1,
	    column: 0
	  };
	  var map = new SourceMapGenerator$1(aArgs);
	  var sourceMappingActive = false;
	  var lastOriginalSource = null;
	  var lastOriginalLine = null;
	  var lastOriginalColumn = null;
	  var lastOriginalName = null;
	  this.walk(function (chunk, original) {
	    generated.code += chunk;

	    if (original.source !== null && original.line !== null && original.column !== null) {
	      if (lastOriginalSource !== original.source || lastOriginalLine !== original.line || lastOriginalColumn !== original.column || lastOriginalName !== original.name) {
	        map.addMapping({
	          source: original.source,
	          original: {
	            line: original.line,
	            column: original.column
	          },
	          generated: {
	            line: generated.line,
	            column: generated.column
	          },
	          name: original.name
	        });
	      }

	      lastOriginalSource = original.source;
	      lastOriginalLine = original.line;
	      lastOriginalColumn = original.column;
	      lastOriginalName = original.name;
	      sourceMappingActive = true;
	    } else if (sourceMappingActive) {
	      map.addMapping({
	        generated: {
	          line: generated.line,
	          column: generated.column
	        }
	      });
	      lastOriginalSource = null;
	      sourceMappingActive = false;
	    }

	    for (var idx = 0, length = chunk.length; idx < length; idx++) {
	      if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
	        generated.line++;
	        generated.column = 0;

	        if (idx + 1 === length) {
	          lastOriginalSource = null;
	          sourceMappingActive = false;
	        } else if (sourceMappingActive) {
	          map.addMapping({
	            source: original.source,
	            original: {
	              line: original.line,
	              column: original.column
	            },
	            generated: {
	              line: generated.line,
	              column: generated.column
	            },
	            name: original.name
	          });
	        }
	      } else {
	        generated.column++;
	      }
	    }
	  });
	  this.walkSourceContents(function (sourceFile, sourceContent) {
	    map.setSourceContent(sourceFile, sourceContent);
	  });
	  return {
	    code: generated.code,
	    map: map
	  };
	};

	var SourceNode_1 = SourceNode$1;
	var sourceNode = {
	  SourceNode: SourceNode_1
	};

	var SourceMapGenerator = sourceMapGenerator.SourceMapGenerator;
	var SourceMapConsumer = sourceMapConsumer.SourceMapConsumer;
	var SourceNode = sourceNode.SourceNode;
	var sourceMap = {
	  SourceMapGenerator: SourceMapGenerator,
	  SourceMapConsumer: SourceMapConsumer,
	  SourceNode: SourceNode
	};

	class SourceMap$1 {
	  _cachedMap;
	  _code;
	  _opts;
	  _rawMappings;
	  _lastGenLine;
	  _lastSourceLine;
	  _lastSourceColumn;

	  constructor(opts, code) {
	    this._cachedMap = null;
	    this._code = code;
	    this._opts = opts;
	    this._rawMappings = [];
	  }

	  get() {
	    if (!this._cachedMap) {
	      const map = this._cachedMap = new sourceMap.SourceMapGenerator({
	        sourceRoot: this._opts.sourceRoot
	      });
	      const code = this._code;

	      if (typeof code === "string") {
	        map.setSourceContent(this._opts.sourceFileName.replace(/\\/g, "/"), code);
	      } else if (typeof code === "object") {
	        Object.keys(code).forEach(sourceFileName => {
	          map.setSourceContent(sourceFileName.replace(/\\/g, "/"), code[sourceFileName]);
	        });
	      }

	      this._rawMappings.forEach(mapping => map.addMapping(mapping), map);
	    }

	    return this._cachedMap.toJSON();
	  }

	  getRawMappings() {
	    return this._rawMappings.slice();
	  }

	  mark(generatedLine, generatedColumn, line, column, identifierName, filename, force) {
	    if (this._lastGenLine !== generatedLine && line === null) return;

	    if (!force && this._lastGenLine === generatedLine && this._lastSourceLine === line && this._lastSourceColumn === column) {
	      return;
	    }

	    this._cachedMap = null;
	    this._lastGenLine = generatedLine;
	    this._lastSourceLine = line;
	    this._lastSourceColumn = column;

	    this._rawMappings.push({
	      name: identifierName || undefined,
	      generated: {
	        line: generatedLine,
	        column: generatedColumn
	      },
	      source: line == null ? undefined : (filename || this._opts.sourceFileName).replace(/\\/g, "/"),
	      original: line == null ? undefined : {
	        line: line,
	        column: column
	      }
	    });
	  }

	}

	const SPACES_RE = /^[ \t]+$/;
	class Buffer {
	  constructor(map) {
	    this._map = map;
	  }

	  _map = null;
	  _buf = "";
	  _last = 0;
	  _queue = [];
	  _position = {
	    line: 1,
	    column: 0
	  };
	  _sourcePosition = {
	    identifierName: null,
	    line: null,
	    column: null,
	    filename: null
	  };
	  _disallowedPop = null;

	  get() {
	    this._flush();

	    const map = this._map;
	    const result = {
	      code: this._buf.trimRight(),
	      map: null,
	      rawMappings: map?.getRawMappings()
	    };

	    if (map) {
	      Object.defineProperty(result, "map", {
	        configurable: true,
	        enumerable: true,

	        get() {
	          return this.map = map.get();
	        },

	        set(value) {
	          Object.defineProperty(this, "map", {
	            value,
	            writable: true
	          });
	        }

	      });
	    }

	    return result;
	  }

	  append(str) {
	    this._flush();

	    const {
	      line,
	      column,
	      filename,
	      identifierName,
	      force
	    } = this._sourcePosition;

	    this._append(str, line, column, identifierName, filename, force);
	  }

	  queue(str) {
	    if (str === "\n") {
	      while (this._queue.length > 0 && SPACES_RE.test(this._queue[0][0])) {
	        this._queue.shift();
	      }
	    }

	    const {
	      line,
	      column,
	      filename,
	      identifierName,
	      force
	    } = this._sourcePosition;

	    this._queue.unshift([str, line, column, identifierName, filename, force]);
	  }

	  _flush() {
	    let item;

	    while (item = this._queue.pop()) {
	      this._append(...item);
	    }
	  }

	  _append(str, line, column, identifierName, filename, force) {
	    this._buf += str;
	    this._last = str.charCodeAt(str.length - 1);
	    let i = str.indexOf("\n");
	    let last = 0;

	    if (i !== 0) {
	      this._mark(line, column, identifierName, filename, force);
	    }

	    while (i !== -1) {
	      this._position.line++;
	      this._position.column = 0;
	      last = i + 1;

	      if (last < str.length) {
	        this._mark(++line, 0, identifierName, filename, force);
	      }

	      i = str.indexOf("\n", last);
	    }

	    this._position.column += str.length - last;
	  }

	  _mark(line, column, identifierName, filename, force) {
	    this._map?.mark(this._position.line, this._position.column, line, column, identifierName, filename, force);
	  }

	  removeTrailingNewline() {
	    if (this._queue.length > 0 && this._queue[0][0] === "\n") {
	      this._queue.shift();
	    }
	  }

	  removeLastSemicolon() {
	    if (this._queue.length > 0 && this._queue[0][0] === ";") {
	      this._queue.shift();
	    }
	  }

	  getLastChar() {
	    let last;

	    if (this._queue.length > 0) {
	      const str = this._queue[0][0];
	      last = str.charCodeAt(0);
	    } else {
	      last = this._last;
	    }

	    return last;
	  }

	  endsWithCharAndNewline() {
	    const queue = this._queue;

	    if (queue.length > 0) {
	      const last = queue[0][0];
	      const lastCp = last.charCodeAt(0);
	      if (lastCp !== 10) return;

	      if (queue.length > 1) {
	        const secondLast = queue[1][0];
	        return secondLast.charCodeAt(0);
	      } else {
	        return this._last;
	      }
	    }
	  }

	  hasContent() {
	    return this._queue.length > 0 || !!this._last;
	  }

	  exactSource(loc, cb) {
	    this.source("start", loc, true);
	    cb();
	    this.source("end", loc);

	    this._disallowPop("start", loc);
	  }

	  source(prop, loc, force) {
	    if (prop && !loc) return;

	    this._normalizePosition(prop, loc, this._sourcePosition, force);
	  }

	  withSource(prop, loc, cb) {
	    if (!this._map) return cb();
	    const originalLine = this._sourcePosition.line;
	    const originalColumn = this._sourcePosition.column;
	    const originalFilename = this._sourcePosition.filename;
	    const originalIdentifierName = this._sourcePosition.identifierName;
	    this.source(prop, loc);
	    cb();

	    if ((!this._sourcePosition.force || this._sourcePosition.line !== originalLine || this._sourcePosition.column !== originalColumn || this._sourcePosition.filename !== originalFilename) && (!this._disallowedPop || this._disallowedPop.line !== originalLine || this._disallowedPop.column !== originalColumn || this._disallowedPop.filename !== originalFilename)) {
	      this._sourcePosition.line = originalLine;
	      this._sourcePosition.column = originalColumn;
	      this._sourcePosition.filename = originalFilename;
	      this._sourcePosition.identifierName = originalIdentifierName;
	      this._sourcePosition.force = false;
	      this._disallowedPop = null;
	    }
	  }

	  _disallowPop(prop, loc) {
	    if (prop && !loc) return;
	    this._disallowedPop = this._normalizePosition(prop, loc);
	  }

	  _normalizePosition(prop, loc, targetObj, force) {
	    const pos = loc ? loc[prop] : null;

	    if (targetObj === undefined) {
	      targetObj = {
	        identifierName: null,
	        line: null,
	        column: null,
	        filename: null,
	        force: false
	      };
	    }

	    const origLine = targetObj.line;
	    const origColumn = targetObj.column;
	    const origFilename = targetObj.filename;
	    targetObj.identifierName = prop === "start" && loc?.identifierName || null;
	    targetObj.line = pos?.line;
	    targetObj.column = pos?.column;
	    targetObj.filename = loc?.filename;

	    if (force || targetObj.line !== origLine || targetObj.column !== origColumn || targetObj.filename !== origFilename) {
	      targetObj.force = force;
	    }

	    return targetObj;
	  }

	  getCurrentColumn() {
	    const extra = this._queue.reduce((acc, item) => item[0] + acc, "");

	    const lastIndex = extra.lastIndexOf("\n");
	    return lastIndex === -1 ? this._position.column + extra.length : extra.length - 1 - lastIndex;
	  }

	  getCurrentLine() {
	    const extra = this._queue.reduce((acc, item) => item[0] + acc, "");

	    let count = 0;

	    for (let i = 0; i < extra.length; i++) {
	      if (extra[i] === "\n") count++;
	    }

	    return this._position.line + count;
	  }

	}

	const {
	  FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS$1,
	  isArrayExpression,
	  isAssignmentExpression: isAssignmentExpression$3,
	  isBinary: isBinary$1,
	  isBlockStatement: isBlockStatement$1,
	  isCallExpression: isCallExpression$5,
	  isFunction: isFunction$4,
	  isIdentifier: isIdentifier$9,
	  isLiteral: isLiteral$3,
	  isMemberExpression: isMemberExpression$4,
	  isObjectExpression,
	  isOptionalCallExpression: isOptionalCallExpression$2,
	  isOptionalMemberExpression: isOptionalMemberExpression$2,
	  isStringLiteral: isStringLiteral$3
	} = _t;

	function crawl(node, state = {}) {
	  if (isMemberExpression$4(node) || isOptionalMemberExpression$2(node)) {
	    crawl(node.object, state);
	    if (node.computed) crawl(node.property, state);
	  } else if (isBinary$1(node) || isAssignmentExpression$3(node)) {
	    crawl(node.left, state);
	    crawl(node.right, state);
	  } else if (isCallExpression$5(node) || isOptionalCallExpression$2(node)) {
	    state.hasCall = true;
	    crawl(node.callee, state);
	  } else if (isFunction$4(node)) {
	    state.hasFunction = true;
	  } else if (isIdentifier$9(node)) {
	    state.hasHelper = state.hasHelper || isHelper(node.callee);
	  }

	  return state;
	}

	function isHelper(node) {
	  if (isMemberExpression$4(node)) {
	    return isHelper(node.object) || isHelper(node.property);
	  } else if (isIdentifier$9(node)) {
	    return node.name === "require" || node.name[0] === "_";
	  } else if (isCallExpression$5(node)) {
	    return isHelper(node.callee);
	  } else if (isBinary$1(node) || isAssignmentExpression$3(node)) {
	    return isIdentifier$9(node.left) && isHelper(node.left) || isHelper(node.right);
	  } else {
	    return false;
	  }
	}

	function isType$1(node) {
	  return isLiteral$3(node) || isObjectExpression(node) || isArrayExpression(node) || isIdentifier$9(node) || isMemberExpression$4(node);
	}

	const nodes = {
	  AssignmentExpression(node) {
	    const state = crawl(node.right);

	    if (state.hasCall && state.hasHelper || state.hasFunction) {
	      return {
	        before: state.hasFunction,
	        after: true
	      };
	    }
	  },

	  SwitchCase(node, parent) {
	    return {
	      before: !!node.consequent.length || parent.cases[0] === node,
	      after: !node.consequent.length && parent.cases[parent.cases.length - 1] === node
	    };
	  },

	  LogicalExpression(node) {
	    if (isFunction$4(node.left) || isFunction$4(node.right)) {
	      return {
	        after: true
	      };
	    }
	  },

	  Literal(node) {
	    if (isStringLiteral$3(node) && node.value === "use strict") {
	      return {
	        after: true
	      };
	    }
	  },

	  CallExpression(node) {
	    if (isFunction$4(node.callee) || isHelper(node)) {
	      return {
	        before: true,
	        after: true
	      };
	    }
	  },

	  OptionalCallExpression(node) {
	    if (isFunction$4(node.callee)) {
	      return {
	        before: true,
	        after: true
	      };
	    }
	  },

	  VariableDeclaration(node) {
	    for (let i = 0; i < node.declarations.length; i++) {
	      const declar = node.declarations[i];
	      let enabled = isHelper(declar.id) && !isType$1(declar.init);

	      if (!enabled) {
	        const state = crawl(declar.init);
	        enabled = isHelper(declar.init) && state.hasCall || state.hasFunction;
	      }

	      if (enabled) {
	        return {
	          before: true,
	          after: true
	        };
	      }
	    }
	  },

	  IfStatement(node) {
	    if (isBlockStatement$1(node.consequent)) {
	      return {
	        before: true,
	        after: true
	      };
	    }
	  }

	};

	nodes.ObjectProperty = nodes.ObjectTypeProperty = nodes.ObjectMethod = function (node, parent) {
	  if (parent.properties[0] === node) {
	    return {
	      before: true
	    };
	  }
	};

	nodes.ObjectTypeCallProperty = function (node, parent) {
	  if (parent.callProperties[0] === node && !parent.properties?.length) {
	    return {
	      before: true
	    };
	  }
	};

	nodes.ObjectTypeIndexer = function (node, parent) {
	  if (parent.indexers[0] === node && !parent.properties?.length && !parent.callProperties?.length) {
	    return {
	      before: true
	    };
	  }
	};

	nodes.ObjectTypeInternalSlot = function (node, parent) {
	  if (parent.internalSlots[0] === node && !parent.properties?.length && !parent.callProperties?.length && !parent.indexers?.length) {
	    return {
	      before: true
	    };
	  }
	};

	const list$1 = {
	  VariableDeclaration(node) {
	    return node.declarations.map(decl => decl.init);
	  },

	  ArrayExpression(node) {
	    return node.elements;
	  },

	  ObjectExpression(node) {
	    return node.properties;
	  }

	};
	[["Function", true], ["Class", true], ["Loop", true], ["LabeledStatement", true], ["SwitchStatement", true], ["TryStatement", true]].forEach(function ([type, amounts]) {
	  if (typeof amounts === "boolean") {
	    amounts = {
	      after: amounts,
	      before: amounts
	    };
	  }

	  [type].concat(FLIPPED_ALIAS_KEYS$1[type] || []).forEach(function (type) {
	    nodes[type] = function () {
	      return amounts;
	    };
	  });
	});

	const {
	  isArrayTypeAnnotation,
	  isArrowFunctionExpression,
	  isAssignmentExpression: isAssignmentExpression$2,
	  isAwaitExpression,
	  isBinary,
	  isBinaryExpression,
	  isCallExpression: isCallExpression$4,
	  isClassDeclaration: isClassDeclaration$1,
	  isClassExpression,
	  isConditional,
	  isConditionalExpression,
	  isExportDeclaration,
	  isExportDefaultDeclaration: isExportDefaultDeclaration$1,
	  isExpressionStatement: isExpressionStatement$2,
	  isFor: isFor$1,
	  isForInStatement,
	  isForOfStatement,
	  isForStatement: isForStatement$1,
	  isIfStatement: isIfStatement$1,
	  isIndexedAccessType,
	  isIntersectionTypeAnnotation,
	  isLogicalExpression,
	  isMemberExpression: isMemberExpression$3,
	  isNewExpression: isNewExpression$3,
	  isNullableTypeAnnotation,
	  isObjectPattern,
	  isOptionalCallExpression: isOptionalCallExpression$1,
	  isOptionalMemberExpression: isOptionalMemberExpression$1,
	  isReturnStatement,
	  isSequenceExpression: isSequenceExpression$1,
	  isSwitchStatement,
	  isTSArrayType,
	  isTSAsExpression: isTSAsExpression$1,
	  isTSIntersectionType,
	  isTSNonNullExpression: isTSNonNullExpression$1,
	  isTSOptionalType,
	  isTSRestType,
	  isTSTypeAssertion: isTSTypeAssertion$1,
	  isTSUnionType,
	  isTaggedTemplateExpression,
	  isThrowStatement,
	  isTypeAnnotation: isTypeAnnotation$1,
	  isUnaryLike,
	  isUnionTypeAnnotation: isUnionTypeAnnotation$1,
	  isVariableDeclarator: isVariableDeclarator$1,
	  isWhileStatement,
	  isYieldExpression
	} = _t;
	const PRECEDENCE = {
	  "||": 0,
	  "??": 0,
	  "&&": 1,
	  "|": 2,
	  "^": 3,
	  "&": 4,
	  "==": 5,
	  "===": 5,
	  "!=": 5,
	  "!==": 5,
	  "<": 6,
	  ">": 6,
	  "<=": 6,
	  ">=": 6,
	  in: 6,
	  instanceof: 6,
	  ">>": 7,
	  "<<": 7,
	  ">>>": 7,
	  "+": 8,
	  "-": 8,
	  "*": 9,
	  "/": 9,
	  "%": 9,
	  "**": 10
	};

	const isClassExtendsClause = (node, parent) => (isClassDeclaration$1(parent) || isClassExpression(parent)) && parent.superClass === node;

	const hasPostfixPart = (node, parent) => (isMemberExpression$3(parent) || isOptionalMemberExpression$1(parent)) && parent.object === node || (isCallExpression$4(parent) || isOptionalCallExpression$1(parent) || isNewExpression$3(parent)) && parent.callee === node || isTaggedTemplateExpression(parent) && parent.tag === node || isTSNonNullExpression$1(parent);

	function NullableTypeAnnotation$1(node, parent) {
	  return isArrayTypeAnnotation(parent);
	}
	function FunctionTypeAnnotation$1(node, parent, printStack) {
	  return isUnionTypeAnnotation$1(parent) || isIntersectionTypeAnnotation(parent) || isArrayTypeAnnotation(parent) || isTypeAnnotation$1(parent) && isArrowFunctionExpression(printStack[printStack.length - 3]);
	}
	function UpdateExpression$2(node, parent) {
	  return hasPostfixPart(node, parent) || isClassExtendsClause(node, parent);
	}
	function ObjectExpression$2(node, parent, printStack) {
	  return isFirstInContext(printStack, {
	    expressionStatement: true,
	    arrowBody: true
	  });
	}
	function DoExpression$1(node, parent, printStack) {
	  return !node.async && isFirstInContext(printStack, {
	    expressionStatement: true
	  });
	}
	function Binary(node, parent) {
	  if (node.operator === "**" && isBinaryExpression(parent, {
	    operator: "**"
	  })) {
	    return parent.left === node;
	  }

	  if (isClassExtendsClause(node, parent)) {
	    return true;
	  }

	  if (hasPostfixPart(node, parent) || isUnaryLike(parent) || isAwaitExpression(parent)) {
	    return true;
	  }

	  if (isBinary(parent)) {
	    const parentOp = parent.operator;
	    const parentPos = PRECEDENCE[parentOp];
	    const nodeOp = node.operator;
	    const nodePos = PRECEDENCE[nodeOp];

	    if (parentPos === nodePos && parent.right === node && !isLogicalExpression(parent) || parentPos > nodePos) {
	      return true;
	    }
	  }
	}
	function UnionTypeAnnotation$1(node, parent) {
	  return isArrayTypeAnnotation(parent) || isNullableTypeAnnotation(parent) || isIntersectionTypeAnnotation(parent) || isUnionTypeAnnotation$1(parent);
	}
	function OptionalIndexedAccessType$1(node, parent) {
	  return isIndexedAccessType(parent, {
	    objectType: node
	  });
	}
	function TSAsExpression$1() {
	  return true;
	}
	function TSTypeAssertion$1() {
	  return true;
	}
	function TSUnionType$1(node, parent) {
	  return isTSArrayType(parent) || isTSOptionalType(parent) || isTSIntersectionType(parent) || isTSUnionType(parent) || isTSRestType(parent);
	}
	function TSInferType$1(node, parent) {
	  return isTSArrayType(parent) || isTSOptionalType(parent);
	}
	function BinaryExpression$1(node, parent) {
	  return node.operator === "in" && (isVariableDeclarator$1(parent) || isFor$1(parent));
	}
	function SequenceExpression$2(node, parent) {
	  if (isForStatement$1(parent) || isThrowStatement(parent) || isReturnStatement(parent) || isIfStatement$1(parent) && parent.test === node || isWhileStatement(parent) && parent.test === node || isForInStatement(parent) && parent.right === node || isSwitchStatement(parent) && parent.discriminant === node || isExpressionStatement$2(parent) && parent.expression === node) {
	    return false;
	  }

	  return true;
	}
	function YieldExpression$1(node, parent) {
	  return isBinary(parent) || isUnaryLike(parent) || hasPostfixPart(node, parent) || isAwaitExpression(parent) && isYieldExpression(node) || isConditionalExpression(parent) && node === parent.test || isClassExtendsClause(node, parent);
	}
	function ClassExpression(node, parent, printStack) {
	  return isFirstInContext(printStack, {
	    expressionStatement: true,
	    exportDefault: true
	  });
	}
	function UnaryLike(node, parent) {
	  return hasPostfixPart(node, parent) || isBinaryExpression(parent, {
	    operator: "**",
	    left: node
	  }) || isClassExtendsClause(node, parent);
	}
	function FunctionExpression$1(node, parent, printStack) {
	  return isFirstInContext(printStack, {
	    expressionStatement: true,
	    exportDefault: true
	  });
	}
	function ArrowFunctionExpression$1(node, parent) {
	  return isExportDeclaration(parent) || ConditionalExpression$2(node, parent);
	}
	function ConditionalExpression$2(node, parent) {
	  if (isUnaryLike(parent) || isBinary(parent) || isConditionalExpression(parent, {
	    test: node
	  }) || isAwaitExpression(parent) || isTSTypeAssertion$1(parent) || isTSAsExpression$1(parent)) {
	    return true;
	  }

	  return UnaryLike(node, parent);
	}
	function OptionalMemberExpression$1(node, parent) {
	  return isCallExpression$4(parent, {
	    callee: node
	  }) || isMemberExpression$3(parent, {
	    object: node
	  });
	}
	function AssignmentExpression$2(node, parent) {
	  if (isObjectPattern(node.left)) {
	    return true;
	  } else {
	    return ConditionalExpression$2(node, parent);
	  }
	}
	function LogicalExpression$1(node, parent) {
	  switch (node.operator) {
	    case "||":
	      if (!isLogicalExpression(parent)) return false;
	      return parent.operator === "??" || parent.operator === "&&";

	    case "&&":
	      return isLogicalExpression(parent, {
	        operator: "??"
	      });

	    case "??":
	      return isLogicalExpression(parent) && parent.operator !== "??";
	  }
	}
	function Identifier$1(node, parent, printStack) {
	  if (node.name === "let") {
	    const isFollowedByBracket = isMemberExpression$3(parent, {
	      object: node,
	      computed: true
	    }) || isOptionalMemberExpression$1(parent, {
	      object: node,
	      computed: true,
	      optional: false
	    });
	    return isFirstInContext(printStack, {
	      expressionStatement: isFollowedByBracket,
	      forHead: isFollowedByBracket,
	      forInHead: isFollowedByBracket,
	      forOfHead: true
	    });
	  }

	  return node.name === "async" && isForOfStatement(parent) && node === parent.left;
	}

	function isFirstInContext(printStack, {
	  expressionStatement = false,
	  arrowBody = false,
	  exportDefault = false,
	  forHead = false,
	  forInHead = false,
	  forOfHead = false
	}) {
	  let i = printStack.length - 1;
	  let node = printStack[i];
	  i--;
	  let parent = printStack[i];

	  while (i >= 0) {
	    if (expressionStatement && isExpressionStatement$2(parent, {
	      expression: node
	    }) || exportDefault && isExportDefaultDeclaration$1(parent, {
	      declaration: node
	    }) || arrowBody && isArrowFunctionExpression(parent, {
	      body: node
	    }) || forHead && isForStatement$1(parent, {
	      init: node
	    }) || forInHead && isForInStatement(parent, {
	      left: node
	    }) || forOfHead && isForOfStatement(parent, {
	      left: node
	    })) {
	      return true;
	    }

	    if (hasPostfixPart(node, parent) && !isNewExpression$3(parent) || isSequenceExpression$1(parent) && parent.expressions[0] === node || isConditional(parent, {
	      test: node
	    }) || isBinary(parent, {
	      left: node
	    }) || isAssignmentExpression$2(parent, {
	      left: node
	    })) {
	      node = parent;
	      i--;
	      parent = printStack[i];
	    } else {
	      return false;
	    }
	  }

	  return false;
	}

	var parens = /*#__PURE__*/Object.freeze({
		__proto__: null,
		NullableTypeAnnotation: NullableTypeAnnotation$1,
		FunctionTypeAnnotation: FunctionTypeAnnotation$1,
		UpdateExpression: UpdateExpression$2,
		ObjectExpression: ObjectExpression$2,
		DoExpression: DoExpression$1,
		Binary: Binary,
		UnionTypeAnnotation: UnionTypeAnnotation$1,
		IntersectionTypeAnnotation: UnionTypeAnnotation$1,
		OptionalIndexedAccessType: OptionalIndexedAccessType$1,
		TSAsExpression: TSAsExpression$1,
		TSTypeAssertion: TSTypeAssertion$1,
		TSUnionType: TSUnionType$1,
		TSIntersectionType: TSUnionType$1,
		TSInferType: TSInferType$1,
		BinaryExpression: BinaryExpression$1,
		SequenceExpression: SequenceExpression$2,
		YieldExpression: YieldExpression$1,
		AwaitExpression: YieldExpression$1,
		ClassExpression: ClassExpression,
		UnaryLike: UnaryLike,
		FunctionExpression: FunctionExpression$1,
		ArrowFunctionExpression: ArrowFunctionExpression$1,
		ConditionalExpression: ConditionalExpression$2,
		OptionalMemberExpression: OptionalMemberExpression$1,
		OptionalCallExpression: OptionalMemberExpression$1,
		AssignmentExpression: AssignmentExpression$2,
		LogicalExpression: LogicalExpression$1,
		Identifier: Identifier$1
	});

	const {
	  FLIPPED_ALIAS_KEYS,
	  isCallExpression: isCallExpression$3,
	  isExpressionStatement: isExpressionStatement$1,
	  isMemberExpression: isMemberExpression$2,
	  isNewExpression: isNewExpression$2
	} = _t;

	function expandAliases(obj) {
	  const newObj = {};

	  function add(type, func) {
	    const fn = newObj[type];
	    newObj[type] = fn ? function (node, parent, stack) {
	      const result = fn(node, parent, stack);
	      return result == null ? func(node, parent, stack) : result;
	    } : func;
	  }

	  for (const type of Object.keys(obj)) {
	    const aliases = FLIPPED_ALIAS_KEYS[type];

	    if (aliases) {
	      for (const alias of aliases) {
	        add(alias, obj[type]);
	      }
	    } else {
	      add(type, obj[type]);
	    }
	  }

	  return newObj;
	}

	const expandedParens = expandAliases(parens);
	const expandedWhitespaceNodes = expandAliases(nodes);
	const expandedWhitespaceList = expandAliases(list$1);

	function find$2(obj, node, parent, printStack) {
	  const fn = obj[node.type];
	  return fn ? fn(node, parent, printStack) : null;
	}

	function isOrHasCallExpression(node) {
	  if (isCallExpression$3(node)) {
	    return true;
	  }

	  return isMemberExpression$2(node) && isOrHasCallExpression(node.object);
	}

	function needsWhitespace(node, parent, type) {
	  if (!node) return 0;

	  if (isExpressionStatement$1(node)) {
	    node = node.expression;
	  }

	  let linesInfo = find$2(expandedWhitespaceNodes, node, parent);

	  if (!linesInfo) {
	    const items = find$2(expandedWhitespaceList, node, parent);

	    if (items) {
	      for (let i = 0; i < items.length; i++) {
	        linesInfo = needsWhitespace(items[i], node, type);
	        if (linesInfo) break;
	      }
	    }
	  }

	  if (typeof linesInfo === "object" && linesInfo !== null) {
	    return linesInfo[type] || 0;
	  }

	  return 0;
	}
	function needsWhitespaceBefore$1(node, parent) {
	  return needsWhitespace(node, parent, "before");
	}
	function needsWhitespaceAfter$1(node, parent) {
	  return needsWhitespace(node, parent, "after");
	}
	function needsParens$1(node, parent, printStack) {
	  if (!parent) return false;

	  if (isNewExpression$2(parent) && parent.callee === node) {
	    if (isOrHasCallExpression(node)) return true;
	  }

	  return find$2(expandedParens, node, parent, printStack);
	}

	var n = /*#__PURE__*/Object.freeze({
		__proto__: null,
		needsWhitespace: needsWhitespace,
		needsWhitespaceBefore: needsWhitespaceBefore$1,
		needsWhitespaceAfter: needsWhitespaceAfter$1,
		needsParens: needsParens$1
	});

	function TaggedTemplateExpression$1(node) {
	  this.print(node.tag, node);
	  this.print(node.typeParameters, node);
	  this.print(node.quasi, node);
	}
	function TemplateElement(node, parent) {
	  const isFirst = parent.quasis[0] === node;
	  const isLast = parent.quasis[parent.quasis.length - 1] === node;
	  const value = (isFirst ? "`" : "}") + node.value.raw + (isLast ? "`" : "${");
	  this.token(value);
	}
	function TemplateLiteral$1(node) {
	  const quasis = node.quasis;

	  for (let i = 0; i < quasis.length; i++) {
	    this.print(quasis[i], node);

	    if (i + 1 < quasis.length) {
	      this.print(node.expressions[i], node);
	    }
	  }
	}

	const {
	  isCallExpression: isCallExpression$2,
	  isLiteral: isLiteral$2,
	  isMemberExpression: isMemberExpression$1,
	  isNewExpression: isNewExpression$1
	} = _t;
	function UnaryExpression$1(node) {
	  if (node.operator === "void" || node.operator === "delete" || node.operator === "typeof" || node.operator === "throw") {
	    this.word(node.operator);
	    this.space();
	  } else {
	    this.token(node.operator);
	  }

	  this.print(node.argument, node);
	}
	function DoExpression(node) {
	  if (node.async) {
	    this.word("async");
	    this.space();
	  }

	  this.word("do");
	  this.space();
	  this.print(node.body, node);
	}
	function ParenthesizedExpression$1(node) {
	  this.token("(");
	  this.print(node.expression, node);
	  this.token(")");
	}
	function UpdateExpression$1(node) {
	  if (node.prefix) {
	    this.token(node.operator);
	    this.print(node.argument, node);
	  } else {
	    this.startTerminatorless(true);
	    this.print(node.argument, node);
	    this.endTerminatorless();
	    this.token(node.operator);
	  }
	}
	function ConditionalExpression$1(node) {
	  this.print(node.test, node);
	  this.space();
	  this.token("?");
	  this.space();
	  this.print(node.consequent, node);
	  this.space();
	  this.token(":");
	  this.space();
	  this.print(node.alternate, node);
	}
	function NewExpression$1(node, parent) {
	  this.word("new");
	  this.space();
	  this.print(node.callee, node);

	  if (this.format.minified && node.arguments.length === 0 && !node.optional && !isCallExpression$2(parent, {
	    callee: node
	  }) && !isMemberExpression$1(parent) && !isNewExpression$1(parent)) {
	    return;
	  }

	  this.print(node.typeArguments, node);
	  this.print(node.typeParameters, node);

	  if (node.optional) {
	    this.token("?.");
	  }

	  this.token("(");
	  this.printList(node.arguments, node);
	  this.token(")");
	}
	function SequenceExpression$1(node) {
	  this.printList(node.expressions, node);
	}
	function ThisExpression() {
	  this.word("this");
	}
	function Super() {
	  this.word("super");
	}
	function Decorator(node) {
	  this.token("@");
	  this.print(node.expression, node);
	  this.newline();
	}
	function OptionalMemberExpression(node) {
	  this.print(node.object, node);

	  if (!node.computed && isMemberExpression$1(node.property)) {
	    throw new TypeError("Got a MemberExpression for MemberExpression property");
	  }

	  let computed = node.computed;

	  if (isLiteral$2(node.property) && typeof node.property.value === "number") {
	    computed = true;
	  }

	  if (node.optional) {
	    this.token("?.");
	  }

	  if (computed) {
	    this.token("[");
	    this.print(node.property, node);
	    this.token("]");
	  } else {
	    if (!node.optional) {
	      this.token(".");
	    }

	    this.print(node.property, node);
	  }
	}
	function OptionalCallExpression(node) {
	  this.print(node.callee, node);
	  this.print(node.typeArguments, node);
	  this.print(node.typeParameters, node);

	  if (node.optional) {
	    this.token("?.");
	  }

	  this.token("(");
	  this.printList(node.arguments, node);
	  this.token(")");
	}
	function CallExpression$1(node) {
	  this.print(node.callee, node);
	  this.print(node.typeArguments, node);
	  this.print(node.typeParameters, node);
	  this.token("(");
	  this.printList(node.arguments, node);
	  this.token(")");
	}
	function Import() {
	  this.word("import");
	}

	function buildYieldAwait(keyword) {
	  return function (node) {
	    this.word(keyword);

	    if (node.delegate) {
	      this.token("*");
	    }

	    if (node.argument) {
	      this.space();
	      const terminatorState = this.startTerminatorless();
	      this.print(node.argument, node);
	      this.endTerminatorless(terminatorState);
	    }
	  };
	}

	const YieldExpression = buildYieldAwait("yield");
	const AwaitExpression = buildYieldAwait("await");
	function EmptyStatement() {
	  this.semicolon(true);
	}
	function ExpressionStatement(node) {
	  this.print(node.expression, node);
	  this.semicolon();
	}
	function AssignmentPattern(node) {
	  this.print(node.left, node);
	  if (node.left.optional) this.token("?");
	  this.print(node.left.typeAnnotation, node);
	  this.space();
	  this.token("=");
	  this.space();
	  this.print(node.right, node);
	}
	function AssignmentExpression$1(node, parent) {
	  const parens = this.inForStatementInitCounter && node.operator === "in" && !needsParens$1(node, parent);

	  if (parens) {
	    this.token("(");
	  }

	  this.print(node.left, node);
	  this.space();

	  if (node.operator === "in" || node.operator === "instanceof") {
	    this.word(node.operator);
	  } else {
	    this.token(node.operator);
	  }

	  this.space();
	  this.print(node.right, node);

	  if (parens) {
	    this.token(")");
	  }
	}
	function BindExpression(node) {
	  this.print(node.object, node);
	  this.token("::");
	  this.print(node.callee, node);
	}
	function MemberExpression(node) {
	  this.print(node.object, node);

	  if (!node.computed && isMemberExpression$1(node.property)) {
	    throw new TypeError("Got a MemberExpression for MemberExpression property");
	  }

	  let computed = node.computed;

	  if (isLiteral$2(node.property) && typeof node.property.value === "number") {
	    computed = true;
	  }

	  if (computed) {
	    this.token("[");
	    this.print(node.property, node);
	    this.token("]");
	  } else {
	    this.token(".");
	    this.print(node.property, node);
	  }
	}
	function MetaProperty(node) {
	  this.print(node.meta, node);
	  this.token(".");
	  this.print(node.property, node);
	}
	function PrivateName(node) {
	  this.token("#");
	  this.print(node.id, node);
	}
	function V8IntrinsicIdentifier(node) {
	  this.token("%");
	  this.word(node.name);
	}
	function ModuleExpression(node) {
	  this.word("module");
	  this.space();
	  this.token("{");

	  if (node.body.body.length === 0) {
	    this.token("}");
	  } else {
	    this.newline();
	    this.printSequence(node.body.body, node, {
	      indent: true
	    });
	    this.rightBrace();
	  }
	}

	const {
	  isFor,
	  isForStatement,
	  isIfStatement,
	  isStatement: isStatement$5
	} = _t;
	function WithStatement(node) {
	  this.word("with");
	  this.space();
	  this.token("(");
	  this.print(node.object, node);
	  this.token(")");
	  this.printBlock(node);
	}
	function IfStatement(node) {
	  this.word("if");
	  this.space();
	  this.token("(");
	  this.print(node.test, node);
	  this.token(")");
	  this.space();
	  const needsBlock = node.alternate && isIfStatement(getLastStatement(node.consequent));

	  if (needsBlock) {
	    this.token("{");
	    this.newline();
	    this.indent();
	  }

	  this.printAndIndentOnComments(node.consequent, node);

	  if (needsBlock) {
	    this.dedent();
	    this.newline();
	    this.token("}");
	  }

	  if (node.alternate) {
	    if (this.endsWith(125)) this.space();
	    this.word("else");
	    this.space();
	    this.printAndIndentOnComments(node.alternate, node);
	  }
	}

	function getLastStatement(statement) {
	  if (!isStatement$5(statement.body)) return statement;
	  return getLastStatement(statement.body);
	}

	function ForStatement(node) {
	  this.word("for");
	  this.space();
	  this.token("(");
	  this.inForStatementInitCounter++;
	  this.print(node.init, node);
	  this.inForStatementInitCounter--;
	  this.token(";");

	  if (node.test) {
	    this.space();
	    this.print(node.test, node);
	  }

	  this.token(";");

	  if (node.update) {
	    this.space();
	    this.print(node.update, node);
	  }

	  this.token(")");
	  this.printBlock(node);
	}
	function WhileStatement(node) {
	  this.word("while");
	  this.space();
	  this.token("(");
	  this.print(node.test, node);
	  this.token(")");
	  this.printBlock(node);
	}

	const buildForXStatement = function (op) {
	  return function (node) {
	    this.word("for");
	    this.space();

	    if (op === "of" && node.await) {
	      this.word("await");
	      this.space();
	    }

	    this.token("(");
	    this.print(node.left, node);
	    this.space();
	    this.word(op);
	    this.space();
	    this.print(node.right, node);
	    this.token(")");
	    this.printBlock(node);
	  };
	};

	const ForInStatement = buildForXStatement("in");
	const ForOfStatement = buildForXStatement("of");
	function DoWhileStatement(node) {
	  this.word("do");
	  this.space();
	  this.print(node.body, node);
	  this.space();
	  this.word("while");
	  this.space();
	  this.token("(");
	  this.print(node.test, node);
	  this.token(")");
	  this.semicolon();
	}

	function buildLabelStatement(prefix, key = "label") {
	  return function (node) {
	    this.word(prefix);
	    const label = node[key];

	    if (label) {
	      this.space();
	      const isLabel = key == "label";
	      const terminatorState = this.startTerminatorless(isLabel);
	      this.print(label, node);
	      this.endTerminatorless(terminatorState);
	    }

	    this.semicolon();
	  };
	}

	const ContinueStatement = buildLabelStatement("continue");
	const ReturnStatement = buildLabelStatement("return", "argument");
	const BreakStatement = buildLabelStatement("break");
	const ThrowStatement = buildLabelStatement("throw", "argument");
	function LabeledStatement(node) {
	  this.print(node.label, node);
	  this.token(":");
	  this.space();
	  this.print(node.body, node);
	}
	function TryStatement(node) {
	  this.word("try");
	  this.space();
	  this.print(node.block, node);
	  this.space();

	  if (node.handlers) {
	    this.print(node.handlers[0], node);
	  } else {
	    this.print(node.handler, node);
	  }

	  if (node.finalizer) {
	    this.space();
	    this.word("finally");
	    this.space();
	    this.print(node.finalizer, node);
	  }
	}
	function CatchClause(node) {
	  this.word("catch");
	  this.space();

	  if (node.param) {
	    this.token("(");
	    this.print(node.param, node);
	    this.print(node.param.typeAnnotation, node);
	    this.token(")");
	    this.space();
	  }

	  this.print(node.body, node);
	}
	function SwitchStatement(node) {
	  this.word("switch");
	  this.space();
	  this.token("(");
	  this.print(node.discriminant, node);
	  this.token(")");
	  this.space();
	  this.token("{");
	  this.printSequence(node.cases, node, {
	    indent: true,

	    addNewlines(leading, cas) {
	      if (!leading && node.cases[node.cases.length - 1] === cas) return -1;
	    }

	  });
	  this.token("}");
	}
	function SwitchCase(node) {
	  if (node.test) {
	    this.word("case");
	    this.space();
	    this.print(node.test, node);
	    this.token(":");
	  } else {
	    this.word("default");
	    this.token(":");
	  }

	  if (node.consequent.length) {
	    this.newline();
	    this.printSequence(node.consequent, node, {
	      indent: true
	    });
	  }
	}
	function DebuggerStatement() {
	  this.word("debugger");
	  this.semicolon();
	}

	function variableDeclarationIndent() {
	  this.token(",");
	  this.newline();

	  if (this.endsWith(10)) {
	    for (let i = 0; i < 4; i++) this.space(true);
	  }
	}

	function constDeclarationIndent() {
	  this.token(",");
	  this.newline();

	  if (this.endsWith(10)) {
	    for (let i = 0; i < 6; i++) this.space(true);
	  }
	}

	function VariableDeclaration(node, parent) {
	  if (node.declare) {
	    this.word("declare");
	    this.space();
	  }

	  this.word(node.kind);
	  this.space();
	  let hasInits = false;

	  if (!isFor(parent)) {
	    for (const declar of node.declarations) {
	      if (declar.init) {
	        hasInits = true;
	      }
	    }
	  }

	  let separator;

	  if (hasInits) {
	    separator = node.kind === "const" ? constDeclarationIndent : variableDeclarationIndent;
	  }

	  this.printList(node.declarations, node, {
	    separator
	  });

	  if (isFor(parent)) {
	    if (isForStatement(parent)) {
	      if (parent.init === node) return;
	    } else {
	      if (parent.left === node) return;
	    }
	  }

	  this.semicolon();
	}
	function VariableDeclarator$1(node) {
	  this.print(node.id, node);
	  if (node.definite) this.token("!");
	  this.print(node.id.typeAnnotation, node);

	  if (node.init) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(node.init, node);
	  }
	}

	const {
	  isExportDefaultDeclaration,
	  isExportNamedDeclaration
	} = _t;
	function ClassDeclaration(node, parent) {
	  if (!this.format.decoratorsBeforeExport || !isExportDefaultDeclaration(parent) && !isExportNamedDeclaration(parent)) {
	    this.printJoin(node.decorators, node);
	  }

	  if (node.declare) {
	    this.word("declare");
	    this.space();
	  }

	  if (node.abstract) {
	    this.word("abstract");
	    this.space();
	  }

	  this.word("class");
	  this.printInnerComments(node);

	  if (node.id) {
	    this.space();
	    this.print(node.id, node);
	  }

	  this.print(node.typeParameters, node);

	  if (node.superClass) {
	    this.space();
	    this.word("extends");
	    this.space();
	    this.print(node.superClass, node);
	    this.print(node.superTypeParameters, node);
	  }

	  if (node.implements) {
	    this.space();
	    this.word("implements");
	    this.space();
	    this.printList(node.implements, node);
	  }

	  this.space();
	  this.print(node.body, node);
	}
	function ClassBody(node) {
	  this.token("{");
	  this.printInnerComments(node);

	  if (node.body.length === 0) {
	    this.token("}");
	  } else {
	    this.newline();
	    this.indent();
	    this.printSequence(node.body, node);
	    this.dedent();
	    if (!this.endsWith(10)) this.newline();
	    this.rightBrace();
	  }
	}
	function ClassProperty(node) {
	  this.printJoin(node.decorators, node);
	  this.source("end", node.key.loc);
	  this.tsPrintClassMemberModifiers(node, true);

	  if (node.computed) {
	    this.token("[");
	    this.print(node.key, node);
	    this.token("]");
	  } else {
	    this._variance(node);

	    this.print(node.key, node);
	  }

	  if (node.optional) {
	    this.token("?");
	  }

	  if (node.definite) {
	    this.token("!");
	  }

	  this.print(node.typeAnnotation, node);

	  if (node.value) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(node.value, node);
	  }

	  this.semicolon();
	}
	function ClassAccessorProperty(node) {
	  this.printJoin(node.decorators, node);
	  this.source("end", node.key.loc);
	  this.tsPrintClassMemberModifiers(node, true);
	  this.word("accessor");
	  this.printInnerComments(node);
	  this.space();

	  if (node.computed) {
	    this.token("[");
	    this.print(node.key, node);
	    this.token("]");
	  } else {
	    this._variance(node);

	    this.print(node.key, node);
	  }

	  if (node.optional) {
	    this.token("?");
	  }

	  if (node.definite) {
	    this.token("!");
	  }

	  this.print(node.typeAnnotation, node);

	  if (node.value) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(node.value, node);
	  }

	  this.semicolon();
	}
	function ClassPrivateProperty(node) {
	  this.printJoin(node.decorators, node);

	  if (node.static) {
	    this.word("static");
	    this.space();
	  }

	  this.print(node.key, node);
	  this.print(node.typeAnnotation, node);

	  if (node.value) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(node.value, node);
	  }

	  this.semicolon();
	}
	function ClassMethod(node) {
	  this._classMethodHead(node);

	  this.space();
	  this.print(node.body, node);
	}
	function ClassPrivateMethod(node) {
	  this._classMethodHead(node);

	  this.space();
	  this.print(node.body, node);
	}
	function _classMethodHead(node) {
	  this.printJoin(node.decorators, node);
	  this.source("end", node.key.loc);
	  this.tsPrintClassMemberModifiers(node, false);

	  this._methodHead(node);
	}
	function StaticBlock(node) {
	  this.word("static");
	  this.space();
	  this.token("{");

	  if (node.body.length === 0) {
	    this.token("}");
	  } else {
	    this.newline();
	    this.printSequence(node.body, node, {
	      indent: true
	    });
	    this.rightBrace();
	  }
	}

	const {
	  isIdentifier: isIdentifier$8
	} = _t;
	function _params(node) {
	  this.print(node.typeParameters, node);
	  this.token("(");

	  this._parameters(node.params, node);

	  this.token(")");
	  this.print(node.returnType, node);
	}
	function _parameters(parameters, parent) {
	  for (let i = 0; i < parameters.length; i++) {
	    this._param(parameters[i], parent);

	    if (i < parameters.length - 1) {
	      this.token(",");
	      this.space();
	    }
	  }
	}
	function _param(parameter, parent) {
	  this.printJoin(parameter.decorators, parameter);
	  this.print(parameter, parent);
	  if (parameter.optional) this.token("?");
	  this.print(parameter.typeAnnotation, parameter);
	}
	function _methodHead(node) {
	  const kind = node.kind;
	  const key = node.key;

	  if (kind === "get" || kind === "set") {
	    this.word(kind);
	    this.space();
	  }

	  if (node.async) {
	    this._catchUp("start", key.loc);

	    this.word("async");
	    this.space();
	  }

	  if (kind === "method" || kind === "init") {
	    if (node.generator) {
	      this.token("*");
	    }
	  }

	  if (node.computed) {
	    this.token("[");
	    this.print(key, node);
	    this.token("]");
	  } else {
	    this.print(key, node);
	  }

	  if (node.optional) {
	    this.token("?");
	  }

	  this._params(node);
	}
	function _predicate(node) {
	  if (node.predicate) {
	    if (!node.returnType) {
	      this.token(":");
	    }

	    this.space();
	    this.print(node.predicate, node);
	  }
	}
	function _functionHead(node) {
	  if (node.async) {
	    this.word("async");
	    this.space();
	  }

	  this.word("function");
	  if (node.generator) this.token("*");
	  this.printInnerComments(node);
	  this.space();

	  if (node.id) {
	    this.print(node.id, node);
	  }

	  this._params(node);

	  this._predicate(node);
	}
	function FunctionExpression(node) {
	  this._functionHead(node);

	  this.space();
	  this.print(node.body, node);
	}
	function ArrowFunctionExpression(node) {
	  if (node.async) {
	    this.word("async");
	    this.space();
	  }

	  const firstParam = node.params[0];

	  if (!this.format.retainLines && !this.format.auxiliaryCommentBefore && !this.format.auxiliaryCommentAfter && node.params.length === 1 && isIdentifier$8(firstParam) && !hasTypesOrComments(node, firstParam)) {
	    this.print(firstParam, node);
	  } else {
	    this._params(node);
	  }

	  this._predicate(node);

	  this.space();
	  this.token("=>");
	  this.space();
	  this.print(node.body, node);
	}

	function hasTypesOrComments(node, param) {
	  return !!(node.typeParameters || node.returnType || node.predicate || param.typeAnnotation || param.optional || param.leadingComments?.length || param.trailingComments?.length);
	}

	const {
	  isClassDeclaration,
	  isExportDefaultSpecifier,
	  isExportNamespaceSpecifier,
	  isImportDefaultSpecifier,
	  isImportNamespaceSpecifier,
	  isStatement: isStatement$4
	} = _t;
	function ImportSpecifier(node) {
	  if (node.importKind === "type" || node.importKind === "typeof") {
	    this.word(node.importKind);
	    this.space();
	  }

	  this.print(node.imported, node);

	  if (node.local && node.local.name !== node.imported.name) {
	    this.space();
	    this.word("as");
	    this.space();
	    this.print(node.local, node);
	  }
	}
	function ImportDefaultSpecifier(node) {
	  this.print(node.local, node);
	}
	function ExportDefaultSpecifier(node) {
	  this.print(node.exported, node);
	}
	function ExportSpecifier(node) {
	  if (node.exportKind === "type") {
	    this.word("type");
	    this.space();
	  }

	  this.print(node.local, node);

	  if (node.exported && node.local.name !== node.exported.name) {
	    this.space();
	    this.word("as");
	    this.space();
	    this.print(node.exported, node);
	  }
	}
	function ExportNamespaceSpecifier(node) {
	  this.token("*");
	  this.space();
	  this.word("as");
	  this.space();
	  this.print(node.exported, node);
	}
	function ExportAllDeclaration(node) {
	  this.word("export");
	  this.space();

	  if (node.exportKind === "type") {
	    this.word("type");
	    this.space();
	  }

	  this.token("*");
	  this.space();
	  this.word("from");
	  this.space();
	  this.print(node.source, node);
	  this.printAssertions(node);
	  this.semicolon();
	}
	function ExportNamedDeclaration(node) {
	  if (this.format.decoratorsBeforeExport && isClassDeclaration(node.declaration)) {
	    this.printJoin(node.declaration.decorators, node);
	  }

	  this.word("export");
	  this.space();
	  ExportDeclaration.apply(this, arguments);
	}
	function ExportDefaultDeclaration(node) {
	  if (this.format.decoratorsBeforeExport && isClassDeclaration(node.declaration)) {
	    this.printJoin(node.declaration.decorators, node);
	  }

	  this.word("export");
	  this.space();
	  this.word("default");
	  this.space();
	  ExportDeclaration.apply(this, arguments);
	}

	function ExportDeclaration(node) {
	  if (node.declaration) {
	    const declar = node.declaration;
	    this.print(declar, node);
	    if (!isStatement$4(declar)) this.semicolon();
	  } else {
	    if (node.exportKind === "type") {
	      this.word("type");
	      this.space();
	    }

	    const specifiers = node.specifiers.slice(0);
	    let hasSpecial = false;

	    for (;;) {
	      const first = specifiers[0];

	      if (isExportDefaultSpecifier(first) || isExportNamespaceSpecifier(first)) {
	        hasSpecial = true;
	        this.print(specifiers.shift(), node);

	        if (specifiers.length) {
	          this.token(",");
	          this.space();
	        }
	      } else {
	        break;
	      }
	    }

	    if (specifiers.length || !specifiers.length && !hasSpecial) {
	      this.token("{");

	      if (specifiers.length) {
	        this.space();
	        this.printList(specifiers, node);
	        this.space();
	      }

	      this.token("}");
	    }

	    if (node.source) {
	      this.space();
	      this.word("from");
	      this.space();
	      this.print(node.source, node);
	      this.printAssertions(node);
	    }

	    this.semicolon();
	  }
	}

	function ImportDeclaration(node) {
	  this.word("import");
	  this.space();

	  if (node.importKind === "type" || node.importKind === "typeof") {
	    this.word(node.importKind);
	    this.space();
	  }

	  const specifiers = node.specifiers.slice(0);

	  if (specifiers?.length) {
	    for (;;) {
	      const first = specifiers[0];

	      if (isImportDefaultSpecifier(first) || isImportNamespaceSpecifier(first)) {
	        this.print(specifiers.shift(), node);

	        if (specifiers.length) {
	          this.token(",");
	          this.space();
	        }
	      } else {
	        break;
	      }
	    }

	    if (specifiers.length) {
	      this.token("{");
	      this.space();
	      this.printList(specifiers, node);
	      this.space();
	      this.token("}");
	    }

	    this.space();
	    this.word("from");
	    this.space();
	  }

	  this.print(node.source, node);
	  this.printAssertions(node);

	  if (!browser$5.env.BABEL_8_BREAKING) {
	    if (node.attributes?.length) {
	      this.space();
	      this.word("with");
	      this.space();
	      this.printList(node.attributes, node);
	    }
	  }

	  this.semicolon();
	}
	function ImportAttribute(node) {
	  this.print(node.key);
	  this.token(":");
	  this.space();
	  this.print(node.value);
	}
	function ImportNamespaceSpecifier(node) {
	  this.token("*");
	  this.space();
	  this.word("as");
	  this.space();
	  this.print(node.local, node);
	}

	var byteLength_1 = byteLength;
	var toByteArray_1 = toByteArray;
	var fromByteArray_1 = fromByteArray;
	var lookup = [];
	var revLookup = [];
	var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
	var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

	for (var i = 0, len = code.length; i < len; ++i) {
	  lookup[i] = code[i];
	  revLookup[code.charCodeAt(i)] = i;
	}

	revLookup['-'.charCodeAt(0)] = 62;
	revLookup['_'.charCodeAt(0)] = 63;

	function getLens(b64) {
	  var len = b64.length;

	  if (len % 4 > 0) {
	    throw new Error('Invalid string. Length must be a multiple of 4');
	  }

	  var validLen = b64.indexOf('=');
	  if (validLen === -1) validLen = len;
	  var placeHoldersLen = validLen === len ? 0 : 4 - validLen % 4;
	  return [validLen, placeHoldersLen];
	}

	function byteLength(b64) {
	  var lens = getLens(b64);
	  var validLen = lens[0];
	  var placeHoldersLen = lens[1];
	  return (validLen + placeHoldersLen) * 3 / 4 - placeHoldersLen;
	}

	function _byteLength(b64, validLen, placeHoldersLen) {
	  return (validLen + placeHoldersLen) * 3 / 4 - placeHoldersLen;
	}

	function toByteArray(b64) {
	  var tmp;
	  var lens = getLens(b64);
	  var validLen = lens[0];
	  var placeHoldersLen = lens[1];
	  var arr = new Arr(_byteLength(b64, validLen, placeHoldersLen));
	  var curByte = 0;
	  var len = placeHoldersLen > 0 ? validLen - 4 : validLen;
	  var i;

	  for (i = 0; i < len; i += 4) {
	    tmp = revLookup[b64.charCodeAt(i)] << 18 | revLookup[b64.charCodeAt(i + 1)] << 12 | revLookup[b64.charCodeAt(i + 2)] << 6 | revLookup[b64.charCodeAt(i + 3)];
	    arr[curByte++] = tmp >> 16 & 0xFF;
	    arr[curByte++] = tmp >> 8 & 0xFF;
	    arr[curByte++] = tmp & 0xFF;
	  }

	  if (placeHoldersLen === 2) {
	    tmp = revLookup[b64.charCodeAt(i)] << 2 | revLookup[b64.charCodeAt(i + 1)] >> 4;
	    arr[curByte++] = tmp & 0xFF;
	  }

	  if (placeHoldersLen === 1) {
	    tmp = revLookup[b64.charCodeAt(i)] << 10 | revLookup[b64.charCodeAt(i + 1)] << 4 | revLookup[b64.charCodeAt(i + 2)] >> 2;
	    arr[curByte++] = tmp >> 8 & 0xFF;
	    arr[curByte++] = tmp & 0xFF;
	  }

	  return arr;
	}

	function tripletToBase64(num) {
	  return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F];
	}

	function encodeChunk(uint8, start, end) {
	  var tmp;
	  var output = [];

	  for (var i = start; i < end; i += 3) {
	    tmp = (uint8[i] << 16 & 0xFF0000) + (uint8[i + 1] << 8 & 0xFF00) + (uint8[i + 2] & 0xFF);
	    output.push(tripletToBase64(tmp));
	  }

	  return output.join('');
	}

	function fromByteArray(uint8) {
	  var tmp;
	  var len = uint8.length;
	  var extraBytes = len % 3;
	  var parts = [];
	  var maxChunkLength = 16383;

	  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
	    parts.push(encodeChunk(uint8, i, i + maxChunkLength > len2 ? len2 : i + maxChunkLength));
	  }

	  if (extraBytes === 1) {
	    tmp = uint8[len - 1];
	    parts.push(lookup[tmp >> 2] + lookup[tmp << 4 & 0x3F] + '==');
	  } else if (extraBytes === 2) {
	    tmp = (uint8[len - 2] << 8) + uint8[len - 1];
	    parts.push(lookup[tmp >> 10] + lookup[tmp >> 4 & 0x3F] + lookup[tmp << 2 & 0x3F] + '=');
	  }

	  return parts.join('');
	}

	var base64Js = {
	  byteLength: byteLength_1,
	  toByteArray: toByteArray_1,
	  fromByteArray: fromByteArray_1
	};

	var read = function (buffer, offset, isLE, mLen, nBytes) {
	  var e, m;
	  var eLen = nBytes * 8 - mLen - 1;
	  var eMax = (1 << eLen) - 1;
	  var eBias = eMax >> 1;
	  var nBits = -7;
	  var i = isLE ? nBytes - 1 : 0;
	  var d = isLE ? -1 : 1;
	  var s = buffer[offset + i];
	  i += d;
	  e = s & (1 << -nBits) - 1;
	  s >>= -nBits;
	  nBits += eLen;

	  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  m = e & (1 << -nBits) - 1;
	  e >>= -nBits;
	  nBits += mLen;

	  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  if (e === 0) {
	    e = 1 - eBias;
	  } else if (e === eMax) {
	    return m ? NaN : (s ? -1 : 1) * Infinity;
	  } else {
	    m = m + Math.pow(2, mLen);
	    e = e - eBias;
	  }

	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen);
	};

	var write = function (buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c;
	  var eLen = nBytes * 8 - mLen - 1;
	  var eMax = (1 << eLen) - 1;
	  var eBias = eMax >> 1;
	  var rt = mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0;
	  var i = isLE ? 0 : nBytes - 1;
	  var d = isLE ? 1 : -1;
	  var s = value < 0 || value === 0 && 1 / value < 0 ? 1 : 0;
	  value = Math.abs(value);

	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0;
	    e = eMax;
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2);

	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--;
	      c *= 2;
	    }

	    if (e + eBias >= 1) {
	      value += rt / c;
	    } else {
	      value += rt * Math.pow(2, 1 - eBias);
	    }

	    if (value * c >= 2) {
	      e++;
	      c /= 2;
	    }

	    if (e + eBias >= eMax) {
	      m = 0;
	      e = eMax;
	    } else if (e + eBias >= 1) {
	      m = (value * c - 1) * Math.pow(2, mLen);
	      e = e + eBias;
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
	      e = 0;
	    }
	  }

	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

	  e = e << mLen | m;
	  eLen += mLen;

	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

	  buffer[offset + i - d] |= s * 128;
	};

	var ieee754 = {
	  read: read,
	  write: write
	};

	/*!
	 * The buffer module from node.js, for the browser.
	 *
	 * @author   Feross Aboukhadijeh <https://feross.org>
	 * @license  MIT
	 */
	var buffer = createCommonjsModule(function (module, exports) {

	  exports.Buffer = Buffer;
	  exports.SlowBuffer = SlowBuffer;
	  exports.INSPECT_MAX_BYTES = 50;
	  var K_MAX_LENGTH = 0x7fffffff;
	  exports.kMaxLength = K_MAX_LENGTH;
	  Buffer.TYPED_ARRAY_SUPPORT = typedArraySupport();

	  if (!Buffer.TYPED_ARRAY_SUPPORT && typeof console !== 'undefined' && typeof console.error === 'function') {
	    console.error('This browser lacks typed array (Uint8Array) support which is required by ' + '`buffer` v5.x. Use `buffer` v4.x if you require old browser support.');
	  }

	  function typedArraySupport() {
	    try {
	      var arr = new Uint8Array(1);
	      arr.__proto__ = {
	        __proto__: Uint8Array.prototype,
	        foo: function () {
	          return 42;
	        }
	      };
	      return arr.foo() === 42;
	    } catch (e) {
	      return false;
	    }
	  }

	  Object.defineProperty(Buffer.prototype, 'parent', {
	    enumerable: true,
	    get: function () {
	      if (!Buffer.isBuffer(this)) return undefined;
	      return this.buffer;
	    }
	  });
	  Object.defineProperty(Buffer.prototype, 'offset', {
	    enumerable: true,
	    get: function () {
	      if (!Buffer.isBuffer(this)) return undefined;
	      return this.byteOffset;
	    }
	  });

	  function createBuffer(length) {
	    if (length > K_MAX_LENGTH) {
	      throw new RangeError('The value "' + length + '" is invalid for option "size"');
	    }

	    var buf = new Uint8Array(length);
	    buf.__proto__ = Buffer.prototype;
	    return buf;
	  }

	  function Buffer(arg, encodingOrOffset, length) {
	    if (typeof arg === 'number') {
	      if (typeof encodingOrOffset === 'string') {
	        throw new TypeError('The "string" argument must be of type string. Received type number');
	      }

	      return allocUnsafe(arg);
	    }

	    return from(arg, encodingOrOffset, length);
	  }

	  if (typeof Symbol !== 'undefined' && Symbol.species != null && Buffer[Symbol.species] === Buffer) {
	    Object.defineProperty(Buffer, Symbol.species, {
	      value: null,
	      configurable: true,
	      enumerable: false,
	      writable: false
	    });
	  }

	  Buffer.poolSize = 8192;

	  function from(value, encodingOrOffset, length) {
	    if (typeof value === 'string') {
	      return fromString(value, encodingOrOffset);
	    }

	    if (ArrayBuffer.isView(value)) {
	      return fromArrayLike(value);
	    }

	    if (value == null) {
	      throw TypeError('The first argument must be one of type string, Buffer, ArrayBuffer, Array, ' + 'or Array-like Object. Received type ' + typeof value);
	    }

	    if (isInstance(value, ArrayBuffer) || value && isInstance(value.buffer, ArrayBuffer)) {
	      return fromArrayBuffer(value, encodingOrOffset, length);
	    }

	    if (typeof value === 'number') {
	      throw new TypeError('The "value" argument must not be of type number. Received type number');
	    }

	    var valueOf = value.valueOf && value.valueOf();

	    if (valueOf != null && valueOf !== value) {
	      return Buffer.from(valueOf, encodingOrOffset, length);
	    }

	    var b = fromObject(value);
	    if (b) return b;

	    if (typeof Symbol !== 'undefined' && Symbol.toPrimitive != null && typeof value[Symbol.toPrimitive] === 'function') {
	      return Buffer.from(value[Symbol.toPrimitive]('string'), encodingOrOffset, length);
	    }

	    throw new TypeError('The first argument must be one of type string, Buffer, ArrayBuffer, Array, ' + 'or Array-like Object. Received type ' + typeof value);
	  }

	  Buffer.from = function (value, encodingOrOffset, length) {
	    return from(value, encodingOrOffset, length);
	  };

	  Buffer.prototype.__proto__ = Uint8Array.prototype;
	  Buffer.__proto__ = Uint8Array;

	  function assertSize(size) {
	    if (typeof size !== 'number') {
	      throw new TypeError('"size" argument must be of type number');
	    } else if (size < 0) {
	      throw new RangeError('The value "' + size + '" is invalid for option "size"');
	    }
	  }

	  function alloc(size, fill, encoding) {
	    assertSize(size);

	    if (size <= 0) {
	      return createBuffer(size);
	    }

	    if (fill !== undefined) {
	      return typeof encoding === 'string' ? createBuffer(size).fill(fill, encoding) : createBuffer(size).fill(fill);
	    }

	    return createBuffer(size);
	  }

	  Buffer.alloc = function (size, fill, encoding) {
	    return alloc(size, fill, encoding);
	  };

	  function allocUnsafe(size) {
	    assertSize(size);
	    return createBuffer(size < 0 ? 0 : checked(size) | 0);
	  }

	  Buffer.allocUnsafe = function (size) {
	    return allocUnsafe(size);
	  };

	  Buffer.allocUnsafeSlow = function (size) {
	    return allocUnsafe(size);
	  };

	  function fromString(string, encoding) {
	    if (typeof encoding !== 'string' || encoding === '') {
	      encoding = 'utf8';
	    }

	    if (!Buffer.isEncoding(encoding)) {
	      throw new TypeError('Unknown encoding: ' + encoding);
	    }

	    var length = byteLength(string, encoding) | 0;
	    var buf = createBuffer(length);
	    var actual = buf.write(string, encoding);

	    if (actual !== length) {
	      buf = buf.slice(0, actual);
	    }

	    return buf;
	  }

	  function fromArrayLike(array) {
	    var length = array.length < 0 ? 0 : checked(array.length) | 0;
	    var buf = createBuffer(length);

	    for (var i = 0; i < length; i += 1) {
	      buf[i] = array[i] & 255;
	    }

	    return buf;
	  }

	  function fromArrayBuffer(array, byteOffset, length) {
	    if (byteOffset < 0 || array.byteLength < byteOffset) {
	      throw new RangeError('"offset" is outside of buffer bounds');
	    }

	    if (array.byteLength < byteOffset + (length || 0)) {
	      throw new RangeError('"length" is outside of buffer bounds');
	    }

	    var buf;

	    if (byteOffset === undefined && length === undefined) {
	      buf = new Uint8Array(array);
	    } else if (length === undefined) {
	      buf = new Uint8Array(array, byteOffset);
	    } else {
	      buf = new Uint8Array(array, byteOffset, length);
	    }

	    buf.__proto__ = Buffer.prototype;
	    return buf;
	  }

	  function fromObject(obj) {
	    if (Buffer.isBuffer(obj)) {
	      var len = checked(obj.length) | 0;
	      var buf = createBuffer(len);

	      if (buf.length === 0) {
	        return buf;
	      }

	      obj.copy(buf, 0, 0, len);
	      return buf;
	    }

	    if (obj.length !== undefined) {
	      if (typeof obj.length !== 'number' || numberIsNaN(obj.length)) {
	        return createBuffer(0);
	      }

	      return fromArrayLike(obj);
	    }

	    if (obj.type === 'Buffer' && Array.isArray(obj.data)) {
	      return fromArrayLike(obj.data);
	    }
	  }

	  function checked(length) {
	    if (length >= K_MAX_LENGTH) {
	      throw new RangeError('Attempt to allocate Buffer larger than maximum ' + 'size: 0x' + K_MAX_LENGTH.toString(16) + ' bytes');
	    }

	    return length | 0;
	  }

	  function SlowBuffer(length) {
	    if (+length != length) {
	      length = 0;
	    }

	    return Buffer.alloc(+length);
	  }

	  Buffer.isBuffer = function isBuffer(b) {
	    return b != null && b._isBuffer === true && b !== Buffer.prototype;
	  };

	  Buffer.compare = function compare(a, b) {
	    if (isInstance(a, Uint8Array)) a = Buffer.from(a, a.offset, a.byteLength);
	    if (isInstance(b, Uint8Array)) b = Buffer.from(b, b.offset, b.byteLength);

	    if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
	      throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');
	    }

	    if (a === b) return 0;
	    var x = a.length;
	    var y = b.length;

	    for (var i = 0, len = Math.min(x, y); i < len; ++i) {
	      if (a[i] !== b[i]) {
	        x = a[i];
	        y = b[i];
	        break;
	      }
	    }

	    if (x < y) return -1;
	    if (y < x) return 1;
	    return 0;
	  };

	  Buffer.isEncoding = function isEncoding(encoding) {
	    switch (String(encoding).toLowerCase()) {
	      case 'hex':
	      case 'utf8':
	      case 'utf-8':
	      case 'ascii':
	      case 'latin1':
	      case 'binary':
	      case 'base64':
	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return true;

	      default:
	        return false;
	    }
	  };

	  Buffer.concat = function concat(list, length) {
	    if (!Array.isArray(list)) {
	      throw new TypeError('"list" argument must be an Array of Buffers');
	    }

	    if (list.length === 0) {
	      return Buffer.alloc(0);
	    }

	    var i;

	    if (length === undefined) {
	      length = 0;

	      for (i = 0; i < list.length; ++i) {
	        length += list[i].length;
	      }
	    }

	    var buffer = Buffer.allocUnsafe(length);
	    var pos = 0;

	    for (i = 0; i < list.length; ++i) {
	      var buf = list[i];

	      if (isInstance(buf, Uint8Array)) {
	        buf = Buffer.from(buf);
	      }

	      if (!Buffer.isBuffer(buf)) {
	        throw new TypeError('"list" argument must be an Array of Buffers');
	      }

	      buf.copy(buffer, pos);
	      pos += buf.length;
	    }

	    return buffer;
	  };

	  function byteLength(string, encoding) {
	    if (Buffer.isBuffer(string)) {
	      return string.length;
	    }

	    if (ArrayBuffer.isView(string) || isInstance(string, ArrayBuffer)) {
	      return string.byteLength;
	    }

	    if (typeof string !== 'string') {
	      throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. ' + 'Received type ' + typeof string);
	    }

	    var len = string.length;
	    var mustMatch = arguments.length > 2 && arguments[2] === true;
	    if (!mustMatch && len === 0) return 0;
	    var loweredCase = false;

	    for (;;) {
	      switch (encoding) {
	        case 'ascii':
	        case 'latin1':
	        case 'binary':
	          return len;

	        case 'utf8':
	        case 'utf-8':
	          return utf8ToBytes(string).length;

	        case 'ucs2':
	        case 'ucs-2':
	        case 'utf16le':
	        case 'utf-16le':
	          return len * 2;

	        case 'hex':
	          return len >>> 1;

	        case 'base64':
	          return base64ToBytes(string).length;

	        default:
	          if (loweredCase) {
	            return mustMatch ? -1 : utf8ToBytes(string).length;
	          }

	          encoding = ('' + encoding).toLowerCase();
	          loweredCase = true;
	      }
	    }
	  }

	  Buffer.byteLength = byteLength;

	  function slowToString(encoding, start, end) {
	    var loweredCase = false;

	    if (start === undefined || start < 0) {
	      start = 0;
	    }

	    if (start > this.length) {
	      return '';
	    }

	    if (end === undefined || end > this.length) {
	      end = this.length;
	    }

	    if (end <= 0) {
	      return '';
	    }

	    end >>>= 0;
	    start >>>= 0;

	    if (end <= start) {
	      return '';
	    }

	    if (!encoding) encoding = 'utf8';

	    while (true) {
	      switch (encoding) {
	        case 'hex':
	          return hexSlice(this, start, end);

	        case 'utf8':
	        case 'utf-8':
	          return utf8Slice(this, start, end);

	        case 'ascii':
	          return asciiSlice(this, start, end);

	        case 'latin1':
	        case 'binary':
	          return latin1Slice(this, start, end);

	        case 'base64':
	          return base64Slice(this, start, end);

	        case 'ucs2':
	        case 'ucs-2':
	        case 'utf16le':
	        case 'utf-16le':
	          return utf16leSlice(this, start, end);

	        default:
	          if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding);
	          encoding = (encoding + '').toLowerCase();
	          loweredCase = true;
	      }
	    }
	  }

	  Buffer.prototype._isBuffer = true;

	  function swap(b, n, m) {
	    var i = b[n];
	    b[n] = b[m];
	    b[m] = i;
	  }

	  Buffer.prototype.swap16 = function swap16() {
	    var len = this.length;

	    if (len % 2 !== 0) {
	      throw new RangeError('Buffer size must be a multiple of 16-bits');
	    }

	    for (var i = 0; i < len; i += 2) {
	      swap(this, i, i + 1);
	    }

	    return this;
	  };

	  Buffer.prototype.swap32 = function swap32() {
	    var len = this.length;

	    if (len % 4 !== 0) {
	      throw new RangeError('Buffer size must be a multiple of 32-bits');
	    }

	    for (var i = 0; i < len; i += 4) {
	      swap(this, i, i + 3);
	      swap(this, i + 1, i + 2);
	    }

	    return this;
	  };

	  Buffer.prototype.swap64 = function swap64() {
	    var len = this.length;

	    if (len % 8 !== 0) {
	      throw new RangeError('Buffer size must be a multiple of 64-bits');
	    }

	    for (var i = 0; i < len; i += 8) {
	      swap(this, i, i + 7);
	      swap(this, i + 1, i + 6);
	      swap(this, i + 2, i + 5);
	      swap(this, i + 3, i + 4);
	    }

	    return this;
	  };

	  Buffer.prototype.toString = function toString() {
	    var length = this.length;
	    if (length === 0) return '';
	    if (arguments.length === 0) return utf8Slice(this, 0, length);
	    return slowToString.apply(this, arguments);
	  };

	  Buffer.prototype.toLocaleString = Buffer.prototype.toString;

	  Buffer.prototype.equals = function equals(b) {
	    if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer');
	    if (this === b) return true;
	    return Buffer.compare(this, b) === 0;
	  };

	  Buffer.prototype.inspect = function inspect() {
	    var str = '';
	    var max = exports.INSPECT_MAX_BYTES;
	    str = this.toString('hex', 0, max).replace(/(.{2})/g, '$1 ').trim();
	    if (this.length > max) str += ' ... ';
	    return '<Buffer ' + str + '>';
	  };

	  Buffer.prototype.compare = function compare(target, start, end, thisStart, thisEnd) {
	    if (isInstance(target, Uint8Array)) {
	      target = Buffer.from(target, target.offset, target.byteLength);
	    }

	    if (!Buffer.isBuffer(target)) {
	      throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. ' + 'Received type ' + typeof target);
	    }

	    if (start === undefined) {
	      start = 0;
	    }

	    if (end === undefined) {
	      end = target ? target.length : 0;
	    }

	    if (thisStart === undefined) {
	      thisStart = 0;
	    }

	    if (thisEnd === undefined) {
	      thisEnd = this.length;
	    }

	    if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
	      throw new RangeError('out of range index');
	    }

	    if (thisStart >= thisEnd && start >= end) {
	      return 0;
	    }

	    if (thisStart >= thisEnd) {
	      return -1;
	    }

	    if (start >= end) {
	      return 1;
	    }

	    start >>>= 0;
	    end >>>= 0;
	    thisStart >>>= 0;
	    thisEnd >>>= 0;
	    if (this === target) return 0;
	    var x = thisEnd - thisStart;
	    var y = end - start;
	    var len = Math.min(x, y);
	    var thisCopy = this.slice(thisStart, thisEnd);
	    var targetCopy = target.slice(start, end);

	    for (var i = 0; i < len; ++i) {
	      if (thisCopy[i] !== targetCopy[i]) {
	        x = thisCopy[i];
	        y = targetCopy[i];
	        break;
	      }
	    }

	    if (x < y) return -1;
	    if (y < x) return 1;
	    return 0;
	  };

	  function bidirectionalIndexOf(buffer, val, byteOffset, encoding, dir) {
	    if (buffer.length === 0) return -1;

	    if (typeof byteOffset === 'string') {
	      encoding = byteOffset;
	      byteOffset = 0;
	    } else if (byteOffset > 0x7fffffff) {
	      byteOffset = 0x7fffffff;
	    } else if (byteOffset < -0x80000000) {
	      byteOffset = -0x80000000;
	    }

	    byteOffset = +byteOffset;

	    if (numberIsNaN(byteOffset)) {
	      byteOffset = dir ? 0 : buffer.length - 1;
	    }

	    if (byteOffset < 0) byteOffset = buffer.length + byteOffset;

	    if (byteOffset >= buffer.length) {
	      if (dir) return -1;else byteOffset = buffer.length - 1;
	    } else if (byteOffset < 0) {
	      if (dir) byteOffset = 0;else return -1;
	    }

	    if (typeof val === 'string') {
	      val = Buffer.from(val, encoding);
	    }

	    if (Buffer.isBuffer(val)) {
	      if (val.length === 0) {
	        return -1;
	      }

	      return arrayIndexOf(buffer, val, byteOffset, encoding, dir);
	    } else if (typeof val === 'number') {
	      val = val & 0xFF;

	      if (typeof Uint8Array.prototype.indexOf === 'function') {
	        if (dir) {
	          return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset);
	        } else {
	          return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset);
	        }
	      }

	      return arrayIndexOf(buffer, [val], byteOffset, encoding, dir);
	    }

	    throw new TypeError('val must be string, number or Buffer');
	  }

	  function arrayIndexOf(arr, val, byteOffset, encoding, dir) {
	    var indexSize = 1;
	    var arrLength = arr.length;
	    var valLength = val.length;

	    if (encoding !== undefined) {
	      encoding = String(encoding).toLowerCase();

	      if (encoding === 'ucs2' || encoding === 'ucs-2' || encoding === 'utf16le' || encoding === 'utf-16le') {
	        if (arr.length < 2 || val.length < 2) {
	          return -1;
	        }

	        indexSize = 2;
	        arrLength /= 2;
	        valLength /= 2;
	        byteOffset /= 2;
	      }
	    }

	    function read(buf, i) {
	      if (indexSize === 1) {
	        return buf[i];
	      } else {
	        return buf.readUInt16BE(i * indexSize);
	      }
	    }

	    var i;

	    if (dir) {
	      var foundIndex = -1;

	      for (i = byteOffset; i < arrLength; i++) {
	        if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
	          if (foundIndex === -1) foundIndex = i;
	          if (i - foundIndex + 1 === valLength) return foundIndex * indexSize;
	        } else {
	          if (foundIndex !== -1) i -= i - foundIndex;
	          foundIndex = -1;
	        }
	      }
	    } else {
	      if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;

	      for (i = byteOffset; i >= 0; i--) {
	        var found = true;

	        for (var j = 0; j < valLength; j++) {
	          if (read(arr, i + j) !== read(val, j)) {
	            found = false;
	            break;
	          }
	        }

	        if (found) return i;
	      }
	    }

	    return -1;
	  }

	  Buffer.prototype.includes = function includes(val, byteOffset, encoding) {
	    return this.indexOf(val, byteOffset, encoding) !== -1;
	  };

	  Buffer.prototype.indexOf = function indexOf(val, byteOffset, encoding) {
	    return bidirectionalIndexOf(this, val, byteOffset, encoding, true);
	  };

	  Buffer.prototype.lastIndexOf = function lastIndexOf(val, byteOffset, encoding) {
	    return bidirectionalIndexOf(this, val, byteOffset, encoding, false);
	  };

	  function hexWrite(buf, string, offset, length) {
	    offset = Number(offset) || 0;
	    var remaining = buf.length - offset;

	    if (!length) {
	      length = remaining;
	    } else {
	      length = Number(length);

	      if (length > remaining) {
	        length = remaining;
	      }
	    }

	    var strLen = string.length;

	    if (length > strLen / 2) {
	      length = strLen / 2;
	    }

	    for (var i = 0; i < length; ++i) {
	      var parsed = parseInt(string.substr(i * 2, 2), 16);
	      if (numberIsNaN(parsed)) return i;
	      buf[offset + i] = parsed;
	    }

	    return i;
	  }

	  function utf8Write(buf, string, offset, length) {
	    return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length);
	  }

	  function asciiWrite(buf, string, offset, length) {
	    return blitBuffer(asciiToBytes(string), buf, offset, length);
	  }

	  function latin1Write(buf, string, offset, length) {
	    return asciiWrite(buf, string, offset, length);
	  }

	  function base64Write(buf, string, offset, length) {
	    return blitBuffer(base64ToBytes(string), buf, offset, length);
	  }

	  function ucs2Write(buf, string, offset, length) {
	    return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length);
	  }

	  Buffer.prototype.write = function write(string, offset, length, encoding) {
	    if (offset === undefined) {
	      encoding = 'utf8';
	      length = this.length;
	      offset = 0;
	    } else if (length === undefined && typeof offset === 'string') {
	      encoding = offset;
	      length = this.length;
	      offset = 0;
	    } else if (isFinite(offset)) {
	      offset = offset >>> 0;

	      if (isFinite(length)) {
	        length = length >>> 0;
	        if (encoding === undefined) encoding = 'utf8';
	      } else {
	        encoding = length;
	        length = undefined;
	      }
	    } else {
	      throw new Error('Buffer.write(string, encoding, offset[, length]) is no longer supported');
	    }

	    var remaining = this.length - offset;
	    if (length === undefined || length > remaining) length = remaining;

	    if (string.length > 0 && (length < 0 || offset < 0) || offset > this.length) {
	      throw new RangeError('Attempt to write outside buffer bounds');
	    }

	    if (!encoding) encoding = 'utf8';
	    var loweredCase = false;

	    for (;;) {
	      switch (encoding) {
	        case 'hex':
	          return hexWrite(this, string, offset, length);

	        case 'utf8':
	        case 'utf-8':
	          return utf8Write(this, string, offset, length);

	        case 'ascii':
	          return asciiWrite(this, string, offset, length);

	        case 'latin1':
	        case 'binary':
	          return latin1Write(this, string, offset, length);

	        case 'base64':
	          return base64Write(this, string, offset, length);

	        case 'ucs2':
	        case 'ucs-2':
	        case 'utf16le':
	        case 'utf-16le':
	          return ucs2Write(this, string, offset, length);

	        default:
	          if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding);
	          encoding = ('' + encoding).toLowerCase();
	          loweredCase = true;
	      }
	    }
	  };

	  Buffer.prototype.toJSON = function toJSON() {
	    return {
	      type: 'Buffer',
	      data: Array.prototype.slice.call(this._arr || this, 0)
	    };
	  };

	  function base64Slice(buf, start, end) {
	    if (start === 0 && end === buf.length) {
	      return base64Js.fromByteArray(buf);
	    } else {
	      return base64Js.fromByteArray(buf.slice(start, end));
	    }
	  }

	  function utf8Slice(buf, start, end) {
	    end = Math.min(buf.length, end);
	    var res = [];
	    var i = start;

	    while (i < end) {
	      var firstByte = buf[i];
	      var codePoint = null;
	      var bytesPerSequence = firstByte > 0xEF ? 4 : firstByte > 0xDF ? 3 : firstByte > 0xBF ? 2 : 1;

	      if (i + bytesPerSequence <= end) {
	        var secondByte, thirdByte, fourthByte, tempCodePoint;

	        switch (bytesPerSequence) {
	          case 1:
	            if (firstByte < 0x80) {
	              codePoint = firstByte;
	            }

	            break;

	          case 2:
	            secondByte = buf[i + 1];

	            if ((secondByte & 0xC0) === 0x80) {
	              tempCodePoint = (firstByte & 0x1F) << 0x6 | secondByte & 0x3F;

	              if (tempCodePoint > 0x7F) {
	                codePoint = tempCodePoint;
	              }
	            }

	            break;

	          case 3:
	            secondByte = buf[i + 1];
	            thirdByte = buf[i + 2];

	            if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
	              tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | thirdByte & 0x3F;

	              if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
	                codePoint = tempCodePoint;
	              }
	            }

	            break;

	          case 4:
	            secondByte = buf[i + 1];
	            thirdByte = buf[i + 2];
	            fourthByte = buf[i + 3];

	            if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
	              tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | fourthByte & 0x3F;

	              if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
	                codePoint = tempCodePoint;
	              }
	            }

	        }
	      }

	      if (codePoint === null) {
	        codePoint = 0xFFFD;
	        bytesPerSequence = 1;
	      } else if (codePoint > 0xFFFF) {
	        codePoint -= 0x10000;
	        res.push(codePoint >>> 10 & 0x3FF | 0xD800);
	        codePoint = 0xDC00 | codePoint & 0x3FF;
	      }

	      res.push(codePoint);
	      i += bytesPerSequence;
	    }

	    return decodeCodePointsArray(res);
	  }

	  var MAX_ARGUMENTS_LENGTH = 0x1000;

	  function decodeCodePointsArray(codePoints) {
	    var len = codePoints.length;

	    if (len <= MAX_ARGUMENTS_LENGTH) {
	      return String.fromCharCode.apply(String, codePoints);
	    }

	    var res = '';
	    var i = 0;

	    while (i < len) {
	      res += String.fromCharCode.apply(String, codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH));
	    }

	    return res;
	  }

	  function asciiSlice(buf, start, end) {
	    var ret = '';
	    end = Math.min(buf.length, end);

	    for (var i = start; i < end; ++i) {
	      ret += String.fromCharCode(buf[i] & 0x7F);
	    }

	    return ret;
	  }

	  function latin1Slice(buf, start, end) {
	    var ret = '';
	    end = Math.min(buf.length, end);

	    for (var i = start; i < end; ++i) {
	      ret += String.fromCharCode(buf[i]);
	    }

	    return ret;
	  }

	  function hexSlice(buf, start, end) {
	    var len = buf.length;
	    if (!start || start < 0) start = 0;
	    if (!end || end < 0 || end > len) end = len;
	    var out = '';

	    for (var i = start; i < end; ++i) {
	      out += toHex(buf[i]);
	    }

	    return out;
	  }

	  function utf16leSlice(buf, start, end) {
	    var bytes = buf.slice(start, end);
	    var res = '';

	    for (var i = 0; i < bytes.length; i += 2) {
	      res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
	    }

	    return res;
	  }

	  Buffer.prototype.slice = function slice(start, end) {
	    var len = this.length;
	    start = ~~start;
	    end = end === undefined ? len : ~~end;

	    if (start < 0) {
	      start += len;
	      if (start < 0) start = 0;
	    } else if (start > len) {
	      start = len;
	    }

	    if (end < 0) {
	      end += len;
	      if (end < 0) end = 0;
	    } else if (end > len) {
	      end = len;
	    }

	    if (end < start) end = start;
	    var newBuf = this.subarray(start, end);
	    newBuf.__proto__ = Buffer.prototype;
	    return newBuf;
	  };

	  function checkOffset(offset, ext, length) {
	    if (offset % 1 !== 0 || offset < 0) throw new RangeError('offset is not uint');
	    if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length');
	  }

	  Buffer.prototype.readUIntLE = function readUIntLE(offset, byteLength, noAssert) {
	    offset = offset >>> 0;
	    byteLength = byteLength >>> 0;
	    if (!noAssert) checkOffset(offset, byteLength, this.length);
	    var val = this[offset];
	    var mul = 1;
	    var i = 0;

	    while (++i < byteLength && (mul *= 0x100)) {
	      val += this[offset + i] * mul;
	    }

	    return val;
	  };

	  Buffer.prototype.readUIntBE = function readUIntBE(offset, byteLength, noAssert) {
	    offset = offset >>> 0;
	    byteLength = byteLength >>> 0;

	    if (!noAssert) {
	      checkOffset(offset, byteLength, this.length);
	    }

	    var val = this[offset + --byteLength];
	    var mul = 1;

	    while (byteLength > 0 && (mul *= 0x100)) {
	      val += this[offset + --byteLength] * mul;
	    }

	    return val;
	  };

	  Buffer.prototype.readUInt8 = function readUInt8(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 1, this.length);
	    return this[offset];
	  };

	  Buffer.prototype.readUInt16LE = function readUInt16LE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 2, this.length);
	    return this[offset] | this[offset + 1] << 8;
	  };

	  Buffer.prototype.readUInt16BE = function readUInt16BE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 2, this.length);
	    return this[offset] << 8 | this[offset + 1];
	  };

	  Buffer.prototype.readUInt32LE = function readUInt32LE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 4, this.length);
	    return (this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16) + this[offset + 3] * 0x1000000;
	  };

	  Buffer.prototype.readUInt32BE = function readUInt32BE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 4, this.length);
	    return this[offset] * 0x1000000 + (this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3]);
	  };

	  Buffer.prototype.readIntLE = function readIntLE(offset, byteLength, noAssert) {
	    offset = offset >>> 0;
	    byteLength = byteLength >>> 0;
	    if (!noAssert) checkOffset(offset, byteLength, this.length);
	    var val = this[offset];
	    var mul = 1;
	    var i = 0;

	    while (++i < byteLength && (mul *= 0x100)) {
	      val += this[offset + i] * mul;
	    }

	    mul *= 0x80;
	    if (val >= mul) val -= Math.pow(2, 8 * byteLength);
	    return val;
	  };

	  Buffer.prototype.readIntBE = function readIntBE(offset, byteLength, noAssert) {
	    offset = offset >>> 0;
	    byteLength = byteLength >>> 0;
	    if (!noAssert) checkOffset(offset, byteLength, this.length);
	    var i = byteLength;
	    var mul = 1;
	    var val = this[offset + --i];

	    while (i > 0 && (mul *= 0x100)) {
	      val += this[offset + --i] * mul;
	    }

	    mul *= 0x80;
	    if (val >= mul) val -= Math.pow(2, 8 * byteLength);
	    return val;
	  };

	  Buffer.prototype.readInt8 = function readInt8(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 1, this.length);
	    if (!(this[offset] & 0x80)) return this[offset];
	    return (0xff - this[offset] + 1) * -1;
	  };

	  Buffer.prototype.readInt16LE = function readInt16LE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 2, this.length);
	    var val = this[offset] | this[offset + 1] << 8;
	    return val & 0x8000 ? val | 0xFFFF0000 : val;
	  };

	  Buffer.prototype.readInt16BE = function readInt16BE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 2, this.length);
	    var val = this[offset + 1] | this[offset] << 8;
	    return val & 0x8000 ? val | 0xFFFF0000 : val;
	  };

	  Buffer.prototype.readInt32LE = function readInt32LE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 4, this.length);
	    return this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16 | this[offset + 3] << 24;
	  };

	  Buffer.prototype.readInt32BE = function readInt32BE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 4, this.length);
	    return this[offset] << 24 | this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3];
	  };

	  Buffer.prototype.readFloatLE = function readFloatLE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 4, this.length);
	    return ieee754.read(this, offset, true, 23, 4);
	  };

	  Buffer.prototype.readFloatBE = function readFloatBE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 4, this.length);
	    return ieee754.read(this, offset, false, 23, 4);
	  };

	  Buffer.prototype.readDoubleLE = function readDoubleLE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 8, this.length);
	    return ieee754.read(this, offset, true, 52, 8);
	  };

	  Buffer.prototype.readDoubleBE = function readDoubleBE(offset, noAssert) {
	    offset = offset >>> 0;
	    if (!noAssert) checkOffset(offset, 8, this.length);
	    return ieee754.read(this, offset, false, 52, 8);
	  };

	  function checkInt(buf, value, offset, ext, max, min) {
	    if (!Buffer.isBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance');
	    if (value > max || value < min) throw new RangeError('"value" argument is out of bounds');
	    if (offset + ext > buf.length) throw new RangeError('Index out of range');
	  }

	  Buffer.prototype.writeUIntLE = function writeUIntLE(value, offset, byteLength, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    byteLength = byteLength >>> 0;

	    if (!noAssert) {
	      var maxBytes = Math.pow(2, 8 * byteLength) - 1;
	      checkInt(this, value, offset, byteLength, maxBytes, 0);
	    }

	    var mul = 1;
	    var i = 0;
	    this[offset] = value & 0xFF;

	    while (++i < byteLength && (mul *= 0x100)) {
	      this[offset + i] = value / mul & 0xFF;
	    }

	    return offset + byteLength;
	  };

	  Buffer.prototype.writeUIntBE = function writeUIntBE(value, offset, byteLength, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    byteLength = byteLength >>> 0;

	    if (!noAssert) {
	      var maxBytes = Math.pow(2, 8 * byteLength) - 1;
	      checkInt(this, value, offset, byteLength, maxBytes, 0);
	    }

	    var i = byteLength - 1;
	    var mul = 1;
	    this[offset + i] = value & 0xFF;

	    while (--i >= 0 && (mul *= 0x100)) {
	      this[offset + i] = value / mul & 0xFF;
	    }

	    return offset + byteLength;
	  };

	  Buffer.prototype.writeUInt8 = function writeUInt8(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0);
	    this[offset] = value & 0xff;
	    return offset + 1;
	  };

	  Buffer.prototype.writeUInt16LE = function writeUInt16LE(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
	    this[offset] = value & 0xff;
	    this[offset + 1] = value >>> 8;
	    return offset + 2;
	  };

	  Buffer.prototype.writeUInt16BE = function writeUInt16BE(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
	    this[offset] = value >>> 8;
	    this[offset + 1] = value & 0xff;
	    return offset + 2;
	  };

	  Buffer.prototype.writeUInt32LE = function writeUInt32LE(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
	    this[offset + 3] = value >>> 24;
	    this[offset + 2] = value >>> 16;
	    this[offset + 1] = value >>> 8;
	    this[offset] = value & 0xff;
	    return offset + 4;
	  };

	  Buffer.prototype.writeUInt32BE = function writeUInt32BE(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
	    this[offset] = value >>> 24;
	    this[offset + 1] = value >>> 16;
	    this[offset + 2] = value >>> 8;
	    this[offset + 3] = value & 0xff;
	    return offset + 4;
	  };

	  Buffer.prototype.writeIntLE = function writeIntLE(value, offset, byteLength, noAssert) {
	    value = +value;
	    offset = offset >>> 0;

	    if (!noAssert) {
	      var limit = Math.pow(2, 8 * byteLength - 1);
	      checkInt(this, value, offset, byteLength, limit - 1, -limit);
	    }

	    var i = 0;
	    var mul = 1;
	    var sub = 0;
	    this[offset] = value & 0xFF;

	    while (++i < byteLength && (mul *= 0x100)) {
	      if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
	        sub = 1;
	      }

	      this[offset + i] = (value / mul >> 0) - sub & 0xFF;
	    }

	    return offset + byteLength;
	  };

	  Buffer.prototype.writeIntBE = function writeIntBE(value, offset, byteLength, noAssert) {
	    value = +value;
	    offset = offset >>> 0;

	    if (!noAssert) {
	      var limit = Math.pow(2, 8 * byteLength - 1);
	      checkInt(this, value, offset, byteLength, limit - 1, -limit);
	    }

	    var i = byteLength - 1;
	    var mul = 1;
	    var sub = 0;
	    this[offset + i] = value & 0xFF;

	    while (--i >= 0 && (mul *= 0x100)) {
	      if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
	        sub = 1;
	      }

	      this[offset + i] = (value / mul >> 0) - sub & 0xFF;
	    }

	    return offset + byteLength;
	  };

	  Buffer.prototype.writeInt8 = function writeInt8(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80);
	    if (value < 0) value = 0xff + value + 1;
	    this[offset] = value & 0xff;
	    return offset + 1;
	  };

	  Buffer.prototype.writeInt16LE = function writeInt16LE(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
	    this[offset] = value & 0xff;
	    this[offset + 1] = value >>> 8;
	    return offset + 2;
	  };

	  Buffer.prototype.writeInt16BE = function writeInt16BE(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
	    this[offset] = value >>> 8;
	    this[offset + 1] = value & 0xff;
	    return offset + 2;
	  };

	  Buffer.prototype.writeInt32LE = function writeInt32LE(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
	    this[offset] = value & 0xff;
	    this[offset + 1] = value >>> 8;
	    this[offset + 2] = value >>> 16;
	    this[offset + 3] = value >>> 24;
	    return offset + 4;
	  };

	  Buffer.prototype.writeInt32BE = function writeInt32BE(value, offset, noAssert) {
	    value = +value;
	    offset = offset >>> 0;
	    if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
	    if (value < 0) value = 0xffffffff + value + 1;
	    this[offset] = value >>> 24;
	    this[offset + 1] = value >>> 16;
	    this[offset + 2] = value >>> 8;
	    this[offset + 3] = value & 0xff;
	    return offset + 4;
	  };

	  function checkIEEE754(buf, value, offset, ext, max, min) {
	    if (offset + ext > buf.length) throw new RangeError('Index out of range');
	    if (offset < 0) throw new RangeError('Index out of range');
	  }

	  function writeFloat(buf, value, offset, littleEndian, noAssert) {
	    value = +value;
	    offset = offset >>> 0;

	    if (!noAssert) {
	      checkIEEE754(buf, value, offset, 4);
	    }

	    ieee754.write(buf, value, offset, littleEndian, 23, 4);
	    return offset + 4;
	  }

	  Buffer.prototype.writeFloatLE = function writeFloatLE(value, offset, noAssert) {
	    return writeFloat(this, value, offset, true, noAssert);
	  };

	  Buffer.prototype.writeFloatBE = function writeFloatBE(value, offset, noAssert) {
	    return writeFloat(this, value, offset, false, noAssert);
	  };

	  function writeDouble(buf, value, offset, littleEndian, noAssert) {
	    value = +value;
	    offset = offset >>> 0;

	    if (!noAssert) {
	      checkIEEE754(buf, value, offset, 8);
	    }

	    ieee754.write(buf, value, offset, littleEndian, 52, 8);
	    return offset + 8;
	  }

	  Buffer.prototype.writeDoubleLE = function writeDoubleLE(value, offset, noAssert) {
	    return writeDouble(this, value, offset, true, noAssert);
	  };

	  Buffer.prototype.writeDoubleBE = function writeDoubleBE(value, offset, noAssert) {
	    return writeDouble(this, value, offset, false, noAssert);
	  };

	  Buffer.prototype.copy = function copy(target, targetStart, start, end) {
	    if (!Buffer.isBuffer(target)) throw new TypeError('argument should be a Buffer');
	    if (!start) start = 0;
	    if (!end && end !== 0) end = this.length;
	    if (targetStart >= target.length) targetStart = target.length;
	    if (!targetStart) targetStart = 0;
	    if (end > 0 && end < start) end = start;
	    if (end === start) return 0;
	    if (target.length === 0 || this.length === 0) return 0;

	    if (targetStart < 0) {
	      throw new RangeError('targetStart out of bounds');
	    }

	    if (start < 0 || start >= this.length) throw new RangeError('Index out of range');
	    if (end < 0) throw new RangeError('sourceEnd out of bounds');
	    if (end > this.length) end = this.length;

	    if (target.length - targetStart < end - start) {
	      end = target.length - targetStart + start;
	    }

	    var len = end - start;

	    if (this === target && typeof Uint8Array.prototype.copyWithin === 'function') {
	      this.copyWithin(targetStart, start, end);
	    } else if (this === target && start < targetStart && targetStart < end) {
	      for (var i = len - 1; i >= 0; --i) {
	        target[i + targetStart] = this[i + start];
	      }
	    } else {
	      Uint8Array.prototype.set.call(target, this.subarray(start, end), targetStart);
	    }

	    return len;
	  };

	  Buffer.prototype.fill = function fill(val, start, end, encoding) {
	    if (typeof val === 'string') {
	      if (typeof start === 'string') {
	        encoding = start;
	        start = 0;
	        end = this.length;
	      } else if (typeof end === 'string') {
	        encoding = end;
	        end = this.length;
	      }

	      if (encoding !== undefined && typeof encoding !== 'string') {
	        throw new TypeError('encoding must be a string');
	      }

	      if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
	        throw new TypeError('Unknown encoding: ' + encoding);
	      }

	      if (val.length === 1) {
	        var code = val.charCodeAt(0);

	        if (encoding === 'utf8' && code < 128 || encoding === 'latin1') {
	          val = code;
	        }
	      }
	    } else if (typeof val === 'number') {
	      val = val & 255;
	    }

	    if (start < 0 || this.length < start || this.length < end) {
	      throw new RangeError('Out of range index');
	    }

	    if (end <= start) {
	      return this;
	    }

	    start = start >>> 0;
	    end = end === undefined ? this.length : end >>> 0;
	    if (!val) val = 0;
	    var i;

	    if (typeof val === 'number') {
	      for (i = start; i < end; ++i) {
	        this[i] = val;
	      }
	    } else {
	      var bytes = Buffer.isBuffer(val) ? val : Buffer.from(val, encoding);
	      var len = bytes.length;

	      if (len === 0) {
	        throw new TypeError('The value "' + val + '" is invalid for argument "value"');
	      }

	      for (i = 0; i < end - start; ++i) {
	        this[i + start] = bytes[i % len];
	      }
	    }

	    return this;
	  };

	  var INVALID_BASE64_RE = /[^+/0-9A-Za-z-_]/g;

	  function base64clean(str) {
	    str = str.split('=')[0];
	    str = str.trim().replace(INVALID_BASE64_RE, '');
	    if (str.length < 2) return '';

	    while (str.length % 4 !== 0) {
	      str = str + '=';
	    }

	    return str;
	  }

	  function toHex(n) {
	    if (n < 16) return '0' + n.toString(16);
	    return n.toString(16);
	  }

	  function utf8ToBytes(string, units) {
	    units = units || Infinity;
	    var codePoint;
	    var length = string.length;
	    var leadSurrogate = null;
	    var bytes = [];

	    for (var i = 0; i < length; ++i) {
	      codePoint = string.charCodeAt(i);

	      if (codePoint > 0xD7FF && codePoint < 0xE000) {
	        if (!leadSurrogate) {
	          if (codePoint > 0xDBFF) {
	            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
	            continue;
	          } else if (i + 1 === length) {
	            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
	            continue;
	          }

	          leadSurrogate = codePoint;
	          continue;
	        }

	        if (codePoint < 0xDC00) {
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
	          leadSurrogate = codePoint;
	          continue;
	        }

	        codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
	      } else if (leadSurrogate) {
	        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
	      }

	      leadSurrogate = null;

	      if (codePoint < 0x80) {
	        if ((units -= 1) < 0) break;
	        bytes.push(codePoint);
	      } else if (codePoint < 0x800) {
	        if ((units -= 2) < 0) break;
	        bytes.push(codePoint >> 0x6 | 0xC0, codePoint & 0x3F | 0x80);
	      } else if (codePoint < 0x10000) {
	        if ((units -= 3) < 0) break;
	        bytes.push(codePoint >> 0xC | 0xE0, codePoint >> 0x6 & 0x3F | 0x80, codePoint & 0x3F | 0x80);
	      } else if (codePoint < 0x110000) {
	        if ((units -= 4) < 0) break;
	        bytes.push(codePoint >> 0x12 | 0xF0, codePoint >> 0xC & 0x3F | 0x80, codePoint >> 0x6 & 0x3F | 0x80, codePoint & 0x3F | 0x80);
	      } else {
	        throw new Error('Invalid code point');
	      }
	    }

	    return bytes;
	  }

	  function asciiToBytes(str) {
	    var byteArray = [];

	    for (var i = 0; i < str.length; ++i) {
	      byteArray.push(str.charCodeAt(i) & 0xFF);
	    }

	    return byteArray;
	  }

	  function utf16leToBytes(str, units) {
	    var c, hi, lo;
	    var byteArray = [];

	    for (var i = 0; i < str.length; ++i) {
	      if ((units -= 2) < 0) break;
	      c = str.charCodeAt(i);
	      hi = c >> 8;
	      lo = c % 256;
	      byteArray.push(lo);
	      byteArray.push(hi);
	    }

	    return byteArray;
	  }

	  function base64ToBytes(str) {
	    return base64Js.toByteArray(base64clean(str));
	  }

	  function blitBuffer(src, dst, offset, length) {
	    for (var i = 0; i < length; ++i) {
	      if (i + offset >= dst.length || i >= src.length) break;
	      dst[i + offset] = src[i];
	    }

	    return i;
	  }

	  function isInstance(obj, type) {
	    return obj instanceof type || obj != null && obj.constructor != null && obj.constructor.name != null && obj.constructor.name === type.name;
	  }

	  function numberIsNaN(obj) {
	    return obj !== obj;
	  }
	}, "/$$rollup_base$$/node_modules/buffer");

	const object$1 = {};
	const hasOwnProperty$2 = object$1.hasOwnProperty;

	const forOwn$1 = (object, callback) => {
	  for (const key in object) {
	    if (hasOwnProperty$2.call(object, key)) {
	      callback(key, object[key]);
	    }
	  }
	};

	const extend$1 = (destination, source) => {
	  if (!source) {
	    return destination;
	  }

	  forOwn$1(source, (key, value) => {
	    destination[key] = value;
	  });
	  return destination;
	};

	const forEach$1 = (array, callback) => {
	  const length = array.length;
	  let index = -1;

	  while (++index < length) {
	    callback(array[index]);
	  }
	};

	const fourHexEscape = hex => {
	  return '\\u' + ('0000' + hex).slice(-4);
	};

	const hexadecimal = (code, lowercase) => {
	  let hexadecimal = code.toString(16);
	  if (lowercase) return hexadecimal;
	  return hexadecimal.toUpperCase();
	};

	const toString$1 = object$1.toString;
	const isArray$2 = Array.isArray;

	const isBuffer$1 = value => {
	  return typeof buffer.Buffer === 'function' && buffer.Buffer.isBuffer(value);
	};

	const isObject$1 = value => {
	  return toString$1.call(value) == '[object Object]';
	};

	const isString$1 = value => {
	  return typeof value == 'string' || toString$1.call(value) == '[object String]';
	};

	const isNumber$1 = value => {
	  return typeof value == 'number' || toString$1.call(value) == '[object Number]';
	};

	const isFunction$3 = value => {
	  return typeof value == 'function';
	};

	const isMap$1 = value => {
	  return toString$1.call(value) == '[object Map]';
	};

	const isSet$1 = value => {
	  return toString$1.call(value) == '[object Set]';
	};

	const singleEscapes$1 = {
	  '\\': '\\\\',
	  '\b': '\\b',
	  '\f': '\\f',
	  '\n': '\\n',
	  '\r': '\\r',
	  '\t': '\\t'
	};
	const regexSingleEscape$1 = /[\\\b\f\n\r\t]/;
	const regexDigit$1 = /[0-9]/;
	const regexWhitespace = /[\xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000]/;
	const escapeEverythingRegex = /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^]/g;
	const escapeNonAsciiRegex = /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^ !#-&\(-\[\]-_a-~]/g;

	const jsesc$2 = (argument, options) => {
	  const increaseIndentation = () => {
	    oldIndent = indent;
	    ++options.indentLevel;
	    indent = options.indent.repeat(options.indentLevel);
	  };

	  const defaults = {
	    'escapeEverything': false,
	    'minimal': false,
	    'isScriptContext': false,
	    'quotes': 'single',
	    'wrap': false,
	    'es6': false,
	    'json': false,
	    'compact': true,
	    'lowercaseHex': false,
	    'numbers': 'decimal',
	    'indent': '\t',
	    'indentLevel': 0,
	    '__inline1__': false,
	    '__inline2__': false
	  };
	  const json = options && options.json;

	  if (json) {
	    defaults.quotes = 'double';
	    defaults.wrap = true;
	  }

	  options = extend$1(defaults, options);

	  if (options.quotes != 'single' && options.quotes != 'double' && options.quotes != 'backtick') {
	    options.quotes = 'single';
	  }

	  const quote = options.quotes == 'double' ? '"' : options.quotes == 'backtick' ? '`' : '\'';
	  const compact = options.compact;
	  const lowercaseHex = options.lowercaseHex;
	  let indent = options.indent.repeat(options.indentLevel);
	  let oldIndent = '';
	  const inline1 = options.__inline1__;
	  const inline2 = options.__inline2__;
	  const newLine = compact ? '' : '\n';
	  let result;
	  let isEmpty = true;
	  const useBinNumbers = options.numbers == 'binary';
	  const useOctNumbers = options.numbers == 'octal';
	  const useDecNumbers = options.numbers == 'decimal';
	  const useHexNumbers = options.numbers == 'hexadecimal';

	  if (json && argument && isFunction$3(argument.toJSON)) {
	    argument = argument.toJSON();
	  }

	  if (!isString$1(argument)) {
	    if (isMap$1(argument)) {
	      if (argument.size == 0) {
	        return 'new Map()';
	      }

	      if (!compact) {
	        options.__inline1__ = true;
	        options.__inline2__ = false;
	      }

	      return 'new Map(' + jsesc$2(Array.from(argument), options) + ')';
	    }

	    if (isSet$1(argument)) {
	      if (argument.size == 0) {
	        return 'new Set()';
	      }

	      return 'new Set(' + jsesc$2(Array.from(argument), options) + ')';
	    }

	    if (isBuffer$1(argument)) {
	      if (argument.length == 0) {
	        return 'Buffer.from([])';
	      }

	      return 'Buffer.from(' + jsesc$2(Array.from(argument), options) + ')';
	    }

	    if (isArray$2(argument)) {
	      result = [];
	      options.wrap = true;

	      if (inline1) {
	        options.__inline1__ = false;
	        options.__inline2__ = true;
	      }

	      if (!inline2) {
	        increaseIndentation();
	      }

	      forEach$1(argument, value => {
	        isEmpty = false;

	        if (inline2) {
	          options.__inline2__ = false;
	        }

	        result.push((compact || inline2 ? '' : indent) + jsesc$2(value, options));
	      });

	      if (isEmpty) {
	        return '[]';
	      }

	      if (inline2) {
	        return '[' + result.join(', ') + ']';
	      }

	      return '[' + newLine + result.join(',' + newLine) + newLine + (compact ? '' : oldIndent) + ']';
	    } else if (isNumber$1(argument)) {
	      if (json) {
	        return JSON.stringify(argument);
	      }

	      if (useDecNumbers) {
	        return String(argument);
	      }

	      if (useHexNumbers) {
	        let hexadecimal = argument.toString(16);

	        if (!lowercaseHex) {
	          hexadecimal = hexadecimal.toUpperCase();
	        }

	        return '0x' + hexadecimal;
	      }

	      if (useBinNumbers) {
	        return '0b' + argument.toString(2);
	      }

	      if (useOctNumbers) {
	        return '0o' + argument.toString(8);
	      }
	    } else if (!isObject$1(argument)) {
	      if (json) {
	        return JSON.stringify(argument) || 'null';
	      }

	      return String(argument);
	    } else {
	      result = [];
	      options.wrap = true;
	      increaseIndentation();
	      forOwn$1(argument, (key, value) => {
	        isEmpty = false;
	        result.push((compact ? '' : indent) + jsesc$2(key, options) + ':' + (compact ? '' : ' ') + jsesc$2(value, options));
	      });

	      if (isEmpty) {
	        return '{}';
	      }

	      return '{' + newLine + result.join(',' + newLine) + newLine + (compact ? '' : oldIndent) + '}';
	    }
	  }

	  const regex = options.escapeEverything ? escapeEverythingRegex : escapeNonAsciiRegex;
	  result = argument.replace(regex, (char, pair, lone, quoteChar, index, string) => {
	    if (pair) {
	      if (options.minimal) return pair;
	      const first = pair.charCodeAt(0);
	      const second = pair.charCodeAt(1);

	      if (options.es6) {
	        const codePoint = (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
	        const hex = hexadecimal(codePoint, lowercaseHex);
	        return '\\u{' + hex + '}';
	      }

	      return fourHexEscape(hexadecimal(first, lowercaseHex)) + fourHexEscape(hexadecimal(second, lowercaseHex));
	    }

	    if (lone) {
	      return fourHexEscape(hexadecimal(lone.charCodeAt(0), lowercaseHex));
	    }

	    if (char == '\0' && !json && !regexDigit$1.test(string.charAt(index + 1))) {
	      return '\\0';
	    }

	    if (quoteChar) {
	      if (quoteChar == quote || options.escapeEverything) {
	        return '\\' + quoteChar;
	      }

	      return quoteChar;
	    }

	    if (regexSingleEscape$1.test(char)) {
	      return singleEscapes$1[char];
	    }

	    if (options.minimal && !regexWhitespace.test(char)) {
	      return char;
	    }

	    const hex = hexadecimal(char.charCodeAt(0), lowercaseHex);

	    if (json || hex.length > 2) {
	      return fourHexEscape(hex);
	    }

	    return '\\x' + ('00' + hex).slice(-2);
	  });

	  if (quote == '`') {
	    result = result.replace(/\$\{/g, '\\${');
	  }

	  if (options.isScriptContext) {
	    result = result.replace(/<\/(script|style)/gi, '<\\/$1').replace(/<!--/g, json ? '\\u003C!--' : '\\x3C!--');
	  }

	  if (options.wrap) {
	    result = quote + result + quote;
	  }

	  return result;
	};

	jsesc$2.version = '3.0.2';
	var jsesc_1$1 = jsesc$2;

	const object = {};
	const hasOwnProperty$1 = object.hasOwnProperty;

	const forOwn = (object, callback) => {
	  for (const key in object) {
	    if (hasOwnProperty$1.call(object, key)) {
	      callback(key, object[key]);
	    }
	  }
	};

	const extend = (destination, source) => {
	  if (!source) {
	    return destination;
	  }

	  forOwn(source, (key, value) => {
	    destination[key] = value;
	  });
	  return destination;
	};

	const forEach = (array, callback) => {
	  const length = array.length;
	  let index = -1;

	  while (++index < length) {
	    callback(array[index]);
	  }
	};

	const toString = object.toString;
	const isArray$1 = Array.isArray;
	const isBuffer = buffer.Buffer.isBuffer;

	const isObject = value => {
	  return toString.call(value) == '[object Object]';
	};

	const isString = value => {
	  return typeof value == 'string' || toString.call(value) == '[object String]';
	};

	const isNumber = value => {
	  return typeof value == 'number' || toString.call(value) == '[object Number]';
	};

	const isFunction$2 = value => {
	  return typeof value == 'function';
	};

	const isMap = value => {
	  return toString.call(value) == '[object Map]';
	};

	const isSet = value => {
	  return toString.call(value) == '[object Set]';
	};

	const singleEscapes = {
	  '"': '\\"',
	  '\'': '\\\'',
	  '\\': '\\\\',
	  '\b': '\\b',
	  '\f': '\\f',
	  '\n': '\\n',
	  '\r': '\\r',
	  '\t': '\\t'
	};
	const regexSingleEscape = /["'\\\b\f\n\r\t]/;
	const regexDigit = /[0-9]/;
	const regexWhitelist = /[ !#-&\(-\[\]-_a-~]/;

	const jsesc$1 = (argument, options) => {
	  const increaseIndentation = () => {
	    oldIndent = indent;
	    ++options.indentLevel;
	    indent = options.indent.repeat(options.indentLevel);
	  };

	  const defaults = {
	    'escapeEverything': false,
	    'minimal': false,
	    'isScriptContext': false,
	    'quotes': 'single',
	    'wrap': false,
	    'es6': false,
	    'json': false,
	    'compact': true,
	    'lowercaseHex': false,
	    'numbers': 'decimal',
	    'indent': '\t',
	    'indentLevel': 0,
	    '__inline1__': false,
	    '__inline2__': false
	  };
	  const json = options && options.json;

	  if (json) {
	    defaults.quotes = 'double';
	    defaults.wrap = true;
	  }

	  options = extend(defaults, options);

	  if (options.quotes != 'single' && options.quotes != 'double' && options.quotes != 'backtick') {
	    options.quotes = 'single';
	  }

	  const quote = options.quotes == 'double' ? '"' : options.quotes == 'backtick' ? '`' : '\'';
	  const compact = options.compact;
	  const lowercaseHex = options.lowercaseHex;
	  let indent = options.indent.repeat(options.indentLevel);
	  let oldIndent = '';
	  const inline1 = options.__inline1__;
	  const inline2 = options.__inline2__;
	  const newLine = compact ? '' : '\n';
	  let result;
	  let isEmpty = true;
	  const useBinNumbers = options.numbers == 'binary';
	  const useOctNumbers = options.numbers == 'octal';
	  const useDecNumbers = options.numbers == 'decimal';
	  const useHexNumbers = options.numbers == 'hexadecimal';

	  if (json && argument && isFunction$2(argument.toJSON)) {
	    argument = argument.toJSON();
	  }

	  if (!isString(argument)) {
	    if (isMap(argument)) {
	      if (argument.size == 0) {
	        return 'new Map()';
	      }

	      if (!compact) {
	        options.__inline1__ = true;
	        options.__inline2__ = false;
	      }

	      return 'new Map(' + jsesc$1(Array.from(argument), options) + ')';
	    }

	    if (isSet(argument)) {
	      if (argument.size == 0) {
	        return 'new Set()';
	      }

	      return 'new Set(' + jsesc$1(Array.from(argument), options) + ')';
	    }

	    if (isBuffer(argument)) {
	      if (argument.length == 0) {
	        return 'Buffer.from([])';
	      }

	      return 'Buffer.from(' + jsesc$1(Array.from(argument), options) + ')';
	    }

	    if (isArray$1(argument)) {
	      result = [];
	      options.wrap = true;

	      if (inline1) {
	        options.__inline1__ = false;
	        options.__inline2__ = true;
	      }

	      if (!inline2) {
	        increaseIndentation();
	      }

	      forEach(argument, value => {
	        isEmpty = false;

	        if (inline2) {
	          options.__inline2__ = false;
	        }

	        result.push((compact || inline2 ? '' : indent) + jsesc$1(value, options));
	      });

	      if (isEmpty) {
	        return '[]';
	      }

	      if (inline2) {
	        return '[' + result.join(', ') + ']';
	      }

	      return '[' + newLine + result.join(',' + newLine) + newLine + (compact ? '' : oldIndent) + ']';
	    } else if (isNumber(argument)) {
	      if (json) {
	        return JSON.stringify(argument);
	      }

	      if (useDecNumbers) {
	        return String(argument);
	      }

	      if (useHexNumbers) {
	        let hexadecimal = argument.toString(16);

	        if (!lowercaseHex) {
	          hexadecimal = hexadecimal.toUpperCase();
	        }

	        return '0x' + hexadecimal;
	      }

	      if (useBinNumbers) {
	        return '0b' + argument.toString(2);
	      }

	      if (useOctNumbers) {
	        return '0o' + argument.toString(8);
	      }
	    } else if (!isObject(argument)) {
	      if (json) {
	        return JSON.stringify(argument) || 'null';
	      }

	      return String(argument);
	    } else {
	      result = [];
	      options.wrap = true;
	      increaseIndentation();
	      forOwn(argument, (key, value) => {
	        isEmpty = false;
	        result.push((compact ? '' : indent) + jsesc$1(key, options) + ':' + (compact ? '' : ' ') + jsesc$1(value, options));
	      });

	      if (isEmpty) {
	        return '{}';
	      }

	      return '{' + newLine + result.join(',' + newLine) + newLine + (compact ? '' : oldIndent) + '}';
	    }
	  }

	  const string = argument;
	  let index = -1;
	  const length = string.length;
	  result = '';

	  while (++index < length) {
	    const character = string.charAt(index);

	    if (options.es6) {
	      const first = string.charCodeAt(index);

	      if (first >= 0xD800 && first <= 0xDBFF && length > index + 1) {
	        const second = string.charCodeAt(index + 1);

	        if (second >= 0xDC00 && second <= 0xDFFF) {
	          const codePoint = (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
	          let hexadecimal = codePoint.toString(16);

	          if (!lowercaseHex) {
	            hexadecimal = hexadecimal.toUpperCase();
	          }

	          result += '\\u{' + hexadecimal + '}';
	          ++index;
	          continue;
	        }
	      }
	    }

	    if (!options.escapeEverything) {
	      if (regexWhitelist.test(character)) {
	        result += character;
	        continue;
	      }

	      if (character == '"') {
	        result += quote == character ? '\\"' : character;
	        continue;
	      }

	      if (character == '`') {
	        result += quote == character ? '\\`' : character;
	        continue;
	      }

	      if (character == '\'') {
	        result += quote == character ? '\\\'' : character;
	        continue;
	      }
	    }

	    if (character == '\0' && !json && !regexDigit.test(string.charAt(index + 1))) {
	      result += '\\0';
	      continue;
	    }

	    if (regexSingleEscape.test(character)) {
	      result += singleEscapes[character];
	      continue;
	    }

	    const charCode = character.charCodeAt(0);

	    if (options.minimal && charCode != 0x2028 && charCode != 0x2029) {
	      result += character;
	      continue;
	    }

	    let hexadecimal = charCode.toString(16);

	    if (!lowercaseHex) {
	      hexadecimal = hexadecimal.toUpperCase();
	    }

	    const longhand = hexadecimal.length > 2 || json;
	    const escaped = '\\' + (longhand ? 'u' : 'x') + ('0000' + hexadecimal).slice(longhand ? -4 : -2);
	    result += escaped;
	    continue;
	  }

	  if (options.wrap) {
	    result = quote + result + quote;
	  }

	  if (quote == '`') {
	    result = result.replace(/\$\{/g, '\\\$\{');
	  }

	  if (options.isScriptContext) {
	    return result.replace(/<\/(script|style)/gi, '<\\/$1').replace(/<!--/g, json ? '\\u003C!--' : '\\x3C!--');
	  }

	  return result;
	};

	jsesc$1.version = '2.5.2';
	var jsesc_1 = jsesc$1;

	function bool$3(value) {
	  if (value == null) return false;
	  return value && value !== "false" && value !== "0";
	}

	var jsesc = bool$3(browser$5.env["BABEL_8_BREAKING"]) ? jsesc_1$1 : jsesc_1;

	const {
	  isAssignmentPattern: isAssignmentPattern$1,
	  isIdentifier: isIdentifier$7
	} = _t;
	function Identifier(node) {
	  this.exactSource(node.loc, () => {
	    this.word(node.name);
	  });
	}
	function ArgumentPlaceholder() {
	  this.token("?");
	}
	function RestElement$1(node) {
	  this.token("...");
	  this.print(node.argument, node);
	}
	function ObjectExpression$1(node) {
	  const props = node.properties;
	  this.token("{");
	  this.printInnerComments(node);

	  if (props.length) {
	    this.space();
	    this.printList(props, node, {
	      indent: true,
	      statement: true
	    });
	    this.space();
	  }

	  this.token("}");
	}
	function ObjectMethod(node) {
	  this.printJoin(node.decorators, node);

	  this._methodHead(node);

	  this.space();
	  this.print(node.body, node);
	}
	function ObjectProperty(node) {
	  this.printJoin(node.decorators, node);

	  if (node.computed) {
	    this.token("[");
	    this.print(node.key, node);
	    this.token("]");
	  } else {
	    if (isAssignmentPattern$1(node.value) && isIdentifier$7(node.key) && node.key.name === node.value.left.name) {
	      this.print(node.value, node);
	      return;
	    }

	    this.print(node.key, node);

	    if (node.shorthand && isIdentifier$7(node.key) && isIdentifier$7(node.value) && node.key.name === node.value.name) {
	      return;
	    }
	  }

	  this.token(":");
	  this.space();
	  this.print(node.value, node);
	}
	function ArrayExpression$1(node) {
	  const elems = node.elements;
	  const len = elems.length;
	  this.token("[");
	  this.printInnerComments(node);

	  for (let i = 0; i < elems.length; i++) {
	    const elem = elems[i];

	    if (elem) {
	      if (i > 0) this.space();
	      this.print(elem, node);
	      if (i < len - 1) this.token(",");
	    } else {
	      this.token(",");
	    }
	  }

	  this.token("]");
	}
	function RecordExpression(node) {
	  const props = node.properties;
	  let startToken;
	  let endToken;

	  if (this.format.recordAndTupleSyntaxType === "bar") {
	    startToken = "{|";
	    endToken = "|}";
	  } else if (this.format.recordAndTupleSyntaxType === "hash") {
	    startToken = "#{";
	    endToken = "}";
	  } else {
	    throw new Error(`The "recordAndTupleSyntaxType" generator option must be "bar" or "hash" (${JSON.stringify(this.format.recordAndTupleSyntaxType)} received).`);
	  }

	  this.token(startToken);
	  this.printInnerComments(node);

	  if (props.length) {
	    this.space();
	    this.printList(props, node, {
	      indent: true,
	      statement: true
	    });
	    this.space();
	  }

	  this.token(endToken);
	}
	function TupleExpression(node) {
	  const elems = node.elements;
	  const len = elems.length;
	  let startToken;
	  let endToken;

	  if (this.format.recordAndTupleSyntaxType === "bar") {
	    startToken = "[|";
	    endToken = "|]";
	  } else if (this.format.recordAndTupleSyntaxType === "hash") {
	    startToken = "#[";
	    endToken = "]";
	  } else {
	    throw new Error(`${this.format.recordAndTupleSyntaxType} is not a valid recordAndTuple syntax type`);
	  }

	  this.token(startToken);
	  this.printInnerComments(node);

	  for (let i = 0; i < elems.length; i++) {
	    const elem = elems[i];

	    if (elem) {
	      if (i > 0) this.space();
	      this.print(elem, node);
	      if (i < len - 1) this.token(",");
	    }
	  }

	  this.token(endToken);
	}
	function RegExpLiteral$1(node) {
	  this.word(`/${node.pattern}/${node.flags}`);
	}
	function BooleanLiteral$1(node) {
	  this.word(node.value ? "true" : "false");
	}
	function NullLiteral$1() {
	  this.word("null");
	}
	function NumericLiteral$2(node) {
	  const raw = this.getPossibleRaw(node);
	  const opts = this.format.jsescOption;
	  const value = node.value + "";

	  if (opts.numbers) {
	    this.number(jsesc(node.value, opts));
	  } else if (raw == null) {
	    this.number(value);
	  } else if (this.format.minified) {
	    this.number(raw.length < value.length ? raw : value);
	  } else {
	    this.number(raw);
	  }
	}
	function StringLiteral$2(node) {
	  const raw = this.getPossibleRaw(node);

	  if (!this.format.minified && raw != null) {
	    this.token(raw);
	    return;
	  }

	  const val = jsesc(node.value, browser$5.env.BABEL_8_BREAKING ? this.format.jsescOption : Object.assign(this.format.jsescOption, this.format.jsonCompatibleStrings && {
	    json: true
	  }));
	  return this.token(val);
	}
	function BigIntLiteral(node) {
	  const raw = this.getPossibleRaw(node);

	  if (!this.format.minified && raw != null) {
	    this.word(raw);
	    return;
	  }

	  this.word(node.value + "n");
	}
	function DecimalLiteral(node) {
	  const raw = this.getPossibleRaw(node);

	  if (!this.format.minified && raw != null) {
	    this.word(raw);
	    return;
	  }

	  this.word(node.value + "m");
	}
	const validTopicTokenSet = new Set(["^^", "@@", "^", "%", "#"]);
	function TopicReference() {
	  const {
	    topicToken
	  } = this.format;

	  if (validTopicTokenSet.has(topicToken)) {
	    this.token(topicToken);
	  } else {
	    const givenTopicTokenJSON = JSON.stringify(topicToken);
	    const validTopics = Array.from(validTopicTokenSet, v => JSON.stringify(v));
	    throw new Error(`The "topicToken" generator option must be one of ` + `${validTopics.join(", ")} (${givenTopicTokenJSON} received instead).`);
	  }
	}
	function PipelineTopicExpression(node) {
	  this.print(node.expression, node);
	}
	function PipelineBareFunction(node) {
	  this.print(node.callee, node);
	}
	function PipelinePrimaryTopicReference() {
	  this.token("#");
	}

	const {
	  isDeclareExportDeclaration,
	  isStatement: isStatement$3
	} = _t;
	function AnyTypeAnnotation() {
	  this.word("any");
	}
	function ArrayTypeAnnotation(node) {
	  this.print(node.elementType, node);
	  this.token("[");
	  this.token("]");
	}
	function BooleanTypeAnnotation() {
	  this.word("boolean");
	}
	function BooleanLiteralTypeAnnotation(node) {
	  this.word(node.value ? "true" : "false");
	}
	function NullLiteralTypeAnnotation() {
	  this.word("null");
	}
	function DeclareClass(node, parent) {
	  if (!isDeclareExportDeclaration(parent)) {
	    this.word("declare");
	    this.space();
	  }

	  this.word("class");
	  this.space();

	  this._interfaceish(node);
	}
	function DeclareFunction(node, parent) {
	  if (!isDeclareExportDeclaration(parent)) {
	    this.word("declare");
	    this.space();
	  }

	  this.word("function");
	  this.space();
	  this.print(node.id, node);
	  this.print(node.id.typeAnnotation.typeAnnotation, node);

	  if (node.predicate) {
	    this.space();
	    this.print(node.predicate, node);
	  }

	  this.semicolon();
	}
	function InferredPredicate() {
	  this.token("%");
	  this.word("checks");
	}
	function DeclaredPredicate(node) {
	  this.token("%");
	  this.word("checks");
	  this.token("(");
	  this.print(node.value, node);
	  this.token(")");
	}
	function DeclareInterface(node) {
	  this.word("declare");
	  this.space();
	  this.InterfaceDeclaration(node);
	}
	function DeclareModule(node) {
	  this.word("declare");
	  this.space();
	  this.word("module");
	  this.space();
	  this.print(node.id, node);
	  this.space();
	  this.print(node.body, node);
	}
	function DeclareModuleExports(node) {
	  this.word("declare");
	  this.space();
	  this.word("module");
	  this.token(".");
	  this.word("exports");
	  this.print(node.typeAnnotation, node);
	}
	function DeclareTypeAlias(node) {
	  this.word("declare");
	  this.space();
	  this.TypeAlias(node);
	}
	function DeclareOpaqueType(node, parent) {
	  if (!isDeclareExportDeclaration(parent)) {
	    this.word("declare");
	    this.space();
	  }

	  this.OpaqueType(node);
	}
	function DeclareVariable(node, parent) {
	  if (!isDeclareExportDeclaration(parent)) {
	    this.word("declare");
	    this.space();
	  }

	  this.word("var");
	  this.space();
	  this.print(node.id, node);
	  this.print(node.id.typeAnnotation, node);
	  this.semicolon();
	}
	function DeclareExportDeclaration(node) {
	  this.word("declare");
	  this.space();
	  this.word("export");
	  this.space();

	  if (node.default) {
	    this.word("default");
	    this.space();
	  }

	  FlowExportDeclaration.apply(this, arguments);
	}
	function DeclareExportAllDeclaration() {
	  this.word("declare");
	  this.space();
	  ExportAllDeclaration.apply(this, arguments);
	}
	function EnumDeclaration(node) {
	  const {
	    id,
	    body
	  } = node;
	  this.word("enum");
	  this.space();
	  this.print(id, node);
	  this.print(body, node);
	}

	function enumExplicitType(context, name, hasExplicitType) {
	  if (hasExplicitType) {
	    context.space();
	    context.word("of");
	    context.space();
	    context.word(name);
	  }

	  context.space();
	}

	function enumBody(context, node) {
	  const {
	    members
	  } = node;
	  context.token("{");
	  context.indent();
	  context.newline();

	  for (const member of members) {
	    context.print(member, node);
	    context.newline();
	  }

	  if (node.hasUnknownMembers) {
	    context.token("...");
	    context.newline();
	  }

	  context.dedent();
	  context.token("}");
	}

	function EnumBooleanBody(node) {
	  const {
	    explicitType
	  } = node;
	  enumExplicitType(this, "boolean", explicitType);
	  enumBody(this, node);
	}
	function EnumNumberBody(node) {
	  const {
	    explicitType
	  } = node;
	  enumExplicitType(this, "number", explicitType);
	  enumBody(this, node);
	}
	function EnumStringBody(node) {
	  const {
	    explicitType
	  } = node;
	  enumExplicitType(this, "string", explicitType);
	  enumBody(this, node);
	}
	function EnumSymbolBody(node) {
	  enumExplicitType(this, "symbol", true);
	  enumBody(this, node);
	}
	function EnumDefaultedMember(node) {
	  const {
	    id
	  } = node;
	  this.print(id, node);
	  this.token(",");
	}

	function enumInitializedMember(context, node) {
	  const {
	    id,
	    init
	  } = node;
	  context.print(id, node);
	  context.space();
	  context.token("=");
	  context.space();
	  context.print(init, node);
	  context.token(",");
	}

	function EnumBooleanMember(node) {
	  enumInitializedMember(this, node);
	}
	function EnumNumberMember(node) {
	  enumInitializedMember(this, node);
	}
	function EnumStringMember(node) {
	  enumInitializedMember(this, node);
	}

	function FlowExportDeclaration(node) {
	  if (node.declaration) {
	    const declar = node.declaration;
	    this.print(declar, node);
	    if (!isStatement$3(declar)) this.semicolon();
	  } else {
	    this.token("{");

	    if (node.specifiers.length) {
	      this.space();
	      this.printList(node.specifiers, node);
	      this.space();
	    }

	    this.token("}");

	    if (node.source) {
	      this.space();
	      this.word("from");
	      this.space();
	      this.print(node.source, node);
	    }

	    this.semicolon();
	  }
	}

	function ExistsTypeAnnotation() {
	  this.token("*");
	}
	function FunctionTypeAnnotation(node, parent) {
	  this.print(node.typeParameters, node);
	  this.token("(");

	  if (node.this) {
	    this.word("this");
	    this.token(":");
	    this.space();
	    this.print(node.this.typeAnnotation, node);

	    if (node.params.length || node.rest) {
	      this.token(",");
	      this.space();
	    }
	  }

	  this.printList(node.params, node);

	  if (node.rest) {
	    if (node.params.length) {
	      this.token(",");
	      this.space();
	    }

	    this.token("...");
	    this.print(node.rest, node);
	  }

	  this.token(")");

	  if (parent && (parent.type === "ObjectTypeCallProperty" || parent.type === "DeclareFunction" || parent.type === "ObjectTypeProperty" && parent.method)) {
	    this.token(":");
	  } else {
	    this.space();
	    this.token("=>");
	  }

	  this.space();
	  this.print(node.returnType, node);
	}
	function FunctionTypeParam(node) {
	  this.print(node.name, node);
	  if (node.optional) this.token("?");

	  if (node.name) {
	    this.token(":");
	    this.space();
	  }

	  this.print(node.typeAnnotation, node);
	}
	function InterfaceExtends(node) {
	  this.print(node.id, node);
	  this.print(node.typeParameters, node);
	}
	function _interfaceish(node) {
	  this.print(node.id, node);
	  this.print(node.typeParameters, node);

	  if (node.extends?.length) {
	    this.space();
	    this.word("extends");
	    this.space();
	    this.printList(node.extends, node);
	  }

	  if (node.mixins && node.mixins.length) {
	    this.space();
	    this.word("mixins");
	    this.space();
	    this.printList(node.mixins, node);
	  }

	  if (node.implements && node.implements.length) {
	    this.space();
	    this.word("implements");
	    this.space();
	    this.printList(node.implements, node);
	  }

	  this.space();
	  this.print(node.body, node);
	}
	function _variance(node) {
	  if (node.variance) {
	    if (node.variance.kind === "plus") {
	      this.token("+");
	    } else if (node.variance.kind === "minus") {
	      this.token("-");
	    }
	  }
	}
	function InterfaceDeclaration(node) {
	  this.word("interface");
	  this.space();

	  this._interfaceish(node);
	}

	function andSeparator() {
	  this.space();
	  this.token("&");
	  this.space();
	}

	function InterfaceTypeAnnotation(node) {
	  this.word("interface");

	  if (node.extends && node.extends.length) {
	    this.space();
	    this.word("extends");
	    this.space();
	    this.printList(node.extends, node);
	  }

	  this.space();
	  this.print(node.body, node);
	}
	function IntersectionTypeAnnotation(node) {
	  this.printJoin(node.types, node, {
	    separator: andSeparator
	  });
	}
	function MixedTypeAnnotation() {
	  this.word("mixed");
	}
	function EmptyTypeAnnotation() {
	  this.word("empty");
	}
	function NullableTypeAnnotation(node) {
	  this.token("?");
	  this.print(node.typeAnnotation, node);
	}
	function NumberTypeAnnotation() {
	  this.word("number");
	}
	function StringTypeAnnotation() {
	  this.word("string");
	}
	function ThisTypeAnnotation() {
	  this.word("this");
	}
	function TupleTypeAnnotation(node) {
	  this.token("[");
	  this.printList(node.types, node);
	  this.token("]");
	}
	function TypeofTypeAnnotation(node) {
	  this.word("typeof");
	  this.space();
	  this.print(node.argument, node);
	}
	function TypeAlias(node) {
	  this.word("type");
	  this.space();
	  this.print(node.id, node);
	  this.print(node.typeParameters, node);
	  this.space();
	  this.token("=");
	  this.space();
	  this.print(node.right, node);
	  this.semicolon();
	}
	function TypeAnnotation(node) {
	  this.token(":");
	  this.space();
	  if (node.optional) this.token("?");
	  this.print(node.typeAnnotation, node);
	}
	function TypeParameterInstantiation(node) {
	  this.token("<");
	  this.printList(node.params, node, {});
	  this.token(">");
	}
	function TypeParameter(node) {
	  this._variance(node);

	  this.word(node.name);

	  if (node.bound) {
	    this.print(node.bound, node);
	  }

	  if (node.default) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(node.default, node);
	  }
	}
	function OpaqueType(node) {
	  this.word("opaque");
	  this.space();
	  this.word("type");
	  this.space();
	  this.print(node.id, node);
	  this.print(node.typeParameters, node);

	  if (node.supertype) {
	    this.token(":");
	    this.space();
	    this.print(node.supertype, node);
	  }

	  if (node.impltype) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(node.impltype, node);
	  }

	  this.semicolon();
	}
	function ObjectTypeAnnotation(node) {
	  if (node.exact) {
	    this.token("{|");
	  } else {
	    this.token("{");
	  }

	  const props = [...node.properties, ...(node.callProperties || []), ...(node.indexers || []), ...(node.internalSlots || [])];

	  if (props.length) {
	    this.space();
	    this.printJoin(props, node, {
	      addNewlines(leading) {
	        if (leading && !props[0]) return 1;
	      },

	      indent: true,
	      statement: true,
	      iterator: () => {
	        if (props.length !== 1 || node.inexact) {
	          this.token(",");
	          this.space();
	        }
	      }
	    });
	    this.space();
	  }

	  if (node.inexact) {
	    this.indent();
	    this.token("...");

	    if (props.length) {
	      this.newline();
	    }

	    this.dedent();
	  }

	  if (node.exact) {
	    this.token("|}");
	  } else {
	    this.token("}");
	  }
	}
	function ObjectTypeInternalSlot(node) {
	  if (node.static) {
	    this.word("static");
	    this.space();
	  }

	  this.token("[");
	  this.token("[");
	  this.print(node.id, node);
	  this.token("]");
	  this.token("]");
	  if (node.optional) this.token("?");

	  if (!node.method) {
	    this.token(":");
	    this.space();
	  }

	  this.print(node.value, node);
	}
	function ObjectTypeCallProperty(node) {
	  if (node.static) {
	    this.word("static");
	    this.space();
	  }

	  this.print(node.value, node);
	}
	function ObjectTypeIndexer(node) {
	  if (node.static) {
	    this.word("static");
	    this.space();
	  }

	  this._variance(node);

	  this.token("[");

	  if (node.id) {
	    this.print(node.id, node);
	    this.token(":");
	    this.space();
	  }

	  this.print(node.key, node);
	  this.token("]");
	  this.token(":");
	  this.space();
	  this.print(node.value, node);
	}
	function ObjectTypeProperty(node) {
	  if (node.proto) {
	    this.word("proto");
	    this.space();
	  }

	  if (node.static) {
	    this.word("static");
	    this.space();
	  }

	  if (node.kind === "get" || node.kind === "set") {
	    this.word(node.kind);
	    this.space();
	  }

	  this._variance(node);

	  this.print(node.key, node);
	  if (node.optional) this.token("?");

	  if (!node.method) {
	    this.token(":");
	    this.space();
	  }

	  this.print(node.value, node);
	}
	function ObjectTypeSpreadProperty(node) {
	  this.token("...");
	  this.print(node.argument, node);
	}
	function QualifiedTypeIdentifier(node) {
	  this.print(node.qualification, node);
	  this.token(".");
	  this.print(node.id, node);
	}
	function SymbolTypeAnnotation() {
	  this.word("symbol");
	}

	function orSeparator() {
	  this.space();
	  this.token("|");
	  this.space();
	}

	function UnionTypeAnnotation(node) {
	  this.printJoin(node.types, node, {
	    separator: orSeparator
	  });
	}
	function TypeCastExpression$1(node) {
	  this.token("(");
	  this.print(node.expression, node);
	  this.print(node.typeAnnotation, node);
	  this.token(")");
	}
	function Variance(node) {
	  if (node.kind === "plus") {
	    this.token("+");
	  } else {
	    this.token("-");
	  }
	}
	function VoidTypeAnnotation() {
	  this.word("void");
	}
	function IndexedAccessType(node) {
	  this.print(node.objectType, node);
	  this.token("[");
	  this.print(node.indexType, node);
	  this.token("]");
	}
	function OptionalIndexedAccessType(node) {
	  this.print(node.objectType, node);

	  if (node.optional) {
	    this.token("?.");
	  }

	  this.token("[");
	  this.print(node.indexType, node);
	  this.token("]");
	}

	function File$1(node) {
	  if (node.program) {
	    this.print(node.program.interpreter, node);
	  }

	  this.print(node.program, node);
	}
	function Program(node) {
	  this.printInnerComments(node, false);
	  this.printSequence(node.directives, node);
	  if (node.directives && node.directives.length) this.newline();
	  this.printSequence(node.body, node);
	}
	function BlockStatement(node) {
	  this.token("{");
	  this.printInnerComments(node);
	  const hasDirectives = node.directives?.length;

	  if (node.body.length || hasDirectives) {
	    this.newline();
	    this.printSequence(node.directives, node, {
	      indent: true
	    });
	    if (hasDirectives) this.newline();
	    this.printSequence(node.body, node, {
	      indent: true
	    });
	    this.removeTrailingNewline();
	    this.source("end", node.loc);
	    if (!this.endsWith(10)) this.newline();
	    this.rightBrace();
	  } else {
	    this.source("end", node.loc);
	    this.token("}");
	  }
	}
	function Directive(node) {
	  this.print(node.value, node);
	  this.semicolon();
	}
	const unescapedSingleQuoteRE = /(?:^|[^\\])(?:\\\\)*'/;
	const unescapedDoubleQuoteRE = /(?:^|[^\\])(?:\\\\)*"/;
	function DirectiveLiteral(node) {
	  const raw = this.getPossibleRaw(node);

	  if (!this.format.minified && raw != null) {
	    this.token(raw);
	    return;
	  }

	  const {
	    value
	  } = node;

	  if (!unescapedDoubleQuoteRE.test(value)) {
	    this.token(`"${value}"`);
	  } else if (!unescapedSingleQuoteRE.test(value)) {
	    this.token(`'${value}'`);
	  } else {
	    throw new Error("Malformed AST: it is not possible to print a directive containing" + " both unescaped single and double quotes.");
	  }
	}
	function InterpreterDirective(node) {
	  this.token(`#!${node.value}\n`);
	}
	function Placeholder(node) {
	  this.token("%%");
	  this.print(node.name);
	  this.token("%%");

	  if (node.expectedNode === "Statement") {
	    this.semicolon();
	  }
	}

	function JSXAttribute(node) {
	  this.print(node.name, node);

	  if (node.value) {
	    this.token("=");
	    this.print(node.value, node);
	  }
	}
	function JSXIdentifier$1(node) {
	  this.word(node.name);
	}
	function JSXNamespacedName(node) {
	  this.print(node.namespace, node);
	  this.token(":");
	  this.print(node.name, node);
	}
	function JSXMemberExpression(node) {
	  this.print(node.object, node);
	  this.token(".");
	  this.print(node.property, node);
	}
	function JSXSpreadAttribute(node) {
	  this.token("{");
	  this.token("...");
	  this.print(node.argument, node);
	  this.token("}");
	}
	function JSXExpressionContainer(node) {
	  this.token("{");
	  this.print(node.expression, node);
	  this.token("}");
	}
	function JSXSpreadChild(node) {
	  this.token("{");
	  this.token("...");
	  this.print(node.expression, node);
	  this.token("}");
	}
	function JSXText$1(node) {
	  const raw = this.getPossibleRaw(node);

	  if (raw != null) {
	    this.token(raw);
	  } else {
	    this.token(node.value);
	  }
	}
	function JSXElement(node) {
	  const open = node.openingElement;
	  this.print(open, node);
	  if (open.selfClosing) return;
	  this.indent();

	  for (const child of node.children) {
	    this.print(child, node);
	  }

	  this.dedent();
	  this.print(node.closingElement, node);
	}

	function spaceSeparator() {
	  this.space();
	}

	function JSXOpeningElement(node) {
	  this.token("<");
	  this.print(node.name, node);
	  this.print(node.typeParameters, node);

	  if (node.attributes.length > 0) {
	    this.space();
	    this.printJoin(node.attributes, node, {
	      separator: spaceSeparator
	    });
	  }

	  if (node.selfClosing) {
	    this.space();
	    this.token("/>");
	  } else {
	    this.token(">");
	  }
	}
	function JSXClosingElement(node) {
	  this.token("</");
	  this.print(node.name, node);
	  this.token(">");
	}
	function JSXEmptyExpression(node) {
	  this.printInnerComments(node);
	}
	function JSXFragment(node) {
	  this.print(node.openingFragment, node);
	  this.indent();

	  for (const child of node.children) {
	    this.print(child, node);
	  }

	  this.dedent();
	  this.print(node.closingFragment, node);
	}
	function JSXOpeningFragment() {
	  this.token("<");
	  this.token(">");
	}
	function JSXClosingFragment() {
	  this.token("</");
	  this.token(">");
	}

	function TSTypeAnnotation(node) {
	  this.token(":");
	  this.space();
	  if (node.optional) this.token("?");
	  this.print(node.typeAnnotation, node);
	}
	function TSTypeParameterInstantiation(node, parent) {
	  this.token("<");
	  this.printList(node.params, node, {});

	  if (parent.type === "ArrowFunctionExpression" && node.params.length === 1) {
	    this.token(",");
	  }

	  this.token(">");
	}
	function TSTypeParameter(node) {
	  this.word(!browser$5.env.BABEL_8_BREAKING ? node.name : node.name.name);

	  if (node.constraint) {
	    this.space();
	    this.word("extends");
	    this.space();
	    this.print(node.constraint, node);
	  }

	  if (node.default) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(node.default, node);
	  }
	}
	function TSParameterProperty(node) {
	  if (node.accessibility) {
	    this.word(node.accessibility);
	    this.space();
	  }

	  if (node.readonly) {
	    this.word("readonly");
	    this.space();
	  }

	  this._param(node.parameter);
	}
	function TSDeclareFunction(node) {
	  if (node.declare) {
	    this.word("declare");
	    this.space();
	  }

	  this._functionHead(node);

	  this.token(";");
	}
	function TSDeclareMethod(node) {
	  this._classMethodHead(node);

	  this.token(";");
	}
	function TSQualifiedName(node) {
	  this.print(node.left, node);
	  this.token(".");
	  this.print(node.right, node);
	}
	function TSCallSignatureDeclaration(node) {
	  this.tsPrintSignatureDeclarationBase(node);
	  this.token(";");
	}
	function TSConstructSignatureDeclaration(node) {
	  this.word("new");
	  this.space();
	  this.tsPrintSignatureDeclarationBase(node);
	  this.token(";");
	}
	function TSPropertySignature(node) {
	  const {
	    readonly,
	    initializer
	  } = node;

	  if (readonly) {
	    this.word("readonly");
	    this.space();
	  }

	  this.tsPrintPropertyOrMethodName(node);
	  this.print(node.typeAnnotation, node);

	  if (initializer) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(initializer, node);
	  }

	  this.token(";");
	}
	function tsPrintPropertyOrMethodName(node) {
	  if (node.computed) {
	    this.token("[");
	  }

	  this.print(node.key, node);

	  if (node.computed) {
	    this.token("]");
	  }

	  if (node.optional) {
	    this.token("?");
	  }
	}
	function TSMethodSignature(node) {
	  const {
	    kind
	  } = node;

	  if (kind === "set" || kind === "get") {
	    this.word(kind);
	    this.space();
	  }

	  this.tsPrintPropertyOrMethodName(node);
	  this.tsPrintSignatureDeclarationBase(node);
	  this.token(";");
	}
	function TSIndexSignature(node) {
	  const {
	    readonly,
	    static: isStatic
	  } = node;

	  if (isStatic) {
	    this.word("static");
	    this.space();
	  }

	  if (readonly) {
	    this.word("readonly");
	    this.space();
	  }

	  this.token("[");

	  this._parameters(node.parameters, node);

	  this.token("]");
	  this.print(node.typeAnnotation, node);
	  this.token(";");
	}
	function TSAnyKeyword() {
	  this.word("any");
	}
	function TSBigIntKeyword() {
	  this.word("bigint");
	}
	function TSUnknownKeyword() {
	  this.word("unknown");
	}
	function TSNumberKeyword() {
	  this.word("number");
	}
	function TSObjectKeyword() {
	  this.word("object");
	}
	function TSBooleanKeyword() {
	  this.word("boolean");
	}
	function TSStringKeyword() {
	  this.word("string");
	}
	function TSSymbolKeyword() {
	  this.word("symbol");
	}
	function TSVoidKeyword() {
	  this.word("void");
	}
	function TSUndefinedKeyword() {
	  this.word("undefined");
	}
	function TSNullKeyword() {
	  this.word("null");
	}
	function TSNeverKeyword() {
	  this.word("never");
	}
	function TSIntrinsicKeyword() {
	  this.word("intrinsic");
	}
	function TSThisType() {
	  this.word("this");
	}
	function TSFunctionType(node) {
	  this.tsPrintFunctionOrConstructorType(node);
	}
	function TSConstructorType(node) {
	  if (node.abstract) {
	    this.word("abstract");
	    this.space();
	  }

	  this.word("new");
	  this.space();
	  this.tsPrintFunctionOrConstructorType(node);
	}
	function tsPrintFunctionOrConstructorType(node) {
	  const {
	    typeParameters
	  } = node;
	  const parameters = browser$5.env.BABEL_8_BREAKING ? node.params : node.parameters;
	  this.print(typeParameters, node);
	  this.token("(");

	  this._parameters(parameters, node);

	  this.token(")");
	  this.space();
	  this.token("=>");
	  this.space();
	  const returnType = browser$5.env.BABEL_8_BREAKING ? node.returnType : node.typeAnnotation;
	  this.print(returnType.typeAnnotation, node);
	}
	function TSTypeReference(node) {
	  this.print(node.typeName, node);
	  this.print(node.typeParameters, node);
	}
	function TSTypePredicate(node) {
	  if (node.asserts) {
	    this.word("asserts");
	    this.space();
	  }

	  this.print(node.parameterName);

	  if (node.typeAnnotation) {
	    this.space();
	    this.word("is");
	    this.space();
	    this.print(node.typeAnnotation.typeAnnotation);
	  }
	}
	function TSTypeQuery(node) {
	  this.word("typeof");
	  this.space();
	  this.print(node.exprName);
	}
	function TSTypeLiteral(node) {
	  this.tsPrintTypeLiteralOrInterfaceBody(node.members, node);
	}
	function tsPrintTypeLiteralOrInterfaceBody(members, node) {
	  this.tsPrintBraced(members, node);
	}
	function tsPrintBraced(members, node) {
	  this.token("{");

	  if (members.length) {
	    this.indent();
	    this.newline();

	    for (const member of members) {
	      this.print(member, node);
	      this.newline();
	    }

	    this.dedent();
	    this.rightBrace();
	  } else {
	    this.token("}");
	  }
	}
	function TSArrayType(node) {
	  this.print(node.elementType, node);
	  this.token("[]");
	}
	function TSTupleType(node) {
	  this.token("[");
	  this.printList(node.elementTypes, node);
	  this.token("]");
	}
	function TSOptionalType(node) {
	  this.print(node.typeAnnotation, node);
	  this.token("?");
	}
	function TSRestType(node) {
	  this.token("...");
	  this.print(node.typeAnnotation, node);
	}
	function TSNamedTupleMember(node) {
	  this.print(node.label, node);
	  if (node.optional) this.token("?");
	  this.token(":");
	  this.space();
	  this.print(node.elementType, node);
	}
	function TSUnionType(node) {
	  this.tsPrintUnionOrIntersectionType(node, "|");
	}
	function TSIntersectionType(node) {
	  this.tsPrintUnionOrIntersectionType(node, "&");
	}
	function tsPrintUnionOrIntersectionType(node, sep) {
	  this.printJoin(node.types, node, {
	    separator() {
	      this.space();
	      this.token(sep);
	      this.space();
	    }

	  });
	}
	function TSConditionalType(node) {
	  this.print(node.checkType);
	  this.space();
	  this.word("extends");
	  this.space();
	  this.print(node.extendsType);
	  this.space();
	  this.token("?");
	  this.space();
	  this.print(node.trueType);
	  this.space();
	  this.token(":");
	  this.space();
	  this.print(node.falseType);
	}
	function TSInferType(node) {
	  this.token("infer");
	  this.space();
	  this.print(node.typeParameter);
	}
	function TSParenthesizedType(node) {
	  this.token("(");
	  this.print(node.typeAnnotation, node);
	  this.token(")");
	}
	function TSTypeOperator(node) {
	  this.word(node.operator);
	  this.space();
	  this.print(node.typeAnnotation, node);
	}
	function TSIndexedAccessType(node) {
	  this.print(node.objectType, node);
	  this.token("[");
	  this.print(node.indexType, node);
	  this.token("]");
	}
	function TSMappedType(node) {
	  const {
	    nameType,
	    optional,
	    readonly,
	    typeParameter
	  } = node;
	  this.token("{");
	  this.space();

	  if (readonly) {
	    tokenIfPlusMinus(this, readonly);
	    this.word("readonly");
	    this.space();
	  }

	  this.token("[");
	  this.word(!browser$5.env.BABEL_8_BREAKING ? typeParameter.name : typeParameter.name.name);
	  this.space();
	  this.word("in");
	  this.space();
	  this.print(typeParameter.constraint, typeParameter);

	  if (nameType) {
	    this.space();
	    this.word("as");
	    this.space();
	    this.print(nameType, node);
	  }

	  this.token("]");

	  if (optional) {
	    tokenIfPlusMinus(this, optional);
	    this.token("?");
	  }

	  this.token(":");
	  this.space();
	  this.print(node.typeAnnotation, node);
	  this.space();
	  this.token("}");
	}

	function tokenIfPlusMinus(self, tok) {
	  if (tok !== true) {
	    self.token(tok);
	  }
	}

	function TSLiteralType(node) {
	  this.print(node.literal, node);
	}
	function TSExpressionWithTypeArguments(node) {
	  this.print(node.expression, node);
	  this.print(node.typeParameters, node);
	}
	function TSInterfaceDeclaration(node) {
	  const {
	    declare,
	    id,
	    typeParameters,
	    extends: extendz,
	    body
	  } = node;

	  if (declare) {
	    this.word("declare");
	    this.space();
	  }

	  this.word("interface");
	  this.space();
	  this.print(id, node);
	  this.print(typeParameters, node);

	  if (extendz?.length) {
	    this.space();
	    this.word("extends");
	    this.space();
	    this.printList(extendz, node);
	  }

	  this.space();
	  this.print(body, node);
	}
	function TSInterfaceBody(node) {
	  this.tsPrintTypeLiteralOrInterfaceBody(node.body, node);
	}
	function TSTypeAliasDeclaration(node) {
	  const {
	    declare,
	    id,
	    typeParameters,
	    typeAnnotation
	  } = node;

	  if (declare) {
	    this.word("declare");
	    this.space();
	  }

	  this.word("type");
	  this.space();
	  this.print(id, node);
	  this.print(typeParameters, node);
	  this.space();
	  this.token("=");
	  this.space();
	  this.print(typeAnnotation, node);
	  this.token(";");
	}
	function TSAsExpression(node) {
	  const {
	    expression,
	    typeAnnotation
	  } = node;
	  this.print(expression, node);
	  this.space();
	  this.word("as");
	  this.space();
	  this.print(typeAnnotation, node);
	}
	function TSTypeAssertion(node) {
	  const {
	    typeAnnotation,
	    expression
	  } = node;
	  this.token("<");
	  this.print(typeAnnotation, node);
	  this.token(">");
	  this.space();
	  this.print(expression, node);
	}
	function TSEnumDeclaration(node) {
	  const {
	    declare,
	    const: isConst,
	    id,
	    members
	  } = node;

	  if (declare) {
	    this.word("declare");
	    this.space();
	  }

	  if (isConst) {
	    this.word("const");
	    this.space();
	  }

	  this.word("enum");
	  this.space();
	  this.print(id, node);
	  this.space();
	  this.tsPrintBraced(members, node);
	}
	function TSEnumMember(node) {
	  const {
	    id,
	    initializer
	  } = node;
	  this.print(id, node);

	  if (initializer) {
	    this.space();
	    this.token("=");
	    this.space();
	    this.print(initializer, node);
	  }

	  this.token(",");
	}
	function TSModuleDeclaration(node) {
	  const {
	    declare,
	    id
	  } = node;

	  if (declare) {
	    this.word("declare");
	    this.space();
	  }

	  if (!node.global) {
	    this.word(id.type === "Identifier" ? "namespace" : "module");
	    this.space();
	  }

	  this.print(id, node);

	  if (!node.body) {
	    this.token(";");
	    return;
	  }

	  let body = node.body;

	  while (body.type === "TSModuleDeclaration") {
	    this.token(".");
	    this.print(body.id, body);
	    body = body.body;
	  }

	  this.space();
	  this.print(body, node);
	}
	function TSModuleBlock(node) {
	  this.tsPrintBraced(node.body, node);
	}
	function TSImportType(node) {
	  const {
	    argument,
	    qualifier,
	    typeParameters
	  } = node;
	  this.word("import");
	  this.token("(");
	  this.print(argument, node);
	  this.token(")");

	  if (qualifier) {
	    this.token(".");
	    this.print(qualifier, node);
	  }

	  if (typeParameters) {
	    this.print(typeParameters, node);
	  }
	}
	function TSImportEqualsDeclaration(node) {
	  const {
	    isExport,
	    id,
	    moduleReference
	  } = node;

	  if (isExport) {
	    this.word("export");
	    this.space();
	  }

	  this.word("import");
	  this.space();
	  this.print(id, node);
	  this.space();
	  this.token("=");
	  this.space();
	  this.print(moduleReference, node);
	  this.token(";");
	}
	function TSExternalModuleReference(node) {
	  this.token("require(");
	  this.print(node.expression, node);
	  this.token(")");
	}
	function TSNonNullExpression(node) {
	  this.print(node.expression, node);
	  this.token("!");
	}
	function TSExportAssignment(node) {
	  this.word("export");
	  this.space();
	  this.token("=");
	  this.space();
	  this.print(node.expression, node);
	  this.token(";");
	}
	function TSNamespaceExportDeclaration(node) {
	  this.word("export");
	  this.space();
	  this.word("as");
	  this.space();
	  this.word("namespace");
	  this.space();
	  this.print(node.id, node);
	}
	function tsPrintSignatureDeclarationBase(node) {
	  const {
	    typeParameters
	  } = node;
	  const parameters = browser$5.env.BABEL_8_BREAKING ? node.params : node.parameters;
	  this.print(typeParameters, node);
	  this.token("(");

	  this._parameters(parameters, node);

	  this.token(")");
	  const returnType = browser$5.env.BABEL_8_BREAKING ? node.returnType : node.typeAnnotation;
	  this.print(returnType, node);
	}
	function tsPrintClassMemberModifiers(node, isField) {
	  if (isField && node.declare) {
	    this.word("declare");
	    this.space();
	  }

	  if (node.accessibility) {
	    this.word(node.accessibility);
	    this.space();
	  }

	  if (node.static) {
	    this.word("static");
	    this.space();
	  }

	  if (node.override) {
	    this.word("override");
	    this.space();
	  }

	  if (node.abstract) {
	    this.word("abstract");
	    this.space();
	  }

	  if (isField && node.readonly) {
	    this.word("readonly");
	    this.space();
	  }
	}

	var generatorFunctions = /*#__PURE__*/Object.freeze({
		__proto__: null,
		TaggedTemplateExpression: TaggedTemplateExpression$1,
		TemplateElement: TemplateElement,
		TemplateLiteral: TemplateLiteral$1,
		UnaryExpression: UnaryExpression$1,
		DoExpression: DoExpression,
		ParenthesizedExpression: ParenthesizedExpression$1,
		UpdateExpression: UpdateExpression$1,
		ConditionalExpression: ConditionalExpression$1,
		NewExpression: NewExpression$1,
		SequenceExpression: SequenceExpression$1,
		ThisExpression: ThisExpression,
		Super: Super,
		Decorator: Decorator,
		OptionalMemberExpression: OptionalMemberExpression,
		OptionalCallExpression: OptionalCallExpression,
		CallExpression: CallExpression$1,
		Import: Import,
		YieldExpression: YieldExpression,
		AwaitExpression: AwaitExpression,
		EmptyStatement: EmptyStatement,
		ExpressionStatement: ExpressionStatement,
		AssignmentPattern: AssignmentPattern,
		AssignmentExpression: AssignmentExpression$1,
		BindExpression: BindExpression,
		BinaryExpression: AssignmentExpression$1,
		LogicalExpression: AssignmentExpression$1,
		MemberExpression: MemberExpression,
		MetaProperty: MetaProperty,
		PrivateName: PrivateName,
		V8IntrinsicIdentifier: V8IntrinsicIdentifier,
		ModuleExpression: ModuleExpression,
		WithStatement: WithStatement,
		IfStatement: IfStatement,
		ForStatement: ForStatement,
		WhileStatement: WhileStatement,
		ForInStatement: ForInStatement,
		ForOfStatement: ForOfStatement,
		DoWhileStatement: DoWhileStatement,
		ContinueStatement: ContinueStatement,
		ReturnStatement: ReturnStatement,
		BreakStatement: BreakStatement,
		ThrowStatement: ThrowStatement,
		LabeledStatement: LabeledStatement,
		TryStatement: TryStatement,
		CatchClause: CatchClause,
		SwitchStatement: SwitchStatement,
		SwitchCase: SwitchCase,
		DebuggerStatement: DebuggerStatement,
		VariableDeclaration: VariableDeclaration,
		VariableDeclarator: VariableDeclarator$1,
		ClassDeclaration: ClassDeclaration,
		ClassExpression: ClassDeclaration,
		ClassBody: ClassBody,
		ClassProperty: ClassProperty,
		ClassAccessorProperty: ClassAccessorProperty,
		ClassPrivateProperty: ClassPrivateProperty,
		ClassMethod: ClassMethod,
		ClassPrivateMethod: ClassPrivateMethod,
		_classMethodHead: _classMethodHead,
		StaticBlock: StaticBlock,
		_params: _params,
		_parameters: _parameters,
		_param: _param,
		_methodHead: _methodHead,
		_predicate: _predicate,
		_functionHead: _functionHead,
		FunctionExpression: FunctionExpression,
		FunctionDeclaration: FunctionExpression,
		ArrowFunctionExpression: ArrowFunctionExpression,
		ImportSpecifier: ImportSpecifier,
		ImportDefaultSpecifier: ImportDefaultSpecifier,
		ExportDefaultSpecifier: ExportDefaultSpecifier,
		ExportSpecifier: ExportSpecifier,
		ExportNamespaceSpecifier: ExportNamespaceSpecifier,
		ExportAllDeclaration: ExportAllDeclaration,
		ExportNamedDeclaration: ExportNamedDeclaration,
		ExportDefaultDeclaration: ExportDefaultDeclaration,
		ImportDeclaration: ImportDeclaration,
		ImportAttribute: ImportAttribute,
		ImportNamespaceSpecifier: ImportNamespaceSpecifier,
		Identifier: Identifier,
		ArgumentPlaceholder: ArgumentPlaceholder,
		RestElement: RestElement$1,
		SpreadElement: RestElement$1,
		ObjectExpression: ObjectExpression$1,
		ObjectPattern: ObjectExpression$1,
		ObjectMethod: ObjectMethod,
		ObjectProperty: ObjectProperty,
		ArrayExpression: ArrayExpression$1,
		ArrayPattern: ArrayExpression$1,
		RecordExpression: RecordExpression,
		TupleExpression: TupleExpression,
		RegExpLiteral: RegExpLiteral$1,
		BooleanLiteral: BooleanLiteral$1,
		NullLiteral: NullLiteral$1,
		NumericLiteral: NumericLiteral$2,
		StringLiteral: StringLiteral$2,
		BigIntLiteral: BigIntLiteral,
		DecimalLiteral: DecimalLiteral,
		TopicReference: TopicReference,
		PipelineTopicExpression: PipelineTopicExpression,
		PipelineBareFunction: PipelineBareFunction,
		PipelinePrimaryTopicReference: PipelinePrimaryTopicReference,
		NumberLiteralTypeAnnotation: NumericLiteral$2,
		StringLiteralTypeAnnotation: StringLiteral$2,
		AnyTypeAnnotation: AnyTypeAnnotation,
		ArrayTypeAnnotation: ArrayTypeAnnotation,
		BooleanTypeAnnotation: BooleanTypeAnnotation,
		BooleanLiteralTypeAnnotation: BooleanLiteralTypeAnnotation,
		NullLiteralTypeAnnotation: NullLiteralTypeAnnotation,
		DeclareClass: DeclareClass,
		DeclareFunction: DeclareFunction,
		InferredPredicate: InferredPredicate,
		DeclaredPredicate: DeclaredPredicate,
		DeclareInterface: DeclareInterface,
		DeclareModule: DeclareModule,
		DeclareModuleExports: DeclareModuleExports,
		DeclareTypeAlias: DeclareTypeAlias,
		DeclareOpaqueType: DeclareOpaqueType,
		DeclareVariable: DeclareVariable,
		DeclareExportDeclaration: DeclareExportDeclaration,
		DeclareExportAllDeclaration: DeclareExportAllDeclaration,
		EnumDeclaration: EnumDeclaration,
		EnumBooleanBody: EnumBooleanBody,
		EnumNumberBody: EnumNumberBody,
		EnumStringBody: EnumStringBody,
		EnumSymbolBody: EnumSymbolBody,
		EnumDefaultedMember: EnumDefaultedMember,
		EnumBooleanMember: EnumBooleanMember,
		EnumNumberMember: EnumNumberMember,
		EnumStringMember: EnumStringMember,
		ExistsTypeAnnotation: ExistsTypeAnnotation,
		FunctionTypeAnnotation: FunctionTypeAnnotation,
		FunctionTypeParam: FunctionTypeParam,
		InterfaceExtends: InterfaceExtends,
		ClassImplements: InterfaceExtends,
		GenericTypeAnnotation: InterfaceExtends,
		_interfaceish: _interfaceish,
		_variance: _variance,
		InterfaceDeclaration: InterfaceDeclaration,
		InterfaceTypeAnnotation: InterfaceTypeAnnotation,
		IntersectionTypeAnnotation: IntersectionTypeAnnotation,
		MixedTypeAnnotation: MixedTypeAnnotation,
		EmptyTypeAnnotation: EmptyTypeAnnotation,
		NullableTypeAnnotation: NullableTypeAnnotation,
		NumberTypeAnnotation: NumberTypeAnnotation,
		StringTypeAnnotation: StringTypeAnnotation,
		ThisTypeAnnotation: ThisTypeAnnotation,
		TupleTypeAnnotation: TupleTypeAnnotation,
		TypeofTypeAnnotation: TypeofTypeAnnotation,
		TypeAlias: TypeAlias,
		TypeAnnotation: TypeAnnotation,
		TypeParameterInstantiation: TypeParameterInstantiation,
		TypeParameterDeclaration: TypeParameterInstantiation,
		TypeParameter: TypeParameter,
		OpaqueType: OpaqueType,
		ObjectTypeAnnotation: ObjectTypeAnnotation,
		ObjectTypeInternalSlot: ObjectTypeInternalSlot,
		ObjectTypeCallProperty: ObjectTypeCallProperty,
		ObjectTypeIndexer: ObjectTypeIndexer,
		ObjectTypeProperty: ObjectTypeProperty,
		ObjectTypeSpreadProperty: ObjectTypeSpreadProperty,
		QualifiedTypeIdentifier: QualifiedTypeIdentifier,
		SymbolTypeAnnotation: SymbolTypeAnnotation,
		UnionTypeAnnotation: UnionTypeAnnotation,
		TypeCastExpression: TypeCastExpression$1,
		Variance: Variance,
		VoidTypeAnnotation: VoidTypeAnnotation,
		IndexedAccessType: IndexedAccessType,
		OptionalIndexedAccessType: OptionalIndexedAccessType,
		File: File$1,
		Program: Program,
		BlockStatement: BlockStatement,
		Directive: Directive,
		DirectiveLiteral: DirectiveLiteral,
		InterpreterDirective: InterpreterDirective,
		Placeholder: Placeholder,
		JSXAttribute: JSXAttribute,
		JSXIdentifier: JSXIdentifier$1,
		JSXNamespacedName: JSXNamespacedName,
		JSXMemberExpression: JSXMemberExpression,
		JSXSpreadAttribute: JSXSpreadAttribute,
		JSXExpressionContainer: JSXExpressionContainer,
		JSXSpreadChild: JSXSpreadChild,
		JSXText: JSXText$1,
		JSXElement: JSXElement,
		JSXOpeningElement: JSXOpeningElement,
		JSXClosingElement: JSXClosingElement,
		JSXEmptyExpression: JSXEmptyExpression,
		JSXFragment: JSXFragment,
		JSXOpeningFragment: JSXOpeningFragment,
		JSXClosingFragment: JSXClosingFragment,
		TSTypeAnnotation: TSTypeAnnotation,
		TSTypeParameterInstantiation: TSTypeParameterInstantiation,
		TSTypeParameterDeclaration: TSTypeParameterInstantiation,
		TSTypeParameter: TSTypeParameter,
		TSParameterProperty: TSParameterProperty,
		TSDeclareFunction: TSDeclareFunction,
		TSDeclareMethod: TSDeclareMethod,
		TSQualifiedName: TSQualifiedName,
		TSCallSignatureDeclaration: TSCallSignatureDeclaration,
		TSConstructSignatureDeclaration: TSConstructSignatureDeclaration,
		TSPropertySignature: TSPropertySignature,
		tsPrintPropertyOrMethodName: tsPrintPropertyOrMethodName,
		TSMethodSignature: TSMethodSignature,
		TSIndexSignature: TSIndexSignature,
		TSAnyKeyword: TSAnyKeyword,
		TSBigIntKeyword: TSBigIntKeyword,
		TSUnknownKeyword: TSUnknownKeyword,
		TSNumberKeyword: TSNumberKeyword,
		TSObjectKeyword: TSObjectKeyword,
		TSBooleanKeyword: TSBooleanKeyword,
		TSStringKeyword: TSStringKeyword,
		TSSymbolKeyword: TSSymbolKeyword,
		TSVoidKeyword: TSVoidKeyword,
		TSUndefinedKeyword: TSUndefinedKeyword,
		TSNullKeyword: TSNullKeyword,
		TSNeverKeyword: TSNeverKeyword,
		TSIntrinsicKeyword: TSIntrinsicKeyword,
		TSThisType: TSThisType,
		TSFunctionType: TSFunctionType,
		TSConstructorType: TSConstructorType,
		tsPrintFunctionOrConstructorType: tsPrintFunctionOrConstructorType,
		TSTypeReference: TSTypeReference,
		TSTypePredicate: TSTypePredicate,
		TSTypeQuery: TSTypeQuery,
		TSTypeLiteral: TSTypeLiteral,
		tsPrintTypeLiteralOrInterfaceBody: tsPrintTypeLiteralOrInterfaceBody,
		tsPrintBraced: tsPrintBraced,
		TSArrayType: TSArrayType,
		TSTupleType: TSTupleType,
		TSOptionalType: TSOptionalType,
		TSRestType: TSRestType,
		TSNamedTupleMember: TSNamedTupleMember,
		TSUnionType: TSUnionType,
		TSIntersectionType: TSIntersectionType,
		tsPrintUnionOrIntersectionType: tsPrintUnionOrIntersectionType,
		TSConditionalType: TSConditionalType,
		TSInferType: TSInferType,
		TSParenthesizedType: TSParenthesizedType,
		TSTypeOperator: TSTypeOperator,
		TSIndexedAccessType: TSIndexedAccessType,
		TSMappedType: TSMappedType,
		TSLiteralType: TSLiteralType,
		TSExpressionWithTypeArguments: TSExpressionWithTypeArguments,
		TSInterfaceDeclaration: TSInterfaceDeclaration,
		TSInterfaceBody: TSInterfaceBody,
		TSTypeAliasDeclaration: TSTypeAliasDeclaration,
		TSAsExpression: TSAsExpression,
		TSTypeAssertion: TSTypeAssertion,
		TSEnumDeclaration: TSEnumDeclaration,
		TSEnumMember: TSEnumMember,
		TSModuleDeclaration: TSModuleDeclaration,
		TSModuleBlock: TSModuleBlock,
		TSImportType: TSImportType,
		TSImportEqualsDeclaration: TSImportEqualsDeclaration,
		TSExternalModuleReference: TSExternalModuleReference,
		TSNonNullExpression: TSNonNullExpression,
		TSExportAssignment: TSExportAssignment,
		TSNamespaceExportDeclaration: TSNamespaceExportDeclaration,
		tsPrintSignatureDeclarationBase: tsPrintSignatureDeclarationBase,
		tsPrintClassMemberModifiers: tsPrintClassMemberModifiers
	});

	const {
	  isProgram: isProgram$1,
	  isFile,
	  isEmptyStatement
	} = _t;
	const SCIENTIFIC_NOTATION = /e/i;
	const ZERO_DECIMAL_INTEGER = /\.0+$/;
	const NON_DECIMAL_LITERAL = /^0[box]/;
	const PURE_ANNOTATION_RE = /^\s*[@#]__PURE__\s*$/;
	const {
	  needsParens,
	  needsWhitespaceAfter,
	  needsWhitespaceBefore
	} = n;

	class Printer {
	  constructor(format, map) {
	    this.format = format;
	    this._buf = new Buffer(map);
	  }

	  inForStatementInitCounter = 0;
	  _printStack = [];
	  _indent = 0;
	  _insideAux = false;
	  _parenPushNewlineState = null;
	  _noLineTerminator = false;
	  _printAuxAfterOnNextUserNode = false;
	  _printedComments = new WeakSet();
	  _endsWithInteger = false;
	  _endsWithWord = false;

	  generate(ast) {
	    this.print(ast);

	    this._maybeAddAuxComment();

	    return this._buf.get();
	  }

	  indent() {
	    if (this.format.compact || this.format.concise) return;
	    this._indent++;
	  }

	  dedent() {
	    if (this.format.compact || this.format.concise) return;
	    this._indent--;
	  }

	  semicolon(force = false) {
	    this._maybeAddAuxComment();

	    this._append(";", !force);
	  }

	  rightBrace() {
	    if (this.format.minified) {
	      this._buf.removeLastSemicolon();
	    }

	    this.token("}");
	  }

	  space(force = false) {
	    if (this.format.compact) return;

	    if (force) {
	      this._space();
	    } else if (this._buf.hasContent()) {
	      const lastCp = this.getLastChar();

	      if (lastCp !== 32 && lastCp !== 10) {
	        this._space();
	      }
	    }
	  }

	  word(str) {
	    if (this._endsWithWord || this.endsWith(47) && str.charCodeAt(0) === 47) {
	      this._space();
	    }

	    this._maybeAddAuxComment();

	    this._append(str);

	    this._endsWithWord = true;
	  }

	  number(str) {
	    this.word(str);
	    this._endsWithInteger = Number.isInteger(+str) && !NON_DECIMAL_LITERAL.test(str) && !SCIENTIFIC_NOTATION.test(str) && !ZERO_DECIMAL_INTEGER.test(str) && str.charCodeAt(str.length - 1) !== 46;
	  }

	  token(str) {
	    const lastChar = this.getLastChar();
	    const strFirst = str.charCodeAt(0);

	    if (str === "--" && lastChar === 33 || strFirst === 43 && lastChar === 43 || strFirst === 45 && lastChar === 45 || strFirst === 46 && this._endsWithInteger) {
	      this._space();
	    }

	    this._maybeAddAuxComment();

	    this._append(str);
	  }

	  newline(i = 1) {
	    if (this.format.retainLines || this.format.compact) return;

	    if (this.format.concise) {
	      this.space();
	      return;
	    }

	    const charBeforeNewline = this.endsWithCharAndNewline();
	    if (charBeforeNewline === 10) return;

	    if (charBeforeNewline === 123 || charBeforeNewline === 58) {
	      i--;
	    }

	    if (i <= 0) return;

	    for (let j = 0; j < i; j++) {
	      this._newline();
	    }
	  }

	  endsWith(char) {
	    return this.getLastChar() === char;
	  }

	  getLastChar() {
	    return this._buf.getLastChar();
	  }

	  endsWithCharAndNewline() {
	    return this._buf.endsWithCharAndNewline();
	  }

	  removeTrailingNewline() {
	    this._buf.removeTrailingNewline();
	  }

	  exactSource(loc, cb) {
	    this._catchUp("start", loc);

	    this._buf.exactSource(loc, cb);
	  }

	  source(prop, loc) {
	    this._catchUp(prop, loc);

	    this._buf.source(prop, loc);
	  }

	  withSource(prop, loc, cb) {
	    this._catchUp(prop, loc);

	    this._buf.withSource(prop, loc, cb);
	  }

	  _space() {
	    this._append(" ", true);
	  }

	  _newline() {
	    this._append("\n", true);
	  }

	  _append(str, queue = false) {
	    this._maybeAddParen(str);

	    this._maybeIndent(str);

	    if (queue) this._buf.queue(str);else this._buf.append(str);
	    this._endsWithWord = false;
	    this._endsWithInteger = false;
	  }

	  _maybeIndent(str) {
	    if (this._indent && this.endsWith(10) && str.charCodeAt(0) !== 10) {
	      this._buf.queue(this._getIndent());
	    }
	  }

	  _maybeAddParen(str) {
	    const parenPushNewlineState = this._parenPushNewlineState;
	    if (!parenPushNewlineState) return;
	    let i;

	    for (i = 0; i < str.length && str[i] === " "; i++) continue;

	    if (i === str.length) {
	      return;
	    }

	    const cha = str[i];

	    if (cha !== "\n") {
	      if (cha !== "/" || i + 1 === str.length) {
	        this._parenPushNewlineState = null;
	        return;
	      }

	      const chaPost = str[i + 1];

	      if (chaPost === "*") {
	        if (PURE_ANNOTATION_RE.test(str.slice(i + 2, str.length - 2))) {
	          return;
	        }
	      } else if (chaPost !== "/") {
	        this._parenPushNewlineState = null;
	        return;
	      }
	    }

	    this.token("(");
	    this.indent();
	    parenPushNewlineState.printed = true;
	  }

	  _catchUp(prop, loc) {
	    if (!this.format.retainLines) return;
	    const pos = loc ? loc[prop] : null;

	    if (pos?.line != null) {
	      const count = pos.line - this._buf.getCurrentLine();

	      for (let i = 0; i < count; i++) {
	        this._newline();
	      }
	    }

	    if (pos?.column != null) {
	      const count = pos.column - this._buf.getCurrentColumn();

	      if (count > 0) {
	        this._append(" ".repeat(count));
	      }
	    }
	  }

	  _getIndent() {
	    if (this.format.retainLines) return "";
	    return this.format.indent.style.repeat(this._indent);
	  }

	  startTerminatorless(isLabel = false) {
	    if (isLabel) {
	      this._noLineTerminator = true;
	      return null;
	    } else {
	      return this._parenPushNewlineState = {
	        printed: false
	      };
	    }
	  }

	  endTerminatorless(state) {
	    this._noLineTerminator = false;

	    if (state?.printed) {
	      this.dedent();
	      this.newline();
	      this.token(")");
	    }
	  }

	  print(node, parent) {
	    if (!node) return;
	    const oldConcise = this.format.concise;

	    if (node._compact) {
	      this.format.concise = true;
	    }

	    const printMethod = this[node.type];

	    if (!printMethod) {
	      throw new ReferenceError(`unknown node of type ${JSON.stringify(node.type)} with constructor ${JSON.stringify(node?.constructor.name)}`);
	    }

	    this._printStack.push(node);

	    const oldInAux = this._insideAux;
	    this._insideAux = !node.loc;

	    this._maybeAddAuxComment(this._insideAux && !oldInAux);

	    let shouldPrintParens = needsParens(node, parent, this._printStack);

	    if (this.format.retainFunctionParens && node.type === "FunctionExpression" && node.extra && node.extra.parenthesized) {
	      shouldPrintParens = true;
	    }

	    if (shouldPrintParens) this.token("(");

	    this._printLeadingComments(node);

	    const loc = isProgram$1(node) || isFile(node) ? null : node.loc;
	    this.withSource("start", loc, () => {
	      printMethod.call(this, node, parent);
	    });

	    this._printTrailingComments(node);

	    if (shouldPrintParens) this.token(")");

	    this._printStack.pop();

	    this.format.concise = oldConcise;
	    this._insideAux = oldInAux;
	  }

	  _maybeAddAuxComment(enteredPositionlessNode) {
	    if (enteredPositionlessNode) this._printAuxBeforeComment();
	    if (!this._insideAux) this._printAuxAfterComment();
	  }

	  _printAuxBeforeComment() {
	    if (this._printAuxAfterOnNextUserNode) return;
	    this._printAuxAfterOnNextUserNode = true;
	    const comment = this.format.auxiliaryCommentBefore;

	    if (comment) {
	      this._printComment({
	        type: "CommentBlock",
	        value: comment
	      });
	    }
	  }

	  _printAuxAfterComment() {
	    if (!this._printAuxAfterOnNextUserNode) return;
	    this._printAuxAfterOnNextUserNode = false;
	    const comment = this.format.auxiliaryCommentAfter;

	    if (comment) {
	      this._printComment({
	        type: "CommentBlock",
	        value: comment
	      });
	    }
	  }

	  getPossibleRaw(node) {
	    const extra = node.extra;

	    if (extra && extra.raw != null && extra.rawValue != null && node.value === extra.rawValue) {
	      return extra.raw;
	    }
	  }

	  printJoin(nodes, parent, opts = {}) {
	    if (!nodes?.length) return;
	    if (opts.indent) this.indent();
	    const newlineOpts = {
	      addNewlines: opts.addNewlines
	    };

	    for (let i = 0; i < nodes.length; i++) {
	      const node = nodes[i];
	      if (!node) continue;
	      if (opts.statement) this._printNewline(true, node, parent, newlineOpts);
	      this.print(node, parent);

	      if (opts.iterator) {
	        opts.iterator(node, i);
	      }

	      if (opts.separator && i < nodes.length - 1) {
	        opts.separator.call(this);
	      }

	      if (opts.statement) this._printNewline(false, node, parent, newlineOpts);
	    }

	    if (opts.indent) this.dedent();
	  }

	  printAndIndentOnComments(node, parent) {
	    const indent = node.leadingComments && node.leadingComments.length > 0;
	    if (indent) this.indent();
	    this.print(node, parent);
	    if (indent) this.dedent();
	  }

	  printBlock(parent) {
	    const node = parent.body;

	    if (!isEmptyStatement(node)) {
	      this.space();
	    }

	    this.print(node, parent);
	  }

	  _printTrailingComments(node) {
	    this._printComments(this._getComments(false, node));
	  }

	  _printLeadingComments(node) {
	    this._printComments(this._getComments(true, node), true);
	  }

	  printInnerComments(node, indent = true) {
	    if (!node.innerComments?.length) return;
	    if (indent) this.indent();

	    this._printComments(node.innerComments);

	    if (indent) this.dedent();
	  }

	  printSequence(nodes, parent, opts = {}) {
	    opts.statement = true;
	    return this.printJoin(nodes, parent, opts);
	  }

	  printList(items, parent, opts = {}) {
	    if (opts.separator == null) {
	      opts.separator = commaSeparator;
	    }

	    return this.printJoin(items, parent, opts);
	  }

	  _printNewline(leading, node, parent, opts) {
	    if (this.format.retainLines || this.format.compact) return;

	    if (this.format.concise) {
	      this.space();
	      return;
	    }

	    let lines = 0;

	    if (this._buf.hasContent()) {
	      if (!leading) lines++;
	      if (opts.addNewlines) lines += opts.addNewlines(leading, node) || 0;
	      const needs = leading ? needsWhitespaceBefore : needsWhitespaceAfter;
	      if (needs(node, parent)) lines++;
	    }

	    this.newline(Math.min(2, lines));
	  }

	  _getComments(leading, node) {
	    return node && (leading ? node.leadingComments : node.trailingComments) || [];
	  }

	  _printComment(comment, skipNewLines) {
	    if (!this.format.shouldPrintComment(comment.value)) return;
	    if (comment.ignore) return;
	    if (this._printedComments.has(comment)) return;

	    this._printedComments.add(comment);

	    const isBlockComment = comment.type === "CommentBlock";
	    const printNewLines = isBlockComment && !skipNewLines && !this._noLineTerminator;
	    if (printNewLines && this._buf.hasContent()) this.newline(1);
	    const lastCharCode = this.getLastChar();

	    if (lastCharCode !== 91 && lastCharCode !== 123) {
	      this.space();
	    }

	    let val = !isBlockComment && !this._noLineTerminator ? `//${comment.value}\n` : `/*${comment.value}*/`;

	    if (isBlockComment && this.format.indent.adjustMultilineComment) {
	      const offset = comment.loc?.start.column;

	      if (offset) {
	        const newlineRegex = new RegExp("\\n\\s{1," + offset + "}", "g");
	        val = val.replace(newlineRegex, "\n");
	      }

	      const indentSize = Math.max(this._getIndent().length, this.format.retainLines ? 0 : this._buf.getCurrentColumn());
	      val = val.replace(/\n(?!$)/g, `\n${" ".repeat(indentSize)}`);
	    }

	    if (this.endsWith(47)) this._space();
	    this.withSource("start", comment.loc, () => {
	      this._append(val);
	    });
	    if (printNewLines) this.newline(1);
	  }

	  _printComments(comments, inlinePureAnnotation) {
	    if (!comments?.length) return;

	    if (inlinePureAnnotation && comments.length === 1 && PURE_ANNOTATION_RE.test(comments[0].value)) {
	      this._printComment(comments[0], this._buf.hasContent() && !this.endsWith(10));
	    } else {
	      for (const comment of comments) {
	        this._printComment(comment);
	      }
	    }
	  }

	  printAssertions(node) {
	    if (node.assertions?.length) {
	      this.space();
	      this.word("assert");
	      this.space();
	      this.token("{");
	      this.space();
	      this.printList(node.assertions, node);
	      this.space();
	      this.token("}");
	    }
	  }

	}

	Object.assign(Printer.prototype, generatorFunctions);

	if (!browser$5.env.BABEL_8_BREAKING) {
	  Printer.prototype.Noop = function Noop() {};
	}

	function commaSeparator() {
	  this.token(",");
	  this.space();
	}

	class Generator extends Printer {
	  constructor(ast, opts = {}, code) {
	    const format = normalizeOptions$2(code, opts);
	    const map = opts.sourceMaps ? new SourceMap$1(opts, code) : null;
	    super(format, map);
	    this.ast = ast;
	  }

	  ast;

	  generate() {
	    return super.generate(this.ast);
	  }

	}

	function normalizeOptions$2(code, opts) {
	  const format = {
	    auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
	    auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
	    shouldPrintComment: opts.shouldPrintComment,
	    retainLines: opts.retainLines,
	    retainFunctionParens: opts.retainFunctionParens,
	    comments: opts.comments == null || opts.comments,
	    compact: opts.compact,
	    minified: opts.minified,
	    concise: opts.concise,
	    indent: {
	      adjustMultilineComment: true,
	      style: "  ",
	      base: 0
	    },
	    decoratorsBeforeExport: !!opts.decoratorsBeforeExport,
	    jsescOption: {
	      quotes: "double",
	      wrap: true,
	      minimal: browser$5.env.BABEL_8_BREAKING ? true : false,
	      ...opts.jsescOption
	    },
	    recordAndTupleSyntaxType: opts.recordAndTupleSyntaxType,
	    topicToken: opts.topicToken
	  };

	  if (!browser$5.env.BABEL_8_BREAKING) {
	    format.jsonCompatibleStrings = opts.jsonCompatibleStrings;
	  }

	  if (format.minified) {
	    format.compact = true;

	    format.shouldPrintComment = format.shouldPrintComment || (() => format.comments);
	  } else {
	    format.shouldPrintComment = format.shouldPrintComment || (value => format.comments || value.indexOf("@license") >= 0 || value.indexOf("@preserve") >= 0);
	  }

	  if (format.compact === "auto") {
	    format.compact = code.length > 500_000;

	    if (format.compact) {
	      console.error("[BABEL] Note: The code generator has deoptimised the styling of " + `${opts.filename} as it exceeds the max of ${"500KB"}.`);
	    }
	  }

	  if (format.compact) {
	    format.indent.adjustMultilineComment = false;
	  }

	  return format;
	}
	function generate$1(ast, opts, code) {
	  const gen = new Generator(ast, opts, code);
	  return gen.generate();
	}

	const {
	  VISITOR_KEYS: VISITOR_KEYS$5
	} = _t;
	function findParent(callback) {
	  let path = this;

	  while (path = path.parentPath) {
	    if (callback(path)) return path;
	  }

	  return null;
	}
	function find$1(callback) {
	  let path = this;

	  do {
	    if (callback(path)) return path;
	  } while (path = path.parentPath);

	  return null;
	}
	function getFunctionParent() {
	  return this.findParent(p => p.isFunction());
	}
	function getStatementParent() {
	  let path = this;

	  do {
	    if (!path.parentPath || Array.isArray(path.container) && path.isStatement()) {
	      break;
	    } else {
	      path = path.parentPath;
	    }
	  } while (path);

	  if (path && (path.isProgram() || path.isFile())) {
	    throw new Error("File/Program node, we can't possibly find a statement parent to this");
	  }

	  return path;
	}
	function getEarliestCommonAncestorFrom(paths) {
	  return this.getDeepestCommonAncestorFrom(paths, function (deepest, i, ancestries) {
	    let earliest;
	    const keys = VISITOR_KEYS$5[deepest.type];

	    for (const ancestry of ancestries) {
	      const path = ancestry[i + 1];

	      if (!earliest) {
	        earliest = path;
	        continue;
	      }

	      if (path.listKey && earliest.listKey === path.listKey) {
	        if (path.key < earliest.key) {
	          earliest = path;
	          continue;
	        }
	      }

	      const earliestKeyIndex = keys.indexOf(earliest.parentKey);
	      const currentKeyIndex = keys.indexOf(path.parentKey);

	      if (earliestKeyIndex > currentKeyIndex) {
	        earliest = path;
	      }
	    }

	    return earliest;
	  });
	}
	function getDeepestCommonAncestorFrom(paths, filter) {
	  if (!paths.length) {
	    return this;
	  }

	  if (paths.length === 1) {
	    return paths[0];
	  }

	  let minDepth = Infinity;
	  let lastCommonIndex, lastCommon;
	  const ancestries = paths.map(path => {
	    const ancestry = [];

	    do {
	      ancestry.unshift(path);
	    } while ((path = path.parentPath) && path !== this);

	    if (ancestry.length < minDepth) {
	      minDepth = ancestry.length;
	    }

	    return ancestry;
	  });
	  const first = ancestries[0];

	  depthLoop: for (let i = 0; i < minDepth; i++) {
	    const shouldMatch = first[i];

	    for (const ancestry of ancestries) {
	      if (ancestry[i] !== shouldMatch) {
	        break depthLoop;
	      }
	    }

	    lastCommonIndex = i;
	    lastCommon = shouldMatch;
	  }

	  if (lastCommon) {
	    if (filter) {
	      return filter(lastCommon, lastCommonIndex, ancestries);
	    } else {
	      return lastCommon;
	    }
	  } else {
	    throw new Error("Couldn't find intersection");
	  }
	}
	function getAncestry() {
	  let path = this;
	  const paths = [];

	  do {
	    paths.push(path);
	  } while (path = path.parentPath);

	  return paths;
	}
	function isAncestor(maybeDescendant) {
	  return maybeDescendant.isDescendant(this);
	}
	function isDescendant(maybeAncestor) {
	  return !!this.findParent(parent => parent === maybeAncestor);
	}
	function inType(...candidateTypes) {
	  let path = this;

	  while (path) {
	    for (const type of candidateTypes) {
	      if (path.node.type === type) return true;
	    }

	    path = path.parentPath;
	  }

	  return false;
	}

	var NodePath_ancestry = /*#__PURE__*/Object.freeze({
		__proto__: null,
		findParent: findParent,
		find: find$1,
		getFunctionParent: getFunctionParent,
		getStatementParent: getStatementParent,
		getEarliestCommonAncestorFrom: getEarliestCommonAncestorFrom,
		getDeepestCommonAncestorFrom: getDeepestCommonAncestorFrom,
		getAncestry: getAncestry,
		isAncestor: isAncestor,
		isDescendant: isDescendant,
		inType: inType
	});

	const {
	  BOOLEAN_NUMBER_BINARY_OPERATORS,
	  createFlowUnionType: createFlowUnionType$1,
	  createTSUnionType: createTSUnionType$1,
	  createTypeAnnotationBasedOnTypeof,
	  createUnionTypeAnnotation: createUnionTypeAnnotation$1,
	  isTSTypeAnnotation: isTSTypeAnnotation$1,
	  numberTypeAnnotation: numberTypeAnnotation$1,
	  voidTypeAnnotation: voidTypeAnnotation$2
	} = _t;
	function infererReference (node) {
	  if (!this.isReferenced()) return;
	  const binding = this.scope.getBinding(node.name);

	  if (binding) {
	    if (binding.identifier.typeAnnotation) {
	      return binding.identifier.typeAnnotation;
	    } else {
	      return getTypeAnnotationBindingConstantViolations(binding, this, node.name);
	    }
	  }

	  if (node.name === "undefined") {
	    return voidTypeAnnotation$2();
	  } else if (node.name === "NaN" || node.name === "Infinity") {
	    return numberTypeAnnotation$1();
	  } else if (node.name === "arguments") ;
	}

	function getTypeAnnotationBindingConstantViolations(binding, path, name) {
	  const types = [];
	  const functionConstantViolations = [];
	  let constantViolations = getConstantViolationsBefore(binding, path, functionConstantViolations);
	  const testType = getConditionalAnnotation(binding, path, name);

	  if (testType) {
	    const testConstantViolations = getConstantViolationsBefore(binding, testType.ifStatement);
	    constantViolations = constantViolations.filter(path => testConstantViolations.indexOf(path) < 0);
	    types.push(testType.typeAnnotation);
	  }

	  if (constantViolations.length) {
	    constantViolations.push(...functionConstantViolations);

	    for (const violation of constantViolations) {
	      types.push(violation.getTypeAnnotation());
	    }
	  }

	  if (!types.length) {
	    return;
	  }

	  if (isTSTypeAnnotation$1(types[0]) && createTSUnionType$1) {
	    return createTSUnionType$1(types);
	  }

	  if (createFlowUnionType$1) {
	    return createFlowUnionType$1(types);
	  }

	  return createUnionTypeAnnotation$1(types);
	}

	function getConstantViolationsBefore(binding, path, functions) {
	  const violations = binding.constantViolations.slice();
	  violations.unshift(binding.path);
	  return violations.filter(violation => {
	    violation = violation.resolve();

	    const status = violation._guessExecutionStatusRelativeTo(path);

	    if (functions && status === "unknown") functions.push(violation);
	    return status === "before";
	  });
	}

	function inferAnnotationFromBinaryExpression(name, path) {
	  const operator = path.node.operator;
	  const right = path.get("right").resolve();
	  const left = path.get("left").resolve();
	  let target;

	  if (left.isIdentifier({
	    name
	  })) {
	    target = right;
	  } else if (right.isIdentifier({
	    name
	  })) {
	    target = left;
	  }

	  if (target) {
	    if (operator === "===") {
	      return target.getTypeAnnotation();
	    }

	    if (BOOLEAN_NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
	      return numberTypeAnnotation$1();
	    }

	    return;
	  }

	  if (operator !== "===" && operator !== "==") return;
	  let typeofPath;
	  let typePath;

	  if (left.isUnaryExpression({
	    operator: "typeof"
	  })) {
	    typeofPath = left;
	    typePath = right;
	  } else if (right.isUnaryExpression({
	    operator: "typeof"
	  })) {
	    typeofPath = right;
	    typePath = left;
	  }

	  if (!typeofPath) return;
	  if (!typeofPath.get("argument").isIdentifier({
	    name
	  })) return;
	  typePath = typePath.resolve();
	  if (!typePath.isLiteral()) return;
	  const typeValue = typePath.node.value;
	  if (typeof typeValue !== "string") return;
	  return createTypeAnnotationBasedOnTypeof(typeValue);
	}

	function getParentConditionalPath(binding, path, name) {
	  let parentPath;

	  while (parentPath = path.parentPath) {
	    if (parentPath.isIfStatement() || parentPath.isConditionalExpression()) {
	      if (path.key === "test") {
	        return;
	      }

	      return parentPath;
	    }

	    if (parentPath.isFunction()) {
	      if (parentPath.parentPath.scope.getBinding(name) !== binding) return;
	    }

	    path = parentPath;
	  }
	}

	function getConditionalAnnotation(binding, path, name) {
	  const ifStatement = getParentConditionalPath(binding, path, name);
	  if (!ifStatement) return;
	  const test = ifStatement.get("test");
	  const paths = [test];
	  const types = [];

	  for (let i = 0; i < paths.length; i++) {
	    const path = paths[i];

	    if (path.isLogicalExpression()) {
	      if (path.node.operator === "&&") {
	        paths.push(path.get("left"));
	        paths.push(path.get("right"));
	      }
	    } else if (path.isBinaryExpression()) {
	      const type = inferAnnotationFromBinaryExpression(name, path);
	      if (type) types.push(type);
	    }
	  }

	  if (types.length) {
	    if (isTSTypeAnnotation$1(types[0]) && createTSUnionType$1) {
	      return {
	        typeAnnotation: createTSUnionType$1(types),
	        ifStatement
	      };
	    }

	    if (createFlowUnionType$1) {
	      return {
	        typeAnnotation: createFlowUnionType$1(types),
	        ifStatement
	      };
	    }

	    return {
	      typeAnnotation: createUnionTypeAnnotation$1(types),
	      ifStatement
	    };
	  }

	  return getConditionalAnnotation(ifStatement, name);
	}

	const {
	  BOOLEAN_BINARY_OPERATORS,
	  BOOLEAN_UNARY_OPERATORS,
	  NUMBER_BINARY_OPERATORS,
	  NUMBER_UNARY_OPERATORS,
	  STRING_UNARY_OPERATORS,
	  anyTypeAnnotation: anyTypeAnnotation$1,
	  arrayTypeAnnotation,
	  booleanTypeAnnotation,
	  buildMatchMemberExpression,
	  createFlowUnionType,
	  createTSUnionType,
	  createUnionTypeAnnotation,
	  genericTypeAnnotation,
	  identifier: identifier$a,
	  isTSTypeAnnotation,
	  nullLiteralTypeAnnotation,
	  numberTypeAnnotation,
	  stringTypeAnnotation: stringTypeAnnotation$1,
	  tupleTypeAnnotation,
	  unionTypeAnnotation,
	  voidTypeAnnotation: voidTypeAnnotation$1
	} = _t;
	function VariableDeclarator() {
	  const id = this.get("id");
	  if (!id.isIdentifier()) return;
	  const init = this.get("init");
	  let type = init.getTypeAnnotation();

	  if (type?.type === "AnyTypeAnnotation") {
	    if (init.isCallExpression() && init.get("callee").isIdentifier({
	      name: "Array"
	    }) && !init.scope.hasBinding("Array", true)) {
	      type = ArrayExpression();
	    }
	  }

	  return type;
	}
	function TypeCastExpression(node) {
	  return node.typeAnnotation;
	}
	TypeCastExpression.validParent = true;
	function NewExpression(node) {
	  if (this.get("callee").isIdentifier()) {
	    return genericTypeAnnotation(node.callee);
	  }
	}
	function TemplateLiteral() {
	  return stringTypeAnnotation$1();
	}
	function UnaryExpression(node) {
	  const operator = node.operator;

	  if (operator === "void") {
	    return voidTypeAnnotation$1();
	  } else if (NUMBER_UNARY_OPERATORS.indexOf(operator) >= 0) {
	    return numberTypeAnnotation();
	  } else if (STRING_UNARY_OPERATORS.indexOf(operator) >= 0) {
	    return stringTypeAnnotation$1();
	  } else if (BOOLEAN_UNARY_OPERATORS.indexOf(operator) >= 0) {
	    return booleanTypeAnnotation();
	  }
	}
	function BinaryExpression(node) {
	  const operator = node.operator;

	  if (NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
	    return numberTypeAnnotation();
	  } else if (BOOLEAN_BINARY_OPERATORS.indexOf(operator) >= 0) {
	    return booleanTypeAnnotation();
	  } else if (operator === "+") {
	    const right = this.get("right");
	    const left = this.get("left");

	    if (left.isBaseType("number") && right.isBaseType("number")) {
	      return numberTypeAnnotation();
	    } else if (left.isBaseType("string") || right.isBaseType("string")) {
	      return stringTypeAnnotation$1();
	    }

	    return unionTypeAnnotation([stringTypeAnnotation$1(), numberTypeAnnotation()]);
	  }
	}
	function LogicalExpression() {
	  const argumentTypes = [this.get("left").getTypeAnnotation(), this.get("right").getTypeAnnotation()];

	  if (isTSTypeAnnotation(argumentTypes[0]) && createTSUnionType) {
	    return createTSUnionType(argumentTypes);
	  }

	  if (createFlowUnionType) {
	    return createFlowUnionType(argumentTypes);
	  }

	  return createUnionTypeAnnotation(argumentTypes);
	}
	function ConditionalExpression() {
	  const argumentTypes = [this.get("consequent").getTypeAnnotation(), this.get("alternate").getTypeAnnotation()];

	  if (isTSTypeAnnotation(argumentTypes[0]) && createTSUnionType) {
	    return createTSUnionType(argumentTypes);
	  }

	  if (createFlowUnionType) {
	    return createFlowUnionType(argumentTypes);
	  }

	  return createUnionTypeAnnotation(argumentTypes);
	}
	function SequenceExpression() {
	  return this.get("expressions").pop().getTypeAnnotation();
	}
	function ParenthesizedExpression() {
	  return this.get("expression").getTypeAnnotation();
	}
	function AssignmentExpression() {
	  return this.get("right").getTypeAnnotation();
	}
	function UpdateExpression(node) {
	  const operator = node.operator;

	  if (operator === "++" || operator === "--") {
	    return numberTypeAnnotation();
	  }
	}
	function StringLiteral$1() {
	  return stringTypeAnnotation$1();
	}
	function NumericLiteral$1() {
	  return numberTypeAnnotation();
	}
	function BooleanLiteral() {
	  return booleanTypeAnnotation();
	}
	function NullLiteral() {
	  return nullLiteralTypeAnnotation();
	}
	function RegExpLiteral() {
	  return genericTypeAnnotation(identifier$a("RegExp"));
	}
	function ObjectExpression() {
	  return genericTypeAnnotation(identifier$a("Object"));
	}
	function ArrayExpression() {
	  return genericTypeAnnotation(identifier$a("Array"));
	}
	function RestElement() {
	  return ArrayExpression();
	}
	RestElement.validParent = true;

	function Func() {
	  return genericTypeAnnotation(identifier$a("Function"));
	}
	const isArrayFrom = buildMatchMemberExpression("Array.from");
	const isObjectKeys = buildMatchMemberExpression("Object.keys");
	const isObjectValues = buildMatchMemberExpression("Object.values");
	const isObjectEntries = buildMatchMemberExpression("Object.entries");
	function CallExpression() {
	  const {
	    callee
	  } = this.node;

	  if (isObjectKeys(callee)) {
	    return arrayTypeAnnotation(stringTypeAnnotation$1());
	  } else if (isArrayFrom(callee) || isObjectValues(callee)) {
	    return arrayTypeAnnotation(anyTypeAnnotation$1());
	  } else if (isObjectEntries(callee)) {
	    return arrayTypeAnnotation(tupleTypeAnnotation([stringTypeAnnotation$1(), anyTypeAnnotation$1()]));
	  }

	  return resolveCall(this.get("callee"));
	}
	function TaggedTemplateExpression() {
	  return resolveCall(this.get("tag"));
	}

	function resolveCall(callee) {
	  callee = callee.resolve();

	  if (callee.isFunction()) {
	    if (callee.is("async")) {
	      if (callee.is("generator")) {
	        return genericTypeAnnotation(identifier$a("AsyncIterator"));
	      } else {
	        return genericTypeAnnotation(identifier$a("Promise"));
	      }
	    } else {
	      if (callee.node.returnType) {
	        return callee.node.returnType;
	      }
	    }
	  }
	}

	var inferers = /*#__PURE__*/Object.freeze({
		__proto__: null,
		VariableDeclarator: VariableDeclarator,
		TypeCastExpression: TypeCastExpression,
		NewExpression: NewExpression,
		TemplateLiteral: TemplateLiteral,
		UnaryExpression: UnaryExpression,
		BinaryExpression: BinaryExpression,
		LogicalExpression: LogicalExpression,
		ConditionalExpression: ConditionalExpression,
		SequenceExpression: SequenceExpression,
		ParenthesizedExpression: ParenthesizedExpression,
		AssignmentExpression: AssignmentExpression,
		UpdateExpression: UpdateExpression,
		StringLiteral: StringLiteral$1,
		NumericLiteral: NumericLiteral$1,
		BooleanLiteral: BooleanLiteral,
		NullLiteral: NullLiteral,
		RegExpLiteral: RegExpLiteral,
		ObjectExpression: ObjectExpression,
		ArrayExpression: ArrayExpression,
		RestElement: RestElement,
		FunctionExpression: Func,
		ArrowFunctionExpression: Func,
		FunctionDeclaration: Func,
		ClassExpression: Func,
		ClassDeclaration: Func,
		CallExpression: CallExpression,
		TaggedTemplateExpression: TaggedTemplateExpression,
		Identifier: infererReference
	});

	const {
	  anyTypeAnnotation,
	  isAnyTypeAnnotation,
	  isBooleanTypeAnnotation,
	  isEmptyTypeAnnotation,
	  isFlowBaseAnnotation,
	  isGenericTypeAnnotation,
	  isIdentifier: isIdentifier$6,
	  isMixedTypeAnnotation,
	  isNumberTypeAnnotation,
	  isStringTypeAnnotation,
	  isTypeAnnotation,
	  isUnionTypeAnnotation,
	  isVoidTypeAnnotation,
	  stringTypeAnnotation,
	  voidTypeAnnotation
	} = _t;
	function getTypeAnnotation() {
	  if (this.typeAnnotation) return this.typeAnnotation;
	  let type = this._getTypeAnnotation() || anyTypeAnnotation();
	  if (isTypeAnnotation(type)) type = type.typeAnnotation;
	  return this.typeAnnotation = type;
	}
	const typeAnnotationInferringNodes = new WeakSet();
	function _getTypeAnnotation() {
	  const node = this.node;

	  if (!node) {
	    if (this.key === "init" && this.parentPath.isVariableDeclarator()) {
	      const declar = this.parentPath.parentPath;
	      const declarParent = declar.parentPath;

	      if (declar.key === "left" && declarParent.isForInStatement()) {
	        return stringTypeAnnotation();
	      }

	      if (declar.key === "left" && declarParent.isForOfStatement()) {
	        return anyTypeAnnotation();
	      }

	      return voidTypeAnnotation();
	    } else {
	      return;
	    }
	  }

	  if (node.typeAnnotation) {
	    return node.typeAnnotation;
	  }

	  if (typeAnnotationInferringNodes.has(node)) {
	    return;
	  }

	  typeAnnotationInferringNodes.add(node);

	  try {
	    let inferer = inferers[node.type];

	    if (inferer) {
	      return inferer.call(this, node);
	    }

	    inferer = inferers[this.parentPath.type];

	    if (inferer?.validParent) {
	      return this.parentPath.getTypeAnnotation();
	    }
	  } finally {
	    typeAnnotationInferringNodes.delete(node);
	  }
	}
	function isBaseType(baseName, soft) {
	  return _isBaseType(baseName, this.getTypeAnnotation(), soft);
	}

	function _isBaseType(baseName, type, soft) {
	  if (baseName === "string") {
	    return isStringTypeAnnotation(type);
	  } else if (baseName === "number") {
	    return isNumberTypeAnnotation(type);
	  } else if (baseName === "boolean") {
	    return isBooleanTypeAnnotation(type);
	  } else if (baseName === "any") {
	    return isAnyTypeAnnotation(type);
	  } else if (baseName === "mixed") {
	    return isMixedTypeAnnotation(type);
	  } else if (baseName === "empty") {
	    return isEmptyTypeAnnotation(type);
	  } else if (baseName === "void") {
	    return isVoidTypeAnnotation(type);
	  } else {
	    if (soft) {
	      return false;
	    } else {
	      throw new Error(`Unknown base type ${baseName}`);
	    }
	  }
	}

	function couldBeBaseType(name) {
	  const type = this.getTypeAnnotation();
	  if (isAnyTypeAnnotation(type)) return true;

	  if (isUnionTypeAnnotation(type)) {
	    for (const type2 of type.types) {
	      if (isAnyTypeAnnotation(type2) || _isBaseType(name, type2, true)) {
	        return true;
	      }
	    }

	    return false;
	  } else {
	    return _isBaseType(name, type, true);
	  }
	}
	function baseTypeStrictlyMatches(rightArg) {
	  const left = this.getTypeAnnotation();
	  const right = rightArg.getTypeAnnotation();

	  if (!isAnyTypeAnnotation(left) && isFlowBaseAnnotation(left)) {
	    return right.type === left.type;
	  }

	  return false;
	}
	function isGenericType(genericName) {
	  const type = this.getTypeAnnotation();
	  return isGenericTypeAnnotation(type) && isIdentifier$6(type.id, {
	    name: genericName
	  });
	}

	var NodePath_inference = /*#__PURE__*/Object.freeze({
		__proto__: null,
		getTypeAnnotation: getTypeAnnotation,
		_getTypeAnnotation: _getTypeAnnotation,
		isBaseType: isBaseType,
		couldBeBaseType: couldBeBaseType,
		baseTypeStrictlyMatches: baseTypeStrictlyMatches,
		isGenericType: isGenericType
	});

	var IdentifierName, JSXIdentifier, JSXPunctuator, JSXString, JSXText, KeywordsWithExpressionAfter, KeywordsWithNoLineTerminatorAfter, LineTerminatorSequence, MultiLineComment, Newline, NumericLiteral, Punctuator, RegularExpressionLiteral, SingleLineComment, StringLiteral, Template, TokensNotPrecedingObjectLiteral, TokensPrecedingExpression, WhiteSpace;
	RegularExpressionLiteral = /\/(?![*\/])(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)*(\/[$_\u200C\u200D\p{ID_Continue}]*|\\)?/yu;
	Punctuator = /--|\+\+|=>|\.{3}|\??\.(?!\d)|(?:&&|\|\||\?\?|[+\-%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2}|\/(?![\/*]))=?|[?~,:;[\](){}]/y;
	IdentifierName = /(?=[$_\p{ID_Start}\\])(?:[$_\u200C\u200D\p{ID_Continue}]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+/yu;
	StringLiteral = /(['"])(?:(?!\1)[^\\\n\r]|\\(?:\r\n|[^]))*(\1)?/y;
	NumericLiteral = /(?:0[xX][\da-fA-F](?:_?[\da-fA-F])*|0[oO][0-7](?:_?[0-7])*|0[bB][01](?:_?[01])*)n?|0n|[1-9](?:_?\d)*n|(?:(?:0(?!\d)|0\d*[89]\d*|[1-9](?:_?\d)*)(?:\.(?:\d(?:_?\d)*)?)?|\.\d(?:_?\d)*)(?:[eE][+-]?\d(?:_?\d)*)?|0[0-7]+/y;
	Template = /[`}](?:[^`\\$]|\\[^]|\$(?!\{))*(`|\$\{)?/y;
	WhiteSpace = /[\t\v\f\ufeff\p{Zs}]+/yu;
	LineTerminatorSequence = /\r?\n|[\r\u2028\u2029]/y;
	MultiLineComment = /\/\*(?:[^*]|\*(?!\/))*(\*\/)?/y;
	SingleLineComment = /\/\/.*/y;
	JSXPunctuator = /[<>.:={}]|\/(?![\/*])/y;
	JSXIdentifier = /[$_\p{ID_Start}][$_\u200C\u200D\p{ID_Continue}-]*/yu;
	JSXString = /(['"])(?:(?!\1)[^])*(\1)?/y;
	JSXText = /[^<>{}]+/y;
	TokensPrecedingExpression = /^(?:[\/+-]|\.{3}|\?(?:InterpolationIn(?:JSX|Template)|NoLineTerminatorHere|NonExpressionParenEnd|UnaryIncDec))?$|[{}([,;<>=*%&|^!~?:]$/;
	TokensNotPrecedingObjectLiteral = /^(?:=>|[;\]){}]|else|\?(?:NoLineTerminatorHere|NonExpressionParenEnd))?$/;
	KeywordsWithExpressionAfter = /^(?:await|case|default|delete|do|else|instanceof|new|return|throw|typeof|void|yield)$/;
	KeywordsWithNoLineTerminatorAfter = /^(?:return|throw|yield)$/;
	Newline = RegExp(LineTerminatorSequence.source);

	var jsTokensBABEL_8_BREAKINGTrue = function* (input, {
	  jsx = false
	} = {}) {
	  var braces, firstCodePoint, isExpression, lastIndex, lastSignificantToken, length, match, mode, nextLastIndex, nextLastSignificantToken, parenNesting, postfixIncDec, punctuator, stack;
	  ({
	    length
	  } = input);
	  lastIndex = 0;
	  lastSignificantToken = "";
	  stack = [{
	    tag: "JS"
	  }];
	  braces = [];
	  parenNesting = 0;
	  postfixIncDec = false;

	  while (lastIndex < length) {
	    mode = stack[stack.length - 1];

	    switch (mode.tag) {
	      case "JS":
	      case "JSNonExpressionParen":
	      case "InterpolationInTemplate":
	      case "InterpolationInJSX":
	        if (input[lastIndex] === "/" && (TokensPrecedingExpression.test(lastSignificantToken) || KeywordsWithExpressionAfter.test(lastSignificantToken))) {
	          RegularExpressionLiteral.lastIndex = lastIndex;

	          if (match = RegularExpressionLiteral.exec(input)) {
	            lastIndex = RegularExpressionLiteral.lastIndex;
	            lastSignificantToken = match[0];
	            postfixIncDec = true;
	            yield {
	              type: "RegularExpressionLiteral",
	              value: match[0],
	              closed: match[1] !== void 0 && match[1] !== "\\"
	            };
	            continue;
	          }
	        }

	        Punctuator.lastIndex = lastIndex;

	        if (match = Punctuator.exec(input)) {
	          punctuator = match[0];
	          nextLastIndex = Punctuator.lastIndex;
	          nextLastSignificantToken = punctuator;

	          switch (punctuator) {
	            case "(":
	              if (lastSignificantToken === "?NonExpressionParenKeyword") {
	                stack.push({
	                  tag: "JSNonExpressionParen",
	                  nesting: parenNesting
	                });
	              }

	              parenNesting++;
	              postfixIncDec = false;
	              break;

	            case ")":
	              parenNesting--;
	              postfixIncDec = true;

	              if (mode.tag === "JSNonExpressionParen" && parenNesting === mode.nesting) {
	                stack.pop();
	                nextLastSignificantToken = "?NonExpressionParenEnd";
	                postfixIncDec = false;
	              }

	              break;

	            case "{":
	              Punctuator.lastIndex = 0;
	              isExpression = !TokensNotPrecedingObjectLiteral.test(lastSignificantToken) && (TokensPrecedingExpression.test(lastSignificantToken) || KeywordsWithExpressionAfter.test(lastSignificantToken));
	              braces.push(isExpression);
	              postfixIncDec = false;
	              break;

	            case "}":
	              switch (mode.tag) {
	                case "InterpolationInTemplate":
	                  if (braces.length === mode.nesting) {
	                    Template.lastIndex = lastIndex;
	                    match = Template.exec(input);
	                    lastIndex = Template.lastIndex;
	                    lastSignificantToken = match[0];

	                    if (match[1] === "${") {
	                      lastSignificantToken = "?InterpolationInTemplate";
	                      postfixIncDec = false;
	                      yield {
	                        type: "TemplateMiddle",
	                        value: match[0]
	                      };
	                    } else {
	                      stack.pop();
	                      postfixIncDec = true;
	                      yield {
	                        type: "TemplateTail",
	                        value: match[0],
	                        closed: match[1] === "`"
	                      };
	                    }

	                    continue;
	                  }

	                  break;

	                case "InterpolationInJSX":
	                  if (braces.length === mode.nesting) {
	                    stack.pop();
	                    lastIndex += 1;
	                    lastSignificantToken = "}";
	                    yield {
	                      type: "JSXPunctuator",
	                      value: "}"
	                    };
	                    continue;
	                  }

	              }

	              postfixIncDec = braces.pop();
	              nextLastSignificantToken = postfixIncDec ? "?ExpressionBraceEnd" : "}";
	              break;

	            case "]":
	              postfixIncDec = true;
	              break;

	            case "++":
	            case "--":
	              nextLastSignificantToken = postfixIncDec ? "?PostfixIncDec" : "?UnaryIncDec";
	              break;

	            case "<":
	              if (jsx && (TokensPrecedingExpression.test(lastSignificantToken) || KeywordsWithExpressionAfter.test(lastSignificantToken))) {
	                stack.push({
	                  tag: "JSXTag"
	                });
	                lastIndex += 1;
	                lastSignificantToken = "<";
	                yield {
	                  type: "JSXPunctuator",
	                  value: punctuator
	                };
	                continue;
	              }

	              postfixIncDec = false;
	              break;

	            default:
	              postfixIncDec = false;
	          }

	          lastIndex = nextLastIndex;
	          lastSignificantToken = nextLastSignificantToken;
	          yield {
	            type: "Punctuator",
	            value: punctuator
	          };
	          continue;
	        }

	        IdentifierName.lastIndex = lastIndex;

	        if (match = IdentifierName.exec(input)) {
	          lastIndex = IdentifierName.lastIndex;
	          nextLastSignificantToken = match[0];

	          switch (match[0]) {
	            case "for":
	            case "if":
	            case "while":
	            case "with":
	              if (lastSignificantToken !== "." && lastSignificantToken !== "?.") {
	                nextLastSignificantToken = "?NonExpressionParenKeyword";
	              }

	          }

	          lastSignificantToken = nextLastSignificantToken;
	          postfixIncDec = !KeywordsWithExpressionAfter.test(match[0]);
	          yield {
	            type: "IdentifierName",
	            value: match[0]
	          };
	          continue;
	        }

	        StringLiteral.lastIndex = lastIndex;

	        if (match = StringLiteral.exec(input)) {
	          lastIndex = StringLiteral.lastIndex;
	          lastSignificantToken = match[0];
	          postfixIncDec = true;
	          yield {
	            type: "StringLiteral",
	            value: match[0],
	            closed: match[2] !== void 0
	          };
	          continue;
	        }

	        NumericLiteral.lastIndex = lastIndex;

	        if (match = NumericLiteral.exec(input)) {
	          lastIndex = NumericLiteral.lastIndex;
	          lastSignificantToken = match[0];
	          postfixIncDec = true;
	          yield {
	            type: "NumericLiteral",
	            value: match[0]
	          };
	          continue;
	        }

	        Template.lastIndex = lastIndex;

	        if (match = Template.exec(input)) {
	          lastIndex = Template.lastIndex;
	          lastSignificantToken = match[0];

	          if (match[1] === "${") {
	            lastSignificantToken = "?InterpolationInTemplate";
	            stack.push({
	              tag: "InterpolationInTemplate",
	              nesting: braces.length
	            });
	            postfixIncDec = false;
	            yield {
	              type: "TemplateHead",
	              value: match[0]
	            };
	          } else {
	            postfixIncDec = true;
	            yield {
	              type: "NoSubstitutionTemplate",
	              value: match[0],
	              closed: match[1] === "`"
	            };
	          }

	          continue;
	        }

	        break;

	      case "JSXTag":
	      case "JSXTagEnd":
	        JSXPunctuator.lastIndex = lastIndex;

	        if (match = JSXPunctuator.exec(input)) {
	          lastIndex = JSXPunctuator.lastIndex;
	          nextLastSignificantToken = match[0];

	          switch (match[0]) {
	            case "<":
	              stack.push({
	                tag: "JSXTag"
	              });
	              break;

	            case ">":
	              stack.pop();

	              if (lastSignificantToken === "/" || mode.tag === "JSXTagEnd") {
	                nextLastSignificantToken = "?JSX";
	                postfixIncDec = true;
	              } else {
	                stack.push({
	                  tag: "JSXChildren"
	                });
	              }

	              break;

	            case "{":
	              stack.push({
	                tag: "InterpolationInJSX",
	                nesting: braces.length
	              });
	              nextLastSignificantToken = "?InterpolationInJSX";
	              postfixIncDec = false;
	              break;

	            case "/":
	              if (lastSignificantToken === "<") {
	                stack.pop();

	                if (stack[stack.length - 1].tag === "JSXChildren") {
	                  stack.pop();
	                }

	                stack.push({
	                  tag: "JSXTagEnd"
	                });
	              }

	          }

	          lastSignificantToken = nextLastSignificantToken;
	          yield {
	            type: "JSXPunctuator",
	            value: match[0]
	          };
	          continue;
	        }

	        JSXIdentifier.lastIndex = lastIndex;

	        if (match = JSXIdentifier.exec(input)) {
	          lastIndex = JSXIdentifier.lastIndex;
	          lastSignificantToken = match[0];
	          yield {
	            type: "JSXIdentifier",
	            value: match[0]
	          };
	          continue;
	        }

	        JSXString.lastIndex = lastIndex;

	        if (match = JSXString.exec(input)) {
	          lastIndex = JSXString.lastIndex;
	          lastSignificantToken = match[0];
	          yield {
	            type: "JSXString",
	            value: match[0],
	            closed: match[2] !== void 0
	          };
	          continue;
	        }

	        break;

	      case "JSXChildren":
	        JSXText.lastIndex = lastIndex;

	        if (match = JSXText.exec(input)) {
	          lastIndex = JSXText.lastIndex;
	          lastSignificantToken = match[0];
	          yield {
	            type: "JSXText",
	            value: match[0]
	          };
	          continue;
	        }

	        switch (input[lastIndex]) {
	          case "<":
	            stack.push({
	              tag: "JSXTag"
	            });
	            lastIndex++;
	            lastSignificantToken = "<";
	            yield {
	              type: "JSXPunctuator",
	              value: "<"
	            };
	            continue;

	          case "{":
	            stack.push({
	              tag: "InterpolationInJSX",
	              nesting: braces.length
	            });
	            lastIndex++;
	            lastSignificantToken = "?InterpolationInJSX";
	            postfixIncDec = false;
	            yield {
	              type: "JSXPunctuator",
	              value: "{"
	            };
	            continue;
	        }

	    }

	    WhiteSpace.lastIndex = lastIndex;

	    if (match = WhiteSpace.exec(input)) {
	      lastIndex = WhiteSpace.lastIndex;
	      yield {
	        type: "WhiteSpace",
	        value: match[0]
	      };
	      continue;
	    }

	    LineTerminatorSequence.lastIndex = lastIndex;

	    if (match = LineTerminatorSequence.exec(input)) {
	      lastIndex = LineTerminatorSequence.lastIndex;
	      postfixIncDec = false;

	      if (KeywordsWithNoLineTerminatorAfter.test(lastSignificantToken)) {
	        lastSignificantToken = "?NoLineTerminatorHere";
	      }

	      yield {
	        type: "LineTerminatorSequence",
	        value: match[0]
	      };
	      continue;
	    }

	    MultiLineComment.lastIndex = lastIndex;

	    if (match = MultiLineComment.exec(input)) {
	      lastIndex = MultiLineComment.lastIndex;

	      if (Newline.test(match[0])) {
	        postfixIncDec = false;

	        if (KeywordsWithNoLineTerminatorAfter.test(lastSignificantToken)) {
	          lastSignificantToken = "?NoLineTerminatorHere";
	        }
	      }

	      yield {
	        type: "MultiLineComment",
	        value: match[0],
	        closed: match[1] !== void 0
	      };
	      continue;
	    }

	    SingleLineComment.lastIndex = lastIndex;

	    if (match = SingleLineComment.exec(input)) {
	      lastIndex = SingleLineComment.lastIndex;
	      postfixIncDec = false;
	      yield {
	        type: "SingleLineComment",
	        value: match[0]
	      };
	      continue;
	    }

	    firstCodePoint = String.fromCodePoint(input.codePointAt(lastIndex));
	    lastIndex += firstCodePoint.length;
	    lastSignificantToken = firstCodePoint;
	    postfixIncDec = false;
	    yield {
	      type: mode.tag.startsWith("JSX") ? "JSXInvalid" : "Invalid",
	      value: firstCodePoint
	    };
	  }

	  return void 0;
	};

	var _default = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;

	var matchToToken = function (match) {
	  var token = {
	    type: "invalid",
	    value: match[0],
	    closed: undefined
	  };
	  if (match[1]) token.type = "string", token.closed = !!(match[3] || match[4]);else if (match[5]) token.type = "comment";else if (match[6]) token.type = "comment", token.closed = !!match[7];else if (match[8]) token.type = "regex";else if (match[9]) token.type = "number";else if (match[10]) token.type = "name";else if (match[11]) token.type = "punctuator";else if (match[12]) token.type = "whitespace";
	  return token;
	};

	var jsTokensBABEL_8_BREAKINGFalse = Object.defineProperty({
	  default: _default,
	  matchToToken: matchToToken
	}, '__esModule', {
	  value: true
	});

	function bool$2(value) {
	  if (value == null) return false;
	  return value && value !== "false" && value !== "0";
	}

	var jsTokens = bool$2(browser$5.env["BABEL_8_BREAKING"]) ? jsTokensBABEL_8_BREAKINGTrue : jsTokensBABEL_8_BREAKINGFalse;

	var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;

	var escapeStringRegexp = function (str) {
	  if (typeof str !== 'string') {
	    throw new TypeError('Expected a string');
	  }

	  return str.replace(matchOperatorsRe, '\\$&');
	};

	var colorName = {
	  "aliceblue": [240, 248, 255],
	  "antiquewhite": [250, 235, 215],
	  "aqua": [0, 255, 255],
	  "aquamarine": [127, 255, 212],
	  "azure": [240, 255, 255],
	  "beige": [245, 245, 220],
	  "bisque": [255, 228, 196],
	  "black": [0, 0, 0],
	  "blanchedalmond": [255, 235, 205],
	  "blue": [0, 0, 255],
	  "blueviolet": [138, 43, 226],
	  "brown": [165, 42, 42],
	  "burlywood": [222, 184, 135],
	  "cadetblue": [95, 158, 160],
	  "chartreuse": [127, 255, 0],
	  "chocolate": [210, 105, 30],
	  "coral": [255, 127, 80],
	  "cornflowerblue": [100, 149, 237],
	  "cornsilk": [255, 248, 220],
	  "crimson": [220, 20, 60],
	  "cyan": [0, 255, 255],
	  "darkblue": [0, 0, 139],
	  "darkcyan": [0, 139, 139],
	  "darkgoldenrod": [184, 134, 11],
	  "darkgray": [169, 169, 169],
	  "darkgreen": [0, 100, 0],
	  "darkgrey": [169, 169, 169],
	  "darkkhaki": [189, 183, 107],
	  "darkmagenta": [139, 0, 139],
	  "darkolivegreen": [85, 107, 47],
	  "darkorange": [255, 140, 0],
	  "darkorchid": [153, 50, 204],
	  "darkred": [139, 0, 0],
	  "darksalmon": [233, 150, 122],
	  "darkseagreen": [143, 188, 143],
	  "darkslateblue": [72, 61, 139],
	  "darkslategray": [47, 79, 79],
	  "darkslategrey": [47, 79, 79],
	  "darkturquoise": [0, 206, 209],
	  "darkviolet": [148, 0, 211],
	  "deeppink": [255, 20, 147],
	  "deepskyblue": [0, 191, 255],
	  "dimgray": [105, 105, 105],
	  "dimgrey": [105, 105, 105],
	  "dodgerblue": [30, 144, 255],
	  "firebrick": [178, 34, 34],
	  "floralwhite": [255, 250, 240],
	  "forestgreen": [34, 139, 34],
	  "fuchsia": [255, 0, 255],
	  "gainsboro": [220, 220, 220],
	  "ghostwhite": [248, 248, 255],
	  "gold": [255, 215, 0],
	  "goldenrod": [218, 165, 32],
	  "gray": [128, 128, 128],
	  "green": [0, 128, 0],
	  "greenyellow": [173, 255, 47],
	  "grey": [128, 128, 128],
	  "honeydew": [240, 255, 240],
	  "hotpink": [255, 105, 180],
	  "indianred": [205, 92, 92],
	  "indigo": [75, 0, 130],
	  "ivory": [255, 255, 240],
	  "khaki": [240, 230, 140],
	  "lavender": [230, 230, 250],
	  "lavenderblush": [255, 240, 245],
	  "lawngreen": [124, 252, 0],
	  "lemonchiffon": [255, 250, 205],
	  "lightblue": [173, 216, 230],
	  "lightcoral": [240, 128, 128],
	  "lightcyan": [224, 255, 255],
	  "lightgoldenrodyellow": [250, 250, 210],
	  "lightgray": [211, 211, 211],
	  "lightgreen": [144, 238, 144],
	  "lightgrey": [211, 211, 211],
	  "lightpink": [255, 182, 193],
	  "lightsalmon": [255, 160, 122],
	  "lightseagreen": [32, 178, 170],
	  "lightskyblue": [135, 206, 250],
	  "lightslategray": [119, 136, 153],
	  "lightslategrey": [119, 136, 153],
	  "lightsteelblue": [176, 196, 222],
	  "lightyellow": [255, 255, 224],
	  "lime": [0, 255, 0],
	  "limegreen": [50, 205, 50],
	  "linen": [250, 240, 230],
	  "magenta": [255, 0, 255],
	  "maroon": [128, 0, 0],
	  "mediumaquamarine": [102, 205, 170],
	  "mediumblue": [0, 0, 205],
	  "mediumorchid": [186, 85, 211],
	  "mediumpurple": [147, 112, 219],
	  "mediumseagreen": [60, 179, 113],
	  "mediumslateblue": [123, 104, 238],
	  "mediumspringgreen": [0, 250, 154],
	  "mediumturquoise": [72, 209, 204],
	  "mediumvioletred": [199, 21, 133],
	  "midnightblue": [25, 25, 112],
	  "mintcream": [245, 255, 250],
	  "mistyrose": [255, 228, 225],
	  "moccasin": [255, 228, 181],
	  "navajowhite": [255, 222, 173],
	  "navy": [0, 0, 128],
	  "oldlace": [253, 245, 230],
	  "olive": [128, 128, 0],
	  "olivedrab": [107, 142, 35],
	  "orange": [255, 165, 0],
	  "orangered": [255, 69, 0],
	  "orchid": [218, 112, 214],
	  "palegoldenrod": [238, 232, 170],
	  "palegreen": [152, 251, 152],
	  "paleturquoise": [175, 238, 238],
	  "palevioletred": [219, 112, 147],
	  "papayawhip": [255, 239, 213],
	  "peachpuff": [255, 218, 185],
	  "peru": [205, 133, 63],
	  "pink": [255, 192, 203],
	  "plum": [221, 160, 221],
	  "powderblue": [176, 224, 230],
	  "purple": [128, 0, 128],
	  "rebeccapurple": [102, 51, 153],
	  "red": [255, 0, 0],
	  "rosybrown": [188, 143, 143],
	  "royalblue": [65, 105, 225],
	  "saddlebrown": [139, 69, 19],
	  "salmon": [250, 128, 114],
	  "sandybrown": [244, 164, 96],
	  "seagreen": [46, 139, 87],
	  "seashell": [255, 245, 238],
	  "sienna": [160, 82, 45],
	  "silver": [192, 192, 192],
	  "skyblue": [135, 206, 235],
	  "slateblue": [106, 90, 205],
	  "slategray": [112, 128, 144],
	  "slategrey": [112, 128, 144],
	  "snow": [255, 250, 250],
	  "springgreen": [0, 255, 127],
	  "steelblue": [70, 130, 180],
	  "tan": [210, 180, 140],
	  "teal": [0, 128, 128],
	  "thistle": [216, 191, 216],
	  "tomato": [255, 99, 71],
	  "turquoise": [64, 224, 208],
	  "violet": [238, 130, 238],
	  "wheat": [245, 222, 179],
	  "white": [255, 255, 255],
	  "whitesmoke": [245, 245, 245],
	  "yellow": [255, 255, 0],
	  "yellowgreen": [154, 205, 50]
	};

	var conversions = createCommonjsModule(function (module) {
	  var reverseKeywords = {};

	  for (var key in colorName) {
	    if (colorName.hasOwnProperty(key)) {
	      reverseKeywords[colorName[key]] = key;
	    }
	  }

	  var convert = module.exports = {
	    rgb: {
	      channels: 3,
	      labels: 'rgb'
	    },
	    hsl: {
	      channels: 3,
	      labels: 'hsl'
	    },
	    hsv: {
	      channels: 3,
	      labels: 'hsv'
	    },
	    hwb: {
	      channels: 3,
	      labels: 'hwb'
	    },
	    cmyk: {
	      channels: 4,
	      labels: 'cmyk'
	    },
	    xyz: {
	      channels: 3,
	      labels: 'xyz'
	    },
	    lab: {
	      channels: 3,
	      labels: 'lab'
	    },
	    lch: {
	      channels: 3,
	      labels: 'lch'
	    },
	    hex: {
	      channels: 1,
	      labels: ['hex']
	    },
	    keyword: {
	      channels: 1,
	      labels: ['keyword']
	    },
	    ansi16: {
	      channels: 1,
	      labels: ['ansi16']
	    },
	    ansi256: {
	      channels: 1,
	      labels: ['ansi256']
	    },
	    hcg: {
	      channels: 3,
	      labels: ['h', 'c', 'g']
	    },
	    apple: {
	      channels: 3,
	      labels: ['r16', 'g16', 'b16']
	    },
	    gray: {
	      channels: 1,
	      labels: ['gray']
	    }
	  };

	  for (var model in convert) {
	    if (convert.hasOwnProperty(model)) {
	      if (!('channels' in convert[model])) {
	        throw new Error('missing channels property: ' + model);
	      }

	      if (!('labels' in convert[model])) {
	        throw new Error('missing channel labels property: ' + model);
	      }

	      if (convert[model].labels.length !== convert[model].channels) {
	        throw new Error('channel and label counts mismatch: ' + model);
	      }

	      var channels = convert[model].channels;
	      var labels = convert[model].labels;
	      delete convert[model].channels;
	      delete convert[model].labels;
	      Object.defineProperty(convert[model], 'channels', {
	        value: channels
	      });
	      Object.defineProperty(convert[model], 'labels', {
	        value: labels
	      });
	    }
	  }

	  convert.rgb.hsl = function (rgb) {
	    var r = rgb[0] / 255;
	    var g = rgb[1] / 255;
	    var b = rgb[2] / 255;
	    var min = Math.min(r, g, b);
	    var max = Math.max(r, g, b);
	    var delta = max - min;
	    var h;
	    var s;
	    var l;

	    if (max === min) {
	      h = 0;
	    } else if (r === max) {
	      h = (g - b) / delta;
	    } else if (g === max) {
	      h = 2 + (b - r) / delta;
	    } else if (b === max) {
	      h = 4 + (r - g) / delta;
	    }

	    h = Math.min(h * 60, 360);

	    if (h < 0) {
	      h += 360;
	    }

	    l = (min + max) / 2;

	    if (max === min) {
	      s = 0;
	    } else if (l <= 0.5) {
	      s = delta / (max + min);
	    } else {
	      s = delta / (2 - max - min);
	    }

	    return [h, s * 100, l * 100];
	  };

	  convert.rgb.hsv = function (rgb) {
	    var rdif;
	    var gdif;
	    var bdif;
	    var h;
	    var s;
	    var r = rgb[0] / 255;
	    var g = rgb[1] / 255;
	    var b = rgb[2] / 255;
	    var v = Math.max(r, g, b);
	    var diff = v - Math.min(r, g, b);

	    var diffc = function (c) {
	      return (v - c) / 6 / diff + 1 / 2;
	    };

	    if (diff === 0) {
	      h = s = 0;
	    } else {
	      s = diff / v;
	      rdif = diffc(r);
	      gdif = diffc(g);
	      bdif = diffc(b);

	      if (r === v) {
	        h = bdif - gdif;
	      } else if (g === v) {
	        h = 1 / 3 + rdif - bdif;
	      } else if (b === v) {
	        h = 2 / 3 + gdif - rdif;
	      }

	      if (h < 0) {
	        h += 1;
	      } else if (h > 1) {
	        h -= 1;
	      }
	    }

	    return [h * 360, s * 100, v * 100];
	  };

	  convert.rgb.hwb = function (rgb) {
	    var r = rgb[0];
	    var g = rgb[1];
	    var b = rgb[2];
	    var h = convert.rgb.hsl(rgb)[0];
	    var w = 1 / 255 * Math.min(r, Math.min(g, b));
	    b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));
	    return [h, w * 100, b * 100];
	  };

	  convert.rgb.cmyk = function (rgb) {
	    var r = rgb[0] / 255;
	    var g = rgb[1] / 255;
	    var b = rgb[2] / 255;
	    var c;
	    var m;
	    var y;
	    var k;
	    k = Math.min(1 - r, 1 - g, 1 - b);
	    c = (1 - r - k) / (1 - k) || 0;
	    m = (1 - g - k) / (1 - k) || 0;
	    y = (1 - b - k) / (1 - k) || 0;
	    return [c * 100, m * 100, y * 100, k * 100];
	  };

	  function comparativeDistance(x, y) {
	    return Math.pow(x[0] - y[0], 2) + Math.pow(x[1] - y[1], 2) + Math.pow(x[2] - y[2], 2);
	  }

	  convert.rgb.keyword = function (rgb) {
	    var reversed = reverseKeywords[rgb];

	    if (reversed) {
	      return reversed;
	    }

	    var currentClosestDistance = Infinity;
	    var currentClosestKeyword;

	    for (var keyword in colorName) {
	      if (colorName.hasOwnProperty(keyword)) {
	        var value = colorName[keyword];
	        var distance = comparativeDistance(rgb, value);

	        if (distance < currentClosestDistance) {
	          currentClosestDistance = distance;
	          currentClosestKeyword = keyword;
	        }
	      }
	    }

	    return currentClosestKeyword;
	  };

	  convert.keyword.rgb = function (keyword) {
	    return colorName[keyword];
	  };

	  convert.rgb.xyz = function (rgb) {
	    var r = rgb[0] / 255;
	    var g = rgb[1] / 255;
	    var b = rgb[2] / 255;
	    r = r > 0.04045 ? Math.pow((r + 0.055) / 1.055, 2.4) : r / 12.92;
	    g = g > 0.04045 ? Math.pow((g + 0.055) / 1.055, 2.4) : g / 12.92;
	    b = b > 0.04045 ? Math.pow((b + 0.055) / 1.055, 2.4) : b / 12.92;
	    var x = r * 0.4124 + g * 0.3576 + b * 0.1805;
	    var y = r * 0.2126 + g * 0.7152 + b * 0.0722;
	    var z = r * 0.0193 + g * 0.1192 + b * 0.9505;
	    return [x * 100, y * 100, z * 100];
	  };

	  convert.rgb.lab = function (rgb) {
	    var xyz = convert.rgb.xyz(rgb);
	    var x = xyz[0];
	    var y = xyz[1];
	    var z = xyz[2];
	    var l;
	    var a;
	    var b;
	    x /= 95.047;
	    y /= 100;
	    z /= 108.883;
	    x = x > 0.008856 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
	    y = y > 0.008856 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
	    z = z > 0.008856 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
	    l = 116 * y - 16;
	    a = 500 * (x - y);
	    b = 200 * (y - z);
	    return [l, a, b];
	  };

	  convert.hsl.rgb = function (hsl) {
	    var h = hsl[0] / 360;
	    var s = hsl[1] / 100;
	    var l = hsl[2] / 100;
	    var t1;
	    var t2;
	    var t3;
	    var rgb;
	    var val;

	    if (s === 0) {
	      val = l * 255;
	      return [val, val, val];
	    }

	    if (l < 0.5) {
	      t2 = l * (1 + s);
	    } else {
	      t2 = l + s - l * s;
	    }

	    t1 = 2 * l - t2;
	    rgb = [0, 0, 0];

	    for (var i = 0; i < 3; i++) {
	      t3 = h + 1 / 3 * -(i - 1);

	      if (t3 < 0) {
	        t3++;
	      }

	      if (t3 > 1) {
	        t3--;
	      }

	      if (6 * t3 < 1) {
	        val = t1 + (t2 - t1) * 6 * t3;
	      } else if (2 * t3 < 1) {
	        val = t2;
	      } else if (3 * t3 < 2) {
	        val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
	      } else {
	        val = t1;
	      }

	      rgb[i] = val * 255;
	    }

	    return rgb;
	  };

	  convert.hsl.hsv = function (hsl) {
	    var h = hsl[0];
	    var s = hsl[1] / 100;
	    var l = hsl[2] / 100;
	    var smin = s;
	    var lmin = Math.max(l, 0.01);
	    var sv;
	    var v;
	    l *= 2;
	    s *= l <= 1 ? l : 2 - l;
	    smin *= lmin <= 1 ? lmin : 2 - lmin;
	    v = (l + s) / 2;
	    sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l + s);
	    return [h, sv * 100, v * 100];
	  };

	  convert.hsv.rgb = function (hsv) {
	    var h = hsv[0] / 60;
	    var s = hsv[1] / 100;
	    var v = hsv[2] / 100;
	    var hi = Math.floor(h) % 6;
	    var f = h - Math.floor(h);
	    var p = 255 * v * (1 - s);
	    var q = 255 * v * (1 - s * f);
	    var t = 255 * v * (1 - s * (1 - f));
	    v *= 255;

	    switch (hi) {
	      case 0:
	        return [v, t, p];

	      case 1:
	        return [q, v, p];

	      case 2:
	        return [p, v, t];

	      case 3:
	        return [p, q, v];

	      case 4:
	        return [t, p, v];

	      case 5:
	        return [v, p, q];
	    }
	  };

	  convert.hsv.hsl = function (hsv) {
	    var h = hsv[0];
	    var s = hsv[1] / 100;
	    var v = hsv[2] / 100;
	    var vmin = Math.max(v, 0.01);
	    var lmin;
	    var sl;
	    var l;
	    l = (2 - s) * v;
	    lmin = (2 - s) * vmin;
	    sl = s * vmin;
	    sl /= lmin <= 1 ? lmin : 2 - lmin;
	    sl = sl || 0;
	    l /= 2;
	    return [h, sl * 100, l * 100];
	  };

	  convert.hwb.rgb = function (hwb) {
	    var h = hwb[0] / 360;
	    var wh = hwb[1] / 100;
	    var bl = hwb[2] / 100;
	    var ratio = wh + bl;
	    var i;
	    var v;
	    var f;
	    var n;

	    if (ratio > 1) {
	      wh /= ratio;
	      bl /= ratio;
	    }

	    i = Math.floor(6 * h);
	    v = 1 - bl;
	    f = 6 * h - i;

	    if ((i & 0x01) !== 0) {
	      f = 1 - f;
	    }

	    n = wh + f * (v - wh);
	    var r;
	    var g;
	    var b;

	    switch (i) {
	      default:
	      case 6:
	      case 0:
	        r = v;
	        g = n;
	        b = wh;
	        break;

	      case 1:
	        r = n;
	        g = v;
	        b = wh;
	        break;

	      case 2:
	        r = wh;
	        g = v;
	        b = n;
	        break;

	      case 3:
	        r = wh;
	        g = n;
	        b = v;
	        break;

	      case 4:
	        r = n;
	        g = wh;
	        b = v;
	        break;

	      case 5:
	        r = v;
	        g = wh;
	        b = n;
	        break;
	    }

	    return [r * 255, g * 255, b * 255];
	  };

	  convert.cmyk.rgb = function (cmyk) {
	    var c = cmyk[0] / 100;
	    var m = cmyk[1] / 100;
	    var y = cmyk[2] / 100;
	    var k = cmyk[3] / 100;
	    var r;
	    var g;
	    var b;
	    r = 1 - Math.min(1, c * (1 - k) + k);
	    g = 1 - Math.min(1, m * (1 - k) + k);
	    b = 1 - Math.min(1, y * (1 - k) + k);
	    return [r * 255, g * 255, b * 255];
	  };

	  convert.xyz.rgb = function (xyz) {
	    var x = xyz[0] / 100;
	    var y = xyz[1] / 100;
	    var z = xyz[2] / 100;
	    var r;
	    var g;
	    var b;
	    r = x * 3.2406 + y * -1.5372 + z * -0.4986;
	    g = x * -0.9689 + y * 1.8758 + z * 0.0415;
	    b = x * 0.0557 + y * -0.2040 + z * 1.0570;
	    r = r > 0.0031308 ? 1.055 * Math.pow(r, 1.0 / 2.4) - 0.055 : r * 12.92;
	    g = g > 0.0031308 ? 1.055 * Math.pow(g, 1.0 / 2.4) - 0.055 : g * 12.92;
	    b = b > 0.0031308 ? 1.055 * Math.pow(b, 1.0 / 2.4) - 0.055 : b * 12.92;
	    r = Math.min(Math.max(0, r), 1);
	    g = Math.min(Math.max(0, g), 1);
	    b = Math.min(Math.max(0, b), 1);
	    return [r * 255, g * 255, b * 255];
	  };

	  convert.xyz.lab = function (xyz) {
	    var x = xyz[0];
	    var y = xyz[1];
	    var z = xyz[2];
	    var l;
	    var a;
	    var b;
	    x /= 95.047;
	    y /= 100;
	    z /= 108.883;
	    x = x > 0.008856 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
	    y = y > 0.008856 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
	    z = z > 0.008856 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
	    l = 116 * y - 16;
	    a = 500 * (x - y);
	    b = 200 * (y - z);
	    return [l, a, b];
	  };

	  convert.lab.xyz = function (lab) {
	    var l = lab[0];
	    var a = lab[1];
	    var b = lab[2];
	    var x;
	    var y;
	    var z;
	    y = (l + 16) / 116;
	    x = a / 500 + y;
	    z = y - b / 200;
	    var y2 = Math.pow(y, 3);
	    var x2 = Math.pow(x, 3);
	    var z2 = Math.pow(z, 3);
	    y = y2 > 0.008856 ? y2 : (y - 16 / 116) / 7.787;
	    x = x2 > 0.008856 ? x2 : (x - 16 / 116) / 7.787;
	    z = z2 > 0.008856 ? z2 : (z - 16 / 116) / 7.787;
	    x *= 95.047;
	    y *= 100;
	    z *= 108.883;
	    return [x, y, z];
	  };

	  convert.lab.lch = function (lab) {
	    var l = lab[0];
	    var a = lab[1];
	    var b = lab[2];
	    var hr;
	    var h;
	    var c;
	    hr = Math.atan2(b, a);
	    h = hr * 360 / 2 / Math.PI;

	    if (h < 0) {
	      h += 360;
	    }

	    c = Math.sqrt(a * a + b * b);
	    return [l, c, h];
	  };

	  convert.lch.lab = function (lch) {
	    var l = lch[0];
	    var c = lch[1];
	    var h = lch[2];
	    var a;
	    var b;
	    var hr;
	    hr = h / 360 * 2 * Math.PI;
	    a = c * Math.cos(hr);
	    b = c * Math.sin(hr);
	    return [l, a, b];
	  };

	  convert.rgb.ansi16 = function (args) {
	    var r = args[0];
	    var g = args[1];
	    var b = args[2];
	    var value = 1 in arguments ? arguments[1] : convert.rgb.hsv(args)[2];
	    value = Math.round(value / 50);

	    if (value === 0) {
	      return 30;
	    }

	    var ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r / 255));

	    if (value === 2) {
	      ansi += 60;
	    }

	    return ansi;
	  };

	  convert.hsv.ansi16 = function (args) {
	    return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
	  };

	  convert.rgb.ansi256 = function (args) {
	    var r = args[0];
	    var g = args[1];
	    var b = args[2];

	    if (r === g && g === b) {
	      if (r < 8) {
	        return 16;
	      }

	      if (r > 248) {
	        return 231;
	      }

	      return Math.round((r - 8) / 247 * 24) + 232;
	    }

	    var ansi = 16 + 36 * Math.round(r / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
	    return ansi;
	  };

	  convert.ansi16.rgb = function (args) {
	    var color = args % 10;

	    if (color === 0 || color === 7) {
	      if (args > 50) {
	        color += 3.5;
	      }

	      color = color / 10.5 * 255;
	      return [color, color, color];
	    }

	    var mult = (~~(args > 50) + 1) * 0.5;
	    var r = (color & 1) * mult * 255;
	    var g = (color >> 1 & 1) * mult * 255;
	    var b = (color >> 2 & 1) * mult * 255;
	    return [r, g, b];
	  };

	  convert.ansi256.rgb = function (args) {
	    if (args >= 232) {
	      var c = (args - 232) * 10 + 8;
	      return [c, c, c];
	    }

	    args -= 16;
	    var rem;
	    var r = Math.floor(args / 36) / 5 * 255;
	    var g = Math.floor((rem = args % 36) / 6) / 5 * 255;
	    var b = rem % 6 / 5 * 255;
	    return [r, g, b];
	  };

	  convert.rgb.hex = function (args) {
	    var integer = ((Math.round(args[0]) & 0xFF) << 16) + ((Math.round(args[1]) & 0xFF) << 8) + (Math.round(args[2]) & 0xFF);
	    var string = integer.toString(16).toUpperCase();
	    return '000000'.substring(string.length) + string;
	  };

	  convert.hex.rgb = function (args) {
	    var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);

	    if (!match) {
	      return [0, 0, 0];
	    }

	    var colorString = match[0];

	    if (match[0].length === 3) {
	      colorString = colorString.split('').map(function (char) {
	        return char + char;
	      }).join('');
	    }

	    var integer = parseInt(colorString, 16);
	    var r = integer >> 16 & 0xFF;
	    var g = integer >> 8 & 0xFF;
	    var b = integer & 0xFF;
	    return [r, g, b];
	  };

	  convert.rgb.hcg = function (rgb) {
	    var r = rgb[0] / 255;
	    var g = rgb[1] / 255;
	    var b = rgb[2] / 255;
	    var max = Math.max(Math.max(r, g), b);
	    var min = Math.min(Math.min(r, g), b);
	    var chroma = max - min;
	    var grayscale;
	    var hue;

	    if (chroma < 1) {
	      grayscale = min / (1 - chroma);
	    } else {
	      grayscale = 0;
	    }

	    if (chroma <= 0) {
	      hue = 0;
	    } else if (max === r) {
	      hue = (g - b) / chroma % 6;
	    } else if (max === g) {
	      hue = 2 + (b - r) / chroma;
	    } else {
	      hue = 4 + (r - g) / chroma + 4;
	    }

	    hue /= 6;
	    hue %= 1;
	    return [hue * 360, chroma * 100, grayscale * 100];
	  };

	  convert.hsl.hcg = function (hsl) {
	    var s = hsl[1] / 100;
	    var l = hsl[2] / 100;
	    var c = 1;
	    var f = 0;

	    if (l < 0.5) {
	      c = 2.0 * s * l;
	    } else {
	      c = 2.0 * s * (1.0 - l);
	    }

	    if (c < 1.0) {
	      f = (l - 0.5 * c) / (1.0 - c);
	    }

	    return [hsl[0], c * 100, f * 100];
	  };

	  convert.hsv.hcg = function (hsv) {
	    var s = hsv[1] / 100;
	    var v = hsv[2] / 100;
	    var c = s * v;
	    var f = 0;

	    if (c < 1.0) {
	      f = (v - c) / (1 - c);
	    }

	    return [hsv[0], c * 100, f * 100];
	  };

	  convert.hcg.rgb = function (hcg) {
	    var h = hcg[0] / 360;
	    var c = hcg[1] / 100;
	    var g = hcg[2] / 100;

	    if (c === 0.0) {
	      return [g * 255, g * 255, g * 255];
	    }

	    var pure = [0, 0, 0];
	    var hi = h % 1 * 6;
	    var v = hi % 1;
	    var w = 1 - v;
	    var mg = 0;

	    switch (Math.floor(hi)) {
	      case 0:
	        pure[0] = 1;
	        pure[1] = v;
	        pure[2] = 0;
	        break;

	      case 1:
	        pure[0] = w;
	        pure[1] = 1;
	        pure[2] = 0;
	        break;

	      case 2:
	        pure[0] = 0;
	        pure[1] = 1;
	        pure[2] = v;
	        break;

	      case 3:
	        pure[0] = 0;
	        pure[1] = w;
	        pure[2] = 1;
	        break;

	      case 4:
	        pure[0] = v;
	        pure[1] = 0;
	        pure[2] = 1;
	        break;

	      default:
	        pure[0] = 1;
	        pure[1] = 0;
	        pure[2] = w;
	    }

	    mg = (1.0 - c) * g;
	    return [(c * pure[0] + mg) * 255, (c * pure[1] + mg) * 255, (c * pure[2] + mg) * 255];
	  };

	  convert.hcg.hsv = function (hcg) {
	    var c = hcg[1] / 100;
	    var g = hcg[2] / 100;
	    var v = c + g * (1.0 - c);
	    var f = 0;

	    if (v > 0.0) {
	      f = c / v;
	    }

	    return [hcg[0], f * 100, v * 100];
	  };

	  convert.hcg.hsl = function (hcg) {
	    var c = hcg[1] / 100;
	    var g = hcg[2] / 100;
	    var l = g * (1.0 - c) + 0.5 * c;
	    var s = 0;

	    if (l > 0.0 && l < 0.5) {
	      s = c / (2 * l);
	    } else if (l >= 0.5 && l < 1.0) {
	      s = c / (2 * (1 - l));
	    }

	    return [hcg[0], s * 100, l * 100];
	  };

	  convert.hcg.hwb = function (hcg) {
	    var c = hcg[1] / 100;
	    var g = hcg[2] / 100;
	    var v = c + g * (1.0 - c);
	    return [hcg[0], (v - c) * 100, (1 - v) * 100];
	  };

	  convert.hwb.hcg = function (hwb) {
	    var w = hwb[1] / 100;
	    var b = hwb[2] / 100;
	    var v = 1 - b;
	    var c = v - w;
	    var g = 0;

	    if (c < 1) {
	      g = (v - c) / (1 - c);
	    }

	    return [hwb[0], c * 100, g * 100];
	  };

	  convert.apple.rgb = function (apple) {
	    return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
	  };

	  convert.rgb.apple = function (rgb) {
	    return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
	  };

	  convert.gray.rgb = function (args) {
	    return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
	  };

	  convert.gray.hsl = convert.gray.hsv = function (args) {
	    return [0, 0, args[0]];
	  };

	  convert.gray.hwb = function (gray) {
	    return [0, 100, gray[0]];
	  };

	  convert.gray.cmyk = function (gray) {
	    return [0, 0, 0, gray[0]];
	  };

	  convert.gray.lab = function (gray) {
	    return [gray[0], 0, 0];
	  };

	  convert.gray.hex = function (gray) {
	    var val = Math.round(gray[0] / 100 * 255) & 0xFF;
	    var integer = (val << 16) + (val << 8) + val;
	    var string = integer.toString(16).toUpperCase();
	    return '000000'.substring(string.length) + string;
	  };

	  convert.rgb.gray = function (rgb) {
	    var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
	    return [val / 255 * 100];
	  };
	}, "/$$rollup_base$$/node_modules/color-convert");

	function buildGraph() {
	  var graph = {};
	  var models = Object.keys(conversions);

	  for (var len = models.length, i = 0; i < len; i++) {
	    graph[models[i]] = {
	      distance: -1,
	      parent: null
	    };
	  }

	  return graph;
	}

	function deriveBFS(fromModel) {
	  var graph = buildGraph();
	  var queue = [fromModel];
	  graph[fromModel].distance = 0;

	  while (queue.length) {
	    var current = queue.pop();
	    var adjacents = Object.keys(conversions[current]);

	    for (var len = adjacents.length, i = 0; i < len; i++) {
	      var adjacent = adjacents[i];
	      var node = graph[adjacent];

	      if (node.distance === -1) {
	        node.distance = graph[current].distance + 1;
	        node.parent = current;
	        queue.unshift(adjacent);
	      }
	    }
	  }

	  return graph;
	}

	function link(from, to) {
	  return function (args) {
	    return to(from(args));
	  };
	}

	function wrapConversion(toModel, graph) {
	  var path = [graph[toModel].parent, toModel];
	  var fn = conversions[graph[toModel].parent][toModel];
	  var cur = graph[toModel].parent;

	  while (graph[cur].parent) {
	    path.unshift(graph[cur].parent);
	    fn = link(conversions[graph[cur].parent][cur], fn);
	    cur = graph[cur].parent;
	  }

	  fn.conversion = path;
	  return fn;
	}

	var route = function (fromModel) {
	  var graph = deriveBFS(fromModel);
	  var conversion = {};
	  var models = Object.keys(graph);

	  for (var len = models.length, i = 0; i < len; i++) {
	    var toModel = models[i];
	    var node = graph[toModel];

	    if (node.parent === null) {
	      continue;
	    }

	    conversion[toModel] = wrapConversion(toModel, graph);
	  }

	  return conversion;
	};

	var convert = {};
	var models = Object.keys(conversions);

	function wrapRaw(fn) {
	  var wrappedFn = function (args) {
	    if (args === undefined || args === null) {
	      return args;
	    }

	    if (arguments.length > 1) {
	      args = Array.prototype.slice.call(arguments);
	    }

	    return fn(args);
	  };

	  if ('conversion' in fn) {
	    wrappedFn.conversion = fn.conversion;
	  }

	  return wrappedFn;
	}

	function wrapRounded(fn) {
	  var wrappedFn = function (args) {
	    if (args === undefined || args === null) {
	      return args;
	    }

	    if (arguments.length > 1) {
	      args = Array.prototype.slice.call(arguments);
	    }

	    var result = fn(args);

	    if (typeof result === 'object') {
	      for (var len = result.length, i = 0; i < len; i++) {
	        result[i] = Math.round(result[i]);
	      }
	    }

	    return result;
	  };

	  if ('conversion' in fn) {
	    wrappedFn.conversion = fn.conversion;
	  }

	  return wrappedFn;
	}

	models.forEach(function (fromModel) {
	  convert[fromModel] = {};
	  Object.defineProperty(convert[fromModel], 'channels', {
	    value: conversions[fromModel].channels
	  });
	  Object.defineProperty(convert[fromModel], 'labels', {
	    value: conversions[fromModel].labels
	  });
	  var routes = route(fromModel);
	  var routeModels = Object.keys(routes);
	  routeModels.forEach(function (toModel) {
	    var fn = routes[toModel];
	    convert[fromModel][toModel] = wrapRounded(fn);
	    convert[fromModel][toModel].raw = wrapRaw(fn);
	  });
	});
	var colorConvert = convert;

	var ansiStyles = createCommonjsModule(function (module) {

	  const wrapAnsi16 = (fn, offset) => function () {
	    const code = fn.apply(colorConvert, arguments);
	    return `\u001B[${code + offset}m`;
	  };

	  const wrapAnsi256 = (fn, offset) => function () {
	    const code = fn.apply(colorConvert, arguments);
	    return `\u001B[${38 + offset};5;${code}m`;
	  };

	  const wrapAnsi16m = (fn, offset) => function () {
	    const rgb = fn.apply(colorConvert, arguments);
	    return `\u001B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
	  };

	  function assembleStyles() {
	    const codes = new Map();
	    const styles = {
	      modifier: {
	        reset: [0, 0],
	        bold: [1, 22],
	        dim: [2, 22],
	        italic: [3, 23],
	        underline: [4, 24],
	        inverse: [7, 27],
	        hidden: [8, 28],
	        strikethrough: [9, 29]
	      },
	      color: {
	        black: [30, 39],
	        red: [31, 39],
	        green: [32, 39],
	        yellow: [33, 39],
	        blue: [34, 39],
	        magenta: [35, 39],
	        cyan: [36, 39],
	        white: [37, 39],
	        gray: [90, 39],
	        redBright: [91, 39],
	        greenBright: [92, 39],
	        yellowBright: [93, 39],
	        blueBright: [94, 39],
	        magentaBright: [95, 39],
	        cyanBright: [96, 39],
	        whiteBright: [97, 39]
	      },
	      bgColor: {
	        bgBlack: [40, 49],
	        bgRed: [41, 49],
	        bgGreen: [42, 49],
	        bgYellow: [43, 49],
	        bgBlue: [44, 49],
	        bgMagenta: [45, 49],
	        bgCyan: [46, 49],
	        bgWhite: [47, 49],
	        bgBlackBright: [100, 49],
	        bgRedBright: [101, 49],
	        bgGreenBright: [102, 49],
	        bgYellowBright: [103, 49],
	        bgBlueBright: [104, 49],
	        bgMagentaBright: [105, 49],
	        bgCyanBright: [106, 49],
	        bgWhiteBright: [107, 49]
	      }
	    };
	    styles.color.grey = styles.color.gray;

	    for (const groupName of Object.keys(styles)) {
	      const group = styles[groupName];

	      for (const styleName of Object.keys(group)) {
	        const style = group[styleName];
	        styles[styleName] = {
	          open: `\u001B[${style[0]}m`,
	          close: `\u001B[${style[1]}m`
	        };
	        group[styleName] = styles[styleName];
	        codes.set(style[0], style[1]);
	      }

	      Object.defineProperty(styles, groupName, {
	        value: group,
	        enumerable: false
	      });
	      Object.defineProperty(styles, 'codes', {
	        value: codes,
	        enumerable: false
	      });
	    }

	    const ansi2ansi = n => n;

	    const rgb2rgb = (r, g, b) => [r, g, b];

	    styles.color.close = '\u001B[39m';
	    styles.bgColor.close = '\u001B[49m';
	    styles.color.ansi = {
	      ansi: wrapAnsi16(ansi2ansi, 0)
	    };
	    styles.color.ansi256 = {
	      ansi256: wrapAnsi256(ansi2ansi, 0)
	    };
	    styles.color.ansi16m = {
	      rgb: wrapAnsi16m(rgb2rgb, 0)
	    };
	    styles.bgColor.ansi = {
	      ansi: wrapAnsi16(ansi2ansi, 10)
	    };
	    styles.bgColor.ansi256 = {
	      ansi256: wrapAnsi256(ansi2ansi, 10)
	    };
	    styles.bgColor.ansi16m = {
	      rgb: wrapAnsi16m(rgb2rgb, 10)
	    };

	    for (let key of Object.keys(colorConvert)) {
	      if (typeof colorConvert[key] !== 'object') {
	        continue;
	      }

	      const suite = colorConvert[key];

	      if (key === 'ansi16') {
	        key = 'ansi';
	      }

	      if ('ansi16' in suite) {
	        styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
	        styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
	      }

	      if ('ansi256' in suite) {
	        styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
	        styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
	      }

	      if ('rgb' in suite) {
	        styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
	        styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
	      }
	    }

	    return styles;
	  }

	  Object.defineProperty(module, 'exports', {
	    enumerable: true,
	    get: assembleStyles
	  });
	}, "/$$rollup_base$$/packages/babel-highlight/node_modules/ansi-styles");

	var browser$1 = {
	  stdout: false,
	  stderr: false
	};

	const TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
	const STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
	const STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
	const ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
	const ESCAPES = new Map([['n', '\n'], ['r', '\r'], ['t', '\t'], ['b', '\b'], ['f', '\f'], ['v', '\v'], ['0', '\0'], ['\\', '\\'], ['e', '\u001B'], ['a', '\u0007']]);

	function unescape(c) {
	  if (c[0] === 'u' && c.length === 5 || c[0] === 'x' && c.length === 3) {
	    return String.fromCharCode(parseInt(c.slice(1), 16));
	  }

	  return ESCAPES.get(c) || c;
	}

	function parseArguments(name, args) {
	  const results = [];
	  const chunks = args.trim().split(/\s*,\s*/g);
	  let matches;

	  for (const chunk of chunks) {
	    if (!isNaN(chunk)) {
	      results.push(Number(chunk));
	    } else if (matches = chunk.match(STRING_REGEX)) {
	      results.push(matches[2].replace(ESCAPE_REGEX, (m, escape, chr) => escape ? unescape(escape) : chr));
	    } else {
	      throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
	    }
	  }

	  return results;
	}

	function parseStyle(style) {
	  STYLE_REGEX.lastIndex = 0;
	  const results = [];
	  let matches;

	  while ((matches = STYLE_REGEX.exec(style)) !== null) {
	    const name = matches[1];

	    if (matches[2]) {
	      const args = parseArguments(name, matches[2]);
	      results.push([name].concat(args));
	    } else {
	      results.push([name]);
	    }
	  }

	  return results;
	}

	function buildStyle(chalk, styles) {
	  const enabled = {};

	  for (const layer of styles) {
	    for (const style of layer.styles) {
	      enabled[style[0]] = layer.inverse ? null : style.slice(1);
	    }
	  }

	  let current = chalk;

	  for (const styleName of Object.keys(enabled)) {
	    if (Array.isArray(enabled[styleName])) {
	      if (!(styleName in current)) {
	        throw new Error(`Unknown Chalk style: ${styleName}`);
	      }

	      if (enabled[styleName].length > 0) {
	        current = current[styleName].apply(current, enabled[styleName]);
	      } else {
	        current = current[styleName];
	      }
	    }
	  }

	  return current;
	}

	var templates = (chalk, tmp) => {
	  const styles = [];
	  const chunks = [];
	  let chunk = [];
	  tmp.replace(TEMPLATE_REGEX, (m, escapeChar, inverse, style, close, chr) => {
	    if (escapeChar) {
	      chunk.push(unescape(escapeChar));
	    } else if (style) {
	      const str = chunk.join('');
	      chunk = [];
	      chunks.push(styles.length === 0 ? str : buildStyle(chalk, styles)(str));
	      styles.push({
	        inverse,
	        styles: parseStyle(style)
	      });
	    } else if (close) {
	      if (styles.length === 0) {
	        throw new Error('Found extraneous } in Chalk template literal');
	      }

	      chunks.push(buildStyle(chalk, styles)(chunk.join('')));
	      chunk = [];
	      styles.pop();
	    } else {
	      chunk.push(chr);
	    }
	  });
	  chunks.push(chunk.join(''));

	  if (styles.length > 0) {
	    const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? '' : 's'} (\`}\`)`;
	    throw new Error(errMsg);
	  }

	  return chunks.join('');
	};

	var chalk = createCommonjsModule(function (module) {

	  const stdoutColor = browser$1.stdout;
	  const isSimpleWindowsTerm = browser$5.platform === 'win32' && !(browser$5.env.TERM || '').toLowerCase().startsWith('xterm');
	  const levelMapping = ['ansi', 'ansi', 'ansi256', 'ansi16m'];
	  const skipModels = new Set(['gray']);
	  const styles = Object.create(null);

	  function applyOptions(obj, options) {
	    options = options || {};
	    const scLevel = 0;
	    obj.level = options.level === undefined ? scLevel : options.level;
	    obj.enabled = 'enabled' in options ? options.enabled : obj.level > 0;
	  }

	  function Chalk(options) {
	    if (!this || !(this instanceof Chalk) || this.template) {
	      const chalk = {};
	      applyOptions(chalk, options);

	      chalk.template = function () {
	        const args = [].slice.call(arguments);
	        return chalkTag.apply(null, [chalk.template].concat(args));
	      };

	      Object.setPrototypeOf(chalk, Chalk.prototype);
	      Object.setPrototypeOf(chalk.template, chalk);
	      chalk.template.constructor = Chalk;
	      return chalk.template;
	    }

	    applyOptions(this, options);
	  }

	  if (isSimpleWindowsTerm) {
	    ansiStyles.blue.open = '\u001B[94m';
	  }

	  for (const key of Object.keys(ansiStyles)) {
	    ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), 'g');
	    styles[key] = {
	      get() {
	        const codes = ansiStyles[key];
	        return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
	      }

	    };
	  }

	  styles.visible = {
	    get() {
	      return build.call(this, this._styles || [], true, 'visible');
	    }

	  };
	  ansiStyles.color.closeRe = new RegExp(escapeStringRegexp(ansiStyles.color.close), 'g');

	  for (const model of Object.keys(ansiStyles.color.ansi)) {
	    if (skipModels.has(model)) {
	      continue;
	    }

	    styles[model] = {
	      get() {
	        const level = this.level;
	        return function () {
	          const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
	          const codes = {
	            open,
	            close: ansiStyles.color.close,
	            closeRe: ansiStyles.color.closeRe
	          };
	          return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
	        };
	      }

	    };
	  }

	  ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp(ansiStyles.bgColor.close), 'g');

	  for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
	    if (skipModels.has(model)) {
	      continue;
	    }

	    const bgModel = 'bg' + model[0].toUpperCase() + model.slice(1);
	    styles[bgModel] = {
	      get() {
	        const level = this.level;
	        return function () {
	          const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
	          const codes = {
	            open,
	            close: ansiStyles.bgColor.close,
	            closeRe: ansiStyles.bgColor.closeRe
	          };
	          return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
	        };
	      }

	    };
	  }

	  const proto = Object.defineProperties(() => {}, styles);

	  function build(_styles, _empty, key) {
	    const builder = function () {
	      return applyStyle.apply(builder, arguments);
	    };

	    builder._styles = _styles;
	    builder._empty = _empty;
	    const self = this;
	    Object.defineProperty(builder, 'level', {
	      enumerable: true,

	      get() {
	        return self.level;
	      },

	      set(level) {
	        self.level = level;
	      }

	    });
	    Object.defineProperty(builder, 'enabled', {
	      enumerable: true,

	      get() {
	        return self.enabled;
	      },

	      set(enabled) {
	        self.enabled = enabled;
	      }

	    });
	    builder.hasGrey = this.hasGrey || key === 'gray' || key === 'grey';
	    builder.__proto__ = proto;
	    return builder;
	  }

	  function applyStyle() {
	    const args = arguments;
	    const argsLen = args.length;
	    let str = String(arguments[0]);

	    if (argsLen === 0) {
	      return '';
	    }

	    if (argsLen > 1) {
	      for (let a = 1; a < argsLen; a++) {
	        str += ' ' + args[a];
	      }
	    }

	    if (!this.enabled || this.level <= 0 || !str) {
	      return this._empty ? '' : str;
	    }

	    const originalDim = ansiStyles.dim.open;

	    if (isSimpleWindowsTerm && this.hasGrey) {
	      ansiStyles.dim.open = '';
	    }

	    for (const code of this._styles.slice().reverse()) {
	      str = code.open + str.replace(code.closeRe, code.open) + code.close;
	      str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
	    }

	    ansiStyles.dim.open = originalDim;
	    return str;
	  }

	  function chalkTag(chalk, strings) {
	    if (!Array.isArray(strings)) {
	      return [].slice.call(arguments, 1).join(' ');
	    }

	    const args = [].slice.call(arguments, 2);
	    const parts = [strings.raw[0]];

	    for (let i = 1; i < strings.length; i++) {
	      parts.push(String(args[i - 1]).replace(/[{}\\]/g, '\\$&'));
	      parts.push(String(strings.raw[i]));
	    }

	    return templates(chalk, parts.join(''));
	  }

	  Object.defineProperties(Chalk.prototype, styles);
	  module.exports = Chalk();
	  module.exports.supportsColor = stdoutColor;
	  module.exports.default = module.exports;
	}, "/$$rollup_base$$/packages/babel-highlight/node_modules/chalk");

	const sometimesKeywords = new Set(["as", "async", "from", "get", "of", "set"]);

	function getDefs$1(chalk) {
	  return {
	    keyword: chalk.cyan,
	    capitalized: chalk.yellow,
	    jsxIdentifier: chalk.yellow,
	    punctuator: chalk.yellow,
	    number: chalk.magenta,
	    string: chalk.green,
	    regex: chalk.magenta,
	    comment: chalk.grey,
	    invalid: chalk.white.bgRed.bold
	  };
	}

	const NEWLINE$1 = /\r\n|[\n\r\u2028\u2029]/;
	const BRACKET = /^[()[\]{}]$/;
	let tokenize;

	if (browser$5.env.BABEL_8_BREAKING) {
	  const getTokenType = function (token) {
	    if (token.type === "IdentifierName") {
	      if (isKeyword(token.value) || isStrictReservedWord(token.value, true) || sometimesKeywords.has(token.value)) {
	        return "keyword";
	      }

	      if (token.value[0] !== token.value[0].toLowerCase()) {
	        return "capitalized";
	      }
	    }

	    if (token.type === "Punctuator" && BRACKET.test(token.value)) {
	      return "uncolored";
	    }

	    if (token.type === "Invalid" && (token.value === "@" || token.value === "#")) {
	      return "punctuator";
	    }

	    switch (token.type) {
	      case "NumericLiteral":
	        return "number";

	      case "StringLiteral":
	      case "JSXString":
	      case "NoSubstitutionTemplate":
	        return "string";

	      case "RegularExpressionLiteral":
	        return "regex";

	      case "Punctuator":
	      case "JSXPunctuator":
	        return "punctuator";

	      case "MultiLineComment":
	      case "SingleLineComment":
	        return "comment";

	      case "Invalid":
	      case "JSXInvalid":
	        return "invalid";

	      case "JSXIdentifier":
	        return "jsxIdentifier";

	      default:
	        return "uncolored";
	    }
	  };

	  tokenize = function* (text) {
	    for (const token of jsTokens(text, {
	      jsx: true
	    })) {
	      switch (token.type) {
	        case "TemplateHead":
	          yield {
	            type: "string",
	            value: token.value.slice(0, -2)
	          };
	          yield {
	            type: "punctuator",
	            value: "${"
	          };
	          break;

	        case "TemplateMiddle":
	          yield {
	            type: "punctuator",
	            value: "}"
	          };
	          yield {
	            type: "string",
	            value: token.value.slice(1, -2)
	          };
	          yield {
	            type: "punctuator",
	            value: "${"
	          };
	          break;

	        case "TemplateTail":
	          yield {
	            type: "punctuator",
	            value: "}"
	          };
	          yield {
	            type: "string",
	            value: token.value.slice(1)
	          };
	          break;

	        default:
	          yield {
	            type: getTokenType(token),
	            value: token.value
	          };
	      }
	    }
	  };
	} else {
	  const JSX_TAG = /^[a-z][\w-]*$/i;

	  const getTokenType = function (token, offset, text) {
	    if (token.type === "name") {
	      if (isKeyword(token.value) || isStrictReservedWord(token.value, true) || sometimesKeywords.has(token.value)) {
	        return "keyword";
	      }

	      if (JSX_TAG.test(token.value) && (text[offset - 1] === "<" || text.substr(offset - 2, 2) == "</")) {
	        return "jsxIdentifier";
	      }

	      if (token.value[0] !== token.value[0].toLowerCase()) {
	        return "capitalized";
	      }
	    }

	    if (token.type === "punctuator" && BRACKET.test(token.value)) {
	      return "bracket";
	    }

	    if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
	      return "punctuator";
	    }

	    return token.type;
	  };

	  tokenize = function* (text) {
	    let match;

	    while (match = jsTokens.default.exec(text)) {
	      const token = jsTokens.matchToToken(match);
	      yield {
	        type: getTokenType(token, match.index, text),
	        value: token.value
	      };
	    }
	  };
	}

	function highlightTokens(defs, text) {
	  let highlighted = "";

	  for (const {
	    type,
	    value
	  } of tokenize(text)) {
	    const colorize = defs[type];

	    if (colorize) {
	      highlighted += value.split(NEWLINE$1).map(str => colorize(str)).join("\n");
	    } else {
	      highlighted += value;
	    }
	  }

	  return highlighted;
	}

	function shouldHighlight(options) {
	  return !!chalk.supportsColor || options.forceColor;
	}
	function getChalk(options) {
	  return options.forceColor ? new chalk.constructor({
	    enabled: true,
	    level: 1
	  }) : chalk;
	}
	function highlight(code, options = {}) {
	  if (code !== "" && shouldHighlight(options)) {
	    const chalk = getChalk(options);
	    const defs = getDefs$1(chalk);
	    return highlightTokens(defs, code);
	  } else {
	    return code;
	  }
	}

	function getDefs(chalk) {
	  return {
	    gutter: chalk.grey,
	    marker: chalk.red.bold,
	    message: chalk.red.bold
	  };
	}

	const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;

	function getMarkerLines(loc, source, opts) {
	  const startLoc = {
	    column: 0,
	    line: -1,
	    ...loc.start
	  };
	  const endLoc = { ...startLoc,
	    ...loc.end
	  };
	  const {
	    linesAbove = 2,
	    linesBelow = 3
	  } = opts || {};
	  const startLine = startLoc.line;
	  const startColumn = startLoc.column;
	  const endLine = endLoc.line;
	  const endColumn = endLoc.column;
	  let start = Math.max(startLine - (linesAbove + 1), 0);
	  let end = Math.min(source.length, endLine + linesBelow);

	  if (startLine === -1) {
	    start = 0;
	  }

	  if (endLine === -1) {
	    end = source.length;
	  }

	  const lineDiff = endLine - startLine;
	  const markerLines = {};

	  if (lineDiff) {
	    for (let i = 0; i <= lineDiff; i++) {
	      const lineNumber = i + startLine;

	      if (!startColumn) {
	        markerLines[lineNumber] = true;
	      } else if (i === 0) {
	        const sourceLength = source[lineNumber - 1].length;
	        markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
	      } else if (i === lineDiff) {
	        markerLines[lineNumber] = [0, endColumn];
	      } else {
	        const sourceLength = source[lineNumber - i].length;
	        markerLines[lineNumber] = [0, sourceLength];
	      }
	    }
	  } else {
	    if (startColumn === endColumn) {
	      if (startColumn) {
	        markerLines[startLine] = [startColumn, 0];
	      } else {
	        markerLines[startLine] = true;
	      }
	    } else {
	      markerLines[startLine] = [startColumn, endColumn - startColumn];
	    }
	  }

	  return {
	    start,
	    end,
	    markerLines
	  };
	}

	function codeFrameColumns(rawLines, loc, opts = {}) {
	  const highlighted = (opts.highlightCode || opts.forceColor) && shouldHighlight(opts);
	  const chalk = getChalk(opts);
	  const defs = getDefs(chalk);

	  const maybeHighlight = (chalkFn, string) => {
	    return highlighted ? chalkFn(string) : string;
	  };

	  const lines = rawLines.split(NEWLINE);
	  const {
	    start,
	    end,
	    markerLines
	  } = getMarkerLines(loc, lines, opts);
	  const hasColumns = loc.start && typeof loc.start.column === "number";
	  const numberMaxWidth = String(end).length;
	  const highlightedLines = highlighted ? highlight(rawLines, opts) : rawLines;
	  let frame = highlightedLines.split(NEWLINE, end).slice(start, end).map((line, index) => {
	    const number = start + 1 + index;
	    const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
	    const gutter = ` ${paddedNumber} |`;
	    const hasMarker = markerLines[number];
	    const lastMarkerLine = !markerLines[number + 1];

	    if (hasMarker) {
	      let markerLine = "";

	      if (Array.isArray(hasMarker)) {
	        const markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
	        const numberOfMarkers = hasMarker[1] || 1;
	        markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");

	        if (lastMarkerLine && opts.message) {
	          markerLine += " " + maybeHighlight(defs.message, opts.message);
	        }
	      }

	      return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? ` ${line}` : "", markerLine].join("");
	    } else {
	      return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ""}`;
	    }
	  }).join("\n");

	  if (opts.message && !hasColumns) {
	    frame = `${" ".repeat(numberMaxWidth + 1)}${opts.message}\n${frame}`;
	  }

	  if (highlighted) {
	    return chalk.reset(frame);
	  } else {
	    return frame;
	  }
	}

	class BaseParser {
	  sawUnambiguousESM = false;
	  ambiguousScriptDifferentAst = false;

	  hasPlugin(pluginConfig) {
	    if (typeof pluginConfig === "string") {
	      return this.plugins.has(pluginConfig);
	    } else {
	      const [pluginName, pluginOptions] = pluginConfig;

	      if (!this.hasPlugin(pluginName)) {
	        return false;
	      }

	      const actualOptions = this.plugins.get(pluginName);

	      for (const key of Object.keys(pluginOptions)) {
	        if (actualOptions?.[key] !== pluginOptions[key]) {
	          return false;
	        }
	      }

	      return true;
	    }
	  }

	  getPluginOption(plugin, name) {
	    return this.plugins.get(plugin)?.[name];
	  }

	}

	function setTrailingComments(node, comments) {
	  if (node.trailingComments === undefined) {
	    node.trailingComments = comments;
	  } else {
	    node.trailingComments.unshift(...comments);
	  }
	}

	function setLeadingComments(node, comments) {
	  if (node.leadingComments === undefined) {
	    node.leadingComments = comments;
	  } else {
	    node.leadingComments.unshift(...comments);
	  }
	}

	function setInnerComments(node, comments) {
	  if (node.innerComments === undefined) {
	    node.innerComments = comments;
	  } else {
	    node.innerComments.unshift(...comments);
	  }
	}

	function adjustInnerComments(node, elements, commentWS) {
	  let lastElement = null;
	  let i = elements.length;

	  while (lastElement === null && i > 0) {
	    lastElement = elements[--i];
	  }

	  if (lastElement === null || lastElement.start > commentWS.start) {
	    setInnerComments(node, commentWS.comments);
	  } else {
	    setTrailingComments(lastElement, commentWS.comments);
	  }
	}

	class CommentsParser extends BaseParser {
	  addComment(comment) {
	    if (this.filename) comment.loc.filename = this.filename;
	    this.state.comments.push(comment);
	  }

	  processComment(node) {
	    const {
	      commentStack
	    } = this.state;
	    const commentStackLength = commentStack.length;
	    if (commentStackLength === 0) return;
	    let i = commentStackLength - 1;
	    const lastCommentWS = commentStack[i];

	    if (lastCommentWS.start === node.end) {
	      lastCommentWS.leadingNode = node;
	      i--;
	    }

	    const {
	      start: nodeStart
	    } = node;

	    for (; i >= 0; i--) {
	      const commentWS = commentStack[i];
	      const commentEnd = commentWS.end;

	      if (commentEnd > nodeStart) {
	        commentWS.containingNode = node;
	        this.finalizeComment(commentWS);
	        commentStack.splice(i, 1);
	      } else {
	        if (commentEnd === nodeStart) {
	          commentWS.trailingNode = node;
	        }

	        break;
	      }
	    }
	  }

	  finalizeComment(commentWS) {
	    const {
	      comments
	    } = commentWS;

	    if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
	      if (commentWS.leadingNode !== null) {
	        setTrailingComments(commentWS.leadingNode, comments);
	      }

	      if (commentWS.trailingNode !== null) {
	        setLeadingComments(commentWS.trailingNode, comments);
	      }
	    } else {
	      const {
	        containingNode: node,
	        start: commentStart
	      } = commentWS;

	      if (this.input.charCodeAt(commentStart - 1) === 44) {
	        switch (node.type) {
	          case "ObjectExpression":
	          case "ObjectPattern":
	          case "RecordExpression":
	            adjustInnerComments(node, node.properties, commentWS);
	            break;

	          case "CallExpression":
	          case "OptionalCallExpression":
	            adjustInnerComments(node, node.arguments, commentWS);
	            break;

	          case "FunctionDeclaration":
	          case "FunctionExpression":
	          case "ArrowFunctionExpression":
	          case "ObjectMethod":
	          case "ClassMethod":
	          case "ClassPrivateMethod":
	            adjustInnerComments(node, node.params, commentWS);
	            break;

	          case "ArrayExpression":
	          case "ArrayPattern":
	          case "TupleExpression":
	            adjustInnerComments(node, node.elements, commentWS);
	            break;

	          case "ExportNamedDeclaration":
	          case "ImportDeclaration":
	            adjustInnerComments(node, node.specifiers, commentWS);
	            break;

	          default:
	            {
	              setInnerComments(node, comments);
	            }
	        }
	      } else {
	        setInnerComments(node, comments);
	      }
	    }
	  }

	  finalizeRemainingComments() {
	    const {
	      commentStack
	    } = this.state;

	    for (let i = commentStack.length - 1; i >= 0; i--) {
	      this.finalizeComment(commentStack[i]);
	    }

	    this.state.commentStack = [];
	  }

	  resetPreviousNodeTrailingComments(node) {
	    const {
	      commentStack
	    } = this.state;
	    const {
	      length
	    } = commentStack;
	    if (length === 0) return;
	    const commentWS = commentStack[length - 1];

	    if (commentWS.leadingNode === node) {
	      commentWS.leadingNode = null;
	    }
	  }

	  takeSurroundingComments(node, start, end) {
	    const {
	      commentStack
	    } = this.state;
	    const commentStackLength = commentStack.length;
	    if (commentStackLength === 0) return;
	    let i = commentStackLength - 1;

	    for (; i >= 0; i--) {
	      const commentWS = commentStack[i];
	      const commentEnd = commentWS.end;
	      const commentStart = commentWS.start;

	      if (commentStart === end) {
	        commentWS.leadingNode = node;
	      } else if (commentEnd === start) {
	        commentWS.trailingNode = node;
	      } else if (commentEnd < start) {
	        break;
	      }
	    }
	  }

	}

	const ErrorCodes = Object.freeze({
	  SyntaxError: "BABEL_PARSER_SYNTAX_ERROR",
	  SourceTypeModuleError: "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED"
	});

	const ErrorMessages = makeErrorTemplates({
	  AccessorIsGenerator: "A %0ter cannot be a generator.",
	  ArgumentsInClass: "'arguments' is only allowed in functions and class methods.",
	  AsyncFunctionInSingleStatementContext: "Async functions can only be declared at the top level or inside a block.",
	  AwaitBindingIdentifier: "Can not use 'await' as identifier inside an async function.",
	  AwaitBindingIdentifierInStaticBlock: "Can not use 'await' as identifier inside a static block.",
	  AwaitExpressionFormalParameter: "'await' is not allowed in async function parameters.",
	  AwaitNotInAsyncContext: "'await' is only allowed within async functions and at the top levels of modules.",
	  AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
	  BadGetterArity: "A 'get' accesor must not have any formal parameters.",
	  BadSetterArity: "A 'set' accesor must have exactly one formal parameter.",
	  BadSetterRestParameter: "A 'set' accesor function argument must not be a rest parameter.",
	  ConstructorClassField: "Classes may not have a field named 'constructor'.",
	  ConstructorClassPrivateField: "Classes may not have a private field named '#constructor'.",
	  ConstructorIsAccessor: "Class constructor may not be an accessor.",
	  ConstructorIsAsync: "Constructor can't be an async function.",
	  ConstructorIsGenerator: "Constructor can't be a generator.",
	  DeclarationMissingInitializer: "'%0' require an initialization value.",
	  DecoratorBeforeExport: "Decorators must be placed *before* the 'export' keyword. You can set the 'decoratorsBeforeExport' option to false to use the 'export @decorator class {}' syntax.",
	  DecoratorConstructor: "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
	  DecoratorExportClass: "Using the export keyword between a decorator and a class is not allowed. Please use `export @dec class` instead.",
	  DecoratorSemicolon: "Decorators must not be followed by a semicolon.",
	  DecoratorStaticBlock: "Decorators can't be used with a static block.",
	  DeletePrivateField: "Deleting a private field is not allowed.",
	  DestructureNamedImport: "ES2015 named imports do not destructure. Use another statement for destructuring after the import.",
	  DuplicateConstructor: "Duplicate constructor in the same class.",
	  DuplicateDefaultExport: "Only one default export allowed per module.",
	  DuplicateExport: "`%0` has already been exported. Exported identifiers must be unique.",
	  DuplicateProto: "Redefinition of __proto__ property.",
	  DuplicateRegExpFlags: "Duplicate regular expression flag.",
	  ElementAfterRest: "Rest element must be last element.",
	  EscapedCharNotAnIdentifier: "Invalid Unicode escape.",
	  ExportBindingIsString: "A string literal cannot be used as an exported binding without `from`.\n- Did you mean `export { '%0' as '%1' } from 'some-module'`?",
	  ExportDefaultFromAsIdentifier: "'from' is not allowed as an identifier after 'export default'.",
	  ForInOfLoopInitializer: "'%0' loop variable declaration may not have an initializer.",
	  ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
	  ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
	  GeneratorInSingleStatementContext: "Generators can only be declared at the top level or inside a block.",
	  IllegalBreakContinue: "Unsyntactic %0.",
	  IllegalLanguageModeDirective: "Illegal 'use strict' directive in function with non-simple parameter list.",
	  IllegalReturn: "'return' outside of function.",
	  ImportBindingIsString: 'A string literal cannot be used as an imported binding.\n- Did you mean `import { "%0" as foo }`?',
	  ImportCallArgumentTrailingComma: "Trailing comma is disallowed inside import(...) arguments.",
	  ImportCallArity: "`import()` requires exactly %0.",
	  ImportCallNotNewExpression: "Cannot use new with import(...).",
	  ImportCallSpreadArgument: "`...` is not allowed in `import()`.",
	  IncompatibleRegExpUVFlags: "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
	  InvalidBigIntLiteral: "Invalid BigIntLiteral.",
	  InvalidCodePoint: "Code point out of bounds.",
	  InvalidCoverInitializedName: "Invalid shorthand property initializer.",
	  InvalidDecimal: "Invalid decimal.",
	  InvalidDigit: "Expected number in radix %0.",
	  InvalidEscapeSequence: "Bad character escape sequence.",
	  InvalidEscapeSequenceTemplate: "Invalid escape sequence in template.",
	  InvalidEscapedReservedWord: "Escape sequence in keyword %0.",
	  InvalidIdentifier: "Invalid identifier %0.",
	  InvalidLhs: "Invalid left-hand side in %0.",
	  InvalidLhsBinding: "Binding invalid left-hand side in %0.",
	  InvalidNumber: "Invalid number.",
	  InvalidOrMissingExponent: "Floating-point numbers require a valid exponent after the 'e'.",
	  InvalidOrUnexpectedToken: "Unexpected character '%0'.",
	  InvalidParenthesizedAssignment: "Invalid parenthesized assignment pattern.",
	  InvalidPrivateFieldResolution: "Private name #%0 is not defined.",
	  InvalidPropertyBindingPattern: "Binding member expression.",
	  InvalidRecordProperty: "Only properties and spread elements are allowed in record definitions.",
	  InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
	  LabelRedeclaration: "Label '%0' is already declared.",
	  LetInLexicalBinding: "'let' is not allowed to be used as a name in 'let' or 'const' declarations.",
	  LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
	  MalformedRegExpFlags: "Invalid regular expression flag.",
	  MissingClassName: "A class name is required.",
	  MissingEqInAssignment: "Only '=' operator can be used for specifying default value.",
	  MissingSemicolon: "Missing semicolon.",
	  MissingUnicodeEscape: "Expecting Unicode escape sequence \\uXXXX.",
	  MixingCoalesceWithLogical: "Nullish coalescing operator(??) requires parens when mixing with logical operators.",
	  ModuleAttributeDifferentFromType: "The only accepted module attribute is `type`.",
	  ModuleAttributeInvalidValue: "Only string literals are allowed as module attribute values.",
	  ModuleAttributesWithDuplicateKeys: 'Duplicate key "%0" is not allowed in module attributes.',
	  ModuleExportNameHasLoneSurrogate: "An export name cannot include a lone surrogate, found '\\u%0'.",
	  ModuleExportUndefined: "Export '%0' is not defined.",
	  MultipleDefaultsInSwitch: "Multiple default clauses.",
	  NewlineAfterThrow: "Illegal newline after throw.",
	  NoCatchOrFinally: "Missing catch or finally clause.",
	  NumberIdentifier: "Identifier directly after number.",
	  NumericSeparatorInEscapeSequence: "Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.",
	  ObsoleteAwaitStar: "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
	  OptionalChainingNoNew: "Constructors in/after an Optional Chain are not allowed.",
	  OptionalChainingNoTemplate: "Tagged Template Literals are not allowed in optionalChain.",
	  OverrideOnConstructor: "'override' modifier cannot appear on a constructor declaration.",
	  ParamDupe: "Argument name clash.",
	  PatternHasAccessor: "Object pattern can't contain getter or setter.",
	  PatternHasMethod: "Object pattern can't contain methods.",
	  PipeBodyIsTighter: "Unexpected %0 after pipeline body; any %0 expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.",
	  PipeTopicRequiresHackPipes: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
	  PipeTopicUnbound: "Topic reference is unbound; it must be inside a pipe body.",
	  PipeTopicUnconfiguredToken: 'Invalid topic token %0. In order to use %0 as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "%0" }.',
	  PipeTopicUnused: "Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.",
	  PipeUnparenthesizedBody: "Hack-style pipe body cannot be an unparenthesized %0 expression; please wrap it in parentheses.",
	  PipelineBodyNoArrow: 'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
	  PipelineBodySequenceExpression: "Pipeline body may not be a comma-separated sequence expression.",
	  PipelineHeadSequenceExpression: "Pipeline head should not be a comma-separated sequence expression.",
	  PipelineTopicUnused: "Pipeline is in topic style but does not use topic reference.",
	  PrimaryTopicNotAllowed: "Topic reference was used in a lexical context without topic binding.",
	  PrimaryTopicRequiresSmartPipeline: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
	  PrivateInExpectedIn: "Private names are only allowed in property accesses (`obj.#%0`) or in `in` expressions (`#%0 in obj`).",
	  PrivateNameRedeclaration: "Duplicate private name #%0.",
	  RecordExpressionBarIncorrectEndSyntaxType: "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
	  RecordExpressionBarIncorrectStartSyntaxType: "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
	  RecordExpressionHashIncorrectStartSyntaxType: "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
	  RecordNoProto: "'__proto__' is not allowed in Record expressions.",
	  RestTrailingComma: "Unexpected trailing comma after rest element.",
	  SloppyFunction: "In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.",
	  StaticPrototype: "Classes may not have static property named prototype.",
	  StrictDelete: "Deleting local variable in strict mode.",
	  StrictEvalArguments: "Assigning to '%0' in strict mode.",
	  StrictEvalArgumentsBinding: "Binding '%0' in strict mode.",
	  StrictFunction: "In strict mode code, functions can only be declared at top level or inside a block.",
	  StrictNumericEscape: "The only valid numeric escape in strict mode is '\\0'.",
	  StrictOctalLiteral: "Legacy octal literals are not allowed in strict mode.",
	  StrictWith: "'with' in strict mode.",
	  SuperNotAllowed: "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
	  SuperPrivateField: "Private fields can't be accessed on super.",
	  TrailingDecorator: "Decorators must be attached to a class element.",
	  TupleExpressionBarIncorrectEndSyntaxType: "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
	  TupleExpressionBarIncorrectStartSyntaxType: "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
	  TupleExpressionHashIncorrectStartSyntaxType: "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
	  UnexpectedArgumentPlaceholder: "Unexpected argument placeholder.",
	  UnexpectedAwaitAfterPipelineBody: 'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
	  UnexpectedDigitAfterHash: "Unexpected digit after hash token.",
	  UnexpectedImportExport: "'import' and 'export' may only appear at the top level.",
	  UnexpectedKeyword: "Unexpected keyword '%0'.",
	  UnexpectedLeadingDecorator: "Leading decorators must be attached to a class declaration.",
	  UnexpectedLexicalDeclaration: "Lexical declaration cannot appear in a single-statement context.",
	  UnexpectedNewTarget: "`new.target` can only be used in functions or class properties.",
	  UnexpectedNumericSeparator: "A numeric separator is only allowed between two digits.",
	  UnexpectedPrivateField: "Unexpected private name.",
	  UnexpectedReservedWord: "Unexpected reserved word '%0'.",
	  UnexpectedSuper: "'super' is only allowed in object methods and classes.",
	  UnexpectedToken: "Unexpected token '%0'.",
	  UnexpectedTokenUnaryExponentiation: "Illegal expression. Wrap left hand side or entire exponentiation in parentheses.",
	  UnsupportedBind: "Binding should be performed on object property.",
	  UnsupportedDecoratorExport: "A decorated export must export a class declaration.",
	  UnsupportedDefaultExport: "Only expressions, functions or classes are allowed as the `default` export.",
	  UnsupportedImport: "`import` can only be used in `import()` or `import.meta`.",
	  UnsupportedMetaProperty: "The only valid meta property for %0 is %0.%1.",
	  UnsupportedParameterDecorator: "Decorators cannot be used to decorate parameters.",
	  UnsupportedPropertyDecorator: "Decorators cannot be used to decorate object literal properties.",
	  UnsupportedSuper: "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
	  UnterminatedComment: "Unterminated comment.",
	  UnterminatedRegExp: "Unterminated regular expression.",
	  UnterminatedString: "Unterminated string constant.",
	  UnterminatedTemplate: "Unterminated template.",
	  VarRedeclaration: "Identifier '%0' has already been declared.",
	  YieldBindingIdentifier: "Can not use 'yield' as identifier inside a generator.",
	  YieldInParameter: "Yield expression is not allowed in formal parameters.",
	  ZeroDigitNumericSeparator: "Numeric separator can not be used after leading 0."
	}, ErrorCodes.SyntaxError);
	const SourceTypeModuleErrorMessages = makeErrorTemplates({
	  ImportMetaOutsideModule: `import.meta may appear only with 'sourceType: "module"'`,
	  ImportOutsideModule: `'import' and 'export' may appear only with 'sourceType: "module"'`
	}, ErrorCodes.SourceTypeModuleError);

	function keepReasonCodeCompat(reasonCode, syntaxPlugin) {
	  if (!browser$5.env.BABEL_8_BREAKING) {
	    if (syntaxPlugin === "flow" && reasonCode === "PatternIsOptional") {
	      return "OptionalBindingPattern";
	    }
	  }

	  return reasonCode;
	}

	function makeErrorTemplates(messages, code, syntaxPlugin) {
	  const templates = {};
	  Object.keys(messages).forEach(reasonCode => {
	    templates[reasonCode] = Object.freeze({
	      code,
	      reasonCode: keepReasonCodeCompat(reasonCode, syntaxPlugin),
	      template: messages[reasonCode]
	    });
	  });
	  return Object.freeze(templates);
	}
	class ParserError extends CommentsParser {
	  raise({
	    code,
	    reasonCode,
	    template
	  }, origin, ...params) {
	    return this.raiseWithData(origin.node ? origin.node.loc.start : origin.at, {
	      code,
	      reasonCode
	    }, template, ...params);
	  }

	  raiseOverwrite(loc, {
	    code,
	    template
	  }, ...params) {
	    const pos = loc.index;
	    const message = template.replace(/%(\d+)/g, (_, i) => params[i]) + ` (${loc.line}:${loc.column})`;

	    if (this.options.errorRecovery) {
	      const errors = this.state.errors;

	      for (let i = errors.length - 1; i >= 0; i--) {
	        const error = errors[i];

	        if (error.pos === pos) {
	          return Object.assign(error, {
	            message
	          });
	        } else if (error.pos < pos) {
	          break;
	        }
	      }
	    }

	    return this._raise({
	      code,
	      loc,
	      pos
	    }, message);
	  }

	  raiseWithData(loc, data, errorTemplate, ...params) {
	    const pos = loc.index;
	    const message = errorTemplate.replace(/%(\d+)/g, (_, i) => params[i]) + ` (${loc.line}:${loc.column})`;
	    return this._raise(Object.assign({
	      loc,
	      pos
	    }, data), message);
	  }

	  _raise(errorContext, message) {
	    const err = new SyntaxError(message);
	    Object.assign(err, errorContext);

	    if (this.options.errorRecovery) {
	      if (!this.isLookahead) this.state.errors.push(err);
	      return err;
	    } else {
	      throw err;
	    }
	  }

	}

	const {
	  defineProperty
	} = Object;

	const toUnenumerable = (object, key) => defineProperty(object, key, {
	  enumerable: false,
	  value: object[key]
	});

	function toESTreeLocation(node) {
	  toUnenumerable(node.loc.start, "index");
	  toUnenumerable(node.loc.end, "index");
	  return node;
	}

	var estree = (superClass => class extends superClass {
	  parse() {
	    const file = toESTreeLocation(super.parse());

	    if (this.options.tokens) {
	      file.tokens = file.tokens.map(toESTreeLocation);
	    }

	    return file;
	  }

	  parseRegExpLiteral({
	    pattern,
	    flags
	  }) {
	    let regex = null;

	    try {
	      regex = new RegExp(pattern, flags);
	    } catch (e) {}

	    const node = this.estreeParseLiteral(regex);
	    node.regex = {
	      pattern,
	      flags
	    };
	    return node;
	  }

	  parseBigIntLiteral(value) {
	    let bigInt;

	    try {
	      bigInt = BigInt(value);
	    } catch {
	      bigInt = null;
	    }

	    const node = this.estreeParseLiteral(bigInt);
	    node.bigint = String(node.value || value);
	    return node;
	  }

	  parseDecimalLiteral(value) {
	    const decimal = null;
	    const node = this.estreeParseLiteral(decimal);
	    node.decimal = String(node.value || value);
	    return node;
	  }

	  estreeParseLiteral(value) {
	    return this.parseLiteral(value, "Literal");
	  }

	  parseStringLiteral(value) {
	    return this.estreeParseLiteral(value);
	  }

	  parseNumericLiteral(value) {
	    return this.estreeParseLiteral(value);
	  }

	  parseNullLiteral() {
	    return this.estreeParseLiteral(null);
	  }

	  parseBooleanLiteral(value) {
	    return this.estreeParseLiteral(value);
	  }

	  directiveToStmt(directive) {
	    const directiveLiteral = directive.value;
	    const stmt = this.startNodeAt(directive.start, directive.loc.start);
	    const expression = this.startNodeAt(directiveLiteral.start, directiveLiteral.loc.start);
	    expression.value = directiveLiteral.extra.expressionValue;
	    expression.raw = directiveLiteral.extra.raw;
	    stmt.expression = this.finishNodeAt(expression, "Literal", directiveLiteral.loc.end);
	    stmt.directive = directiveLiteral.extra.raw.slice(1, -1);
	    return this.finishNodeAt(stmt, "ExpressionStatement", directive.loc.end);
	  }

	  initFunction(node, isAsync) {
	    super.initFunction(node, isAsync);
	    node.expression = false;
	  }

	  checkDeclaration(node) {
	    if (node != null && this.isObjectProperty(node)) {
	      this.checkDeclaration(node.value);
	    } else {
	      super.checkDeclaration(node);
	    }
	  }

	  getObjectOrClassMethodParams(method) {
	    return method.value.params;
	  }

	  isValidDirective(stmt) {
	    return stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && typeof stmt.expression.value === "string" && !stmt.expression.extra?.parenthesized;
	  }

	  parseBlockBody(node, ...args) {
	    super.parseBlockBody(node, ...args);
	    const directiveStatements = node.directives.map(d => this.directiveToStmt(d));
	    node.body = directiveStatements.concat(node.body);
	    delete node.directives;
	  }

	  pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
	    this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true);

	    if (method.typeParameters) {
	      method.value.typeParameters = method.typeParameters;
	      delete method.typeParameters;
	    }

	    classBody.body.push(method);
	  }

	  parsePrivateName() {
	    const node = super.parsePrivateName();

	    if (!browser$5.env.BABEL_8_BREAKING) {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return node;
	      }
	    }

	    return this.convertPrivateNameToPrivateIdentifier(node);
	  }

	  convertPrivateNameToPrivateIdentifier(node) {
	    const name = super.getPrivateNameSV(node);
	    node = node;
	    delete node.id;
	    node.name = name;
	    node.type = "PrivateIdentifier";
	    return node;
	  }

	  isPrivateName(node) {
	    if (!browser$5.env.BABEL_8_BREAKING) {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return super.isPrivateName(node);
	      }
	    }

	    return node.type === "PrivateIdentifier";
	  }

	  getPrivateNameSV(node) {
	    if (!browser$5.env.BABEL_8_BREAKING) {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return super.getPrivateNameSV(node);
	      }
	    }

	    return node.name;
	  }

	  parseLiteral(value, type) {
	    const node = super.parseLiteral(value, type);
	    node.raw = node.extra.raw;
	    delete node.extra;
	    return node;
	  }

	  parseFunctionBody(node, allowExpression, isMethod = false) {
	    super.parseFunctionBody(node, allowExpression, isMethod);
	    node.expression = node.body.type !== "BlockStatement";
	  }

	  parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope = false) {
	    let funcNode = this.startNode();
	    funcNode.kind = node.kind;
	    funcNode = super.parseMethod(funcNode, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
	    funcNode.type = "FunctionExpression";
	    delete funcNode.kind;
	    node.value = funcNode;

	    if (type === "ClassPrivateMethod") {
	      node.computed = false;
	    }

	    type = "MethodDefinition";
	    return this.finishNode(node, type);
	  }

	  parseClassProperty(...args) {
	    const propertyNode = super.parseClassProperty(...args);

	    if (!browser$5.env.BABEL_8_BREAKING) {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return propertyNode;
	      }
	    }

	    propertyNode.type = "PropertyDefinition";
	    return propertyNode;
	  }

	  parseClassPrivateProperty(...args) {
	    const propertyNode = super.parseClassPrivateProperty(...args);

	    if (!browser$5.env.BABEL_8_BREAKING) {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return propertyNode;
	      }
	    }

	    propertyNode.type = "PropertyDefinition";
	    propertyNode.computed = false;
	    return propertyNode;
	  }

	  parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
	    const node = super.parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor);

	    if (node) {
	      node.type = "Property";
	      if (node.kind === "method") node.kind = "init";
	      node.shorthand = false;
	    }

	    return node;
	  }

	  parseObjectProperty(prop, startPos, startLoc, isPattern, refExpressionErrors) {
	    const node = super.parseObjectProperty(prop, startPos, startLoc, isPattern, refExpressionErrors);

	    if (node) {
	      node.kind = "init";
	      node.type = "Property";
	    }

	    return node;
	  }

	  isAssignable(node, isBinding) {
	    if (node != null && this.isObjectProperty(node)) {
	      return this.isAssignable(node.value, isBinding);
	    }

	    return super.isAssignable(node, isBinding);
	  }

	  toAssignable(node, isLHS = false) {
	    if (node != null && this.isObjectProperty(node)) {
	      const {
	        key,
	        value
	      } = node;

	      if (this.isPrivateName(key)) {
	        this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
	      }

	      this.toAssignable(value, isLHS);
	      return node;
	    }

	    return super.toAssignable(node, isLHS);
	  }

	  toAssignableObjectExpressionProp(prop, ...args) {
	    if (prop.kind === "get" || prop.kind === "set") {
	      this.raise(ErrorMessages.PatternHasAccessor, {
	        node: prop.key
	      });
	    } else if (prop.method) {
	      this.raise(ErrorMessages.PatternHasMethod, {
	        node: prop.key
	      });
	    } else {
	      super.toAssignableObjectExpressionProp(prop, ...args);
	    }
	  }

	  finishCallExpression(node, optional) {
	    super.finishCallExpression(node, optional);

	    if (node.callee.type === "Import") {
	      node.type = "ImportExpression";
	      node.source = node.arguments[0];

	      if (this.hasPlugin("importAssertions")) {
	        node.attributes = node.arguments[1] ?? null;
	      }

	      delete node.arguments;
	      delete node.callee;
	    }

	    return node;
	  }

	  toReferencedArguments(node) {
	    if (node.type === "ImportExpression") {
	      return;
	    }

	    super.toReferencedArguments(node);
	  }

	  parseExport(node) {
	    super.parseExport(node);

	    switch (node.type) {
	      case "ExportAllDeclaration":
	        node.exported = null;
	        break;

	      case "ExportNamedDeclaration":
	        if (node.specifiers.length === 1 && node.specifiers[0].type === "ExportNamespaceSpecifier") {
	          node.type = "ExportAllDeclaration";
	          node.exported = node.specifiers[0].exported;
	          delete node.specifiers;
	        }

	        break;
	    }

	    return node;
	  }

	  parseSubscript(base, startPos, startLoc, noCalls, state) {
	    const node = super.parseSubscript(base, startPos, startLoc, noCalls, state);

	    if (state.optionalChainMember) {
	      if (node.type === "OptionalMemberExpression" || node.type === "OptionalCallExpression") {
	        node.type = node.type.substring(8);
	      }

	      if (state.stop) {
	        const chain = this.startNodeAtNode(node);
	        chain.expression = node;
	        return this.finishNode(chain, "ChainExpression");
	      }
	    } else if (node.type === "MemberExpression" || node.type === "CallExpression") {
	      node.optional = false;
	    }

	    return node;
	  }

	  hasPropertyAsPrivateName(node) {
	    if (node.type === "ChainExpression") {
	      node = node.expression;
	    }

	    return super.hasPropertyAsPrivateName(node);
	  }

	  isOptionalChain(node) {
	    return node.type === "ChainExpression";
	  }

	  isObjectProperty(node) {
	    return node.type === "Property" && node.kind === "init" && !node.method;
	  }

	  isObjectMethod(node) {
	    return node.method || node.kind === "get" || node.kind === "set";
	  }

	  finishNodeAt(node, type, endLoc) {
	    return toESTreeLocation(super.finishNodeAt(node, type, endLoc));
	  }

	  resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
	    super.resetEndLocation(node, endLoc);
	    toESTreeLocation(node);
	  }

	});

	class TokContext {
	  constructor(token, preserveSpace) {
	    this.token = token;
	    this.preserveSpace = !!preserveSpace;
	  }

	  token;
	  preserveSpace;
	}
	const types = {
	  brace: new TokContext("{"),
	  j_oTag: new TokContext("<tag"),
	  j_cTag: new TokContext("</tag"),
	  j_expr: new TokContext("<tag>...</tag>", true)
	};

	if (!browser$5.env.BABEL_8_BREAKING) {
	  types.template = new TokContext("`", true);
	}

	const beforeExpr = true;
	const startsExpr = true;
	const isLoop = true;
	const isAssign = true;
	const prefix = true;
	const postfix = true;
	class ExportedTokenType {
	  label;
	  keyword;
	  beforeExpr;
	  startsExpr;
	  rightAssociative;
	  isLoop;
	  isAssign;
	  prefix;
	  postfix;
	  binop;

	  constructor(label, conf = {}) {
	    this.label = label;
	    this.keyword = conf.keyword;
	    this.beforeExpr = !!conf.beforeExpr;
	    this.startsExpr = !!conf.startsExpr;
	    this.rightAssociative = !!conf.rightAssociative;
	    this.isLoop = !!conf.isLoop;
	    this.isAssign = !!conf.isAssign;
	    this.prefix = !!conf.prefix;
	    this.postfix = !!conf.postfix;
	    this.binop = conf.binop != null ? conf.binop : null;

	    if (!browser$5.env.BABEL_8_BREAKING) {
	      this.updateContext = null;
	    }
	  }

	}
	const keywords = new Map();

	function createKeyword(name, options = {}) {
	  options.keyword = name;
	  const token = createToken(name, options);
	  keywords.set(name, token);
	  return token;
	}

	function createBinop(name, binop) {
	  return createToken(name, {
	    beforeExpr,
	    binop
	  });
	}

	let tokenTypeCounter = -1;
	const tokenTypes = [];
	const tokenLabels = [];
	const tokenBinops = [];
	const tokenBeforeExprs = [];
	const tokenStartsExprs = [];
	const tokenPrefixes = [];

	function createToken(name, options = {}) {
	  ++tokenTypeCounter;
	  tokenLabels.push(name);
	  tokenBinops.push(options.binop ?? -1);
	  tokenBeforeExprs.push(options.beforeExpr ?? false);
	  tokenStartsExprs.push(options.startsExpr ?? false);
	  tokenPrefixes.push(options.prefix ?? false);
	  tokenTypes.push(new ExportedTokenType(name, options));
	  return tokenTypeCounter;
	}

	function createKeywordLike(name, options = {}) {
	  ++tokenTypeCounter;
	  keywords.set(name, tokenTypeCounter);
	  tokenLabels.push(name);
	  tokenBinops.push(options.binop ?? -1);
	  tokenBeforeExprs.push(options.beforeExpr ?? false);
	  tokenStartsExprs.push(options.startsExpr ?? false);
	  tokenPrefixes.push(options.prefix ?? false);
	  tokenTypes.push(new ExportedTokenType("name", options));
	  return tokenTypeCounter;
	}

	const tt = {
	  bracketL: createToken("[", {
	    beforeExpr,
	    startsExpr
	  }),
	  bracketHashL: createToken("#[", {
	    beforeExpr,
	    startsExpr
	  }),
	  bracketBarL: createToken("[|", {
	    beforeExpr,
	    startsExpr
	  }),
	  bracketR: createToken("]"),
	  bracketBarR: createToken("|]"),
	  braceL: createToken("{", {
	    beforeExpr,
	    startsExpr
	  }),
	  braceBarL: createToken("{|", {
	    beforeExpr,
	    startsExpr
	  }),
	  braceHashL: createToken("#{", {
	    beforeExpr,
	    startsExpr
	  }),
	  braceR: createToken("}", {
	    beforeExpr
	  }),
	  braceBarR: createToken("|}"),
	  parenL: createToken("(", {
	    beforeExpr,
	    startsExpr
	  }),
	  parenR: createToken(")"),
	  comma: createToken(",", {
	    beforeExpr
	  }),
	  semi: createToken(";", {
	    beforeExpr
	  }),
	  colon: createToken(":", {
	    beforeExpr
	  }),
	  doubleColon: createToken("::", {
	    beforeExpr
	  }),
	  dot: createToken("."),
	  question: createToken("?", {
	    beforeExpr
	  }),
	  questionDot: createToken("?."),
	  arrow: createToken("=>", {
	    beforeExpr
	  }),
	  template: createToken("template"),
	  ellipsis: createToken("...", {
	    beforeExpr
	  }),
	  backQuote: createToken("`", {
	    startsExpr
	  }),
	  dollarBraceL: createToken("${", {
	    beforeExpr,
	    startsExpr
	  }),
	  templateTail: createToken("...`", {
	    startsExpr
	  }),
	  templateNonTail: createToken("...${", {
	    beforeExpr,
	    startsExpr
	  }),
	  at: createToken("@"),
	  hash: createToken("#", {
	    startsExpr
	  }),
	  interpreterDirective: createToken("#!..."),
	  eq: createToken("=", {
	    beforeExpr,
	    isAssign
	  }),
	  assign: createToken("_=", {
	    beforeExpr,
	    isAssign
	  }),
	  slashAssign: createToken("_=", {
	    beforeExpr,
	    isAssign
	  }),
	  xorAssign: createToken("_=", {
	    beforeExpr,
	    isAssign
	  }),
	  moduloAssign: createToken("_=", {
	    beforeExpr,
	    isAssign
	  }),
	  incDec: createToken("++/--", {
	    prefix,
	    postfix,
	    startsExpr
	  }),
	  bang: createToken("!", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  tilde: createToken("~", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  doubleCaret: createToken("^^", {
	    startsExpr
	  }),
	  doubleAt: createToken("@@", {
	    startsExpr
	  }),
	  pipeline: createBinop("|>", 0),
	  nullishCoalescing: createBinop("??", 1),
	  logicalOR: createBinop("||", 1),
	  logicalAND: createBinop("&&", 2),
	  bitwiseOR: createBinop("|", 3),
	  bitwiseXOR: createBinop("^", 4),
	  bitwiseAND: createBinop("&", 5),
	  equality: createBinop("==/!=/===/!==", 6),
	  lt: createBinop("</>/<=/>=", 7),
	  gt: createBinop("</>/<=/>=", 7),
	  relational: createBinop("</>/<=/>=", 7),
	  bitShift: createBinop("<</>>/>>>", 8),
	  bitShiftL: createBinop("<</>>/>>>", 8),
	  bitShiftR: createBinop("<</>>/>>>", 8),
	  plusMin: createToken("+/-", {
	    beforeExpr,
	    binop: 9,
	    prefix,
	    startsExpr
	  }),
	  modulo: createToken("%", {
	    binop: 10,
	    startsExpr
	  }),
	  star: createToken("*", {
	    binop: 10
	  }),
	  slash: createBinop("/", 10),
	  exponent: createToken("**", {
	    beforeExpr,
	    binop: 11,
	    rightAssociative: true
	  }),
	  _in: createKeyword("in", {
	    beforeExpr,
	    binop: 7
	  }),
	  _instanceof: createKeyword("instanceof", {
	    beforeExpr,
	    binop: 7
	  }),
	  _break: createKeyword("break"),
	  _case: createKeyword("case", {
	    beforeExpr
	  }),
	  _catch: createKeyword("catch"),
	  _continue: createKeyword("continue"),
	  _debugger: createKeyword("debugger"),
	  _default: createKeyword("default", {
	    beforeExpr
	  }),
	  _else: createKeyword("else", {
	    beforeExpr
	  }),
	  _finally: createKeyword("finally"),
	  _function: createKeyword("function", {
	    startsExpr
	  }),
	  _if: createKeyword("if"),
	  _return: createKeyword("return", {
	    beforeExpr
	  }),
	  _switch: createKeyword("switch"),
	  _throw: createKeyword("throw", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  _try: createKeyword("try"),
	  _var: createKeyword("var"),
	  _const: createKeyword("const"),
	  _with: createKeyword("with"),
	  _new: createKeyword("new", {
	    beforeExpr,
	    startsExpr
	  }),
	  _this: createKeyword("this", {
	    startsExpr
	  }),
	  _super: createKeyword("super", {
	    startsExpr
	  }),
	  _class: createKeyword("class", {
	    startsExpr
	  }),
	  _extends: createKeyword("extends", {
	    beforeExpr
	  }),
	  _export: createKeyword("export"),
	  _import: createKeyword("import", {
	    startsExpr
	  }),
	  _null: createKeyword("null", {
	    startsExpr
	  }),
	  _true: createKeyword("true", {
	    startsExpr
	  }),
	  _false: createKeyword("false", {
	    startsExpr
	  }),
	  _typeof: createKeyword("typeof", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  _void: createKeyword("void", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  _delete: createKeyword("delete", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  _do: createKeyword("do", {
	    isLoop,
	    beforeExpr
	  }),
	  _for: createKeyword("for", {
	    isLoop
	  }),
	  _while: createKeyword("while", {
	    isLoop
	  }),
	  _as: createKeywordLike("as", {
	    startsExpr
	  }),
	  _assert: createKeywordLike("assert", {
	    startsExpr
	  }),
	  _async: createKeywordLike("async", {
	    startsExpr
	  }),
	  _await: createKeywordLike("await", {
	    startsExpr
	  }),
	  _from: createKeywordLike("from", {
	    startsExpr
	  }),
	  _get: createKeywordLike("get", {
	    startsExpr
	  }),
	  _let: createKeywordLike("let", {
	    startsExpr
	  }),
	  _meta: createKeywordLike("meta", {
	    startsExpr
	  }),
	  _of: createKeywordLike("of", {
	    startsExpr
	  }),
	  _sent: createKeywordLike("sent", {
	    startsExpr
	  }),
	  _set: createKeywordLike("set", {
	    startsExpr
	  }),
	  _static: createKeywordLike("static", {
	    startsExpr
	  }),
	  _yield: createKeywordLike("yield", {
	    startsExpr
	  }),
	  _asserts: createKeywordLike("asserts", {
	    startsExpr
	  }),
	  _checks: createKeywordLike("checks", {
	    startsExpr
	  }),
	  _exports: createKeywordLike("exports", {
	    startsExpr
	  }),
	  _global: createKeywordLike("global", {
	    startsExpr
	  }),
	  _implements: createKeywordLike("implements", {
	    startsExpr
	  }),
	  _intrinsic: createKeywordLike("intrinsic", {
	    startsExpr
	  }),
	  _infer: createKeywordLike("infer", {
	    startsExpr
	  }),
	  _is: createKeywordLike("is", {
	    startsExpr
	  }),
	  _mixins: createKeywordLike("mixins", {
	    startsExpr
	  }),
	  _proto: createKeywordLike("proto", {
	    startsExpr
	  }),
	  _require: createKeywordLike("require", {
	    startsExpr
	  }),
	  _keyof: createKeywordLike("keyof", {
	    startsExpr
	  }),
	  _readonly: createKeywordLike("readonly", {
	    startsExpr
	  }),
	  _unique: createKeywordLike("unique", {
	    startsExpr
	  }),
	  _abstract: createKeywordLike("abstract", {
	    startsExpr
	  }),
	  _declare: createKeywordLike("declare", {
	    startsExpr
	  }),
	  _enum: createKeywordLike("enum", {
	    startsExpr
	  }),
	  _module: createKeywordLike("module", {
	    startsExpr
	  }),
	  _namespace: createKeywordLike("namespace", {
	    startsExpr
	  }),
	  _interface: createKeywordLike("interface", {
	    startsExpr
	  }),
	  _type: createKeywordLike("type", {
	    startsExpr
	  }),
	  _opaque: createKeywordLike("opaque", {
	    startsExpr
	  }),
	  name: createToken("name", {
	    startsExpr
	  }),
	  string: createToken("string", {
	    startsExpr
	  }),
	  num: createToken("num", {
	    startsExpr
	  }),
	  bigint: createToken("bigint", {
	    startsExpr
	  }),
	  decimal: createToken("decimal", {
	    startsExpr
	  }),
	  regexp: createToken("regexp", {
	    startsExpr
	  }),
	  privateName: createToken("#name", {
	    startsExpr
	  }),
	  eof: createToken("eof"),
	  jsxName: createToken("jsxName"),
	  jsxText: createToken("jsxText", {
	    beforeExpr: true
	  }),
	  jsxTagStart: createToken("jsxTagStart", {
	    startsExpr: true
	  }),
	  jsxTagEnd: createToken("jsxTagEnd"),
	  placeholder: createToken("%%", {
	    startsExpr: true
	  })
	};
	function tokenIsIdentifier(token) {
	  return token >= 93 && token <= 128;
	}
	function tokenKeywordOrIdentifierIsKeyword(token) {
	  return token <= 92;
	}
	function tokenIsKeywordOrIdentifier(token) {
	  return token >= 58 && token <= 128;
	}
	function tokenIsLiteralPropertyName(token) {
	  return token >= 58 && token <= 132;
	}
	function tokenComesBeforeExpression(token) {
	  return tokenBeforeExprs[token];
	}
	function tokenCanStartExpression(token) {
	  return tokenStartsExprs[token];
	}
	function tokenIsAssignment(token) {
	  return token >= 29 && token <= 33;
	}
	function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
	  return token >= 125 && token <= 127;
	}
	function tokenIsLoop(token) {
	  return token >= 90 && token <= 92;
	}
	function tokenIsKeyword(token) {
	  return token >= 58 && token <= 92;
	}
	function tokenIsOperator(token) {
	  return token >= 39 && token <= 59;
	}
	function tokenIsPostfix(token) {
	  return token === 34;
	}
	function tokenIsPrefix(token) {
	  return tokenPrefixes[token];
	}
	function tokenIsTSTypeOperator(token) {
	  return token >= 117 && token <= 119;
	}
	function tokenIsTSDeclarationStart(token) {
	  return token >= 120 && token <= 126;
	}
	function tokenLabelName(token) {
	  return tokenLabels[token];
	}
	function tokenOperatorPrecedence(token) {
	  return tokenBinops[token];
	}
	function tokenIsRightAssociative(token) {
	  return token === 57;
	}
	function tokenIsTemplate(token) {
	  return token >= 24 && token <= 25;
	}
	function getExportedToken(token) {
	  return tokenTypes[token];
	}

	if (!browser$5.env.BABEL_8_BREAKING) {
	  tokenTypes[8].updateContext = context => {
	    context.pop();
	  };

	  tokenTypes[5].updateContext = tokenTypes[7].updateContext = tokenTypes[23].updateContext = context => {
	    context.push(types.brace);
	  };

	  tokenTypes[22].updateContext = context => {
	    if (context[context.length - 1] === types.template) {
	      context.pop();
	    } else {
	      context.push(types.template);
	    }
	  };

	  tokenTypes[138].updateContext = context => {
	    context.push(types.j_expr, types.j_oTag);
	  };
	}

	class Position {
	  line;
	  column;
	  index;

	  constructor(line, col, index) {
	    this.line = line;
	    this.column = col;
	    this.index = index;
	  }

	}
	class SourceLocation {
	  start;
	  end;
	  filename;
	  identifierName;

	  constructor(start, end) {
	    this.start = start;
	    this.end = end;
	  }

	}
	function createPositionWithColumnOffset(position, columnOffset) {
	  const {
	    line,
	    column,
	    index
	  } = position;
	  return new Position(line, column + columnOffset, index + columnOffset);
	}

	function isIteratorStart(current, next, next2) {
	  return current === 64 && next === 64 && isIdentifierStart(next2);
	}
	const reservedWordLikeSet = new Set(["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete", "implements", "interface", "let", "package", "private", "protected", "public", "static", "yield", "eval", "arguments", "enum", "await"]);
	function canBeReservedWord(word) {
	  return reservedWordLikeSet.has(word);
	}

	const SCOPE_OTHER = 0b000000000,
	      SCOPE_PROGRAM = 0b000000001,
	      SCOPE_FUNCTION = 0b000000010,
	      SCOPE_ARROW = 0b000000100,
	      SCOPE_SIMPLE_CATCH = 0b000001000,
	      SCOPE_SUPER = 0b000010000,
	      SCOPE_DIRECT_SUPER = 0b000100000,
	      SCOPE_CLASS = 0b001000000,
	      SCOPE_STATIC_BLOCK = 0b010000000,
	      SCOPE_TS_MODULE = 0b100000000,
	      SCOPE_VAR = SCOPE_PROGRAM | SCOPE_FUNCTION | SCOPE_TS_MODULE;
	const BIND_KIND_VALUE = 0b000000_0000_01,
	      BIND_KIND_TYPE = 0b000000_0000_10,
	      BIND_SCOPE_VAR = 0b000000_0001_00,
	      BIND_SCOPE_LEXICAL = 0b000000_0010_00,
	      BIND_SCOPE_FUNCTION = 0b000000_0100_00,
	      BIND_FLAGS_NONE = 0b000001_0000_00,
	      BIND_FLAGS_CLASS = 0b000010_0000_00,
	      BIND_FLAGS_TS_ENUM = 0b000100_0000_00,
	      BIND_FLAGS_TS_CONST_ENUM = 0b001000_0000_00,
	      BIND_FLAGS_TS_EXPORT_ONLY = 0b010000_0000_00,
	      BIND_FLAGS_FLOW_DECLARE_FN = 0b100000_0000_00;
	const BIND_CLASS = BIND_KIND_VALUE | BIND_KIND_TYPE | BIND_SCOPE_LEXICAL | BIND_FLAGS_CLASS,
	      BIND_LEXICAL = BIND_KIND_VALUE | 0 | BIND_SCOPE_LEXICAL | 0,
	      BIND_VAR = BIND_KIND_VALUE | 0 | BIND_SCOPE_VAR | 0,
	      BIND_FUNCTION = BIND_KIND_VALUE | 0 | BIND_SCOPE_FUNCTION | 0,
	      BIND_TS_INTERFACE = 0 | BIND_KIND_TYPE | 0 | BIND_FLAGS_CLASS,
	      BIND_TS_TYPE = 0 | BIND_KIND_TYPE | 0 | 0,
	      BIND_TS_ENUM = BIND_KIND_VALUE | BIND_KIND_TYPE | BIND_SCOPE_LEXICAL | BIND_FLAGS_TS_ENUM,
	      BIND_TS_AMBIENT = 0 | 0 | 0 | BIND_FLAGS_TS_EXPORT_ONLY,
	      BIND_NONE = 0 | 0 | 0 | BIND_FLAGS_NONE,
	      BIND_OUTSIDE = BIND_KIND_VALUE | 0 | 0 | BIND_FLAGS_NONE,
	      BIND_TS_CONST_ENUM = BIND_TS_ENUM | BIND_FLAGS_TS_CONST_ENUM,
	      BIND_TS_NAMESPACE = 0 | 0 | 0 | BIND_FLAGS_TS_EXPORT_ONLY,
	      BIND_FLOW_DECLARE_FN = BIND_FLAGS_FLOW_DECLARE_FN;
	const CLASS_ELEMENT_FLAG_STATIC = 0b1_00,
	      CLASS_ELEMENT_KIND_GETTER = 0b0_10,
	      CLASS_ELEMENT_KIND_SETTER = 0b0_01,
	      CLASS_ELEMENT_KIND_ACCESSOR = CLASS_ELEMENT_KIND_GETTER | CLASS_ELEMENT_KIND_SETTER;
	const CLASS_ELEMENT_STATIC_GETTER = CLASS_ELEMENT_KIND_GETTER | CLASS_ELEMENT_FLAG_STATIC,
	      CLASS_ELEMENT_STATIC_SETTER = CLASS_ELEMENT_KIND_SETTER | CLASS_ELEMENT_FLAG_STATIC,
	      CLASS_ELEMENT_INSTANCE_GETTER = CLASS_ELEMENT_KIND_GETTER,
	      CLASS_ELEMENT_INSTANCE_SETTER = CLASS_ELEMENT_KIND_SETTER,
	      CLASS_ELEMENT_OTHER = 0;

	class Scope {
	  var = new Set();
	  lexical = new Set();
	  functions = new Set();

	  constructor(flags) {
	    this.flags = flags;
	  }

	}
	class ScopeHandler {
	  scopeStack = [];
	  undefinedExports = new Map();

	  constructor(raise, inModule) {
	    this.raise = raise;
	    this.inModule = inModule;
	  }

	  get inFunction() {
	    return (this.currentVarScopeFlags() & SCOPE_FUNCTION) > 0;
	  }

	  get allowSuper() {
	    return (this.currentThisScopeFlags() & SCOPE_SUPER) > 0;
	  }

	  get allowDirectSuper() {
	    return (this.currentThisScopeFlags() & SCOPE_DIRECT_SUPER) > 0;
	  }

	  get inClass() {
	    return (this.currentThisScopeFlags() & SCOPE_CLASS) > 0;
	  }

	  get inClassAndNotInNonArrowFunction() {
	    const flags = this.currentThisScopeFlags();
	    return (flags & SCOPE_CLASS) > 0 && (flags & SCOPE_FUNCTION) === 0;
	  }

	  get inStaticBlock() {
	    for (let i = this.scopeStack.length - 1;; i--) {
	      const {
	        flags
	      } = this.scopeStack[i];

	      if (flags & SCOPE_STATIC_BLOCK) {
	        return true;
	      }

	      if (flags & (SCOPE_VAR | SCOPE_CLASS)) {
	        return false;
	      }
	    }
	  }

	  get inNonArrowFunction() {
	    return (this.currentThisScopeFlags() & SCOPE_FUNCTION) > 0;
	  }

	  get treatFunctionsAsVar() {
	    return this.treatFunctionsAsVarInScope(this.currentScope());
	  }

	  createScope(flags) {
	    return new Scope(flags);
	  }

	  enter(flags) {
	    this.scopeStack.push(this.createScope(flags));
	  }

	  exit() {
	    this.scopeStack.pop();
	  }

	  treatFunctionsAsVarInScope(scope) {
	    return !!(scope.flags & SCOPE_FUNCTION || !this.inModule && scope.flags & SCOPE_PROGRAM);
	  }

	  declareName(name, bindingType, loc) {
	    let scope = this.currentScope();

	    if (bindingType & BIND_SCOPE_LEXICAL || bindingType & BIND_SCOPE_FUNCTION) {
	      this.checkRedeclarationInScope(scope, name, bindingType, loc);

	      if (bindingType & BIND_SCOPE_FUNCTION) {
	        scope.functions.add(name);
	      } else {
	        scope.lexical.add(name);
	      }

	      if (bindingType & BIND_SCOPE_LEXICAL) {
	        this.maybeExportDefined(scope, name);
	      }
	    } else if (bindingType & BIND_SCOPE_VAR) {
	      for (let i = this.scopeStack.length - 1; i >= 0; --i) {
	        scope = this.scopeStack[i];
	        this.checkRedeclarationInScope(scope, name, bindingType, loc);
	        scope.var.add(name);
	        this.maybeExportDefined(scope, name);
	        if (scope.flags & SCOPE_VAR) break;
	      }
	    }

	    if (this.inModule && scope.flags & SCOPE_PROGRAM) {
	      this.undefinedExports.delete(name);
	    }
	  }

	  maybeExportDefined(scope, name) {
	    if (this.inModule && scope.flags & SCOPE_PROGRAM) {
	      this.undefinedExports.delete(name);
	    }
	  }

	  checkRedeclarationInScope(scope, name, bindingType, loc) {
	    if (this.isRedeclaredInScope(scope, name, bindingType)) {
	      this.raise(ErrorMessages.VarRedeclaration, {
	        at: loc
	      }, name);
	    }
	  }

	  isRedeclaredInScope(scope, name, bindingType) {
	    if (!(bindingType & BIND_KIND_VALUE)) return false;

	    if (bindingType & BIND_SCOPE_LEXICAL) {
	      return scope.lexical.has(name) || scope.functions.has(name) || scope.var.has(name);
	    }

	    if (bindingType & BIND_SCOPE_FUNCTION) {
	      return scope.lexical.has(name) || !this.treatFunctionsAsVarInScope(scope) && scope.var.has(name);
	    }

	    return scope.lexical.has(name) && !(scope.flags & SCOPE_SIMPLE_CATCH && scope.lexical.values().next().value === name) || !this.treatFunctionsAsVarInScope(scope) && scope.functions.has(name);
	  }

	  checkLocalExport(id) {
	    const {
	      name
	    } = id;
	    const topLevelScope = this.scopeStack[0];

	    if (!topLevelScope.lexical.has(name) && !topLevelScope.var.has(name) && !topLevelScope.functions.has(name)) {
	      this.undefinedExports.set(name, id.loc.start);
	    }
	  }

	  currentScope() {
	    return this.scopeStack[this.scopeStack.length - 1];
	  }

	  currentVarScopeFlags() {
	    for (let i = this.scopeStack.length - 1;; i--) {
	      const {
	        flags
	      } = this.scopeStack[i];

	      if (flags & SCOPE_VAR) {
	        return flags;
	      }
	    }
	  }

	  currentThisScopeFlags() {
	    for (let i = this.scopeStack.length - 1;; i--) {
	      const {
	        flags
	      } = this.scopeStack[i];

	      if (flags & (SCOPE_VAR | SCOPE_CLASS) && !(flags & SCOPE_ARROW)) {
	        return flags;
	      }
	    }
	  }

	}

	class FlowScope extends Scope {
	  declareFunctions = new Set();
	}

	class FlowScopeHandler extends ScopeHandler {
	  createScope(flags) {
	    return new FlowScope(flags);
	  }

	  declareName(name, bindingType, loc) {
	    const scope = this.currentScope();

	    if (bindingType & BIND_FLAGS_FLOW_DECLARE_FN) {
	      this.checkRedeclarationInScope(scope, name, bindingType, loc);
	      this.maybeExportDefined(scope, name);
	      scope.declareFunctions.add(name);
	      return;
	    }

	    super.declareName(...arguments);
	  }

	  isRedeclaredInScope(scope, name, bindingType) {
	    if (super.isRedeclaredInScope(...arguments)) return true;

	    if (bindingType & BIND_FLAGS_FLOW_DECLARE_FN) {
	      return !scope.declareFunctions.has(name) && (scope.lexical.has(name) || scope.functions.has(name));
	    }

	    return false;
	  }

	  checkLocalExport(id) {
	    if (!this.scopeStack[0].declareFunctions.has(id.name)) {
	      super.checkLocalExport(id);
	    }
	  }

	}

	const lineBreak = /\r\n?|[\n\u2028\u2029]/;
	const lineBreakG = new RegExp(lineBreak.source, "g");
	function isNewLine(code) {
	  switch (code) {
	    case 10:
	    case 13:
	    case 8232:
	    case 8233:
	      return true;

	    default:
	      return false;
	  }
	}
	const skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
	const skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/y;
	const skipWhiteSpaceToLineBreak = new RegExp("(?=(" + skipWhiteSpaceInLine.source + "))\\1" + /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source, "y");
	function isWhitespace(code) {
	  switch (code) {
	    case 0x0009:
	    case 0x000b:
	    case 0x000c:
	    case 32:
	    case 160:
	    case 5760:
	    case 0x2000:
	    case 0x2001:
	    case 0x2002:
	    case 0x2003:
	    case 0x2004:
	    case 0x2005:
	    case 0x2006:
	    case 0x2007:
	    case 0x2008:
	    case 0x2009:
	    case 0x200a:
	    case 0x202f:
	    case 0x205f:
	    case 0x3000:
	    case 0xfeff:
	      return true;

	    default:
	      return false;
	  }
	}

	class State {
	  strict;
	  curLine;
	  lineStart;
	  startLoc;
	  endLoc;

	  init({
	    strictMode,
	    sourceType,
	    startLine,
	    startColumn
	  }) {
	    this.strict = strictMode === false ? false : strictMode === true ? true : sourceType === "module";
	    this.curLine = startLine;
	    this.lineStart = -startColumn;
	    this.startLoc = this.endLoc = new Position(startLine, startColumn, 0);
	  }

	  errors = [];
	  potentialArrowAt = -1;
	  noArrowAt = [];
	  noArrowParamsConversionAt = [];
	  maybeInArrowParameters = false;
	  inType = false;
	  noAnonFunctionType = false;
	  hasFlowComment = false;
	  isAmbientContext = false;
	  inAbstractClass = false;
	  topicContext = {
	    maxNumOfResolvableTopics: 0,
	    maxTopicIndex: null
	  };
	  soloAwait = false;
	  inFSharpPipelineDirectBody = false;
	  labels = [];
	  decoratorStack = [[]];
	  comments = [];
	  commentStack = [];
	  pos = 0;
	  type = 135;
	  value = null;
	  start = 0;
	  end = 0;
	  lastTokEndLoc = null;
	  lastTokStartLoc = null;
	  lastTokStart = 0;
	  context = [types.brace];
	  canStartJSXElement = true;
	  containsEsc = false;
	  strictErrors = new Map();
	  tokensLength = 0;

	  curPosition() {
	    return new Position(this.curLine, this.pos - this.lineStart, this.pos);
	  }

	  clone(skipArrays) {
	    const state = new State();
	    const keys = Object.keys(this);

	    for (let i = 0, length = keys.length; i < length; i++) {
	      const key = keys[i];
	      let val = this[key];

	      if (!skipArrays && Array.isArray(val)) {
	        val = val.slice();
	      }

	      state[key] = val;
	    }

	    return state;
	  }

	}

	var _isDigit = function isDigit(code) {
	  return code >= 48 && code <= 57;
	};
	const VALID_REGEX_FLAGS = new Set([103, 109, 115, 105, 121, 117, 100, 118]);
	const forbiddenNumericSeparatorSiblings = {
	  decBinOct: [46, 66, 69, 79, 95, 98, 101, 111],
	  hex: [46, 88, 95, 120]
	};
	const allowedNumericSeparatorSiblings = {};
	allowedNumericSeparatorSiblings.bin = [48, 49];
	allowedNumericSeparatorSiblings.oct = [...allowedNumericSeparatorSiblings.bin, 50, 51, 52, 53, 54, 55];
	allowedNumericSeparatorSiblings.dec = [...allowedNumericSeparatorSiblings.oct, 56, 57];
	allowedNumericSeparatorSiblings.hex = [...allowedNumericSeparatorSiblings.dec, 65, 66, 67, 68, 69, 70, 97, 98, 99, 100, 101, 102];
	class Token {
	  constructor(state) {
	    this.type = state.type;
	    this.value = state.value;
	    this.start = state.start;
	    this.end = state.end;
	    this.loc = new SourceLocation(state.startLoc, state.endLoc);
	  }

	}
	class Tokenizer extends ParserError {
	  isLookahead;
	  tokens = [];

	  constructor(options, input) {
	    super();
	    this.state = new State();
	    this.state.init(options);
	    this.input = input;
	    this.length = input.length;
	    this.isLookahead = false;
	  }

	  pushToken(token) {
	    this.tokens.length = this.state.tokensLength;
	    this.tokens.push(token);
	    ++this.state.tokensLength;
	  }

	  next() {
	    this.checkKeywordEscapes();

	    if (this.options.tokens) {
	      this.pushToken(new Token(this.state));
	    }

	    this.state.lastTokStart = this.state.start;
	    this.state.lastTokEndLoc = this.state.endLoc;
	    this.state.lastTokStartLoc = this.state.startLoc;
	    this.nextToken();
	  }

	  eat(type) {
	    if (this.match(type)) {
	      this.next();
	      return true;
	    } else {
	      return false;
	    }
	  }

	  match(type) {
	    return this.state.type === type;
	  }

	  createLookaheadState(state) {
	    return {
	      pos: state.pos,
	      value: null,
	      type: state.type,
	      start: state.start,
	      end: state.end,
	      context: [this.curContext()],
	      inType: state.inType,
	      startLoc: state.startLoc,
	      lastTokEndLoc: state.lastTokEndLoc,
	      curLine: state.curLine,
	      lineStart: state.lineStart,
	      curPosition: state.curPosition
	    };
	  }

	  lookahead() {
	    const old = this.state;
	    this.state = this.createLookaheadState(old);
	    this.isLookahead = true;
	    this.nextToken();
	    this.isLookahead = false;
	    const curr = this.state;
	    this.state = old;
	    return curr;
	  }

	  nextTokenStart() {
	    return this.nextTokenStartSince(this.state.pos);
	  }

	  nextTokenStartSince(pos) {
	    skipWhiteSpace.lastIndex = pos;
	    return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
	  }

	  lookaheadCharCode() {
	    return this.input.charCodeAt(this.nextTokenStart());
	  }

	  codePointAtPos(pos) {
	    let cp = this.input.charCodeAt(pos);

	    if ((cp & 0xfc00) === 0xd800 && ++pos < this.input.length) {
	      const trail = this.input.charCodeAt(pos);

	      if ((trail & 0xfc00) === 0xdc00) {
	        cp = 0x10000 + ((cp & 0x3ff) << 10) + (trail & 0x3ff);
	      }
	    }

	    return cp;
	  }

	  setStrict(strict) {
	    this.state.strict = strict;

	    if (strict) {
	      this.state.strictErrors.forEach(({
	        message,
	        loc
	      }) => this.raise(message, {
	        at: loc
	      }));
	      this.state.strictErrors.clear();
	    }
	  }

	  curContext() {
	    return this.state.context[this.state.context.length - 1];
	  }

	  nextToken() {
	    this.skipSpace();
	    this.state.start = this.state.pos;
	    if (!this.isLookahead) this.state.startLoc = this.state.curPosition();

	    if (this.state.pos >= this.length) {
	      this.finishToken(135);
	      return;
	    }

	    this.getTokenFromCode(this.codePointAtPos(this.state.pos));
	  }

	  skipBlockComment() {
	    let startLoc;
	    if (!this.isLookahead) startLoc = this.state.curPosition();
	    const start = this.state.pos;
	    const end = this.input.indexOf("*/", start + 2);

	    if (end === -1) {
	      throw this.raise(ErrorMessages.UnterminatedComment, {
	        at: this.state.curPosition()
	      });
	    }

	    this.state.pos = end + 2;
	    lineBreakG.lastIndex = start + 2;

	    while (lineBreakG.test(this.input) && lineBreakG.lastIndex <= end) {
	      ++this.state.curLine;
	      this.state.lineStart = lineBreakG.lastIndex;
	    }

	    if (this.isLookahead) return;
	    const comment = {
	      type: "CommentBlock",
	      value: this.input.slice(start + 2, end),
	      start,
	      end: end + 2,
	      loc: new SourceLocation(startLoc, this.state.curPosition())
	    };
	    if (this.options.tokens) this.pushToken(comment);
	    return comment;
	  }

	  skipLineComment(startSkip) {
	    const start = this.state.pos;
	    let startLoc;
	    if (!this.isLookahead) startLoc = this.state.curPosition();
	    let ch = this.input.charCodeAt(this.state.pos += startSkip);

	    if (this.state.pos < this.length) {
	      while (!isNewLine(ch) && ++this.state.pos < this.length) {
	        ch = this.input.charCodeAt(this.state.pos);
	      }
	    }

	    if (this.isLookahead) return;
	    const end = this.state.pos;
	    const value = this.input.slice(start + startSkip, end);
	    const comment = {
	      type: "CommentLine",
	      value,
	      start,
	      end,
	      loc: new SourceLocation(startLoc, this.state.curPosition())
	    };
	    if (this.options.tokens) this.pushToken(comment);
	    return comment;
	  }

	  skipSpace() {
	    const spaceStart = this.state.pos;
	    const comments = [];

	    loop: while (this.state.pos < this.length) {
	      const ch = this.input.charCodeAt(this.state.pos);

	      switch (ch) {
	        case 32:
	        case 160:
	        case 9:
	          ++this.state.pos;
	          break;

	        case 13:
	          if (this.input.charCodeAt(this.state.pos + 1) === 10) {
	            ++this.state.pos;
	          }

	        case 10:
	        case 8232:
	        case 8233:
	          ++this.state.pos;
	          ++this.state.curLine;
	          this.state.lineStart = this.state.pos;
	          break;

	        case 47:
	          switch (this.input.charCodeAt(this.state.pos + 1)) {
	            case 42:
	              {
	                const comment = this.skipBlockComment();

	                if (comment !== undefined) {
	                  this.addComment(comment);
	                  if (this.options.attachComment) comments.push(comment);
	                }

	                break;
	              }

	            case 47:
	              {
	                const comment = this.skipLineComment(2);

	                if (comment !== undefined) {
	                  this.addComment(comment);
	                  if (this.options.attachComment) comments.push(comment);
	                }

	                break;
	              }

	            default:
	              break loop;
	          }

	          break;

	        default:
	          if (isWhitespace(ch)) {
	            ++this.state.pos;
	          } else if (ch === 45 && !this.inModule) {
	            const pos = this.state.pos;

	            if (this.input.charCodeAt(pos + 1) === 45 && this.input.charCodeAt(pos + 2) === 62 && (spaceStart === 0 || this.state.lineStart > spaceStart)) {
	              const comment = this.skipLineComment(3);

	              if (comment !== undefined) {
	                this.addComment(comment);
	                if (this.options.attachComment) comments.push(comment);
	              }
	            } else {
	              break loop;
	            }
	          } else if (ch === 60 && !this.inModule) {
	            const pos = this.state.pos;

	            if (this.input.charCodeAt(pos + 1) === 33 && this.input.charCodeAt(pos + 2) === 45 && this.input.charCodeAt(pos + 3) === 45) {
	              const comment = this.skipLineComment(4);

	              if (comment !== undefined) {
	                this.addComment(comment);
	                if (this.options.attachComment) comments.push(comment);
	              }
	            } else {
	              break loop;
	            }
	          } else {
	            break loop;
	          }

	      }
	    }

	    if (comments.length > 0) {
	      const end = this.state.pos;
	      const CommentWhitespace = {
	        start: spaceStart,
	        end,
	        comments,
	        leadingNode: null,
	        trailingNode: null,
	        containingNode: null
	      };
	      this.state.commentStack.push(CommentWhitespace);
	    }
	  }

	  finishToken(type, val) {
	    this.state.end = this.state.pos;
	    this.state.endLoc = this.state.curPosition();
	    const prevType = this.state.type;
	    this.state.type = type;
	    this.state.value = val;

	    if (!this.isLookahead) {
	      this.updateContext(prevType);
	    }
	  }

	  replaceToken(type) {
	    this.state.type = type;
	    this.updateContext();
	  }

	  readToken_numberSign() {
	    if (this.state.pos === 0 && this.readToken_interpreter()) {
	      return;
	    }

	    const nextPos = this.state.pos + 1;
	    const next = this.codePointAtPos(nextPos);

	    if (next >= 48 && next <= 57) {
	      throw this.raise(ErrorMessages.UnexpectedDigitAfterHash, {
	        at: this.state.curPosition()
	      });
	    }

	    if (next === 123 || next === 91 && this.hasPlugin("recordAndTuple")) {
	      this.expectPlugin("recordAndTuple");

	      if (this.getPluginOption("recordAndTuple", "syntaxType") !== "hash") {
	        throw this.raise(next === 123 ? ErrorMessages.RecordExpressionHashIncorrectStartSyntaxType : ErrorMessages.TupleExpressionHashIncorrectStartSyntaxType, {
	          at: this.state.curPosition()
	        });
	      }

	      this.state.pos += 2;

	      if (next === 123) {
	        this.finishToken(7);
	      } else {
	        this.finishToken(1);
	      }
	    } else if (isIdentifierStart(next)) {
	      ++this.state.pos;
	      this.finishToken(134, this.readWord1(next));
	    } else if (next === 92) {
	      ++this.state.pos;
	      this.finishToken(134, this.readWord1());
	    } else {
	      this.finishOp(27, 1);
	    }
	  }

	  readToken_dot() {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (next >= 48 && next <= 57) {
	      this.readNumber(true);
	      return;
	    }

	    if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
	      this.state.pos += 3;
	      this.finishToken(21);
	    } else {
	      ++this.state.pos;
	      this.finishToken(16);
	    }
	  }

	  readToken_slash() {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (next === 61) {
	      this.finishOp(31, 2);
	    } else {
	      this.finishOp(56, 1);
	    }
	  }

	  readToken_interpreter() {
	    if (this.state.pos !== 0 || this.length < 2) return false;
	    let ch = this.input.charCodeAt(this.state.pos + 1);
	    if (ch !== 33) return false;
	    const start = this.state.pos;
	    this.state.pos += 1;

	    while (!isNewLine(ch) && ++this.state.pos < this.length) {
	      ch = this.input.charCodeAt(this.state.pos);
	    }

	    const value = this.input.slice(start + 2, this.state.pos);
	    this.finishToken(28, value);
	    return true;
	  }

	  readToken_mult_modulo(code) {
	    let type = code === 42 ? 55 : 54;
	    let width = 1;
	    let next = this.input.charCodeAt(this.state.pos + 1);

	    if (code === 42 && next === 42) {
	      width++;
	      next = this.input.charCodeAt(this.state.pos + 2);
	      type = 57;
	    }

	    if (next === 61 && !this.state.inType) {
	      width++;
	      type = code === 37 ? 33 : 30;
	    }

	    this.finishOp(type, width);
	  }

	  readToken_pipe_amp(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (next === code) {
	      if (this.input.charCodeAt(this.state.pos + 2) === 61) {
	        this.finishOp(30, 3);
	      } else {
	        this.finishOp(code === 124 ? 41 : 42, 2);
	      }

	      return;
	    }

	    if (code === 124) {
	      if (next === 62) {
	        this.finishOp(39, 2);
	        return;
	      }

	      if (this.hasPlugin("recordAndTuple") && next === 125) {
	        if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
	          throw this.raise(ErrorMessages.RecordExpressionBarIncorrectEndSyntaxType, {
	            at: this.state.curPosition()
	          });
	        }

	        this.state.pos += 2;
	        this.finishToken(9);
	        return;
	      }

	      if (this.hasPlugin("recordAndTuple") && next === 93) {
	        if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
	          throw this.raise(ErrorMessages.TupleExpressionBarIncorrectEndSyntaxType, {
	            at: this.state.curPosition()
	          });
	        }

	        this.state.pos += 2;
	        this.finishToken(4);
	        return;
	      }
	    }

	    if (next === 61) {
	      this.finishOp(30, 2);
	      return;
	    }

	    this.finishOp(code === 124 ? 43 : 45, 1);
	  }

	  readToken_caret() {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (next === 61 && !this.state.inType) {
	      this.finishOp(32, 2);
	    } else if (next === 94 && this.hasPlugin(["pipelineOperator", {
	      proposal: "hack",
	      topicToken: "^^"
	    }])) {
	      this.finishOp(37, 2);
	      const lookaheadCh = this.input.codePointAt(this.state.pos);

	      if (lookaheadCh === 94) {
	        throw this.unexpected();
	      }
	    } else {
	      this.finishOp(44, 1);
	    }
	  }

	  readToken_atSign() {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (next === 64 && this.hasPlugin(["pipelineOperator", {
	      proposal: "hack",
	      topicToken: "@@"
	    }])) {
	      this.finishOp(38, 2);
	    } else {
	      this.finishOp(26, 1);
	    }
	  }

	  readToken_plus_min(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (next === code) {
	      this.finishOp(34, 2);
	      return;
	    }

	    if (next === 61) {
	      this.finishOp(30, 2);
	    } else {
	      this.finishOp(53, 1);
	    }
	  }

	  readToken_lt() {
	    const {
	      pos
	    } = this.state;
	    const next = this.input.charCodeAt(pos + 1);

	    if (next === 60) {
	      if (this.input.charCodeAt(pos + 2) === 61) {
	        this.finishOp(30, 3);
	        return;
	      }

	      this.finishOp(51, 2);
	      return;
	    }

	    if (next === 61) {
	      this.finishOp(49, 2);
	      return;
	    }

	    this.finishOp(47, 1);
	  }

	  readToken_gt() {
	    const {
	      pos
	    } = this.state;
	    const next = this.input.charCodeAt(pos + 1);

	    if (next === 62) {
	      const size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;

	      if (this.input.charCodeAt(pos + size) === 61) {
	        this.finishOp(30, size + 1);
	        return;
	      }

	      this.finishOp(52, size);
	      return;
	    }

	    if (next === 61) {
	      this.finishOp(49, 2);
	      return;
	    }

	    this.finishOp(48, 1);
	  }

	  readToken_eq_excl(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (next === 61) {
	      this.finishOp(46, this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2);
	      return;
	    }

	    if (code === 61 && next === 62) {
	      this.state.pos += 2;
	      this.finishToken(19);
	      return;
	    }

	    this.finishOp(code === 61 ? 29 : 35, 1);
	  }

	  readToken_question() {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    const next2 = this.input.charCodeAt(this.state.pos + 2);

	    if (next === 63) {
	      if (next2 === 61) {
	        this.finishOp(30, 3);
	      } else {
	        this.finishOp(40, 2);
	      }
	    } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
	      this.state.pos += 2;
	      this.finishToken(18);
	    } else {
	      ++this.state.pos;
	      this.finishToken(17);
	    }
	  }

	  getTokenFromCode(code) {
	    switch (code) {
	      case 46:
	        this.readToken_dot();
	        return;

	      case 40:
	        ++this.state.pos;
	        this.finishToken(10);
	        return;

	      case 41:
	        ++this.state.pos;
	        this.finishToken(11);
	        return;

	      case 59:
	        ++this.state.pos;
	        this.finishToken(13);
	        return;

	      case 44:
	        ++this.state.pos;
	        this.finishToken(12);
	        return;

	      case 91:
	        if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
	          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
	            throw this.raise(ErrorMessages.TupleExpressionBarIncorrectStartSyntaxType, {
	              at: this.state.curPosition()
	            });
	          }

	          this.state.pos += 2;
	          this.finishToken(2);
	        } else {
	          ++this.state.pos;
	          this.finishToken(0);
	        }

	        return;

	      case 93:
	        ++this.state.pos;
	        this.finishToken(3);
	        return;

	      case 123:
	        if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
	          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
	            throw this.raise(ErrorMessages.RecordExpressionBarIncorrectStartSyntaxType, {
	              at: this.state.curPosition()
	            });
	          }

	          this.state.pos += 2;
	          this.finishToken(6);
	        } else {
	          ++this.state.pos;
	          this.finishToken(5);
	        }

	        return;

	      case 125:
	        ++this.state.pos;
	        this.finishToken(8);
	        return;

	      case 58:
	        if (this.hasPlugin("functionBind") && this.input.charCodeAt(this.state.pos + 1) === 58) {
	          this.finishOp(15, 2);
	        } else {
	          ++this.state.pos;
	          this.finishToken(14);
	        }

	        return;

	      case 63:
	        this.readToken_question();
	        return;

	      case 96:
	        this.readTemplateToken();
	        return;

	      case 48:
	        {
	          const next = this.input.charCodeAt(this.state.pos + 1);

	          if (next === 120 || next === 88) {
	            this.readRadixNumber(16);
	            return;
	          }

	          if (next === 111 || next === 79) {
	            this.readRadixNumber(8);
	            return;
	          }

	          if (next === 98 || next === 66) {
	            this.readRadixNumber(2);
	            return;
	          }
	        }

	      case 49:
	      case 50:
	      case 51:
	      case 52:
	      case 53:
	      case 54:
	      case 55:
	      case 56:
	      case 57:
	        this.readNumber(false);
	        return;

	      case 34:
	      case 39:
	        this.readString(code);
	        return;

	      case 47:
	        this.readToken_slash();
	        return;

	      case 37:
	      case 42:
	        this.readToken_mult_modulo(code);
	        return;

	      case 124:
	      case 38:
	        this.readToken_pipe_amp(code);
	        return;

	      case 94:
	        this.readToken_caret();
	        return;

	      case 43:
	      case 45:
	        this.readToken_plus_min(code);
	        return;

	      case 60:
	        this.readToken_lt();
	        return;

	      case 62:
	        this.readToken_gt();
	        return;

	      case 61:
	      case 33:
	        this.readToken_eq_excl(code);
	        return;

	      case 126:
	        this.finishOp(36, 1);
	        return;

	      case 64:
	        this.readToken_atSign();
	        return;

	      case 35:
	        this.readToken_numberSign();
	        return;

	      case 92:
	        this.readWord();
	        return;

	      default:
	        if (isIdentifierStart(code)) {
	          this.readWord(code);
	          return;
	        }

	    }

	    throw this.raise(ErrorMessages.InvalidOrUnexpectedToken, {
	      at: this.state.curPosition()
	    }, String.fromCodePoint(code));
	  }

	  finishOp(type, size) {
	    const str = this.input.slice(this.state.pos, this.state.pos + size);
	    this.state.pos += size;
	    this.finishToken(type, str);
	  }

	  readRegexp() {
	    const startLoc = this.state.startLoc;
	    const start = this.state.start + 1;
	    let escaped, inClass;
	    let {
	      pos
	    } = this.state;

	    for (;; ++pos) {
	      if (pos >= this.length) {
	        throw this.raise(ErrorMessages.UnterminatedRegExp, {
	          at: createPositionWithColumnOffset(startLoc, 1)
	        });
	      }

	      const ch = this.input.charCodeAt(pos);

	      if (isNewLine(ch)) {
	        throw this.raise(ErrorMessages.UnterminatedRegExp, {
	          at: createPositionWithColumnOffset(startLoc, 1)
	        });
	      }

	      if (escaped) {
	        escaped = false;
	      } else {
	        if (ch === 91) {
	          inClass = true;
	        } else if (ch === 93 && inClass) {
	          inClass = false;
	        } else if (ch === 47 && !inClass) {
	          break;
	        }

	        escaped = ch === 92;
	      }
	    }

	    const content = this.input.slice(start, pos);
	    ++pos;
	    let mods = "";

	    const nextPos = () => createPositionWithColumnOffset(startLoc, pos + 2 - start);

	    while (pos < this.length) {
	      const cp = this.codePointAtPos(pos);
	      const char = String.fromCharCode(cp);

	      if (VALID_REGEX_FLAGS.has(cp)) {
	        if (cp === 118) {
	          this.expectPlugin("regexpUnicodeSets", nextPos());

	          if (mods.includes("u")) {
	            this.raise(ErrorMessages.IncompatibleRegExpUVFlags, {
	              at: nextPos()
	            });
	          }
	        } else if (cp === 117) {
	          if (mods.includes("v")) {
	            this.raise(ErrorMessages.IncompatibleRegExpUVFlags, {
	              at: nextPos()
	            });
	          }
	        }

	        if (mods.includes(char)) {
	          this.raise(ErrorMessages.DuplicateRegExpFlags, {
	            at: nextPos()
	          });
	        }
	      } else if (isIdentifierChar(cp) || cp === 92) {
	        this.raise(ErrorMessages.MalformedRegExpFlags, {
	          at: nextPos()
	        });
	      } else {
	        break;
	      }

	      ++pos;
	      mods += char;
	    }

	    this.state.pos = pos;
	    this.finishToken(133, {
	      pattern: content,
	      flags: mods
	    });
	  }

	  readInt(radix, len, forceLen, allowNumSeparator = true) {
	    const start = this.state.pos;
	    const forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings.hex : forbiddenNumericSeparatorSiblings.decBinOct;
	    const allowedSiblings = radix === 16 ? allowedNumericSeparatorSiblings.hex : radix === 10 ? allowedNumericSeparatorSiblings.dec : radix === 8 ? allowedNumericSeparatorSiblings.oct : allowedNumericSeparatorSiblings.bin;
	    let invalid = false;
	    let total = 0;

	    for (let i = 0, e = len == null ? Infinity : len; i < e; ++i) {
	      const code = this.input.charCodeAt(this.state.pos);
	      let val;

	      if (code === 95) {
	        const prev = this.input.charCodeAt(this.state.pos - 1);
	        const next = this.input.charCodeAt(this.state.pos + 1);

	        if (allowedSiblings.indexOf(next) === -1) {
	          this.raise(ErrorMessages.UnexpectedNumericSeparator, {
	            at: this.state.curPosition()
	          });
	        } else if (forbiddenSiblings.indexOf(prev) > -1 || forbiddenSiblings.indexOf(next) > -1 || Number.isNaN(next)) {
	          this.raise(ErrorMessages.UnexpectedNumericSeparator, {
	            at: this.state.curPosition()
	          });
	        }

	        if (!allowNumSeparator) {
	          this.raise(ErrorMessages.NumericSeparatorInEscapeSequence, {
	            at: this.state.curPosition()
	          });
	        }

	        ++this.state.pos;
	        continue;
	      }

	      if (code >= 97) {
	        val = code - 97 + 10;
	      } else if (code >= 65) {
	        val = code - 65 + 10;
	      } else if (_isDigit(code)) {
	        val = code - 48;
	      } else {
	        val = Infinity;
	      }

	      if (val >= radix) {
	        if (this.options.errorRecovery && val <= 9) {
	          val = 0;
	          this.raise(ErrorMessages.InvalidDigit, {
	            at: this.state.curPosition()
	          }, radix);
	        } else if (forceLen) {
	          val = 0;
	          invalid = true;
	        } else {
	          break;
	        }
	      }

	      ++this.state.pos;
	      total = total * radix + val;
	    }

	    if (this.state.pos === start || len != null && this.state.pos - start !== len || invalid) {
	      return null;
	    }

	    return total;
	  }

	  readRadixNumber(radix) {
	    const startLoc = this.state.curPosition();
	    let isBigInt = false;
	    this.state.pos += 2;
	    const val = this.readInt(radix);

	    if (val == null) {
	      this.raise(ErrorMessages.InvalidDigit, {
	        at: createPositionWithColumnOffset(startLoc, 2)
	      }, radix);
	    }

	    const next = this.input.charCodeAt(this.state.pos);

	    if (next === 110) {
	      ++this.state.pos;
	      isBigInt = true;
	    } else if (next === 109) {
	      throw this.raise(ErrorMessages.InvalidDecimal, {
	        at: startLoc
	      });
	    }

	    if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
	      throw this.raise(ErrorMessages.NumberIdentifier, {
	        at: this.state.curPosition()
	      });
	    }

	    if (isBigInt) {
	      const str = this.input.slice(startLoc.index, this.state.pos).replace(/[_n]/g, "");
	      this.finishToken(131, str);
	      return;
	    }

	    this.finishToken(130, val);
	  }

	  readNumber(startsWithDot) {
	    const start = this.state.pos;
	    const startLoc = this.state.curPosition();
	    let isFloat = false;
	    let isBigInt = false;
	    let isDecimal = false;
	    let hasExponent = false;
	    let isOctal = false;

	    if (!startsWithDot && this.readInt(10) === null) {
	      this.raise(ErrorMessages.InvalidNumber, {
	        at: this.state.curPosition()
	      });
	    }

	    const hasLeadingZero = this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;

	    if (hasLeadingZero) {
	      const integer = this.input.slice(start, this.state.pos);
	      this.recordStrictModeErrors(ErrorMessages.StrictOctalLiteral, startLoc);

	      if (!this.state.strict) {
	        const underscorePos = integer.indexOf("_");

	        if (underscorePos > 0) {
	          this.raise(ErrorMessages.ZeroDigitNumericSeparator, {
	            at: createPositionWithColumnOffset(startLoc, underscorePos)
	          });
	        }
	      }

	      isOctal = hasLeadingZero && !/[89]/.test(integer);
	    }

	    let next = this.input.charCodeAt(this.state.pos);

	    if (next === 46 && !isOctal) {
	      ++this.state.pos;
	      this.readInt(10);
	      isFloat = true;
	      next = this.input.charCodeAt(this.state.pos);
	    }

	    if ((next === 69 || next === 101) && !isOctal) {
	      next = this.input.charCodeAt(++this.state.pos);

	      if (next === 43 || next === 45) {
	        ++this.state.pos;
	      }

	      if (this.readInt(10) === null) {
	        this.raise(ErrorMessages.InvalidOrMissingExponent, {
	          at: startLoc
	        });
	      }

	      isFloat = true;
	      hasExponent = true;
	      next = this.input.charCodeAt(this.state.pos);
	    }

	    if (next === 110) {
	      if (isFloat || hasLeadingZero) {
	        this.raise(ErrorMessages.InvalidBigIntLiteral, {
	          at: startLoc
	        });
	      }

	      ++this.state.pos;
	      isBigInt = true;
	    }

	    if (next === 109) {
	      this.expectPlugin("decimal", this.state.curPosition());

	      if (hasExponent || hasLeadingZero) {
	        this.raise(ErrorMessages.InvalidDecimal, {
	          at: startLoc
	        });
	      }

	      ++this.state.pos;
	      isDecimal = true;
	    }

	    if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
	      throw this.raise(ErrorMessages.NumberIdentifier, {
	        at: this.state.curPosition()
	      });
	    }

	    const str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, "");

	    if (isBigInt) {
	      this.finishToken(131, str);
	      return;
	    }

	    if (isDecimal) {
	      this.finishToken(132, str);
	      return;
	    }

	    const val = isOctal ? parseInt(str, 8) : parseFloat(str);
	    this.finishToken(130, val);
	  }

	  readCodePoint(throwOnInvalid) {
	    const ch = this.input.charCodeAt(this.state.pos);
	    let code;

	    if (ch === 123) {
	      ++this.state.pos;
	      code = this.readHexChar(this.input.indexOf("}", this.state.pos) - this.state.pos, true, throwOnInvalid);
	      ++this.state.pos;

	      if (code !== null && code > 0x10ffff) {
	        if (throwOnInvalid) {
	          this.raise(ErrorMessages.InvalidCodePoint, {
	            at: this.state.curPosition()
	          });
	        } else {
	          return null;
	        }
	      }
	    } else {
	      code = this.readHexChar(4, false, throwOnInvalid);
	    }

	    return code;
	  }

	  readString(quote) {
	    let out = "",
	        chunkStart = ++this.state.pos;

	    for (;;) {
	      if (this.state.pos >= this.length) {
	        throw this.raise(ErrorMessages.UnterminatedString, {
	          at: this.state.startLoc
	        });
	      }

	      const ch = this.input.charCodeAt(this.state.pos);
	      if (ch === quote) break;

	      if (ch === 92) {
	        out += this.input.slice(chunkStart, this.state.pos);
	        out += this.readEscapedChar(false);
	        chunkStart = this.state.pos;
	      } else if (ch === 8232 || ch === 8233) {
	        ++this.state.pos;
	        ++this.state.curLine;
	        this.state.lineStart = this.state.pos;
	      } else if (isNewLine(ch)) {
	        throw this.raise(ErrorMessages.UnterminatedString, {
	          at: this.state.startLoc
	        });
	      } else {
	        ++this.state.pos;
	      }
	    }

	    out += this.input.slice(chunkStart, this.state.pos++);
	    this.finishToken(129, out);
	  }

	  readTemplateContinuation() {
	    if (!this.match(8)) {
	      this.unexpected(null, 8);
	    }

	    this.state.pos--;
	    this.readTemplateToken();
	  }

	  readTemplateToken() {
	    let out = "",
	        chunkStart = this.state.pos,
	        containsInvalid = false;
	    ++this.state.pos;

	    for (;;) {
	      if (this.state.pos >= this.length) {
	        throw this.raise(ErrorMessages.UnterminatedTemplate, {
	          at: createPositionWithColumnOffset(this.state.startLoc, 1)
	        });
	      }

	      const ch = this.input.charCodeAt(this.state.pos);

	      if (ch === 96) {
	        ++this.state.pos;
	        out += this.input.slice(chunkStart, this.state.pos);
	        this.finishToken(24, containsInvalid ? null : out);
	        return;
	      }

	      if (ch === 36 && this.input.charCodeAt(this.state.pos + 1) === 123) {
	        this.state.pos += 2;
	        out += this.input.slice(chunkStart, this.state.pos);
	        this.finishToken(25, containsInvalid ? null : out);
	        return;
	      }

	      if (ch === 92) {
	        out += this.input.slice(chunkStart, this.state.pos);
	        const escaped = this.readEscapedChar(true);

	        if (escaped === null) {
	          containsInvalid = true;
	        } else {
	          out += escaped;
	        }

	        chunkStart = this.state.pos;
	      } else if (isNewLine(ch)) {
	        out += this.input.slice(chunkStart, this.state.pos);
	        ++this.state.pos;

	        switch (ch) {
	          case 13:
	            if (this.input.charCodeAt(this.state.pos) === 10) {
	              ++this.state.pos;
	            }

	          case 10:
	            out += "\n";
	            break;

	          default:
	            out += String.fromCharCode(ch);
	            break;
	        }

	        ++this.state.curLine;
	        this.state.lineStart = this.state.pos;
	        chunkStart = this.state.pos;
	      } else {
	        ++this.state.pos;
	      }
	    }
	  }

	  recordStrictModeErrors(message, loc) {
	    if (this.state.strict && !this.state.strictErrors.has(loc.index)) {
	      this.raise(message, {
	        at: loc
	      });
	    } else {
	      this.state.strictErrors.set(loc.index, {
	        loc,
	        message
	      });
	    }
	  }

	  readEscapedChar(inTemplate) {
	    const throwOnInvalid = !inTemplate;
	    const ch = this.input.charCodeAt(++this.state.pos);
	    ++this.state.pos;

	    switch (ch) {
	      case 110:
	        return "\n";

	      case 114:
	        return "\r";

	      case 120:
	        {
	          const code = this.readHexChar(2, false, throwOnInvalid);
	          return code === null ? null : String.fromCharCode(code);
	        }

	      case 117:
	        {
	          const code = this.readCodePoint(throwOnInvalid);
	          return code === null ? null : String.fromCodePoint(code);
	        }

	      case 116:
	        return "\t";

	      case 98:
	        return "\b";

	      case 118:
	        return "\u000b";

	      case 102:
	        return "\f";

	      case 13:
	        if (this.input.charCodeAt(this.state.pos) === 10) {
	          ++this.state.pos;
	        }

	      case 10:
	        this.state.lineStart = this.state.pos;
	        ++this.state.curLine;

	      case 8232:
	      case 8233:
	        return "";

	      case 56:
	      case 57:
	        if (inTemplate) {
	          return null;
	        } else {
	          this.recordStrictModeErrors(ErrorMessages.StrictNumericEscape, createPositionWithColumnOffset(this.state.curPosition(), -1));
	        }

	      default:
	        if (ch >= 48 && ch <= 55) {
	          const codePos = createPositionWithColumnOffset(this.state.curPosition(), -1);
	          const match = this.input.substr(this.state.pos - 1, 3).match(/^[0-7]+/);
	          let octalStr = match[0];
	          let octal = parseInt(octalStr, 8);

	          if (octal > 255) {
	            octalStr = octalStr.slice(0, -1);
	            octal = parseInt(octalStr, 8);
	          }

	          this.state.pos += octalStr.length - 1;
	          const next = this.input.charCodeAt(this.state.pos);

	          if (octalStr !== "0" || next === 56 || next === 57) {
	            if (inTemplate) {
	              return null;
	            } else {
	              this.recordStrictModeErrors(ErrorMessages.StrictNumericEscape, codePos);
	            }
	          }

	          return String.fromCharCode(octal);
	        }

	        return String.fromCharCode(ch);
	    }
	  }

	  readHexChar(len, forceLen, throwOnInvalid) {
	    const codeLoc = this.state.curPosition();
	    const n = this.readInt(16, len, forceLen, false);

	    if (n === null) {
	      if (throwOnInvalid) {
	        this.raise(ErrorMessages.InvalidEscapeSequence, {
	          at: codeLoc
	        });
	      } else {
	        this.state.pos = codeLoc.index - 1;
	      }
	    }

	    return n;
	  }

	  readWord1(firstCode) {
	    this.state.containsEsc = false;
	    let word = "";
	    const start = this.state.pos;
	    let chunkStart = this.state.pos;

	    if (firstCode !== undefined) {
	      this.state.pos += firstCode <= 0xffff ? 1 : 2;
	    }

	    while (this.state.pos < this.length) {
	      const ch = this.codePointAtPos(this.state.pos);

	      if (isIdentifierChar(ch)) {
	        this.state.pos += ch <= 0xffff ? 1 : 2;
	      } else if (ch === 92) {
	        this.state.containsEsc = true;
	        word += this.input.slice(chunkStart, this.state.pos);
	        const escStart = this.state.curPosition();
	        const identifierCheck = this.state.pos === start ? isIdentifierStart : isIdentifierChar;

	        if (this.input.charCodeAt(++this.state.pos) !== 117) {
	          this.raise(ErrorMessages.MissingUnicodeEscape, {
	            at: this.state.curPosition()
	          });
	          chunkStart = this.state.pos - 1;
	          continue;
	        }

	        ++this.state.pos;
	        const esc = this.readCodePoint(true);

	        if (esc !== null) {
	          if (!identifierCheck(esc)) {
	            this.raise(ErrorMessages.EscapedCharNotAnIdentifier, {
	              at: escStart
	            });
	          }

	          word += String.fromCodePoint(esc);
	        }

	        chunkStart = this.state.pos;
	      } else {
	        break;
	      }
	    }

	    return word + this.input.slice(chunkStart, this.state.pos);
	  }

	  readWord(firstCode) {
	    const word = this.readWord1(firstCode);
	    const type = keywords.get(word);

	    if (type !== undefined) {
	      this.finishToken(type, tokenLabelName(type));
	    } else {
	      this.finishToken(128, word);
	    }
	  }

	  checkKeywordEscapes() {
	    const {
	      type
	    } = this.state;

	    if (tokenIsKeyword(type) && this.state.containsEsc) {
	      this.raise(ErrorMessages.InvalidEscapedReservedWord, {
	        at: this.state.startLoc
	      }, tokenLabelName(type));
	    }
	  }

	  updateContext(prevType) {}

	}

	class ClassScope {
	  privateNames = new Set();
	  loneAccessors = new Map();
	  undefinedPrivateNames = new Map();
	}
	class ClassScopeHandler {
	  stack = [];
	  undefinedPrivateNames = new Map();

	  constructor(raise) {
	    this.raise = raise;
	  }

	  current() {
	    return this.stack[this.stack.length - 1];
	  }

	  enter() {
	    this.stack.push(new ClassScope());
	  }

	  exit() {
	    const oldClassScope = this.stack.pop();
	    const current = this.current();

	    for (const [name, loc] of Array.from(oldClassScope.undefinedPrivateNames)) {
	      if (current) {
	        if (!current.undefinedPrivateNames.has(name)) {
	          current.undefinedPrivateNames.set(name, loc);
	        }
	      } else {
	        this.raise(ErrorMessages.InvalidPrivateFieldResolution, {
	          at: loc
	        }, name);
	      }
	    }
	  }

	  declarePrivateName(name, elementType, loc) {
	    const {
	      privateNames,
	      loneAccessors,
	      undefinedPrivateNames
	    } = this.current();
	    let redefined = privateNames.has(name);

	    if (elementType & CLASS_ELEMENT_KIND_ACCESSOR) {
	      const accessor = redefined && loneAccessors.get(name);

	      if (accessor) {
	        const oldStatic = accessor & CLASS_ELEMENT_FLAG_STATIC;
	        const newStatic = elementType & CLASS_ELEMENT_FLAG_STATIC;
	        const oldKind = accessor & CLASS_ELEMENT_KIND_ACCESSOR;
	        const newKind = elementType & CLASS_ELEMENT_KIND_ACCESSOR;
	        redefined = oldKind === newKind || oldStatic !== newStatic;
	        if (!redefined) loneAccessors.delete(name);
	      } else if (!redefined) {
	        loneAccessors.set(name, elementType);
	      }
	    }

	    if (redefined) {
	      this.raise(ErrorMessages.PrivateNameRedeclaration, {
	        at: loc
	      }, name);
	    }

	    privateNames.add(name);
	    undefinedPrivateNames.delete(name);
	  }

	  usePrivateName(name, loc) {
	    let classScope;

	    for (classScope of this.stack) {
	      if (classScope.privateNames.has(name)) return;
	    }

	    if (classScope) {
	      classScope.undefinedPrivateNames.set(name, loc);
	    } else {
	      this.raise(ErrorMessages.InvalidPrivateFieldResolution, {
	        at: loc
	      }, name);
	    }
	  }

	}

	const kExpression = 0,
	      kMaybeArrowParameterDeclaration = 1,
	      kMaybeAsyncArrowParameterDeclaration = 2,
	      kParameterDeclaration = 3;

	class ExpressionScope {
	  type;

	  constructor(type = kExpression) {
	    this.type = type;
	  }

	  canBeArrowParameterDeclaration() {
	    return this.type === kMaybeAsyncArrowParameterDeclaration || this.type === kMaybeArrowParameterDeclaration;
	  }

	  isCertainlyParameterDeclaration() {
	    return this.type === kParameterDeclaration;
	  }

	}

	class ArrowHeadParsingScope extends ExpressionScope {
	  errors = new Map();

	  constructor(type) {
	    super(type);
	  }

	  recordDeclarationError(message, loc) {
	    this.errors.set(loc.index, {
	      message,
	      loc
	    });
	  }

	  clearDeclarationError(loc) {
	    this.errors.delete(loc.index);
	  }

	  iterateErrors(iterator) {
	    this.errors.forEach(iterator);
	  }

	}

	class ExpressionScopeHandler {
	  stack = [new ExpressionScope()];

	  constructor(raise) {
	    this.raise = raise;
	  }

	  enter(scope) {
	    this.stack.push(scope);
	  }

	  exit() {
	    this.stack.pop();
	  }

	  recordParameterInitializerError(loc, template) {
	    const {
	      stack
	    } = this;
	    let i = stack.length - 1;
	    let scope = stack[i];

	    while (!scope.isCertainlyParameterDeclaration()) {
	      if (scope.canBeArrowParameterDeclaration()) {
	        scope.recordDeclarationError(template, loc);
	      } else {
	        return;
	      }

	      scope = stack[--i];
	    }

	    this.raise(template, {
	      at: loc
	    });
	  }

	  recordParenthesizedIdentifierError(template, loc) {
	    const {
	      stack
	    } = this;
	    const scope = stack[stack.length - 1];

	    if (scope.isCertainlyParameterDeclaration()) {
	      this.raise(template, {
	        at: loc
	      });
	    } else if (scope.canBeArrowParameterDeclaration()) {
	      scope.recordDeclarationError(template, loc);
	    } else {
	      return;
	    }
	  }

	  recordAsyncArrowParametersError(template, loc) {
	    const {
	      stack
	    } = this;
	    let i = stack.length - 1;
	    let scope = stack[i];

	    while (scope.canBeArrowParameterDeclaration()) {
	      if (scope.type === kMaybeAsyncArrowParameterDeclaration) {
	        scope.recordDeclarationError(template, loc);
	      }

	      scope = stack[--i];
	    }
	  }

	  validateAsPattern() {
	    const {
	      stack
	    } = this;
	    const currentScope = stack[stack.length - 1];
	    if (!currentScope.canBeArrowParameterDeclaration()) return;
	    currentScope.iterateErrors(({
	      message,
	      loc
	    }) => {
	      this.raise(message, {
	        at: loc
	      });
	      let i = stack.length - 2;
	      let scope = stack[i];

	      while (scope.canBeArrowParameterDeclaration()) {
	        scope.clearDeclarationError(loc);
	        scope = stack[--i];
	      }
	    });
	  }

	}
	function newParameterDeclarationScope() {
	  return new ExpressionScope(kParameterDeclaration);
	}
	function newArrowHeadScope() {
	  return new ArrowHeadParsingScope(kMaybeArrowParameterDeclaration);
	}
	function newAsyncArrowScope() {
	  return new ArrowHeadParsingScope(kMaybeAsyncArrowParameterDeclaration);
	}
	function newExpressionScope() {
	  return new ExpressionScope();
	}

	const PARAM = 0b0000,
	      PARAM_YIELD = 0b0001,
	      PARAM_AWAIT = 0b0010,
	      PARAM_RETURN = 0b0100,
	      PARAM_IN = 0b1000;
	class ProductionParameterHandler {
	  stacks = [];

	  enter(flags) {
	    this.stacks.push(flags);
	  }

	  exit() {
	    this.stacks.pop();
	  }

	  currentFlags() {
	    return this.stacks[this.stacks.length - 1];
	  }

	  get hasAwait() {
	    return (this.currentFlags() & PARAM_AWAIT) > 0;
	  }

	  get hasYield() {
	    return (this.currentFlags() & PARAM_YIELD) > 0;
	  }

	  get hasReturn() {
	    return (this.currentFlags() & PARAM_RETURN) > 0;
	  }

	  get hasIn() {
	    return (this.currentFlags() & PARAM_IN) > 0;
	  }

	}
	function functionFlags(isAsync, isGenerator) {
	  return (isAsync ? PARAM_AWAIT : 0) | (isGenerator ? PARAM_YIELD : 0);
	}

	class UtilParser extends Tokenizer {
	  addExtra(node, key, value, enumerable = true) {
	    if (!node) return;
	    const extra = node.extra = node.extra || {};

	    if (enumerable) {
	      extra[key] = value;
	    } else {
	      Object.defineProperty(extra, key, {
	        enumerable,
	        value
	      });
	    }
	  }

	  isContextual(token) {
	    return this.state.type === token && !this.state.containsEsc;
	  }

	  isUnparsedContextual(nameStart, name) {
	    const nameEnd = nameStart + name.length;

	    if (this.input.slice(nameStart, nameEnd) === name) {
	      const nextCh = this.input.charCodeAt(nameEnd);
	      return !(isIdentifierChar(nextCh) || (nextCh & 0xfc00) === 0xd800);
	    }

	    return false;
	  }

	  isLookaheadContextual(name) {
	    const next = this.nextTokenStart();
	    return this.isUnparsedContextual(next, name);
	  }

	  eatContextual(token) {
	    if (this.isContextual(token)) {
	      this.next();
	      return true;
	    }

	    return false;
	  }

	  expectContextual(token, template) {
	    if (!this.eatContextual(token)) {
	      if (template != null) {
	        throw this.raise(template, {
	          at: this.state.startLoc
	        });
	      }

	      throw this.unexpected(null, token);
	    }
	  }

	  canInsertSemicolon() {
	    return this.match(135) || this.match(8) || this.hasPrecedingLineBreak();
	  }

	  hasPrecedingLineBreak() {
	    return lineBreak.test(this.input.slice(this.state.lastTokEndLoc.index, this.state.start));
	  }

	  hasFollowingLineBreak() {
	    skipWhiteSpaceToLineBreak.lastIndex = this.state.end;
	    return skipWhiteSpaceToLineBreak.test(this.input);
	  }

	  isLineTerminator() {
	    return this.eat(13) || this.canInsertSemicolon();
	  }

	  semicolon(allowAsi = true) {
	    if (allowAsi ? this.isLineTerminator() : this.eat(13)) return;
	    this.raise(ErrorMessages.MissingSemicolon, {
	      at: this.state.lastTokEndLoc
	    });
	  }

	  expect(type, loc) {
	    this.eat(type) || this.unexpected(loc, type);
	  }

	  assertNoSpace(message = "Unexpected space.") {
	    if (this.state.start > this.state.lastTokEndLoc.index) {
	      this.raise({
	        code: ErrorCodes.SyntaxError,
	        reasonCode: "UnexpectedSpace",
	        template: message
	      }, {
	        at: this.state.lastTokEndLoc
	      });
	    }
	  }

	  unexpected(loc, type) {
	    throw this.raise({
	      code: ErrorCodes.SyntaxError,
	      reasonCode: "UnexpectedToken",
	      template: type != null ? `Unexpected token, expected "${tokenLabelName(type)}"` : "Unexpected token"
	    }, {
	      at: loc != null ? loc : this.state.startLoc
	    });
	  }

	  getPluginNamesFromConfigs(pluginConfigs) {
	    return pluginConfigs.map(c => {
	      if (typeof c === "string") {
	        return c;
	      } else {
	        return c[0];
	      }
	    });
	  }

	  expectPlugin(pluginConfig, loc) {
	    if (!this.hasPlugin(pluginConfig)) {
	      throw this.raiseWithData(loc != null ? loc : this.state.startLoc, {
	        missingPlugin: this.getPluginNamesFromConfigs([pluginConfig])
	      }, `This experimental syntax requires enabling the parser plugin: ${JSON.stringify(pluginConfig)}.`);
	    }

	    return true;
	  }

	  expectOnePlugin(pluginConfigs) {
	    if (!pluginConfigs.some(c => this.hasPlugin(c))) {
	      throw this.raiseWithData(this.state.startLoc, {
	        missingPlugin: this.getPluginNamesFromConfigs(pluginConfigs)
	      }, `This experimental syntax requires enabling one of the following parser plugin(s): ${pluginConfigs.map(c => JSON.stringify(c)).join(", ")}.`);
	    }
	  }

	  tryParse(fn, oldState = this.state.clone()) {
	    const abortSignal = {
	      node: null
	    };

	    try {
	      const node = fn((node = null) => {
	        abortSignal.node = node;
	        throw abortSignal;
	      });

	      if (this.state.errors.length > oldState.errors.length) {
	        const failState = this.state;
	        this.state = oldState;
	        this.state.tokensLength = failState.tokensLength;
	        return {
	          node,
	          error: failState.errors[oldState.errors.length],
	          thrown: false,
	          aborted: false,
	          failState
	        };
	      }

	      return {
	        node,
	        error: null,
	        thrown: false,
	        aborted: false,
	        failState: null
	      };
	    } catch (error) {
	      const failState = this.state;
	      this.state = oldState;

	      if (error instanceof SyntaxError) {
	        return {
	          node: null,
	          error,
	          thrown: true,
	          aborted: false,
	          failState
	        };
	      }

	      if (error === abortSignal) {
	        return {
	          node: abortSignal.node,
	          error: null,
	          thrown: false,
	          aborted: true,
	          failState
	        };
	      }

	      throw error;
	    }
	  }

	  checkExpressionErrors(refExpressionErrors, andThrow) {
	    if (!refExpressionErrors) return false;
	    const {
	      shorthandAssignLoc,
	      doubleProtoLoc,
	      privateKeyLoc,
	      optionalParametersLoc
	    } = refExpressionErrors;
	    const hasErrors = !!shorthandAssignLoc || !!doubleProtoLoc || !!optionalParametersLoc || !!privateKeyLoc;

	    if (!andThrow) {
	      return hasErrors;
	    }

	    if (shorthandAssignLoc != null) {
	      this.raise(ErrorMessages.InvalidCoverInitializedName, {
	        at: shorthandAssignLoc
	      });
	    }

	    if (doubleProtoLoc != null) {
	      this.raise(ErrorMessages.DuplicateProto, {
	        at: doubleProtoLoc
	      });
	    }

	    if (privateKeyLoc != null) {
	      this.raise(ErrorMessages.UnexpectedPrivateField, {
	        at: privateKeyLoc
	      });
	    }

	    if (optionalParametersLoc != null) {
	      this.unexpected(optionalParametersLoc);
	    }
	  }

	  isLiteralPropertyName() {
	    return tokenIsLiteralPropertyName(this.state.type);
	  }

	  isPrivateName(node) {
	    return node.type === "PrivateName";
	  }

	  getPrivateNameSV(node) {
	    return node.id.name;
	  }

	  hasPropertyAsPrivateName(node) {
	    return (node.type === "MemberExpression" || node.type === "OptionalMemberExpression") && this.isPrivateName(node.property);
	  }

	  isOptionalChain(node) {
	    return node.type === "OptionalMemberExpression" || node.type === "OptionalCallExpression";
	  }

	  isObjectProperty(node) {
	    return node.type === "ObjectProperty";
	  }

	  isObjectMethod(node) {
	    return node.type === "ObjectMethod";
	  }

	  initializeScopes(inModule = this.options.sourceType === "module") {
	    const oldLabels = this.state.labels;
	    this.state.labels = [];
	    const oldExportedIdentifiers = this.exportedIdentifiers;
	    this.exportedIdentifiers = new Set();
	    const oldInModule = this.inModule;
	    this.inModule = inModule;
	    const oldScope = this.scope;
	    const ScopeHandler = this.getScopeHandler();
	    this.scope = new ScopeHandler(this.raise.bind(this), this.inModule);
	    const oldProdParam = this.prodParam;
	    this.prodParam = new ProductionParameterHandler();
	    const oldClassScope = this.classScope;
	    this.classScope = new ClassScopeHandler(this.raise.bind(this));
	    const oldExpressionScope = this.expressionScope;
	    this.expressionScope = new ExpressionScopeHandler(this.raise.bind(this));
	    return () => {
	      this.state.labels = oldLabels;
	      this.exportedIdentifiers = oldExportedIdentifiers;
	      this.inModule = oldInModule;
	      this.scope = oldScope;
	      this.prodParam = oldProdParam;
	      this.classScope = oldClassScope;
	      this.expressionScope = oldExpressionScope;
	    };
	  }

	  enterInitialScopes() {
	    let paramFlags = PARAM;

	    if (this.inModule) {
	      paramFlags |= PARAM_AWAIT;
	    }

	    this.scope.enter(SCOPE_PROGRAM);
	    this.prodParam.enter(paramFlags);
	  }

	  checkDestructuringPrivate(refExpressionErrors) {
	    const {
	      privateKeyLoc
	    } = refExpressionErrors;

	    if (privateKeyLoc !== null) {
	      this.expectPlugin("destructuringPrivate", privateKeyLoc);
	    }
	  }

	}
	class ExpressionErrors {
	  shorthandAssignLoc = null;
	  doubleProtoLoc = null;
	  privateKeyLoc = null;
	  optionalParametersLoc = null;
	}

	class Node$1 {
	  constructor(parser, pos, loc) {
	    this.start = pos;
	    this.end = 0;
	    this.loc = new SourceLocation(loc);
	    if (parser?.options.ranges) this.range = [pos, 0];
	    if (parser?.filename) this.loc.filename = parser.filename;
	  }

	  type = "";
	}

	const NodePrototype = Node$1.prototype;

	if (!browser$5.env.BABEL_8_BREAKING) {
	  NodePrototype.__clone = function () {
	    const newNode = new Node$1();
	    const keys = Object.keys(this);

	    for (let i = 0, length = keys.length; i < length; i++) {
	      const key = keys[i];

	      if (key !== "leadingComments" && key !== "trailingComments" && key !== "innerComments") {
	        newNode[key] = this[key];
	      }
	    }

	    return newNode;
	  };
	}

	function clonePlaceholder(node) {
	  return cloneIdentifier(node);
	}

	function cloneIdentifier(node) {
	  const {
	    type,
	    start,
	    end,
	    loc,
	    range,
	    extra,
	    name
	  } = node;
	  const cloned = Object.create(NodePrototype);
	  cloned.type = type;
	  cloned.start = start;
	  cloned.end = end;
	  cloned.loc = loc;
	  cloned.range = range;
	  cloned.extra = extra;
	  cloned.name = name;

	  if (type === "Placeholder") {
	    cloned.expectedNode = node.expectedNode;
	  }

	  return cloned;
	}
	function cloneStringLiteral(node) {
	  const {
	    type,
	    start,
	    end,
	    loc,
	    range,
	    extra
	  } = node;

	  if (type === "Placeholder") {
	    return clonePlaceholder(node);
	  }

	  const cloned = Object.create(NodePrototype);
	  cloned.type = type;
	  cloned.start = start;
	  cloned.end = end;
	  cloned.loc = loc;
	  cloned.range = range;

	  if (node.raw !== undefined) {
	    cloned.raw = node.raw;
	  } else {
	    cloned.extra = extra;
	  }

	  cloned.value = node.value;
	  return cloned;
	}
	class NodeUtils extends UtilParser {
	  startNode() {
	    return new Node$1(this, this.state.start, this.state.startLoc);
	  }

	  startNodeAt(pos, loc) {
	    return new Node$1(this, pos, loc);
	  }

	  startNodeAtNode(type) {
	    return this.startNodeAt(type.start, type.loc.start);
	  }

	  finishNode(node, type) {
	    return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
	  }

	  finishNodeAt(node, type, endLoc) {
	    if (node.end > 0) {
	      throw new Error("Do not call finishNode*() twice on the same node." + " Instead use resetEndLocation() or change type directly.");
	    }

	    node.type = type;
	    node.end = endLoc.index;
	    node.loc.end = endLoc;
	    if (this.options.ranges) node.range[1] = endLoc.index;
	    if (this.options.attachComment) this.processComment(node);
	    return node;
	  }

	  resetStartLocation(node, start, startLoc) {
	    node.start = start;
	    node.loc.start = startLoc;
	    if (this.options.ranges) node.range[0] = start;
	  }

	  resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
	    node.end = endLoc.index;
	    node.loc.end = endLoc;
	    if (this.options.ranges) node.range[1] = endLoc.index;
	  }

	  resetStartLocationFromNode(node, locationNode) {
	    this.resetStartLocation(node, locationNode.start, locationNode.loc.start);
	  }

	}

	const reservedTypes = new Set(["_", "any", "bool", "boolean", "empty", "extends", "false", "interface", "mixed", "null", "number", "static", "string", "true", "typeof", "void"]);
	const FlowErrors = makeErrorTemplates({
	  AmbiguousConditionalArrow: "Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.",
	  AmbiguousDeclareModuleKind: "Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.",
	  AssignReservedType: "Cannot overwrite reserved type %0.",
	  DeclareClassElement: "The `declare` modifier can only appear on class fields.",
	  DeclareClassFieldInitializer: "Initializers are not allowed in fields with the `declare` modifier.",
	  DuplicateDeclareModuleExports: "Duplicate `declare module.exports` statement.",
	  EnumBooleanMemberNotInitialized: "Boolean enum members need to be initialized. Use either `%0 = true,` or `%0 = false,` in enum `%1`.",
	  EnumDuplicateMemberName: "Enum member names need to be unique, but the name `%0` has already been used before in enum `%1`.",
	  EnumInconsistentMemberValues: "Enum `%0` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.",
	  EnumInvalidExplicitType: "Enum type `%1` is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `%0`.",
	  EnumInvalidExplicitTypeUnknownSupplied: "Supplied enum type is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `%0`.",
	  EnumInvalidMemberInitializerPrimaryType: "Enum `%0` has type `%2`, so the initializer of `%1` needs to be a %2 literal.",
	  EnumInvalidMemberInitializerSymbolType: "Symbol enum members cannot be initialized. Use `%1,` in enum `%0`.",
	  EnumInvalidMemberInitializerUnknownType: "The enum member initializer for `%1` needs to be a literal (either a boolean, number, or string) in enum `%0`.",
	  EnumInvalidMemberName: "Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `%0`, consider using `%1`, in enum `%2`.",
	  EnumNumberMemberNotInitialized: "Number enum members need to be initialized, e.g. `%1 = 1` in enum `%0`.",
	  EnumStringMemberInconsistentlyInitailized: "String enum members need to consistently either all use initializers, or use no initializers, in enum `%0`.",
	  GetterMayNotHaveThisParam: "A getter cannot have a `this` parameter.",
	  ImportTypeShorthandOnlyInPureImport: "The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.",
	  InexactInsideExact: "Explicit inexact syntax cannot appear inside an explicit exact object type.",
	  InexactInsideNonObject: "Explicit inexact syntax cannot appear in class or interface definitions.",
	  InexactVariance: "Explicit inexact syntax cannot have variance.",
	  InvalidNonTypeImportInDeclareModule: "Imports within a `declare module` body must always be `import type` or `import typeof`.",
	  MissingTypeParamDefault: "Type parameter declaration needs a default, since a preceding type parameter declaration has a default.",
	  NestedDeclareModule: "`declare module` cannot be used inside another `declare module`.",
	  NestedFlowComment: "Cannot have a flow comment inside another flow comment.",
	  PatternIsOptional: "A binding pattern parameter cannot be optional in an implementation signature.",
	  SetterMayNotHaveThisParam: "A setter cannot have a `this` parameter.",
	  SpreadVariance: "Spread properties cannot have variance.",
	  ThisParamAnnotationRequired: "A type annotation is required for the `this` parameter.",
	  ThisParamBannedInConstructor: "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
	  ThisParamMayNotBeOptional: "The `this` parameter cannot be optional.",
	  ThisParamMustBeFirst: "The `this` parameter must be the first function parameter.",
	  ThisParamNoDefault: "The `this` parameter may not have a default value.",
	  TypeBeforeInitializer: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
	  TypeCastInPattern: "The type cast expression is expected to be wrapped with parenthesis.",
	  UnexpectedExplicitInexactInObject: "Explicit inexact syntax must appear at the end of an inexact object.",
	  UnexpectedReservedType: "Unexpected reserved type %0.",
	  UnexpectedReservedUnderscore: "`_` is only allowed as a type argument to call or new.",
	  UnexpectedSpaceBetweenModuloChecks: "Spaces between `%` and `checks` are not allowed here.",
	  UnexpectedSpreadType: "Spread operator cannot appear in class or interface definitions.",
	  UnexpectedSubtractionOperand: 'Unexpected token, expected "number" or "bigint".',
	  UnexpectedTokenAfterTypeParameter: "Expected an arrow function after this type parameter declaration.",
	  UnexpectedTypeParameterBeforeAsyncArrowFunction: "Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.",
	  UnsupportedDeclareExportKind: "`declare export %0` is not supported. Use `%1` instead.",
	  UnsupportedStatementInDeclareModule: "Only declares and type imports are allowed inside declare module.",
	  UnterminatedFlowComment: "Unterminated flow-comment."
	}, ErrorCodes.SyntaxError, "flow");

	function isEsModuleType(bodyElement) {
	  return bodyElement.type === "DeclareExportAllDeclaration" || bodyElement.type === "DeclareExportDeclaration" && (!bodyElement.declaration || bodyElement.declaration.type !== "TypeAlias" && bodyElement.declaration.type !== "InterfaceDeclaration");
	}

	function hasTypeImportKind(node) {
	  return node.importKind === "type" || node.importKind === "typeof";
	}

	function isMaybeDefaultImport(type) {
	  return tokenIsKeywordOrIdentifier(type) && type !== 97;
	}

	const exportSuggestions = {
	  const: "declare export var",
	  let: "declare export var",
	  type: "export type",
	  interface: "export interface"
	};

	function partition(list, test) {
	  const list1 = [];
	  const list2 = [];

	  for (let i = 0; i < list.length; i++) {
	    (test(list[i], i, list) ? list1 : list2).push(list[i]);
	  }

	  return [list1, list2];
	}

	const FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
	var flow = (superClass => class extends superClass {
	  flowPragma = undefined;

	  getScopeHandler() {
	    return FlowScopeHandler;
	  }

	  shouldParseTypes() {
	    return this.getPluginOption("flow", "all") || this.flowPragma === "flow";
	  }

	  shouldParseEnums() {
	    return !!this.getPluginOption("flow", "enums");
	  }

	  finishToken(type, val) {
	    if (type !== 129 && type !== 13 && type !== 28) {
	      if (this.flowPragma === undefined) {
	        this.flowPragma = null;
	      }
	    }

	    return super.finishToken(type, val);
	  }

	  addComment(comment) {
	    if (this.flowPragma === undefined) {
	      const matches = FLOW_PRAGMA_REGEX.exec(comment.value);

	      if (!matches) ; else if (matches[1] === "flow") {
	        this.flowPragma = "flow";
	      } else if (matches[1] === "noflow") {
	        this.flowPragma = "noflow";
	      } else {
	        throw new Error("Unexpected flow pragma");
	      }
	    }

	    return super.addComment(comment);
	  }

	  flowParseTypeInitialiser(tok) {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    this.expect(tok || 14);
	    const type = this.flowParseType();
	    this.state.inType = oldInType;
	    return type;
	  }

	  flowParsePredicate() {
	    const node = this.startNode();
	    const moduloLoc = this.state.startLoc;
	    this.next();
	    this.expectContextual(107);

	    if (this.state.lastTokStart > moduloLoc.index + 1) {
	      this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, {
	        at: moduloLoc
	      });
	    }

	    if (this.eat(10)) {
	      node.value = this.parseExpression();
	      this.expect(11);
	      return this.finishNode(node, "DeclaredPredicate");
	    } else {
	      return this.finishNode(node, "InferredPredicate");
	    }
	  }

	  flowParseTypeAndPredicateInitialiser() {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    this.expect(14);
	    let type = null;
	    let predicate = null;

	    if (this.match(54)) {
	      this.state.inType = oldInType;
	      predicate = this.flowParsePredicate();
	    } else {
	      type = this.flowParseType();
	      this.state.inType = oldInType;

	      if (this.match(54)) {
	        predicate = this.flowParsePredicate();
	      }
	    }

	    return [type, predicate];
	  }

	  flowParseDeclareClass(node) {
	    this.next();
	    this.flowParseInterfaceish(node, true);
	    return this.finishNode(node, "DeclareClass");
	  }

	  flowParseDeclareFunction(node) {
	    this.next();
	    const id = node.id = this.parseIdentifier();
	    const typeNode = this.startNode();
	    const typeContainer = this.startNode();

	    if (this.match(47)) {
	      typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
	    } else {
	      typeNode.typeParameters = null;
	    }

	    this.expect(10);
	    const tmp = this.flowParseFunctionTypeParams();
	    typeNode.params = tmp.params;
	    typeNode.rest = tmp.rest;
	    typeNode.this = tmp._this;
	    this.expect(11);
	    [typeNode.returnType, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
	    typeContainer.typeAnnotation = this.finishNode(typeNode, "FunctionTypeAnnotation");
	    id.typeAnnotation = this.finishNode(typeContainer, "TypeAnnotation");
	    this.resetEndLocation(id);
	    this.semicolon();
	    this.scope.declareName(node.id.name, BIND_FLOW_DECLARE_FN, node.id.loc.start);
	    return this.finishNode(node, "DeclareFunction");
	  }

	  flowParseDeclare(node, insideModule) {
	    if (this.match(80)) {
	      return this.flowParseDeclareClass(node);
	    } else if (this.match(68)) {
	      return this.flowParseDeclareFunction(node);
	    } else if (this.match(74)) {
	      return this.flowParseDeclareVariable(node);
	    } else if (this.eatContextual(123)) {
	      if (this.match(16)) {
	        return this.flowParseDeclareModuleExports(node);
	      } else {
	        if (insideModule) {
	          this.raise(FlowErrors.NestedDeclareModule, {
	            at: this.state.lastTokStartLoc
	          });
	        }

	        return this.flowParseDeclareModule(node);
	      }
	    } else if (this.isContextual(126)) {
	      return this.flowParseDeclareTypeAlias(node);
	    } else if (this.isContextual(127)) {
	      return this.flowParseDeclareOpaqueType(node);
	    } else if (this.isContextual(125)) {
	      return this.flowParseDeclareInterface(node);
	    } else if (this.match(82)) {
	      return this.flowParseDeclareExportDeclaration(node, insideModule);
	    } else {
	      throw this.unexpected();
	    }
	  }

	  flowParseDeclareVariable(node) {
	    this.next();
	    node.id = this.flowParseTypeAnnotatableIdentifier(true);
	    this.scope.declareName(node.id.name, BIND_VAR, node.id.loc.start);
	    this.semicolon();
	    return this.finishNode(node, "DeclareVariable");
	  }

	  flowParseDeclareModule(node) {
	    this.scope.enter(SCOPE_OTHER);

	    if (this.match(129)) {
	      node.id = this.parseExprAtom();
	    } else {
	      node.id = this.parseIdentifier();
	    }

	    const bodyNode = node.body = this.startNode();
	    const body = bodyNode.body = [];
	    this.expect(5);

	    while (!this.match(8)) {
	      let bodyNode = this.startNode();

	      if (this.match(83)) {
	        this.next();

	        if (!this.isContextual(126) && !this.match(87)) {
	          this.raise(FlowErrors.InvalidNonTypeImportInDeclareModule, {
	            at: this.state.lastTokStartLoc
	          });
	        }

	        this.parseImport(bodyNode);
	      } else {
	        this.expectContextual(121, FlowErrors.UnsupportedStatementInDeclareModule);
	        bodyNode = this.flowParseDeclare(bodyNode, true);
	      }

	      body.push(bodyNode);
	    }

	    this.scope.exit();
	    this.expect(8);
	    this.finishNode(bodyNode, "BlockStatement");
	    let kind = null;
	    let hasModuleExport = false;
	    body.forEach(bodyElement => {
	      if (isEsModuleType(bodyElement)) {
	        if (kind === "CommonJS") {
	          this.raise(FlowErrors.AmbiguousDeclareModuleKind, {
	            node: bodyElement
	          });
	        }

	        kind = "ES";
	      } else if (bodyElement.type === "DeclareModuleExports") {
	        if (hasModuleExport) {
	          this.raise(FlowErrors.DuplicateDeclareModuleExports, {
	            node: bodyElement
	          });
	        }

	        if (kind === "ES") {
	          this.raise(FlowErrors.AmbiguousDeclareModuleKind, {
	            node: bodyElement
	          });
	        }

	        kind = "CommonJS";
	        hasModuleExport = true;
	      }
	    });
	    node.kind = kind || "CommonJS";
	    return this.finishNode(node, "DeclareModule");
	  }

	  flowParseDeclareExportDeclaration(node, insideModule) {
	    this.expect(82);

	    if (this.eat(65)) {
	      if (this.match(68) || this.match(80)) {
	        node.declaration = this.flowParseDeclare(this.startNode());
	      } else {
	        node.declaration = this.flowParseType();
	        this.semicolon();
	      }

	      node.default = true;
	      return this.finishNode(node, "DeclareExportDeclaration");
	    } else {
	      if (this.match(75) || this.isLet() || (this.isContextual(126) || this.isContextual(125)) && !insideModule) {
	        const label = this.state.value;
	        const suggestion = exportSuggestions[label];
	        throw this.raise(FlowErrors.UnsupportedDeclareExportKind, {
	          at: this.state.startLoc
	        }, label, suggestion);
	      }

	      if (this.match(74) || this.match(68) || this.match(80) || this.isContextual(127)) {
	        node.declaration = this.flowParseDeclare(this.startNode());
	        node.default = false;
	        return this.finishNode(node, "DeclareExportDeclaration");
	      } else if (this.match(55) || this.match(5) || this.isContextual(125) || this.isContextual(126) || this.isContextual(127)) {
	        node = this.parseExport(node);

	        if (node.type === "ExportNamedDeclaration") {
	          node.type = "ExportDeclaration";
	          node.default = false;
	          delete node.exportKind;
	        }

	        node.type = "Declare" + node.type;
	        return node;
	      }
	    }

	    throw this.unexpected();
	  }

	  flowParseDeclareModuleExports(node) {
	    this.next();
	    this.expectContextual(108);
	    node.typeAnnotation = this.flowParseTypeAnnotation();
	    this.semicolon();
	    return this.finishNode(node, "DeclareModuleExports");
	  }

	  flowParseDeclareTypeAlias(node) {
	    this.next();
	    this.flowParseTypeAlias(node);
	    node.type = "DeclareTypeAlias";
	    return node;
	  }

	  flowParseDeclareOpaqueType(node) {
	    this.next();
	    this.flowParseOpaqueType(node, true);
	    node.type = "DeclareOpaqueType";
	    return node;
	  }

	  flowParseDeclareInterface(node) {
	    this.next();
	    this.flowParseInterfaceish(node);
	    return this.finishNode(node, "DeclareInterface");
	  }

	  flowParseInterfaceish(node, isClass = false) {
	    node.id = this.flowParseRestrictedIdentifier(!isClass, true);
	    this.scope.declareName(node.id.name, isClass ? BIND_FUNCTION : BIND_LEXICAL, node.id.loc.start);

	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    } else {
	      node.typeParameters = null;
	    }

	    node.extends = [];
	    node.implements = [];
	    node.mixins = [];

	    if (this.eat(81)) {
	      do {
	        node.extends.push(this.flowParseInterfaceExtends());
	      } while (!isClass && this.eat(12));
	    }

	    if (this.isContextual(114)) {
	      this.next();

	      do {
	        node.mixins.push(this.flowParseInterfaceExtends());
	      } while (this.eat(12));
	    }

	    if (this.isContextual(110)) {
	      this.next();

	      do {
	        node.implements.push(this.flowParseInterfaceExtends());
	      } while (this.eat(12));
	    }

	    node.body = this.flowParseObjectType({
	      allowStatic: isClass,
	      allowExact: false,
	      allowSpread: false,
	      allowProto: isClass,
	      allowInexact: false
	    });
	  }

	  flowParseInterfaceExtends() {
	    const node = this.startNode();
	    node.id = this.flowParseQualifiedTypeIdentifier();

	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterInstantiation();
	    } else {
	      node.typeParameters = null;
	    }

	    return this.finishNode(node, "InterfaceExtends");
	  }

	  flowParseInterface(node) {
	    this.flowParseInterfaceish(node);
	    return this.finishNode(node, "InterfaceDeclaration");
	  }

	  checkNotUnderscore(word) {
	    if (word === "_") {
	      this.raise(FlowErrors.UnexpectedReservedUnderscore, {
	        at: this.state.startLoc
	      });
	    }
	  }

	  checkReservedType(word, startLoc, declaration) {
	    if (!reservedTypes.has(word)) return;
	    this.raise(declaration ? FlowErrors.AssignReservedType : FlowErrors.UnexpectedReservedType, {
	      at: startLoc
	    }, word);
	  }

	  flowParseRestrictedIdentifier(liberal, declaration) {
	    this.checkReservedType(this.state.value, this.state.startLoc, declaration);
	    return this.parseIdentifier(liberal);
	  }

	  flowParseTypeAlias(node) {
	    node.id = this.flowParseRestrictedIdentifier(false, true);
	    this.scope.declareName(node.id.name, BIND_LEXICAL, node.id.loc.start);

	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    } else {
	      node.typeParameters = null;
	    }

	    node.right = this.flowParseTypeInitialiser(29);
	    this.semicolon();
	    return this.finishNode(node, "TypeAlias");
	  }

	  flowParseOpaqueType(node, declare) {
	    this.expectContextual(126);
	    node.id = this.flowParseRestrictedIdentifier(true, true);
	    this.scope.declareName(node.id.name, BIND_LEXICAL, node.id.loc.start);

	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    } else {
	      node.typeParameters = null;
	    }

	    node.supertype = null;

	    if (this.match(14)) {
	      node.supertype = this.flowParseTypeInitialiser(14);
	    }

	    node.impltype = null;

	    if (!declare) {
	      node.impltype = this.flowParseTypeInitialiser(29);
	    }

	    this.semicolon();
	    return this.finishNode(node, "OpaqueType");
	  }

	  flowParseTypeParameter(requireDefault = false) {
	    const nodeStartLoc = this.state.startLoc;
	    const node = this.startNode();
	    const variance = this.flowParseVariance();
	    const ident = this.flowParseTypeAnnotatableIdentifier();
	    node.name = ident.name;
	    node.variance = variance;
	    node.bound = ident.typeAnnotation;

	    if (this.match(29)) {
	      this.eat(29);
	      node.default = this.flowParseType();
	    } else {
	      if (requireDefault) {
	        this.raise(FlowErrors.MissingTypeParamDefault, {
	          at: nodeStartLoc
	        });
	      }
	    }

	    return this.finishNode(node, "TypeParameter");
	  }

	  flowParseTypeParameterDeclaration() {
	    const oldInType = this.state.inType;
	    const node = this.startNode();
	    node.params = [];
	    this.state.inType = true;

	    if (this.match(47) || this.match(138)) {
	      this.next();
	    } else {
	      this.unexpected();
	    }

	    let defaultRequired = false;

	    do {
	      const typeParameter = this.flowParseTypeParameter(defaultRequired);
	      node.params.push(typeParameter);

	      if (typeParameter.default) {
	        defaultRequired = true;
	      }

	      if (!this.match(48)) {
	        this.expect(12);
	      }
	    } while (!this.match(48));

	    this.expect(48);
	    this.state.inType = oldInType;
	    return this.finishNode(node, "TypeParameterDeclaration");
	  }

	  flowParseTypeParameterInstantiation() {
	    const node = this.startNode();
	    const oldInType = this.state.inType;
	    node.params = [];
	    this.state.inType = true;
	    this.expect(47);
	    const oldNoAnonFunctionType = this.state.noAnonFunctionType;
	    this.state.noAnonFunctionType = false;

	    while (!this.match(48)) {
	      node.params.push(this.flowParseType());

	      if (!this.match(48)) {
	        this.expect(12);
	      }
	    }

	    this.state.noAnonFunctionType = oldNoAnonFunctionType;
	    this.expect(48);
	    this.state.inType = oldInType;
	    return this.finishNode(node, "TypeParameterInstantiation");
	  }

	  flowParseTypeParameterInstantiationCallOrNew() {
	    const node = this.startNode();
	    const oldInType = this.state.inType;
	    node.params = [];
	    this.state.inType = true;
	    this.expect(47);

	    while (!this.match(48)) {
	      node.params.push(this.flowParseTypeOrImplicitInstantiation());

	      if (!this.match(48)) {
	        this.expect(12);
	      }
	    }

	    this.expect(48);
	    this.state.inType = oldInType;
	    return this.finishNode(node, "TypeParameterInstantiation");
	  }

	  flowParseInterfaceType() {
	    const node = this.startNode();
	    this.expectContextual(125);
	    node.extends = [];

	    if (this.eat(81)) {
	      do {
	        node.extends.push(this.flowParseInterfaceExtends());
	      } while (this.eat(12));
	    }

	    node.body = this.flowParseObjectType({
	      allowStatic: false,
	      allowExact: false,
	      allowSpread: false,
	      allowProto: false,
	      allowInexact: false
	    });
	    return this.finishNode(node, "InterfaceTypeAnnotation");
	  }

	  flowParseObjectPropertyKey() {
	    return this.match(130) || this.match(129) ? this.parseExprAtom() : this.parseIdentifier(true);
	  }

	  flowParseObjectTypeIndexer(node, isStatic, variance) {
	    node.static = isStatic;

	    if (this.lookahead().type === 14) {
	      node.id = this.flowParseObjectPropertyKey();
	      node.key = this.flowParseTypeInitialiser();
	    } else {
	      node.id = null;
	      node.key = this.flowParseType();
	    }

	    this.expect(3);
	    node.value = this.flowParseTypeInitialiser();
	    node.variance = variance;
	    return this.finishNode(node, "ObjectTypeIndexer");
	  }

	  flowParseObjectTypeInternalSlot(node, isStatic) {
	    node.static = isStatic;
	    node.id = this.flowParseObjectPropertyKey();
	    this.expect(3);
	    this.expect(3);

	    if (this.match(47) || this.match(10)) {
	      node.method = true;
	      node.optional = false;
	      node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.start, node.loc.start));
	    } else {
	      node.method = false;

	      if (this.eat(17)) {
	        node.optional = true;
	      }

	      node.value = this.flowParseTypeInitialiser();
	    }

	    return this.finishNode(node, "ObjectTypeInternalSlot");
	  }

	  flowParseObjectTypeMethodish(node) {
	    node.params = [];
	    node.rest = null;
	    node.typeParameters = null;
	    node.this = null;

	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    }

	    this.expect(10);

	    if (this.match(78)) {
	      node.this = this.flowParseFunctionTypeParam(true);
	      node.this.name = null;

	      if (!this.match(11)) {
	        this.expect(12);
	      }
	    }

	    while (!this.match(11) && !this.match(21)) {
	      node.params.push(this.flowParseFunctionTypeParam(false));

	      if (!this.match(11)) {
	        this.expect(12);
	      }
	    }

	    if (this.eat(21)) {
	      node.rest = this.flowParseFunctionTypeParam(false);
	    }

	    this.expect(11);
	    node.returnType = this.flowParseTypeInitialiser();
	    return this.finishNode(node, "FunctionTypeAnnotation");
	  }

	  flowParseObjectTypeCallProperty(node, isStatic) {
	    const valueNode = this.startNode();
	    node.static = isStatic;
	    node.value = this.flowParseObjectTypeMethodish(valueNode);
	    return this.finishNode(node, "ObjectTypeCallProperty");
	  }

	  flowParseObjectType({
	    allowStatic,
	    allowExact,
	    allowSpread,
	    allowProto,
	    allowInexact
	  }) {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    const nodeStart = this.startNode();
	    nodeStart.callProperties = [];
	    nodeStart.properties = [];
	    nodeStart.indexers = [];
	    nodeStart.internalSlots = [];
	    let endDelim;
	    let exact;
	    let inexact = false;

	    if (allowExact && this.match(6)) {
	      this.expect(6);
	      endDelim = 9;
	      exact = true;
	    } else {
	      this.expect(5);
	      endDelim = 8;
	      exact = false;
	    }

	    nodeStart.exact = exact;

	    while (!this.match(endDelim)) {
	      let isStatic = false;
	      let protoStartLoc = null;
	      let inexactStartLoc = null;
	      const node = this.startNode();

	      if (allowProto && this.isContextual(115)) {
	        const lookahead = this.lookahead();

	        if (lookahead.type !== 14 && lookahead.type !== 17) {
	          this.next();
	          protoStartLoc = this.state.startLoc;
	          allowStatic = false;
	        }
	      }

	      if (allowStatic && this.isContextual(104)) {
	        const lookahead = this.lookahead();

	        if (lookahead.type !== 14 && lookahead.type !== 17) {
	          this.next();
	          isStatic = true;
	        }
	      }

	      const variance = this.flowParseVariance();

	      if (this.eat(0)) {
	        if (protoStartLoc != null) {
	          this.unexpected(protoStartLoc);
	        }

	        if (this.eat(0)) {
	          if (variance) {
	            this.unexpected(variance.loc.start);
	          }

	          nodeStart.internalSlots.push(this.flowParseObjectTypeInternalSlot(node, isStatic));
	        } else {
	          nodeStart.indexers.push(this.flowParseObjectTypeIndexer(node, isStatic, variance));
	        }
	      } else if (this.match(10) || this.match(47)) {
	        if (protoStartLoc != null) {
	          this.unexpected(protoStartLoc);
	        }

	        if (variance) {
	          this.unexpected(variance.loc.start);
	        }

	        nodeStart.callProperties.push(this.flowParseObjectTypeCallProperty(node, isStatic));
	      } else {
	        let kind = "init";

	        if (this.isContextual(98) || this.isContextual(103)) {
	          const lookahead = this.lookahead();

	          if (tokenIsLiteralPropertyName(lookahead.type)) {
	            kind = this.state.value;
	            this.next();
	          }
	        }

	        const propOrInexact = this.flowParseObjectTypeProperty(node, isStatic, protoStartLoc, variance, kind, allowSpread, allowInexact ?? !exact);

	        if (propOrInexact === null) {
	          inexact = true;
	          inexactStartLoc = this.state.lastTokStartLoc;
	        } else {
	          nodeStart.properties.push(propOrInexact);
	        }
	      }

	      this.flowObjectTypeSemicolon();

	      if (inexactStartLoc && !this.match(8) && !this.match(9)) {
	        this.raise(FlowErrors.UnexpectedExplicitInexactInObject, {
	          at: inexactStartLoc
	        });
	      }
	    }

	    this.expect(endDelim);

	    if (allowSpread) {
	      nodeStart.inexact = inexact;
	    }

	    const out = this.finishNode(nodeStart, "ObjectTypeAnnotation");
	    this.state.inType = oldInType;
	    return out;
	  }

	  flowParseObjectTypeProperty(node, isStatic, protoStartLoc, variance, kind, allowSpread, allowInexact) {
	    if (this.eat(21)) {
	      const isInexactToken = this.match(12) || this.match(13) || this.match(8) || this.match(9);

	      if (isInexactToken) {
	        if (!allowSpread) {
	          this.raise(FlowErrors.InexactInsideNonObject, {
	            at: this.state.lastTokStartLoc
	          });
	        } else if (!allowInexact) {
	          this.raise(FlowErrors.InexactInsideExact, {
	            at: this.state.lastTokStartLoc
	          });
	        }

	        if (variance) {
	          this.raise(FlowErrors.InexactVariance, {
	            node: variance
	          });
	        }

	        return null;
	      }

	      if (!allowSpread) {
	        this.raise(FlowErrors.UnexpectedSpreadType, {
	          at: this.state.lastTokStartLoc
	        });
	      }

	      if (protoStartLoc != null) {
	        this.unexpected(protoStartLoc);
	      }

	      if (variance) {
	        this.raise(FlowErrors.SpreadVariance, {
	          node: variance
	        });
	      }

	      node.argument = this.flowParseType();
	      return this.finishNode(node, "ObjectTypeSpreadProperty");
	    } else {
	      node.key = this.flowParseObjectPropertyKey();
	      node.static = isStatic;
	      node.proto = protoStartLoc != null;
	      node.kind = kind;
	      let optional = false;

	      if (this.match(47) || this.match(10)) {
	        node.method = true;

	        if (protoStartLoc != null) {
	          this.unexpected(protoStartLoc);
	        }

	        if (variance) {
	          this.unexpected(variance.loc.start);
	        }

	        node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.start, node.loc.start));

	        if (kind === "get" || kind === "set") {
	          this.flowCheckGetterSetterParams(node);
	        }

	        if (!allowSpread && node.key.name === "constructor" && node.value.this) {
	          this.raise(FlowErrors.ThisParamBannedInConstructor, {
	            node: node.value.this
	          });
	        }
	      } else {
	        if (kind !== "init") this.unexpected();
	        node.method = false;

	        if (this.eat(17)) {
	          optional = true;
	        }

	        node.value = this.flowParseTypeInitialiser();
	        node.variance = variance;
	      }

	      node.optional = optional;
	      return this.finishNode(node, "ObjectTypeProperty");
	    }
	  }

	  flowCheckGetterSetterParams(property) {
	    const paramCount = property.kind === "get" ? 0 : 1;
	    const length = property.value.params.length + (property.value.rest ? 1 : 0);

	    if (property.value.this) {
	      this.raise(property.kind === "get" ? FlowErrors.GetterMayNotHaveThisParam : FlowErrors.SetterMayNotHaveThisParam, {
	        node: property.value.this
	      });
	    }

	    if (length !== paramCount) {
	      this.raise(property.kind === "get" ? ErrorMessages.BadGetterArity : ErrorMessages.BadSetterArity, {
	        node: property
	      });
	    }

	    if (property.kind === "set" && property.value.rest) {
	      this.raise(ErrorMessages.BadSetterRestParameter, {
	        node: property
	      });
	    }
	  }

	  flowObjectTypeSemicolon() {
	    if (!this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9)) {
	      this.unexpected();
	    }
	  }

	  flowParseQualifiedTypeIdentifier(startPos, startLoc, id) {
	    startPos = startPos || this.state.start;
	    startLoc = startLoc || this.state.startLoc;
	    let node = id || this.flowParseRestrictedIdentifier(true);

	    while (this.eat(16)) {
	      const node2 = this.startNodeAt(startPos, startLoc);
	      node2.qualification = node;
	      node2.id = this.flowParseRestrictedIdentifier(true);
	      node = this.finishNode(node2, "QualifiedTypeIdentifier");
	    }

	    return node;
	  }

	  flowParseGenericType(startPos, startLoc, id) {
	    const node = this.startNodeAt(startPos, startLoc);
	    node.typeParameters = null;
	    node.id = this.flowParseQualifiedTypeIdentifier(startPos, startLoc, id);

	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterInstantiation();
	    }

	    return this.finishNode(node, "GenericTypeAnnotation");
	  }

	  flowParseTypeofType() {
	    const node = this.startNode();
	    this.expect(87);
	    node.argument = this.flowParsePrimaryType();
	    return this.finishNode(node, "TypeofTypeAnnotation");
	  }

	  flowParseTupleType() {
	    const node = this.startNode();
	    node.types = [];
	    this.expect(0);

	    while (this.state.pos < this.length && !this.match(3)) {
	      node.types.push(this.flowParseType());
	      if (this.match(3)) break;
	      this.expect(12);
	    }

	    this.expect(3);
	    return this.finishNode(node, "TupleTypeAnnotation");
	  }

	  flowParseFunctionTypeParam(first) {
	    let name = null;
	    let optional = false;
	    let typeAnnotation = null;
	    const node = this.startNode();
	    const lh = this.lookahead();
	    const isThis = this.state.type === 78;

	    if (lh.type === 14 || lh.type === 17) {
	      if (isThis && !first) {
	        this.raise(FlowErrors.ThisParamMustBeFirst, {
	          node
	        });
	      }

	      name = this.parseIdentifier(isThis);

	      if (this.eat(17)) {
	        optional = true;

	        if (isThis) {
	          this.raise(FlowErrors.ThisParamMayNotBeOptional, {
	            node
	          });
	        }
	      }

	      typeAnnotation = this.flowParseTypeInitialiser();
	    } else {
	      typeAnnotation = this.flowParseType();
	    }

	    node.name = name;
	    node.optional = optional;
	    node.typeAnnotation = typeAnnotation;
	    return this.finishNode(node, "FunctionTypeParam");
	  }

	  reinterpretTypeAsFunctionTypeParam(type) {
	    const node = this.startNodeAt(type.start, type.loc.start);
	    node.name = null;
	    node.optional = false;
	    node.typeAnnotation = type;
	    return this.finishNode(node, "FunctionTypeParam");
	  }

	  flowParseFunctionTypeParams(params = []) {
	    let rest = null;
	    let _this = null;

	    if (this.match(78)) {
	      _this = this.flowParseFunctionTypeParam(true);
	      _this.name = null;

	      if (!this.match(11)) {
	        this.expect(12);
	      }
	    }

	    while (!this.match(11) && !this.match(21)) {
	      params.push(this.flowParseFunctionTypeParam(false));

	      if (!this.match(11)) {
	        this.expect(12);
	      }
	    }

	    if (this.eat(21)) {
	      rest = this.flowParseFunctionTypeParam(false);
	    }

	    return {
	      params,
	      rest,
	      _this
	    };
	  }

	  flowIdentToTypeAnnotation(startPos, startLoc, node, id) {
	    switch (id.name) {
	      case "any":
	        return this.finishNode(node, "AnyTypeAnnotation");

	      case "bool":
	      case "boolean":
	        return this.finishNode(node, "BooleanTypeAnnotation");

	      case "mixed":
	        return this.finishNode(node, "MixedTypeAnnotation");

	      case "empty":
	        return this.finishNode(node, "EmptyTypeAnnotation");

	      case "number":
	        return this.finishNode(node, "NumberTypeAnnotation");

	      case "string":
	        return this.finishNode(node, "StringTypeAnnotation");

	      case "symbol":
	        return this.finishNode(node, "SymbolTypeAnnotation");

	      default:
	        this.checkNotUnderscore(id.name);
	        return this.flowParseGenericType(startPos, startLoc, id);
	    }
	  }

	  flowParsePrimaryType() {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    const node = this.startNode();
	    let tmp;
	    let type;
	    let isGroupedType = false;
	    const oldNoAnonFunctionType = this.state.noAnonFunctionType;

	    switch (this.state.type) {
	      case 5:
	        return this.flowParseObjectType({
	          allowStatic: false,
	          allowExact: false,
	          allowSpread: true,
	          allowProto: false,
	          allowInexact: true
	        });

	      case 6:
	        return this.flowParseObjectType({
	          allowStatic: false,
	          allowExact: true,
	          allowSpread: true,
	          allowProto: false,
	          allowInexact: false
	        });

	      case 0:
	        this.state.noAnonFunctionType = false;
	        type = this.flowParseTupleType();
	        this.state.noAnonFunctionType = oldNoAnonFunctionType;
	        return type;

	      case 47:
	        node.typeParameters = this.flowParseTypeParameterDeclaration();
	        this.expect(10);
	        tmp = this.flowParseFunctionTypeParams();
	        node.params = tmp.params;
	        node.rest = tmp.rest;
	        node.this = tmp._this;
	        this.expect(11);
	        this.expect(19);
	        node.returnType = this.flowParseType();
	        return this.finishNode(node, "FunctionTypeAnnotation");

	      case 10:
	        this.next();

	        if (!this.match(11) && !this.match(21)) {
	          if (tokenIsIdentifier(this.state.type) || this.match(78)) {
	            const token = this.lookahead().type;
	            isGroupedType = token !== 17 && token !== 14;
	          } else {
	            isGroupedType = true;
	          }
	        }

	        if (isGroupedType) {
	          this.state.noAnonFunctionType = false;
	          type = this.flowParseType();
	          this.state.noAnonFunctionType = oldNoAnonFunctionType;

	          if (this.state.noAnonFunctionType || !(this.match(12) || this.match(11) && this.lookahead().type === 19)) {
	            this.expect(11);
	            return type;
	          } else {
	            this.eat(12);
	          }
	        }

	        if (type) {
	          tmp = this.flowParseFunctionTypeParams([this.reinterpretTypeAsFunctionTypeParam(type)]);
	        } else {
	          tmp = this.flowParseFunctionTypeParams();
	        }

	        node.params = tmp.params;
	        node.rest = tmp.rest;
	        node.this = tmp._this;
	        this.expect(11);
	        this.expect(19);
	        node.returnType = this.flowParseType();
	        node.typeParameters = null;
	        return this.finishNode(node, "FunctionTypeAnnotation");

	      case 129:
	        return this.parseLiteral(this.state.value, "StringLiteralTypeAnnotation");

	      case 85:
	      case 86:
	        node.value = this.match(85);
	        this.next();
	        return this.finishNode(node, "BooleanLiteralTypeAnnotation");

	      case 53:
	        if (this.state.value === "-") {
	          this.next();

	          if (this.match(130)) {
	            return this.parseLiteralAtNode(-this.state.value, "NumberLiteralTypeAnnotation", node);
	          }

	          if (this.match(131)) {
	            return this.parseLiteralAtNode(-this.state.value, "BigIntLiteralTypeAnnotation", node);
	          }

	          throw this.raise(FlowErrors.UnexpectedSubtractionOperand, {
	            at: this.state.startLoc
	          });
	        }

	        throw this.unexpected();

	      case 130:
	        return this.parseLiteral(this.state.value, "NumberLiteralTypeAnnotation");

	      case 131:
	        return this.parseLiteral(this.state.value, "BigIntLiteralTypeAnnotation");

	      case 88:
	        this.next();
	        return this.finishNode(node, "VoidTypeAnnotation");

	      case 84:
	        this.next();
	        return this.finishNode(node, "NullLiteralTypeAnnotation");

	      case 78:
	        this.next();
	        return this.finishNode(node, "ThisTypeAnnotation");

	      case 55:
	        this.next();
	        return this.finishNode(node, "ExistsTypeAnnotation");

	      case 87:
	        return this.flowParseTypeofType();

	      default:
	        if (tokenIsKeyword(this.state.type)) {
	          const label = tokenLabelName(this.state.type);
	          this.next();
	          return super.createIdentifier(node, label);
	        } else if (tokenIsIdentifier(this.state.type)) {
	          if (this.isContextual(125)) {
	            return this.flowParseInterfaceType();
	          }

	          return this.flowIdentToTypeAnnotation(startPos, startLoc, node, this.parseIdentifier());
	        }

	    }

	    throw this.unexpected();
	  }

	  flowParsePostfixType() {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    let type = this.flowParsePrimaryType();
	    let seenOptionalIndexedAccess = false;

	    while ((this.match(0) || this.match(18)) && !this.canInsertSemicolon()) {
	      const node = this.startNodeAt(startPos, startLoc);
	      const optional = this.eat(18);
	      seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
	      this.expect(0);

	      if (!optional && this.match(3)) {
	        node.elementType = type;
	        this.next();
	        type = this.finishNode(node, "ArrayTypeAnnotation");
	      } else {
	        node.objectType = type;
	        node.indexType = this.flowParseType();
	        this.expect(3);

	        if (seenOptionalIndexedAccess) {
	          node.optional = optional;
	          type = this.finishNode(node, "OptionalIndexedAccessType");
	        } else {
	          type = this.finishNode(node, "IndexedAccessType");
	        }
	      }
	    }

	    return type;
	  }

	  flowParsePrefixType() {
	    const node = this.startNode();

	    if (this.eat(17)) {
	      node.typeAnnotation = this.flowParsePrefixType();
	      return this.finishNode(node, "NullableTypeAnnotation");
	    } else {
	      return this.flowParsePostfixType();
	    }
	  }

	  flowParseAnonFunctionWithoutParens() {
	    const param = this.flowParsePrefixType();

	    if (!this.state.noAnonFunctionType && this.eat(19)) {
	      const node = this.startNodeAt(param.start, param.loc.start);
	      node.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
	      node.rest = null;
	      node.this = null;
	      node.returnType = this.flowParseType();
	      node.typeParameters = null;
	      return this.finishNode(node, "FunctionTypeAnnotation");
	    }

	    return param;
	  }

	  flowParseIntersectionType() {
	    const node = this.startNode();
	    this.eat(45);
	    const type = this.flowParseAnonFunctionWithoutParens();
	    node.types = [type];

	    while (this.eat(45)) {
	      node.types.push(this.flowParseAnonFunctionWithoutParens());
	    }

	    return node.types.length === 1 ? type : this.finishNode(node, "IntersectionTypeAnnotation");
	  }

	  flowParseUnionType() {
	    const node = this.startNode();
	    this.eat(43);
	    const type = this.flowParseIntersectionType();
	    node.types = [type];

	    while (this.eat(43)) {
	      node.types.push(this.flowParseIntersectionType());
	    }

	    return node.types.length === 1 ? type : this.finishNode(node, "UnionTypeAnnotation");
	  }

	  flowParseType() {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    const type = this.flowParseUnionType();
	    this.state.inType = oldInType;
	    return type;
	  }

	  flowParseTypeOrImplicitInstantiation() {
	    if (this.state.type === 128 && this.state.value === "_") {
	      const startPos = this.state.start;
	      const startLoc = this.state.startLoc;
	      const node = this.parseIdentifier();
	      return this.flowParseGenericType(startPos, startLoc, node);
	    } else {
	      return this.flowParseType();
	    }
	  }

	  flowParseTypeAnnotation() {
	    const node = this.startNode();
	    node.typeAnnotation = this.flowParseTypeInitialiser();
	    return this.finishNode(node, "TypeAnnotation");
	  }

	  flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
	    const ident = allowPrimitiveOverride ? this.parseIdentifier() : this.flowParseRestrictedIdentifier();

	    if (this.match(14)) {
	      ident.typeAnnotation = this.flowParseTypeAnnotation();
	      this.resetEndLocation(ident);
	    }

	    return ident;
	  }

	  typeCastToParameter(node) {
	    node.expression.typeAnnotation = node.typeAnnotation;
	    this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
	    return node.expression;
	  }

	  flowParseVariance() {
	    let variance = null;

	    if (this.match(53)) {
	      variance = this.startNode();

	      if (this.state.value === "+") {
	        variance.kind = "plus";
	      } else {
	        variance.kind = "minus";
	      }

	      this.next();
	      this.finishNode(variance, "Variance");
	    }

	    return variance;
	  }

	  parseFunctionBody(node, allowExpressionBody, isMethod = false) {
	    if (allowExpressionBody) {
	      return this.forwardNoArrowParamsConversionAt(node, () => super.parseFunctionBody(node, true, isMethod));
	    }

	    return super.parseFunctionBody(node, false, isMethod);
	  }

	  parseFunctionBodyAndFinish(node, type, isMethod = false) {
	    if (this.match(14)) {
	      const typeNode = this.startNode();
	      [typeNode.typeAnnotation, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
	      node.returnType = typeNode.typeAnnotation ? this.finishNode(typeNode, "TypeAnnotation") : null;
	    }

	    super.parseFunctionBodyAndFinish(node, type, isMethod);
	  }

	  parseStatement(context, topLevel) {
	    if (this.state.strict && this.isContextual(125)) {
	      const lookahead = this.lookahead();

	      if (tokenIsKeywordOrIdentifier(lookahead.type)) {
	        const node = this.startNode();
	        this.next();
	        return this.flowParseInterface(node);
	      }
	    } else if (this.shouldParseEnums() && this.isContextual(122)) {
	      const node = this.startNode();
	      this.next();
	      return this.flowParseEnumDeclaration(node);
	    }

	    const stmt = super.parseStatement(context, topLevel);

	    if (this.flowPragma === undefined && !this.isValidDirective(stmt)) {
	      this.flowPragma = null;
	    }

	    return stmt;
	  }

	  parseExpressionStatement(node, expr) {
	    if (expr.type === "Identifier") {
	      if (expr.name === "declare") {
	        if (this.match(80) || tokenIsIdentifier(this.state.type) || this.match(68) || this.match(74) || this.match(82)) {
	          return this.flowParseDeclare(node);
	        }
	      } else if (tokenIsIdentifier(this.state.type)) {
	        if (expr.name === "interface") {
	          return this.flowParseInterface(node);
	        } else if (expr.name === "type") {
	          return this.flowParseTypeAlias(node);
	        } else if (expr.name === "opaque") {
	          return this.flowParseOpaqueType(node, false);
	        }
	      }
	    }

	    return super.parseExpressionStatement(node, expr);
	  }

	  shouldParseExportDeclaration() {
	    const {
	      type
	    } = this.state;

	    if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.shouldParseEnums() && type === 122) {
	      return !this.state.containsEsc;
	    }

	    return super.shouldParseExportDeclaration();
	  }

	  isExportDefaultSpecifier() {
	    const {
	      type
	    } = this.state;

	    if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.shouldParseEnums() && type === 122) {
	      return this.state.containsEsc;
	    }

	    return super.isExportDefaultSpecifier();
	  }

	  parseExportDefaultExpression() {
	    if (this.shouldParseEnums() && this.isContextual(122)) {
	      const node = this.startNode();
	      this.next();
	      return this.flowParseEnumDeclaration(node);
	    }

	    return super.parseExportDefaultExpression();
	  }

	  parseConditional(expr, startPos, startLoc, refExpressionErrors) {
	    if (!this.match(17)) return expr;

	    if (this.state.maybeInArrowParameters) {
	      const nextCh = this.lookaheadCharCode();

	      if (nextCh === 44 || nextCh === 61 || nextCh === 58 || nextCh === 41) {
	        this.setOptionalParametersError(refExpressionErrors);
	        return expr;
	      }
	    }

	    this.expect(17);
	    const state = this.state.clone();
	    const originalNoArrowAt = this.state.noArrowAt;
	    const node = this.startNodeAt(startPos, startLoc);
	    let {
	      consequent,
	      failed
	    } = this.tryParseConditionalConsequent();
	    let [valid, invalid] = this.getArrowLikeExpressions(consequent);

	    if (failed || invalid.length > 0) {
	      const noArrowAt = [...originalNoArrowAt];

	      if (invalid.length > 0) {
	        this.state = state;
	        this.state.noArrowAt = noArrowAt;

	        for (let i = 0; i < invalid.length; i++) {
	          noArrowAt.push(invalid[i].start);
	        }

	        ({
	          consequent,
	          failed
	        } = this.tryParseConditionalConsequent());
	        [valid, invalid] = this.getArrowLikeExpressions(consequent);
	      }

	      if (failed && valid.length > 1) {
	        this.raise(FlowErrors.AmbiguousConditionalArrow, {
	          at: state.startLoc
	        });
	      }

	      if (failed && valid.length === 1) {
	        this.state = state;
	        noArrowAt.push(valid[0].start);
	        this.state.noArrowAt = noArrowAt;
	        ({
	          consequent,
	          failed
	        } = this.tryParseConditionalConsequent());
	      }
	    }

	    this.getArrowLikeExpressions(consequent, true);
	    this.state.noArrowAt = originalNoArrowAt;
	    this.expect(14);
	    node.test = expr;
	    node.consequent = consequent;
	    node.alternate = this.forwardNoArrowParamsConversionAt(node, () => this.parseMaybeAssign(undefined, undefined));
	    return this.finishNode(node, "ConditionalExpression");
	  }

	  tryParseConditionalConsequent() {
	    this.state.noArrowParamsConversionAt.push(this.state.start);
	    const consequent = this.parseMaybeAssignAllowIn();
	    const failed = !this.match(14);
	    this.state.noArrowParamsConversionAt.pop();
	    return {
	      consequent,
	      failed
	    };
	  }

	  getArrowLikeExpressions(node, disallowInvalid) {
	    const stack = [node];
	    const arrows = [];

	    while (stack.length !== 0) {
	      const node = stack.pop();

	      if (node.type === "ArrowFunctionExpression") {
	        if (node.typeParameters || !node.returnType) {
	          this.finishArrowValidation(node);
	        } else {
	          arrows.push(node);
	        }

	        stack.push(node.body);
	      } else if (node.type === "ConditionalExpression") {
	        stack.push(node.consequent);
	        stack.push(node.alternate);
	      }
	    }

	    if (disallowInvalid) {
	      arrows.forEach(node => this.finishArrowValidation(node));
	      return [arrows, []];
	    }

	    return partition(arrows, node => node.params.every(param => this.isAssignable(param, true)));
	  }

	  finishArrowValidation(node) {
	    this.toAssignableList(node.params, node.extra?.trailingCommaLoc, false);
	    this.scope.enter(SCOPE_FUNCTION | SCOPE_ARROW);
	    super.checkParams(node, false, true);
	    this.scope.exit();
	  }

	  forwardNoArrowParamsConversionAt(node, parse) {
	    let result;

	    if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
	      this.state.noArrowParamsConversionAt.push(this.state.start);
	      result = parse();
	      this.state.noArrowParamsConversionAt.pop();
	    } else {
	      result = parse();
	    }

	    return result;
	  }

	  parseParenItem(node, startPos, startLoc) {
	    node = super.parseParenItem(node, startPos, startLoc);

	    if (this.eat(17)) {
	      node.optional = true;
	      this.resetEndLocation(node);
	    }

	    if (this.match(14)) {
	      const typeCastNode = this.startNodeAt(startPos, startLoc);
	      typeCastNode.expression = node;
	      typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
	      return this.finishNode(typeCastNode, "TypeCastExpression");
	    }

	    return node;
	  }

	  assertModuleNodeAllowed(node) {
	    if (node.type === "ImportDeclaration" && (node.importKind === "type" || node.importKind === "typeof") || node.type === "ExportNamedDeclaration" && node.exportKind === "type" || node.type === "ExportAllDeclaration" && node.exportKind === "type") {
	      return;
	    }

	    super.assertModuleNodeAllowed(node);
	  }

	  parseExport(node) {
	    const decl = super.parseExport(node);

	    if (decl.type === "ExportNamedDeclaration" || decl.type === "ExportAllDeclaration") {
	      decl.exportKind = decl.exportKind || "value";
	    }

	    return decl;
	  }

	  parseExportDeclaration(node) {
	    if (this.isContextual(126)) {
	      node.exportKind = "type";
	      const declarationNode = this.startNode();
	      this.next();

	      if (this.match(5)) {
	        node.specifiers = this.parseExportSpecifiers(true);
	        this.parseExportFrom(node);
	        return null;
	      } else {
	        return this.flowParseTypeAlias(declarationNode);
	      }
	    } else if (this.isContextual(127)) {
	      node.exportKind = "type";
	      const declarationNode = this.startNode();
	      this.next();
	      return this.flowParseOpaqueType(declarationNode, false);
	    } else if (this.isContextual(125)) {
	      node.exportKind = "type";
	      const declarationNode = this.startNode();
	      this.next();
	      return this.flowParseInterface(declarationNode);
	    } else if (this.shouldParseEnums() && this.isContextual(122)) {
	      node.exportKind = "value";
	      const declarationNode = this.startNode();
	      this.next();
	      return this.flowParseEnumDeclaration(declarationNode);
	    } else {
	      return super.parseExportDeclaration(node);
	    }
	  }

	  eatExportStar(node) {
	    if (super.eatExportStar(...arguments)) return true;

	    if (this.isContextual(126) && this.lookahead().type === 55) {
	      node.exportKind = "type";
	      this.next();
	      this.next();
	      return true;
	    }

	    return false;
	  }

	  maybeParseExportNamespaceSpecifier(node) {
	    const {
	      startLoc
	    } = this.state;
	    const hasNamespace = super.maybeParseExportNamespaceSpecifier(node);

	    if (hasNamespace && node.exportKind === "type") {
	      this.unexpected(startLoc);
	    }

	    return hasNamespace;
	  }

	  parseClassId(node, isStatement, optionalId) {
	    super.parseClassId(node, isStatement, optionalId);

	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    }
	  }

	  parseClassMember(classBody, member, state) {
	    const {
	      startLoc
	    } = this.state;

	    if (this.isContextual(121)) {
	      if (this.parseClassMemberFromModifier(classBody, member)) {
	        return;
	      }

	      member.declare = true;
	    }

	    super.parseClassMember(classBody, member, state);

	    if (member.declare) {
	      if (member.type !== "ClassProperty" && member.type !== "ClassPrivateProperty" && member.type !== "PropertyDefinition") {
	        this.raise(FlowErrors.DeclareClassElement, {
	          at: startLoc
	        });
	      } else if (member.value) {
	        this.raise(FlowErrors.DeclareClassFieldInitializer, {
	          node: member.value
	        });
	      }
	    }
	  }

	  isIterator(word) {
	    return word === "iterator" || word === "asyncIterator";
	  }

	  readIterator() {
	    const word = super.readWord1();
	    const fullWord = "@@" + word;

	    if (!this.isIterator(word) || !this.state.inType) {
	      this.raise(ErrorMessages.InvalidIdentifier, {
	        at: this.state.curPosition()
	      }, fullWord);
	    }

	    this.finishToken(128, fullWord);
	  }

	  getTokenFromCode(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (code === 123 && next === 124) {
	      return this.finishOp(6, 2);
	    } else if (this.state.inType && (code === 62 || code === 60)) {
	      return this.finishOp(code === 62 ? 48 : 47, 1);
	    } else if (this.state.inType && code === 63) {
	      if (next === 46) {
	        return this.finishOp(18, 2);
	      }

	      return this.finishOp(17, 1);
	    } else if (isIteratorStart(code, next, this.input.charCodeAt(this.state.pos + 2))) {
	      this.state.pos += 2;
	      return this.readIterator();
	    } else {
	      return super.getTokenFromCode(code);
	    }
	  }

	  isAssignable(node, isBinding) {
	    if (node.type === "TypeCastExpression") {
	      return this.isAssignable(node.expression, isBinding);
	    } else {
	      return super.isAssignable(node, isBinding);
	    }
	  }

	  toAssignable(node, isLHS = false) {
	    if (node.type === "TypeCastExpression") {
	      return super.toAssignable(this.typeCastToParameter(node), isLHS);
	    } else {
	      return super.toAssignable(node, isLHS);
	    }
	  }

	  toAssignableList(exprList, trailingCommaLoc, isLHS) {
	    for (let i = 0; i < exprList.length; i++) {
	      const expr = exprList[i];

	      if (expr?.type === "TypeCastExpression") {
	        exprList[i] = this.typeCastToParameter(expr);
	      }
	    }

	    return super.toAssignableList(exprList, trailingCommaLoc, isLHS);
	  }

	  toReferencedList(exprList, isParenthesizedExpr) {
	    for (let i = 0; i < exprList.length; i++) {
	      const expr = exprList[i];

	      if (expr && expr.type === "TypeCastExpression" && !expr.extra?.parenthesized && (exprList.length > 1 || !isParenthesizedExpr)) {
	        this.raise(FlowErrors.TypeCastInPattern, {
	          node: expr.typeAnnotation
	        });
	      }
	    }

	    return exprList;
	  }

	  parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
	    const node = super.parseArrayLike(close, canBePattern, isTuple, refExpressionErrors);

	    if (canBePattern && !this.state.maybeInArrowParameters) {
	      this.toReferencedList(node.elements);
	    }

	    return node;
	  }

	  checkLVal(expr, ...args) {
	    if (expr.type !== "TypeCastExpression") {
	      return super.checkLVal(expr, ...args);
	    }
	  }

	  parseClassProperty(node) {
	    if (this.match(14)) {
	      node.typeAnnotation = this.flowParseTypeAnnotation();
	    }

	    return super.parseClassProperty(node);
	  }

	  parseClassPrivateProperty(node) {
	    if (this.match(14)) {
	      node.typeAnnotation = this.flowParseTypeAnnotation();
	    }

	    return super.parseClassPrivateProperty(node);
	  }

	  isClassMethod() {
	    return this.match(47) || super.isClassMethod();
	  }

	  isClassProperty() {
	    return this.match(14) || super.isClassProperty();
	  }

	  isNonstaticConstructor(method) {
	    return !this.match(14) && super.isNonstaticConstructor(method);
	  }

	  pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
	    if (method.variance) {
	      this.unexpected(method.variance.loc.start);
	    }

	    delete method.variance;

	    if (this.match(47)) {
	      method.typeParameters = this.flowParseTypeParameterDeclaration();
	    }

	    super.pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);

	    if (method.params && isConstructor) {
	      const params = method.params;

	      if (params.length > 0 && this.isThisParam(params[0])) {
	        this.raise(FlowErrors.ThisParamBannedInConstructor, {
	          node: method
	        });
	      }
	    } else if (method.type === "MethodDefinition" && isConstructor && method.value.params) {
	      const params = method.value.params;

	      if (params.length > 0 && this.isThisParam(params[0])) {
	        this.raise(FlowErrors.ThisParamBannedInConstructor, {
	          node: method
	        });
	      }
	    }
	  }

	  pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
	    if (method.variance) {
	      this.unexpected(method.variance.loc.start);
	    }

	    delete method.variance;

	    if (this.match(47)) {
	      method.typeParameters = this.flowParseTypeParameterDeclaration();
	    }

	    super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
	  }

	  parseClassSuper(node) {
	    super.parseClassSuper(node);

	    if (node.superClass && this.match(47)) {
	      node.superTypeParameters = this.flowParseTypeParameterInstantiation();
	    }

	    if (this.isContextual(110)) {
	      this.next();
	      const implemented = node.implements = [];

	      do {
	        const node = this.startNode();
	        node.id = this.flowParseRestrictedIdentifier(true);

	        if (this.match(47)) {
	          node.typeParameters = this.flowParseTypeParameterInstantiation();
	        } else {
	          node.typeParameters = null;
	        }

	        implemented.push(this.finishNode(node, "ClassImplements"));
	      } while (this.eat(12));
	    }
	  }

	  checkGetterSetterParams(method) {
	    super.checkGetterSetterParams(method);
	    const params = this.getObjectOrClassMethodParams(method);

	    if (params.length > 0) {
	      const param = params[0];

	      if (this.isThisParam(param) && method.kind === "get") {
	        this.raise(FlowErrors.GetterMayNotHaveThisParam, {
	          node: param
	        });
	      } else if (this.isThisParam(param)) {
	        this.raise(FlowErrors.SetterMayNotHaveThisParam, {
	          node: param
	        });
	      }
	    }
	  }

	  parsePropertyNamePrefixOperator(node) {
	    node.variance = this.flowParseVariance();
	  }

	  parseObjPropValue(prop, startPos, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
	    if (prop.variance) {
	      this.unexpected(prop.variance.loc.start);
	    }

	    delete prop.variance;
	    let typeParameters;

	    if (this.match(47) && !isAccessor) {
	      typeParameters = this.flowParseTypeParameterDeclaration();
	      if (!this.match(10)) this.unexpected();
	    }

	    super.parseObjPropValue(prop, startPos, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors);

	    if (typeParameters) {
	      (prop.value || prop).typeParameters = typeParameters;
	    }
	  }

	  parseAssignableListItemTypes(param) {
	    if (this.eat(17)) {
	      if (param.type !== "Identifier") {
	        this.raise(FlowErrors.PatternIsOptional, {
	          node: param
	        });
	      }

	      if (this.isThisParam(param)) {
	        this.raise(FlowErrors.ThisParamMayNotBeOptional, {
	          node: param
	        });
	      }

	      param.optional = true;
	    }

	    if (this.match(14)) {
	      param.typeAnnotation = this.flowParseTypeAnnotation();
	    } else if (this.isThisParam(param)) {
	      this.raise(FlowErrors.ThisParamAnnotationRequired, {
	        node: param
	      });
	    }

	    if (this.match(29) && this.isThisParam(param)) {
	      this.raise(FlowErrors.ThisParamNoDefault, {
	        node: param
	      });
	    }

	    this.resetEndLocation(param);
	    return param;
	  }

	  parseMaybeDefault(startPos, startLoc, left) {
	    const node = super.parseMaybeDefault(startPos, startLoc, left);

	    if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
	      this.raise(FlowErrors.TypeBeforeInitializer, {
	        node: node.typeAnnotation
	      });
	    }

	    return node;
	  }

	  shouldParseDefaultImport(node) {
	    if (!hasTypeImportKind(node)) {
	      return super.shouldParseDefaultImport(node);
	    }

	    return isMaybeDefaultImport(this.state.type);
	  }

	  parseImportSpecifierLocal(node, specifier, type, contextDescription) {
	    specifier.local = hasTypeImportKind(node) ? this.flowParseRestrictedIdentifier(true, true) : this.parseIdentifier();
	    this.checkLVal(specifier.local, contextDescription, BIND_LEXICAL);
	    node.specifiers.push(this.finishNode(specifier, type));
	  }

	  maybeParseDefaultImportSpecifier(node) {
	    node.importKind = "value";
	    let kind = null;

	    if (this.match(87)) {
	      kind = "typeof";
	    } else if (this.isContextual(126)) {
	      kind = "type";
	    }

	    if (kind) {
	      const lh = this.lookahead();
	      const {
	        type
	      } = lh;

	      if (kind === "type" && type === 55) {
	        this.unexpected(null, lh.type);
	      }

	      if (isMaybeDefaultImport(type) || type === 5 || type === 55) {
	        this.next();
	        node.importKind = kind;
	      }
	    }

	    return super.maybeParseDefaultImportSpecifier(node);
	  }

	  parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly) {
	    const firstIdent = specifier.imported;
	    let specifierTypeKind = null;

	    if (firstIdent.type === "Identifier") {
	      if (firstIdent.name === "type") {
	        specifierTypeKind = "type";
	      } else if (firstIdent.name === "typeof") {
	        specifierTypeKind = "typeof";
	      }
	    }

	    let isBinding = false;

	    if (this.isContextual(93) && !this.isLookaheadContextual("as")) {
	      const as_ident = this.parseIdentifier(true);

	      if (specifierTypeKind !== null && !tokenIsKeywordOrIdentifier(this.state.type)) {
	        specifier.imported = as_ident;
	        specifier.importKind = specifierTypeKind;
	        specifier.local = cloneIdentifier(as_ident);
	      } else {
	        specifier.imported = firstIdent;
	        specifier.importKind = null;
	        specifier.local = this.parseIdentifier();
	      }
	    } else {
	      if (specifierTypeKind !== null && tokenIsKeywordOrIdentifier(this.state.type)) {
	        specifier.imported = this.parseIdentifier(true);
	        specifier.importKind = specifierTypeKind;
	      } else {
	        if (importedIsString) {
	          throw this.raise(ErrorMessages.ImportBindingIsString, {
	            node: specifier
	          }, firstIdent.value);
	        }

	        specifier.imported = firstIdent;
	        specifier.importKind = null;
	      }

	      if (this.eatContextual(93)) {
	        specifier.local = this.parseIdentifier();
	      } else {
	        isBinding = true;
	        specifier.local = cloneIdentifier(specifier.imported);
	      }
	    }

	    const specifierIsTypeImport = hasTypeImportKind(specifier);

	    if (isInTypeOnlyImport && specifierIsTypeImport) {
	      this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, {
	        node: specifier
	      });
	    }

	    if (isInTypeOnlyImport || specifierIsTypeImport) {
	      this.checkReservedType(specifier.local.name, specifier.local.loc.start, true);
	    }

	    if (isBinding && !isInTypeOnlyImport && !specifierIsTypeImport) {
	      this.checkReservedWord(specifier.local.name, specifier.loc.start, true, true);
	    }

	    this.checkLVal(specifier.local, "import specifier", BIND_LEXICAL);
	    return this.finishNode(specifier, "ImportSpecifier");
	  }

	  parseBindingAtom() {
	    switch (this.state.type) {
	      case 78:
	        return this.parseIdentifier(true);

	      default:
	        return super.parseBindingAtom();
	    }
	  }

	  parseFunctionParams(node, allowModifiers) {
	    const kind = node.kind;

	    if (kind !== "get" && kind !== "set" && this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    }

	    super.parseFunctionParams(node, allowModifiers);
	  }

	  parseVarId(decl, kind) {
	    super.parseVarId(decl, kind);

	    if (this.match(14)) {
	      decl.id.typeAnnotation = this.flowParseTypeAnnotation();
	      this.resetEndLocation(decl.id);
	    }
	  }

	  parseAsyncArrowFromCallExpression(node, call) {
	    if (this.match(14)) {
	      const oldNoAnonFunctionType = this.state.noAnonFunctionType;
	      this.state.noAnonFunctionType = true;
	      node.returnType = this.flowParseTypeAnnotation();
	      this.state.noAnonFunctionType = oldNoAnonFunctionType;
	    }

	    return super.parseAsyncArrowFromCallExpression(node, call);
	  }

	  shouldParseAsyncArrow() {
	    return this.match(14) || super.shouldParseAsyncArrow();
	  }

	  parseMaybeAssign(refExpressionErrors, afterLeftParse) {
	    let state = null;
	    let jsx;

	    if (this.hasPlugin("jsx") && (this.match(138) || this.match(47))) {
	      state = this.state.clone();
	      jsx = this.tryParse(() => super.parseMaybeAssign(refExpressionErrors, afterLeftParse), state);
	      if (!jsx.error) return jsx.node;
	      const {
	        context
	      } = this.state;
	      const currentContext = context[context.length - 1];

	      if (currentContext === types.j_oTag || currentContext === types.j_expr) {
	        context.pop();
	      }
	    }

	    if (jsx?.error || this.match(47)) {
	      state = state || this.state.clone();
	      let typeParameters;
	      const arrow = this.tryParse(abort => {
	        typeParameters = this.flowParseTypeParameterDeclaration();
	        const arrowExpression = this.forwardNoArrowParamsConversionAt(typeParameters, () => {
	          const result = super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
	          this.resetStartLocationFromNode(result, typeParameters);
	          return result;
	        });
	        if (arrowExpression.extra?.parenthesized) abort();
	        const expr = this.maybeUnwrapTypeCastExpression(arrowExpression);
	        if (expr.type !== "ArrowFunctionExpression") abort();
	        expr.typeParameters = typeParameters;
	        this.resetStartLocationFromNode(expr, typeParameters);
	        return arrowExpression;
	      }, state);
	      let arrowExpression = null;

	      if (arrow.node && this.maybeUnwrapTypeCastExpression(arrow.node).type === "ArrowFunctionExpression") {
	        if (!arrow.error && !arrow.aborted) {
	          if (arrow.node.async) {
	            this.raise(FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction, {
	              node: typeParameters
	            });
	          }

	          return arrow.node;
	        }

	        arrowExpression = arrow.node;
	      }

	      if (jsx?.node) {
	        this.state = jsx.failState;
	        return jsx.node;
	      }

	      if (arrowExpression) {
	        this.state = arrow.failState;
	        return arrowExpression;
	      }

	      if (jsx?.thrown) throw jsx.error;
	      if (arrow.thrown) throw arrow.error;
	      throw this.raise(FlowErrors.UnexpectedTokenAfterTypeParameter, {
	        node: typeParameters
	      });
	    }

	    return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
	  }

	  parseArrow(node) {
	    if (this.match(14)) {
	      const result = this.tryParse(() => {
	        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
	        this.state.noAnonFunctionType = true;
	        const typeNode = this.startNode();
	        [typeNode.typeAnnotation, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
	        this.state.noAnonFunctionType = oldNoAnonFunctionType;
	        if (this.canInsertSemicolon()) this.unexpected();
	        if (!this.match(19)) this.unexpected();
	        return typeNode;
	      });
	      if (result.thrown) return null;
	      if (result.error) this.state = result.failState;
	      node.returnType = result.node.typeAnnotation ? this.finishNode(result.node, "TypeAnnotation") : null;
	    }

	    return super.parseArrow(node);
	  }

	  shouldParseArrow(params) {
	    return this.match(14) || super.shouldParseArrow(params);
	  }

	  setArrowFunctionParameters(node, params) {
	    if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
	      node.params = params;
	    } else {
	      super.setArrowFunctionParameters(node, params);
	    }
	  }

	  checkParams(node, allowDuplicates, isArrowFunction) {
	    if (isArrowFunction && this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
	      return;
	    }

	    for (let i = 0; i < node.params.length; i++) {
	      if (this.isThisParam(node.params[i]) && i > 0) {
	        this.raise(FlowErrors.ThisParamMustBeFirst, {
	          node: node.params[i]
	        });
	      }
	    }

	    return super.checkParams(...arguments);
	  }

	  parseParenAndDistinguishExpression(canBeArrow) {
	    return super.parseParenAndDistinguishExpression(canBeArrow && this.state.noArrowAt.indexOf(this.state.start) === -1);
	  }

	  parseSubscripts(base, startPos, startLoc, noCalls) {
	    if (base.type === "Identifier" && base.name === "async" && this.state.noArrowAt.indexOf(startPos) !== -1) {
	      this.next();
	      const node = this.startNodeAt(startPos, startLoc);
	      node.callee = base;
	      node.arguments = this.parseCallExpressionArguments(11, false);
	      base = this.finishNode(node, "CallExpression");
	    } else if (base.type === "Identifier" && base.name === "async" && this.match(47)) {
	      const state = this.state.clone();
	      const arrow = this.tryParse(abort => this.parseAsyncArrowWithTypeParameters(startPos, startLoc) || abort(), state);
	      if (!arrow.error && !arrow.aborted) return arrow.node;
	      const result = this.tryParse(() => super.parseSubscripts(base, startPos, startLoc, noCalls), state);
	      if (result.node && !result.error) return result.node;

	      if (arrow.node) {
	        this.state = arrow.failState;
	        return arrow.node;
	      }

	      if (result.node) {
	        this.state = result.failState;
	        return result.node;
	      }

	      throw arrow.error || result.error;
	    }

	    return super.parseSubscripts(base, startPos, startLoc, noCalls);
	  }

	  parseSubscript(base, startPos, startLoc, noCalls, subscriptState) {
	    if (this.match(18) && this.isLookaheadToken_lt()) {
	      subscriptState.optionalChainMember = true;

	      if (noCalls) {
	        subscriptState.stop = true;
	        return base;
	      }

	      this.next();
	      const node = this.startNodeAt(startPos, startLoc);
	      node.callee = base;
	      node.typeArguments = this.flowParseTypeParameterInstantiation();
	      this.expect(10);
	      node.arguments = this.parseCallExpressionArguments(11, false);
	      node.optional = true;
	      return this.finishCallExpression(node, true);
	    } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
	      const node = this.startNodeAt(startPos, startLoc);
	      node.callee = base;
	      const result = this.tryParse(() => {
	        node.typeArguments = this.flowParseTypeParameterInstantiationCallOrNew();
	        this.expect(10);
	        node.arguments = this.parseCallExpressionArguments(11, false);
	        if (subscriptState.optionalChainMember) node.optional = false;
	        return this.finishCallExpression(node, subscriptState.optionalChainMember);
	      });

	      if (result.node) {
	        if (result.error) this.state = result.failState;
	        return result.node;
	      }
	    }

	    return super.parseSubscript(base, startPos, startLoc, noCalls, subscriptState);
	  }

	  parseNewArguments(node) {
	    let targs = null;

	    if (this.shouldParseTypes() && this.match(47)) {
	      targs = this.tryParse(() => this.flowParseTypeParameterInstantiationCallOrNew()).node;
	    }

	    node.typeArguments = targs;
	    super.parseNewArguments(node);
	  }

	  parseAsyncArrowWithTypeParameters(startPos, startLoc) {
	    const node = this.startNodeAt(startPos, startLoc);
	    this.parseFunctionParams(node);
	    if (!this.parseArrow(node)) return;
	    return this.parseArrowExpression(node, undefined, true);
	  }

	  readToken_mult_modulo(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (code === 42 && next === 47 && this.state.hasFlowComment) {
	      this.state.hasFlowComment = false;
	      this.state.pos += 2;
	      this.nextToken();
	      return;
	    }

	    super.readToken_mult_modulo(code);
	  }

	  readToken_pipe_amp(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);

	    if (code === 124 && next === 125) {
	      this.finishOp(9, 2);
	      return;
	    }

	    super.readToken_pipe_amp(code);
	  }

	  parseTopLevel(file, program) {
	    const fileNode = super.parseTopLevel(file, program);

	    if (this.state.hasFlowComment) {
	      this.raise(FlowErrors.UnterminatedFlowComment, {
	        at: this.state.curPosition()
	      });
	    }

	    return fileNode;
	  }

	  skipBlockComment() {
	    if (this.hasPlugin("flowComments") && this.skipFlowComment()) {
	      if (this.state.hasFlowComment) {
	        throw this.raise(FlowErrors.NestedFlowComment, {
	          at: this.state.startLoc
	        });
	      }

	      this.hasFlowCommentCompletion();
	      this.state.pos += this.skipFlowComment();
	      this.state.hasFlowComment = true;
	      return;
	    }

	    if (this.state.hasFlowComment) {
	      const end = this.input.indexOf("*-/", this.state.pos + 2);

	      if (end === -1) {
	        throw this.raise(ErrorMessages.UnterminatedComment, {
	          at: this.state.curPosition()
	        });
	      }

	      this.state.pos = end + 2 + 3;
	      return;
	    }

	    return super.skipBlockComment();
	  }

	  skipFlowComment() {
	    const {
	      pos
	    } = this.state;
	    let shiftToFirstNonWhiteSpace = 2;

	    while ([32, 9].includes(this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace))) {
	      shiftToFirstNonWhiteSpace++;
	    }

	    const ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
	    const ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);

	    if (ch2 === 58 && ch3 === 58) {
	      return shiftToFirstNonWhiteSpace + 2;
	    }

	    if (this.input.slice(shiftToFirstNonWhiteSpace + pos, shiftToFirstNonWhiteSpace + pos + 12) === "flow-include") {
	      return shiftToFirstNonWhiteSpace + 12;
	    }

	    if (ch2 === 58 && ch3 !== 58) {
	      return shiftToFirstNonWhiteSpace;
	    }

	    return false;
	  }

	  hasFlowCommentCompletion() {
	    const end = this.input.indexOf("*/", this.state.pos);

	    if (end === -1) {
	      throw this.raise(ErrorMessages.UnterminatedComment, {
	        at: this.state.curPosition()
	      });
	    }
	  }

	  flowEnumErrorBooleanMemberNotInitialized(loc, {
	    enumName,
	    memberName
	  }) {
	    this.raise(FlowErrors.EnumBooleanMemberNotInitialized, {
	      at: loc
	    }, memberName, enumName);
	  }

	  flowEnumErrorInvalidExplicitType(loc, {
	    enumName,
	    suppliedType
	  }) {
	    return this.raise(suppliedType === null ? FlowErrors.EnumInvalidExplicitTypeUnknownSupplied : FlowErrors.EnumInvalidExplicitType, {
	      at: loc
	    }, enumName, suppliedType);
	  }

	  flowEnumErrorInvalidMemberInitializer(loc, {
	    enumName,
	    explicitType,
	    memberName
	  }) {
	    return this.raise(explicitType === "boolean" || explicitType === "number" || explicitType === "string" ? FlowErrors.EnumInvalidMemberInitializerPrimaryType : explicitType === "symbol" ? FlowErrors.EnumInvalidMemberInitializerSymbolType : FlowErrors.EnumInvalidMemberInitializerUnknownType, {
	      at: loc
	    }, enumName, memberName, explicitType);
	  }

	  flowEnumErrorNumberMemberNotInitialized(loc, {
	    enumName,
	    memberName
	  }) {
	    this.raise(FlowErrors.EnumNumberMemberNotInitialized, {
	      at: loc
	    }, enumName, memberName);
	  }

	  flowEnumErrorStringMemberInconsistentlyInitailized(node, {
	    enumName
	  }) {
	    this.raise(FlowErrors.EnumStringMemberInconsistentlyInitailized, {
	      node
	    }, enumName);
	  }

	  flowEnumMemberInit() {
	    const startLoc = this.state.startLoc;

	    const endOfInit = () => this.match(12) || this.match(8);

	    switch (this.state.type) {
	      case 130:
	        {
	          const literal = this.parseNumericLiteral(this.state.value);

	          if (endOfInit()) {
	            return {
	              type: "number",
	              loc: literal.loc.start,
	              value: literal
	            };
	          }

	          return {
	            type: "invalid",
	            loc: startLoc
	          };
	        }

	      case 129:
	        {
	          const literal = this.parseStringLiteral(this.state.value);

	          if (endOfInit()) {
	            return {
	              type: "string",
	              loc: literal.loc.start,
	              value: literal
	            };
	          }

	          return {
	            type: "invalid",
	            loc: startLoc
	          };
	        }

	      case 85:
	      case 86:
	        {
	          const literal = this.parseBooleanLiteral(this.match(85));

	          if (endOfInit()) {
	            return {
	              type: "boolean",
	              loc: literal.loc.start,
	              value: literal
	            };
	          }

	          return {
	            type: "invalid",
	            loc: startLoc
	          };
	        }

	      default:
	        return {
	          type: "invalid",
	          loc: startLoc
	        };
	    }
	  }

	  flowEnumMemberRaw() {
	    const loc = this.state.startLoc;
	    const id = this.parseIdentifier(true);
	    const init = this.eat(29) ? this.flowEnumMemberInit() : {
	      type: "none",
	      loc
	    };
	    return {
	      id,
	      init
	    };
	  }

	  flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
	    const {
	      explicitType
	    } = context;

	    if (explicitType === null) {
	      return;
	    }

	    if (explicitType !== expectedType) {
	      this.flowEnumErrorInvalidMemberInitializer(loc, context);
	    }
	  }

	  flowEnumMembers({
	    enumName,
	    explicitType
	  }) {
	    const seenNames = new Set();
	    const members = {
	      booleanMembers: [],
	      numberMembers: [],
	      stringMembers: [],
	      defaultedMembers: []
	    };
	    let hasUnknownMembers = false;

	    while (!this.match(8)) {
	      if (this.eat(21)) {
	        hasUnknownMembers = true;
	        break;
	      }

	      const memberNode = this.startNode();
	      const {
	        id,
	        init
	      } = this.flowEnumMemberRaw();
	      const memberName = id.name;

	      if (memberName === "") {
	        continue;
	      }

	      if (/^[a-z]/.test(memberName)) {
	        this.raise(FlowErrors.EnumInvalidMemberName, {
	          node: id
	        }, memberName, memberName[0].toUpperCase() + memberName.slice(1), enumName);
	      }

	      if (seenNames.has(memberName)) {
	        this.raise(FlowErrors.EnumDuplicateMemberName, {
	          node: id
	        }, memberName, enumName);
	      }

	      seenNames.add(memberName);
	      const context = {
	        enumName,
	        explicitType,
	        memberName
	      };
	      memberNode.id = id;

	      switch (init.type) {
	        case "boolean":
	          {
	            this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "boolean");
	            memberNode.init = init.value;
	            members.booleanMembers.push(this.finishNode(memberNode, "EnumBooleanMember"));
	            break;
	          }

	        case "number":
	          {
	            this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "number");
	            memberNode.init = init.value;
	            members.numberMembers.push(this.finishNode(memberNode, "EnumNumberMember"));
	            break;
	          }

	        case "string":
	          {
	            this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "string");
	            memberNode.init = init.value;
	            members.stringMembers.push(this.finishNode(memberNode, "EnumStringMember"));
	            break;
	          }

	        case "invalid":
	          {
	            throw this.flowEnumErrorInvalidMemberInitializer(init.loc, context);
	          }

	        case "none":
	          {
	            switch (explicitType) {
	              case "boolean":
	                this.flowEnumErrorBooleanMemberNotInitialized(init.loc, context);
	                break;

	              case "number":
	                this.flowEnumErrorNumberMemberNotInitialized(init.loc, context);
	                break;

	              default:
	                members.defaultedMembers.push(this.finishNode(memberNode, "EnumDefaultedMember"));
	            }
	          }
	      }

	      if (!this.match(8)) {
	        this.expect(12);
	      }
	    }

	    return {
	      members,
	      hasUnknownMembers
	    };
	  }

	  flowEnumStringMembers(initializedMembers, defaultedMembers, {
	    enumName
	  }) {
	    if (initializedMembers.length === 0) {
	      return defaultedMembers;
	    } else if (defaultedMembers.length === 0) {
	      return initializedMembers;
	    } else if (defaultedMembers.length > initializedMembers.length) {
	      for (const member of initializedMembers) {
	        this.flowEnumErrorStringMemberInconsistentlyInitailized(member, {
	          enumName
	        });
	      }

	      return defaultedMembers;
	    } else {
	      for (const member of defaultedMembers) {
	        this.flowEnumErrorStringMemberInconsistentlyInitailized(member, {
	          enumName
	        });
	      }

	      return initializedMembers;
	    }
	  }

	  flowEnumParseExplicitType({
	    enumName
	  }) {
	    if (this.eatContextual(101)) {
	      if (!tokenIsIdentifier(this.state.type)) {
	        throw this.flowEnumErrorInvalidExplicitType(this.state.startLoc, {
	          enumName,
	          suppliedType: null
	        });
	      }

	      const {
	        value
	      } = this.state;
	      this.next();

	      if (value !== "boolean" && value !== "number" && value !== "string" && value !== "symbol") {
	        this.flowEnumErrorInvalidExplicitType(this.state.startLoc, {
	          enumName,
	          suppliedType: value
	        });
	      }

	      return value;
	    }

	    return null;
	  }

	  flowEnumBody(node, id) {
	    const enumName = id.name;
	    const nameLoc = id.loc.start;
	    const explicitType = this.flowEnumParseExplicitType({
	      enumName
	    });
	    this.expect(5);
	    const {
	      members,
	      hasUnknownMembers
	    } = this.flowEnumMembers({
	      enumName,
	      explicitType
	    });
	    node.hasUnknownMembers = hasUnknownMembers;

	    switch (explicitType) {
	      case "boolean":
	        node.explicitType = true;
	        node.members = members.booleanMembers;
	        this.expect(8);
	        return this.finishNode(node, "EnumBooleanBody");

	      case "number":
	        node.explicitType = true;
	        node.members = members.numberMembers;
	        this.expect(8);
	        return this.finishNode(node, "EnumNumberBody");

	      case "string":
	        node.explicitType = true;
	        node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
	          enumName
	        });
	        this.expect(8);
	        return this.finishNode(node, "EnumStringBody");

	      case "symbol":
	        node.members = members.defaultedMembers;
	        this.expect(8);
	        return this.finishNode(node, "EnumSymbolBody");

	      default:
	        {
	          const empty = () => {
	            node.members = [];
	            this.expect(8);
	            return this.finishNode(node, "EnumStringBody");
	          };

	          node.explicitType = false;
	          const boolsLen = members.booleanMembers.length;
	          const numsLen = members.numberMembers.length;
	          const strsLen = members.stringMembers.length;
	          const defaultedLen = members.defaultedMembers.length;

	          if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
	            return empty();
	          } else if (!boolsLen && !numsLen) {
	            node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
	              enumName
	            });
	            this.expect(8);
	            return this.finishNode(node, "EnumStringBody");
	          } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
	            for (const member of members.defaultedMembers) {
	              this.flowEnumErrorBooleanMemberNotInitialized(member.loc.start, {
	                enumName,
	                memberName: member.id.name
	              });
	            }

	            node.members = members.booleanMembers;
	            this.expect(8);
	            return this.finishNode(node, "EnumBooleanBody");
	          } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
	            for (const member of members.defaultedMembers) {
	              this.flowEnumErrorNumberMemberNotInitialized(member.loc.start, {
	                enumName,
	                memberName: member.id.name
	              });
	            }

	            node.members = members.numberMembers;
	            this.expect(8);
	            return this.finishNode(node, "EnumNumberBody");
	          } else {
	            this.raise(FlowErrors.EnumInconsistentMemberValues, {
	              at: nameLoc
	            }, enumName);
	            return empty();
	          }
	        }
	    }
	  }

	  flowParseEnumDeclaration(node) {
	    const id = this.parseIdentifier();
	    node.id = id;
	    node.body = this.flowEnumBody(this.startNode(), id);
	    return this.finishNode(node, "EnumDeclaration");
	  }

	  isLookaheadToken_lt() {
	    const next = this.nextTokenStart();

	    if (this.input.charCodeAt(next) === 60) {
	      const afterNext = this.input.charCodeAt(next + 1);
	      return afterNext !== 60 && afterNext !== 61;
	    }

	    return false;
	  }

	  maybeUnwrapTypeCastExpression(node) {
	    return node.type === "TypeCastExpression" ? node.expression : node;
	  }

	});

	const entities = {
	  quot: "\u0022",
	  amp: "&",
	  apos: "\u0027",
	  lt: "<",
	  gt: ">",
	  nbsp: "\u00A0",
	  iexcl: "\u00A1",
	  cent: "\u00A2",
	  pound: "\u00A3",
	  curren: "\u00A4",
	  yen: "\u00A5",
	  brvbar: "\u00A6",
	  sect: "\u00A7",
	  uml: "\u00A8",
	  copy: "\u00A9",
	  ordf: "\u00AA",
	  laquo: "\u00AB",
	  not: "\u00AC",
	  shy: "\u00AD",
	  reg: "\u00AE",
	  macr: "\u00AF",
	  deg: "\u00B0",
	  plusmn: "\u00B1",
	  sup2: "\u00B2",
	  sup3: "\u00B3",
	  acute: "\u00B4",
	  micro: "\u00B5",
	  para: "\u00B6",
	  middot: "\u00B7",
	  cedil: "\u00B8",
	  sup1: "\u00B9",
	  ordm: "\u00BA",
	  raquo: "\u00BB",
	  frac14: "\u00BC",
	  frac12: "\u00BD",
	  frac34: "\u00BE",
	  iquest: "\u00BF",
	  Agrave: "\u00C0",
	  Aacute: "\u00C1",
	  Acirc: "\u00C2",
	  Atilde: "\u00C3",
	  Auml: "\u00C4",
	  Aring: "\u00C5",
	  AElig: "\u00C6",
	  Ccedil: "\u00C7",
	  Egrave: "\u00C8",
	  Eacute: "\u00C9",
	  Ecirc: "\u00CA",
	  Euml: "\u00CB",
	  Igrave: "\u00CC",
	  Iacute: "\u00CD",
	  Icirc: "\u00CE",
	  Iuml: "\u00CF",
	  ETH: "\u00D0",
	  Ntilde: "\u00D1",
	  Ograve: "\u00D2",
	  Oacute: "\u00D3",
	  Ocirc: "\u00D4",
	  Otilde: "\u00D5",
	  Ouml: "\u00D6",
	  times: "\u00D7",
	  Oslash: "\u00D8",
	  Ugrave: "\u00D9",
	  Uacute: "\u00DA",
	  Ucirc: "\u00DB",
	  Uuml: "\u00DC",
	  Yacute: "\u00DD",
	  THORN: "\u00DE",
	  szlig: "\u00DF",
	  agrave: "\u00E0",
	  aacute: "\u00E1",
	  acirc: "\u00E2",
	  atilde: "\u00E3",
	  auml: "\u00E4",
	  aring: "\u00E5",
	  aelig: "\u00E6",
	  ccedil: "\u00E7",
	  egrave: "\u00E8",
	  eacute: "\u00E9",
	  ecirc: "\u00EA",
	  euml: "\u00EB",
	  igrave: "\u00EC",
	  iacute: "\u00ED",
	  icirc: "\u00EE",
	  iuml: "\u00EF",
	  eth: "\u00F0",
	  ntilde: "\u00F1",
	  ograve: "\u00F2",
	  oacute: "\u00F3",
	  ocirc: "\u00F4",
	  otilde: "\u00F5",
	  ouml: "\u00F6",
	  divide: "\u00F7",
	  oslash: "\u00F8",
	  ugrave: "\u00F9",
	  uacute: "\u00FA",
	  ucirc: "\u00FB",
	  uuml: "\u00FC",
	  yacute: "\u00FD",
	  thorn: "\u00FE",
	  yuml: "\u00FF",
	  OElig: "\u0152",
	  oelig: "\u0153",
	  Scaron: "\u0160",
	  scaron: "\u0161",
	  Yuml: "\u0178",
	  fnof: "\u0192",
	  circ: "\u02C6",
	  tilde: "\u02DC",
	  Alpha: "\u0391",
	  Beta: "\u0392",
	  Gamma: "\u0393",
	  Delta: "\u0394",
	  Epsilon: "\u0395",
	  Zeta: "\u0396",
	  Eta: "\u0397",
	  Theta: "\u0398",
	  Iota: "\u0399",
	  Kappa: "\u039A",
	  Lambda: "\u039B",
	  Mu: "\u039C",
	  Nu: "\u039D",
	  Xi: "\u039E",
	  Omicron: "\u039F",
	  Pi: "\u03A0",
	  Rho: "\u03A1",
	  Sigma: "\u03A3",
	  Tau: "\u03A4",
	  Upsilon: "\u03A5",
	  Phi: "\u03A6",
	  Chi: "\u03A7",
	  Psi: "\u03A8",
	  Omega: "\u03A9",
	  alpha: "\u03B1",
	  beta: "\u03B2",
	  gamma: "\u03B3",
	  delta: "\u03B4",
	  epsilon: "\u03B5",
	  zeta: "\u03B6",
	  eta: "\u03B7",
	  theta: "\u03B8",
	  iota: "\u03B9",
	  kappa: "\u03BA",
	  lambda: "\u03BB",
	  mu: "\u03BC",
	  nu: "\u03BD",
	  xi: "\u03BE",
	  omicron: "\u03BF",
	  pi: "\u03C0",
	  rho: "\u03C1",
	  sigmaf: "\u03C2",
	  sigma: "\u03C3",
	  tau: "\u03C4",
	  upsilon: "\u03C5",
	  phi: "\u03C6",
	  chi: "\u03C7",
	  psi: "\u03C8",
	  omega: "\u03C9",
	  thetasym: "\u03D1",
	  upsih: "\u03D2",
	  piv: "\u03D6",
	  ensp: "\u2002",
	  emsp: "\u2003",
	  thinsp: "\u2009",
	  zwnj: "\u200C",
	  zwj: "\u200D",
	  lrm: "\u200E",
	  rlm: "\u200F",
	  ndash: "\u2013",
	  mdash: "\u2014",
	  lsquo: "\u2018",
	  rsquo: "\u2019",
	  sbquo: "\u201A",
	  ldquo: "\u201C",
	  rdquo: "\u201D",
	  bdquo: "\u201E",
	  dagger: "\u2020",
	  Dagger: "\u2021",
	  bull: "\u2022",
	  hellip: "\u2026",
	  permil: "\u2030",
	  prime: "\u2032",
	  Prime: "\u2033",
	  lsaquo: "\u2039",
	  rsaquo: "\u203A",
	  oline: "\u203E",
	  frasl: "\u2044",
	  euro: "\u20AC",
	  image: "\u2111",
	  weierp: "\u2118",
	  real: "\u211C",
	  trade: "\u2122",
	  alefsym: "\u2135",
	  larr: "\u2190",
	  uarr: "\u2191",
	  rarr: "\u2192",
	  darr: "\u2193",
	  harr: "\u2194",
	  crarr: "\u21B5",
	  lArr: "\u21D0",
	  uArr: "\u21D1",
	  rArr: "\u21D2",
	  dArr: "\u21D3",
	  hArr: "\u21D4",
	  forall: "\u2200",
	  part: "\u2202",
	  exist: "\u2203",
	  empty: "\u2205",
	  nabla: "\u2207",
	  isin: "\u2208",
	  notin: "\u2209",
	  ni: "\u220B",
	  prod: "\u220F",
	  sum: "\u2211",
	  minus: "\u2212",
	  lowast: "\u2217",
	  radic: "\u221A",
	  prop: "\u221D",
	  infin: "\u221E",
	  ang: "\u2220",
	  and: "\u2227",
	  or: "\u2228",
	  cap: "\u2229",
	  cup: "\u222A",
	  int: "\u222B",
	  there4: "\u2234",
	  sim: "\u223C",
	  cong: "\u2245",
	  asymp: "\u2248",
	  ne: "\u2260",
	  equiv: "\u2261",
	  le: "\u2264",
	  ge: "\u2265",
	  sub: "\u2282",
	  sup: "\u2283",
	  nsub: "\u2284",
	  sube: "\u2286",
	  supe: "\u2287",
	  oplus: "\u2295",
	  otimes: "\u2297",
	  perp: "\u22A5",
	  sdot: "\u22C5",
	  lceil: "\u2308",
	  rceil: "\u2309",
	  lfloor: "\u230A",
	  rfloor: "\u230B",
	  lang: "\u2329",
	  rang: "\u232A",
	  loz: "\u25CA",
	  spades: "\u2660",
	  clubs: "\u2663",
	  hearts: "\u2665",
	  diams: "\u2666"
	};

	const HEX_NUMBER = /^[\da-fA-F]+$/;
	const DECIMAL_NUMBER = /^\d+$/;
	const JsxErrors = makeErrorTemplates({
	  AttributeIsEmpty: "JSX attributes must only be assigned a non-empty expression.",
	  MissingClosingTagElement: "Expected corresponding JSX closing tag for <%0>.",
	  MissingClosingTagFragment: "Expected corresponding JSX closing tag for <>.",
	  UnexpectedSequenceExpression: "Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?",
	  UnsupportedJsxValue: "JSX value should be either an expression or a quoted JSX text.",
	  UnterminatedJsxContent: "Unterminated JSX contents.",
	  UnwrappedAdjacentJSXElements: "Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?"
	}, ErrorCodes.SyntaxError, "jsx");

	function isFragment(object) {
	  return object ? object.type === "JSXOpeningFragment" || object.type === "JSXClosingFragment" : false;
	}

	function getQualifiedJSXName(object) {
	  if (object.type === "JSXIdentifier") {
	    return object.name;
	  }

	  if (object.type === "JSXNamespacedName") {
	    return object.namespace.name + ":" + object.name.name;
	  }

	  if (object.type === "JSXMemberExpression") {
	    return getQualifiedJSXName(object.object) + "." + getQualifiedJSXName(object.property);
	  }

	  throw new Error("Node had unexpected type: " + object.type);
	}

	var jsx = (superClass => class extends superClass {
	  jsxReadToken() {
	    let out = "";
	    let chunkStart = this.state.pos;

	    for (;;) {
	      if (this.state.pos >= this.length) {
	        throw this.raise(JsxErrors.UnterminatedJsxContent, {
	          at: this.state.startLoc
	        });
	      }

	      const ch = this.input.charCodeAt(this.state.pos);

	      switch (ch) {
	        case 60:
	        case 123:
	          if (this.state.pos === this.state.start) {
	            if (ch === 60 && this.state.canStartJSXElement) {
	              ++this.state.pos;
	              return this.finishToken(138);
	            }

	            return super.getTokenFromCode(ch);
	          }

	          out += this.input.slice(chunkStart, this.state.pos);
	          return this.finishToken(137, out);

	        case 38:
	          out += this.input.slice(chunkStart, this.state.pos);
	          out += this.jsxReadEntity();
	          chunkStart = this.state.pos;
	          break;

	        case 62:
	        case 125:
	          if (browser$5.env.BABEL_8_BREAKING) {
	            const htmlEntity = ch === 125 ? "&rbrace;" : "&gt;";
	            const char = this.input[this.state.pos];
	            this.raise({
	              code: ErrorCodes.SyntaxError,
	              reasonCode: "UnexpectedToken",
	              template: `Unexpected token \`${char}\`. Did you mean \`${htmlEntity}\` or \`{'${char}'}\`?`
	            }, {
	              at: this.state.curPosition()
	            });
	          }

	        default:
	          if (isNewLine(ch)) {
	            out += this.input.slice(chunkStart, this.state.pos);
	            out += this.jsxReadNewLine(true);
	            chunkStart = this.state.pos;
	          } else {
	            ++this.state.pos;
	          }

	      }
	    }
	  }

	  jsxReadNewLine(normalizeCRLF) {
	    const ch = this.input.charCodeAt(this.state.pos);
	    let out;
	    ++this.state.pos;

	    if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
	      ++this.state.pos;
	      out = normalizeCRLF ? "\n" : "\r\n";
	    } else {
	      out = String.fromCharCode(ch);
	    }

	    ++this.state.curLine;
	    this.state.lineStart = this.state.pos;
	    return out;
	  }

	  jsxReadString(quote) {
	    let out = "";
	    let chunkStart = ++this.state.pos;

	    for (;;) {
	      if (this.state.pos >= this.length) {
	        throw this.raise(ErrorMessages.UnterminatedString, {
	          at: this.state.startLoc
	        });
	      }

	      const ch = this.input.charCodeAt(this.state.pos);
	      if (ch === quote) break;

	      if (ch === 38) {
	        out += this.input.slice(chunkStart, this.state.pos);
	        out += this.jsxReadEntity();
	        chunkStart = this.state.pos;
	      } else if (isNewLine(ch)) {
	        out += this.input.slice(chunkStart, this.state.pos);
	        out += this.jsxReadNewLine(false);
	        chunkStart = this.state.pos;
	      } else {
	        ++this.state.pos;
	      }
	    }

	    out += this.input.slice(chunkStart, this.state.pos++);
	    return this.finishToken(129, out);
	  }

	  jsxReadEntity() {
	    let str = "";
	    let count = 0;
	    let entity;
	    let ch = this.input[this.state.pos];
	    const startPos = ++this.state.pos;

	    while (this.state.pos < this.length && count++ < 10) {
	      ch = this.input[this.state.pos++];

	      if (ch === ";") {
	        if (str[0] === "#") {
	          if (str[1] === "x") {
	            str = str.substr(2);

	            if (HEX_NUMBER.test(str)) {
	              entity = String.fromCodePoint(parseInt(str, 16));
	            }
	          } else {
	            str = str.substr(1);

	            if (DECIMAL_NUMBER.test(str)) {
	              entity = String.fromCodePoint(parseInt(str, 10));
	            }
	          }
	        } else {
	          entity = entities[str];
	        }

	        break;
	      }

	      str += ch;
	    }

	    if (!entity) {
	      this.state.pos = startPos;
	      return "&";
	    }

	    return entity;
	  }

	  jsxReadWord() {
	    let ch;
	    const start = this.state.pos;

	    do {
	      ch = this.input.charCodeAt(++this.state.pos);
	    } while (isIdentifierChar(ch) || ch === 45);

	    return this.finishToken(136, this.input.slice(start, this.state.pos));
	  }

	  jsxParseIdentifier() {
	    const node = this.startNode();

	    if (this.match(136)) {
	      node.name = this.state.value;
	    } else if (tokenIsKeyword(this.state.type)) {
	      node.name = tokenLabelName(this.state.type);
	    } else {
	      this.unexpected();
	    }

	    this.next();
	    return this.finishNode(node, "JSXIdentifier");
	  }

	  jsxParseNamespacedName() {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    const name = this.jsxParseIdentifier();
	    if (!this.eat(14)) return name;
	    const node = this.startNodeAt(startPos, startLoc);
	    node.namespace = name;
	    node.name = this.jsxParseIdentifier();
	    return this.finishNode(node, "JSXNamespacedName");
	  }

	  jsxParseElementName() {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    let node = this.jsxParseNamespacedName();

	    if (node.type === "JSXNamespacedName") {
	      return node;
	    }

	    while (this.eat(16)) {
	      const newNode = this.startNodeAt(startPos, startLoc);
	      newNode.object = node;
	      newNode.property = this.jsxParseIdentifier();
	      node = this.finishNode(newNode, "JSXMemberExpression");
	    }

	    return node;
	  }

	  jsxParseAttributeValue() {
	    let node;

	    switch (this.state.type) {
	      case 5:
	        node = this.startNode();
	        this.setContext(types.brace);
	        this.next();
	        node = this.jsxParseExpressionContainer(node, types.j_oTag);

	        if (node.expression.type === "JSXEmptyExpression") {
	          this.raise(JsxErrors.AttributeIsEmpty, {
	            node
	          });
	        }

	        return node;

	      case 138:
	      case 129:
	        return this.parseExprAtom();

	      default:
	        throw this.raise(JsxErrors.UnsupportedJsxValue, {
	          at: this.state.startLoc
	        });
	    }
	  }

	  jsxParseEmptyExpression() {
	    const node = this.startNodeAt(this.state.lastTokEndLoc.index, this.state.lastTokEndLoc);
	    return this.finishNodeAt(node, "JSXEmptyExpression", this.state.startLoc);
	  }

	  jsxParseSpreadChild(node) {
	    this.next();
	    node.expression = this.parseExpression();
	    this.setContext(types.j_oTag);
	    this.expect(8);
	    return this.finishNode(node, "JSXSpreadChild");
	  }

	  jsxParseExpressionContainer(node, previousContext) {
	    if (this.match(8)) {
	      node.expression = this.jsxParseEmptyExpression();
	    } else {
	      const expression = this.parseExpression();

	      if (browser$5.env.BABEL_8_BREAKING) {
	        if (expression.type === "SequenceExpression" && !expression.extra?.parenthesized) {
	          this.raise(JsxErrors.UnexpectedSequenceExpression, {
	            node: expression.expressions[1]
	          });
	        }
	      }

	      node.expression = expression;
	    }

	    this.setContext(previousContext);
	    this.expect(8);
	    return this.finishNode(node, "JSXExpressionContainer");
	  }

	  jsxParseAttribute() {
	    const node = this.startNode();

	    if (this.match(5)) {
	      this.setContext(types.brace);
	      this.next();
	      this.expect(21);
	      node.argument = this.parseMaybeAssignAllowIn();
	      this.setContext(types.j_oTag);
	      this.expect(8);
	      return this.finishNode(node, "JSXSpreadAttribute");
	    }

	    node.name = this.jsxParseNamespacedName();
	    node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
	    return this.finishNode(node, "JSXAttribute");
	  }

	  jsxParseOpeningElementAt(startPos, startLoc) {
	    const node = this.startNodeAt(startPos, startLoc);

	    if (this.match(139)) {
	      this.expect(139);
	      return this.finishNode(node, "JSXOpeningFragment");
	    }

	    node.name = this.jsxParseElementName();
	    return this.jsxParseOpeningElementAfterName(node);
	  }

	  jsxParseOpeningElementAfterName(node) {
	    const attributes = [];

	    while (!this.match(56) && !this.match(139)) {
	      attributes.push(this.jsxParseAttribute());
	    }

	    node.attributes = attributes;
	    node.selfClosing = this.eat(56);
	    this.expect(139);
	    return this.finishNode(node, "JSXOpeningElement");
	  }

	  jsxParseClosingElementAt(startPos, startLoc) {
	    const node = this.startNodeAt(startPos, startLoc);

	    if (this.match(139)) {
	      this.expect(139);
	      return this.finishNode(node, "JSXClosingFragment");
	    }

	    node.name = this.jsxParseElementName();
	    this.expect(139);
	    return this.finishNode(node, "JSXClosingElement");
	  }

	  jsxParseElementAt(startPos, startLoc) {
	    const node = this.startNodeAt(startPos, startLoc);
	    const children = [];
	    const openingElement = this.jsxParseOpeningElementAt(startPos, startLoc);
	    let closingElement = null;

	    if (!openingElement.selfClosing) {
	      contents: for (;;) {
	        switch (this.state.type) {
	          case 138:
	            startPos = this.state.start;
	            startLoc = this.state.startLoc;
	            this.next();

	            if (this.eat(56)) {
	              closingElement = this.jsxParseClosingElementAt(startPos, startLoc);
	              break contents;
	            }

	            children.push(this.jsxParseElementAt(startPos, startLoc));
	            break;

	          case 137:
	            children.push(this.parseExprAtom());
	            break;

	          case 5:
	            {
	              const node = this.startNode();
	              this.setContext(types.brace);
	              this.next();

	              if (this.match(21)) {
	                children.push(this.jsxParseSpreadChild(node));
	              } else {
	                children.push(this.jsxParseExpressionContainer(node, types.j_expr));
	              }

	              break;
	            }

	          default:
	            throw this.unexpected();
	        }
	      }

	      if (isFragment(openingElement) && !isFragment(closingElement) && closingElement !== null) {
	        this.raise(JsxErrors.MissingClosingTagFragment, {
	          node: closingElement
	        });
	      } else if (!isFragment(openingElement) && isFragment(closingElement)) {
	        this.raise(JsxErrors.MissingClosingTagElement, {
	          node: closingElement
	        }, getQualifiedJSXName(openingElement.name));
	      } else if (!isFragment(openingElement) && !isFragment(closingElement)) {
	        if (getQualifiedJSXName(closingElement.name) !== getQualifiedJSXName(openingElement.name)) {
	          this.raise(JsxErrors.MissingClosingTagElement, {
	            node: closingElement
	          }, getQualifiedJSXName(openingElement.name));
	        }
	      }
	    }

	    if (isFragment(openingElement)) {
	      node.openingFragment = openingElement;
	      node.closingFragment = closingElement;
	    } else {
	      node.openingElement = openingElement;
	      node.closingElement = closingElement;
	    }

	    node.children = children;

	    if (this.match(47)) {
	      throw this.raise(JsxErrors.UnwrappedAdjacentJSXElements, {
	        at: this.state.startLoc
	      });
	    }

	    return isFragment(openingElement) ? this.finishNode(node, "JSXFragment") : this.finishNode(node, "JSXElement");
	  }

	  jsxParseElement() {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    this.next();
	    return this.jsxParseElementAt(startPos, startLoc);
	  }

	  setContext(newContext) {
	    const {
	      context
	    } = this.state;
	    context[context.length - 1] = newContext;
	  }

	  parseExprAtom(refExpressionErrors) {
	    if (this.match(137)) {
	      return this.parseLiteral(this.state.value, "JSXText");
	    } else if (this.match(138)) {
	      return this.jsxParseElement();
	    } else if (this.match(47) && this.input.charCodeAt(this.state.pos) !== 33) {
	      this.replaceToken(138);
	      return this.jsxParseElement();
	    } else {
	      return super.parseExprAtom(refExpressionErrors);
	    }
	  }

	  skipSpace() {
	    const curContext = this.curContext();
	    if (!curContext.preserveSpace) super.skipSpace();
	  }

	  getTokenFromCode(code) {
	    const context = this.curContext();

	    if (context === types.j_expr) {
	      return this.jsxReadToken();
	    }

	    if (context === types.j_oTag || context === types.j_cTag) {
	      if (isIdentifierStart(code)) {
	        return this.jsxReadWord();
	      }

	      if (code === 62) {
	        ++this.state.pos;
	        return this.finishToken(139);
	      }

	      if ((code === 34 || code === 39) && context === types.j_oTag) {
	        return this.jsxReadString(code);
	      }
	    }

	    if (code === 60 && this.state.canStartJSXElement && this.input.charCodeAt(this.state.pos + 1) !== 33) {
	      ++this.state.pos;
	      return this.finishToken(138);
	    }

	    return super.getTokenFromCode(code);
	  }

	  updateContext(prevType) {
	    const {
	      context,
	      type
	    } = this.state;

	    if (type === 56 && prevType === 138) {
	      context.splice(-2, 2, types.j_cTag);
	      this.state.canStartJSXElement = false;
	    } else if (type === 138) {
	      context.push(types.j_oTag);
	    } else if (type === 139) {
	      const out = context[context.length - 1];

	      if (out === types.j_oTag && prevType === 56 || out === types.j_cTag) {
	        context.pop();
	        this.state.canStartJSXElement = context[context.length - 1] === types.j_expr;
	      } else {
	        this.setContext(types.j_expr);
	        this.state.canStartJSXElement = true;
	      }
	    } else {
	      this.state.canStartJSXElement = tokenComesBeforeExpression(type);
	    }
	  }

	});

	class TypeScriptScope extends Scope {
	  types = new Set();
	  enums = new Set();
	  constEnums = new Set();
	  classes = new Set();
	  exportOnlyBindings = new Set();
	}

	class TypeScriptScopeHandler extends ScopeHandler {
	  createScope(flags) {
	    return new TypeScriptScope(flags);
	  }

	  declareName(name, bindingType, loc) {
	    const scope = this.currentScope();

	    if (bindingType & BIND_FLAGS_TS_EXPORT_ONLY) {
	      this.maybeExportDefined(scope, name);
	      scope.exportOnlyBindings.add(name);
	      return;
	    }

	    super.declareName(...arguments);

	    if (bindingType & BIND_KIND_TYPE) {
	      if (!(bindingType & BIND_KIND_VALUE)) {
	        this.checkRedeclarationInScope(scope, name, bindingType, loc);
	        this.maybeExportDefined(scope, name);
	      }

	      scope.types.add(name);
	    }

	    if (bindingType & BIND_FLAGS_TS_ENUM) scope.enums.add(name);
	    if (bindingType & BIND_FLAGS_TS_CONST_ENUM) scope.constEnums.add(name);
	    if (bindingType & BIND_FLAGS_CLASS) scope.classes.add(name);
	  }

	  isRedeclaredInScope(scope, name, bindingType) {
	    if (scope.enums.has(name)) {
	      if (bindingType & BIND_FLAGS_TS_ENUM) {
	        const isConst = !!(bindingType & BIND_FLAGS_TS_CONST_ENUM);
	        const wasConst = scope.constEnums.has(name);
	        return isConst !== wasConst;
	      }

	      return true;
	    }

	    if (bindingType & BIND_FLAGS_CLASS && scope.classes.has(name)) {
	      if (scope.lexical.has(name)) {
	        return !!(bindingType & BIND_KIND_VALUE);
	      } else {
	        return false;
	      }
	    }

	    if (bindingType & BIND_KIND_TYPE && scope.types.has(name)) {
	      return true;
	    }

	    return super.isRedeclaredInScope(...arguments);
	  }

	  checkLocalExport(id) {
	    const topLevelScope = this.scopeStack[0];
	    const {
	      name
	    } = id;

	    if (!topLevelScope.types.has(name) && !topLevelScope.exportOnlyBindings.has(name)) {
	      super.checkLocalExport(id);
	    }
	  }

	}

	function nonNull(x) {
	  if (x == null) {
	    throw new Error(`Unexpected ${x} value.`);
	  }

	  return x;
	}

	function assert(x) {
	  if (!x) {
	    throw new Error("Assert fail");
	  }
	}

	const TSErrors = makeErrorTemplates({
	  AbstractMethodHasImplementation: "Method '%0' cannot have an implementation because it is marked abstract.",
	  AbstractPropertyHasInitializer: "Property '%0' cannot have an initializer because it is marked abstract.",
	  AccesorCannotDeclareThisParameter: "'get' and 'set' accessors cannot declare 'this' parameters.",
	  AccesorCannotHaveTypeParameters: "An accessor cannot have type parameters.",
	  ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
	  ClassMethodHasReadonly: "Class methods cannot have the 'readonly' modifier.",
	  ConstructorHasTypeParameters: "Type parameters cannot appear on a constructor declaration.",
	  DeclareAccessor: "'declare' is not allowed in %0ters.",
	  DeclareClassFieldHasInitializer: "Initializers are not allowed in ambient contexts.",
	  DeclareFunctionHasImplementation: "An implementation cannot be declared in ambient contexts.",
	  DuplicateAccessibilityModifier: "Accessibility modifier already seen.",
	  DuplicateModifier: "Duplicate modifier: '%0'.",
	  EmptyHeritageClauseType: "'%0' list cannot be empty.",
	  EmptyTypeArguments: "Type argument list cannot be empty.",
	  EmptyTypeParameters: "Type parameter list cannot be empty.",
	  ExpectedAmbientAfterExportDeclare: "'export declare' must be followed by an ambient declaration.",
	  ImportAliasHasImportType: "An import alias can not use 'import type'.",
	  IncompatibleModifiers: "'%0' modifier cannot be used with '%1' modifier.",
	  IndexSignatureHasAbstract: "Index signatures cannot have the 'abstract' modifier.",
	  IndexSignatureHasAccessibility: "Index signatures cannot have an accessibility modifier ('%0').",
	  IndexSignatureHasDeclare: "Index signatures cannot have the 'declare' modifier.",
	  IndexSignatureHasOverride: "'override' modifier cannot appear on an index signature.",
	  IndexSignatureHasStatic: "Index signatures cannot have the 'static' modifier.",
	  InvalidModifierOnTypeMember: "'%0' modifier cannot appear on a type member.",
	  InvalidModifiersOrder: "'%0' modifier must precede '%1' modifier.",
	  InvalidTupleMemberLabel: "Tuple members must be labeled with a simple identifier.",
	  MissingInterfaceName: "'interface' declarations must be followed by an identifier.",
	  MixedLabeledAndUnlabeledElements: "Tuple members must all have names or all not have names.",
	  NonAbstractClassHasAbstractMethod: "Abstract methods can only appear within an abstract class.",
	  NonClassMethodPropertyHasAbstractModifer: "'abstract' modifier can only appear on a class, method, or property declaration.",
	  OptionalTypeBeforeRequired: "A required element cannot follow an optional element.",
	  OverrideNotInSubClass: "This member cannot have an 'override' modifier because its containing class does not extend another class.",
	  PatternIsOptional: "A binding pattern parameter cannot be optional in an implementation signature.",
	  PrivateElementHasAbstract: "Private elements cannot have the 'abstract' modifier.",
	  PrivateElementHasAccessibility: "Private elements cannot have an accessibility modifier ('%0').",
	  ReadonlyForMethodSignature: "'readonly' modifier can only appear on a property declaration or index signature.",
	  ReservedArrowTypeParam: "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.",
	  ReservedTypeAssertion: "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.",
	  SetAccesorCannotHaveOptionalParameter: "A 'set' accessor cannot have an optional parameter.",
	  SetAccesorCannotHaveRestParameter: "A 'set' accessor cannot have rest parameter.",
	  SetAccesorCannotHaveReturnType: "A 'set' accessor cannot have a return type annotation.",
	  StaticBlockCannotHaveModifier: "Static class blocks cannot have any modifier.",
	  TypeAnnotationAfterAssign: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
	  TypeImportCannotSpecifyDefaultAndNamed: "A type-only import can specify a default import or named bindings, but not both.",
	  TypeModifierIsUsedInTypeExports: "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
	  TypeModifierIsUsedInTypeImports: "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
	  UnexpectedParameterModifier: "A parameter property is only allowed in a constructor implementation.",
	  UnexpectedReadonly: "'readonly' type modifier is only permitted on array and tuple literal types.",
	  UnexpectedTypeAnnotation: "Did not expect a type annotation here.",
	  UnexpectedTypeCastInParameter: "Unexpected type cast in parameter position.",
	  UnsupportedImportTypeArgument: "Argument in a type import must be a string literal.",
	  UnsupportedParameterPropertyKind: "A parameter property may not be declared using a binding pattern.",
	  UnsupportedSignatureParameterKind: "Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got %0."
	}, ErrorCodes.SyntaxError, "typescript");

	function keywordTypeFromName(value) {
	  switch (value) {
	    case "any":
	      return "TSAnyKeyword";

	    case "boolean":
	      return "TSBooleanKeyword";

	    case "bigint":
	      return "TSBigIntKeyword";

	    case "never":
	      return "TSNeverKeyword";

	    case "number":
	      return "TSNumberKeyword";

	    case "object":
	      return "TSObjectKeyword";

	    case "string":
	      return "TSStringKeyword";

	    case "symbol":
	      return "TSSymbolKeyword";

	    case "undefined":
	      return "TSUndefinedKeyword";

	    case "unknown":
	      return "TSUnknownKeyword";

	    default:
	      return undefined;
	  }
	}

	function tsIsAccessModifier(modifier) {
	  return modifier === "private" || modifier === "public" || modifier === "protected";
	}

	var typescript = (superClass => class extends superClass {
	  getScopeHandler() {
	    return TypeScriptScopeHandler;
	  }

	  tsIsIdentifier() {
	    return tokenIsIdentifier(this.state.type);
	  }

	  tsTokenCanFollowModifier() {
	    return (this.match(0) || this.match(5) || this.match(55) || this.match(21) || this.match(134) || this.isLiteralPropertyName()) && !this.hasPrecedingLineBreak();
	  }

	  tsNextTokenCanFollowModifier() {
	    this.next();
	    return this.tsTokenCanFollowModifier();
	  }

	  tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
	    if (!tokenIsIdentifier(this.state.type)) {
	      return undefined;
	    }

	    const modifier = this.state.value;

	    if (allowedModifiers.indexOf(modifier) !== -1) {
	      if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
	        return undefined;
	      }

	      if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
	        return modifier;
	      }
	    }

	    return undefined;
	  }

	  tsParseModifiers(modified, allowedModifiers, disallowedModifiers, errorTemplate, stopOnStartOfClassStaticBlock) {
	    const enforceOrder = (loc, modifier, before, after) => {
	      if (modifier === before && modified[after]) {
	        this.raise(TSErrors.InvalidModifiersOrder, {
	          at: loc
	        }, before, after);
	      }
	    };

	    const incompatible = (loc, modifier, mod1, mod2) => {
	      if (modified[mod1] && modifier === mod2 || modified[mod2] && modifier === mod1) {
	        this.raise(TSErrors.IncompatibleModifiers, {
	          at: loc
	        }, mod1, mod2);
	      }
	    };

	    for (;;) {
	      const {
	        startLoc
	      } = this.state;
	      const modifier = this.tsParseModifier(allowedModifiers.concat(disallowedModifiers ?? []), stopOnStartOfClassStaticBlock);
	      if (!modifier) break;

	      if (tsIsAccessModifier(modifier)) {
	        if (modified.accessibility) {
	          this.raise(TSErrors.DuplicateAccessibilityModifier, {
	            at: startLoc
	          });
	        } else {
	          enforceOrder(startLoc, modifier, modifier, "override");
	          enforceOrder(startLoc, modifier, modifier, "static");
	          enforceOrder(startLoc, modifier, modifier, "readonly");
	          modified.accessibility = modifier;
	        }
	      } else {
	        if (Object.hasOwnProperty.call(modified, modifier)) {
	          this.raise(TSErrors.DuplicateModifier, {
	            at: startLoc
	          }, modifier);
	        } else {
	          enforceOrder(startLoc, modifier, "static", "readonly");
	          enforceOrder(startLoc, modifier, "static", "override");
	          enforceOrder(startLoc, modifier, "override", "readonly");
	          enforceOrder(startLoc, modifier, "abstract", "override");
	          incompatible(startLoc, modifier, "declare", "override");
	          incompatible(startLoc, modifier, "static", "abstract");
	        }

	        modified[modifier] = true;
	      }

	      if (disallowedModifiers?.includes(modifier)) {
	        this.raise(errorTemplate, {
	          at: startLoc
	        }, modifier);
	      }
	    }
	  }

	  tsIsListTerminator(kind) {
	    switch (kind) {
	      case "EnumMembers":
	      case "TypeMembers":
	        return this.match(8);

	      case "HeritageClauseElement":
	        return this.match(5);

	      case "TupleElementTypes":
	        return this.match(3);

	      case "TypeParametersOrArguments":
	        return this.match(48);
	    }

	    throw new Error("Unreachable");
	  }

	  tsParseList(kind, parseElement) {
	    const result = [];

	    while (!this.tsIsListTerminator(kind)) {
	      result.push(parseElement());
	    }

	    return result;
	  }

	  tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
	    return nonNull(this.tsParseDelimitedListWorker(kind, parseElement, true, refTrailingCommaPos));
	  }

	  tsParseDelimitedListWorker(kind, parseElement, expectSuccess, refTrailingCommaPos) {
	    const result = [];
	    let trailingCommaPos = -1;

	    for (;;) {
	      if (this.tsIsListTerminator(kind)) {
	        break;
	      }

	      trailingCommaPos = -1;
	      const element = parseElement();

	      if (element == null) {
	        return undefined;
	      }

	      result.push(element);

	      if (this.eat(12)) {
	        trailingCommaPos = this.state.lastTokStart;
	        continue;
	      }

	      if (this.tsIsListTerminator(kind)) {
	        break;
	      }

	      if (expectSuccess) {
	        this.expect(12);
	      }

	      return undefined;
	    }

	    if (refTrailingCommaPos) {
	      refTrailingCommaPos.value = trailingCommaPos;
	    }

	    return result;
	  }

	  tsParseBracketedList(kind, parseElement, bracket, skipFirstToken, refTrailingCommaPos) {
	    if (!skipFirstToken) {
	      if (bracket) {
	        this.expect(0);
	      } else {
	        this.expect(47);
	      }
	    }

	    const result = this.tsParseDelimitedList(kind, parseElement, refTrailingCommaPos);

	    if (bracket) {
	      this.expect(3);
	    } else {
	      this.expect(48);
	    }

	    return result;
	  }

	  tsParseImportType() {
	    const node = this.startNode();
	    this.expect(83);
	    this.expect(10);

	    if (!this.match(129)) {
	      this.raise(TSErrors.UnsupportedImportTypeArgument, {
	        at: this.state.startLoc
	      });
	    }

	    node.argument = this.parseExprAtom();
	    this.expect(11);

	    if (this.eat(16)) {
	      node.qualifier = this.tsParseEntityName(true);
	    }

	    if (this.match(47)) {
	      node.typeParameters = this.tsParseTypeArguments();
	    }

	    return this.finishNode(node, "TSImportType");
	  }

	  tsParseEntityName(allowReservedWords) {
	    let entity = this.parseIdentifier();

	    while (this.eat(16)) {
	      const node = this.startNodeAtNode(entity);
	      node.left = entity;
	      node.right = this.parseIdentifier(allowReservedWords);
	      entity = this.finishNode(node, "TSQualifiedName");
	    }

	    return entity;
	  }

	  tsParseTypeReference() {
	    const node = this.startNode();
	    node.typeName = this.tsParseEntityName(false);

	    if (!this.hasPrecedingLineBreak() && this.match(47)) {
	      node.typeParameters = this.tsParseTypeArguments();
	    }

	    return this.finishNode(node, "TSTypeReference");
	  }

	  tsParseThisTypePredicate(lhs) {
	    this.next();
	    const node = this.startNodeAtNode(lhs);
	    node.parameterName = lhs;
	    node.typeAnnotation = this.tsParseTypeAnnotation(false);
	    node.asserts = false;
	    return this.finishNode(node, "TSTypePredicate");
	  }

	  tsParseThisTypeNode() {
	    const node = this.startNode();
	    this.next();
	    return this.finishNode(node, "TSThisType");
	  }

	  tsParseTypeQuery() {
	    const node = this.startNode();
	    this.expect(87);

	    if (this.match(83)) {
	      node.exprName = this.tsParseImportType();
	    } else {
	      node.exprName = this.tsParseEntityName(true);
	    }

	    return this.finishNode(node, "TSTypeQuery");
	  }

	  tsParseTypeParameter() {
	    const node = this.startNode();
	    node.name = this.tsParseTypeParameterName();
	    node.constraint = this.tsEatThenParseType(81);
	    node.default = this.tsEatThenParseType(29);
	    return this.finishNode(node, "TSTypeParameter");
	  }

	  tsTryParseTypeParameters() {
	    if (this.match(47)) {
	      return this.tsParseTypeParameters();
	    }
	  }

	  tsParseTypeParameters() {
	    const node = this.startNode();

	    if (this.match(47) || this.match(138)) {
	      this.next();
	    } else {
	      this.unexpected();
	    }

	    const refTrailingCommaPos = {
	      value: -1
	    };
	    node.params = this.tsParseBracketedList("TypeParametersOrArguments", this.tsParseTypeParameter.bind(this), false, true, refTrailingCommaPos);

	    if (node.params.length === 0) {
	      this.raise(TSErrors.EmptyTypeParameters, {
	        node
	      });
	    }

	    if (refTrailingCommaPos.value !== -1) {
	      this.addExtra(node, "trailingComma", refTrailingCommaPos.value);
	    }

	    return this.finishNode(node, "TSTypeParameterDeclaration");
	  }

	  tsTryNextParseConstantContext() {
	    if (this.lookahead().type === 75) {
	      this.next();
	      return this.tsParseTypeReference();
	    }

	    return null;
	  }

	  tsFillSignature(returnToken, signature) {
	    const returnTokenRequired = returnToken === 19;
	    const paramsKey = browser$5.env.BABEL_8_BREAKING ? "params" : "parameters";
	    const returnTypeKey = browser$5.env.BABEL_8_BREAKING ? "returnType" : "typeAnnotation";
	    signature.typeParameters = this.tsTryParseTypeParameters();
	    this.expect(10);
	    signature[paramsKey] = this.tsParseBindingListForSignature();

	    if (returnTokenRequired) {
	      signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
	    } else if (this.match(returnToken)) {
	      signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
	    }
	  }

	  tsParseBindingListForSignature() {
	    return this.parseBindingList(11, 41).map(pattern => {
	      if (pattern.type !== "Identifier" && pattern.type !== "RestElement" && pattern.type !== "ObjectPattern" && pattern.type !== "ArrayPattern") {
	        this.raise(TSErrors.UnsupportedSignatureParameterKind, {
	          node: pattern
	        }, pattern.type);
	      }

	      return pattern;
	    });
	  }

	  tsParseTypeMemberSemicolon() {
	    if (!this.eat(12) && !this.isLineTerminator()) {
	      this.expect(13);
	    }
	  }

	  tsParseSignatureMember(kind, node) {
	    this.tsFillSignature(14, node);
	    this.tsParseTypeMemberSemicolon();
	    return this.finishNode(node, kind);
	  }

	  tsIsUnambiguouslyIndexSignature() {
	    this.next();

	    if (tokenIsIdentifier(this.state.type)) {
	      this.next();
	      return this.match(14);
	    }

	    return false;
	  }

	  tsTryParseIndexSignature(node) {
	    if (!(this.match(0) && this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this)))) {
	      return undefined;
	    }

	    this.expect(0);
	    const id = this.parseIdentifier();
	    id.typeAnnotation = this.tsParseTypeAnnotation();
	    this.resetEndLocation(id);
	    this.expect(3);
	    node.parameters = [id];
	    const type = this.tsTryParseTypeAnnotation();
	    if (type) node.typeAnnotation = type;
	    this.tsParseTypeMemberSemicolon();
	    return this.finishNode(node, "TSIndexSignature");
	  }

	  tsParsePropertyOrMethodSignature(node, readonly) {
	    if (this.eat(17)) node.optional = true;
	    const nodeAny = node;

	    if (this.match(10) || this.match(47)) {
	      if (readonly) {
	        this.raise(TSErrors.ReadonlyForMethodSignature, {
	          node
	        });
	      }

	      const method = nodeAny;

	      if (method.kind && this.match(47)) {
	        this.raise(TSErrors.AccesorCannotHaveTypeParameters, {
	          at: this.state.curPosition()
	        });
	      }

	      this.tsFillSignature(14, method);
	      this.tsParseTypeMemberSemicolon();
	      const paramsKey = browser$5.env.BABEL_8_BREAKING ? "params" : "parameters";
	      const returnTypeKey = browser$5.env.BABEL_8_BREAKING ? "returnType" : "typeAnnotation";

	      if (method.kind === "get") {
	        if (method[paramsKey].length > 0) {
	          this.raise(ErrorMessages.BadGetterArity, {
	            at: this.state.curPosition()
	          });

	          if (this.isThisParam(method[paramsKey][0])) {
	            this.raise(TSErrors.AccesorCannotDeclareThisParameter, {
	              at: this.state.curPosition()
	            });
	          }
	        }
	      } else if (method.kind === "set") {
	        if (method[paramsKey].length !== 1) {
	          this.raise(ErrorMessages.BadSetterArity, {
	            at: this.state.curPosition()
	          });
	        } else {
	          const firstParameter = method[paramsKey][0];

	          if (this.isThisParam(firstParameter)) {
	            this.raise(TSErrors.AccesorCannotDeclareThisParameter, {
	              at: this.state.curPosition()
	            });
	          }

	          if (firstParameter.type === "Identifier" && firstParameter.optional) {
	            this.raise(TSErrors.SetAccesorCannotHaveOptionalParameter, {
	              at: this.state.curPosition()
	            });
	          }

	          if (firstParameter.type === "RestElement") {
	            this.raise(TSErrors.SetAccesorCannotHaveRestParameter, {
	              at: this.state.curPosition()
	            });
	          }
	        }

	        if (method[returnTypeKey]) {
	          this.raise(TSErrors.SetAccesorCannotHaveReturnType, {
	            node: method[returnTypeKey]
	          });
	        }
	      } else {
	        method.kind = "method";
	      }

	      return this.finishNode(method, "TSMethodSignature");
	    } else {
	      const property = nodeAny;
	      if (readonly) property.readonly = true;
	      const type = this.tsTryParseTypeAnnotation();
	      if (type) property.typeAnnotation = type;
	      this.tsParseTypeMemberSemicolon();
	      return this.finishNode(property, "TSPropertySignature");
	    }
	  }

	  tsParseTypeMember() {
	    const node = this.startNode();

	    if (this.match(10) || this.match(47)) {
	      return this.tsParseSignatureMember("TSCallSignatureDeclaration", node);
	    }

	    if (this.match(77)) {
	      const id = this.startNode();
	      this.next();

	      if (this.match(10) || this.match(47)) {
	        return this.tsParseSignatureMember("TSConstructSignatureDeclaration", node);
	      } else {
	        node.key = this.createIdentifier(id, "new");
	        return this.tsParsePropertyOrMethodSignature(node, false);
	      }
	    }

	    this.tsParseModifiers(node, ["readonly"], ["declare", "abstract", "private", "protected", "public", "static", "override"], TSErrors.InvalidModifierOnTypeMember);
	    const idx = this.tsTryParseIndexSignature(node);

	    if (idx) {
	      return idx;
	    }

	    this.parsePropertyName(node);

	    if (!node.computed && node.key.type === "Identifier" && (node.key.name === "get" || node.key.name === "set") && this.tsTokenCanFollowModifier()) {
	      node.kind = node.key.name;
	      this.parsePropertyName(node);
	    }

	    return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
	  }

	  tsParseTypeLiteral() {
	    const node = this.startNode();
	    node.members = this.tsParseObjectTypeMembers();
	    return this.finishNode(node, "TSTypeLiteral");
	  }

	  tsParseObjectTypeMembers() {
	    this.expect(5);
	    const members = this.tsParseList("TypeMembers", this.tsParseTypeMember.bind(this));
	    this.expect(8);
	    return members;
	  }

	  tsIsStartOfMappedType() {
	    this.next();

	    if (this.eat(53)) {
	      return this.isContextual(118);
	    }

	    if (this.isContextual(118)) {
	      this.next();
	    }

	    if (!this.match(0)) {
	      return false;
	    }

	    this.next();

	    if (!this.tsIsIdentifier()) {
	      return false;
	    }

	    this.next();
	    return this.match(58);
	  }

	  tsParseMappedTypeParameter() {
	    const node = this.startNode();
	    node.name = this.tsParseTypeParameterName();
	    node.constraint = this.tsExpectThenParseType(58);
	    return this.finishNode(node, "TSTypeParameter");
	  }

	  tsParseMappedType() {
	    const node = this.startNode();
	    this.expect(5);

	    if (this.match(53)) {
	      node.readonly = this.state.value;
	      this.next();
	      this.expectContextual(118);
	    } else if (this.eatContextual(118)) {
	      node.readonly = true;
	    }

	    this.expect(0);
	    node.typeParameter = this.tsParseMappedTypeParameter();
	    node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
	    this.expect(3);

	    if (this.match(53)) {
	      node.optional = this.state.value;
	      this.next();
	      this.expect(17);
	    } else if (this.eat(17)) {
	      node.optional = true;
	    }

	    node.typeAnnotation = this.tsTryParseType();
	    this.semicolon();
	    this.expect(8);
	    return this.finishNode(node, "TSMappedType");
	  }

	  tsParseTupleType() {
	    const node = this.startNode();
	    node.elementTypes = this.tsParseBracketedList("TupleElementTypes", this.tsParseTupleElementType.bind(this), true, false);
	    let seenOptionalElement = false;
	    let labeledElements = null;
	    node.elementTypes.forEach(elementNode => {
	      let {
	        type
	      } = elementNode;

	      if (seenOptionalElement && type !== "TSRestType" && type !== "TSOptionalType" && !(type === "TSNamedTupleMember" && elementNode.optional)) {
	        this.raise(TSErrors.OptionalTypeBeforeRequired, {
	          node: elementNode
	        });
	      }

	      seenOptionalElement = seenOptionalElement || type === "TSNamedTupleMember" && elementNode.optional || type === "TSOptionalType";

	      if (type === "TSRestType") {
	        elementNode = elementNode.typeAnnotation;
	        type = elementNode.type;
	      }

	      const isLabeled = type === "TSNamedTupleMember";
	      labeledElements = labeledElements ?? isLabeled;

	      if (labeledElements !== isLabeled) {
	        this.raise(TSErrors.MixedLabeledAndUnlabeledElements, {
	          node: elementNode
	        });
	      }
	    });
	    return this.finishNode(node, "TSTupleType");
	  }

	  tsParseTupleElementType() {
	    const {
	      start: startPos,
	      startLoc
	    } = this.state;
	    const rest = this.eat(21);
	    let type = this.tsParseType();
	    const optional = this.eat(17);
	    const labeled = this.eat(14);

	    if (labeled) {
	      const labeledNode = this.startNodeAtNode(type);
	      labeledNode.optional = optional;

	      if (type.type === "TSTypeReference" && !type.typeParameters && type.typeName.type === "Identifier") {
	        labeledNode.label = type.typeName;
	      } else {
	        this.raise(TSErrors.InvalidTupleMemberLabel, {
	          node: type
	        });
	        labeledNode.label = type;
	      }

	      labeledNode.elementType = this.tsParseType();
	      type = this.finishNode(labeledNode, "TSNamedTupleMember");
	    } else if (optional) {
	      const optionalTypeNode = this.startNodeAtNode(type);
	      optionalTypeNode.typeAnnotation = type;
	      type = this.finishNode(optionalTypeNode, "TSOptionalType");
	    }

	    if (rest) {
	      const restNode = this.startNodeAt(startPos, startLoc);
	      restNode.typeAnnotation = type;
	      type = this.finishNode(restNode, "TSRestType");
	    }

	    return type;
	  }

	  tsParseParenthesizedType() {
	    const node = this.startNode();
	    this.expect(10);
	    node.typeAnnotation = this.tsParseType();
	    this.expect(11);
	    return this.finishNode(node, "TSParenthesizedType");
	  }

	  tsParseFunctionOrConstructorType(type, abstract) {
	    const node = this.startNode();

	    if (type === "TSConstructorType") {
	      node.abstract = !!abstract;
	      if (abstract) this.next();
	      this.next();
	    }

	    this.tsFillSignature(19, node);
	    return this.finishNode(node, type);
	  }

	  tsParseLiteralTypeNode() {
	    const node = this.startNode();

	    node.literal = (() => {
	      switch (this.state.type) {
	        case 130:
	        case 131:
	        case 129:
	        case 85:
	        case 86:
	          return this.parseExprAtom();

	        default:
	          throw this.unexpected();
	      }
	    })();

	    return this.finishNode(node, "TSLiteralType");
	  }

	  tsParseTemplateLiteralType() {
	    const node = this.startNode();
	    node.literal = this.parseTemplate(false);
	    return this.finishNode(node, "TSLiteralType");
	  }

	  parseTemplateSubstitution() {
	    if (this.state.inType) return this.tsParseType();
	    return super.parseTemplateSubstitution();
	  }

	  tsParseThisTypeOrThisTypePredicate() {
	    const thisKeyword = this.tsParseThisTypeNode();

	    if (this.isContextual(113) && !this.hasPrecedingLineBreak()) {
	      return this.tsParseThisTypePredicate(thisKeyword);
	    } else {
	      return thisKeyword;
	    }
	  }

	  tsParseNonArrayType() {
	    switch (this.state.type) {
	      case 129:
	      case 130:
	      case 131:
	      case 85:
	      case 86:
	        return this.tsParseLiteralTypeNode();

	      case 53:
	        if (this.state.value === "-") {
	          const node = this.startNode();
	          const nextToken = this.lookahead();

	          if (nextToken.type !== 130 && nextToken.type !== 131) {
	            throw this.unexpected();
	          }

	          node.literal = this.parseMaybeUnary();
	          return this.finishNode(node, "TSLiteralType");
	        }

	        break;

	      case 78:
	        return this.tsParseThisTypeOrThisTypePredicate();

	      case 87:
	        return this.tsParseTypeQuery();

	      case 83:
	        return this.tsParseImportType();

	      case 5:
	        return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this)) ? this.tsParseMappedType() : this.tsParseTypeLiteral();

	      case 0:
	        return this.tsParseTupleType();

	      case 10:
	        if (browser$5.env.BABEL_8_BREAKING) {
	          if (!this.options.createParenthesizedExpressions) {
	            const startPos = this.state.start;
	            this.next();
	            const type = this.tsParseType();
	            this.expect(11);
	            this.addExtra(type, "parenthesized", true);
	            this.addExtra(type, "parenStart", startPos);
	            return type;
	          }
	        }

	        return this.tsParseParenthesizedType();

	      case 25:
	      case 24:
	        return this.tsParseTemplateLiteralType();

	      default:
	        {
	          const {
	            type
	          } = this.state;

	          if (tokenIsIdentifier(type) || type === 88 || type === 84) {
	            const nodeType = type === 88 ? "TSVoidKeyword" : type === 84 ? "TSNullKeyword" : keywordTypeFromName(this.state.value);

	            if (nodeType !== undefined && this.lookaheadCharCode() !== 46) {
	              const node = this.startNode();
	              this.next();
	              return this.finishNode(node, nodeType);
	            }

	            return this.tsParseTypeReference();
	          }
	        }
	    }

	    throw this.unexpected();
	  }

	  tsParseArrayTypeOrHigher() {
	    let type = this.tsParseNonArrayType();

	    while (!this.hasPrecedingLineBreak() && this.eat(0)) {
	      if (this.match(3)) {
	        const node = this.startNodeAtNode(type);
	        node.elementType = type;
	        this.expect(3);
	        type = this.finishNode(node, "TSArrayType");
	      } else {
	        const node = this.startNodeAtNode(type);
	        node.objectType = type;
	        node.indexType = this.tsParseType();
	        this.expect(3);
	        type = this.finishNode(node, "TSIndexedAccessType");
	      }
	    }

	    return type;
	  }

	  tsParseTypeOperator() {
	    const node = this.startNode();
	    const operator = this.state.value;
	    this.next();
	    node.operator = operator;
	    node.typeAnnotation = this.tsParseTypeOperatorOrHigher();

	    if (operator === "readonly") {
	      this.tsCheckTypeAnnotationForReadOnly(node);
	    }

	    return this.finishNode(node, "TSTypeOperator");
	  }

	  tsCheckTypeAnnotationForReadOnly(node) {
	    switch (node.typeAnnotation.type) {
	      case "TSTupleType":
	      case "TSArrayType":
	        return;

	      default:
	        this.raise(TSErrors.UnexpectedReadonly, {
	          node
	        });
	    }
	  }

	  tsParseInferType() {
	    const node = this.startNode();
	    this.expectContextual(112);
	    const typeParameter = this.startNode();
	    typeParameter.name = this.tsParseTypeParameterName();
	    node.typeParameter = this.finishNode(typeParameter, "TSTypeParameter");
	    return this.finishNode(node, "TSInferType");
	  }

	  tsParseTypeOperatorOrHigher() {
	    const isTypeOperator = tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
	    return isTypeOperator ? this.tsParseTypeOperator() : this.isContextual(112) ? this.tsParseInferType() : this.tsParseArrayTypeOrHigher();
	  }

	  tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
	    const node = this.startNode();
	    const hasLeadingOperator = this.eat(operator);
	    const types = [];

	    do {
	      types.push(parseConstituentType());
	    } while (this.eat(operator));

	    if (types.length === 1 && !hasLeadingOperator) {
	      return types[0];
	    }

	    node.types = types;
	    return this.finishNode(node, kind);
	  }

	  tsParseIntersectionTypeOrHigher() {
	    return this.tsParseUnionOrIntersectionType("TSIntersectionType", this.tsParseTypeOperatorOrHigher.bind(this), 45);
	  }

	  tsParseUnionTypeOrHigher() {
	    return this.tsParseUnionOrIntersectionType("TSUnionType", this.tsParseIntersectionTypeOrHigher.bind(this), 43);
	  }

	  tsIsStartOfFunctionType() {
	    if (this.match(47)) {
	      return true;
	    }

	    return this.match(10) && this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this));
	  }

	  tsSkipParameterStart() {
	    if (tokenIsIdentifier(this.state.type) || this.match(78)) {
	      this.next();
	      return true;
	    }

	    if (this.match(5)) {
	      let braceStackCounter = 1;
	      this.next();

	      while (braceStackCounter > 0) {
	        if (this.match(5)) {
	          ++braceStackCounter;
	        } else if (this.match(8)) {
	          --braceStackCounter;
	        }

	        this.next();
	      }

	      return true;
	    }

	    if (this.match(0)) {
	      let braceStackCounter = 1;
	      this.next();

	      while (braceStackCounter > 0) {
	        if (this.match(0)) {
	          ++braceStackCounter;
	        } else if (this.match(3)) {
	          --braceStackCounter;
	        }

	        this.next();
	      }

	      return true;
	    }

	    return false;
	  }

	  tsIsUnambiguouslyStartOfFunctionType() {
	    this.next();

	    if (this.match(11) || this.match(21)) {
	      return true;
	    }

	    if (this.tsSkipParameterStart()) {
	      if (this.match(14) || this.match(12) || this.match(17) || this.match(29)) {
	        return true;
	      }

	      if (this.match(11)) {
	        this.next();

	        if (this.match(19)) {
	          return true;
	        }
	      }
	    }

	    return false;
	  }

	  tsParseTypeOrTypePredicateAnnotation(returnToken) {
	    return this.tsInType(() => {
	      const t = this.startNode();
	      this.expect(returnToken);
	      const node = this.startNode();
	      const asserts = !!this.tsTryParse(this.tsParseTypePredicateAsserts.bind(this));

	      if (asserts && this.match(78)) {
	        let thisTypePredicate = this.tsParseThisTypeOrThisTypePredicate();

	        if (thisTypePredicate.type === "TSThisType") {
	          node.parameterName = thisTypePredicate;
	          node.asserts = true;
	          node.typeAnnotation = null;
	          thisTypePredicate = this.finishNode(node, "TSTypePredicate");
	        } else {
	          this.resetStartLocationFromNode(thisTypePredicate, node);
	          thisTypePredicate.asserts = true;
	        }

	        t.typeAnnotation = thisTypePredicate;
	        return this.finishNode(t, "TSTypeAnnotation");
	      }

	      const typePredicateVariable = this.tsIsIdentifier() && this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));

	      if (!typePredicateVariable) {
	        if (!asserts) {
	          return this.tsParseTypeAnnotation(false, t);
	        }

	        node.parameterName = this.parseIdentifier();
	        node.asserts = asserts;
	        node.typeAnnotation = null;
	        t.typeAnnotation = this.finishNode(node, "TSTypePredicate");
	        return this.finishNode(t, "TSTypeAnnotation");
	      }

	      const type = this.tsParseTypeAnnotation(false);
	      node.parameterName = typePredicateVariable;
	      node.typeAnnotation = type;
	      node.asserts = asserts;
	      t.typeAnnotation = this.finishNode(node, "TSTypePredicate");
	      return this.finishNode(t, "TSTypeAnnotation");
	    });
	  }

	  tsTryParseTypeOrTypePredicateAnnotation() {
	    return this.match(14) ? this.tsParseTypeOrTypePredicateAnnotation(14) : undefined;
	  }

	  tsTryParseTypeAnnotation() {
	    return this.match(14) ? this.tsParseTypeAnnotation() : undefined;
	  }

	  tsTryParseType() {
	    return this.tsEatThenParseType(14);
	  }

	  tsParseTypePredicatePrefix() {
	    const id = this.parseIdentifier();

	    if (this.isContextual(113) && !this.hasPrecedingLineBreak()) {
	      this.next();
	      return id;
	    }
	  }

	  tsParseTypePredicateAsserts() {
	    if (this.state.type !== 106) {
	      return false;
	    }

	    const containsEsc = this.state.containsEsc;
	    this.next();

	    if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
	      return false;
	    }

	    if (containsEsc) {
	      this.raise(ErrorMessages.InvalidEscapedReservedWord, {
	        at: this.state.lastTokStartLoc
	      }, "asserts");
	    }

	    return true;
	  }

	  tsParseTypeAnnotation(eatColon = true, t = this.startNode()) {
	    this.tsInType(() => {
	      if (eatColon) this.expect(14);
	      t.typeAnnotation = this.tsParseType();
	    });
	    return this.finishNode(t, "TSTypeAnnotation");
	  }

	  tsParseType() {
	    assert(this.state.inType);
	    const type = this.tsParseNonConditionalType();

	    if (this.hasPrecedingLineBreak() || !this.eat(81)) {
	      return type;
	    }

	    const node = this.startNodeAtNode(type);
	    node.checkType = type;
	    node.extendsType = this.tsParseNonConditionalType();
	    this.expect(17);
	    node.trueType = this.tsParseType();
	    this.expect(14);
	    node.falseType = this.tsParseType();
	    return this.finishNode(node, "TSConditionalType");
	  }

	  isAbstractConstructorSignature() {
	    return this.isContextual(120) && this.lookahead().type === 77;
	  }

	  tsParseNonConditionalType() {
	    if (this.tsIsStartOfFunctionType()) {
	      return this.tsParseFunctionOrConstructorType("TSFunctionType");
	    }

	    if (this.match(77)) {
	      return this.tsParseFunctionOrConstructorType("TSConstructorType");
	    } else if (this.isAbstractConstructorSignature()) {
	      return this.tsParseFunctionOrConstructorType("TSConstructorType", true);
	    }

	    return this.tsParseUnionTypeOrHigher();
	  }

	  tsParseTypeAssertion() {
	    if (this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
	      this.raise(TSErrors.ReservedTypeAssertion, {
	        at: this.state.startLoc
	      });
	    }

	    const node = this.startNode();

	    const _const = this.tsTryNextParseConstantContext();

	    node.typeAnnotation = _const || this.tsNextThenParseType();
	    this.expect(48);
	    node.expression = this.parseMaybeUnary();
	    return this.finishNode(node, "TSTypeAssertion");
	  }

	  tsParseHeritageClause(descriptor) {
	    const originalStartLoc = this.state.startLoc;
	    const delimitedList = this.tsParseDelimitedList("HeritageClauseElement", this.tsParseExpressionWithTypeArguments.bind(this));

	    if (!delimitedList.length) {
	      this.raise(TSErrors.EmptyHeritageClauseType, {
	        at: originalStartLoc
	      }, descriptor);
	    }

	    return delimitedList;
	  }

	  tsParseExpressionWithTypeArguments() {
	    const node = this.startNode();
	    node.expression = this.tsParseEntityName(false);

	    if (this.match(47)) {
	      node.typeParameters = this.tsParseTypeArguments();
	    }

	    return this.finishNode(node, "TSExpressionWithTypeArguments");
	  }

	  tsParseInterfaceDeclaration(node) {
	    if (tokenIsIdentifier(this.state.type)) {
	      node.id = this.parseIdentifier();
	      this.checkLVal(node.id, "typescript interface declaration", BIND_TS_INTERFACE);
	    } else {
	      node.id = null;
	      this.raise(TSErrors.MissingInterfaceName, {
	        at: this.state.startLoc
	      });
	    }

	    node.typeParameters = this.tsTryParseTypeParameters();

	    if (this.eat(81)) {
	      node.extends = this.tsParseHeritageClause("extends");
	    }

	    const body = this.startNode();
	    body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
	    node.body = this.finishNode(body, "TSInterfaceBody");
	    return this.finishNode(node, "TSInterfaceDeclaration");
	  }

	  tsParseTypeAliasDeclaration(node) {
	    node.id = this.parseIdentifier();
	    this.checkLVal(node.id, "typescript type alias", BIND_TS_TYPE);
	    node.typeParameters = this.tsTryParseTypeParameters();
	    node.typeAnnotation = this.tsInType(() => {
	      this.expect(29);

	      if (this.isContextual(111) && this.lookahead().type !== 16) {
	        const node = this.startNode();
	        this.next();
	        return this.finishNode(node, "TSIntrinsicKeyword");
	      }

	      return this.tsParseType();
	    });
	    this.semicolon();
	    return this.finishNode(node, "TSTypeAliasDeclaration");
	  }

	  tsInNoContext(cb) {
	    const oldContext = this.state.context;
	    this.state.context = [oldContext[0]];

	    try {
	      return cb();
	    } finally {
	      this.state.context = oldContext;
	    }
	  }

	  tsInType(cb) {
	    const oldInType = this.state.inType;
	    this.state.inType = true;

	    try {
	      return cb();
	    } finally {
	      this.state.inType = oldInType;
	    }
	  }

	  tsEatThenParseType(token) {
	    return !this.match(token) ? undefined : this.tsNextThenParseType();
	  }

	  tsExpectThenParseType(token) {
	    return this.tsDoThenParseType(() => this.expect(token));
	  }

	  tsNextThenParseType() {
	    return this.tsDoThenParseType(() => this.next());
	  }

	  tsDoThenParseType(cb) {
	    return this.tsInType(() => {
	      cb();
	      return this.tsParseType();
	    });
	  }

	  tsParseEnumMember() {
	    const node = this.startNode();
	    node.id = this.match(129) ? this.parseExprAtom() : this.parseIdentifier(true);

	    if (this.eat(29)) {
	      node.initializer = this.parseMaybeAssignAllowIn();
	    }

	    return this.finishNode(node, "TSEnumMember");
	  }

	  tsParseEnumDeclaration(node, isConst) {
	    if (isConst) node.const = true;
	    node.id = this.parseIdentifier();
	    this.checkLVal(node.id, "typescript enum declaration", isConst ? BIND_TS_CONST_ENUM : BIND_TS_ENUM);
	    this.expect(5);
	    node.members = this.tsParseDelimitedList("EnumMembers", this.tsParseEnumMember.bind(this));
	    this.expect(8);
	    return this.finishNode(node, "TSEnumDeclaration");
	  }

	  tsParseModuleBlock() {
	    const node = this.startNode();
	    this.scope.enter(SCOPE_OTHER);
	    this.expect(5);
	    this.parseBlockOrModuleBlockBody(node.body = [], undefined, true, 8);
	    this.scope.exit();
	    return this.finishNode(node, "TSModuleBlock");
	  }

	  tsParseModuleOrNamespaceDeclaration(node, nested = false) {
	    node.id = this.parseIdentifier();

	    if (!nested) {
	      this.checkLVal(node.id, "module or namespace declaration", BIND_TS_NAMESPACE);
	    }

	    if (this.eat(16)) {
	      const inner = this.startNode();
	      this.tsParseModuleOrNamespaceDeclaration(inner, true);
	      node.body = inner;
	    } else {
	      this.scope.enter(SCOPE_TS_MODULE);
	      this.prodParam.enter(PARAM);
	      node.body = this.tsParseModuleBlock();
	      this.prodParam.exit();
	      this.scope.exit();
	    }

	    return this.finishNode(node, "TSModuleDeclaration");
	  }

	  tsParseAmbientExternalModuleDeclaration(node) {
	    if (this.isContextual(109)) {
	      node.global = true;
	      node.id = this.parseIdentifier();
	    } else if (this.match(129)) {
	      node.id = this.parseExprAtom();
	    } else {
	      this.unexpected();
	    }

	    if (this.match(5)) {
	      this.scope.enter(SCOPE_TS_MODULE);
	      this.prodParam.enter(PARAM);
	      node.body = this.tsParseModuleBlock();
	      this.prodParam.exit();
	      this.scope.exit();
	    } else {
	      this.semicolon();
	    }

	    return this.finishNode(node, "TSModuleDeclaration");
	  }

	  tsParseImportEqualsDeclaration(node, isExport) {
	    node.isExport = isExport || false;
	    node.id = this.parseIdentifier();
	    this.checkLVal(node.id, "import equals declaration", BIND_LEXICAL);
	    this.expect(29);
	    const moduleReference = this.tsParseModuleReference();

	    if (node.importKind === "type" && moduleReference.type !== "TSExternalModuleReference") {
	      this.raise(TSErrors.ImportAliasHasImportType, {
	        node: moduleReference
	      });
	    }

	    node.moduleReference = moduleReference;
	    this.semicolon();
	    return this.finishNode(node, "TSImportEqualsDeclaration");
	  }

	  tsIsExternalModuleReference() {
	    return this.isContextual(116) && this.lookaheadCharCode() === 40;
	  }

	  tsParseModuleReference() {
	    return this.tsIsExternalModuleReference() ? this.tsParseExternalModuleReference() : this.tsParseEntityName(false);
	  }

	  tsParseExternalModuleReference() {
	    const node = this.startNode();
	    this.expectContextual(116);
	    this.expect(10);

	    if (!this.match(129)) {
	      throw this.unexpected();
	    }

	    node.expression = this.parseExprAtom();
	    this.expect(11);
	    return this.finishNode(node, "TSExternalModuleReference");
	  }

	  tsLookAhead(f) {
	    const state = this.state.clone();
	    const res = f();
	    this.state = state;
	    return res;
	  }

	  tsTryParseAndCatch(f) {
	    const result = this.tryParse(abort => f() || abort());
	    if (result.aborted || !result.node) return undefined;
	    if (result.error) this.state = result.failState;
	    return result.node;
	  }

	  tsTryParse(f) {
	    const state = this.state.clone();
	    const result = f();

	    if (result !== undefined && result !== false) {
	      return result;
	    } else {
	      this.state = state;
	      return undefined;
	    }
	  }

	  tsTryParseDeclare(nany) {
	    if (this.isLineTerminator()) {
	      return;
	    }

	    let starttype = this.state.type;
	    let kind;

	    if (this.isContextual(99)) {
	      starttype = 74;
	      kind = "let";
	    }

	    return this.tsInAmbientContext(() => {
	      switch (starttype) {
	        case 68:
	          nany.declare = true;
	          return this.parseFunctionStatement(nany, false, true);

	        case 80:
	          nany.declare = true;
	          return this.parseClass(nany, true, false);

	        case 75:
	          if (this.match(75) && this.isLookaheadContextual("enum")) {
	            this.expect(75);
	            this.expectContextual(122);
	            return this.tsParseEnumDeclaration(nany, true);
	          }

	        case 74:
	          kind = kind || this.state.value;
	          return this.parseVarStatement(nany, kind);

	        case 109:
	          return this.tsParseAmbientExternalModuleDeclaration(nany);

	        default:
	          {
	            if (tokenIsIdentifier(starttype)) {
	              return this.tsParseDeclaration(nany, this.state.value, true);
	            }
	          }
	      }
	    });
	  }

	  tsTryParseExportDeclaration() {
	    return this.tsParseDeclaration(this.startNode(), this.state.value, true);
	  }

	  tsParseExpressionStatement(node, expr) {
	    switch (expr.name) {
	      case "declare":
	        {
	          const declaration = this.tsTryParseDeclare(node);

	          if (declaration) {
	            declaration.declare = true;
	            return declaration;
	          }

	          break;
	        }

	      case "global":
	        if (this.match(5)) {
	          this.scope.enter(SCOPE_TS_MODULE);
	          this.prodParam.enter(PARAM);
	          const mod = node;
	          mod.global = true;
	          mod.id = expr;
	          mod.body = this.tsParseModuleBlock();
	          this.scope.exit();
	          this.prodParam.exit();
	          return this.finishNode(mod, "TSModuleDeclaration");
	        }

	        break;

	      default:
	        return this.tsParseDeclaration(node, expr.name, false);
	    }
	  }

	  tsParseDeclaration(node, value, next) {
	    switch (value) {
	      case "abstract":
	        if (this.tsCheckLineTerminator(next) && (this.match(80) || tokenIsIdentifier(this.state.type))) {
	          return this.tsParseAbstractDeclaration(node);
	        }

	        break;

	      case "enum":
	        if (next || tokenIsIdentifier(this.state.type)) {
	          if (next) this.next();
	          return this.tsParseEnumDeclaration(node, false);
	        }

	        break;

	      case "interface":
	        if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
	          return this.tsParseInterfaceDeclaration(node);
	        }

	        break;

	      case "module":
	        if (this.tsCheckLineTerminator(next)) {
	          if (this.match(129)) {
	            return this.tsParseAmbientExternalModuleDeclaration(node);
	          } else if (tokenIsIdentifier(this.state.type)) {
	            return this.tsParseModuleOrNamespaceDeclaration(node);
	          }
	        }

	        break;

	      case "namespace":
	        if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
	          return this.tsParseModuleOrNamespaceDeclaration(node);
	        }

	        break;

	      case "type":
	        if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
	          return this.tsParseTypeAliasDeclaration(node);
	        }

	        break;
	    }
	  }

	  tsCheckLineTerminator(next) {
	    if (next) {
	      if (this.hasFollowingLineBreak()) return false;
	      this.next();
	      return true;
	    }

	    return !this.isLineTerminator();
	  }

	  tsTryParseGenericAsyncArrowFunction(startPos, startLoc) {
	    if (!this.match(47)) {
	      return undefined;
	    }

	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    this.state.maybeInArrowParameters = true;
	    const res = this.tsTryParseAndCatch(() => {
	      const node = this.startNodeAt(startPos, startLoc);
	      node.typeParameters = this.tsParseTypeParameters();
	      super.parseFunctionParams(node);
	      node.returnType = this.tsTryParseTypeOrTypePredicateAnnotation();
	      this.expect(19);
	      return node;
	    });
	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;

	    if (!res) {
	      return undefined;
	    }

	    return this.parseArrowExpression(res, null, true);
	  }

	  tsParseTypeArgumentsInExpression() {
	    if (this.reScan_lt() !== 47) {
	      return undefined;
	    }

	    return this.tsParseTypeArguments();
	  }

	  tsParseTypeArguments() {
	    const node = this.startNode();
	    node.params = this.tsInType(() => this.tsInNoContext(() => {
	      this.expect(47);
	      return this.tsParseDelimitedList("TypeParametersOrArguments", this.tsParseType.bind(this));
	    }));

	    if (node.params.length === 0) {
	      this.raise(TSErrors.EmptyTypeArguments, {
	        node
	      });
	    }

	    this.expect(48);
	    return this.finishNode(node, "TSTypeParameterInstantiation");
	  }

	  tsIsDeclarationStart() {
	    return tokenIsTSDeclarationStart(this.state.type);
	  }

	  isExportDefaultSpecifier() {
	    if (this.tsIsDeclarationStart()) return false;
	    return super.isExportDefaultSpecifier();
	  }

	  parseAssignableListItem(allowModifiers, decorators) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    let accessibility;
	    let readonly = false;
	    let override = false;

	    if (allowModifiers !== undefined) {
	      const modified = {};
	      this.tsParseModifiers(modified, ["public", "private", "protected", "override", "readonly"]);
	      accessibility = modified.accessibility;
	      override = modified.override;
	      readonly = modified.readonly;

	      if (allowModifiers === false && (accessibility || readonly || override)) {
	        this.raise(TSErrors.UnexpectedParameterModifier, {
	          at: startLoc
	        });
	      }
	    }

	    const left = this.parseMaybeDefault();
	    this.parseAssignableListItemTypes(left);
	    const elt = this.parseMaybeDefault(left.start, left.loc.start, left);

	    if (accessibility || readonly || override) {
	      const pp = this.startNodeAt(startPos, startLoc);

	      if (decorators.length) {
	        pp.decorators = decorators;
	      }

	      if (accessibility) pp.accessibility = accessibility;
	      if (readonly) pp.readonly = readonly;
	      if (override) pp.override = override;

	      if (elt.type !== "Identifier" && elt.type !== "AssignmentPattern") {
	        this.raise(TSErrors.UnsupportedParameterPropertyKind, {
	          node: pp
	        });
	      }

	      pp.parameter = elt;
	      return this.finishNode(pp, "TSParameterProperty");
	    }

	    if (decorators.length) {
	      left.decorators = decorators;
	    }

	    return elt;
	  }

	  parseFunctionBodyAndFinish(node, type, isMethod = false) {
	    if (this.match(14)) {
	      node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
	    }

	    const bodilessType = type === "FunctionDeclaration" ? "TSDeclareFunction" : type === "ClassMethod" || type === "ClassPrivateMethod" ? "TSDeclareMethod" : undefined;

	    if (bodilessType && !this.match(5) && this.isLineTerminator()) {
	      this.finishNode(node, bodilessType);
	      return;
	    }

	    if (bodilessType === "TSDeclareFunction" && this.state.isAmbientContext) {
	      this.raise(TSErrors.DeclareFunctionHasImplementation, {
	        node
	      });

	      if (node.declare) {
	        super.parseFunctionBodyAndFinish(node, bodilessType, isMethod);
	        return;
	      }
	    }

	    super.parseFunctionBodyAndFinish(node, type, isMethod);
	  }

	  registerFunctionStatementId(node) {
	    if (!node.body && node.id) {
	      this.checkLVal(node.id, "function name", BIND_TS_AMBIENT);
	    } else {
	      super.registerFunctionStatementId(...arguments);
	    }
	  }

	  tsCheckForInvalidTypeCasts(items) {
	    items.forEach(node => {
	      if (node?.type === "TSTypeCastExpression") {
	        this.raise(TSErrors.UnexpectedTypeAnnotation, {
	          node: node.typeAnnotation
	        });
	      }
	    });
	  }

	  toReferencedList(exprList, isInParens) {
	    this.tsCheckForInvalidTypeCasts(exprList);
	    return exprList;
	  }

	  parseArrayLike(...args) {
	    const node = super.parseArrayLike(...args);

	    if (node.type === "ArrayExpression") {
	      this.tsCheckForInvalidTypeCasts(node.elements);
	    }

	    return node;
	  }

	  parseSubscript(base, startPos, startLoc, noCalls, state) {
	    if (!this.hasPrecedingLineBreak() && this.match(35)) {
	      this.state.canStartJSXElement = false;
	      this.next();
	      const nonNullExpression = this.startNodeAt(startPos, startLoc);
	      nonNullExpression.expression = base;
	      return this.finishNode(nonNullExpression, "TSNonNullExpression");
	    }

	    let isOptionalCall = false;

	    if (this.match(18) && this.lookaheadCharCode() === 60) {
	      if (noCalls) {
	        state.stop = true;
	        return base;
	      }

	      state.optionalChainMember = isOptionalCall = true;
	      this.next();
	    }

	    if (this.match(47) || this.match(51)) {
	      let missingParenErrorLoc;
	      const result = this.tsTryParseAndCatch(() => {
	        if (!noCalls && this.atPossibleAsyncArrow(base)) {
	          const asyncArrowFn = this.tsTryParseGenericAsyncArrowFunction(startPos, startLoc);

	          if (asyncArrowFn) {
	            return asyncArrowFn;
	          }
	        }

	        const node = this.startNodeAt(startPos, startLoc);
	        node.callee = base;
	        const typeArguments = this.tsParseTypeArgumentsInExpression();

	        if (typeArguments) {
	          if (isOptionalCall && !this.match(10)) {
	            missingParenErrorLoc = this.state.curPosition();
	            this.unexpected();
	          }

	          if (!noCalls && this.eat(10)) {
	            node.arguments = this.parseCallExpressionArguments(11, false);
	            this.tsCheckForInvalidTypeCasts(node.arguments);
	            node.typeParameters = typeArguments;

	            if (state.optionalChainMember) {
	              node.optional = isOptionalCall;
	            }

	            return this.finishCallExpression(node, state.optionalChainMember);
	          } else if (tokenIsTemplate(this.state.type)) {
	            const result = this.parseTaggedTemplateExpression(base, startPos, startLoc, state);
	            result.typeParameters = typeArguments;
	            return result;
	          }
	        }

	        this.unexpected();
	      });

	      if (missingParenErrorLoc) {
	        this.unexpected(missingParenErrorLoc, 10);
	      }

	      if (result) return result;
	    }

	    return super.parseSubscript(base, startPos, startLoc, noCalls, state);
	  }

	  parseNewArguments(node) {
	    if (this.match(47) || this.match(51)) {
	      const typeParameters = this.tsTryParseAndCatch(() => {
	        const args = this.tsParseTypeArgumentsInExpression();
	        if (!this.match(10)) this.unexpected();
	        return args;
	      });

	      if (typeParameters) {
	        node.typeParameters = typeParameters;
	      }
	    }

	    super.parseNewArguments(node);
	  }

	  parseExprOp(left, leftStartPos, leftStartLoc, minPrec) {
	    if (tokenOperatorPrecedence(58) > minPrec && !this.hasPrecedingLineBreak() && this.isContextual(93)) {
	      const node = this.startNodeAt(leftStartPos, leftStartLoc);
	      node.expression = left;

	      const _const = this.tsTryNextParseConstantContext();

	      if (_const) {
	        node.typeAnnotation = _const;
	      } else {
	        node.typeAnnotation = this.tsNextThenParseType();
	      }

	      this.finishNode(node, "TSAsExpression");
	      this.reScan_lt_gt();
	      return this.parseExprOp(node, leftStartPos, leftStartLoc, minPrec);
	    }

	    return super.parseExprOp(left, leftStartPos, leftStartLoc, minPrec);
	  }

	  checkReservedWord(word, startLoc, checkKeywords, isBinding) {}

	  checkDuplicateExports() {}

	  parseImport(node) {
	    node.importKind = "value";

	    if (tokenIsIdentifier(this.state.type) || this.match(55) || this.match(5)) {
	      let ahead = this.lookahead();

	      if (this.isContextual(126) && ahead.type !== 12 && ahead.type !== 97 && ahead.type !== 29) {
	        node.importKind = "type";
	        this.next();
	        ahead = this.lookahead();
	      }

	      if (tokenIsIdentifier(this.state.type) && ahead.type === 29) {
	        return this.tsParseImportEqualsDeclaration(node);
	      }
	    }

	    const importNode = super.parseImport(node);

	    if (importNode.importKind === "type" && importNode.specifiers.length > 1 && importNode.specifiers[0].type === "ImportDefaultSpecifier") {
	      this.raise(TSErrors.TypeImportCannotSpecifyDefaultAndNamed, {
	        node: importNode
	      });
	    }

	    return importNode;
	  }

	  parseExport(node) {
	    if (this.match(83)) {
	      this.next();

	      if (this.isContextual(126) && this.lookaheadCharCode() !== 61) {
	        node.importKind = "type";
	        this.next();
	      } else {
	        node.importKind = "value";
	      }

	      return this.tsParseImportEqualsDeclaration(node, true);
	    } else if (this.eat(29)) {
	      const assign = node;
	      assign.expression = this.parseExpression();
	      this.semicolon();
	      return this.finishNode(assign, "TSExportAssignment");
	    } else if (this.eatContextual(93)) {
	      const decl = node;
	      this.expectContextual(124);
	      decl.id = this.parseIdentifier();
	      this.semicolon();
	      return this.finishNode(decl, "TSNamespaceExportDeclaration");
	    } else {
	      if (this.isContextual(126) && this.lookahead().type === 5) {
	        this.next();
	        node.exportKind = "type";
	      } else {
	        node.exportKind = "value";
	      }

	      return super.parseExport(node);
	    }
	  }

	  isAbstractClass() {
	    return this.isContextual(120) && this.lookahead().type === 80;
	  }

	  parseExportDefaultExpression() {
	    if (this.isAbstractClass()) {
	      const cls = this.startNode();
	      this.next();
	      cls.abstract = true;
	      this.parseClass(cls, true, true);
	      return cls;
	    }

	    if (this.match(125)) {
	      const interfaceNode = this.startNode();
	      this.next();
	      const result = this.tsParseInterfaceDeclaration(interfaceNode);
	      if (result) return result;
	    }

	    return super.parseExportDefaultExpression();
	  }

	  parseStatementContent(context, topLevel) {
	    if (this.state.type === 75) {
	      const ahead = this.lookahead();

	      if (ahead.type === 122) {
	        const node = this.startNode();
	        this.next();
	        this.expectContextual(122);
	        return this.tsParseEnumDeclaration(node, true);
	      }
	    }

	    return super.parseStatementContent(context, topLevel);
	  }

	  parseAccessModifier() {
	    return this.tsParseModifier(["public", "protected", "private"]);
	  }

	  tsHasSomeModifiers(member, modifiers) {
	    return modifiers.some(modifier => {
	      if (tsIsAccessModifier(modifier)) {
	        return member.accessibility === modifier;
	      }

	      return !!member[modifier];
	    });
	  }

	  tsIsStartOfStaticBlocks() {
	    return this.isContextual(104) && this.lookaheadCharCode() === 123;
	  }

	  parseClassMember(classBody, member, state) {
	    const modifiers = ["declare", "private", "public", "protected", "override", "abstract", "readonly", "static"];
	    this.tsParseModifiers(member, modifiers, undefined, undefined, true);

	    const callParseClassMemberWithIsStatic = () => {
	      if (this.tsIsStartOfStaticBlocks()) {
	        this.next();
	        this.next();

	        if (this.tsHasSomeModifiers(member, modifiers)) {
	          this.raise(TSErrors.StaticBlockCannotHaveModifier, {
	            at: this.state.curPosition()
	          });
	        }

	        this.parseClassStaticBlock(classBody, member);
	      } else {
	        this.parseClassMemberWithIsStatic(classBody, member, state, !!member.static);
	      }
	    };

	    if (member.declare) {
	      this.tsInAmbientContext(callParseClassMemberWithIsStatic);
	    } else {
	      callParseClassMemberWithIsStatic();
	    }
	  }

	  parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
	    const idx = this.tsTryParseIndexSignature(member);

	    if (idx) {
	      classBody.body.push(idx);

	      if (member.abstract) {
	        this.raise(TSErrors.IndexSignatureHasAbstract, {
	          node: member
	        });
	      }

	      if (member.accessibility) {
	        this.raise(TSErrors.IndexSignatureHasAccessibility, {
	          node: member
	        }, member.accessibility);
	      }

	      if (member.declare) {
	        this.raise(TSErrors.IndexSignatureHasDeclare, {
	          node: member
	        });
	      }

	      if (member.override) {
	        this.raise(TSErrors.IndexSignatureHasOverride, {
	          node: member
	        });
	      }

	      return;
	    }

	    if (!this.state.inAbstractClass && member.abstract) {
	      this.raise(TSErrors.NonAbstractClassHasAbstractMethod, {
	        node: member
	      });
	    }

	    if (member.override) {
	      if (!state.hadSuperClass) {
	        this.raise(TSErrors.OverrideNotInSubClass, {
	          node: member
	        });
	      }
	    }

	    super.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
	  }

	  parsePostMemberNameModifiers(methodOrProp) {
	    const optional = this.eat(17);
	    if (optional) methodOrProp.optional = true;

	    if (methodOrProp.readonly && this.match(10)) {
	      this.raise(TSErrors.ClassMethodHasReadonly, {
	        node: methodOrProp
	      });
	    }

	    if (methodOrProp.declare && this.match(10)) {
	      this.raise(TSErrors.ClassMethodHasDeclare, {
	        node: methodOrProp
	      });
	    }
	  }

	  parseExpressionStatement(node, expr) {
	    const decl = expr.type === "Identifier" ? this.tsParseExpressionStatement(node, expr) : undefined;
	    return decl || super.parseExpressionStatement(node, expr);
	  }

	  shouldParseExportDeclaration() {
	    if (this.tsIsDeclarationStart()) return true;
	    return super.shouldParseExportDeclaration();
	  }

	  parseConditional(expr, startPos, startLoc, refExpressionErrors) {
	    if (!this.state.maybeInArrowParameters || !this.match(17)) {
	      return super.parseConditional(expr, startPos, startLoc, refExpressionErrors);
	    }

	    const result = this.tryParse(() => super.parseConditional(expr, startPos, startLoc));

	    if (!result.node) {
	      if (result.error) {
	        super.setOptionalParametersError(refExpressionErrors, result.error);
	      }

	      return expr;
	    }

	    if (result.error) this.state = result.failState;
	    return result.node;
	  }

	  parseParenItem(node, startPos, startLoc) {
	    node = super.parseParenItem(node, startPos, startLoc);

	    if (this.eat(17)) {
	      node.optional = true;
	      this.resetEndLocation(node);
	    }

	    if (this.match(14)) {
	      const typeCastNode = this.startNodeAt(startPos, startLoc);
	      typeCastNode.expression = node;
	      typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
	      return this.finishNode(typeCastNode, "TSTypeCastExpression");
	    }

	    return node;
	  }

	  parseExportDeclaration(node) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    const isDeclare = this.eatContextual(121);

	    if (isDeclare && (this.isContextual(121) || !this.shouldParseExportDeclaration())) {
	      throw this.raise(TSErrors.ExpectedAmbientAfterExportDeclare, {
	        at: this.state.startLoc
	      });
	    }

	    let declaration;

	    if (tokenIsIdentifier(this.state.type)) {
	      declaration = this.tsTryParseExportDeclaration();
	    }

	    if (!declaration) {
	      declaration = super.parseExportDeclaration(node);
	    }

	    if (declaration && (declaration.type === "TSInterfaceDeclaration" || declaration.type === "TSTypeAliasDeclaration" || isDeclare)) {
	      node.exportKind = "type";
	    }

	    if (declaration && isDeclare) {
	      this.resetStartLocation(declaration, startPos, startLoc);
	      declaration.declare = true;
	    }

	    return declaration;
	  }

	  parseClassId(node, isStatement, optionalId) {
	    if ((!isStatement || optionalId) && this.isContextual(110)) {
	      return;
	    }

	    super.parseClassId(node, isStatement, optionalId, node.declare ? BIND_TS_AMBIENT : BIND_CLASS);
	    const typeParameters = this.tsTryParseTypeParameters();
	    if (typeParameters) node.typeParameters = typeParameters;
	  }

	  parseClassPropertyAnnotation(node) {
	    if (!node.optional && this.eat(35)) {
	      node.definite = true;
	    }

	    const type = this.tsTryParseTypeAnnotation();
	    if (type) node.typeAnnotation = type;
	  }

	  parseClassProperty(node) {
	    this.parseClassPropertyAnnotation(node);

	    if (this.state.isAmbientContext && this.match(29)) {
	      this.raise(TSErrors.DeclareClassFieldHasInitializer, {
	        at: this.state.startLoc
	      });
	    }

	    if (node.abstract && this.match(29)) {
	      const {
	        key
	      } = node;
	      this.raise(TSErrors.AbstractPropertyHasInitializer, {
	        at: this.state.startLoc
	      }, key.type === "Identifier" && !node.computed ? key.name : `[${this.input.slice(key.start, key.end)}]`);
	    }

	    return super.parseClassProperty(node);
	  }

	  parseClassPrivateProperty(node) {
	    if (node.abstract) {
	      this.raise(TSErrors.PrivateElementHasAbstract, {
	        node
	      });
	    }

	    if (node.accessibility) {
	      this.raise(TSErrors.PrivateElementHasAccessibility, {
	        node
	      }, node.accessibility);
	    }

	    this.parseClassPropertyAnnotation(node);
	    return super.parseClassPrivateProperty(node);
	  }

	  pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
	    const typeParameters = this.tsTryParseTypeParameters();

	    if (typeParameters && isConstructor) {
	      this.raise(TSErrors.ConstructorHasTypeParameters, {
	        node: typeParameters
	      });
	    }

	    if (method.declare && (method.kind === "get" || method.kind === "set")) {
	      this.raise(TSErrors.DeclareAccessor, {
	        node: method
	      }, method.kind);
	    }

	    if (typeParameters) method.typeParameters = typeParameters;
	    super.pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
	  }

	  pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
	    const typeParameters = this.tsTryParseTypeParameters();
	    if (typeParameters) method.typeParameters = typeParameters;
	    super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
	  }

	  declareClassPrivateMethodInScope(node, kind) {
	    if (node.type === "TSDeclareMethod") return;
	    if (node.type === "MethodDefinition" && !node.value.body) return;
	    super.declareClassPrivateMethodInScope(node, kind);
	  }

	  parseClassSuper(node) {
	    super.parseClassSuper(node);

	    if (node.superClass && (this.match(47) || this.match(51))) {
	      node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
	    }

	    if (this.eatContextual(110)) {
	      node.implements = this.tsParseHeritageClause("implements");
	    }
	  }

	  parseObjPropValue(prop, ...args) {
	    const typeParameters = this.tsTryParseTypeParameters();
	    if (typeParameters) prop.typeParameters = typeParameters;
	    super.parseObjPropValue(prop, ...args);
	  }

	  parseFunctionParams(node, allowModifiers) {
	    const typeParameters = this.tsTryParseTypeParameters();
	    if (typeParameters) node.typeParameters = typeParameters;
	    super.parseFunctionParams(node, allowModifiers);
	  }

	  parseVarId(decl, kind) {
	    super.parseVarId(decl, kind);

	    if (decl.id.type === "Identifier" && !this.hasPrecedingLineBreak() && this.eat(35)) {
	      decl.definite = true;
	    }

	    const type = this.tsTryParseTypeAnnotation();

	    if (type) {
	      decl.id.typeAnnotation = type;
	      this.resetEndLocation(decl.id);
	    }
	  }

	  parseAsyncArrowFromCallExpression(node, call) {
	    if (this.match(14)) {
	      node.returnType = this.tsParseTypeAnnotation();
	    }

	    return super.parseAsyncArrowFromCallExpression(node, call);
	  }

	  parseMaybeAssign(...args) {
	    let state;
	    let jsx;
	    let typeCast;

	    if (this.hasPlugin("jsx") && (this.match(138) || this.match(47))) {
	      state = this.state.clone();
	      jsx = this.tryParse(() => super.parseMaybeAssign(...args), state);
	      if (!jsx.error) return jsx.node;
	      const {
	        context
	      } = this.state;
	      const currentContext = context[context.length - 1];

	      if (currentContext === types.j_oTag || currentContext === types.j_expr) {
	        context.pop();
	      }
	    }

	    if (!jsx?.error && !this.match(47)) {
	      return super.parseMaybeAssign(...args);
	    }

	    let typeParameters;
	    state = state || this.state.clone();
	    const arrow = this.tryParse(abort => {
	      typeParameters = this.tsParseTypeParameters();
	      const expr = super.parseMaybeAssign(...args);

	      if (expr.type !== "ArrowFunctionExpression" || expr.extra?.parenthesized) {
	        abort();
	      }

	      if (typeParameters?.params.length !== 0) {
	        this.resetStartLocationFromNode(expr, typeParameters);
	      }

	      expr.typeParameters = typeParameters;
	      return expr;
	    }, state);

	    if (!arrow.error && !arrow.aborted) {
	      if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
	      return arrow.node;
	    }

	    if (!jsx) {
	      assert(!this.hasPlugin("jsx"));
	      typeCast = this.tryParse(() => super.parseMaybeAssign(...args), state);
	      if (!typeCast.error) return typeCast.node;
	    }

	    if (jsx?.node) {
	      this.state = jsx.failState;
	      return jsx.node;
	    }

	    if (arrow.node) {
	      this.state = arrow.failState;
	      if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
	      return arrow.node;
	    }

	    if (typeCast?.node) {
	      this.state = typeCast.failState;
	      return typeCast.node;
	    }

	    if (jsx?.thrown) throw jsx.error;
	    if (arrow.thrown) throw arrow.error;
	    if (typeCast?.thrown) throw typeCast.error;
	    throw jsx?.error || arrow.error || typeCast?.error;
	  }

	  reportReservedArrowTypeParam(node) {
	    if (node.params.length === 1 && !node.extra?.trailingComma && this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
	      this.raise(TSErrors.ReservedArrowTypeParam, {
	        node
	      });
	    }
	  }

	  parseMaybeUnary(refExpressionErrors) {
	    if (!this.hasPlugin("jsx") && this.match(47)) {
	      return this.tsParseTypeAssertion();
	    } else {
	      return super.parseMaybeUnary(refExpressionErrors);
	    }
	  }

	  parseArrow(node) {
	    if (this.match(14)) {
	      const result = this.tryParse(abort => {
	        const returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
	        if (this.canInsertSemicolon() || !this.match(19)) abort();
	        return returnType;
	      });
	      if (result.aborted) return;

	      if (!result.thrown) {
	        if (result.error) this.state = result.failState;
	        node.returnType = result.node;
	      }
	    }

	    return super.parseArrow(node);
	  }

	  parseAssignableListItemTypes(param) {
	    if (this.eat(17)) {
	      if (param.type !== "Identifier" && !this.state.isAmbientContext && !this.state.inType) {
	        this.raise(TSErrors.PatternIsOptional, {
	          node: param
	        });
	      }

	      param.optional = true;
	    }

	    const type = this.tsTryParseTypeAnnotation();
	    if (type) param.typeAnnotation = type;
	    this.resetEndLocation(param);
	    return param;
	  }

	  isAssignable(node, isBinding) {
	    switch (node.type) {
	      case "TSTypeCastExpression":
	        return this.isAssignable(node.expression, isBinding);

	      case "TSParameterProperty":
	        return true;

	      default:
	        return super.isAssignable(node, isBinding);
	    }
	  }

	  toAssignable(node, isLHS = false) {
	    switch (node.type) {
	      case "TSTypeCastExpression":
	        return super.toAssignable(this.typeCastToParameter(node), isLHS);

	      case "TSParameterProperty":
	        return super.toAssignable(node, isLHS);

	      case "ParenthesizedExpression":
	        return this.toAssignableParenthesizedExpression(node, isLHS);

	      case "TSAsExpression":
	      case "TSNonNullExpression":
	      case "TSTypeAssertion":
	        node.expression = this.toAssignable(node.expression, isLHS);
	        return node;

	      default:
	        return super.toAssignable(node, isLHS);
	    }
	  }

	  toAssignableParenthesizedExpression(node, isLHS) {
	    switch (node.expression.type) {
	      case "TSAsExpression":
	      case "TSNonNullExpression":
	      case "TSTypeAssertion":
	      case "ParenthesizedExpression":
	        node.expression = this.toAssignable(node.expression, isLHS);
	        return node;

	      default:
	        return super.toAssignable(node, isLHS);
	    }
	  }

	  checkLVal(expr, contextDescription, ...args) {
	    switch (expr.type) {
	      case "TSTypeCastExpression":
	        return;

	      case "TSParameterProperty":
	        this.checkLVal(expr.parameter, "parameter property", ...args);
	        return;

	      case "TSAsExpression":
	      case "TSTypeAssertion":
	        if (!args[0] && contextDescription !== "parenthesized expression" && !expr.extra?.parenthesized) {
	          this.raise(ErrorMessages.InvalidLhs, {
	            node: expr
	          }, contextDescription);
	          break;
	        }

	        this.checkLVal(expr.expression, "parenthesized expression", ...args);
	        return;

	      case "TSNonNullExpression":
	        this.checkLVal(expr.expression, contextDescription, ...args);
	        return;

	      default:
	        super.checkLVal(expr, contextDescription, ...args);
	        return;
	    }
	  }

	  parseBindingAtom() {
	    switch (this.state.type) {
	      case 78:
	        return this.parseIdentifier(true);

	      default:
	        return super.parseBindingAtom();
	    }
	  }

	  parseMaybeDecoratorArguments(expr) {
	    if (this.match(47) || this.match(51)) {
	      const typeArguments = this.tsParseTypeArgumentsInExpression();

	      if (this.match(10)) {
	        const call = super.parseMaybeDecoratorArguments(expr);
	        call.typeParameters = typeArguments;
	        return call;
	      }

	      this.unexpected(null, 10);
	    }

	    return super.parseMaybeDecoratorArguments(expr);
	  }

	  checkCommaAfterRest(close) {
	    if (this.state.isAmbientContext && this.match(12) && this.lookaheadCharCode() === close) {
	      this.next();
	      return false;
	    } else {
	      return super.checkCommaAfterRest(close);
	    }
	  }

	  isClassMethod() {
	    return this.match(47) || super.isClassMethod();
	  }

	  isClassProperty() {
	    return this.match(35) || this.match(14) || super.isClassProperty();
	  }

	  parseMaybeDefault(...args) {
	    const node = super.parseMaybeDefault(...args);

	    if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
	      this.raise(TSErrors.TypeAnnotationAfterAssign, {
	        node: node.typeAnnotation
	      });
	    }

	    return node;
	  }

	  getTokenFromCode(code) {
	    if (this.state.inType) {
	      if (code === 62) {
	        return this.finishOp(48, 1);
	      }

	      if (code === 60) {
	        return this.finishOp(47, 1);
	      }
	    }

	    return super.getTokenFromCode(code);
	  }

	  reScan_lt_gt() {
	    const {
	      type
	    } = this.state;

	    if (type === 47) {
	      this.state.pos -= 1;
	      this.readToken_lt();
	    } else if (type === 48) {
	      this.state.pos -= 1;
	      this.readToken_gt();
	    }
	  }

	  reScan_lt() {
	    const {
	      type
	    } = this.state;

	    if (type === 51) {
	      this.state.pos -= 2;
	      this.finishOp(47, 1);
	      return 47;
	    }

	    return type;
	  }

	  toAssignableList(exprList) {
	    for (let i = 0; i < exprList.length; i++) {
	      const expr = exprList[i];
	      if (!expr) continue;

	      switch (expr.type) {
	        case "TSTypeCastExpression":
	          exprList[i] = this.typeCastToParameter(expr);
	          break;

	        case "TSAsExpression":
	        case "TSTypeAssertion":
	          if (!this.state.maybeInArrowParameters) {
	            exprList[i] = this.typeCastToParameter(expr);
	          } else {
	            this.raise(TSErrors.UnexpectedTypeCastInParameter, {
	              node: expr
	            });
	          }

	          break;
	      }
	    }

	    return super.toAssignableList(...arguments);
	  }

	  typeCastToParameter(node) {
	    node.expression.typeAnnotation = node.typeAnnotation;
	    this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
	    return node.expression;
	  }

	  shouldParseArrow(params) {
	    if (this.match(14)) {
	      return params.every(expr => this.isAssignable(expr, true));
	    }

	    return super.shouldParseArrow(params);
	  }

	  shouldParseAsyncArrow() {
	    return this.match(14) || super.shouldParseAsyncArrow();
	  }

	  canHaveLeadingDecorator() {
	    return super.canHaveLeadingDecorator() || this.isAbstractClass();
	  }

	  jsxParseOpeningElementAfterName(node) {
	    if (this.match(47) || this.match(51)) {
	      const typeArguments = this.tsTryParseAndCatch(() => this.tsParseTypeArgumentsInExpression());
	      if (typeArguments) node.typeParameters = typeArguments;
	    }

	    return super.jsxParseOpeningElementAfterName(node);
	  }

	  getGetterSetterExpectedParamCount(method) {
	    const baseCount = super.getGetterSetterExpectedParamCount(method);
	    const params = this.getObjectOrClassMethodParams(method);
	    const firstParam = params[0];
	    const hasContextParam = firstParam && this.isThisParam(firstParam);
	    return hasContextParam ? baseCount + 1 : baseCount;
	  }

	  parseCatchClauseParam() {
	    const param = super.parseCatchClauseParam();
	    const type = this.tsTryParseTypeAnnotation();

	    if (type) {
	      param.typeAnnotation = type;
	      this.resetEndLocation(param);
	    }

	    return param;
	  }

	  tsInAmbientContext(cb) {
	    const oldIsAmbientContext = this.state.isAmbientContext;
	    this.state.isAmbientContext = true;

	    try {
	      return cb();
	    } finally {
	      this.state.isAmbientContext = oldIsAmbientContext;
	    }
	  }

	  parseClass(node, ...args) {
	    const oldInAbstractClass = this.state.inAbstractClass;
	    this.state.inAbstractClass = !!node.abstract;

	    try {
	      return super.parseClass(node, ...args);
	    } finally {
	      this.state.inAbstractClass = oldInAbstractClass;
	    }
	  }

	  tsParseAbstractDeclaration(node) {
	    if (this.match(80)) {
	      node.abstract = true;
	      return this.parseClass(node, true, false);
	    } else if (this.isContextual(125)) {
	      if (!this.hasFollowingLineBreak()) {
	        node.abstract = true;
	        this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, {
	          node
	        });
	        this.next();
	        return this.tsParseInterfaceDeclaration(node);
	      }
	    } else {
	      this.unexpected(null, 80);
	    }
	  }

	  parseMethod(...args) {
	    const method = super.parseMethod(...args);

	    if (method.abstract) {
	      const hasBody = this.hasPlugin("estree") ? !!method.value.body : !!method.body;

	      if (hasBody) {
	        const {
	          key
	        } = method;
	        this.raise(TSErrors.AbstractMethodHasImplementation, {
	          node: method
	        }, key.type === "Identifier" && !method.computed ? key.name : `[${this.input.slice(key.start, key.end)}]`);
	      }
	    }

	    return method;
	  }

	  tsParseTypeParameterName() {
	    const typeName = this.parseIdentifier();
	    return browser$5.env.BABEL_8_BREAKING ? typeName : typeName.name;
	  }

	  shouldParseAsAmbientContext() {
	    return !!this.getPluginOption("typescript", "dts");
	  }

	  parse() {
	    if (this.shouldParseAsAmbientContext()) {
	      this.state.isAmbientContext = true;
	    }

	    return super.parse();
	  }

	  getExpression() {
	    if (this.shouldParseAsAmbientContext()) {
	      this.state.isAmbientContext = true;
	    }

	    return super.getExpression();
	  }

	  parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
	    if (!isString && isMaybeTypeOnly) {
	      this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
	      return this.finishNode(node, "ExportSpecifier");
	    }

	    node.exportKind = "value";
	    return super.parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly);
	  }

	  parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly) {
	    if (!importedIsString && isMaybeTypeOnly) {
	      this.parseTypeOnlyImportExportSpecifier(specifier, true, isInTypeOnlyImport);
	      return this.finishNode(specifier, "ImportSpecifier");
	    }

	    specifier.importKind = "value";
	    return super.parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly);
	  }

	  parseTypeOnlyImportExportSpecifier(node, isImport, isInTypeOnlyImportExport) {
	    const leftOfAsKey = isImport ? "imported" : "local";
	    const rightOfAsKey = isImport ? "local" : "exported";
	    let leftOfAs = node[leftOfAsKey];
	    let rightOfAs;
	    let hasTypeSpecifier = false;
	    let canParseAsKeyword = true;
	    const loc = leftOfAs.loc.start;

	    if (this.isContextual(93)) {
	      const firstAs = this.parseIdentifier();

	      if (this.isContextual(93)) {
	        const secondAs = this.parseIdentifier();

	        if (tokenIsKeywordOrIdentifier(this.state.type)) {
	          hasTypeSpecifier = true;
	          leftOfAs = firstAs;
	          rightOfAs = this.parseIdentifier();
	          canParseAsKeyword = false;
	        } else {
	          rightOfAs = secondAs;
	          canParseAsKeyword = false;
	        }
	      } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
	        canParseAsKeyword = false;
	        rightOfAs = this.parseIdentifier();
	      } else {
	        hasTypeSpecifier = true;
	        leftOfAs = firstAs;
	      }
	    } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
	      hasTypeSpecifier = true;
	      leftOfAs = this.parseIdentifier();
	    }

	    if (hasTypeSpecifier && isInTypeOnlyImportExport) {
	      this.raise(isImport ? TSErrors.TypeModifierIsUsedInTypeImports : TSErrors.TypeModifierIsUsedInTypeExports, {
	        at: loc
	      });
	    }

	    node[leftOfAsKey] = leftOfAs;
	    node[rightOfAsKey] = rightOfAs;
	    const kindKey = isImport ? "importKind" : "exportKind";
	    node[kindKey] = hasTypeSpecifier ? "type" : "value";

	    if (canParseAsKeyword && this.eatContextual(93)) {
	      node[rightOfAsKey] = isImport ? this.parseIdentifier() : this.parseModuleExportName();
	    }

	    if (!node[rightOfAsKey]) {
	      node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
	    }

	    if (isImport) {
	      this.checkLVal(node[rightOfAsKey], "import specifier", BIND_LEXICAL);
	    }
	  }

	});

	const PlaceholderErrors = makeErrorTemplates({
	  ClassNameIsRequired: "A class name is required."
	}, ErrorCodes.SyntaxError, "placeholders");
	var placeholders = (superClass => class extends superClass {
	  parsePlaceholder(expectedNode) {
	    if (this.match(140)) {
	      const node = this.startNode();
	      this.next();
	      this.assertNoSpace("Unexpected space in placeholder.");
	      node.name = super.parseIdentifier(true);
	      this.assertNoSpace("Unexpected space in placeholder.");
	      this.expect(140);
	      return this.finishPlaceholder(node, expectedNode);
	    }
	  }

	  finishPlaceholder(node, expectedNode) {
	    const isFinished = !!(node.expectedNode && node.type === "Placeholder");
	    node.expectedNode = expectedNode;
	    return isFinished ? node : this.finishNode(node, "Placeholder");
	  }

	  getTokenFromCode(code) {
	    if (code === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
	      return this.finishOp(140, 2);
	    }

	    return super.getTokenFromCode(...arguments);
	  }

	  parseExprAtom() {
	    return this.parsePlaceholder("Expression") || super.parseExprAtom(...arguments);
	  }

	  parseIdentifier() {
	    return this.parsePlaceholder("Identifier") || super.parseIdentifier(...arguments);
	  }

	  checkReservedWord(word) {
	    if (word !== undefined) super.checkReservedWord(...arguments);
	  }

	  parseBindingAtom() {
	    return this.parsePlaceholder("Pattern") || super.parseBindingAtom(...arguments);
	  }

	  checkLVal(expr) {
	    if (expr.type !== "Placeholder") super.checkLVal(...arguments);
	  }

	  toAssignable(node) {
	    if (node && node.type === "Placeholder" && node.expectedNode === "Expression") {
	      node.expectedNode = "Pattern";
	      return node;
	    }

	    return super.toAssignable(...arguments);
	  }

	  isLet(context) {
	    if (super.isLet(context)) {
	      return true;
	    }

	    if (!this.isContextual(99)) {
	      return false;
	    }

	    if (context) return false;
	    const nextToken = this.lookahead();

	    if (nextToken.type === 140) {
	      return true;
	    }

	    return false;
	  }

	  verifyBreakContinue(node) {
	    if (node.label && node.label.type === "Placeholder") return;
	    super.verifyBreakContinue(...arguments);
	  }

	  parseExpressionStatement(node, expr) {
	    if (expr.type !== "Placeholder" || expr.extra && expr.extra.parenthesized) {
	      return super.parseExpressionStatement(...arguments);
	    }

	    if (this.match(14)) {
	      const stmt = node;
	      stmt.label = this.finishPlaceholder(expr, "Identifier");
	      this.next();
	      stmt.body = this.parseStatement("label");
	      return this.finishNode(stmt, "LabeledStatement");
	    }

	    this.semicolon();
	    node.name = expr.name;
	    return this.finishPlaceholder(node, "Statement");
	  }

	  parseBlock() {
	    return this.parsePlaceholder("BlockStatement") || super.parseBlock(...arguments);
	  }

	  parseFunctionId() {
	    return this.parsePlaceholder("Identifier") || super.parseFunctionId(...arguments);
	  }

	  parseClass(node, isStatement, optionalId) {
	    const type = isStatement ? "ClassDeclaration" : "ClassExpression";
	    this.next();
	    this.takeDecorators(node);
	    const oldStrict = this.state.strict;
	    const placeholder = this.parsePlaceholder("Identifier");

	    if (placeholder) {
	      if (this.match(81) || this.match(140) || this.match(5)) {
	        node.id = placeholder;
	      } else if (optionalId || !isStatement) {
	        node.id = null;
	        node.body = this.finishPlaceholder(placeholder, "ClassBody");
	        return this.finishNode(node, type);
	      } else {
	        throw this.raise(PlaceholderErrors.ClassNameIsRequired, {
	          at: this.state.startLoc
	        });
	      }
	    } else {
	      this.parseClassId(node, isStatement, optionalId);
	    }

	    this.parseClassSuper(node);
	    node.body = this.parsePlaceholder("ClassBody") || this.parseClassBody(!!node.superClass, oldStrict);
	    return this.finishNode(node, type);
	  }

	  parseExport(node) {
	    const placeholder = this.parsePlaceholder("Identifier");
	    if (!placeholder) return super.parseExport(...arguments);

	    if (!this.isContextual(97) && !this.match(12)) {
	      node.specifiers = [];
	      node.source = null;
	      node.declaration = this.finishPlaceholder(placeholder, "Declaration");
	      return this.finishNode(node, "ExportNamedDeclaration");
	    }

	    this.expectPlugin("exportDefaultFrom");
	    const specifier = this.startNode();
	    specifier.exported = placeholder;
	    node.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
	    return super.parseExport(node);
	  }

	  isExportDefaultSpecifier() {
	    if (this.match(65)) {
	      const next = this.nextTokenStart();

	      if (this.isUnparsedContextual(next, "from")) {
	        if (this.input.startsWith(tokenLabelName(140), this.nextTokenStartSince(next + 4))) {
	          return true;
	        }
	      }
	    }

	    return super.isExportDefaultSpecifier();
	  }

	  maybeParseExportDefaultSpecifier(node) {
	    if (node.specifiers && node.specifiers.length > 0) {
	      return true;
	    }

	    return super.maybeParseExportDefaultSpecifier(...arguments);
	  }

	  checkExport(node) {
	    const {
	      specifiers
	    } = node;

	    if (specifiers?.length) {
	      node.specifiers = specifiers.filter(node => node.exported.type === "Placeholder");
	    }

	    super.checkExport(node);
	    node.specifiers = specifiers;
	  }

	  parseImport(node) {
	    const placeholder = this.parsePlaceholder("Identifier");
	    if (!placeholder) return super.parseImport(...arguments);
	    node.specifiers = [];

	    if (!this.isContextual(97) && !this.match(12)) {
	      node.source = this.finishPlaceholder(placeholder, "StringLiteral");
	      this.semicolon();
	      return this.finishNode(node, "ImportDeclaration");
	    }

	    const specifier = this.startNodeAtNode(placeholder);
	    specifier.local = placeholder;
	    this.finishNode(specifier, "ImportDefaultSpecifier");
	    node.specifiers.push(specifier);

	    if (this.eat(12)) {
	      const hasStarImport = this.maybeParseStarImportSpecifier(node);
	      if (!hasStarImport) this.parseNamedImportSpecifiers(node);
	    }

	    this.expectContextual(97);
	    node.source = this.parseImportSource();
	    this.semicolon();
	    return this.finishNode(node, "ImportDeclaration");
	  }

	  parseImportSource() {
	    return this.parsePlaceholder("StringLiteral") || super.parseImportSource(...arguments);
	  }

	});

	var v8intrinsic = (superClass => class extends superClass {
	  parseV8Intrinsic() {
	    if (this.match(54)) {
	      const v8IntrinsicStartLoc = this.state.startLoc;
	      const node = this.startNode();
	      this.next();

	      if (tokenIsIdentifier(this.state.type)) {
	        const name = this.parseIdentifierName(this.state.start);
	        const identifier = this.createIdentifier(node, name);
	        identifier.type = "V8IntrinsicIdentifier";

	        if (this.match(10)) {
	          return identifier;
	        }
	      }

	      this.unexpected(v8IntrinsicStartLoc);
	    }
	  }

	  parseExprAtom() {
	    return this.parseV8Intrinsic() || super.parseExprAtom(...arguments);
	  }

	});

	function hasPlugin(plugins, expectedConfig) {
	  const [expectedName, expectedOptions] = typeof expectedConfig === "string" ? [expectedConfig, {}] : expectedConfig;
	  const expectedKeys = Object.keys(expectedOptions);
	  const expectedOptionsIsEmpty = expectedKeys.length === 0;
	  return plugins.some(p => {
	    if (typeof p === "string") {
	      return expectedOptionsIsEmpty && p === expectedName;
	    } else {
	      const [pluginName, pluginOptions] = p;

	      if (pluginName !== expectedName) {
	        return false;
	      }

	      for (const key of expectedKeys) {
	        if (pluginOptions[key] !== expectedOptions[key]) {
	          return false;
	        }
	      }

	      return true;
	    }
	  });
	}
	function getPluginOption(plugins, name, option) {
	  const plugin = plugins.find(plugin => {
	    if (Array.isArray(plugin)) {
	      return plugin[0] === name;
	    } else {
	      return plugin === name;
	    }
	  });

	  if (plugin && Array.isArray(plugin)) {
	    return plugin[1][option];
	  }

	  return null;
	}
	const PIPELINE_PROPOSALS$1 = ["minimal", "fsharp", "hack", "smart"];
	const TOPIC_TOKENS$1 = ["^^", "@@", "^", "%", "#"];
	const RECORD_AND_TUPLE_SYNTAX_TYPES = ["hash", "bar"];
	function validatePlugins(plugins) {
	  if (hasPlugin(plugins, "decorators")) {
	    if (hasPlugin(plugins, "decorators-legacy")) {
	      throw new Error("Cannot use the decorators and decorators-legacy plugin together");
	    }

	    const decoratorsBeforeExport = getPluginOption(plugins, "decorators", "decoratorsBeforeExport");

	    if (decoratorsBeforeExport == null) {
	      throw new Error("The 'decorators' plugin requires a 'decoratorsBeforeExport' option," + " whose value must be a boolean. If you are migrating from" + " Babylon/Babel 6 or want to use the old decorators proposal, you" + " should use the 'decorators-legacy' plugin instead of 'decorators'.");
	    } else if (typeof decoratorsBeforeExport !== "boolean") {
	      throw new Error("'decoratorsBeforeExport' must be a boolean.");
	    }
	  }

	  if (hasPlugin(plugins, "flow") && hasPlugin(plugins, "typescript")) {
	    throw new Error("Cannot combine flow and typescript plugins.");
	  }

	  if (hasPlugin(plugins, "placeholders") && hasPlugin(plugins, "v8intrinsic")) {
	    throw new Error("Cannot combine placeholders and v8intrinsic plugins.");
	  }

	  if (hasPlugin(plugins, "pipelineOperator")) {
	    const proposal = getPluginOption(plugins, "pipelineOperator", "proposal");

	    if (!PIPELINE_PROPOSALS$1.includes(proposal)) {
	      const proposalList = PIPELINE_PROPOSALS$1.map(p => `"${p}"`).join(", ");
	      throw new Error(`"pipelineOperator" requires "proposal" option whose value must be one of: ${proposalList}.`);
	    }

	    const tupleSyntaxIsHash = hasPlugin(plugins, ["recordAndTuple", {
	      syntaxType: "hash"
	    }]);

	    if (proposal === "hack") {
	      if (hasPlugin(plugins, "placeholders")) {
	        throw new Error("Cannot combine placeholders plugin and Hack-style pipes.");
	      }

	      if (hasPlugin(plugins, "v8intrinsic")) {
	        throw new Error("Cannot combine v8intrinsic plugin and Hack-style pipes.");
	      }

	      const topicToken = getPluginOption(plugins, "pipelineOperator", "topicToken");

	      if (!TOPIC_TOKENS$1.includes(topicToken)) {
	        const tokenList = TOPIC_TOKENS$1.map(t => `"${t}"`).join(", ");
	        throw new Error(`"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: ${tokenList}.`);
	      }

	      if (topicToken === "#" && tupleSyntaxIsHash) {
	        throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
	      }
	    } else if (proposal === "smart" && tupleSyntaxIsHash) {
	      throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
	    }
	  }

	  if (hasPlugin(plugins, "moduleAttributes")) {
	    if (browser$5.env.BABEL_8_BREAKING) {
	      throw new Error("`moduleAttributes` has been removed in Babel 8, please use `importAssertions` parser plugin, or `@babel/plugin-syntax-import-assertions`.");
	    } else {
	      if (hasPlugin(plugins, "importAssertions")) {
	        throw new Error("Cannot combine importAssertions and moduleAttributes plugins.");
	      }

	      const moduleAttributesVerionPluginOption = getPluginOption(plugins, "moduleAttributes", "version");

	      if (moduleAttributesVerionPluginOption !== "may-2020") {
	        throw new Error("The 'moduleAttributes' plugin requires a 'version' option," + " representing the last proposal update. Currently, the" + " only supported value is 'may-2020'.");
	      }
	    }
	  }

	  if (hasPlugin(plugins, "recordAndTuple") && !RECORD_AND_TUPLE_SYNTAX_TYPES.includes(getPluginOption(plugins, "recordAndTuple", "syntaxType"))) {
	    throw new Error("'recordAndTuple' requires 'syntaxType' option whose value should be one of: " + RECORD_AND_TUPLE_SYNTAX_TYPES.map(p => `'${p}'`).join(", "));
	  }

	  if (hasPlugin(plugins, "asyncDoExpressions") && !hasPlugin(plugins, "doExpressions")) {
	    const error = new Error("'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins.");
	    error.missingPlugins = "doExpressions";
	    throw error;
	  }
	}
	const mixinPlugins = {
	  estree,
	  jsx,
	  flow,
	  typescript,
	  v8intrinsic,
	  placeholders
	};
	const mixinPluginNames = Object.keys(mixinPlugins);

	const defaultOptions = {
	  sourceType: "script",
	  sourceFilename: undefined,
	  startColumn: 0,
	  startLine: 1,
	  allowAwaitOutsideFunction: false,
	  allowReturnOutsideFunction: false,
	  allowImportExportEverywhere: false,
	  allowSuperOutsideMethod: false,
	  allowUndeclaredExports: false,
	  plugins: [],
	  strictMode: null,
	  ranges: false,
	  tokens: false,
	  createParenthesizedExpressions: false,
	  errorRecovery: false,
	  attachComment: true
	};
	function getOptions(opts) {
	  const options = {};

	  for (const key of Object.keys(defaultOptions)) {
	    options[key] = opts && opts[key] != null ? opts[key] : defaultOptions[key];
	  }

	  return options;
	}

	const unwrapParenthesizedExpression = node => {
	  return node.type === "ParenthesizedExpression" ? unwrapParenthesizedExpression(node.expression) : node;
	};

	class LValParser extends NodeUtils {
	  toAssignable(node, isLHS = false) {
	    let parenthesized = undefined;

	    if (node.type === "ParenthesizedExpression" || node.extra?.parenthesized) {
	      parenthesized = unwrapParenthesizedExpression(node);

	      if (isLHS) {
	        if (parenthesized.type === "Identifier") {
	          this.expressionScope.recordParenthesizedIdentifierError(ErrorMessages.InvalidParenthesizedAssignment, node.loc.start);
	        } else if (parenthesized.type !== "MemberExpression") {
	          this.raise(ErrorMessages.InvalidParenthesizedAssignment, {
	            node
	          });
	        }
	      } else {
	        this.raise(ErrorMessages.InvalidParenthesizedAssignment, {
	          node
	        });
	      }
	    }

	    switch (node.type) {
	      case "Identifier":
	      case "ObjectPattern":
	      case "ArrayPattern":
	      case "AssignmentPattern":
	      case "RestElement":
	        break;

	      case "ObjectExpression":
	        node.type = "ObjectPattern";

	        for (let i = 0, length = node.properties.length, last = length - 1; i < length; i++) {
	          const prop = node.properties[i];
	          const isLast = i === last;
	          this.toAssignableObjectExpressionProp(prop, isLast, isLHS);

	          if (isLast && prop.type === "RestElement" && node.extra?.trailingCommaLoc) {
	            this.raise(ErrorMessages.RestTrailingComma, {
	              at: node.extra.trailingCommaLoc
	            });
	          }
	        }

	        break;

	      case "ObjectProperty":
	        {
	          const {
	            key,
	            value
	          } = node;

	          if (this.isPrivateName(key)) {
	            this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
	          }

	          this.toAssignable(value, isLHS);
	          break;
	        }

	      case "SpreadElement":
	        {
	          this.checkToRestConversion(node);
	          node.type = "RestElement";
	          const arg = node.argument;
	          this.toAssignable(arg, isLHS);
	          break;
	        }

	      case "ArrayExpression":
	        node.type = "ArrayPattern";
	        this.toAssignableList(node.elements, node.extra?.trailingCommaLoc, isLHS);
	        break;

	      case "AssignmentExpression":
	        if (node.operator !== "=") {
	          this.raise(ErrorMessages.MissingEqInAssignment, {
	            at: node.left.loc.end
	          });
	        }

	        node.type = "AssignmentPattern";
	        delete node.operator;
	        this.toAssignable(node.left, isLHS);
	        break;

	      case "ParenthesizedExpression":
	        this.toAssignable(parenthesized, isLHS);
	        break;
	    }

	    return node;
	  }

	  toAssignableObjectExpressionProp(prop, isLast, isLHS) {
	    if (prop.type === "ObjectMethod") {
	      this.raise(prop.kind === "get" || prop.kind === "set" ? ErrorMessages.PatternHasAccessor : ErrorMessages.PatternHasMethod, {
	        node: prop.key
	      });
	    } else if (prop.type === "SpreadElement" && !isLast) {
	      this.raise(ErrorMessages.RestTrailingComma, {
	        node: prop
	      });
	    } else {
	      this.toAssignable(prop, isLHS);
	    }
	  }

	  toAssignableList(exprList, trailingCommaLoc, isLHS) {
	    let end = exprList.length;

	    if (end) {
	      const last = exprList[end - 1];

	      if (last?.type === "RestElement") {
	        --end;
	      } else if (last?.type === "SpreadElement") {
	        last.type = "RestElement";
	        let arg = last.argument;
	        this.toAssignable(arg, isLHS);
	        arg = unwrapParenthesizedExpression(arg);

	        if (arg.type !== "Identifier" && arg.type !== "MemberExpression" && arg.type !== "ArrayPattern" && arg.type !== "ObjectPattern") {
	          this.unexpected(arg.start);
	        }

	        if (trailingCommaLoc) {
	          this.raise(ErrorMessages.RestTrailingComma, {
	            at: trailingCommaLoc
	          });
	        }

	        --end;
	      }
	    }

	    for (let i = 0; i < end; i++) {
	      const elt = exprList[i];

	      if (elt) {
	        this.toAssignable(elt, isLHS);

	        if (elt.type === "RestElement") {
	          this.raise(ErrorMessages.RestTrailingComma, {
	            node: elt
	          });
	        }
	      }
	    }

	    return exprList;
	  }

	  isAssignable(node, isBinding) {
	    switch (node.type) {
	      case "Identifier":
	      case "ObjectPattern":
	      case "ArrayPattern":
	      case "AssignmentPattern":
	      case "RestElement":
	        return true;

	      case "ObjectExpression":
	        {
	          const last = node.properties.length - 1;
	          return node.properties.every((prop, i) => {
	            return prop.type !== "ObjectMethod" && (i === last || prop.type !== "SpreadElement") && this.isAssignable(prop);
	          });
	        }

	      case "ObjectProperty":
	        return this.isAssignable(node.value);

	      case "SpreadElement":
	        return this.isAssignable(node.argument);

	      case "ArrayExpression":
	        return node.elements.every(element => element === null || this.isAssignable(element));

	      case "AssignmentExpression":
	        return node.operator === "=";

	      case "ParenthesizedExpression":
	        return this.isAssignable(node.expression);

	      case "MemberExpression":
	      case "OptionalMemberExpression":
	        return !isBinding;

	      default:
	        return false;
	    }
	  }

	  toReferencedList(exprList, isParenthesizedExpr) {
	    return exprList;
	  }

	  toReferencedListDeep(exprList, isParenthesizedExpr) {
	    this.toReferencedList(exprList, isParenthesizedExpr);

	    for (const expr of exprList) {
	      if (expr?.type === "ArrayExpression") {
	        this.toReferencedListDeep(expr.elements);
	      }
	    }
	  }

	  parseSpread(refExpressionErrors, refNeedsArrowPos) {
	    const node = this.startNode();
	    this.next();
	    node.argument = this.parseMaybeAssignAllowIn(refExpressionErrors, undefined, refNeedsArrowPos);
	    return this.finishNode(node, "SpreadElement");
	  }

	  parseRestBinding() {
	    const node = this.startNode();
	    this.next();
	    node.argument = this.parseBindingAtom();
	    return this.finishNode(node, "RestElement");
	  }

	  parseBindingAtom() {
	    switch (this.state.type) {
	      case 0:
	        {
	          const node = this.startNode();
	          this.next();
	          node.elements = this.parseBindingList(3, 93, true);
	          return this.finishNode(node, "ArrayPattern");
	        }

	      case 5:
	        return this.parseObjectLike(8, true);
	    }

	    return this.parseIdentifier();
	  }

	  parseBindingList(close, closeCharCode, allowEmpty, allowModifiers) {
	    const elts = [];
	    let first = true;

	    while (!this.eat(close)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);
	      }

	      if (allowEmpty && this.match(12)) {
	        elts.push(null);
	      } else if (this.eat(close)) {
	        break;
	      } else if (this.match(21)) {
	        elts.push(this.parseAssignableListItemTypes(this.parseRestBinding()));

	        if (!this.checkCommaAfterRest(closeCharCode)) {
	          this.expect(close);
	          break;
	        }
	      } else {
	        const decorators = [];

	        if (this.match(26) && this.hasPlugin("decorators")) {
	          this.raise(ErrorMessages.UnsupportedParameterDecorator, {
	            at: this.state.startLoc
	          });
	        }

	        while (this.match(26)) {
	          decorators.push(this.parseDecorator());
	        }

	        elts.push(this.parseAssignableListItem(allowModifiers, decorators));
	      }
	    }

	    return elts;
	  }

	  parseBindingRestProperty(prop) {
	    this.next();
	    prop.argument = this.parseIdentifier();
	    this.checkCommaAfterRest(125);
	    return this.finishNode(prop, "RestElement");
	  }

	  parseBindingProperty() {
	    const prop = this.startNode();
	    const {
	      type,
	      start: startPos,
	      startLoc
	    } = this.state;

	    if (type === 21) {
	      return this.parseBindingRestProperty(prop);
	    } else if (type === 134) {
	      this.expectPlugin("destructuringPrivate", startLoc);
	      this.classScope.usePrivateName(this.state.value, startLoc);
	      prop.key = this.parsePrivateName();
	    } else {
	      this.parsePropertyName(prop);
	    }

	    prop.method = false;
	    this.parseObjPropValue(prop, startPos, startLoc, false, false, true, false);
	    return prop;
	  }

	  parseAssignableListItem(allowModifiers, decorators) {
	    const left = this.parseMaybeDefault();
	    this.parseAssignableListItemTypes(left);
	    const elt = this.parseMaybeDefault(left.start, left.loc.start, left);

	    if (decorators.length) {
	      left.decorators = decorators;
	    }

	    return elt;
	  }

	  parseAssignableListItemTypes(param) {
	    return param;
	  }

	  parseMaybeDefault(startPos, startLoc, left) {
	    startLoc = startLoc ?? this.state.startLoc;
	    startPos = startPos ?? this.state.start;
	    left = left ?? this.parseBindingAtom();
	    if (!this.eat(29)) return left;
	    const node = this.startNodeAt(startPos, startLoc);
	    node.left = left;
	    node.right = this.parseMaybeAssignAllowIn();
	    return this.finishNode(node, "AssignmentPattern");
	  }

	  checkLVal(expr, contextDescription, bindingType = BIND_NONE, checkClashes, disallowLetBinding, strictModeChanged = false) {
	    switch (expr.type) {
	      case "Identifier":
	        {
	          const {
	            name
	          } = expr;

	          if (this.state.strict && (strictModeChanged ? isStrictBindReservedWord(name, this.inModule) : isStrictBindOnlyReservedWord(name))) {
	            this.raise(bindingType === BIND_NONE ? ErrorMessages.StrictEvalArguments : ErrorMessages.StrictEvalArgumentsBinding, {
	              node: expr
	            }, name);
	          }

	          if (checkClashes) {
	            if (checkClashes.has(name)) {
	              this.raise(ErrorMessages.ParamDupe, {
	                node: expr
	              });
	            } else {
	              checkClashes.add(name);
	            }
	          }

	          if (disallowLetBinding && name === "let") {
	            this.raise(ErrorMessages.LetInLexicalBinding, {
	              node: expr
	            });
	          }

	          if (!(bindingType & BIND_NONE)) {
	            this.scope.declareName(name, bindingType, expr.loc.start);
	          }

	          break;
	        }

	      case "MemberExpression":
	        if (bindingType !== BIND_NONE) {
	          this.raise(ErrorMessages.InvalidPropertyBindingPattern, {
	            node: expr
	          });
	        }

	        break;

	      case "ObjectPattern":
	        for (let prop of expr.properties) {
	          if (this.isObjectProperty(prop)) prop = prop.value;else if (this.isObjectMethod(prop)) continue;
	          this.checkLVal(prop, "object destructuring pattern", bindingType, checkClashes, disallowLetBinding);
	        }

	        break;

	      case "ArrayPattern":
	        for (const elem of expr.elements) {
	          if (elem) {
	            this.checkLVal(elem, "array destructuring pattern", bindingType, checkClashes, disallowLetBinding);
	          }
	        }

	        break;

	      case "AssignmentPattern":
	        this.checkLVal(expr.left, "assignment pattern", bindingType, checkClashes);
	        break;

	      case "RestElement":
	        this.checkLVal(expr.argument, "rest element", bindingType, checkClashes);
	        break;

	      case "ParenthesizedExpression":
	        this.checkLVal(expr.expression, "parenthesized expression", bindingType, checkClashes);
	        break;

	      default:
	        {
	          this.raise(bindingType === BIND_NONE ? ErrorMessages.InvalidLhs : ErrorMessages.InvalidLhsBinding, {
	            node: expr
	          }, contextDescription);
	        }
	    }
	  }

	  checkToRestConversion(node) {
	    if (node.argument.type !== "Identifier" && node.argument.type !== "MemberExpression") {
	      this.raise(ErrorMessages.InvalidRestAssignmentPattern, {
	        node: node.argument
	      });
	    }
	  }

	  checkCommaAfterRest(close) {
	    if (!this.match(12)) {
	      return false;
	    }

	    this.raise(this.lookaheadCharCode() === close ? ErrorMessages.RestTrailingComma : ErrorMessages.ElementAfterRest, {
	      at: this.state.startLoc
	    });
	    return true;
	  }

	}

	const invalidHackPipeBodies = new Map([["ArrowFunctionExpression", "arrow function"], ["AssignmentExpression", "assignment"], ["ConditionalExpression", "conditional"], ["YieldExpression", "yield"]]);
	class ExpressionParser extends LValParser {
	  checkProto(prop, isRecord, protoRef, refExpressionErrors) {
	    if (prop.type === "SpreadElement" || this.isObjectMethod(prop) || prop.computed || prop.shorthand) {
	      return;
	    }

	    const key = prop.key;
	    const name = key.type === "Identifier" ? key.name : key.value;

	    if (name === "__proto__") {
	      if (isRecord) {
	        this.raise(ErrorMessages.RecordNoProto, {
	          node: key
	        });
	        return;
	      }

	      if (protoRef.used) {
	        if (refExpressionErrors) {
	          if (refExpressionErrors.doubleProtoLoc === null) {
	            refExpressionErrors.doubleProtoLoc = key.loc.start;
	          }
	        } else {
	          this.raise(ErrorMessages.DuplicateProto, {
	            node: key
	          });
	        }
	      }

	      protoRef.used = true;
	    }
	  }

	  shouldExitDescending(expr, potentialArrowAt) {
	    return expr.type === "ArrowFunctionExpression" && expr.start === potentialArrowAt;
	  }

	  getExpression() {
	    this.enterInitialScopes();
	    this.nextToken();
	    const expr = this.parseExpression();

	    if (!this.match(135)) {
	      this.unexpected();
	    }

	    this.finalizeRemainingComments();
	    expr.comments = this.state.comments;
	    expr.errors = this.state.errors;

	    if (this.options.tokens) {
	      expr.tokens = this.tokens;
	    }

	    return expr;
	  }

	  parseExpression(disallowIn, refExpressionErrors) {
	    if (disallowIn) {
	      return this.disallowInAnd(() => this.parseExpressionBase(refExpressionErrors));
	    }

	    return this.allowInAnd(() => this.parseExpressionBase(refExpressionErrors));
	  }

	  parseExpressionBase(refExpressionErrors) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    const expr = this.parseMaybeAssign(refExpressionErrors);

	    if (this.match(12)) {
	      const node = this.startNodeAt(startPos, startLoc);
	      node.expressions = [expr];

	      while (this.eat(12)) {
	        node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
	      }

	      this.toReferencedList(node.expressions);
	      return this.finishNode(node, "SequenceExpression");
	    }

	    return expr;
	  }

	  parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
	    return this.disallowInAnd(() => this.parseMaybeAssign(refExpressionErrors, afterLeftParse));
	  }

	  parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
	    return this.allowInAnd(() => this.parseMaybeAssign(refExpressionErrors, afterLeftParse));
	  }

	  setOptionalParametersError(refExpressionErrors, resultError) {
	    refExpressionErrors.optionalParametersLoc = resultError?.loc ?? this.state.startLoc;
	  }

	  parseMaybeAssign(refExpressionErrors, afterLeftParse) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;

	    if (this.isContextual(105)) {
	      if (this.prodParam.hasYield) {
	        let left = this.parseYield();

	        if (afterLeftParse) {
	          left = afterLeftParse.call(this, left, startPos, startLoc);
	        }

	        return left;
	      }
	    }

	    let ownExpressionErrors;

	    if (refExpressionErrors) {
	      ownExpressionErrors = false;
	    } else {
	      refExpressionErrors = new ExpressionErrors();
	      ownExpressionErrors = true;
	    }

	    const {
	      type
	    } = this.state;

	    if (type === 10 || tokenIsIdentifier(type)) {
	      this.state.potentialArrowAt = this.state.start;
	    }

	    let left = this.parseMaybeConditional(refExpressionErrors);

	    if (afterLeftParse) {
	      left = afterLeftParse.call(this, left, startPos, startLoc);
	    }

	    if (tokenIsAssignment(this.state.type)) {
	      const node = this.startNodeAt(startPos, startLoc);
	      const operator = this.state.value;
	      node.operator = operator;

	      if (this.match(29)) {
	        node.left = this.toAssignable(left, true);

	        if (refExpressionErrors.doubleProtoLoc != null && refExpressionErrors.doubleProtoLoc.index >= startPos) {
	          refExpressionErrors.doubleProtoLoc = null;
	        }

	        if (refExpressionErrors.shorthandAssignLoc != null && refExpressionErrors.shorthandAssignLoc.index >= startPos) {
	          refExpressionErrors.shorthandAssignLoc = null;
	        }

	        if (refExpressionErrors.privateKeyLoc != null && refExpressionErrors.privateKeyLoc.index >= startPos) {
	          this.checkDestructuringPrivate(refExpressionErrors);
	          refExpressionErrors.privateKeyLoc = null;
	        }
	      } else {
	        node.left = left;
	      }

	      this.checkLVal(left, "assignment expression");
	      this.next();
	      node.right = this.parseMaybeAssign();
	      return this.finishNode(node, "AssignmentExpression");
	    } else if (ownExpressionErrors) {
	      this.checkExpressionErrors(refExpressionErrors, true);
	    }

	    return left;
	  }

	  parseMaybeConditional(refExpressionErrors) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    const potentialArrowAt = this.state.potentialArrowAt;
	    const expr = this.parseExprOps(refExpressionErrors);

	    if (this.shouldExitDescending(expr, potentialArrowAt)) {
	      return expr;
	    }

	    return this.parseConditional(expr, startPos, startLoc, refExpressionErrors);
	  }

	  parseConditional(expr, startPos, startLoc, refExpressionErrors) {
	    if (this.eat(17)) {
	      const node = this.startNodeAt(startPos, startLoc);
	      node.test = expr;
	      node.consequent = this.parseMaybeAssignAllowIn();
	      this.expect(14);
	      node.alternate = this.parseMaybeAssign();
	      return this.finishNode(node, "ConditionalExpression");
	    }

	    return expr;
	  }

	  parseMaybeUnaryOrPrivate(refExpressionErrors) {
	    return this.match(134) ? this.parsePrivateName() : this.parseMaybeUnary(refExpressionErrors);
	  }

	  parseExprOps(refExpressionErrors) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    const potentialArrowAt = this.state.potentialArrowAt;
	    const expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);

	    if (this.shouldExitDescending(expr, potentialArrowAt)) {
	      return expr;
	    }

	    return this.parseExprOp(expr, startPos, startLoc, -1);
	  }

	  parseExprOp(left, leftStartPos, leftStartLoc, minPrec) {
	    if (this.isPrivateName(left)) {
	      const value = this.getPrivateNameSV(left);

	      if (minPrec >= tokenOperatorPrecedence(58) || !this.prodParam.hasIn || !this.match(58)) {
	        this.raise(ErrorMessages.PrivateInExpectedIn, {
	          node: left
	        }, value);
	      }

	      this.classScope.usePrivateName(value, left.loc.start);
	    }

	    const op = this.state.type;

	    if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
	      let prec = tokenOperatorPrecedence(op);

	      if (prec > minPrec) {
	        if (op === 39) {
	          this.expectPlugin("pipelineOperator");

	          if (this.state.inFSharpPipelineDirectBody) {
	            return left;
	          }

	          this.checkPipelineAtInfixOperator(left, leftStartLoc);
	        }

	        const node = this.startNodeAt(leftStartPos, leftStartLoc);
	        node.left = left;
	        node.operator = this.state.value;
	        const logical = op === 41 || op === 42;
	        const coalesce = op === 40;

	        if (coalesce) {
	          prec = tokenOperatorPrecedence(42);
	        }

	        this.next();

	        if (op === 39 && this.hasPlugin(["pipelineOperator", {
	          proposal: "minimal"
	        }])) {
	          if (this.state.type === 96 && this.prodParam.hasAwait) {
	            throw this.raise(ErrorMessages.UnexpectedAwaitAfterPipelineBody, {
	              at: this.state.startLoc
	            });
	          }
	        }

	        node.right = this.parseExprOpRightExpr(op, prec);
	        this.finishNode(node, logical || coalesce ? "LogicalExpression" : "BinaryExpression");
	        const nextOp = this.state.type;

	        if (coalesce && (nextOp === 41 || nextOp === 42) || logical && nextOp === 40) {
	          throw this.raise(ErrorMessages.MixingCoalesceWithLogical, {
	            at: this.state.startLoc
	          });
	        }

	        return this.parseExprOp(node, leftStartPos, leftStartLoc, minPrec);
	      }
	    }

	    return left;
	  }

	  parseExprOpRightExpr(op, prec) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;

	    switch (op) {
	      case 39:
	        switch (this.getPluginOption("pipelineOperator", "proposal")) {
	          case "hack":
	            return this.withTopicBindingContext(() => {
	              return this.parseHackPipeBody();
	            });

	          case "smart":
	            return this.withTopicBindingContext(() => {
	              if (this.prodParam.hasYield && this.isContextual(105)) {
	                throw this.raise(ErrorMessages.PipeBodyIsTighter, {
	                  at: this.state.startLoc
	                }, this.state.value);
	              }

	              return this.parseSmartPipelineBodyInStyle(this.parseExprOpBaseRightExpr(op, prec), startPos, startLoc);
	            });

	          case "fsharp":
	            return this.withSoloAwaitPermittingContext(() => {
	              return this.parseFSharpPipelineBody(prec);
	            });
	        }

	      default:
	        return this.parseExprOpBaseRightExpr(op, prec);
	    }
	  }

	  parseExprOpBaseRightExpr(op, prec) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    return this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startPos, startLoc, tokenIsRightAssociative(op) ? prec - 1 : prec);
	  }

	  parseHackPipeBody() {
	    const {
	      startLoc
	    } = this.state;
	    const body = this.parseMaybeAssign();

	    if (invalidHackPipeBodies.has(body.type) && !body.extra?.parenthesized) {
	      this.raise(ErrorMessages.PipeUnparenthesizedBody, {
	        at: startLoc
	      }, invalidHackPipeBodies.get(body.type));
	    }

	    if (!this.topicReferenceWasUsedInCurrentContext()) {
	      this.raise(ErrorMessages.PipeTopicUnused, {
	        at: startLoc
	      });
	    }

	    return body;
	  }

	  checkExponentialAfterUnary(node) {
	    if (this.match(57)) {
	      this.raise(ErrorMessages.UnexpectedTokenUnaryExponentiation, {
	        node: node.argument
	      });
	    }
	  }

	  parseMaybeUnary(refExpressionErrors, sawUnary) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    const isAwait = this.isContextual(96);

	    if (isAwait && this.isAwaitAllowed()) {
	      this.next();
	      const expr = this.parseAwait(startPos, startLoc);
	      if (!sawUnary) this.checkExponentialAfterUnary(expr);
	      return expr;
	    }

	    const update = this.match(34);
	    const node = this.startNode();

	    if (tokenIsPrefix(this.state.type)) {
	      node.operator = this.state.value;
	      node.prefix = true;

	      if (this.match(72)) {
	        this.expectPlugin("throwExpressions");
	      }

	      const isDelete = this.match(89);
	      this.next();
	      node.argument = this.parseMaybeUnary(null, true);
	      this.checkExpressionErrors(refExpressionErrors, true);

	      if (this.state.strict && isDelete) {
	        const arg = node.argument;

	        if (arg.type === "Identifier") {
	          this.raise(ErrorMessages.StrictDelete, {
	            node
	          });
	        } else if (this.hasPropertyAsPrivateName(arg)) {
	          this.raise(ErrorMessages.DeletePrivateField, {
	            node
	          });
	        }
	      }

	      if (!update) {
	        if (!sawUnary) this.checkExponentialAfterUnary(node);
	        return this.finishNode(node, "UnaryExpression");
	      }
	    }

	    const expr = this.parseUpdate(node, update, refExpressionErrors);

	    if (isAwait) {
	      const {
	        type
	      } = this.state;
	      const startsExpr = this.hasPlugin("v8intrinsic") ? tokenCanStartExpression(type) : tokenCanStartExpression(type) && !this.match(54);

	      if (startsExpr && !this.isAmbiguousAwait()) {
	        this.raiseOverwrite(startLoc, ErrorMessages.AwaitNotInAsyncContext);
	        return this.parseAwait(startPos, startLoc);
	      }
	    }

	    return expr;
	  }

	  parseUpdate(node, update, refExpressionErrors) {
	    if (update) {
	      this.checkLVal(node.argument, "prefix operation");
	      return this.finishNode(node, "UpdateExpression");
	    }

	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    let expr = this.parseExprSubscripts(refExpressionErrors);
	    if (this.checkExpressionErrors(refExpressionErrors, false)) return expr;

	    while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
	      const node = this.startNodeAt(startPos, startLoc);
	      node.operator = this.state.value;
	      node.prefix = false;
	      node.argument = expr;
	      this.checkLVal(expr, "postfix operation");
	      this.next();
	      expr = this.finishNode(node, "UpdateExpression");
	    }

	    return expr;
	  }

	  parseExprSubscripts(refExpressionErrors) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    const potentialArrowAt = this.state.potentialArrowAt;
	    const expr = this.parseExprAtom(refExpressionErrors);

	    if (this.shouldExitDescending(expr, potentialArrowAt)) {
	      return expr;
	    }

	    return this.parseSubscripts(expr, startPos, startLoc);
	  }

	  parseSubscripts(base, startPos, startLoc, noCalls) {
	    const state = {
	      optionalChainMember: false,
	      maybeAsyncArrow: this.atPossibleAsyncArrow(base),
	      stop: false
	    };

	    do {
	      base = this.parseSubscript(base, startPos, startLoc, noCalls, state);
	      state.maybeAsyncArrow = false;
	    } while (!state.stop);

	    return base;
	  }

	  parseSubscript(base, startPos, startLoc, noCalls, state) {
	    const {
	      type
	    } = this.state;

	    if (!noCalls && type === 15) {
	      return this.parseBind(base, startPos, startLoc, noCalls, state);
	    } else if (tokenIsTemplate(type)) {
	      return this.parseTaggedTemplateExpression(base, startPos, startLoc, state);
	    }

	    let optional = false;

	    if (type === 18) {
	      if (noCalls && this.lookaheadCharCode() === 40) {
	        state.stop = true;
	        return base;
	      }

	      state.optionalChainMember = optional = true;
	      this.next();
	    }

	    if (!noCalls && this.match(10)) {
	      return this.parseCoverCallAndAsyncArrowHead(base, startPos, startLoc, state, optional);
	    } else {
	      const computed = this.eat(0);

	      if (computed || optional || this.eat(16)) {
	        return this.parseMember(base, startPos, startLoc, state, computed, optional);
	      } else {
	        state.stop = true;
	        return base;
	      }
	    }
	  }

	  parseMember(base, startPos, startLoc, state, computed, optional) {
	    const node = this.startNodeAt(startPos, startLoc);
	    node.object = base;
	    node.computed = computed;

	    if (computed) {
	      node.property = this.parseExpression();
	      this.expect(3);
	    } else if (this.match(134)) {
	      if (base.type === "Super") {
	        this.raise(ErrorMessages.SuperPrivateField, {
	          at: startLoc
	        });
	      }

	      this.classScope.usePrivateName(this.state.value, this.state.startLoc);
	      node.property = this.parsePrivateName();
	    } else {
	      node.property = this.parseIdentifier(true);
	    }

	    if (state.optionalChainMember) {
	      node.optional = optional;
	      return this.finishNode(node, "OptionalMemberExpression");
	    } else {
	      return this.finishNode(node, "MemberExpression");
	    }
	  }

	  parseBind(base, startPos, startLoc, noCalls, state) {
	    const node = this.startNodeAt(startPos, startLoc);
	    node.object = base;
	    this.next();
	    node.callee = this.parseNoCallExpr();
	    state.stop = true;
	    return this.parseSubscripts(this.finishNode(node, "BindExpression"), startPos, startLoc, noCalls);
	  }

	  parseCoverCallAndAsyncArrowHead(base, startPos, startLoc, state, optional) {
	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    let refExpressionErrors = null;
	    this.state.maybeInArrowParameters = true;
	    this.next();
	    let node = this.startNodeAt(startPos, startLoc);
	    node.callee = base;
	    const {
	      maybeAsyncArrow,
	      optionalChainMember
	    } = state;

	    if (maybeAsyncArrow) {
	      this.expressionScope.enter(newAsyncArrowScope());
	      refExpressionErrors = new ExpressionErrors();
	    }

	    if (optionalChainMember) {
	      node.optional = optional;
	    }

	    if (optional) {
	      node.arguments = this.parseCallExpressionArguments(11);
	    } else {
	      node.arguments = this.parseCallExpressionArguments(11, base.type === "Import", base.type !== "Super", node, refExpressionErrors);
	    }

	    this.finishCallExpression(node, optionalChainMember);

	    if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
	      state.stop = true;
	      this.checkDestructuringPrivate(refExpressionErrors);
	      this.expressionScope.validateAsPattern();
	      this.expressionScope.exit();
	      node = this.parseAsyncArrowFromCallExpression(this.startNodeAt(startPos, startLoc), node);
	    } else {
	      if (maybeAsyncArrow) {
	        this.checkExpressionErrors(refExpressionErrors, true);
	        this.expressionScope.exit();
	      }

	      this.toReferencedArguments(node);
	    }

	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    return node;
	  }

	  toReferencedArguments(node, isParenthesizedExpr) {
	    this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
	  }

	  parseTaggedTemplateExpression(base, startPos, startLoc, state) {
	    const node = this.startNodeAt(startPos, startLoc);
	    node.tag = base;
	    node.quasi = this.parseTemplate(true);

	    if (state.optionalChainMember) {
	      this.raise(ErrorMessages.OptionalChainingNoTemplate, {
	        at: startLoc
	      });
	    }

	    return this.finishNode(node, "TaggedTemplateExpression");
	  }

	  atPossibleAsyncArrow(base) {
	    return base.type === "Identifier" && base.name === "async" && this.state.lastTokEndLoc.index === base.end && !this.canInsertSemicolon() && base.end - base.start === 5 && base.start === this.state.potentialArrowAt;
	  }

	  finishCallExpression(node, optional) {
	    if (node.callee.type === "Import") {
	      if (node.arguments.length === 2) {
	        if (browser$5.env.BABEL_8_BREAKING) {
	          this.expectPlugin("importAssertions");
	        } else {
	          if (!this.hasPlugin("moduleAttributes")) {
	            this.expectPlugin("importAssertions");
	          }
	        }
	      }

	      if (node.arguments.length === 0 || node.arguments.length > 2) {
	        this.raise(ErrorMessages.ImportCallArity, {
	          node
	        }, this.hasPlugin("importAssertions") || this.hasPlugin("moduleAttributes") ? "one or two arguments" : "one argument");
	      } else {
	        for (const arg of node.arguments) {
	          if (arg.type === "SpreadElement") {
	            this.raise(ErrorMessages.ImportCallSpreadArgument, {
	              node: arg
	            });
	          }
	        }
	      }
	    }

	    return this.finishNode(node, optional ? "OptionalCallExpression" : "CallExpression");
	  }

	  parseCallExpressionArguments(close, dynamicImport, allowPlaceholder, nodeForExtra, refExpressionErrors) {
	    const elts = [];
	    let first = true;
	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.inFSharpPipelineDirectBody = false;

	    while (!this.eat(close)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);

	        if (this.match(close)) {
	          if (dynamicImport && !this.hasPlugin("importAssertions") && !this.hasPlugin("moduleAttributes")) {
	            this.raise(ErrorMessages.ImportCallArgumentTrailingComma, {
	              at: this.state.lastTokStartLoc
	            });
	          }

	          if (nodeForExtra) {
	            this.addTrailingCommaExtraToNode(nodeForExtra);
	          }

	          this.next();
	          break;
	        }
	      }

	      elts.push(this.parseExprListItem(false, refExpressionErrors, allowPlaceholder));
	    }

	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    return elts;
	  }

	  shouldParseAsyncArrow() {
	    return this.match(19) && !this.canInsertSemicolon();
	  }

	  parseAsyncArrowFromCallExpression(node, call) {
	    this.resetPreviousNodeTrailingComments(call);
	    this.expect(19);
	    this.parseArrowExpression(node, call.arguments, true, call.extra?.trailingCommaLoc);

	    if (call.innerComments) {
	      setInnerComments(node, call.innerComments);
	    }

	    if (call.callee.trailingComments) {
	      setInnerComments(node, call.callee.trailingComments);
	    }

	    return node;
	  }

	  parseNoCallExpr() {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    return this.parseSubscripts(this.parseExprAtom(), startPos, startLoc, true);
	  }

	  parseExprAtom(refExpressionErrors) {
	    let node;
	    const {
	      type
	    } = this.state;

	    switch (type) {
	      case 79:
	        return this.parseSuper();

	      case 83:
	        node = this.startNode();
	        this.next();

	        if (this.match(16)) {
	          return this.parseImportMetaProperty(node);
	        }

	        if (!this.match(10)) {
	          this.raise(ErrorMessages.UnsupportedImport, {
	            at: this.state.lastTokStartLoc
	          });
	        }

	        return this.finishNode(node, "Import");

	      case 78:
	        node = this.startNode();
	        this.next();
	        return this.finishNode(node, "ThisExpression");

	      case 90:
	        {
	          return this.parseDo(this.startNode(), false);
	        }

	      case 56:
	      case 31:
	        {
	          this.readRegexp();
	          return this.parseRegExpLiteral(this.state.value);
	        }

	      case 130:
	        return this.parseNumericLiteral(this.state.value);

	      case 131:
	        return this.parseBigIntLiteral(this.state.value);

	      case 132:
	        return this.parseDecimalLiteral(this.state.value);

	      case 129:
	        return this.parseStringLiteral(this.state.value);

	      case 84:
	        return this.parseNullLiteral();

	      case 85:
	        return this.parseBooleanLiteral(true);

	      case 86:
	        return this.parseBooleanLiteral(false);

	      case 10:
	        {
	          const canBeArrow = this.state.potentialArrowAt === this.state.start;
	          return this.parseParenAndDistinguishExpression(canBeArrow);
	        }

	      case 2:
	      case 1:
	        {
	          return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
	        }

	      case 0:
	        {
	          return this.parseArrayLike(3, true, false, refExpressionErrors);
	        }

	      case 6:
	      case 7:
	        {
	          return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
	        }

	      case 5:
	        {
	          return this.parseObjectLike(8, false, false, refExpressionErrors);
	        }

	      case 68:
	        return this.parseFunctionOrFunctionSent();

	      case 26:
	        this.parseDecorators();

	      case 80:
	        node = this.startNode();
	        this.takeDecorators(node);
	        return this.parseClass(node, false);

	      case 77:
	        return this.parseNewOrNewTarget();

	      case 25:
	      case 24:
	        return this.parseTemplate(false);

	      case 15:
	        {
	          node = this.startNode();
	          this.next();
	          node.object = null;
	          const callee = node.callee = this.parseNoCallExpr();

	          if (callee.type === "MemberExpression") {
	            return this.finishNode(node, "BindExpression");
	          } else {
	            throw this.raise(ErrorMessages.UnsupportedBind, {
	              node: callee
	            });
	          }
	        }

	      case 134:
	        {
	          this.raise(ErrorMessages.PrivateInExpectedIn, {
	            at: this.state.startLoc
	          }, this.state.value);
	          return this.parsePrivateName();
	        }

	      case 33:
	        {
	          return this.parseTopicReferenceThenEqualsSign(54, "%");
	        }

	      case 32:
	        {
	          return this.parseTopicReferenceThenEqualsSign(44, "^");
	        }

	      case 37:
	      case 38:
	        {
	          return this.parseTopicReference("hack");
	        }

	      case 44:
	      case 54:
	      case 27:
	        {
	          const pipeProposal = this.getPluginOption("pipelineOperator", "proposal");

	          if (pipeProposal) {
	            return this.parseTopicReference(pipeProposal);
	          } else {
	            throw this.unexpected();
	          }
	        }

	      case 47:
	        {
	          const lookaheadCh = this.input.codePointAt(this.nextTokenStart());

	          if (isIdentifierStart(lookaheadCh) || lookaheadCh === 62) {
	            this.expectOnePlugin(["jsx", "flow", "typescript"]);
	            break;
	          } else {
	            throw this.unexpected();
	          }
	        }

	      default:
	        if (tokenIsIdentifier(type)) {
	          if (this.isContextual(123) && this.lookaheadCharCode() === 123 && !this.hasFollowingLineBreak()) {
	            return this.parseModuleExpression();
	          }

	          const canBeArrow = this.state.potentialArrowAt === this.state.start;
	          const containsEsc = this.state.containsEsc;
	          const id = this.parseIdentifier();

	          if (!containsEsc && id.name === "async" && !this.canInsertSemicolon()) {
	            const {
	              type
	            } = this.state;

	            if (type === 68) {
	              this.resetPreviousNodeTrailingComments(id);
	              this.next();
	              return this.parseFunction(this.startNodeAtNode(id), undefined, true);
	            } else if (tokenIsIdentifier(type)) {
	              if (this.lookaheadCharCode() === 61) {
	                return this.parseAsyncArrowUnaryFunction(this.startNodeAtNode(id));
	              } else {
	                return id;
	              }
	            } else if (type === 90) {
	              this.resetPreviousNodeTrailingComments(id);
	              return this.parseDo(this.startNodeAtNode(id), true);
	            }
	          }

	          if (canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
	            this.next();
	            return this.parseArrowExpression(this.startNodeAtNode(id), [id], false);
	          }

	          return id;
	        } else {
	          throw this.unexpected();
	        }

	    }
	  }

	  parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
	    const pipeProposal = this.getPluginOption("pipelineOperator", "proposal");

	    if (pipeProposal) {
	      this.state.type = topicTokenType;
	      this.state.value = topicTokenValue;
	      this.state.pos--;
	      this.state.end--;
	      this.state.endLoc = createPositionWithColumnOffset(this.state.endLoc, -1);
	      return this.parseTopicReference(pipeProposal);
	    } else {
	      throw this.unexpected();
	    }
	  }

	  parseTopicReference(pipeProposal) {
	    const node = this.startNode();
	    const startLoc = this.state.startLoc;
	    const tokenType = this.state.type;
	    this.next();
	    return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
	  }

	  finishTopicReference(node, startLoc, pipeProposal, tokenType) {
	    if (this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)) {
	      const nodeType = pipeProposal === "smart" ? "PipelinePrimaryTopicReference" : "TopicReference";

	      if (!this.topicReferenceIsAllowedInCurrentContext()) {
	        this.raise(pipeProposal === "smart" ? ErrorMessages.PrimaryTopicNotAllowed : ErrorMessages.PipeTopicUnbound, {
	          at: startLoc
	        });
	      }

	      this.registerTopicReference();
	      return this.finishNode(node, nodeType);
	    } else {
	      throw this.raise(ErrorMessages.PipeTopicUnconfiguredToken, {
	        at: startLoc
	      }, tokenLabelName(tokenType));
	    }
	  }

	  testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
	    switch (pipeProposal) {
	      case "hack":
	        {
	          return this.hasPlugin(["pipelineOperator", {
	            topicToken: tokenLabelName(tokenType)
	          }]);
	        }

	      case "smart":
	        return tokenType === 27;

	      default:
	        throw this.raise(ErrorMessages.PipeTopicRequiresHackPipes, {
	          at: startLoc
	        });
	    }
	  }

	  parseAsyncArrowUnaryFunction(node) {
	    this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
	    const params = [this.parseIdentifier()];
	    this.prodParam.exit();

	    if (this.hasPrecedingLineBreak()) {
	      this.raise(ErrorMessages.LineTerminatorBeforeArrow, {
	        at: this.state.curPosition()
	      });
	    }

	    this.expect(19);
	    this.parseArrowExpression(node, params, true);
	    return node;
	  }

	  parseDo(node, isAsync) {
	    this.expectPlugin("doExpressions");

	    if (isAsync) {
	      this.expectPlugin("asyncDoExpressions");
	    }

	    node.async = isAsync;
	    this.next();
	    const oldLabels = this.state.labels;
	    this.state.labels = [];

	    if (isAsync) {
	      this.prodParam.enter(PARAM_AWAIT);
	      node.body = this.parseBlock();
	      this.prodParam.exit();
	    } else {
	      node.body = this.parseBlock();
	    }

	    this.state.labels = oldLabels;
	    return this.finishNode(node, "DoExpression");
	  }

	  parseSuper() {
	    const node = this.startNode();
	    this.next();

	    if (this.match(10) && !this.scope.allowDirectSuper && !this.options.allowSuperOutsideMethod) {
	      this.raise(ErrorMessages.SuperNotAllowed, {
	        node
	      });
	    } else if (!this.scope.allowSuper && !this.options.allowSuperOutsideMethod) {
	      this.raise(ErrorMessages.UnexpectedSuper, {
	        node
	      });
	    }

	    if (!this.match(10) && !this.match(0) && !this.match(16)) {
	      this.raise(ErrorMessages.UnsupportedSuper, {
	        node
	      });
	    }

	    return this.finishNode(node, "Super");
	  }

	  parsePrivateName() {
	    const node = this.startNode();
	    const id = this.startNodeAt(this.state.start + 1, new Position(this.state.curLine, this.state.start + 1 - this.state.lineStart, this.state.start + 1));
	    const name = this.state.value;
	    this.next();
	    node.id = this.createIdentifier(id, name);
	    return this.finishNode(node, "PrivateName");
	  }

	  parseFunctionOrFunctionSent() {
	    const node = this.startNode();
	    this.next();

	    if (this.prodParam.hasYield && this.match(16)) {
	      const meta = this.createIdentifier(this.startNodeAtNode(node), "function");
	      this.next();

	      if (this.match(102)) {
	        this.expectPlugin("functionSent");
	      } else if (!this.hasPlugin("functionSent")) {
	        this.unexpected();
	      }

	      return this.parseMetaProperty(node, meta, "sent");
	    }

	    return this.parseFunction(node);
	  }

	  parseMetaProperty(node, meta, propertyName) {
	    node.meta = meta;
	    const containsEsc = this.state.containsEsc;
	    node.property = this.parseIdentifier(true);

	    if (node.property.name !== propertyName || containsEsc) {
	      this.raise(ErrorMessages.UnsupportedMetaProperty, {
	        node: node.property
	      }, meta.name, propertyName);
	    }

	    return this.finishNode(node, "MetaProperty");
	  }

	  parseImportMetaProperty(node) {
	    const id = this.createIdentifier(this.startNodeAtNode(node), "import");
	    this.next();

	    if (this.isContextual(100)) {
	      if (!this.inModule) {
	        this.raise(SourceTypeModuleErrorMessages.ImportMetaOutsideModule, {
	          node: id
	        });
	      }

	      this.sawUnambiguousESM = true;
	    }

	    return this.parseMetaProperty(node, id, "meta");
	  }

	  parseLiteralAtNode(value, type, node) {
	    this.addExtra(node, "rawValue", value);
	    this.addExtra(node, "raw", this.input.slice(node.start, this.state.end));
	    node.value = value;
	    this.next();
	    return this.finishNode(node, type);
	  }

	  parseLiteral(value, type) {
	    const node = this.startNode();
	    return this.parseLiteralAtNode(value, type, node);
	  }

	  parseStringLiteral(value) {
	    return this.parseLiteral(value, "StringLiteral");
	  }

	  parseNumericLiteral(value) {
	    return this.parseLiteral(value, "NumericLiteral");
	  }

	  parseBigIntLiteral(value) {
	    return this.parseLiteral(value, "BigIntLiteral");
	  }

	  parseDecimalLiteral(value) {
	    return this.parseLiteral(value, "DecimalLiteral");
	  }

	  parseRegExpLiteral(value) {
	    const node = this.parseLiteral(value.value, "RegExpLiteral");
	    node.pattern = value.pattern;
	    node.flags = value.flags;
	    return node;
	  }

	  parseBooleanLiteral(value) {
	    const node = this.startNode();
	    node.value = value;
	    this.next();
	    return this.finishNode(node, "BooleanLiteral");
	  }

	  parseNullLiteral() {
	    const node = this.startNode();
	    this.next();
	    return this.finishNode(node, "NullLiteral");
	  }

	  parseParenAndDistinguishExpression(canBeArrow) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    let val;
	    this.next();
	    this.expressionScope.enter(newArrowHeadScope());
	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.maybeInArrowParameters = true;
	    this.state.inFSharpPipelineDirectBody = false;
	    const innerStartPos = this.state.start;
	    const innerStartLoc = this.state.startLoc;
	    const exprList = [];
	    const refExpressionErrors = new ExpressionErrors();
	    let first = true;
	    let spreadStartLoc;
	    let optionalCommaStartLoc;

	    while (!this.match(11)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12, refExpressionErrors.optionalParametersLoc === null ? null : refExpressionErrors.optionalParametersLoc);

	        if (this.match(11)) {
	          optionalCommaStartLoc = this.state.startLoc;
	          break;
	        }
	      }

	      if (this.match(21)) {
	        const spreadNodeStartPos = this.state.start;
	        const spreadNodeStartLoc = this.state.startLoc;
	        spreadStartLoc = this.state.startLoc;
	        exprList.push(this.parseParenItem(this.parseRestBinding(), spreadNodeStartPos, spreadNodeStartLoc));

	        if (!this.checkCommaAfterRest(41)) {
	          break;
	        }
	      } else {
	        exprList.push(this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem));
	      }
	    }

	    const innerEndLoc = this.state.lastTokEndLoc;
	    this.expect(11);
	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    let arrowNode = this.startNodeAt(startPos, startLoc);

	    if (canBeArrow && this.shouldParseArrow(exprList) && (arrowNode = this.parseArrow(arrowNode))) {
	      this.checkDestructuringPrivate(refExpressionErrors);
	      this.expressionScope.validateAsPattern();
	      this.expressionScope.exit();
	      this.parseArrowExpression(arrowNode, exprList, false);
	      return arrowNode;
	    }

	    this.expressionScope.exit();

	    if (!exprList.length) {
	      this.unexpected(this.state.lastTokStartLoc);
	    }

	    if (optionalCommaStartLoc) this.unexpected(optionalCommaStartLoc);
	    if (spreadStartLoc) this.unexpected(spreadStartLoc);
	    this.checkExpressionErrors(refExpressionErrors, true);
	    this.toReferencedListDeep(exprList, true);

	    if (exprList.length > 1) {
	      val = this.startNodeAt(innerStartPos, innerStartLoc);
	      val.expressions = exprList;
	      this.finishNode(val, "SequenceExpression");
	      this.resetEndLocation(val, innerEndLoc);
	    } else {
	      val = exprList[0];
	    }

	    if (!this.options.createParenthesizedExpressions) {
	      this.addExtra(val, "parenthesized", true);
	      this.addExtra(val, "parenStart", startPos);
	      this.takeSurroundingComments(val, startPos, this.state.lastTokEndLoc.index);
	      return val;
	    }

	    const parenExpression = this.startNodeAt(startPos, startLoc);
	    parenExpression.expression = val;
	    this.finishNode(parenExpression, "ParenthesizedExpression");
	    return parenExpression;
	  }

	  shouldParseArrow(params) {
	    return !this.canInsertSemicolon();
	  }

	  parseArrow(node) {
	    if (this.eat(19)) {
	      return node;
	    }
	  }

	  parseParenItem(node, startPos, startLoc) {
	    return node;
	  }

	  parseNewOrNewTarget() {
	    const node = this.startNode();
	    this.next();

	    if (this.match(16)) {
	      const meta = this.createIdentifier(this.startNodeAtNode(node), "new");
	      this.next();
	      const metaProp = this.parseMetaProperty(node, meta, "target");

	      if (!this.scope.inNonArrowFunction && !this.scope.inClass) {
	        this.raise(ErrorMessages.UnexpectedNewTarget, {
	          node: metaProp
	        });
	      }

	      return metaProp;
	    }

	    return this.parseNew(node);
	  }

	  parseNew(node) {
	    node.callee = this.parseNoCallExpr();

	    if (node.callee.type === "Import") {
	      this.raise(ErrorMessages.ImportCallNotNewExpression, {
	        node: node.callee
	      });
	    } else if (this.isOptionalChain(node.callee)) {
	      this.raise(ErrorMessages.OptionalChainingNoNew, {
	        at: this.state.lastTokEndLoc
	      });
	    } else if (this.eat(18)) {
	      this.raise(ErrorMessages.OptionalChainingNoNew, {
	        at: this.state.startLoc
	      });
	    }

	    this.parseNewArguments(node);
	    return this.finishNode(node, "NewExpression");
	  }

	  parseNewArguments(node) {
	    if (this.eat(10)) {
	      const args = this.parseExprList(11);
	      this.toReferencedList(args);
	      node.arguments = args;
	    } else {
	      node.arguments = [];
	    }
	  }

	  parseTemplateElement(isTagged) {
	    const {
	      start,
	      startLoc,
	      end,
	      value
	    } = this.state;
	    const elemStart = start + 1;
	    const elem = this.startNodeAt(elemStart, createPositionWithColumnOffset(startLoc, 1));

	    if (value === null) {
	      if (!isTagged) {
	        this.raise(ErrorMessages.InvalidEscapeSequenceTemplate, {
	          at: createPositionWithColumnOffset(startLoc, 2)
	        });
	      }
	    }

	    const isTail = this.match(24);
	    const endOffset = isTail ? -1 : -2;
	    const elemEnd = end + endOffset;
	    elem.value = {
	      raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, "\n"),
	      cooked: value === null ? null : value.slice(1, endOffset)
	    };
	    elem.tail = isTail;
	    this.next();
	    this.finishNode(elem, "TemplateElement");
	    this.resetEndLocation(elem, createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset));
	    return elem;
	  }

	  parseTemplate(isTagged) {
	    const node = this.startNode();
	    node.expressions = [];
	    let curElt = this.parseTemplateElement(isTagged);
	    node.quasis = [curElt];

	    while (!curElt.tail) {
	      node.expressions.push(this.parseTemplateSubstitution());
	      this.readTemplateContinuation();
	      node.quasis.push(curElt = this.parseTemplateElement(isTagged));
	    }

	    return this.finishNode(node, "TemplateLiteral");
	  }

	  parseTemplateSubstitution() {
	    return this.parseExpression();
	  }

	  parseObjectLike(close, isPattern, isRecord, refExpressionErrors) {
	    if (isRecord) {
	      this.expectPlugin("recordAndTuple");
	    }

	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.inFSharpPipelineDirectBody = false;
	    const propHash = Object.create(null);
	    let first = true;
	    const node = this.startNode();
	    node.properties = [];
	    this.next();

	    while (!this.match(close)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);

	        if (this.match(close)) {
	          this.addTrailingCommaExtraToNode(node);
	          break;
	        }
	      }

	      let prop;

	      if (isPattern) {
	        prop = this.parseBindingProperty();
	      } else {
	        prop = this.parsePropertyDefinition(refExpressionErrors);
	        this.checkProto(prop, isRecord, propHash, refExpressionErrors);
	      }

	      if (isRecord && !this.isObjectProperty(prop) && prop.type !== "SpreadElement") {
	        this.raise(ErrorMessages.InvalidRecordProperty, {
	          node: prop
	        });
	      }

	      if (prop.shorthand) {
	        this.addExtra(prop, "shorthand", true);
	      }

	      node.properties.push(prop);
	    }

	    this.next();
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    let type = "ObjectExpression";

	    if (isPattern) {
	      type = "ObjectPattern";
	    } else if (isRecord) {
	      type = "RecordExpression";
	    }

	    return this.finishNode(node, type);
	  }

	  addTrailingCommaExtraToNode(node) {
	    this.addExtra(node, "trailingComma", this.state.lastTokStart);
	    this.addExtra(node, "trailingCommaLoc", this.state.lastTokStartLoc, false);
	  }

	  maybeAsyncOrAccessorProp(prop) {
	    return !prop.computed && prop.key.type === "Identifier" && (this.isLiteralPropertyName() || this.match(0) || this.match(55));
	  }

	  parsePropertyDefinition(refExpressionErrors) {
	    let decorators = [];

	    if (this.match(26)) {
	      if (this.hasPlugin("decorators")) {
	        this.raise(ErrorMessages.UnsupportedPropertyDecorator, {
	          at: this.state.startLoc
	        });
	      }

	      while (this.match(26)) {
	        decorators.push(this.parseDecorator());
	      }
	    }

	    const prop = this.startNode();
	    let isAsync = false;
	    let isAccessor = false;
	    let startPos;
	    let startLoc;

	    if (this.match(21)) {
	      if (decorators.length) this.unexpected();
	      return this.parseSpread();
	    }

	    if (decorators.length) {
	      prop.decorators = decorators;
	      decorators = [];
	    }

	    prop.method = false;

	    if (refExpressionErrors) {
	      startPos = this.state.start;
	      startLoc = this.state.startLoc;
	    }

	    let isGenerator = this.eat(55);
	    this.parsePropertyNamePrefixOperator(prop);
	    const containsEsc = this.state.containsEsc;
	    const key = this.parsePropertyName(prop, refExpressionErrors);

	    if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
	      const keyName = key.name;

	      if (keyName === "async" && !this.hasPrecedingLineBreak()) {
	        isAsync = true;
	        this.resetPreviousNodeTrailingComments(key);
	        isGenerator = this.eat(55);
	        this.parsePropertyName(prop);
	      }

	      if (keyName === "get" || keyName === "set") {
	        isAccessor = true;
	        this.resetPreviousNodeTrailingComments(key);
	        prop.kind = keyName;

	        if (this.match(55)) {
	          isGenerator = true;
	          this.raise(ErrorMessages.AccessorIsGenerator, {
	            at: this.state.curPosition()
	          }, keyName);
	          this.next();
	        }

	        this.parsePropertyName(prop);
	      }
	    }

	    this.parseObjPropValue(prop, startPos, startLoc, isGenerator, isAsync, false, isAccessor, refExpressionErrors);
	    return prop;
	  }

	  getGetterSetterExpectedParamCount(method) {
	    return method.kind === "get" ? 0 : 1;
	  }

	  getObjectOrClassMethodParams(method) {
	    return method.params;
	  }

	  checkGetterSetterParams(method) {
	    const paramCount = this.getGetterSetterExpectedParamCount(method);
	    const params = this.getObjectOrClassMethodParams(method);

	    if (params.length !== paramCount) {
	      this.raise(method.kind === "get" ? ErrorMessages.BadGetterArity : ErrorMessages.BadSetterArity, {
	        node: method
	      });
	    }

	    if (method.kind === "set" && params[params.length - 1]?.type === "RestElement") {
	      this.raise(ErrorMessages.BadSetterRestParameter, {
	        node: method
	      });
	    }
	  }

	  parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
	    if (isAccessor) {
	      this.parseMethod(prop, isGenerator, false, false, false, "ObjectMethod");
	      this.checkGetterSetterParams(prop);
	      return prop;
	    }

	    if (isAsync || isGenerator || this.match(10)) {
	      if (isPattern) this.unexpected();
	      prop.kind = "method";
	      prop.method = true;
	      return this.parseMethod(prop, isGenerator, isAsync, false, false, "ObjectMethod");
	    }
	  }

	  parseObjectProperty(prop, startPos, startLoc, isPattern, refExpressionErrors) {
	    prop.shorthand = false;

	    if (this.eat(14)) {
	      prop.value = isPattern ? this.parseMaybeDefault(this.state.start, this.state.startLoc) : this.parseMaybeAssignAllowIn(refExpressionErrors);
	      return this.finishNode(prop, "ObjectProperty");
	    }

	    if (!prop.computed && prop.key.type === "Identifier") {
	      this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);

	      if (isPattern) {
	        prop.value = this.parseMaybeDefault(startPos, startLoc, cloneIdentifier(prop.key));
	      } else if (this.match(29)) {
	        const shorthandAssignLoc = this.state.startLoc;

	        if (refExpressionErrors != null) {
	          if (refExpressionErrors.shorthandAssignLoc === null) {
	            refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
	          }
	        } else {
	          this.raise(ErrorMessages.InvalidCoverInitializedName, {
	            at: shorthandAssignLoc
	          });
	        }

	        prop.value = this.parseMaybeDefault(startPos, startLoc, cloneIdentifier(prop.key));
	      } else {
	        prop.value = cloneIdentifier(prop.key);
	      }

	      prop.shorthand = true;
	      return this.finishNode(prop, "ObjectProperty");
	    }
	  }

	  parseObjPropValue(prop, startPos, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
	    const node = this.parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) || this.parseObjectProperty(prop, startPos, startLoc, isPattern, refExpressionErrors);
	    if (!node) this.unexpected();
	    return node;
	  }

	  parsePropertyName(prop, refExpressionErrors) {
	    if (this.eat(0)) {
	      prop.computed = true;
	      prop.key = this.parseMaybeAssignAllowIn();
	      this.expect(3);
	    } else {
	      const {
	        type,
	        value
	      } = this.state;
	      let key;

	      if (tokenIsKeywordOrIdentifier(type)) {
	        key = this.parseIdentifier(true);
	      } else {
	        switch (type) {
	          case 130:
	            key = this.parseNumericLiteral(value);
	            break;

	          case 129:
	            key = this.parseStringLiteral(value);
	            break;

	          case 131:
	            key = this.parseBigIntLiteral(value);
	            break;

	          case 132:
	            key = this.parseDecimalLiteral(value);
	            break;

	          case 134:
	            {
	              const privateKeyLoc = this.state.startLoc;

	              if (refExpressionErrors != null) {
	                if (refExpressionErrors.privateKeyLoc === null) {
	                  refExpressionErrors.privateKeyLoc = privateKeyLoc;
	                }
	              } else {
	                this.raise(ErrorMessages.UnexpectedPrivateField, {
	                  at: privateKeyLoc
	                });
	              }

	              key = this.parsePrivateName();
	              break;
	            }

	          default:
	            throw this.unexpected();
	        }
	      }

	      prop.key = key;

	      if (type !== 134) {
	        prop.computed = false;
	      }
	    }

	    return prop.key;
	  }

	  initFunction(node, isAsync) {
	    node.id = null;
	    node.generator = false;
	    node.async = !!isAsync;
	  }

	  parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope = false) {
	    this.initFunction(node, isAsync);
	    node.generator = !!isGenerator;
	    const allowModifiers = isConstructor;
	    this.scope.enter(SCOPE_FUNCTION | SCOPE_SUPER | (inClassScope ? SCOPE_CLASS : 0) | (allowDirectSuper ? SCOPE_DIRECT_SUPER : 0));
	    this.prodParam.enter(functionFlags(isAsync, node.generator));
	    this.parseFunctionParams(node, allowModifiers);
	    this.parseFunctionBodyAndFinish(node, type, true);
	    this.prodParam.exit();
	    this.scope.exit();
	    return node;
	  }

	  parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
	    if (isTuple) {
	      this.expectPlugin("recordAndTuple");
	    }

	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.inFSharpPipelineDirectBody = false;
	    const node = this.startNode();
	    this.next();
	    node.elements = this.parseExprList(close, !isTuple, refExpressionErrors, node);
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    return this.finishNode(node, isTuple ? "TupleExpression" : "ArrayExpression");
	  }

	  parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
	    this.scope.enter(SCOPE_FUNCTION | SCOPE_ARROW);
	    let flags = functionFlags(isAsync, false);

	    if (!this.match(5) && this.prodParam.hasIn) {
	      flags |= PARAM_IN;
	    }

	    this.prodParam.enter(flags);
	    this.initFunction(node, isAsync);
	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;

	    if (params) {
	      this.state.maybeInArrowParameters = true;
	      this.setArrowFunctionParameters(node, params, trailingCommaLoc);
	    }

	    this.state.maybeInArrowParameters = false;
	    this.parseFunctionBody(node, true);
	    this.prodParam.exit();
	    this.scope.exit();
	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    return this.finishNode(node, "ArrowFunctionExpression");
	  }

	  setArrowFunctionParameters(node, params, trailingCommaLoc) {
	    node.params = this.toAssignableList(params, trailingCommaLoc, false);
	  }

	  parseFunctionBodyAndFinish(node, type, isMethod = false) {
	    this.parseFunctionBody(node, false, isMethod);
	    this.finishNode(node, type);
	  }

	  parseFunctionBody(node, allowExpression, isMethod = false) {
	    const isExpression = allowExpression && !this.match(5);
	    this.expressionScope.enter(newExpressionScope());

	    if (isExpression) {
	      node.body = this.parseMaybeAssign();
	      this.checkParams(node, false, allowExpression, false);
	    } else {
	      const oldStrict = this.state.strict;
	      const oldLabels = this.state.labels;
	      this.state.labels = [];
	      this.prodParam.enter(this.prodParam.currentFlags() | PARAM_RETURN);
	      node.body = this.parseBlock(true, false, hasStrictModeDirective => {
	        const nonSimple = !this.isSimpleParamList(node.params);

	        if (hasStrictModeDirective && nonSimple) {
	          const errorOrigin = (node.kind === "method" || node.kind === "constructor") && !!node.key ? {
	            at: node.key.loc.end
	          } : {
	            node
	          };
	          this.raise(ErrorMessages.IllegalLanguageModeDirective, errorOrigin);
	        }

	        const strictModeChanged = !oldStrict && this.state.strict;
	        this.checkParams(node, !this.state.strict && !allowExpression && !isMethod && !nonSimple, allowExpression, strictModeChanged);

	        if (this.state.strict && node.id) {
	          this.checkLVal(node.id, "function name", BIND_OUTSIDE, undefined, undefined, strictModeChanged);
	        }
	      });
	      this.prodParam.exit();
	      this.state.labels = oldLabels;
	    }

	    this.expressionScope.exit();
	  }

	  isSimpleParamList(params) {
	    for (let i = 0, len = params.length; i < len; i++) {
	      if (params[i].type !== "Identifier") return false;
	    }

	    return true;
	  }

	  checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged = true) {
	    const checkClashes = new Set();

	    for (const param of node.params) {
	      this.checkLVal(param, "function parameter list", BIND_VAR, allowDuplicates ? null : checkClashes, undefined, strictModeChanged);
	    }
	  }

	  parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
	    const elts = [];
	    let first = true;

	    while (!this.eat(close)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);

	        if (this.match(close)) {
	          if (nodeForExtra) {
	            this.addTrailingCommaExtraToNode(nodeForExtra);
	          }

	          this.next();
	          break;
	        }
	      }

	      elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
	    }

	    return elts;
	  }

	  parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
	    let elt;

	    if (this.match(12)) {
	      if (!allowEmpty) {
	        this.raise(ErrorMessages.UnexpectedToken, {
	          at: this.state.curPosition()
	        }, ",");
	      }

	      elt = null;
	    } else if (this.match(21)) {
	      const spreadNodeStartPos = this.state.start;
	      const spreadNodeStartLoc = this.state.startLoc;
	      elt = this.parseParenItem(this.parseSpread(refExpressionErrors), spreadNodeStartPos, spreadNodeStartLoc);
	    } else if (this.match(17)) {
	      this.expectPlugin("partialApplication");

	      if (!allowPlaceholder) {
	        this.raise(ErrorMessages.UnexpectedArgumentPlaceholder, {
	          at: this.state.startLoc
	        });
	      }

	      const node = this.startNode();
	      this.next();
	      elt = this.finishNode(node, "ArgumentPlaceholder");
	    } else {
	      elt = this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem);
	    }

	    return elt;
	  }

	  parseIdentifier(liberal) {
	    const node = this.startNode();
	    const name = this.parseIdentifierName(node.start, liberal);
	    return this.createIdentifier(node, name);
	  }

	  createIdentifier(node, name) {
	    node.name = name;
	    node.loc.identifierName = name;
	    return this.finishNode(node, "Identifier");
	  }

	  parseIdentifierName(pos, liberal) {
	    let name;
	    const {
	      startLoc,
	      type
	    } = this.state;

	    if (tokenIsKeywordOrIdentifier(type)) {
	      name = this.state.value;
	    } else {
	      throw this.unexpected();
	    }

	    const tokenIsKeyword = tokenKeywordOrIdentifierIsKeyword(type);

	    if (liberal) {
	      if (tokenIsKeyword) {
	        this.replaceToken(128);
	      }
	    } else {
	      this.checkReservedWord(name, startLoc, tokenIsKeyword, false);
	    }

	    this.next();
	    return name;
	  }

	  checkReservedWord(word, startLoc, checkKeywords, isBinding) {
	    if (word.length > 10) {
	      return;
	    }

	    if (!canBeReservedWord(word)) {
	      return;
	    }

	    if (word === "yield") {
	      if (this.prodParam.hasYield) {
	        this.raise(ErrorMessages.YieldBindingIdentifier, {
	          at: startLoc
	        });
	        return;
	      }
	    } else if (word === "await") {
	      if (this.prodParam.hasAwait) {
	        this.raise(ErrorMessages.AwaitBindingIdentifier, {
	          at: startLoc
	        });
	        return;
	      }

	      if (this.scope.inStaticBlock) {
	        this.raise(ErrorMessages.AwaitBindingIdentifierInStaticBlock, {
	          at: startLoc
	        });
	        return;
	      }

	      this.expressionScope.recordAsyncArrowParametersError(ErrorMessages.AwaitBindingIdentifier, startLoc);
	    } else if (word === "arguments") {
	      if (this.scope.inClassAndNotInNonArrowFunction) {
	        this.raise(ErrorMessages.ArgumentsInClass, {
	          at: startLoc
	        });
	        return;
	      }
	    }

	    if (checkKeywords && isKeyword(word)) {
	      this.raise(ErrorMessages.UnexpectedKeyword, {
	        at: startLoc
	      }, word);
	      return;
	    }

	    const reservedTest = !this.state.strict ? isReservedWord : isBinding ? isStrictBindReservedWord : isStrictReservedWord;

	    if (reservedTest(word, this.inModule)) {
	      this.raise(ErrorMessages.UnexpectedReservedWord, {
	        at: startLoc
	      }, word);
	    }
	  }

	  isAwaitAllowed() {
	    if (this.prodParam.hasAwait) return true;

	    if (this.options.allowAwaitOutsideFunction && !this.scope.inFunction) {
	      return true;
	    }

	    return false;
	  }

	  parseAwait(startPos, startLoc) {
	    const node = this.startNodeAt(startPos, startLoc);
	    this.expressionScope.recordParameterInitializerError(node.loc.start, ErrorMessages.AwaitExpressionFormalParameter);

	    if (this.eat(55)) {
	      this.raise(ErrorMessages.ObsoleteAwaitStar, {
	        node
	      });
	    }

	    if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
	      if (this.isAmbiguousAwait()) {
	        this.ambiguousScriptDifferentAst = true;
	      } else {
	        this.sawUnambiguousESM = true;
	      }
	    }

	    if (!this.state.soloAwait) {
	      node.argument = this.parseMaybeUnary(null, true);
	    }

	    return this.finishNode(node, "AwaitExpression");
	  }

	  isAmbiguousAwait() {
	    if (this.hasPrecedingLineBreak()) return true;
	    const {
	      type
	    } = this.state;
	    return type === 53 || type === 10 || type === 0 || tokenIsTemplate(type) || type === 133 || type === 56 || this.hasPlugin("v8intrinsic") && type === 54;
	  }

	  parseYield() {
	    const node = this.startNode();
	    this.expressionScope.recordParameterInitializerError(node.loc.start, ErrorMessages.YieldInParameter);
	    this.next();
	    let delegating = false;
	    let argument = null;

	    if (!this.hasPrecedingLineBreak()) {
	      delegating = this.eat(55);

	      switch (this.state.type) {
	        case 13:
	        case 135:
	        case 8:
	        case 11:
	        case 3:
	        case 9:
	        case 14:
	        case 12:
	          if (!delegating) break;

	        default:
	          argument = this.parseMaybeAssign();
	      }
	    }

	    node.delegate = delegating;
	    node.argument = argument;
	    return this.finishNode(node, "YieldExpression");
	  }

	  checkPipelineAtInfixOperator(left, leftStartLoc) {
	    if (this.hasPlugin(["pipelineOperator", {
	      proposal: "smart"
	    }])) {
	      if (left.type === "SequenceExpression") {
	        this.raise(ErrorMessages.PipelineHeadSequenceExpression, {
	          at: leftStartLoc
	        });
	      }
	    }
	  }

	  parseSmartPipelineBodyInStyle(childExpr, startPos, startLoc) {
	    const bodyNode = this.startNodeAt(startPos, startLoc);

	    if (this.isSimpleReference(childExpr)) {
	      bodyNode.callee = childExpr;
	      return this.finishNode(bodyNode, "PipelineBareFunction");
	    } else {
	      this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
	      bodyNode.expression = childExpr;
	      return this.finishNode(bodyNode, "PipelineTopicExpression");
	    }
	  }

	  isSimpleReference(expression) {
	    switch (expression.type) {
	      case "MemberExpression":
	        return !expression.computed && this.isSimpleReference(expression.object);

	      case "Identifier":
	        return true;

	      default:
	        return false;
	    }
	  }

	  checkSmartPipeTopicBodyEarlyErrors(startLoc) {
	    if (this.match(19)) {
	      throw this.raise(ErrorMessages.PipelineBodyNoArrow, {
	        at: this.state.startLoc
	      });
	    }

	    if (!this.topicReferenceWasUsedInCurrentContext()) {
	      this.raise(ErrorMessages.PipelineTopicUnused, {
	        at: startLoc
	      });
	    }
	  }

	  withTopicBindingContext(callback) {
	    const outerContextTopicState = this.state.topicContext;
	    this.state.topicContext = {
	      maxNumOfResolvableTopics: 1,
	      maxTopicIndex: null
	    };

	    try {
	      return callback();
	    } finally {
	      this.state.topicContext = outerContextTopicState;
	    }
	  }

	  withSmartMixTopicForbiddingContext(callback) {
	    if (this.hasPlugin(["pipelineOperator", {
	      proposal: "smart"
	    }])) {
	      const outerContextTopicState = this.state.topicContext;
	      this.state.topicContext = {
	        maxNumOfResolvableTopics: 0,
	        maxTopicIndex: null
	      };

	      try {
	        return callback();
	      } finally {
	        this.state.topicContext = outerContextTopicState;
	      }
	    } else {
	      return callback();
	    }
	  }

	  withSoloAwaitPermittingContext(callback) {
	    const outerContextSoloAwaitState = this.state.soloAwait;
	    this.state.soloAwait = true;

	    try {
	      return callback();
	    } finally {
	      this.state.soloAwait = outerContextSoloAwaitState;
	    }
	  }

	  allowInAnd(callback) {
	    const flags = this.prodParam.currentFlags();
	    const prodParamToSet = PARAM_IN & ~flags;

	    if (prodParamToSet) {
	      this.prodParam.enter(flags | PARAM_IN);

	      try {
	        return callback();
	      } finally {
	        this.prodParam.exit();
	      }
	    }

	    return callback();
	  }

	  disallowInAnd(callback) {
	    const flags = this.prodParam.currentFlags();
	    const prodParamToClear = PARAM_IN & flags;

	    if (prodParamToClear) {
	      this.prodParam.enter(flags & ~PARAM_IN);

	      try {
	        return callback();
	      } finally {
	        this.prodParam.exit();
	      }
	    }

	    return callback();
	  }

	  registerTopicReference() {
	    this.state.topicContext.maxTopicIndex = 0;
	  }

	  topicReferenceIsAllowedInCurrentContext() {
	    return this.state.topicContext.maxNumOfResolvableTopics >= 1;
	  }

	  topicReferenceWasUsedInCurrentContext() {
	    return this.state.topicContext.maxTopicIndex != null && this.state.topicContext.maxTopicIndex >= 0;
	  }

	  parseFSharpPipelineBody(prec) {
	    const startPos = this.state.start;
	    const startLoc = this.state.startLoc;
	    this.state.potentialArrowAt = this.state.start;
	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.inFSharpPipelineDirectBody = true;
	    const ret = this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startPos, startLoc, prec);
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    return ret;
	  }

	  parseModuleExpression() {
	    this.expectPlugin("moduleBlocks");
	    const node = this.startNode();
	    this.next();
	    this.eat(5);
	    const revertScopes = this.initializeScopes(true);
	    this.enterInitialScopes();
	    const program = this.startNode();

	    try {
	      node.body = this.parseProgram(program, 8, "module");
	    } finally {
	      revertScopes();
	    }

	    this.eat(8);
	    return this.finishNode(node, "ModuleExpression");
	  }

	  parsePropertyNamePrefixOperator(prop) {}

	}

	const loopLabel = {
	  kind: "loop"
	},
	      switchLabel = {
	  kind: "switch"
	};
	const FUNC_NO_FLAGS = 0b000,
	      FUNC_STATEMENT = 0b001,
	      FUNC_HANGING_STATEMENT = 0b010,
	      FUNC_NULLABLE_ID = 0b100;
	const loneSurrogate = /[\uD800-\uDFFF]/u;
	const keywordRelationalOperator = /in(?:stanceof)?/y;

	function babel7CompatTokens(tokens, input) {
	  for (let i = 0; i < tokens.length; i++) {
	    const token = tokens[i];
	    const {
	      type
	    } = token;

	    if (typeof type === "number") {
	      if (!browser$5.env.BABEL_8_BREAKING) {
	        if (type === 134) {
	          const {
	            loc,
	            start,
	            value,
	            end
	          } = token;
	          const hashEndPos = start + 1;
	          const hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
	          tokens.splice(i, 1, new Token({
	            type: getExportedToken(27),
	            value: "#",
	            start: start,
	            end: hashEndPos,
	            startLoc: loc.start,
	            endLoc: hashEndLoc
	          }), new Token({
	            type: getExportedToken(128),
	            value: value,
	            start: hashEndPos,
	            end: end,
	            startLoc: hashEndLoc,
	            endLoc: loc.end
	          }));
	          i++;
	          continue;
	        }

	        if (tokenIsTemplate(type)) {
	          const {
	            loc,
	            start,
	            value,
	            end
	          } = token;
	          const backquoteEnd = start + 1;
	          const backquoteEndLoc = createPositionWithColumnOffset(loc.start, 1);
	          let startToken;

	          if (input.charCodeAt(start) === 96) {
	            startToken = new Token({
	              type: getExportedToken(22),
	              value: "`",
	              start: start,
	              end: backquoteEnd,
	              startLoc: loc.start,
	              endLoc: backquoteEndLoc
	            });
	          } else {
	            startToken = new Token({
	              type: getExportedToken(8),
	              value: "}",
	              start: start,
	              end: backquoteEnd,
	              startLoc: loc.start,
	              endLoc: backquoteEndLoc
	            });
	          }

	          let templateValue, templateElementEnd, templateElementEndLoc, endToken;

	          if (type === 24) {
	            templateElementEnd = end - 1;
	            templateElementEndLoc = createPositionWithColumnOffset(loc.end, -1);
	            templateValue = value === null ? null : value.slice(1, -1);
	            endToken = new Token({
	              type: getExportedToken(22),
	              value: "`",
	              start: templateElementEnd,
	              end: end,
	              startLoc: templateElementEndLoc,
	              endLoc: loc.end
	            });
	          } else {
	            templateElementEnd = end - 2;
	            templateElementEndLoc = createPositionWithColumnOffset(loc.end, -2);
	            templateValue = value === null ? null : value.slice(1, -2);
	            endToken = new Token({
	              type: getExportedToken(23),
	              value: "${",
	              start: templateElementEnd,
	              end: end,
	              startLoc: templateElementEndLoc,
	              endLoc: loc.end
	            });
	          }

	          tokens.splice(i, 1, startToken, new Token({
	            type: getExportedToken(20),
	            value: templateValue,
	            start: backquoteEnd,
	            end: templateElementEnd,
	            startLoc: backquoteEndLoc,
	            endLoc: templateElementEndLoc
	          }), endToken);
	          i += 2;
	          continue;
	        }
	      }

	      token.type = getExportedToken(type);
	    }
	  }

	  return tokens;
	}

	class StatementParser extends ExpressionParser {
	  parseTopLevel(file, program) {
	    file.program = this.parseProgram(program);
	    file.comments = this.state.comments;

	    if (this.options.tokens) {
	      file.tokens = babel7CompatTokens(this.tokens, this.input);
	    }

	    return this.finishNode(file, "File");
	  }

	  parseProgram(program, end = 135, sourceType = this.options.sourceType) {
	    program.sourceType = sourceType;
	    program.interpreter = this.parseInterpreterDirective();
	    this.parseBlockBody(program, true, true, end);

	    if (this.inModule && !this.options.allowUndeclaredExports && this.scope.undefinedExports.size > 0) {
	      for (const [name, loc] of Array.from(this.scope.undefinedExports)) {
	        this.raise(ErrorMessages.ModuleExportUndefined, {
	          at: loc
	        }, name);
	      }
	    }

	    return this.finishNode(program, "Program");
	  }

	  stmtToDirective(stmt) {
	    const directive = stmt;
	    directive.type = "Directive";
	    directive.value = directive.expression;
	    delete directive.expression;
	    const directiveLiteral = directive.value;
	    const expressionValue = directiveLiteral.value;
	    const raw = this.input.slice(directiveLiteral.start, directiveLiteral.end);
	    const val = directiveLiteral.value = raw.slice(1, -1);
	    this.addExtra(directiveLiteral, "raw", raw);
	    this.addExtra(directiveLiteral, "rawValue", val);
	    this.addExtra(directiveLiteral, "expressionValue", expressionValue);
	    directiveLiteral.type = "DirectiveLiteral";
	    return directive;
	  }

	  parseInterpreterDirective() {
	    if (!this.match(28)) {
	      return null;
	    }

	    const node = this.startNode();
	    node.value = this.state.value;
	    this.next();
	    return this.finishNode(node, "InterpreterDirective");
	  }

	  isLet(context) {
	    if (!this.isContextual(99)) {
	      return false;
	    }

	    return this.isLetKeyword(context);
	  }

	  isLetKeyword(context) {
	    const next = this.nextTokenStart();
	    const nextCh = this.codePointAtPos(next);

	    if (nextCh === 92 || nextCh === 91) {
	      return true;
	    }

	    if (context) return false;
	    if (nextCh === 123) return true;

	    if (isIdentifierStart(nextCh)) {
	      keywordRelationalOperator.lastIndex = next;

	      if (keywordRelationalOperator.test(this.input)) {
	        const endCh = this.codePointAtPos(keywordRelationalOperator.lastIndex);

	        if (!isIdentifierChar(endCh) && endCh !== 92) {
	          return false;
	        }
	      }

	      return true;
	    }

	    return false;
	  }

	  parseStatement(context, topLevel) {
	    if (this.match(26)) {
	      this.parseDecorators(true);
	    }

	    return this.parseStatementContent(context, topLevel);
	  }

	  parseStatementContent(context, topLevel) {
	    let starttype = this.state.type;
	    const node = this.startNode();
	    let kind;

	    if (this.isLet(context)) {
	      starttype = 74;
	      kind = "let";
	    }

	    switch (starttype) {
	      case 60:
	        return this.parseBreakContinueStatement(node, true);

	      case 63:
	        return this.parseBreakContinueStatement(node, false);

	      case 64:
	        return this.parseDebuggerStatement(node);

	      case 90:
	        return this.parseDoStatement(node);

	      case 91:
	        return this.parseForStatement(node);

	      case 68:
	        if (this.lookaheadCharCode() === 46) break;

	        if (context) {
	          if (this.state.strict) {
	            this.raise(ErrorMessages.StrictFunction, {
	              at: this.state.startLoc
	            });
	          } else if (context !== "if" && context !== "label") {
	            this.raise(ErrorMessages.SloppyFunction, {
	              at: this.state.startLoc
	            });
	          }
	        }

	        return this.parseFunctionStatement(node, false, !context);

	      case 80:
	        if (context) this.unexpected();
	        return this.parseClass(node, true);

	      case 69:
	        return this.parseIfStatement(node);

	      case 70:
	        return this.parseReturnStatement(node);

	      case 71:
	        return this.parseSwitchStatement(node);

	      case 72:
	        return this.parseThrowStatement(node);

	      case 73:
	        return this.parseTryStatement(node);

	      case 75:
	      case 74:
	        kind = kind || this.state.value;

	        if (context && kind !== "var") {
	          this.raise(ErrorMessages.UnexpectedLexicalDeclaration, {
	            at: this.state.startLoc
	          });
	        }

	        return this.parseVarStatement(node, kind);

	      case 92:
	        return this.parseWhileStatement(node);

	      case 76:
	        return this.parseWithStatement(node);

	      case 5:
	        return this.parseBlock();

	      case 13:
	        return this.parseEmptyStatement(node);

	      case 83:
	        {
	          const nextTokenCharCode = this.lookaheadCharCode();

	          if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
	            break;
	          }
	        }

	      case 82:
	        {
	          if (!this.options.allowImportExportEverywhere && !topLevel) {
	            this.raise(ErrorMessages.UnexpectedImportExport, {
	              at: this.state.startLoc
	            });
	          }

	          this.next();
	          let result;

	          if (starttype === 83) {
	            result = this.parseImport(node);

	            if (result.type === "ImportDeclaration" && (!result.importKind || result.importKind === "value")) {
	              this.sawUnambiguousESM = true;
	            }
	          } else {
	            result = this.parseExport(node);

	            if (result.type === "ExportNamedDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportAllDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportDefaultDeclaration") {
	              this.sawUnambiguousESM = true;
	            }
	          }

	          this.assertModuleNodeAllowed(node);
	          return result;
	        }

	      default:
	        {
	          if (this.isAsyncFunction()) {
	            if (context) {
	              this.raise(ErrorMessages.AsyncFunctionInSingleStatementContext, {
	                at: this.state.startLoc
	              });
	            }

	            this.next();
	            return this.parseFunctionStatement(node, true, !context);
	          }
	        }
	    }

	    const maybeName = this.state.value;
	    const expr = this.parseExpression();

	    if (tokenIsIdentifier(starttype) && expr.type === "Identifier" && this.eat(14)) {
	      return this.parseLabeledStatement(node, maybeName, expr, context);
	    } else {
	      return this.parseExpressionStatement(node, expr);
	    }
	  }

	  assertModuleNodeAllowed(node) {
	    if (!this.options.allowImportExportEverywhere && !this.inModule) {
	      this.raise(SourceTypeModuleErrorMessages.ImportOutsideModule, {
	        node
	      });
	    }
	  }

	  takeDecorators(node) {
	    const decorators = this.state.decoratorStack[this.state.decoratorStack.length - 1];

	    if (decorators.length) {
	      node.decorators = decorators;
	      this.resetStartLocationFromNode(node, decorators[0]);
	      this.state.decoratorStack[this.state.decoratorStack.length - 1] = [];
	    }
	  }

	  canHaveLeadingDecorator() {
	    return this.match(80);
	  }

	  parseDecorators(allowExport) {
	    const currentContextDecorators = this.state.decoratorStack[this.state.decoratorStack.length - 1];

	    while (this.match(26)) {
	      const decorator = this.parseDecorator();
	      currentContextDecorators.push(decorator);
	    }

	    if (this.match(82)) {
	      if (!allowExport) {
	        this.unexpected();
	      }

	      if (this.hasPlugin("decorators") && !this.getPluginOption("decorators", "decoratorsBeforeExport")) {
	        this.raise(ErrorMessages.DecoratorExportClass, {
	          at: this.state.startLoc
	        });
	      }
	    } else if (!this.canHaveLeadingDecorator()) {
	      throw this.raise(ErrorMessages.UnexpectedLeadingDecorator, {
	        at: this.state.startLoc
	      });
	    }
	  }

	  parseDecorator() {
	    this.expectOnePlugin(["decorators-legacy", "decorators"]);
	    const node = this.startNode();
	    this.next();

	    if (this.hasPlugin("decorators")) {
	      this.state.decoratorStack.push([]);
	      const startPos = this.state.start;
	      const startLoc = this.state.startLoc;
	      let expr;

	      if (this.eat(10)) {
	        expr = this.parseExpression();
	        this.expect(11);
	      } else {
	        expr = this.parseIdentifier(false);

	        while (this.eat(16)) {
	          const node = this.startNodeAt(startPos, startLoc);
	          node.object = expr;
	          node.property = this.parseIdentifier(true);
	          node.computed = false;
	          expr = this.finishNode(node, "MemberExpression");
	        }
	      }

	      node.expression = this.parseMaybeDecoratorArguments(expr);
	      this.state.decoratorStack.pop();
	    } else {
	      node.expression = this.parseExprSubscripts();
	    }

	    return this.finishNode(node, "Decorator");
	  }

	  parseMaybeDecoratorArguments(expr) {
	    if (this.eat(10)) {
	      const node = this.startNodeAtNode(expr);
	      node.callee = expr;
	      node.arguments = this.parseCallExpressionArguments(11, false);
	      this.toReferencedList(node.arguments);
	      return this.finishNode(node, "CallExpression");
	    }

	    return expr;
	  }

	  parseBreakContinueStatement(node, isBreak) {
	    this.next();

	    if (this.isLineTerminator()) {
	      node.label = null;
	    } else {
	      node.label = this.parseIdentifier();
	      this.semicolon();
	    }

	    this.verifyBreakContinue(node, isBreak);
	    return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
	  }

	  verifyBreakContinue(node, isBreak) {
	    let i;

	    for (i = 0; i < this.state.labels.length; ++i) {
	      const lab = this.state.labels[i];

	      if (node.label == null || lab.name === node.label.name) {
	        if (lab.kind != null && (isBreak || lab.kind === "loop")) break;
	        if (node.label && isBreak) break;
	      }
	    }

	    if (i === this.state.labels.length) {
	      this.raise(ErrorMessages.IllegalBreakContinue, {
	        node
	      }, isBreak ? "break" : "continue");
	    }
	  }

	  parseDebuggerStatement(node) {
	    this.next();
	    this.semicolon();
	    return this.finishNode(node, "DebuggerStatement");
	  }

	  parseHeaderExpression() {
	    this.expect(10);
	    const val = this.parseExpression();
	    this.expect(11);
	    return val;
	  }

	  parseDoStatement(node) {
	    this.next();
	    this.state.labels.push(loopLabel);
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("do"));
	    this.state.labels.pop();
	    this.expect(92);
	    node.test = this.parseHeaderExpression();
	    this.eat(13);
	    return this.finishNode(node, "DoWhileStatement");
	  }

	  parseForStatement(node) {
	    this.next();
	    this.state.labels.push(loopLabel);
	    let awaitAt = null;

	    if (this.isAwaitAllowed() && this.eatContextual(96)) {
	      awaitAt = this.state.lastTokStartLoc;
	    }

	    this.scope.enter(SCOPE_OTHER);
	    this.expect(10);

	    if (this.match(13)) {
	      if (awaitAt !== null) {
	        this.unexpected(awaitAt);
	      }

	      return this.parseFor(node, null);
	    }

	    const startsWithLet = this.isContextual(99);
	    const isLet = startsWithLet && this.isLetKeyword();

	    if (this.match(74) || this.match(75) || isLet) {
	      const init = this.startNode();
	      const kind = isLet ? "let" : this.state.value;
	      this.next();
	      this.parseVar(init, true, kind);
	      this.finishNode(init, "VariableDeclaration");

	      if ((this.match(58) || this.isContextual(101)) && init.declarations.length === 1) {
	        return this.parseForIn(node, init, awaitAt);
	      }

	      if (awaitAt !== null) {
	        this.unexpected(awaitAt);
	      }

	      return this.parseFor(node, init);
	    }

	    const startsWithAsync = this.isContextual(95);
	    const refExpressionErrors = new ExpressionErrors();
	    const init = this.parseExpression(true, refExpressionErrors);
	    const isForOf = this.isContextual(101);

	    if (isForOf) {
	      if (startsWithLet) {
	        this.raise(ErrorMessages.ForOfLet, {
	          node: init
	        });
	      }

	      if (awaitAt === null && startsWithAsync && init.type === "Identifier") {
	        this.raise(ErrorMessages.ForOfAsync, {
	          node: init
	        });
	      }
	    }

	    if (isForOf || this.match(58)) {
	      this.checkDestructuringPrivate(refExpressionErrors);
	      this.toAssignable(init, true);
	      const description = isForOf ? "for-of statement" : "for-in statement";
	      this.checkLVal(init, description);
	      return this.parseForIn(node, init, awaitAt);
	    } else {
	      this.checkExpressionErrors(refExpressionErrors, true);
	    }

	    if (awaitAt !== null) {
	      this.unexpected(awaitAt);
	    }

	    return this.parseFor(node, init);
	  }

	  parseFunctionStatement(node, isAsync, declarationPosition) {
	    this.next();
	    return this.parseFunction(node, FUNC_STATEMENT | (declarationPosition ? 0 : FUNC_HANGING_STATEMENT), isAsync);
	  }

	  parseIfStatement(node) {
	    this.next();
	    node.test = this.parseHeaderExpression();
	    node.consequent = this.parseStatement("if");
	    node.alternate = this.eat(66) ? this.parseStatement("if") : null;
	    return this.finishNode(node, "IfStatement");
	  }

	  parseReturnStatement(node) {
	    if (!this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction) {
	      this.raise(ErrorMessages.IllegalReturn, {
	        at: this.state.startLoc
	      });
	    }

	    this.next();

	    if (this.isLineTerminator()) {
	      node.argument = null;
	    } else {
	      node.argument = this.parseExpression();
	      this.semicolon();
	    }

	    return this.finishNode(node, "ReturnStatement");
	  }

	  parseSwitchStatement(node) {
	    this.next();
	    node.discriminant = this.parseHeaderExpression();
	    const cases = node.cases = [];
	    this.expect(5);
	    this.state.labels.push(switchLabel);
	    this.scope.enter(SCOPE_OTHER);
	    let cur;

	    for (let sawDefault; !this.match(8);) {
	      if (this.match(61) || this.match(65)) {
	        const isCase = this.match(61);
	        if (cur) this.finishNode(cur, "SwitchCase");
	        cases.push(cur = this.startNode());
	        cur.consequent = [];
	        this.next();

	        if (isCase) {
	          cur.test = this.parseExpression();
	        } else {
	          if (sawDefault) {
	            this.raise(ErrorMessages.MultipleDefaultsInSwitch, {
	              at: this.state.lastTokStartLoc
	            });
	          }

	          sawDefault = true;
	          cur.test = null;
	        }

	        this.expect(14);
	      } else {
	        if (cur) {
	          cur.consequent.push(this.parseStatement(null));
	        } else {
	          this.unexpected();
	        }
	      }
	    }

	    this.scope.exit();
	    if (cur) this.finishNode(cur, "SwitchCase");
	    this.next();
	    this.state.labels.pop();
	    return this.finishNode(node, "SwitchStatement");
	  }

	  parseThrowStatement(node) {
	    this.next();

	    if (this.hasPrecedingLineBreak()) {
	      this.raise(ErrorMessages.NewlineAfterThrow, {
	        at: this.state.lastTokEndLoc
	      });
	    }

	    node.argument = this.parseExpression();
	    this.semicolon();
	    return this.finishNode(node, "ThrowStatement");
	  }

	  parseCatchClauseParam() {
	    const param = this.parseBindingAtom();
	    const simple = param.type === "Identifier";
	    this.scope.enter(simple ? SCOPE_SIMPLE_CATCH : 0);
	    this.checkLVal(param, "catch clause", BIND_LEXICAL);
	    return param;
	  }

	  parseTryStatement(node) {
	    this.next();
	    node.block = this.parseBlock();
	    node.handler = null;

	    if (this.match(62)) {
	      const clause = this.startNode();
	      this.next();

	      if (this.match(10)) {
	        this.expect(10);
	        clause.param = this.parseCatchClauseParam();
	        this.expect(11);
	      } else {
	        clause.param = null;
	        this.scope.enter(SCOPE_OTHER);
	      }

	      clause.body = this.withSmartMixTopicForbiddingContext(() => this.parseBlock(false, false));
	      this.scope.exit();
	      node.handler = this.finishNode(clause, "CatchClause");
	    }

	    node.finalizer = this.eat(67) ? this.parseBlock() : null;

	    if (!node.handler && !node.finalizer) {
	      this.raise(ErrorMessages.NoCatchOrFinally, {
	        node
	      });
	    }

	    return this.finishNode(node, "TryStatement");
	  }

	  parseVarStatement(node, kind) {
	    this.next();
	    this.parseVar(node, false, kind);
	    this.semicolon();
	    return this.finishNode(node, "VariableDeclaration");
	  }

	  parseWhileStatement(node) {
	    this.next();
	    node.test = this.parseHeaderExpression();
	    this.state.labels.push(loopLabel);
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("while"));
	    this.state.labels.pop();
	    return this.finishNode(node, "WhileStatement");
	  }

	  parseWithStatement(node) {
	    if (this.state.strict) {
	      this.raise(ErrorMessages.StrictWith, {
	        at: this.state.startLoc
	      });
	    }

	    this.next();
	    node.object = this.parseHeaderExpression();
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("with"));
	    return this.finishNode(node, "WithStatement");
	  }

	  parseEmptyStatement(node) {
	    this.next();
	    return this.finishNode(node, "EmptyStatement");
	  }

	  parseLabeledStatement(node, maybeName, expr, context) {
	    for (const label of this.state.labels) {
	      if (label.name === maybeName) {
	        this.raise(ErrorMessages.LabelRedeclaration, {
	          node: expr
	        }, maybeName);
	      }
	    }

	    const kind = tokenIsLoop(this.state.type) ? "loop" : this.match(71) ? "switch" : null;

	    for (let i = this.state.labels.length - 1; i >= 0; i--) {
	      const label = this.state.labels[i];

	      if (label.statementStart === node.start) {
	        label.statementStart = this.state.start;
	        label.kind = kind;
	      } else {
	        break;
	      }
	    }

	    this.state.labels.push({
	      name: maybeName,
	      kind: kind,
	      statementStart: this.state.start
	    });
	    node.body = this.parseStatement(context ? context.indexOf("label") === -1 ? context + "label" : context : "label");
	    this.state.labels.pop();
	    node.label = expr;
	    return this.finishNode(node, "LabeledStatement");
	  }

	  parseExpressionStatement(node, expr) {
	    node.expression = expr;
	    this.semicolon();
	    return this.finishNode(node, "ExpressionStatement");
	  }

	  parseBlock(allowDirectives = false, createNewLexicalScope = true, afterBlockParse) {
	    const node = this.startNode();

	    if (allowDirectives) {
	      this.state.strictErrors.clear();
	    }

	    this.expect(5);

	    if (createNewLexicalScope) {
	      this.scope.enter(SCOPE_OTHER);
	    }

	    this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);

	    if (createNewLexicalScope) {
	      this.scope.exit();
	    }

	    return this.finishNode(node, "BlockStatement");
	  }

	  isValidDirective(stmt) {
	    return stmt.type === "ExpressionStatement" && stmt.expression.type === "StringLiteral" && !stmt.expression.extra.parenthesized;
	  }

	  parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
	    const body = node.body = [];
	    const directives = node.directives = [];
	    this.parseBlockOrModuleBlockBody(body, allowDirectives ? directives : undefined, topLevel, end, afterBlockParse);
	  }

	  parseBlockOrModuleBlockBody(body, directives, topLevel, end, afterBlockParse) {
	    const oldStrict = this.state.strict;
	    let hasStrictModeDirective = false;
	    let parsedNonDirective = false;

	    while (!this.match(end)) {
	      const stmt = this.parseStatement(null, topLevel);

	      if (directives && !parsedNonDirective) {
	        if (this.isValidDirective(stmt)) {
	          const directive = this.stmtToDirective(stmt);
	          directives.push(directive);

	          if (!hasStrictModeDirective && directive.value.value === "use strict") {
	            hasStrictModeDirective = true;
	            this.setStrict(true);
	          }

	          continue;
	        }

	        parsedNonDirective = true;
	        this.state.strictErrors.clear();
	      }

	      body.push(stmt);
	    }

	    if (afterBlockParse) {
	      afterBlockParse.call(this, hasStrictModeDirective);
	    }

	    if (!oldStrict) {
	      this.setStrict(false);
	    }

	    this.next();
	  }

	  parseFor(node, init) {
	    node.init = init;
	    this.semicolon(false);
	    node.test = this.match(13) ? null : this.parseExpression();
	    this.semicolon(false);
	    node.update = this.match(11) ? null : this.parseExpression();
	    this.expect(11);
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("for"));
	    this.scope.exit();
	    this.state.labels.pop();
	    return this.finishNode(node, "ForStatement");
	  }

	  parseForIn(node, init, awaitAt) {
	    const isForIn = this.match(58);
	    this.next();

	    if (isForIn) {
	      if (awaitAt !== null) this.unexpected(awaitAt);
	    } else {
	      node.await = awaitAt !== null;
	    }

	    if (init.type === "VariableDeclaration" && init.declarations[0].init != null && (!isForIn || this.state.strict || init.kind !== "var" || init.declarations[0].id.type !== "Identifier")) {
	      this.raise(ErrorMessages.ForInOfLoopInitializer, {
	        node: init
	      }, isForIn ? "for-in" : "for-of");
	    }

	    if (init.type === "AssignmentPattern") {
	      this.raise(ErrorMessages.InvalidLhs, {
	        node: init
	      }, "for-loop");
	    }

	    node.left = init;
	    node.right = isForIn ? this.parseExpression() : this.parseMaybeAssignAllowIn();
	    this.expect(11);
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("for"));
	    this.scope.exit();
	    this.state.labels.pop();
	    return this.finishNode(node, isForIn ? "ForInStatement" : "ForOfStatement");
	  }

	  parseVar(node, isFor, kind) {
	    const declarations = node.declarations = [];
	    const isTypescript = this.hasPlugin("typescript");
	    node.kind = kind;

	    for (;;) {
	      const decl = this.startNode();
	      this.parseVarId(decl, kind);

	      if (this.eat(29)) {
	        decl.init = isFor ? this.parseMaybeAssignDisallowIn() : this.parseMaybeAssignAllowIn();
	      } else {
	        if (kind === "const" && !(this.match(58) || this.isContextual(101))) {
	          if (!isTypescript) {
	            this.raise(ErrorMessages.DeclarationMissingInitializer, {
	              at: this.state.lastTokEndLoc
	            }, "Const declarations");
	          }
	        } else if (decl.id.type !== "Identifier" && !(isFor && (this.match(58) || this.isContextual(101)))) {
	          this.raise(ErrorMessages.DeclarationMissingInitializer, {
	            at: this.state.lastTokEndLoc
	          }, "Complex binding patterns");
	        }

	        decl.init = null;
	      }

	      declarations.push(this.finishNode(decl, "VariableDeclarator"));
	      if (!this.eat(12)) break;
	    }

	    return node;
	  }

	  parseVarId(decl, kind) {
	    decl.id = this.parseBindingAtom();
	    this.checkLVal(decl.id, "variable declaration", kind === "var" ? BIND_VAR : BIND_LEXICAL, undefined, kind !== "var");
	  }

	  parseFunction(node, statement = FUNC_NO_FLAGS, isAsync = false) {
	    const isStatement = statement & FUNC_STATEMENT;
	    const isHangingStatement = statement & FUNC_HANGING_STATEMENT;
	    const requireId = !!isStatement && !(statement & FUNC_NULLABLE_ID);
	    this.initFunction(node, isAsync);

	    if (this.match(55) && isHangingStatement) {
	      this.raise(ErrorMessages.GeneratorInSingleStatementContext, {
	        at: this.state.startLoc
	      });
	    }

	    node.generator = this.eat(55);

	    if (isStatement) {
	      node.id = this.parseFunctionId(requireId);
	    }

	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    this.state.maybeInArrowParameters = false;
	    this.scope.enter(SCOPE_FUNCTION);
	    this.prodParam.enter(functionFlags(isAsync, node.generator));

	    if (!isStatement) {
	      node.id = this.parseFunctionId();
	    }

	    this.parseFunctionParams(node, false);
	    this.withSmartMixTopicForbiddingContext(() => {
	      this.parseFunctionBodyAndFinish(node, isStatement ? "FunctionDeclaration" : "FunctionExpression");
	    });
	    this.prodParam.exit();
	    this.scope.exit();

	    if (isStatement && !isHangingStatement) {
	      this.registerFunctionStatementId(node);
	    }

	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    return node;
	  }

	  parseFunctionId(requireId) {
	    return requireId || tokenIsIdentifier(this.state.type) ? this.parseIdentifier() : null;
	  }

	  parseFunctionParams(node, allowModifiers) {
	    this.expect(10);
	    this.expressionScope.enter(newParameterDeclarationScope());
	    node.params = this.parseBindingList(11, 41, false, allowModifiers);
	    this.expressionScope.exit();
	  }

	  registerFunctionStatementId(node) {
	    if (!node.id) return;
	    this.scope.declareName(node.id.name, this.state.strict || node.generator || node.async ? this.scope.treatFunctionsAsVar ? BIND_VAR : BIND_LEXICAL : BIND_FUNCTION, node.id.loc.start);
	  }

	  parseClass(node, isStatement, optionalId) {
	    this.next();
	    this.takeDecorators(node);
	    const oldStrict = this.state.strict;
	    this.state.strict = true;
	    this.parseClassId(node, isStatement, optionalId);
	    this.parseClassSuper(node);
	    node.body = this.parseClassBody(!!node.superClass, oldStrict);
	    return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression");
	  }

	  isClassProperty() {
	    return this.match(29) || this.match(13) || this.match(8);
	  }

	  isClassMethod() {
	    return this.match(10);
	  }

	  isNonstaticConstructor(method) {
	    return !method.computed && !method.static && (method.key.name === "constructor" || method.key.value === "constructor");
	  }

	  parseClassBody(hadSuperClass, oldStrict) {
	    this.classScope.enter();
	    const state = {
	      hadConstructor: false,
	      hadSuperClass
	    };
	    let decorators = [];
	    const classBody = this.startNode();
	    classBody.body = [];
	    this.expect(5);
	    this.withSmartMixTopicForbiddingContext(() => {
	      while (!this.match(8)) {
	        if (this.eat(13)) {
	          if (decorators.length > 0) {
	            throw this.raise(ErrorMessages.DecoratorSemicolon, {
	              at: this.state.lastTokEndLoc
	            });
	          }

	          continue;
	        }

	        if (this.match(26)) {
	          decorators.push(this.parseDecorator());
	          continue;
	        }

	        const member = this.startNode();

	        if (decorators.length) {
	          member.decorators = decorators;
	          this.resetStartLocationFromNode(member, decorators[0]);
	          decorators = [];
	        }

	        this.parseClassMember(classBody, member, state);

	        if (member.kind === "constructor" && member.decorators && member.decorators.length > 0) {
	          this.raise(ErrorMessages.DecoratorConstructor, {
	            node: member
	          });
	        }
	      }
	    });
	    this.state.strict = oldStrict;
	    this.next();

	    if (decorators.length) {
	      throw this.raise(ErrorMessages.TrailingDecorator, {
	        at: this.state.startLoc
	      });
	    }

	    this.classScope.exit();
	    return this.finishNode(classBody, "ClassBody");
	  }

	  parseClassMemberFromModifier(classBody, member) {
	    const key = this.parseIdentifier(true);

	    if (this.isClassMethod()) {
	      const method = member;
	      method.kind = "method";
	      method.computed = false;
	      method.key = key;
	      method.static = false;
	      this.pushClassMethod(classBody, method, false, false, false, false);
	      return true;
	    } else if (this.isClassProperty()) {
	      const prop = member;
	      prop.computed = false;
	      prop.key = key;
	      prop.static = false;
	      classBody.body.push(this.parseClassProperty(prop));
	      return true;
	    }

	    this.resetPreviousNodeTrailingComments(key);
	    return false;
	  }

	  parseClassMember(classBody, member, state) {
	    const isStatic = this.isContextual(104);

	    if (isStatic) {
	      if (this.parseClassMemberFromModifier(classBody, member)) {
	        return;
	      }

	      if (this.eat(5)) {
	        this.parseClassStaticBlock(classBody, member);
	        return;
	      }
	    }

	    this.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
	  }

	  parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
	    const publicMethod = member;
	    const privateMethod = member;
	    const publicProp = member;
	    const privateProp = member;
	    const accessorProp = member;
	    const method = publicMethod;
	    const publicMember = publicMethod;
	    member.static = isStatic;
	    this.parsePropertyNamePrefixOperator(member);

	    if (this.eat(55)) {
	      method.kind = "method";
	      const isPrivateName = this.match(134);
	      this.parseClassElementName(method);

	      if (isPrivateName) {
	        this.pushClassPrivateMethod(classBody, privateMethod, true, false);
	        return;
	      }

	      if (this.isNonstaticConstructor(publicMethod)) {
	        this.raise(ErrorMessages.ConstructorIsGenerator, {
	          node: publicMethod.key
	        });
	      }

	      this.pushClassMethod(classBody, publicMethod, true, false, false, false);
	      return;
	    }

	    const isContextual = tokenIsIdentifier(this.state.type) && !this.state.containsEsc;
	    const isPrivate = this.match(134);
	    const key = this.parseClassElementName(member);
	    const maybeQuestionTokenStartLoc = this.state.startLoc;
	    this.parsePostMemberNameModifiers(publicMember);

	    if (this.isClassMethod()) {
	      method.kind = "method";

	      if (isPrivate) {
	        this.pushClassPrivateMethod(classBody, privateMethod, false, false);
	        return;
	      }

	      const isConstructor = this.isNonstaticConstructor(publicMethod);
	      let allowsDirectSuper = false;

	      if (isConstructor) {
	        publicMethod.kind = "constructor";

	        if (state.hadConstructor && !this.hasPlugin("typescript")) {
	          this.raise(ErrorMessages.DuplicateConstructor, {
	            node: key
	          });
	        }

	        if (isConstructor && this.hasPlugin("typescript") && member.override) {
	          this.raise(ErrorMessages.OverrideOnConstructor, {
	            node: key
	          });
	        }

	        state.hadConstructor = true;
	        allowsDirectSuper = state.hadSuperClass;
	      }

	      this.pushClassMethod(classBody, publicMethod, false, false, isConstructor, allowsDirectSuper);
	    } else if (this.isClassProperty()) {
	      if (isPrivate) {
	        this.pushClassPrivateProperty(classBody, privateProp);
	      } else {
	        this.pushClassProperty(classBody, publicProp);
	      }
	    } else if (isContextual && key.name === "async" && !this.isLineTerminator()) {
	      this.resetPreviousNodeTrailingComments(key);
	      const isGenerator = this.eat(55);

	      if (publicMember.optional) {
	        this.unexpected(maybeQuestionTokenStartLoc);
	      }

	      method.kind = "method";
	      const isPrivate = this.match(134);
	      this.parseClassElementName(method);
	      this.parsePostMemberNameModifiers(publicMember);

	      if (isPrivate) {
	        this.pushClassPrivateMethod(classBody, privateMethod, isGenerator, true);
	      } else {
	        if (this.isNonstaticConstructor(publicMethod)) {
	          this.raise(ErrorMessages.ConstructorIsAsync, {
	            node: publicMethod.key
	          });
	        }

	        this.pushClassMethod(classBody, publicMethod, isGenerator, true, false, false);
	      }
	    } else if (isContextual && (key.name === "get" || key.name === "set") && !(this.match(55) && this.isLineTerminator())) {
	      this.resetPreviousNodeTrailingComments(key);
	      method.kind = key.name;
	      const isPrivate = this.match(134);
	      this.parseClassElementName(publicMethod);

	      if (isPrivate) {
	        this.pushClassPrivateMethod(classBody, privateMethod, false, false);
	      } else {
	        if (this.isNonstaticConstructor(publicMethod)) {
	          this.raise(ErrorMessages.ConstructorIsAccessor, {
	            node: publicMethod.key
	          });
	        }

	        this.pushClassMethod(classBody, publicMethod, false, false, false, false);
	      }

	      this.checkGetterSetterParams(publicMethod);
	    } else if (isContextual && key.name === "accessor" && !this.isLineTerminator()) {
	      this.expectPlugin("decoratorAutoAccessors");
	      this.resetPreviousNodeTrailingComments(key);
	      const isPrivate = this.match(134);
	      this.parseClassElementName(publicProp);
	      this.pushClassAccessorProperty(classBody, accessorProp, isPrivate);
	    } else if (this.isLineTerminator()) {
	      if (isPrivate) {
	        this.pushClassPrivateProperty(classBody, privateProp);
	      } else {
	        this.pushClassProperty(classBody, publicProp);
	      }
	    } else {
	      this.unexpected();
	    }
	  }

	  parseClassElementName(member) {
	    const {
	      type,
	      value
	    } = this.state;

	    if ((type === 128 || type === 129) && member.static && value === "prototype") {
	      this.raise(ErrorMessages.StaticPrototype, {
	        at: this.state.startLoc
	      });
	    }

	    if (type === 134) {
	      if (value === "constructor") {
	        this.raise(ErrorMessages.ConstructorClassPrivateField, {
	          at: this.state.startLoc
	        });
	      }

	      const key = this.parsePrivateName();
	      member.key = key;
	      return key;
	    }

	    return this.parsePropertyName(member);
	  }

	  parseClassStaticBlock(classBody, member) {
	    this.scope.enter(SCOPE_CLASS | SCOPE_STATIC_BLOCK | SCOPE_SUPER);
	    const oldLabels = this.state.labels;
	    this.state.labels = [];
	    this.prodParam.enter(PARAM);
	    const body = member.body = [];
	    this.parseBlockOrModuleBlockBody(body, undefined, false, 8);
	    this.prodParam.exit();
	    this.scope.exit();
	    this.state.labels = oldLabels;
	    classBody.body.push(this.finishNode(member, "StaticBlock"));

	    if (member.decorators?.length) {
	      this.raise(ErrorMessages.DecoratorStaticBlock, {
	        node: member
	      });
	    }
	  }

	  pushClassProperty(classBody, prop) {
	    if (!prop.computed && (prop.key.name === "constructor" || prop.key.value === "constructor")) {
	      this.raise(ErrorMessages.ConstructorClassField, {
	        node: prop.key
	      });
	    }

	    classBody.body.push(this.parseClassProperty(prop));
	  }

	  pushClassPrivateProperty(classBody, prop) {
	    const node = this.parseClassPrivateProperty(prop);
	    classBody.body.push(node);
	    this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), CLASS_ELEMENT_OTHER, node.key.loc.start);
	  }

	  pushClassAccessorProperty(classBody, prop, isPrivate) {
	    if (!isPrivate && !prop.computed) {
	      const key = prop.key;

	      if (key.name === "constructor" || key.value === "constructor") {
	        this.raise(ErrorMessages.ConstructorClassField, {
	          node: key
	        });
	      }
	    }

	    const node = this.parseClassAccessorProperty(prop);
	    classBody.body.push(node);

	    if (isPrivate) {
	      this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), CLASS_ELEMENT_OTHER, node.key.loc.start);
	    }
	  }

	  pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
	    classBody.body.push(this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true));
	  }

	  pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
	    const node = this.parseMethod(method, isGenerator, isAsync, false, false, "ClassPrivateMethod", true);
	    classBody.body.push(node);
	    const kind = node.kind === "get" ? node.static ? CLASS_ELEMENT_STATIC_GETTER : CLASS_ELEMENT_INSTANCE_GETTER : node.kind === "set" ? node.static ? CLASS_ELEMENT_STATIC_SETTER : CLASS_ELEMENT_INSTANCE_SETTER : CLASS_ELEMENT_OTHER;
	    this.declareClassPrivateMethodInScope(node, kind);
	  }

	  declareClassPrivateMethodInScope(node, kind) {
	    this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), kind, node.key.loc.start);
	  }

	  parsePostMemberNameModifiers(methodOrProp) {}

	  parseClassPrivateProperty(node) {
	    this.parseInitializer(node);
	    this.semicolon();
	    return this.finishNode(node, "ClassPrivateProperty");
	  }

	  parseClassProperty(node) {
	    this.parseInitializer(node);
	    this.semicolon();
	    return this.finishNode(node, "ClassProperty");
	  }

	  parseClassAccessorProperty(node) {
	    this.parseInitializer(node);
	    this.semicolon();
	    return this.finishNode(node, "ClassAccessorProperty");
	  }

	  parseInitializer(node) {
	    this.scope.enter(SCOPE_CLASS | SCOPE_SUPER);
	    this.expressionScope.enter(newExpressionScope());
	    this.prodParam.enter(PARAM);
	    node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
	    this.expressionScope.exit();
	    this.prodParam.exit();
	    this.scope.exit();
	  }

	  parseClassId(node, isStatement, optionalId, bindingType = BIND_CLASS) {
	    if (tokenIsIdentifier(this.state.type)) {
	      node.id = this.parseIdentifier();

	      if (isStatement) {
	        this.checkLVal(node.id, "class name", bindingType);
	      }
	    } else {
	      if (optionalId || !isStatement) {
	        node.id = null;
	      } else {
	        throw this.raise(ErrorMessages.MissingClassName, {
	          at: this.state.startLoc
	        });
	      }
	    }
	  }

	  parseClassSuper(node) {
	    node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
	  }

	  parseExport(node) {
	    const hasDefault = this.maybeParseExportDefaultSpecifier(node);
	    const parseAfterDefault = !hasDefault || this.eat(12);
	    const hasStar = parseAfterDefault && this.eatExportStar(node);
	    const hasNamespace = hasStar && this.maybeParseExportNamespaceSpecifier(node);
	    const parseAfterNamespace = parseAfterDefault && (!hasNamespace || this.eat(12));
	    const isFromRequired = hasDefault || hasStar;

	    if (hasStar && !hasNamespace) {
	      if (hasDefault) this.unexpected();
	      this.parseExportFrom(node, true);
	      return this.finishNode(node, "ExportAllDeclaration");
	    }

	    const hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);

	    if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers || hasNamespace && parseAfterNamespace && !hasSpecifiers) {
	      throw this.unexpected(null, 5);
	    }

	    let hasDeclaration;

	    if (isFromRequired || hasSpecifiers) {
	      hasDeclaration = false;
	      this.parseExportFrom(node, isFromRequired);
	    } else {
	      hasDeclaration = this.maybeParseExportDeclaration(node);
	    }

	    if (isFromRequired || hasSpecifiers || hasDeclaration) {
	      this.checkExport(node, true, false, !!node.source);
	      return this.finishNode(node, "ExportNamedDeclaration");
	    }

	    if (this.eat(65)) {
	      node.declaration = this.parseExportDefaultExpression();
	      this.checkExport(node, true, true);
	      return this.finishNode(node, "ExportDefaultDeclaration");
	    }

	    throw this.unexpected(null, 5);
	  }

	  eatExportStar(node) {
	    return this.eat(55);
	  }

	  maybeParseExportDefaultSpecifier(node) {
	    if (this.isExportDefaultSpecifier()) {
	      this.expectPlugin("exportDefaultFrom");
	      const specifier = this.startNode();
	      specifier.exported = this.parseIdentifier(true);
	      node.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
	      return true;
	    }

	    return false;
	  }

	  maybeParseExportNamespaceSpecifier(node) {
	    if (this.isContextual(93)) {
	      if (!node.specifiers) node.specifiers = [];
	      const specifier = this.startNodeAt(this.state.lastTokStart, this.state.lastTokStartLoc);
	      this.next();
	      specifier.exported = this.parseModuleExportName();
	      node.specifiers.push(this.finishNode(specifier, "ExportNamespaceSpecifier"));
	      return true;
	    }

	    return false;
	  }

	  maybeParseExportNamedSpecifiers(node) {
	    if (this.match(5)) {
	      if (!node.specifiers) node.specifiers = [];
	      const isTypeExport = node.exportKind === "type";
	      node.specifiers.push(...this.parseExportSpecifiers(isTypeExport));
	      node.source = null;
	      node.declaration = null;

	      if (this.hasPlugin("importAssertions")) {
	        node.assertions = [];
	      }

	      return true;
	    }

	    return false;
	  }

	  maybeParseExportDeclaration(node) {
	    if (this.shouldParseExportDeclaration()) {
	      node.specifiers = [];
	      node.source = null;

	      if (this.hasPlugin("importAssertions")) {
	        node.assertions = [];
	      }

	      node.declaration = this.parseExportDeclaration(node);
	      return true;
	    }

	    return false;
	  }

	  isAsyncFunction() {
	    if (!this.isContextual(95)) return false;
	    const next = this.nextTokenStart();
	    return !lineBreak.test(this.input.slice(this.state.pos, next)) && this.isUnparsedContextual(next, "function");
	  }

	  parseExportDefaultExpression() {
	    const expr = this.startNode();
	    const isAsync = this.isAsyncFunction();

	    if (this.match(68) || isAsync) {
	      this.next();

	      if (isAsync) {
	        this.next();
	      }

	      return this.parseFunction(expr, FUNC_STATEMENT | FUNC_NULLABLE_ID, isAsync);
	    }

	    if (this.match(80)) {
	      return this.parseClass(expr, true, true);
	    }

	    if (this.match(26)) {
	      if (this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport")) {
	        this.raise(ErrorMessages.DecoratorBeforeExport, {
	          at: this.state.startLoc
	        });
	      }

	      this.parseDecorators(false);
	      return this.parseClass(expr, true, true);
	    }

	    if (this.match(75) || this.match(74) || this.isLet()) {
	      throw this.raise(ErrorMessages.UnsupportedDefaultExport, {
	        at: this.state.startLoc
	      });
	    }

	    const res = this.parseMaybeAssignAllowIn();
	    this.semicolon();
	    return res;
	  }

	  parseExportDeclaration(node) {
	    return this.parseStatement(null);
	  }

	  isExportDefaultSpecifier() {
	    const {
	      type
	    } = this.state;

	    if (tokenIsIdentifier(type)) {
	      if (type === 95 && !this.state.containsEsc || type === 99) {
	        return false;
	      }

	      if ((type === 126 || type === 125) && !this.state.containsEsc) {
	        const {
	          type: nextType
	        } = this.lookahead();

	        if (tokenIsIdentifier(nextType) && nextType !== 97 || nextType === 5) {
	          this.expectOnePlugin(["flow", "typescript"]);
	          return false;
	        }
	      }
	    } else if (!this.match(65)) {
	      return false;
	    }

	    const next = this.nextTokenStart();
	    const hasFrom = this.isUnparsedContextual(next, "from");

	    if (this.input.charCodeAt(next) === 44 || tokenIsIdentifier(this.state.type) && hasFrom) {
	      return true;
	    }

	    if (this.match(65) && hasFrom) {
	      const nextAfterFrom = this.input.charCodeAt(this.nextTokenStartSince(next + 4));
	      return nextAfterFrom === 34 || nextAfterFrom === 39;
	    }

	    return false;
	  }

	  parseExportFrom(node, expect) {
	    if (this.eatContextual(97)) {
	      node.source = this.parseImportSource();
	      this.checkExport(node);
	      const assertions = this.maybeParseImportAssertions();

	      if (assertions) {
	        node.assertions = assertions;
	      }
	    } else if (expect) {
	      this.unexpected();
	    }

	    this.semicolon();
	  }

	  shouldParseExportDeclaration() {
	    const {
	      type
	    } = this.state;

	    if (type === 26) {
	      this.expectOnePlugin(["decorators", "decorators-legacy"]);

	      if (this.hasPlugin("decorators")) {
	        if (this.getPluginOption("decorators", "decoratorsBeforeExport")) {
	          throw this.raise(ErrorMessages.DecoratorBeforeExport, {
	            at: this.state.startLoc
	          });
	        }

	        return true;
	      }
	    }

	    return type === 74 || type === 75 || type === 68 || type === 80 || this.isLet() || this.isAsyncFunction();
	  }

	  checkExport(node, checkNames, isDefault, isFrom) {
	    if (checkNames) {
	      if (isDefault) {
	        this.checkDuplicateExports(node, "default");

	        if (this.hasPlugin("exportDefaultFrom")) {
	          const declaration = node.declaration;

	          if (declaration.type === "Identifier" && declaration.name === "from" && declaration.end - declaration.start === 4 && !declaration.extra?.parenthesized) {
	            this.raise(ErrorMessages.ExportDefaultFromAsIdentifier, {
	              node: declaration
	            });
	          }
	        }
	      } else if (node.specifiers && node.specifiers.length) {
	        for (const specifier of node.specifiers) {
	          const {
	            exported
	          } = specifier;
	          const exportedName = exported.type === "Identifier" ? exported.name : exported.value;
	          this.checkDuplicateExports(specifier, exportedName);

	          if (!isFrom && specifier.local) {
	            const {
	              local
	            } = specifier;

	            if (local.type !== "Identifier") {
	              this.raise(ErrorMessages.ExportBindingIsString, {
	                node: specifier
	              }, local.value, exportedName);
	            } else {
	              this.checkReservedWord(local.name, local.loc.start, true, false);
	              this.scope.checkLocalExport(local);
	            }
	          }
	        }
	      } else if (node.declaration) {
	        if (node.declaration.type === "FunctionDeclaration" || node.declaration.type === "ClassDeclaration") {
	          const id = node.declaration.id;
	          if (!id) throw new Error("Assertion failure");
	          this.checkDuplicateExports(node, id.name);
	        } else if (node.declaration.type === "VariableDeclaration") {
	          for (const declaration of node.declaration.declarations) {
	            this.checkDeclaration(declaration.id);
	          }
	        }
	      }
	    }

	    const currentContextDecorators = this.state.decoratorStack[this.state.decoratorStack.length - 1];

	    if (currentContextDecorators.length) {
	      throw this.raise(ErrorMessages.UnsupportedDecoratorExport, {
	        node
	      });
	    }
	  }

	  checkDeclaration(node) {
	    if (node.type === "Identifier") {
	      this.checkDuplicateExports(node, node.name);
	    } else if (node.type === "ObjectPattern") {
	      for (const prop of node.properties) {
	        this.checkDeclaration(prop);
	      }
	    } else if (node.type === "ArrayPattern") {
	      for (const elem of node.elements) {
	        if (elem) {
	          this.checkDeclaration(elem);
	        }
	      }
	    } else if (node.type === "ObjectProperty") {
	      this.checkDeclaration(node.value);
	    } else if (node.type === "RestElement") {
	      this.checkDeclaration(node.argument);
	    } else if (node.type === "AssignmentPattern") {
	      this.checkDeclaration(node.left);
	    }
	  }

	  checkDuplicateExports(node, name) {
	    if (this.exportedIdentifiers.has(name)) {
	      this.raise(name === "default" ? ErrorMessages.DuplicateDefaultExport : ErrorMessages.DuplicateExport, {
	        node
	      }, name);
	    }

	    this.exportedIdentifiers.add(name);
	  }

	  parseExportSpecifiers(isInTypeExport) {
	    const nodes = [];
	    let first = true;
	    this.expect(5);

	    while (!this.eat(8)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);
	        if (this.eat(8)) break;
	      }

	      const isMaybeTypeOnly = this.isContextual(126);
	      const isString = this.match(129);
	      const node = this.startNode();
	      node.local = this.parseModuleExportName();
	      nodes.push(this.parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly));
	    }

	    return nodes;
	  }

	  parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
	    if (this.eatContextual(93)) {
	      node.exported = this.parseModuleExportName();
	    } else if (isString) {
	      node.exported = cloneStringLiteral(node.local);
	    } else if (!node.exported) {
	      node.exported = cloneIdentifier(node.local);
	    }

	    return this.finishNode(node, "ExportSpecifier");
	  }

	  parseModuleExportName() {
	    if (this.match(129)) {
	      const result = this.parseStringLiteral(this.state.value);
	      const surrogate = result.value.match(loneSurrogate);

	      if (surrogate) {
	        this.raise(ErrorMessages.ModuleExportNameHasLoneSurrogate, {
	          node: result
	        }, surrogate[0].charCodeAt(0).toString(16));
	      }

	      return result;
	    }

	    return this.parseIdentifier(true);
	  }

	  parseImport(node) {
	    node.specifiers = [];

	    if (!this.match(129)) {
	      const hasDefault = this.maybeParseDefaultImportSpecifier(node);
	      const parseNext = !hasDefault || this.eat(12);
	      const hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
	      if (parseNext && !hasStar) this.parseNamedImportSpecifiers(node);
	      this.expectContextual(97);
	    }

	    node.source = this.parseImportSource();
	    const assertions = this.maybeParseImportAssertions();

	    if (assertions) {
	      node.assertions = assertions;
	    } else if (!browser$5.env.BABEL_8_BREAKING) {
	      const attributes = this.maybeParseModuleAttributes();

	      if (attributes) {
	        node.attributes = attributes;
	      }
	    }

	    this.semicolon();
	    return this.finishNode(node, "ImportDeclaration");
	  }

	  parseImportSource() {
	    if (!this.match(129)) this.unexpected();
	    return this.parseExprAtom();
	  }

	  shouldParseDefaultImport(node) {
	    return tokenIsIdentifier(this.state.type);
	  }

	  parseImportSpecifierLocal(node, specifier, type, contextDescription) {
	    specifier.local = this.parseIdentifier();
	    this.checkLVal(specifier.local, contextDescription, BIND_LEXICAL);
	    node.specifiers.push(this.finishNode(specifier, type));
	  }

	  parseAssertEntries() {
	    const attrs = [];
	    const attrNames = new Set();

	    do {
	      if (this.match(8)) {
	        break;
	      }

	      const node = this.startNode();
	      const keyName = this.state.value;

	      if (attrNames.has(keyName)) {
	        this.raise(ErrorMessages.ModuleAttributesWithDuplicateKeys, {
	          at: this.state.startLoc
	        }, keyName);
	      }

	      attrNames.add(keyName);

	      if (this.match(129)) {
	        node.key = this.parseStringLiteral(keyName);
	      } else {
	        node.key = this.parseIdentifier(true);
	      }

	      this.expect(14);

	      if (!this.match(129)) {
	        throw this.raise(ErrorMessages.ModuleAttributeInvalidValue, {
	          at: this.state.startLoc
	        });
	      }

	      node.value = this.parseStringLiteral(this.state.value);
	      this.finishNode(node, "ImportAttribute");
	      attrs.push(node);
	    } while (this.eat(12));

	    return attrs;
	  }

	  maybeParseModuleAttributes() {
	    if (this.match(76) && !this.hasPrecedingLineBreak()) {
	      this.expectPlugin("moduleAttributes");
	      this.next();
	    } else {
	      if (this.hasPlugin("moduleAttributes")) return [];
	      return null;
	    }

	    const attrs = [];
	    const attributes = new Set();

	    do {
	      const node = this.startNode();
	      node.key = this.parseIdentifier(true);

	      if (node.key.name !== "type") {
	        this.raise(ErrorMessages.ModuleAttributeDifferentFromType, {
	          node: node.key
	        }, node.key.name);
	      }

	      if (attributes.has(node.key.name)) {
	        this.raise(ErrorMessages.ModuleAttributesWithDuplicateKeys, {
	          node: node.key
	        }, node.key.name);
	      }

	      attributes.add(node.key.name);
	      this.expect(14);

	      if (!this.match(129)) {
	        throw this.raise(ErrorMessages.ModuleAttributeInvalidValue, {
	          at: this.state.startLoc
	        });
	      }

	      node.value = this.parseStringLiteral(this.state.value);
	      this.finishNode(node, "ImportAttribute");
	      attrs.push(node);
	    } while (this.eat(12));

	    return attrs;
	  }

	  maybeParseImportAssertions() {
	    if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
	      this.expectPlugin("importAssertions");
	      this.next();
	    } else {
	      if (this.hasPlugin("importAssertions")) return [];
	      return null;
	    }

	    this.eat(5);
	    const attrs = this.parseAssertEntries();
	    this.eat(8);
	    return attrs;
	  }

	  maybeParseDefaultImportSpecifier(node) {
	    if (this.shouldParseDefaultImport(node)) {
	      this.parseImportSpecifierLocal(node, this.startNode(), "ImportDefaultSpecifier", "default import specifier");
	      return true;
	    }

	    return false;
	  }

	  maybeParseStarImportSpecifier(node) {
	    if (this.match(55)) {
	      const specifier = this.startNode();
	      this.next();
	      this.expectContextual(93);
	      this.parseImportSpecifierLocal(node, specifier, "ImportNamespaceSpecifier", "import namespace specifier");
	      return true;
	    }

	    return false;
	  }

	  parseNamedImportSpecifiers(node) {
	    let first = true;
	    this.expect(5);

	    while (!this.eat(8)) {
	      if (first) {
	        first = false;
	      } else {
	        if (this.eat(14)) {
	          throw this.raise(ErrorMessages.DestructureNamedImport, {
	            at: this.state.startLoc
	          });
	        }

	        this.expect(12);
	        if (this.eat(8)) break;
	      }

	      const specifier = this.startNode();
	      const importedIsString = this.match(129);
	      const isMaybeTypeOnly = this.isContextual(126);
	      specifier.imported = this.parseModuleExportName();
	      const importSpecifier = this.parseImportSpecifier(specifier, importedIsString, node.importKind === "type" || node.importKind === "typeof", isMaybeTypeOnly);
	      node.specifiers.push(importSpecifier);
	    }
	  }

	  parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly) {
	    if (this.eatContextual(93)) {
	      specifier.local = this.parseIdentifier();
	    } else {
	      const {
	        imported
	      } = specifier;

	      if (importedIsString) {
	        throw this.raise(ErrorMessages.ImportBindingIsString, {
	          node: specifier
	        }, imported.value);
	      }

	      this.checkReservedWord(imported.name, specifier.loc.start, true, true);

	      if (!specifier.local) {
	        specifier.local = cloneIdentifier(imported);
	      }
	    }

	    this.checkLVal(specifier.local, "import specifier", BIND_LEXICAL);
	    return this.finishNode(specifier, "ImportSpecifier");
	  }

	  isThisParam(param) {
	    return param.type === "Identifier" && param.name === "this";
	  }

	}

	class Parser extends StatementParser {
	  constructor(options, input) {
	    options = getOptions(options);
	    super(options, input);
	    this.options = options;
	    this.initializeScopes();
	    this.plugins = pluginsMap(this.options.plugins);
	    this.filename = options.sourceFilename;
	  }

	  getScopeHandler() {
	    return ScopeHandler;
	  }

	  parse() {
	    this.enterInitialScopes();
	    const file = this.startNode();
	    const program = this.startNode();
	    this.nextToken();
	    file.errors = null;
	    this.parseTopLevel(file, program);
	    file.errors = this.state.errors;
	    return file;
	  }

	}

	function pluginsMap(plugins) {
	  const pluginMap = new Map();

	  for (const plugin of plugins) {
	    const [name, options] = Array.isArray(plugin) ? plugin : [plugin, {}];
	    if (!pluginMap.has(name)) pluginMap.set(name, options || {});
	  }

	  return pluginMap;
	}

	function parse$4(input, options) {
	  if (options?.sourceType === "unambiguous") {
	    options = { ...options
	    };

	    try {
	      options.sourceType = "module";
	      const parser = getParser(options, input);
	      const ast = parser.parse();

	      if (parser.sawUnambiguousESM) {
	        return ast;
	      }

	      if (parser.ambiguousScriptDifferentAst) {
	        try {
	          options.sourceType = "script";
	          return getParser(options, input).parse();
	        } catch {}
	      } else {
	        ast.program.sourceType = "script";
	      }

	      return ast;
	    } catch (moduleError) {
	      try {
	        options.sourceType = "script";
	        return getParser(options, input).parse();
	      } catch {}

	      throw moduleError;
	    }
	  } else {
	    return getParser(options, input).parse();
	  }
	}

	function generateExportedTokenTypes(internalTokenTypes) {
	  const tokenTypes = {};

	  for (const typeName of Object.keys(internalTokenTypes)) {
	    tokenTypes[typeName] = getExportedToken(internalTokenTypes[typeName]);
	  }

	  return tokenTypes;
	}

	const tokTypes = generateExportedTokenTypes(tt);

	function getParser(options, input) {
	  let cls = Parser;

	  if (options?.plugins) {
	    validatePlugins(options.plugins);
	    cls = getParserClass(options.plugins);
	  }

	  return new cls(options, input);
	}

	const parserClassCache = {};

	function getParserClass(pluginsFromOptions) {
	  const pluginList = mixinPluginNames.filter(name => hasPlugin(pluginsFromOptions, name));
	  const key = pluginList.join("/");
	  let cls = parserClassCache[key];

	  if (!cls) {
	    cls = Parser;

	    for (const plugin of pluginList) {
	      cls = mixinPlugins[plugin](cls);
	    }

	    parserClassCache[key] = cls;
	  }

	  return cls;
	}

	const {
	  assignmentExpression: assignmentExpression$7,
	  expressionStatement: expressionStatement$6,
	  identifier: identifier$9
	} = _t;
	const visitor$2 = {
	  Scope(path, state) {
	    if (state.kind === "let") path.skip();
	  },

	  FunctionParent(path) {
	    path.skip();
	  },

	  VariableDeclaration(path, state) {
	    if (state.kind && path.node.kind !== state.kind) return;
	    const nodes = [];
	    const declarations = path.get("declarations");
	    let firstId;

	    for (const declar of declarations) {
	      firstId = declar.node.id;

	      if (declar.node.init) {
	        nodes.push(expressionStatement$6(assignmentExpression$7("=", declar.node.id, declar.node.init)));
	      }

	      for (const name of Object.keys(declar.getBindingIdentifiers())) {
	        state.emit(identifier$9(name), name, declar.node.init !== null);
	      }
	    }

	    if (path.parentPath.isFor({
	      left: path.node
	    })) {
	      path.replaceWith(firstId);
	    } else {
	      path.replaceWithMultiple(nodes);
	    }
	  }

	};
	function hoistVariables(path, emit, kind = "var") {
	  path.traverse(visitor$2, {
	    kind,
	    emit
	  });
	}

	const {
	  FUNCTION_TYPES,
	  arrowFunctionExpression: arrowFunctionExpression$3,
	  assignmentExpression: assignmentExpression$6,
	  awaitExpression,
	  blockStatement: blockStatement$4,
	  callExpression: callExpression$6,
	  cloneNode: cloneNode$9,
	  expressionStatement: expressionStatement$5,
	  identifier: identifier$8,
	  inheritLeadingComments,
	  inheritTrailingComments,
	  inheritsComments,
	  isExpression: isExpression$2,
	  isProgram,
	  isStatement: isStatement$2,
	  removeComments,
	  returnStatement: returnStatement$1,
	  toSequenceExpression,
	  validate: validate$4,
	  yieldExpression
	} = _t;
	function replaceWithMultiple(nodes) {
	  this.resync();
	  nodes = this._verifyNodeList(nodes);
	  inheritLeadingComments(nodes[0], this.node);
	  inheritTrailingComments(nodes[nodes.length - 1], this.node);
	  path$3.get(this.parent)?.delete(this.node);
	  this.node = this.container[this.key] = null;
	  const paths = this.insertAfter(nodes);

	  if (this.node) {
	    this.requeue();
	  } else {
	    this.remove();
	  }

	  return paths;
	}
	function replaceWithSourceString(replacement) {
	  this.resync();

	  try {
	    replacement = `(${replacement})`;
	    replacement = parse$4(replacement);
	  } catch (err) {
	    const loc = err.loc;

	    if (loc) {
	      err.message += " - make sure this is an expression.\n" + codeFrameColumns(replacement, {
	        start: {
	          line: loc.line,
	          column: loc.column + 1
	        }
	      });
	      err.code = "BABEL_REPLACE_SOURCE_ERROR";
	    }

	    throw err;
	  }

	  replacement = replacement.program.body[0].expression;
	  traverse.removeProperties(replacement);
	  return this.replaceWith(replacement);
	}
	function replaceWith(replacement) {
	  this.resync();

	  if (this.removed) {
	    throw new Error("You can't replace this node, we've already removed it");
	  }

	  if (replacement instanceof NodePath) {
	    replacement = replacement.node;
	  }

	  if (!replacement) {
	    throw new Error("You passed `path.replaceWith()` a falsy node, use `path.remove()` instead");
	  }

	  if (this.node === replacement) {
	    return [this];
	  }

	  if (this.isProgram() && !isProgram(replacement)) {
	    throw new Error("You can only replace a Program root node with another Program node");
	  }

	  if (Array.isArray(replacement)) {
	    throw new Error("Don't use `path.replaceWith()` with an array of nodes, use `path.replaceWithMultiple()`");
	  }

	  if (typeof replacement === "string") {
	    throw new Error("Don't use `path.replaceWith()` with a source string, use `path.replaceWithSourceString()`");
	  }

	  let nodePath = "";

	  if (this.isNodeType("Statement") && isExpression$2(replacement)) {
	    if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement) && !this.parentPath.isExportDefaultDeclaration()) {
	      replacement = expressionStatement$5(replacement);
	      nodePath = "expression";
	    }
	  }

	  if (this.isNodeType("Expression") && isStatement$2(replacement)) {
	    if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement)) {
	      return this.replaceExpressionWithStatements([replacement]);
	    }
	  }

	  const oldNode = this.node;

	  if (oldNode) {
	    inheritsComments(replacement, oldNode);
	    removeComments(oldNode);
	  }

	  this._replaceWith(replacement);

	  this.type = replacement.type;
	  this.setScope();
	  this.requeue();
	  return [nodePath ? this.get(nodePath) : this];
	}
	function _replaceWith(node) {
	  if (!this.container) {
	    throw new ReferenceError("Container is falsy");
	  }

	  if (this.inList) {
	    validate$4(this.parent, this.key, [node]);
	  } else {
	    validate$4(this.parent, this.key, node);
	  }

	  this.debug(`Replace with ${node?.type}`);
	  path$3.get(this.parent)?.set(node, this).delete(this.node);
	  this.node = this.container[this.key] = node;
	}
	function replaceExpressionWithStatements(nodes) {
	  this.resync();
	  const nodesAsSequenceExpression = toSequenceExpression(nodes, this.scope);

	  if (nodesAsSequenceExpression) {
	    return this.replaceWith(nodesAsSequenceExpression)[0].get("expressions");
	  }

	  const functionParent = this.getFunctionParent();
	  const isParentAsync = functionParent?.is("async");
	  const isParentGenerator = functionParent?.is("generator");
	  const container = arrowFunctionExpression$3([], blockStatement$4(nodes));
	  this.replaceWith(callExpression$6(container, []));
	  const callee = this.get("callee");
	  hoistVariables(callee.get("body"), id => {
	    this.scope.push({
	      id
	    });
	  }, "var");
	  const completionRecords = this.get("callee").getCompletionRecords();

	  for (const path of completionRecords) {
	    if (!path.isExpressionStatement()) continue;
	    const loop = path.findParent(path => path.isLoop());

	    if (loop) {
	      let uid = loop.getData("expressionReplacementReturnUid");

	      if (!uid) {
	        uid = callee.scope.generateDeclaredUidIdentifier("ret");
	        callee.get("body").pushContainer("body", returnStatement$1(cloneNode$9(uid)));
	        loop.setData("expressionReplacementReturnUid", uid);
	      } else {
	        uid = identifier$8(uid.name);
	      }

	      path.get("expression").replaceWith(assignmentExpression$6("=", cloneNode$9(uid), path.node.expression));
	    } else {
	      path.replaceWith(returnStatement$1(path.node.expression));
	    }
	  }

	  callee.arrowFunctionToExpression();
	  const newCallee = callee;
	  const needToAwaitFunction = isParentAsync && traverse.hasType(this.get("callee.body").node, "AwaitExpression", FUNCTION_TYPES);
	  const needToYieldFunction = isParentGenerator && traverse.hasType(this.get("callee.body").node, "YieldExpression", FUNCTION_TYPES);

	  if (needToAwaitFunction) {
	    newCallee.set("async", true);

	    if (!needToYieldFunction) {
	      this.replaceWith(awaitExpression(this.node));
	    }
	  }

	  if (needToYieldFunction) {
	    newCallee.set("generator", true);
	    this.replaceWith(yieldExpression(this.node, true));
	  }

	  return newCallee.get("body.body");
	}
	function replaceInline(nodes) {
	  this.resync();

	  if (Array.isArray(nodes)) {
	    if (Array.isArray(this.container)) {
	      nodes = this._verifyNodeList(nodes);

	      const paths = this._containerInsertAfter(nodes);

	      this.remove();
	      return paths;
	    } else {
	      return this.replaceWithMultiple(nodes);
	    }
	  } else {
	    return this.replaceWith(nodes);
	  }
	}

	var NodePath_replacement = /*#__PURE__*/Object.freeze({
		__proto__: null,
		replaceWithMultiple: replaceWithMultiple,
		replaceWithSourceString: replaceWithSourceString,
		replaceWith: replaceWith,
		_replaceWith: _replaceWith,
		replaceExpressionWithStatements: replaceExpressionWithStatements,
		replaceInline: replaceInline
	});

	var global$1 = typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {};

	const VALID_CALLEES = ["String", "Number", "Math"];
	const INVALID_METHODS = ["random"];
	function evaluateTruthy() {
	  const res = this.evaluate();
	  if (res.confident) return !!res.value;
	}

	function deopt(path, state) {
	  if (!state.confident) return;
	  state.deoptPath = path;
	  state.confident = false;
	}

	function evaluateCached(path, state) {
	  const {
	    node
	  } = path;
	  const {
	    seen
	  } = state;

	  if (seen.has(node)) {
	    const existing = seen.get(node);

	    if (existing.resolved) {
	      return existing.value;
	    } else {
	      deopt(path, state);
	      return;
	    }
	  } else {
	    const item = {
	      resolved: false
	    };
	    seen.set(node, item);

	    const val = _evaluate(path, state);

	    if (state.confident) {
	      item.resolved = true;
	      item.value = val;
	    }

	    return val;
	  }
	}

	function _evaluate(path, state) {
	  if (!state.confident) return;

	  if (path.isSequenceExpression()) {
	    const exprs = path.get("expressions");
	    return evaluateCached(exprs[exprs.length - 1], state);
	  }

	  if (path.isStringLiteral() || path.isNumericLiteral() || path.isBooleanLiteral()) {
	    return path.node.value;
	  }

	  if (path.isNullLiteral()) {
	    return null;
	  }

	  if (path.isTemplateLiteral()) {
	    return evaluateQuasis(path, path.node.quasis, state);
	  }

	  if (path.isTaggedTemplateExpression() && path.get("tag").isMemberExpression()) {
	    const object = path.get("tag.object");
	    const {
	      node: {
	        name
	      }
	    } = object;
	    const property = path.get("tag.property");

	    if (object.isIdentifier() && name === "String" && !path.scope.getBinding(name) && property.isIdentifier() && property.node.name === "raw") {
	      return evaluateQuasis(path, path.node.quasi.quasis, state, true);
	    }
	  }

	  if (path.isConditionalExpression()) {
	    const testResult = evaluateCached(path.get("test"), state);
	    if (!state.confident) return;

	    if (testResult) {
	      return evaluateCached(path.get("consequent"), state);
	    } else {
	      return evaluateCached(path.get("alternate"), state);
	    }
	  }

	  if (path.isExpressionWrapper()) {
	    return evaluateCached(path.get("expression"), state);
	  }

	  if (path.isMemberExpression() && !path.parentPath.isCallExpression({
	    callee: path.node
	  })) {
	    const property = path.get("property");
	    const object = path.get("object");

	    if (object.isLiteral() && property.isIdentifier()) {
	      const value = object.node.value;
	      const type = typeof value;

	      if (type === "number" || type === "string") {
	        return value[property.node.name];
	      }
	    }
	  }

	  if (path.isReferencedIdentifier()) {
	    const binding = path.scope.getBinding(path.node.name);

	    if (binding && binding.constantViolations.length > 0) {
	      return deopt(binding.path, state);
	    }

	    if (binding && path.node.start < binding.path.node.end) {
	      return deopt(binding.path, state);
	    }

	    if (binding?.hasValue) {
	      return binding.value;
	    } else {
	      if (path.node.name === "undefined") {
	        return binding ? deopt(binding.path, state) : undefined;
	      } else if (path.node.name === "Infinity") {
	        return binding ? deopt(binding.path, state) : Infinity;
	      } else if (path.node.name === "NaN") {
	        return binding ? deopt(binding.path, state) : NaN;
	      }

	      const resolved = path.resolve();

	      if (resolved === path) {
	        return deopt(path, state);
	      } else {
	        return evaluateCached(resolved, state);
	      }
	    }
	  }

	  if (path.isUnaryExpression({
	    prefix: true
	  })) {
	    if (path.node.operator === "void") {
	      return undefined;
	    }

	    const argument = path.get("argument");

	    if (path.node.operator === "typeof" && (argument.isFunction() || argument.isClass())) {
	      return "function";
	    }

	    const arg = evaluateCached(argument, state);
	    if (!state.confident) return;

	    switch (path.node.operator) {
	      case "!":
	        return !arg;

	      case "+":
	        return +arg;

	      case "-":
	        return -arg;

	      case "~":
	        return ~arg;

	      case "typeof":
	        return typeof arg;
	    }
	  }

	  if (path.isArrayExpression()) {
	    const arr = [];
	    const elems = path.get("elements");

	    for (const elem of elems) {
	      const elemValue = elem.evaluate();

	      if (elemValue.confident) {
	        arr.push(elemValue.value);
	      } else {
	        return deopt(elemValue.deopt, state);
	      }
	    }

	    return arr;
	  }

	  if (path.isObjectExpression()) {
	    const obj = {};
	    const props = path.get("properties");

	    for (const prop of props) {
	      if (prop.isObjectMethod() || prop.isSpreadElement()) {
	        return deopt(prop, state);
	      }

	      const keyPath = prop.get("key");
	      let key = keyPath;

	      if (prop.node.computed) {
	        key = key.evaluate();

	        if (!key.confident) {
	          return deopt(key.deopt, state);
	        }

	        key = key.value;
	      } else if (key.isIdentifier()) {
	        key = key.node.name;
	      } else {
	        key = key.node.value;
	      }

	      const valuePath = prop.get("value");
	      let value = valuePath.evaluate();

	      if (!value.confident) {
	        return deopt(value.deopt, state);
	      }

	      value = value.value;
	      obj[key] = value;
	    }

	    return obj;
	  }

	  if (path.isLogicalExpression()) {
	    const wasConfident = state.confident;
	    const left = evaluateCached(path.get("left"), state);
	    const leftConfident = state.confident;
	    state.confident = wasConfident;
	    const right = evaluateCached(path.get("right"), state);
	    const rightConfident = state.confident;

	    switch (path.node.operator) {
	      case "||":
	        state.confident = leftConfident && (!!left || rightConfident);
	        if (!state.confident) return;
	        return left || right;

	      case "&&":
	        state.confident = leftConfident && (!left || rightConfident);
	        if (!state.confident) return;
	        return left && right;
	    }
	  }

	  if (path.isBinaryExpression()) {
	    const left = evaluateCached(path.get("left"), state);
	    if (!state.confident) return;
	    const right = evaluateCached(path.get("right"), state);
	    if (!state.confident) return;

	    switch (path.node.operator) {
	      case "-":
	        return left - right;

	      case "+":
	        return left + right;

	      case "/":
	        return left / right;

	      case "*":
	        return left * right;

	      case "%":
	        return left % right;

	      case "**":
	        return left ** right;

	      case "<":
	        return left < right;

	      case ">":
	        return left > right;

	      case "<=":
	        return left <= right;

	      case ">=":
	        return left >= right;

	      case "==":
	        return left == right;

	      case "!=":
	        return left != right;

	      case "===":
	        return left === right;

	      case "!==":
	        return left !== right;

	      case "|":
	        return left | right;

	      case "&":
	        return left & right;

	      case "^":
	        return left ^ right;

	      case "<<":
	        return left << right;

	      case ">>":
	        return left >> right;

	      case ">>>":
	        return left >>> right;
	    }
	  }

	  if (path.isCallExpression()) {
	    const callee = path.get("callee");
	    let context;
	    let func;

	    if (callee.isIdentifier() && !path.scope.getBinding(callee.node.name) && VALID_CALLEES.indexOf(callee.node.name) >= 0) {
	      func = global$1[callee.node.name];
	    }

	    if (callee.isMemberExpression()) {
	      const object = callee.get("object");
	      const property = callee.get("property");

	      if (object.isIdentifier() && property.isIdentifier() && VALID_CALLEES.indexOf(object.node.name) >= 0 && INVALID_METHODS.indexOf(property.node.name) < 0) {
	        context = global$1[object.node.name];
	        func = context[property.node.name];
	      }

	      if (object.isLiteral() && property.isIdentifier()) {
	        const type = typeof object.node.value;

	        if (type === "string" || type === "number") {
	          context = object.node.value;
	          func = context[property.node.name];
	        }
	      }
	    }

	    if (func) {
	      const args = path.get("arguments").map(arg => evaluateCached(arg, state));
	      if (!state.confident) return;
	      return func.apply(context, args);
	    }
	  }

	  deopt(path, state);
	}

	function evaluateQuasis(path, quasis, state, raw = false) {
	  let str = "";
	  let i = 0;
	  const exprs = path.get("expressions");

	  for (const elem of quasis) {
	    if (!state.confident) break;
	    str += raw ? elem.value.raw : elem.value.cooked;
	    const expr = exprs[i++];
	    if (expr) str += String(evaluateCached(expr, state));
	  }

	  if (!state.confident) return;
	  return str;
	}

	function evaluate() {
	  const state = {
	    confident: true,
	    deoptPath: null,
	    seen: new Map()
	  };
	  let value = evaluateCached(this, state);
	  if (!state.confident) value = undefined;
	  return {
	    confident: state.confident,
	    deopt: state.deoptPath,
	    value: value
	  };
	}

	var NodePath_evaluation = /*#__PURE__*/Object.freeze({
		__proto__: null,
		evaluateTruthy: evaluateTruthy,
		evaluate: evaluate
	});

	const {
	  VISITOR_KEYS: VISITOR_KEYS$4,
	  staticBlock
	} = _t;
	function skipAllButComputedKey(path) {
	  if (!path.node.computed) {
	    path.skip();
	    return;
	  }

	  const keys = VISITOR_KEYS$4[path.type];

	  for (const key of keys) {
	    if (key !== "key") path.skipKey(key);
	  }
	}
	const skipKey$1 = browser$5.env.BABEL_8_BREAKING ? "StaticBlock|ClassPrivateProperty|TypeAnnotation|FunctionDeclaration|FunctionExpression" : (staticBlock ? "StaticBlock|" : "") + "ClassPrivateProperty|TypeAnnotation|FunctionDeclaration|FunctionExpression";
	var environmentVisitor = {
	  [skipKey$1]: path => path.skip(),

	  "Method|ClassProperty"(path) {
	    skipAllButComputedKey(path);
	  }

	};

	const {
	  isAssignmentPattern,
	  isRestElement
	} = _t;
	function getFunctionArity (node) {
	  const params = node.params;

	  for (let i = 0; i < params.length; i++) {
	    const param = params[i];

	    if (isAssignmentPattern(param) || isRestElement(param)) {
	      return i;
	    }
	  }

	  return params.length;
	}

	const {
	  assertExpressionStatement
	} = _t;

	function makeStatementFormatter(fn) {
	  return {
	    code: str => `/* @babel/template */;\n${str}`,
	    validate: () => {},
	    unwrap: ast => {
	      return fn(ast.program.body.slice(1));
	    }
	  };
	}

	const smart$1 = makeStatementFormatter(body => {
	  if (body.length > 1) {
	    return body;
	  } else {
	    return body[0];
	  }
	});
	const statements$1 = makeStatementFormatter(body => body);
	const statement$1 = makeStatementFormatter(body => {
	  if (body.length === 0) {
	    throw new Error("Found nothing to return.");
	  }

	  if (body.length > 1) {
	    throw new Error("Found multiple statements but wanted one");
	  }

	  return body[0];
	});
	const expression$1 = {
	  code: str => `(\n${str}\n)`,
	  validate: ast => {
	    if (ast.program.body.length > 1) {
	      throw new Error("Found multiple statements but wanted one");
	    }

	    if (expression$1.unwrap(ast).start === 0) {
	      throw new Error("Parse result included parens.");
	    }
	  },
	  unwrap: ({
	    program
	  }) => {
	    const [stmt] = program.body;
	    assertExpressionStatement(stmt);
	    return stmt.expression;
	  }
	};
	const program$2 = {
	  code: str => str,
	  validate: () => {},
	  unwrap: ast => ast.program
	};

	function merge(a, b) {
	  const {
	    placeholderWhitelist = a.placeholderWhitelist,
	    placeholderPattern = a.placeholderPattern,
	    preserveComments = a.preserveComments,
	    syntacticPlaceholders = a.syntacticPlaceholders
	  } = b;
	  return {
	    parser: { ...a.parser,
	      ...b.parser
	    },
	    placeholderWhitelist,
	    placeholderPattern,
	    preserveComments,
	    syntacticPlaceholders
	  };
	}
	function validate$3(opts) {
	  if (opts != null && typeof opts !== "object") {
	    throw new Error("Unknown template options.");
	  }

	  const {
	    placeholderWhitelist,
	    placeholderPattern,
	    preserveComments,
	    syntacticPlaceholders,
	    ...parser
	  } = opts || {};

	  if (placeholderWhitelist != null && !(placeholderWhitelist instanceof Set)) {
	    throw new Error("'.placeholderWhitelist' must be a Set, null, or undefined");
	  }

	  if (placeholderPattern != null && !(placeholderPattern instanceof RegExp) && placeholderPattern !== false) {
	    throw new Error("'.placeholderPattern' must be a RegExp, false, null, or undefined");
	  }

	  if (preserveComments != null && typeof preserveComments !== "boolean") {
	    throw new Error("'.preserveComments' must be a boolean, null, or undefined");
	  }

	  if (syntacticPlaceholders != null && typeof syntacticPlaceholders !== "boolean") {
	    throw new Error("'.syntacticPlaceholders' must be a boolean, null, or undefined");
	  }

	  if (syntacticPlaceholders === true && (placeholderWhitelist != null || placeholderPattern != null)) {
	    throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" + " with '.syntacticPlaceholders: true'");
	  }

	  return {
	    parser,
	    placeholderWhitelist: placeholderWhitelist || undefined,
	    placeholderPattern: placeholderPattern == null ? undefined : placeholderPattern,
	    preserveComments: preserveComments == null ? undefined : preserveComments,
	    syntacticPlaceholders: syntacticPlaceholders == null ? undefined : syntacticPlaceholders
	  };
	}
	function normalizeReplacements(replacements) {
	  if (Array.isArray(replacements)) {
	    return replacements.reduce((acc, replacement, i) => {
	      acc["$" + i] = replacement;
	      return acc;
	    }, {});
	  } else if (typeof replacements === "object" || replacements == null) {
	    return replacements || undefined;
	  }

	  throw new Error("Template replacements must be an array, object, null, or undefined");
	}

	const {
	  isCallExpression: isCallExpression$1,
	  isExpressionStatement,
	  isFunction: isFunction$1,
	  isIdentifier: isIdentifier$5,
	  isJSXIdentifier,
	  isNewExpression,
	  isPlaceholder,
	  isStatement: isStatement$1,
	  isStringLiteral: isStringLiteral$2,
	  removePropertiesDeep,
	  traverse: traverse$1
	} = _t;
	const PATTERN = /^[_$A-Z0-9]+$/;
	function parseAndBuildMetadata(formatter, code, opts) {
	  const {
	    placeholderWhitelist,
	    placeholderPattern,
	    preserveComments,
	    syntacticPlaceholders
	  } = opts;
	  const ast = parseWithCodeFrame(code, opts.parser, syntacticPlaceholders);
	  removePropertiesDeep(ast, {
	    preserveComments
	  });
	  formatter.validate(ast);
	  const syntactic = {
	    placeholders: [],
	    placeholderNames: new Set()
	  };
	  const legacy = {
	    placeholders: [],
	    placeholderNames: new Set()
	  };
	  const isLegacyRef = {
	    value: undefined
	  };
	  traverse$1(ast, placeholderVisitorHandler, {
	    syntactic,
	    legacy,
	    isLegacyRef,
	    placeholderWhitelist,
	    placeholderPattern,
	    syntacticPlaceholders
	  });
	  return {
	    ast,
	    ...(isLegacyRef.value ? legacy : syntactic)
	  };
	}

	function placeholderVisitorHandler(node, ancestors, state) {
	  let name;

	  if (isPlaceholder(node)) {
	    if (state.syntacticPlaceholders === false) {
	      throw new Error("%%foo%%-style placeholders can't be used when " + "'.syntacticPlaceholders' is false.");
	    } else {
	      name = node.name.name;
	      state.isLegacyRef.value = false;
	    }
	  } else if (state.isLegacyRef.value === false || state.syntacticPlaceholders) {
	    return;
	  } else if (isIdentifier$5(node) || isJSXIdentifier(node)) {
	    name = node.name;
	    state.isLegacyRef.value = true;
	  } else if (isStringLiteral$2(node)) {
	    name = node.value;
	    state.isLegacyRef.value = true;
	  } else {
	    return;
	  }

	  if (!state.isLegacyRef.value && (state.placeholderPattern != null || state.placeholderWhitelist != null)) {
	    throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" + " with '.syntacticPlaceholders: true'");
	  }

	  if (state.isLegacyRef.value && (state.placeholderPattern === false || !(state.placeholderPattern || PATTERN).test(name)) && !state.placeholderWhitelist?.has(name)) {
	    return;
	  }

	  ancestors = ancestors.slice();
	  const {
	    node: parent,
	    key
	  } = ancestors[ancestors.length - 1];
	  let type;

	  if (isStringLiteral$2(node) || isPlaceholder(node, {
	    expectedNode: "StringLiteral"
	  })) {
	    type = "string";
	  } else if (isNewExpression(parent) && key === "arguments" || isCallExpression$1(parent) && key === "arguments" || isFunction$1(parent) && key === "params") {
	    type = "param";
	  } else if (isExpressionStatement(parent) && !isPlaceholder(node)) {
	    type = "statement";
	    ancestors = ancestors.slice(0, -1);
	  } else if (isStatement$1(node) && isPlaceholder(node)) {
	    type = "statement";
	  } else {
	    type = "other";
	  }

	  const {
	    placeholders,
	    placeholderNames
	  } = state.isLegacyRef.value ? state.legacy : state.syntactic;
	  placeholders.push({
	    name,
	    type,
	    resolve: ast => resolveAncestors(ast, ancestors),
	    isDuplicate: placeholderNames.has(name)
	  });
	  placeholderNames.add(name);
	}

	function resolveAncestors(ast, ancestors) {
	  let parent = ast;

	  for (let i = 0; i < ancestors.length - 1; i++) {
	    const {
	      key,
	      index
	    } = ancestors[i];

	    if (index === undefined) {
	      parent = parent[key];
	    } else {
	      parent = parent[key][index];
	    }
	  }

	  const {
	    key,
	    index
	  } = ancestors[ancestors.length - 1];
	  return {
	    parent,
	    key,
	    index
	  };
	}

	function parseWithCodeFrame(code, parserOpts, syntacticPlaceholders) {
	  const plugins = (parserOpts.plugins || []).slice();

	  if (syntacticPlaceholders !== false) {
	    plugins.push("placeholders");
	  }

	  parserOpts = {
	    allowReturnOutsideFunction: true,
	    allowSuperOutsideMethod: true,
	    sourceType: "module",
	    ...parserOpts,
	    plugins
	  };

	  try {
	    return parse$4(code, parserOpts);
	  } catch (err) {
	    const loc = err.loc;

	    if (loc) {
	      err.message += "\n" + codeFrameColumns(code, {
	        start: loc
	      });
	      err.code = "BABEL_TEMPLATE_PARSE_ERROR";
	    }

	    throw err;
	  }
	}

	const {
	  blockStatement: blockStatement$3,
	  cloneNode: cloneNode$8,
	  emptyStatement,
	  expressionStatement: expressionStatement$4,
	  identifier: identifier$7,
	  isStatement,
	  isStringLiteral: isStringLiteral$1,
	  stringLiteral: stringLiteral$3,
	  validate: validate$2
	} = _t;
	function populatePlaceholders(metadata, replacements) {
	  const ast = cloneNode$8(metadata.ast);

	  if (replacements) {
	    metadata.placeholders.forEach(placeholder => {
	      if (!Object.prototype.hasOwnProperty.call(replacements, placeholder.name)) {
	        const placeholderName = placeholder.name;
	        throw new Error(`Error: No substitution given for "${placeholderName}". If this is not meant to be a
            placeholder you may want to consider passing one of the following options to @babel/template:
            - { placeholderPattern: false, placeholderWhitelist: new Set(['${placeholderName}'])}
            - { placeholderPattern: /^${placeholderName}$/ }`);
	      }
	    });
	    Object.keys(replacements).forEach(key => {
	      if (!metadata.placeholderNames.has(key)) {
	        throw new Error(`Unknown substitution "${key}" given`);
	      }
	    });
	  }

	  metadata.placeholders.slice().reverse().forEach(placeholder => {
	    try {
	      applyReplacement(placeholder, ast, replacements && replacements[placeholder.name] || null);
	    } catch (e) {
	      e.message = `@babel/template placeholder "${placeholder.name}": ${e.message}`;
	      throw e;
	    }
	  });
	  return ast;
	}

	function applyReplacement(placeholder, ast, replacement) {
	  if (placeholder.isDuplicate) {
	    if (Array.isArray(replacement)) {
	      replacement = replacement.map(node => cloneNode$8(node));
	    } else if (typeof replacement === "object") {
	      replacement = cloneNode$8(replacement);
	    }
	  }

	  const {
	    parent,
	    key,
	    index
	  } = placeholder.resolve(ast);

	  if (placeholder.type === "string") {
	    if (typeof replacement === "string") {
	      replacement = stringLiteral$3(replacement);
	    }

	    if (!replacement || !isStringLiteral$1(replacement)) {
	      throw new Error("Expected string substitution");
	    }
	  } else if (placeholder.type === "statement") {
	    if (index === undefined) {
	      if (!replacement) {
	        replacement = emptyStatement();
	      } else if (Array.isArray(replacement)) {
	        replacement = blockStatement$3(replacement);
	      } else if (typeof replacement === "string") {
	        replacement = expressionStatement$4(identifier$7(replacement));
	      } else if (!isStatement(replacement)) {
	        replacement = expressionStatement$4(replacement);
	      }
	    } else {
	      if (replacement && !Array.isArray(replacement)) {
	        if (typeof replacement === "string") {
	          replacement = identifier$7(replacement);
	        }

	        if (!isStatement(replacement)) {
	          replacement = expressionStatement$4(replacement);
	        }
	      }
	    }
	  } else if (placeholder.type === "param") {
	    if (typeof replacement === "string") {
	      replacement = identifier$7(replacement);
	    }

	    if (index === undefined) throw new Error("Assertion failure.");
	  } else {
	    if (typeof replacement === "string") {
	      replacement = identifier$7(replacement);
	    }

	    if (Array.isArray(replacement)) {
	      throw new Error("Cannot replace single expression with an array.");
	    }
	  }

	  if (index === undefined) {
	    validate$2(parent, key, replacement);
	    parent[key] = replacement;
	  } else {
	    const items = parent[key].slice();

	    if (placeholder.type === "statement" || placeholder.type === "param") {
	      if (replacement == null) {
	        items.splice(index, 1);
	      } else if (Array.isArray(replacement)) {
	        items.splice(index, 1, ...replacement);
	      } else {
	        items[index] = replacement;
	      }
	    } else {
	      items[index] = replacement;
	    }

	    validate$2(parent, key, items);
	    parent[key] = items;
	  }
	}

	function stringTemplate(formatter, code, opts) {
	  code = formatter.code(code);
	  let metadata;
	  return arg => {
	    const replacements = normalizeReplacements(arg);
	    if (!metadata) metadata = parseAndBuildMetadata(formatter, code, opts);
	    return formatter.unwrap(populatePlaceholders(metadata, replacements));
	  };
	}

	function literalTemplate(formatter, tpl, opts) {
	  const {
	    metadata,
	    names
	  } = buildLiteralData(formatter, tpl, opts);
	  return arg => {
	    const defaultReplacements = {};
	    arg.forEach((replacement, i) => {
	      defaultReplacements[names[i]] = replacement;
	    });
	    return arg => {
	      const replacements = normalizeReplacements(arg);

	      if (replacements) {
	        Object.keys(replacements).forEach(key => {
	          if (Object.prototype.hasOwnProperty.call(defaultReplacements, key)) {
	            throw new Error("Unexpected replacement overlap.");
	          }
	        });
	      }

	      return formatter.unwrap(populatePlaceholders(metadata, replacements ? Object.assign(replacements, defaultReplacements) : defaultReplacements));
	    };
	  };
	}

	function buildLiteralData(formatter, tpl, opts) {
	  let names;
	  let nameSet;
	  let metadata;
	  let prefix = "";

	  do {
	    prefix += "$";
	    const result = buildTemplateCode(tpl, prefix);
	    names = result.names;
	    nameSet = new Set(names);
	    metadata = parseAndBuildMetadata(formatter, formatter.code(result.code), {
	      parser: opts.parser,
	      placeholderWhitelist: new Set(result.names.concat(opts.placeholderWhitelist ? Array.from(opts.placeholderWhitelist) : [])),
	      placeholderPattern: opts.placeholderPattern,
	      preserveComments: opts.preserveComments,
	      syntacticPlaceholders: opts.syntacticPlaceholders
	    });
	  } while (metadata.placeholders.some(placeholder => placeholder.isDuplicate && nameSet.has(placeholder.name)));

	  return {
	    metadata,
	    names
	  };
	}

	function buildTemplateCode(tpl, prefix) {
	  const names = [];
	  let code = tpl[0];

	  for (let i = 1; i < tpl.length; i++) {
	    const value = `${prefix}${i - 1}`;
	    names.push(value);
	    code += value + tpl[i];
	  }

	  return {
	    names,
	    code
	  };
	}

	const NO_PLACEHOLDER = validate$3({
	  placeholderPattern: false
	});
	function createTemplateBuilder(formatter, defaultOpts) {
	  const templateFnCache = new WeakMap();
	  const templateAstCache = new WeakMap();
	  const cachedOpts = defaultOpts || validate$3(null);
	  return Object.assign((tpl, ...args) => {
	    if (typeof tpl === "string") {
	      if (args.length > 1) throw new Error("Unexpected extra params.");
	      return extendedTrace(stringTemplate(formatter, tpl, merge(cachedOpts, validate$3(args[0]))));
	    } else if (Array.isArray(tpl)) {
	      let builder = templateFnCache.get(tpl);

	      if (!builder) {
	        builder = literalTemplate(formatter, tpl, cachedOpts);
	        templateFnCache.set(tpl, builder);
	      }

	      return extendedTrace(builder(args));
	    } else if (typeof tpl === "object" && tpl) {
	      if (args.length > 0) throw new Error("Unexpected extra params.");
	      return createTemplateBuilder(formatter, merge(cachedOpts, validate$3(tpl)));
	    }

	    throw new Error(`Unexpected template param ${typeof tpl}`);
	  }, {
	    ast: (tpl, ...args) => {
	      if (typeof tpl === "string") {
	        if (args.length > 1) throw new Error("Unexpected extra params.");
	        return stringTemplate(formatter, tpl, merge(merge(cachedOpts, validate$3(args[0])), NO_PLACEHOLDER))();
	      } else if (Array.isArray(tpl)) {
	        let builder = templateAstCache.get(tpl);

	        if (!builder) {
	          builder = literalTemplate(formatter, tpl, merge(cachedOpts, NO_PLACEHOLDER));
	          templateAstCache.set(tpl, builder);
	        }

	        return builder(args)();
	      }

	      throw new Error(`Unexpected template param ${typeof tpl}`);
	    }
	  });
	}

	function extendedTrace(fn) {
	  let rootStack = "";

	  try {
	    throw new Error();
	  } catch (error) {
	    if (error.stack) {
	      rootStack = error.stack.split("\n").slice(3).join("\n");
	    }
	  }

	  return arg => {
	    try {
	      return fn(arg);
	    } catch (err) {
	      err.stack += `\n    =============\n${rootStack}`;
	      throw err;
	    }
	  };
	}

	const smart = createTemplateBuilder(smart$1);
	const statement = createTemplateBuilder(statement$1);
	const statements = createTemplateBuilder(statements$1);
	const expression = createTemplateBuilder(expression$1);
	const program$1 = createTemplateBuilder(program$2);
	var template = Object.assign(smart.bind(undefined), {
	  smart,
	  statement,
	  statements,
	  expression,
	  program: program$1,
	  ast: smart.ast
	});

	const {
	  NOT_LOCAL_BINDING,
	  cloneNode: cloneNode$7,
	  identifier: identifier$6,
	  isAssignmentExpression: isAssignmentExpression$1,
	  isFunction,
	  isIdentifier: isIdentifier$4,
	  isLiteral: isLiteral$1,
	  isNullLiteral,
	  isObjectMethod,
	  isObjectProperty,
	  isRegExpLiteral,
	  isTemplateLiteral,
	  isVariableDeclarator,
	  toBindingIdentifierName
	} = _t;
	const buildPropertyMethodAssignmentWrapper = template(`
  (function (FUNCTION_KEY) {
    function FUNCTION_ID() {
      return FUNCTION_KEY.apply(this, arguments);
    }

    FUNCTION_ID.toString = function () {
      return FUNCTION_KEY.toString();
    }

    return FUNCTION_ID;
  })(FUNCTION)
`);
	const buildGeneratorPropertyMethodAssignmentWrapper = template(`
  (function (FUNCTION_KEY) {
    function* FUNCTION_ID() {
      return yield* FUNCTION_KEY.apply(this, arguments);
    }

    FUNCTION_ID.toString = function () {
      return FUNCTION_KEY.toString();
    };

    return FUNCTION_ID;
  })(FUNCTION)
`);
	const visitor$1 = {
	  "ReferencedIdentifier|BindingIdentifier"(path, state) {
	    if (path.node.name !== state.name) return;
	    const localDeclar = path.scope.getBindingIdentifier(state.name);
	    if (localDeclar !== state.outerDeclar) return;
	    state.selfReference = true;
	    path.stop();
	  }

	};

	function getNameFromLiteralId(id) {
	  if (isNullLiteral(id)) {
	    return "null";
	  }

	  if (isRegExpLiteral(id)) {
	    return `_${id.pattern}_${id.flags}`;
	  }

	  if (isTemplateLiteral(id)) {
	    return id.quasis.map(quasi => quasi.value.raw).join("");
	  }

	  if (id.value !== undefined) {
	    return id.value + "";
	  }

	  return "";
	}

	function wrap$1(state, method, id, scope) {
	  if (state.selfReference) {
	    if (scope.hasBinding(id.name) && !scope.hasGlobal(id.name)) {
	      scope.rename(id.name);
	    } else {
	      if (!isFunction(method)) return;
	      let build = buildPropertyMethodAssignmentWrapper;

	      if (method.generator) {
	        build = buildGeneratorPropertyMethodAssignmentWrapper;
	      }

	      const template = build({
	        FUNCTION: method,
	        FUNCTION_ID: id,
	        FUNCTION_KEY: scope.generateUidIdentifier(id.name)
	      }).expression;
	      const params = template.callee.body.body[0].params;

	      for (let i = 0, len = getFunctionArity(method); i < len; i++) {
	        params.push(scope.generateUidIdentifier("x"));
	      }

	      return template;
	    }
	  }

	  method.id = id;
	  scope.getProgramParent().references[id.name] = true;
	}

	function visit$1(node, name, scope) {
	  const state = {
	    selfAssignment: false,
	    selfReference: false,
	    outerDeclar: scope.getBindingIdentifier(name),
	    references: [],
	    name: name
	  };
	  const binding = scope.getOwnBinding(name);

	  if (binding) {
	    if (binding.kind === "param") {
	      state.selfReference = true;
	    }
	  } else if (state.outerDeclar || scope.hasGlobal(name)) {
	    scope.traverse(node, visitor$1, state);
	  }

	  return state;
	}

	function nameFunction ({
	  node,
	  parent,
	  scope,
	  id
	}, localBinding = false, supportUnicodeId = false) {
	  if (node.id) return;

	  if ((isObjectProperty(parent) || isObjectMethod(parent, {
	    kind: "method"
	  })) && (!parent.computed || isLiteral$1(parent.key))) {
	    id = parent.key;
	  } else if (isVariableDeclarator(parent)) {
	    id = parent.id;

	    if (isIdentifier$4(id) && !localBinding) {
	      const binding = scope.parent.getBinding(id.name);

	      if (binding && binding.constant && scope.getBinding(id.name) === binding) {
	        node.id = cloneNode$7(id);
	        node.id[NOT_LOCAL_BINDING] = true;
	        return;
	      }
	    }
	  } else if (isAssignmentExpression$1(parent, {
	    operator: "="
	  })) {
	    id = parent.left;
	  } else if (!id) {
	    return;
	  }

	  let name;

	  if (id && isLiteral$1(id)) {
	    name = getNameFromLiteralId(id);
	  } else if (id && isIdentifier$4(id)) {
	    name = id.name;
	  }

	  if (name === undefined) {
	    return;
	  }

	  if (!supportUnicodeId && isFunction(node) && /[\uD800-\uDFFF]/.test(name)) {
	    return;
	  }

	  name = toBindingIdentifierName(name);
	  id = identifier$6(name);
	  id[NOT_LOCAL_BINDING] = true;
	  const state = visit$1(node, name, scope);
	  return wrap$1(state, node, id, scope) || node;
	}

	const {
	  arrowFunctionExpression: arrowFunctionExpression$2,
	  assignmentExpression: assignmentExpression$5,
	  binaryExpression: binaryExpression$2,
	  blockStatement: blockStatement$2,
	  callExpression: callExpression$5,
	  conditionalExpression: conditionalExpression$2,
	  expressionStatement: expressionStatement$3,
	  identifier: identifier$5,
	  isIdentifier: isIdentifier$3,
	  jsxIdentifier,
	  logicalExpression: logicalExpression$1,
	  LOGICAL_OPERATORS: LOGICAL_OPERATORS$1,
	  memberExpression: memberExpression$4,
	  metaProperty,
	  numericLiteral: numericLiteral$3,
	  objectExpression: objectExpression$1,
	  restElement,
	  returnStatement,
	  sequenceExpression: sequenceExpression$2,
	  spreadElement,
	  stringLiteral: stringLiteral$2,
	  super: _super,
	  thisExpression: thisExpression$2,
	  toExpression,
	  unaryExpression: unaryExpression$4
	} = _t;
	function toComputedKey() {
	  let key;

	  if (this.isMemberExpression()) {
	    key = this.node.property;
	  } else if (this.isProperty() || this.isMethod()) {
	    key = this.node.key;
	  } else {
	    throw new ReferenceError("todo");
	  }

	  if (!this.node.computed) {
	    if (isIdentifier$3(key)) key = stringLiteral$2(key.name);
	  }

	  return key;
	}
	function ensureBlock() {
	  const body = this.get("body");
	  const bodyNode = body.node;

	  if (Array.isArray(body)) {
	    throw new Error("Can't convert array path to a block statement");
	  }

	  if (!bodyNode) {
	    throw new Error("Can't convert node without a body");
	  }

	  if (body.isBlockStatement()) {
	    return bodyNode;
	  }

	  const statements = [];
	  let stringPath = "body";
	  let key;
	  let listKey;

	  if (body.isStatement()) {
	    listKey = "body";
	    key = 0;
	    statements.push(body.node);
	  } else {
	    stringPath += ".body.0";

	    if (this.isFunction()) {
	      key = "argument";
	      statements.push(returnStatement(body.node));
	    } else {
	      key = "expression";
	      statements.push(expressionStatement$3(body.node));
	    }
	  }

	  this.node.body = blockStatement$2(statements);
	  const parentPath = this.get(stringPath);
	  body.setup(parentPath, listKey ? parentPath.node[listKey] : parentPath.node, listKey, key);
	  return this.node;
	}
	function arrowFunctionToShadowed() {
	  if (!this.isArrowFunctionExpression()) return;
	  this.arrowFunctionToExpression();
	}
	function unwrapFunctionEnvironment() {
	  if (!this.isArrowFunctionExpression() && !this.isFunctionExpression() && !this.isFunctionDeclaration()) {
	    throw this.buildCodeFrameError("Can only unwrap the environment of a function.");
	  }

	  hoistFunctionEnvironment(this);
	}
	function arrowFunctionToExpression({
	  allowInsertArrow = true,
	  specCompliant = false,
	  noNewArrows = !specCompliant
	} = {}) {
	  if (!this.isArrowFunctionExpression()) {
	    throw this.buildCodeFrameError("Cannot convert non-arrow function to a function expression.");
	  }

	  const {
	    thisBinding,
	    fnPath: fn
	  } = hoistFunctionEnvironment(this, noNewArrows, allowInsertArrow);
	  fn.ensureBlock();
	  fn.node.type = "FunctionExpression";

	  if (!noNewArrows) {
	    const checkBinding = thisBinding ? null : fn.scope.generateUidIdentifier("arrowCheckId");

	    if (checkBinding) {
	      fn.parentPath.scope.push({
	        id: checkBinding,
	        init: objectExpression$1([])
	      });
	    }

	    fn.get("body").unshiftContainer("body", expressionStatement$3(callExpression$5(this.hub.addHelper("newArrowCheck"), [thisExpression$2(), checkBinding ? identifier$5(checkBinding.name) : identifier$5(thisBinding)])));
	    fn.replaceWith(callExpression$5(memberExpression$4(nameFunction(this, true) || fn.node, identifier$5("bind")), [checkBinding ? identifier$5(checkBinding.name) : thisExpression$2()]));
	  }
	}
	const getSuperCallsVisitor = merge$1([{
	  CallExpression(child, {
	    allSuperCalls
	  }) {
	    if (!child.get("callee").isSuper()) return;
	    allSuperCalls.push(child);
	  }

	}, environmentVisitor]);

	function hoistFunctionEnvironment(fnPath, noNewArrows = true, allowInsertArrow = true) {
	  let arrowParent;
	  let thisEnvFn = fnPath.findParent(p => {
	    if (p.isArrowFunctionExpression()) {
	      arrowParent ??= p;
	      return false;
	    }

	    return p.isFunction() || p.isProgram() || p.isClassProperty({
	      static: false
	    }) || p.isClassPrivateProperty({
	      static: false
	    });
	  });
	  const inConstructor = thisEnvFn.isClassMethod({
	    kind: "constructor"
	  });

	  if (thisEnvFn.isClassProperty() || thisEnvFn.isClassPrivateProperty()) {
	    if (arrowParent) {
	      thisEnvFn = arrowParent;
	    } else if (allowInsertArrow) {
	      fnPath.replaceWith(callExpression$5(arrowFunctionExpression$2([], toExpression(fnPath.node)), []));
	      thisEnvFn = fnPath.get("callee");
	      fnPath = thisEnvFn.get("body");
	    } else {
	      throw fnPath.buildCodeFrameError("Unable to transform arrow inside class property");
	    }
	  }

	  const {
	    thisPaths,
	    argumentsPaths,
	    newTargetPaths,
	    superProps,
	    superCalls
	  } = getScopeInformation(fnPath);

	  if (inConstructor && superCalls.length > 0) {
	    if (!allowInsertArrow) {
	      throw superCalls[0].buildCodeFrameError("Unable to handle nested super() usage in arrow");
	    }

	    const allSuperCalls = [];
	    thisEnvFn.traverse(getSuperCallsVisitor, {
	      allSuperCalls
	    });
	    const superBinding = getSuperBinding(thisEnvFn);
	    allSuperCalls.forEach(superCall => {
	      const callee = identifier$5(superBinding);
	      callee.loc = superCall.node.callee.loc;
	      superCall.get("callee").replaceWith(callee);
	    });
	  }

	  if (argumentsPaths.length > 0) {
	    const argumentsBinding = getBinding(thisEnvFn, "arguments", () => {
	      const args = () => identifier$5("arguments");

	      if (thisEnvFn.scope.path.isProgram()) {
	        return conditionalExpression$2(binaryExpression$2("===", unaryExpression$4("typeof", args()), stringLiteral$2("undefined")), thisEnvFn.scope.buildUndefinedNode(), args());
	      } else {
	        return args();
	      }
	    });
	    argumentsPaths.forEach(argumentsChild => {
	      const argsRef = identifier$5(argumentsBinding);
	      argsRef.loc = argumentsChild.node.loc;
	      argumentsChild.replaceWith(argsRef);
	    });
	  }

	  if (newTargetPaths.length > 0) {
	    const newTargetBinding = getBinding(thisEnvFn, "newtarget", () => metaProperty(identifier$5("new"), identifier$5("target")));
	    newTargetPaths.forEach(targetChild => {
	      const targetRef = identifier$5(newTargetBinding);
	      targetRef.loc = targetChild.node.loc;
	      targetChild.replaceWith(targetRef);
	    });
	  }

	  if (superProps.length > 0) {
	    if (!allowInsertArrow) {
	      throw superProps[0].buildCodeFrameError("Unable to handle nested super.prop usage");
	    }

	    const flatSuperProps = superProps.reduce((acc, superProp) => acc.concat(standardizeSuperProperty(superProp)), []);
	    flatSuperProps.forEach(superProp => {
	      const key = superProp.node.computed ? "" : superProp.get("property").node.name;
	      const isAssignment = superProp.parentPath.isAssignmentExpression({
	        left: superProp.node
	      });
	      const isCall = superProp.parentPath.isCallExpression({
	        callee: superProp.node
	      });
	      const superBinding = getSuperPropBinding(thisEnvFn, isAssignment, key);
	      const args = [];

	      if (superProp.node.computed) {
	        args.push(superProp.get("property").node);
	      }

	      if (isAssignment) {
	        const value = superProp.parentPath.node.right;
	        args.push(value);
	      }

	      const call = callExpression$5(identifier$5(superBinding), args);

	      if (isCall) {
	        superProp.parentPath.unshiftContainer("arguments", thisExpression$2());
	        superProp.replaceWith(memberExpression$4(call, identifier$5("call")));
	        thisPaths.push(superProp.parentPath.get("arguments.0"));
	      } else if (isAssignment) {
	        superProp.parentPath.replaceWith(call);
	      } else {
	        superProp.replaceWith(call);
	      }
	    });
	  }

	  let thisBinding;

	  if (thisPaths.length > 0 || !noNewArrows) {
	    thisBinding = getThisBinding(thisEnvFn, inConstructor);

	    if (noNewArrows || inConstructor && hasSuperClass(thisEnvFn)) {
	      thisPaths.forEach(thisChild => {
	        const thisRef = thisChild.isJSX() ? jsxIdentifier(thisBinding) : identifier$5(thisBinding);
	        thisRef.loc = thisChild.node.loc;
	        thisChild.replaceWith(thisRef);
	      });
	      if (!noNewArrows) thisBinding = null;
	    }
	  }

	  return {
	    thisBinding,
	    fnPath
	  };
	}

	function isLogicalOp(op) {
	  return LOGICAL_OPERATORS$1.includes(op);
	}

	function standardizeSuperProperty(superProp) {
	  if (superProp.parentPath.isAssignmentExpression() && superProp.parentPath.node.operator !== "=") {
	    const assignmentPath = superProp.parentPath;
	    const op = assignmentPath.node.operator.slice(0, -1);
	    const value = assignmentPath.node.right;
	    const isLogicalAssignment = isLogicalOp(op);

	    if (superProp.node.computed) {
	      const tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
	      const object = superProp.node.object;
	      const property = superProp.node.property;
	      assignmentPath.get("left").replaceWith(memberExpression$4(object, assignmentExpression$5("=", tmp, property), true));
	      assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression$4(object, identifier$5(tmp.name), true), value));
	    } else {
	      const object = superProp.node.object;
	      const property = superProp.node.property;
	      assignmentPath.get("left").replaceWith(memberExpression$4(object, property));
	      assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression$4(object, identifier$5(property.name)), value));
	    }

	    if (isLogicalAssignment) {
	      assignmentPath.replaceWith(logicalExpression$1(op, assignmentPath.node.left, assignmentPath.node.right));
	    } else {
	      assignmentPath.node.operator = "=";
	    }

	    return [assignmentPath.get("left"), assignmentPath.get("right").get("left")];
	  } else if (superProp.parentPath.isUpdateExpression()) {
	    const updateExpr = superProp.parentPath;
	    const tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
	    const computedKey = superProp.node.computed ? superProp.scope.generateDeclaredUidIdentifier("prop") : null;
	    const parts = [assignmentExpression$5("=", tmp, memberExpression$4(superProp.node.object, computedKey ? assignmentExpression$5("=", computedKey, superProp.node.property) : superProp.node.property, superProp.node.computed)), assignmentExpression$5("=", memberExpression$4(superProp.node.object, computedKey ? identifier$5(computedKey.name) : superProp.node.property, superProp.node.computed), binaryExpression$2(superProp.parentPath.node.operator[0], identifier$5(tmp.name), numericLiteral$3(1)))];

	    if (!superProp.parentPath.node.prefix) {
	      parts.push(identifier$5(tmp.name));
	    }

	    updateExpr.replaceWith(sequenceExpression$2(parts));
	    const left = updateExpr.get("expressions.0.right");
	    const right = updateExpr.get("expressions.1.left");
	    return [left, right];
	  }

	  return [superProp];

	  function rightExpression(op, left, right) {
	    if (op === "=") {
	      return assignmentExpression$5("=", left, right);
	    } else {
	      return binaryExpression$2(op, left, right);
	    }
	  }
	}

	function hasSuperClass(thisEnvFn) {
	  return thisEnvFn.isClassMethod() && !!thisEnvFn.parentPath.parentPath.node.superClass;
	}

	const assignSuperThisVisitor = merge$1([{
	  CallExpression(child, {
	    supers,
	    thisBinding
	  }) {
	    if (!child.get("callee").isSuper()) return;
	    if (supers.has(child.node)) return;
	    supers.add(child.node);
	    child.replaceWithMultiple([child.node, assignmentExpression$5("=", identifier$5(thisBinding), identifier$5("this"))]);
	  }

	}, environmentVisitor]);

	function getThisBinding(thisEnvFn, inConstructor) {
	  return getBinding(thisEnvFn, "this", thisBinding => {
	    if (!inConstructor || !hasSuperClass(thisEnvFn)) return thisExpression$2();
	    thisEnvFn.traverse(assignSuperThisVisitor, {
	      supers: new WeakSet(),
	      thisBinding
	    });
	  });
	}

	function getSuperBinding(thisEnvFn) {
	  return getBinding(thisEnvFn, "supercall", () => {
	    const argsBinding = thisEnvFn.scope.generateUidIdentifier("args");
	    return arrowFunctionExpression$2([restElement(argsBinding)], callExpression$5(_super(), [spreadElement(identifier$5(argsBinding.name))]));
	  });
	}

	function getSuperPropBinding(thisEnvFn, isAssignment, propName) {
	  const op = isAssignment ? "set" : "get";
	  return getBinding(thisEnvFn, `superprop_${op}:${propName || ""}`, () => {
	    const argsList = [];
	    let fnBody;

	    if (propName) {
	      fnBody = memberExpression$4(_super(), identifier$5(propName));
	    } else {
	      const method = thisEnvFn.scope.generateUidIdentifier("prop");
	      argsList.unshift(method);
	      fnBody = memberExpression$4(_super(), identifier$5(method.name), true);
	    }

	    if (isAssignment) {
	      const valueIdent = thisEnvFn.scope.generateUidIdentifier("value");
	      argsList.push(valueIdent);
	      fnBody = assignmentExpression$5("=", fnBody, identifier$5(valueIdent.name));
	    }

	    return arrowFunctionExpression$2(argsList, fnBody);
	  });
	}

	function getBinding(thisEnvFn, key, init) {
	  const cacheKey = "binding:" + key;
	  let data = thisEnvFn.getData(cacheKey);

	  if (!data) {
	    const id = thisEnvFn.scope.generateUidIdentifier(key);
	    data = id.name;
	    thisEnvFn.setData(cacheKey, data);
	    thisEnvFn.scope.push({
	      id: id,
	      init: init(data)
	    });
	  }

	  return data;
	}

	const getScopeInformationVisitor = merge$1([{
	  ThisExpression(child, {
	    thisPaths
	  }) {
	    thisPaths.push(child);
	  },

	  JSXIdentifier(child, {
	    thisPaths
	  }) {
	    if (child.node.name !== "this") return;

	    if (!child.parentPath.isJSXMemberExpression({
	      object: child.node
	    }) && !child.parentPath.isJSXOpeningElement({
	      name: child.node
	    })) {
	      return;
	    }

	    thisPaths.push(child);
	  },

	  CallExpression(child, {
	    superCalls
	  }) {
	    if (child.get("callee").isSuper()) superCalls.push(child);
	  },

	  MemberExpression(child, {
	    superProps
	  }) {
	    if (child.get("object").isSuper()) superProps.push(child);
	  },

	  Identifier(child, {
	    argumentsPaths
	  }) {
	    if (!child.isReferencedIdentifier({
	      name: "arguments"
	    })) return;
	    let curr = child.scope;

	    do {
	      if (curr.hasOwnBinding("arguments")) {
	        curr.rename("arguments");
	        return;
	      }

	      if (curr.path.isFunction() && !curr.path.isArrowFunctionExpression()) {
	        break;
	      }
	    } while (curr = curr.parent);

	    argumentsPaths.push(child);
	  },

	  MetaProperty(child, {
	    newTargetPaths
	  }) {
	    if (!child.get("meta").isIdentifier({
	      name: "new"
	    })) return;
	    if (!child.get("property").isIdentifier({
	      name: "target"
	    })) return;
	    newTargetPaths.push(child);
	  }

	}, environmentVisitor]);

	function getScopeInformation(fnPath) {
	  const thisPaths = [];
	  const argumentsPaths = [];
	  const newTargetPaths = [];
	  const superProps = [];
	  const superCalls = [];
	  fnPath.traverse(getScopeInformationVisitor, {
	    thisPaths,
	    argumentsPaths,
	    newTargetPaths,
	    superProps,
	    superCalls
	  });
	  return {
	    thisPaths,
	    argumentsPaths,
	    newTargetPaths,
	    superProps,
	    superCalls
	  };
	}

	var NodePath_conversion = /*#__PURE__*/Object.freeze({
		__proto__: null,
		toComputedKey: toComputedKey,
		ensureBlock: ensureBlock,
		arrowFunctionToShadowed: arrowFunctionToShadowed,
		unwrapFunctionEnvironment: unwrapFunctionEnvironment,
		arrowFunctionToExpression: arrowFunctionToExpression
	});

	const {
	  STATEMENT_OR_BLOCK_KEYS,
	  VISITOR_KEYS: VISITOR_KEYS$3,
	  isBlockStatement,
	  isExpression: isExpression$1,
	  isIdentifier: isIdentifier$2,
	  isLiteral,
	  isStringLiteral,
	  isType,
	  matchesPattern: _matchesPattern
	} = _t;
	function matchesPattern(pattern, allowPartial) {
	  return _matchesPattern(this.node, pattern, allowPartial);
	}
	function has$2(key) {
	  const val = this.node && this.node[key];

	  if (val && Array.isArray(val)) {
	    return !!val.length;
	  } else {
	    return !!val;
	  }
	}
	function isStatic() {
	  return this.scope.isStatic(this.node);
	}
	const is = has$2;
	function isnt(key) {
	  return !this.has(key);
	}
	function equals(key, value) {
	  return this.node[key] === value;
	}
	function isNodeType(type) {
	  return isType(this.type, type);
	}
	function canHaveVariableDeclarationOrExpression() {
	  return (this.key === "init" || this.key === "left") && this.parentPath.isFor();
	}
	function canSwapBetweenExpressionAndStatement(replacement) {
	  if (this.key !== "body" || !this.parentPath.isArrowFunctionExpression()) {
	    return false;
	  }

	  if (this.isExpression()) {
	    return isBlockStatement(replacement);
	  } else if (this.isBlockStatement()) {
	    return isExpression$1(replacement);
	  }

	  return false;
	}
	function isCompletionRecord(allowInsideFunction) {
	  let path = this;
	  let first = true;

	  do {
	    const container = path.container;

	    if (path.isFunction() && !first) {
	      return !!allowInsideFunction;
	    }

	    first = false;

	    if (Array.isArray(container) && path.key !== container.length - 1) {
	      return false;
	    }
	  } while ((path = path.parentPath) && !path.isProgram());

	  return true;
	}
	function isStatementOrBlock() {
	  if (this.parentPath.isLabeledStatement() || isBlockStatement(this.container)) {
	    return false;
	  } else {
	    return STATEMENT_OR_BLOCK_KEYS.includes(this.key);
	  }
	}
	function referencesImport(moduleSource, importName) {
	  if (!this.isReferencedIdentifier()) {
	    if ((this.isMemberExpression() || this.isOptionalMemberExpression()) && (this.node.computed ? isStringLiteral(this.node.property, {
	      value: importName
	    }) : this.node.property.name === importName)) {
	      const object = this.get("object");
	      return object.isReferencedIdentifier() && object.referencesImport(moduleSource, "*");
	    }

	    return false;
	  }

	  const binding = this.scope.getBinding(this.node.name);
	  if (!binding || binding.kind !== "module") return false;
	  const path = binding.path;
	  const parent = path.parentPath;
	  if (!parent.isImportDeclaration()) return false;

	  if (parent.node.source.value === moduleSource) {
	    if (!importName) return true;
	  } else {
	    return false;
	  }

	  if (path.isImportDefaultSpecifier() && importName === "default") {
	    return true;
	  }

	  if (path.isImportNamespaceSpecifier() && importName === "*") {
	    return true;
	  }

	  if (path.isImportSpecifier() && isIdentifier$2(path.node.imported, {
	    name: importName
	  })) {
	    return true;
	  }

	  return false;
	}
	function getSource$1() {
	  const node = this.node;

	  if (node.end) {
	    const code = this.hub.getCode();
	    if (code) return code.slice(node.start, node.end);
	  }

	  return "";
	}
	function willIMaybeExecuteBefore(target) {
	  return this._guessExecutionStatusRelativeTo(target) !== "after";
	}

	function getOuterFunction(path) {
	  return (path.scope.getFunctionParent() || path.scope.getProgramParent()).path;
	}

	function isExecutionUncertain(type, key) {
	  switch (type) {
	    case "LogicalExpression":
	      return key === "right";

	    case "ConditionalExpression":
	    case "IfStatement":
	      return key === "consequent" || key === "alternate";

	    case "WhileStatement":
	    case "DoWhileStatement":
	    case "ForInStatement":
	    case "ForOfStatement":
	      return key === "body";

	    case "ForStatement":
	      return key === "body" || key === "update";

	    case "SwitchStatement":
	      return key === "cases";

	    case "TryStatement":
	      return key === "handler";

	    case "AssignmentPattern":
	      return key === "right";

	    case "OptionalMemberExpression":
	      return key === "property";

	    case "OptionalCallExpression":
	      return key === "arguments";

	    default:
	      return false;
	  }
	}

	function isExecutionUncertainInList(paths, maxIndex) {
	  for (let i = 0; i < maxIndex; i++) {
	    const path = paths[i];

	    if (isExecutionUncertain(path.parent.type, path.parentKey)) {
	      return true;
	    }
	  }

	  return false;
	}

	function _guessExecutionStatusRelativeTo(target) {
	  const funcParent = {
	    this: getOuterFunction(this),
	    target: getOuterFunction(target)
	  };

	  if (funcParent.target.node !== funcParent.this.node) {
	    return this._guessExecutionStatusRelativeToDifferentFunctions(funcParent.target);
	  }

	  const paths = {
	    target: target.getAncestry(),
	    this: this.getAncestry()
	  };
	  if (paths.target.indexOf(this) >= 0) return "after";
	  if (paths.this.indexOf(target) >= 0) return "before";
	  let commonPath;
	  const commonIndex = {
	    target: 0,
	    this: 0
	  };

	  while (!commonPath && commonIndex.this < paths.this.length) {
	    const path = paths.this[commonIndex.this];
	    commonIndex.target = paths.target.indexOf(path);

	    if (commonIndex.target >= 0) {
	      commonPath = path;
	    } else {
	      commonIndex.this++;
	    }
	  }

	  if (!commonPath) {
	    throw new Error("Internal Babel error - The two compared nodes" + " don't appear to belong to the same program.");
	  }

	  if (isExecutionUncertainInList(paths.this, commonIndex.this - 1) || isExecutionUncertainInList(paths.target, commonIndex.target - 1)) {
	    return "unknown";
	  }

	  const divergence = {
	    this: paths.this[commonIndex.this - 1],
	    target: paths.target[commonIndex.target - 1]
	  };

	  if (divergence.target.listKey && divergence.this.listKey && divergence.target.container === divergence.this.container) {
	    return divergence.target.key > divergence.this.key ? "before" : "after";
	  }

	  const keys = VISITOR_KEYS$3[commonPath.type];
	  const keyPosition = {
	    this: keys.indexOf(divergence.this.parentKey),
	    target: keys.indexOf(divergence.target.parentKey)
	  };
	  return keyPosition.target > keyPosition.this ? "before" : "after";
	}
	const executionOrderCheckedNodes = new WeakSet();
	function _guessExecutionStatusRelativeToDifferentFunctions(target) {
	  if (!target.isFunctionDeclaration() || target.parentPath.isExportDeclaration()) {
	    return "unknown";
	  }

	  const binding = target.scope.getBinding(target.node.id.name);
	  if (!binding.references) return "before";
	  const referencePaths = binding.referencePaths;
	  let allStatus;

	  for (const path of referencePaths) {
	    const childOfFunction = !!path.find(path => path.node === target.node);
	    if (childOfFunction) continue;

	    if (path.key !== "callee" || !path.parentPath.isCallExpression()) {
	      return "unknown";
	    }

	    if (executionOrderCheckedNodes.has(path.node)) continue;
	    executionOrderCheckedNodes.add(path.node);

	    const status = this._guessExecutionStatusRelativeTo(path);

	    executionOrderCheckedNodes.delete(path.node);

	    if (allStatus && allStatus !== status) {
	      return "unknown";
	    } else {
	      allStatus = status;
	    }
	  }

	  return allStatus;
	}
	function resolve$2(dangerous, resolved) {
	  return this._resolve(dangerous, resolved) || this;
	}
	function _resolve(dangerous, resolved) {
	  if (resolved && resolved.indexOf(this) >= 0) return;
	  resolved = resolved || [];
	  resolved.push(this);

	  if (this.isVariableDeclarator()) {
	    if (this.get("id").isIdentifier()) {
	      return this.get("init").resolve(dangerous, resolved);
	    }
	  } else if (this.isReferencedIdentifier()) {
	    const binding = this.scope.getBinding(this.node.name);
	    if (!binding) return;
	    if (!binding.constant) return;
	    if (binding.kind === "module") return;

	    if (binding.path !== this) {
	      const ret = binding.path.resolve(dangerous, resolved);
	      if (this.find(parent => parent.node === ret.node)) return;
	      return ret;
	    }
	  } else if (this.isTypeCastExpression()) {
	    return this.get("expression").resolve(dangerous, resolved);
	  } else if (dangerous && this.isMemberExpression()) {
	    const targetKey = this.toComputedKey();
	    if (!isLiteral(targetKey)) return;
	    const targetName = targetKey.value;
	    const target = this.get("object").resolve(dangerous, resolved);

	    if (target.isObjectExpression()) {
	      const props = target.get("properties");

	      for (const prop of props) {
	        if (!prop.isProperty()) continue;
	        const key = prop.get("key");
	        let match = prop.isnt("computed") && key.isIdentifier({
	          name: targetName
	        });
	        match = match || key.isLiteral({
	          value: targetName
	        });
	        if (match) return prop.get("value").resolve(dangerous, resolved);
	      }
	    } else if (target.isArrayExpression() && !isNaN(+targetName)) {
	      const elems = target.get("elements");
	      const elem = elems[targetName];
	      if (elem) return elem.resolve(dangerous, resolved);
	    }
	  }
	}
	function isConstantExpression() {
	  if (this.isIdentifier()) {
	    const binding = this.scope.getBinding(this.node.name);
	    if (!binding) return false;
	    return binding.constant;
	  }

	  if (this.isLiteral()) {
	    if (this.isRegExpLiteral()) {
	      return false;
	    }

	    if (this.isTemplateLiteral()) {
	      return this.get("expressions").every(expression => expression.isConstantExpression());
	    }

	    return true;
	  }

	  if (this.isUnaryExpression()) {
	    if (this.node.operator !== "void") {
	      return false;
	    }

	    return this.get("argument").isConstantExpression();
	  }

	  if (this.isBinaryExpression()) {
	    return this.get("left").isConstantExpression() && this.get("right").isConstantExpression();
	  }

	  return false;
	}
	function isInStrictMode() {
	  const start = this.isProgram() ? this : this.parentPath;
	  const strictParent = start.find(path => {
	    if (path.isProgram({
	      sourceType: "module"
	    })) return true;
	    if (path.isClass()) return true;
	    if (!path.isProgram() && !path.isFunction()) return false;

	    if (path.isArrowFunctionExpression() && !path.get("body").isBlockStatement()) {
	      return false;
	    }

	    const body = path.isFunction() ? path.node.body : path.node;

	    for (const directive of body.directives) {
	      if (directive.value.value === "use strict") {
	        return true;
	      }
	    }
	  });
	  return !!strictParent;
	}

	var NodePath_introspection = /*#__PURE__*/Object.freeze({
		__proto__: null,
		matchesPattern: matchesPattern,
		has: has$2,
		isStatic: isStatic,
		is: is,
		isnt: isnt,
		equals: equals,
		isNodeType: isNodeType,
		canHaveVariableDeclarationOrExpression: canHaveVariableDeclarationOrExpression,
		canSwapBetweenExpressionAndStatement: canSwapBetweenExpressionAndStatement,
		isCompletionRecord: isCompletionRecord,
		isStatementOrBlock: isStatementOrBlock,
		referencesImport: referencesImport,
		getSource: getSource$1,
		willIMaybeExecuteBefore: willIMaybeExecuteBefore,
		_guessExecutionStatusRelativeTo: _guessExecutionStatusRelativeTo,
		_guessExecutionStatusRelativeToDifferentFunctions: _guessExecutionStatusRelativeToDifferentFunctions,
		resolve: resolve$2,
		_resolve: _resolve,
		isConstantExpression: isConstantExpression,
		isInStrictMode: isInStrictMode
	});

	function call(key) {
	  const opts = this.opts;
	  this.debug(key);

	  if (this.node) {
	    if (this._call(opts[key])) return true;
	  }

	  if (this.node) {
	    return this._call(opts[this.node.type] && opts[this.node.type][key]);
	  }

	  return false;
	}
	function _call(fns) {
	  if (!fns) return false;

	  for (const fn of fns) {
	    if (!fn) continue;
	    const node = this.node;
	    if (!node) return true;
	    const ret = fn.call(this.state, this, this.state);

	    if (ret && typeof ret === "object" && typeof ret.then === "function") {
	      throw new Error(`You appear to be using a plugin with an async traversal visitor, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, you may need to upgrade ` + `your @babel/core version.`);
	    }

	    if (ret) {
	      throw new Error(`Unexpected return value from visitor method ${fn}`);
	    }

	    if (this.node !== node) return true;
	    if (this._traverseFlags > 0) return true;
	  }

	  return false;
	}
	function isDenylisted() {
	  const denylist = this.opts.denylist ?? this.opts.blacklist;
	  return denylist && denylist.indexOf(this.node.type) > -1;
	}

	function restoreContext(path, context) {
	  if (path.context !== context) {
	    path.context = context;
	    path.state = context.state;
	    path.opts = context.opts;
	  }
	}

	function visit() {
	  if (!this.node) {
	    return false;
	  }

	  if (this.isDenylisted()) {
	    return false;
	  }

	  if (this.opts.shouldSkip && this.opts.shouldSkip(this)) {
	    return false;
	  }

	  const currentContext = this.context;

	  if (this.shouldSkip || this.call("enter")) {
	    this.debug("Skip...");
	    return this.shouldStop;
	  }

	  restoreContext(this, currentContext);
	  this.debug("Recursing into...");
	  this.shouldStop = traverseNode(this.node, this.opts, this.scope, this.state, this, this.skipKeys);
	  restoreContext(this, currentContext);
	  this.call("exit");
	  return this.shouldStop;
	}
	function skip() {
	  this.shouldSkip = true;
	}
	function skipKey(key) {
	  if (this.skipKeys == null) {
	    this.skipKeys = {};
	  }

	  this.skipKeys[key] = true;
	}
	function stop() {
	  this._traverseFlags |= SHOULD_SKIP | SHOULD_STOP;
	}
	function setScope() {
	  if (this.opts && this.opts.noScope) return;
	  let path = this.parentPath;
	  if (this.key === "key" && path.isMethod()) path = path.parentPath;
	  let target;

	  while (path && !target) {
	    if (path.opts && path.opts.noScope) return;
	    target = path.scope;
	    path = path.parentPath;
	  }

	  this.scope = this.getScope(target);
	  if (this.scope) this.scope.init();
	}
	function setContext(context) {
	  if (this.skipKeys != null) {
	    this.skipKeys = {};
	  }

	  this._traverseFlags = 0;

	  if (context) {
	    this.context = context;
	    this.state = context.state;
	    this.opts = context.opts;
	  }

	  this.setScope();
	  return this;
	}
	function resync() {
	  if (this.removed) return;

	  this._resyncParent();

	  this._resyncList();

	  this._resyncKey();
	}
	function _resyncParent() {
	  if (this.parentPath) {
	    this.parent = this.parentPath.node;
	  }
	}
	function _resyncKey() {
	  if (!this.container) return;
	  if (this.node === this.container[this.key]) return;

	  if (Array.isArray(this.container)) {
	    for (let i = 0; i < this.container.length; i++) {
	      if (this.container[i] === this.node) {
	        return this.setKey(i);
	      }
	    }
	  } else {
	    for (const key of Object.keys(this.container)) {
	      if (this.container[key] === this.node) {
	        return this.setKey(key);
	      }
	    }
	  }

	  this.key = null;
	}
	function _resyncList() {
	  if (!this.parent || !this.inList) return;
	  const newContainer = this.parent[this.listKey];
	  if (this.container === newContainer) return;
	  this.container = newContainer || null;
	}
	function _resyncRemoved() {
	  if (this.key == null || !this.container || this.container[this.key] !== this.node) {
	    this._markRemoved();
	  }
	}
	function popContext() {
	  this.contexts.pop();

	  if (this.contexts.length > 0) {
	    this.setContext(this.contexts[this.contexts.length - 1]);
	  } else {
	    this.setContext(undefined);
	  }
	}
	function pushContext(context) {
	  this.contexts.push(context);
	  this.setContext(context);
	}
	function setup(parentPath, container, listKey, key) {
	  this.listKey = listKey;
	  this.container = container;
	  this.parentPath = parentPath || this.parentPath;
	  this.setKey(key);
	}
	function setKey(key) {
	  this.key = key;
	  this.node = this.container[this.key];
	  this.type = this.node?.type;
	}
	function requeue(pathToQueue = this) {
	  if (pathToQueue.removed) return;

	  if (browser$5.env.BABEL_8_BREAKING) {
	    pathToQueue.shouldSkip = false;
	  }

	  const contexts = this.contexts;

	  for (const context of contexts) {
	    context.maybeQueue(pathToQueue);
	  }
	}
	function _getQueueContexts() {
	  let path = this;
	  let contexts = this.contexts;

	  while (!contexts.length) {
	    path = path.parentPath;
	    if (!path) break;
	    contexts = path.contexts;
	  }

	  return contexts;
	}

	var NodePath_context = /*#__PURE__*/Object.freeze({
		__proto__: null,
		call: call,
		_call: _call,
		isDenylisted: isDenylisted,
		isBlacklisted: isDenylisted,
		visit: visit,
		skip: skip,
		skipKey: skipKey,
		stop: stop,
		setScope: setScope,
		setContext: setContext,
		resync: resync,
		_resyncParent: _resyncParent,
		_resyncKey: _resyncKey,
		_resyncList: _resyncList,
		_resyncRemoved: _resyncRemoved,
		popContext: popContext,
		pushContext: pushContext,
		setup: setup,
		setKey: setKey,
		requeue: requeue,
		_getQueueContexts: _getQueueContexts
	});

	const hooks = [function (self, parent) {
	  const removeParent = self.key === "test" && (parent.isWhile() || parent.isSwitchCase()) || self.key === "declaration" && parent.isExportDeclaration() || self.key === "body" && parent.isLabeledStatement() || self.listKey === "declarations" && parent.isVariableDeclaration() && parent.node.declarations.length === 1 || self.key === "expression" && parent.isExpressionStatement();

	  if (removeParent) {
	    parent.remove();
	    return true;
	  }
	}, function (self, parent) {
	  if (parent.isSequenceExpression() && parent.node.expressions.length === 1) {
	    parent.replaceWith(parent.node.expressions[0]);
	    return true;
	  }
	}, function (self, parent) {
	  if (parent.isBinary()) {
	    if (self.key === "left") {
	      parent.replaceWith(parent.node.right);
	    } else {
	      parent.replaceWith(parent.node.left);
	    }

	    return true;
	  }
	}, function (self, parent) {
	  if (parent.isIfStatement() && (self.key === "consequent" || self.key === "alternate") || self.key === "body" && (parent.isLoop() || parent.isArrowFunctionExpression())) {
	    self.replaceWith({
	      type: "BlockStatement",
	      body: []
	    });
	    return true;
	  }
	}];

	function remove() {
	  this._assertUnremoved();

	  this.resync();

	  if (!this.opts?.noScope) {
	    this._removeFromScope();
	  }

	  if (this._callRemovalHooks()) {
	    this._markRemoved();

	    return;
	  }

	  this.shareCommentsWithSiblings();

	  this._remove();

	  this._markRemoved();
	}
	function _removeFromScope() {
	  const bindings = this.getBindingIdentifiers();
	  Object.keys(bindings).forEach(name => this.scope.removeBinding(name));
	}
	function _callRemovalHooks() {
	  for (const fn of hooks) {
	    if (fn(this, this.parentPath)) return true;
	  }
	}
	function _remove() {
	  if (Array.isArray(this.container)) {
	    this.container.splice(this.key, 1);
	    this.updateSiblingKeys(this.key, -1);
	  } else {
	    this._replaceWith(null);
	  }
	}
	function _markRemoved() {
	  this._traverseFlags |= SHOULD_SKIP | REMOVED;
	  if (this.parent) path$3.get(this.parent).delete(this.node);
	  this.node = null;
	}
	function _assertUnremoved() {
	  if (this.removed) {
	    throw this.buildCodeFrameError("NodePath has been removed so is read-only.");
	  }
	}

	var NodePath_removal = /*#__PURE__*/Object.freeze({
		__proto__: null,
		remove: remove,
		_removeFromScope: _removeFromScope,
		_callRemovalHooks: _callRemovalHooks,
		_remove: _remove,
		_markRemoved: _markRemoved,
		_assertUnremoved: _assertUnremoved
	});

	const {
	  react
	} = _t;
	const {
	  cloneNode: cloneNode$6,
	  jsxExpressionContainer,
	  variableDeclaration: variableDeclaration$2,
	  variableDeclarator: variableDeclarator$2
	} = _t;
	const referenceVisitor$1 = {
	  ReferencedIdentifier(path, state) {
	    if (path.isJSXIdentifier() && react.isCompatTag(path.node.name) && !path.parentPath.isJSXMemberExpression()) {
	      return;
	    }

	    if (path.node.name === "this") {
	      let scope = path.scope;

	      do {
	        if (scope.path.isFunction() && !scope.path.isArrowFunctionExpression()) {
	          break;
	        }
	      } while (scope = scope.parent);

	      if (scope) state.breakOnScopePaths.push(scope.path);
	    }

	    const binding = path.scope.getBinding(path.node.name);
	    if (!binding) return;

	    for (const violation of binding.constantViolations) {
	      if (violation.scope !== binding.path.scope) {
	        state.mutableBinding = true;
	        path.stop();
	        return;
	      }
	    }

	    if (binding !== state.scope.getBinding(path.node.name)) return;
	    state.bindings[path.node.name] = binding;
	  }

	};
	class PathHoister {
	  breakOnScopePaths;
	  bindings;
	  mutableBinding;
	  scopes;
	  scope;
	  path;
	  attachAfter;

	  constructor(path, scope) {
	    this.breakOnScopePaths = [];
	    this.bindings = {};
	    this.mutableBinding = false;
	    this.scopes = [];
	    this.scope = scope;
	    this.path = path;
	    this.attachAfter = false;
	  }

	  isCompatibleScope(scope) {
	    for (const key of Object.keys(this.bindings)) {
	      const binding = this.bindings[key];

	      if (!scope.bindingIdentifierEquals(key, binding.identifier)) {
	        return false;
	      }
	    }

	    return true;
	  }

	  getCompatibleScopes() {
	    let scope = this.path.scope;

	    do {
	      if (this.isCompatibleScope(scope)) {
	        this.scopes.push(scope);
	      } else {
	        break;
	      }

	      if (this.breakOnScopePaths.indexOf(scope.path) >= 0) {
	        break;
	      }
	    } while (scope = scope.parent);
	  }

	  getAttachmentPath() {
	    let path = this._getAttachmentPath();

	    if (!path) return;
	    let targetScope = path.scope;

	    if (targetScope.path === path) {
	      targetScope = path.scope.parent;
	    }

	    if (targetScope.path.isProgram() || targetScope.path.isFunction()) {
	      for (const name of Object.keys(this.bindings)) {
	        if (!targetScope.hasOwnBinding(name)) continue;
	        const binding = this.bindings[name];

	        if (binding.kind === "param" || binding.path.parentKey === "params") {
	          continue;
	        }

	        const bindingParentPath = this.getAttachmentParentForPath(binding.path);

	        if (bindingParentPath.key >= path.key) {
	          this.attachAfter = true;
	          path = binding.path;

	          for (const violationPath of binding.constantViolations) {
	            if (this.getAttachmentParentForPath(violationPath).key > path.key) {
	              path = violationPath;
	            }
	          }
	        }
	      }
	    }

	    return path;
	  }

	  _getAttachmentPath() {
	    const scopes = this.scopes;
	    const scope = scopes.pop();
	    if (!scope) return;

	    if (scope.path.isFunction()) {
	      if (this.hasOwnParamBindings(scope)) {
	        if (this.scope === scope) return;
	        const bodies = scope.path.get("body").get("body");

	        for (let i = 0; i < bodies.length; i++) {
	          if (bodies[i].node._blockHoist) continue;
	          return bodies[i];
	        }
	      } else {
	        return this.getNextScopeAttachmentParent();
	      }
	    } else if (scope.path.isProgram()) {
	      return this.getNextScopeAttachmentParent();
	    }
	  }

	  getNextScopeAttachmentParent() {
	    const scope = this.scopes.pop();
	    if (scope) return this.getAttachmentParentForPath(scope.path);
	  }

	  getAttachmentParentForPath(path) {
	    do {
	      if (!path.parentPath || Array.isArray(path.container) && path.isStatement()) {
	        return path;
	      }
	    } while (path = path.parentPath);
	  }

	  hasOwnParamBindings(scope) {
	    for (const name of Object.keys(this.bindings)) {
	      if (!scope.hasOwnBinding(name)) continue;
	      const binding = this.bindings[name];
	      if (binding.kind === "param" && binding.constant) return true;
	    }

	    return false;
	  }

	  run() {
	    this.path.traverse(referenceVisitor$1, this);
	    if (this.mutableBinding) return;
	    this.getCompatibleScopes();
	    const attachTo = this.getAttachmentPath();
	    if (!attachTo) return;
	    if (attachTo.getFunctionParent() === this.path.getFunctionParent()) return;
	    let uid = attachTo.scope.generateUidIdentifier("ref");
	    const declarator = variableDeclarator$2(uid, this.path.node);
	    const insertFn = this.attachAfter ? "insertAfter" : "insertBefore";
	    const [attached] = attachTo[insertFn]([attachTo.isVariableDeclarator() ? declarator : variableDeclaration$2("var", [declarator])]);
	    const parent = this.path.parentPath;

	    if (parent.isJSXElement() && this.path.container === parent.node.children) {
	      uid = jsxExpressionContainer(uid);
	    }

	    this.path.replaceWith(cloneNode$6(uid));
	    return attachTo.isVariableDeclarator() ? attached.get("init") : attached.get("declarations.0.init");
	  }

	}

	const {
	  arrowFunctionExpression: arrowFunctionExpression$1,
	  assertExpression,
	  assignmentExpression: assignmentExpression$4,
	  blockStatement: blockStatement$1,
	  callExpression: callExpression$4,
	  cloneNode: cloneNode$5,
	  expressionStatement: expressionStatement$2,
	  isAssignmentExpression,
	  isCallExpression,
	  isExpression,
	  isIdentifier: isIdentifier$1,
	  isSequenceExpression,
	  isSuper,
	  thisExpression: thisExpression$1
	} = _t;
	function insertBefore(nodes_) {
	  this._assertUnremoved();

	  const nodes = this._verifyNodeList(nodes_);

	  const {
	    parentPath
	  } = this;

	  if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || parentPath.isExportNamedDeclaration() || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
	    return parentPath.insertBefore(nodes);
	  } else if (this.isNodeType("Expression") && !this.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
	    if (this.node) nodes.push(this.node);
	    return this.replaceExpressionWithStatements(nodes);
	  } else if (Array.isArray(this.container)) {
	    return this._containerInsertBefore(nodes);
	  } else if (this.isStatementOrBlock()) {
	    const node = this.node;
	    const shouldInsertCurrentNode = node && (!this.isExpressionStatement() || node.expression != null);
	    this.replaceWith(blockStatement$1(shouldInsertCurrentNode ? [node] : []));
	    return this.unshiftContainer("body", nodes);
	  } else {
	    throw new Error("We don't know what to do with this node type. " + "We were previously a Statement but we can't fit in here?");
	  }
	}
	function _containerInsert(from, nodes) {
	  this.updateSiblingKeys(from, nodes.length);
	  const paths = [];
	  this.container.splice(from, 0, ...nodes);

	  for (let i = 0; i < nodes.length; i++) {
	    const to = from + i;
	    const path = this.getSibling(to);
	    paths.push(path);

	    if (this.context && this.context.queue) {
	      path.pushContext(this.context);
	    }
	  }

	  const contexts = this._getQueueContexts();

	  for (const path of paths) {
	    path.setScope();
	    path.debug("Inserted.");

	    for (const context of contexts) {
	      context.maybeQueue(path, true);
	    }
	  }

	  return paths;
	}
	function _containerInsertBefore(nodes) {
	  return this._containerInsert(this.key, nodes);
	}
	function _containerInsertAfter(nodes) {
	  return this._containerInsert(this.key + 1, nodes);
	}

	const last = arr => arr[arr.length - 1];

	function isHiddenInSequenceExpression(path) {
	  return isSequenceExpression(path.parent) && (last(path.parent.expressions) !== path.node || isHiddenInSequenceExpression(path.parentPath));
	}

	function isAlmostConstantAssignment(node, scope) {
	  if (!isAssignmentExpression(node) || !isIdentifier$1(node.left)) {
	    return false;
	  }

	  const blockScope = scope.getBlockParent();
	  return blockScope.hasOwnBinding(node.left.name) && blockScope.getOwnBinding(node.left.name).constantViolations.length <= 1;
	}

	function insertAfter(nodes_) {
	  this._assertUnremoved();

	  if (this.isSequenceExpression()) {
	    return last(this.get("expressions")).insertAfter(nodes_);
	  }

	  const nodes = this._verifyNodeList(nodes_);

	  const {
	    parentPath
	  } = this;

	  if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || parentPath.isExportNamedDeclaration() || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
	    return parentPath.insertAfter(nodes.map(node => {
	      return isExpression(node) ? expressionStatement$2(node) : node;
	    }));
	  } else if (this.isNodeType("Expression") && !this.isJSXElement() && !parentPath.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
	    if (this.node) {
	      const node = this.node;
	      let {
	        scope
	      } = this;

	      if (scope.path.isPattern()) {
	        assertExpression(node);
	        this.replaceWith(callExpression$4(arrowFunctionExpression$1([], node), []));
	        this.get("callee.body").insertAfter(nodes);
	        return [this];
	      }

	      if (isHiddenInSequenceExpression(this)) {
	        nodes.unshift(node);
	      } else if (isCallExpression(node) && isSuper(node.callee)) {
	        nodes.unshift(node);
	        nodes.push(thisExpression$1());
	      } else if (isAlmostConstantAssignment(node, scope)) {
	        nodes.unshift(node);
	        nodes.push(cloneNode$5(node.left));
	      } else if (scope.isPure(node, true)) {
	        nodes.push(node);
	      } else {
	        if (parentPath.isMethod({
	          computed: true,
	          key: node
	        })) {
	          scope = scope.parent;
	        }

	        const temp = scope.generateDeclaredUidIdentifier();
	        nodes.unshift(expressionStatement$2(assignmentExpression$4("=", cloneNode$5(temp), node)));
	        nodes.push(expressionStatement$2(cloneNode$5(temp)));
	      }
	    }

	    return this.replaceExpressionWithStatements(nodes);
	  } else if (Array.isArray(this.container)) {
	    return this._containerInsertAfter(nodes);
	  } else if (this.isStatementOrBlock()) {
	    const node = this.node;
	    const shouldInsertCurrentNode = node && (!this.isExpressionStatement() || node.expression != null);
	    this.replaceWith(blockStatement$1(shouldInsertCurrentNode ? [node] : []));
	    return this.pushContainer("body", nodes);
	  } else {
	    throw new Error("We don't know what to do with this node type. " + "We were previously a Statement but we can't fit in here?");
	  }
	}
	function updateSiblingKeys(fromIndex, incrementBy) {
	  if (!this.parent) return;
	  const paths = path$3.get(this.parent);

	  for (const [, path] of paths) {
	    if (path.key >= fromIndex) {
	      path.key += incrementBy;
	    }
	  }
	}
	function _verifyNodeList(nodes) {
	  if (!nodes) {
	    return [];
	  }

	  if (!Array.isArray(nodes)) {
	    nodes = [nodes];
	  }

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];
	    let msg;

	    if (!node) {
	      msg = "has falsy node";
	    } else if (typeof node !== "object") {
	      msg = "contains a non-object node";
	    } else if (!node.type) {
	      msg = "without a type";
	    } else if (node instanceof NodePath) {
	      msg = "has a NodePath when it expected a raw object";
	    }

	    if (msg) {
	      const type = Array.isArray(node) ? "array" : typeof node;
	      throw new Error(`Node list ${msg} with the index of ${i} and type of ${type}`);
	    }
	  }

	  return nodes;
	}
	function unshiftContainer(listKey, nodes) {
	  this._assertUnremoved();

	  nodes = this._verifyNodeList(nodes);
	  const path = NodePath.get({
	    parentPath: this,
	    parent: this.node,
	    container: this.node[listKey],
	    listKey,
	    key: 0
	  }).setContext(this.context);
	  return path._containerInsertBefore(nodes);
	}
	function pushContainer(listKey, nodes) {
	  this._assertUnremoved();

	  const verifiedNodes = this._verifyNodeList(nodes);

	  const container = this.node[listKey];
	  const path = NodePath.get({
	    parentPath: this,
	    parent: this.node,
	    container: container,
	    listKey,
	    key: container.length
	  }).setContext(this.context);
	  return path.replaceWithMultiple(verifiedNodes);
	}
	function hoist(scope = this.scope) {
	  const hoister = new PathHoister(this, scope);
	  return hoister.run();
	}

	var NodePath_modification = /*#__PURE__*/Object.freeze({
		__proto__: null,
		insertBefore: insertBefore,
		_containerInsert: _containerInsert,
		_containerInsertBefore: _containerInsertBefore,
		_containerInsertAfter: _containerInsertAfter,
		insertAfter: insertAfter,
		updateSiblingKeys: updateSiblingKeys,
		_verifyNodeList: _verifyNodeList,
		unshiftContainer: unshiftContainer,
		pushContainer: pushContainer,
		hoist: hoist
	});

	const {
	  getBindingIdentifiers: _getBindingIdentifiers,
	  getOuterBindingIdentifiers: _getOuterBindingIdentifiers,
	  isDeclaration,
	  numericLiteral: numericLiteral$2,
	  unaryExpression: unaryExpression$3
	} = _t;
	const NORMAL_COMPLETION = 0;
	const BREAK_COMPLETION = 1;

	function NormalCompletion(path) {
	  return {
	    type: NORMAL_COMPLETION,
	    path
	  };
	}

	function BreakCompletion(path) {
	  return {
	    type: BREAK_COMPLETION,
	    path
	  };
	}

	function getOpposite() {
	  if (this.key === "left") {
	    return this.getSibling("right");
	  } else if (this.key === "right") {
	    return this.getSibling("left");
	  }

	  return null;
	}

	function addCompletionRecords(path, records, context) {
	  if (path) {
	    records.push(..._getCompletionRecords(path, context));
	  }

	  return records;
	}

	function completionRecordForSwitch(cases, records, context) {
	  let lastNormalCompletions = [];

	  for (let i = 0; i < cases.length; i++) {
	    const casePath = cases[i];

	    const caseCompletions = _getCompletionRecords(casePath, context);

	    const normalCompletions = [];
	    const breakCompletions = [];

	    for (const c of caseCompletions) {
	      if (c.type === NORMAL_COMPLETION) {
	        normalCompletions.push(c);
	      }

	      if (c.type === BREAK_COMPLETION) {
	        breakCompletions.push(c);
	      }
	    }

	    if (normalCompletions.length) {
	      lastNormalCompletions = normalCompletions;
	    }

	    records.push(...breakCompletions);
	  }

	  records.push(...lastNormalCompletions);
	  return records;
	}

	function normalCompletionToBreak(completions) {
	  completions.forEach(c => {
	    c.type = BREAK_COMPLETION;
	  });
	}

	function replaceBreakStatementInBreakCompletion(completions, reachable) {
	  completions.forEach(c => {
	    if (c.path.isBreakStatement({
	      label: null
	    })) {
	      if (reachable) {
	        c.path.replaceWith(unaryExpression$3("void", numericLiteral$2(0)));
	      } else {
	        c.path.remove();
	      }
	    }
	  });
	}

	function getStatementListCompletion(paths, context) {
	  const completions = [];

	  if (context.canHaveBreak) {
	    let lastNormalCompletions = [];

	    for (let i = 0; i < paths.length; i++) {
	      const path = paths[i];
	      const newContext = { ...context,
	        inCaseClause: false
	      };

	      if (path.isBlockStatement() && (context.inCaseClause || context.shouldPopulateBreak)) {
	        newContext.shouldPopulateBreak = true;
	      } else {
	        newContext.shouldPopulateBreak = false;
	      }

	      const statementCompletions = _getCompletionRecords(path, newContext);

	      if (statementCompletions.length > 0 && statementCompletions.every(c => c.type === BREAK_COMPLETION)) {
	        if (lastNormalCompletions.length > 0 && statementCompletions.every(c => c.path.isBreakStatement({
	          label: null
	        }))) {
	          normalCompletionToBreak(lastNormalCompletions);
	          completions.push(...lastNormalCompletions);

	          if (lastNormalCompletions.some(c => c.path.isDeclaration())) {
	            completions.push(...statementCompletions);
	            replaceBreakStatementInBreakCompletion(statementCompletions, true);
	          }

	          replaceBreakStatementInBreakCompletion(statementCompletions, false);
	        } else {
	          completions.push(...statementCompletions);

	          if (!context.shouldPopulateBreak) {
	            replaceBreakStatementInBreakCompletion(statementCompletions, true);
	          }
	        }

	        break;
	      }

	      if (i === paths.length - 1) {
	        completions.push(...statementCompletions);
	      } else {
	        lastNormalCompletions = [];

	        for (let i = 0; i < statementCompletions.length; i++) {
	          const c = statementCompletions[i];

	          if (c.type === BREAK_COMPLETION) {
	            completions.push(c);
	          }

	          if (c.type === NORMAL_COMPLETION) {
	            lastNormalCompletions.push(c);
	          }
	        }
	      }
	    }
	  } else if (paths.length) {
	    for (let i = paths.length - 1; i >= 0; i--) {
	      const pathCompletions = _getCompletionRecords(paths[i], context);

	      if (pathCompletions.length > 1 || pathCompletions.length === 1 && !pathCompletions[0].path.isVariableDeclaration()) {
	        completions.push(...pathCompletions);
	        break;
	      }
	    }
	  }

	  return completions;
	}

	function _getCompletionRecords(path, context) {
	  let records = [];

	  if (path.isIfStatement()) {
	    records = addCompletionRecords(path.get("consequent"), records, context);
	    records = addCompletionRecords(path.get("alternate"), records, context);
	  } else if (path.isDoExpression() || path.isFor() || path.isWhile() || path.isLabeledStatement()) {
	    return addCompletionRecords(path.get("body"), records, context);
	  } else if (path.isProgram() || path.isBlockStatement()) {
	    return getStatementListCompletion(path.get("body"), context);
	  } else if (path.isFunction()) {
	    return _getCompletionRecords(path.get("body"), context);
	  } else if (path.isTryStatement()) {
	    records = addCompletionRecords(path.get("block"), records, context);
	    records = addCompletionRecords(path.get("handler"), records, context);
	  } else if (path.isCatchClause()) {
	    return addCompletionRecords(path.get("body"), records, context);
	  } else if (path.isSwitchStatement()) {
	    return completionRecordForSwitch(path.get("cases"), records, context);
	  } else if (path.isSwitchCase()) {
	    return getStatementListCompletion(path.get("consequent"), {
	      canHaveBreak: true,
	      shouldPopulateBreak: false,
	      inCaseClause: true
	    });
	  } else if (path.isBreakStatement()) {
	    records.push(BreakCompletion(path));
	  } else {
	    records.push(NormalCompletion(path));
	  }

	  return records;
	}

	function getCompletionRecords() {
	  const records = _getCompletionRecords(this, {
	    canHaveBreak: false,
	    shouldPopulateBreak: false,
	    inCaseClause: false
	  });

	  return records.map(r => r.path);
	}
	function getSibling(key) {
	  return NodePath.get({
	    parentPath: this.parentPath,
	    parent: this.parent,
	    container: this.container,
	    listKey: this.listKey,
	    key: key
	  }).setContext(this.context);
	}
	function getPrevSibling() {
	  return this.getSibling(this.key - 1);
	}
	function getNextSibling() {
	  return this.getSibling(this.key + 1);
	}
	function getAllNextSiblings() {
	  let _key = this.key;
	  let sibling = this.getSibling(++_key);
	  const siblings = [];

	  while (sibling.node) {
	    siblings.push(sibling);
	    sibling = this.getSibling(++_key);
	  }

	  return siblings;
	}
	function getAllPrevSiblings() {
	  let _key = this.key;
	  let sibling = this.getSibling(--_key);
	  const siblings = [];

	  while (sibling.node) {
	    siblings.push(sibling);
	    sibling = this.getSibling(--_key);
	  }

	  return siblings;
	}

	function get$2(key, context = true) {
	  if (context === true) context = this.context;
	  const parts = key.split(".");

	  if (parts.length === 1) {
	    return this._getKey(key, context);
	  } else {
	    return this._getPattern(parts, context);
	  }
	}
	function _getKey(key, context) {
	  const node = this.node;
	  const container = node[key];

	  if (Array.isArray(container)) {
	    return container.map((_, i) => {
	      return NodePath.get({
	        listKey: key,
	        parentPath: this,
	        parent: node,
	        container: container,
	        key: i
	      }).setContext(context);
	    });
	  } else {
	    return NodePath.get({
	      parentPath: this,
	      parent: node,
	      container: node,
	      key: key
	    }).setContext(context);
	  }
	}
	function _getPattern(parts, context) {
	  let path = this;

	  for (const part of parts) {
	    if (part === ".") {
	      path = path.parentPath;
	    } else {
	      if (Array.isArray(path)) {
	        path = path[part];
	      } else {
	        path = path.get(part, context);
	      }
	    }
	  }

	  return path;
	}

	function getBindingIdentifiers(duplicates) {
	  return _getBindingIdentifiers(this.node, duplicates);
	}

	function getOuterBindingIdentifiers(duplicates) {
	  return _getOuterBindingIdentifiers(this.node, duplicates);
	}
	function getBindingIdentifierPaths(duplicates = false, outerOnly = false) {
	  const path = this;
	  const search = [path];
	  const ids = Object.create(null);

	  while (search.length) {
	    const id = search.shift();
	    if (!id) continue;
	    if (!id.node) continue;
	    const keys = _getBindingIdentifiers.keys[id.node.type];

	    if (id.isIdentifier()) {
	      if (duplicates) {
	        const _ids = ids[id.node.name] = ids[id.node.name] || [];

	        _ids.push(id);
	      } else {
	        ids[id.node.name] = id;
	      }

	      continue;
	    }

	    if (id.isExportDeclaration()) {
	      const declaration = id.get("declaration");

	      if (isDeclaration(declaration)) {
	        search.push(declaration);
	      }

	      continue;
	    }

	    if (outerOnly) {
	      if (id.isFunctionDeclaration()) {
	        search.push(id.get("id"));
	        continue;
	      }

	      if (id.isFunctionExpression()) {
	        continue;
	      }
	    }

	    if (keys) {
	      for (let i = 0; i < keys.length; i++) {
	        const key = keys[i];
	        const child = id.get(key);

	        if (Array.isArray(child)) {
	          search.push(...child);
	        } else if (child.node) {
	          search.push(child);
	        }
	      }
	    }
	  }

	  return ids;
	}
	function getOuterBindingIdentifierPaths(duplicates) {
	  return this.getBindingIdentifierPaths(duplicates, true);
	}

	var NodePath_family = /*#__PURE__*/Object.freeze({
		__proto__: null,
		getOpposite: getOpposite,
		getCompletionRecords: getCompletionRecords,
		getSibling: getSibling,
		getPrevSibling: getPrevSibling,
		getNextSibling: getNextSibling,
		getAllNextSiblings: getAllNextSiblings,
		getAllPrevSiblings: getAllPrevSiblings,
		get: get$2,
		_getKey: _getKey,
		_getPattern: _getPattern,
		getBindingIdentifiers: getBindingIdentifiers,
		getOuterBindingIdentifiers: getOuterBindingIdentifiers,
		getBindingIdentifierPaths: getBindingIdentifierPaths,
		getOuterBindingIdentifierPaths: getOuterBindingIdentifierPaths
	});

	const {
	  addComment: _addComment,
	  addComments: _addComments
	} = _t;
	function shareCommentsWithSiblings() {
	  if (typeof this.key === "string") return;
	  const node = this.node;
	  if (!node) return;
	  const trailing = node.trailingComments;
	  const leading = node.leadingComments;
	  if (!trailing && !leading) return;
	  const prev = this.getSibling(this.key - 1);
	  const next = this.getSibling(this.key + 1);
	  const hasPrev = Boolean(prev.node);
	  const hasNext = Boolean(next.node);

	  if (hasPrev && !hasNext) {
	    prev.addComments("trailing", trailing);
	  } else if (hasNext && !hasPrev) {
	    next.addComments("leading", leading);
	  }
	}
	function addComment$1(type, content, line) {
	  _addComment(this.node, type, content, line);
	}
	function addComments(type, comments) {
	  _addComments(this.node, type, comments);
	}

	var NodePath_comments = /*#__PURE__*/Object.freeze({
		__proto__: null,
		shareCommentsWithSiblings: shareCommentsWithSiblings,
		addComment: addComment$1,
		addComments: addComments
	});

	const {
	  validate: validate$1
	} = _t;
	const debug$3 = browser$4("babel");
	const REMOVED = 1 << 0;
	const SHOULD_STOP = 1 << 1;
	const SHOULD_SKIP = 1 << 2;

	class NodePath {
	  constructor(hub, parent) {
	    this.parent = parent;
	    this.hub = hub;
	    this.data = null;
	    this.context = null;
	    this.scope = null;
	  }

	  contexts = [];
	  state = null;
	  opts = null;
	  _traverseFlags = 0;
	  skipKeys = null;
	  parentPath = null;
	  container = null;
	  listKey = null;
	  key = null;
	  node = null;
	  type = null;

	  static get({
	    hub,
	    parentPath,
	    parent,
	    container,
	    listKey,
	    key
	  }) {
	    if (!hub && parentPath) {
	      hub = parentPath.hub;
	    }

	    if (!parent) {
	      throw new Error("To get a node path the parent needs to exist");
	    }

	    const targetNode = container[key];
	    let paths = path$3.get(parent);

	    if (!paths) {
	      paths = new Map();
	      path$3.set(parent, paths);
	    }

	    let path = paths.get(targetNode);

	    if (!path) {
	      path = new NodePath(hub, parent);
	      if (targetNode) paths.set(targetNode, path);
	    }

	    path.setup(parentPath, container, listKey, key);
	    return path;
	  }

	  getScope(scope) {
	    return this.isScope() ? new Scope$1(this) : scope;
	  }

	  setData(key, val) {
	    if (this.data == null) {
	      this.data = Object.create(null);
	    }

	    return this.data[key] = val;
	  }

	  getData(key, def) {
	    if (this.data == null) {
	      this.data = Object.create(null);
	    }

	    let val = this.data[key];
	    if (val === undefined && def !== undefined) val = this.data[key] = def;
	    return val;
	  }

	  hasNode() {
	    return this.node != null;
	  }

	  buildCodeFrameError(msg, Error = SyntaxError) {
	    return this.hub.buildError(this.node, msg, Error);
	  }

	  traverse(visitor, state) {
	    traverse(this.node, visitor, this.scope, state, this);
	  }

	  set(key, node) {
	    validate$1(this.node, key, node);
	    this.node[key] = node;
	  }

	  getPathLocation() {
	    const parts = [];
	    let path = this;

	    do {
	      let key = path.key;
	      if (path.inList) key = `${path.listKey}[${key}]`;
	      parts.unshift(key);
	    } while (path = path.parentPath);

	    return parts.join(".");
	  }

	  debug(message) {
	    if (!debug$3.enabled) return;
	    debug$3(`${this.getPathLocation()} ${this.type}: ${message}`);
	  }

	  toString() {
	    return generate$1(this.node).code;
	  }

	  get inList() {
	    return !!this.listKey;
	  }

	  set inList(inList) {
	    if (!inList) {
	      this.listKey = null;
	    }
	  }

	  get parentKey() {
	    return this.listKey || this.key;
	  }

	  get shouldSkip() {
	    return !!(this._traverseFlags & SHOULD_SKIP);
	  }

	  set shouldSkip(v) {
	    if (v) {
	      this._traverseFlags |= SHOULD_SKIP;
	    } else {
	      this._traverseFlags &= ~SHOULD_SKIP;
	    }
	  }

	  get shouldStop() {
	    return !!(this._traverseFlags & SHOULD_STOP);
	  }

	  set shouldStop(v) {
	    if (v) {
	      this._traverseFlags |= SHOULD_STOP;
	    } else {
	      this._traverseFlags &= ~SHOULD_STOP;
	    }
	  }

	  get removed() {
	    return !!(this._traverseFlags & REMOVED);
	  }

	  set removed(v) {
	    if (v) {
	      this._traverseFlags |= REMOVED;
	    } else {
	      this._traverseFlags &= ~REMOVED;
	    }
	  }

	}

	Object.assign(NodePath.prototype, NodePath_ancestry, NodePath_inference, NodePath_replacement, NodePath_evaluation, NodePath_conversion, NodePath_introspection, NodePath_context, NodePath_removal, NodePath_modification, NodePath_family, NodePath_comments);

	for (const type of TYPES$1) {
	  const typeKey = `is${type}`;
	  const fn = _t[typeKey];

	  NodePath.prototype[typeKey] = function (opts) {
	    return fn(this.node, opts);
	  };

	  NodePath.prototype[`assert${type}`] = function (opts) {
	    if (!fn(this.node, opts)) {
	      throw new TypeError(`Expected node path of type ${type}`);
	    }
	  };
	}

	for (const type of Object.keys(virtualTypes)) {
	  if (type[0] === "_") continue;
	  if (TYPES$1.indexOf(type) < 0) TYPES$1.push(type);
	  const virtualType = virtualTypes[type];

	  NodePath.prototype[`is${type}`] = function (opts) {
	    return virtualType.checkPath(this, opts);
	  };
	}

	const {
	  VISITOR_KEYS: VISITOR_KEYS$2
	} = _t;
	class TraversalContext {
	  constructor(scope, opts, state, parentPath) {
	    this.parentPath = parentPath;
	    this.scope = scope;
	    this.state = state;
	    this.opts = opts;
	  }

	  queue = null;
	  priorityQueue = null;

	  shouldVisit(node) {
	    const opts = this.opts;
	    if (opts.enter || opts.exit) return true;
	    if (opts[node.type]) return true;
	    const keys = VISITOR_KEYS$2[node.type];
	    if (!keys?.length) return false;

	    for (const key of keys) {
	      if (node[key]) return true;
	    }

	    return false;
	  }

	  create(node, obj, key, listKey) {
	    return NodePath.get({
	      parentPath: this.parentPath,
	      parent: node,
	      container: obj,
	      key: key,
	      listKey
	    });
	  }

	  maybeQueue(path, notPriority) {
	    if (this.queue) {
	      if (notPriority) {
	        this.queue.push(path);
	      } else {
	        this.priorityQueue.push(path);
	      }
	    }
	  }

	  visitMultiple(container, parent, listKey) {
	    if (container.length === 0) return false;
	    const queue = [];

	    for (let key = 0; key < container.length; key++) {
	      const node = container[key];

	      if (node && this.shouldVisit(node)) {
	        queue.push(this.create(parent, container, key, listKey));
	      }
	    }

	    return this.visitQueue(queue);
	  }

	  visitSingle(node, key) {
	    if (this.shouldVisit(node[key])) {
	      return this.visitQueue([this.create(node, node, key)]);
	    } else {
	      return false;
	    }
	  }

	  visitQueue(queue) {
	    this.queue = queue;
	    this.priorityQueue = [];
	    const visited = new WeakSet();
	    let stop = false;

	    for (const path of queue) {
	      path.resync();

	      if (path.contexts.length === 0 || path.contexts[path.contexts.length - 1] !== this) {
	        path.pushContext(this);
	      }

	      if (path.key === null) continue;
	      const {
	        node
	      } = path;
	      if (visited.has(node)) continue;
	      if (node) visited.add(node);

	      if (path.visit()) {
	        stop = true;
	        break;
	      }

	      if (this.priorityQueue.length) {
	        stop = this.visitQueue(this.priorityQueue);
	        this.priorityQueue = [];
	        this.queue = queue;
	        if (stop) break;
	      }
	    }

	    for (const path of queue) {
	      path.popContext();
	    }

	    this.queue = null;
	    return stop;
	  }

	  visit(node, key) {
	    const nodes = node[key];
	    if (!nodes) return false;

	    if (Array.isArray(nodes)) {
	      return this.visitMultiple(nodes, node, key);
	    } else {
	      return this.visitSingle(node, key);
	    }
	  }

	}

	const {
	  VISITOR_KEYS: VISITOR_KEYS$1
	} = _t;
	function traverseNode(node, opts, scope, state, path, skipKeys) {
	  const keys = VISITOR_KEYS$1[node.type];
	  if (!keys) return false;
	  const context = new TraversalContext(scope, opts, state, path);

	  for (const key of keys) {
	    if (skipKeys && skipKeys[key]) continue;

	    if (context.visit(node, key)) {
	      return true;
	    }
	  }

	  return false;
	}

	const {
	  VISITOR_KEYS,
	  removeProperties,
	  traverseFast: traverseFast$1
	} = _t;

	function traverse(parent, opts = {}, scope, state, parentPath) {
	  if (!parent) return;

	  if (!opts.noScope && !scope) {
	    if (parent.type !== "Program" && parent.type !== "File") {
	      throw new Error("You must pass a scope and parentPath unless traversing a Program/File. " + `Instead of that you tried to traverse a ${parent.type} node without ` + "passing scope and parentPath.");
	    }
	  }

	  if (!VISITOR_KEYS[parent.type]) {
	    return;
	  }

	  explode(opts);
	  traverseNode(parent, opts, scope, state, parentPath);
	}
	traverse.visitors = visitors;
	traverse.verify = verify;
	traverse.explode = explode;

	traverse.cheap = function (node, enter) {
	  return traverseFast$1(node, enter);
	};

	traverse.node = function (node, opts, scope, state, path, skipKeys) {
	  traverseNode(node, opts, scope, state, path, skipKeys);
	};

	traverse.clearNode = function (node, opts) {
	  removeProperties(node, opts);
	  path$3.delete(node);
	};

	traverse.removeProperties = function (tree, opts) {
	  traverseFast$1(tree, traverse.clearNode, opts);
	  return tree;
	};

	function hasDenylistedType(path, state) {
	  if (path.node.type === state.type) {
	    state.has = true;
	    path.stop();
	  }
	}

	traverse.hasType = function (tree, type, denylistTypes) {
	  if (denylistTypes?.includes(tree.type)) return false;
	  if (tree.type === type) return true;
	  const state = {
	    has: false,
	    type: type
	  };
	  traverse(tree, {
	    noScope: true,
	    denylist: denylistTypes,
	    enter: hasDenylistedType
	  }, null, state);
	  return state.has;
	};

	traverse.cache = cache$2;

	function helper$1(minVersion, source) {
	  return Object.freeze({
	    minVersion,
	    ast: () => template.program.ast(source)
	  });
	}

	var generated = Object.freeze({
	  applyDecs: helper$1("7.17.0", 'function createMetadataMethodsForProperty(metadataMap,kind,property){return{getMetadata:function(key){if("symbol"!=typeof key)throw new TypeError("Metadata keys must be symbols, received: "+key);var metadataForKey=metadataMap[key];if(void 0!==metadataForKey)if(1===kind){var pub=metadataForKey.public;if(void 0!==pub)return pub[property]}else if(2===kind){var priv=metadataForKey.private;if(void 0!==priv)return priv.get(property)}else if(Object.hasOwnProperty.call(metadataForKey,"constructor"))return metadataForKey.constructor},setMetadata:function(key,value){if("symbol"!=typeof key)throw new TypeError("Metadata keys must be symbols, received: "+key);var metadataForKey=metadataMap[key];if(void 0===metadataForKey&&(metadataForKey=metadataMap[key]={}),1===kind){var pub=metadataForKey.public;void 0===pub&&(pub=metadataForKey.public={}),pub[property]=value}else if(2===kind){var priv=metadataForKey.priv;void 0===priv&&(priv=metadataForKey.private=new Map),priv.set(property,value)}else metadataForKey.constructor=value}}}function convertMetadataMapToFinal(obj,metadataMap){var parentMetadataMap=obj[Symbol.metadata||Symbol.for("Symbol.metadata")],metadataKeys=Object.getOwnPropertySymbols(metadataMap);if(0!==metadataKeys.length){for(var i=0;i<metadataKeys.length;i++){var key=metadataKeys[i],metaForKey=metadataMap[key],parentMetaForKey=parentMetadataMap?parentMetadataMap[key]:null,pub=metaForKey.public,parentPub=parentMetaForKey?parentMetaForKey.public:null;pub&&parentPub&&Object.setPrototypeOf(pub,parentPub);var priv=metaForKey.private;if(priv){var privArr=Array.from(priv.values()),parentPriv=parentMetaForKey?parentMetaForKey.private:null;parentPriv&&(privArr=privArr.concat(parentPriv)),metaForKey.private=privArr}parentMetaForKey&&Object.setPrototypeOf(metaForKey,parentMetaForKey)}parentMetadataMap&&Object.setPrototypeOf(metadataMap,parentMetadataMap),obj[Symbol.metadata||Symbol.for("Symbol.metadata")]=metadataMap}}function createAddInitializerMethod(initializers){return function(initializer){assertValidInitializer(initializer),initializers.push(initializer)}}function memberDecCtx(base,name,desc,metadataMap,initializers,kind,isStatic,isPrivate){var kindStr;switch(kind){case 1:kindStr="accessor";break;case 2:kindStr="method";break;case 3:kindStr="getter";break;case 4:kindStr="setter";break;default:kindStr="field"}var metadataKind,metadataName,ctx={kind:kindStr,name:isPrivate?"#"+name:name,isStatic:isStatic,isPrivate:isPrivate};if(0!==kind&&(ctx.addInitializer=createAddInitializerMethod(initializers)),isPrivate){metadataKind=2,metadataName=Symbol(name);var access={};0===kind?(access.get=desc.get,access.set=desc.set):2===kind?access.get=function(){return desc.value}:(1!==kind&&3!==kind||(access.get=function(){return desc.get.call(this)}),1!==kind&&4!==kind||(access.set=function(v){desc.set.call(this,v)})),ctx.access=access}else metadataKind=1,metadataName=name;return Object.assign(ctx,createMetadataMethodsForProperty(metadataMap,metadataKind,metadataName))}function assertValidInitializer(initializer){if("function"!=typeof initializer)throw new Error("initializers must be functions")}function assertValidReturnValue(kind,value){var type=typeof value;if(1===kind){if("object"!==type||null===value)throw new Error("accessor decorators must return an object with get, set, or initializer properties or void 0")}else if("function"!==type)throw 0===kind?new Error("field decorators must return a initializer function or void 0"):new Error("method decorators must return a function or void 0")}function applyMemberDec(ret,base,decInfo,name,kind,isStatic,isPrivate,metadataMap,initializers){var desc,initializer,value,decs=decInfo[0];isPrivate?desc=0===kind||1===kind?{get:decInfo[3],set:decInfo[4]}:3===kind?{get:decInfo[3]}:4===kind?{set:decInfo[3]}:{value:decInfo[3]}:0!==kind&&(desc=Object.getOwnPropertyDescriptor(base,name)),1===kind?value={get:desc.get,set:desc.set}:2===kind?value=desc.value:3===kind?value=desc.get:4===kind&&(value=desc.set);var newValue,get,set,ctx=memberDecCtx(base,name,desc,metadataMap,initializers,kind,isStatic,isPrivate);if("function"==typeof decs)void 0!==(newValue=decs(value,ctx))&&(assertValidReturnValue(kind,newValue),0===kind?initializer=newValue:1===kind?(initializer=newValue.initializer,get=newValue.get||value.get,set=newValue.set||value.set,value={get:get,set:set}):value=newValue);else for(var i=decs.length-1;i>=0;i--){var newInit;if(void 0!==(newValue=(0,decs[i])(value,ctx)))assertValidReturnValue(kind,newValue),0===kind?newInit=newValue:1===kind?(newInit=newValue.initializer,get=newValue.get||value.get,set=newValue.set||value.set,value={get:get,set:set}):value=newValue,void 0!==newInit&&(void 0===initializer?initializer=newInit:"function"==typeof initializer?initializer=[initializer,newInit]:initializer.push(newInit))}if(0===kind||1===kind){if(void 0===initializer)initializer=function(instance,init){return init};else if("function"!=typeof initializer){var ownInitializers=initializer;initializer=function(instance,init){for(var value=init,i=0;i<ownInitializers.length;i++)value=ownInitializers[i].call(instance,value);return value}}else{var originalInitializer=initializer;initializer=function(instance,init){return originalInitializer.call(instance,init)}}ret.push(initializer)}0!==kind&&(1===kind?(desc.get=value.get,desc.set=value.set):2===kind?desc.value=value:3===kind?desc.get=value:4===kind&&(desc.set=value),isPrivate?1===kind?(ret.push((function(instance,args){return value.get.call(instance,args)})),ret.push((function(instance,args){return value.set.call(instance,args)}))):2===kind?ret.push(value):ret.push((function(instance,args){return value.call(instance,args)})):Object.defineProperty(base,name,desc))}function applyMemberDecs(ret,Class,protoMetadataMap,staticMetadataMap,decInfos){for(var protoInitializers=[],staticInitializers=[],existingProtoNonFields=new Map,existingStaticNonFields=new Map,i=0;i<decInfos.length;i++){var decInfo=decInfos[i];if(Array.isArray(decInfo)){var base,metadataMap,initializers,kind=decInfo[1],name=decInfo[2],isPrivate=decInfo.length>3,isStatic=kind>=5;if(isStatic?(base=Class,metadataMap=staticMetadataMap,kind-=5,initializers=staticInitializers):(base=Class.prototype,metadataMap=protoMetadataMap,initializers=protoInitializers),0!==kind&&!isPrivate){var existingNonFields=isStatic?existingStaticNonFields:existingProtoNonFields,existingKind=existingNonFields.get(name)||0;if(!0===existingKind||3===existingKind&&4!==kind||4===existingKind&&3!==kind)throw new Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+name);!existingKind&&kind>2?existingNonFields.set(name,kind):existingNonFields.set(name,!0)}applyMemberDec(ret,base,decInfo,name,kind,isStatic,isPrivate,metadataMap,initializers)}}protoInitializers.length>0&&pushInitializers(ret,protoInitializers),staticInitializers.length>0&&pushInitializers(ret,staticInitializers)}function pushInitializers(ret,initializers){initializers.length>0?(initializers=initializers.slice(),ret.push((function(instance){for(var i=0;i<initializers.length;i++)initializers[i].call(instance,instance);return instance}))):ret.push((function(instance){return instance}))}function applyClassDecs(ret,targetClass,metadataMap,classDecs){for(var initializers=[],newClass=targetClass,name=targetClass.name,ctx=Object.assign({kind:"class",name:name,addInitializer:createAddInitializerMethod(initializers)},createMetadataMethodsForProperty(metadataMap,0,name)),i=classDecs.length-1;i>=0;i--)newClass=classDecs[i](newClass,ctx)||newClass;ret.push(newClass),initializers.length>0?ret.push((function(){for(var i=0;i<initializers.length;i++)initializers[i].call(newClass,newClass)})):ret.push((function(){}))}export default function applyDecs(targetClass,memberDecs,classDecs){var ret=[],staticMetadataMap={};if(memberDecs){var protoMetadataMap={};applyMemberDecs(ret,targetClass,protoMetadataMap,staticMetadataMap,memberDecs),convertMetadataMapToFinal(targetClass.prototype,protoMetadataMap)}return classDecs&&applyClassDecs(ret,targetClass,staticMetadataMap,classDecs),convertMetadataMapToFinal(targetClass,staticMetadataMap),ret}'),
	  asyncIterator: helper$1("7.15.9", 'export default function _asyncIterator(iterable){var method,async,sync,retry=2;for("undefined"!=typeof Symbol&&(async=Symbol.asyncIterator,sync=Symbol.iterator);retry--;){if(async&&null!=(method=iterable[async]))return method.call(iterable);if(sync&&null!=(method=iterable[sync]))return new AsyncFromSyncIterator(method.call(iterable));async="@@asyncIterator",sync="@@iterator"}throw new TypeError("Object is not async iterable")}function AsyncFromSyncIterator(s){function AsyncFromSyncIteratorContinuation(r){if(Object(r)!==r)return Promise.reject(new TypeError(r+" is not an object."));var done=r.done;return Promise.resolve(r.value).then((function(value){return{value:value,done:done}}))}return AsyncFromSyncIterator=function(s){this.s=s,this.n=s.next},AsyncFromSyncIterator.prototype={s:null,n:null,next:function(){return AsyncFromSyncIteratorContinuation(this.n.apply(this.s,arguments))},return:function(value){var ret=this.s.return;return void 0===ret?Promise.resolve({value:value,done:!0}):AsyncFromSyncIteratorContinuation(ret.apply(this.s,arguments))},throw:function(value){var thr=this.s.return;return void 0===thr?Promise.reject(value):AsyncFromSyncIteratorContinuation(thr.apply(this.s,arguments))}},new AsyncFromSyncIterator(s)}'),
	  jsx: helper$1("7.0.0-beta.0", 'var REACT_ELEMENT_TYPE;export default function _createRawReactElement(type,props,key,children){REACT_ELEMENT_TYPE||(REACT_ELEMENT_TYPE="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103);var defaultProps=type&&type.defaultProps,childrenLength=arguments.length-3;if(props||0===childrenLength||(props={children:void 0}),1===childrenLength)props.children=children;else if(childrenLength>1){for(var childArray=new Array(childrenLength),i=0;i<childrenLength;i++)childArray[i]=arguments[i+3];props.children=childArray}if(props&&defaultProps)for(var propName in defaultProps)void 0===props[propName]&&(props[propName]=defaultProps[propName]);else props||(props=defaultProps||{});return{$$typeof:REACT_ELEMENT_TYPE,type:type,key:void 0===key?null:""+key,ref:null,props:props,_owner:null}}'),
	  objectSpread2: helper$1("7.5.0", 'import defineProperty from"defineProperty";function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);enumerableOnly&&(symbols=symbols.filter((function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable}))),keys.push.apply(keys,symbols)}return keys}export default function _objectSpread2(target){for(var i=1;i<arguments.length;i++){var source=null!=arguments[i]?arguments[i]:{};i%2?ownKeys(Object(source),!0).forEach((function(key){defineProperty(target,key,source[key])})):Object.getOwnPropertyDescriptors?Object.defineProperties(target,Object.getOwnPropertyDescriptors(source)):ownKeys(Object(source)).forEach((function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))}))}return target}'),
	  typeof: helper$1("7.0.0-beta.0", 'export default function _typeof(obj){"@babel/helpers - typeof";return _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj},_typeof(obj)}'),
	  wrapRegExp: helper$1("7.2.6", 'import setPrototypeOf from"setPrototypeOf";import inherits from"inherits";export default function _wrapRegExp(){_wrapRegExp=function(re,groups){return new BabelRegExp(re,void 0,groups)};var _super=RegExp.prototype,_groups=new WeakMap;function BabelRegExp(re,flags,groups){var _this=new RegExp(re,flags);return _groups.set(_this,groups||_groups.get(re)),setPrototypeOf(_this,BabelRegExp.prototype)}function buildGroups(result,re){var g=_groups.get(re);return Object.keys(g).reduce((function(groups,name){return groups[name]=result[g[name]],groups}),Object.create(null))}return inherits(BabelRegExp,RegExp),BabelRegExp.prototype.exec=function(str){var result=_super.exec.call(this,str);return result&&(result.groups=buildGroups(result,this)),result},BabelRegExp.prototype[Symbol.replace]=function(str,substitution){if("string"==typeof substitution){var groups=_groups.get(this);return _super[Symbol.replace].call(this,str,substitution.replace(/\\$<([^>]+)>/g,(function(_,name){return"$"+groups[name]})))}if("function"==typeof substitution){var _this=this;return _super[Symbol.replace].call(this,str,(function(){var args=arguments;return"object"!=typeof args[args.length-1]&&(args=[].slice.call(args)).push(buildGroups(args,_this)),substitution.apply(this,args)}))}return _super[Symbol.replace].call(this,str,substitution)},_wrapRegExp.apply(this,arguments)}')
	});

	const helpers = {
	  __proto__: null,
	  ...generated
	};

	const helper = minVersion => tpl => ({
	  minVersion,
	  ast: () => template.program.ast(tpl)
	});

	helpers.AwaitValue = helper("7.0.0-beta.0")`
  export default function _AwaitValue(value) {
    this.wrapped = value;
  }
`;
	helpers.AsyncGenerator = helper("7.0.0-beta.0")`
  import AwaitValue from "AwaitValue";

  export default function AsyncGenerator(gen) {
    var front, back;

    function send(key, arg) {
      return new Promise(function (resolve, reject) {
        var request = {
          key: key,
          arg: arg,
          resolve: resolve,
          reject: reject,
          next: null,
        };

        if (back) {
          back = back.next = request;
        } else {
          front = back = request;
          resume(key, arg);
        }
      });
    }

    function resume(key, arg) {
      try {
        var result = gen[key](arg)
        var value = result.value;
        var wrappedAwait = value instanceof AwaitValue;

        Promise.resolve(wrappedAwait ? value.wrapped : value).then(
          function (arg) {
            if (wrappedAwait) {
              resume(key === "return" ? "return" : "next", arg);
              return
            }

            settle(result.done ? "return" : "normal", arg);
          },
          function (err) { resume("throw", err); });
      } catch (err) {
        settle("throw", err);
      }
    }

    function settle(type, value) {
      switch (type) {
        case "return":
          front.resolve({ value: value, done: true });
          break;
        case "throw":
          front.reject(value);
          break;
        default:
          front.resolve({ value: value, done: false });
          break;
      }

      front = front.next;
      if (front) {
        resume(front.key, front.arg);
      } else {
        back = null;
      }
    }

    this._invoke = send;

    // Hide "return" method if generator return is not supported
    if (typeof gen.return !== "function") {
      this.return = undefined;
    }
  }

  AsyncGenerator.prototype[typeof Symbol === "function" && Symbol.asyncIterator || "@@asyncIterator"] = function () { return this; };

  AsyncGenerator.prototype.next = function (arg) { return this._invoke("next", arg); };
  AsyncGenerator.prototype.throw = function (arg) { return this._invoke("throw", arg); };
  AsyncGenerator.prototype.return = function (arg) { return this._invoke("return", arg); };
`;
	helpers.wrapAsyncGenerator = helper("7.0.0-beta.0")`
  import AsyncGenerator from "AsyncGenerator";

  export default function _wrapAsyncGenerator(fn) {
    return function () {
      return new AsyncGenerator(fn.apply(this, arguments));
    };
  }
`;
	helpers.awaitAsyncGenerator = helper("7.0.0-beta.0")`
  import AwaitValue from "AwaitValue";

  export default function _awaitAsyncGenerator(value) {
    return new AwaitValue(value);
  }
`;
	helpers.asyncGeneratorDelegate = helper("7.0.0-beta.0")`
  export default function _asyncGeneratorDelegate(inner, awaitWrap) {
    var iter = {}, waiting = false;

    function pump(key, value) {
      waiting = true;
      value = new Promise(function (resolve) { resolve(inner[key](value)); });
      return { done: false, value: awaitWrap(value) };
    };

    iter[typeof Symbol !== "undefined" && Symbol.iterator || "@@iterator"] = function () { return this; };

    iter.next = function (value) {
      if (waiting) {
        waiting = false;
        return value;
      }
      return pump("next", value);
    };

    if (typeof inner.throw === "function") {
      iter.throw = function (value) {
        if (waiting) {
          waiting = false;
          throw value;
        }
        return pump("throw", value);
      };
    }

    if (typeof inner.return === "function") {
      iter.return = function (value) {
        if (waiting) {
          waiting = false;
          return value;
        }
        return pump("return", value);
      };
    }

    return iter;
  }
`;
	helpers.asyncToGenerator = helper("7.0.0-beta.0")`
  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  export default function _asyncToGenerator(fn) {
    return function () {
      var self = this, args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }
        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }
`;
	helpers.classCallCheck = helper("7.0.0-beta.0")`
  export default function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
`;
	helpers.createClass = helper("7.0.0-beta.0")`
  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i ++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  export default function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", { writable: false });
    return Constructor;
  }
`;
	helpers.defineEnumerableProperties = helper("7.0.0-beta.0")`
  export default function _defineEnumerableProperties(obj, descs) {
    for (var key in descs) {
      var desc = descs[key];
      desc.configurable = desc.enumerable = true;
      if ("value" in desc) desc.writable = true;
      Object.defineProperty(obj, key, desc);
    }

    // Symbols are not enumerated over by for-in loops. If native
    // Symbols are available, fetch all of the descs object's own
    // symbol properties and define them on our target object too.
    if (Object.getOwnPropertySymbols) {
      var objectSymbols = Object.getOwnPropertySymbols(descs);
      for (var i = 0; i < objectSymbols.length; i++) {
        var sym = objectSymbols[i];
        var desc = descs[sym];
        desc.configurable = desc.enumerable = true;
        if ("value" in desc) desc.writable = true;
        Object.defineProperty(obj, sym, desc);
      }
    }
    return obj;
  }
`;
	helpers.defaults = helper("7.0.0-beta.0")`
  export default function _defaults(obj, defaults) {
    var keys = Object.getOwnPropertyNames(defaults);
    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];
      var value = Object.getOwnPropertyDescriptor(defaults, key);
      if (value && value.configurable && obj[key] === undefined) {
        Object.defineProperty(obj, key, value);
      }
    }
    return obj;
  }
`;
	helpers.defineProperty = helper("7.0.0-beta.0")`
  export default function _defineProperty(obj, key, value) {
    // Shortcircuit the slow defineProperty path when possible.
    // We are trying to avoid issues where setters defined on the
    // prototype cause side effects under the fast path of simple
    // assignment. By checking for existence of the property with
    // the in operator, we can optimize most of this overhead away.
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }
    return obj;
  }
`;
	helpers.extends = helper("7.0.0-beta.0")`
  export default function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };

    return _extends.apply(this, arguments);
  }
`;
	helpers.objectSpread = helper("7.0.0-beta.0")`
  import defineProperty from "defineProperty";

  export default function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = (arguments[i] != null) ? Object(arguments[i]) : {};
      var ownKeys = Object.keys(source);
      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys.push.apply(ownKeys, Object.getOwnPropertySymbols(source).filter(function(sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }
      ownKeys.forEach(function(key) {
        defineProperty(target, key, source[key]);
      });
    }
    return target;
  }
`;
	helpers.inherits = helper("7.0.0-beta.0")`
  import setPrototypeOf from "setPrototypeOf";

  export default function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }
    // We can't use defineProperty to set the prototype in a single step because it
    // doesn't work in Chrome <= 36. https://github.com/babel/babel/issues/14056
    // V8 bug: https://bugs.chromium.org/p/v8/issues/detail?id=3334
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    Object.defineProperty(subClass, "prototype", { writable: false });
    if (superClass) setPrototypeOf(subClass, superClass);
  }
`;
	helpers.inheritsLoose = helper("7.0.0-beta.0")`
  import setPrototypeOf from "setPrototypeOf";

  export default function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    setPrototypeOf(subClass, superClass);
  }
`;
	helpers.getPrototypeOf = helper("7.0.0-beta.0")`
  export default function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf
      ? Object.getPrototypeOf
      : function _getPrototypeOf(o) {
          return o.__proto__ || Object.getPrototypeOf(o);
        };
    return _getPrototypeOf(o);
  }
`;
	helpers.setPrototypeOf = helper("7.0.0-beta.0")`
  export default function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
    return _setPrototypeOf(o, p);
  }
`;
	helpers.isNativeReflectConstruct = helper("7.9.0")`
  export default function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;

    // core-js@3
    if (Reflect.construct.sham) return false;

    // Proxy can't be polyfilled. Every browser implemented
    // proxies before or at the same time as Reflect.construct,
    // so if they support Proxy they also support Reflect.construct.
    if (typeof Proxy === "function") return true;

    // Since Reflect.construct can't be properly polyfilled, some
    // implementations (e.g. core-js@2) don't set the correct internal slots.
    // Those polyfills don't allow us to subclass built-ins, so we need to
    // use our fallback implementation.
    try {
      // If the internal slots aren't set, this throws an error similar to
      //   TypeError: this is not a Boolean object.

      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
      return true;
    } catch (e) {
      return false;
    }
  }
`;
	helpers.construct = helper("7.0.0-beta.0")`
  import setPrototypeOf from "setPrototypeOf";
  import isNativeReflectConstruct from "isNativeReflectConstruct";

  export default function _construct(Parent, args, Class) {
    if (isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      // NOTE: If Parent !== Class, the correct __proto__ is set *after*
      //       calling the constructor.
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }
    // Avoid issues with Class being present but undefined when it wasn't
    // present in the original call.
    return _construct.apply(null, arguments);
  }
`;
	helpers.isNativeFunction = helper("7.0.0-beta.0")`
  export default function _isNativeFunction(fn) {
    // Note: This function returns "true" for core-js functions.
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }
`;
	helpers.wrapNativeSuper = helper("7.0.0-beta.0")`
  import getPrototypeOf from "getPrototypeOf";
  import setPrototypeOf from "setPrototypeOf";
  import isNativeFunction from "isNativeFunction";
  import construct from "construct";

  export default function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !isNativeFunction(Class)) return Class;
      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }
      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);
        _cache.set(Class, Wrapper);
      }
      function Wrapper() {
        return construct(Class, arguments, getPrototypeOf(this).constructor)
      }
      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true,
        }
      });

      return setPrototypeOf(Wrapper, Class);
    }

    return _wrapNativeSuper(Class)
  }
`;
	helpers.instanceof = helper("7.0.0-beta.0")`
  export default function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
      return !!right[Symbol.hasInstance](left);
    } else {
      return left instanceof right;
    }
  }
`;
	helpers.interopRequireDefault = helper("7.0.0-beta.0")`
  export default function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
`;
	helpers.interopRequireWildcard = helper("7.14.0")`
  function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;

    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function (nodeInterop) {
      return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
  }

  export default function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
      return obj;
    }

    if (obj === null || (typeof obj !== "object" && typeof obj !== "function")) {
      return { default: obj }
    }

    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }

    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
`;
	helpers.newArrowCheck = helper("7.0.0-beta.0")`
  export default function _newArrowCheck(innerThis, boundThis) {
    if (innerThis !== boundThis) {
      throw new TypeError("Cannot instantiate an arrow function");
    }
  }
`;
	helpers.objectDestructuringEmpty = helper("7.0.0-beta.0")`
  export default function _objectDestructuringEmpty(obj) {
    if (obj == null) throw new TypeError("Cannot destructure undefined");
  }
`;
	helpers.objectWithoutPropertiesLoose = helper("7.0.0-beta.0")`
  export default function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};

    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }
`;
	helpers.objectWithoutProperties = helper("7.0.0-beta.0")`
  import objectWithoutPropertiesLoose from "objectWithoutPropertiesLoose";

  export default function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = objectWithoutPropertiesLoose(source, excluded);
    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }
`;
	helpers.assertThisInitialized = helper("7.0.0-beta.0")`
  export default function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
  }
`;
	helpers.possibleConstructorReturn = helper("7.0.0-beta.0")`
  import assertThisInitialized from "assertThisInitialized";

  export default function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }

    return assertThisInitialized(self);
  }
`;
	helpers.createSuper = helper("7.9.0")`
  import getPrototypeOf from "getPrototypeOf";
  import isNativeReflectConstruct from "isNativeReflectConstruct";
  import possibleConstructorReturn from "possibleConstructorReturn";

  export default function _createSuper(Derived) {
    var hasNativeReflectConstruct = isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = getPrototypeOf(Derived), result;
      if (hasNativeReflectConstruct) {
        // NOTE: This doesn't work if this.__proto__.constructor has been modified.
        var NewTarget = getPrototypeOf(this).constructor;
        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }
      return possibleConstructorReturn(this, result);
    }
  }
 `;
	helpers.superPropBase = helper("7.0.0-beta.0")`
  import getPrototypeOf from "getPrototypeOf";

  export default function _superPropBase(object, property) {
    // Yes, this throws if object is null to being with, that's on purpose.
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = getPrototypeOf(object);
      if (object === null) break;
    }
    return object;
  }
`;
	helpers.get = helper("7.0.0-beta.0")`
  import superPropBase from "superPropBase";

  export default function _get() {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get;
    } else {
      _get = function _get(target, property, receiver) {
        var base = superPropBase(target, property);

        if (!base) return;

        var desc = Object.getOwnPropertyDescriptor(base, property);
        if (desc.get) {
          // STEP 3. If receiver is not present, then set receiver to target.
          return desc.get.call(arguments.length < 3 ? target : receiver);
        }

        return desc.value;
      };
    }
    return _get.apply(this, arguments);
  }
`;
	helpers.set = helper("7.0.0-beta.0")`
  import superPropBase from "superPropBase";
  import defineProperty from "defineProperty";

  function set(target, property, value, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.set) {
      set = Reflect.set;
    } else {
      set = function set(target, property, value, receiver) {
        var base = superPropBase(target, property);
        var desc;

        if (base) {
          desc = Object.getOwnPropertyDescriptor(base, property);
          if (desc.set) {
            desc.set.call(receiver, value);
            return true;
          } else if (!desc.writable) {
            // Both getter and non-writable fall into this.
            return false;
          }
        }

        // Without a super that defines the property, spec boils down to
        // "define on receiver" for some reason.
        desc = Object.getOwnPropertyDescriptor(receiver, property);
        if (desc) {
          if (!desc.writable) {
            // Setter, getter, and non-writable fall into this.
            return false;
          }

          desc.value = value;
          Object.defineProperty(receiver, property, desc);
        } else {
          // Avoid setters that may be defined on Sub's prototype, but not on
          // the instance.
          defineProperty(receiver, property, value);
        }

        return true;
      };
    }

    return set(target, property, value, receiver);
  }

  export default function _set(target, property, value, receiver, isStrict) {
    var s = set(target, property, value, receiver || target);
    if (!s && isStrict) {
      throw new Error('failed to set property');
    }

    return value;
  }
`;
	helpers.taggedTemplateLiteral = helper("7.0.0-beta.0")`
  export default function _taggedTemplateLiteral(strings, raw) {
    if (!raw) { raw = strings.slice(0); }
    return Object.freeze(Object.defineProperties(strings, {
        raw: { value: Object.freeze(raw) }
    }));
  }
`;
	helpers.taggedTemplateLiteralLoose = helper("7.0.0-beta.0")`
  export default function _taggedTemplateLiteralLoose(strings, raw) {
    if (!raw) { raw = strings.slice(0); }
    strings.raw = raw;
    return strings;
  }
`;
	helpers.readOnlyError = helper("7.0.0-beta.0")`
  export default function _readOnlyError(name) {
    throw new TypeError("\\"" + name + "\\" is read-only");
  }
`;
	helpers.writeOnlyError = helper("7.12.13")`
  export default function _writeOnlyError(name) {
    throw new TypeError("\\"" + name + "\\" is write-only");
  }
`;
	helpers.classNameTDZError = helper("7.0.0-beta.0")`
  export default function _classNameTDZError(name) {
    throw new Error("Class \\"" + name + "\\" cannot be referenced in computed property keys.");
  }
`;
	helpers.temporalUndefined = helper("7.0.0-beta.0")`
  // This function isn't mean to be called, but to be used as a reference.
  // We can't use a normal object because it isn't hoisted.
  export default function _temporalUndefined() {}
`;
	helpers.tdz = helper("7.5.5")`
  export default function _tdzError(name) {
    throw new ReferenceError(name + " is not defined - temporal dead zone");
  }
`;
	helpers.temporalRef = helper("7.0.0-beta.0")`
  import undef from "temporalUndefined";
  import err from "tdz";

  export default function _temporalRef(val, name) {
    return val === undef ? err(name) : val;
  }
`;
	helpers.slicedToArray = helper("7.0.0-beta.0")`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArrayLimit from "iterableToArrayLimit";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _slicedToArray(arr, i) {
    return (
      arrayWithHoles(arr) ||
      iterableToArrayLimit(arr, i) ||
      unsupportedIterableToArray(arr, i) ||
      nonIterableRest()
    );
  }
`;
	helpers.slicedToArrayLoose = helper("7.0.0-beta.0")`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArrayLimitLoose from "iterableToArrayLimitLoose";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _slicedToArrayLoose(arr, i) {
    return (
      arrayWithHoles(arr) ||
      iterableToArrayLimitLoose(arr, i) ||
      unsupportedIterableToArray(arr, i) ||
      nonIterableRest()
    );
  }
`;
	helpers.toArray = helper("7.0.0-beta.0")`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArray from "iterableToArray";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _toArray(arr) {
    return (
      arrayWithHoles(arr) ||
      iterableToArray(arr) ||
      unsupportedIterableToArray(arr) ||
      nonIterableRest()
    );
  }
`;
	helpers.toConsumableArray = helper("7.0.0-beta.0")`
  import arrayWithoutHoles from "arrayWithoutHoles";
  import iterableToArray from "iterableToArray";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableSpread from "nonIterableSpread";

  export default function _toConsumableArray(arr) {
    return (
      arrayWithoutHoles(arr) ||
      iterableToArray(arr) ||
      unsupportedIterableToArray(arr) ||
      nonIterableSpread()
    );
  }
`;
	helpers.arrayWithoutHoles = helper("7.0.0-beta.0")`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return arrayLikeToArray(arr);
  }
`;
	helpers.arrayWithHoles = helper("7.0.0-beta.0")`
  export default function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }
`;
	helpers.maybeArrayLike = helper("7.9.0")`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _maybeArrayLike(next, arr, i) {
    if (arr && !Array.isArray(arr) && typeof arr.length === "number") {
      var len = arr.length;
      return arrayLikeToArray(arr, i !== void 0 && i < len ? i : len);
    }
    return next(arr, i);
  }
`;
	helpers.iterableToArray = helper("7.0.0-beta.0")`
  export default function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }
`;
	helpers.iterableToArrayLimit = helper("7.0.0-beta.0")`
  export default function _iterableToArrayLimit(arr, i) {
    // this is an expanded form of \`for...of\` that properly supports abrupt completions of
    // iterators etc. variable names have been minimised to reduce the size of this massive
    // helper. sometimes spec compliance is annoying :(
    //
    // _n = _iteratorNormalCompletion
    // _d = _didIteratorError
    // _e = _iteratorError
    // _i = _iterator
    // _s = _step

    var _i = arr == null ? null : (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);
    if (_i == null) return;

    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);
        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
`;
	helpers.iterableToArrayLimitLoose = helper("7.0.0-beta.0")`
  export default function _iterableToArrayLimitLoose(arr, i) {
    var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);
    if (_i == null) return;

    var _arr = [];
    for (_i = _i.call(arr), _step; !(_step = _i.next()).done;) {
      _arr.push(_step.value);
      if (i && _arr.length === i) break;
    }
    return _arr;
  }
`;
	helpers.unsupportedIterableToArray = helper("7.9.0")`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return arrayLikeToArray(o, minLen);
  }
`;
	helpers.arrayLikeToArray = helper("7.9.0")`
  export default function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
    return arr2;
  }
`;
	helpers.nonIterableSpread = helper("7.0.0-beta.0")`
  export default function _nonIterableSpread() {
    throw new TypeError(
      "Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."
    );
  }
`;
	helpers.nonIterableRest = helper("7.0.0-beta.0")`
  export default function _nonIterableRest() {
    throw new TypeError(
      "Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."
    );
  }
`;
	helpers.createForOfIteratorHelper = helper("7.9.0")`
  import unsupportedIterableToArray from "unsupportedIterableToArray";

  // s: start (create the iterator)
  // n: next
  // e: error (called whenever something throws)
  // f: finish (always called at the end)

  export default function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (!it) {
      // Fallback for engines without symbol support
      if (
        Array.isArray(o) ||
        (it = unsupportedIterableToArray(o)) ||
        (allowArrayLike && o && typeof o.length === "number")
      ) {
        if (it) o = it;
        var i = 0;
        var F = function(){};
        return {
          s: F,
          n: function() {
            if (i >= o.length) return { done: true };
            return { done: false, value: o[i++] };
          },
          e: function(e) { throw e; },
          f: F,
        };
      }

      throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    var normalCompletion = true, didErr = false, err;

    return {
      s: function() {
        it = it.call(o);
      },
      n: function() {
        var step = it.next();
        normalCompletion = step.done;
        return step;
      },
      e: function(e) {
        didErr = true;
        err = e;
      },
      f: function() {
        try {
          if (!normalCompletion && it.return != null) it.return();
        } finally {
          if (didErr) throw err;
        }
      }
    };
  }
`;
	helpers.createForOfIteratorHelperLoose = helper("7.9.0")`
  import unsupportedIterableToArray from "unsupportedIterableToArray";

  export default function _createForOfIteratorHelperLoose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (it) return (it = it.call(o)).next.bind(it);

    // Fallback for engines without symbol support
    if (
      Array.isArray(o) ||
      (it = unsupportedIterableToArray(o)) ||
      (allowArrayLike && o && typeof o.length === "number")
    ) {
      if (it) o = it;
      var i = 0;
      return function() {
        if (i >= o.length) return { done: true };
        return { done: false, value: o[i++] };
      }
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
`;
	helpers.skipFirstGeneratorNext = helper("7.0.0-beta.0")`
  export default function _skipFirstGeneratorNext(fn) {
    return function () {
      var it = fn.apply(this, arguments);
      it.next();
      return it;
    }
  }
`;
	helpers.toPrimitive = helper("7.1.5")`
  export default function _toPrimitive(
    input,
    hint /*: "default" | "string" | "number" | void */
  ) {
    if (typeof input !== "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== undefined) {
      var res = prim.call(input, hint || "default");
      if (typeof res !== "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
`;
	helpers.toPropertyKey = helper("7.1.5")`
  import toPrimitive from "toPrimitive";

  export default function _toPropertyKey(arg) {
    var key = toPrimitive(arg, "string");
    return typeof key === "symbol" ? key : String(key);
  }
`;
	helpers.initializerWarningHelper = helper("7.0.0-beta.0")`
    export default function _initializerWarningHelper(descriptor, context){
        throw new Error(
          'Decorating class property failed. Please ensure that ' +
          'proposal-class-properties is enabled and runs after the decorators transform.'
        );
    }
`;
	helpers.initializerDefineProperty = helper("7.0.0-beta.0")`
    export default function _initializerDefineProperty(target, property, descriptor, context){
        if (!descriptor) return;

        Object.defineProperty(target, property, {
            enumerable: descriptor.enumerable,
            configurable: descriptor.configurable,
            writable: descriptor.writable,
            value: descriptor.initializer ? descriptor.initializer.call(context) : void 0,
        });
    }
`;
	helpers.applyDecoratedDescriptor = helper("7.0.0-beta.0")`
    export default function _applyDecoratedDescriptor(target, property, decorators, descriptor, context){
        var desc = {};
        Object.keys(descriptor).forEach(function(key){
            desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;
        if ('value' in desc || desc.initializer){
            desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function(desc, decorator){
            return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0){
            desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
            desc.initializer = undefined;
        }

        if (desc.initializer === void 0){
            Object.defineProperty(target, property, desc);
            desc = null;
        }

        return desc;
    }
`;
	helpers.classPrivateFieldLooseKey = helper("7.0.0-beta.0")`
  var id = 0;
  export default function _classPrivateFieldKey(name) {
    return "__private_" + (id++) + "_" + name;
  }
`;
	helpers.classPrivateFieldLooseBase = helper("7.0.0-beta.0")`
  export default function _classPrivateFieldBase(receiver, privateKey) {
    if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) {
      throw new TypeError("attempted to use private field on non-instance");
    }
    return receiver;
  }
`;
	helpers.classPrivateFieldGet = helper("7.0.0-beta.0")`
  import classApplyDescriptorGet from "classApplyDescriptorGet";
  import classExtractFieldDescriptor from "classExtractFieldDescriptor";
  export default function _classPrivateFieldGet(receiver, privateMap) {
    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "get");
    return classApplyDescriptorGet(receiver, descriptor);
  }
`;
	helpers.classPrivateFieldSet = helper("7.0.0-beta.0")`
  import classApplyDescriptorSet from "classApplyDescriptorSet";
  import classExtractFieldDescriptor from "classExtractFieldDescriptor";
  export default function _classPrivateFieldSet(receiver, privateMap, value) {
    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "set");
    classApplyDescriptorSet(receiver, descriptor, value);
    return value;
  }
`;
	helpers.classPrivateFieldDestructureSet = helper("7.4.4")`
  import classApplyDescriptorDestructureSet from "classApplyDescriptorDestructureSet";
  import classExtractFieldDescriptor from "classExtractFieldDescriptor";
  export default function _classPrivateFieldDestructureSet(receiver, privateMap) {
    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "set");
    return classApplyDescriptorDestructureSet(receiver, descriptor);
  }
`;
	helpers.classExtractFieldDescriptor = helper("7.13.10")`
  export default function _classExtractFieldDescriptor(receiver, privateMap, action) {
    if (!privateMap.has(receiver)) {
      throw new TypeError("attempted to " + action + " private field on non-instance");
    }
    return privateMap.get(receiver);
  }
`;
	helpers.classStaticPrivateFieldSpecGet = helper("7.0.2")`
  import classApplyDescriptorGet from "classApplyDescriptorGet";
  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldSpecGet(receiver, classConstructor, descriptor) {
    classCheckPrivateStaticAccess(receiver, classConstructor);
    classCheckPrivateStaticFieldDescriptor(descriptor, "get");
    return classApplyDescriptorGet(receiver, descriptor);
  }
`;
	helpers.classStaticPrivateFieldSpecSet = helper("7.0.2")`
  import classApplyDescriptorSet from "classApplyDescriptorSet";
  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldSpecSet(receiver, classConstructor, descriptor, value) {
    classCheckPrivateStaticAccess(receiver, classConstructor);
    classCheckPrivateStaticFieldDescriptor(descriptor, "set");
    classApplyDescriptorSet(receiver, descriptor, value);
    return value;
  }
`;
	helpers.classStaticPrivateMethodGet = helper("7.3.2")`
  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";
  export default function _classStaticPrivateMethodGet(receiver, classConstructor, method) {
    classCheckPrivateStaticAccess(receiver, classConstructor);
    return method;
  }
`;
	helpers.classStaticPrivateMethodSet = helper("7.3.2")`
  export default function _classStaticPrivateMethodSet() {
    throw new TypeError("attempted to set read only static private field");
  }
`;
	helpers.classApplyDescriptorGet = helper("7.13.10")`
  export default function _classApplyDescriptorGet(receiver, descriptor) {
    if (descriptor.get) {
      return descriptor.get.call(receiver);
    }
    return descriptor.value;
  }
`;
	helpers.classApplyDescriptorSet = helper("7.13.10")`
  export default function _classApplyDescriptorSet(receiver, descriptor, value) {
    if (descriptor.set) {
      descriptor.set.call(receiver, value);
    } else {
      if (!descriptor.writable) {
        // This should only throw in strict mode, but class bodies are
        // always strict and private fields can only be used inside
        // class bodies.
        throw new TypeError("attempted to set read only private field");
      }
      descriptor.value = value;
    }
  }
`;
	helpers.classApplyDescriptorDestructureSet = helper("7.13.10")`
  export default function _classApplyDescriptorDestructureSet(receiver, descriptor) {
    if (descriptor.set) {
      if (!("__destrObj" in descriptor)) {
        descriptor.__destrObj = {
          set value(v) {
            descriptor.set.call(receiver, v)
          },
        };
      }
      return descriptor.__destrObj;
    } else {
      if (!descriptor.writable) {
        // This should only throw in strict mode, but class bodies are
        // always strict and private fields can only be used inside
        // class bodies.
        throw new TypeError("attempted to set read only private field");
      }

      return descriptor;
    }
  }
`;
	helpers.classStaticPrivateFieldDestructureSet = helper("7.13.10")`
  import classApplyDescriptorDestructureSet from "classApplyDescriptorDestructureSet";
  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldDestructureSet(receiver, classConstructor, descriptor) {
    classCheckPrivateStaticAccess(receiver, classConstructor);
    classCheckPrivateStaticFieldDescriptor(descriptor, "set");
    return classApplyDescriptorDestructureSet(receiver, descriptor);
  }
`;
	helpers.classCheckPrivateStaticAccess = helper("7.13.10")`
  export default function _classCheckPrivateStaticAccess(receiver, classConstructor) {
    if (receiver !== classConstructor) {
      throw new TypeError("Private static access of wrong provenance");
    }
  }
`;
	helpers.classCheckPrivateStaticFieldDescriptor = helper("7.13.10")`
  export default function _classCheckPrivateStaticFieldDescriptor(descriptor, action) {
    if (descriptor === undefined) {
      throw new TypeError("attempted to " + action + " private static field before its declaration");
    }
  }
`;
	helpers.decorate = helper("7.1.5")`
  import toArray from "toArray";
  import toPropertyKey from "toPropertyKey";

  // These comments are stripped by @babel/template
  /*::
  type PropertyDescriptor =
    | {
        value: any,
        writable: boolean,
        configurable: boolean,
        enumerable: boolean,
      }
    | {
        get?: () => any,
        set?: (v: any) => void,
        configurable: boolean,
        enumerable: boolean,
      };

  type FieldDescriptor ={
    writable: boolean,
    configurable: boolean,
    enumerable: boolean,
  };

  type Placement = "static" | "prototype" | "own";
  type Key = string | symbol; // PrivateName is not supported yet.

  type ElementDescriptor =
    | {
        kind: "method",
        key: Key,
        placement: Placement,
        descriptor: PropertyDescriptor
      }
    | {
        kind: "field",
        key: Key,
        placement: Placement,
        descriptor: FieldDescriptor,
        initializer?: () => any,
      };

  // This is exposed to the user code
  type ElementObjectInput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
  };

  // This is exposed to the user code
  type ElementObjectOutput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
    extras?: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  // This is exposed to the user code
  type ClassObject = {
    [@@toStringTag]?: "Descriptor",
    kind: "class",
    elements: ElementDescriptor[],
  };

  type ElementDecorator = (descriptor: ElementObjectInput) => ?ElementObjectOutput;
  type ClassDecorator = (descriptor: ClassObject) => ?ClassObject;
  type ClassFinisher = <A, B>(cl: Class<A>) => Class<B>;

  // Only used by Babel in the transform output, not part of the spec.
  type ElementDefinition =
    | {
        kind: "method",
        value: any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
      }
    | {
        kind: "field",
        value: () => any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
    };

  declare function ClassFactory<C>(initialize: (instance: C) => void): {
    F: Class<C>,
    d: ElementDefinition[]
  }

  */

  /*::
  // Various combinations with/without extras and with one or many finishers

  type ElementFinisherExtras = {
    element: ElementDescriptor,
    finisher?: ClassFinisher,
    extras?: ElementDescriptor[],
  };

  type ElementFinishersExtras = {
    element: ElementDescriptor,
    finishers: ClassFinisher[],
    extras: ElementDescriptor[],
  };

  type ElementsFinisher = {
    elements: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  type ElementsFinishers = {
    elements: ElementDescriptor[],
    finishers: ClassFinisher[],
  };

  */

  /*::

  type Placements = {
    static: Key[],
    prototype: Key[],
    own: Key[],
  };

  */

  // ClassDefinitionEvaluation (Steps 26-*)
  export default function _decorate(
    decorators /*: ClassDecorator[] */,
    factory /*: ClassFactory */,
    superClass /*: ?Class<*> */,
    mixins /*: ?Array<Function> */,
  ) /*: Class<*> */ {
    var api = _getDecoratorsApi();
    if (mixins) {
      for (var i = 0; i < mixins.length; i++) {
        api = mixins[i](api);
      }
    }

    var r = factory(function initialize(O) {
      api.initializeInstanceElements(O, decorated.elements);
    }, superClass);
    var decorated = api.decorateClass(
      _coalesceClassElements(r.d.map(_createElementDescriptor)),
      decorators,
    );

    api.initializeClassElements(r.F, decorated.elements);

    return api.runClassFinishers(r.F, decorated.finishers);
  }

  function _getDecoratorsApi() {
    _getDecoratorsApi = function() {
      return api;
    };

    var api = {
      elementsDefinitionOrder: [["method"], ["field"]],

      // InitializeInstanceElements
      initializeInstanceElements: function(
        /*::<C>*/ O /*: C */,
        elements /*: ElementDescriptor[] */,
      ) {
        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            if (element.kind === kind && element.placement === "own") {
              this.defineClassElement(O, element);
            }
          }, this);
        }, this);
      },

      // InitializeClassElements
      initializeClassElements: function(
        /*::<C>*/ F /*: Class<C> */,
        elements /*: ElementDescriptor[] */,
      ) {
        var proto = F.prototype;

        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            var placement = element.placement;
            if (
              element.kind === kind &&
              (placement === "static" || placement === "prototype")
            ) {
              var receiver = placement === "static" ? F : proto;
              this.defineClassElement(receiver, element);
            }
          }, this);
        }, this);
      },

      // DefineClassElement
      defineClassElement: function(
        /*::<C>*/ receiver /*: C | Class<C> */,
        element /*: ElementDescriptor */,
      ) {
        var descriptor /*: PropertyDescriptor */ = element.descriptor;
        if (element.kind === "field") {
          var initializer = element.initializer;
          descriptor = {
            enumerable: descriptor.enumerable,
            writable: descriptor.writable,
            configurable: descriptor.configurable,
            value: initializer === void 0 ? void 0 : initializer.call(receiver),
          };
        }
        Object.defineProperty(receiver, element.key, descriptor);
      },

      // DecorateClass
      decorateClass: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var newElements /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];
        var placements /*: Placements */ = {
          static: [],
          prototype: [],
          own: [],
        };

        elements.forEach(function(element /*: ElementDescriptor */) {
          this.addElementPlacement(element, placements);
        }, this);

        elements.forEach(function(element /*: ElementDescriptor */) {
          if (!_hasDecorators(element)) return newElements.push(element);

          var elementFinishersExtras /*: ElementFinishersExtras */ = this.decorateElement(
            element,
            placements,
          );
          newElements.push(elementFinishersExtras.element);
          newElements.push.apply(newElements, elementFinishersExtras.extras);
          finishers.push.apply(finishers, elementFinishersExtras.finishers);
        }, this);

        if (!decorators) {
          return { elements: newElements, finishers: finishers };
        }

        var result /*: ElementsFinishers */ = this.decorateConstructor(
          newElements,
          decorators,
        );
        finishers.push.apply(finishers, result.finishers);
        result.finishers = finishers;

        return result;
      },

      // AddElementPlacement
      addElementPlacement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
        silent /*: boolean */,
      ) {
        var keys = placements[element.placement];
        if (!silent && keys.indexOf(element.key) !== -1) {
          throw new TypeError("Duplicated element (" + element.key + ")");
        }
        keys.push(element.key);
      },

      // DecorateElement
      decorateElement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
      ) /*: ElementFinishersExtras */ {
        var extras /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];

        for (
          var decorators = element.decorators, i = decorators.length - 1;
          i >= 0;
          i--
        ) {
          // (inlined) RemoveElementPlacement
          var keys = placements[element.placement];
          keys.splice(keys.indexOf(element.key), 1);

          var elementObject /*: ElementObjectInput */ = this.fromElementDescriptor(
            element,
          );
          var elementFinisherExtras /*: ElementFinisherExtras */ = this.toElementFinisherExtras(
            (0, decorators[i])(elementObject) /*: ElementObjectOutput */ ||
              elementObject,
          );

          element = elementFinisherExtras.element;
          this.addElementPlacement(element, placements);

          if (elementFinisherExtras.finisher) {
            finishers.push(elementFinisherExtras.finisher);
          }

          var newExtras /*: ElementDescriptor[] | void */ =
            elementFinisherExtras.extras;
          if (newExtras) {
            for (var j = 0; j < newExtras.length; j++) {
              this.addElementPlacement(newExtras[j], placements);
            }
            extras.push.apply(extras, newExtras);
          }
        }

        return { element: element, finishers: finishers, extras: extras };
      },

      // DecorateConstructor
      decorateConstructor: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var finishers /*: ClassFinisher[] */ = [];

        for (var i = decorators.length - 1; i >= 0; i--) {
          var obj /*: ClassObject */ = this.fromClassDescriptor(elements);
          var elementsAndFinisher /*: ElementsFinisher */ = this.toClassDescriptor(
            (0, decorators[i])(obj) /*: ClassObject */ || obj,
          );

          if (elementsAndFinisher.finisher !== undefined) {
            finishers.push(elementsAndFinisher.finisher);
          }

          if (elementsAndFinisher.elements !== undefined) {
            elements = elementsAndFinisher.elements;

            for (var j = 0; j < elements.length - 1; j++) {
              for (var k = j + 1; k < elements.length; k++) {
                if (
                  elements[j].key === elements[k].key &&
                  elements[j].placement === elements[k].placement
                ) {
                  throw new TypeError(
                    "Duplicated element (" + elements[j].key + ")",
                  );
                }
              }
            }
          }
        }

        return { elements: elements, finishers: finishers };
      },

      // FromElementDescriptor
      fromElementDescriptor: function(
        element /*: ElementDescriptor */,
      ) /*: ElementObject */ {
        var obj /*: ElementObject */ = {
          kind: element.kind,
          key: element.key,
          placement: element.placement,
          descriptor: element.descriptor,
        };

        var desc = {
          value: "Descriptor",
          configurable: true,
        };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        if (element.kind === "field") obj.initializer = element.initializer;

        return obj;
      },

      // ToElementDescriptors
      toElementDescriptors: function(
        elementObjects /*: ElementObject[] */,
      ) /*: ElementDescriptor[] */ {
        if (elementObjects === undefined) return;
        return toArray(elementObjects).map(function(elementObject) {
          var element = this.toElementDescriptor(elementObject);
          this.disallowProperty(elementObject, "finisher", "An element descriptor");
          this.disallowProperty(elementObject, "extras", "An element descriptor");
          return element;
        }, this);
      },

      // ToElementDescriptor
      toElementDescriptor: function(
        elementObject /*: ElementObject */,
      ) /*: ElementDescriptor */ {
        var kind = String(elementObject.kind);
        if (kind !== "method" && kind !== "field") {
          throw new TypeError(
            'An element descriptor\\'s .kind property must be either "method" or' +
              ' "field", but a decorator created an element descriptor with' +
              ' .kind "' +
              kind +
              '"',
          );
        }

        var key = toPropertyKey(elementObject.key);

        var placement = String(elementObject.placement);
        if (
          placement !== "static" &&
          placement !== "prototype" &&
          placement !== "own"
        ) {
          throw new TypeError(
            'An element descriptor\\'s .placement property must be one of "static",' +
              ' "prototype" or "own", but a decorator created an element descriptor' +
              ' with .placement "' +
              placement +
              '"',
          );
        }

        var descriptor /*: PropertyDescriptor */ = elementObject.descriptor;

        this.disallowProperty(elementObject, "elements", "An element descriptor");

        var element /*: ElementDescriptor */ = {
          kind: kind,
          key: key,
          placement: placement,
          descriptor: Object.assign({}, descriptor),
        };

        if (kind !== "field") {
          this.disallowProperty(elementObject, "initializer", "A method descriptor");
        } else {
          this.disallowProperty(
            descriptor,
            "get",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "set",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "value",
            "The property descriptor of a field descriptor",
          );

          element.initializer = elementObject.initializer;
        }

        return element;
      },

      toElementFinisherExtras: function(
        elementObject /*: ElementObject */,
      ) /*: ElementFinisherExtras */ {
        var element /*: ElementDescriptor */ = this.toElementDescriptor(
          elementObject,
        );
        var finisher /*: ClassFinisher */ = _optionalCallableProperty(
          elementObject,
          "finisher",
        );
        var extras /*: ElementDescriptors[] */ = this.toElementDescriptors(
          elementObject.extras,
        );

        return { element: element, finisher: finisher, extras: extras };
      },

      // FromClassDescriptor
      fromClassDescriptor: function(
        elements /*: ElementDescriptor[] */,
      ) /*: ClassObject */ {
        var obj = {
          kind: "class",
          elements: elements.map(this.fromElementDescriptor, this),
        };

        var desc = { value: "Descriptor", configurable: true };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        return obj;
      },

      // ToClassDescriptor
      toClassDescriptor: function(
        obj /*: ClassObject */,
      ) /*: ElementsFinisher */ {
        var kind = String(obj.kind);
        if (kind !== "class") {
          throw new TypeError(
            'A class descriptor\\'s .kind property must be "class", but a decorator' +
              ' created a class descriptor with .kind "' +
              kind +
              '"',
          );
        }

        this.disallowProperty(obj, "key", "A class descriptor");
        this.disallowProperty(obj, "placement", "A class descriptor");
        this.disallowProperty(obj, "descriptor", "A class descriptor");
        this.disallowProperty(obj, "initializer", "A class descriptor");
        this.disallowProperty(obj, "extras", "A class descriptor");

        var finisher = _optionalCallableProperty(obj, "finisher");
        var elements = this.toElementDescriptors(obj.elements);

        return { elements: elements, finisher: finisher };
      },

      // RunClassFinishers
      runClassFinishers: function(
        constructor /*: Class<*> */,
        finishers /*: ClassFinisher[] */,
      ) /*: Class<*> */ {
        for (var i = 0; i < finishers.length; i++) {
          var newConstructor /*: ?Class<*> */ = (0, finishers[i])(constructor);
          if (newConstructor !== undefined) {
            // NOTE: This should check if IsConstructor(newConstructor) is false.
            if (typeof newConstructor !== "function") {
              throw new TypeError("Finishers must return a constructor.");
            }
            constructor = newConstructor;
          }
        }
        return constructor;
      },

      disallowProperty: function(obj, name, objectType) {
        if (obj[name] !== undefined) {
          throw new TypeError(objectType + " can't have a ." + name + " property.");
        }
      }
    };

    return api;
  }

  // ClassElementEvaluation
  function _createElementDescriptor(
    def /*: ElementDefinition */,
  ) /*: ElementDescriptor */ {
    var key = toPropertyKey(def.key);

    var descriptor /*: PropertyDescriptor */;
    if (def.kind === "method") {
      descriptor = {
        value: def.value,
        writable: true,
        configurable: true,
        enumerable: false,
      };
    } else if (def.kind === "get") {
      descriptor = { get: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "set") {
      descriptor = { set: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "field") {
      descriptor = { configurable: true, writable: true, enumerable: true };
    }

    var element /*: ElementDescriptor */ = {
      kind: def.kind === "field" ? "field" : "method",
      key: key,
      placement: def.static
        ? "static"
        : def.kind === "field"
        ? "own"
        : "prototype",
      descriptor: descriptor,
    };
    if (def.decorators) element.decorators = def.decorators;
    if (def.kind === "field") element.initializer = def.value;

    return element;
  }

  // CoalesceGetterSetter
  function _coalesceGetterSetter(
    element /*: ElementDescriptor */,
    other /*: ElementDescriptor */,
  ) {
    if (element.descriptor.get !== undefined) {
      other.descriptor.get = element.descriptor.get;
    } else {
      other.descriptor.set = element.descriptor.set;
    }
  }

  // CoalesceClassElements
  function _coalesceClassElements(
    elements /*: ElementDescriptor[] */,
  ) /*: ElementDescriptor[] */ {
    var newElements /*: ElementDescriptor[] */ = [];

    var isSameElement = function(
      other /*: ElementDescriptor */,
    ) /*: boolean */ {
      return (
        other.kind === "method" &&
        other.key === element.key &&
        other.placement === element.placement
      );
    };

    for (var i = 0; i < elements.length; i++) {
      var element /*: ElementDescriptor */ = elements[i];
      var other /*: ElementDescriptor */;

      if (
        element.kind === "method" &&
        (other = newElements.find(isSameElement))
      ) {
        if (
          _isDataDescriptor(element.descriptor) ||
          _isDataDescriptor(other.descriptor)
        ) {
          if (_hasDecorators(element) || _hasDecorators(other)) {
            throw new ReferenceError(
              "Duplicated methods (" + element.key + ") can't be decorated.",
            );
          }
          other.descriptor = element.descriptor;
        } else {
          if (_hasDecorators(element)) {
            if (_hasDecorators(other)) {
              throw new ReferenceError(
                "Decorators can't be placed on different accessors with for " +
                  "the same property (" +
                  element.key +
                  ").",
              );
            }
            other.decorators = element.decorators;
          }
          _coalesceGetterSetter(element, other);
        }
      } else {
        newElements.push(element);
      }
    }

    return newElements;
  }

  function _hasDecorators(element /*: ElementDescriptor */) /*: boolean */ {
    return element.decorators && element.decorators.length;
  }

  function _isDataDescriptor(desc /*: PropertyDescriptor */) /*: boolean */ {
    return (
      desc !== undefined &&
      !(desc.value === undefined && desc.writable === undefined)
    );
  }

  function _optionalCallableProperty /*::<T>*/(
    obj /*: T */,
    name /*: $Keys<T> */,
  ) /*: ?Function */ {
    var value = obj[name];
    if (value !== undefined && typeof value !== "function") {
      throw new TypeError("Expected '" + name + "' to be a function");
    }
    return value;
  }

`;
	helpers.classPrivateMethodGet = helper("7.1.6")`
  export default function _classPrivateMethodGet(receiver, privateSet, fn) {
    if (!privateSet.has(receiver)) {
      throw new TypeError("attempted to get private field on non-instance");
    }
    return fn;
  }
`;
	helpers.checkPrivateRedeclaration = helper("7.14.1")`
  export default function _checkPrivateRedeclaration(obj, privateCollection) {
    if (privateCollection.has(obj)) {
      throw new TypeError("Cannot initialize the same private elements twice on an object");
    }
  }
`;
	helpers.classPrivateFieldInitSpec = helper("7.14.1")`
  import checkPrivateRedeclaration from "checkPrivateRedeclaration";

  export default function _classPrivateFieldInitSpec(obj, privateMap, value) {
    checkPrivateRedeclaration(obj, privateMap);
    privateMap.set(obj, value);
  }
`;
	helpers.classPrivateMethodInitSpec = helper("7.14.1")`
  import checkPrivateRedeclaration from "checkPrivateRedeclaration";

  export default function _classPrivateMethodInitSpec(obj, privateSet) {
    checkPrivateRedeclaration(obj, privateSet);
    privateSet.add(obj);
  }
`;

	if (!browser$5.env.BABEL_8_BREAKING) {
	  helpers.classPrivateMethodSet = helper("7.1.6")`
    export default function _classPrivateMethodSet() {
      throw new TypeError("attempted to reassign private method");
    }
  `;
	}

	helpers.identity = helper("7.17.0")`
  export default function _identity(x) {
    return x;
  }
`;

	const {
	  assignmentExpression: assignmentExpression$3,
	  cloneNode: cloneNode$4,
	  expressionStatement: expressionStatement$1,
	  file: t_file,
	  identifier: identifier$4,
	  variableDeclaration: variableDeclaration$1,
	  variableDeclarator: variableDeclarator$1
	} = _t;

	function makePath(path) {
	  const parts = [];

	  for (; path.parentPath; path = path.parentPath) {
	    parts.push(path.key);
	    if (path.inList) parts.push(path.listKey);
	  }

	  return parts.reverse().join(".");
	}

	let fileClass = undefined;

	function getHelperMetadata(file) {
	  const globals = new Set();
	  const localBindingNames = new Set();
	  const dependencies = new Map();
	  let exportName;
	  let exportPath;
	  const exportBindingAssignments = [];
	  const importPaths = [];
	  const importBindingsReferences = [];
	  const dependencyVisitor = {
	    ImportDeclaration(child) {
	      const name = child.node.source.value;

	      if (!helpers[name]) {
	        throw child.buildCodeFrameError(`Unknown helper ${name}`);
	      }

	      if (child.get("specifiers").length !== 1 || !child.get("specifiers.0").isImportDefaultSpecifier()) {
	        throw child.buildCodeFrameError("Helpers can only import a default value");
	      }

	      const bindingIdentifier = child.node.specifiers[0].local;
	      dependencies.set(bindingIdentifier, name);
	      importPaths.push(makePath(child));
	    },

	    ExportDefaultDeclaration(child) {
	      const decl = child.get("declaration");

	      if (decl.isFunctionDeclaration()) {
	        if (!decl.node.id) {
	          throw decl.buildCodeFrameError("Helpers should give names to their exported func declaration");
	        }

	        exportName = decl.node.id.name;
	      }

	      exportPath = makePath(child);
	    },

	    ExportAllDeclaration(child) {
	      throw child.buildCodeFrameError("Helpers can only export default");
	    },

	    ExportNamedDeclaration(child) {
	      throw child.buildCodeFrameError("Helpers can only export default");
	    },

	    Statement(child) {
	      if (child.isModuleDeclaration()) return;
	      child.skip();
	    }

	  };
	  const referenceVisitor = {
	    Program(path) {
	      const bindings = path.scope.getAllBindings();
	      Object.keys(bindings).forEach(name => {
	        if (name === exportName) return;
	        if (dependencies.has(bindings[name].identifier)) return;
	        localBindingNames.add(name);
	      });
	    },

	    ReferencedIdentifier(child) {
	      const name = child.node.name;
	      const binding = child.scope.getBinding(name);

	      if (!binding) {
	        globals.add(name);
	      } else if (dependencies.has(binding.identifier)) {
	        importBindingsReferences.push(makePath(child));
	      }
	    },

	    AssignmentExpression(child) {
	      const left = child.get("left");
	      if (!(exportName in left.getBindingIdentifiers())) return;

	      if (!left.isIdentifier()) {
	        throw left.buildCodeFrameError("Only simple assignments to exports are allowed in helpers");
	      }

	      const binding = child.scope.getBinding(exportName);

	      if (binding?.scope.path.isProgram()) {
	        exportBindingAssignments.push(makePath(child));
	      }
	    }

	  };
	  traverse(file.ast, dependencyVisitor, file.scope);
	  traverse(file.ast, referenceVisitor, file.scope);
	  if (!exportPath) throw new Error("Helpers must default-export something.");
	  exportBindingAssignments.reverse();
	  return {
	    globals: Array.from(globals),
	    localBindingNames: Array.from(localBindingNames),
	    dependencies,
	    exportBindingAssignments,
	    exportPath,
	    exportName,
	    importBindingsReferences,
	    importPaths
	  };
	}

	function permuteHelperAST(file, metadata, id, localBindings, getDependency) {
	  if (localBindings && !id) {
	    throw new Error("Unexpected local bindings for module-based helpers.");
	  }

	  if (!id) return;
	  const {
	    localBindingNames,
	    dependencies,
	    exportBindingAssignments,
	    exportPath,
	    exportName,
	    importBindingsReferences,
	    importPaths
	  } = metadata;
	  const dependenciesRefs = {};
	  dependencies.forEach((name, id) => {
	    dependenciesRefs[id.name] = typeof getDependency === "function" && getDependency(name) || id;
	  });
	  const toRename = {};
	  const bindings = new Set(localBindings || []);
	  localBindingNames.forEach(name => {
	    let newName = name;

	    while (bindings.has(newName)) newName = "_" + newName;

	    if (newName !== name) toRename[name] = newName;
	  });

	  if (id.type === "Identifier" && exportName !== id.name) {
	    toRename[exportName] = id.name;
	  }

	  const visitor = {
	    Program(path) {
	      const exp = path.get(exportPath);
	      const imps = importPaths.map(p => path.get(p));
	      const impsBindingRefs = importBindingsReferences.map(p => path.get(p));
	      const decl = exp.get("declaration");

	      if (id.type === "Identifier") {
	        if (decl.isFunctionDeclaration()) {
	          exp.replaceWith(decl);
	        } else {
	          exp.replaceWith(variableDeclaration$1("var", [variableDeclarator$1(id, decl.node)]));
	        }
	      } else if (id.type === "MemberExpression") {
	        if (decl.isFunctionDeclaration()) {
	          exportBindingAssignments.forEach(assignPath => {
	            const assign = path.get(assignPath);
	            assign.replaceWith(assignmentExpression$3("=", id, assign.node));
	          });
	          exp.replaceWith(decl);
	          path.pushContainer("body", expressionStatement$1(assignmentExpression$3("=", id, identifier$4(exportName))));
	        } else {
	          exp.replaceWith(expressionStatement$1(assignmentExpression$3("=", id, decl.node)));
	        }
	      } else {
	        throw new Error("Unexpected helper format.");
	      }

	      Object.keys(toRename).forEach(name => {
	        path.scope.rename(name, toRename[name]);
	      });

	      for (const path of imps) path.remove();

	      for (const path of impsBindingRefs) {
	        const node = cloneNode$4(dependenciesRefs[path.node.name]);
	        path.replaceWith(node);
	      }

	      path.stop();
	    }

	  };
	  traverse(file.ast, visitor, file.scope);
	}

	const helperData = Object.create(null);

	function loadHelper(name) {
	  if (!helperData[name]) {
	    const helper = helpers[name];

	    if (!helper) {
	      throw Object.assign(new ReferenceError(`Unknown helper ${name}`), {
	        code: "BABEL_HELPER_UNKNOWN",
	        helper: name
	      });
	    }

	    const fn = () => {
	      const file = {
	        ast: t_file(helper.ast())
	      };

	      if (fileClass) {
	        return new fileClass({
	          filename: `babel-helper://${name}`
	        }, file);
	      }

	      return file;
	    };

	    const metadata = getHelperMetadata(fn());
	    helperData[name] = {
	      build(getDependency, id, localBindings) {
	        const file = fn();
	        permuteHelperAST(file, metadata, id, localBindings, getDependency);
	        return {
	          nodes: file.ast.program.body,
	          globals: metadata.globals
	        };
	      },

	      minVersion() {
	        return helper.minVersion;
	      },

	      dependencies: metadata.dependencies
	    };
	  }

	  return helperData[name];
	}

	function get$1(name, getDependency, id, localBindings) {
	  return loadHelper(name).build(getDependency, id, localBindings);
	}
	function minVersion$1(name) {
	  return loadHelper(name).minVersion();
	}
	function getDependencies(name) {
	  return Array.from(loadHelper(name).dependencies.values());
	}
	function ensure(name, newFileClass) {
	  if (!fileClass) {
	    fileClass = newFileClass;
	  }

	  loadHelper(name);
	}
	const list = Object.keys(helpers).map(name => name.replace(/^_/, ""));

	/*
	object-assign
	(c) Sindre Sorhus
	@license MIT
	*/

	var getOwnPropertySymbols = Object.getOwnPropertySymbols;
	var hasOwnProperty = Object.prototype.hasOwnProperty;
	var propIsEnumerable = Object.prototype.propertyIsEnumerable;

	function toObject(val) {
	  if (val === null || val === undefined) {
	    throw new TypeError('Object.assign cannot be called with null or undefined');
	  }

	  return Object(val);
	}

	function shouldUseNative() {
	  try {
	    if (!Object.assign) {
	      return false;
	    }

	    var test1 = new String('abc');
	    test1[5] = 'de';

	    if (Object.getOwnPropertyNames(test1)[0] === '5') {
	      return false;
	    }

	    var test2 = {};

	    for (var i = 0; i < 10; i++) {
	      test2['_' + String.fromCharCode(i)] = i;
	    }

	    var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
	      return test2[n];
	    });

	    if (order2.join('') !== '0123456789') {
	      return false;
	    }

	    var test3 = {};
	    'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
	      test3[letter] = letter;
	    });

	    if (Object.keys(Object.assign({}, test3)).join('') !== 'abcdefghijklmnopqrst') {
	      return false;
	    }

	    return true;
	  } catch (err) {
	    return false;
	  }
	}

	var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	  var from;
	  var to = toObject(target);
	  var symbols;

	  for (var s = 1; s < arguments.length; s++) {
	    from = Object(arguments[s]);

	    for (var key in from) {
	      if (hasOwnProperty.call(from, key)) {
	        to[key] = from[key];
	      }
	    }

	    if (getOwnPropertySymbols) {
	      symbols = getOwnPropertySymbols(from);

	      for (var i = 0; i < symbols.length; i++) {
	        if (propIsEnumerable.call(from, symbols[i])) {
	          to[symbols[i]] = from[symbols[i]];
	        }
	      }
	    }
	  }

	  return to;
	};

	var isBufferBrowser = function isBuffer(arg) {
	  return arg && typeof arg === 'object' && typeof arg.copy === 'function' && typeof arg.fill === 'function' && typeof arg.readUInt8 === 'function';
	};

	var inherits_browser = createCommonjsModule(function (module) {
	  if (typeof Object.create === 'function') {
	    module.exports = function inherits(ctor, superCtor) {
	      ctor.super_ = superCtor;
	      ctor.prototype = Object.create(superCtor.prototype, {
	        constructor: {
	          value: ctor,
	          enumerable: false,
	          writable: true,
	          configurable: true
	        }
	      });
	    };
	  } else {
	    module.exports = function inherits(ctor, superCtor) {
	      ctor.super_ = superCtor;

	      var TempCtor = function () {};

	      TempCtor.prototype = superCtor.prototype;
	      ctor.prototype = new TempCtor();
	      ctor.prototype.constructor = ctor;
	    };
	  }
	}, "/$$rollup_base$$/node_modules/util/node_modules/inherits");

	var util = createCommonjsModule(function (module, exports) {
	  var formatRegExp = /%[sdj%]/g;

	  exports.format = function (f) {
	    if (!isString(f)) {
	      var objects = [];

	      for (var i = 0; i < arguments.length; i++) {
	        objects.push(inspect(arguments[i]));
	      }

	      return objects.join(' ');
	    }

	    var i = 1;
	    var args = arguments;
	    var len = args.length;
	    var str = String(f).replace(formatRegExp, function (x) {
	      if (x === '%%') return '%';
	      if (i >= len) return x;

	      switch (x) {
	        case '%s':
	          return String(args[i++]);

	        case '%d':
	          return Number(args[i++]);

	        case '%j':
	          try {
	            return JSON.stringify(args[i++]);
	          } catch (_) {
	            return '[Circular]';
	          }

	        default:
	          return x;
	      }
	    });

	    for (var x = args[i]; i < len; x = args[++i]) {
	      if (isNull(x) || !isObject(x)) {
	        str += ' ' + x;
	      } else {
	        str += ' ' + inspect(x);
	      }
	    }

	    return str;
	  };

	  exports.deprecate = function (fn, msg) {
	    if (isUndefined(commonjsGlobal.process)) {
	      return function () {
	        return exports.deprecate(fn, msg).apply(this, arguments);
	      };
	    }

	    if (browser$5.noDeprecation === true) {
	      return fn;
	    }

	    var warned = false;

	    function deprecated() {
	      if (!warned) {
	        if (browser$5.throwDeprecation) {
	          throw new Error(msg);
	        } else if (browser$5.traceDeprecation) {
	          console.trace(msg);
	        } else {
	          console.error(msg);
	        }

	        warned = true;
	      }

	      return fn.apply(this, arguments);
	    }

	    return deprecated;
	  };

	  var debugs = {};
	  var debugEnviron;

	  exports.debuglog = function (set) {
	    if (isUndefined(debugEnviron)) debugEnviron = browser$5.env.NODE_DEBUG || '';
	    set = set.toUpperCase();

	    if (!debugs[set]) {
	      if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
	        var pid = browser$5.pid;

	        debugs[set] = function () {
	          var msg = exports.format.apply(exports, arguments);
	          console.error('%s %d: %s', set, pid, msg);
	        };
	      } else {
	        debugs[set] = function () {};
	      }
	    }

	    return debugs[set];
	  };

	  function inspect(obj, opts) {
	    var ctx = {
	      seen: [],
	      stylize: stylizeNoColor
	    };
	    if (arguments.length >= 3) ctx.depth = arguments[2];
	    if (arguments.length >= 4) ctx.colors = arguments[3];

	    if (isBoolean(opts)) {
	      ctx.showHidden = opts;
	    } else if (opts) {
	      exports._extend(ctx, opts);
	    }

	    if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
	    if (isUndefined(ctx.depth)) ctx.depth = 2;
	    if (isUndefined(ctx.colors)) ctx.colors = false;
	    if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
	    if (ctx.colors) ctx.stylize = stylizeWithColor;
	    return formatValue(ctx, obj, ctx.depth);
	  }

	  exports.inspect = inspect;
	  inspect.colors = {
	    'bold': [1, 22],
	    'italic': [3, 23],
	    'underline': [4, 24],
	    'inverse': [7, 27],
	    'white': [37, 39],
	    'grey': [90, 39],
	    'black': [30, 39],
	    'blue': [34, 39],
	    'cyan': [36, 39],
	    'green': [32, 39],
	    'magenta': [35, 39],
	    'red': [31, 39],
	    'yellow': [33, 39]
	  };
	  inspect.styles = {
	    'special': 'cyan',
	    'number': 'yellow',
	    'boolean': 'yellow',
	    'undefined': 'grey',
	    'null': 'bold',
	    'string': 'green',
	    'date': 'magenta',
	    'regexp': 'red'
	  };

	  function stylizeWithColor(str, styleType) {
	    var style = inspect.styles[styleType];

	    if (style) {
	      return '\u001b[' + inspect.colors[style][0] + 'm' + str + '\u001b[' + inspect.colors[style][1] + 'm';
	    } else {
	      return str;
	    }
	  }

	  function stylizeNoColor(str, styleType) {
	    return str;
	  }

	  function arrayToHash(array) {
	    var hash = {};
	    array.forEach(function (val, idx) {
	      hash[val] = true;
	    });
	    return hash;
	  }

	  function formatValue(ctx, value, recurseTimes) {
	    if (ctx.customInspect && value && isFunction(value.inspect) && value.inspect !== exports.inspect && !(value.constructor && value.constructor.prototype === value)) {
	      var ret = value.inspect(recurseTimes, ctx);

	      if (!isString(ret)) {
	        ret = formatValue(ctx, ret, recurseTimes);
	      }

	      return ret;
	    }

	    var primitive = formatPrimitive(ctx, value);

	    if (primitive) {
	      return primitive;
	    }

	    var keys = Object.keys(value);
	    var visibleKeys = arrayToHash(keys);

	    if (ctx.showHidden) {
	      keys = Object.getOwnPropertyNames(value);
	    }

	    if (isError(value) && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
	      return formatError(value);
	    }

	    if (keys.length === 0) {
	      if (isFunction(value)) {
	        var name = value.name ? ': ' + value.name : '';
	        return ctx.stylize('[Function' + name + ']', 'special');
	      }

	      if (isRegExp(value)) {
	        return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
	      }

	      if (isDate(value)) {
	        return ctx.stylize(Date.prototype.toString.call(value), 'date');
	      }

	      if (isError(value)) {
	        return formatError(value);
	      }
	    }

	    var base = '',
	        array = false,
	        braces = ['{', '}'];

	    if (isArray(value)) {
	      array = true;
	      braces = ['[', ']'];
	    }

	    if (isFunction(value)) {
	      var n = value.name ? ': ' + value.name : '';
	      base = ' [Function' + n + ']';
	    }

	    if (isRegExp(value)) {
	      base = ' ' + RegExp.prototype.toString.call(value);
	    }

	    if (isDate(value)) {
	      base = ' ' + Date.prototype.toUTCString.call(value);
	    }

	    if (isError(value)) {
	      base = ' ' + formatError(value);
	    }

	    if (keys.length === 0 && (!array || value.length == 0)) {
	      return braces[0] + base + braces[1];
	    }

	    if (recurseTimes < 0) {
	      if (isRegExp(value)) {
	        return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
	      } else {
	        return ctx.stylize('[Object]', 'special');
	      }
	    }

	    ctx.seen.push(value);
	    var output;

	    if (array) {
	      output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
	    } else {
	      output = keys.map(function (key) {
	        return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
	      });
	    }

	    ctx.seen.pop();
	    return reduceToSingleString(output, base, braces);
	  }

	  function formatPrimitive(ctx, value) {
	    if (isUndefined(value)) return ctx.stylize('undefined', 'undefined');

	    if (isString(value)) {
	      var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '').replace(/'/g, "\\'").replace(/\\"/g, '"') + '\'';
	      return ctx.stylize(simple, 'string');
	    }

	    if (isNumber(value)) return ctx.stylize('' + value, 'number');
	    if (isBoolean(value)) return ctx.stylize('' + value, 'boolean');
	    if (isNull(value)) return ctx.stylize('null', 'null');
	  }

	  function formatError(value) {
	    return '[' + Error.prototype.toString.call(value) + ']';
	  }

	  function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
	    var output = [];

	    for (var i = 0, l = value.length; i < l; ++i) {
	      if (hasOwnProperty(value, String(i))) {
	        output.push(formatProperty(ctx, value, recurseTimes, visibleKeys, String(i), true));
	      } else {
	        output.push('');
	      }
	    }

	    keys.forEach(function (key) {
	      if (!key.match(/^\d+$/)) {
	        output.push(formatProperty(ctx, value, recurseTimes, visibleKeys, key, true));
	      }
	    });
	    return output;
	  }

	  function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
	    var name, str, desc;
	    desc = Object.getOwnPropertyDescriptor(value, key) || {
	      value: value[key]
	    };

	    if (desc.get) {
	      if (desc.set) {
	        str = ctx.stylize('[Getter/Setter]', 'special');
	      } else {
	        str = ctx.stylize('[Getter]', 'special');
	      }
	    } else {
	      if (desc.set) {
	        str = ctx.stylize('[Setter]', 'special');
	      }
	    }

	    if (!hasOwnProperty(visibleKeys, key)) {
	      name = '[' + key + ']';
	    }

	    if (!str) {
	      if (ctx.seen.indexOf(desc.value) < 0) {
	        if (isNull(recurseTimes)) {
	          str = formatValue(ctx, desc.value, null);
	        } else {
	          str = formatValue(ctx, desc.value, recurseTimes - 1);
	        }

	        if (str.indexOf('\n') > -1) {
	          if (array) {
	            str = str.split('\n').map(function (line) {
	              return '  ' + line;
	            }).join('\n').substr(2);
	          } else {
	            str = '\n' + str.split('\n').map(function (line) {
	              return '   ' + line;
	            }).join('\n');
	          }
	        }
	      } else {
	        str = ctx.stylize('[Circular]', 'special');
	      }
	    }

	    if (isUndefined(name)) {
	      if (array && key.match(/^\d+$/)) {
	        return str;
	      }

	      name = JSON.stringify('' + key);

	      if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
	        name = name.substr(1, name.length - 2);
	        name = ctx.stylize(name, 'name');
	      } else {
	        name = name.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'");
	        name = ctx.stylize(name, 'string');
	      }
	    }

	    return name + ': ' + str;
	  }

	  function reduceToSingleString(output, base, braces) {
	    var length = output.reduce(function (prev, cur) {
	      if (cur.indexOf('\n') >= 0) ;
	      return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
	    }, 0);

	    if (length > 60) {
	      return braces[0] + (base === '' ? '' : base + '\n ') + ' ' + output.join(',\n  ') + ' ' + braces[1];
	    }

	    return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
	  }

	  function isArray(ar) {
	    return Array.isArray(ar);
	  }

	  exports.isArray = isArray;

	  function isBoolean(arg) {
	    return typeof arg === 'boolean';
	  }

	  exports.isBoolean = isBoolean;

	  function isNull(arg) {
	    return arg === null;
	  }

	  exports.isNull = isNull;

	  function isNullOrUndefined(arg) {
	    return arg == null;
	  }

	  exports.isNullOrUndefined = isNullOrUndefined;

	  function isNumber(arg) {
	    return typeof arg === 'number';
	  }

	  exports.isNumber = isNumber;

	  function isString(arg) {
	    return typeof arg === 'string';
	  }

	  exports.isString = isString;

	  function isSymbol(arg) {
	    return typeof arg === 'symbol';
	  }

	  exports.isSymbol = isSymbol;

	  function isUndefined(arg) {
	    return arg === void 0;
	  }

	  exports.isUndefined = isUndefined;

	  function isRegExp(re) {
	    return isObject(re) && objectToString(re) === '[object RegExp]';
	  }

	  exports.isRegExp = isRegExp;

	  function isObject(arg) {
	    return typeof arg === 'object' && arg !== null;
	  }

	  exports.isObject = isObject;

	  function isDate(d) {
	    return isObject(d) && objectToString(d) === '[object Date]';
	  }

	  exports.isDate = isDate;

	  function isError(e) {
	    return isObject(e) && (objectToString(e) === '[object Error]' || e instanceof Error);
	  }

	  exports.isError = isError;

	  function isFunction(arg) {
	    return typeof arg === 'function';
	  }

	  exports.isFunction = isFunction;

	  function isPrimitive(arg) {
	    return arg === null || typeof arg === 'boolean' || typeof arg === 'number' || typeof arg === 'string' || typeof arg === 'symbol' || typeof arg === 'undefined';
	  }

	  exports.isPrimitive = isPrimitive;
	  exports.isBuffer = isBufferBrowser;

	  function objectToString(o) {
	    return Object.prototype.toString.call(o);
	  }

	  function pad(n) {
	    return n < 10 ? '0' + n.toString(10) : n.toString(10);
	  }

	  var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

	  function timestamp() {
	    var d = new Date();
	    var time = [pad(d.getHours()), pad(d.getMinutes()), pad(d.getSeconds())].join(':');
	    return [d.getDate(), months[d.getMonth()], time].join(' ');
	  }

	  exports.log = function () {
	    console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
	  };

	  exports.inherits = inherits_browser;

	  exports._extend = function (origin, add) {
	    if (!add || !isObject(add)) return origin;
	    var keys = Object.keys(add);
	    var i = keys.length;

	    while (i--) {
	      origin[keys[i]] = add[keys[i]];
	    }

	    return origin;
	  };

	  function hasOwnProperty(obj, prop) {
	    return Object.prototype.hasOwnProperty.call(obj, prop);
	  }
	}, "/$$rollup_base$$/node_modules/util");

	createCommonjsModule(function (module) {
	  /*!
	   * The buffer module from node.js, for the browser.
	   *
	   * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
	   * @license  MIT
	   */

	  function compare(a, b) {
	    if (a === b) {
	      return 0;
	    }

	    var x = a.length;
	    var y = b.length;

	    for (var i = 0, len = Math.min(x, y); i < len; ++i) {
	      if (a[i] !== b[i]) {
	        x = a[i];
	        y = b[i];
	        break;
	      }
	    }

	    if (x < y) {
	      return -1;
	    }

	    if (y < x) {
	      return 1;
	    }

	    return 0;
	  }

	  function isBuffer(b) {
	    if (commonjsGlobal.Buffer && typeof commonjsGlobal.Buffer.isBuffer === 'function') {
	      return commonjsGlobal.Buffer.isBuffer(b);
	    }

	    return !!(b != null && b._isBuffer);
	  }

	  var hasOwn = Object.prototype.hasOwnProperty;
	  var pSlice = Array.prototype.slice;

	  var functionsHaveNames = function () {
	    return function foo() {}.name === 'foo';
	  }();

	  function pToString(obj) {
	    return Object.prototype.toString.call(obj);
	  }

	  function isView(arrbuf) {
	    if (isBuffer(arrbuf)) {
	      return false;
	    }

	    if (typeof commonjsGlobal.ArrayBuffer !== 'function') {
	      return false;
	    }

	    if (typeof ArrayBuffer.isView === 'function') {
	      return ArrayBuffer.isView(arrbuf);
	    }

	    if (!arrbuf) {
	      return false;
	    }

	    if (arrbuf instanceof DataView) {
	      return true;
	    }

	    if (arrbuf.buffer && arrbuf.buffer instanceof ArrayBuffer) {
	      return true;
	    }

	    return false;
	  }

	  var assert = module.exports = ok;
	  var regex = /\s*function\s+([^\(\s]*)\s*/;

	  function getName(func) {
	    if (!util.isFunction(func)) {
	      return;
	    }

	    if (functionsHaveNames) {
	      return func.name;
	    }

	    var str = func.toString();
	    var match = str.match(regex);
	    return match && match[1];
	  }

	  assert.AssertionError = function AssertionError(options) {
	    this.name = 'AssertionError';
	    this.actual = options.actual;
	    this.expected = options.expected;
	    this.operator = options.operator;

	    if (options.message) {
	      this.message = options.message;
	      this.generatedMessage = false;
	    } else {
	      this.message = getMessage(this);
	      this.generatedMessage = true;
	    }

	    var stackStartFunction = options.stackStartFunction || fail;

	    if (Error.captureStackTrace) {
	      Error.captureStackTrace(this, stackStartFunction);
	    } else {
	      var err = new Error();

	      if (err.stack) {
	        var out = err.stack;
	        var fn_name = getName(stackStartFunction);
	        var idx = out.indexOf('\n' + fn_name);

	        if (idx >= 0) {
	          var next_line = out.indexOf('\n', idx + 1);
	          out = out.substring(next_line + 1);
	        }

	        this.stack = out;
	      }
	    }
	  };

	  util.inherits(assert.AssertionError, Error);

	  function truncate(s, n) {
	    if (typeof s === 'string') {
	      return s.length < n ? s : s.slice(0, n);
	    } else {
	      return s;
	    }
	  }

	  function inspect(something) {
	    if (functionsHaveNames || !util.isFunction(something)) {
	      return util.inspect(something);
	    }

	    var rawname = getName(something);
	    var name = rawname ? ': ' + rawname : '';
	    return '[Function' + name + ']';
	  }

	  function getMessage(self) {
	    return truncate(inspect(self.actual), 128) + ' ' + self.operator + ' ' + truncate(inspect(self.expected), 128);
	  }

	  function fail(actual, expected, message, operator, stackStartFunction) {
	    throw new assert.AssertionError({
	      message: message,
	      actual: actual,
	      expected: expected,
	      operator: operator,
	      stackStartFunction: stackStartFunction
	    });
	  }

	  assert.fail = fail;

	  function ok(value, message) {
	    if (!value) fail(value, true, message, '==', assert.ok);
	  }

	  assert.ok = ok;

	  assert.equal = function equal(actual, expected, message) {
	    if (actual != expected) fail(actual, expected, message, '==', assert.equal);
	  };

	  assert.notEqual = function notEqual(actual, expected, message) {
	    if (actual == expected) {
	      fail(actual, expected, message, '!=', assert.notEqual);
	    }
	  };

	  assert.deepEqual = function deepEqual(actual, expected, message) {
	    if (!_deepEqual(actual, expected, false)) {
	      fail(actual, expected, message, 'deepEqual', assert.deepEqual);
	    }
	  };

	  assert.deepStrictEqual = function deepStrictEqual(actual, expected, message) {
	    if (!_deepEqual(actual, expected, true)) {
	      fail(actual, expected, message, 'deepStrictEqual', assert.deepStrictEqual);
	    }
	  };

	  function _deepEqual(actual, expected, strict, memos) {
	    if (actual === expected) {
	      return true;
	    } else if (isBuffer(actual) && isBuffer(expected)) {
	      return compare(actual, expected) === 0;
	    } else if (util.isDate(actual) && util.isDate(expected)) {
	      return actual.getTime() === expected.getTime();
	    } else if (util.isRegExp(actual) && util.isRegExp(expected)) {
	      return actual.source === expected.source && actual.global === expected.global && actual.multiline === expected.multiline && actual.lastIndex === expected.lastIndex && actual.ignoreCase === expected.ignoreCase;
	    } else if ((actual === null || typeof actual !== 'object') && (expected === null || typeof expected !== 'object')) {
	      return strict ? actual === expected : actual == expected;
	    } else if (isView(actual) && isView(expected) && pToString(actual) === pToString(expected) && !(actual instanceof Float32Array || actual instanceof Float64Array)) {
	      return compare(new Uint8Array(actual.buffer), new Uint8Array(expected.buffer)) === 0;
	    } else if (isBuffer(actual) !== isBuffer(expected)) {
	      return false;
	    } else {
	      memos = memos || {
	        actual: [],
	        expected: []
	      };
	      var actualIndex = memos.actual.indexOf(actual);

	      if (actualIndex !== -1) {
	        if (actualIndex === memos.expected.indexOf(expected)) {
	          return true;
	        }
	      }

	      memos.actual.push(actual);
	      memos.expected.push(expected);
	      return objEquiv(actual, expected, strict, memos);
	    }
	  }

	  function isArguments(object) {
	    return Object.prototype.toString.call(object) == '[object Arguments]';
	  }

	  function objEquiv(a, b, strict, actualVisitedObjects) {
	    if (a === null || a === undefined || b === null || b === undefined) return false;
	    if (util.isPrimitive(a) || util.isPrimitive(b)) return a === b;
	    if (strict && Object.getPrototypeOf(a) !== Object.getPrototypeOf(b)) return false;
	    var aIsArgs = isArguments(a);
	    var bIsArgs = isArguments(b);
	    if (aIsArgs && !bIsArgs || !aIsArgs && bIsArgs) return false;

	    if (aIsArgs) {
	      a = pSlice.call(a);
	      b = pSlice.call(b);
	      return _deepEqual(a, b, strict);
	    }

	    var ka = objectKeys(a);
	    var kb = objectKeys(b);
	    var key, i;
	    if (ka.length !== kb.length) return false;
	    ka.sort();
	    kb.sort();

	    for (i = ka.length - 1; i >= 0; i--) {
	      if (ka[i] !== kb[i]) return false;
	    }

	    for (i = ka.length - 1; i >= 0; i--) {
	      key = ka[i];
	      if (!_deepEqual(a[key], b[key], strict, actualVisitedObjects)) return false;
	    }

	    return true;
	  }

	  assert.notDeepEqual = function notDeepEqual(actual, expected, message) {
	    if (_deepEqual(actual, expected, false)) {
	      fail(actual, expected, message, 'notDeepEqual', assert.notDeepEqual);
	    }
	  };

	  assert.notDeepStrictEqual = notDeepStrictEqual;

	  function notDeepStrictEqual(actual, expected, message) {
	    if (_deepEqual(actual, expected, true)) {
	      fail(actual, expected, message, 'notDeepStrictEqual', notDeepStrictEqual);
	    }
	  }

	  assert.strictEqual = function strictEqual(actual, expected, message) {
	    if (actual !== expected) {
	      fail(actual, expected, message, '===', assert.strictEqual);
	    }
	  };

	  assert.notStrictEqual = function notStrictEqual(actual, expected, message) {
	    if (actual === expected) {
	      fail(actual, expected, message, '!==', assert.notStrictEqual);
	    }
	  };

	  function expectedException(actual, expected) {
	    if (!actual || !expected) {
	      return false;
	    }

	    if (Object.prototype.toString.call(expected) == '[object RegExp]') {
	      return expected.test(actual);
	    }

	    try {
	      if (actual instanceof expected) {
	        return true;
	      }
	    } catch (e) {}

	    if (Error.isPrototypeOf(expected)) {
	      return false;
	    }

	    return expected.call({}, actual) === true;
	  }

	  function _tryBlock(block) {
	    var error;

	    try {
	      block();
	    } catch (e) {
	      error = e;
	    }

	    return error;
	  }

	  function _throws(shouldThrow, block, expected, message) {
	    var actual;

	    if (typeof block !== 'function') {
	      throw new TypeError('"block" argument must be a function');
	    }

	    if (typeof expected === 'string') {
	      message = expected;
	      expected = null;
	    }

	    actual = _tryBlock(block);
	    message = (expected && expected.name ? ' (' + expected.name + ').' : '.') + (message ? ' ' + message : '.');

	    if (shouldThrow && !actual) {
	      fail(actual, expected, 'Missing expected exception' + message);
	    }

	    var userProvidedMessage = typeof message === 'string';
	    var isUnwantedException = !shouldThrow && util.isError(actual);
	    var isUnexpectedException = !shouldThrow && actual && !expected;

	    if (isUnwantedException && userProvidedMessage && expectedException(actual, expected) || isUnexpectedException) {
	      fail(actual, expected, 'Got unwanted exception' + message);
	    }

	    if (shouldThrow && actual && expected && !expectedException(actual, expected) || !shouldThrow && actual) {
	      throw actual;
	    }
	  }

	  assert.throws = function (block, error, message) {
	    _throws(true, block, error, message);
	  };

	  assert.doesNotThrow = function (block, error, message) {
	    _throws(false, block, error, message);
	  };

	  assert.ifError = function (err) {
	    if (err) throw err;
	  };

	  function strict(value, message) {
	    if (!value) fail(value, true, message, '==', strict);
	  }

	  assert.strict = objectAssign(strict, assert, {
	    equal: assert.strictEqual,
	    deepEqual: assert.deepStrictEqual,
	    notEqual: assert.notStrictEqual,
	    notDeepEqual: assert.notDeepStrictEqual
	  });
	  assert.strict.strict = assert.strict;

	  var objectKeys = Object.keys || function (obj) {
	    var keys = [];

	    for (var key in obj) {
	      if (hasOwn.call(obj, key)) keys.push(key);
	    }

	    return keys;
	  };
	}, "/$$rollup_base$$/node_modules/assert");

	const {
	  numericLiteral: numericLiteral$1,
	  unaryExpression: unaryExpression$2
	} = _t;
	traverse.visitors.merge([environmentVisitor, {
	  ThisExpression(path) {
	    path.replaceWith(unaryExpression$2("void", numericLiteral$1(0), true));
	  }

	}]);

	function normalizeArray(parts, allowAboveRoot) {
	  var up = 0;

	  for (var i = parts.length - 1; i >= 0; i--) {
	    var last = parts[i];

	    if (last === '.') {
	      parts.splice(i, 1);
	    } else if (last === '..') {
	      parts.splice(i, 1);
	      up++;
	    } else if (up) {
	      parts.splice(i, 1);
	      up--;
	    }
	  }

	  if (allowAboveRoot) {
	    for (; up--; up) {
	      parts.unshift('..');
	    }
	  }

	  return parts;
	}

	var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;

	var splitPath = function (filename) {
	  return splitPathRe.exec(filename).slice(1);
	};

	function resolve$1() {
	  var resolvedPath = '',
	      resolvedAbsolute = false;

	  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
	    var path = i >= 0 ? arguments[i] : '/';

	    if (typeof path !== 'string') {
	      throw new TypeError('Arguments to path.resolve must be strings');
	    } else if (!path) {
	      continue;
	    }

	    resolvedPath = path + '/' + resolvedPath;
	    resolvedAbsolute = path.charAt(0) === '/';
	  }

	  resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function (p) {
	    return !!p;
	  }), !resolvedAbsolute).join('/');
	  return (resolvedAbsolute ? '/' : '') + resolvedPath || '.';
	}
	function normalize$1(path) {
	  var isPathAbsolute = isAbsolute(path),
	      trailingSlash = substr(path, -1) === '/';
	  path = normalizeArray(filter(path.split('/'), function (p) {
	    return !!p;
	  }), !isPathAbsolute).join('/');

	  if (!path && !isPathAbsolute) {
	    path = '.';
	  }

	  if (path && trailingSlash) {
	    path += '/';
	  }

	  return (isPathAbsolute ? '/' : '') + path;
	}
	function isAbsolute(path) {
	  return path.charAt(0) === '/';
	}
	function join() {
	  var paths = Array.prototype.slice.call(arguments, 0);
	  return normalize$1(filter(paths, function (p, index) {
	    if (typeof p !== 'string') {
	      throw new TypeError('Arguments to path.join must be strings');
	    }

	    return p;
	  }).join('/'));
	}
	function relative(from, to) {
	  from = resolve$1(from).substr(1);
	  to = resolve$1(to).substr(1);

	  function trim(arr) {
	    var start = 0;

	    for (; start < arr.length; start++) {
	      if (arr[start] !== '') break;
	    }

	    var end = arr.length - 1;

	    for (; end >= 0; end--) {
	      if (arr[end] !== '') break;
	    }

	    if (start > end) return [];
	    return arr.slice(start, end - start + 1);
	  }

	  var fromParts = trim(from.split('/'));
	  var toParts = trim(to.split('/'));
	  var length = Math.min(fromParts.length, toParts.length);
	  var samePartsLength = length;

	  for (var i = 0; i < length; i++) {
	    if (fromParts[i] !== toParts[i]) {
	      samePartsLength = i;
	      break;
	    }
	  }

	  var outputParts = [];

	  for (var i = samePartsLength; i < fromParts.length; i++) {
	    outputParts.push('..');
	  }

	  outputParts = outputParts.concat(toParts.slice(samePartsLength));
	  return outputParts.join('/');
	}
	var sep$1 = '/';
	var delimiter = ':';
	function dirname(path) {
	  var result = splitPath(path),
	      root = result[0],
	      dir = result[1];

	  if (!root && !dir) {
	    return '.';
	  }

	  if (dir) {
	    dir = dir.substr(0, dir.length - 1);
	  }

	  return root + dir;
	}
	function basename(path, ext) {
	  var f = splitPath(path)[2];

	  if (ext && f.substr(-1 * ext.length) === ext) {
	    f = f.substr(0, f.length - ext.length);
	  }

	  return f;
	}
	function extname(path) {
	  return splitPath(path)[3];
	}
	var path$1 = {
	  extname: extname,
	  basename: basename,
	  dirname: dirname,
	  sep: sep$1,
	  delimiter: delimiter,
	  relative: relative,
	  join: join,
	  isAbsolute: isAbsolute,
	  normalize: normalize$1,
	  resolve: resolve$1
	};

	function filter(xs, f) {
	  if (xs.filter) return xs.filter(f);
	  var res = [];

	  for (var i = 0; i < xs.length; i++) {
	    if (f(xs[i], i, xs)) res.push(xs[i]);
	  }

	  return res;
	}

	var substr = 'ab'.substr(-1) === 'b' ? function (str, start, len) {
	  return str.substr(start, len);
	} : function (str, start, len) {
	  if (start < 0) start = str.length + start;
	  return str.substr(start, len);
	};

	var path$2 = /*#__PURE__*/Object.freeze({
		__proto__: null,
		resolve: resolve$1,
		normalize: normalize$1,
		isAbsolute: isAbsolute,
		join: join,
		relative: relative,
		sep: sep$1,
		delimiter: delimiter,
		dirname: dirname,
		basename: basename,
		extname: extname,
		'default': path$1
	});

	if (!browser$5.env.BABEL_8_BREAKING) {
	  const originalGetModuleName = getModuleName;

	  getModuleName = function getModuleName(rootOpts, pluginOpts) {
	    return originalGetModuleName(rootOpts, {
	      moduleId: pluginOpts.moduleId ?? rootOpts.moduleId,
	      moduleIds: pluginOpts.moduleIds ?? rootOpts.moduleIds,
	      getModuleId: pluginOpts.getModuleId ?? rootOpts.getModuleId,
	      moduleRoot: pluginOpts.moduleRoot ?? rootOpts.moduleRoot
	    });
	  };
	}

	function getModuleName(rootOpts, pluginOpts) {
	  const {
	    filename,
	    filenameRelative = filename,
	    sourceRoot = pluginOpts.moduleRoot
	  } = rootOpts;
	  const {
	    moduleId,
	    moduleIds = !!moduleId,
	    getModuleId,
	    moduleRoot = sourceRoot
	  } = pluginOpts;
	  if (!moduleIds) return null;

	  if (moduleId != null && !getModuleId) {
	    return moduleId;
	  }

	  let moduleName = moduleRoot != null ? moduleRoot + "/" : "";

	  if (filenameRelative) {
	    const sourceRootReplacer = sourceRoot != null ? new RegExp("^" + sourceRoot + "/?") : "";
	    moduleName += filenameRelative.replace(sourceRootReplacer, "").replace(/\.(\w*?)$/, "");
	  }

	  moduleName = moduleName.replace(/\\/g, "/");

	  if (getModuleId) {
	    return getModuleId(moduleName) || moduleName;
	  } else {
	    return moduleName;
	  }
	}

	({
	  constant: template.statement`EXPORTS.EXPORT_NAME = NAMESPACE_IMPORT;`,
	  constantComputed: template.statement`EXPORTS["EXPORT_NAME"] = NAMESPACE_IMPORT;`,
	  spec: template.statement`
    Object.defineProperty(EXPORTS, "EXPORT_NAME", {
      enumerable: true,
      get: function() {
        return NAMESPACE_IMPORT;
      },
    });
    `
	});

	({
	  computed: template.expression`EXPORTS["NAME"] = VALUE`,
	  default: template.expression`EXPORTS.NAME = VALUE`
	});

	const SEMVER_SPEC_VERSION = '2.0.0';
	const MAX_LENGTH$2 = 256;
	const MAX_SAFE_INTEGER$1 = Number.MAX_SAFE_INTEGER || 9007199254740991;
	const MAX_SAFE_COMPONENT_LENGTH = 16;
	var constants = {
	  SEMVER_SPEC_VERSION,
	  MAX_LENGTH: MAX_LENGTH$2,
	  MAX_SAFE_INTEGER: MAX_SAFE_INTEGER$1,
	  MAX_SAFE_COMPONENT_LENGTH
	};

	const debug$2 = typeof browser$5 === 'object' && browser$5.env && browser$5.env.NODE_DEBUG && /\bsemver\b/i.test(browser$5.env.NODE_DEBUG) ? (...args) => console.error('SEMVER', ...args) : () => {};
	var debug_1 = debug$2;

	var re_1 = createCommonjsModule(function (module, exports) {
	  const {
	    MAX_SAFE_COMPONENT_LENGTH
	  } = constants;
	  exports = module.exports = {};
	  const re = exports.re = [];
	  const src = exports.src = [];
	  const t = exports.t = {};
	  let R = 0;

	  const createToken = (name, value, isGlobal) => {
	    const index = R++;
	    debug_1(index, value);
	    t[name] = index;
	    src[index] = value;
	    re[index] = new RegExp(value, isGlobal ? 'g' : undefined);
	  };

	  createToken('NUMERICIDENTIFIER', '0|[1-9]\\d*');
	  createToken('NUMERICIDENTIFIERLOOSE', '[0-9]+');
	  createToken('NONNUMERICIDENTIFIER', '\\d*[a-zA-Z-][a-zA-Z0-9-]*');
	  createToken('MAINVERSION', `(${src[t.NUMERICIDENTIFIER]})\\.` + `(${src[t.NUMERICIDENTIFIER]})\\.` + `(${src[t.NUMERICIDENTIFIER]})`);
	  createToken('MAINVERSIONLOOSE', `(${src[t.NUMERICIDENTIFIERLOOSE]})\\.` + `(${src[t.NUMERICIDENTIFIERLOOSE]})\\.` + `(${src[t.NUMERICIDENTIFIERLOOSE]})`);
	  createToken('PRERELEASEIDENTIFIER', `(?:${src[t.NUMERICIDENTIFIER]}|${src[t.NONNUMERICIDENTIFIER]})`);
	  createToken('PRERELEASEIDENTIFIERLOOSE', `(?:${src[t.NUMERICIDENTIFIERLOOSE]}|${src[t.NONNUMERICIDENTIFIER]})`);
	  createToken('PRERELEASE', `(?:-(${src[t.PRERELEASEIDENTIFIER]}(?:\\.${src[t.PRERELEASEIDENTIFIER]})*))`);
	  createToken('PRERELEASELOOSE', `(?:-?(${src[t.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${src[t.PRERELEASEIDENTIFIERLOOSE]})*))`);
	  createToken('BUILDIDENTIFIER', '[0-9A-Za-z-]+');
	  createToken('BUILD', `(?:\\+(${src[t.BUILDIDENTIFIER]}(?:\\.${src[t.BUILDIDENTIFIER]})*))`);
	  createToken('FULLPLAIN', `v?${src[t.MAINVERSION]}${src[t.PRERELEASE]}?${src[t.BUILD]}?`);
	  createToken('FULL', `^${src[t.FULLPLAIN]}$`);
	  createToken('LOOSEPLAIN', `[v=\\s]*${src[t.MAINVERSIONLOOSE]}${src[t.PRERELEASELOOSE]}?${src[t.BUILD]}?`);
	  createToken('LOOSE', `^${src[t.LOOSEPLAIN]}$`);
	  createToken('GTLT', '((?:<|>)?=?)');
	  createToken('XRANGEIDENTIFIERLOOSE', `${src[t.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);
	  createToken('XRANGEIDENTIFIER', `${src[t.NUMERICIDENTIFIER]}|x|X|\\*`);
	  createToken('XRANGEPLAIN', `[v=\\s]*(${src[t.XRANGEIDENTIFIER]})` + `(?:\\.(${src[t.XRANGEIDENTIFIER]})` + `(?:\\.(${src[t.XRANGEIDENTIFIER]})` + `(?:${src[t.PRERELEASE]})?${src[t.BUILD]}?` + `)?)?`);
	  createToken('XRANGEPLAINLOOSE', `[v=\\s]*(${src[t.XRANGEIDENTIFIERLOOSE]})` + `(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})` + `(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})` + `(?:${src[t.PRERELEASELOOSE]})?${src[t.BUILD]}?` + `)?)?`);
	  createToken('XRANGE', `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAIN]}$`);
	  createToken('XRANGELOOSE', `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAINLOOSE]}$`);
	  createToken('COERCE', `${'(^|[^\\d])' + '(\\d{1,'}${MAX_SAFE_COMPONENT_LENGTH}})` + `(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?` + `(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?` + `(?:$|[^\\d])`);
	  createToken('COERCERTL', src[t.COERCE], true);
	  createToken('LONETILDE', '(?:~>?)');
	  createToken('TILDETRIM', `(\\s*)${src[t.LONETILDE]}\\s+`, true);
	  exports.tildeTrimReplace = '$1~';
	  createToken('TILDE', `^${src[t.LONETILDE]}${src[t.XRANGEPLAIN]}$`);
	  createToken('TILDELOOSE', `^${src[t.LONETILDE]}${src[t.XRANGEPLAINLOOSE]}$`);
	  createToken('LONECARET', '(?:\\^)');
	  createToken('CARETTRIM', `(\\s*)${src[t.LONECARET]}\\s+`, true);
	  exports.caretTrimReplace = '$1^';
	  createToken('CARET', `^${src[t.LONECARET]}${src[t.XRANGEPLAIN]}$`);
	  createToken('CARETLOOSE', `^${src[t.LONECARET]}${src[t.XRANGEPLAINLOOSE]}$`);
	  createToken('COMPARATORLOOSE', `^${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]})$|^$`);
	  createToken('COMPARATOR', `^${src[t.GTLT]}\\s*(${src[t.FULLPLAIN]})$|^$`);
	  createToken('COMPARATORTRIM', `(\\s*)${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]}|${src[t.XRANGEPLAIN]})`, true);
	  exports.comparatorTrimReplace = '$1$2$3';
	  createToken('HYPHENRANGE', `^\\s*(${src[t.XRANGEPLAIN]})` + `\\s+-\\s+` + `(${src[t.XRANGEPLAIN]})` + `\\s*$`);
	  createToken('HYPHENRANGELOOSE', `^\\s*(${src[t.XRANGEPLAINLOOSE]})` + `\\s+-\\s+` + `(${src[t.XRANGEPLAINLOOSE]})` + `\\s*$`);
	  createToken('STAR', '(<|>)?=?\\s*\\*');
	  createToken('GTE0', '^\\s*>=\\s*0\.0\.0\\s*$');
	  createToken('GTE0PRE', '^\\s*>=\\s*0\.0\.0-0\\s*$');
	}, "/$$rollup_base$$/node_modules/semver-BABEL_8_BREAKING-true/internal");

	const opts = ['includePrerelease', 'loose', 'rtl'];

	const parseOptions = options => !options ? {} : typeof options !== 'object' ? {
	  loose: true
	} : opts.filter(k => options[k]).reduce((options, k) => {
	  options[k] = true;
	  return options;
	}, {});

	var parseOptions_1 = parseOptions;

	const numeric = /^[0-9]+$/;

	const compareIdentifiers$1 = (a, b) => {
	  const anum = numeric.test(a);
	  const bnum = numeric.test(b);

	  if (anum && bnum) {
	    a = +a;
	    b = +b;
	  }

	  return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
	};

	const rcompareIdentifiers = (a, b) => compareIdentifiers$1(b, a);

	var identifiers = {
	  compareIdentifiers: compareIdentifiers$1,
	  rcompareIdentifiers
	};

	const {
	  MAX_LENGTH: MAX_LENGTH$1,
	  MAX_SAFE_INTEGER
	} = constants;
	const {
	  re: re$4,
	  t: t$4
	} = re_1;
	const {
	  compareIdentifiers
	} = identifiers;

	class SemVer {
	  constructor(version, options) {
	    options = parseOptions_1(options);

	    if (version instanceof SemVer) {
	      if (version.loose === !!options.loose && version.includePrerelease === !!options.includePrerelease) {
	        return version;
	      } else {
	        version = version.version;
	      }
	    } else if (typeof version !== 'string') {
	      throw new TypeError(`Invalid Version: ${version}`);
	    }

	    if (version.length > MAX_LENGTH$1) {
	      throw new TypeError(`version is longer than ${MAX_LENGTH$1} characters`);
	    }

	    debug_1('SemVer', version, options);
	    this.options = options;
	    this.loose = !!options.loose;
	    this.includePrerelease = !!options.includePrerelease;
	    const m = version.trim().match(options.loose ? re$4[t$4.LOOSE] : re$4[t$4.FULL]);

	    if (!m) {
	      throw new TypeError(`Invalid Version: ${version}`);
	    }

	    this.raw = version;
	    this.major = +m[1];
	    this.minor = +m[2];
	    this.patch = +m[3];

	    if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
	      throw new TypeError('Invalid major version');
	    }

	    if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
	      throw new TypeError('Invalid minor version');
	    }

	    if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
	      throw new TypeError('Invalid patch version');
	    }

	    if (!m[4]) {
	      this.prerelease = [];
	    } else {
	      this.prerelease = m[4].split('.').map(id => {
	        if (/^[0-9]+$/.test(id)) {
	          const num = +id;

	          if (num >= 0 && num < MAX_SAFE_INTEGER) {
	            return num;
	          }
	        }

	        return id;
	      });
	    }

	    this.build = m[5] ? m[5].split('.') : [];
	    this.format();
	  }

	  format() {
	    this.version = `${this.major}.${this.minor}.${this.patch}`;

	    if (this.prerelease.length) {
	      this.version += `-${this.prerelease.join('.')}`;
	    }

	    return this.version;
	  }

	  toString() {
	    return this.version;
	  }

	  compare(other) {
	    debug_1('SemVer.compare', this.version, this.options, other);

	    if (!(other instanceof SemVer)) {
	      if (typeof other === 'string' && other === this.version) {
	        return 0;
	      }

	      other = new SemVer(other, this.options);
	    }

	    if (other.version === this.version) {
	      return 0;
	    }

	    return this.compareMain(other) || this.comparePre(other);
	  }

	  compareMain(other) {
	    if (!(other instanceof SemVer)) {
	      other = new SemVer(other, this.options);
	    }

	    return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
	  }

	  comparePre(other) {
	    if (!(other instanceof SemVer)) {
	      other = new SemVer(other, this.options);
	    }

	    if (this.prerelease.length && !other.prerelease.length) {
	      return -1;
	    } else if (!this.prerelease.length && other.prerelease.length) {
	      return 1;
	    } else if (!this.prerelease.length && !other.prerelease.length) {
	      return 0;
	    }

	    let i = 0;

	    do {
	      const a = this.prerelease[i];
	      const b = other.prerelease[i];
	      debug_1('prerelease compare', i, a, b);

	      if (a === undefined && b === undefined) {
	        return 0;
	      } else if (b === undefined) {
	        return 1;
	      } else if (a === undefined) {
	        return -1;
	      } else if (a === b) {
	        continue;
	      } else {
	        return compareIdentifiers(a, b);
	      }
	    } while (++i);
	  }

	  compareBuild(other) {
	    if (!(other instanceof SemVer)) {
	      other = new SemVer(other, this.options);
	    }

	    let i = 0;

	    do {
	      const a = this.build[i];
	      const b = other.build[i];
	      debug_1('prerelease compare', i, a, b);

	      if (a === undefined && b === undefined) {
	        return 0;
	      } else if (b === undefined) {
	        return 1;
	      } else if (a === undefined) {
	        return -1;
	      } else if (a === b) {
	        continue;
	      } else {
	        return compareIdentifiers(a, b);
	      }
	    } while (++i);
	  }

	  inc(release, identifier) {
	    switch (release) {
	      case 'premajor':
	        this.prerelease.length = 0;
	        this.patch = 0;
	        this.minor = 0;
	        this.major++;
	        this.inc('pre', identifier);
	        break;

	      case 'preminor':
	        this.prerelease.length = 0;
	        this.patch = 0;
	        this.minor++;
	        this.inc('pre', identifier);
	        break;

	      case 'prepatch':
	        this.prerelease.length = 0;
	        this.inc('patch', identifier);
	        this.inc('pre', identifier);
	        break;

	      case 'prerelease':
	        if (this.prerelease.length === 0) {
	          this.inc('patch', identifier);
	        }

	        this.inc('pre', identifier);
	        break;

	      case 'major':
	        if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
	          this.major++;
	        }

	        this.minor = 0;
	        this.patch = 0;
	        this.prerelease = [];
	        break;

	      case 'minor':
	        if (this.patch !== 0 || this.prerelease.length === 0) {
	          this.minor++;
	        }

	        this.patch = 0;
	        this.prerelease = [];
	        break;

	      case 'patch':
	        if (this.prerelease.length === 0) {
	          this.patch++;
	        }

	        this.prerelease = [];
	        break;

	      case 'pre':
	        if (this.prerelease.length === 0) {
	          this.prerelease = [0];
	        } else {
	          let i = this.prerelease.length;

	          while (--i >= 0) {
	            if (typeof this.prerelease[i] === 'number') {
	              this.prerelease[i]++;
	              i = -2;
	            }
	          }

	          if (i === -1) {
	            this.prerelease.push(0);
	          }
	        }

	        if (identifier) {
	          if (this.prerelease[0] === identifier) {
	            if (isNaN(this.prerelease[1])) {
	              this.prerelease = [identifier, 0];
	            }
	          } else {
	            this.prerelease = [identifier, 0];
	          }
	        }

	        break;

	      default:
	        throw new Error(`invalid increment argument: ${release}`);
	    }

	    this.format();
	    this.raw = this.version;
	    return this;
	  }

	}

	var semver$3 = SemVer;

	const {
	  MAX_LENGTH
	} = constants;
	const {
	  re: re$3,
	  t: t$3
	} = re_1;

	const parse$3 = (version, options) => {
	  options = parseOptions_1(options);

	  if (version instanceof semver$3) {
	    return version;
	  }

	  if (typeof version !== 'string') {
	    return null;
	  }

	  if (version.length > MAX_LENGTH) {
	    return null;
	  }

	  const r = options.loose ? re$3[t$3.LOOSE] : re$3[t$3.FULL];

	  if (!r.test(version)) {
	    return null;
	  }

	  try {
	    return new semver$3(version, options);
	  } catch (er) {
	    return null;
	  }
	};

	var parse_1 = parse$3;

	const valid$1 = (version, options) => {
	  const v = parse_1(version, options);
	  return v ? v.version : null;
	};

	var valid_1 = valid$1;

	const clean = (version, options) => {
	  const s = parse_1(version.trim().replace(/^[=v]+/, ''), options);
	  return s ? s.version : null;
	};

	var clean_1 = clean;

	const inc = (version, release, options, identifier) => {
	  if (typeof options === 'string') {
	    identifier = options;
	    options = undefined;
	  }

	  try {
	    return new semver$3(version, options).inc(release, identifier).version;
	  } catch (er) {
	    return null;
	  }
	};

	var inc_1 = inc;

	const compare$1 = (a, b, loose) => new semver$3(a, loose).compare(new semver$3(b, loose));

	var compare_1 = compare$1;

	const eq = (a, b, loose) => compare_1(a, b, loose) === 0;

	var eq_1 = eq;

	const diff = (version1, version2) => {
	  if (eq_1(version1, version2)) {
	    return null;
	  } else {
	    const v1 = parse_1(version1);
	    const v2 = parse_1(version2);
	    const hasPre = v1.prerelease.length || v2.prerelease.length;
	    const prefix = hasPre ? 'pre' : '';
	    const defaultResult = hasPre ? 'prerelease' : '';

	    for (const key in v1) {
	      if (key === 'major' || key === 'minor' || key === 'patch') {
	        if (v1[key] !== v2[key]) {
	          return prefix + key;
	        }
	      }
	    }

	    return defaultResult;
	  }
	};

	var diff_1 = diff;

	const major = (a, loose) => new semver$3(a, loose).major;

	var major_1 = major;

	const minor = (a, loose) => new semver$3(a, loose).minor;

	var minor_1 = minor;

	const patch = (a, loose) => new semver$3(a, loose).patch;

	var patch_1 = patch;

	const prerelease = (version, options) => {
	  const parsed = parse_1(version, options);
	  return parsed && parsed.prerelease.length ? parsed.prerelease : null;
	};

	var prerelease_1 = prerelease;

	const rcompare = (a, b, loose) => compare_1(b, a, loose);

	var rcompare_1 = rcompare;

	const compareLoose = (a, b) => compare_1(a, b, true);

	var compareLoose_1 = compareLoose;

	const compareBuild = (a, b, loose) => {
	  const versionA = new semver$3(a, loose);
	  const versionB = new semver$3(b, loose);
	  return versionA.compare(versionB) || versionA.compareBuild(versionB);
	};

	var compareBuild_1 = compareBuild;

	const sort = (list, loose) => list.sort((a, b) => compareBuild_1(a, b, loose));

	var sort_1 = sort;

	const rsort = (list, loose) => list.sort((a, b) => compareBuild_1(b, a, loose));

	var rsort_1 = rsort;

	const gt = (a, b, loose) => compare_1(a, b, loose) > 0;

	var gt_1 = gt;

	const lt = (a, b, loose) => compare_1(a, b, loose) < 0;

	var lt_1 = lt;

	const neq = (a, b, loose) => compare_1(a, b, loose) !== 0;

	var neq_1 = neq;

	const gte = (a, b, loose) => compare_1(a, b, loose) >= 0;

	var gte_1 = gte;

	const lte = (a, b, loose) => compare_1(a, b, loose) <= 0;

	var lte_1 = lte;

	const cmp = (a, op, b, loose) => {
	  switch (op) {
	    case '===':
	      if (typeof a === 'object') a = a.version;
	      if (typeof b === 'object') b = b.version;
	      return a === b;

	    case '!==':
	      if (typeof a === 'object') a = a.version;
	      if (typeof b === 'object') b = b.version;
	      return a !== b;

	    case '':
	    case '=':
	    case '==':
	      return eq_1(a, b, loose);

	    case '!=':
	      return neq_1(a, b, loose);

	    case '>':
	      return gt_1(a, b, loose);

	    case '>=':
	      return gte_1(a, b, loose);

	    case '<':
	      return lt_1(a, b, loose);

	    case '<=':
	      return lte_1(a, b, loose);

	    default:
	      throw new TypeError(`Invalid operator: ${op}`);
	  }
	};

	var cmp_1 = cmp;

	const {
	  re: re$2,
	  t: t$2
	} = re_1;

	const coerce = (version, options) => {
	  if (version instanceof semver$3) {
	    return version;
	  }

	  if (typeof version === 'number') {
	    version = String(version);
	  }

	  if (typeof version !== 'string') {
	    return null;
	  }

	  options = options || {};
	  let match = null;

	  if (!options.rtl) {
	    match = version.match(re$2[t$2.COERCE]);
	  } else {
	    let next;

	    while ((next = re$2[t$2.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
	      if (!match || next.index + next[0].length !== match.index + match[0].length) {
	        match = next;
	      }

	      re$2[t$2.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
	    }

	    re$2[t$2.COERCERTL].lastIndex = -1;
	  }

	  if (match === null) return null;
	  return parse_1(`${match[2]}.${match[3] || '0'}.${match[4] || '0'}`, options);
	};

	var coerce_1 = coerce;

	var iterator = function (Yallist) {
	  Yallist.prototype[Symbol.iterator] = function* () {
	    for (let walker = this.head; walker; walker = walker.next) {
	      yield walker.value;
	    }
	  };
	};

	var yallist = Yallist;
	Yallist.Node = Node;
	Yallist.create = Yallist;

	function Yallist(list) {
	  var self = this;

	  if (!(self instanceof Yallist)) {
	    self = new Yallist();
	  }

	  self.tail = null;
	  self.head = null;
	  self.length = 0;

	  if (list && typeof list.forEach === 'function') {
	    list.forEach(function (item) {
	      self.push(item);
	    });
	  } else if (arguments.length > 0) {
	    for (var i = 0, l = arguments.length; i < l; i++) {
	      self.push(arguments[i]);
	    }
	  }

	  return self;
	}

	Yallist.prototype.removeNode = function (node) {
	  if (node.list !== this) {
	    throw new Error('removing node which does not belong to this list');
	  }

	  var next = node.next;
	  var prev = node.prev;

	  if (next) {
	    next.prev = prev;
	  }

	  if (prev) {
	    prev.next = next;
	  }

	  if (node === this.head) {
	    this.head = next;
	  }

	  if (node === this.tail) {
	    this.tail = prev;
	  }

	  node.list.length--;
	  node.next = null;
	  node.prev = null;
	  node.list = null;
	  return next;
	};

	Yallist.prototype.unshiftNode = function (node) {
	  if (node === this.head) {
	    return;
	  }

	  if (node.list) {
	    node.list.removeNode(node);
	  }

	  var head = this.head;
	  node.list = this;
	  node.next = head;

	  if (head) {
	    head.prev = node;
	  }

	  this.head = node;

	  if (!this.tail) {
	    this.tail = node;
	  }

	  this.length++;
	};

	Yallist.prototype.pushNode = function (node) {
	  if (node === this.tail) {
	    return;
	  }

	  if (node.list) {
	    node.list.removeNode(node);
	  }

	  var tail = this.tail;
	  node.list = this;
	  node.prev = tail;

	  if (tail) {
	    tail.next = node;
	  }

	  this.tail = node;

	  if (!this.head) {
	    this.head = node;
	  }

	  this.length++;
	};

	Yallist.prototype.push = function () {
	  for (var i = 0, l = arguments.length; i < l; i++) {
	    push(this, arguments[i]);
	  }

	  return this.length;
	};

	Yallist.prototype.unshift = function () {
	  for (var i = 0, l = arguments.length; i < l; i++) {
	    unshift(this, arguments[i]);
	  }

	  return this.length;
	};

	Yallist.prototype.pop = function () {
	  if (!this.tail) {
	    return undefined;
	  }

	  var res = this.tail.value;
	  this.tail = this.tail.prev;

	  if (this.tail) {
	    this.tail.next = null;
	  } else {
	    this.head = null;
	  }

	  this.length--;
	  return res;
	};

	Yallist.prototype.shift = function () {
	  if (!this.head) {
	    return undefined;
	  }

	  var res = this.head.value;
	  this.head = this.head.next;

	  if (this.head) {
	    this.head.prev = null;
	  } else {
	    this.tail = null;
	  }

	  this.length--;
	  return res;
	};

	Yallist.prototype.forEach = function (fn, thisp) {
	  thisp = thisp || this;

	  for (var walker = this.head, i = 0; walker !== null; i++) {
	    fn.call(thisp, walker.value, i, this);
	    walker = walker.next;
	  }
	};

	Yallist.prototype.forEachReverse = function (fn, thisp) {
	  thisp = thisp || this;

	  for (var walker = this.tail, i = this.length - 1; walker !== null; i--) {
	    fn.call(thisp, walker.value, i, this);
	    walker = walker.prev;
	  }
	};

	Yallist.prototype.get = function (n) {
	  for (var i = 0, walker = this.head; walker !== null && i < n; i++) {
	    walker = walker.next;
	  }

	  if (i === n && walker !== null) {
	    return walker.value;
	  }
	};

	Yallist.prototype.getReverse = function (n) {
	  for (var i = 0, walker = this.tail; walker !== null && i < n; i++) {
	    walker = walker.prev;
	  }

	  if (i === n && walker !== null) {
	    return walker.value;
	  }
	};

	Yallist.prototype.map = function (fn, thisp) {
	  thisp = thisp || this;
	  var res = new Yallist();

	  for (var walker = this.head; walker !== null;) {
	    res.push(fn.call(thisp, walker.value, this));
	    walker = walker.next;
	  }

	  return res;
	};

	Yallist.prototype.mapReverse = function (fn, thisp) {
	  thisp = thisp || this;
	  var res = new Yallist();

	  for (var walker = this.tail; walker !== null;) {
	    res.push(fn.call(thisp, walker.value, this));
	    walker = walker.prev;
	  }

	  return res;
	};

	Yallist.prototype.reduce = function (fn, initial) {
	  var acc;
	  var walker = this.head;

	  if (arguments.length > 1) {
	    acc = initial;
	  } else if (this.head) {
	    walker = this.head.next;
	    acc = this.head.value;
	  } else {
	    throw new TypeError('Reduce of empty list with no initial value');
	  }

	  for (var i = 0; walker !== null; i++) {
	    acc = fn(acc, walker.value, i);
	    walker = walker.next;
	  }

	  return acc;
	};

	Yallist.prototype.reduceReverse = function (fn, initial) {
	  var acc;
	  var walker = this.tail;

	  if (arguments.length > 1) {
	    acc = initial;
	  } else if (this.tail) {
	    walker = this.tail.prev;
	    acc = this.tail.value;
	  } else {
	    throw new TypeError('Reduce of empty list with no initial value');
	  }

	  for (var i = this.length - 1; walker !== null; i--) {
	    acc = fn(acc, walker.value, i);
	    walker = walker.prev;
	  }

	  return acc;
	};

	Yallist.prototype.toArray = function () {
	  var arr = new Array(this.length);

	  for (var i = 0, walker = this.head; walker !== null; i++) {
	    arr[i] = walker.value;
	    walker = walker.next;
	  }

	  return arr;
	};

	Yallist.prototype.toArrayReverse = function () {
	  var arr = new Array(this.length);

	  for (var i = 0, walker = this.tail; walker !== null; i++) {
	    arr[i] = walker.value;
	    walker = walker.prev;
	  }

	  return arr;
	};

	Yallist.prototype.slice = function (from, to) {
	  to = to || this.length;

	  if (to < 0) {
	    to += this.length;
	  }

	  from = from || 0;

	  if (from < 0) {
	    from += this.length;
	  }

	  var ret = new Yallist();

	  if (to < from || to < 0) {
	    return ret;
	  }

	  if (from < 0) {
	    from = 0;
	  }

	  if (to > this.length) {
	    to = this.length;
	  }

	  for (var i = 0, walker = this.head; walker !== null && i < from; i++) {
	    walker = walker.next;
	  }

	  for (; walker !== null && i < to; i++, walker = walker.next) {
	    ret.push(walker.value);
	  }

	  return ret;
	};

	Yallist.prototype.sliceReverse = function (from, to) {
	  to = to || this.length;

	  if (to < 0) {
	    to += this.length;
	  }

	  from = from || 0;

	  if (from < 0) {
	    from += this.length;
	  }

	  var ret = new Yallist();

	  if (to < from || to < 0) {
	    return ret;
	  }

	  if (from < 0) {
	    from = 0;
	  }

	  if (to > this.length) {
	    to = this.length;
	  }

	  for (var i = this.length, walker = this.tail; walker !== null && i > to; i--) {
	    walker = walker.prev;
	  }

	  for (; walker !== null && i > from; i--, walker = walker.prev) {
	    ret.push(walker.value);
	  }

	  return ret;
	};

	Yallist.prototype.splice = function (start, deleteCount, ...nodes) {
	  if (start > this.length) {
	    start = this.length - 1;
	  }

	  if (start < 0) {
	    start = this.length + start;
	  }

	  for (var i = 0, walker = this.head; walker !== null && i < start; i++) {
	    walker = walker.next;
	  }

	  var ret = [];

	  for (var i = 0; walker && i < deleteCount; i++) {
	    ret.push(walker.value);
	    walker = this.removeNode(walker);
	  }

	  if (walker === null) {
	    walker = this.tail;
	  }

	  if (walker !== this.head && walker !== this.tail) {
	    walker = walker.prev;
	  }

	  for (var i = 0; i < nodes.length; i++) {
	    walker = insert(this, walker, nodes[i]);
	  }

	  return ret;
	};

	Yallist.prototype.reverse = function () {
	  var head = this.head;
	  var tail = this.tail;

	  for (var walker = head; walker !== null; walker = walker.prev) {
	    var p = walker.prev;
	    walker.prev = walker.next;
	    walker.next = p;
	  }

	  this.head = tail;
	  this.tail = head;
	  return this;
	};

	function insert(self, node, value) {
	  var inserted = node === self.head ? new Node(value, null, node, self) : new Node(value, node, node.next, self);

	  if (inserted.next === null) {
	    self.tail = inserted;
	  }

	  if (inserted.prev === null) {
	    self.head = inserted;
	  }

	  self.length++;
	  return inserted;
	}

	function push(self, item) {
	  self.tail = new Node(item, self.tail, null, self);

	  if (!self.head) {
	    self.head = self.tail;
	  }

	  self.length++;
	}

	function unshift(self, item) {
	  self.head = new Node(item, null, self.head, self);

	  if (!self.tail) {
	    self.tail = self.head;
	  }

	  self.length++;
	}

	function Node(value, prev, next, list) {
	  if (!(this instanceof Node)) {
	    return new Node(value, prev, next, list);
	  }

	  this.list = list;
	  this.value = value;

	  if (prev) {
	    prev.next = this;
	    this.prev = prev;
	  } else {
	    this.prev = null;
	  }

	  if (next) {
	    next.prev = this;
	    this.next = next;
	  } else {
	    this.next = null;
	  }
	}

	try {
	  iterator(Yallist);
	} catch (er) {}

	const MAX = Symbol('max');
	const LENGTH = Symbol('length');
	const LENGTH_CALCULATOR = Symbol('lengthCalculator');
	const ALLOW_STALE = Symbol('allowStale');
	const MAX_AGE = Symbol('maxAge');
	const DISPOSE = Symbol('dispose');
	const NO_DISPOSE_ON_SET = Symbol('noDisposeOnSet');
	const LRU_LIST = Symbol('lruList');
	const CACHE = Symbol('cache');
	const UPDATE_AGE_ON_GET = Symbol('updateAgeOnGet');

	const naiveLength = () => 1;

	class LRUCache {
	  constructor(options) {
	    if (typeof options === 'number') options = {
	      max: options
	    };
	    if (!options) options = {};
	    if (options.max && (typeof options.max !== 'number' || options.max < 0)) throw new TypeError('max must be a non-negative number');
	    this[MAX] = options.max || Infinity;
	    const lc = options.length || naiveLength;
	    this[LENGTH_CALCULATOR] = typeof lc !== 'function' ? naiveLength : lc;
	    this[ALLOW_STALE] = options.stale || false;
	    if (options.maxAge && typeof options.maxAge !== 'number') throw new TypeError('maxAge must be a number');
	    this[MAX_AGE] = options.maxAge || 0;
	    this[DISPOSE] = options.dispose;
	    this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
	    this[UPDATE_AGE_ON_GET] = options.updateAgeOnGet || false;
	    this.reset();
	  }

	  set max(mL) {
	    if (typeof mL !== 'number' || mL < 0) throw new TypeError('max must be a non-negative number');
	    this[MAX] = mL || Infinity;
	    trim(this);
	  }

	  get max() {
	    return this[MAX];
	  }

	  set allowStale(allowStale) {
	    this[ALLOW_STALE] = !!allowStale;
	  }

	  get allowStale() {
	    return this[ALLOW_STALE];
	  }

	  set maxAge(mA) {
	    if (typeof mA !== 'number') throw new TypeError('maxAge must be a non-negative number');
	    this[MAX_AGE] = mA;
	    trim(this);
	  }

	  get maxAge() {
	    return this[MAX_AGE];
	  }

	  set lengthCalculator(lC) {
	    if (typeof lC !== 'function') lC = naiveLength;

	    if (lC !== this[LENGTH_CALCULATOR]) {
	      this[LENGTH_CALCULATOR] = lC;
	      this[LENGTH] = 0;
	      this[LRU_LIST].forEach(hit => {
	        hit.length = this[LENGTH_CALCULATOR](hit.value, hit.key);
	        this[LENGTH] += hit.length;
	      });
	    }

	    trim(this);
	  }

	  get lengthCalculator() {
	    return this[LENGTH_CALCULATOR];
	  }

	  get length() {
	    return this[LENGTH];
	  }

	  get itemCount() {
	    return this[LRU_LIST].length;
	  }

	  rforEach(fn, thisp) {
	    thisp = thisp || this;

	    for (let walker = this[LRU_LIST].tail; walker !== null;) {
	      const prev = walker.prev;
	      forEachStep(this, fn, walker, thisp);
	      walker = prev;
	    }
	  }

	  forEach(fn, thisp) {
	    thisp = thisp || this;

	    for (let walker = this[LRU_LIST].head; walker !== null;) {
	      const next = walker.next;
	      forEachStep(this, fn, walker, thisp);
	      walker = next;
	    }
	  }

	  keys() {
	    return this[LRU_LIST].toArray().map(k => k.key);
	  }

	  values() {
	    return this[LRU_LIST].toArray().map(k => k.value);
	  }

	  reset() {
	    if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
	      this[LRU_LIST].forEach(hit => this[DISPOSE](hit.key, hit.value));
	    }

	    this[CACHE] = new Map();
	    this[LRU_LIST] = new yallist();
	    this[LENGTH] = 0;
	  }

	  dump() {
	    return this[LRU_LIST].map(hit => isStale(this, hit) ? false : {
	      k: hit.key,
	      v: hit.value,
	      e: hit.now + (hit.maxAge || 0)
	    }).toArray().filter(h => h);
	  }

	  dumpLru() {
	    return this[LRU_LIST];
	  }

	  set(key, value, maxAge) {
	    maxAge = maxAge || this[MAX_AGE];
	    if (maxAge && typeof maxAge !== 'number') throw new TypeError('maxAge must be a number');
	    const now = maxAge ? Date.now() : 0;
	    const len = this[LENGTH_CALCULATOR](value, key);

	    if (this[CACHE].has(key)) {
	      if (len > this[MAX]) {
	        del(this, this[CACHE].get(key));
	        return false;
	      }

	      const node = this[CACHE].get(key);
	      const item = node.value;

	      if (this[DISPOSE]) {
	        if (!this[NO_DISPOSE_ON_SET]) this[DISPOSE](key, item.value);
	      }

	      item.now = now;
	      item.maxAge = maxAge;
	      item.value = value;
	      this[LENGTH] += len - item.length;
	      item.length = len;
	      this.get(key);
	      trim(this);
	      return true;
	    }

	    const hit = new Entry(key, value, len, now, maxAge);

	    if (hit.length > this[MAX]) {
	      if (this[DISPOSE]) this[DISPOSE](key, value);
	      return false;
	    }

	    this[LENGTH] += hit.length;
	    this[LRU_LIST].unshift(hit);
	    this[CACHE].set(key, this[LRU_LIST].head);
	    trim(this);
	    return true;
	  }

	  has(key) {
	    if (!this[CACHE].has(key)) return false;
	    const hit = this[CACHE].get(key).value;
	    return !isStale(this, hit);
	  }

	  get(key) {
	    return get(this, key, true);
	  }

	  peek(key) {
	    return get(this, key, false);
	  }

	  pop() {
	    const node = this[LRU_LIST].tail;
	    if (!node) return null;
	    del(this, node);
	    return node.value;
	  }

	  del(key) {
	    del(this, this[CACHE].get(key));
	  }

	  load(arr) {
	    this.reset();
	    const now = Date.now();

	    for (let l = arr.length - 1; l >= 0; l--) {
	      const hit = arr[l];
	      const expiresAt = hit.e || 0;
	      if (expiresAt === 0) this.set(hit.k, hit.v);else {
	        const maxAge = expiresAt - now;

	        if (maxAge > 0) {
	          this.set(hit.k, hit.v, maxAge);
	        }
	      }
	    }
	  }

	  prune() {
	    this[CACHE].forEach((value, key) => get(this, key, false));
	  }

	}

	const get = (self, key, doUse) => {
	  const node = self[CACHE].get(key);

	  if (node) {
	    const hit = node.value;

	    if (isStale(self, hit)) {
	      del(self, node);
	      if (!self[ALLOW_STALE]) return undefined;
	    } else {
	      if (doUse) {
	        if (self[UPDATE_AGE_ON_GET]) node.value.now = Date.now();
	        self[LRU_LIST].unshiftNode(node);
	      }
	    }

	    return hit.value;
	  }
	};

	const isStale = (self, hit) => {
	  if (!hit || !hit.maxAge && !self[MAX_AGE]) return false;
	  const diff = Date.now() - hit.now;
	  return hit.maxAge ? diff > hit.maxAge : self[MAX_AGE] && diff > self[MAX_AGE];
	};

	const trim = self => {
	  if (self[LENGTH] > self[MAX]) {
	    for (let walker = self[LRU_LIST].tail; self[LENGTH] > self[MAX] && walker !== null;) {
	      const prev = walker.prev;
	      del(self, walker);
	      walker = prev;
	    }
	  }
	};

	const del = (self, node) => {
	  if (node) {
	    const hit = node.value;
	    if (self[DISPOSE]) self[DISPOSE](hit.key, hit.value);
	    self[LENGTH] -= hit.length;
	    self[CACHE].delete(hit.key);
	    self[LRU_LIST].removeNode(node);
	  }
	};

	class Entry {
	  constructor(key, value, length, now, maxAge) {
	    this.key = key;
	    this.value = value;
	    this.length = length;
	    this.now = now;
	    this.maxAge = maxAge || 0;
	  }

	}

	const forEachStep = (self, fn, node, thisp) => {
	  let hit = node.value;

	  if (isStale(self, hit)) {
	    del(self, node);
	    if (!self[ALLOW_STALE]) hit = undefined;
	  }

	  if (hit) fn.call(thisp, hit.value, hit.key, self);
	};

	var lruCache = LRUCache;

	class Range {
	  constructor(range, options) {
	    options = parseOptions_1(options);

	    if (range instanceof Range) {
	      if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
	        return range;
	      } else {
	        return new Range(range.raw, options);
	      }
	    }

	    if (range instanceof comparator) {
	      this.raw = range.value;
	      this.set = [[range]];
	      this.format();
	      return this;
	    }

	    this.options = options;
	    this.loose = !!options.loose;
	    this.includePrerelease = !!options.includePrerelease;
	    this.raw = range;
	    this.set = range.split(/\s*\|\|\s*/).map(range => this.parseRange(range.trim())).filter(c => c.length);

	    if (!this.set.length) {
	      throw new TypeError(`Invalid SemVer Range: ${range}`);
	    }

	    if (this.set.length > 1) {
	      const first = this.set[0];
	      this.set = this.set.filter(c => !isNullSet(c[0]));
	      if (this.set.length === 0) this.set = [first];else if (this.set.length > 1) {
	        for (const c of this.set) {
	          if (c.length === 1 && isAny(c[0])) {
	            this.set = [c];
	            break;
	          }
	        }
	      }
	    }

	    this.format();
	  }

	  format() {
	    this.range = this.set.map(comps => {
	      return comps.join(' ').trim();
	    }).join('||').trim();
	    return this.range;
	  }

	  toString() {
	    return this.range;
	  }

	  parseRange(range) {
	    range = range.trim();
	    const memoOpts = Object.keys(this.options).join(',');
	    const memoKey = `parseRange:${memoOpts}:${range}`;
	    const cached = cache$1.get(memoKey);
	    if (cached) return cached;
	    const loose = this.options.loose;
	    const hr = loose ? re$1[t$1.HYPHENRANGELOOSE] : re$1[t$1.HYPHENRANGE];
	    range = range.replace(hr, hyphenReplace(this.options.includePrerelease));
	    debug_1('hyphen replace', range);
	    range = range.replace(re$1[t$1.COMPARATORTRIM], comparatorTrimReplace);
	    debug_1('comparator trim', range, re$1[t$1.COMPARATORTRIM]);
	    range = range.replace(re$1[t$1.TILDETRIM], tildeTrimReplace);
	    range = range.replace(re$1[t$1.CARETTRIM], caretTrimReplace);
	    range = range.split(/\s+/).join(' ');
	    const compRe = loose ? re$1[t$1.COMPARATORLOOSE] : re$1[t$1.COMPARATOR];
	    const rangeList = range.split(' ').map(comp => parseComparator(comp, this.options)).join(' ').split(/\s+/).map(comp => replaceGTE0(comp, this.options)).filter(this.options.loose ? comp => !!comp.match(compRe) : () => true).map(comp => new comparator(comp, this.options));
	    rangeList.length;
	    const rangeMap = new Map();

	    for (const comp of rangeList) {
	      if (isNullSet(comp)) return [comp];
	      rangeMap.set(comp.value, comp);
	    }

	    if (rangeMap.size > 1 && rangeMap.has('')) rangeMap.delete('');
	    const result = [...rangeMap.values()];
	    cache$1.set(memoKey, result);
	    return result;
	  }

	  intersects(range, options) {
	    if (!(range instanceof Range)) {
	      throw new TypeError('a Range is required');
	    }

	    return this.set.some(thisComparators => {
	      return isSatisfiable(thisComparators, options) && range.set.some(rangeComparators => {
	        return isSatisfiable(rangeComparators, options) && thisComparators.every(thisComparator => {
	          return rangeComparators.every(rangeComparator => {
	            return thisComparator.intersects(rangeComparator, options);
	          });
	        });
	      });
	    });
	  }

	  test(version) {
	    if (!version) {
	      return false;
	    }

	    if (typeof version === 'string') {
	      try {
	        version = new semver$3(version, this.options);
	      } catch (er) {
	        return false;
	      }
	    }

	    for (let i = 0; i < this.set.length; i++) {
	      if (testSet(this.set[i], version, this.options)) {
	        return true;
	      }
	    }

	    return false;
	  }

	}

	var range = Range;
	const cache$1 = new lruCache({
	  max: 1000
	});
	const {
	  re: re$1,
	  t: t$1,
	  comparatorTrimReplace,
	  tildeTrimReplace,
	  caretTrimReplace
	} = re_1;

	const isNullSet = c => c.value === '<0.0.0-0';

	const isAny = c => c.value === '';

	const isSatisfiable = (comparators, options) => {
	  let result = true;
	  const remainingComparators = comparators.slice();
	  let testComparator = remainingComparators.pop();

	  while (result && remainingComparators.length) {
	    result = remainingComparators.every(otherComparator => {
	      return testComparator.intersects(otherComparator, options);
	    });
	    testComparator = remainingComparators.pop();
	  }

	  return result;
	};

	const parseComparator = (comp, options) => {
	  debug_1('comp', comp, options);
	  comp = replaceCarets(comp, options);
	  debug_1('caret', comp);
	  comp = replaceTildes(comp, options);
	  debug_1('tildes', comp);
	  comp = replaceXRanges(comp, options);
	  debug_1('xrange', comp);
	  comp = replaceStars(comp, options);
	  debug_1('stars', comp);
	  return comp;
	};

	const isX = id => !id || id.toLowerCase() === 'x' || id === '*';

	const replaceTildes = (comp, options) => comp.trim().split(/\s+/).map(comp => {
	  return replaceTilde(comp, options);
	}).join(' ');

	const replaceTilde = (comp, options) => {
	  const r = options.loose ? re$1[t$1.TILDELOOSE] : re$1[t$1.TILDE];
	  return comp.replace(r, (_, M, m, p, pr) => {
	    debug_1('tilde', comp, _, M, m, p, pr);
	    let ret;

	    if (isX(M)) {
	      ret = '';
	    } else if (isX(m)) {
	      ret = `>=${M}.0.0 <${+M + 1}.0.0-0`;
	    } else if (isX(p)) {
	      ret = `>=${M}.${m}.0 <${M}.${+m + 1}.0-0`;
	    } else if (pr) {
	      debug_1('replaceTilde pr', pr);
	      ret = `>=${M}.${m}.${p}-${pr} <${M}.${+m + 1}.0-0`;
	    } else {
	      ret = `>=${M}.${m}.${p} <${M}.${+m + 1}.0-0`;
	    }

	    debug_1('tilde return', ret);
	    return ret;
	  });
	};

	const replaceCarets = (comp, options) => comp.trim().split(/\s+/).map(comp => {
	  return replaceCaret(comp, options);
	}).join(' ');

	const replaceCaret = (comp, options) => {
	  debug_1('caret', comp, options);
	  const r = options.loose ? re$1[t$1.CARETLOOSE] : re$1[t$1.CARET];
	  const z = options.includePrerelease ? '-0' : '';
	  return comp.replace(r, (_, M, m, p, pr) => {
	    debug_1('caret', comp, _, M, m, p, pr);
	    let ret;

	    if (isX(M)) {
	      ret = '';
	    } else if (isX(m)) {
	      ret = `>=${M}.0.0${z} <${+M + 1}.0.0-0`;
	    } else if (isX(p)) {
	      if (M === '0') {
	        ret = `>=${M}.${m}.0${z} <${M}.${+m + 1}.0-0`;
	      } else {
	        ret = `>=${M}.${m}.0${z} <${+M + 1}.0.0-0`;
	      }
	    } else if (pr) {
	      debug_1('replaceCaret pr', pr);

	      if (M === '0') {
	        if (m === '0') {
	          ret = `>=${M}.${m}.${p}-${pr} <${M}.${m}.${+p + 1}-0`;
	        } else {
	          ret = `>=${M}.${m}.${p}-${pr} <${M}.${+m + 1}.0-0`;
	        }
	      } else {
	        ret = `>=${M}.${m}.${p}-${pr} <${+M + 1}.0.0-0`;
	      }
	    } else {
	      debug_1('no pr');

	      if (M === '0') {
	        if (m === '0') {
	          ret = `>=${M}.${m}.${p}${z} <${M}.${m}.${+p + 1}-0`;
	        } else {
	          ret = `>=${M}.${m}.${p}${z} <${M}.${+m + 1}.0-0`;
	        }
	      } else {
	        ret = `>=${M}.${m}.${p} <${+M + 1}.0.0-0`;
	      }
	    }

	    debug_1('caret return', ret);
	    return ret;
	  });
	};

	const replaceXRanges = (comp, options) => {
	  debug_1('replaceXRanges', comp, options);
	  return comp.split(/\s+/).map(comp => {
	    return replaceXRange(comp, options);
	  }).join(' ');
	};

	const replaceXRange = (comp, options) => {
	  comp = comp.trim();
	  const r = options.loose ? re$1[t$1.XRANGELOOSE] : re$1[t$1.XRANGE];
	  return comp.replace(r, (ret, gtlt, M, m, p, pr) => {
	    debug_1('xRange', comp, ret, gtlt, M, m, p, pr);
	    const xM = isX(M);
	    const xm = xM || isX(m);
	    const xp = xm || isX(p);
	    const anyX = xp;

	    if (gtlt === '=' && anyX) {
	      gtlt = '';
	    }

	    pr = options.includePrerelease ? '-0' : '';

	    if (xM) {
	      if (gtlt === '>' || gtlt === '<') {
	        ret = '<0.0.0-0';
	      } else {
	        ret = '*';
	      }
	    } else if (gtlt && anyX) {
	      if (xm) {
	        m = 0;
	      }

	      p = 0;

	      if (gtlt === '>') {
	        gtlt = '>=';

	        if (xm) {
	          M = +M + 1;
	          m = 0;
	          p = 0;
	        } else {
	          m = +m + 1;
	          p = 0;
	        }
	      } else if (gtlt === '<=') {
	        gtlt = '<';

	        if (xm) {
	          M = +M + 1;
	        } else {
	          m = +m + 1;
	        }
	      }

	      if (gtlt === '<') pr = '-0';
	      ret = `${gtlt + M}.${m}.${p}${pr}`;
	    } else if (xm) {
	      ret = `>=${M}.0.0${pr} <${+M + 1}.0.0-0`;
	    } else if (xp) {
	      ret = `>=${M}.${m}.0${pr} <${M}.${+m + 1}.0-0`;
	    }

	    debug_1('xRange return', ret);
	    return ret;
	  });
	};

	const replaceStars = (comp, options) => {
	  debug_1('replaceStars', comp, options);
	  return comp.trim().replace(re$1[t$1.STAR], '');
	};

	const replaceGTE0 = (comp, options) => {
	  debug_1('replaceGTE0', comp, options);
	  return comp.trim().replace(re$1[options.includePrerelease ? t$1.GTE0PRE : t$1.GTE0], '');
	};

	const hyphenReplace = incPr => ($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) => {
	  if (isX(fM)) {
	    from = '';
	  } else if (isX(fm)) {
	    from = `>=${fM}.0.0${incPr ? '-0' : ''}`;
	  } else if (isX(fp)) {
	    from = `>=${fM}.${fm}.0${incPr ? '-0' : ''}`;
	  } else if (fpr) {
	    from = `>=${from}`;
	  } else {
	    from = `>=${from}${incPr ? '-0' : ''}`;
	  }

	  if (isX(tM)) {
	    to = '';
	  } else if (isX(tm)) {
	    to = `<${+tM + 1}.0.0-0`;
	  } else if (isX(tp)) {
	    to = `<${tM}.${+tm + 1}.0-0`;
	  } else if (tpr) {
	    to = `<=${tM}.${tm}.${tp}-${tpr}`;
	  } else if (incPr) {
	    to = `<${tM}.${tm}.${+tp + 1}-0`;
	  } else {
	    to = `<=${to}`;
	  }

	  return `${from} ${to}`.trim();
	};

	const testSet = (set, version, options) => {
	  for (let i = 0; i < set.length; i++) {
	    if (!set[i].test(version)) {
	      return false;
	    }
	  }

	  if (version.prerelease.length && !options.includePrerelease) {
	    for (let i = 0; i < set.length; i++) {
	      debug_1(set[i].semver);

	      if (set[i].semver === comparator.ANY) {
	        continue;
	      }

	      if (set[i].semver.prerelease.length > 0) {
	        const allowed = set[i].semver;

	        if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
	          return true;
	        }
	      }
	    }

	    return false;
	  }

	  return true;
	};

	const ANY$2 = Symbol('SemVer ANY');

	class Comparator {
	  static get ANY() {
	    return ANY$2;
	  }

	  constructor(comp, options) {
	    options = parseOptions_1(options);

	    if (comp instanceof Comparator) {
	      if (comp.loose === !!options.loose) {
	        return comp;
	      } else {
	        comp = comp.value;
	      }
	    }

	    debug_1('comparator', comp, options);
	    this.options = options;
	    this.loose = !!options.loose;
	    this.parse(comp);

	    if (this.semver === ANY$2) {
	      this.value = '';
	    } else {
	      this.value = this.operator + this.semver.version;
	    }

	    debug_1('comp', this);
	  }

	  parse(comp) {
	    const r = this.options.loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
	    const m = comp.match(r);

	    if (!m) {
	      throw new TypeError(`Invalid comparator: ${comp}`);
	    }

	    this.operator = m[1] !== undefined ? m[1] : '';

	    if (this.operator === '=') {
	      this.operator = '';
	    }

	    if (!m[2]) {
	      this.semver = ANY$2;
	    } else {
	      this.semver = new semver$3(m[2], this.options.loose);
	    }
	  }

	  toString() {
	    return this.value;
	  }

	  test(version) {
	    debug_1('Comparator.test', version, this.options.loose);

	    if (this.semver === ANY$2 || version === ANY$2) {
	      return true;
	    }

	    if (typeof version === 'string') {
	      try {
	        version = new semver$3(version, this.options);
	      } catch (er) {
	        return false;
	      }
	    }

	    return cmp_1(version, this.operator, this.semver, this.options);
	  }

	  intersects(comp, options) {
	    if (!(comp instanceof Comparator)) {
	      throw new TypeError('a Comparator is required');
	    }

	    if (!options || typeof options !== 'object') {
	      options = {
	        loose: !!options,
	        includePrerelease: false
	      };
	    }

	    if (this.operator === '') {
	      if (this.value === '') {
	        return true;
	      }

	      return new range(comp.value, options).test(this.value);
	    } else if (comp.operator === '') {
	      if (comp.value === '') {
	        return true;
	      }

	      return new range(this.value, options).test(comp.semver);
	    }

	    const sameDirectionIncreasing = (this.operator === '>=' || this.operator === '>') && (comp.operator === '>=' || comp.operator === '>');
	    const sameDirectionDecreasing = (this.operator === '<=' || this.operator === '<') && (comp.operator === '<=' || comp.operator === '<');
	    const sameSemVer = this.semver.version === comp.semver.version;
	    const differentDirectionsInclusive = (this.operator === '>=' || this.operator === '<=') && (comp.operator === '>=' || comp.operator === '<=');
	    const oppositeDirectionsLessThan = cmp_1(this.semver, '<', comp.semver, options) && (this.operator === '>=' || this.operator === '>') && (comp.operator === '<=' || comp.operator === '<');
	    const oppositeDirectionsGreaterThan = cmp_1(this.semver, '>', comp.semver, options) && (this.operator === '<=' || this.operator === '<') && (comp.operator === '>=' || comp.operator === '>');
	    return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
	  }

	}

	var comparator = Comparator;
	const {
	  re,
	  t
	} = re_1;

	const satisfies = (version, range$1, options) => {
	  try {
	    range$1 = new range(range$1, options);
	  } catch (er) {
	    return false;
	  }

	  return range$1.test(version);
	};

	var satisfies_1 = satisfies;

	const toComparators = (range$1, options) => new range(range$1, options).set.map(comp => comp.map(c => c.value).join(' ').trim().split(' '));

	var toComparators_1 = toComparators;

	const maxSatisfying = (versions, range$1, options) => {
	  let max = null;
	  let maxSV = null;
	  let rangeObj = null;

	  try {
	    rangeObj = new range(range$1, options);
	  } catch (er) {
	    return null;
	  }

	  versions.forEach(v => {
	    if (rangeObj.test(v)) {
	      if (!max || maxSV.compare(v) === -1) {
	        max = v;
	        maxSV = new semver$3(max, options);
	      }
	    }
	  });
	  return max;
	};

	var maxSatisfying_1 = maxSatisfying;

	const minSatisfying = (versions, range$1, options) => {
	  let min = null;
	  let minSV = null;
	  let rangeObj = null;

	  try {
	    rangeObj = new range(range$1, options);
	  } catch (er) {
	    return null;
	  }

	  versions.forEach(v => {
	    if (rangeObj.test(v)) {
	      if (!min || minSV.compare(v) === 1) {
	        min = v;
	        minSV = new semver$3(min, options);
	      }
	    }
	  });
	  return min;
	};

	var minSatisfying_1 = minSatisfying;

	const minVersion = (range$1, loose) => {
	  range$1 = new range(range$1, loose);
	  let minver = new semver$3('0.0.0');

	  if (range$1.test(minver)) {
	    return minver;
	  }

	  minver = new semver$3('0.0.0-0');

	  if (range$1.test(minver)) {
	    return minver;
	  }

	  minver = null;

	  for (let i = 0; i < range$1.set.length; ++i) {
	    const comparators = range$1.set[i];
	    let setMin = null;
	    comparators.forEach(comparator => {
	      const compver = new semver$3(comparator.semver.version);

	      switch (comparator.operator) {
	        case '>':
	          if (compver.prerelease.length === 0) {
	            compver.patch++;
	          } else {
	            compver.prerelease.push(0);
	          }

	          compver.raw = compver.format();

	        case '':
	        case '>=':
	          if (!setMin || gt_1(compver, setMin)) {
	            setMin = compver;
	          }

	          break;

	        case '<':
	        case '<=':
	          break;

	        default:
	          throw new Error(`Unexpected operation: ${comparator.operator}`);
	      }
	    });
	    if (setMin && (!minver || gt_1(minver, setMin))) minver = setMin;
	  }

	  if (minver && range$1.test(minver)) {
	    return minver;
	  }

	  return null;
	};

	var minVersion_1 = minVersion;

	const validRange = (range$1, options) => {
	  try {
	    return new range(range$1, options).range || '*';
	  } catch (er) {
	    return null;
	  }
	};

	var valid = validRange;

	const {
	  ANY: ANY$1
	} = comparator;

	const outside = (version, range$1, hilo, options) => {
	  version = new semver$3(version, options);
	  range$1 = new range(range$1, options);
	  let gtfn, ltefn, ltfn, comp, ecomp;

	  switch (hilo) {
	    case '>':
	      gtfn = gt_1;
	      ltefn = lte_1;
	      ltfn = lt_1;
	      comp = '>';
	      ecomp = '>=';
	      break;

	    case '<':
	      gtfn = lt_1;
	      ltefn = gte_1;
	      ltfn = gt_1;
	      comp = '<';
	      ecomp = '<=';
	      break;

	    default:
	      throw new TypeError('Must provide a hilo val of "<" or ">"');
	  }

	  if (satisfies_1(version, range$1, options)) {
	    return false;
	  }

	  for (let i = 0; i < range$1.set.length; ++i) {
	    const comparators = range$1.set[i];
	    let high = null;
	    let low = null;
	    comparators.forEach(comparator$1 => {
	      if (comparator$1.semver === ANY$1) {
	        comparator$1 = new comparator('>=0.0.0');
	      }

	      high = high || comparator$1;
	      low = low || comparator$1;

	      if (gtfn(comparator$1.semver, high.semver, options)) {
	        high = comparator$1;
	      } else if (ltfn(comparator$1.semver, low.semver, options)) {
	        low = comparator$1;
	      }
	    });

	    if (high.operator === comp || high.operator === ecomp) {
	      return false;
	    }

	    if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
	      return false;
	    } else if (low.operator === ecomp && ltfn(version, low.semver)) {
	      return false;
	    }
	  }

	  return true;
	};

	var outside_1 = outside;

	const gtr = (version, range, options) => outside_1(version, range, '>', options);

	var gtr_1 = gtr;

	const ltr = (version, range, options) => outside_1(version, range, '<', options);

	var ltr_1 = ltr;

	const intersects = (r1, r2, options) => {
	  r1 = new range(r1, options);
	  r2 = new range(r2, options);
	  return r1.intersects(r2);
	};

	var intersects_1 = intersects;

	var simplify = (versions, range, options) => {
	  const set = [];
	  let min = null;
	  let prev = null;
	  const v = versions.sort((a, b) => compare_1(a, b, options));

	  for (const version of v) {
	    const included = satisfies_1(version, range, options);

	    if (included) {
	      prev = version;
	      if (!min) min = version;
	    } else {
	      if (prev) {
	        set.push([min, prev]);
	      }

	      prev = null;
	      min = null;
	    }
	  }

	  if (min) set.push([min, null]);
	  const ranges = [];

	  for (const [min, max] of set) {
	    if (min === max) ranges.push(min);else if (!max && min === v[0]) ranges.push('*');else if (!max) ranges.push(`>=${min}`);else if (min === v[0]) ranges.push(`<=${max}`);else ranges.push(`${min} - ${max}`);
	  }

	  const simplified = ranges.join(' || ');
	  const original = typeof range.raw === 'string' ? range.raw : String(range);
	  return simplified.length < original.length ? simplified : range;
	};

	const {
	  ANY
	} = comparator;

	const subset = (sub, dom, options) => {
	  if (sub === dom) return true;
	  sub = new range(sub, options);
	  dom = new range(dom, options);
	  let sawNonNull = false;

	  OUTER: for (const simpleSub of sub.set) {
	    for (const simpleDom of dom.set) {
	      const isSub = simpleSubset(simpleSub, simpleDom, options);
	      sawNonNull = sawNonNull || isSub !== null;
	      if (isSub) continue OUTER;
	    }

	    if (sawNonNull) return false;
	  }

	  return true;
	};

	const simpleSubset = (sub, dom, options) => {
	  if (sub === dom) return true;
	  if (sub.length === 1 && sub[0].semver === ANY) return dom.length === 1 && dom[0].semver === ANY;
	  const eqSet = new Set();
	  let gt, lt;

	  for (const c of sub) {
	    if (c.operator === '>' || c.operator === '>=') gt = higherGT(gt, c, options);else if (c.operator === '<' || c.operator === '<=') lt = lowerLT(lt, c, options);else eqSet.add(c.semver);
	  }

	  if (eqSet.size > 1) return null;
	  let gtltComp;

	  if (gt && lt) {
	    gtltComp = compare_1(gt.semver, lt.semver, options);
	    if (gtltComp > 0) return null;else if (gtltComp === 0 && (gt.operator !== '>=' || lt.operator !== '<=')) return null;
	  }

	  for (const eq of eqSet) {
	    if (gt && !satisfies_1(eq, String(gt), options)) return null;
	    if (lt && !satisfies_1(eq, String(lt), options)) return null;

	    for (const c of dom) {
	      if (!satisfies_1(eq, String(c), options)) return false;
	    }

	    return true;
	  }

	  let higher, lower;
	  let hasDomLT, hasDomGT;

	  for (const c of dom) {
	    hasDomGT = hasDomGT || c.operator === '>' || c.operator === '>=';
	    hasDomLT = hasDomLT || c.operator === '<' || c.operator === '<=';

	    if (gt) {
	      if (c.operator === '>' || c.operator === '>=') {
	        higher = higherGT(gt, c, options);
	        if (higher === c && higher !== gt) return false;
	      } else if (gt.operator === '>=' && !satisfies_1(gt.semver, String(c), options)) return false;
	    }

	    if (lt) {
	      if (c.operator === '<' || c.operator === '<=') {
	        lower = lowerLT(lt, c, options);
	        if (lower === c && lower !== lt) return false;
	      } else if (lt.operator === '<=' && !satisfies_1(lt.semver, String(c), options)) return false;
	    }

	    if (!c.operator && (lt || gt) && gtltComp !== 0) return false;
	  }

	  if (gt && hasDomLT && !lt && gtltComp !== 0) return false;
	  if (lt && hasDomGT && !gt && gtltComp !== 0) return false;
	  return true;
	};

	const higherGT = (a, b, options) => {
	  if (!a) return b;
	  const comp = compare_1(a.semver, b.semver, options);
	  return comp > 0 ? a : comp < 0 ? b : b.operator === '>' && a.operator === '>=' ? b : a;
	};

	const lowerLT = (a, b, options) => {
	  if (!a) return b;
	  const comp = compare_1(a.semver, b.semver, options);
	  return comp < 0 ? a : comp > 0 ? b : b.operator === '<' && a.operator === '<=' ? b : a;
	};

	var subset_1 = subset;

	var semverBABEL_8_BREAKINGTrue = {
	  re: re_1.re,
	  src: re_1.src,
	  tokens: re_1.t,
	  SEMVER_SPEC_VERSION: constants.SEMVER_SPEC_VERSION,
	  SemVer: semver$3,
	  compareIdentifiers: identifiers.compareIdentifiers,
	  rcompareIdentifiers: identifiers.rcompareIdentifiers,
	  parse: parse_1,
	  valid: valid_1,
	  clean: clean_1,
	  inc: inc_1,
	  diff: diff_1,
	  major: major_1,
	  minor: minor_1,
	  patch: patch_1,
	  prerelease: prerelease_1,
	  compare: compare_1,
	  rcompare: rcompare_1,
	  compareLoose: compareLoose_1,
	  compareBuild: compareBuild_1,
	  sort: sort_1,
	  rsort: rsort_1,
	  gt: gt_1,
	  lt: lt_1,
	  eq: eq_1,
	  neq: neq_1,
	  gte: gte_1,
	  lte: lte_1,
	  cmp: cmp_1,
	  coerce: coerce_1,
	  Comparator: comparator,
	  Range: range,
	  satisfies: satisfies_1,
	  toComparators: toComparators_1,
	  maxSatisfying: maxSatisfying_1,
	  minSatisfying: minSatisfying_1,
	  minVersion: minVersion_1,
	  validRange: valid,
	  outside: outside_1,
	  gtr: gtr_1,
	  ltr: ltr_1,
	  intersects: intersects_1,
	  simplifyRange: simplify,
	  subset: subset_1
	};

	var semver$2 = createCommonjsModule(function (module, exports) {
	  exports = module.exports = SemVer;
	  var debug;

	  if (typeof browser$5 === 'object' && browser$5.env && browser$5.env.NODE_DEBUG && /\bsemver\b/i.test(browser$5.env.NODE_DEBUG)) {
	    debug = function () {
	      var args = Array.prototype.slice.call(arguments, 0);
	      args.unshift('SEMVER');
	      console.log.apply(console, args);
	    };
	  } else {
	    debug = function () {};
	  }

	  exports.SEMVER_SPEC_VERSION = '2.0.0';
	  var MAX_LENGTH = 256;
	  var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
	  var MAX_SAFE_COMPONENT_LENGTH = 16;
	  var re = exports.re = [];
	  var src = exports.src = [];
	  var t = exports.tokens = {};
	  var R = 0;

	  function tok(n) {
	    t[n] = R++;
	  }

	  tok('NUMERICIDENTIFIER');
	  src[t.NUMERICIDENTIFIER] = '0|[1-9]\\d*';
	  tok('NUMERICIDENTIFIERLOOSE');
	  src[t.NUMERICIDENTIFIERLOOSE] = '[0-9]+';
	  tok('NONNUMERICIDENTIFIER');
	  src[t.NONNUMERICIDENTIFIER] = '\\d*[a-zA-Z-][a-zA-Z0-9-]*';
	  tok('MAINVERSION');
	  src[t.MAINVERSION] = '(' + src[t.NUMERICIDENTIFIER] + ')\\.' + '(' + src[t.NUMERICIDENTIFIER] + ')\\.' + '(' + src[t.NUMERICIDENTIFIER] + ')';
	  tok('MAINVERSIONLOOSE');
	  src[t.MAINVERSIONLOOSE] = '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' + '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' + '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')';
	  tok('PRERELEASEIDENTIFIER');
	  src[t.PRERELEASEIDENTIFIER] = '(?:' + src[t.NUMERICIDENTIFIER] + '|' + src[t.NONNUMERICIDENTIFIER] + ')';
	  tok('PRERELEASEIDENTIFIERLOOSE');
	  src[t.PRERELEASEIDENTIFIERLOOSE] = '(?:' + src[t.NUMERICIDENTIFIERLOOSE] + '|' + src[t.NONNUMERICIDENTIFIER] + ')';
	  tok('PRERELEASE');
	  src[t.PRERELEASE] = '(?:-(' + src[t.PRERELEASEIDENTIFIER] + '(?:\\.' + src[t.PRERELEASEIDENTIFIER] + ')*))';
	  tok('PRERELEASELOOSE');
	  src[t.PRERELEASELOOSE] = '(?:-?(' + src[t.PRERELEASEIDENTIFIERLOOSE] + '(?:\\.' + src[t.PRERELEASEIDENTIFIERLOOSE] + ')*))';
	  tok('BUILDIDENTIFIER');
	  src[t.BUILDIDENTIFIER] = '[0-9A-Za-z-]+';
	  tok('BUILD');
	  src[t.BUILD] = '(?:\\+(' + src[t.BUILDIDENTIFIER] + '(?:\\.' + src[t.BUILDIDENTIFIER] + ')*))';
	  tok('FULL');
	  tok('FULLPLAIN');
	  src[t.FULLPLAIN] = 'v?' + src[t.MAINVERSION] + src[t.PRERELEASE] + '?' + src[t.BUILD] + '?';
	  src[t.FULL] = '^' + src[t.FULLPLAIN] + '$';
	  tok('LOOSEPLAIN');
	  src[t.LOOSEPLAIN] = '[v=\\s]*' + src[t.MAINVERSIONLOOSE] + src[t.PRERELEASELOOSE] + '?' + src[t.BUILD] + '?';
	  tok('LOOSE');
	  src[t.LOOSE] = '^' + src[t.LOOSEPLAIN] + '$';
	  tok('GTLT');
	  src[t.GTLT] = '((?:<|>)?=?)';
	  tok('XRANGEIDENTIFIERLOOSE');
	  src[t.XRANGEIDENTIFIERLOOSE] = src[t.NUMERICIDENTIFIERLOOSE] + '|x|X|\\*';
	  tok('XRANGEIDENTIFIER');
	  src[t.XRANGEIDENTIFIER] = src[t.NUMERICIDENTIFIER] + '|x|X|\\*';
	  tok('XRANGEPLAIN');
	  src[t.XRANGEPLAIN] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:' + src[t.PRERELEASE] + ')?' + src[t.BUILD] + '?' + ')?)?';
	  tok('XRANGEPLAINLOOSE');
	  src[t.XRANGEPLAINLOOSE] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:' + src[t.PRERELEASELOOSE] + ')?' + src[t.BUILD] + '?' + ')?)?';
	  tok('XRANGE');
	  src[t.XRANGE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAIN] + '$';
	  tok('XRANGELOOSE');
	  src[t.XRANGELOOSE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAINLOOSE] + '$';
	  tok('COERCE');
	  src[t.COERCE] = '(^|[^\\d])' + '(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '})' + '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' + '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' + '(?:$|[^\\d])';
	  tok('COERCERTL');
	  re[t.COERCERTL] = new RegExp(src[t.COERCE], 'g');
	  tok('LONETILDE');
	  src[t.LONETILDE] = '(?:~>?)';
	  tok('TILDETRIM');
	  src[t.TILDETRIM] = '(\\s*)' + src[t.LONETILDE] + '\\s+';
	  re[t.TILDETRIM] = new RegExp(src[t.TILDETRIM], 'g');
	  var tildeTrimReplace = '$1~';
	  tok('TILDE');
	  src[t.TILDE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAIN] + '$';
	  tok('TILDELOOSE');
	  src[t.TILDELOOSE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAINLOOSE] + '$';
	  tok('LONECARET');
	  src[t.LONECARET] = '(?:\\^)';
	  tok('CARETTRIM');
	  src[t.CARETTRIM] = '(\\s*)' + src[t.LONECARET] + '\\s+';
	  re[t.CARETTRIM] = new RegExp(src[t.CARETTRIM], 'g');
	  var caretTrimReplace = '$1^';
	  tok('CARET');
	  src[t.CARET] = '^' + src[t.LONECARET] + src[t.XRANGEPLAIN] + '$';
	  tok('CARETLOOSE');
	  src[t.CARETLOOSE] = '^' + src[t.LONECARET] + src[t.XRANGEPLAINLOOSE] + '$';
	  tok('COMPARATORLOOSE');
	  src[t.COMPARATORLOOSE] = '^' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + ')$|^$';
	  tok('COMPARATOR');
	  src[t.COMPARATOR] = '^' + src[t.GTLT] + '\\s*(' + src[t.FULLPLAIN] + ')$|^$';
	  tok('COMPARATORTRIM');
	  src[t.COMPARATORTRIM] = '(\\s*)' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + '|' + src[t.XRANGEPLAIN] + ')';
	  re[t.COMPARATORTRIM] = new RegExp(src[t.COMPARATORTRIM], 'g');
	  var comparatorTrimReplace = '$1$2$3';
	  tok('HYPHENRANGE');
	  src[t.HYPHENRANGE] = '^\\s*(' + src[t.XRANGEPLAIN] + ')' + '\\s+-\\s+' + '(' + src[t.XRANGEPLAIN] + ')' + '\\s*$';
	  tok('HYPHENRANGELOOSE');
	  src[t.HYPHENRANGELOOSE] = '^\\s*(' + src[t.XRANGEPLAINLOOSE] + ')' + '\\s+-\\s+' + '(' + src[t.XRANGEPLAINLOOSE] + ')' + '\\s*$';
	  tok('STAR');
	  src[t.STAR] = '(<|>)?=?\\s*\\*';

	  for (var i = 0; i < R; i++) {
	    debug(i, src[i]);

	    if (!re[i]) {
	      re[i] = new RegExp(src[i]);
	    }
	  }

	  exports.parse = parse;

	  function parse(version, options) {
	    if (!options || typeof options !== 'object') {
	      options = {
	        loose: !!options,
	        includePrerelease: false
	      };
	    }

	    if (version instanceof SemVer) {
	      return version;
	    }

	    if (typeof version !== 'string') {
	      return null;
	    }

	    if (version.length > MAX_LENGTH) {
	      return null;
	    }

	    var r = options.loose ? re[t.LOOSE] : re[t.FULL];

	    if (!r.test(version)) {
	      return null;
	    }

	    try {
	      return new SemVer(version, options);
	    } catch (er) {
	      return null;
	    }
	  }

	  exports.valid = valid;

	  function valid(version, options) {
	    var v = parse(version, options);
	    return v ? v.version : null;
	  }

	  exports.clean = clean;

	  function clean(version, options) {
	    var s = parse(version.trim().replace(/^[=v]+/, ''), options);
	    return s ? s.version : null;
	  }

	  exports.SemVer = SemVer;

	  function SemVer(version, options) {
	    if (!options || typeof options !== 'object') {
	      options = {
	        loose: !!options,
	        includePrerelease: false
	      };
	    }

	    if (version instanceof SemVer) {
	      if (version.loose === options.loose) {
	        return version;
	      } else {
	        version = version.version;
	      }
	    } else if (typeof version !== 'string') {
	      throw new TypeError('Invalid Version: ' + version);
	    }

	    if (version.length > MAX_LENGTH) {
	      throw new TypeError('version is longer than ' + MAX_LENGTH + ' characters');
	    }

	    if (!(this instanceof SemVer)) {
	      return new SemVer(version, options);
	    }

	    debug('SemVer', version, options);
	    this.options = options;
	    this.loose = !!options.loose;
	    var m = version.trim().match(options.loose ? re[t.LOOSE] : re[t.FULL]);

	    if (!m) {
	      throw new TypeError('Invalid Version: ' + version);
	    }

	    this.raw = version;
	    this.major = +m[1];
	    this.minor = +m[2];
	    this.patch = +m[3];

	    if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
	      throw new TypeError('Invalid major version');
	    }

	    if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
	      throw new TypeError('Invalid minor version');
	    }

	    if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
	      throw new TypeError('Invalid patch version');
	    }

	    if (!m[4]) {
	      this.prerelease = [];
	    } else {
	      this.prerelease = m[4].split('.').map(function (id) {
	        if (/^[0-9]+$/.test(id)) {
	          var num = +id;

	          if (num >= 0 && num < MAX_SAFE_INTEGER) {
	            return num;
	          }
	        }

	        return id;
	      });
	    }

	    this.build = m[5] ? m[5].split('.') : [];
	    this.format();
	  }

	  SemVer.prototype.format = function () {
	    this.version = this.major + '.' + this.minor + '.' + this.patch;

	    if (this.prerelease.length) {
	      this.version += '-' + this.prerelease.join('.');
	    }

	    return this.version;
	  };

	  SemVer.prototype.toString = function () {
	    return this.version;
	  };

	  SemVer.prototype.compare = function (other) {
	    debug('SemVer.compare', this.version, this.options, other);

	    if (!(other instanceof SemVer)) {
	      other = new SemVer(other, this.options);
	    }

	    return this.compareMain(other) || this.comparePre(other);
	  };

	  SemVer.prototype.compareMain = function (other) {
	    if (!(other instanceof SemVer)) {
	      other = new SemVer(other, this.options);
	    }

	    return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
	  };

	  SemVer.prototype.comparePre = function (other) {
	    if (!(other instanceof SemVer)) {
	      other = new SemVer(other, this.options);
	    }

	    if (this.prerelease.length && !other.prerelease.length) {
	      return -1;
	    } else if (!this.prerelease.length && other.prerelease.length) {
	      return 1;
	    } else if (!this.prerelease.length && !other.prerelease.length) {
	      return 0;
	    }

	    var i = 0;

	    do {
	      var a = this.prerelease[i];
	      var b = other.prerelease[i];
	      debug('prerelease compare', i, a, b);

	      if (a === undefined && b === undefined) {
	        return 0;
	      } else if (b === undefined) {
	        return 1;
	      } else if (a === undefined) {
	        return -1;
	      } else if (a === b) {
	        continue;
	      } else {
	        return compareIdentifiers(a, b);
	      }
	    } while (++i);
	  };

	  SemVer.prototype.compareBuild = function (other) {
	    if (!(other instanceof SemVer)) {
	      other = new SemVer(other, this.options);
	    }

	    var i = 0;

	    do {
	      var a = this.build[i];
	      var b = other.build[i];
	      debug('prerelease compare', i, a, b);

	      if (a === undefined && b === undefined) {
	        return 0;
	      } else if (b === undefined) {
	        return 1;
	      } else if (a === undefined) {
	        return -1;
	      } else if (a === b) {
	        continue;
	      } else {
	        return compareIdentifiers(a, b);
	      }
	    } while (++i);
	  };

	  SemVer.prototype.inc = function (release, identifier) {
	    switch (release) {
	      case 'premajor':
	        this.prerelease.length = 0;
	        this.patch = 0;
	        this.minor = 0;
	        this.major++;
	        this.inc('pre', identifier);
	        break;

	      case 'preminor':
	        this.prerelease.length = 0;
	        this.patch = 0;
	        this.minor++;
	        this.inc('pre', identifier);
	        break;

	      case 'prepatch':
	        this.prerelease.length = 0;
	        this.inc('patch', identifier);
	        this.inc('pre', identifier);
	        break;

	      case 'prerelease':
	        if (this.prerelease.length === 0) {
	          this.inc('patch', identifier);
	        }

	        this.inc('pre', identifier);
	        break;

	      case 'major':
	        if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
	          this.major++;
	        }

	        this.minor = 0;
	        this.patch = 0;
	        this.prerelease = [];
	        break;

	      case 'minor':
	        if (this.patch !== 0 || this.prerelease.length === 0) {
	          this.minor++;
	        }

	        this.patch = 0;
	        this.prerelease = [];
	        break;

	      case 'patch':
	        if (this.prerelease.length === 0) {
	          this.patch++;
	        }

	        this.prerelease = [];
	        break;

	      case 'pre':
	        if (this.prerelease.length === 0) {
	          this.prerelease = [0];
	        } else {
	          var i = this.prerelease.length;

	          while (--i >= 0) {
	            if (typeof this.prerelease[i] === 'number') {
	              this.prerelease[i]++;
	              i = -2;
	            }
	          }

	          if (i === -1) {
	            this.prerelease.push(0);
	          }
	        }

	        if (identifier) {
	          if (this.prerelease[0] === identifier) {
	            if (isNaN(this.prerelease[1])) {
	              this.prerelease = [identifier, 0];
	            }
	          } else {
	            this.prerelease = [identifier, 0];
	          }
	        }

	        break;

	      default:
	        throw new Error('invalid increment argument: ' + release);
	    }

	    this.format();
	    this.raw = this.version;
	    return this;
	  };

	  exports.inc = inc;

	  function inc(version, release, loose, identifier) {
	    if (typeof loose === 'string') {
	      identifier = loose;
	      loose = undefined;
	    }

	    try {
	      return new SemVer(version, loose).inc(release, identifier).version;
	    } catch (er) {
	      return null;
	    }
	  }

	  exports.diff = diff;

	  function diff(version1, version2) {
	    if (eq(version1, version2)) {
	      return null;
	    } else {
	      var v1 = parse(version1);
	      var v2 = parse(version2);
	      var prefix = '';

	      if (v1.prerelease.length || v2.prerelease.length) {
	        prefix = 'pre';
	        var defaultResult = 'prerelease';
	      }

	      for (var key in v1) {
	        if (key === 'major' || key === 'minor' || key === 'patch') {
	          if (v1[key] !== v2[key]) {
	            return prefix + key;
	          }
	        }
	      }

	      return defaultResult;
	    }
	  }

	  exports.compareIdentifiers = compareIdentifiers;
	  var numeric = /^[0-9]+$/;

	  function compareIdentifiers(a, b) {
	    var anum = numeric.test(a);
	    var bnum = numeric.test(b);

	    if (anum && bnum) {
	      a = +a;
	      b = +b;
	    }

	    return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
	  }

	  exports.rcompareIdentifiers = rcompareIdentifiers;

	  function rcompareIdentifiers(a, b) {
	    return compareIdentifiers(b, a);
	  }

	  exports.major = major;

	  function major(a, loose) {
	    return new SemVer(a, loose).major;
	  }

	  exports.minor = minor;

	  function minor(a, loose) {
	    return new SemVer(a, loose).minor;
	  }

	  exports.patch = patch;

	  function patch(a, loose) {
	    return new SemVer(a, loose).patch;
	  }

	  exports.compare = compare;

	  function compare(a, b, loose) {
	    return new SemVer(a, loose).compare(new SemVer(b, loose));
	  }

	  exports.compareLoose = compareLoose;

	  function compareLoose(a, b) {
	    return compare(a, b, true);
	  }

	  exports.compareBuild = compareBuild;

	  function compareBuild(a, b, loose) {
	    var versionA = new SemVer(a, loose);
	    var versionB = new SemVer(b, loose);
	    return versionA.compare(versionB) || versionA.compareBuild(versionB);
	  }

	  exports.rcompare = rcompare;

	  function rcompare(a, b, loose) {
	    return compare(b, a, loose);
	  }

	  exports.sort = sort;

	  function sort(list, loose) {
	    return list.sort(function (a, b) {
	      return exports.compareBuild(a, b, loose);
	    });
	  }

	  exports.rsort = rsort;

	  function rsort(list, loose) {
	    return list.sort(function (a, b) {
	      return exports.compareBuild(b, a, loose);
	    });
	  }

	  exports.gt = gt;

	  function gt(a, b, loose) {
	    return compare(a, b, loose) > 0;
	  }

	  exports.lt = lt;

	  function lt(a, b, loose) {
	    return compare(a, b, loose) < 0;
	  }

	  exports.eq = eq;

	  function eq(a, b, loose) {
	    return compare(a, b, loose) === 0;
	  }

	  exports.neq = neq;

	  function neq(a, b, loose) {
	    return compare(a, b, loose) !== 0;
	  }

	  exports.gte = gte;

	  function gte(a, b, loose) {
	    return compare(a, b, loose) >= 0;
	  }

	  exports.lte = lte;

	  function lte(a, b, loose) {
	    return compare(a, b, loose) <= 0;
	  }

	  exports.cmp = cmp;

	  function cmp(a, op, b, loose) {
	    switch (op) {
	      case '===':
	        if (typeof a === 'object') a = a.version;
	        if (typeof b === 'object') b = b.version;
	        return a === b;

	      case '!==':
	        if (typeof a === 'object') a = a.version;
	        if (typeof b === 'object') b = b.version;
	        return a !== b;

	      case '':
	      case '=':
	      case '==':
	        return eq(a, b, loose);

	      case '!=':
	        return neq(a, b, loose);

	      case '>':
	        return gt(a, b, loose);

	      case '>=':
	        return gte(a, b, loose);

	      case '<':
	        return lt(a, b, loose);

	      case '<=':
	        return lte(a, b, loose);

	      default:
	        throw new TypeError('Invalid operator: ' + op);
	    }
	  }

	  exports.Comparator = Comparator;

	  function Comparator(comp, options) {
	    if (!options || typeof options !== 'object') {
	      options = {
	        loose: !!options,
	        includePrerelease: false
	      };
	    }

	    if (comp instanceof Comparator) {
	      if (comp.loose === !!options.loose) {
	        return comp;
	      } else {
	        comp = comp.value;
	      }
	    }

	    if (!(this instanceof Comparator)) {
	      return new Comparator(comp, options);
	    }

	    debug('comparator', comp, options);
	    this.options = options;
	    this.loose = !!options.loose;
	    this.parse(comp);

	    if (this.semver === ANY) {
	      this.value = '';
	    } else {
	      this.value = this.operator + this.semver.version;
	    }

	    debug('comp', this);
	  }

	  var ANY = {};

	  Comparator.prototype.parse = function (comp) {
	    var r = this.options.loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
	    var m = comp.match(r);

	    if (!m) {
	      throw new TypeError('Invalid comparator: ' + comp);
	    }

	    this.operator = m[1] !== undefined ? m[1] : '';

	    if (this.operator === '=') {
	      this.operator = '';
	    }

	    if (!m[2]) {
	      this.semver = ANY;
	    } else {
	      this.semver = new SemVer(m[2], this.options.loose);
	    }
	  };

	  Comparator.prototype.toString = function () {
	    return this.value;
	  };

	  Comparator.prototype.test = function (version) {
	    debug('Comparator.test', version, this.options.loose);

	    if (this.semver === ANY || version === ANY) {
	      return true;
	    }

	    if (typeof version === 'string') {
	      try {
	        version = new SemVer(version, this.options);
	      } catch (er) {
	        return false;
	      }
	    }

	    return cmp(version, this.operator, this.semver, this.options);
	  };

	  Comparator.prototype.intersects = function (comp, options) {
	    if (!(comp instanceof Comparator)) {
	      throw new TypeError('a Comparator is required');
	    }

	    if (!options || typeof options !== 'object') {
	      options = {
	        loose: !!options,
	        includePrerelease: false
	      };
	    }

	    var rangeTmp;

	    if (this.operator === '') {
	      if (this.value === '') {
	        return true;
	      }

	      rangeTmp = new Range(comp.value, options);
	      return satisfies(this.value, rangeTmp, options);
	    } else if (comp.operator === '') {
	      if (comp.value === '') {
	        return true;
	      }

	      rangeTmp = new Range(this.value, options);
	      return satisfies(comp.semver, rangeTmp, options);
	    }

	    var sameDirectionIncreasing = (this.operator === '>=' || this.operator === '>') && (comp.operator === '>=' || comp.operator === '>');
	    var sameDirectionDecreasing = (this.operator === '<=' || this.operator === '<') && (comp.operator === '<=' || comp.operator === '<');
	    var sameSemVer = this.semver.version === comp.semver.version;
	    var differentDirectionsInclusive = (this.operator === '>=' || this.operator === '<=') && (comp.operator === '>=' || comp.operator === '<=');
	    var oppositeDirectionsLessThan = cmp(this.semver, '<', comp.semver, options) && (this.operator === '>=' || this.operator === '>') && (comp.operator === '<=' || comp.operator === '<');
	    var oppositeDirectionsGreaterThan = cmp(this.semver, '>', comp.semver, options) && (this.operator === '<=' || this.operator === '<') && (comp.operator === '>=' || comp.operator === '>');
	    return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
	  };

	  exports.Range = Range;

	  function Range(range, options) {
	    if (!options || typeof options !== 'object') {
	      options = {
	        loose: !!options,
	        includePrerelease: false
	      };
	    }

	    if (range instanceof Range) {
	      if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
	        return range;
	      } else {
	        return new Range(range.raw, options);
	      }
	    }

	    if (range instanceof Comparator) {
	      return new Range(range.value, options);
	    }

	    if (!(this instanceof Range)) {
	      return new Range(range, options);
	    }

	    this.options = options;
	    this.loose = !!options.loose;
	    this.includePrerelease = !!options.includePrerelease;
	    this.raw = range;
	    this.set = range.split(/\s*\|\|\s*/).map(function (range) {
	      return this.parseRange(range.trim());
	    }, this).filter(function (c) {
	      return c.length;
	    });

	    if (!this.set.length) {
	      throw new TypeError('Invalid SemVer Range: ' + range);
	    }

	    this.format();
	  }

	  Range.prototype.format = function () {
	    this.range = this.set.map(function (comps) {
	      return comps.join(' ').trim();
	    }).join('||').trim();
	    return this.range;
	  };

	  Range.prototype.toString = function () {
	    return this.range;
	  };

	  Range.prototype.parseRange = function (range) {
	    var loose = this.options.loose;
	    range = range.trim();
	    var hr = loose ? re[t.HYPHENRANGELOOSE] : re[t.HYPHENRANGE];
	    range = range.replace(hr, hyphenReplace);
	    debug('hyphen replace', range);
	    range = range.replace(re[t.COMPARATORTRIM], comparatorTrimReplace);
	    debug('comparator trim', range, re[t.COMPARATORTRIM]);
	    range = range.replace(re[t.TILDETRIM], tildeTrimReplace);
	    range = range.replace(re[t.CARETTRIM], caretTrimReplace);
	    range = range.split(/\s+/).join(' ');
	    var compRe = loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
	    var set = range.split(' ').map(function (comp) {
	      return parseComparator(comp, this.options);
	    }, this).join(' ').split(/\s+/);

	    if (this.options.loose) {
	      set = set.filter(function (comp) {
	        return !!comp.match(compRe);
	      });
	    }

	    set = set.map(function (comp) {
	      return new Comparator(comp, this.options);
	    }, this);
	    return set;
	  };

	  Range.prototype.intersects = function (range, options) {
	    if (!(range instanceof Range)) {
	      throw new TypeError('a Range is required');
	    }

	    return this.set.some(function (thisComparators) {
	      return isSatisfiable(thisComparators, options) && range.set.some(function (rangeComparators) {
	        return isSatisfiable(rangeComparators, options) && thisComparators.every(function (thisComparator) {
	          return rangeComparators.every(function (rangeComparator) {
	            return thisComparator.intersects(rangeComparator, options);
	          });
	        });
	      });
	    });
	  };

	  function isSatisfiable(comparators, options) {
	    var result = true;
	    var remainingComparators = comparators.slice();
	    var testComparator = remainingComparators.pop();

	    while (result && remainingComparators.length) {
	      result = remainingComparators.every(function (otherComparator) {
	        return testComparator.intersects(otherComparator, options);
	      });
	      testComparator = remainingComparators.pop();
	    }

	    return result;
	  }

	  exports.toComparators = toComparators;

	  function toComparators(range, options) {
	    return new Range(range, options).set.map(function (comp) {
	      return comp.map(function (c) {
	        return c.value;
	      }).join(' ').trim().split(' ');
	    });
	  }

	  function parseComparator(comp, options) {
	    debug('comp', comp, options);
	    comp = replaceCarets(comp, options);
	    debug('caret', comp);
	    comp = replaceTildes(comp, options);
	    debug('tildes', comp);
	    comp = replaceXRanges(comp, options);
	    debug('xrange', comp);
	    comp = replaceStars(comp, options);
	    debug('stars', comp);
	    return comp;
	  }

	  function isX(id) {
	    return !id || id.toLowerCase() === 'x' || id === '*';
	  }

	  function replaceTildes(comp, options) {
	    return comp.trim().split(/\s+/).map(function (comp) {
	      return replaceTilde(comp, options);
	    }).join(' ');
	  }

	  function replaceTilde(comp, options) {
	    var r = options.loose ? re[t.TILDELOOSE] : re[t.TILDE];
	    return comp.replace(r, function (_, M, m, p, pr) {
	      debug('tilde', comp, _, M, m, p, pr);
	      var ret;

	      if (isX(M)) {
	        ret = '';
	      } else if (isX(m)) {
	        ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
	      } else if (isX(p)) {
	        ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
	      } else if (pr) {
	        debug('replaceTilde pr', pr);
	        ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + (+m + 1) + '.0';
	      } else {
	        ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
	      }

	      debug('tilde return', ret);
	      return ret;
	    });
	  }

	  function replaceCarets(comp, options) {
	    return comp.trim().split(/\s+/).map(function (comp) {
	      return replaceCaret(comp, options);
	    }).join(' ');
	  }

	  function replaceCaret(comp, options) {
	    debug('caret', comp, options);
	    var r = options.loose ? re[t.CARETLOOSE] : re[t.CARET];
	    return comp.replace(r, function (_, M, m, p, pr) {
	      debug('caret', comp, _, M, m, p, pr);
	      var ret;

	      if (isX(M)) {
	        ret = '';
	      } else if (isX(m)) {
	        ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
	      } else if (isX(p)) {
	        if (M === '0') {
	          ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
	        } else {
	          ret = '>=' + M + '.' + m + '.0 <' + (+M + 1) + '.0.0';
	        }
	      } else if (pr) {
	        debug('replaceCaret pr', pr);

	        if (M === '0') {
	          if (m === '0') {
	            ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + m + '.' + (+p + 1);
	          } else {
	            ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + (+m + 1) + '.0';
	          }
	        } else {
	          ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + (+M + 1) + '.0.0';
	        }
	      } else {
	        debug('no pr');

	        if (M === '0') {
	          if (m === '0') {
	            ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + m + '.' + (+p + 1);
	          } else {
	            ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
	          }
	        } else {
	          ret = '>=' + M + '.' + m + '.' + p + ' <' + (+M + 1) + '.0.0';
	        }
	      }

	      debug('caret return', ret);
	      return ret;
	    });
	  }

	  function replaceXRanges(comp, options) {
	    debug('replaceXRanges', comp, options);
	    return comp.split(/\s+/).map(function (comp) {
	      return replaceXRange(comp, options);
	    }).join(' ');
	  }

	  function replaceXRange(comp, options) {
	    comp = comp.trim();
	    var r = options.loose ? re[t.XRANGELOOSE] : re[t.XRANGE];
	    return comp.replace(r, function (ret, gtlt, M, m, p, pr) {
	      debug('xRange', comp, ret, gtlt, M, m, p, pr);
	      var xM = isX(M);
	      var xm = xM || isX(m);
	      var xp = xm || isX(p);
	      var anyX = xp;

	      if (gtlt === '=' && anyX) {
	        gtlt = '';
	      }

	      pr = options.includePrerelease ? '-0' : '';

	      if (xM) {
	        if (gtlt === '>' || gtlt === '<') {
	          ret = '<0.0.0-0';
	        } else {
	          ret = '*';
	        }
	      } else if (gtlt && anyX) {
	        if (xm) {
	          m = 0;
	        }

	        p = 0;

	        if (gtlt === '>') {
	          gtlt = '>=';

	          if (xm) {
	            M = +M + 1;
	            m = 0;
	            p = 0;
	          } else {
	            m = +m + 1;
	            p = 0;
	          }
	        } else if (gtlt === '<=') {
	          gtlt = '<';

	          if (xm) {
	            M = +M + 1;
	          } else {
	            m = +m + 1;
	          }
	        }

	        ret = gtlt + M + '.' + m + '.' + p + pr;
	      } else if (xm) {
	        ret = '>=' + M + '.0.0' + pr + ' <' + (+M + 1) + '.0.0' + pr;
	      } else if (xp) {
	        ret = '>=' + M + '.' + m + '.0' + pr + ' <' + M + '.' + (+m + 1) + '.0' + pr;
	      }

	      debug('xRange return', ret);
	      return ret;
	    });
	  }

	  function replaceStars(comp, options) {
	    debug('replaceStars', comp, options);
	    return comp.trim().replace(re[t.STAR], '');
	  }

	  function hyphenReplace($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) {
	    if (isX(fM)) {
	      from = '';
	    } else if (isX(fm)) {
	      from = '>=' + fM + '.0.0';
	    } else if (isX(fp)) {
	      from = '>=' + fM + '.' + fm + '.0';
	    } else {
	      from = '>=' + from;
	    }

	    if (isX(tM)) {
	      to = '';
	    } else if (isX(tm)) {
	      to = '<' + (+tM + 1) + '.0.0';
	    } else if (isX(tp)) {
	      to = '<' + tM + '.' + (+tm + 1) + '.0';
	    } else if (tpr) {
	      to = '<=' + tM + '.' + tm + '.' + tp + '-' + tpr;
	    } else {
	      to = '<=' + to;
	    }

	    return (from + ' ' + to).trim();
	  }

	  Range.prototype.test = function (version) {
	    if (!version) {
	      return false;
	    }

	    if (typeof version === 'string') {
	      try {
	        version = new SemVer(version, this.options);
	      } catch (er) {
	        return false;
	      }
	    }

	    for (var i = 0; i < this.set.length; i++) {
	      if (testSet(this.set[i], version, this.options)) {
	        return true;
	      }
	    }

	    return false;
	  };

	  function testSet(set, version, options) {
	    for (var i = 0; i < set.length; i++) {
	      if (!set[i].test(version)) {
	        return false;
	      }
	    }

	    if (version.prerelease.length && !options.includePrerelease) {
	      for (i = 0; i < set.length; i++) {
	        debug(set[i].semver);

	        if (set[i].semver === ANY) {
	          continue;
	        }

	        if (set[i].semver.prerelease.length > 0) {
	          var allowed = set[i].semver;

	          if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
	            return true;
	          }
	        }
	      }

	      return false;
	    }

	    return true;
	  }

	  exports.satisfies = satisfies;

	  function satisfies(version, range, options) {
	    try {
	      range = new Range(range, options);
	    } catch (er) {
	      return false;
	    }

	    return range.test(version);
	  }

	  exports.maxSatisfying = maxSatisfying;

	  function maxSatisfying(versions, range, options) {
	    var max = null;
	    var maxSV = null;

	    try {
	      var rangeObj = new Range(range, options);
	    } catch (er) {
	      return null;
	    }

	    versions.forEach(function (v) {
	      if (rangeObj.test(v)) {
	        if (!max || maxSV.compare(v) === -1) {
	          max = v;
	          maxSV = new SemVer(max, options);
	        }
	      }
	    });
	    return max;
	  }

	  exports.minSatisfying = minSatisfying;

	  function minSatisfying(versions, range, options) {
	    var min = null;
	    var minSV = null;

	    try {
	      var rangeObj = new Range(range, options);
	    } catch (er) {
	      return null;
	    }

	    versions.forEach(function (v) {
	      if (rangeObj.test(v)) {
	        if (!min || minSV.compare(v) === 1) {
	          min = v;
	          minSV = new SemVer(min, options);
	        }
	      }
	    });
	    return min;
	  }

	  exports.minVersion = minVersion;

	  function minVersion(range, loose) {
	    range = new Range(range, loose);
	    var minver = new SemVer('0.0.0');

	    if (range.test(minver)) {
	      return minver;
	    }

	    minver = new SemVer('0.0.0-0');

	    if (range.test(minver)) {
	      return minver;
	    }

	    minver = null;

	    for (var i = 0; i < range.set.length; ++i) {
	      var comparators = range.set[i];
	      comparators.forEach(function (comparator) {
	        var compver = new SemVer(comparator.semver.version);

	        switch (comparator.operator) {
	          case '>':
	            if (compver.prerelease.length === 0) {
	              compver.patch++;
	            } else {
	              compver.prerelease.push(0);
	            }

	            compver.raw = compver.format();

	          case '':
	          case '>=':
	            if (!minver || gt(minver, compver)) {
	              minver = compver;
	            }

	            break;

	          case '<':
	          case '<=':
	            break;

	          default:
	            throw new Error('Unexpected operation: ' + comparator.operator);
	        }
	      });
	    }

	    if (minver && range.test(minver)) {
	      return minver;
	    }

	    return null;
	  }

	  exports.validRange = validRange;

	  function validRange(range, options) {
	    try {
	      return new Range(range, options).range || '*';
	    } catch (er) {
	      return null;
	    }
	  }

	  exports.ltr = ltr;

	  function ltr(version, range, options) {
	    return outside(version, range, '<', options);
	  }

	  exports.gtr = gtr;

	  function gtr(version, range, options) {
	    return outside(version, range, '>', options);
	  }

	  exports.outside = outside;

	  function outside(version, range, hilo, options) {
	    version = new SemVer(version, options);
	    range = new Range(range, options);
	    var gtfn, ltefn, ltfn, comp, ecomp;

	    switch (hilo) {
	      case '>':
	        gtfn = gt;
	        ltefn = lte;
	        ltfn = lt;
	        comp = '>';
	        ecomp = '>=';
	        break;

	      case '<':
	        gtfn = lt;
	        ltefn = gte;
	        ltfn = gt;
	        comp = '<';
	        ecomp = '<=';
	        break;

	      default:
	        throw new TypeError('Must provide a hilo val of "<" or ">"');
	    }

	    if (satisfies(version, range, options)) {
	      return false;
	    }

	    for (var i = 0; i < range.set.length; ++i) {
	      var comparators = range.set[i];
	      var high = null;
	      var low = null;
	      comparators.forEach(function (comparator) {
	        if (comparator.semver === ANY) {
	          comparator = new Comparator('>=0.0.0');
	        }

	        high = high || comparator;
	        low = low || comparator;

	        if (gtfn(comparator.semver, high.semver, options)) {
	          high = comparator;
	        } else if (ltfn(comparator.semver, low.semver, options)) {
	          low = comparator;
	        }
	      });

	      if (high.operator === comp || high.operator === ecomp) {
	        return false;
	      }

	      if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
	        return false;
	      } else if (low.operator === ecomp && ltfn(version, low.semver)) {
	        return false;
	      }
	    }

	    return true;
	  }

	  exports.prerelease = prerelease;

	  function prerelease(version, options) {
	    var parsed = parse(version, options);
	    return parsed && parsed.prerelease.length ? parsed.prerelease : null;
	  }

	  exports.intersects = intersects;

	  function intersects(r1, r2, options) {
	    r1 = new Range(r1, options);
	    r2 = new Range(r2, options);
	    return r1.intersects(r2);
	  }

	  exports.coerce = coerce;

	  function coerce(version, options) {
	    if (version instanceof SemVer) {
	      return version;
	    }

	    if (typeof version === 'number') {
	      version = String(version);
	    }

	    if (typeof version !== 'string') {
	      return null;
	    }

	    options = options || {};
	    var match = null;

	    if (!options.rtl) {
	      match = version.match(re[t.COERCE]);
	    } else {
	      var next;

	      while ((next = re[t.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
	        if (!match || next.index + next[0].length !== match.index + match[0].length) {
	          match = next;
	        }

	        re[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
	      }

	      re[t.COERCERTL].lastIndex = -1;
	    }

	    if (match === null) {
	      return null;
	    }

	    return parse(match[2] + '.' + (match[3] || '0') + '.' + (match[4] || '0'), options);
	  }
	}, "/$$rollup_base$$/node_modules/semver-BABEL_8_BREAKING-false");

	function bool$1(value) {
	  if (value == null) return false;
	  return value && value !== "false" && value !== "0";
	}

	var semver$1 = bool$1(browser$5.env["BABEL_8_BREAKING"]) ? semverBABEL_8_BREAKINGTrue : semver$2;

	const {
	  cloneNode: cloneNode$3,
	  interpreterDirective
	} = _t;
	const errorVisitor = {
	  enter(path, state) {
	    const loc = path.node.loc;

	    if (loc) {
	      state.loc = loc;
	      path.stop();
	    }
	  }

	};
	class File {
	  _map = new Map();
	  opts;
	  declarations = {};
	  path = null;
	  ast = {};
	  scope;
	  metadata = {};
	  code = "";
	  inputMap = null;
	  hub = {
	    file: this,
	    getCode: () => this.code,
	    getScope: () => this.scope,
	    addHelper: this.addHelper.bind(this),
	    buildError: this.buildCodeFrameError.bind(this)
	  };

	  constructor(options, {
	    code,
	    ast,
	    inputMap
	  }) {
	    this.opts = options;
	    this.code = code;
	    this.ast = ast;
	    this.inputMap = inputMap;
	    this.path = NodePath.get({
	      hub: this.hub,
	      parentPath: null,
	      parent: this.ast,
	      container: this.ast,
	      key: "program"
	    }).setContext();
	    this.scope = this.path.scope;
	  }

	  get shebang() {
	    const {
	      interpreter
	    } = this.path.node;
	    return interpreter ? interpreter.value : "";
	  }

	  set shebang(value) {
	    if (value) {
	      this.path.get("interpreter").replaceWith(interpreterDirective(value));
	    } else {
	      this.path.get("interpreter").remove();
	    }
	  }

	  set(key, val) {
	    if (key === "helpersNamespace") {
	      throw new Error("Babel 7.0.0-beta.56 has dropped support for the 'helpersNamespace' utility." + "If you are using @babel/plugin-external-helpers you will need to use a newer " + "version than the one you currently have installed. " + "If you have your own implementation, you'll want to explore using 'helperGenerator' " + "alongside 'file.availableHelper()'.");
	    }

	    this._map.set(key, val);
	  }

	  get(key) {
	    return this._map.get(key);
	  }

	  has(key) {
	    return this._map.has(key);
	  }

	  getModuleName() {
	    return getModuleName(this.opts, this.opts);
	  }

	  addImport() {
	    throw new Error("This API has been removed. If you're looking for this " + "functionality in Babel 7, you should import the " + "'@babel/helper-module-imports' module and use the functions exposed " + " from that module, such as 'addNamed' or 'addDefault'.");
	  }

	  availableHelper(name, versionRange) {
	    let minVersion;

	    try {
	      minVersion = minVersion$1(name);
	    } catch (err) {
	      if (err.code !== "BABEL_HELPER_UNKNOWN") throw err;
	      return false;
	    }

	    if (typeof versionRange !== "string") return true;
	    if (semver$1.valid(versionRange)) versionRange = `^${versionRange}`;
	    return !semver$1.intersects(`<${minVersion}`, versionRange) && !semver$1.intersects(`>=8.0.0`, versionRange);
	  }

	  addHelper(name) {
	    const declar = this.declarations[name];
	    if (declar) return cloneNode$3(declar);
	    const generator = this.get("helperGenerator");

	    if (generator) {
	      const res = generator(name);
	      if (res) return res;
	    }

	    ensure(name, File);
	    const uid = this.declarations[name] = this.scope.generateUidIdentifier(name);
	    const dependencies = {};

	    for (const dep of getDependencies(name)) {
	      dependencies[dep] = this.addHelper(dep);
	    }

	    const {
	      nodes,
	      globals
	    } = get$1(name, dep => dependencies[dep], uid, Object.keys(this.scope.getAllBindings()));
	    globals.forEach(name => {
	      if (this.path.scope.hasBinding(name, true)) {
	        this.path.scope.rename(name);
	      }
	    });
	    nodes.forEach(node => {
	      node._compact = true;
	    });
	    this.path.unshiftContainer("body", nodes);
	    this.path.get("body").forEach(path => {
	      if (nodes.indexOf(path.node) === -1) return;
	      if (path.isVariableDeclaration()) this.scope.registerDeclaration(path);
	    });
	    return uid;
	  }

	  addTemplateObject() {
	    throw new Error("This function has been moved into the template literal transform itself.");
	  }

	  buildCodeFrameError(node, msg, _Error = SyntaxError) {
	    let loc = node && (node.loc || node._loc);

	    if (!loc && node) {
	      const state = {
	        loc: null
	      };
	      traverse(node, errorVisitor, this.scope, state);
	      loc = state.loc;
	      let txt = "This is an error on an internal node. Probably an internal error.";
	      if (loc) txt += " Location has been estimated.";
	      msg += ` (${txt})`;
	    }

	    if (loc) {
	      const {
	        highlightCode = true
	      } = this.opts;
	      msg += "\n" + codeFrameColumns(this.code, {
	        start: {
	          line: loc.start.line,
	          column: loc.start.column + 1
	        },
	        end: loc.end && loc.start.line === loc.end.line ? {
	          line: loc.end.line,
	          column: loc.end.column + 1
	        } : undefined
	      }, {
	        highlightCode
	      });
	    }

	    return new _Error(msg);
	  }

	}

	const {
	  arrayExpression,
	  assignmentExpression: assignmentExpression$2,
	  binaryExpression: binaryExpression$1,
	  blockStatement,
	  callExpression: callExpression$3,
	  cloneNode: cloneNode$2,
	  conditionalExpression: conditionalExpression$1,
	  exportNamedDeclaration,
	  exportSpecifier,
	  expressionStatement,
	  functionExpression,
	  identifier: identifier$3,
	  memberExpression: memberExpression$3,
	  objectExpression,
	  program,
	  stringLiteral: stringLiteral$1,
	  unaryExpression: unaryExpression$1,
	  variableDeclaration,
	  variableDeclarator
	} = _t;

	const buildUmdWrapper = replacements => template.statement`
    (function (root, factory) {
      if (typeof define === "function" && define.amd) {
        define(AMD_ARGUMENTS, factory);
      } else if (typeof exports === "object") {
        factory(COMMON_ARGUMENTS);
      } else {
        factory(BROWSER_ARGUMENTS);
      }
    })(UMD_ROOT, function (FACTORY_PARAMETERS) {
      FACTORY_BODY
    });
  `(replacements);

	function buildGlobal(allowlist) {
	  const namespace = identifier$3("babelHelpers");
	  const body = [];
	  const container = functionExpression(null, [identifier$3("global")], blockStatement(body));
	  const tree = program([expressionStatement(callExpression$3(container, [conditionalExpression$1(binaryExpression$1("===", unaryExpression$1("typeof", identifier$3("global")), stringLiteral$1("undefined")), identifier$3("self"), identifier$3("global"))]))]);
	  body.push(variableDeclaration("var", [variableDeclarator(namespace, assignmentExpression$2("=", memberExpression$3(identifier$3("global"), namespace), objectExpression([])))]));
	  buildHelpers(body, namespace, allowlist);
	  return tree;
	}

	function buildModule(allowlist) {
	  const body = [];
	  const refs = buildHelpers(body, null, allowlist);
	  body.unshift(exportNamedDeclaration(null, Object.keys(refs).map(name => {
	    return exportSpecifier(cloneNode$2(refs[name]), identifier$3(name));
	  })));
	  return program(body, [], "module");
	}

	function buildUmd(allowlist) {
	  const namespace = identifier$3("babelHelpers");
	  const body = [];
	  body.push(variableDeclaration("var", [variableDeclarator(namespace, identifier$3("global"))]));
	  buildHelpers(body, namespace, allowlist);
	  return program([buildUmdWrapper({
	    FACTORY_PARAMETERS: identifier$3("global"),
	    BROWSER_ARGUMENTS: assignmentExpression$2("=", memberExpression$3(identifier$3("root"), namespace), objectExpression([])),
	    COMMON_ARGUMENTS: identifier$3("exports"),
	    AMD_ARGUMENTS: arrayExpression([stringLiteral$1("exports")]),
	    FACTORY_BODY: body,
	    UMD_ROOT: identifier$3("this")
	  })]);
	}

	function buildVar(allowlist) {
	  const namespace = identifier$3("babelHelpers");
	  const body = [];
	  body.push(variableDeclaration("var", [variableDeclarator(namespace, objectExpression([]))]));
	  const tree = program(body);
	  buildHelpers(body, namespace, allowlist);
	  body.push(expressionStatement(namespace));
	  return tree;
	}

	function buildHelpers(body, namespace, allowlist) {
	  const getHelperReference = name => {
	    return namespace ? memberExpression$3(namespace, identifier$3(name)) : identifier$3(`_${name}`);
	  };

	  const refs = {};
	  list.forEach(function (name) {
	    if (allowlist && allowlist.indexOf(name) < 0) return;
	    const ref = refs[name] = getHelperReference(name);
	    ensure(name, File);
	    const {
	      nodes
	    } = get$1(name, getHelperReference, ref);
	    body.push(...nodes);
	  });
	  return refs;
	}

	function babelBuildExternalHelpers (allowlist, outputType = "global") {
	  let tree;
	  const build = {
	    global: buildGlobal,
	    module: buildModule,
	    umd: buildUmd,
	    var: buildVar
	  }[outputType];

	  if (build) {
	    tree = build(allowlist);
	  } else {
	    throw new Error(`Unsupported output type ${outputType}`);
	  }

	  return generate$1(tree).code;
	}

	function findConfigUpwards(rootDir) {
	  return null;
	}
	function* findPackageData(filepath) {
	  return {
	    filepath,
	    directories: [],
	    pkg: null,
	    isPackage: false
	  };
	}
	function* findRelativeConfig(pkgData, envName, caller) {
	  return {
	    config: null,
	    ignore: null
	  };
	}
	function* findRootConfig(dirname, envName, caller) {
	  return null;
	}
	function* loadConfig$1(name, dirname, envName, caller) {
	  throw new Error(`Cannot load ${name} relative to ${dirname} in a browser`);
	}
	function* resolveShowConfigPath(dirname) {
	  return null;
	}
	const ROOT_CONFIG_FILENAMES = [];
	function resolvePlugin(name, dirname) {
	  return null;
	}
	function resolvePreset(name, dirname) {
	  return null;
	}
	function loadPlugin(name, dirname) {
	  throw new Error(`Cannot load plugin ${name} relative to ${dirname} in a browser`);
	}
	function loadPreset(name, dirname) {
	  throw new Error(`Cannot load preset ${name} relative to ${dirname} in a browser`);
	}

	function getEnv(defaultValue = "development") {
	  return browser$5.env.BABEL_ENV || undefined || defaultValue;
	}

	const GENSYNC_START = Symbol.for("gensync:v1:start");
	const GENSYNC_SUSPEND = Symbol.for("gensync:v1:suspend");
	const GENSYNC_EXPECTED_START = "GENSYNC_EXPECTED_START";
	const GENSYNC_EXPECTED_SUSPEND = "GENSYNC_EXPECTED_SUSPEND";
	const GENSYNC_OPTIONS_ERROR = "GENSYNC_OPTIONS_ERROR";
	const GENSYNC_RACE_NONEMPTY = "GENSYNC_RACE_NONEMPTY";
	const GENSYNC_ERRBACK_NO_CALLBACK = "GENSYNC_ERRBACK_NO_CALLBACK";
	var gensync = Object.assign(function gensync(optsOrFn) {
	  let genFn = optsOrFn;

	  if (typeof optsOrFn !== "function") {
	    genFn = newGenerator(optsOrFn);
	  } else {
	    genFn = wrapGenerator(optsOrFn);
	  }

	  return Object.assign(genFn, makeFunctionAPI(genFn));
	}, {
	  all: buildOperation({
	    name: "all",
	    arity: 1,
	    sync: function (args) {
	      const items = Array.from(args[0]);
	      return items.map(item => evaluateSync(item));
	    },
	    async: function (args, resolve, reject) {
	      const items = Array.from(args[0]);

	      if (items.length === 0) {
	        Promise.resolve().then(() => resolve([]));
	        return;
	      }

	      let count = 0;
	      const results = items.map(() => undefined);
	      items.forEach((item, i) => {
	        evaluateAsync(item, val => {
	          results[i] = val;
	          count += 1;
	          if (count === results.length) resolve(results);
	        }, reject);
	      });
	    }
	  }),
	  race: buildOperation({
	    name: "race",
	    arity: 1,
	    sync: function (args) {
	      const items = Array.from(args[0]);

	      if (items.length === 0) {
	        throw makeError("Must race at least 1 item", GENSYNC_RACE_NONEMPTY);
	      }

	      return evaluateSync(items[0]);
	    },
	    async: function (args, resolve, reject) {
	      const items = Array.from(args[0]);

	      if (items.length === 0) {
	        throw makeError("Must race at least 1 item", GENSYNC_RACE_NONEMPTY);
	      }

	      for (const item of items) {
	        evaluateAsync(item, resolve, reject);
	      }
	    }
	  })
	});

	function makeFunctionAPI(genFn) {
	  const fns = {
	    sync: function (...args) {
	      return evaluateSync(genFn.apply(this, args));
	    },
	    async: function (...args) {
	      return new Promise((resolve, reject) => {
	        evaluateAsync(genFn.apply(this, args), resolve, reject);
	      });
	    },
	    errback: function (...args) {
	      const cb = args.pop();

	      if (typeof cb !== "function") {
	        throw makeError("Asynchronous function called without callback", GENSYNC_ERRBACK_NO_CALLBACK);
	      }

	      let gen;

	      try {
	        gen = genFn.apply(this, args);
	      } catch (err) {
	        cb(err);
	        return;
	      }

	      evaluateAsync(gen, val => cb(undefined, val), err => cb(err));
	    }
	  };
	  return fns;
	}

	function assertTypeof(type, name, value, allowUndefined) {
	  if (typeof value === type || allowUndefined && typeof value === "undefined") {
	    return;
	  }

	  let msg;

	  if (allowUndefined) {
	    msg = `Expected opts.${name} to be either a ${type}, or undefined.`;
	  } else {
	    msg = `Expected opts.${name} to be a ${type}.`;
	  }

	  throw makeError(msg, GENSYNC_OPTIONS_ERROR);
	}

	function makeError(msg, code) {
	  return Object.assign(new Error(msg), {
	    code
	  });
	}

	function newGenerator({
	  name,
	  arity,
	  sync,
	  async,
	  errback
	}) {
	  assertTypeof("string", "name", name, true);
	  assertTypeof("number", "arity", arity, true);
	  assertTypeof("function", "sync", sync);
	  assertTypeof("function", "async", async, true);
	  assertTypeof("function", "errback", errback, true);

	  if (async && errback) {
	    throw makeError("Expected one of either opts.async or opts.errback, but got _both_.", GENSYNC_OPTIONS_ERROR);
	  }

	  if (typeof name !== "string") {
	    let fnName;

	    if (errback && errback.name && errback.name !== "errback") {
	      fnName = errback.name;
	    }

	    if (async && async.name && async.name !== "async") {
	      fnName = async.name.replace(/Async$/, "");
	    }

	    if (sync && sync.name && sync.name !== "sync") {
	      fnName = sync.name.replace(/Sync$/, "");
	    }

	    if (typeof fnName === "string") {
	      name = fnName;
	    }
	  }

	  if (typeof arity !== "number") {
	    arity = sync.length;
	  }

	  return buildOperation({
	    name,
	    arity,
	    sync: function (args) {
	      return sync.apply(this, args);
	    },
	    async: function (args, resolve, reject) {
	      if (async) {
	        async.apply(this, args).then(resolve, reject);
	      } else if (errback) {
	        errback.call(this, ...args, (err, value) => {
	          if (err == null) resolve(value);else reject(err);
	        });
	      } else {
	        resolve(sync.apply(this, args));
	      }
	    }
	  });
	}

	function wrapGenerator(genFn) {
	  return setFunctionMetadata(genFn.name, genFn.length, function (...args) {
	    return genFn.apply(this, args);
	  });
	}

	function buildOperation({
	  name,
	  arity,
	  sync,
	  async
	}) {
	  return setFunctionMetadata(name, arity, function* (...args) {
	    const resume = yield GENSYNC_START;

	    if (!resume) {
	      const res = sync.call(this, args);
	      return res;
	    }

	    let result;

	    try {
	      async.call(this, args, value => {
	        if (result) return;
	        result = {
	          value
	        };
	        resume();
	      }, err => {
	        if (result) return;
	        result = {
	          err
	        };
	        resume();
	      });
	    } catch (err) {
	      result = {
	        err
	      };
	      resume();
	    }

	    yield GENSYNC_SUSPEND;

	    if (result.hasOwnProperty("err")) {
	      throw result.err;
	    }

	    return result.value;
	  });
	}

	function evaluateSync(gen) {
	  let value;

	  while (!({
	    value
	  } = gen.next()).done) {
	    assertStart(value, gen);
	  }

	  return value;
	}

	function evaluateAsync(gen, resolve, reject) {
	  (function step() {
	    try {
	      let value;

	      while (!({
	        value
	      } = gen.next()).done) {
	        assertStart(value, gen);
	        let sync = true;
	        let didSyncResume = false;
	        const out = gen.next(() => {
	          if (sync) {
	            didSyncResume = true;
	          } else {
	            step();
	          }
	        });
	        sync = false;
	        assertSuspend(out, gen);

	        if (!didSyncResume) {
	          return;
	        }
	      }

	      return resolve(value);
	    } catch (err) {
	      return reject(err);
	    }
	  })();
	}

	function assertStart(value, gen) {
	  if (value === GENSYNC_START) return;
	  throwError(gen, makeError(`Got unexpected yielded value in gensync generator: ${JSON.stringify(value)}. Did you perhaps mean to use 'yield*' instead of 'yield'?`, GENSYNC_EXPECTED_START));
	}

	function assertSuspend({
	  value,
	  done
	}, gen) {
	  if (!done && value === GENSYNC_SUSPEND) return;
	  throwError(gen, makeError(done ? "Unexpected generator completion. If you get this, it is probably a gensync bug." : `Expected GENSYNC_SUSPEND, got ${JSON.stringify(value)}. If you get this, it is probably a gensync bug.`, GENSYNC_EXPECTED_SUSPEND));
	}

	function throwError(gen, err) {
	  if (gen.throw) gen.throw(err);
	  throw err;
	}

	function setFunctionMetadata(name, arity, fn) {
	  if (typeof name === "string") {
	    const nameDesc = Object.getOwnPropertyDescriptor(fn, "name");

	    if (!nameDesc || nameDesc.configurable) {
	      Object.defineProperty(fn, "name", Object.assign(nameDesc || {}, {
	        configurable: true,
	        value: name
	      }));
	    }
	  }

	  if (typeof arity === "number") {
	    const lengthDesc = Object.getOwnPropertyDescriptor(fn, "length");

	    if (!lengthDesc || lengthDesc.configurable) {
	      Object.defineProperty(fn, "length", Object.assign(lengthDesc || {}, {
	        configurable: true,
	        value: arity
	      }));
	    }
	  }

	  return fn;
	}

	const id = x => x;

	const runGenerator = gensync(function* (item) {
	  return yield* item;
	});
	const isAsync = gensync({
	  sync: () => false,
	  errback: cb => cb(null, true)
	});
	function maybeAsync(fn, message) {
	  return gensync({
	    sync(...args) {
	      const result = fn.apply(this, args);
	      if (isThenable$1(result)) throw new Error(message);
	      return result;
	    },

	    async(...args) {
	      return Promise.resolve(fn.apply(this, args));
	    }

	  });
	}
	const withKind = gensync({
	  sync: cb => cb("sync"),
	  async: cb => cb("async")
	});
	function forwardAsync(action, cb) {
	  const g = gensync(action);
	  return withKind(kind => {
	    const adapted = g[kind];
	    return cb(adapted);
	  });
	}
	const onFirstPause = gensync({
	  name: "onFirstPause",
	  arity: 2,
	  sync: function (item) {
	    return runGenerator.sync(item);
	  },
	  errback: function (item, firstPause, cb) {
	    let completed = false;
	    runGenerator.errback(item, (err, value) => {
	      completed = true;
	      cb(err, value);
	    });

	    if (!completed) {
	      firstPause();
	    }
	  }
	});
	const waitFor = gensync({
	  sync: id,
	  async: id
	});
	function isThenable$1(val) {
	  return !!val && (typeof val === "object" || typeof val === "function") && !!val.then && typeof val.then === "function";
	}

	function mergeOptions(target, source) {
	  for (const k of Object.keys(source)) {
	    if ((k === "parserOpts" || k === "generatorOpts" || k === "assumptions") && source[k]) {
	      const parserOpts = source[k];
	      const targetObj = target[k] || (target[k] = {});
	      mergeDefaultFields(targetObj, parserOpts);
	    } else {
	      const val = source[k];
	      if (val !== undefined) target[k] = val;
	    }
	  }
	}

	function mergeDefaultFields(target, source) {
	  for (const k of Object.keys(source)) {
	    const val = source[k];
	    if (val !== undefined) target[k] = val;
	  }
	}

	function isIterableIterator(value) {
	  return !!value && typeof value.next === "function" && typeof value[Symbol.iterator] === "function";
	}

	function finalize(deepArr) {
	  return Object.freeze(deepArr);
	}
	function flattenToSet(arr) {
	  const result = new Set();
	  const stack = [arr];

	  while (stack.length > 0) {
	    for (const el of stack.pop()) {
	      if (Array.isArray(el)) stack.push(el);else result.add(el);
	    }
	  }

	  return result;
	}

	class Plugin$1 {
	  key;
	  manipulateOptions;
	  post;
	  pre;
	  visitor;
	  parserOverride;
	  generatorOverride;
	  options;
	  externalDependencies;

	  constructor(plugin, options, key, externalDependencies = finalize([])) {
	    this.key = plugin.name || key;
	    this.manipulateOptions = plugin.manipulateOptions;
	    this.post = plugin.post;
	    this.pre = plugin.pre;
	    this.visitor = plugin.visitor || {};
	    this.parserOverride = plugin.parserOverride;
	    this.generatorOverride = plugin.generatorOverride;
	    this.options = options;
	    this.externalDependencies = externalDependencies;
	  }

	}

	const synchronize = gen => {
	  return gensync(gen).sync;
	};

	function* genTrue() {
	  return true;
	}

	function makeWeakCache(handler) {
	  return makeCachedFunction(WeakMap, handler);
	}
	function makeWeakCacheSync(handler) {
	  return synchronize(makeWeakCache(handler));
	}
	function makeStrongCache(handler) {
	  return makeCachedFunction(Map, handler);
	}
	function makeStrongCacheSync(handler) {
	  return synchronize(makeStrongCache(handler));
	}

	function makeCachedFunction(CallCache, handler) {
	  const callCacheSync = new CallCache();
	  const callCacheAsync = new CallCache();
	  const futureCache = new CallCache();
	  return function* cachedFunction(arg, data) {
	    const asyncContext = yield* isAsync();
	    const callCache = asyncContext ? callCacheAsync : callCacheSync;
	    const cached = yield* getCachedValueOrWait(asyncContext, callCache, futureCache, arg, data);
	    if (cached.valid) return cached.value;
	    const cache = new CacheConfigurator(data);
	    const handlerResult = handler(arg, cache);
	    let finishLock;
	    let value;

	    if (isIterableIterator(handlerResult)) {
	      const gen = handlerResult;
	      value = yield* onFirstPause(gen, () => {
	        finishLock = setupAsyncLocks(cache, futureCache, arg);
	      });
	    } else {
	      value = handlerResult;
	    }

	    updateFunctionCache(callCache, cache, arg, value);

	    if (finishLock) {
	      futureCache.delete(arg);
	      finishLock.release(value);
	    }

	    return value;
	  };
	}

	function* getCachedValue(cache, arg, data) {
	  const cachedValue = cache.get(arg);

	  if (cachedValue) {
	    for (const {
	      value,
	      valid
	    } of cachedValue) {
	      if (yield* valid(data)) return {
	        valid: true,
	        value
	      };
	    }
	  }

	  return {
	    valid: false,
	    value: null
	  };
	}

	function* getCachedValueOrWait(asyncContext, callCache, futureCache, arg, data) {
	  const cached = yield* getCachedValue(callCache, arg, data);

	  if (cached.valid) {
	    return cached;
	  }

	  if (asyncContext) {
	    const cached = yield* getCachedValue(futureCache, arg, data);

	    if (cached.valid) {
	      const value = yield* waitFor(cached.value.promise);
	      return {
	        valid: true,
	        value
	      };
	    }
	  }

	  return {
	    valid: false,
	    value: null
	  };
	}

	function setupAsyncLocks(config, futureCache, arg) {
	  const finishLock = new Lock();
	  updateFunctionCache(futureCache, config, arg, finishLock);
	  return finishLock;
	}

	function updateFunctionCache(cache, config, arg, value) {
	  if (!config.configured()) config.forever();
	  let cachedValue = cache.get(arg);
	  config.deactivate();

	  switch (config.mode()) {
	    case "forever":
	      cachedValue = [{
	        value,
	        valid: genTrue
	      }];
	      cache.set(arg, cachedValue);
	      break;

	    case "invalidate":
	      cachedValue = [{
	        value,
	        valid: config.validator()
	      }];
	      cache.set(arg, cachedValue);
	      break;

	    case "valid":
	      if (cachedValue) {
	        cachedValue.push({
	          value,
	          valid: config.validator()
	        });
	      } else {
	        cachedValue = [{
	          value,
	          valid: config.validator()
	        }];
	        cache.set(arg, cachedValue);
	      }

	  }
	}

	class CacheConfigurator {
	  _active = true;
	  _never = false;
	  _forever = false;
	  _invalidate = false;
	  _configured = false;
	  _pairs = [];
	  _data;

	  constructor(data) {
	    this._data = data;
	  }

	  simple() {
	    return makeSimpleConfigurator(this);
	  }

	  mode() {
	    if (this._never) return "never";
	    if (this._forever) return "forever";
	    if (this._invalidate) return "invalidate";
	    return "valid";
	  }

	  forever() {
	    if (!this._active) {
	      throw new Error("Cannot change caching after evaluation has completed.");
	    }

	    if (this._never) {
	      throw new Error("Caching has already been configured with .never()");
	    }

	    this._forever = true;
	    this._configured = true;
	  }

	  never() {
	    if (!this._active) {
	      throw new Error("Cannot change caching after evaluation has completed.");
	    }

	    if (this._forever) {
	      throw new Error("Caching has already been configured with .forever()");
	    }

	    this._never = true;
	    this._configured = true;
	  }

	  using(handler) {
	    if (!this._active) {
	      throw new Error("Cannot change caching after evaluation has completed.");
	    }

	    if (this._never || this._forever) {
	      throw new Error("Caching has already been configured with .never or .forever()");
	    }

	    this._configured = true;
	    const key = handler(this._data);
	    const fn = maybeAsync(handler, `You appear to be using an async cache handler, but Babel has been called synchronously`);

	    if (isThenable$1(key)) {
	      return key.then(key => {
	        this._pairs.push([key, fn]);

	        return key;
	      });
	    }

	    this._pairs.push([key, fn]);

	    return key;
	  }

	  invalidate(handler) {
	    this._invalidate = true;
	    return this.using(handler);
	  }

	  validator() {
	    const pairs = this._pairs;
	    return function* (data) {
	      for (const [key, fn] of pairs) {
	        if (key !== (yield* fn(data))) return false;
	      }

	      return true;
	    };
	  }

	  deactivate() {
	    this._active = false;
	  }

	  configured() {
	    return this._configured;
	  }

	}

	function makeSimpleConfigurator(cache) {
	  function cacheFn(val) {
	    if (typeof val === "boolean") {
	      if (val) cache.forever();else cache.never();
	      return;
	    }

	    return cache.using(() => assertSimpleType(val()));
	  }

	  cacheFn.forever = () => cache.forever();

	  cacheFn.never = () => cache.never();

	  cacheFn.using = cb => cache.using(() => assertSimpleType(cb()));

	  cacheFn.invalidate = cb => cache.invalidate(() => assertSimpleType(cb()));

	  return cacheFn;
	}

	function assertSimpleType(value) {
	  if (isThenable$1(value)) {
	    throw new Error(`You appear to be using an async cache handler, ` + `which your current version of Babel does not support. ` + `We may add support for this in the future, ` + `but if you're on the most recent version of @babel/core and still ` + `seeing this error, then you'll need to synchronously handle your caching logic.`);
	  }

	  if (value != null && typeof value !== "string" && typeof value !== "boolean" && typeof value !== "number") {
	    throw new Error("Cache keys must be either string, boolean, number, null, or undefined.");
	  }

	  return value;
	}

	class Lock {
	  released = false;
	  promise;
	  _resolve;

	  constructor() {
	    this.promise = new Promise(resolve => {
	      this._resolve = resolve;
	    });
	  }

	  release(value) {
	    this.released = true;

	    this._resolve(value);
	  }

	}

	var jsReleases = [
		{
			name: "nodejs",
			version: "0.2.0",
			date: "2011-08-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.3.0",
			date: "2011-08-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.4.0",
			date: "2011-08-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.5.0",
			date: "2011-08-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.6.0",
			date: "2011-11-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.7.0",
			date: "2012-01-17",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.8.0",
			date: "2012-06-22",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.9.0",
			date: "2012-07-20",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.10.0",
			date: "2013-03-11",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.11.0",
			date: "2013-03-28",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "0.12.0",
			date: "2015-02-06",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "4.0.0",
			date: "2015-09-08",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "4.1.0",
			date: "2015-09-17",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "4.2.0",
			date: "2015-10-12",
			lts: "Argon",
			security: false
		},
		{
			name: "nodejs",
			version: "4.3.0",
			date: "2016-02-09",
			lts: "Argon",
			security: false
		},
		{
			name: "nodejs",
			version: "4.4.0",
			date: "2016-03-08",
			lts: "Argon",
			security: false
		},
		{
			name: "nodejs",
			version: "4.5.0",
			date: "2016-08-16",
			lts: "Argon",
			security: false
		},
		{
			name: "nodejs",
			version: "4.6.0",
			date: "2016-09-27",
			lts: "Argon",
			security: true
		},
		{
			name: "nodejs",
			version: "4.7.0",
			date: "2016-12-06",
			lts: "Argon",
			security: false
		},
		{
			name: "nodejs",
			version: "4.8.0",
			date: "2017-02-21",
			lts: "Argon",
			security: false
		},
		{
			name: "nodejs",
			version: "4.9.0",
			date: "2018-03-28",
			lts: "Argon",
			security: true
		},
		{
			name: "nodejs",
			version: "5.0.0",
			date: "2015-10-29",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.1.0",
			date: "2015-11-17",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.2.0",
			date: "2015-12-09",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.3.0",
			date: "2015-12-15",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.4.0",
			date: "2016-01-06",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.5.0",
			date: "2016-01-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.6.0",
			date: "2016-02-09",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.7.0",
			date: "2016-02-23",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.8.0",
			date: "2016-03-09",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.9.0",
			date: "2016-03-16",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.10.0",
			date: "2016-04-01",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.11.0",
			date: "2016-04-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "5.12.0",
			date: "2016-06-23",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.0.0",
			date: "2016-04-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.1.0",
			date: "2016-05-05",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.2.0",
			date: "2016-05-17",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.3.0",
			date: "2016-07-06",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.4.0",
			date: "2016-08-12",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.5.0",
			date: "2016-08-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.6.0",
			date: "2016-09-14",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.7.0",
			date: "2016-09-27",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "6.8.0",
			date: "2016-10-12",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "6.9.0",
			date: "2016-10-18",
			lts: "Boron",
			security: false
		},
		{
			name: "nodejs",
			version: "6.10.0",
			date: "2017-02-21",
			lts: "Boron",
			security: false
		},
		{
			name: "nodejs",
			version: "6.11.0",
			date: "2017-06-06",
			lts: "Boron",
			security: false
		},
		{
			name: "nodejs",
			version: "6.12.0",
			date: "2017-11-06",
			lts: "Boron",
			security: false
		},
		{
			name: "nodejs",
			version: "6.13.0",
			date: "2018-02-10",
			lts: "Boron",
			security: false
		},
		{
			name: "nodejs",
			version: "6.14.0",
			date: "2018-03-28",
			lts: "Boron",
			security: true
		},
		{
			name: "nodejs",
			version: "6.15.0",
			date: "2018-11-27",
			lts: "Boron",
			security: true
		},
		{
			name: "nodejs",
			version: "6.16.0",
			date: "2018-12-26",
			lts: "Boron",
			security: false
		},
		{
			name: "nodejs",
			version: "6.17.0",
			date: "2019-02-28",
			lts: "Boron",
			security: true
		},
		{
			name: "nodejs",
			version: "7.0.0",
			date: "2016-10-25",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.1.0",
			date: "2016-11-08",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.2.0",
			date: "2016-11-22",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.3.0",
			date: "2016-12-20",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.4.0",
			date: "2017-01-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.5.0",
			date: "2017-01-31",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.6.0",
			date: "2017-02-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.7.0",
			date: "2017-02-28",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.8.0",
			date: "2017-03-29",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.9.0",
			date: "2017-04-11",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "7.10.0",
			date: "2017-05-02",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.0.0",
			date: "2017-05-30",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.1.0",
			date: "2017-06-08",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.2.0",
			date: "2017-07-19",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.3.0",
			date: "2017-08-08",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.4.0",
			date: "2017-08-15",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.5.0",
			date: "2017-09-12",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.6.0",
			date: "2017-09-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.7.0",
			date: "2017-10-11",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.8.0",
			date: "2017-10-24",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "8.9.0",
			date: "2017-10-31",
			lts: "Carbon",
			security: false
		},
		{
			name: "nodejs",
			version: "8.10.0",
			date: "2018-03-06",
			lts: "Carbon",
			security: false
		},
		{
			name: "nodejs",
			version: "8.11.0",
			date: "2018-03-28",
			lts: "Carbon",
			security: true
		},
		{
			name: "nodejs",
			version: "8.12.0",
			date: "2018-09-10",
			lts: "Carbon",
			security: false
		},
		{
			name: "nodejs",
			version: "8.13.0",
			date: "2018-11-20",
			lts: "Carbon",
			security: false
		},
		{
			name: "nodejs",
			version: "8.14.0",
			date: "2018-11-27",
			lts: "Carbon",
			security: true
		},
		{
			name: "nodejs",
			version: "8.15.0",
			date: "2018-12-26",
			lts: "Carbon",
			security: false
		},
		{
			name: "nodejs",
			version: "8.16.0",
			date: "2019-04-16",
			lts: "Carbon",
			security: false
		},
		{
			name: "nodejs",
			version: "8.17.0",
			date: "2019-12-17",
			lts: "Carbon",
			security: true
		},
		{
			name: "nodejs",
			version: "9.0.0",
			date: "2017-10-31",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.1.0",
			date: "2017-11-07",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.2.0",
			date: "2017-11-14",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.3.0",
			date: "2017-12-12",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.4.0",
			date: "2018-01-10",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.5.0",
			date: "2018-01-31",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.6.0",
			date: "2018-02-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.7.0",
			date: "2018-03-01",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.8.0",
			date: "2018-03-07",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.9.0",
			date: "2018-03-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "9.10.0",
			date: "2018-03-28",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "9.11.0",
			date: "2018-04-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.0.0",
			date: "2018-04-24",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.1.0",
			date: "2018-05-08",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.2.0",
			date: "2018-05-23",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.3.0",
			date: "2018-05-29",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.4.0",
			date: "2018-06-06",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.5.0",
			date: "2018-06-20",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.6.0",
			date: "2018-07-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.7.0",
			date: "2018-07-18",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.8.0",
			date: "2018-08-01",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.9.0",
			date: "2018-08-15",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.10.0",
			date: "2018-09-06",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.11.0",
			date: "2018-09-19",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.12.0",
			date: "2018-10-10",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "10.13.0",
			date: "2018-10-30",
			lts: "Dubnium",
			security: false
		},
		{
			name: "nodejs",
			version: "10.14.0",
			date: "2018-11-27",
			lts: "Dubnium",
			security: true
		},
		{
			name: "nodejs",
			version: "10.15.0",
			date: "2018-12-26",
			lts: "Dubnium",
			security: false
		},
		{
			name: "nodejs",
			version: "10.16.0",
			date: "2019-05-28",
			lts: "Dubnium",
			security: false
		},
		{
			name: "nodejs",
			version: "10.17.0",
			date: "2019-10-22",
			lts: "Dubnium",
			security: false
		},
		{
			name: "nodejs",
			version: "10.18.0",
			date: "2019-12-17",
			lts: "Dubnium",
			security: true
		},
		{
			name: "nodejs",
			version: "10.19.0",
			date: "2020-02-05",
			lts: "Dubnium",
			security: true
		},
		{
			name: "nodejs",
			version: "10.20.0",
			date: "2020-03-26",
			lts: "Dubnium",
			security: false
		},
		{
			name: "nodejs",
			version: "10.21.0",
			date: "2020-06-02",
			lts: "Dubnium",
			security: true
		},
		{
			name: "nodejs",
			version: "10.22.0",
			date: "2020-07-21",
			lts: "Dubnium",
			security: false
		},
		{
			name: "nodejs",
			version: "10.23.0",
			date: "2020-10-27",
			lts: "Dubnium",
			security: false
		},
		{
			name: "nodejs",
			version: "10.24.0",
			date: "2021-02-23",
			lts: "Dubnium",
			security: true
		},
		{
			name: "nodejs",
			version: "11.0.0",
			date: "2018-10-23",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.1.0",
			date: "2018-10-30",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.2.0",
			date: "2018-11-15",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.3.0",
			date: "2018-11-27",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "11.4.0",
			date: "2018-12-07",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.5.0",
			date: "2018-12-18",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.6.0",
			date: "2018-12-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.7.0",
			date: "2019-01-17",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.8.0",
			date: "2019-01-24",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.9.0",
			date: "2019-01-30",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.10.0",
			date: "2019-02-14",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.11.0",
			date: "2019-03-05",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.12.0",
			date: "2019-03-14",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.13.0",
			date: "2019-03-28",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.14.0",
			date: "2019-04-10",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "11.15.0",
			date: "2019-04-30",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.0.0",
			date: "2019-04-23",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.1.0",
			date: "2019-04-29",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.2.0",
			date: "2019-05-07",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.3.0",
			date: "2019-05-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.4.0",
			date: "2019-06-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.5.0",
			date: "2019-06-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.6.0",
			date: "2019-07-03",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.7.0",
			date: "2019-07-23",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.8.0",
			date: "2019-08-06",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.9.0",
			date: "2019-08-20",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.10.0",
			date: "2019-09-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.11.0",
			date: "2019-09-25",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.12.0",
			date: "2019-10-11",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "12.13.0",
			date: "2019-10-21",
			lts: "Erbium",
			security: false
		},
		{
			name: "nodejs",
			version: "12.14.0",
			date: "2019-12-17",
			lts: "Erbium",
			security: true
		},
		{
			name: "nodejs",
			version: "12.15.0",
			date: "2020-02-05",
			lts: "Erbium",
			security: true
		},
		{
			name: "nodejs",
			version: "12.16.0",
			date: "2020-02-11",
			lts: "Erbium",
			security: false
		},
		{
			name: "nodejs",
			version: "12.17.0",
			date: "2020-05-26",
			lts: "Erbium",
			security: false
		},
		{
			name: "nodejs",
			version: "12.18.0",
			date: "2020-06-02",
			lts: "Erbium",
			security: true
		},
		{
			name: "nodejs",
			version: "12.19.0",
			date: "2020-10-06",
			lts: "Erbium",
			security: false
		},
		{
			name: "nodejs",
			version: "12.20.0",
			date: "2020-11-24",
			lts: "Erbium",
			security: false
		},
		{
			name: "nodejs",
			version: "12.21.0",
			date: "2021-02-23",
			lts: "Erbium",
			security: true
		},
		{
			name: "nodejs",
			version: "12.22.0",
			date: "2021-03-30",
			lts: "Erbium",
			security: false
		},
		{
			name: "nodejs",
			version: "13.0.0",
			date: "2019-10-22",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.1.0",
			date: "2019-11-05",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.2.0",
			date: "2019-11-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.3.0",
			date: "2019-12-03",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.4.0",
			date: "2019-12-17",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "13.5.0",
			date: "2019-12-18",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.6.0",
			date: "2020-01-07",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.7.0",
			date: "2020-01-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.8.0",
			date: "2020-02-05",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "13.9.0",
			date: "2020-02-18",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.10.0",
			date: "2020-03-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.11.0",
			date: "2020-03-12",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.12.0",
			date: "2020-03-26",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.13.0",
			date: "2020-04-14",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "13.14.0",
			date: "2020-04-29",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.0.0",
			date: "2020-04-21",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.1.0",
			date: "2020-04-29",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.2.0",
			date: "2020-05-05",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.3.0",
			date: "2020-05-19",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.4.0",
			date: "2020-06-02",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "14.5.0",
			date: "2020-06-30",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.6.0",
			date: "2020-07-20",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.7.0",
			date: "2020-07-29",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.8.0",
			date: "2020-08-11",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.9.0",
			date: "2020-08-27",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.10.0",
			date: "2020-09-08",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.11.0",
			date: "2020-09-15",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "14.12.0",
			date: "2020-09-22",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.13.0",
			date: "2020-09-29",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.14.0",
			date: "2020-10-15",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "14.15.0",
			date: "2020-10-27",
			lts: "Fermium",
			security: false
		},
		{
			name: "nodejs",
			version: "14.16.0",
			date: "2021-02-23",
			lts: "Fermium",
			security: true
		},
		{
			name: "nodejs",
			version: "14.17.0",
			date: "2021-05-11",
			lts: "Fermium",
			security: false
		},
		{
			name: "nodejs",
			version: "14.18.0",
			date: "2021-09-28",
			lts: "Fermium",
			security: false
		},
		{
			name: "nodejs",
			version: "15.0.0",
			date: "2020-10-20",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.1.0",
			date: "2020-11-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.2.0",
			date: "2020-11-10",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.3.0",
			date: "2020-11-24",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.4.0",
			date: "2020-12-09",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.5.0",
			date: "2020-12-22",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.6.0",
			date: "2021-01-14",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.7.0",
			date: "2021-01-25",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.8.0",
			date: "2021-02-02",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.9.0",
			date: "2021-02-18",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.10.0",
			date: "2021-02-23",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "15.11.0",
			date: "2021-03-03",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.12.0",
			date: "2021-03-17",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.13.0",
			date: "2021-03-31",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "15.14.0",
			date: "2021-04-06",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.0.0",
			date: "2021-04-20",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.1.0",
			date: "2021-05-04",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.2.0",
			date: "2021-05-19",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.3.0",
			date: "2021-06-03",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.4.0",
			date: "2021-06-23",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.5.0",
			date: "2021-07-14",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.6.0",
			date: "2021-07-29",
			lts: false,
			security: true
		},
		{
			name: "nodejs",
			version: "16.7.0",
			date: "2021-08-18",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.8.0",
			date: "2021-08-25",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.9.0",
			date: "2021-09-07",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.10.0",
			date: "2021-09-22",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.11.0",
			date: "2021-10-08",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "16.12.0",
			date: "2021-10-20",
			lts: false,
			security: false
		},
		{
			name: "nodejs",
			version: "17.0.0",
			date: "2021-10-19",
			lts: false,
			security: false
		}
	];

	var browsers$2 = {
	  A: "ie",
	  B: "edge",
	  C: "firefox",
	  D: "chrome",
	  E: "safari",
	  F: "opera",
	  G: "ios_saf",
	  H: "op_mini",
	  I: "android",
	  J: "bb",
	  K: "op_mob",
	  L: "and_chr",
	  M: "and_ff",
	  N: "ie_mob",
	  O: "and_uc",
	  P: "samsung",
	  Q: "and_qq",
	  R: "baidu",
	  S: "kaios"
	};

	var browsers_1 = browsers$2;
	var browsers$1 = {
	  browsers: browsers_1
	};

	var browserVersions$1 = {
	  "0": "39",
	  "1": "40",
	  "2": "41",
	  "3": "42",
	  "4": "43",
	  "5": "44",
	  "6": "45",
	  "7": "46",
	  "8": "47",
	  "9": "48",
	  A: "10",
	  B: "11",
	  C: "12",
	  D: "15",
	  E: "7",
	  F: "8",
	  G: "9",
	  H: "94",
	  I: "4",
	  J: "6",
	  K: "13",
	  L: "14",
	  M: "16",
	  N: "17",
	  O: "18",
	  P: "79",
	  Q: "80",
	  R: "92",
	  S: "64",
	  T: "81",
	  U: "83",
	  V: "84",
	  W: "85",
	  X: "86",
	  Y: "87",
	  Z: "88",
	  a: "89",
	  b: "90",
	  c: "91",
	  d: "93",
	  e: "95",
	  f: "5",
	  g: "19",
	  h: "20",
	  i: "21",
	  j: "22",
	  k: "23",
	  l: "24",
	  m: "25",
	  n: "26",
	  o: "27",
	  p: "28",
	  q: "29",
	  r: "30",
	  s: "31",
	  t: "32",
	  u: "33",
	  v: "34",
	  w: "35",
	  x: "36",
	  y: "37",
	  z: "38",
	  AB: "49",
	  BB: "50",
	  CB: "51",
	  DB: "52",
	  EB: "53",
	  FB: "54",
	  GB: "55",
	  HB: "56",
	  IB: "57",
	  JB: "58",
	  KB: "60",
	  LB: "62",
	  MB: "63",
	  NB: "65",
	  OB: "66",
	  PB: "67",
	  QB: "68",
	  RB: "69",
	  SB: "70",
	  TB: "71",
	  UB: "72",
	  VB: "73",
	  WB: "74",
	  XB: "75",
	  YB: "76",
	  ZB: "77",
	  aB: "78",
	  bB: "11.1",
	  cB: "12.1",
	  dB: "3",
	  eB: "59",
	  fB: "61",
	  gB: "3.2",
	  hB: "10.1",
	  iB: "11.5",
	  jB: "4.2-4.3",
	  kB: "5.5",
	  lB: "2",
	  mB: "82",
	  nB: "3.5",
	  oB: "3.6",
	  pB: "96",
	  qB: "97",
	  rB: "98",
	  sB: "3.1",
	  tB: "5.1",
	  uB: "6.1",
	  vB: "7.1",
	  wB: "9.1",
	  xB: "13.1",
	  yB: "14.1",
	  zB: "TP",
	  "0B": "9.5-9.6",
	  "1B": "10.0-10.1",
	  "2B": "10.5",
	  "3B": "10.6",
	  "4B": "11.6",
	  "5B": "4.0-4.1",
	  "6B": "5.0-5.1",
	  "7B": "6.0-6.1",
	  "8B": "7.0-7.1",
	  "9B": "8.1-8.4",
	  AC: "9.0-9.2",
	  BC: "9.3",
	  CC: "10.0-10.2",
	  DC: "10.3",
	  EC: "11.0-11.2",
	  FC: "11.3-11.4",
	  GC: "12.0-12.1",
	  HC: "12.2-12.5",
	  IC: "13.0-13.1",
	  JC: "13.2",
	  KC: "13.3",
	  LC: "13.4-13.7",
	  MC: "14.0-14.4",
	  NC: "14.5-14.8",
	  OC: "all",
	  PC: "2.1",
	  QC: "2.2",
	  RC: "2.3",
	  SC: "4.1",
	  TC: "4.4",
	  UC: "4.4.3-4.4.4",
	  VC: "12.12",
	  WC: "5.0-5.4",
	  XC: "6.2-6.4",
	  YC: "7.2-7.4",
	  ZC: "8.2",
	  aC: "9.2",
	  bC: "11.1-11.2",
	  cC: "12.0",
	  dC: "13.0",
	  eC: "14.0",
	  fC: "15.0",
	  gC: "10.4",
	  hC: "7.12",
	  iC: "2.5"
	};

	var browserVersions_1 = browserVersions$1;
	var browserVersions = {
	  browserVersions: browserVersions_1
	};

	var agents$2 = {
	  A: {
	    A: {
	      J: 0.0131217,
	      E: 0.00621152,
	      F: 0.0414881,
	      G: 0.11755,
	      A: 0.020744,
	      B: 0.726041,
	      kB: 0.009298
	    },
	    B: "ms",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "kB", "J", "E", "F", "G", "A", "B", "", "", ""],
	    E: "IE",
	    F: {
	      kB: 962323200,
	      J: 998870400,
	      E: 1161129600,
	      F: 1237420800,
	      G: 1300060800,
	      A: 1346716800,
	      B: 1381968000
	    }
	  },
	  B: {
	    A: {
	      C: 0.008586,
	      K: 0.004267,
	      L: 0.004293,
	      D: 0.008586,
	      M: 0.008586,
	      N: 0.017172,
	      O: 0.090153,
	      P: 0,
	      Q: 0.004298,
	      T: 0.00944,
	      U: 0.004043,
	      V: 0.012879,
	      W: 0.008586,
	      X: 0.008586,
	      Y: 0.012879,
	      Z: 0.004293,
	      a: 0.017172,
	      b: 0.008586,
	      c: 0.030051,
	      R: 0.570969,
	      d: 2.53287,
	      H: 0.523746,
	      e: 0
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "C", "K", "L", "D", "M", "N", "O", "P", "Q", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "R", "d", "H", "e", "", "", ""],
	    E: "Edge",
	    F: {
	      C: 1438128000,
	      K: 1447286400,
	      L: 1470096000,
	      D: 1491868800,
	      M: 1508198400,
	      N: 1525046400,
	      O: 1542067200,
	      P: 1579046400,
	      Q: 1581033600,
	      T: 1586736000,
	      U: 1590019200,
	      V: 1594857600,
	      W: 1598486400,
	      X: 1602201600,
	      Y: 1605830400,
	      Z: 1611360000,
	      a: 1614816000,
	      b: 1618358400,
	      c: 1622073600,
	      R: 1626912000,
	      d: 1630627200,
	      H: 1632441600,
	      e: 1634774400
	    },
	    D: {
	      C: "ms",
	      K: "ms",
	      L: "ms",
	      D: "ms",
	      M: "ms",
	      N: "ms",
	      O: "ms"
	    }
	  },
	  C: {
	    A: {
	      "0": 0.004783,
	      "1": 0.00487,
	      "2": 0.005029,
	      "3": 0.0047,
	      "4": 0.038637,
	      "5": 0.004293,
	      "6": 0.004293,
	      "7": 0.004525,
	      "8": 0.004293,
	      "9": 0.008586,
	      lB: 0.004293,
	      dB: 0.004271,
	      I: 0.021465,
	      f: 0.004879,
	      J: 0.020136,
	      E: 0.005725,
	      F: 0.004525,
	      G: 0.00533,
	      A: 0.004283,
	      B: 0.008586,
	      C: 0.004471,
	      K: 0.004486,
	      L: 0.00453,
	      D: 0.004293,
	      M: 0.004417,
	      N: 0.004425,
	      O: 0.004293,
	      g: 0.004443,
	      h: 0.004283,
	      i: 0.004293,
	      j: 0.013698,
	      k: 0.004293,
	      l: 0.008786,
	      m: 0.008586,
	      n: 0.004317,
	      o: 0.004393,
	      p: 0.004418,
	      q: 0.008834,
	      r: 0.004293,
	      s: 0.008928,
	      t: 0.004471,
	      u: 0.009284,
	      v: 0.004707,
	      w: 0.009076,
	      x: 0.004425,
	      y: 0.004783,
	      z: 0.004271,
	      AB: 0.004538,
	      BB: 0.008282,
	      CB: 0.008586,
	      DB: 0.072981,
	      EB: 0.004335,
	      FB: 0.008586,
	      GB: 0.004293,
	      HB: 0.008586,
	      IB: 0.004425,
	      JB: 0.004293,
	      eB: 0.004293,
	      KB: 0.008586,
	      fB: 0.00472,
	      LB: 0.004425,
	      MB: 0.008586,
	      S: 0.00415,
	      NB: 0.004267,
	      OB: 0.004293,
	      PB: 0.004267,
	      QB: 0.012879,
	      RB: 0.00415,
	      SB: 0.004293,
	      TB: 0.004425,
	      UB: 0.008586,
	      VB: 0.00415,
	      WB: 0.00415,
	      XB: 0.004141,
	      YB: 0.004043,
	      ZB: 0.004293,
	      aB: 0.150255,
	      P: 0.012879,
	      Q: 0.012879,
	      T: 0.012879,
	      mB: 0.012879,
	      U: 0.008586,
	      V: 0.017172,
	      W: 0.008586,
	      X: 0.008586,
	      Y: 0.012879,
	      Z: 0.030051,
	      a: 0.047223,
	      b: 0.047223,
	      c: 0.841428,
	      R: 1.77301,
	      d: 0.025758,
	      H: 0,
	      e: 0,
	      nB: 0.008786,
	      oB: 0.00487
	    },
	    B: "moz",
	    C: ["lB", "dB", "nB", "oB", "I", "f", "J", "E", "F", "G", "A", "B", "C", "K", "L", "D", "M", "N", "O", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "eB", "KB", "fB", "LB", "MB", "S", "NB", "OB", "PB", "QB", "RB", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "P", "Q", "T", "mB", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "R", "d", "H", "e", ""],
	    E: "Firefox",
	    F: {
	      "0": 1435881600,
	      "1": 1439251200,
	      "2": 1442880000,
	      "3": 1446508800,
	      "4": 1450137600,
	      "5": 1453852800,
	      "6": 1457395200,
	      "7": 1461628800,
	      "8": 1465257600,
	      "9": 1470096000,
	      lB: 1161648000,
	      dB: 1213660800,
	      nB: 1246320000,
	      oB: 1264032000,
	      I: 1300752000,
	      f: 1308614400,
	      J: 1313452800,
	      E: 1317081600,
	      F: 1317081600,
	      G: 1320710400,
	      A: 1324339200,
	      B: 1327968000,
	      C: 1331596800,
	      K: 1335225600,
	      L: 1338854400,
	      D: 1342483200,
	      M: 1346112000,
	      N: 1349740800,
	      O: 1353628800,
	      g: 1357603200,
	      h: 1361232000,
	      i: 1364860800,
	      j: 1368489600,
	      k: 1372118400,
	      l: 1375747200,
	      m: 1379376000,
	      n: 1386633600,
	      o: 1391472000,
	      p: 1395100800,
	      q: 1398729600,
	      r: 1402358400,
	      s: 1405987200,
	      t: 1409616000,
	      u: 1413244800,
	      v: 1417392000,
	      w: 1421107200,
	      x: 1424736000,
	      y: 1428278400,
	      z: 1431475200,
	      AB: 1474329600,
	      BB: 1479168000,
	      CB: 1485216000,
	      DB: 1488844800,
	      EB: 1492560000,
	      FB: 1497312000,
	      GB: 1502150400,
	      HB: 1506556800,
	      IB: 1510617600,
	      JB: 1516665600,
	      eB: 1520985600,
	      KB: 1525824000,
	      fB: 1529971200,
	      LB: 1536105600,
	      MB: 1540252800,
	      S: 1544486400,
	      NB: 1548720000,
	      OB: 1552953600,
	      PB: 1558396800,
	      QB: 1562630400,
	      RB: 1567468800,
	      SB: 1571788800,
	      TB: 1575331200,
	      UB: 1578355200,
	      VB: 1581379200,
	      WB: 1583798400,
	      XB: 1586304000,
	      YB: 1588636800,
	      ZB: 1591056000,
	      aB: 1593475200,
	      P: 1595894400,
	      Q: 1598313600,
	      T: 1600732800,
	      mB: 1603152000,
	      U: 1605571200,
	      V: 1607990400,
	      W: 1611619200,
	      X: 1614038400,
	      Y: 1616457600,
	      Z: 1618790400,
	      a: 1622505600,
	      b: 1626134400,
	      c: 1628553600,
	      R: 1630972800,
	      d: 1633392000,
	      H: null,
	      e: null
	    }
	  },
	  D: {
	    A: {
	      "0": 0.004464,
	      "1": 0.012879,
	      "2": 0.0236,
	      "3": 0.004293,
	      "4": 0.008586,
	      "5": 0.004465,
	      "6": 0.004642,
	      "7": 0.004891,
	      "8": 0.012879,
	      "9": 0.021465,
	      I: 0.004706,
	      f: 0.004879,
	      J: 0.004879,
	      E: 0.005591,
	      F: 0.005591,
	      G: 0.005591,
	      A: 0.004534,
	      B: 0.004464,
	      C: 0.010424,
	      K: 0.0083,
	      L: 0.004706,
	      D: 0.015087,
	      M: 0.004393,
	      N: 0.004393,
	      O: 0.008652,
	      g: 0.004293,
	      h: 0.004393,
	      i: 0.004317,
	      j: 0.008586,
	      k: 0.008786,
	      l: 0.017172,
	      m: 0.004461,
	      n: 0.004141,
	      o: 0.004326,
	      p: 0.0047,
	      q: 0.004538,
	      r: 0.004293,
	      s: 0.008596,
	      t: 0.004566,
	      u: 0.008586,
	      v: 0.008586,
	      w: 0.017172,
	      x: 0.004335,
	      y: 0.004464,
	      z: 0.025758,
	      AB: 0.188892,
	      BB: 0.004293,
	      CB: 0.008586,
	      DB: 0.008586,
	      EB: 0.017172,
	      FB: 0.012879,
	      GB: 0.012879,
	      HB: 0.055809,
	      IB: 0.008586,
	      JB: 0.008586,
	      eB: 0.008586,
	      KB: 0.012879,
	      fB: 0.08586,
	      LB: 0.012879,
	      MB: 0.017172,
	      S: 0.021465,
	      NB: 0.025758,
	      OB: 0.025758,
	      PB: 0.017172,
	      QB: 0.012879,
	      RB: 0.068688,
	      SB: 0.051516,
	      TB: 0.021465,
	      UB: 0.047223,
	      VB: 0.012879,
	      WB: 0.077274,
	      XB: 0.090153,
	      YB: 0.060102,
	      ZB: 0.025758,
	      aB: 0.051516,
	      P: 0.206064,
	      Q: 0.08586,
	      T: 0.060102,
	      U: 0.103032,
	      V: 0.137376,
	      W: 0.218943,
	      X: 0.154548,
	      Y: 0.407835,
	      Z: 0.115911,
	      a: 0.184599,
	      b: 0.197478,
	      c: 0.588141,
	      R: 5.26751,
	      d: 15.97,
	      H: 2.60156,
	      e: 0.017172,
	      pB: 0.012879,
	      qB: 0,
	      rB: 0
	    },
	    B: "webkit",
	    C: ["", "", "", "I", "f", "J", "E", "F", "G", "A", "B", "C", "K", "L", "D", "M", "N", "O", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "eB", "KB", "fB", "LB", "MB", "S", "NB", "OB", "PB", "QB", "RB", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "P", "Q", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "R", "d", "H", "e", "pB", "qB", "rB"],
	    E: "Chrome",
	    F: {
	      "0": 1416268800,
	      "1": 1421798400,
	      "2": 1425513600,
	      "3": 1429401600,
	      "4": 1432080000,
	      "5": 1437523200,
	      "6": 1441152000,
	      "7": 1444780800,
	      "8": 1449014400,
	      "9": 1453248000,
	      I: 1264377600,
	      f: 1274745600,
	      J: 1283385600,
	      E: 1287619200,
	      F: 1291248000,
	      G: 1296777600,
	      A: 1299542400,
	      B: 1303862400,
	      C: 1307404800,
	      K: 1312243200,
	      L: 1316131200,
	      D: 1316131200,
	      M: 1319500800,
	      N: 1323734400,
	      O: 1328659200,
	      g: 1332892800,
	      h: 1337040000,
	      i: 1340668800,
	      j: 1343692800,
	      k: 1348531200,
	      l: 1352246400,
	      m: 1357862400,
	      n: 1361404800,
	      o: 1364428800,
	      p: 1369094400,
	      q: 1374105600,
	      r: 1376956800,
	      s: 1384214400,
	      t: 1389657600,
	      u: 1392940800,
	      v: 1397001600,
	      w: 1400544000,
	      x: 1405468800,
	      y: 1409011200,
	      z: 1412640000,
	      AB: 1456963200,
	      BB: 1460592000,
	      CB: 1464134400,
	      DB: 1469059200,
	      EB: 1472601600,
	      FB: 1476230400,
	      GB: 1480550400,
	      HB: 1485302400,
	      IB: 1489017600,
	      JB: 1492560000,
	      eB: 1496707200,
	      KB: 1500940800,
	      fB: 1504569600,
	      LB: 1508198400,
	      MB: 1512518400,
	      S: 1516752000,
	      NB: 1520294400,
	      OB: 1523923200,
	      PB: 1527552000,
	      QB: 1532390400,
	      RB: 1536019200,
	      SB: 1539648000,
	      TB: 1543968000,
	      UB: 1548720000,
	      VB: 1552348800,
	      WB: 1555977600,
	      XB: 1559606400,
	      YB: 1564444800,
	      ZB: 1568073600,
	      aB: 1571702400,
	      P: 1575936000,
	      Q: 1580860800,
	      T: 1586304000,
	      U: 1589846400,
	      V: 1594684800,
	      W: 1598313600,
	      X: 1601942400,
	      Y: 1605571200,
	      Z: 1611014400,
	      a: 1614556800,
	      b: 1618272000,
	      c: 1621987200,
	      R: 1626739200,
	      d: 1630368000,
	      H: 1632268800,
	      e: 1634601600,
	      pB: null,
	      qB: null,
	      rB: null
	    }
	  },
	  E: {
	    A: {
	      I: 0,
	      f: 0.004293,
	      J: 0.004656,
	      E: 0.004465,
	      F: 0.004043,
	      G: 0.004891,
	      A: 0.004425,
	      B: 0.004293,
	      C: 0.008586,
	      K: 0.072981,
	      L: 0.437886,
	      D: 0.197478,
	      sB: 0,
	      gB: 0.008692,
	      tB: 0.012879,
	      uB: 0.00456,
	      vB: 0.004283,
	      wB: 0.021465,
	      hB: 0.017172,
	      bB: 0.047223,
	      cB: 0.077274,
	      xB: 0.536625,
	      yB: 2.58868,
	      zB: 0
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "sB", "gB", "I", "f", "tB", "J", "uB", "E", "vB", "F", "G", "wB", "A", "hB", "B", "bB", "C", "cB", "K", "xB", "L", "yB", "D", "zB", "", ""],
	    E: "Safari",
	    F: {
	      sB: 1205798400,
	      gB: 1226534400,
	      I: 1244419200,
	      f: 1275868800,
	      tB: 1311120000,
	      J: 1343174400,
	      uB: 1382400000,
	      E: 1382400000,
	      vB: 1410998400,
	      F: 1413417600,
	      G: 1443657600,
	      wB: 1458518400,
	      A: 1474329600,
	      hB: 1490572800,
	      B: 1505779200,
	      bB: 1522281600,
	      C: 1537142400,
	      cB: 1553472000,
	      K: 1568851200,
	      xB: 1585008000,
	      L: 1600214400,
	      yB: 1619395200,
	      D: 1632096000,
	      zB: null
	    }
	  },
	  F: {
	    A: {
	      "0": 0.004534,
	      "1": 0.008586,
	      "2": 0.004227,
	      "3": 0.004418,
	      "4": 0.004293,
	      "5": 0.004227,
	      "6": 0.004725,
	      "7": 0.008586,
	      "8": 0.008942,
	      "9": 0.004707,
	      G: 0.0082,
	      B: 0.016581,
	      C: 0.004317,
	      D: 0.00685,
	      M: 0.00685,
	      N: 0.00685,
	      O: 0.005014,
	      g: 0.006015,
	      h: 0.004879,
	      i: 0.006597,
	      j: 0.006597,
	      k: 0.013434,
	      l: 0.006702,
	      m: 0.006015,
	      n: 0.005595,
	      o: 0.004393,
	      p: 0.008652,
	      q: 0.004879,
	      r: 0.004879,
	      s: 0.004293,
	      t: 0.005152,
	      u: 0.005014,
	      v: 0.009758,
	      w: 0.004879,
	      x: 0.008586,
	      y: 0.004283,
	      z: 0.004367,
	      AB: 0.004827,
	      BB: 0.004707,
	      CB: 0.004707,
	      DB: 0.004326,
	      EB: 0.008922,
	      FB: 0.014349,
	      GB: 0.004425,
	      HB: 0.00472,
	      IB: 0.004425,
	      JB: 0.004425,
	      KB: 0.00472,
	      LB: 0.004532,
	      MB: 0.004566,
	      S: 0.02283,
	      NB: 0.00867,
	      OB: 0.004656,
	      PB: 0.004642,
	      QB: 0.004293,
	      RB: 0.00944,
	      SB: 0.004293,
	      TB: 0.004293,
	      UB: 0.004298,
	      VB: 0.096692,
	      WB: 0.004201,
	      XB: 0.004141,
	      YB: 0.004043,
	      ZB: 0.017172,
	      aB: 0.759861,
	      P: 0.17172,
	      Q: 0,
	      "0B": 0.00685,
	      "1B": 0.004293,
	      "2B": 0.008392,
	      "3B": 0.004706,
	      bB: 0.006229,
	      iB: 0.004879,
	      "4B": 0.008786,
	      cB: 0.00472
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "G", "0B", "1B", "2B", "3B", "B", "bB", "iB", "4B", "C", "cB", "D", "M", "N", "O", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "KB", "LB", "MB", "S", "NB", "OB", "PB", "QB", "RB", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "P", "Q", "", "", ""],
	    E: "Opera",
	    F: {
	      "0": 1470096000,
	      "1": 1474329600,
	      "2": 1477267200,
	      "3": 1481587200,
	      "4": 1486425600,
	      "5": 1490054400,
	      "6": 1494374400,
	      "7": 1498003200,
	      "8": 1502236800,
	      "9": 1506470400,
	      G: 1150761600,
	      "0B": 1223424000,
	      "1B": 1251763200,
	      "2B": 1267488000,
	      "3B": 1277942400,
	      B: 1292457600,
	      bB: 1302566400,
	      iB: 1309219200,
	      "4B": 1323129600,
	      C: 1323129600,
	      cB: 1352073600,
	      D: 1372723200,
	      M: 1377561600,
	      N: 1381104000,
	      O: 1386288000,
	      g: 1390867200,
	      h: 1393891200,
	      i: 1399334400,
	      j: 1401753600,
	      k: 1405987200,
	      l: 1409616000,
	      m: 1413331200,
	      n: 1417132800,
	      o: 1422316800,
	      p: 1425945600,
	      q: 1430179200,
	      r: 1433808000,
	      s: 1438646400,
	      t: 1442448000,
	      u: 1445904000,
	      v: 1449100800,
	      w: 1454371200,
	      x: 1457308800,
	      y: 1462320000,
	      z: 1465344000,
	      AB: 1510099200,
	      BB: 1515024000,
	      CB: 1517961600,
	      DB: 1521676800,
	      EB: 1525910400,
	      FB: 1530144000,
	      GB: 1534982400,
	      HB: 1537833600,
	      IB: 1543363200,
	      JB: 1548201600,
	      KB: 1554768000,
	      LB: 1561593600,
	      MB: 1566259200,
	      S: 1570406400,
	      NB: 1573689600,
	      OB: 1578441600,
	      PB: 1583971200,
	      QB: 1587513600,
	      RB: 1592956800,
	      SB: 1595894400,
	      TB: 1600128000,
	      UB: 1603238400,
	      VB: 1613520000,
	      WB: 1612224000,
	      XB: 1616544000,
	      YB: 1619568000,
	      ZB: 1623715200,
	      aB: 1627948800,
	      P: 1631577600,
	      Q: 1633392000
	    },
	    D: {
	      G: "o",
	      B: "o",
	      C: "o",
	      "0B": "o",
	      "1B": "o",
	      "2B": "o",
	      "3B": "o",
	      bB: "o",
	      iB: "o",
	      "4B": "o",
	      cB: "o"
	    }
	  },
	  G: {
	    A: {
	      F: 0,
	      D: 0.586471,
	      gB: 0,
	      "5B": 0,
	      jB: 0.00276637,
	      "6B": 0.00829912,
	      "7B": 0.0968231,
	      "8B": 0.0248974,
	      "9B": 0.0138319,
	      AC: 0.0179814,
	      BC: 0.116188,
	      CC: 0.0428788,
	      DC: 0.131403,
	      EC: 0.0829912,
	      FC: 0.0539443,
	      GC: 0.0567107,
	      HC: 0.709575,
	      IC: 0.044262,
	      JC: 0.022131,
	      KC: 0.116188,
	      LC: 0.374844,
	      MC: 1.32924,
	      NC: 9.99906
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "gB", "5B", "jB", "6B", "7B", "8B", "F", "9B", "AC", "BC", "CC", "DC", "EC", "FC", "GC", "HC", "IC", "JC", "KC", "LC", "MC", "NC", "D", "", "", ""],
	    E: "Safari on iOS",
	    F: {
	      gB: 1270252800,
	      "5B": 1283904000,
	      jB: 1299628800,
	      "6B": 1331078400,
	      "7B": 1359331200,
	      "8B": 1394409600,
	      F: 1410912000,
	      "9B": 1413763200,
	      AC: 1442361600,
	      BC: 1458518400,
	      CC: 1473724800,
	      DC: 1490572800,
	      EC: 1505779200,
	      FC: 1522281600,
	      GC: 1537142400,
	      HC: 1553472000,
	      IC: 1568851200,
	      JC: 1572220800,
	      KC: 1580169600,
	      LC: 1585008000,
	      MC: 1600214400,
	      NC: 1619395200,
	      D: 1632096000
	    }
	  },
	  H: {
	    A: {
	      OC: 1.18887
	    },
	    B: "o",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "OC", "", "", ""],
	    E: "Opera Mini",
	    F: {
	      OC: 1426464000
	    }
	  },
	  I: {
	    A: {
	      dB: 0,
	      I: 0.0066069,
	      H: 0,
	      PC: 0,
	      QC: 0,
	      RC: 0,
	      SC: 0.0110115,
	      jB: 0.0484506,
	      TC: 0,
	      UC: 0.213623
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "PC", "QC", "RC", "dB", "I", "SC", "jB", "TC", "UC", "H", "", "", ""],
	    E: "Android Browser",
	    F: {
	      PC: 1256515200,
	      QC: 1274313600,
	      RC: 1291593600,
	      dB: 1298332800,
	      I: 1318896000,
	      SC: 1341792000,
	      jB: 1374624000,
	      TC: 1386547200,
	      UC: 1401667200,
	      H: 1632355200
	    }
	  },
	  J: {
	    A: {
	      E: 0,
	      A: 0
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "E", "A", "", "", ""],
	    E: "Blackberry Browser",
	    F: {
	      E: 1325376000,
	      A: 1359504000
	    }
	  },
	  K: {
	    A: {
	      A: 0,
	      B: 0,
	      C: 0,
	      S: 0.0111391,
	      bB: 0,
	      iB: 0,
	      cB: 0
	    },
	    B: "o",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "A", "B", "bB", "iB", "C", "cB", "S", "", "", ""],
	    E: "Opera Mobile",
	    F: {
	      A: 1287100800,
	      B: 1300752000,
	      bB: 1314835200,
	      iB: 1318291200,
	      C: 1330300800,
	      cB: 1349740800,
	      S: 1613433600
	    },
	    D: {
	      S: "webkit"
	    }
	  },
	  L: {
	    A: {
	      H: 38.0375
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "H", "", "", ""],
	    E: "Chrome for Android",
	    F: {
	      H: 1632182400
	    }
	  },
	  M: {
	    A: {
	      R: 0.279692
	    },
	    B: "moz",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "R", "", "", ""],
	    E: "Firefox for Android",
	    F: {
	      R: 1630972800
	    }
	  },
	  N: {
	    A: {
	      A: 0.0115934,
	      B: 0.022664
	    },
	    B: "ms",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "A", "B", "", "", ""],
	    E: "IE Mobile",
	    F: {
	      A: 1340150400,
	      B: 1353456000
	    }
	  },
	  O: {
	    A: {
	      VC: 1.0674
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "VC", "", "", ""],
	    E: "UC Browser for Android",
	    F: {
	      VC: 1471392000
	    },
	    D: {
	      VC: "webkit"
	    }
	  },
	  P: {
	    A: {
	      I: 0.241599,
	      WC: 0.0103543,
	      XC: 0.010304,
	      YC: 0.0735301,
	      ZC: 0.0103584,
	      aC: 0.0315129,
	      hB: 0.0105043,
	      bC: 0.126052,
	      cC: 0.0630258,
	      dC: 0.168069,
	      eC: 0.399164,
	      fC: 1.91178
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "I", "WC", "XC", "YC", "ZC", "aC", "hB", "bC", "cC", "dC", "eC", "fC", "", "", ""],
	    E: "Samsung Internet",
	    F: {
	      I: 1461024000,
	      WC: 1481846400,
	      XC: 1509408000,
	      YC: 1528329600,
	      ZC: 1546128000,
	      aC: 1554163200,
	      hB: 1567900800,
	      bC: 1582588800,
	      cC: 1593475200,
	      dC: 1605657600,
	      eC: 1618531200,
	      fC: 1629072000
	    }
	  },
	  Q: {
	    A: {
	      gC: 0.176948
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "gC", "", "", ""],
	    E: "QQ Browser",
	    F: {
	      gC: 1589846400
	    }
	  },
	  R: {
	    A: {
	      hC: 0
	    },
	    B: "webkit",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "hC", "", "", ""],
	    E: "Baidu Browser",
	    F: {
	      hC: 1491004800
	    }
	  },
	  S: {
	    A: {
	      iC: 0.097036
	    },
	    B: "moz",
	    C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "iC", "", "", ""],
	    E: "KaiOS Browser",
	    F: {
	      iC: 1527811200
	    }
	  }
	};

	const browsers = browsers$1.browsers;
	const versions$1 = browserVersions.browserVersions;

	function unpackBrowserVersions(versionsData) {
	  return Object.keys(versionsData).reduce((usage, version) => {
	    usage[versions$1[version]] = versionsData[version];
	    return usage;
	  }, {});
	}

	var agents_1 = Object.keys(agents$2).reduce((map, key) => {
	  let versionsData = agents$2[key];
	  map[browsers[key]] = Object.keys(versionsData).reduce((data, entry) => {
	    if (entry === 'A') {
	      data.usage_global = unpackBrowserVersions(versionsData[entry]);
	    } else if (entry === 'C') {
	      data.versions = versionsData[entry].reduce((list, version) => {
	        if (version === '') {
	          list.push(null);
	        } else {
	          list.push(versions$1[version]);
	        }

	        return list;
	      }, []);
	    } else if (entry === 'D') {
	      data.prefix_exceptions = unpackBrowserVersions(versionsData[entry]);
	    } else if (entry === 'E') {
	      data.browser = versionsData[entry];
	    } else if (entry === 'F') {
	      data.release_date = Object.keys(versionsData[entry]).reduce((map2, key2) => {
	        map2[versions$1[key2]] = versionsData[entry][key2];
	        return map2;
	      }, {});
	    } else {
	      data.prefix = versionsData[entry];
	    }

	    return data;
	  }, {});
	  return map;
	}, {});
	var agents$1 = {
	  agents: agents_1
	};

	var v4 = {
		start: "2015-09-08",
		lts: "2015-10-12",
		maintenance: "2017-04-01",
		end: "2018-04-30",
		codename: "Argon"
	};
	var v5 = {
		start: "2015-10-29",
		maintenance: "2016-04-30",
		end: "2016-06-30"
	};
	var v6 = {
		start: "2016-04-26",
		lts: "2016-10-18",
		maintenance: "2018-04-30",
		end: "2019-04-30",
		codename: "Boron"
	};
	var v7 = {
		start: "2016-10-25",
		maintenance: "2017-04-30",
		end: "2017-06-30"
	};
	var v8 = {
		start: "2017-05-30",
		lts: "2017-10-31",
		maintenance: "2019-01-01",
		end: "2019-12-31",
		codename: "Carbon"
	};
	var v9 = {
		start: "2017-10-01",
		maintenance: "2018-04-01",
		end: "2018-06-30"
	};
	var v10 = {
		start: "2018-04-24",
		lts: "2018-10-30",
		maintenance: "2020-05-19",
		end: "2021-04-30",
		codename: "Dubnium"
	};
	var v11 = {
		start: "2018-10-23",
		maintenance: "2019-04-22",
		end: "2019-06-01"
	};
	var v12 = {
		start: "2019-04-23",
		lts: "2019-10-21",
		maintenance: "2020-11-30",
		end: "2022-04-30",
		codename: "Erbium"
	};
	var v13 = {
		start: "2019-10-22",
		maintenance: "2020-04-01",
		end: "2020-06-01"
	};
	var v14 = {
		start: "2020-04-21",
		lts: "2020-10-27",
		maintenance: "2021-10-19",
		end: "2023-04-30",
		codename: "Fermium"
	};
	var v15 = {
		start: "2020-10-20",
		maintenance: "2021-04-01",
		end: "2021-06-01"
	};
	var v16 = {
		start: "2021-04-20",
		lts: "2021-10-26",
		maintenance: "2022-10-18",
		end: "2024-04-30",
		codename: ""
	};
	var v17 = {
		start: "2021-10-19",
		maintenance: "2022-04-01",
		end: "2022-06-01"
	};
	var v18 = {
		start: "2022-04-19",
		lts: "2022-10-25",
		maintenance: "2023-10-18",
		end: "2025-04-30",
		codename: ""
	};
	var jsEOL = {
		"v0.8": {
		start: "2012-06-25",
		end: "2014-07-31"
	},
		"v0.10": {
		start: "2013-03-11",
		end: "2016-10-31"
	},
		"v0.12": {
		start: "2015-02-06",
		end: "2016-12-31"
	},
		v4: v4,
		v5: v5,
		v6: v6,
		v7: v7,
		v8: v8,
		v9: v9,
		v10: v10,
		v11: v11,
		v12: v12,
		v13: v13,
		v14: v14,
		v15: v15,
		v16: v16,
		v17: v17,
		v18: v18
	};

	var _nodeResolve_empty = {};

	var _nodeResolve_empty$1 = /*#__PURE__*/Object.freeze({
		__proto__: null,
		'default': _nodeResolve_empty
	});

	var versions = {
	  "0.20": "39",
	  "0.21": "41",
	  "0.22": "41",
	  "0.23": "41",
	  "0.24": "41",
	  "0.25": "42",
	  "0.26": "42",
	  "0.27": "43",
	  "0.28": "43",
	  "0.29": "43",
	  "0.30": "44",
	  "0.31": "45",
	  "0.32": "45",
	  "0.33": "45",
	  "0.34": "45",
	  "0.35": "45",
	  "0.36": "47",
	  "0.37": "49",
	  "1.0": "49",
	  "1.1": "50",
	  "1.2": "51",
	  "1.3": "52",
	  "1.4": "53",
	  "1.5": "54",
	  "1.6": "56",
	  "1.7": "58",
	  "1.8": "59",
	  "2.0": "61",
	  "2.1": "61",
	  "3.0": "66",
	  "3.1": "66",
	  "4.0": "69",
	  "4.1": "69",
	  "4.2": "69",
	  "5.0": "73",
	  "6.0": "76",
	  "6.1": "76",
	  "7.0": "78",
	  "7.1": "78",
	  "7.2": "78",
	  "7.3": "78",
	  "8.0": "80",
	  "8.1": "80",
	  "8.2": "80",
	  "8.3": "80",
	  "8.4": "80",
	  "8.5": "80",
	  "9.0": "83",
	  "9.1": "83",
	  "9.2": "83",
	  "9.3": "83",
	  "9.4": "83",
	  "10.0": "85",
	  "10.1": "85",
	  "10.2": "85",
	  "10.3": "85",
	  "10.4": "85",
	  "11.0": "87",
	  "11.1": "87",
	  "11.2": "87",
	  "11.3": "87",
	  "11.4": "87",
	  "12.0": "89",
	  "13.0": "91",
	  "13.1": "91",
	  "14.0": "92"
	};

	function BrowserslistError(message) {
	  this.name = 'BrowserslistError';
	  this.message = message;
	  this.browserslist = true;

	  if (Error.captureStackTrace) {
	    Error.captureStackTrace(this, BrowserslistError);
	  }
	}

	BrowserslistError.prototype = Error.prototype;
	var error = BrowserslistError;

	function noop() {}

	var browser = {
	  loadQueries: function loadQueries() {
	    throw new error('Sharable configs are not supported in client-side build of Browserslist');
	  },
	  getStat: function getStat(opts) {
	    return opts.stats;
	  },
	  loadConfig: function loadConfig(opts) {
	    if (opts.config) {
	      throw new error('Browserslist config are not supported in client-side build');
	    }
	  },
	  loadCountry: function loadCountry() {
	    throw new error('Country statistics are not supported ' + 'in client-side build of Browserslist');
	  },
	  loadFeature: function loadFeature() {
	    throw new error('Supports queries are not available in client-side build of Browserslist');
	  },
	  currentNode: function currentNode(resolve, context) {
	    return resolve(['maintained node versions'], context)[0];
	  },
	  parseConfig: noop,
	  readConfig: noop,
	  findConfig: noop,
	  clearCaches: noop,
	  oldDataWarning: noop
	};

	var fs$1 = /*@__PURE__*/getAugmentedNamespace(_nodeResolve_empty$1);

	var agents = agents$1.agents;
	var YEAR = 365.259641 * 24 * 60 * 60 * 1000;
	var ANDROID_EVERGREEN_FIRST = 37;
	var QUERY_OR = 1;
	var QUERY_AND = 2;

	function isVersionsMatch(versionA, versionB) {
	  return (versionA + '.').indexOf(versionB + '.') === 0;
	}

	function isEolReleased(name) {
	  var version = name.slice(1);
	  return jsReleases.some(function (i) {
	    return isVersionsMatch(i.version, version);
	  });
	}

	function normalize(versions) {
	  return versions.filter(function (version) {
	    return typeof version === 'string';
	  });
	}

	function normalizeElectron(version) {
	  var versionToUse = version;

	  if (version.split('.').length === 3) {
	    versionToUse = version.split('.').slice(0, -1).join('.');
	  }

	  return versionToUse;
	}

	function nameMapper(name) {
	  return function mapName(version) {
	    return name + ' ' + version;
	  };
	}

	function getMajor(version) {
	  return parseInt(version.split('.')[0]);
	}

	function getMajorVersions(released, number) {
	  if (released.length === 0) return [];
	  var majorVersions = uniq(released.map(getMajor));
	  var minimum = majorVersions[majorVersions.length - number];

	  if (!minimum) {
	    return released;
	  }

	  var selected = [];

	  for (var i = released.length - 1; i >= 0; i--) {
	    if (minimum > getMajor(released[i])) break;
	    selected.unshift(released[i]);
	  }

	  return selected;
	}

	function uniq(array) {
	  var filtered = [];

	  for (var i = 0; i < array.length; i++) {
	    if (filtered.indexOf(array[i]) === -1) filtered.push(array[i]);
	  }

	  return filtered;
	}

	function fillUsage(result, name, data) {
	  for (var i in data) {
	    result[name + ' ' + i] = data[i];
	  }
	}

	function generateFilter(sign, version) {
	  version = parseFloat(version);

	  if (sign === '>') {
	    return function (v) {
	      return parseFloat(v) > version;
	    };
	  } else if (sign === '>=') {
	    return function (v) {
	      return parseFloat(v) >= version;
	    };
	  } else if (sign === '<') {
	    return function (v) {
	      return parseFloat(v) < version;
	    };
	  } else {
	    return function (v) {
	      return parseFloat(v) <= version;
	    };
	  }
	}

	function generateSemverFilter(sign, version) {
	  version = version.split('.').map(parseSimpleInt);
	  version[1] = version[1] || 0;
	  version[2] = version[2] || 0;

	  if (sign === '>') {
	    return function (v) {
	      v = v.split('.').map(parseSimpleInt);
	      return compareSemver(v, version) > 0;
	    };
	  } else if (sign === '>=') {
	    return function (v) {
	      v = v.split('.').map(parseSimpleInt);
	      return compareSemver(v, version) >= 0;
	    };
	  } else if (sign === '<') {
	    return function (v) {
	      v = v.split('.').map(parseSimpleInt);
	      return compareSemver(version, v) > 0;
	    };
	  } else {
	    return function (v) {
	      v = v.split('.').map(parseSimpleInt);
	      return compareSemver(version, v) >= 0;
	    };
	  }
	}

	function parseSimpleInt(x) {
	  return parseInt(x);
	}

	function compare(a, b) {
	  if (a < b) return -1;
	  if (a > b) return +1;
	  return 0;
	}

	function compareSemver(a, b) {
	  return compare(parseInt(a[0]), parseInt(b[0])) || compare(parseInt(a[1] || '0'), parseInt(b[1] || '0')) || compare(parseInt(a[2] || '0'), parseInt(b[2] || '0'));
	}

	function semverFilterLoose(operator, range) {
	  range = range.split('.').map(parseSimpleInt);

	  if (typeof range[1] === 'undefined') {
	    range[1] = 'x';
	  }

	  switch (operator) {
	    case '<=':
	      return function (version) {
	        version = version.split('.').map(parseSimpleInt);
	        return compareSemverLoose(version, range) <= 0;
	      };

	    default:
	    case '>=':
	      return function (version) {
	        version = version.split('.').map(parseSimpleInt);
	        return compareSemverLoose(version, range) >= 0;
	      };
	  }
	}

	function compareSemverLoose(version, range) {
	  if (version[0] !== range[0]) {
	    return version[0] < range[0] ? -1 : +1;
	  }

	  if (range[1] === 'x') {
	    return 0;
	  }

	  if (version[1] !== range[1]) {
	    return version[1] < range[1] ? -1 : +1;
	  }

	  return 0;
	}

	function resolveVersion(data, version) {
	  if (data.versions.indexOf(version) !== -1) {
	    return version;
	  } else if (browserslist.versionAliases[data.name][version]) {
	    return browserslist.versionAliases[data.name][version];
	  } else {
	    return false;
	  }
	}

	function normalizeVersion(data, version) {
	  var resolved = resolveVersion(data, version);

	  if (resolved) {
	    return resolved;
	  } else if (data.versions.length === 1) {
	    return data.versions[0];
	  } else {
	    return false;
	  }
	}

	function filterByYear(since, context) {
	  since = since / 1000;
	  return Object.keys(agents).reduce(function (selected, name) {
	    var data = byName(name, context);
	    if (!data) return selected;
	    var versions = Object.keys(data.releaseDate).filter(function (v) {
	      return data.releaseDate[v] >= since;
	    });
	    return selected.concat(versions.map(nameMapper(data.name)));
	  }, []);
	}

	function cloneData(data) {
	  return {
	    name: data.name,
	    versions: data.versions,
	    released: data.released,
	    releaseDate: data.releaseDate
	  };
	}

	function mapVersions(data, map) {
	  data.versions = data.versions.map(function (i) {
	    return map[i] || i;
	  });
	  data.released = data.versions.map(function (i) {
	    return map[i] || i;
	  });
	  var fixedDate = {};

	  for (var i in data.releaseDate) {
	    fixedDate[map[i] || i] = data.releaseDate[i];
	  }

	  data.releaseDate = fixedDate;
	  return data;
	}

	function byName(name, context) {
	  name = name.toLowerCase();
	  name = browserslist.aliases[name] || name;

	  if (context.mobileToDesktop && browserslist.desktopNames[name]) {
	    var desktop = browserslist.data[browserslist.desktopNames[name]];

	    if (name === 'android') {
	      return normalizeAndroidData(cloneData(browserslist.data[name]), desktop);
	    } else {
	      var cloned = cloneData(desktop);
	      cloned.name = name;

	      if (name === 'op_mob') {
	        cloned = mapVersions(cloned, {
	          '10.0-10.1': '10'
	        });
	      }

	      return cloned;
	    }
	  }

	  return browserslist.data[name];
	}

	function normalizeAndroidVersions(androidVersions, chromeVersions) {
	  var firstEvergreen = ANDROID_EVERGREEN_FIRST;
	  var last = chromeVersions[chromeVersions.length - 1];
	  return androidVersions.filter(function (version) {
	    return /^(?:[2-4]\.|[34]$)/.test(version);
	  }).concat(chromeVersions.slice(firstEvergreen - last - 1));
	}

	function normalizeAndroidData(android, chrome) {
	  android.released = normalizeAndroidVersions(android.released, chrome.released);
	  android.versions = normalizeAndroidVersions(android.versions, chrome.versions);
	  return android;
	}

	function checkName(name, context) {
	  var data = byName(name, context);
	  if (!data) throw new error('Unknown browser ' + name);
	  return data;
	}

	function unknownQuery(query) {
	  return new error('Unknown browser query `' + query + '`. ' + 'Maybe you are using old Browserslist or made typo in query.');
	}

	function filterAndroid(list, versions, context) {
	  if (context.mobileToDesktop) return list;
	  var released = browserslist.data.android.released;
	  var last = released[released.length - 1];
	  var diff = last - ANDROID_EVERGREEN_FIRST - versions;

	  if (diff > 0) {
	    return list.slice(-1);
	  } else {
	    return list.slice(diff - 1);
	  }
	}

	function resolve(queries, context) {
	  if (Array.isArray(queries)) {
	    queries = flatten(queries.map(parse$2));
	  } else {
	    queries = parse$2(queries);
	  }

	  return queries.reduce(function (result, query, index) {
	    var selection = query.queryString;
	    var isExclude = selection.indexOf('not ') === 0;

	    if (isExclude) {
	      if (index === 0) {
	        throw new error('Write any browsers query (for instance, `defaults`) ' + 'before `' + selection + '`');
	      }

	      selection = selection.slice(4);
	    }

	    for (var i = 0; i < QUERIES.length; i++) {
	      var type = QUERIES[i];
	      var match = selection.match(type.regexp);

	      if (match) {
	        var args = [context].concat(match.slice(1));
	        var array = type.select.apply(browserslist, args).map(function (j) {
	          var parts = j.split(' ');

	          if (parts[1] === '0') {
	            return parts[0] + ' ' + byName(parts[0], context).versions[0];
	          } else {
	            return j;
	          }
	        });

	        switch (query.type) {
	          case QUERY_AND:
	            if (isExclude) {
	              return result.filter(function (j) {
	                return array.indexOf(j) === -1;
	              });
	            } else {
	              return result.filter(function (j) {
	                return array.indexOf(j) !== -1;
	              });
	            }

	          case QUERY_OR:
	          default:
	            if (isExclude) {
	              var filter = {};
	              array.forEach(function (j) {
	                filter[j] = true;
	              });
	              return result.filter(function (j) {
	                return !filter[j];
	              });
	            }

	            return result.concat(array);
	        }
	      }
	    }

	    throw unknownQuery(selection);
	  }, []);
	}

	var cache = {};

	function browserslist(queries, opts) {
	  if (typeof opts === 'undefined') opts = {};

	  if (typeof opts.path === 'undefined') {
	    opts.path = fs$1.resolve ? fs$1.resolve('.') : '.';
	  }

	  if (typeof queries === 'undefined' || queries === null) {
	    var config = browserslist.loadConfig(opts);

	    if (config) {
	      queries = config;
	    } else {
	      queries = browserslist.defaults;
	    }
	  }

	  if (!(typeof queries === 'string' || Array.isArray(queries))) {
	    throw new error('Browser queries must be an array or string. Got ' + typeof queries + '.');
	  }

	  var context = {
	    ignoreUnknownVersions: opts.ignoreUnknownVersions,
	    dangerousExtend: opts.dangerousExtend,
	    mobileToDesktop: opts.mobileToDesktop,
	    path: opts.path,
	    env: opts.env
	  };
	  var stats = browser.getStat(opts, browserslist.data);

	  if (stats) {
	    context.customUsage = {};

	    for (var browser$1 in stats) {
	      fillUsage(context.customUsage, browser$1, stats[browser$1]);
	    }
	  }

	  var cacheKey = JSON.stringify([queries, context]);
	  if (cache[cacheKey]) return cache[cacheKey];
	  var result = uniq(resolve(queries, context)).sort(function (name1, name2) {
	    name1 = name1.split(' ');
	    name2 = name2.split(' ');

	    if (name1[0] === name2[0]) {
	      var version1 = name1[1].split('-')[0];
	      var version2 = name2[1].split('-')[0];
	      return compareSemver(version2.split('.'), version1.split('.'));
	    } else {
	      return compare(name1[0], name2[0]);
	    }
	  });

	  if (!browser$5.env.BROWSERSLIST_DISABLE_CACHE) {
	    cache[cacheKey] = result;
	  }

	  return result;
	}

	function parse$2(queries) {
	  var qs = [];

	  do {
	    queries = doMatch(queries, qs);
	  } while (queries);

	  return qs;
	}

	function doMatch(string, qs) {
	  var or = /^(?:,\s*|\s+or\s+)(.*)/i;
	  var and = /^\s+and\s+(.*)/i;
	  return find(string, function (parsed, n, max) {
	    if (and.test(parsed)) {
	      qs.unshift({
	        type: QUERY_AND,
	        queryString: parsed.match(and)[1]
	      });
	      return true;
	    } else if (or.test(parsed)) {
	      qs.unshift({
	        type: QUERY_OR,
	        queryString: parsed.match(or)[1]
	      });
	      return true;
	    } else if (n === max) {
	      qs.unshift({
	        type: QUERY_OR,
	        queryString: parsed.trim()
	      });
	      return true;
	    }

	    return false;
	  });
	}

	function find(string, predicate) {
	  for (var n = 1, max = string.length; n <= max; n++) {
	    var parsed = string.substr(-n, n);

	    if (predicate(parsed, n, max)) {
	      return string.slice(0, -n);
	    }
	  }

	  return '';
	}

	function flatten(array) {
	  if (!Array.isArray(array)) return [array];
	  return array.reduce(function (a, b) {
	    return a.concat(flatten(b));
	  }, []);
	}

	browserslist.cache = {};
	browserslist.data = {};
	browserslist.usage = {
	  global: {},
	  custom: null
	};
	browserslist.defaults = ['> 0.5%', 'last 2 versions', 'Firefox ESR', 'not dead'];
	browserslist.aliases = {
	  fx: 'firefox',
	  ff: 'firefox',
	  ios: 'ios_saf',
	  explorer: 'ie',
	  blackberry: 'bb',
	  explorermobile: 'ie_mob',
	  operamini: 'op_mini',
	  operamobile: 'op_mob',
	  chromeandroid: 'and_chr',
	  firefoxandroid: 'and_ff',
	  ucandroid: 'and_uc',
	  qqandroid: 'and_qq'
	};
	browserslist.desktopNames = {
	  and_chr: 'chrome',
	  and_ff: 'firefox',
	  ie_mob: 'ie',
	  op_mob: 'opera',
	  android: 'chrome'
	};
	browserslist.versionAliases = {};
	browserslist.clearCaches = browser.clearCaches;
	browserslist.parseConfig = browser.parseConfig;
	browserslist.readConfig = browser.readConfig;
	browserslist.findConfig = browser.findConfig;
	browserslist.loadConfig = browser.loadConfig;

	browserslist.coverage = function (browsers, stats) {
	  var data;

	  if (typeof stats === 'undefined') {
	    data = browserslist.usage.global;
	  } else if (stats === 'my stats') {
	    var opts = {};
	    opts.path = fs$1.resolve ? fs$1.resolve('.') : '.';
	    var customStats = browser.getStat(opts);

	    if (!customStats) {
	      throw new error('Custom usage statistics was not provided');
	    }

	    data = {};

	    for (var browser$1 in customStats) {
	      fillUsage(data, browser$1, customStats[browser$1]);
	    }
	  } else if (typeof stats === 'string') {
	    if (stats.length > 2) {
	      stats = stats.toLowerCase();
	    } else {
	      stats = stats.toUpperCase();
	    }

	    browser.loadCountry(browserslist.usage, stats, browserslist.data);
	    data = browserslist.usage[stats];
	  } else {
	    if ('dataByBrowser' in stats) {
	      stats = stats.dataByBrowser;
	    }

	    data = {};

	    for (var name in stats) {
	      for (var version in stats[name]) {
	        data[name + ' ' + version] = stats[name][version];
	      }
	    }
	  }

	  return browsers.reduce(function (all, i) {
	    var usage = data[i];

	    if (usage === undefined) {
	      usage = data[i.replace(/ \S+$/, ' 0')];
	    }

	    return all + (usage || 0);
	  }, 0);
	};

	function nodeQuery(context, version) {
	  var nodeReleases = jsReleases.filter(function (i) {
	    return i.name === 'nodejs';
	  });
	  var matched = nodeReleases.filter(function (i) {
	    return isVersionsMatch(i.version, version);
	  });

	  if (matched.length === 0) {
	    if (context.ignoreUnknownVersions) {
	      return [];
	    } else {
	      throw new error('Unknown version ' + version + ' of Node.js');
	    }
	  }

	  return ['node ' + matched[matched.length - 1].version];
	}

	function sinceQuery(context, year, month, date) {
	  year = parseInt(year);
	  month = parseInt(month || '01') - 1;
	  date = parseInt(date || '01');
	  return filterByYear(Date.UTC(year, month, date, 0, 0, 0), context);
	}

	function coverQuery(context, coverage, statMode) {
	  coverage = parseFloat(coverage);
	  var usage = browserslist.usage.global;

	  if (statMode) {
	    if (statMode.match(/^my\s+stats$/)) {
	      if (!context.customUsage) {
	        throw new error('Custom usage statistics was not provided');
	      }

	      usage = context.customUsage;
	    } else {
	      var place;

	      if (statMode.length === 2) {
	        place = statMode.toUpperCase();
	      } else {
	        place = statMode.toLowerCase();
	      }

	      browser.loadCountry(browserslist.usage, place, browserslist.data);
	      usage = browserslist.usage[place];
	    }
	  }

	  var versions = Object.keys(usage).sort(function (a, b) {
	    return usage[b] - usage[a];
	  });
	  var coveraged = 0;
	  var result = [];
	  var version;

	  for (var i = 0; i <= versions.length; i++) {
	    version = versions[i];
	    if (usage[version] === 0) break;
	    coveraged += usage[version];
	    result.push(version);
	    if (coveraged >= coverage) break;
	  }

	  return result;
	}

	var QUERIES = [{
	  regexp: /^last\s+(\d+)\s+major\s+versions?$/i,
	  select: function (context, versions) {
	    return Object.keys(agents).reduce(function (selected, name) {
	      var data = byName(name, context);
	      if (!data) return selected;
	      var list = getMajorVersions(data.released, versions);
	      list = list.map(nameMapper(data.name));

	      if (data.name === 'android') {
	        list = filterAndroid(list, versions, context);
	      }

	      return selected.concat(list);
	    }, []);
	  }
	}, {
	  regexp: /^last\s+(\d+)\s+versions?$/i,
	  select: function (context, versions) {
	    return Object.keys(agents).reduce(function (selected, name) {
	      var data = byName(name, context);
	      if (!data) return selected;
	      var list = data.released.slice(-versions);
	      list = list.map(nameMapper(data.name));

	      if (data.name === 'android') {
	        list = filterAndroid(list, versions, context);
	      }

	      return selected.concat(list);
	    }, []);
	  }
	}, {
	  regexp: /^last\s+(\d+)\s+electron\s+major\s+versions?$/i,
	  select: function (context, versions$1) {
	    var validVersions = getMajorVersions(Object.keys(versions), versions$1);
	    return validVersions.map(function (i) {
	      return 'chrome ' + versions[i];
	    });
	  }
	}, {
	  regexp: /^last\s+(\d+)\s+(\w+)\s+major\s+versions?$/i,
	  select: function (context, versions, name) {
	    var data = checkName(name, context);
	    var validVersions = getMajorVersions(data.released, versions);
	    var list = validVersions.map(nameMapper(data.name));

	    if (data.name === 'android') {
	      list = filterAndroid(list, versions, context);
	    }

	    return list;
	  }
	}, {
	  regexp: /^last\s+(\d+)\s+electron\s+versions?$/i,
	  select: function (context, versions$1) {
	    return Object.keys(versions).slice(-versions$1).map(function (i) {
	      return 'chrome ' + versions[i];
	    });
	  }
	}, {
	  regexp: /^last\s+(\d+)\s+(\w+)\s+versions?$/i,
	  select: function (context, versions, name) {
	    var data = checkName(name, context);
	    var list = data.released.slice(-versions).map(nameMapper(data.name));

	    if (data.name === 'android') {
	      list = filterAndroid(list, versions, context);
	    }

	    return list;
	  }
	}, {
	  regexp: /^unreleased\s+versions$/i,
	  select: function (context) {
	    return Object.keys(agents).reduce(function (selected, name) {
	      var data = byName(name, context);
	      if (!data) return selected;
	      var list = data.versions.filter(function (v) {
	        return data.released.indexOf(v) === -1;
	      });
	      list = list.map(nameMapper(data.name));
	      return selected.concat(list);
	    }, []);
	  }
	}, {
	  regexp: /^unreleased\s+electron\s+versions?$/i,
	  select: function () {
	    return [];
	  }
	}, {
	  regexp: /^unreleased\s+(\w+)\s+versions?$/i,
	  select: function (context, name) {
	    var data = checkName(name, context);
	    return data.versions.filter(function (v) {
	      return data.released.indexOf(v) === -1;
	    }).map(nameMapper(data.name));
	  }
	}, {
	  regexp: /^last\s+(\d*.?\d+)\s+years?$/i,
	  select: function (context, years) {
	    return filterByYear(Date.now() - YEAR * years, context);
	  }
	}, {
	  regexp: /^since (\d+)$/i,
	  select: sinceQuery
	}, {
	  regexp: /^since (\d+)-(\d+)$/i,
	  select: sinceQuery
	}, {
	  regexp: /^since (\d+)-(\d+)-(\d+)$/i,
	  select: sinceQuery
	}, {
	  regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%$/,
	  select: function (context, sign, popularity) {
	    popularity = parseFloat(popularity);
	    var usage = browserslist.usage.global;
	    return Object.keys(usage).reduce(function (result, version) {
	      if (sign === '>') {
	        if (usage[version] > popularity) {
	          result.push(version);
	        }
	      } else if (sign === '<') {
	        if (usage[version] < popularity) {
	          result.push(version);
	        }
	      } else if (sign === '<=') {
	        if (usage[version] <= popularity) {
	          result.push(version);
	        }
	      } else if (usage[version] >= popularity) {
	        result.push(version);
	      }

	      return result;
	    }, []);
	  }
	}, {
	  regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+my\s+stats$/,
	  select: function (context, sign, popularity) {
	    popularity = parseFloat(popularity);

	    if (!context.customUsage) {
	      throw new error('Custom usage statistics was not provided');
	    }

	    var usage = context.customUsage;
	    return Object.keys(usage).reduce(function (result, version) {
	      if (sign === '>') {
	        if (usage[version] > popularity) {
	          result.push(version);
	        }
	      } else if (sign === '<') {
	        if (usage[version] < popularity) {
	          result.push(version);
	        }
	      } else if (sign === '<=') {
	        if (usage[version] <= popularity) {
	          result.push(version);
	        }
	      } else if (usage[version] >= popularity) {
	        result.push(version);
	      }

	      return result;
	    }, []);
	  }
	}, {
	  regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+(\S+)\s+stats$/,
	  select: function (context, sign, popularity, name) {
	    popularity = parseFloat(popularity);
	    var stats = browser.loadStat(context, name, browserslist.data);

	    if (stats) {
	      context.customUsage = {};

	      for (var browser$1 in stats) {
	        fillUsage(context.customUsage, browser$1, stats[browser$1]);
	      }
	    }

	    if (!context.customUsage) {
	      throw new error('Custom usage statistics was not provided');
	    }

	    var usage = context.customUsage;
	    return Object.keys(usage).reduce(function (result, version) {
	      if (sign === '>') {
	        if (usage[version] > popularity) {
	          result.push(version);
	        }
	      } else if (sign === '<') {
	        if (usage[version] < popularity) {
	          result.push(version);
	        }
	      } else if (sign === '<=') {
	        if (usage[version] <= popularity) {
	          result.push(version);
	        }
	      } else if (usage[version] >= popularity) {
	        result.push(version);
	      }

	      return result;
	    }, []);
	  }
	}, {
	  regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+((alt-)?\w\w)$/,
	  select: function (context, sign, popularity, place) {
	    popularity = parseFloat(popularity);

	    if (place.length === 2) {
	      place = place.toUpperCase();
	    } else {
	      place = place.toLowerCase();
	    }

	    browser.loadCountry(browserslist.usage, place, browserslist.data);
	    var usage = browserslist.usage[place];
	    return Object.keys(usage).reduce(function (result, version) {
	      if (sign === '>') {
	        if (usage[version] > popularity) {
	          result.push(version);
	        }
	      } else if (sign === '<') {
	        if (usage[version] < popularity) {
	          result.push(version);
	        }
	      } else if (sign === '<=') {
	        if (usage[version] <= popularity) {
	          result.push(version);
	        }
	      } else if (usage[version] >= popularity) {
	        result.push(version);
	      }

	      return result;
	    }, []);
	  }
	}, {
	  regexp: /^cover\s+(\d+|\d+\.\d+|\.\d+)%$/,
	  select: coverQuery
	}, {
	  regexp: /^cover\s+(\d+|\d+\.\d+|\.\d+)%\s+in\s+(my\s+stats|(alt-)?\w\w)$/,
	  select: coverQuery
	}, {
	  regexp: /^supports\s+([\w-]+)$/,
	  select: function (context, feature) {
	    browser.loadFeature(browserslist.cache, feature);
	    var features = browserslist.cache[feature];
	    return Object.keys(features).reduce(function (result, version) {
	      var flags = features[version];

	      if (flags.indexOf('y') >= 0 || flags.indexOf('a') >= 0) {
	        result.push(version);
	      }

	      return result;
	    }, []);
	  }
	}, {
	  regexp: /^electron\s+([\d.]+)\s*-\s*([\d.]+)$/i,
	  select: function (context, from, to) {
	    var fromToUse = normalizeElectron(from);
	    var toToUse = normalizeElectron(to);

	    if (!versions[fromToUse]) {
	      throw new error('Unknown version ' + from + ' of electron');
	    }

	    if (!versions[toToUse]) {
	      throw new error('Unknown version ' + to + ' of electron');
	    }

	    from = parseFloat(from);
	    to = parseFloat(to);
	    return Object.keys(versions).filter(function (i) {
	      var parsed = parseFloat(i);
	      return parsed >= from && parsed <= to;
	    }).map(function (i) {
	      return 'chrome ' + versions[i];
	    });
	  }
	}, {
	  regexp: /^node\s+([\d.]+)\s*-\s*([\d.]+)$/i,
	  select: function (context, from, to) {
	    var nodeVersions = jsReleases.filter(function (i) {
	      return i.name === 'nodejs';
	    }).map(function (i) {
	      return i.version;
	    });
	    return nodeVersions.filter(semverFilterLoose('>=', from)).filter(semverFilterLoose('<=', to)).map(function (v) {
	      return 'node ' + v;
	    });
	  }
	}, {
	  regexp: /^(\w+)\s+([\d.]+)\s*-\s*([\d.]+)$/i,
	  select: function (context, name, from, to) {
	    var data = checkName(name, context);
	    from = parseFloat(normalizeVersion(data, from) || from);
	    to = parseFloat(normalizeVersion(data, to) || to);

	    function filter(v) {
	      var parsed = parseFloat(v);
	      return parsed >= from && parsed <= to;
	    }

	    return data.released.filter(filter).map(nameMapper(data.name));
	  }
	}, {
	  regexp: /^electron\s*(>=?|<=?)\s*([\d.]+)$/i,
	  select: function (context, sign, version) {
	    var versionToUse = normalizeElectron(version);
	    return Object.keys(versions).filter(generateFilter(sign, versionToUse)).map(function (i) {
	      return 'chrome ' + versions[i];
	    });
	  }
	}, {
	  regexp: /^node\s*(>=?|<=?)\s*([\d.]+)$/i,
	  select: function (context, sign, version) {
	    var nodeVersions = jsReleases.filter(function (i) {
	      return i.name === 'nodejs';
	    }).map(function (i) {
	      return i.version;
	    });
	    return nodeVersions.filter(generateSemverFilter(sign, version)).map(function (v) {
	      return 'node ' + v;
	    });
	  }
	}, {
	  regexp: /^(\w+)\s*(>=?|<=?)\s*([\d.]+)$/,
	  select: function (context, name, sign, version) {
	    var data = checkName(name, context);
	    var alias = browserslist.versionAliases[data.name][version];

	    if (alias) {
	      version = alias;
	    }

	    return data.released.filter(generateFilter(sign, version)).map(function (v) {
	      return data.name + ' ' + v;
	    });
	  }
	}, {
	  regexp: /^(firefox|ff|fx)\s+esr$/i,
	  select: function () {
	    return ['firefox 78', 'firefox 91'];
	  }
	}, {
	  regexp: /(operamini|op_mini)\s+all/i,
	  select: function () {
	    return ['op_mini all'];
	  }
	}, {
	  regexp: /^electron\s+([\d.]+)$/i,
	  select: function (context, version) {
	    var versionToUse = normalizeElectron(version);
	    var chrome = versions[versionToUse];

	    if (!chrome) {
	      throw new error('Unknown version ' + version + ' of electron');
	    }

	    return ['chrome ' + chrome];
	  }
	}, {
	  regexp: /^node\s+(\d+)$/i,
	  select: nodeQuery
	}, {
	  regexp: /^node\s+(\d+\.\d+)$/i,
	  select: nodeQuery
	}, {
	  regexp: /^node\s+(\d+\.\d+\.\d+)$/i,
	  select: nodeQuery
	}, {
	  regexp: /^current\s+node$/i,
	  select: function (context) {
	    return [browser.currentNode(resolve, context)];
	  }
	}, {
	  regexp: /^maintained\s+node\s+versions$/i,
	  select: function (context) {
	    var now = Date.now();
	    var queries = Object.keys(jsEOL).filter(function (key) {
	      return now < Date.parse(jsEOL[key].end) && now > Date.parse(jsEOL[key].start) && isEolReleased(key);
	    }).map(function (key) {
	      return 'node ' + key.slice(1);
	    });
	    return resolve(queries, context);
	  }
	}, {
	  regexp: /^phantomjs\s+1.9$/i,
	  select: function () {
	    return ['safari 5'];
	  }
	}, {
	  regexp: /^phantomjs\s+2.1$/i,
	  select: function () {
	    return ['safari 6'];
	  }
	}, {
	  regexp: /^(\w+)\s+(tp|[\d.]+)$/i,
	  select: function (context, name, version) {
	    if (/^tp$/i.test(version)) version = 'TP';
	    var data = checkName(name, context);
	    var alias = normalizeVersion(data, version);

	    if (alias) {
	      version = alias;
	    } else {
	      if (version.indexOf('.') === -1) {
	        alias = version + '.0';
	      } else {
	        alias = version.replace(/\.0$/, '');
	      }

	      alias = normalizeVersion(data, alias);

	      if (alias) {
	        version = alias;
	      } else if (context.ignoreUnknownVersions) {
	        return [];
	      } else {
	        throw new error('Unknown version ' + version + ' of ' + name);
	      }
	    }

	    return [data.name + ' ' + version];
	  }
	}, {
	  regexp: /^browserslist config$/i,
	  select: function (context) {
	    return browserslist(undefined, context);
	  }
	}, {
	  regexp: /^extends (.+)$/i,
	  select: function (context, name) {
	    return resolve(browser.loadQueries(context, name), context);
	  }
	}, {
	  regexp: /^defaults$/i,
	  select: function (context) {
	    return resolve(browserslist.defaults, context);
	  }
	}, {
	  regexp: /^dead$/i,
	  select: function (context) {
	    var dead = ['ie <= 10', 'ie_mob <= 11', 'bb <= 10', 'op_mob <= 12.1', 'samsung 4'];
	    return resolve(dead, context);
	  }
	}, {
	  regexp: /^(\w+)$/i,
	  select: function (context, name) {
	    if (byName(name, context)) {
	      throw new error('Specify versions in Browserslist query for browser ' + name);
	    } else {
	      throw unknownQuery(name);
	    }
	  }
	}];

	(function () {
	  for (var name in agents) {
	    var browser = agents[name];
	    browserslist.data[name] = {
	      name: name,
	      versions: normalize(agents[name].versions),
	      released: normalize(agents[name].versions.slice(0, -3)),
	      releaseDate: agents[name].release_date
	    };
	    fillUsage(browserslist.usage.global, name, browser.usage_global);
	    browserslist.versionAliases[name] = {};

	    for (var i = 0; i < browser.versions.length; i++) {
	      var full = browser.versions[i];
	      if (!full) continue;

	      if (full.indexOf('-') !== -1) {
	        var interval = full.split('-');

	        for (var j = 0; j < interval.length; j++) {
	          browserslist.versionAliases[name][interval[j]] = full;
	        }
	      }
	    }
	  }

	  browserslist.versionAliases.op_mob['59'] = '58';
	})();

	var browserslist_1 = browserslist;

	const {
	  min
	} = Math;

	function levenshtein(a, b) {
	  let t = [],
	      u = [],
	      i,
	      j;
	  const m = a.length,
	        n = b.length;

	  if (!m) {
	    return n;
	  }

	  if (!n) {
	    return m;
	  }

	  for (j = 0; j <= n; j++) {
	    t[j] = j;
	  }

	  for (i = 1; i <= m; i++) {
	    for (u = [i], j = 1; j <= n; j++) {
	      u[j] = a[i - 1] === b[j - 1] ? t[j - 1] : min(t[j - 1], t[j], u[j - 1]) + 1;
	    }

	    t = u;
	  }

	  return u[n];
	}

	function findSuggestion(str, arr) {
	  const distances = arr.map(el => levenshtein(el, str));
	  return arr[distances.indexOf(min(...distances))];
	}

	class OptionValidator {
	  constructor(descriptor) {
	    this.descriptor = descriptor;
	  }

	  validateTopLevelOptions(options, TopLevelOptionShape) {
	    const validOptionNames = Object.keys(TopLevelOptionShape);

	    for (const option of Object.keys(options)) {
	      if (!validOptionNames.includes(option)) {
	        throw new Error(this.formatMessage(`'${option}' is not a valid top-level option.
- Did you mean '${findSuggestion(option, validOptionNames)}'?`));
	      }
	    }
	  }

	  validateBooleanOption(name, value, defaultValue) {
	    if (value === undefined) {
	      return defaultValue;
	    } else {
	      this.invariant(typeof value === "boolean", `'${name}' option must be a boolean.`);
	    }

	    return value;
	  }

	  validateStringOption(name, value, defaultValue) {
	    if (value === undefined) {
	      return defaultValue;
	    } else {
	      this.invariant(typeof value === "string", `'${name}' option must be a string.`);
	    }

	    return value;
	  }

	  invariant(condition, message) {
	    if (!condition) {
	      throw new Error(this.formatMessage(message));
	    }
	  }

	  formatMessage(message) {
	    return `${this.descriptor}: ${message}`;
	  }

	}

	var require$$0 = {
		"es6.module": {
		chrome: "61",
		and_chr: "61",
		edge: "16",
		firefox: "60",
		and_ff: "60",
		node: "13.2.0",
		opera: "48",
		op_mob: "48",
		safari: "10.1",
		ios: "10.3",
		samsung: "8.2",
		android: "61",
		electron: "2.0",
		ios_saf: "10.3"
	}
	};

	var nativeModules = require$$0;

	function bool(value) {
	  if (value == null) return false;
	  return value && value !== "false" && value !== "0";
	}

	var semver = bool(browser$5.env["BABEL_8_BREAKING"]) ? semverBABEL_8_BREAKINGTrue : semver$2;

	const unreleasedLabels = {
	  safari: "tp"
	};
	const browserNameMap = {
	  and_chr: "chrome",
	  and_ff: "firefox",
	  android: "android",
	  chrome: "chrome",
	  edge: "edge",
	  firefox: "firefox",
	  ie: "ie",
	  ie_mob: "ie",
	  ios_saf: "ios",
	  node: "node",
	  op_mob: "opera",
	  opera: "opera",
	  safari: "safari",
	  samsung: "samsung"
	};

	const versionRegExp = /^(\d+|\d+.\d+)$/;
	const v$1 = new OptionValidator("@babel/helper-compilation-targets");
	function semverMin(first, second) {
	  return first && semver.lt(first, second) ? first : second;
	}
	function semverify(version) {
	  if (typeof version === "string" && semver.valid(version)) {
	    return version;
	  }

	  v$1.invariant(typeof version === "number" || typeof version === "string" && versionRegExp.test(version), `'${version}' is not a valid version`);
	  const split = version.toString().split(".");

	  while (split.length < 3) {
	    split.push("0");
	  }

	  return split.join(".");
	}
	function isUnreleasedVersion(version, env) {
	  const unreleasedLabel = unreleasedLabels[env];
	  return !!unreleasedLabel && unreleasedLabel === version.toString().toLowerCase();
	}
	function getLowestUnreleased(a, b, env) {
	  const unreleasedLabel = unreleasedLabels[env];
	  const hasUnreleased = [a, b].some(item => item === unreleasedLabel);

	  if (hasUnreleased) {
	    return a === hasUnreleased ? b : a || b;
	  }

	  return semverMin(a, b);
	}
	function getHighestUnreleased(a, b, env) {
	  return getLowestUnreleased(a, b, env) === a ? b : a;
	}

	const TargetNames = {
	  node: "node",
	  chrome: "chrome",
	  opera: "opera",
	  edge: "edge",
	  firefox: "firefox",
	  safari: "safari",
	  ie: "ie",
	  ios: "ios",
	  android: "android",
	  electron: "electron",
	  samsung: "samsung",
	  rhino: "rhino"
	};

	const ESM_SUPPORT = nativeModules["es6.module"];
	const v = new OptionValidator("@babel/helper-compilation-targets");

	function validateTargetNames(targets) {
	  const validTargets = Object.keys(TargetNames);

	  for (const target of Object.keys(targets)) {
	    if (!(target in TargetNames)) {
	      throw new Error(v.formatMessage(`'${target}' is not a valid target
- Did you mean '${findSuggestion(target, validTargets)}'?`));
	    }
	  }

	  return targets;
	}

	function isBrowsersQueryValid(browsers) {
	  return typeof browsers === "string" || Array.isArray(browsers) && browsers.every(b => typeof b === "string");
	}

	function validateBrowsers(browsers) {
	  v.invariant(browsers === undefined || isBrowsersQueryValid(browsers), `'${String(browsers)}' is not a valid browserslist query`);
	  return browsers;
	}

	function getLowestVersions(browsers) {
	  return browsers.reduce((all, browser) => {
	    const [browserName, browserVersion] = browser.split(" ");
	    const normalizedBrowserName = browserNameMap[browserName];

	    if (!normalizedBrowserName) {
	      return all;
	    }

	    try {
	      const splitVersion = browserVersion.split("-")[0].toLowerCase();
	      const isSplitUnreleased = isUnreleasedVersion(splitVersion, browserName);

	      if (!all[normalizedBrowserName]) {
	        all[normalizedBrowserName] = isSplitUnreleased ? splitVersion : semverify(splitVersion);
	        return all;
	      }

	      const version = all[normalizedBrowserName];
	      const isUnreleased = isUnreleasedVersion(version, browserName);

	      if (isUnreleased && isSplitUnreleased) {
	        all[normalizedBrowserName] = getLowestUnreleased(version, splitVersion, browserName);
	      } else if (isUnreleased) {
	        all[normalizedBrowserName] = semverify(splitVersion);
	      } else if (!isUnreleased && !isSplitUnreleased) {
	        const parsedBrowserVersion = semverify(splitVersion);
	        all[normalizedBrowserName] = semverMin(version, parsedBrowserVersion);
	      }
	    } catch (e) {}

	    return all;
	  }, {});
	}

	function outputDecimalWarning(decimalTargets) {
	  if (!decimalTargets.length) {
	    return;
	  }

	  console.warn("Warning, the following targets are using a decimal version:\n");
	  decimalTargets.forEach(({
	    target,
	    value
	  }) => console.warn(`  ${target}: ${value}`));
	  console.warn(`
We recommend using a string for minor/patch versions to avoid numbers like 6.10
getting parsed as 6.1, which can lead to unexpected behavior.
`);
	}

	function semverifyTarget(target, value) {
	  try {
	    return semverify(value);
	  } catch (error) {
	    throw new Error(v.formatMessage(`'${value}' is not a valid value for 'targets.${target}'.`));
	  }
	}

	const targetParserMap = {
	  __default(target, value) {
	    const version = isUnreleasedVersion(value, target) ? value.toLowerCase() : semverifyTarget(target, value);
	    return [target, version];
	  },

	  node(target, value) {
	    const parsed = value === true || value === "current" ? browser$5.versions.node : semverifyTarget(target, value);
	    return [target, parsed];
	  }

	};

	function generateTargets(inputTargets) {
	  const input = { ...inputTargets
	  };
	  delete input.esmodules;
	  delete input.browsers;
	  return input;
	}

	function resolveTargets$1(queries, env) {
	  const resolved = browserslist_1(queries, {
	    mobileToDesktop: true,
	    env
	  });
	  return getLowestVersions(resolved);
	}

	function getTargets(inputTargets = {}, options = {}) {
	  let {
	    browsers,
	    esmodules
	  } = inputTargets;
	  const {
	    configPath = "."
	  } = options;
	  validateBrowsers(browsers);
	  const input = generateTargets(inputTargets);
	  let targets = validateTargetNames(input);
	  const shouldParseBrowsers = !!browsers;
	  const hasTargets = shouldParseBrowsers || Object.keys(targets).length > 0;
	  const shouldSearchForConfig = !options.ignoreBrowserslistConfig && !hasTargets;

	  if (!browsers && shouldSearchForConfig) {
	    browsers = browserslist_1.loadConfig({
	      config: options.configFile,
	      path: configPath,
	      env: options.browserslistEnv
	    });

	    if (browsers == null) {
	      if (browser$5.env.BABEL_8_BREAKING) {
	        browsers = ["defaults, not ie 11"];
	      } else {
	        browsers = [];
	      }
	    }
	  }

	  if (esmodules && (esmodules !== "intersect" || !browsers?.length)) {
	    browsers = Object.keys(ESM_SUPPORT).map(browser => `${browser} >= ${ESM_SUPPORT[browser]}`).join(", ");
	    esmodules = false;
	  }

	  if (browsers) {
	    const queryBrowsers = resolveTargets$1(browsers, options.browserslistEnv);

	    if (esmodules === "intersect") {
	      for (const browser of Object.keys(queryBrowsers)) {
	        const version = queryBrowsers[browser];

	        if (ESM_SUPPORT[browser]) {
	          queryBrowsers[browser] = getHighestUnreleased(version, semverify(ESM_SUPPORT[browser]), browser);
	        } else {
	          delete queryBrowsers[browser];
	        }
	      }
	    }

	    targets = Object.assign(queryBrowsers, targets);
	  }

	  const result = {};
	  const decimalWarnings = [];

	  for (const target of Object.keys(targets).sort()) {
	    const value = targets[target];

	    if (typeof value === "number" && value % 1 !== 0) {
	      decimalWarnings.push({
	        target,
	        value
	      });
	    }

	    const parser = targetParserMap[target] ?? targetParserMap.__default;
	    const [parsedTarget, parsedValue] = parser(target, value);

	    if (parsedValue) {
	      result[parsedTarget] = parsedValue;
	    }
	  }

	  outputDecimalWarning(decimalWarnings);
	  return result;
	}

	function resolveBrowserslistConfigFile(browserslistConfigFile, configFilePath) {
	  return undefined;
	}
	function resolveTargets(options, root) {
	  let targets = options.targets;

	  if (typeof targets === "string" || Array.isArray(targets)) {
	    targets = {
	      browsers: targets
	    };
	  }

	  if (targets && targets.esmodules) {
	    targets = { ...targets,
	      esmodules: "intersect"
	    };
	  }

	  return getTargets(targets, {
	    ignoreBrowserslistConfig: true,
	    browserslistEnv: options.browserslistEnv
	  });
	}

	function isEqualDescriptor(a, b) {
	  return a.name === b.name && a.value === b.value && a.options === b.options && a.dirname === b.dirname && a.alias === b.alias && a.ownPass === b.ownPass && (a.file && a.file.request) === (b.file && b.file.request) && (a.file && a.file.resolved) === (b.file && b.file.resolved);
	}

	function* handlerOf(value) {
	  return value;
	}

	function optionsWithResolvedBrowserslistConfigFile(options, dirname) {
	  if (typeof options.browserslistConfigFile === "string") {
	    options.browserslistConfigFile = resolveBrowserslistConfigFile(options.browserslistConfigFile);
	  }

	  return options;
	}

	function createCachedDescriptors(dirname, options, alias) {
	  const {
	    plugins,
	    presets,
	    passPerPreset
	  } = options;
	  return {
	    options: optionsWithResolvedBrowserslistConfigFile(options),
	    plugins: plugins ? () => createCachedPluginDescriptors(plugins, dirname)(alias) : () => handlerOf([]),
	    presets: presets ? () => createCachedPresetDescriptors(presets, dirname)(alias)(!!passPerPreset) : () => handlerOf([])
	  };
	}
	function createUncachedDescriptors(dirname, options, alias) {
	  let plugins;
	  let presets;
	  return {
	    options: optionsWithResolvedBrowserslistConfigFile(options),

	    *plugins() {
	      if (!plugins) {
	        plugins = yield* createPluginDescriptors(options.plugins || [], dirname, alias);
	      }

	      return plugins;
	    },

	    *presets() {
	      if (!presets) {
	        presets = yield* createPresetDescriptors(options.presets || [], dirname, alias, !!options.passPerPreset);
	      }

	      return presets;
	    }

	  };
	}
	const PRESET_DESCRIPTOR_CACHE = new WeakMap();
	const createCachedPresetDescriptors = makeWeakCacheSync((items, cache) => {
	  const dirname = cache.using(dir => dir);
	  return makeStrongCacheSync(alias => makeStrongCache(function* (passPerPreset) {
	    const descriptors = yield* createPresetDescriptors(items, dirname, alias, passPerPreset);
	    return descriptors.map(desc => loadCachedDescriptor(PRESET_DESCRIPTOR_CACHE, desc));
	  }));
	});
	const PLUGIN_DESCRIPTOR_CACHE = new WeakMap();
	const createCachedPluginDescriptors = makeWeakCacheSync((items, cache) => {
	  const dirname = cache.using(dir => dir);
	  return makeStrongCache(function* (alias) {
	    const descriptors = yield* createPluginDescriptors(items, dirname, alias);
	    return descriptors.map(desc => loadCachedDescriptor(PLUGIN_DESCRIPTOR_CACHE, desc));
	  });
	});
	const DEFAULT_OPTIONS = {};

	function loadCachedDescriptor(cache, desc) {
	  const {
	    value,
	    options = DEFAULT_OPTIONS
	  } = desc;
	  if (options === false) return desc;
	  let cacheByOptions = cache.get(value);

	  if (!cacheByOptions) {
	    cacheByOptions = new WeakMap();
	    cache.set(value, cacheByOptions);
	  }

	  let possibilities = cacheByOptions.get(options);

	  if (!possibilities) {
	    possibilities = [];
	    cacheByOptions.set(options, possibilities);
	  }

	  if (possibilities.indexOf(desc) === -1) {
	    const matches = possibilities.filter(possibility => isEqualDescriptor(possibility, desc));

	    if (matches.length > 0) {
	      return matches[0];
	    }

	    possibilities.push(desc);
	  }

	  return desc;
	}

	function* createPresetDescriptors(items, dirname, alias, passPerPreset) {
	  return yield* createDescriptors("preset", items, dirname, alias, passPerPreset);
	}

	function* createPluginDescriptors(items, dirname, alias) {
	  return yield* createDescriptors("plugin", items, dirname, alias);
	}

	function* createDescriptors(type, items, dirname, alias, ownPass) {
	  const descriptors = yield* gensync.all(items.map((item, index) => createDescriptor(item, dirname, {
	    type,
	    alias: `${alias}$${index}`,
	    ownPass: !!ownPass
	  })));
	  assertNoDuplicates(descriptors);
	  return descriptors;
	}

	function* createDescriptor(pair, dirname, {
	  type,
	  alias,
	  ownPass
	}) {
	  const desc = getItemDescriptor(pair);

	  if (desc) {
	    return desc;
	  }

	  let name;
	  let options;
	  let value = pair;

	  if (Array.isArray(value)) {
	    if (value.length === 3) {
	      [value, options, name] = value;
	    } else {
	      [value, options] = value;
	    }
	  }

	  let file = undefined;
	  let filepath = null;

	  if (typeof value === "string") {
	    if (typeof type !== "string") {
	      throw new Error("To resolve a string-based item, the type of item must be given");
	    }

	    const resolver = type === "plugin" ? loadPlugin : loadPreset;
	    const request = value;
	    ({
	      filepath,
	      value
	    } = yield* resolver(value, dirname));
	    file = {
	      request,
	      resolved: filepath
	    };
	  }

	  if (!value) {
	    throw new Error(`Unexpected falsy value: ${String(value)}`);
	  }

	  if (typeof value === "object" && value.__esModule) {
	    if (value.default) {
	      value = value.default;
	    } else {
	      throw new Error("Must export a default export when using ES6 modules.");
	    }
	  }

	  if (typeof value !== "object" && typeof value !== "function") {
	    throw new Error(`Unsupported format: ${typeof value}. Expected an object or a function.`);
	  }

	  if (filepath !== null && typeof value === "object" && value) {
	    throw new Error(`Plugin/Preset files are not allowed to export objects, only functions. In ${filepath}`);
	  }

	  return {
	    name,
	    alias: filepath || alias,
	    value,
	    options,
	    dirname,
	    ownPass,
	    file
	  };
	}

	function assertNoDuplicates(items) {
	  const map = new Map();

	  for (const item of items) {
	    if (typeof item.value !== "function") continue;
	    let nameMap = map.get(item.value);

	    if (!nameMap) {
	      nameMap = new Set();
	      map.set(item.value, nameMap);
	    }

	    if (nameMap.has(item.name)) {
	      const conflicts = items.filter(i => i.value === item.value);
	      throw new Error([`Duplicate plugin/preset detected.`, `If you'd like to use two separate instances of a plugin,`, `they need separate names, e.g.`, ``, `  plugins: [`, `    ['some-plugin', {}],`, `    ['some-plugin', {}, 'some unique name'],`, `  ]`, ``, `Duplicates detected are:`, `${JSON.stringify(conflicts, null, 2)}`].join("\n"));
	    }

	    nameMap.add(item.name);
	  }
	}

	function createItemFromDescriptor(desc) {
	  return new ConfigItem(desc);
	}
	function* createConfigItem$1(value, {
	  dirname = ".",
	  type
	} = {}) {
	  const descriptor = yield* createDescriptor(value, path$1.resolve(dirname), {
	    type,
	    alias: "programmatic item"
	  });
	  return createItemFromDescriptor(descriptor);
	}
	function getItemDescriptor(item) {
	  if (item?.[CONFIG_ITEM_BRAND]) {
	    return item._descriptor;
	  }

	  return undefined;
	}
	const CONFIG_ITEM_BRAND = Symbol.for("@babel/core@7 - ConfigItem");

	class ConfigItem {
	  _descriptor;
	  [CONFIG_ITEM_BRAND] = true;
	  value;
	  options;
	  dirname;
	  name;
	  file;

	  constructor(descriptor) {
	    this._descriptor = descriptor;
	    Object.defineProperty(this, "_descriptor", {
	      enumerable: false
	    });
	    Object.defineProperty(this, CONFIG_ITEM_BRAND, {
	      enumerable: false
	    });
	    this.value = this._descriptor.value;
	    this.options = this._descriptor.options;
	    this.dirname = this._descriptor.dirname;
	    this.name = this._descriptor.name;
	    this.file = this._descriptor.file ? {
	      request: this._descriptor.file.request,
	      resolved: this._descriptor.file.resolved
	    } : undefined;
	    Object.freeze(this);
	  }

	}

	Object.freeze(ConfigItem.prototype);

	var removed = {
	  auxiliaryComment: {
	    message: "Use `auxiliaryCommentBefore` or `auxiliaryCommentAfter`"
	  },
	  blacklist: {
	    message: "Put the specific transforms you want in the `plugins` option"
	  },
	  breakConfig: {
	    message: "This is not a necessary option in Babel 6"
	  },
	  experimental: {
	    message: "Put the specific transforms you want in the `plugins` option"
	  },
	  externalHelpers: {
	    message: "Use the `external-helpers` plugin instead. " + "Check out http://babeljs.io/docs/plugins/external-helpers/"
	  },
	  extra: {
	    message: ""
	  },
	  jsxPragma: {
	    message: "use the `pragma` option in the `react-jsx` plugin. " + "Check out http://babeljs.io/docs/plugins/transform-react-jsx/"
	  },
	  loose: {
	    message: "Specify the `loose` option for the relevant plugin you are using " + "or use a preset that sets the option."
	  },
	  metadataUsedHelpers: {
	    message: "Not required anymore as this is enabled by default"
	  },
	  modules: {
	    message: "Use the corresponding module transform plugin in the `plugins` option. " + "Check out http://babeljs.io/docs/plugins/#modules"
	  },
	  nonStandard: {
	    message: "Use the `react-jsx` and `flow-strip-types` plugins to support JSX and Flow. " + "Also check out the react preset http://babeljs.io/docs/plugins/preset-react/"
	  },
	  optional: {
	    message: "Put the specific transforms you want in the `plugins` option"
	  },
	  sourceMapName: {
	    message: "The `sourceMapName` option has been removed because it makes more sense for the " + "tooling that calls Babel to assign `map.file` themselves."
	  },
	  stage: {
	    message: "Check out the corresponding stage-x presets http://babeljs.io/docs/plugins/#presets"
	  },
	  whitelist: {
	    message: "Put the specific transforms you want in the `plugins` option"
	  },
	  resolveModuleSource: {
	    version: 6,
	    message: "Use `babel-plugin-module-resolver@3`'s 'resolvePath' options"
	  },
	  metadata: {
	    version: 6,
	    message: "Generated plugin metadata is always included in the output result"
	  },
	  sourceMapTarget: {
	    version: 6,
	    message: "The `sourceMapTarget` option has been removed because it makes more sense for the tooling " + "that calls Babel to assign `map.file` themselves."
	  }
	};

	function msg(loc) {
	  switch (loc.type) {
	    case "root":
	      return ``;

	    case "env":
	      return `${msg(loc.parent)}.env["${loc.name}"]`;

	    case "overrides":
	      return `${msg(loc.parent)}.overrides[${loc.index}]`;

	    case "option":
	      return `${msg(loc.parent)}.${loc.name}`;

	    case "access":
	      return `${msg(loc.parent)}[${JSON.stringify(loc.name)}]`;

	    default:
	      throw new Error(`Assertion failure: Unknown type ${loc.type}`);
	  }
	}
	function access(loc, name) {
	  return {
	    type: "access",
	    name,
	    parent: loc
	  };
	}
	function assertRootMode(loc, value) {
	  if (value !== undefined && value !== "root" && value !== "upward" && value !== "upward-optional") {
	    throw new Error(`${msg(loc)} must be a "root", "upward", "upward-optional" or undefined`);
	  }

	  return value;
	}
	function assertSourceMaps(loc, value) {
	  if (value !== undefined && typeof value !== "boolean" && value !== "inline" && value !== "both") {
	    throw new Error(`${msg(loc)} must be a boolean, "inline", "both", or undefined`);
	  }

	  return value;
	}
	function assertCompact(loc, value) {
	  if (value !== undefined && typeof value !== "boolean" && value !== "auto") {
	    throw new Error(`${msg(loc)} must be a boolean, "auto", or undefined`);
	  }

	  return value;
	}
	function assertSourceType(loc, value) {
	  if (value !== undefined && value !== "module" && value !== "script" && value !== "unambiguous") {
	    throw new Error(`${msg(loc)} must be "module", "script", "unambiguous", or undefined`);
	  }

	  return value;
	}
	function assertCallerMetadata(loc, value) {
	  const obj = assertObject(loc, value);

	  if (obj) {
	    if (typeof obj.name !== "string") {
	      throw new Error(`${msg(loc)} set but does not contain "name" property string`);
	    }

	    for (const prop of Object.keys(obj)) {
	      const propLoc = access(loc, prop);
	      const value = obj[prop];

	      if (value != null && typeof value !== "boolean" && typeof value !== "string" && typeof value !== "number") {
	        throw new Error(`${msg(propLoc)} must be null, undefined, a boolean, a string, or a number.`);
	      }
	    }
	  }

	  return value;
	}
	function assertInputSourceMap(loc, value) {
	  if (value !== undefined && typeof value !== "boolean" && (typeof value !== "object" || !value)) {
	    throw new Error(`${msg(loc)} must be a boolean, object, or undefined`);
	  }

	  return value;
	}
	function assertString(loc, value) {
	  if (value !== undefined && typeof value !== "string") {
	    throw new Error(`${msg(loc)} must be a string, or undefined`);
	  }

	  return value;
	}
	function assertFunction(loc, value) {
	  if (value !== undefined && typeof value !== "function") {
	    throw new Error(`${msg(loc)} must be a function, or undefined`);
	  }

	  return value;
	}
	function assertBoolean(loc, value) {
	  if (value !== undefined && typeof value !== "boolean") {
	    throw new Error(`${msg(loc)} must be a boolean, or undefined`);
	  }

	  return value;
	}
	function assertObject(loc, value) {
	  if (value !== undefined && (typeof value !== "object" || Array.isArray(value) || !value)) {
	    throw new Error(`${msg(loc)} must be an object, or undefined`);
	  }

	  return value;
	}
	function assertArray(loc, value) {
	  if (value != null && !Array.isArray(value)) {
	    throw new Error(`${msg(loc)} must be an array, or undefined`);
	  }

	  return value;
	}
	function assertIgnoreList(loc, value) {
	  const arr = assertArray(loc, value);

	  if (arr) {
	    arr.forEach((item, i) => assertIgnoreItem(access(loc, i), item));
	  }

	  return arr;
	}

	function assertIgnoreItem(loc, value) {
	  if (typeof value !== "string" && typeof value !== "function" && !(value instanceof RegExp)) {
	    throw new Error(`${msg(loc)} must be an array of string/Function/RegExp values, or undefined`);
	  }

	  return value;
	}

	function assertConfigApplicableTest(loc, value) {
	  if (value === undefined) return value;

	  if (Array.isArray(value)) {
	    value.forEach((item, i) => {
	      if (!checkValidTest(item)) {
	        throw new Error(`${msg(access(loc, i))} must be a string/Function/RegExp.`);
	      }
	    });
	  } else if (!checkValidTest(value)) {
	    throw new Error(`${msg(loc)} must be a string/Function/RegExp, or an array of those`);
	  }

	  return value;
	}

	function checkValidTest(value) {
	  return typeof value === "string" || typeof value === "function" || value instanceof RegExp;
	}

	function assertConfigFileSearch(loc, value) {
	  if (value !== undefined && typeof value !== "boolean" && typeof value !== "string") {
	    throw new Error(`${msg(loc)} must be a undefined, a boolean, a string, ` + `got ${JSON.stringify(value)}`);
	  }

	  return value;
	}
	function assertBabelrcSearch(loc, value) {
	  if (value === undefined || typeof value === "boolean") return value;

	  if (Array.isArray(value)) {
	    value.forEach((item, i) => {
	      if (!checkValidTest(item)) {
	        throw new Error(`${msg(access(loc, i))} must be a string/Function/RegExp.`);
	      }
	    });
	  } else if (!checkValidTest(value)) {
	    throw new Error(`${msg(loc)} must be a undefined, a boolean, a string/Function/RegExp ` + `or an array of those, got ${JSON.stringify(value)}`);
	  }

	  return value;
	}
	function assertPluginList(loc, value) {
	  const arr = assertArray(loc, value);

	  if (arr) {
	    arr.forEach((item, i) => assertPluginItem(access(loc, i), item));
	  }

	  return arr;
	}

	function assertPluginItem(loc, value) {
	  if (Array.isArray(value)) {
	    if (value.length === 0) {
	      throw new Error(`${msg(loc)} must include an object`);
	    }

	    if (value.length > 3) {
	      throw new Error(`${msg(loc)} may only be a two-tuple or three-tuple`);
	    }

	    assertPluginTarget(access(loc, 0), value[0]);

	    if (value.length > 1) {
	      const opts = value[1];

	      if (opts !== undefined && opts !== false && (typeof opts !== "object" || Array.isArray(opts) || opts === null)) {
	        throw new Error(`${msg(access(loc, 1))} must be an object, false, or undefined`);
	      }
	    }

	    if (value.length === 3) {
	      const name = value[2];

	      if (name !== undefined && typeof name !== "string") {
	        throw new Error(`${msg(access(loc, 2))} must be a string, or undefined`);
	      }
	    }
	  } else {
	    assertPluginTarget(loc, value);
	  }

	  return value;
	}

	function assertPluginTarget(loc, value) {
	  if ((typeof value !== "object" || !value) && typeof value !== "string" && typeof value !== "function") {
	    throw new Error(`${msg(loc)} must be a string, object, function`);
	  }

	  return value;
	}

	function assertTargets(loc, value) {
	  if (isBrowsersQueryValid(value)) return value;

	  if (typeof value !== "object" || !value || Array.isArray(value)) {
	    throw new Error(`${msg(loc)} must be a string, an array of strings or an object`);
	  }

	  const browsersLoc = access(loc, "browsers");
	  const esmodulesLoc = access(loc, "esmodules");
	  assertBrowsersList(browsersLoc, value.browsers);
	  assertBoolean(esmodulesLoc, value.esmodules);

	  for (const key of Object.keys(value)) {
	    const val = value[key];
	    const subLoc = access(loc, key);
	    if (key === "esmodules") assertBoolean(subLoc, val);else if (key === "browsers") assertBrowsersList(subLoc, val);else if (!Object.hasOwnProperty.call(TargetNames, key)) {
	      const validTargets = Object.keys(TargetNames).join(", ");
	      throw new Error(`${msg(subLoc)} is not a valid target. Supported targets are ${validTargets}`);
	    } else assertBrowserVersion(subLoc, val);
	  }

	  return value;
	}

	function assertBrowsersList(loc, value) {
	  if (value !== undefined && !isBrowsersQueryValid(value)) {
	    throw new Error(`${msg(loc)} must be undefined, a string or an array of strings`);
	  }
	}

	function assertBrowserVersion(loc, value) {
	  if (typeof value === "number" && Math.round(value) === value) return;
	  if (typeof value === "string") return;
	  throw new Error(`${msg(loc)} must be a string or an integer number`);
	}

	function assertAssumptions(loc, value) {
	  if (value === undefined) return;

	  if (typeof value !== "object" || value === null) {
	    throw new Error(`${msg(loc)} must be an object or undefined.`);
	  }

	  let root = loc;

	  do {
	    root = root.parent;
	  } while (root.type !== "root");

	  const inPreset = root.source === "preset";

	  for (const name of Object.keys(value)) {
	    const subLoc = access(loc, name);

	    if (!assumptionsNames.has(name)) {
	      throw new Error(`${msg(subLoc)} is not a supported assumption.`);
	    }

	    if (typeof value[name] !== "boolean") {
	      throw new Error(`${msg(subLoc)} must be a boolean.`);
	    }

	    if (inPreset && value[name] === false) {
	      throw new Error(`${msg(subLoc)} cannot be set to 'false' inside presets.`);
	    }
	  }

	  return value;
	}

	const ROOT_VALIDATORS = {
	  cwd: assertString,
	  root: assertString,
	  rootMode: assertRootMode,
	  configFile: assertConfigFileSearch,
	  caller: assertCallerMetadata,
	  filename: assertString,
	  filenameRelative: assertString,
	  code: assertBoolean,
	  ast: assertBoolean,
	  cloneInputAst: assertBoolean,
	  envName: assertString
	};
	const BABELRC_VALIDATORS = {
	  babelrc: assertBoolean,
	  babelrcRoots: assertBabelrcSearch
	};
	const NONPRESET_VALIDATORS = {
	  extends: assertString,
	  ignore: assertIgnoreList,
	  only: assertIgnoreList,
	  targets: assertTargets,
	  browserslistConfigFile: assertConfigFileSearch,
	  browserslistEnv: assertString
	};
	const COMMON_VALIDATORS = {
	  inputSourceMap: assertInputSourceMap,
	  presets: assertPluginList,
	  plugins: assertPluginList,
	  passPerPreset: assertBoolean,
	  assumptions: assertAssumptions,
	  env: assertEnvSet,
	  overrides: assertOverridesList,
	  test: assertConfigApplicableTest,
	  include: assertConfigApplicableTest,
	  exclude: assertConfigApplicableTest,
	  retainLines: assertBoolean,
	  comments: assertBoolean,
	  shouldPrintComment: assertFunction,
	  compact: assertCompact,
	  minified: assertBoolean,
	  auxiliaryCommentBefore: assertString,
	  auxiliaryCommentAfter: assertString,
	  sourceType: assertSourceType,
	  wrapPluginVisitorMethod: assertFunction,
	  highlightCode: assertBoolean,
	  sourceMaps: assertSourceMaps,
	  sourceMap: assertSourceMaps,
	  sourceFileName: assertString,
	  sourceRoot: assertString,
	  parserOpts: assertObject,
	  generatorOpts: assertObject
	};

	if (!browser$5.env.BABEL_8_BREAKING) {
	  Object.assign(COMMON_VALIDATORS, {
	    getModuleId: assertFunction,
	    moduleRoot: assertString,
	    moduleIds: assertBoolean,
	    moduleId: assertString
	  });
	}

	const assumptionsNames = new Set(["arrayLikeIsIterable", "constantReexports", "constantSuper", "enumerableModuleMeta", "ignoreFunctionLength", "ignoreToPrimitiveHint", "iterableIsArray", "mutableTemplateObject", "noClassCalls", "noDocumentAll", "noIncompleteNsImportDetection", "noNewArrows", "objectRestNoSymbols", "privateFieldsAsProperties", "pureGetters", "setClassMethods", "setComputedProperties", "setPublicClassFields", "setSpreadProperties", "skipForOfIteratorClosing", "superIsCallableConstructor"]);

	function getSource(loc) {
	  return loc.type === "root" ? loc.source : getSource(loc.parent);
	}

	function validate(type, opts) {
	  return validateNested({
	    type: "root",
	    source: type
	  }, opts);
	}

	function validateNested(loc, opts) {
	  const type = getSource(loc);
	  assertNoDuplicateSourcemap(opts);
	  Object.keys(opts).forEach(key => {
	    const optLoc = {
	      type: "option",
	      name: key,
	      parent: loc
	    };

	    if (type === "preset" && NONPRESET_VALIDATORS[key]) {
	      throw new Error(`${msg(optLoc)} is not allowed in preset options`);
	    }

	    if (type !== "arguments" && ROOT_VALIDATORS[key]) {
	      throw new Error(`${msg(optLoc)} is only allowed in root programmatic options`);
	    }

	    if (type !== "arguments" && type !== "configfile" && BABELRC_VALIDATORS[key]) {
	      if (type === "babelrcfile" || type === "extendsfile") {
	        throw new Error(`${msg(optLoc)} is not allowed in .babelrc or "extends"ed files, only in root programmatic options, ` + `or babel.config.js/config file options`);
	      }

	      throw new Error(`${msg(optLoc)} is only allowed in root programmatic options, or babel.config.js/config file options`);
	    }

	    const validator = COMMON_VALIDATORS[key] || NONPRESET_VALIDATORS[key] || BABELRC_VALIDATORS[key] || ROOT_VALIDATORS[key] || throwUnknownError;
	    validator(optLoc, opts[key]);
	  });
	  return opts;
	}

	function throwUnknownError(loc) {
	  const key = loc.name;

	  if (removed[key]) {
	    const {
	      message,
	      version = 5
	    } = removed[key];
	    throw new Error(`Using removed Babel ${version} option: ${msg(loc)} - ${message}`);
	  } else {
	    const unknownOptErr = new Error(`Unknown option: ${msg(loc)}. Check out https://babeljs.io/docs/en/babel-core/#options for more information about options.`);
	    unknownOptErr.code = "BABEL_UNKNOWN_OPTION";
	    throw unknownOptErr;
	  }
	}

	function has$1(obj, key) {
	  return Object.prototype.hasOwnProperty.call(obj, key);
	}

	function assertNoDuplicateSourcemap(opts) {
	  if (has$1(opts, "sourceMap") && has$1(opts, "sourceMaps")) {
	    throw new Error(".sourceMap is an alias for .sourceMaps, cannot use both");
	  }
	}

	function assertEnvSet(loc, value) {
	  if (loc.parent.type === "env") {
	    throw new Error(`${msg(loc)} is not allowed inside of another .env block`);
	  }

	  const parent = loc.parent;
	  const obj = assertObject(loc, value);

	  if (obj) {
	    for (const envName of Object.keys(obj)) {
	      const env = assertObject(access(loc, envName), obj[envName]);
	      if (!env) continue;
	      const envLoc = {
	        type: "env",
	        name: envName,
	        parent
	      };
	      validateNested(envLoc, env);
	    }
	  }

	  return obj;
	}

	function assertOverridesList(loc, value) {
	  if (loc.parent.type === "env") {
	    throw new Error(`${msg(loc)} is not allowed inside an .env block`);
	  }

	  if (loc.parent.type === "overrides") {
	    throw new Error(`${msg(loc)} is not allowed inside an .overrides block`);
	  }

	  const parent = loc.parent;
	  const arr = assertArray(loc, value);

	  if (arr) {
	    for (const [index, item] of arr.entries()) {
	      const objLoc = access(loc, index);
	      const env = assertObject(objLoc, item);
	      if (!env) throw new Error(`${msg(objLoc)} must be an object`);
	      const overridesLoc = {
	        type: "overrides",
	        index,
	        parent
	      };
	      validateNested(overridesLoc, env);
	    }
	  }

	  return arr;
	}

	function checkNoUnwrappedItemOptionPairs(items, index, type, e) {
	  if (index === 0) return;
	  const lastItem = items[index - 1];
	  const thisItem = items[index];

	  if (lastItem.file && lastItem.options === undefined && typeof thisItem.value === "object") {
	    e.message += `\n- Maybe you meant to use\n` + `"${type}s": [\n  ["${lastItem.file.request}", ${JSON.stringify(thisItem.value, undefined, 2)}]\n]\n` + `To be a valid ${type}, its name and options should be wrapped in a pair of brackets`;
	  }
	}

	const sep = `\\${path$1.sep}`;
	const endSep = `(?:${sep}|$)`;
	const substitution = `[^${sep}]+`;
	const starPat = `(?:${substitution}${sep})`;
	const starPatLast = `(?:${substitution}${endSep})`;
	const starStarPat = `${starPat}*?`;
	const starStarPatLast = `${starPat}*?${starPatLast}?`;

	function escapeRegExp(string) {
	  return string.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&");
	}

	function pathToPattern(pattern, dirname) {
	  const parts = path$1.resolve(dirname, pattern).split(path$1.sep);
	  return new RegExp(["^", ...parts.map((part, i) => {
	    const last = i === parts.length - 1;
	    if (part === "**") return last ? starStarPatLast : starStarPat;
	    if (part === "*") return last ? starPatLast : starPat;

	    if (part.indexOf("*.") === 0) {
	      return substitution + escapeRegExp(part.slice(1)) + (last ? endSep : sep);
	    }

	    return escapeRegExp(part) + (last ? endSep : sep);
	  })].join(""));
	}

	const ChainFormatter = {
	  Programmatic: 0,
	  Config: 1
	};
	const Formatter = {
	  title(type, callerName, filepath) {
	    let title = "";

	    if (type === ChainFormatter.Programmatic) {
	      title = "programmatic options";

	      if (callerName) {
	        title += " from " + callerName;
	      }
	    } else {
	      title = "config " + filepath;
	    }

	    return title;
	  },

	  loc(index, envName) {
	    let loc = "";

	    if (index != null) {
	      loc += `.overrides[${index}]`;
	    }

	    if (envName != null) {
	      loc += `.env["${envName}"]`;
	    }

	    return loc;
	  },

	  *optionsAndDescriptors(opt) {
	    const content = { ...opt.options
	    };
	    delete content.overrides;
	    delete content.env;
	    const pluginDescriptors = [...(yield* opt.plugins())];

	    if (pluginDescriptors.length) {
	      content.plugins = pluginDescriptors.map(d => descriptorToConfig(d));
	    }

	    const presetDescriptors = [...(yield* opt.presets())];

	    if (presetDescriptors.length) {
	      content.presets = [...presetDescriptors].map(d => descriptorToConfig(d));
	    }

	    return JSON.stringify(content, undefined, 2);
	  }

	};

	function descriptorToConfig(d) {
	  let name = d.file?.request;

	  if (name == null) {
	    if (typeof d.value === "object") {
	      name = d.value;
	    } else if (typeof d.value === "function") {
	      name = `[Function: ${d.value.toString().substr(0, 50)} ... ]`;
	    }
	  }

	  if (name == null) {
	    name = "[Unknown]";
	  }

	  if (d.options === undefined) {
	    return name;
	  } else if (d.name == null) {
	    return [name, d.options];
	  } else {
	    return [name, d.options, d.name];
	  }
	}

	class ConfigPrinter {
	  _stack = [];

	  configure(enabled, type, {
	    callerName,
	    filepath
	  }) {
	    if (!enabled) return () => {};
	    return (content, index, envName) => {
	      this._stack.push({
	        type,
	        callerName,
	        filepath,
	        content,
	        index,
	        envName
	      });
	    };
	  }

	  static *format(config) {
	    let title = Formatter.title(config.type, config.callerName, config.filepath);
	    const loc = Formatter.loc(config.index, config.envName);
	    if (loc) title += ` ${loc}`;
	    const content = yield* Formatter.optionsAndDescriptors(config.content);
	    return `${title}\n${content}`;
	  }

	  *output() {
	    if (this._stack.length === 0) return "";
	    const configs = yield* gensync.all(this._stack.map(s => ConfigPrinter.format(s)));
	    return configs.join("\n\n");
	  }

	}

	const debug$1 = browser$4("babel:config:config-chain");
	function* buildPresetChain(arg, context) {
	  const chain = yield* buildPresetChainWalker(arg, context);
	  if (!chain) return null;
	  return {
	    plugins: dedupDescriptors(chain.plugins),
	    presets: dedupDescriptors(chain.presets),
	    options: chain.options.map(o => normalizeOptions$1(o)),
	    files: new Set()
	  };
	}
	const buildPresetChainWalker = makeChainWalker({
	  root: preset => loadPresetDescriptors(preset),
	  env: (preset, envName) => loadPresetEnvDescriptors(preset)(envName),
	  overrides: (preset, index) => loadPresetOverridesDescriptors(preset)(index),
	  overridesEnv: (preset, index, envName) => loadPresetOverridesEnvDescriptors(preset)(index)(envName),
	  createLogger: () => () => {}
	});
	const loadPresetDescriptors = makeWeakCacheSync(preset => buildRootDescriptors(preset, preset.alias, createUncachedDescriptors));
	const loadPresetEnvDescriptors = makeWeakCacheSync(preset => makeStrongCacheSync(envName => buildEnvDescriptors(preset, preset.alias, createUncachedDescriptors, envName)));
	const loadPresetOverridesDescriptors = makeWeakCacheSync(preset => makeStrongCacheSync(index => buildOverrideDescriptors(preset, preset.alias, createUncachedDescriptors, index)));
	const loadPresetOverridesEnvDescriptors = makeWeakCacheSync(preset => makeStrongCacheSync(index => makeStrongCacheSync(envName => buildOverrideEnvDescriptors(preset, preset.alias, createUncachedDescriptors, index, envName))));
	function* buildRootChain(opts, context) {
	  let configReport, babelRcReport;
	  const programmaticLogger = new ConfigPrinter();
	  const programmaticChain = yield* loadProgrammaticChain({
	    options: opts,
	    dirname: context.cwd
	  }, context, undefined, programmaticLogger);
	  if (!programmaticChain) return null;
	  const programmaticReport = yield* programmaticLogger.output();
	  let configFile;

	  if (typeof opts.configFile === "string") {
	    configFile = yield* loadConfig$1(opts.configFile, context.cwd, context.envName, context.caller);
	  } else if (opts.configFile !== false) {
	    configFile = yield* findRootConfig(context.root, context.envName, context.caller);
	  }

	  let {
	    babelrc,
	    babelrcRoots
	  } = opts;
	  let babelrcRootsDirectory = context.cwd;
	  const configFileChain = emptyChain();
	  const configFileLogger = new ConfigPrinter();

	  if (configFile) {
	    const validatedFile = validateConfigFile(configFile);
	    const result = yield* loadFileChain(validatedFile, context, undefined, configFileLogger);
	    if (!result) return null;
	    configReport = yield* configFileLogger.output();

	    if (babelrc === undefined) {
	      babelrc = validatedFile.options.babelrc;
	    }

	    if (babelrcRoots === undefined) {
	      babelrcRootsDirectory = validatedFile.dirname;
	      babelrcRoots = validatedFile.options.babelrcRoots;
	    }

	    mergeChain(configFileChain, result);
	  }

	  let ignoreFile, babelrcFile;
	  let isIgnored = false;
	  const fileChain = emptyChain();

	  if ((babelrc === true || babelrc === undefined) && typeof context.filename === "string") {
	    const pkgData = yield* findPackageData(context.filename);

	    if (pkgData && babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory)) {
	      ({
	        ignore: ignoreFile,
	        config: babelrcFile
	      } = yield* findRelativeConfig(pkgData, context.envName, context.caller));

	      if (ignoreFile) {
	        fileChain.files.add(ignoreFile.filepath);
	      }

	      if (ignoreFile && shouldIgnore(context, ignoreFile.ignore, null, ignoreFile.dirname)) {
	        isIgnored = true;
	      }

	      if (babelrcFile && !isIgnored) {
	        const validatedFile = validateBabelrcFile(babelrcFile);
	        const babelrcLogger = new ConfigPrinter();
	        const result = yield* loadFileChain(validatedFile, context, undefined, babelrcLogger);

	        if (!result) {
	          isIgnored = true;
	        } else {
	          babelRcReport = yield* babelrcLogger.output();
	          mergeChain(fileChain, result);
	        }
	      }

	      if (babelrcFile && isIgnored) {
	        fileChain.files.add(babelrcFile.filepath);
	      }
	    }
	  }

	  if (context.showConfig) {
	    console.log(`Babel configs on "${context.filename}" (ascending priority):\n` + [configReport, babelRcReport, programmaticReport].filter(x => !!x).join("\n\n") + "\n-----End Babel configs-----");
	  }

	  const chain = mergeChain(mergeChain(mergeChain(emptyChain(), configFileChain), fileChain), programmaticChain);
	  return {
	    plugins: isIgnored ? [] : dedupDescriptors(chain.plugins),
	    presets: isIgnored ? [] : dedupDescriptors(chain.presets),
	    options: isIgnored ? [] : chain.options.map(o => normalizeOptions$1(o)),
	    fileHandling: isIgnored ? "ignored" : "transpile",
	    ignore: ignoreFile || undefined,
	    babelrc: babelrcFile || undefined,
	    config: configFile || undefined,
	    files: chain.files
	  };
	}

	function babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory) {
	  if (typeof babelrcRoots === "boolean") return babelrcRoots;
	  const absoluteRoot = context.root;

	  if (babelrcRoots === undefined) {
	    return pkgData.directories.indexOf(absoluteRoot) !== -1;
	  }

	  let babelrcPatterns = babelrcRoots;

	  if (!Array.isArray(babelrcPatterns)) {
	    babelrcPatterns = [babelrcPatterns];
	  }

	  babelrcPatterns = babelrcPatterns.map(pat => {
	    return typeof pat === "string" ? path$1.resolve(babelrcRootsDirectory, pat) : pat;
	  });

	  if (babelrcPatterns.length === 1 && babelrcPatterns[0] === absoluteRoot) {
	    return pkgData.directories.indexOf(absoluteRoot) !== -1;
	  }

	  return babelrcPatterns.some(pat => {
	    if (typeof pat === "string") {
	      pat = pathToPattern(pat, babelrcRootsDirectory);
	    }

	    return pkgData.directories.some(directory => {
	      return matchPattern(pat, babelrcRootsDirectory, directory, context);
	    });
	  });
	}

	const validateConfigFile = makeWeakCacheSync(file => ({
	  filepath: file.filepath,
	  dirname: file.dirname,
	  options: validate("configfile", file.options)
	}));
	const validateBabelrcFile = makeWeakCacheSync(file => ({
	  filepath: file.filepath,
	  dirname: file.dirname,
	  options: validate("babelrcfile", file.options)
	}));
	const validateExtendFile = makeWeakCacheSync(file => ({
	  filepath: file.filepath,
	  dirname: file.dirname,
	  options: validate("extendsfile", file.options)
	}));
	const loadProgrammaticChain = makeChainWalker({
	  root: input => buildRootDescriptors(input, "base", createCachedDescriptors),
	  env: (input, envName) => buildEnvDescriptors(input, "base", createCachedDescriptors, envName),
	  overrides: (input, index) => buildOverrideDescriptors(input, "base", createCachedDescriptors, index),
	  overridesEnv: (input, index, envName) => buildOverrideEnvDescriptors(input, "base", createCachedDescriptors, index, envName),
	  createLogger: (input, context, baseLogger) => buildProgrammaticLogger(input, context, baseLogger)
	});
	const loadFileChainWalker = makeChainWalker({
	  root: file => loadFileDescriptors(file),
	  env: (file, envName) => loadFileEnvDescriptors(file)(envName),
	  overrides: (file, index) => loadFileOverridesDescriptors(file)(index),
	  overridesEnv: (file, index, envName) => loadFileOverridesEnvDescriptors(file)(index)(envName),
	  createLogger: (file, context, baseLogger) => buildFileLogger(file.filepath, context, baseLogger)
	});

	function* loadFileChain(input, context, files, baseLogger) {
	  const chain = yield* loadFileChainWalker(input, context, files, baseLogger);

	  if (chain) {
	    chain.files.add(input.filepath);
	  }

	  return chain;
	}

	const loadFileDescriptors = makeWeakCacheSync(file => buildRootDescriptors(file, file.filepath, createUncachedDescriptors));
	const loadFileEnvDescriptors = makeWeakCacheSync(file => makeStrongCacheSync(envName => buildEnvDescriptors(file, file.filepath, createUncachedDescriptors, envName)));
	const loadFileOverridesDescriptors = makeWeakCacheSync(file => makeStrongCacheSync(index => buildOverrideDescriptors(file, file.filepath, createUncachedDescriptors, index)));
	const loadFileOverridesEnvDescriptors = makeWeakCacheSync(file => makeStrongCacheSync(index => makeStrongCacheSync(envName => buildOverrideEnvDescriptors(file, file.filepath, createUncachedDescriptors, index, envName))));

	function buildFileLogger(filepath, context, baseLogger) {
	  if (!baseLogger) {
	    return () => {};
	  }

	  return baseLogger.configure(context.showConfig, ChainFormatter.Config, {
	    filepath
	  });
	}

	function buildRootDescriptors({
	  dirname,
	  options
	}, alias, descriptors) {
	  return descriptors(dirname, options, alias);
	}

	function buildProgrammaticLogger(_, context, baseLogger) {
	  if (!baseLogger) {
	    return () => {};
	  }

	  return baseLogger.configure(context.showConfig, ChainFormatter.Programmatic, {
	    callerName: context.caller?.name
	  });
	}

	function buildEnvDescriptors({
	  dirname,
	  options
	}, alias, descriptors, envName) {
	  const opts = options.env && options.env[envName];
	  return opts ? descriptors(dirname, opts, `${alias}.env["${envName}"]`) : null;
	}

	function buildOverrideDescriptors({
	  dirname,
	  options
	}, alias, descriptors, index) {
	  const opts = options.overrides && options.overrides[index];
	  if (!opts) throw new Error("Assertion failure - missing override");
	  return descriptors(dirname, opts, `${alias}.overrides[${index}]`);
	}

	function buildOverrideEnvDescriptors({
	  dirname,
	  options
	}, alias, descriptors, index, envName) {
	  const override = options.overrides && options.overrides[index];
	  if (!override) throw new Error("Assertion failure - missing override");
	  const opts = override.env && override.env[envName];
	  return opts ? descriptors(dirname, opts, `${alias}.overrides[${index}].env["${envName}"]`) : null;
	}

	function makeChainWalker({
	  root,
	  env,
	  overrides,
	  overridesEnv,
	  createLogger
	}) {
	  return function* (input, context, files = new Set(), baseLogger) {
	    const {
	      dirname
	    } = input;
	    const flattenedConfigs = [];
	    const rootOpts = root(input);

	    if (configIsApplicable(rootOpts, dirname, context)) {
	      flattenedConfigs.push({
	        config: rootOpts,
	        envName: undefined,
	        index: undefined
	      });
	      const envOpts = env(input, context.envName);

	      if (envOpts && configIsApplicable(envOpts, dirname, context)) {
	        flattenedConfigs.push({
	          config: envOpts,
	          envName: context.envName,
	          index: undefined
	        });
	      }

	      (rootOpts.options.overrides || []).forEach((_, index) => {
	        const overrideOps = overrides(input, index);

	        if (configIsApplicable(overrideOps, dirname, context)) {
	          flattenedConfigs.push({
	            config: overrideOps,
	            index,
	            envName: undefined
	          });
	          const overrideEnvOpts = overridesEnv(input, index, context.envName);

	          if (overrideEnvOpts && configIsApplicable(overrideEnvOpts, dirname, context)) {
	            flattenedConfigs.push({
	              config: overrideEnvOpts,
	              index,
	              envName: context.envName
	            });
	          }
	        }
	      });
	    }

	    if (flattenedConfigs.some(({
	      config: {
	        options: {
	          ignore,
	          only
	        }
	      }
	    }) => shouldIgnore(context, ignore, only, dirname))) {
	      return null;
	    }

	    const chain = emptyChain();
	    const logger = createLogger(input, context, baseLogger);

	    for (const {
	      config,
	      index,
	      envName
	    } of flattenedConfigs) {
	      if (!(yield* mergeExtendsChain(chain, config.options, dirname, context, files, baseLogger))) {
	        return null;
	      }

	      logger(config, index, envName);
	      yield* mergeChainOpts(chain, config);
	    }

	    return chain;
	  };
	}

	function* mergeExtendsChain(chain, opts, dirname, context, files, baseLogger) {
	  if (opts.extends === undefined) return true;
	  const file = yield* loadConfig$1(opts.extends, dirname, context.envName, context.caller);

	  if (files.has(file)) {
	    throw new Error(`Configuration cycle detected loading ${file.filepath}.\n` + `File already loaded following the config chain:\n` + Array.from(files, file => ` - ${file.filepath}`).join("\n"));
	  }

	  files.add(file);
	  const fileChain = yield* loadFileChain(validateExtendFile(file), context, files, baseLogger);
	  files.delete(file);
	  if (!fileChain) return false;
	  mergeChain(chain, fileChain);
	  return true;
	}

	function mergeChain(target, source) {
	  target.options.push(...source.options);
	  target.plugins.push(...source.plugins);
	  target.presets.push(...source.presets);

	  for (const file of source.files) {
	    target.files.add(file);
	  }

	  return target;
	}

	function* mergeChainOpts(target, {
	  options,
	  plugins,
	  presets
	}) {
	  target.options.push(options);
	  target.plugins.push(...(yield* plugins()));
	  target.presets.push(...(yield* presets()));
	  return target;
	}

	function emptyChain() {
	  return {
	    options: [],
	    presets: [],
	    plugins: [],
	    files: new Set()
	  };
	}

	function normalizeOptions$1(opts) {
	  const options = { ...opts
	  };
	  delete options.extends;
	  delete options.env;
	  delete options.overrides;
	  delete options.plugins;
	  delete options.presets;
	  delete options.passPerPreset;
	  delete options.ignore;
	  delete options.only;
	  delete options.test;
	  delete options.include;
	  delete options.exclude;

	  if (Object.prototype.hasOwnProperty.call(options, "sourceMap")) {
	    options.sourceMaps = options.sourceMap;
	    delete options.sourceMap;
	  }

	  return options;
	}

	function dedupDescriptors(items) {
	  const map = new Map();
	  const descriptors = [];

	  for (const item of items) {
	    if (typeof item.value === "function") {
	      const fnKey = item.value;
	      let nameMap = map.get(fnKey);

	      if (!nameMap) {
	        nameMap = new Map();
	        map.set(fnKey, nameMap);
	      }

	      let desc = nameMap.get(item.name);

	      if (!desc) {
	        desc = {
	          value: item
	        };
	        descriptors.push(desc);
	        if (!item.ownPass) nameMap.set(item.name, desc);
	      } else {
	        desc.value = item;
	      }
	    } else {
	      descriptors.push({
	        value: item
	      });
	    }
	  }

	  return descriptors.reduce((acc, desc) => {
	    acc.push(desc.value);
	    return acc;
	  }, []);
	}

	function configIsApplicable({
	  options
	}, dirname, context) {
	  return (options.test === undefined || configFieldIsApplicable(context, options.test, dirname)) && (options.include === undefined || configFieldIsApplicable(context, options.include, dirname)) && (options.exclude === undefined || !configFieldIsApplicable(context, options.exclude, dirname));
	}

	function configFieldIsApplicable(context, test, dirname) {
	  const patterns = Array.isArray(test) ? test : [test];
	  return matchesPatterns(context, patterns, dirname);
	}

	function ignoreListReplacer(_key, value) {
	  if (value instanceof RegExp) {
	    return String(value);
	  }

	  return value;
	}

	function shouldIgnore(context, ignore, only, dirname) {
	  if (ignore && matchesPatterns(context, ignore, dirname)) {
	    const message = `No config is applied to "${context.filename ?? "(unknown)"}" because it matches one of \`ignore: ${JSON.stringify(ignore, ignoreListReplacer)}\` from "${dirname}"`;
	    debug$1(message);

	    if (context.showConfig) {
	      console.log(message);
	    }

	    return true;
	  }

	  if (only && !matchesPatterns(context, only, dirname)) {
	    const message = `No config is applied to "${context.filename ?? "(unknown)"}" because it fails to match one of \`only: ${JSON.stringify(only, ignoreListReplacer)}\` from "${dirname}"`;
	    debug$1(message);

	    if (context.showConfig) {
	      console.log(message);
	    }

	    return true;
	  }

	  return false;
	}

	function matchesPatterns(context, patterns, dirname) {
	  return patterns.some(pattern => matchPattern(pattern, dirname, context.filename, context));
	}

	function matchPattern(pattern, dirname, pathToTest, context) {
	  if (typeof pattern === "function") {
	    return !!pattern(pathToTest, {
	      dirname,
	      envName: context.envName,
	      caller: context.caller
	    });
	  }

	  if (typeof pathToTest !== "string") {
	    throw new Error(`Configuration contains string/RegExp pattern, but no filename was passed to Babel`);
	  }

	  if (typeof pattern === "string") {
	    pattern = pathToPattern(pattern, dirname);
	  }

	  return pattern.test(pathToTest);
	}

	const VALIDATORS = {
	  name: assertString,
	  manipulateOptions: assertFunction,
	  pre: assertFunction,
	  post: assertFunction,
	  inherits: assertFunction,
	  visitor: assertVisitorMap,
	  parserOverride: assertFunction,
	  generatorOverride: assertFunction
	};

	function assertVisitorMap(loc, value) {
	  const obj = assertObject(loc, value);

	  if (obj) {
	    Object.keys(obj).forEach(prop => assertVisitorHandler(prop, obj[prop]));

	    if (obj.enter || obj.exit) {
	      throw new Error(`${msg(loc)} cannot contain catch-all "enter" or "exit" handlers. Please target individual nodes.`);
	    }
	  }

	  return obj;
	}

	function assertVisitorHandler(key, value) {
	  if (value && typeof value === "object") {
	    Object.keys(value).forEach(handler => {
	      if (handler !== "enter" && handler !== "exit") {
	        throw new Error(`.visitor["${key}"] may only have .enter and/or .exit handlers.`);
	      }
	    });
	  } else if (typeof value !== "function") {
	    throw new Error(`.visitor["${key}"] must be a function`);
	  }

	  return value;
	}

	function validatePluginObject(obj) {
	  const rootPath = {
	    type: "root",
	    source: "plugin"
	  };
	  Object.keys(obj).forEach(key => {
	    const validator = VALIDATORS[key];

	    if (validator) {
	      const optLoc = {
	        type: "option",
	        name: key,
	        parent: rootPath
	      };
	      validator(optLoc, obj[key]);
	    } else {
	      const invalidPluginPropertyError = new Error(`.${key} is not a valid Plugin property`);
	      invalidPluginPropertyError.code = "BABEL_UNKNOWN_PLUGIN_PROPERTY";
	      throw invalidPluginPropertyError;
	    }
	  });
	  return obj;
	}

	function makeConfigAPI(cache) {
	  const env = value => cache.using(data => {
	    if (typeof value === "undefined") return data.envName;

	    if (typeof value === "function") {
	      return assertSimpleType(value(data.envName));
	    }

	    if (!Array.isArray(value)) value = [value];
	    return value.some(entry => {
	      if (typeof entry !== "string") {
	        throw new Error("Unexpected non-string value");
	      }

	      return entry === data.envName;
	    });
	  });

	  const caller = cb => cache.using(data => assertSimpleType(cb(data.caller)));

	  return {
	    version: version$3,
	    cache: cache.simple(),
	    env,
	    async: () => false,
	    caller,
	    assertVersion
	  };
	}
	function makePresetAPI(cache, externalDependencies) {
	  const targets = () => JSON.parse(cache.using(data => JSON.stringify(data.targets)));

	  const addExternalDependency = ref => {
	    externalDependencies.push(ref);
	  };

	  return { ...makeConfigAPI(cache),
	    targets,
	    addExternalDependency
	  };
	}
	function makePluginAPI(cache, externalDependencies) {
	  const assumption = name => cache.using(data => data.assumptions[name]);

	  return { ...makePresetAPI(cache, externalDependencies),
	    assumption
	  };
	}

	function assertVersion(range) {
	  if (typeof range === "number") {
	    if (!Number.isInteger(range)) {
	      throw new Error("Expected string or integer value.");
	    }

	    range = `^${range}.0.0-0`;
	  }

	  if (typeof range !== "string") {
	    throw new Error("Expected string or integer value.");
	  }

	  if (semver$1.satisfies(version$3, range)) return;
	  const limit = Error.stackTraceLimit;

	  if (typeof limit === "number" && limit < 25) {
	    Error.stackTraceLimit = 25;
	  }

	  const err = new Error(`Requires Babel "${range}", but was loaded with "${version$3}". ` + `If you are sure you have a compatible version of @babel/core, ` + `it is likely that something in your build process is loading the ` + `wrong version. Inspect the stack trace of this error to look for ` + `the first entry that doesn't mention "@babel/core" or "babel-core" ` + `to see what is calling Babel.`);

	  if (typeof limit === "number") {
	    Error.stackTraceLimit = limit;
	  }

	  throw Object.assign(err, {
	    code: "BABEL_VERSION_UNSUPPORTED",
	    version: version$3,
	    range
	  });
	}

	function resolveRootMode(rootDir, rootMode) {
	  switch (rootMode) {
	    case "root":
	      return rootDir;

	    case "upward-optional":
	      {
	        const upwardRootDir = findConfigUpwards();
	        return upwardRootDir === null ? rootDir : upwardRootDir;
	      }

	    case "upward":
	      {
	        throw Object.assign(new Error(`Babel was run with rootMode:"upward" but a root could not ` + `be found when searching upward from "${rootDir}".\n` + `One of the following config files must be in the directory tree: ` + `"${ROOT_CONFIG_FILENAMES.join(", ")}".`), {
	          code: "BABEL_ROOT_NOT_FOUND",
	          dirname: rootDir
	        });
	      }

	    default:
	      throw new Error(`Assertion failure - unknown rootMode value.`);
	  }
	}

	function* loadPrivatePartialConfig(inputOpts) {
	  if (inputOpts != null && (typeof inputOpts !== "object" || Array.isArray(inputOpts))) {
	    throw new Error("Babel options must be an object, null, or undefined");
	  }

	  const args = inputOpts ? validate("arguments", inputOpts) : {};
	  const {
	    envName = getEnv(),
	    cwd = ".",
	    root: rootDir = ".",
	    rootMode = "root",
	    caller,
	    cloneInputAst = true
	  } = args;
	  const absoluteCwd = path$1.resolve(cwd);
	  const absoluteRootDir = resolveRootMode(path$1.resolve(absoluteCwd, rootDir), rootMode);
	  const filename = typeof args.filename === "string" ? path$1.resolve(cwd, args.filename) : undefined;
	  const showConfigPath = yield* resolveShowConfigPath();
	  const context = {
	    filename,
	    cwd: absoluteCwd,
	    root: absoluteRootDir,
	    envName,
	    caller,
	    showConfig: showConfigPath === filename
	  };
	  const configChain = yield* buildRootChain(args, context);
	  if (!configChain) return null;
	  const merged = {
	    assumptions: {}
	  };
	  configChain.options.forEach(opts => {
	    mergeOptions(merged, opts);
	  });
	  const options = { ...merged,
	    targets: resolveTargets(merged),
	    cloneInputAst,
	    babelrc: false,
	    configFile: false,
	    browserslistConfigFile: false,
	    passPerPreset: false,
	    envName: context.envName,
	    cwd: context.cwd,
	    root: context.root,
	    rootMode: "root",
	    filename: typeof context.filename === "string" ? context.filename : undefined,
	    plugins: configChain.plugins.map(descriptor => createItemFromDescriptor(descriptor)),
	    presets: configChain.presets.map(descriptor => createItemFromDescriptor(descriptor))
	  };
	  return {
	    options,
	    context,
	    fileHandling: configChain.fileHandling,
	    ignore: configChain.ignore,
	    babelrc: configChain.babelrc,
	    config: configChain.config,
	    files: configChain.files
	  };
	}
	const loadPartialConfig$1 = gensync(function* (opts) {
	  let showIgnoredFiles = false;

	  if (typeof opts === "object" && opts !== null && !Array.isArray(opts)) {
	    ({
	      showIgnoredFiles,
	      ...opts
	    } = opts);
	  }

	  const result = yield* loadPrivatePartialConfig(opts);
	  if (!result) return null;
	  const {
	    options,
	    babelrc,
	    ignore,
	    config,
	    fileHandling,
	    files
	  } = result;

	  if (fileHandling === "ignored" && !showIgnoredFiles) {
	    return null;
	  }

	  (options.plugins || []).forEach(item => {
	    if (item.value instanceof Plugin$1) {
	      throw new Error("Passing cached plugin instances is not supported in " + "babel.loadPartialConfig()");
	    }
	  });
	  return new PartialConfig(options, babelrc ? babelrc.filepath : undefined, ignore ? ignore.filepath : undefined, config ? config.filepath : undefined, fileHandling, files);
	});

	class PartialConfig {
	  options;
	  babelrc;
	  babelignore;
	  config;
	  fileHandling;
	  files;

	  constructor(options, babelrc, ignore, config, fileHandling, files) {
	    this.options = options;
	    this.babelignore = ignore;
	    this.babelrc = babelrc;
	    this.config = config;
	    this.fileHandling = fileHandling;
	    this.files = files;
	    Object.freeze(this);
	  }

	  hasFilesystemConfig() {
	    return this.babelrc !== undefined || this.config !== undefined;
	  }

	}

	Object.freeze(PartialConfig.prototype);

	var loadConfig = gensync(function* loadFullConfig(inputOpts) {
	  const result = yield* loadPrivatePartialConfig(inputOpts);

	  if (!result) {
	    return null;
	  }

	  const {
	    options,
	    context,
	    fileHandling
	  } = result;

	  if (fileHandling === "ignored") {
	    return null;
	  }

	  const optionDefaults = {};
	  const {
	    plugins,
	    presets
	  } = options;

	  if (!plugins || !presets) {
	    throw new Error("Assertion failure - plugins and presets exist");
	  }

	  const presetContext = { ...context,
	    targets: options.targets
	  };

	  const toDescriptor = item => {
	    const desc = getItemDescriptor(item);

	    if (!desc) {
	      throw new Error("Assertion failure - must be config item");
	    }

	    return desc;
	  };

	  const presetsDescriptors = presets.map(toDescriptor);
	  const initialPluginsDescriptors = plugins.map(toDescriptor);
	  const pluginDescriptorsByPass = [[]];
	  const passes = [];
	  const externalDependencies = [];
	  const ignored = yield* enhanceError(context, function* recursePresetDescriptors(rawPresets, pluginDescriptorsPass) {
	    const presets = [];

	    for (let i = 0; i < rawPresets.length; i++) {
	      const descriptor = rawPresets[i];

	      if (descriptor.options !== false) {
	        try {
	          var preset = yield* loadPresetDescriptor(descriptor, presetContext);
	        } catch (e) {
	          if (e.code === "BABEL_UNKNOWN_OPTION") {
	            checkNoUnwrappedItemOptionPairs(rawPresets, i, "preset", e);
	          }

	          throw e;
	        }

	        externalDependencies.push(preset.externalDependencies);

	        if (descriptor.ownPass) {
	          presets.push({
	            preset: preset.chain,
	            pass: []
	          });
	        } else {
	          presets.unshift({
	            preset: preset.chain,
	            pass: pluginDescriptorsPass
	          });
	        }
	      }
	    }

	    if (presets.length > 0) {
	      pluginDescriptorsByPass.splice(1, 0, ...presets.map(o => o.pass).filter(p => p !== pluginDescriptorsPass));

	      for (const {
	        preset,
	        pass
	      } of presets) {
	        if (!preset) return true;
	        pass.push(...preset.plugins);
	        const ignored = yield* recursePresetDescriptors(preset.presets, pass);
	        if (ignored) return true;
	        preset.options.forEach(opts => {
	          mergeOptions(optionDefaults, opts);
	        });
	      }
	    }
	  })(presetsDescriptors, pluginDescriptorsByPass[0]);
	  if (ignored) return null;
	  const opts = optionDefaults;
	  mergeOptions(opts, options);
	  const pluginContext = { ...presetContext,
	    assumptions: opts.assumptions ?? {}
	  };
	  yield* enhanceError(context, function* loadPluginDescriptors() {
	    pluginDescriptorsByPass[0].unshift(...initialPluginsDescriptors);

	    for (const descs of pluginDescriptorsByPass) {
	      const pass = [];
	      passes.push(pass);

	      for (let i = 0; i < descs.length; i++) {
	        const descriptor = descs[i];

	        if (descriptor.options !== false) {
	          try {
	            var plugin = yield* loadPluginDescriptor(descriptor, pluginContext);
	          } catch (e) {
	            if (e.code === "BABEL_UNKNOWN_PLUGIN_PROPERTY") {
	              checkNoUnwrappedItemOptionPairs(descs, i, "plugin", e);
	            }

	            throw e;
	          }

	          pass.push(plugin);
	          externalDependencies.push(plugin.externalDependencies);
	        }
	      }
	    }
	  })();
	  opts.plugins = passes[0];
	  opts.presets = passes.slice(1).filter(plugins => plugins.length > 0).map(plugins => ({
	    plugins
	  }));
	  opts.passPerPreset = opts.presets.length > 0;
	  return {
	    options: opts,
	    passes: passes,
	    externalDependencies: finalize(externalDependencies)
	  };
	});

	function enhanceError(context, fn) {
	  return function* (arg1, arg2) {
	    try {
	      return yield* fn(arg1, arg2);
	    } catch (e) {
	      if (!/^\[BABEL\]/.test(e.message)) {
	        e.message = `[BABEL] ${context.filename || "unknown"}: ${e.message}`;
	      }

	      throw e;
	    }
	  };
	}

	const makeDescriptorLoader = apiFactory => makeWeakCache(function* ({
	  value,
	  options,
	  dirname,
	  alias
	}, cache) {
	  if (options === false) throw new Error("Assertion failure");
	  options = options || {};
	  const externalDependencies = [];
	  let item = value;

	  if (typeof value === "function") {
	    const factory = maybeAsync(value, `You appear to be using an async plugin/preset, but Babel has been called synchronously`);
	    const api = { ...context,
	      ...apiFactory(cache, externalDependencies)
	    };

	    try {
	      item = yield* factory(api, options, dirname);
	    } catch (e) {
	      if (alias) {
	        e.message += ` (While processing: ${JSON.stringify(alias)})`;
	      }

	      throw e;
	    }
	  }

	  if (!item || typeof item !== "object") {
	    throw new Error("Plugin/Preset did not return an object.");
	  }

	  if (isThenable$1(item)) {
	    yield* [];
	    throw new Error(`You appear to be using a promise as a plugin, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, ` + `you may need to upgrade your @babel/core version. ` + `As an alternative, you can prefix the promise with "await". ` + `(While processing: ${JSON.stringify(alias)})`);
	  }

	  if (externalDependencies.length > 0 && (!cache.configured() || cache.mode() === "forever")) {
	    let error = `A plugin/preset has external untracked dependencies ` + `(${externalDependencies[0]}), but the cache `;

	    if (!cache.configured()) {
	      error += `has not been configured to be invalidated when the external dependencies change. `;
	    } else {
	      error += ` has been configured to never be invalidated. `;
	    }

	    error += `Plugins/presets should configure their cache to be invalidated when the external ` + `dependencies change, for example using \`api.cache.invalidate(() => ` + `statSync(filepath).mtimeMs)\` or \`api.cache.never()\`\n` + `(While processing: ${JSON.stringify(alias)})`;
	    throw new Error(error);
	  }

	  return {
	    value: item,
	    options,
	    dirname,
	    alias,
	    externalDependencies: finalize(externalDependencies)
	  };
	});

	const pluginDescriptorLoader = makeDescriptorLoader(makePluginAPI);
	const presetDescriptorLoader = makeDescriptorLoader(makePresetAPI);

	function* loadPluginDescriptor(descriptor, context) {
	  if (descriptor.value instanceof Plugin$1) {
	    if (descriptor.options) {
	      throw new Error("Passed options to an existing Plugin instance will not work.");
	    }

	    return descriptor.value;
	  }

	  return yield* instantiatePlugin(yield* pluginDescriptorLoader(descriptor, context), context);
	}

	const instantiatePlugin = makeWeakCache(function* ({
	  value,
	  options,
	  dirname,
	  alias,
	  externalDependencies
	}, cache) {
	  const pluginObj = validatePluginObject(value);
	  const plugin = { ...pluginObj
	  };

	  if (plugin.visitor) {
	    plugin.visitor = traverse.explode({ ...plugin.visitor
	    });
	  }

	  if (plugin.inherits) {
	    const inheritsDescriptor = {
	      name: undefined,
	      alias: `${alias}$inherits`,
	      value: plugin.inherits,
	      options,
	      dirname
	    };
	    const inherits = yield* forwardAsync(loadPluginDescriptor, run => {
	      return cache.invalidate(data => run(inheritsDescriptor, data));
	    });
	    plugin.pre = chain(inherits.pre, plugin.pre);
	    plugin.post = chain(inherits.post, plugin.post);
	    plugin.manipulateOptions = chain(inherits.manipulateOptions, plugin.manipulateOptions);
	    plugin.visitor = traverse.visitors.merge([inherits.visitor || {}, plugin.visitor || {}]);

	    if (inherits.externalDependencies.length > 0) {
	      if (externalDependencies.length === 0) {
	        externalDependencies = inherits.externalDependencies;
	      } else {
	        externalDependencies = finalize([externalDependencies, inherits.externalDependencies]);
	      }
	    }
	  }

	  return new Plugin$1(plugin, options, alias, externalDependencies);
	});

	const validateIfOptionNeedsFilename = (options, descriptor) => {
	  if (options.test || options.include || options.exclude) {
	    const formattedPresetName = descriptor.name ? `"${descriptor.name}"` : "/* your preset */";
	    throw new Error([`Preset ${formattedPresetName} requires a filename to be set when babel is called directly,`, `\`\`\``, `babel.transform(code, { filename: 'file.ts', presets: [${formattedPresetName}] });`, `\`\`\``, `See https://babeljs.io/docs/en/options#filename for more information.`].join("\n"));
	  }
	};

	const validatePreset = (preset, context, descriptor) => {
	  if (!context.filename) {
	    const {
	      options
	    } = preset;
	    validateIfOptionNeedsFilename(options, descriptor);

	    if (options.overrides) {
	      options.overrides.forEach(overrideOptions => validateIfOptionNeedsFilename(overrideOptions, descriptor));
	    }
	  }
	};

	function* loadPresetDescriptor(descriptor, context) {
	  const preset = instantiatePreset(yield* presetDescriptorLoader(descriptor, context));
	  validatePreset(preset, context, descriptor);
	  return {
	    chain: yield* buildPresetChain(preset, context),
	    externalDependencies: preset.externalDependencies
	  };
	}

	const instantiatePreset = makeWeakCacheSync(({
	  value,
	  dirname,
	  alias,
	  externalDependencies
	}) => {
	  return {
	    options: validate("preset", value),
	    alias,
	    dirname,
	    externalDependencies
	  };
	});

	function chain(a, b) {
	  const fns = [a, b].filter(Boolean);
	  if (fns.length <= 1) return fns[0];
	  return function (...args) {
	    for (const fn of fns) {
	      fn.apply(this, args);
	    }
	  };
	}

	const loadOptionsRunner = gensync(function* (opts) {
	  const config = yield* loadConfig(opts);
	  return config?.options ?? null;
	});
	const createConfigItemRunner = gensync(createConfigItem$1);

	const maybeErrback = runner => (opts, callback) => {
	  if (callback === undefined && typeof opts === "function") {
	    callback = opts;
	    opts = undefined;
	  }

	  return callback ? runner.errback(opts, callback) : runner.sync(opts);
	};

	const loadPartialConfig = maybeErrback(loadPartialConfig$1);
	const loadPartialConfigSync = loadPartialConfig$1.sync;
	const loadPartialConfigAsync = loadPartialConfig$1.async;
	const loadOptions = maybeErrback(loadOptionsRunner);
	const loadOptionsSync = loadOptionsRunner.sync;
	const loadOptionsAsync = loadOptionsRunner.async;
	const createConfigItemSync = createConfigItemRunner.sync;
	const createConfigItemAsync = createConfigItemRunner.async;
	function createConfigItem(target, options, callback) {
	  if (callback !== undefined) {
	    return createConfigItemRunner.errback(target, options, callback);
	  } else if (typeof options === "function") {
	    return createConfigItemRunner.errback(target, undefined, callback);
	  } else {
	    return createConfigItemRunner.sync(target, options);
	  }
	}

	class PluginPass {
	  _map = new Map();
	  key;
	  file;
	  opts;
	  cwd;
	  filename;

	  constructor(file, key, options) {
	    this.key = key;
	    this.file = file;
	    this.opts = options || {};
	    this.cwd = file.opts.cwd;
	    this.filename = file.opts.filename;
	  }

	  set(key, val) {
	    this._map.set(key, val);
	  }

	  get(key) {
	    return this._map.get(key);
	  }

	  availableHelper(name, versionRange) {
	    return this.file.availableHelper(name, versionRange);
	  }

	  addHelper(name) {
	    return this.file.addHelper(name);
	  }

	  addImport() {
	    return this.file.addImport();
	  }

	  buildCodeFrameError(node, msg, _Error) {
	    return this.file.buildCodeFrameError(node, msg, _Error);
	  }

	}

	if (!browser$5.env.BABEL_8_BREAKING) {
	  PluginPass.prototype.getModuleName = function getModuleName() {
	    return this.file.getModuleName();
	  };
	}

	let LOADED_PLUGIN;
	function loadBlockHoistPlugin() {
	  if (!LOADED_PLUGIN) {
	    LOADED_PLUGIN = new Plugin$1({ ...blockHoistPlugin,
	      visitor: traverse.explode(blockHoistPlugin.visitor)
	    }, {});
	  }

	  return LOADED_PLUGIN;
	}

	function priority(bodyNode) {
	  const priority = bodyNode?._blockHoist;
	  if (priority == null) return 1;
	  if (priority === true) return 2;
	  return priority;
	}

	function stableSort(body) {
	  const buckets = Object.create(null);

	  for (let i = 0; i < body.length; i++) {
	    const n = body[i];
	    const p = priority(n);
	    const bucket = buckets[p] || (buckets[p] = []);
	    bucket.push(n);
	  }

	  const keys = Object.keys(buckets).map(k => +k).sort((a, b) => b - a);
	  let index = 0;

	  for (const key of keys) {
	    const bucket = buckets[key];

	    for (const n of bucket) {
	      body[index++] = n;
	    }
	  }

	  return body;
	}

	const blockHoistPlugin = {
	  name: "internal.blockHoist",
	  visitor: {
	    Block: {
	      exit({
	        node
	      }) {
	        const {
	          body
	        } = node;
	        let max = 2 ** 30 - 1;
	        let hasChange = false;

	        for (let i = 0; i < body.length; i++) {
	          const n = body[i];
	          const p = priority(n);

	          if (p > max) {
	            hasChange = true;
	            break;
	          }

	          max = p;
	        }

	        if (!hasChange) return;
	        node.body = stableSort(body.slice());
	      }

	    }
	  }
	};

	function normalizeOptions(config) {
	  const {
	    filename,
	    cwd,
	    filenameRelative = typeof filename === "string" ? path$1.relative(cwd, filename) : "unknown",
	    sourceType = "module",
	    inputSourceMap,
	    sourceMaps = !!inputSourceMap,
	    sourceRoot = process.env.BABEL_8_BREAKING ? undefined : config.options.moduleRoot,
	    sourceFileName = path$1.basename(filenameRelative),
	    comments = true,
	    compact = "auto"
	  } = config.options;
	  const opts = config.options;
	  const options = { ...opts,
	    parserOpts: {
	      sourceType: path$1.extname(filenameRelative) === ".mjs" ? "module" : sourceType,
	      sourceFileName: filename,
	      plugins: [],
	      ...opts.parserOpts
	    },
	    generatorOpts: {
	      filename,
	      auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
	      auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
	      retainLines: opts.retainLines,
	      comments,
	      shouldPrintComment: opts.shouldPrintComment,
	      compact,
	      minified: opts.minified,
	      sourceMaps,
	      sourceRoot,
	      sourceFileName,
	      ...opts.generatorOpts
	    }
	  };

	  for (const plugins of config.passes) {
	    for (const plugin of plugins) {
	      if (plugin.manipulateOptions) {
	        plugin.manipulateOptions(options, options.parserOpts);
	      }
	    }
	  }

	  return options;
	}

	var fs = {};

	var safeBuffer = createCommonjsModule(function (module, exports) {
	  var Buffer = buffer.Buffer;

	  function copyProps(src, dst) {
	    for (var key in src) {
	      dst[key] = src[key];
	    }
	  }

	  if (Buffer.from && Buffer.alloc && Buffer.allocUnsafe && Buffer.allocUnsafeSlow) {
	    module.exports = buffer;
	  } else {
	    copyProps(buffer, exports);
	    exports.Buffer = SafeBuffer;
	  }

	  function SafeBuffer(arg, encodingOrOffset, length) {
	    return Buffer(arg, encodingOrOffset, length);
	  }

	  copyProps(Buffer, SafeBuffer);

	  SafeBuffer.from = function (arg, encodingOrOffset, length) {
	    if (typeof arg === 'number') {
	      throw new TypeError('Argument must not be a number');
	    }

	    return Buffer(arg, encodingOrOffset, length);
	  };

	  SafeBuffer.alloc = function (size, fill, encoding) {
	    if (typeof size !== 'number') {
	      throw new TypeError('Argument must be a number');
	    }

	    var buf = Buffer(size);

	    if (fill !== undefined) {
	      if (typeof encoding === 'string') {
	        buf.fill(fill, encoding);
	      } else {
	        buf.fill(fill);
	      }
	    } else {
	      buf.fill(0);
	    }

	    return buf;
	  };

	  SafeBuffer.allocUnsafe = function (size) {
	    if (typeof size !== 'number') {
	      throw new TypeError('Argument must be a number');
	    }

	    return Buffer(size);
	  };

	  SafeBuffer.allocUnsafeSlow = function (size) {
	    if (typeof size !== 'number') {
	      throw new TypeError('Argument must be a number');
	    }

	    return buffer.SlowBuffer(size);
	  };
	}, "/$$rollup_base$$/node_modules/convert-source-map/node_modules/safe-buffer");

	var path = /*@__PURE__*/getAugmentedNamespace(path$2);

	var convertSourceMap = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, 'commentRegex', {
	    get: function getCommentRegex() {
	      return /^\s*\/(?:\/|\*)[@#]\s+sourceMappingURL=data:(?:application|text)\/json;(?:charset[:=]\S+?;)?base64,(?:.*)$/mg;
	    }
	  });
	  Object.defineProperty(exports, 'mapFileCommentRegex', {
	    get: function getMapFileCommentRegex() {
	      return /(?:\/\/[@#][ \t]+sourceMappingURL=([^\s'"`]+?)[ \t]*$)|(?:\/\*[@#][ \t]+sourceMappingURL=([^\*]+?)[ \t]*(?:\*\/){1}[ \t]*$)/mg;
	    }
	  });

	  function decodeBase64(base64) {
	    return safeBuffer.Buffer.from(base64, 'base64').toString();
	  }

	  function stripComment(sm) {
	    return sm.split(',').pop();
	  }

	  function readFromFileMap(sm, dir) {
	    var r = exports.mapFileCommentRegex.exec(sm);
	    var filename = r[1] || r[2];
	    var filepath = path.resolve(dir, filename);

	    try {
	      return fs$1.readFileSync(filepath, 'utf8');
	    } catch (e) {
	      throw new Error('An error occurred while trying to read the map file at ' + filepath + '\n' + e);
	    }
	  }

	  function Converter(sm, opts) {
	    opts = opts || {};
	    if (opts.isFileComment) sm = readFromFileMap(sm, opts.commentFileDir);
	    if (opts.hasComment) sm = stripComment(sm);
	    if (opts.isEncoded) sm = decodeBase64(sm);
	    if (opts.isJSON || opts.isEncoded) sm = JSON.parse(sm);
	    this.sourcemap = sm;
	  }

	  Converter.prototype.toJSON = function (space) {
	    return JSON.stringify(this.sourcemap, null, space);
	  };

	  Converter.prototype.toBase64 = function () {
	    var json = this.toJSON();
	    return safeBuffer.Buffer.from(json, 'utf8').toString('base64');
	  };

	  Converter.prototype.toComment = function (options) {
	    var base64 = this.toBase64();
	    var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;
	    return options && options.multiline ? '/*# ' + data + ' */' : '//# ' + data;
	  };

	  Converter.prototype.toObject = function () {
	    return JSON.parse(this.toJSON());
	  };

	  Converter.prototype.addProperty = function (key, value) {
	    if (this.sourcemap.hasOwnProperty(key)) throw new Error('property "' + key + '" already exists on the sourcemap, use set property instead');
	    return this.setProperty(key, value);
	  };

	  Converter.prototype.setProperty = function (key, value) {
	    this.sourcemap[key] = value;
	    return this;
	  };

	  Converter.prototype.getProperty = function (key) {
	    return this.sourcemap[key];
	  };

	  exports.fromObject = function (obj) {
	    return new Converter(obj);
	  };

	  exports.fromJSON = function (json) {
	    return new Converter(json, {
	      isJSON: true
	    });
	  };

	  exports.fromBase64 = function (base64) {
	    return new Converter(base64, {
	      isEncoded: true
	    });
	  };

	  exports.fromComment = function (comment) {
	    comment = comment.replace(/^\/\*/g, '//').replace(/\*\/$/g, '');
	    return new Converter(comment, {
	      isEncoded: true,
	      hasComment: true
	    });
	  };

	  exports.fromMapFileComment = function (comment, dir) {
	    return new Converter(comment, {
	      commentFileDir: dir,
	      isFileComment: true,
	      isJSON: true
	    });
	  };

	  exports.fromSource = function (content) {
	    var m = content.match(exports.commentRegex);
	    return m ? exports.fromComment(m.pop()) : null;
	  };

	  exports.fromMapFileSource = function (content, dir) {
	    var m = content.match(exports.mapFileCommentRegex);
	    return m ? exports.fromMapFileComment(m.pop(), dir) : null;
	  };

	  exports.removeComments = function (src) {
	    return src.replace(exports.commentRegex, '');
	  };

	  exports.removeMapFileComments = function (src) {
	    return src.replace(exports.mapFileCommentRegex, '');
	  };

	  exports.generateMapFileComment = function (file, options) {
	    var data = 'sourceMappingURL=' + file;
	    return options && options.multiline ? '/*# ' + data + ' */' : '//# ' + data;
	  };
	}, "/$$rollup_base$$/node_modules/convert-source-map");

	const pluginNameMap = {
	  asyncDoExpressions: {
	    syntax: {
	      name: "@babel/plugin-syntax-async-do-expressions",
	      url: "https://git.io/JYer8"
	    }
	  },
	  classProperties: {
	    syntax: {
	      name: "@babel/plugin-syntax-class-properties",
	      url: "https://git.io/vb4yQ"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-class-properties",
	      url: "https://git.io/vb4SL"
	    }
	  },
	  classPrivateProperties: {
	    syntax: {
	      name: "@babel/plugin-syntax-class-properties",
	      url: "https://git.io/vb4yQ"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-class-properties",
	      url: "https://git.io/vb4SL"
	    }
	  },
	  classPrivateMethods: {
	    syntax: {
	      name: "@babel/plugin-syntax-class-properties",
	      url: "https://git.io/vb4yQ"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-private-methods",
	      url: "https://git.io/JvpRG"
	    }
	  },
	  classStaticBlock: {
	    syntax: {
	      name: "@babel/plugin-syntax-class-static-block",
	      url: "https://git.io/JTLB6"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-class-static-block",
	      url: "https://git.io/JTLBP"
	    }
	  },
	  decimal: {
	    syntax: {
	      name: "@babel/plugin-syntax-decimal",
	      url: "https://git.io/JfKOH"
	    }
	  },
	  decorators: {
	    syntax: {
	      name: "@babel/plugin-syntax-decorators",
	      url: "https://git.io/vb4y9"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-decorators",
	      url: "https://git.io/vb4ST"
	    }
	  },
	  doExpressions: {
	    syntax: {
	      name: "@babel/plugin-syntax-do-expressions",
	      url: "https://git.io/vb4yh"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-do-expressions",
	      url: "https://git.io/vb4S3"
	    }
	  },
	  dynamicImport: {
	    syntax: {
	      name: "@babel/plugin-syntax-dynamic-import",
	      url: "https://git.io/vb4Sv"
	    }
	  },
	  exportDefaultFrom: {
	    syntax: {
	      name: "@babel/plugin-syntax-export-default-from",
	      url: "https://git.io/vb4SO"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-export-default-from",
	      url: "https://git.io/vb4yH"
	    }
	  },
	  exportNamespaceFrom: {
	    syntax: {
	      name: "@babel/plugin-syntax-export-namespace-from",
	      url: "https://git.io/vb4Sf"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-export-namespace-from",
	      url: "https://git.io/vb4SG"
	    }
	  },
	  flow: {
	    syntax: {
	      name: "@babel/plugin-syntax-flow",
	      url: "https://git.io/vb4yb"
	    },
	    transform: {
	      name: "@babel/preset-flow",
	      url: "https://git.io/JfeDn"
	    }
	  },
	  functionBind: {
	    syntax: {
	      name: "@babel/plugin-syntax-function-bind",
	      url: "https://git.io/vb4y7"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-function-bind",
	      url: "https://git.io/vb4St"
	    }
	  },
	  functionSent: {
	    syntax: {
	      name: "@babel/plugin-syntax-function-sent",
	      url: "https://git.io/vb4yN"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-function-sent",
	      url: "https://git.io/vb4SZ"
	    }
	  },
	  importMeta: {
	    syntax: {
	      name: "@babel/plugin-syntax-import-meta",
	      url: "https://git.io/vbKK6"
	    }
	  },
	  jsx: {
	    syntax: {
	      name: "@babel/plugin-syntax-jsx",
	      url: "https://git.io/vb4yA"
	    },
	    transform: {
	      name: "@babel/preset-react",
	      url: "https://git.io/JfeDR"
	    }
	  },
	  importAssertions: {
	    syntax: {
	      name: "@babel/plugin-syntax-import-assertions",
	      url: "https://git.io/JUbkv"
	    }
	  },
	  moduleStringNames: {
	    syntax: {
	      name: "@babel/plugin-syntax-module-string-names",
	      url: "https://git.io/JTL8G"
	    }
	  },
	  numericSeparator: {
	    syntax: {
	      name: "@babel/plugin-syntax-numeric-separator",
	      url: "https://git.io/vb4Sq"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-numeric-separator",
	      url: "https://git.io/vb4yS"
	    }
	  },
	  optionalChaining: {
	    syntax: {
	      name: "@babel/plugin-syntax-optional-chaining",
	      url: "https://git.io/vb4Sc"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-optional-chaining",
	      url: "https://git.io/vb4Sk"
	    }
	  },
	  pipelineOperator: {
	    syntax: {
	      name: "@babel/plugin-syntax-pipeline-operator",
	      url: "https://git.io/vb4yj"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-pipeline-operator",
	      url: "https://git.io/vb4SU"
	    }
	  },
	  privateIn: {
	    syntax: {
	      name: "@babel/plugin-syntax-private-property-in-object",
	      url: "https://git.io/JfK3q"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-private-property-in-object",
	      url: "https://git.io/JfK3O"
	    }
	  },
	  recordAndTuple: {
	    syntax: {
	      name: "@babel/plugin-syntax-record-and-tuple",
	      url: "https://git.io/JvKp3"
	    }
	  },
	  regexpUnicodeSets: {
	    syntax: {
	      name: "@babel/plugin-syntax-unicode-sets-regex",
	      url: "https://git.io/J9GTd"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-unicode-sets-regex",
	      url: "https://git.io/J9GTQ"
	    }
	  },
	  throwExpressions: {
	    syntax: {
	      name: "@babel/plugin-syntax-throw-expressions",
	      url: "https://git.io/vb4SJ"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-throw-expressions",
	      url: "https://git.io/vb4yF"
	    }
	  },
	  typescript: {
	    syntax: {
	      name: "@babel/plugin-syntax-typescript",
	      url: "https://git.io/vb4SC"
	    },
	    transform: {
	      name: "@babel/preset-typescript",
	      url: "https://git.io/JfeDz"
	    }
	  },
	  asyncGenerators: {
	    syntax: {
	      name: "@babel/plugin-syntax-async-generators",
	      url: "https://git.io/vb4SY"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-async-generator-functions",
	      url: "https://git.io/vb4yp"
	    }
	  },
	  logicalAssignment: {
	    syntax: {
	      name: "@babel/plugin-syntax-logical-assignment-operators",
	      url: "https://git.io/vAlBp"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-logical-assignment-operators",
	      url: "https://git.io/vAlRe"
	    }
	  },
	  nullishCoalescingOperator: {
	    syntax: {
	      name: "@babel/plugin-syntax-nullish-coalescing-operator",
	      url: "https://git.io/vb4yx"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-nullish-coalescing-operator",
	      url: "https://git.io/vb4Se"
	    }
	  },
	  objectRestSpread: {
	    syntax: {
	      name: "@babel/plugin-syntax-object-rest-spread",
	      url: "https://git.io/vb4y5"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-object-rest-spread",
	      url: "https://git.io/vb4Ss"
	    }
	  },
	  optionalCatchBinding: {
	    syntax: {
	      name: "@babel/plugin-syntax-optional-catch-binding",
	      url: "https://git.io/vb4Sn"
	    },
	    transform: {
	      name: "@babel/plugin-proposal-optional-catch-binding",
	      url: "https://git.io/vb4SI"
	    }
	  }
	};
	pluginNameMap.privateIn.syntax = pluginNameMap.privateIn.transform;

	const getNameURLCombination = ({
	  name,
	  url
	}) => `${name} (${url})`;

	function generateMissingPluginMessage(missingPluginName, loc, codeFrame) {
	  let helpMessage = `Support for the experimental syntax '${missingPluginName}' isn't currently enabled ` + `(${loc.line}:${loc.column + 1}):\n\n` + codeFrame;
	  const pluginInfo = pluginNameMap[missingPluginName];

	  if (pluginInfo) {
	    const {
	      syntax: syntaxPlugin,
	      transform: transformPlugin
	    } = pluginInfo;

	    if (syntaxPlugin) {
	      const syntaxPluginInfo = getNameURLCombination(syntaxPlugin);

	      if (transformPlugin) {
	        const transformPluginInfo = getNameURLCombination(transformPlugin);
	        const sectionType = transformPlugin.name.startsWith("@babel/plugin") ? "plugins" : "presets";
	        helpMessage += `\n\nAdd ${transformPluginInfo} to the '${sectionType}' section of your Babel config to enable transformation.
If you want to leave it as-is, add ${syntaxPluginInfo} to the 'plugins' section to enable parsing.`;
	      } else {
	        helpMessage += `\n\nAdd ${syntaxPluginInfo} to the 'plugins' section of your Babel config ` + `to enable parsing.`;
	      }
	    }
	  }

	  return helpMessage;
	}

	function* parser$1(pluginPasses, {
	  parserOpts,
	  highlightCode = true,
	  filename = "unknown"
	}, code) {
	  try {
	    const results = [];

	    for (const plugins of pluginPasses) {
	      for (const plugin of plugins) {
	        const {
	          parserOverride
	        } = plugin;

	        if (parserOverride) {
	          const ast = parserOverride(code, parserOpts, parse$4);
	          if (ast !== undefined) results.push(ast);
	        }
	      }
	    }

	    if (results.length === 0) {
	      return parse$4(code, parserOpts);
	    } else if (results.length === 1) {
	      yield* [];

	      if (typeof results[0].then === "function") {
	        throw new Error(`You appear to be using an async parser plugin, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, you may need to upgrade ` + `your @babel/core version.`);
	      }

	      return results[0];
	    }

	    throw new Error("More than one plugin attempted to override parsing.");
	  } catch (err) {
	    if (err.code === "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED") {
	      err.message += "\nConsider renaming the file to '.mjs', or setting sourceType:module " + "or sourceType:unambiguous in your Babel config for this file.";
	    }

	    const {
	      loc,
	      missingPlugin
	    } = err;

	    if (loc) {
	      const codeFrame = codeFrameColumns(code, {
	        start: {
	          line: loc.line,
	          column: loc.column + 1
	        }
	      }, {
	        highlightCode
	      });

	      if (missingPlugin) {
	        err.message = `${filename}: ` + generateMissingPluginMessage(missingPlugin[0], loc, codeFrame);
	      } else {
	        err.message = `${filename}: ${err.message}\n\n` + codeFrame;
	      }

	      err.code = "BABEL_PARSE_ERROR";
	    }

	    throw err;
	  }
	}

	const serialized = "$$ babel internal serialized type" + Math.random();

	function serialize(key, value) {
	  if (typeof value !== "bigint") return value;
	  return {
	    [serialized]: "BigInt",
	    value: value.toString()
	  };
	}

	function revive(key, value) {
	  if (!value || typeof value !== "object") return value;
	  if (value[serialized] !== "BigInt") return value;
	  return BigInt(value.value);
	}

	function cloneDeep (value) {
	  return JSON.parse(JSON.stringify(value, serialize), revive);
	}

	const {
	  file,
	  traverseFast
	} = _t;
	const debug = browser$4("babel:transform:file");
	const LARGE_INPUT_SOURCEMAP_THRESHOLD = 1_000_000;
	function* normalizeFile(pluginPasses, options, code, ast) {
	  code = `${code || ""}`;

	  if (ast) {
	    if (ast.type === "Program") {
	      ast = file(ast, [], []);
	    } else if (ast.type !== "File") {
	      throw new Error("AST root must be a Program or File node");
	    }

	    if (options.cloneInputAst) {
	      ast = cloneDeep(ast);
	    }
	  } else {
	    ast = yield* parser$1(pluginPasses, options, code);
	  }

	  let inputMap = null;

	  if (options.inputSourceMap !== false) {
	    if (typeof options.inputSourceMap === "object") {
	      inputMap = convertSourceMap.fromObject(options.inputSourceMap);
	    }

	    if (!inputMap) {
	      const lastComment = extractComments(INLINE_SOURCEMAP_REGEX, ast);

	      if (lastComment) {
	        try {
	          inputMap = convertSourceMap.fromComment(lastComment);
	        } catch (err) {
	          debug("discarding unknown inline input sourcemap", err);
	        }
	      }
	    }

	    if (!inputMap) {
	      const lastComment = extractComments(EXTERNAL_SOURCEMAP_REGEX, ast);

	      if (typeof options.filename === "string" && lastComment) {
	        try {
	          const match = EXTERNAL_SOURCEMAP_REGEX.exec(lastComment);
	          const inputMapContent = fs.readFileSync(path$1.resolve(path$1.dirname(options.filename), match[1]));

	          if (inputMapContent.length > LARGE_INPUT_SOURCEMAP_THRESHOLD) {
	            debug("skip merging input map > 1 MB");
	          } else {
	            inputMap = convertSourceMap.fromJSON(inputMapContent);
	          }
	        } catch (err) {
	          debug("discarding unknown file input sourcemap", err);
	        }
	      } else if (lastComment) {
	        debug("discarding un-loadable file input sourcemap");
	      }
	    }
	  }

	  return new File(options, {
	    code,
	    ast,
	    inputMap
	  });
	}
	const INLINE_SOURCEMAP_REGEX = /^[@#]\s+sourceMappingURL=data:(?:application|text)\/json;(?:charset[:=]\S+?;)?base64,(?:.*)$/;
	const EXTERNAL_SOURCEMAP_REGEX = /^[@#][ \t]+sourceMappingURL=([^\s'"`]+)[ \t]*$/;

	function extractCommentsFromList(regex, comments, lastComment) {
	  if (comments) {
	    comments = comments.filter(({
	      value
	    }) => {
	      if (regex.test(value)) {
	        lastComment = value;
	        return false;
	      }

	      return true;
	    });
	  }

	  return [comments, lastComment];
	}

	function extractComments(regex, ast) {
	  let lastComment = null;
	  traverseFast(ast, node => {
	    [node.leadingComments, lastComment] = extractCommentsFromList(regex, node.leadingComments, lastComment);
	    [node.innerComments, lastComment] = extractCommentsFromList(regex, node.innerComments, lastComment);
	    [node.trailingComments, lastComment] = extractCommentsFromList(regex, node.trailingComments, lastComment);
	  });
	  return lastComment;
	}

	var sourcemapCodec_umd = createCommonjsModule(function (module, exports) {
	  (function (global, factory) {
	    factory(exports) ;
	  })(commonjsGlobal, function (exports) {

	    const comma = 44;
	    const semicolon = 59;
	    const chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
	    const intToChar = new Uint8Array(65);
	    const charToInteger = new Uint8Array(123);

	    for (let i = 0; i < chars.length; i++) {
	      const c = chars.charCodeAt(i);
	      charToInteger[c] = i;
	      intToChar[i] = c;
	    }

	    const td = typeof TextDecoder !== 'undefined' ? new TextDecoder() : typeof buffer.Buffer !== 'undefined' ? {
	      decode(buf) {
	        const out = buffer.Buffer.from(buf.buffer, buf.byteOffset, buf.byteLength);
	        return out.toString();
	      }

	    } : {
	      decode(buf) {
	        let out = '';

	        for (let i = 0; i < buf.length; i++) {
	          out += String.fromCharCode(buf[i]);
	        }

	        return out;
	      }

	    };

	    function decode(mappings) {
	      const state = new Int32Array(5);
	      const decoded = [];
	      let line = [];
	      let sorted = true;
	      let lastCol = 0;

	      for (let i = 0; i < mappings.length;) {
	        const c = mappings.charCodeAt(i);

	        if (c === comma) {
	          i++;
	        } else if (c === semicolon) {
	          state[0] = lastCol = 0;
	          if (!sorted) sort(line);
	          sorted = true;
	          decoded.push(line);
	          line = [];
	          i++;
	        } else {
	          i = decodeInteger(mappings, i, state, 0);
	          const col = state[0];
	          if (col < lastCol) sorted = false;
	          lastCol = col;

	          if (!hasMoreSegments(mappings, i)) {
	            line.push([col]);
	            continue;
	          }

	          i = decodeInteger(mappings, i, state, 1);
	          i = decodeInteger(mappings, i, state, 2);
	          i = decodeInteger(mappings, i, state, 3);

	          if (!hasMoreSegments(mappings, i)) {
	            line.push([col, state[1], state[2], state[3]]);
	            continue;
	          }

	          i = decodeInteger(mappings, i, state, 4);
	          line.push([col, state[1], state[2], state[3], state[4]]);
	        }
	      }

	      if (!sorted) sort(line);
	      decoded.push(line);
	      return decoded;
	    }

	    function decodeInteger(mappings, pos, state, j) {
	      let value = 0;
	      let shift = 0;
	      let integer = 0;

	      do {
	        const c = mappings.charCodeAt(pos++);
	        integer = charToInteger[c];
	        value |= (integer & 31) << shift;
	        shift += 5;
	      } while (integer & 32);

	      const shouldNegate = value & 1;
	      value >>>= 1;

	      if (shouldNegate) {
	        value = value === 0 ? -0x80000000 : -value;
	      }

	      state[j] += value;
	      return pos;
	    }

	    function hasMoreSegments(mappings, i) {
	      if (i >= mappings.length) return false;
	      const c = mappings.charCodeAt(i);
	      if (c === comma || c === semicolon) return false;
	      return true;
	    }

	    function sort(line) {
	      line.sort(sortComparator);
	    }

	    function sortComparator(a, b) {
	      return a[0] - b[0];
	    }

	    function encode(decoded) {
	      const state = new Int32Array(5);
	      let buf = new Uint8Array(1000);
	      let pos = 0;

	      for (let i = 0; i < decoded.length; i++) {
	        const line = decoded[i];

	        if (i > 0) {
	          buf = reserve(buf, pos, 1);
	          buf[pos++] = semicolon;
	        }

	        if (line.length === 0) continue;
	        state[0] = 0;

	        for (let j = 0; j < line.length; j++) {
	          const segment = line[j];
	          buf = reserve(buf, pos, 36);
	          if (j > 0) buf[pos++] = comma;
	          pos = encodeInteger(buf, pos, state, segment, 0);
	          if (segment.length === 1) continue;
	          pos = encodeInteger(buf, pos, state, segment, 1);
	          pos = encodeInteger(buf, pos, state, segment, 2);
	          pos = encodeInteger(buf, pos, state, segment, 3);
	          if (segment.length === 4) continue;
	          pos = encodeInteger(buf, pos, state, segment, 4);
	        }
	      }

	      return td.decode(buf.subarray(0, pos));
	    }

	    function reserve(buf, pos, count) {
	      if (buf.length > pos + count) return buf;
	      const swap = new Uint8Array(buf.length * 2);
	      swap.set(buf);
	      return swap;
	    }

	    function encodeInteger(buf, pos, state, segment, j) {
	      const next = segment[j];
	      let num = next - state[j];
	      state[j] = next;
	      num = num < 0 ? -num << 1 | 1 : num << 1;

	      do {
	        let clamped = num & 31;
	        num >>>= 5;
	        if (num > 0) clamped |= 32;
	        buf[pos++] = intToChar[clamped];
	      } while (num > 0);

	      return pos;
	    }

	    exports.decode = decode;
	    exports.encode = encode;
	    Object.defineProperty(exports, '__esModule', {
	      value: true
	    });
	  });
	}, "/$$rollup_base$$/node_modules/@jridgewell/sourcemap-codec/dist");

	var resolveUri_umd = createCommonjsModule(function (module, exports) {
	  (function (global, factory) {
	    module.exports = factory() ;
	  })(commonjsGlobal, function () {

	    const schemeRegex = /^[\w+.-]+:\/\//;
	    const urlRegex = /^([\w+.-]+:)\/\/([^@]*@)?([^:/]*)(:\d+)?(\/[^#?]*)?/;

	    function isAbsoluteUrl(input) {
	      return schemeRegex.test(input);
	    }

	    function isSchemeRelativeUrl(input) {
	      return input.startsWith('//');
	    }

	    function isAbsolutePath(input) {
	      return input.startsWith('/');
	    }

	    function parseAbsoluteUrl(input) {
	      const match = urlRegex.exec(input);
	      return {
	        scheme: match[1],
	        user: match[2] || '',
	        host: match[3],
	        port: match[4] || '',
	        path: match[5] || '/',
	        relativePath: false
	      };
	    }

	    function parseUrl(input) {
	      if (isSchemeRelativeUrl(input)) {
	        const url = parseAbsoluteUrl('http:' + input);
	        url.scheme = '';
	        return url;
	      }

	      if (isAbsolutePath(input)) {
	        const url = parseAbsoluteUrl('http://foo.com' + input);
	        url.scheme = '';
	        url.host = '';
	        return url;
	      }

	      if (!isAbsoluteUrl(input)) {
	        const url = parseAbsoluteUrl('http://foo.com/' + input);
	        url.scheme = '';
	        url.host = '';
	        url.relativePath = true;
	        return url;
	      }

	      return parseAbsoluteUrl(input);
	    }

	    function stripPathFilename(path) {
	      if (path.endsWith('/..')) return path;
	      const index = path.lastIndexOf('/');
	      return path.slice(0, index + 1);
	    }

	    function mergePaths(url, base) {
	      if (!url.relativePath) return;
	      normalizePath(base);

	      if (url.path === '/') {
	        url.path = base.path;
	      } else {
	        url.path = stripPathFilename(base.path) + url.path;
	      }

	      url.relativePath = base.relativePath;
	    }

	    function normalizePath(url) {
	      const {
	        relativePath
	      } = url;
	      const pieces = url.path.split('/');
	      let pointer = 1;
	      let positive = 0;
	      let addTrailingSlash = false;

	      for (let i = 1; i < pieces.length; i++) {
	        const piece = pieces[i];

	        if (!piece) {
	          addTrailingSlash = true;
	          continue;
	        }

	        addTrailingSlash = false;
	        if (piece === '.') continue;

	        if (piece === '..') {
	          if (positive) {
	            addTrailingSlash = true;
	            positive--;
	            pointer--;
	          } else if (relativePath) {
	            pieces[pointer++] = piece;
	          }

	          continue;
	        }

	        pieces[pointer++] = piece;
	        positive++;
	      }

	      let path = '';

	      for (let i = 1; i < pointer; i++) {
	        path += '/' + pieces[i];
	      }

	      if (!path || addTrailingSlash && !path.endsWith('/..')) {
	        path += '/';
	      }

	      url.path = path;
	    }

	    function resolve(input, base) {
	      if (!input && !base) return '';
	      const url = parseUrl(input);

	      if (base && !url.scheme) {
	        const baseUrl = parseUrl(base);
	        url.scheme = baseUrl.scheme;

	        if (!url.host || baseUrl.scheme === 'file:') {
	          url.user = baseUrl.user;
	          url.host = baseUrl.host;
	          url.port = baseUrl.port;
	        }

	        mergePaths(url, baseUrl);
	      }

	      normalizePath(url);

	      if (url.relativePath) {
	        const path = url.path.slice(1);
	        if (!path) return '.';
	        const keepRelative = (base || input).startsWith('.');
	        return !keepRelative || path.startsWith('.') ? path : './' + path;
	      }

	      if (!url.scheme && !url.host) return url.path;
	      return `${url.scheme}//${url.user}${url.host}${url.port}${url.path}`;
	    }

	    return resolve;
	  });
	}, "/$$rollup_base$$/node_modules/@jridgewell/resolve-uri/dist");

	var traceMapping_umd = createCommonjsModule(function (module, exports) {
	  (function (global, factory) {
	    factory(exports, sourcemapCodec_umd, resolveUri_umd) ;
	  })(commonjsGlobal, function (exports, sourcemapCodec, resolveUri) {

	    function _interopDefaultLegacy(e) {
	      return e && typeof e === 'object' && 'default' in e ? e : {
	        'default': e
	      };
	    }

	    var resolveUri__default = _interopDefaultLegacy(resolveUri);

	    function resolve(input, base) {
	      if (base && !base.endsWith('/')) base += '/';
	      return resolveUri__default["default"](input, base);
	    }

	    function stripFilename(path) {
	      if (!path) return '';
	      const index = path.lastIndexOf('/');
	      return path.slice(0, index + 1);
	    }

	    function maybeSort(mappings, owned) {
	      const unsortedIndex = nextUnsortedSegmentLine(mappings, 0);
	      if (unsortedIndex === mappings.length) return mappings;
	      if (!owned) mappings = mappings.slice();

	      for (let i = unsortedIndex; i < mappings.length; i = nextUnsortedSegmentLine(mappings, i + 1)) {
	        mappings[i] = sortSegments(mappings[i], owned);
	      }

	      return mappings;
	    }

	    function nextUnsortedSegmentLine(mappings, start) {
	      for (let i = start; i < mappings.length; i++) {
	        if (!isSorted(mappings[i])) return i;
	      }

	      return mappings.length;
	    }

	    function isSorted(line) {
	      for (let j = 1; j < line.length; j++) {
	        if (line[j][0] < line[j - 1][0]) {
	          return false;
	        }
	      }

	      return true;
	    }

	    function sortSegments(line, owned) {
	      if (!owned) line = line.slice();
	      return line.sort(sortComparator);
	    }

	    function sortComparator(a, b) {
	      return a[0] - b[0];
	    }

	    function binarySearch(haystack, needle, low, high) {
	      while (low <= high) {
	        const mid = low + (high - low >> 1);
	        const cmp = haystack[mid][0] - needle;

	        if (cmp === 0) {
	          return mid;
	        }

	        if (cmp < 0) {
	          low = mid + 1;
	        } else {
	          high = mid - 1;
	        }
	      }

	      return low - 1;
	    }

	    function memoizedState() {
	      return {
	        lastKey: -1,
	        lastNeedle: -1,
	        lastIndex: -1
	      };
	    }

	    function memoizedBinarySearch(haystack, needle, state, key) {
	      const {
	        lastKey,
	        lastNeedle,
	        lastIndex
	      } = state;
	      let low = 0;
	      let high = haystack.length - 1;

	      if (key === lastKey) {
	        if (needle === lastNeedle) {
	          return lastIndex;
	        }

	        if (needle >= lastNeedle) {
	          low = Math.max(lastIndex, 0);
	        } else {
	          high = lastIndex;
	        }
	      }

	      state.lastKey = key;
	      state.lastNeedle = needle;
	      return state.lastIndex = binarySearch(haystack, needle, low, high);
	    }

	    const INVALID_MAPPING = Object.freeze({
	      source: null,
	      line: null,
	      column: null,
	      name: null
	    });
	    exports.encodedMappings = void 0;
	    exports.decodedMappings = void 0;
	    exports.traceSegment = void 0;
	    exports.originalPositionFor = void 0;
	    exports.eachMapping = void 0;
	    exports.presortedDecodedMap = void 0;

	    class TraceMap {
	      constructor(map, mapUrl) {
	        this._binarySearchMemo = memoizedState();
	        const isString = typeof map === 'string';
	        const parsed = isString ? JSON.parse(map) : map;
	        const {
	          version,
	          file,
	          names,
	          sourceRoot,
	          sources,
	          sourcesContent
	        } = parsed;
	        this.version = version;
	        this.file = file;
	        this.names = names;
	        this.sourceRoot = sourceRoot;
	        this.sources = sources;
	        this.sourcesContent = sourcesContent;

	        if (sourceRoot || mapUrl) {
	          const from = resolve(sourceRoot || '', stripFilename(mapUrl));
	          this.resolvedSources = sources.map(s => resolve(s || '', from));
	        } else {
	          this.resolvedSources = sources.map(s => s || '');
	        }

	        const {
	          mappings
	        } = parsed;

	        if (typeof mappings === 'string') {
	          this._encoded = mappings;
	          this._decoded = sourcemapCodec.decode(mappings);
	        } else {
	          this._encoded = undefined;
	          this._decoded = maybeSort(mappings, isString);
	        }
	      }

	    }

	    (() => {
	      exports.encodedMappings = map => {
	        var _a;

	        return (_a = map._encoded) !== null && _a !== void 0 ? _a : map._encoded = sourcemapCodec.encode(map._decoded);
	      };

	      exports.decodedMappings = map => {
	        return map._decoded;
	      };

	      exports.traceSegment = (map, line, column) => {
	        const decoded = map._decoded;
	        if (line >= decoded.length) return null;
	        const segments = decoded[line];
	        const index = memoizedBinarySearch(segments, column, map._binarySearchMemo, line);
	        if (index < 0) return null;
	        return segments[index];
	      };

	      exports.originalPositionFor = (map, {
	        line,
	        column
	      }) => {
	        if (line < 1) throw new Error('`line` must be greater than 0 (lines start at line 1)');

	        if (column < 0) {
	          throw new Error('`column` must be greater than or equal to 0 (columns start at column 0)');
	        }

	        const segment = exports.traceSegment(map, line - 1, column);
	        if (segment == null) return INVALID_MAPPING;
	        if (segment.length == 1) return INVALID_MAPPING;
	        const {
	          names,
	          resolvedSources
	        } = map;
	        return {
	          source: resolvedSources[segment[1]],
	          line: segment[2] + 1,
	          column: segment[3],
	          name: segment.length === 5 ? names[segment[4]] : null
	        };
	      };

	      exports.eachMapping = (map, cb) => {
	        const decoded = map._decoded;
	        const {
	          names,
	          resolvedSources
	        } = map;

	        for (let i = 0; i < decoded.length; i++) {
	          const line = decoded[i];

	          for (let j = 0; j < line.length; j++) {
	            const seg = line[j];
	            const generatedLine = i + 1;
	            const generatedColumn = seg[0];
	            let source = null;
	            let originalLine = null;
	            let originalColumn = null;
	            let name = null;

	            if (seg.length !== 1) {
	              source = resolvedSources[seg[1]];
	              originalLine = seg[2] + 1;
	              originalColumn = seg[3];
	            }

	            if (seg.length === 5) name = names[seg[4]];
	            cb({
	              generatedLine,
	              generatedColumn,
	              source,
	              originalLine,
	              originalColumn,
	              name
	            });
	          }
	        }
	      };

	      exports.presortedDecodedMap = (map, mapUrl) => {
	        const clone = Object.assign({}, map);
	        clone.mappings = [];
	        const tracer = new TraceMap(clone, mapUrl);
	        tracer._decoded = map.mappings;
	        return tracer;
	      };
	    })();

	    exports.TraceMap = TraceMap;
	    Object.defineProperty(exports, '__esModule', {
	      value: true
	    });
	  });
	}, "/$$rollup_base$$/node_modules/@jridgewell/trace-mapping/dist");

	class OriginalSource {
	  constructor(source, content) {
	    this.source = source;
	    this.content = content;
	  }

	  originalPositionFor(line, column, name) {
	    return {
	      column,
	      line,
	      name,
	      source: this.source,
	      content: this.content
	    };
	  }

	}

	let put;

	class FastStringArray {
	  constructor() {
	    this.indexes = Object.create(null);
	    this.array = [];
	  }

	}

	(() => {
	  put = (strarr, key) => {
	    const {
	      array,
	      indexes
	    } = strarr;
	    let index = indexes[key];

	    if (index === undefined) {
	      index = indexes[key] = array.length;
	      array.push(key);
	    }

	    return index;
	  };
	})();

	const INVALID_MAPPING = undefined;
	const SOURCELESS_MAPPING = null;
	let traceMappings;

	class SourceMapTree {
	  constructor(map, sources) {
	    this.map = map;
	    this.sources = sources;
	  }

	  originalPositionFor(line, column, name) {
	    const segment = traceMapping_umd.traceSegment(this.map, line, column);
	    if (segment == null) return INVALID_MAPPING;
	    if (segment.length === 1) return SOURCELESS_MAPPING;
	    const source = this.sources[segment[1]];
	    return source.originalPositionFor(segment[2], segment[3], segment.length === 5 ? this.map.names[segment[4]] : name);
	  }

	}

	(() => {
	  traceMappings = tree => {
	    const mappings = [];
	    const names = new FastStringArray();
	    const sources = new FastStringArray();
	    const sourcesContent = [];
	    const {
	      sources: rootSources,
	      map
	    } = tree;
	    const rootNames = map.names;
	    const rootMappings = traceMapping_umd.decodedMappings(map);
	    let lastLineWithSegment = -1;

	    for (let i = 0; i < rootMappings.length; i++) {
	      const segments = rootMappings[i];
	      const tracedSegments = [];
	      let lastSourcesIndex = -1;
	      let lastSourceLine = -1;
	      let lastSourceColumn = -1;

	      for (let j = 0; j < segments.length; j++) {
	        const segment = segments[j];
	        let traced = SOURCELESS_MAPPING;

	        if (segment.length !== 1) {
	          const source = rootSources[segment[1]];
	          traced = source.originalPositionFor(segment[2], segment[3], segment.length === 5 ? rootNames[segment[4]] : '');
	          if (traced === INVALID_MAPPING) continue;
	        }

	        const genCol = segment[0];

	        if (traced === SOURCELESS_MAPPING) {
	          if (lastSourcesIndex === -1) {
	            continue;
	          }

	          lastSourcesIndex = lastSourceLine = lastSourceColumn = -1;
	          tracedSegments.push([genCol]);
	          continue;
	        }

	        const {
	          column,
	          line,
	          name,
	          content,
	          source
	        } = traced;
	        const sourcesIndex = put(sources, source);
	        sourcesContent[sourcesIndex] = content;

	        if (lastSourcesIndex === sourcesIndex && lastSourceLine === line && lastSourceColumn === column) {
	          continue;
	        }

	        lastLineWithSegment = i;
	        lastSourcesIndex = sourcesIndex;
	        lastSourceLine = line;
	        lastSourceColumn = column;
	        tracedSegments.push(name ? [genCol, sourcesIndex, line, column, put(names, name)] : [genCol, sourcesIndex, line, column]);
	      }

	      mappings.push(tracedSegments);
	    }

	    if (mappings.length > lastLineWithSegment + 1) {
	      mappings.length = lastLineWithSegment + 1;
	    }

	    return traceMapping_umd.presortedDecodedMap(Object.assign({}, tree.map, {
	      mappings,
	      sourceRoot: undefined,
	      names: names.array,
	      sources: sources.array,
	      sourcesContent
	    }));
	  };
	})();

	function asArray(value) {
	  if (Array.isArray(value)) return value;
	  return [value];
	}

	function buildSourceMapTree(input, loader) {
	  const maps = asArray(input).map(m => new traceMapping_umd.TraceMap(m, ''));
	  const map = maps.pop();

	  for (let i = 0; i < maps.length; i++) {
	    if (maps[i].sources.length > 1) {
	      throw new Error(`Transformation map ${i} must have exactly one source file.\n` + 'Did you specify these with the most recent transformation maps first?');
	    }
	  }

	  let tree = build(map, '', loader);

	  for (let i = maps.length - 1; i >= 0; i--) {
	    tree = new SourceMapTree(maps[i], [tree]);
	  }

	  return tree;
	}

	function build(map, importer, loader) {
	  const {
	    resolvedSources,
	    sourcesContent
	  } = map;
	  const children = resolvedSources.map((sourceFile, i) => {
	    const ctx = {
	      importer,
	      source: sourceFile || '',
	      content: undefined
	    };
	    const sourceMap = loader(ctx.source, ctx);
	    const {
	      source,
	      content
	    } = ctx;

	    if (!sourceMap) {
	      const sourceContent = content !== undefined ? content : sourcesContent ? sourcesContent[i] : null;
	      return new OriginalSource(source, sourceContent);
	    }

	    return build(new traceMapping_umd.TraceMap(sourceMap, source), source, loader);
	  });
	  return new SourceMapTree(map, children);
	}

	class SourceMap {
	  constructor(map, options) {
	    this.version = 3;
	    this.file = map.file;
	    this.mappings = options.decodedMappings ? traceMapping_umd.decodedMappings(map) : traceMapping_umd.encodedMappings(map);
	    this.names = map.names;
	    this.sourceRoot = map.sourceRoot;
	    this.sources = map.sources;

	    if (!options.excludeContent && 'sourcesContent' in map) {
	      this.sourcesContent = map.sourcesContent;
	    }
	  }

	  toString() {
	    return JSON.stringify(this);
	  }

	}

	function remapping(input, loader, options) {
	  const opts = typeof options === 'object' ? options : {
	    excludeContent: !!options,
	    decodedMappings: false
	  };
	  const tree = buildSourceMapTree(input, loader);
	  return new SourceMap(traceMappings(tree), opts);
	}

	function mergeSourceMap(inputMap, map, sourceFileName) {
	  const source = sourceFileName.replace(/\\/g, "/");
	  let found = false;
	  const result = remapping(rootless(map), (s, ctx) => {
	    if (s === source && !found) {
	      found = true;
	      ctx.source = "";
	      return rootless(inputMap);
	    }

	    return null;
	  });

	  if (typeof inputMap.sourceRoot === "string") {
	    result.sourceRoot = inputMap.sourceRoot;
	  }

	  return { ...result
	  };
	}

	function rootless(map) {
	  return { ...map,
	    sourceRoot: null
	  };
	}

	function generateCode(pluginPasses, file) {
	  const {
	    opts,
	    ast,
	    code,
	    inputMap
	  } = file;
	  const {
	    generatorOpts
	  } = opts;
	  const results = [];

	  for (const plugins of pluginPasses) {
	    for (const plugin of plugins) {
	      const {
	        generatorOverride
	      } = plugin;

	      if (generatorOverride) {
	        const result = generatorOverride(ast, generatorOpts, code, generate$1);
	        if (result !== undefined) results.push(result);
	      }
	    }
	  }

	  let result;

	  if (results.length === 0) {
	    result = generate$1(ast, generatorOpts, code);
	  } else if (results.length === 1) {
	    result = results[0];

	    if (typeof result.then === "function") {
	      throw new Error(`You appear to be using an async codegen plugin, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, ` + `you may need to upgrade your @babel/core version.`);
	    }
	  } else {
	    throw new Error("More than one plugin attempted to override codegen.");
	  }

	  let {
	    code: outputCode,
	    map: outputMap
	  } = result;

	  if (outputMap && inputMap) {
	    outputMap = mergeSourceMap(inputMap.toObject(), outputMap, generatorOpts.sourceFileName);
	  }

	  if (opts.sourceMaps === "inline" || opts.sourceMaps === "both") {
	    outputCode += "\n" + convertSourceMap.fromObject(outputMap).toComment();
	  }

	  if (opts.sourceMaps === "inline") {
	    outputMap = null;
	  }

	  return {
	    outputCode,
	    outputMap
	  };
	}

	function* run$1(config, code, ast) {
	  const file = yield* normalizeFile(config.passes, normalizeOptions(config), code, ast);
	  const opts = file.opts;

	  try {
	    yield* transformFile$1(file, config.passes);
	  } catch (e) {
	    e.message = `${opts.filename ?? "unknown"}: ${e.message}`;

	    if (!e.code) {
	      e.code = "BABEL_TRANSFORM_ERROR";
	    }

	    throw e;
	  }

	  let outputCode, outputMap;

	  try {
	    if (opts.code !== false) {
	      ({
	        outputCode,
	        outputMap
	      } = generateCode(config.passes, file));
	    }
	  } catch (e) {
	    e.message = `${opts.filename ?? "unknown"}: ${e.message}`;

	    if (!e.code) {
	      e.code = "BABEL_GENERATE_ERROR";
	    }

	    throw e;
	  }

	  return {
	    metadata: file.metadata,
	    options: opts,
	    ast: opts.ast === true ? file.ast : null,
	    code: outputCode === undefined ? null : outputCode,
	    map: outputMap === undefined ? null : outputMap,
	    sourceType: file.ast.program.sourceType,
	    externalDependencies: flattenToSet(config.externalDependencies)
	  };
	}

	function* transformFile$1(file, pluginPasses) {
	  for (const pluginPairs of pluginPasses) {
	    const passPairs = [];
	    const passes = [];
	    const visitors = [];

	    for (const plugin of pluginPairs.concat([loadBlockHoistPlugin()])) {
	      const pass = new PluginPass(file, plugin.key, plugin.options);
	      passPairs.push([plugin, pass]);
	      passes.push(pass);
	      visitors.push(plugin.visitor);
	    }

	    for (const [plugin, pass] of passPairs) {
	      const fn = plugin.pre;

	      if (fn) {
	        const result = fn.call(pass, file);
	        yield* [];

	        if (isThenable(result)) {
	          throw new Error(`You appear to be using an plugin with an async .pre, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, you may need to upgrade ` + `your @babel/core version.`);
	        }
	      }
	    }

	    const visitor = traverse.visitors.merge(visitors, passes, file.opts.wrapPluginVisitorMethod);
	    traverse(file.ast, visitor, file.scope);

	    for (const [plugin, pass] of passPairs) {
	      const fn = plugin.post;

	      if (fn) {
	        const result = fn.call(pass, file);
	        yield* [];

	        if (isThenable(result)) {
	          throw new Error(`You appear to be using an plugin with an async .post, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, you may need to upgrade ` + `your @babel/core version.`);
	        }
	      }
	    }
	  }
	}

	function isThenable(val) {
	  return !!val && (typeof val === "object" || typeof val === "function") && !!val.then && typeof val.then === "function";
	}

	const transformRunner = gensync(function* transform(code, opts) {
	  const config = yield* loadConfig(opts);
	  if (config === null) return null;
	  return yield* run$1(config, code);
	});
	const transform$3 = function transform(code, opts, callback) {
	  if (typeof opts === "function") {
	    callback = opts;
	    opts = undefined;
	  }

	  if (callback === undefined) return transformRunner.sync(code, opts);
	  transformRunner.errback(code, opts, callback);
	};
	const transformSync = transformRunner.sync;
	const transformAsync = transformRunner.async;

	const transformFile = function transformFile(filename, opts, callback) {
	  if (typeof opts === "function") {
	    callback = opts;
	  }

	  callback(new Error("Transforming files is not supported in browsers"), null);
	};
	function transformFileSync() {
	  throw new Error("Transforming files is not supported in browsers");
	}
	function transformFileAsync() {
	  return Promise.reject(new Error("Transforming files is not supported in browsers"));
	}

	const transformFromAstRunner = gensync(function* (ast, code, opts) {
	  const config = yield* loadConfig(opts);
	  if (config === null) return null;
	  if (!ast) throw new Error("No AST given");
	  return yield* run$1(config, code, ast);
	});
	const transformFromAst$1 = function transformFromAst(ast, code, opts, callback) {
	  if (typeof opts === "function") {
	    callback = opts;
	    opts = undefined;
	  }

	  if (callback === undefined) {
	    return transformFromAstRunner.sync(ast, code, opts);
	  }

	  transformFromAstRunner.errback(ast, code, opts, callback);
	};
	const transformFromAstSync = transformFromAstRunner.sync;
	const transformFromAstAsync = transformFromAstRunner.async;

	const parseRunner = gensync(function* parse(code, opts) {
	  const config = yield* loadConfig(opts);

	  if (config === null) {
	    return null;
	  }

	  return yield* parser$1(config.passes, normalizeOptions(config), code);
	});
	const parse$1 = function parse(code, opts, callback) {
	  if (typeof opts === "function") {
	    callback = opts;
	    opts = undefined;
	  }

	  if (callback === undefined) return parseRunner.sync(code, opts);
	  parseRunner.errback(code, opts, callback);
	};
	const parseSync = parseRunner.sync;
	const parseAsync = parseRunner.async;

	const version$3 = "7.17.5";
	const DEFAULT_EXTENSIONS = Object.freeze([".js", ".jsx", ".es6", ".es", ".mjs", ".cjs"]);
	class OptionManager {
	  init(opts) {
	    return loadOptions(opts);
	  }

	}
	function Plugin(alias) {
	  throw new Error(`The (${alias}) Babel 5 plugin is being run with an unsupported Babel version.`);
	}

	function declare(builder) {
	  return (api, options, dirname) => {
	    let clonedApi;

	    for (const name of Object.keys(apiPolyfills)) {
	      if (api[name]) continue;
	      clonedApi = clonedApi ?? copyApiObject(api);
	      clonedApi[name] = apiPolyfills[name](clonedApi);
	    }

	    return builder(clonedApi ?? api, options || {}, dirname);
	  };
	}
	const apiPolyfills = {
	  assertVersion: api => range => {
	    throwVersionError(range, api.version);
	  },
	  targets: () => () => {
	    return {};
	  },
	  assumption: () => () => {}
	};

	function copyApiObject(api) {
	  let proto = null;

	  if (typeof api.version === "string" && /^7\./.test(api.version)) {
	    proto = Object.getPrototypeOf(api);

	    if (proto && (!has(proto, "version") || !has(proto, "transform") || !has(proto, "template") || !has(proto, "types"))) {
	      proto = null;
	    }
	  }

	  return { ...proto,
	    ...api
	  };
	}

	function has(obj, key) {
	  return Object.prototype.hasOwnProperty.call(obj, key);
	}

	function throwVersionError(range, version) {
	  if (typeof range === "number") {
	    if (!Number.isInteger(range)) {
	      throw new Error("Expected string or integer value.");
	    }

	    range = `^${range}.0.0-0`;
	  }

	  if (typeof range !== "string") {
	    throw new Error("Expected string or integer value.");
	  }

	  const limit = Error.stackTraceLimit;

	  if (typeof limit === "number" && limit < 25) {
	    Error.stackTraceLimit = 25;
	  }

	  let err;

	  if (version.slice(0, 2) === "7.") {
	    err = new Error(`Requires Babel "^7.0.0-beta.41", but was loaded with "${version}". ` + `You'll need to update your @babel/core version.`);
	  } else {
	    err = new Error(`Requires Babel "${range}", but was loaded with "${version}". ` + `If you are sure you have a compatible version of @babel/core, ` + `it is likely that something in your build process is loading the ` + `wrong version. Inspect the stack trace of this error to look for ` + `the first entry that doesn't mention "@babel/core" or "babel-core" ` + `to see what is calling Babel.`);
	  }

	  if (typeof limit === "number") {
	    Error.stackTraceLimit = limit;
	  }

	  throw Object.assign(err, {
	    code: "BABEL_VERSION_UNSUPPORTED",
	    version,
	    range
	  });
	}

	var src = /*#__PURE__*/Object.freeze({
		__proto__: null,
		declare: declare
	});

	var _helperPluginUtils = /*@__PURE__*/getAugmentedNamespace(src);

	var lib$e = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-async-generators",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("asyncGenerators");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-standalone/node_modules/@babel/plugin-syntax-async-generators/lib");

	var lib$d = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-class-properties",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("classProperties", "classPrivateProperties", "classPrivateMethods");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-standalone/node_modules/@babel/plugin-syntax-class-properties/lib");

	var lib$c = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-class-static-block",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("classStaticBlock");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-standalone/node_modules/@babel/plugin-syntax-class-static-block/lib");

	var syntaxDecimal = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-decimal",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push("decimal");
	    }

	  };
	});

	var syntaxDecorators = declare((api, options) => {
	  api.assertVersion(7);
	  const {
	    legacy,
	    version = legacy ? "legacy" : "2018-09",
	    decoratorsBeforeExport = version === "2021-12" ? false : undefined
	  } = options;

	  if (version !== "2021-12" && version !== "2018-09" && version !== "legacy") {
	    throw new Error("Unsupported decorators version: " + version);
	  }

	  if (legacy !== undefined) {
	    if (typeof legacy !== "boolean") {
	      throw new Error(".legacy must be a boolean.");
	    }

	    if (options.version !== undefined) {
	      throw new Error("You can either use the .legacy or the .version option, not both.");
	    }
	  }

	  if (decoratorsBeforeExport === undefined) {
	    if (version === "2018-09") {
	      throw new Error("The decorators plugin, when .version is '2018-09' or not specified," + " requires a 'decoratorsBeforeExport' option, whose value must be a boolean.");
	    }
	  } else {
	    if (version === "legacy") {
	      throw new Error("'decoratorsBeforeExport' can't be used with legacy decorators.");
	    }

	    if (typeof decoratorsBeforeExport !== "boolean") {
	      throw new Error("'decoratorsBeforeExport' must be a boolean.");
	    }
	  }

	  return {
	    name: "syntax-decorators",

	    manipulateOptions({
	      generatorOpts
	    }, parserOpts) {
	      if (version === "legacy") {
	        parserOpts.plugins.push("decorators-legacy");
	      } else if (version === "2018-09") {
	        parserOpts.plugins.push(["decorators", {
	          decoratorsBeforeExport
	        }]);
	        generatorOpts.decoratorsBeforeExport = decoratorsBeforeExport;
	      } else {
	        parserOpts.plugins.push(["decorators", {
	          decoratorsBeforeExport
	        }], "decoratorAutoAccessors");
	        generatorOpts.decoratorsBeforeExport = decoratorsBeforeExport;
	      }
	    }

	  };
	});

	var syntaxDestructuringPrivate = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-destructuring-private",

	    manipulateOptions(_, parserOpts) {
	      parserOpts.plugins.push("destructuringPrivate");
	    }

	  };
	});

	var syntaxDoExpressions = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-do-expressions",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push("doExpressions");
	    }

	  };
	});

	var syntaxExportDefaultFrom = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-export-default-from",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push("exportDefaultFrom");
	    }

	  };
	});

	var syntaxFunctionBind = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-function-bind",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push("functionBind");
	    }

	  };
	});

	var syntaxFunctionSent = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-function-sent",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push("functionSent");
	    }

	  };
	});

	var syntaxModuleBlocks = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-module-blocks",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push("moduleBlocks");
	    }

	  };
	});

	var lib$b = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-import-meta",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("importMeta");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-standalone/node_modules/@babel/plugin-syntax-import-meta/lib");

	var syntaxImportAssertions = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-import-assertions",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push(["importAssertions"]);
	    }

	  };
	});

	var lib$a = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-object-rest-spread",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("objectRestSpread");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-standalone/node_modules/@babel/plugin-syntax-object-rest-spread/lib");

	var lib$9 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-optional-catch-binding",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("optionalCatchBinding");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-standalone/node_modules/@babel/plugin-syntax-optional-catch-binding/lib");

	const PIPELINE_PROPOSALS = ["minimal", "fsharp", "hack", "smart"];
	const TOPIC_TOKENS = ["^^", "@@", "^", "%", "#"];
	const documentationURL = "https://babeljs.io/docs/en/babel-plugin-proposal-pipeline-operator";
	var syntaxPipelineOperator = declare((api, {
	  proposal,
	  topicToken
	}) => {
	  api.assertVersion(7);

	  if (typeof proposal !== "string" || !PIPELINE_PROPOSALS.includes(proposal)) {
	    const proposalList = PIPELINE_PROPOSALS.map(p => `"${p}"`).join(", ");
	    throw new Error(`The pipeline plugin requires a "proposal" option. "proposal" must be one of: ${proposalList}. See <${documentationURL}>.`);
	  }

	  if (proposal === "hack" && !TOPIC_TOKENS.includes(topicToken)) {
	    const topicTokenList = TOPIC_TOKENS.map(t => `"${t}"`).join(", ");
	    throw new Error(`The pipeline plugin in "proposal": "hack" mode also requires a "topicToken" option. "topicToken" must be one of: ${topicTokenList}. See <${documentationURL}>.`);
	  }

	  return {
	    name: "syntax-pipeline-operator",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push(["pipelineOperator", {
	        proposal,
	        topicToken
	      }]);
	      opts.generatorOpts.topicToken = topicToken;
	    }

	  };
	});

	var syntaxRecordAndTuple = declare((api, options) => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-record-and-tuple",

	    manipulateOptions(opts, parserOpts) {
	      opts.generatorOpts.recordAndTupleSyntaxType = options.syntaxType;
	      parserOpts.plugins.push(["recordAndTuple", {
	        syntaxType: options.syntaxType
	      }]);
	    }

	  };
	});

	var lib$8 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-top-level-await",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("topLevelAwait");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-standalone/node_modules/@babel/plugin-syntax-top-level-await/lib");

	var lib$7 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-dynamic-import",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("dynamicImport");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-plugin-proposal-dynamic-import/node_modules/@babel/plugin-syntax-dynamic-import/lib");

	const SUPPORTED_MODULES = ["commonjs", "amd", "systemjs"];
	const MODULES_NOT_FOUND = `\
@babel/plugin-proposal-dynamic-import depends on a modules
transform plugin. Supported plugins are:
 - @babel/plugin-transform-modules-commonjs ^7.4.0
 - @babel/plugin-transform-modules-amd ^7.4.0
 - @babel/plugin-transform-modules-systemjs ^7.4.0

If you are using Webpack or Rollup and thus don't want
Babel to transpile your imports and exports, you can use
the @babel/plugin-syntax-dynamic-import plugin and let your
bundler handle dynamic imports.
`;
	var proposalDynamicImport = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "proposal-dynamic-import",
	    inherits: lib$7.default,

	    pre() {
	      this.file.set("@babel/plugin-proposal-dynamic-import", "7.16.7");
	    },

	    visitor: {
	      Program() {
	        const modules = this.file.get("@babel/plugin-transform-modules-*");

	        if (!SUPPORTED_MODULES.includes(modules)) {
	          throw new Error(MODULES_NOT_FOUND);
	        }
	      }

	    }
	  };
	});

	var lib$6 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-export-namespace-from",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("exportNamespaceFrom");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-plugin-proposal-export-namespace-from/node_modules/@babel/plugin-syntax-export-namespace-from/lib");

	var proposalExportNamespaceFrom = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "proposal-export-namespace-from",
	    inherits: lib$6.default,
	    visitor: {
	      ExportNamedDeclaration(path) {
	        const {
	          node,
	          scope
	        } = path;
	        const {
	          specifiers
	        } = node;
	        const index = isExportDefaultSpecifier$1(specifiers[0]) ? 1 : 0;
	        if (!isExportNamespaceSpecifier$1(specifiers[index])) return;
	        const nodes = [];

	        if (index === 1) {
	          nodes.push(exportNamedDeclaration$2(null, [specifiers.shift()], node.source));
	        }

	        const specifier = specifiers.shift();
	        const {
	          exported
	        } = specifier;
	        const uid = scope.generateUidIdentifier(exported.name ?? exported.value);
	        nodes.push(importDeclaration([importNamespaceSpecifier(uid)], cloneNode$c(node.source)), exportNamedDeclaration$2(null, [exportSpecifier$2(cloneNode$c(uid), exported)]));

	        if (node.specifiers.length >= 1) {
	          nodes.push(node);
	        }

	        const [importDeclaration$1] = path.replaceWithMultiple(nodes);
	        path.scope.registerDeclaration(importDeclaration$1);
	      }

	    }
	  };
	});

	var lib$5 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-json-strings",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("jsonStrings");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-plugin-proposal-json-strings/node_modules/@babel/plugin-syntax-json-strings/lib");

	var proposalJsonStrings = declare(api => {
	  api.assertVersion(7);
	  const regex = /(\\*)([\u2028\u2029])/g;

	  function replace(match, escapes, separator) {
	    const isEscaped = escapes.length % 2 === 1;
	    if (isEscaped) return match;
	    return `${escapes}\\u${separator.charCodeAt(0).toString(16)}`;
	  }

	  return {
	    name: "proposal-json-strings",
	    inherits: lib$5.default,
	    visitor: {
	      "DirectiveLiteral|StringLiteral"({
	        node
	      }) {
	        const {
	          extra
	        } = node;
	        if (!extra?.raw) return;
	        extra.raw = extra.raw.replace(regex, replace);
	      }

	    }
	  };
	});

	var lib$4 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-logical-assignment-operators",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("logicalAssignment");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-plugin-proposal-logical-assignment-operators/node_modules/@babel/plugin-syntax-logical-assignment-operators/lib");

	var proposalLogicalAssignmentOperators = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "proposal-logical-assignment-operators",
	    inherits: lib$4.default,
	    visitor: {
	      AssignmentExpression(path) {
	        const {
	          node,
	          scope
	        } = path;
	        const {
	          operator,
	          left,
	          right
	        } = node;
	        const operatorTrunc = operator.slice(0, -1);

	        if (!LOGICAL_OPERATORS$2.includes(operatorTrunc)) {
	          return;
	        }

	        const lhs = cloneNode$c(left);

	        if (isMemberExpression$6(left)) {
	          const {
	            object,
	            property,
	            computed
	          } = left;
	          const memo = scope.maybeGenerateMemoised(object);

	          if (memo) {
	            left.object = memo;
	            lhs.object = assignmentExpression$9("=", cloneNode$c(memo), object);
	          }

	          if (computed) {
	            const memo = scope.maybeGenerateMemoised(property);

	            if (memo) {
	              left.property = memo;
	              lhs.property = assignmentExpression$9("=", cloneNode$c(memo), property);
	            }
	          }
	        }

	        path.replaceWith(logicalExpression$2(operatorTrunc, lhs, assignmentExpression$9("=", left, right)));
	      }

	    }
	  };
	});

	var lib$3 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-nullish-coalescing-operator",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("nullishCoalescingOperator");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-plugin-proposal-nullish-coalescing-operator/node_modules/@babel/plugin-syntax-nullish-coalescing-operator/lib");

	var proposalNullishCoalescingOperator = declare((api, {
	  loose = false
	}) => {
	  api.assertVersion(7);
	  const noDocumentAll = api.assumption("noDocumentAll") ?? loose;
	  return {
	    name: "proposal-nullish-coalescing-operator",
	    inherits: lib$3.default,
	    visitor: {
	      LogicalExpression(path) {
	        const {
	          node,
	          scope
	        } = path;

	        if (node.operator !== "??") {
	          return;
	        }

	        let ref;
	        let assignment;

	        if (scope.isStatic(node.left)) {
	          ref = node.left;
	          assignment = cloneNode$c(node.left);
	        } else if (scope.path.isPattern()) {
	          path.replaceWith(template.ast`(() => ${path.node})()`);
	          return;
	        } else {
	          ref = scope.generateUidIdentifierBasedOnNode(node.left);
	          scope.push({
	            id: cloneNode$c(ref)
	          });
	          assignment = assignmentExpression$9("=", ref, node.left);
	        }

	        path.replaceWith(conditionalExpression$3(noDocumentAll ? binaryExpression$3("!=", assignment, nullLiteral$1()) : logicalExpression$2("&&", binaryExpression$3("!==", assignment, nullLiteral$1()), binaryExpression$3("!==", cloneNode$c(ref), scope.buildUndefinedNode())), cloneNode$c(ref), node.right));
	      }

	    }
	  };
	});

	var lib$2 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-numeric-separator",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("numericSeparator");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-plugin-proposal-numeric-separator/node_modules/@babel/plugin-syntax-numeric-separator/lib");

	function remover({
	  node
	}) {
	  const {
	    extra
	  } = node;

	  if (extra?.raw?.includes("_")) {
	    extra.raw = extra.raw.replace(/_/g, "");
	  }
	}

	var proposalNumericSeparator = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "proposal-numeric-separator",
	    inherits: lib$2.default,
	    visitor: {
	      NumericLiteral: remover,
	      BigIntLiteral: remover
	    }
	  };
	});

	var lib$1 = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-optional-chaining",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("optionalChaining");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-plugin-proposal-optional-chaining/node_modules/@babel/plugin-syntax-optional-chaining/lib");

	const {
	  isParenthesizedExpression,
	  isTSAsExpression,
	  isTSNonNullExpression,
	  isTSTypeAssertion,
	  isTypeCastExpression
	} = _t;
	function isTransparentExprWrapper(node) {
	  return isTSAsExpression(node) || isTSTypeAssertion(node) || isTSNonNullExpression(node) || isTypeCastExpression(node) || isParenthesizedExpression(node);
	}
	function skipTransparentExprWrappers(path) {
	  while (isTransparentExprWrapper(path.node)) {
	    path = path.get("expression");
	  }

	  return path;
	}
	function skipTransparentExprWrapperNodes(node) {
	  while (isTransparentExprWrapper(node)) {
	    node = node.expression;
	  }

	  return node;
	}

	function willPathCastToBoolean$1(path) {
	  const maybeWrapped = findOutermostTransparentParent(path);
	  const {
	    node,
	    parentPath
	  } = maybeWrapped;

	  if (parentPath.isLogicalExpression()) {
	    const {
	      operator,
	      right
	    } = parentPath.node;

	    if (operator === "&&" || operator === "||" || operator === "??" && node === right) {
	      return willPathCastToBoolean$1(parentPath);
	    }
	  }

	  if (parentPath.isSequenceExpression()) {
	    const {
	      expressions
	    } = parentPath.node;

	    if (expressions[expressions.length - 1] === node) {
	      return willPathCastToBoolean$1(parentPath);
	    } else {
	      return true;
	    }
	  }

	  return parentPath.isConditional({
	    test: node
	  }) || parentPath.isUnaryExpression({
	    operator: "!"
	  }) || parentPath.isLoop({
	    test: node
	  });
	}
	function findOutermostTransparentParent(path) {
	  let maybeWrapped = path;
	  path.findParent(p => {
	    if (!isTransparentExprWrapper(p.node)) return true;
	    maybeWrapped = p;
	  });
	  return maybeWrapped;
	}

	const {
	  ast
	} = template.expression;

	function isSimpleMemberExpression(expression) {
	  expression = skipTransparentExprWrapperNodes(expression);
	  return isIdentifier$c(expression) || isSuper$2(expression) || isMemberExpression$6(expression) && !expression.computed && isSimpleMemberExpression(expression.object);
	}

	function needsMemoize(path) {
	  let optionalPath = path;
	  const {
	    scope
	  } = path;

	  while (optionalPath.isOptionalMemberExpression() || optionalPath.isOptionalCallExpression()) {
	    const {
	      node
	    } = optionalPath;
	    const childKey = optionalPath.isOptionalMemberExpression() ? "object" : "callee";
	    const childPath = skipTransparentExprWrappers(optionalPath.get(childKey));

	    if (node.optional) {
	      return !scope.isStatic(childPath.node);
	    }

	    optionalPath = childPath;
	  }
	}

	function transform$2(path, {
	  pureGetters,
	  noDocumentAll
	}) {
	  const {
	    scope
	  } = path;
	  const maybeWrapped = findOutermostTransparentParent(path);
	  const {
	    parentPath
	  } = maybeWrapped;
	  const willReplacementCastToBoolean = willPathCastToBoolean$1(maybeWrapped);
	  let isDeleteOperation = false;
	  const parentIsCall = parentPath.isCallExpression({
	    callee: maybeWrapped.node
	  }) && path.isOptionalMemberExpression();
	  const optionals = [];
	  let optionalPath = path;

	  if (scope.path.isPattern() && needsMemoize(optionalPath)) {
	    path.replaceWith(template.ast`(() => ${path.node})()`);
	    return;
	  }

	  while (optionalPath.isOptionalMemberExpression() || optionalPath.isOptionalCallExpression()) {
	    const {
	      node
	    } = optionalPath;

	    if (node.optional) {
	      optionals.push(node);
	    }

	    if (optionalPath.isOptionalMemberExpression()) {
	      optionalPath.node.type = "MemberExpression";
	      optionalPath = skipTransparentExprWrappers(optionalPath.get("object"));
	    } else if (optionalPath.isOptionalCallExpression()) {
	      optionalPath.node.type = "CallExpression";
	      optionalPath = skipTransparentExprWrappers(optionalPath.get("callee"));
	    }
	  }

	  let replacementPath = path;

	  if (parentPath.isUnaryExpression({
	    operator: "delete"
	  })) {
	    replacementPath = parentPath;
	    isDeleteOperation = true;
	  }

	  for (let i = optionals.length - 1; i >= 0; i--) {
	    const node = optionals[i];
	    const isCall = isCallExpression$6(node);
	    const replaceKey = isCall ? "callee" : "object";
	    const chainWithTypes = node[replaceKey];
	    const chain = skipTransparentExprWrapperNodes(chainWithTypes);
	    let ref;
	    let check;

	    if (isCall && isIdentifier$c(chain, {
	      name: "eval"
	    })) {
	      check = ref = chain;
	      node[replaceKey] = sequenceExpression$3([numericLiteral$5(0), ref]);
	    } else if (pureGetters && isCall && isSimpleMemberExpression(chain)) {
	      check = ref = chainWithTypes;
	    } else {
	      ref = scope.maybeGenerateMemoised(chain);

	      if (ref) {
	        check = assignmentExpression$9("=", cloneNode$c(ref), chainWithTypes);
	        node[replaceKey] = ref;
	      } else {
	        check = ref = chainWithTypes;
	      }
	    }

	    if (isCall && isMemberExpression$6(chain)) {
	      if (pureGetters && isSimpleMemberExpression(chain)) {
	        node.callee = chainWithTypes;
	      } else {
	        const {
	          object
	        } = chain;
	        let context = scope.maybeGenerateMemoised(object);

	        if (context) {
	          chain.object = assignmentExpression$9("=", context, object);
	        } else if (isSuper$2(object)) {
	          context = thisExpression$3();
	        } else {
	          context = object;
	        }

	        node.arguments.unshift(cloneNode$c(context));
	        node.callee = memberExpression$6(node.callee, identifier$e("call"));
	      }
	    }

	    let replacement = replacementPath.node;

	    if (i === 0 && parentIsCall) {
	      const object = skipTransparentExprWrapperNodes(replacement.object);
	      let baseRef;

	      if (!pureGetters || !isSimpleMemberExpression(object)) {
	        baseRef = scope.maybeGenerateMemoised(object);

	        if (baseRef) {
	          replacement.object = assignmentExpression$9("=", baseRef, object);
	        }
	      }

	      replacement = callExpression$8(memberExpression$6(replacement, identifier$e("bind")), [cloneNode$c(baseRef ?? object)]);
	    }

	    if (willReplacementCastToBoolean) {
	      const nonNullishCheck = noDocumentAll ? ast`${cloneNode$c(check)} != null` : ast`
            ${cloneNode$c(check)} !== null && ${cloneNode$c(ref)} !== void 0`;
	      replacementPath.replaceWith(logicalExpression$2("&&", nonNullishCheck, replacement));
	      replacementPath = skipTransparentExprWrappers(replacementPath.get("right"));
	    } else {
	      const nullishCheck = noDocumentAll ? ast`${cloneNode$c(check)} == null` : ast`
            ${cloneNode$c(check)} === null || ${cloneNode$c(ref)} === void 0`;
	      const returnValue = isDeleteOperation ? ast`true` : ast`void 0`;
	      replacementPath.replaceWith(conditionalExpression$3(nullishCheck, returnValue, replacement));
	      replacementPath = skipTransparentExprWrappers(replacementPath.get("alternate"));
	    }
	  }
	}

	var proposalOptionalChaining = declare((api, options) => {
	  api.assertVersion(7);
	  const {
	    loose = false
	  } = options;
	  const noDocumentAll = api.assumption("noDocumentAll") ?? loose;
	  const pureGetters = api.assumption("pureGetters") ?? loose;
	  return {
	    name: "proposal-optional-chaining",
	    inherits: lib$1.default,
	    visitor: {
	      "OptionalCallExpression|OptionalMemberExpression"(path) {
	        transform$2(path, {
	          noDocumentAll,
	          pureGetters
	        });
	      }

	    }
	  };
	});

	function willPathCastToBoolean(path) {
	  const maybeWrapped = path;
	  const {
	    node,
	    parentPath
	  } = maybeWrapped;

	  if (parentPath.isLogicalExpression()) {
	    const {
	      operator,
	      right
	    } = parentPath.node;

	    if (operator === "&&" || operator === "||" || operator === "??" && node === right) {
	      return willPathCastToBoolean(parentPath);
	    }
	  }

	  if (parentPath.isSequenceExpression()) {
	    const {
	      expressions
	    } = parentPath.node;

	    if (expressions[expressions.length - 1] === node) {
	      return willPathCastToBoolean(parentPath);
	    } else {
	      return true;
	    }
	  }

	  return parentPath.isConditional({
	    test: node
	  }) || parentPath.isUnaryExpression({
	    operator: "!"
	  }) || parentPath.isLoop({
	    test: node
	  });
	}

	const {
	  LOGICAL_OPERATORS,
	  arrowFunctionExpression,
	  assignmentExpression: assignmentExpression$1,
	  binaryExpression,
	  booleanLiteral: booleanLiteral$1,
	  callExpression: callExpression$2,
	  cloneNode: cloneNode$1,
	  conditionalExpression,
	  identifier: identifier$2,
	  isMemberExpression,
	  isOptionalCallExpression,
	  isOptionalMemberExpression,
	  isUpdateExpression,
	  logicalExpression,
	  memberExpression: memberExpression$2,
	  nullLiteral,
	  numericLiteral,
	  optionalCallExpression: optionalCallExpression$1,
	  optionalMemberExpression: optionalMemberExpression$1,
	  sequenceExpression: sequenceExpression$1,
	  unaryExpression
	} = _t;

	class AssignmentMemoiser {
	  _map;

	  constructor() {
	    this._map = new WeakMap();
	  }

	  has(key) {
	    return this._map.has(key);
	  }

	  get(key) {
	    if (!this.has(key)) return;

	    const record = this._map.get(key);

	    const {
	      value
	    } = record;
	    record.count--;

	    if (record.count === 0) {
	      return assignmentExpression$1("=", value, key);
	    }

	    return value;
	  }

	  set(key, value, count) {
	    return this._map.set(key, {
	      count,
	      value
	    });
	  }

	}

	function toNonOptional(path, base) {
	  const {
	    node
	  } = path;

	  if (isOptionalMemberExpression(node)) {
	    return memberExpression$2(base, node.property, node.computed);
	  }

	  if (path.isOptionalCallExpression()) {
	    const callee = path.get("callee");

	    if (path.node.optional && callee.isOptionalMemberExpression()) {
	      const {
	        object
	      } = callee.node;
	      const context = path.scope.maybeGenerateMemoised(object) || object;
	      callee.get("object").replaceWith(assignmentExpression$1("=", context, object));
	      return callExpression$2(memberExpression$2(base, identifier$2("call")), [context, ...path.node.arguments]);
	    }

	    return callExpression$2(base, path.node.arguments);
	  }

	  return path.node;
	}

	function isInDetachedTree(path) {
	  while (path) {
	    if (path.isProgram()) break;
	    const {
	      parentPath,
	      container,
	      listKey
	    } = path;
	    const parentNode = parentPath.node;

	    if (listKey) {
	      if (container !== parentNode[listKey]) return true;
	    } else {
	      if (container !== parentNode) return true;
	    }

	    path = parentPath;
	  }

	  return false;
	}

	const handle = {
	  memoise() {},

	  handle(member, noDocumentAll) {
	    const {
	      node,
	      parent,
	      parentPath,
	      scope
	    } = member;

	    if (member.isOptionalMemberExpression()) {
	      if (isInDetachedTree(member)) return;
	      const endPath = member.find(({
	        node,
	        parent
	      }) => {
	        if (isOptionalMemberExpression(parent)) {
	          return parent.optional || parent.object !== node;
	        }

	        if (isOptionalCallExpression(parent)) {
	          return node !== member.node && parent.optional || parent.callee !== node;
	        }

	        return true;
	      });

	      if (scope.path.isPattern()) {
	        endPath.replaceWith(callExpression$2(arrowFunctionExpression([], endPath.node), []));
	        return;
	      }

	      const willEndPathCastToBoolean = willPathCastToBoolean(endPath);
	      const rootParentPath = endPath.parentPath;

	      if (rootParentPath.isUpdateExpression({
	        argument: node
	      }) || rootParentPath.isAssignmentExpression({
	        left: node
	      })) {
	        throw member.buildCodeFrameError(`can't handle assignment`);
	      }

	      const isDeleteOperation = rootParentPath.isUnaryExpression({
	        operator: "delete"
	      });

	      if (isDeleteOperation && endPath.isOptionalMemberExpression() && endPath.get("property").isPrivateName()) {
	        throw member.buildCodeFrameError(`can't delete a private class element`);
	      }

	      let startingOptional = member;

	      for (;;) {
	        if (startingOptional.isOptionalMemberExpression()) {
	          if (startingOptional.node.optional) break;
	          startingOptional = startingOptional.get("object");
	          continue;
	        } else if (startingOptional.isOptionalCallExpression()) {
	          if (startingOptional.node.optional) break;
	          startingOptional = startingOptional.get("callee");
	          continue;
	        }

	        throw new Error(`Internal error: unexpected ${startingOptional.node.type}`);
	      }

	      const startingProp = startingOptional.isOptionalMemberExpression() ? "object" : "callee";
	      const startingNode = startingOptional.node[startingProp];
	      const baseNeedsMemoised = scope.maybeGenerateMemoised(startingNode);
	      const baseRef = baseNeedsMemoised ?? startingNode;
	      const parentIsOptionalCall = parentPath.isOptionalCallExpression({
	        callee: node
	      });

	      const isOptionalCall = parent => parentIsOptionalCall;

	      const parentIsCall = parentPath.isCallExpression({
	        callee: node
	      });
	      startingOptional.replaceWith(toNonOptional(startingOptional, baseRef));

	      if (isOptionalCall()) {
	        if (parent.optional) {
	          parentPath.replaceWith(this.optionalCall(member, parent.arguments));
	        } else {
	          parentPath.replaceWith(this.call(member, parent.arguments));
	        }
	      } else if (parentIsCall) {
	        member.replaceWith(this.boundGet(member));
	      } else {
	        member.replaceWith(this.get(member));
	      }

	      let regular = member.node;

	      for (let current = member; current !== endPath;) {
	        const parentPath = current.parentPath;

	        if (parentPath === endPath && isOptionalCall() && parent.optional) {
	          regular = parentPath.node;
	          break;
	        }

	        regular = toNonOptional(parentPath, regular);
	        current = parentPath;
	      }

	      let context;
	      const endParentPath = endPath.parentPath;

	      if (isMemberExpression(regular) && endParentPath.isOptionalCallExpression({
	        callee: endPath.node,
	        optional: true
	      })) {
	        const {
	          object
	        } = regular;
	        context = member.scope.maybeGenerateMemoised(object);

	        if (context) {
	          regular.object = assignmentExpression$1("=", context, object);
	        }
	      }

	      let replacementPath = endPath;

	      if (isDeleteOperation) {
	        replacementPath = endParentPath;
	        regular = endParentPath.node;
	      }

	      const baseMemoised = baseNeedsMemoised ? assignmentExpression$1("=", cloneNode$1(baseRef), cloneNode$1(startingNode)) : cloneNode$1(baseRef);

	      if (willEndPathCastToBoolean) {
	        let nonNullishCheck;

	        if (noDocumentAll) {
	          nonNullishCheck = binaryExpression("!=", baseMemoised, nullLiteral());
	        } else {
	          nonNullishCheck = logicalExpression("&&", binaryExpression("!==", baseMemoised, nullLiteral()), binaryExpression("!==", cloneNode$1(baseRef), scope.buildUndefinedNode()));
	        }

	        replacementPath.replaceWith(logicalExpression("&&", nonNullishCheck, regular));
	      } else {
	        let nullishCheck;

	        if (noDocumentAll) {
	          nullishCheck = binaryExpression("==", baseMemoised, nullLiteral());
	        } else {
	          nullishCheck = logicalExpression("||", binaryExpression("===", baseMemoised, nullLiteral()), binaryExpression("===", cloneNode$1(baseRef), scope.buildUndefinedNode()));
	        }

	        replacementPath.replaceWith(conditionalExpression(nullishCheck, isDeleteOperation ? booleanLiteral$1(true) : scope.buildUndefinedNode(), regular));
	      }

	      if (context) {
	        const endParent = endParentPath.node;
	        endParentPath.replaceWith(optionalCallExpression$1(optionalMemberExpression$1(endParent.callee, identifier$2("call"), false, true), [cloneNode$1(context), ...endParent.arguments], false));
	      }

	      return;
	    }

	    if (isUpdateExpression(parent, {
	      argument: node
	    })) {
	      if (this.simpleSet) {
	        member.replaceWith(this.simpleSet(member));
	        return;
	      }

	      const {
	        operator,
	        prefix
	      } = parent;
	      this.memoise(member, 2);
	      const value = binaryExpression(operator[0], unaryExpression("+", this.get(member)), numericLiteral(1));

	      if (prefix) {
	        parentPath.replaceWith(this.set(member, value));
	      } else {
	        const {
	          scope
	        } = member;
	        const ref = scope.generateUidIdentifierBasedOnNode(node);
	        scope.push({
	          id: ref
	        });
	        value.left = assignmentExpression$1("=", cloneNode$1(ref), value.left);
	        parentPath.replaceWith(sequenceExpression$1([this.set(member, value), cloneNode$1(ref)]));
	      }

	      return;
	    }

	    if (parentPath.isAssignmentExpression({
	      left: node
	    })) {
	      if (this.simpleSet) {
	        member.replaceWith(this.simpleSet(member));
	        return;
	      }

	      const {
	        operator,
	        right: value
	      } = parentPath.node;

	      if (operator === "=") {
	        parentPath.replaceWith(this.set(member, value));
	      } else {
	        const operatorTrunc = operator.slice(0, -1);

	        if (LOGICAL_OPERATORS.includes(operatorTrunc)) {
	          this.memoise(member, 1);
	          parentPath.replaceWith(logicalExpression(operatorTrunc, this.get(member), this.set(member, value)));
	        } else {
	          this.memoise(member, 2);
	          parentPath.replaceWith(this.set(member, binaryExpression(operatorTrunc, this.get(member), value)));
	        }
	      }

	      return;
	    }

	    if (parentPath.isCallExpression({
	      callee: node
	    })) {
	      parentPath.replaceWith(this.call(member, parentPath.node.arguments));
	      return;
	    }

	    if (parentPath.isOptionalCallExpression({
	      callee: node
	    })) {
	      if (scope.path.isPattern()) {
	        parentPath.replaceWith(callExpression$2(arrowFunctionExpression([], parentPath.node), []));
	        return;
	      }

	      parentPath.replaceWith(this.optionalCall(member, parentPath.node.arguments));
	      return;
	    }

	    if (parentPath.isForXStatement({
	      left: node
	    }) || parentPath.isObjectProperty({
	      value: node
	    }) && parentPath.parentPath.isObjectPattern() || parentPath.isAssignmentPattern({
	      left: node
	    }) && parentPath.parentPath.isObjectProperty({
	      value: parent
	    }) && parentPath.parentPath.parentPath.isObjectPattern() || parentPath.isArrayPattern() || parentPath.isAssignmentPattern({
	      left: node
	    }) && parentPath.parentPath.isArrayPattern() || parentPath.isRestElement()) {
	      member.replaceWith(this.destructureSet(member));
	      return;
	    }

	    if (parentPath.isTaggedTemplateExpression()) {
	      member.replaceWith(this.boundGet(member));
	    } else {
	      member.replaceWith(this.get(member));
	    }
	  }

	};
	function memberExpressionToFunctions(path, visitor, state) {
	  path.traverse(visitor, { ...handle,
	    ...state,
	    memoiser: new AssignmentMemoiser()
	  });
	}

	const {
	  callExpression: callExpression$1,
	  identifier: identifier$1,
	  isIdentifier,
	  isSpreadElement,
	  memberExpression: memberExpression$1,
	  optionalCallExpression,
	  optionalMemberExpression
	} = _t;
	function optimiseCallExpression(callee, thisNode, args, optional) {
	  if (args.length === 1 && isSpreadElement(args[0]) && isIdentifier(args[0].argument, {
	    name: "arguments"
	  })) {
	    if (optional) {
	      return optionalCallExpression(optionalMemberExpression(callee, identifier$1("apply"), false, true), [thisNode, args[0].argument], false);
	    }

	    return callExpression$1(memberExpression$1(callee, identifier$1("apply")), [thisNode, args[0].argument]);
	  } else {
	    if (optional) {
	      return optionalCallExpression(optionalMemberExpression(callee, identifier$1("call"), false, true), [thisNode, ...args], false);
	    }

	    return callExpression$1(memberExpression$1(callee, identifier$1("call")), [thisNode, ...args]);
	  }
	}

	const {
	  assignmentExpression,
	  booleanLiteral,
	  callExpression,
	  cloneNode,
	  identifier,
	  memberExpression,
	  sequenceExpression,
	  stringLiteral,
	  thisExpression
	} = _t;

	function getPrototypeOfExpression(objectRef, isStatic, file, isPrivateMethod) {
	  objectRef = cloneNode(objectRef);
	  const targetRef = isStatic || isPrivateMethod ? objectRef : memberExpression(objectRef, identifier("prototype"));
	  return callExpression(file.addHelper("getPrototypeOf"), [targetRef]);
	}

	const visitor = traverse.visitors.merge([environmentVisitor, {
	  Super(path, state) {
	    const {
	      node,
	      parentPath
	    } = path;
	    if (!parentPath.isMemberExpression({
	      object: node
	    })) return;
	    state.handle(parentPath);
	  }

	}]);
	const unshadowSuperBindingVisitor = traverse.visitors.merge([environmentVisitor, {
	  Scopable(path, {
	    refName
	  }) {
	    const binding = path.scope.getOwnBinding(refName);

	    if (binding && binding.identifier.name === refName) {
	      path.scope.rename(refName);
	    }
	  }

	}]);
	const specHandlers = {
	  memoise(superMember, count) {
	    const {
	      scope,
	      node
	    } = superMember;
	    const {
	      computed,
	      property
	    } = node;

	    if (!computed) {
	      return;
	    }

	    const memo = scope.maybeGenerateMemoised(property);

	    if (!memo) {
	      return;
	    }

	    this.memoiser.set(property, memo, count);
	  },

	  prop(superMember) {
	    const {
	      computed,
	      property
	    } = superMember.node;

	    if (this.memoiser.has(property)) {
	      return cloneNode(this.memoiser.get(property));
	    }

	    if (computed) {
	      return cloneNode(property);
	    }

	    return stringLiteral(property.name);
	  },

	  get(superMember) {
	    return this._get(superMember, this._getThisRefs());
	  },

	  _get(superMember, thisRefs) {
	    const proto = getPrototypeOfExpression(this.getObjectRef(), this.isStatic, this.file, this.isPrivateMethod);
	    return callExpression(this.file.addHelper("get"), [thisRefs.memo ? sequenceExpression([thisRefs.memo, proto]) : proto, this.prop(superMember), thisRefs.this]);
	  },

	  _getThisRefs() {
	    if (!this.isDerivedConstructor) {
	      return {
	        this: thisExpression()
	      };
	    }

	    const thisRef = this.scope.generateDeclaredUidIdentifier("thisSuper");
	    return {
	      memo: assignmentExpression("=", thisRef, thisExpression()),
	      this: cloneNode(thisRef)
	    };
	  },

	  set(superMember, value) {
	    const thisRefs = this._getThisRefs();

	    const proto = getPrototypeOfExpression(this.getObjectRef(), this.isStatic, this.file, this.isPrivateMethod);
	    return callExpression(this.file.addHelper("set"), [thisRefs.memo ? sequenceExpression([thisRefs.memo, proto]) : proto, this.prop(superMember), value, thisRefs.this, booleanLiteral(superMember.isInStrictMode())]);
	  },

	  destructureSet(superMember) {
	    throw superMember.buildCodeFrameError(`Destructuring to a super field is not supported yet.`);
	  },

	  call(superMember, args) {
	    const thisRefs = this._getThisRefs();

	    return optimiseCallExpression(this._get(superMember, thisRefs), cloneNode(thisRefs.this), args, false);
	  },

	  optionalCall(superMember, args) {
	    const thisRefs = this._getThisRefs();

	    return optimiseCallExpression(this._get(superMember, thisRefs), cloneNode(thisRefs.this), args, true);
	  }

	};
	const looseHandlers = { ...specHandlers,

	  prop(superMember) {
	    const {
	      property
	    } = superMember.node;

	    if (this.memoiser.has(property)) {
	      return cloneNode(this.memoiser.get(property));
	    }

	    return cloneNode(property);
	  },

	  get(superMember) {
	    const {
	      isStatic,
	      getSuperRef
	    } = this;
	    const {
	      computed
	    } = superMember.node;
	    const prop = this.prop(superMember);
	    let object;

	    if (isStatic) {
	      object = getSuperRef() ?? memberExpression(identifier("Function"), identifier("prototype"));
	    } else {
	      object = memberExpression(getSuperRef() ?? identifier("Object"), identifier("prototype"));
	    }

	    return memberExpression(object, prop, computed);
	  },

	  set(superMember, value) {
	    const {
	      computed
	    } = superMember.node;
	    const prop = this.prop(superMember);
	    return assignmentExpression("=", memberExpression(thisExpression(), prop, computed), value);
	  },

	  destructureSet(superMember) {
	    const {
	      computed
	    } = superMember.node;
	    const prop = this.prop(superMember);
	    return memberExpression(thisExpression(), prop, computed);
	  },

	  call(superMember, args) {
	    return optimiseCallExpression(this.get(superMember), thisExpression(), args, false);
	  },

	  optionalCall(superMember, args) {
	    return optimiseCallExpression(this.get(superMember), thisExpression(), args, true);
	  }

	};
	class ReplaceSupers {
	  constructor(opts) {
	    const path = opts.methodPath;
	    this.methodPath = path;
	    this.isDerivedConstructor = path.isClassMethod({
	      kind: "constructor"
	    }) && !!opts.superRef;
	    this.isStatic = path.isObjectMethod() || path.node.static || path.isStaticBlock?.();
	    this.isPrivateMethod = path.isPrivate() && path.isMethod();
	    this.file = opts.file;
	    this.constantSuper = browser$5.env.BABEL_8_BREAKING ? opts.constantSuper : opts.constantSuper ?? opts.isLoose;
	    this.opts = opts;
	  }

	  getObjectRef() {
	    return cloneNode(this.opts.objectRef || this.opts.getObjectRef());
	  }

	  getSuperRef() {
	    if (this.opts.superRef) return cloneNode(this.opts.superRef);
	    if (this.opts.getSuperRef) return cloneNode(this.opts.getSuperRef());
	  }

	  replace() {
	    if (this.opts.refToPreserve) {
	      this.methodPath.traverse(unshadowSuperBindingVisitor, {
	        refName: this.opts.refToPreserve.name
	      });
	    }

	    const handler = this.constantSuper ? looseHandlers : specHandlers;
	    memberExpressionToFunctions(this.methodPath, visitor, {
	      file: this.file,
	      scope: this.methodPath.scope,
	      isDerivedConstructor: this.isDerivedConstructor,
	      isStatic: this.isStatic,
	      isPrivateMethod: this.isPrivateMethod,
	      getObjectRef: this.getObjectRef.bind(this),
	      getSuperRef: this.getSuperRef.bind(this),
	      boundGet: handler.get,
	      ...handler
	    });
	  }

	}

	const {
	  addComment
	} = _t;
	const PURE_ANNOTATION = "#__PURE__";

	const isPureAnnotated = ({
	  leadingComments
	}) => !!leadingComments && leadingComments.some(comment => /[@#]__PURE__/.test(comment.value));

	function annotateAsPure(pathOrNode) {
	  const node = pathOrNode["node"] || pathOrNode;

	  if (isPureAnnotated(node)) {
	    return;
	  }

	  addComment(node, "leading", PURE_ANNOTATION);
	}

	function assertFieldTransformed(path) {
	  if (path.node.declare) {
	    throw path.buildCodeFrameError(`TypeScript 'declare' fields must first be transformed by ` + `@babel/plugin-transform-typescript.\n` + `If you have already enabled that plugin (or '@babel/preset-typescript'), make sure ` + `that it runs before any plugin related to additional class features:\n` + ` - @babel/plugin-proposal-class-properties\n` + ` - @babel/plugin-proposal-private-methods\n` + ` - @babel/plugin-proposal-decorators`);
	  }
	}

	function buildPrivateNamesMap(props) {
	  const privateNamesMap = new Map();

	  for (const prop of props) {
	    if (prop.isPrivate()) {
	      const {
	        name
	      } = prop.node.key.id;
	      const update = privateNamesMap.has(name) ? privateNamesMap.get(name) : {
	        id: prop.scope.generateUidIdentifier(name),
	        static: prop.node.static,
	        method: !prop.isProperty()
	      };

	      if (prop.isClassPrivateMethod()) {
	        if (prop.node.kind === "get") {
	          update.getId = prop.scope.generateUidIdentifier(`get_${name}`);
	        } else if (prop.node.kind === "set") {
	          update.setId = prop.scope.generateUidIdentifier(`set_${name}`);
	        } else if (prop.node.kind === "method") {
	          update.methodId = prop.scope.generateUidIdentifier(name);
	        }
	      }

	      privateNamesMap.set(name, update);
	    }
	  }

	  return privateNamesMap;
	}
	function buildPrivateNamesNodes(privateNamesMap, privateFieldsAsProperties, state) {
	  const initNodes = [];

	  for (const [name, value] of privateNamesMap) {
	    const {
	      static: isStatic,
	      method: isMethod,
	      getId,
	      setId
	    } = value;
	    const isAccessor = getId || setId;
	    const id = cloneNode$c(value.id);
	    let init;

	    if (privateFieldsAsProperties) {
	      init = callExpression$8(state.addHelper("classPrivateFieldLooseKey"), [stringLiteral$4(name)]);
	    } else if (!isStatic) {
	      init = newExpression(identifier$e(!isMethod || isAccessor ? "WeakMap" : "WeakSet"), []);
	    }

	    if (init) {
	      annotateAsPure(init);
	      initNodes.push(template.statement.ast`var ${id} = ${init}`);
	    }
	  }

	  return initNodes;
	}

	function privateNameVisitorFactory(visitor) {
	  const privateNameVisitor = { ...visitor,

	    Class(path) {
	      const {
	        privateNamesMap
	      } = this;
	      const body = path.get("body.body");
	      const visiblePrivateNames = new Map(privateNamesMap);
	      const redeclared = [];

	      for (const prop of body) {
	        if (!prop.isPrivate()) continue;
	        const {
	          name
	        } = prop.node.key.id;
	        visiblePrivateNames.delete(name);
	        redeclared.push(name);
	      }

	      if (!redeclared.length) {
	        return;
	      }

	      path.get("body").traverse(nestedVisitor, { ...this,
	        redeclared
	      });
	      path.traverse(privateNameVisitor, { ...this,
	        privateNamesMap: visiblePrivateNames
	      });
	      path.skipKey("body");
	    }

	  };
	  const nestedVisitor = traverse.visitors.merge([{ ...visitor
	  }, environmentVisitor]);
	  return privateNameVisitor;
	}

	const privateNameVisitor = privateNameVisitorFactory({
	  PrivateName(path, {
	    noDocumentAll
	  }) {
	    const {
	      privateNamesMap,
	      redeclared
	    } = this;
	    const {
	      node,
	      parentPath
	    } = path;

	    if (!parentPath.isMemberExpression({
	      property: node
	    }) && !parentPath.isOptionalMemberExpression({
	      property: node
	    })) {
	      return;
	    }

	    const {
	      name
	    } = node.id;
	    if (!privateNamesMap.has(name)) return;
	    if (redeclared && redeclared.includes(name)) return;
	    this.handle(parentPath, noDocumentAll);
	  }

	});

	function unshadow(name, scope, innerBinding) {
	  while (scope?.hasBinding(name) && !scope.bindingIdentifierEquals(name, innerBinding)) {
	    scope.rename(name);
	    scope = scope.parent;
	  }
	}

	const privateInVisitor = privateNameVisitorFactory({
	  BinaryExpression(path) {
	    const {
	      operator,
	      left,
	      right
	    } = path.node;
	    if (operator !== "in") return;
	    if (!isPrivateName(left)) return;
	    const {
	      privateFieldsAsProperties,
	      privateNamesMap,
	      redeclared
	    } = this;
	    const {
	      name
	    } = left.id;
	    if (!privateNamesMap.has(name)) return;
	    if (redeclared && redeclared.includes(name)) return;
	    unshadow(this.classRef.name, path.scope, this.innerBinding);

	    if (privateFieldsAsProperties) {
	      const {
	        id
	      } = privateNamesMap.get(name);
	      path.replaceWith(template.expression.ast`
        Object.prototype.hasOwnProperty.call(${right}, ${cloneNode$c(id)})
      `);
	      return;
	    }

	    const {
	      id,
	      static: isStatic
	    } = privateNamesMap.get(name);

	    if (isStatic) {
	      path.replaceWith(template.expression.ast`${right} === ${this.classRef}`);
	      return;
	    }

	    path.replaceWith(template.expression.ast`${cloneNode$c(id)}.has(${right})`);
	  }

	});
	const privateNameHandlerSpec = {
	  memoise(member, count) {
	    const {
	      scope
	    } = member;
	    const {
	      object
	    } = member.node;
	    const memo = scope.maybeGenerateMemoised(object);

	    if (!memo) {
	      return;
	    }

	    this.memoiser.set(object, memo, count);
	  },

	  receiver(member) {
	    const {
	      object
	    } = member.node;

	    if (this.memoiser.has(object)) {
	      return cloneNode$c(this.memoiser.get(object));
	    }

	    return cloneNode$c(object);
	  },

	  get(member) {
	    const {
	      classRef,
	      privateNamesMap,
	      file,
	      innerBinding
	    } = this;
	    const {
	      name
	    } = member.node.property.id;
	    const {
	      id,
	      static: isStatic,
	      method: isMethod,
	      methodId,
	      getId,
	      setId
	    } = privateNamesMap.get(name);
	    const isAccessor = getId || setId;

	    if (isStatic) {
	      const helperName = isMethod && !isAccessor ? "classStaticPrivateMethodGet" : "classStaticPrivateFieldSpecGet";
	      unshadow(classRef.name, member.scope, innerBinding);
	      return callExpression$8(file.addHelper(helperName), [this.receiver(member), cloneNode$c(classRef), cloneNode$c(id)]);
	    }

	    if (isMethod) {
	      if (isAccessor) {
	        if (!getId && setId) {
	          if (file.availableHelper("writeOnlyError")) {
	            return sequenceExpression$3([this.receiver(member), callExpression$8(file.addHelper("writeOnlyError"), [stringLiteral$4(`#${name}`)])]);
	          }

	          console.warn(`@babel/helpers is outdated, update it to silence this warning.`);
	        }

	        return callExpression$8(file.addHelper("classPrivateFieldGet"), [this.receiver(member), cloneNode$c(id)]);
	      }

	      return callExpression$8(file.addHelper("classPrivateMethodGet"), [this.receiver(member), cloneNode$c(id), cloneNode$c(methodId)]);
	    }

	    return callExpression$8(file.addHelper("classPrivateFieldGet"), [this.receiver(member), cloneNode$c(id)]);
	  },

	  boundGet(member) {
	    this.memoise(member, 1);
	    return callExpression$8(memberExpression$6(this.get(member), identifier$e("bind")), [this.receiver(member)]);
	  },

	  set(member, value) {
	    const {
	      classRef,
	      privateNamesMap,
	      file
	    } = this;
	    const {
	      name
	    } = member.node.property.id;
	    const {
	      id,
	      static: isStatic,
	      method: isMethod,
	      setId,
	      getId
	    } = privateNamesMap.get(name);
	    const isAccessor = getId || setId;

	    if (isStatic) {
	      const helperName = isMethod && !isAccessor ? "classStaticPrivateMethodSet" : "classStaticPrivateFieldSpecSet";
	      return callExpression$8(file.addHelper(helperName), [this.receiver(member), cloneNode$c(classRef), cloneNode$c(id), value]);
	    }

	    if (isMethod) {
	      if (setId) {
	        return callExpression$8(file.addHelper("classPrivateFieldSet"), [this.receiver(member), cloneNode$c(id), value]);
	      }

	      return sequenceExpression$3([this.receiver(member), value, callExpression$8(file.addHelper("readOnlyError"), [stringLiteral$4(`#${name}`)])]);
	    }

	    return callExpression$8(file.addHelper("classPrivateFieldSet"), [this.receiver(member), cloneNode$c(id), value]);
	  },

	  destructureSet(member) {
	    const {
	      classRef,
	      privateNamesMap,
	      file
	    } = this;
	    const {
	      name
	    } = member.node.property.id;
	    const {
	      id,
	      static: isStatic
	    } = privateNamesMap.get(name);

	    if (isStatic) {
	      try {
	        var helper = file.addHelper("classStaticPrivateFieldDestructureSet");
	      } catch {
	        throw new Error("Babel can not transpile `[C.#p] = [0]` with @babel/helpers < 7.13.10, \n" + "please update @babel/helpers to the latest version.");
	      }

	      return memberExpression$6(callExpression$8(helper, [this.receiver(member), cloneNode$c(classRef), cloneNode$c(id)]), identifier$e("value"));
	    }

	    return memberExpression$6(callExpression$8(file.addHelper("classPrivateFieldDestructureSet"), [this.receiver(member), cloneNode$c(id)]), identifier$e("value"));
	  },

	  call(member, args) {
	    this.memoise(member, 1);
	    return optimiseCallExpression(this.get(member), this.receiver(member), args, false);
	  },

	  optionalCall(member, args) {
	    this.memoise(member, 1);
	    return optimiseCallExpression(this.get(member), this.receiver(member), args, true);
	  }

	};
	const privateNameHandlerLoose = {
	  get(member) {
	    const {
	      privateNamesMap,
	      file
	    } = this;
	    const {
	      object
	    } = member.node;
	    const {
	      name
	    } = member.node.property.id;
	    return template.expression`BASE(REF, PROP)[PROP]`({
	      BASE: file.addHelper("classPrivateFieldLooseBase"),
	      REF: cloneNode$c(object),
	      PROP: cloneNode$c(privateNamesMap.get(name).id)
	    });
	  },

	  set() {
	    throw new Error("private name handler with loose = true don't need set()");
	  },

	  boundGet(member) {
	    return callExpression$8(memberExpression$6(this.get(member), identifier$e("bind")), [cloneNode$c(member.node.object)]);
	  },

	  simpleSet(member) {
	    return this.get(member);
	  },

	  destructureSet(member) {
	    return this.get(member);
	  },

	  call(member, args) {
	    return callExpression$8(this.get(member), args);
	  },

	  optionalCall(member, args) {
	    return optionalCallExpression$2(this.get(member), args, true);
	  }

	};
	function transformPrivateNamesUsage(ref, path, privateNamesMap, {
	  privateFieldsAsProperties,
	  noDocumentAll,
	  innerBinding
	}, state) {
	  if (!privateNamesMap.size) return;
	  const body = path.get("body");
	  const handler = privateFieldsAsProperties ? privateNameHandlerLoose : privateNameHandlerSpec;
	  memberExpressionToFunctions(body, privateNameVisitor, {
	    privateNamesMap,
	    classRef: ref,
	    file: state,
	    ...handler,
	    noDocumentAll,
	    innerBinding
	  });
	  body.traverse(privateInVisitor, {
	    privateNamesMap,
	    classRef: ref,
	    file: state,
	    privateFieldsAsProperties,
	    innerBinding
	  });
	}

	function buildPrivateFieldInitLoose(ref, prop, privateNamesMap) {
	  const {
	    id
	  } = privateNamesMap.get(prop.node.key.id.name);
	  const value = prop.node.value || prop.scope.buildUndefinedNode();
	  return template.statement.ast`
    Object.defineProperty(${ref}, ${cloneNode$c(id)}, {
      // configurable is false by default
      // enumerable is false by default
      writable: true,
      value: ${value}
    });
  `;
	}

	function buildPrivateInstanceFieldInitSpec(ref, prop, privateNamesMap, state) {
	  const {
	    id
	  } = privateNamesMap.get(prop.node.key.id.name);
	  const value = prop.node.value || prop.scope.buildUndefinedNode();

	  if (!browser$5.env.BABEL_8_BREAKING) {
	    if (!state.availableHelper("classPrivateFieldInitSpec")) {
	      return template.statement.ast`${cloneNode$c(id)}.set(${ref}, {
        // configurable is always false for private elements
        // enumerable is always false for private elements
        writable: true,
        value: ${value},
      })`;
	    }
	  }

	  const helper = state.addHelper("classPrivateFieldInitSpec");
	  return template.statement.ast`${helper}(
    ${thisExpression$3()},
    ${cloneNode$c(id)},
    {
      writable: true,
      value: ${value}
    },
  )`;
	}

	function buildPrivateStaticFieldInitSpec(prop, privateNamesMap) {
	  const privateName = privateNamesMap.get(prop.node.key.id.name);
	  const {
	    id,
	    getId,
	    setId,
	    initAdded
	  } = privateName;
	  const isAccessor = getId || setId;
	  if (!prop.isProperty() && (initAdded || !isAccessor)) return;

	  if (isAccessor) {
	    privateNamesMap.set(prop.node.key.id.name, { ...privateName,
	      initAdded: true
	    });
	    return template.statement.ast`
      var ${cloneNode$c(id)} = {
        // configurable is false by default
        // enumerable is false by default
        // writable is false by default
        get: ${getId ? getId.name : prop.scope.buildUndefinedNode()},
        set: ${setId ? setId.name : prop.scope.buildUndefinedNode()}
      }
    `;
	  }

	  const value = prop.node.value || prop.scope.buildUndefinedNode();
	  return template.statement.ast`
    var ${cloneNode$c(id)} = {
      // configurable is false by default
      // enumerable is false by default
      writable: true,
      value: ${value}
    };
  `;
	}

	function buildPrivateMethodInitLoose(ref, prop, privateNamesMap) {
	  const privateName = privateNamesMap.get(prop.node.key.id.name);
	  const {
	    methodId,
	    id,
	    getId,
	    setId,
	    initAdded
	  } = privateName;
	  if (initAdded) return;

	  if (methodId) {
	    return template.statement.ast`
        Object.defineProperty(${ref}, ${id}, {
          // configurable is false by default
          // enumerable is false by default
          // writable is false by default
          value: ${methodId.name}
        });
      `;
	  }

	  const isAccessor = getId || setId;

	  if (isAccessor) {
	    privateNamesMap.set(prop.node.key.id.name, { ...privateName,
	      initAdded: true
	    });
	    return template.statement.ast`
      Object.defineProperty(${ref}, ${id}, {
        // configurable is false by default
        // enumerable is false by default
        // writable is false by default
        get: ${getId ? getId.name : prop.scope.buildUndefinedNode()},
        set: ${setId ? setId.name : prop.scope.buildUndefinedNode()}
      });
    `;
	  }
	}

	function buildPrivateInstanceMethodInitSpec(ref, prop, privateNamesMap, state) {
	  const privateName = privateNamesMap.get(prop.node.key.id.name);
	  const {
	    getId,
	    setId,
	    initAdded
	  } = privateName;
	  if (initAdded) return;
	  const isAccessor = getId || setId;

	  if (isAccessor) {
	    return buildPrivateAccessorInitialization(ref, prop, privateNamesMap, state);
	  }

	  return buildPrivateInstanceMethodInitalization(ref, prop, privateNamesMap, state);
	}

	function buildPrivateAccessorInitialization(ref, prop, privateNamesMap, state) {
	  const privateName = privateNamesMap.get(prop.node.key.id.name);
	  const {
	    id,
	    getId,
	    setId
	  } = privateName;
	  privateNamesMap.set(prop.node.key.id.name, { ...privateName,
	    initAdded: true
	  });

	  if (!browser$5.env.BABEL_8_BREAKING) {
	    if (!state.availableHelper("classPrivateFieldInitSpec")) {
	      return template.statement.ast`
      ${id}.set(${ref}, {
        get: ${getId ? getId.name : prop.scope.buildUndefinedNode()},
        set: ${setId ? setId.name : prop.scope.buildUndefinedNode()}
      });
    `;
	    }
	  }

	  const helper = state.addHelper("classPrivateFieldInitSpec");
	  return template.statement.ast`${helper}(
    ${thisExpression$3()},
    ${cloneNode$c(id)},
    {
      get: ${getId ? getId.name : prop.scope.buildUndefinedNode()},
      set: ${setId ? setId.name : prop.scope.buildUndefinedNode()}
    },
  )`;
	}

	function buildPrivateInstanceMethodInitalization(ref, prop, privateNamesMap, state) {
	  const privateName = privateNamesMap.get(prop.node.key.id.name);
	  const {
	    id
	  } = privateName;

	  if (!browser$5.env.BABEL_8_BREAKING) {
	    if (!state.availableHelper("classPrivateMethodInitSpec")) {
	      return template.statement.ast`${id}.add(${ref})`;
	    }
	  }

	  const helper = state.addHelper("classPrivateMethodInitSpec");
	  return template.statement.ast`${helper}(
    ${thisExpression$3()},
    ${cloneNode$c(id)}
  )`;
	}

	function buildPublicFieldInitLoose(ref, prop) {
	  const {
	    key,
	    computed
	  } = prop.node;
	  const value = prop.node.value || prop.scope.buildUndefinedNode();
	  return expressionStatement$7(assignmentExpression$9("=", memberExpression$6(ref, key, computed || isLiteral$5(key)), value));
	}

	function buildPublicFieldInitSpec(ref, prop, state) {
	  const {
	    key,
	    computed
	  } = prop.node;
	  const value = prop.node.value || prop.scope.buildUndefinedNode();
	  return expressionStatement$7(callExpression$8(state.addHelper("defineProperty"), [ref, computed || isLiteral$5(key) ? key : stringLiteral$4(key.name), value]));
	}

	function buildPrivateStaticMethodInitLoose(ref, prop, state, privateNamesMap) {
	  const privateName = privateNamesMap.get(prop.node.key.id.name);
	  const {
	    id,
	    methodId,
	    getId,
	    setId,
	    initAdded
	  } = privateName;
	  if (initAdded) return;
	  const isAccessor = getId || setId;

	  if (isAccessor) {
	    privateNamesMap.set(prop.node.key.id.name, { ...privateName,
	      initAdded: true
	    });
	    return template.statement.ast`
      Object.defineProperty(${ref}, ${id}, {
        // configurable is false by default
        // enumerable is false by default
        // writable is false by default
        get: ${getId ? getId.name : prop.scope.buildUndefinedNode()},
        set: ${setId ? setId.name : prop.scope.buildUndefinedNode()}
      })
    `;
	  }

	  return template.statement.ast`
    Object.defineProperty(${ref}, ${id}, {
      // configurable is false by default
      // enumerable is false by default
      // writable is false by default
      value: ${methodId.name}
    });
  `;
	}

	function buildPrivateMethodDeclaration(prop, privateNamesMap, privateFieldsAsProperties = false) {
	  const privateName = privateNamesMap.get(prop.node.key.id.name);
	  const {
	    id,
	    methodId,
	    getId,
	    setId,
	    getterDeclared,
	    setterDeclared,
	    static: isStatic
	  } = privateName;
	  const {
	    params,
	    body,
	    generator,
	    async
	  } = prop.node;
	  const isGetter = getId && !getterDeclared && params.length === 0;
	  const isSetter = setId && !setterDeclared && params.length > 0;
	  let declId = methodId;

	  if (isGetter) {
	    privateNamesMap.set(prop.node.key.id.name, { ...privateName,
	      getterDeclared: true
	    });
	    declId = getId;
	  } else if (isSetter) {
	    privateNamesMap.set(prop.node.key.id.name, { ...privateName,
	      setterDeclared: true
	    });
	    declId = setId;
	  } else if (isStatic && !privateFieldsAsProperties) {
	    declId = id;
	  }

	  return functionDeclaration(cloneNode$c(declId), params, body, generator, async);
	}

	const thisContextVisitor = traverse.visitors.merge([{
	  ThisExpression(path, state) {
	    state.needsClassRef = true;
	    path.replaceWith(cloneNode$c(state.classRef));
	  },

	  MetaProperty(path) {
	    const meta = path.get("meta");
	    const property = path.get("property");
	    const {
	      scope
	    } = path;

	    if (meta.isIdentifier({
	      name: "new"
	    }) && property.isIdentifier({
	      name: "target"
	    })) {
	      path.replaceWith(scope.buildUndefinedNode());
	    }
	  }

	}, environmentVisitor]);
	const innerReferencesVisitor = {
	  ReferencedIdentifier(path, state) {
	    if (path.scope.bindingIdentifierEquals(path.node.name, state.innerBinding)) {
	      state.needsClassRef = true;
	      path.node.name = state.classRef.name;
	    }
	  }

	};

	function replaceThisContext(path, ref, getSuperRef, file, isStaticBlock$1, constantSuper, innerBindingRef) {
	  const state = {
	    classRef: ref,
	    needsClassRef: false,
	    innerBinding: innerBindingRef
	  };
	  const replacer = new ReplaceSupers({
	    methodPath: path,
	    constantSuper,
	    file,
	    refToPreserve: ref,
	    getSuperRef,

	    getObjectRef() {
	      state.needsClassRef = true;
	      return isStaticBlock?.(path.node) || path.node.static ? ref : memberExpression$6(ref, identifier$e("prototype"));
	    }

	  });
	  replacer.replace();

	  if (isStaticBlock$1 || path.isProperty()) {
	    path.traverse(thisContextVisitor, state);
	  }

	  if (state.classRef?.name && state.classRef.name !== innerBindingRef?.name) {
	    path.traverse(innerReferencesVisitor, state);
	  }

	  return state.needsClassRef;
	}

	function buildFieldsInitNodes(ref, superRef, props, privateNamesMap, state, setPublicClassFields, privateFieldsAsProperties, constantSuper, innerBindingRef) {
	  let needsClassRef = false;
	  let injectSuperRef;
	  const staticNodes = [];
	  const instanceNodes = [];
	  const pureStaticNodes = [];
	  const getSuperRef = isIdentifier$c(superRef) ? () => superRef : () => {
	    injectSuperRef ??= props[0].scope.generateUidIdentifierBasedOnNode(superRef);
	    return injectSuperRef;
	  };

	  for (const prop of props) {
	    prop.isClassProperty() && assertFieldTransformed(prop);
	    const isStatic = !isStaticBlock?.(prop.node) && prop.node.static;
	    const isInstance = !isStatic;
	    const isPrivate = prop.isPrivate();
	    const isPublic = !isPrivate;
	    const isField = prop.isProperty();
	    const isMethod = !isField;
	    const isStaticBlock$1 = prop.isStaticBlock?.();

	    if (isStatic || isMethod && isPrivate || isStaticBlock$1) {
	      const replaced = replaceThisContext(prop, ref, getSuperRef, state, isStaticBlock$1, constantSuper, innerBindingRef);
	      needsClassRef = needsClassRef || replaced;
	    }

	    switch (true) {
	      case isStaticBlock$1:
	        {
	          const blockBody = prop.node.body;

	          if (blockBody.length === 1 && isExpressionStatement$3(blockBody[0])) {
	            staticNodes.push(blockBody[0]);
	          } else {
	            staticNodes.push(template.statement.ast`(() => { ${blockBody} })()`);
	          }

	          break;
	        }

	      case isStatic && isPrivate && isField && privateFieldsAsProperties:
	        needsClassRef = true;
	        staticNodes.push(buildPrivateFieldInitLoose(cloneNode$c(ref), prop, privateNamesMap));
	        break;

	      case isStatic && isPrivate && isField && !privateFieldsAsProperties:
	        needsClassRef = true;
	        staticNodes.push(buildPrivateStaticFieldInitSpec(prop, privateNamesMap));
	        break;

	      case isStatic && isPublic && isField && setPublicClassFields:
	        needsClassRef = true;
	        staticNodes.push(buildPublicFieldInitLoose(cloneNode$c(ref), prop));
	        break;

	      case isStatic && isPublic && isField && !setPublicClassFields:
	        needsClassRef = true;
	        staticNodes.push(buildPublicFieldInitSpec(cloneNode$c(ref), prop, state));
	        break;

	      case isInstance && isPrivate && isField && privateFieldsAsProperties:
	        instanceNodes.push(buildPrivateFieldInitLoose(thisExpression$3(), prop, privateNamesMap));
	        break;

	      case isInstance && isPrivate && isField && !privateFieldsAsProperties:
	        instanceNodes.push(buildPrivateInstanceFieldInitSpec(thisExpression$3(), prop, privateNamesMap, state));
	        break;

	      case isInstance && isPrivate && isMethod && privateFieldsAsProperties:
	        instanceNodes.unshift(buildPrivateMethodInitLoose(thisExpression$3(), prop, privateNamesMap));
	        pureStaticNodes.push(buildPrivateMethodDeclaration(prop, privateNamesMap, privateFieldsAsProperties));
	        break;

	      case isInstance && isPrivate && isMethod && !privateFieldsAsProperties:
	        instanceNodes.unshift(buildPrivateInstanceMethodInitSpec(thisExpression$3(), prop, privateNamesMap, state));
	        pureStaticNodes.push(buildPrivateMethodDeclaration(prop, privateNamesMap, privateFieldsAsProperties));
	        break;

	      case isStatic && isPrivate && isMethod && !privateFieldsAsProperties:
	        needsClassRef = true;
	        staticNodes.unshift(buildPrivateStaticFieldInitSpec(prop, privateNamesMap));
	        pureStaticNodes.push(buildPrivateMethodDeclaration(prop, privateNamesMap, privateFieldsAsProperties));
	        break;

	      case isStatic && isPrivate && isMethod && privateFieldsAsProperties:
	        needsClassRef = true;
	        staticNodes.unshift(buildPrivateStaticMethodInitLoose(cloneNode$c(ref), prop, state, privateNamesMap));
	        pureStaticNodes.push(buildPrivateMethodDeclaration(prop, privateNamesMap, privateFieldsAsProperties));
	        break;

	      case isInstance && isPublic && isField && setPublicClassFields:
	        instanceNodes.push(buildPublicFieldInitLoose(thisExpression$3(), prop));
	        break;

	      case isInstance && isPublic && isField && !setPublicClassFields:
	        instanceNodes.push(buildPublicFieldInitSpec(thisExpression$3(), prop, state));
	        break;

	      default:
	        throw new Error("Unreachable.");
	    }
	  }

	  return {
	    staticNodes: staticNodes.filter(Boolean),
	    instanceNodes: instanceNodes.filter(Boolean),
	    pureStaticNodes: pureStaticNodes.filter(Boolean),

	    wrapClass(path) {
	      for (const prop of props) {
	        prop.remove();
	      }

	      if (injectSuperRef) {
	        path.scope.push({
	          id: cloneNode$c(injectSuperRef)
	        });
	        path.set("superClass", assignmentExpression$9("=", injectSuperRef, path.node.superClass));
	      }

	      if (!needsClassRef) return path;

	      if (path.isClassExpression()) {
	        path.scope.push({
	          id: ref
	        });
	        path.replaceWith(assignmentExpression$9("=", cloneNode$c(ref), path.node));
	      } else if (!path.node.id) {
	        path.node.id = ref;
	      }

	      return path;
	    }

	  };
	}

	function hasOwnDecorators(node) {
	  return !!(node.decorators && node.decorators.length);
	}
	function hasDecorators(node) {
	  return hasOwnDecorators(node) || node.body.body.some(hasOwnDecorators);
	}

	function prop(key, value) {
	  if (!value) return null;
	  return objectProperty(identifier$e(key), value);
	}

	function method(key, body) {
	  return objectMethod("method", identifier$e(key), [], blockStatement$5(body));
	}

	function takeDecorators(node) {
	  let result;

	  if (node.decorators && node.decorators.length > 0) {
	    result = arrayExpression$1(node.decorators.map(decorator => decorator.expression));
	  }

	  node.decorators = undefined;
	  return result;
	}

	function getKey(node) {
	  if (node.computed) {
	    return node.key;
	  } else if (isIdentifier$c(node.key)) {
	    return stringLiteral$4(node.key.name);
	  } else {
	    return stringLiteral$4(String(node.key.value));
	  }
	}

	function extractElementDescriptor(classRef, superRef, path) {
	  const {
	    node,
	    scope
	  } = path;
	  const isMethod = path.isClassMethod();

	  if (path.isPrivate()) {
	    throw path.buildCodeFrameError(`Private ${isMethod ? "methods" : "fields"} in decorated classes are not supported yet.`);
	  }

	  new ReplaceSupers({
	    methodPath: path,
	    objectRef: classRef,
	    superRef,
	    file: this,
	    refToPreserve: classRef
	  }).replace();
	  const properties = [prop("kind", stringLiteral$4(isClassMethod(node) ? node.kind : "field")), prop("decorators", takeDecorators(node)), prop("static", !isStaticBlock?.(node) && node.static && booleanLiteral$2(true)), prop("key", getKey(node))].filter(Boolean);

	  if (isClassMethod(node)) {
	    const id = node.computed ? null : node.key;
	    toExpression$2(node);
	    properties.push(prop("value", nameFunction({
	      node,
	      id,
	      scope
	    }) || node));
	  } else if (isClassProperty(node) && node.value) {
	    properties.push(method("value", template.statements.ast`return ${node.value}`));
	  } else {
	    properties.push(prop("value", scope.buildUndefinedNode()));
	  }

	  path.remove();
	  return objectExpression$2(properties);
	}

	function addDecorateHelper(file) {
	  try {
	    return file.addHelper("decorate");
	  } catch (err) {
	    if (err.code === "BABEL_HELPER_UNKNOWN") {
	      err.message += "\n  '@babel/plugin-transform-decorators' in non-legacy mode" + " requires '@babel/core' version ^7.0.2 and you appear to be using" + " an older version.";
	    }

	    throw err;
	  }
	}

	function buildDecoratedClass(ref, path, elements, file) {
	  const {
	    node,
	    scope
	  } = path;
	  const initializeId = scope.generateUidIdentifier("initialize");
	  const isDeclaration = node.id && path.isDeclaration();
	  const isStrict = path.isInStrictMode();
	  const {
	    superClass
	  } = node;
	  node.type = "ClassDeclaration";
	  if (!node.id) node.id = cloneNode$c(ref);
	  let superId;

	  if (superClass) {
	    superId = scope.generateUidIdentifierBasedOnNode(node.superClass, "super");
	    node.superClass = superId;
	  }

	  const classDecorators = takeDecorators(node);
	  const definitions = arrayExpression$1(elements.filter(element => !element.node.abstract).map(extractElementDescriptor.bind(file, node.id, superId)));
	  const wrapperCall = template.expression.ast`
    ${addDecorateHelper(file)}(
      ${classDecorators || nullLiteral$1()},
      function (${initializeId}, ${superClass ? cloneNode$c(superId) : null}) {
        ${node}
        return { F: ${cloneNode$c(node.id)}, d: ${definitions} };
      },
      ${superClass}
    )
  `;

	  if (!isStrict) {
	    wrapperCall.arguments[1].body.directives.push(directive(directiveLiteral("use strict")));
	  }

	  let replacement = wrapperCall;
	  let classPathDesc = "arguments.1.body.body.0";

	  if (isDeclaration) {
	    replacement = template.statement.ast`let ${ref} = ${wrapperCall}`;
	    classPathDesc = "declarations.0.init." + classPathDesc;
	  }

	  return {
	    instanceNodes: [template.statement.ast`${cloneNode$c(initializeId)}(this)`],

	    wrapClass(path) {
	      path.replaceWith(replacement);
	      return path.get(classPathDesc);
	    }

	  };
	}

	const findBareSupers = traverse.visitors.merge([{
	  Super(path) {
	    const {
	      node,
	      parentPath
	    } = path;

	    if (parentPath.isCallExpression({
	      callee: node
	    })) {
	      this.push(parentPath);
	    }
	  }

	}, environmentVisitor]);
	const referenceVisitor = {
	  "TSTypeAnnotation|TypeAnnotation"(path) {
	    path.skip();
	  },

	  ReferencedIdentifier(path) {
	    if (this.scope.hasOwnBinding(path.node.name)) {
	      this.scope.rename(path.node.name);
	      path.skip();
	    }
	  }

	};

	function handleClassTDZ(path, state) {
	  if (state.classBinding && state.classBinding === path.scope.getBinding(path.node.name)) {
	    const classNameTDZError = state.file.addHelper("classNameTDZError");
	    const throwNode = callExpression$8(classNameTDZError, [stringLiteral$4(path.node.name)]);
	    path.replaceWith(sequenceExpression$3([throwNode, path.node]));
	    path.skip();
	  }
	}

	const classFieldDefinitionEvaluationTDZVisitor = {
	  ReferencedIdentifier: handleClassTDZ
	};
	function injectInitialization(path, constructor, nodes, renamer) {
	  if (!nodes.length) return;
	  const isDerived = !!path.node.superClass;

	  if (!constructor) {
	    const newConstructor = classMethod("constructor", identifier$e("constructor"), [], blockStatement$5([]));

	    if (isDerived) {
	      newConstructor.params = [restElement$1(identifier$e("args"))];
	      newConstructor.body.body.push(template.statement.ast`super(...args)`);
	    }

	    [constructor] = path.get("body").unshiftContainer("body", newConstructor);
	  }

	  if (renamer) {
	    renamer(referenceVisitor, {
	      scope: constructor.scope
	    });
	  }

	  if (isDerived) {
	    const bareSupers = [];
	    constructor.traverse(findBareSupers, bareSupers);
	    let isFirst = true;

	    for (const bareSuper of bareSupers) {
	      if (isFirst) {
	        bareSuper.insertAfter(nodes);
	        isFirst = false;
	      } else {
	        bareSuper.insertAfter(nodes.map(n => cloneNode$c(n)));
	      }
	    }
	  } else {
	    constructor.get("body").unshiftContainer("body", nodes);
	  }
	}
	function extractComputedKeys(ref, path, computedPaths, file) {
	  const declarations = [];
	  const state = {
	    classBinding: path.node.id && path.scope.getBinding(path.node.id.name),
	    file
	  };

	  for (const computedPath of computedPaths) {
	    const computedKey = computedPath.get("key");

	    if (computedKey.isReferencedIdentifier()) {
	      handleClassTDZ(computedKey, state);
	    } else {
	      computedKey.traverse(classFieldDefinitionEvaluationTDZVisitor, state);
	    }

	    const computedNode = computedPath.node;

	    if (!computedKey.isConstantExpression()) {
	      const ident = path.scope.generateUidIdentifierBasedOnNode(computedNode.key);
	      path.scope.push({
	        id: ident,
	        kind: "let"
	      });
	      declarations.push(expressionStatement$7(assignmentExpression$9("=", cloneNode$c(ident), computedNode.key)));
	      computedNode.key = cloneNode$c(ident);
	    }
	  }

	  return declarations;
	}

	const FEATURES$1 = Object.freeze({
	  fields: 1 << 1,
	  privateMethods: 1 << 2,
	  decorators: 1 << 3,
	  privateIn: 1 << 4,
	  staticBlocks: 1 << 5
	});
	const featuresSameLoose = new Map([[FEATURES$1.fields, "@babel/plugin-proposal-class-properties"], [FEATURES$1.privateMethods, "@babel/plugin-proposal-private-methods"], [FEATURES$1.privateIn, "@babel/plugin-proposal-private-property-in-object"]]);
	const featuresKey$1 = "@babel/plugin-class-features/featuresKey";
	const looseKey = "@babel/plugin-class-features/looseKey";
	const looseLowPriorityKey = "@babel/plugin-class-features/looseLowPriorityKey/#__internal__@babel/preset-env__please-overwrite-loose-instead-of-throwing";
	function enableFeature$1(file, feature, loose) {
	  if (!hasFeature$1(file, feature) || canIgnoreLoose(file, feature)) {
	    file.set(featuresKey$1, file.get(featuresKey$1) | feature);

	    if (loose === "#__internal__@babel/preset-env__prefer-true-but-false-is-ok-if-it-prevents-an-error") {
	      setLoose(file, feature, true);
	      file.set(looseLowPriorityKey, file.get(looseLowPriorityKey) | feature);
	    } else if (loose === "#__internal__@babel/preset-env__prefer-false-but-true-is-ok-if-it-prevents-an-error") {
	      setLoose(file, feature, false);
	      file.set(looseLowPriorityKey, file.get(looseLowPriorityKey) | feature);
	    } else {
	      setLoose(file, feature, loose);
	    }
	  }

	  let resolvedLoose;
	  let higherPriorityPluginName;

	  for (const [mask, name] of featuresSameLoose) {
	    if (!hasFeature$1(file, mask)) continue;
	    const loose = isLoose(file, mask);

	    if (canIgnoreLoose(file, mask)) {
	      continue;
	    } else if (resolvedLoose === !loose) {
	      throw new Error("'loose' mode configuration must be the same for @babel/plugin-proposal-class-properties, " + "@babel/plugin-proposal-private-methods and " + "@babel/plugin-proposal-private-property-in-object (when they are enabled).");
	    } else {
	      resolvedLoose = loose;
	      higherPriorityPluginName = name;
	    }
	  }

	  if (resolvedLoose !== undefined) {
	    for (const [mask, name] of featuresSameLoose) {
	      if (hasFeature$1(file, mask) && isLoose(file, mask) !== resolvedLoose) {
	        setLoose(file, mask, resolvedLoose);
	        console.warn(`Though the "loose" option was set to "${!resolvedLoose}" in your @babel/preset-env ` + `config, it will not be used for ${name} since the "loose" mode option was set to ` + `"${resolvedLoose}" for ${higherPriorityPluginName}.\nThe "loose" option must be the ` + `same for @babel/plugin-proposal-class-properties, @babel/plugin-proposal-private-methods ` + `and @babel/plugin-proposal-private-property-in-object (when they are enabled): you can ` + `silence this warning by explicitly adding\n` + `\t["${name}", { "loose": ${resolvedLoose} }]\n` + `to the "plugins" section of your Babel config.`);
	      }
	    }
	  }
	}

	function hasFeature$1(file, feature) {
	  return !!(file.get(featuresKey$1) & feature);
	}

	function isLoose(file, feature) {
	  return !!(file.get(looseKey) & feature);
	}

	function setLoose(file, feature, loose) {
	  if (loose) file.set(looseKey, file.get(looseKey) | feature);else file.set(looseKey, file.get(looseKey) & ~feature);
	  file.set(looseLowPriorityKey, file.get(looseLowPriorityKey) & ~feature);
	}

	function canIgnoreLoose(file, feature) {
	  return !!(file.get(looseLowPriorityKey) & feature);
	}

	function shouldTransform(path, file) {
	  let decoratorPath = null;
	  let publicFieldPath = null;
	  let privateFieldPath = null;
	  let privateMethodPath = null;
	  let staticBlockPath = null;

	  if (hasOwnDecorators(path.node)) {
	    decoratorPath = path.get("decorators.0");
	  }

	  for (const el of path.get("body.body")) {
	    if (!decoratorPath && hasOwnDecorators(el.node)) {
	      decoratorPath = el.get("decorators.0");
	    }

	    if (!publicFieldPath && el.isClassProperty()) {
	      publicFieldPath = el;
	    }

	    if (!privateFieldPath && el.isClassPrivateProperty()) {
	      privateFieldPath = el;
	    }

	    if (!privateMethodPath && el.isClassPrivateMethod?.()) {
	      privateMethodPath = el;
	    }

	    if (!staticBlockPath && el.isStaticBlock?.()) {
	      staticBlockPath = el;
	    }
	  }

	  if (decoratorPath && privateFieldPath) {
	    throw privateFieldPath.buildCodeFrameError("Private fields in decorated classes are not supported yet.");
	  }

	  if (decoratorPath && privateMethodPath) {
	    throw privateMethodPath.buildCodeFrameError("Private methods in decorated classes are not supported yet.");
	  }

	  if (decoratorPath && !hasFeature$1(file, FEATURES$1.decorators)) {
	    throw path.buildCodeFrameError("Decorators are not enabled." + "\nIf you are using " + '["@babel/plugin-proposal-decorators", { "legacy": true }], ' + 'make sure it comes *before* "@babel/plugin-proposal-class-properties" ' + "and enable loose mode, like so:\n" + '\t["@babel/plugin-proposal-decorators", { "legacy": true }]\n' + '\t["@babel/plugin-proposal-class-properties", { "loose": true }]');
	  }

	  if (privateMethodPath && !hasFeature$1(file, FEATURES$1.privateMethods)) {
	    throw privateMethodPath.buildCodeFrameError("Class private methods are not enabled. " + "Please add `@babel/plugin-proposal-private-method` to your configuration.");
	  }

	  if ((publicFieldPath || privateFieldPath) && !hasFeature$1(file, FEATURES$1.fields) && !hasFeature$1(file, FEATURES$1.privateMethods)) {
	    throw path.buildCodeFrameError("Class fields are not enabled. " + "Please add `@babel/plugin-proposal-class-properties` to your configuration.");
	  }

	  if (staticBlockPath && !hasFeature$1(file, FEATURES$1.staticBlocks)) {
	    throw path.buildCodeFrameError("Static class blocks are not enabled. " + "Please add `@babel/plugin-proposal-class-static-block` to your configuration.");
	  }

	  if (decoratorPath || privateMethodPath || staticBlockPath) {
	    return true;
	  }

	  if ((publicFieldPath || privateFieldPath) && hasFeature$1(file, FEATURES$1.fields)) {
	    return true;
	  }

	  return false;
	}

	const version$2 = "7.17.6".split(".").reduce((v, x) => v * 1e5 + +x, 0);
	const versionKey$1 = "@babel/plugin-class-features/version";
	function createClassFeaturePlugin({
	  name,
	  feature,
	  loose,
	  manipulateOptions,
	  api = {
	    assumption: () => void 0
	  },
	  inherits
	}) {
	  const setPublicClassFields = api.assumption("setPublicClassFields");
	  const privateFieldsAsProperties = api.assumption("privateFieldsAsProperties");
	  const constantSuper = api.assumption("constantSuper");
	  const noDocumentAll = api.assumption("noDocumentAll");

	  if (loose === true) {
	    const explicit = [];

	    if (setPublicClassFields !== undefined) {
	      explicit.push(`"setPublicClassFields"`);
	    }

	    if (privateFieldsAsProperties !== undefined) {
	      explicit.push(`"privateFieldsAsProperties"`);
	    }

	    if (explicit.length !== 0) {
	      console.warn(`[${name}]: You are using the "loose: true" option and you are` + ` explicitly setting a value for the ${explicit.join(" and ")}` + ` assumption${explicit.length > 1 ? "s" : ""}. The "loose" option` + ` can cause incompatibilities with the other class features` + ` plugins, so it's recommended that you replace it with the` + ` following top-level option:\n` + `\t"assumptions": {\n` + `\t\t"setPublicClassFields": true,\n` + `\t\t"privateFieldsAsProperties": true\n` + `\t}`);
	    }
	  }

	  return {
	    name,
	    manipulateOptions,
	    inherits,

	    pre() {
	      enableFeature$1(this.file, feature, loose);

	      if (!this.file.get(versionKey$1) || this.file.get(versionKey$1) < version$2) {
	        this.file.set(versionKey$1, version$2);
	      }
	    },

	    visitor: {
	      Class(path, state) {
	        if (this.file.get(versionKey$1) !== version$2) return;
	        if (!shouldTransform(path, this.file)) return;
	        if (path.isClassDeclaration()) assertFieldTransformed(path);
	        const loose = isLoose(this.file, feature);
	        let constructor;
	        const isDecorated = hasDecorators(path.node);
	        const props = [];
	        const elements = [];
	        const computedPaths = [];
	        const privateNames = new Set();
	        const body = path.get("body");

	        for (const path of body.get("body")) {
	          if ((path.isClassProperty() || path.isClassMethod()) && path.node.computed) {
	            computedPaths.push(path);
	          }

	          if (path.isPrivate()) {
	            const {
	              name
	            } = path.node.key.id;
	            const getName = `get ${name}`;
	            const setName = `set ${name}`;

	            if (path.isClassPrivateMethod()) {
	              if (path.node.kind === "get") {
	                if (privateNames.has(getName) || privateNames.has(name) && !privateNames.has(setName)) {
	                  throw path.buildCodeFrameError("Duplicate private field");
	                }

	                privateNames.add(getName).add(name);
	              } else if (path.node.kind === "set") {
	                if (privateNames.has(setName) || privateNames.has(name) && !privateNames.has(getName)) {
	                  throw path.buildCodeFrameError("Duplicate private field");
	                }

	                privateNames.add(setName).add(name);
	              }
	            } else {
	              if (privateNames.has(name) && !privateNames.has(getName) && !privateNames.has(setName) || privateNames.has(name) && (privateNames.has(getName) || privateNames.has(setName))) {
	                throw path.buildCodeFrameError("Duplicate private field");
	              }

	              privateNames.add(name);
	            }
	          }

	          if (path.isClassMethod({
	            kind: "constructor"
	          })) {
	            constructor = path;
	          } else {
	            elements.push(path);

	            if (path.isProperty() || path.isPrivate() || path.isStaticBlock?.()) {
	              props.push(path);
	            }
	          }
	        }

	        if (!props.length && !isDecorated) return;
	        const innerBinding = path.node.id;
	        let ref;

	        if (!innerBinding || path.isClassExpression()) {
	          nameFunction(path);
	          ref = path.scope.generateUidIdentifier("class");
	        } else {
	          ref = cloneNode$c(path.node.id);
	        }

	        const privateNamesMap = buildPrivateNamesMap(props);
	        const privateNamesNodes = buildPrivateNamesNodes(privateNamesMap, privateFieldsAsProperties ?? loose, state);
	        transformPrivateNamesUsage(ref, path, privateNamesMap, {
	          privateFieldsAsProperties: privateFieldsAsProperties ?? loose,
	          noDocumentAll,
	          innerBinding
	        }, state);
	        let keysNodes, staticNodes, instanceNodes, pureStaticNodes, wrapClass;

	        if (isDecorated) {
	          staticNodes = pureStaticNodes = keysNodes = [];
	          ({
	            instanceNodes,
	            wrapClass
	          } = buildDecoratedClass(ref, path, elements, this.file));
	        } else {
	          keysNodes = extractComputedKeys(ref, path, computedPaths, this.file);
	          ({
	            staticNodes,
	            pureStaticNodes,
	            instanceNodes,
	            wrapClass
	          } = buildFieldsInitNodes(ref, path.node.superClass, props, privateNamesMap, state, setPublicClassFields ?? loose, privateFieldsAsProperties ?? loose, constantSuper ?? loose, innerBinding));
	        }

	        if (instanceNodes.length > 0) {
	          injectInitialization(path, constructor, instanceNodes, (referenceVisitor, state) => {
	            if (isDecorated) return;

	            for (const prop of props) {
	              if (isStaticBlock?.(prop.node) || prop.node.static) continue;
	              prop.traverse(referenceVisitor, state);
	            }
	          });
	        }

	        const wrappedPath = wrapClass(path);
	        wrappedPath.insertBefore([...privateNamesNodes, ...keysNodes]);

	        if (staticNodes.length > 0) {
	          wrappedPath.insertAfter(staticNodes);
	        }

	        if (pureStaticNodes.length > 0) {
	          wrappedPath.find(parent => parent.isStatement() || parent.isDeclaration()).insertAfter(pureStaticNodes);
	        }
	      },

	      ExportDefaultDeclaration(path) {
	        if (this.file.get(versionKey$1) !== version$2) return;
	        const decl = path.get("declaration");

	        if (decl.isClassDeclaration() && hasDecorators(decl.node)) {
	          if (decl.node.id) {
	            splitExportDeclaration(path);
	          } else {
	            decl.node.type = "ClassExpression";
	          }
	        }
	      }

	    }
	  };
	}

	var proposalPrivateMethods = declare((api, options) => {
	  api.assertVersion(7);
	  return createClassFeaturePlugin({
	    name: "proposal-private-methods",
	    api,
	    feature: FEATURES$1.privateMethods,
	    loose: options.loose,

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push("classPrivateMethods");
	    }

	  });
	});

	var lib = createCommonjsModule(function (module, exports) {

	  Object.defineProperty(exports, "__esModule", {
	    value: true
	  });
	  exports.default = void 0;

	  var _default = (0, _helperPluginUtils.declare)(api => {
	    api.assertVersion(7);
	    return {
	      name: "syntax-private-property-in-object",

	      manipulateOptions(opts, parserOpts) {
	        parserOpts.plugins.push("privateIn");
	      }

	    };
	  });

	  exports.default = _default;
	}, "/$$rollup_base$$/packages/babel-plugin-proposal-private-property-in-object/node_modules/@babel/plugin-syntax-private-property-in-object/lib");

	var proposalPrivatePropertyInObject = declare(({
	  assertVersion,
	  types: t,
	  template
	}, {
	  loose
	}) => {
	  assertVersion(7);
	  const classWeakSets = new WeakMap();
	  const fieldsWeakSets = new WeakMap();

	  function unshadow(name, targetScope, scope) {
	    while (scope !== targetScope) {
	      if (scope.hasOwnBinding(name)) scope.rename(name);
	      scope = scope.parent;
	    }
	  }

	  function injectToFieldInit(fieldPath, expr, before = false) {
	    if (fieldPath.node.value) {
	      if (before) {
	        fieldPath.get("value").insertBefore(expr);
	      } else {
	        fieldPath.get("value").insertAfter(expr);
	      }
	    } else {
	      fieldPath.set("value", t.unaryExpression("void", expr));
	    }
	  }

	  function injectInitialization$1(classPath, init) {
	    let firstFieldPath;
	    let consturctorPath;

	    for (const el of classPath.get("body.body")) {
	      if ((el.isClassProperty() || el.isClassPrivateProperty()) && !el.node.static) {
	        firstFieldPath = el;
	        break;
	      }

	      if (!consturctorPath && el.isClassMethod({
	        kind: "constructor"
	      })) {
	        consturctorPath = el;
	      }
	    }

	    if (firstFieldPath) {
	      injectToFieldInit(firstFieldPath, init, true);
	    } else {
	      injectInitialization(classPath, consturctorPath, [t.expressionStatement(init)]);
	    }
	  }

	  function getWeakSetId(weakSets, outerClass, reference, name = "", inject) {
	    let id = classWeakSets.get(reference.node);

	    if (!id) {
	      id = outerClass.scope.generateUidIdentifier(`${name || ""} brandCheck`);
	      classWeakSets.set(reference.node, id);
	      inject(reference, template.expression.ast`${t.cloneNode(id)}.add(this)`);
	      const newExpr = t.newExpression(t.identifier("WeakSet"), []);
	      annotateAsPure(newExpr);
	      outerClass.insertBefore(template.ast`var ${id} = ${newExpr}`);
	    }

	    return t.cloneNode(id);
	  }

	  return {
	    name: "proposal-private-property-in-object",
	    inherits: lib.default,

	    pre() {
	      enableFeature$1(this.file, FEATURES$1.privateIn, loose);
	    },

	    visitor: {
	      BinaryExpression(path) {
	        const {
	          node
	        } = path;
	        if (node.operator !== "in") return;
	        if (!t.isPrivateName(node.left)) return;
	        const {
	          name
	        } = node.left.id;
	        let privateElement;
	        const outerClass = path.findParent(path => {
	          if (!path.isClass()) return false;
	          privateElement = path.get("body.body").find(({
	            node
	          }) => t.isPrivate(node) && node.key.id.name === name);
	          return !!privateElement;
	        });

	        if (outerClass.parentPath.scope.path.isPattern()) {
	          outerClass.replaceWith(template.ast`(() => ${outerClass.node})()`);
	          return;
	        }

	        if (privateElement.isMethod()) {
	          if (privateElement.node.static) {
	            if (outerClass.node.id) {
	              unshadow(outerClass.node.id.name, outerClass.scope, path.scope);
	            } else {
	              outerClass.set("id", path.scope.generateUidIdentifier("class"));
	            }

	            path.replaceWith(template.expression.ast`
                ${t.cloneNode(outerClass.node.id)} === ${path.node.right}
              `);
	          } else {
	            const id = getWeakSetId(classWeakSets, outerClass, outerClass, outerClass.node.id?.name, injectInitialization$1);
	            path.replaceWith(template.expression.ast`${id}.has(${path.node.right})`);
	          }
	        } else {
	          const id = getWeakSetId(fieldsWeakSets, outerClass, privateElement, privateElement.node.key.id.name, injectToFieldInit);
	          path.replaceWith(template.expression.ast`${id}.has(${path.node.right})`);
	        }
	      }

	    }
	  };
	});

	var syntaxThrowExpressions = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "syntax-throw-expressions",

	    manipulateOptions(opts, parserOpts) {
	      parserOpts.plugins.push("throwExpressions");
	    }

	  };
	});

	var proposalThrowExpressions = declare(api => {
	  api.assertVersion(7);
	  return {
	    name: "proposal-throw-expressions",
	    inherits: syntaxThrowExpressions,
	    visitor: {
	      UnaryExpression(path) {
	        const {
	          operator,
	          argument
	        } = path.node;
	        if (operator !== "throw") return;
	        const arrow = functionExpression$1(null, [identifier$e("e")], blockStatement$5([throwStatement(identifier$e("e"))]));
	        path.replaceWith(callExpression$8(arrow, [argument]));
	      }

	    }
	  };
	});

	var regjsgen = createCommonjsModule(function (module, exports) {
	  (function () {

	    var objectTypes = {
	      'function': true,
	      'object': true
	    };
	    var root = objectTypes[typeof window] && window || this;
	    var freeExports = exports && !exports.nodeType && exports;
	    var hasFreeModule = module && !module.nodeType;
	    var freeGlobal = freeExports && hasFreeModule && typeof commonjsGlobal == 'object' && commonjsGlobal;

	    if (freeGlobal && (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal || freeGlobal.self === freeGlobal)) {
	      root = freeGlobal;
	    }

	    var hasOwnProperty = Object.prototype.hasOwnProperty;

	    function fromCodePoint() {
	      var codePoint = Number(arguments[0]);

	      if (!isFinite(codePoint) || codePoint < 0 || codePoint > 0x10FFFF || Math.floor(codePoint) != codePoint) {
	        throw RangeError('Invalid code point: ' + codePoint);
	      }

	      if (codePoint <= 0xFFFF) {
	        return String.fromCharCode(codePoint);
	      } else {
	        codePoint -= 0x10000;
	        var highSurrogate = (codePoint >> 10) + 0xD800;
	        var lowSurrogate = codePoint % 0x400 + 0xDC00;
	        return String.fromCharCode(highSurrogate, lowSurrogate);
	      }
	    }

	    var assertTypeRegexMap = {};

	    function assertType(type, expected) {
	      if (expected.indexOf('|') == -1) {
	        if (type == expected) {
	          return;
	        }

	        throw Error('Invalid node type: ' + type + '; expected type: ' + expected);
	      }

	      expected = hasOwnProperty.call(assertTypeRegexMap, expected) ? assertTypeRegexMap[expected] : assertTypeRegexMap[expected] = RegExp('^(?:' + expected + ')$');

	      if (expected.test(type)) {
	        return;
	      }

	      throw Error('Invalid node type: ' + type + '; expected types: ' + expected);
	    }

	    function generate(node) {
	      var type = node.type;

	      if (hasOwnProperty.call(generators, type)) {
	        return generators[type](node);
	      }

	      throw Error('Invalid node type: ' + type);
	    }

	    function generateSequence(generator, terms, separator) {
	      var i = -1,
	          length = terms.length,
	          result = '',
	          term;

	      while (++i < length) {
	        term = terms[i];
	        if (separator && i > 0) result += separator;

	        if (i + 1 < length && terms[i].type == 'value' && terms[i].kind == 'null' && terms[i + 1].type == 'value' && terms[i + 1].kind == 'symbol' && terms[i + 1].codePoint >= 48 && terms[i + 1].codePoint <= 57) {
	          result += '\\000';
	          continue;
	        }

	        result += generator(term);
	      }

	      return result;
	    }

	    function generateAlternative(node) {
	      assertType(node.type, 'alternative');
	      return generateSequence(generateTerm, node.body);
	    }

	    function generateAnchor(node) {
	      assertType(node.type, 'anchor');

	      switch (node.kind) {
	        case 'start':
	          return '^';

	        case 'end':
	          return '$';

	        case 'boundary':
	          return '\\b';

	        case 'not-boundary':
	          return '\\B';

	        default:
	          throw Error('Invalid assertion');
	      }
	    }

	    function generateAtom(node) {
	      assertType(node.type, 'anchor|characterClass|characterClassEscape|dot|group|reference|value');
	      return generate(node);
	    }

	    function generateCharacterClass(node) {
	      assertType(node.type, 'characterClass');
	      var kind = node.kind;
	      var separator = kind === 'intersection' ? '&&' : kind === 'subtraction' ? '--' : '';
	      return '[' + (node.negative ? '^' : '') + generateSequence(generateClassAtom, node.body, separator) + ']';
	    }

	    function generateCharacterClassEscape(node) {
	      assertType(node.type, 'characterClassEscape');
	      return '\\' + node.value;
	    }

	    function generateCharacterClassRange(node) {
	      assertType(node.type, 'characterClassRange');
	      var min = node.min,
	          max = node.max;

	      if (min.type == 'characterClassRange' || max.type == 'characterClassRange') {
	        throw Error('Invalid character class range');
	      }

	      return generateClassAtom(min) + '-' + generateClassAtom(max);
	    }

	    function generateClassAtom(node) {
	      assertType(node.type, 'anchor|characterClass|characterClassEscape|characterClassRange|dot|value|unicodePropertyEscape|classStrings');
	      return generate(node);
	    }

	    function generateClassStrings(node) {
	      assertType(node.type, 'classStrings');
	      return '(' + generateSequence(generateClassString, node.strings, '|') + ')';
	    }

	    function generateClassString(node) {
	      assertType(node.type, 'classString');
	      return generateSequence(generate, node.characters);
	    }

	    function generateDisjunction(node) {
	      assertType(node.type, 'disjunction');
	      return generateSequence(generate, node.body, '|');
	    }

	    function generateDot(node) {
	      assertType(node.type, 'dot');
	      return '.';
	    }

	    function generateGroup(node) {
	      assertType(node.type, 'group');
	      var result = '';

	      switch (node.behavior) {
	        case 'normal':
	          if (node.name) {
	            result += '?<' + generateIdentifier(node.name) + '>';
	          }

	          break;

	        case 'ignore':
	          result += '?:';
	          break;

	        case 'lookahead':
	          result += '?=';
	          break;

	        case 'negativeLookahead':
	          result += '?!';
	          break;

	        case 'lookbehind':
	          result += '?<=';
	          break;

	        case 'negativeLookbehind':
	          result += '?<!';
	          break;

	        default:
	          throw Error('Invalid behaviour: ' + node.behaviour);
	      }

	      result += generateSequence(generate, node.body);
	      return '(' + result + ')';
	    }

	    function generateIdentifier(node) {
	      assertType(node.type, 'identifier');
	      return node.value;
	    }

	    function generateQuantifier(node) {
	      assertType(node.type, 'quantifier');
	      var quantifier = '',
	          min = node.min,
	          max = node.max;

	      if (max == null) {
	        if (min == 0) {
	          quantifier = '*';
	        } else if (min == 1) {
	          quantifier = '+';
	        } else {
	          quantifier = '{' + min + ',}';
	        }
	      } else if (min == max) {
	        quantifier = '{' + min + '}';
	      } else if (min == 0 && max == 1) {
	        quantifier = '?';
	      } else {
	        quantifier = '{' + min + ',' + max + '}';
	      }

	      if (!node.greedy) {
	        quantifier += '?';
	      }

	      return generateAtom(node.body[0]) + quantifier;
	    }

	    function generateReference(node) {
	      assertType(node.type, 'reference');

	      if (node.matchIndex) {
	        return '\\' + node.matchIndex;
	      }

	      if (node.name) {
	        return '\\k<' + generateIdentifier(node.name) + '>';
	      }

	      throw new Error('Unknown reference type');
	    }

	    function generateTerm(node) {
	      assertType(node.type, 'anchor|characterClass|characterClassEscape|empty|group|quantifier|reference|unicodePropertyEscape|value|dot');
	      return generate(node);
	    }

	    function generateUnicodePropertyEscape(node) {
	      assertType(node.type, 'unicodePropertyEscape');
	      return '\\' + (node.negative ? 'P' : 'p') + '{' + node.value + '}';
	    }

	    function generateValue(node) {
	      assertType(node.type, 'value');
	      var kind = node.kind,
	          codePoint = node.codePoint;

	      if (typeof codePoint != 'number') {
	        throw new Error('Invalid code point: ' + codePoint);
	      }

	      switch (kind) {
	        case 'controlLetter':
	          return '\\c' + fromCodePoint(codePoint + 64);

	        case 'hexadecimalEscape':
	          return '\\x' + ('00' + codePoint.toString(16).toUpperCase()).slice(-2);

	        case 'identifier':
	          return '\\' + fromCodePoint(codePoint);

	        case 'null':
	          return '\\' + codePoint;

	        case 'octal':
	          return '\\' + ('000' + codePoint.toString(8)).slice(-3);

	        case 'singleEscape':
	          switch (codePoint) {
	            case 0x0008:
	              return '\\b';

	            case 0x0009:
	              return '\\t';

	            case 0x000A:
	              return '\\n';

	            case 0x000B:
	              return '\\v';

	            case 0x000C:
	              return '\\f';

	            case 0x000D:
	              return '\\r';

	            case 0x002D:
	              return '\\-';

	            default:
	              throw Error('Invalid code point: ' + codePoint);
	          }

	        case 'symbol':
	          return fromCodePoint(codePoint);

	        case 'unicodeEscape':
	          return '\\u' + ('0000' + codePoint.toString(16).toUpperCase()).slice(-4);

	        case 'unicodeCodePointEscape':
	          return '\\u{' + codePoint.toString(16).toUpperCase() + '}';

	        default:
	          throw Error('Unsupported node kind: ' + kind);
	      }
	    }

	    var generators = {
	      'alternative': generateAlternative,
	      'anchor': generateAnchor,
	      'characterClass': generateCharacterClass,
	      'characterClassEscape': generateCharacterClassEscape,
	      'characterClassRange': generateCharacterClassRange,
	      'classStrings': generateClassStrings,
	      'disjunction': generateDisjunction,
	      'dot': generateDot,
	      'group': generateGroup,
	      'quantifier': generateQuantifier,
	      'reference': generateReference,
	      'unicodePropertyEscape': generateUnicodePropertyEscape,
	      'value': generateValue
	    };
	    var regjsgen = {
	      'generate': generate
	    };

	    if (freeExports && hasFreeModule) {
	      freeExports.generate = generate;
	    } else {
	      root.regjsgen = regjsgen;
	    }
	  }).call(commonjsGlobal);
	}, "/$$rollup_base$$/node_modules/regjsgen");

	var parser = createCommonjsModule(function (module) {
	  (function () {
	    var fromCodePoint = String.fromCodePoint || function () {
	      var stringFromCharCode = String.fromCharCode;
	      var floor = Math.floor;
	      return function fromCodePoint() {
	        var MAX_SIZE = 0x4000;
	        var codeUnits = [];
	        var highSurrogate;
	        var lowSurrogate;
	        var index = -1;
	        var length = arguments.length;

	        if (!length) {
	          return '';
	        }

	        var result = '';

	        while (++index < length) {
	          var codePoint = Number(arguments[index]);

	          if (!isFinite(codePoint) || codePoint < 0 || codePoint > 0x10FFFF || floor(codePoint) != codePoint) {
	            throw RangeError('Invalid code point: ' + codePoint);
	          }

	          if (codePoint <= 0xFFFF) {
	            codeUnits.push(codePoint);
	          } else {
	            codePoint -= 0x10000;
	            highSurrogate = (codePoint >> 10) + 0xD800;
	            lowSurrogate = codePoint % 0x400 + 0xDC00;
	            codeUnits.push(highSurrogate, lowSurrogate);
	          }

	          if (index + 1 == length || codeUnits.length > MAX_SIZE) {
	            result += stringFromCharCode.apply(null, codeUnits);
	            codeUnits.length = 0;
	          }
	        }

	        return result;
	      };
	    }();

	    function parse(str, flags, features) {
	      if (!features) {
	        features = {};
	      }

	      function addRaw(node) {
	        node.raw = str.substring(node.range[0], node.range[1]);
	        return node;
	      }

	      function updateRawStart(node, start) {
	        node.range[0] = start;
	        return addRaw(node);
	      }

	      function createAnchor(kind, rawLength) {
	        return addRaw({
	          type: 'anchor',
	          kind: kind,
	          range: [pos - rawLength, pos]
	        });
	      }

	      function createValue(kind, codePoint, from, to) {
	        return addRaw({
	          type: 'value',
	          kind: kind,
	          codePoint: codePoint,
	          range: [from, to]
	        });
	      }

	      function createEscaped(kind, codePoint, value, fromOffset) {
	        fromOffset = fromOffset || 0;
	        return createValue(kind, codePoint, pos - (value.length + fromOffset), pos);
	      }

	      function createCharacter(matches) {
	        var _char = matches[0];

	        var first = _char.charCodeAt(0);

	        if (isUnicodeMode) {
	          var second;

	          if (_char.length === 1 && first >= 0xD800 && first <= 0xDBFF) {
	            second = lookahead().charCodeAt(0);

	            if (second >= 0xDC00 && second <= 0xDFFF) {
	              pos++;
	              return createValue('symbol', (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000, pos - 2, pos);
	            }
	          }
	        }

	        return createValue('symbol', first, pos - 1, pos);
	      }

	      function createDisjunction(alternatives, from, to) {
	        return addRaw({
	          type: 'disjunction',
	          body: alternatives,
	          range: [from, to]
	        });
	      }

	      function createDot() {
	        return addRaw({
	          type: 'dot',
	          range: [pos - 1, pos]
	        });
	      }

	      function createCharacterClassEscape(value) {
	        return addRaw({
	          type: 'characterClassEscape',
	          value: value,
	          range: [pos - 2, pos]
	        });
	      }

	      function createReference(matchIndex) {
	        return addRaw({
	          type: 'reference',
	          matchIndex: parseInt(matchIndex, 10),
	          range: [pos - 1 - matchIndex.length, pos]
	        });
	      }

	      function createNamedReference(name) {
	        return addRaw({
	          type: 'reference',
	          name: name,
	          range: [name.range[0] - 3, pos]
	        });
	      }

	      function createGroup(behavior, disjunction, from, to) {
	        return addRaw({
	          type: 'group',
	          behavior: behavior,
	          body: disjunction,
	          range: [from, to]
	        });
	      }

	      function createQuantifier(min, max, from, to) {
	        if (to == null) {
	          from = pos - 1;
	          to = pos;
	        }

	        return addRaw({
	          type: 'quantifier',
	          min: min,
	          max: max,
	          greedy: true,
	          body: null,
	          range: [from, to]
	        });
	      }

	      function createAlternative(terms, from, to) {
	        return addRaw({
	          type: 'alternative',
	          body: terms,
	          range: [from, to]
	        });
	      }

	      function createCharacterClass(contents, negative, from, to) {
	        return addRaw({
	          type: 'characterClass',
	          kind: contents.kind,
	          body: contents.body,
	          negative: negative,
	          range: [from, to]
	        });
	      }

	      function createClassRange(min, max, from, to) {
	        if (min.codePoint > max.codePoint) {
	          bail('invalid range in character class', min.raw + '-' + max.raw, from, to);
	        }

	        return addRaw({
	          type: 'characterClassRange',
	          min: min,
	          max: max,
	          range: [from, to]
	        });
	      }

	      function createClassStrings(strings, from, to) {
	        return addRaw({
	          type: 'classStrings',
	          strings: strings,
	          range: [from, to]
	        });
	      }

	      function createClassString(characters, from, to) {
	        return addRaw({
	          type: 'classString',
	          characters: characters,
	          range: [from, to]
	        });
	      }

	      function flattenBody(body) {
	        if (body.type === 'alternative') {
	          return body.body;
	        } else {
	          return [body];
	        }
	      }

	      function incr(amount) {
	        amount = amount || 1;
	        var res = str.substring(pos, pos + amount);
	        pos += amount || 1;
	        return res;
	      }

	      function skip(value) {
	        if (!match(value)) {
	          bail('character', value);
	        }
	      }

	      function match(value) {
	        if (str.indexOf(value, pos) === pos) {
	          return incr(value.length);
	        }
	      }

	      function lookahead() {
	        return str[pos];
	      }

	      function current(value) {
	        return str.indexOf(value, pos) === pos;
	      }

	      function next(value) {
	        return str[pos + 1] === value;
	      }

	      function matchReg(regExp) {
	        var subStr = str.substring(pos);
	        var res = subStr.match(regExp);

	        if (res) {
	          res.range = [];
	          res.range[0] = pos;
	          incr(res[0].length);
	          res.range[1] = pos;
	        }

	        return res;
	      }

	      function parseDisjunction() {
	        var res = [],
	            from = pos;
	        res.push(parseAlternative());

	        while (match('|')) {
	          res.push(parseAlternative());
	        }

	        if (res.length === 1) {
	          return res[0];
	        }

	        return createDisjunction(res, from, pos);
	      }

	      function parseAlternative() {
	        var res = [],
	            from = pos;
	        var term;

	        while (term = parseTerm()) {
	          res.push(term);
	        }

	        if (res.length === 1) {
	          return res[0];
	        }

	        return createAlternative(res, from, pos);
	      }

	      function parseTerm() {
	        if (pos >= str.length || current('|') || current(')')) {
	          return null;
	        }

	        var anchor = parseAnchor();

	        if (anchor) {
	          return anchor;
	        }

	        var atom = parseAtomAndExtendedAtom();

	        if (!atom) {
	          var pos_backup = pos;
	          var quantifier = parseQuantifier() || false;

	          if (quantifier) {
	            pos = pos_backup;
	            bail('Expected atom');
	          }

	          if (!isUnicodeMode && (res = matchReg(/^{/))) {
	            atom = createCharacter(res);
	          } else {
	            bail('Expected atom');
	          }
	        }

	        var quantifier = parseQuantifier() || false;

	        if (quantifier) {
	          quantifier.body = flattenBody(atom);
	          updateRawStart(quantifier, atom.range[0]);
	          return quantifier;
	        }

	        return atom;
	      }

	      function parseGroup(matchA, typeA, matchB, typeB) {
	        var type = null,
	            from = pos;

	        if (match(matchA)) {
	          type = typeA;
	        } else if (match(matchB)) {
	          type = typeB;
	        } else {
	          return false;
	        }

	        return finishGroup(type, from);
	      }

	      function finishGroup(type, from) {
	        var body = parseDisjunction();

	        if (!body) {
	          bail('Expected disjunction');
	        }

	        skip(')');
	        var group = createGroup(type, flattenBody(body), from, pos);

	        if (type == 'normal') {
	          if (firstIteration) {
	            closedCaptureCounter++;
	          }
	        }

	        return group;
	      }

	      function parseAnchor() {

	        if (match('^')) {
	          return createAnchor('start', 1);
	        } else if (match('$')) {
	          return createAnchor('end', 1);
	        } else if (match('\\b')) {
	          return createAnchor('boundary', 2);
	        } else if (match('\\B')) {
	          return createAnchor('not-boundary', 2);
	        } else {
	          return parseGroup('(?=', 'lookahead', '(?!', 'negativeLookahead');
	        }
	      }

	      function parseQuantifier() {
	        var res,
	            from = pos;
	        var quantifier;
	        var min, max;

	        if (match('*')) {
	          quantifier = createQuantifier(0);
	        } else if (match('+')) {
	          quantifier = createQuantifier(1);
	        } else if (match('?')) {
	          quantifier = createQuantifier(0, 1);
	        } else if (res = matchReg(/^\{([0-9]+)\}/)) {
	          min = parseInt(res[1], 10);
	          quantifier = createQuantifier(min, min, res.range[0], res.range[1]);
	        } else if (res = matchReg(/^\{([0-9]+),\}/)) {
	          min = parseInt(res[1], 10);
	          quantifier = createQuantifier(min, undefined, res.range[0], res.range[1]);
	        } else if (res = matchReg(/^\{([0-9]+),([0-9]+)\}/)) {
	          min = parseInt(res[1], 10);
	          max = parseInt(res[2], 10);

	          if (min > max) {
	            bail('numbers out of order in {} quantifier', '', from, pos);
	          }

	          quantifier = createQuantifier(min, max, res.range[0], res.range[1]);
	        }

	        if (min && !Number.isSafeInteger(min) || max && !Number.isSafeInteger(max)) {
	          bail("iterations outside JS safe integer range in quantifier", "", from, pos);
	        }

	        if (quantifier) {
	          if (match('?')) {
	            quantifier.greedy = false;
	            quantifier.range[1] += 1;
	          }
	        }

	        return quantifier;
	      }

	      function parseAtomAndExtendedAtom() {
	        var res;

	        if (res = matchReg(/^[^^$\\.*+?()[\]{}|]/)) {
	          return createCharacter(res);
	        } else if (!isUnicodeMode && (res = matchReg(/^(?:]|})/))) {
	          return createCharacter(res);
	        } else if (match('.')) {
	          return createDot();
	        } else if (match('\\')) {
	          res = parseAtomEscape();

	          if (!res) {
	            if (!isUnicodeMode && lookahead() == 'c') {
	              return createValue('symbol', 92, pos - 1, pos);
	            }

	            bail('atomEscape');
	          }

	          return res;
	        } else if (res = parseCharacterClass()) {
	          return res;
	        } else if (features.lookbehind && (res = parseGroup('(?<=', 'lookbehind', '(?<!', 'negativeLookbehind'))) {
	          return res;
	        } else if (features.namedGroups && match("(?<")) {
	          var name = parseIdentifier();
	          skip(">");
	          var group = finishGroup("normal", name.range[0] - 3);
	          group.name = name;
	          return group;
	        } else {
	          return parseGroup('(?:', 'ignore', '(', 'normal');
	        }
	      }

	      function parseUnicodeSurrogatePairEscape(firstEscape) {
	        if (isUnicodeMode) {
	          var first, second;

	          if (firstEscape.kind == 'unicodeEscape' && (first = firstEscape.codePoint) >= 0xD800 && first <= 0xDBFF && current('\\') && next('u')) {
	            var prevPos = pos;
	            pos++;
	            var secondEscape = parseClassEscape();

	            if (secondEscape.kind == 'unicodeEscape' && (second = secondEscape.codePoint) >= 0xDC00 && second <= 0xDFFF) {
	              firstEscape.range[1] = secondEscape.range[1];
	              firstEscape.codePoint = (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
	              firstEscape.type = 'value';
	              firstEscape.kind = 'unicodeCodePointEscape';
	              addRaw(firstEscape);
	            } else {
	              pos = prevPos;
	            }
	          }
	        }

	        return firstEscape;
	      }

	      function parseClassEscape() {
	        return parseAtomEscape(true);
	      }

	      function parseAtomEscape(insideCharacterClass) {
	        var res,
	            from = pos;
	        res = parseDecimalEscape(insideCharacterClass) || parseNamedReference();

	        if (res) {
	          return res;
	        }

	        if (insideCharacterClass) {
	          if (match('b')) {
	            return createEscaped('singleEscape', 0x0008, '\\b');
	          } else if (match('B')) {
	            bail('\\B not possible inside of CharacterClass', '', from);
	          } else if (!isUnicodeMode && (res = matchReg(/^c([0-9])/))) {
	            return createEscaped('controlLetter', res[1] + 16, res[1], 2);
	          } else if (!isUnicodeMode && (res = matchReg(/^c_/))) {
	            return createEscaped('controlLetter', 31, '_', 2);
	          }

	          if (isUnicodeMode && match('-')) {
	            return createEscaped('singleEscape', 0x002d, '\\-');
	          }
	        }

	        res = parseCharacterClassEscape() || parseCharacterEscape();
	        return res;
	      }

	      function parseDecimalEscape(insideCharacterClass) {
	        var res,
	            match,
	            from = pos;

	        if (res = matchReg(/^(?!0)\d+/)) {
	          match = res[0];
	          var refIdx = parseInt(res[0], 10);

	          if (refIdx <= closedCaptureCounter && !insideCharacterClass) {
	            return createReference(res[0]);
	          } else {
	            backrefDenied.push(refIdx);

	            if (firstIteration) {
	              shouldReparse = true;
	            } else {
	              bailOctalEscapeIfUnicode(from, pos);
	            }

	            incr(-res[0].length);

	            if (res = matchReg(/^[0-7]{1,3}/)) {
	              return createEscaped('octal', parseInt(res[0], 8), res[0], 1);
	            } else {
	              res = createCharacter(matchReg(/^[89]/));
	              return updateRawStart(res, res.range[0] - 1);
	            }
	          }
	        } else if (res = matchReg(/^[0-7]{1,3}/)) {
	          match = res[0];

	          if (match !== '0') {
	            bailOctalEscapeIfUnicode(from, pos);
	          }

	          if (/^0{1,3}$/.test(match)) {
	            return createEscaped('null', 0x0000, '0', match.length);
	          } else {
	            return createEscaped('octal', parseInt(match, 8), match, 1);
	          }
	        }

	        return false;
	      }

	      function bailOctalEscapeIfUnicode(from, pos) {
	        if (isUnicodeMode) {
	          bail("Invalid decimal escape in unicode mode", null, from, pos);
	        }
	      }

	      function parseCharacterClassEscape() {
	        var res;

	        if (res = matchReg(/^[dDsSwW]/)) {
	          return createCharacterClassEscape(res[0]);
	        } else if (features.unicodePropertyEscape && isUnicodeMode && (res = matchReg(/^([pP])\{([^\}]+)\}/))) {
	          return addRaw({
	            type: 'unicodePropertyEscape',
	            negative: res[1] === 'P',
	            value: res[2],
	            range: [res.range[0] - 1, res.range[1]],
	            raw: res[0]
	          });
	        } else if (features.unicodeSet && hasUnicodeSetFlag && match('q{')) {
	          return parseClassStrings();
	        }

	        return false;
	      }

	      function parseNamedReference() {
	        if (features.namedGroups && matchReg(/^k<(?=.*?>)/)) {
	          var name = parseIdentifier();
	          skip('>');
	          return createNamedReference(name);
	        }
	      }

	      function parseRegExpUnicodeEscapeSequence() {
	        var res;

	        if (res = matchReg(/^u([0-9a-fA-F]{4})/)) {
	          return parseUnicodeSurrogatePairEscape(createEscaped('unicodeEscape', parseInt(res[1], 16), res[1], 2));
	        } else if (isUnicodeMode && (res = matchReg(/^u\{([0-9a-fA-F]+)\}/))) {
	          return createEscaped('unicodeCodePointEscape', parseInt(res[1], 16), res[1], 4);
	        }
	      }

	      function parseCharacterEscape() {
	        var res;
	        var from = pos;

	        if (res = matchReg(/^[fnrtv]/)) {
	          var codePoint = 0;

	          switch (res[0]) {
	            case 't':
	              codePoint = 0x009;
	              break;

	            case 'n':
	              codePoint = 0x00A;
	              break;

	            case 'v':
	              codePoint = 0x00B;
	              break;

	            case 'f':
	              codePoint = 0x00C;
	              break;

	            case 'r':
	              codePoint = 0x00D;
	              break;
	          }

	          return createEscaped('singleEscape', codePoint, '\\' + res[0]);
	        } else if (res = matchReg(/^c([a-zA-Z])/)) {
	          return createEscaped('controlLetter', res[1].charCodeAt(0) % 32, res[1], 2);
	        } else if (res = matchReg(/^x([0-9a-fA-F]{2})/)) {
	          return createEscaped('hexadecimalEscape', parseInt(res[1], 16), res[1], 2);
	        } else if (res = parseRegExpUnicodeEscapeSequence()) {
	          if (!res || res.codePoint > 0x10FFFF) {
	            bail('Invalid escape sequence', null, from, pos);
	          }

	          return res;
	        } else {
	          return parseIdentityEscape();
	        }
	      }

	      function parseIdentifierAtom(check) {
	        var ch = lookahead();
	        var from = pos;

	        if (ch === '\\') {
	          incr();
	          var esc = parseRegExpUnicodeEscapeSequence();

	          if (!esc || !check(esc.codePoint)) {
	            bail('Invalid escape sequence', null, from, pos);
	          }

	          return fromCodePoint(esc.codePoint);
	        }

	        var code = ch.charCodeAt(0);

	        if (code >= 0xD800 && code <= 0xDBFF) {
	          ch += str[pos + 1];
	          var second = ch.charCodeAt(1);

	          if (second >= 0xDC00 && second <= 0xDFFF) {
	            code = (code - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
	          }
	        }

	        if (!check(code)) return;
	        incr();
	        if (code > 0xFFFF) incr();
	        return ch;
	      }

	      function parseIdentifier() {
	        var start = pos;
	        var res = parseIdentifierAtom(isIdentifierStart);

	        if (!res) {
	          bail('Invalid identifier');
	        }

	        var ch;

	        while (ch = parseIdentifierAtom(isIdentifierPart)) {
	          res += ch;
	        }

	        return addRaw({
	          type: 'identifier',
	          value: res,
	          range: [start, pos]
	        });
	      }

	      function isIdentifierStart(ch) {
	        var NonAsciiIdentifierStart = /[\$A-Z_a-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEF\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7B9\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDD00-\uDD23\uDF00-\uDF1C\uDF27\uDF30-\uDF45]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD44\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF1A]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDEE0-\uDEF2]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE7F\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFF1]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]/;
	        return ch === 36 || ch === 95 || ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122 || ch >= 0x80 && NonAsciiIdentifierStart.test(fromCodePoint(ch));
	      }

	      function isIdentifierPart(ch) {
	        var NonAsciiIdentifierPartOnly = /[0-9_\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u08D3-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D82\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF2-\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DF9\u1DFB-\u1DFF\u200C\u200D\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F]|\uD800[\uDDFD\uDEE0\uDF76-\uDF7A]|\uD801[\uDCA0-\uDCA9]|\uD802[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F\uDEE5\uDEE6]|\uD803[\uDD24-\uDD27\uDD30-\uDD39\uDF46-\uDF50]|\uD804[\uDC00-\uDC02\uDC38-\uDC46\uDC66-\uDC6F\uDC7F-\uDC82\uDCB0-\uDCBA\uDCF0-\uDCF9\uDD00-\uDD02\uDD27-\uDD34\uDD36-\uDD3F\uDD45\uDD46\uDD73\uDD80-\uDD82\uDDB3-\uDDC0\uDDC9-\uDDCC\uDDD0-\uDDD9\uDE2C-\uDE37\uDE3E\uDEDF-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF3B\uDF3C\uDF3E-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF57\uDF62\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC35-\uDC46\uDC50-\uDC59\uDC5E\uDCB0-\uDCC3\uDCD0-\uDCD9\uDDAF-\uDDB5\uDDB8-\uDDC0\uDDDC\uDDDD\uDE30-\uDE40\uDE50-\uDE59\uDEAB-\uDEB7\uDEC0-\uDEC9\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDC2C-\uDC3A\uDCE0-\uDCE9\uDE01-\uDE0A\uDE33-\uDE39\uDE3B-\uDE3E\uDE47\uDE51-\uDE5B\uDE8A-\uDE99]|\uD807[\uDC2F-\uDC36\uDC38-\uDC3F\uDC50-\uDC59\uDC92-\uDCA7\uDCA9-\uDCB6\uDD31-\uDD36\uDD3A\uDD3C\uDD3D\uDD3F-\uDD45\uDD47\uDD50-\uDD59\uDD8A-\uDD8E\uDD90\uDD91\uDD93-\uDD97\uDDA0-\uDDA9\uDEF3-\uDEF6]|\uD81A[\uDE60-\uDE69\uDEF0-\uDEF4\uDF30-\uDF36\uDF50-\uDF59]|\uD81B[\uDF51-\uDF7E\uDF8F-\uDF92]|\uD82F[\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDCD0-\uDCD6\uDD44-\uDD4A\uDD50-\uDD59]|\uDB40[\uDD00-\uDDEF]/;
	        return isIdentifierStart(ch) || ch >= 48 && ch <= 57 || ch >= 0x80 && NonAsciiIdentifierPartOnly.test(fromCodePoint(ch));
	      }

	      function parseIdentityEscape() {
	        var tmp;
	        var l = lookahead();

	        if (isUnicodeMode && /[\^\$\.\*\+\?\(\)\\\[\]\{\}\|\/]/.test(l) || !isUnicodeMode && l !== "c") {
	          if (l === "k" && features.lookbehind) {
	            return null;
	          }

	          tmp = incr();
	          return createEscaped('identifier', tmp.charCodeAt(0), tmp, 1);
	        }

	        return null;
	      }

	      function parseCharacterClass() {
	        var res,
	            from = pos;

	        if (res = matchReg(/^\[\^/)) {
	          res = parseClassRanges();
	          skip(']');
	          return createCharacterClass(res, true, from, pos);
	        } else if (match('[')) {
	          res = parseClassRanges();
	          skip(']');
	          return createCharacterClass(res, false, from, pos);
	        }

	        return null;
	      }

	      function parseClassRanges() {
	        var res;

	        if (current(']')) {
	          return {
	            kind: 'union',
	            body: []
	          };
	        } else if (hasUnicodeSetFlag) {
	          return parseClassContents();
	        } else {
	          res = parseNonemptyClassRanges();

	          if (!res) {
	            bail('nonEmptyClassRanges');
	          }

	          return {
	            kind: 'union',
	            body: res
	          };
	        }
	      }

	      function parseHelperClassRanges(atom) {
	        var from, to, res, atomTo, dash;

	        if (current('-') && !next(']')) {
	          from = atom.range[0];
	          dash = createCharacter(match('-'));
	          atomTo = parseClassAtom();

	          if (!atomTo) {
	            bail('classAtom');
	          }

	          to = pos;
	          var classRanges = parseClassRanges();

	          if (!classRanges) {
	            bail('classRanges');
	          }

	          if (!('codePoint' in atom) || !('codePoint' in atomTo)) {
	            if (!isUnicodeMode) {
	              res = [atom, dash, atomTo];
	            } else {
	              bail('invalid character class');
	            }
	          } else {
	            res = [createClassRange(atom, atomTo, from, to)];
	          }

	          if (classRanges.type === 'empty') {
	            return res;
	          }

	          return res.concat(classRanges.body);
	        }

	        res = parseNonemptyClassRangesNoDash();

	        if (!res) {
	          bail('nonEmptyClassRangesNoDash');
	        }

	        return [atom].concat(res);
	      }

	      function parseNonemptyClassRanges() {
	        var atom = parseClassAtom();

	        if (!atom) {
	          bail('classAtom');
	        }

	        if (current(']')) {
	          return [atom];
	        }

	        return parseHelperClassRanges(atom);
	      }

	      function parseNonemptyClassRangesNoDash() {
	        var res = parseClassAtom();

	        if (!res) {
	          bail('classAtom');
	        }

	        if (current(']')) {
	          return res;
	        }

	        return parseHelperClassRanges(res);
	      }

	      function parseClassAtom() {
	        if (match('-')) {
	          return createCharacter('-');
	        } else {
	          return parseClassAtomNoDash();
	        }
	      }

	      function parseClassAtomNoDash() {
	        var res;

	        if (res = matchReg(/^[^\\\]-]/)) {
	          return createCharacter(res[0]);
	        } else if (match('\\')) {
	          res = parseClassEscape();

	          if (!res) {
	            bail('classEscape');
	          }

	          return parseUnicodeSurrogatePairEscape(res);
	        }
	      }

	      function parseClassContents() {
	        var body = [];
	        var kind;
	        var operand = parseClassOperand(true);
	        body.push(operand);

	        if (operand.type === 'classRange') {
	          kind = 'union';
	        } else if (current('&')) {
	          kind = 'intersection';
	        } else if (current('-')) {
	          kind = 'subtraction';
	        } else {
	          kind = 'union';
	        }

	        while (!current(']')) {
	          if (kind === 'intersection') {
	            skip('&');
	            skip('&');

	            if (current('&')) {
	              bail('&& cannot be followed by &. Wrap it in brackets: &&[&].');
	            }
	          } else if (kind === 'subtraction') {
	            skip('-');
	            skip('-');
	          }

	          operand = parseClassOperand(kind === 'union');
	          body.push(operand);
	        }

	        return {
	          kind: kind,
	          body: body
	        };
	      }

	      function parseClassOperand(allowRanges) {
	        var from = pos;
	        var start, res;

	        if (match('\\')) {
	          if (res = parseClassEscape()) {
	            start = res;
	          } else if (res = parseClassCharacterEscapedHelper()) {
	            return res;
	          } else {
	            bail('Invalid escape', '\\' + lookahead(), from);
	          }
	        } else if (res = parseClassCharacterUnescapedHelper()) {
	          start = res;
	        } else if (res = parseCharacterClass()) {
	          return res;
	        } else {
	          bail('Invalid character', lookahead());
	        }

	        if (allowRanges && current('-') && !next('-')) {
	          skip('-');

	          if (res = parseClassCharacter()) {
	            return createClassRange(start, res, from, pos);
	          }

	          bail('Invalid range end', lookahead());
	        }

	        return start;
	      }

	      function parseClassCharacter() {
	        if (match('\\')) {
	          if (res = parseClassCharacterEscapedHelper()) {
	            return res;
	          } else {
	            bail('Invalid escape', '\\' + lookahead(), from);
	          }
	        }

	        return parseClassCharacterUnescapedHelper();
	      }

	      function parseClassCharacterUnescapedHelper() {
	        var res;

	        if (res = matchReg(/^[^()[\]{}/\-\\|]/)) {
	          return createCharacter(res);
	        }
	      }

	      function parseClassCharacterEscapedHelper() {
	        if (match('b')) {
	          return createEscaped('singleEscape', 0x0008, '\\b');
	        } else if (match('B')) {
	          bail('\\B not possible inside of ClassContents', '', pos - 2);
	        } else if (res = matchReg(/^[&\-!#%,:;<=>@_`~]/)) {
	          return createEscaped('identifier', res[0].codePointAt(0), res[0]);
	        } else if (res = parseCharacterEscape()) {
	          return res;
	        } else {
	          return null;
	        }
	      }

	      function parseClassStrings() {
	        var from = pos - 3;
	        var res = [];

	        do {
	          res.push(parseClassString());
	        } while (match('|'));

	        skip('}');
	        return createClassStrings(res, from, pos);
	      }

	      function parseClassString() {
	        var res = [],
	            from = pos;
	        var char;

	        while (char = parseClassCharacter()) {
	          res.push(char);
	        }

	        return createClassString(res, from, pos);
	      }

	      function bail(message, details, from, to) {
	        from = from == null ? pos : from;
	        to = to == null ? from : to;
	        var contextStart = Math.max(0, from - 10);
	        var contextEnd = Math.min(to + 10, str.length);
	        var context = '    ' + str.substring(contextStart, contextEnd);
	        var pointer = '    ' + new Array(from - contextStart + 1).join(' ') + '^';
	        throw SyntaxError(message + ' at position ' + from + (details ? ': ' + details : '') + '\n' + context + '\n' + pointer);
	      }

	      var backrefDenied = [];
	      var closedCaptureCounter = 0;
	      var firstIteration = true;
	      var shouldReparse = false;
	      var hasUnicodeFlag = (flags || "").indexOf("u") !== -1;
	      var hasUnicodeSetFlag = (flags || "").indexOf("v") !== -1;
	      var isUnicodeMode = hasUnicodeFlag || hasUnicodeSetFlag;
	      var pos = 0;

	      if (hasUnicodeSetFlag && !features.unicodeSet) {
	        throw new Error('The "v" flag is only supported when the .unicodeSet option is enabled.');
	      }

	      if (hasUnicodeFlag && hasUnicodeSetFlag) {
	        throw new Error('The "u" and "v" flags are mutually exclusive.');
	      }

	      str = String(str);

	      if (str === '') {
	        str = '(?:)';
	      }

	      var result = parseDisjunction();

	      if (result.range[1] !== str.length) {
	        bail('Could not parse entire input - got stuck', '', result.range[1]);
	      }

	      shouldReparse = shouldReparse || backrefDenied.some(function (ref) {
	        return ref <= closedCaptureCounter;
	      });

	      if (shouldReparse) {
	        pos = 0;
	        firstIteration = false;
	        return parseDisjunction();
	      }

	      return result;
	    }

	    var regjsparser = {
	      parse: parse
	    };

	    if (module.exports) {
	      module.exports = regjsparser;
	    } else {
	      window.regjsparser = regjsparser;
	    }
	  })();
	}, "/$$rollup_base$$/node_modules/regjsparser");

	var unicodeCanonicalPropertyNamesEcmascript = new Set(['General_Category', 'Script', 'Script_Extensions', 'Alphabetic', 'Any', 'ASCII', 'ASCII_Hex_Digit', 'Assigned', 'Bidi_Control', 'Bidi_Mirrored', 'Case_Ignorable', 'Cased', 'Changes_When_Casefolded', 'Changes_When_Casemapped', 'Changes_When_Lowercased', 'Changes_When_NFKC_Casefolded', 'Changes_When_Titlecased', 'Changes_When_Uppercased', 'Dash', 'Default_Ignorable_Code_Point', 'Deprecated', 'Diacritic', 'Emoji', 'Emoji_Component', 'Emoji_Modifier', 'Emoji_Modifier_Base', 'Emoji_Presentation', 'Extended_Pictographic', 'Extender', 'Grapheme_Base', 'Grapheme_Extend', 'Hex_Digit', 'ID_Continue', 'ID_Start', 'Ideographic', 'IDS_Binary_Operator', 'IDS_Trinary_Operator', 'Join_Control', 'Logical_Order_Exception', 'Lowercase', 'Math', 'Noncharacter_Code_Point', 'Pattern_Syntax', 'Pattern_White_Space', 'Quotation_Mark', 'Radical', 'Regional_Indicator', 'Sentence_Terminal', 'Soft_Dotted', 'Terminal_Punctuation', 'Unified_Ideograph', 'Uppercase', 'Variation_Selector', 'White_Space', 'XID_Continue', 'XID_Start']);

	var unicodePropertyAliasesEcmascript = new Map([['scx', 'Script_Extensions'], ['sc', 'Script'], ['gc', 'General_Category'], ['AHex', 'ASCII_Hex_Digit'], ['Alpha', 'Alphabetic'], ['Bidi_C', 'Bidi_Control'], ['Bidi_M', 'Bidi_Mirrored'], ['Cased', 'Cased'], ['CI', 'Case_Ignorable'], ['CWCF', 'Changes_When_Casefolded'], ['CWCM', 'Changes_When_Casemapped'], ['CWKCF', 'Changes_When_NFKC_Casefolded'], ['CWL', 'Changes_When_Lowercased'], ['CWT', 'Changes_When_Titlecased'], ['CWU', 'Changes_When_Uppercased'], ['Dash', 'Dash'], ['Dep', 'Deprecated'], ['DI', 'Default_Ignorable_Code_Point'], ['Dia', 'Diacritic'], ['EBase', 'Emoji_Modifier_Base'], ['EComp', 'Emoji_Component'], ['EMod', 'Emoji_Modifier'], ['Emoji', 'Emoji'], ['EPres', 'Emoji_Presentation'], ['Ext', 'Extender'], ['ExtPict', 'Extended_Pictographic'], ['Gr_Base', 'Grapheme_Base'], ['Gr_Ext', 'Grapheme_Extend'], ['Hex', 'Hex_Digit'], ['IDC', 'ID_Continue'], ['Ideo', 'Ideographic'], ['IDS', 'ID_Start'], ['IDSB', 'IDS_Binary_Operator'], ['IDST', 'IDS_Trinary_Operator'], ['Join_C', 'Join_Control'], ['LOE', 'Logical_Order_Exception'], ['Lower', 'Lowercase'], ['Math', 'Math'], ['NChar', 'Noncharacter_Code_Point'], ['Pat_Syn', 'Pattern_Syntax'], ['Pat_WS', 'Pattern_White_Space'], ['QMark', 'Quotation_Mark'], ['Radical', 'Radical'], ['RI', 'Regional_Indicator'], ['SD', 'Soft_Dotted'], ['STerm', 'Sentence_Terminal'], ['Term', 'Terminal_Punctuation'], ['UIdeo', 'Unified_Ideograph'], ['Upper', 'Uppercase'], ['VS', 'Variation_Selector'], ['WSpace', 'White_Space'], ['space', 'White_Space'], ['XIDC', 'XID_Continue'], ['XIDS', 'XID_Start']]);

	const matchProperty = function (property) {
	  if (unicodeCanonicalPropertyNamesEcmascript.has(property)) {
	    return property;
	  }

	  if (unicodePropertyAliasesEcmascript.has(property)) {
	    return unicodePropertyAliasesEcmascript.get(property);
	  }

	  throw new Error(`Unknown property: ${property}`);
	};

	var unicodeMatchPropertyEcmascript = matchProperty;

	var mappings = new Map([['General_Category', new Map([['C', 'Other'], ['Cc', 'Control'], ['cntrl', 'Control'], ['Cf', 'Format'], ['Cn', 'Unassigned'], ['Co', 'Private_Use'], ['Cs', 'Surrogate'], ['L', 'Letter'], ['LC', 'Cased_Letter'], ['Ll', 'Lowercase_Letter'], ['Lm', 'Modifier_Letter'], ['Lo', 'Other_Letter'], ['Lt', 'Titlecase_Letter'], ['Lu', 'Uppercase_Letter'], ['M', 'Mark'], ['Combining_Mark', 'Mark'], ['Mc', 'Spacing_Mark'], ['Me', 'Enclosing_Mark'], ['Mn', 'Nonspacing_Mark'], ['N', 'Number'], ['Nd', 'Decimal_Number'], ['digit', 'Decimal_Number'], ['Nl', 'Letter_Number'], ['No', 'Other_Number'], ['P', 'Punctuation'], ['punct', 'Punctuation'], ['Pc', 'Connector_Punctuation'], ['Pd', 'Dash_Punctuation'], ['Pe', 'Close_Punctuation'], ['Pf', 'Final_Punctuation'], ['Pi', 'Initial_Punctuation'], ['Po', 'Other_Punctuation'], ['Ps', 'Open_Punctuation'], ['S', 'Symbol'], ['Sc', 'Currency_Symbol'], ['Sk', 'Modifier_Symbol'], ['Sm', 'Math_Symbol'], ['So', 'Other_Symbol'], ['Z', 'Separator'], ['Zl', 'Line_Separator'], ['Zp', 'Paragraph_Separator'], ['Zs', 'Space_Separator'], ['Other', 'Other'], ['Control', 'Control'], ['Format', 'Format'], ['Unassigned', 'Unassigned'], ['Private_Use', 'Private_Use'], ['Surrogate', 'Surrogate'], ['Letter', 'Letter'], ['Cased_Letter', 'Cased_Letter'], ['Lowercase_Letter', 'Lowercase_Letter'], ['Modifier_Letter', 'Modifier_Letter'], ['Other_Letter', 'Other_Letter'], ['Titlecase_Letter', 'Titlecase_Letter'], ['Uppercase_Letter', 'Uppercase_Letter'], ['Mark', 'Mark'], ['Spacing_Mark', 'Spacing_Mark'], ['Enclosing_Mark', 'Enclosing_Mark'], ['Nonspacing_Mark', 'Nonspacing_Mark'], ['Number', 'Number'], ['Decimal_Number', 'Decimal_Number'], ['Letter_Number', 'Letter_Number'], ['Other_Number', 'Other_Number'], ['Punctuation', 'Punctuation'], ['Connector_Punctuation', 'Connector_Punctuation'], ['Dash_Punctuation', 'Dash_Punctuation'], ['Close_Punctuation', 'Close_Punctuation'], ['Final_Punctuation', 'Final_Punctuation'], ['Initial_Punctuation', 'Initial_Punctuation'], ['Other_Punctuation', 'Other_Punctuation'], ['Open_Punctuation', 'Open_Punctuation'], ['Symbol', 'Symbol'], ['Currency_Symbol', 'Currency_Symbol'], ['Modifier_Symbol', 'Modifier_Symbol'], ['Math_Symbol', 'Math_Symbol'], ['Other_Symbol', 'Other_Symbol'], ['Separator', 'Separator'], ['Line_Separator', 'Line_Separator'], ['Paragraph_Separator', 'Paragraph_Separator'], ['Space_Separator', 'Space_Separator']])], ['Script', new Map([['Adlm', 'Adlam'], ['Aghb', 'Caucasian_Albanian'], ['Ahom', 'Ahom'], ['Arab', 'Arabic'], ['Armi', 'Imperial_Aramaic'], ['Armn', 'Armenian'], ['Avst', 'Avestan'], ['Bali', 'Balinese'], ['Bamu', 'Bamum'], ['Bass', 'Bassa_Vah'], ['Batk', 'Batak'], ['Beng', 'Bengali'], ['Bhks', 'Bhaiksuki'], ['Bopo', 'Bopomofo'], ['Brah', 'Brahmi'], ['Brai', 'Braille'], ['Bugi', 'Buginese'], ['Buhd', 'Buhid'], ['Cakm', 'Chakma'], ['Cans', 'Canadian_Aboriginal'], ['Cari', 'Carian'], ['Cham', 'Cham'], ['Cher', 'Cherokee'], ['Chrs', 'Chorasmian'], ['Copt', 'Coptic'], ['Qaac', 'Coptic'], ['Cpmn', 'Cypro_Minoan'], ['Cprt', 'Cypriot'], ['Cyrl', 'Cyrillic'], ['Deva', 'Devanagari'], ['Diak', 'Dives_Akuru'], ['Dogr', 'Dogra'], ['Dsrt', 'Deseret'], ['Dupl', 'Duployan'], ['Egyp', 'Egyptian_Hieroglyphs'], ['Elba', 'Elbasan'], ['Elym', 'Elymaic'], ['Ethi', 'Ethiopic'], ['Geor', 'Georgian'], ['Glag', 'Glagolitic'], ['Gong', 'Gunjala_Gondi'], ['Gonm', 'Masaram_Gondi'], ['Goth', 'Gothic'], ['Gran', 'Grantha'], ['Grek', 'Greek'], ['Gujr', 'Gujarati'], ['Guru', 'Gurmukhi'], ['Hang', 'Hangul'], ['Hani', 'Han'], ['Hano', 'Hanunoo'], ['Hatr', 'Hatran'], ['Hebr', 'Hebrew'], ['Hira', 'Hiragana'], ['Hluw', 'Anatolian_Hieroglyphs'], ['Hmng', 'Pahawh_Hmong'], ['Hmnp', 'Nyiakeng_Puachue_Hmong'], ['Hrkt', 'Katakana_Or_Hiragana'], ['Hung', 'Old_Hungarian'], ['Ital', 'Old_Italic'], ['Java', 'Javanese'], ['Kali', 'Kayah_Li'], ['Kana', 'Katakana'], ['Khar', 'Kharoshthi'], ['Khmr', 'Khmer'], ['Khoj', 'Khojki'], ['Kits', 'Khitan_Small_Script'], ['Knda', 'Kannada'], ['Kthi', 'Kaithi'], ['Lana', 'Tai_Tham'], ['Laoo', 'Lao'], ['Latn', 'Latin'], ['Lepc', 'Lepcha'], ['Limb', 'Limbu'], ['Lina', 'Linear_A'], ['Linb', 'Linear_B'], ['Lisu', 'Lisu'], ['Lyci', 'Lycian'], ['Lydi', 'Lydian'], ['Mahj', 'Mahajani'], ['Maka', 'Makasar'], ['Mand', 'Mandaic'], ['Mani', 'Manichaean'], ['Marc', 'Marchen'], ['Medf', 'Medefaidrin'], ['Mend', 'Mende_Kikakui'], ['Merc', 'Meroitic_Cursive'], ['Mero', 'Meroitic_Hieroglyphs'], ['Mlym', 'Malayalam'], ['Modi', 'Modi'], ['Mong', 'Mongolian'], ['Mroo', 'Mro'], ['Mtei', 'Meetei_Mayek'], ['Mult', 'Multani'], ['Mymr', 'Myanmar'], ['Nand', 'Nandinagari'], ['Narb', 'Old_North_Arabian'], ['Nbat', 'Nabataean'], ['Newa', 'Newa'], ['Nkoo', 'Nko'], ['Nshu', 'Nushu'], ['Ogam', 'Ogham'], ['Olck', 'Ol_Chiki'], ['Orkh', 'Old_Turkic'], ['Orya', 'Oriya'], ['Osge', 'Osage'], ['Osma', 'Osmanya'], ['Ougr', 'Old_Uyghur'], ['Palm', 'Palmyrene'], ['Pauc', 'Pau_Cin_Hau'], ['Perm', 'Old_Permic'], ['Phag', 'Phags_Pa'], ['Phli', 'Inscriptional_Pahlavi'], ['Phlp', 'Psalter_Pahlavi'], ['Phnx', 'Phoenician'], ['Plrd', 'Miao'], ['Prti', 'Inscriptional_Parthian'], ['Rjng', 'Rejang'], ['Rohg', 'Hanifi_Rohingya'], ['Runr', 'Runic'], ['Samr', 'Samaritan'], ['Sarb', 'Old_South_Arabian'], ['Saur', 'Saurashtra'], ['Sgnw', 'SignWriting'], ['Shaw', 'Shavian'], ['Shrd', 'Sharada'], ['Sidd', 'Siddham'], ['Sind', 'Khudawadi'], ['Sinh', 'Sinhala'], ['Sogd', 'Sogdian'], ['Sogo', 'Old_Sogdian'], ['Sora', 'Sora_Sompeng'], ['Soyo', 'Soyombo'], ['Sund', 'Sundanese'], ['Sylo', 'Syloti_Nagri'], ['Syrc', 'Syriac'], ['Tagb', 'Tagbanwa'], ['Takr', 'Takri'], ['Tale', 'Tai_Le'], ['Talu', 'New_Tai_Lue'], ['Taml', 'Tamil'], ['Tang', 'Tangut'], ['Tavt', 'Tai_Viet'], ['Telu', 'Telugu'], ['Tfng', 'Tifinagh'], ['Tglg', 'Tagalog'], ['Thaa', 'Thaana'], ['Thai', 'Thai'], ['Tibt', 'Tibetan'], ['Tirh', 'Tirhuta'], ['Tnsa', 'Tangsa'], ['Toto', 'Toto'], ['Ugar', 'Ugaritic'], ['Vaii', 'Vai'], ['Vith', 'Vithkuqi'], ['Wara', 'Warang_Citi'], ['Wcho', 'Wancho'], ['Xpeo', 'Old_Persian'], ['Xsux', 'Cuneiform'], ['Yezi', 'Yezidi'], ['Yiii', 'Yi'], ['Zanb', 'Zanabazar_Square'], ['Zinh', 'Inherited'], ['Qaai', 'Inherited'], ['Zyyy', 'Common'], ['Zzzz', 'Unknown'], ['Adlam', 'Adlam'], ['Caucasian_Albanian', 'Caucasian_Albanian'], ['Arabic', 'Arabic'], ['Imperial_Aramaic', 'Imperial_Aramaic'], ['Armenian', 'Armenian'], ['Avestan', 'Avestan'], ['Balinese', 'Balinese'], ['Bamum', 'Bamum'], ['Bassa_Vah', 'Bassa_Vah'], ['Batak', 'Batak'], ['Bengali', 'Bengali'], ['Bhaiksuki', 'Bhaiksuki'], ['Bopomofo', 'Bopomofo'], ['Brahmi', 'Brahmi'], ['Braille', 'Braille'], ['Buginese', 'Buginese'], ['Buhid', 'Buhid'], ['Chakma', 'Chakma'], ['Canadian_Aboriginal', 'Canadian_Aboriginal'], ['Carian', 'Carian'], ['Cherokee', 'Cherokee'], ['Chorasmian', 'Chorasmian'], ['Coptic', 'Coptic'], ['Cypro_Minoan', 'Cypro_Minoan'], ['Cypriot', 'Cypriot'], ['Cyrillic', 'Cyrillic'], ['Devanagari', 'Devanagari'], ['Dives_Akuru', 'Dives_Akuru'], ['Dogra', 'Dogra'], ['Deseret', 'Deseret'], ['Duployan', 'Duployan'], ['Egyptian_Hieroglyphs', 'Egyptian_Hieroglyphs'], ['Elbasan', 'Elbasan'], ['Elymaic', 'Elymaic'], ['Ethiopic', 'Ethiopic'], ['Georgian', 'Georgian'], ['Glagolitic', 'Glagolitic'], ['Gunjala_Gondi', 'Gunjala_Gondi'], ['Masaram_Gondi', 'Masaram_Gondi'], ['Gothic', 'Gothic'], ['Grantha', 'Grantha'], ['Greek', 'Greek'], ['Gujarati', 'Gujarati'], ['Gurmukhi', 'Gurmukhi'], ['Hangul', 'Hangul'], ['Han', 'Han'], ['Hanunoo', 'Hanunoo'], ['Hatran', 'Hatran'], ['Hebrew', 'Hebrew'], ['Hiragana', 'Hiragana'], ['Anatolian_Hieroglyphs', 'Anatolian_Hieroglyphs'], ['Pahawh_Hmong', 'Pahawh_Hmong'], ['Nyiakeng_Puachue_Hmong', 'Nyiakeng_Puachue_Hmong'], ['Katakana_Or_Hiragana', 'Katakana_Or_Hiragana'], ['Old_Hungarian', 'Old_Hungarian'], ['Old_Italic', 'Old_Italic'], ['Javanese', 'Javanese'], ['Kayah_Li', 'Kayah_Li'], ['Katakana', 'Katakana'], ['Kharoshthi', 'Kharoshthi'], ['Khmer', 'Khmer'], ['Khojki', 'Khojki'], ['Khitan_Small_Script', 'Khitan_Small_Script'], ['Kannada', 'Kannada'], ['Kaithi', 'Kaithi'], ['Tai_Tham', 'Tai_Tham'], ['Lao', 'Lao'], ['Latin', 'Latin'], ['Lepcha', 'Lepcha'], ['Limbu', 'Limbu'], ['Linear_A', 'Linear_A'], ['Linear_B', 'Linear_B'], ['Lycian', 'Lycian'], ['Lydian', 'Lydian'], ['Mahajani', 'Mahajani'], ['Makasar', 'Makasar'], ['Mandaic', 'Mandaic'], ['Manichaean', 'Manichaean'], ['Marchen', 'Marchen'], ['Medefaidrin', 'Medefaidrin'], ['Mende_Kikakui', 'Mende_Kikakui'], ['Meroitic_Cursive', 'Meroitic_Cursive'], ['Meroitic_Hieroglyphs', 'Meroitic_Hieroglyphs'], ['Malayalam', 'Malayalam'], ['Mongolian', 'Mongolian'], ['Mro', 'Mro'], ['Meetei_Mayek', 'Meetei_Mayek'], ['Multani', 'Multani'], ['Myanmar', 'Myanmar'], ['Nandinagari', 'Nandinagari'], ['Old_North_Arabian', 'Old_North_Arabian'], ['Nabataean', 'Nabataean'], ['Nko', 'Nko'], ['Nushu', 'Nushu'], ['Ogham', 'Ogham'], ['Ol_Chiki', 'Ol_Chiki'], ['Old_Turkic', 'Old_Turkic'], ['Oriya', 'Oriya'], ['Osage', 'Osage'], ['Osmanya', 'Osmanya'], ['Old_Uyghur', 'Old_Uyghur'], ['Palmyrene', 'Palmyrene'], ['Pau_Cin_Hau', 'Pau_Cin_Hau'], ['Old_Permic', 'Old_Permic'], ['Phags_Pa', 'Phags_Pa'], ['Inscriptional_Pahlavi', 'Inscriptional_Pahlavi'], ['Psalter_Pahlavi', 'Psalter_Pahlavi'], ['Phoenician', 'Phoenician'], ['Miao', 'Miao'], ['Inscriptional_Parthian', 'Inscriptional_Parthian'], ['Rejang', 'Rejang'], ['Hanifi_Rohingya', 'Hanifi_Rohingya'], ['Runic', 'Runic'], ['Samaritan', 'Samaritan'], ['Old_South_Arabian', 'Old_South_Arabian'], ['Saurashtra', 'Saurashtra'], ['SignWriting', 'SignWriting'], ['Shavian', 'Shavian'], ['Sharada', 'Sharada'], ['Siddham', 'Siddham'], ['Khudawadi', 'Khudawadi'], ['Sinhala', 'Sinhala'], ['Sogdian', 'Sogdian'], ['Old_Sogdian', 'Old_Sogdian'], ['Sora_Sompeng', 'Sora_Sompeng'], ['Soyombo', 'Soyombo'], ['Sundanese', 'Sundanese'], ['Syloti_Nagri', 'Syloti_Nagri'], ['Syriac', 'Syriac'], ['Tagbanwa', 'Tagbanwa'], ['Takri', 'Takri'], ['Tai_Le', 'Tai_Le'], ['New_Tai_Lue', 'New_Tai_Lue'], ['Tamil', 'Tamil'], ['Tangut', 'Tangut'], ['Tai_Viet', 'Tai_Viet'], ['Telugu', 'Telugu'], ['Tifinagh', 'Tifinagh'], ['Tagalog', 'Tagalog'], ['Thaana', 'Thaana'], ['Tibetan', 'Tibetan'], ['Tirhuta', 'Tirhuta'], ['Tangsa', 'Tangsa'], ['Ugaritic', 'Ugaritic'], ['Vai', 'Vai'], ['Vithkuqi', 'Vithkuqi'], ['Warang_Citi', 'Warang_Citi'], ['Wancho', 'Wancho'], ['Old_Persian', 'Old_Persian'], ['Cuneiform', 'Cuneiform'], ['Yezidi', 'Yezidi'], ['Yi', 'Yi'], ['Zanabazar_Square', 'Zanabazar_Square'], ['Inherited', 'Inherited'], ['Common', 'Common'], ['Unknown', 'Unknown']])], ['Script_Extensions', new Map([['Adlm', 'Adlam'], ['Aghb', 'Caucasian_Albanian'], ['Ahom', 'Ahom'], ['Arab', 'Arabic'], ['Armi', 'Imperial_Aramaic'], ['Armn', 'Armenian'], ['Avst', 'Avestan'], ['Bali', 'Balinese'], ['Bamu', 'Bamum'], ['Bass', 'Bassa_Vah'], ['Batk', 'Batak'], ['Beng', 'Bengali'], ['Bhks', 'Bhaiksuki'], ['Bopo', 'Bopomofo'], ['Brah', 'Brahmi'], ['Brai', 'Braille'], ['Bugi', 'Buginese'], ['Buhd', 'Buhid'], ['Cakm', 'Chakma'], ['Cans', 'Canadian_Aboriginal'], ['Cari', 'Carian'], ['Cham', 'Cham'], ['Cher', 'Cherokee'], ['Chrs', 'Chorasmian'], ['Copt', 'Coptic'], ['Qaac', 'Coptic'], ['Cpmn', 'Cypro_Minoan'], ['Cprt', 'Cypriot'], ['Cyrl', 'Cyrillic'], ['Deva', 'Devanagari'], ['Diak', 'Dives_Akuru'], ['Dogr', 'Dogra'], ['Dsrt', 'Deseret'], ['Dupl', 'Duployan'], ['Egyp', 'Egyptian_Hieroglyphs'], ['Elba', 'Elbasan'], ['Elym', 'Elymaic'], ['Ethi', 'Ethiopic'], ['Geor', 'Georgian'], ['Glag', 'Glagolitic'], ['Gong', 'Gunjala_Gondi'], ['Gonm', 'Masaram_Gondi'], ['Goth', 'Gothic'], ['Gran', 'Grantha'], ['Grek', 'Greek'], ['Gujr', 'Gujarati'], ['Guru', 'Gurmukhi'], ['Hang', 'Hangul'], ['Hani', 'Han'], ['Hano', 'Hanunoo'], ['Hatr', 'Hatran'], ['Hebr', 'Hebrew'], ['Hira', 'Hiragana'], ['Hluw', 'Anatolian_Hieroglyphs'], ['Hmng', 'Pahawh_Hmong'], ['Hmnp', 'Nyiakeng_Puachue_Hmong'], ['Hrkt', 'Katakana_Or_Hiragana'], ['Hung', 'Old_Hungarian'], ['Ital', 'Old_Italic'], ['Java', 'Javanese'], ['Kali', 'Kayah_Li'], ['Kana', 'Katakana'], ['Khar', 'Kharoshthi'], ['Khmr', 'Khmer'], ['Khoj', 'Khojki'], ['Kits', 'Khitan_Small_Script'], ['Knda', 'Kannada'], ['Kthi', 'Kaithi'], ['Lana', 'Tai_Tham'], ['Laoo', 'Lao'], ['Latn', 'Latin'], ['Lepc', 'Lepcha'], ['Limb', 'Limbu'], ['Lina', 'Linear_A'], ['Linb', 'Linear_B'], ['Lisu', 'Lisu'], ['Lyci', 'Lycian'], ['Lydi', 'Lydian'], ['Mahj', 'Mahajani'], ['Maka', 'Makasar'], ['Mand', 'Mandaic'], ['Mani', 'Manichaean'], ['Marc', 'Marchen'], ['Medf', 'Medefaidrin'], ['Mend', 'Mende_Kikakui'], ['Merc', 'Meroitic_Cursive'], ['Mero', 'Meroitic_Hieroglyphs'], ['Mlym', 'Malayalam'], ['Modi', 'Modi'], ['Mong', 'Mongolian'], ['Mroo', 'Mro'], ['Mtei', 'Meetei_Mayek'], ['Mult', 'Multani'], ['Mymr', 'Myanmar'], ['Nand', 'Nandinagari'], ['Narb', 'Old_North_Arabian'], ['Nbat', 'Nabataean'], ['Newa', 'Newa'], ['Nkoo', 'Nko'], ['Nshu', 'Nushu'], ['Ogam', 'Ogham'], ['Olck', 'Ol_Chiki'], ['Orkh', 'Old_Turkic'], ['Orya', 'Oriya'], ['Osge', 'Osage'], ['Osma', 'Osmanya'], ['Ougr', 'Old_Uyghur'], ['Palm', 'Palmyrene'], ['Pauc', 'Pau_Cin_Hau'], ['Perm', 'Old_Permic'], ['Phag', 'Phags_Pa'], ['Phli', 'Inscriptional_Pahlavi'], ['Phlp', 'Psalter_Pahlavi'], ['Phnx', 'Phoenician'], ['Plrd', 'Miao'], ['Prti', 'Inscriptional_Parthian'], ['Rjng', 'Rejang'], ['Rohg', 'Hanifi_Rohingya'], ['Runr', 'Runic'], ['Samr', 'Samaritan'], ['Sarb', 'Old_South_Arabian'], ['Saur', 'Saurashtra'], ['Sgnw', 'SignWriting'], ['Shaw', 'Shavian'], ['Shrd', 'Sharada'], ['Sidd', 'Siddham'], ['Sind', 'Khudawadi'], ['Sinh', 'Sinhala'], ['Sogd', 'Sogdian'], ['Sogo', 'Old_Sogdian'], ['Sora', 'Sora_Sompeng'], ['Soyo', 'Soyombo'], ['Sund', 'Sundanese'], ['Sylo', 'Syloti_Nagri'], ['Syrc', 'Syriac'], ['Tagb', 'Tagbanwa'], ['Takr', 'Takri'], ['Tale', 'Tai_Le'], ['Talu', 'New_Tai_Lue'], ['Taml', 'Tamil'], ['Tang', 'Tangut'], ['Tavt', 'Tai_Viet'], ['Telu', 'Telugu'], ['Tfng', 'Tifinagh'], ['Tglg', 'Tagalog'], ['Thaa', 'Thaana'], ['Thai', 'Thai'], ['Tibt', 'Tibetan'], ['Tirh', 'Tirhuta'], ['Tnsa', 'Tangsa'], ['Toto', 'Toto'], ['Ugar', 'Ugaritic'], ['Vaii', 'Vai'], ['Vith', 'Vithkuqi'], ['Wara', 'Warang_Citi'], ['Wcho', 'Wancho'], ['Xpeo', 'Old_Persian'], ['Xsux', 'Cuneiform'], ['Yezi', 'Yezidi'], ['Yiii', 'Yi'], ['Zanb', 'Zanabazar_Square'], ['Zinh', 'Inherited'], ['Qaai', 'Inherited'], ['Zyyy', 'Common'], ['Zzzz', 'Unknown'], ['Adlam', 'Adlam'], ['Caucasian_Albanian', 'Caucasian_Albanian'], ['Arabic', 'Arabic'], ['Imperial_Aramaic', 'Imperial_Aramaic'], ['Armenian', 'Armenian'], ['Avestan', 'Avestan'], ['Balinese', 'Balinese'], ['Bamum', 'Bamum'], ['Bassa_Vah', 'Bassa_Vah'], ['Batak', 'Batak'], ['Bengali', 'Bengali'], ['Bhaiksuki', 'Bhaiksuki'], ['Bopomofo', 'Bopomofo'], ['Brahmi', 'Brahmi'], ['Braille', 'Braille'], ['Buginese', 'Buginese'], ['Buhid', 'Buhid'], ['Chakma', 'Chakma'], ['Canadian_Aboriginal', 'Canadian_Aboriginal'], ['Carian', 'Carian'], ['Cherokee', 'Cherokee'], ['Chorasmian', 'Chorasmian'], ['Coptic', 'Coptic'], ['Cypro_Minoan', 'Cypro_Minoan'], ['Cypriot', 'Cypriot'], ['Cyrillic', 'Cyrillic'], ['Devanagari', 'Devanagari'], ['Dives_Akuru', 'Dives_Akuru'], ['Dogra', 'Dogra'], ['Deseret', 'Deseret'], ['Duployan', 'Duployan'], ['Egyptian_Hieroglyphs', 'Egyptian_Hieroglyphs'], ['Elbasan', 'Elbasan'], ['Elymaic', 'Elymaic'], ['Ethiopic', 'Ethiopic'], ['Georgian', 'Georgian'], ['Glagolitic', 'Glagolitic'], ['Gunjala_Gondi', 'Gunjala_Gondi'], ['Masaram_Gondi', 'Masaram_Gondi'], ['Gothic', 'Gothic'], ['Grantha', 'Grantha'], ['Greek', 'Greek'], ['Gujarati', 'Gujarati'], ['Gurmukhi', 'Gurmukhi'], ['Hangul', 'Hangul'], ['Han', 'Han'], ['Hanunoo', 'Hanunoo'], ['Hatran', 'Hatran'], ['Hebrew', 'Hebrew'], ['Hiragana', 'Hiragana'], ['Anatolian_Hieroglyphs', 'Anatolian_Hieroglyphs'], ['Pahawh_Hmong', 'Pahawh_Hmong'], ['Nyiakeng_Puachue_Hmong', 'Nyiakeng_Puachue_Hmong'], ['Katakana_Or_Hiragana', 'Katakana_Or_Hiragana'], ['Old_Hungarian', 'Old_Hungarian'], ['Old_Italic', 'Old_Italic'], ['Javanese', 'Javanese'], ['Kayah_Li', 'Kayah_Li'], ['Katakana', 'Katakana'], ['Kharoshthi', 'Kharoshthi'], ['Khmer', 'Khmer'], ['Khojki', 'Khojki'], ['Khitan_Small_Script', 'Khitan_Small_Script'], ['Kannada', 'Kannada'], ['Kaithi', 'Kaithi'], ['Tai_Tham', 'Tai_Tham'], ['Lao', 'Lao'], ['Latin', 'Latin'], ['Lepcha', 'Lepcha'], ['Limbu', 'Limbu'], ['Linear_A', 'Linear_A'], ['Linear_B', 'Linear_B'], ['Lycian', 'Lycian'], ['Lydian', 'Lydian'], ['Mahajani', 'Mahajani'], ['Makasar', 'Makasar'], ['Mandaic', 'Mandaic'], ['Manichaean', 'Manichaean'], ['Marchen', 'Marchen'], ['Medefaidrin', 'Medefaidrin'], ['Mende_Kikakui', 'Mende_Kikakui'], ['Meroitic_Cursive', 'Meroitic_Cursive'], ['Meroitic_Hieroglyphs', 'Meroitic_Hieroglyphs'], ['Malayalam', 'Malayalam'], ['Mongolian', 'Mongolian'], ['Mro', 'Mro'], ['Meetei_Mayek', 'Meetei_Mayek'], ['Multani', 'Multani'], ['Myanmar', 'Myanmar'], ['Nandinagari', 'Nandinagari'], ['Old_North_Arabian', 'Old_North_Arabian'], ['Nabataean', 'Nabataean'], ['Nko', 'Nko'], ['Nushu', 'Nushu'], ['Ogham', 'Ogham'], ['Ol_Chiki', 'Ol_Chiki'], ['Old_Turkic', 'Old_Turkic'], ['Oriya', 'Oriya'], ['Osage', 'Osage'], ['Osmanya', 'Osmanya'], ['Old_Uyghur', 'Old_Uyghur'], ['Palmyrene', 'Palmyrene'], ['Pau_Cin_Hau', 'Pau_Cin_Hau'], ['Old_Permic', 'Old_Permic'], ['Phags_Pa', 'Phags_Pa'], ['Inscriptional_Pahlavi', 'Inscriptional_Pahlavi'], ['Psalter_Pahlavi', 'Psalter_Pahlavi'], ['Phoenician', 'Phoenician'], ['Miao', 'Miao'], ['Inscriptional_Parthian', 'Inscriptional_Parthian'], ['Rejang', 'Rejang'], ['Hanifi_Rohingya', 'Hanifi_Rohingya'], ['Runic', 'Runic'], ['Samaritan', 'Samaritan'], ['Old_South_Arabian', 'Old_South_Arabian'], ['Saurashtra', 'Saurashtra'], ['SignWriting', 'SignWriting'], ['Shavian', 'Shavian'], ['Sharada', 'Sharada'], ['Siddham', 'Siddham'], ['Khudawadi', 'Khudawadi'], ['Sinhala', 'Sinhala'], ['Sogdian', 'Sogdian'], ['Old_Sogdian', 'Old_Sogdian'], ['Sora_Sompeng', 'Sora_Sompeng'], ['Soyombo', 'Soyombo'], ['Sundanese', 'Sundanese'], ['Syloti_Nagri', 'Syloti_Nagri'], ['Syriac', 'Syriac'], ['Tagbanwa', 'Tagbanwa'], ['Takri', 'Takri'], ['Tai_Le', 'Tai_Le'], ['New_Tai_Lue', 'New_Tai_Lue'], ['Tamil', 'Tamil'], ['Tangut', 'Tangut'], ['Tai_Viet', 'Tai_Viet'], ['Telugu', 'Telugu'], ['Tifinagh', 'Tifinagh'], ['Tagalog', 'Tagalog'], ['Thaana', 'Thaana'], ['Tibetan', 'Tibetan'], ['Tirhuta', 'Tirhuta'], ['Tangsa', 'Tangsa'], ['Ugaritic', 'Ugaritic'], ['Vai', 'Vai'], ['Vithkuqi', 'Vithkuqi'], ['Warang_Citi', 'Warang_Citi'], ['Wancho', 'Wancho'], ['Old_Persian', 'Old_Persian'], ['Cuneiform', 'Cuneiform'], ['Yezidi', 'Yezidi'], ['Yi', 'Yi'], ['Zanabazar_Square', 'Zanabazar_Square'], ['Inherited', 'Inherited'], ['Common', 'Common'], ['Unknown', 'Unknown']])]]);

	const matchPropertyValue = function (property, value) {
	  const aliasToValue = mappings.get(property);

	  if (!aliasToValue) {
	    throw new Error(`Unknown property \`${property}\`.`);
	  }

	  const canonicalValue = aliasToValue.get(value);

	  if (canonicalValue) {
	    return canonicalValue;
	  }

	  throw new Error(`Unknown value \`${value}\` for property \`${property}\`.`);
	};

	var unicodeMatchPropertyValueEcmascript = matchPropertyValue;

	var iuMappings = new Map([[0x4B, 0x212A], [0x53, 0x17F], [0x6B, 0x212A], [0x73, 0x17F], [0xB5, 0x39C], [0xC5, 0x212B], [0xDF, 0x1E9E], [0xE5, 0x212B], [0x17F, 0x53], [0x1C4, 0x1C5], [0x1C5, 0x1C4], [0x1C7, 0x1C8], [0x1C8, 0x1C7], [0x1CA, 0x1CB], [0x1CB, 0x1CA], [0x1F1, 0x1F2], [0x1F2, 0x1F1], [0x345, 0x1FBE], [0x392, 0x3D0], [0x395, 0x3F5], [0x398, 0x3F4], [0x399, 0x1FBE], [0x39A, 0x3F0], [0x39C, 0xB5], [0x3A0, 0x3D6], [0x3A1, 0x3F1], [0x3A3, 0x3C2], [0x3A6, 0x3D5], [0x3A9, 0x2126], [0x3B8, 0x3F4], [0x3C2, 0x3A3], [0x3C9, 0x2126], [0x3D0, 0x392], [0x3D1, 0x3F4], [0x3D5, 0x3A6], [0x3D6, 0x3A0], [0x3F0, 0x39A], [0x3F1, 0x3A1], [0x3F4, [0x398, 0x3D1, 0x3B8]], [0x3F5, 0x395], [0x412, 0x1C80], [0x414, 0x1C81], [0x41E, 0x1C82], [0x421, 0x1C83], [0x422, 0x1C85], [0x42A, 0x1C86], [0x462, 0x1C87], [0x1C80, 0x412], [0x1C81, 0x414], [0x1C82, 0x41E], [0x1C83, 0x421], [0x1C84, 0x1C85], [0x1C85, [0x422, 0x1C84]], [0x1C86, 0x42A], [0x1C87, 0x462], [0x1C88, 0xA64A], [0x1E60, 0x1E9B], [0x1E9B, 0x1E60], [0x1E9E, 0xDF], [0x1F80, 0x1F88], [0x1F81, 0x1F89], [0x1F82, 0x1F8A], [0x1F83, 0x1F8B], [0x1F84, 0x1F8C], [0x1F85, 0x1F8D], [0x1F86, 0x1F8E], [0x1F87, 0x1F8F], [0x1F88, 0x1F80], [0x1F89, 0x1F81], [0x1F8A, 0x1F82], [0x1F8B, 0x1F83], [0x1F8C, 0x1F84], [0x1F8D, 0x1F85], [0x1F8E, 0x1F86], [0x1F8F, 0x1F87], [0x1F90, 0x1F98], [0x1F91, 0x1F99], [0x1F92, 0x1F9A], [0x1F93, 0x1F9B], [0x1F94, 0x1F9C], [0x1F95, 0x1F9D], [0x1F96, 0x1F9E], [0x1F97, 0x1F9F], [0x1F98, 0x1F90], [0x1F99, 0x1F91], [0x1F9A, 0x1F92], [0x1F9B, 0x1F93], [0x1F9C, 0x1F94], [0x1F9D, 0x1F95], [0x1F9E, 0x1F96], [0x1F9F, 0x1F97], [0x1FA0, 0x1FA8], [0x1FA1, 0x1FA9], [0x1FA2, 0x1FAA], [0x1FA3, 0x1FAB], [0x1FA4, 0x1FAC], [0x1FA5, 0x1FAD], [0x1FA6, 0x1FAE], [0x1FA7, 0x1FAF], [0x1FA8, 0x1FA0], [0x1FA9, 0x1FA1], [0x1FAA, 0x1FA2], [0x1FAB, 0x1FA3], [0x1FAC, 0x1FA4], [0x1FAD, 0x1FA5], [0x1FAE, 0x1FA6], [0x1FAF, 0x1FA7], [0x1FB3, 0x1FBC], [0x1FBC, 0x1FB3], [0x1FBE, [0x345, 0x399]], [0x1FC3, 0x1FCC], [0x1FCC, 0x1FC3], [0x1FF3, 0x1FFC], [0x1FFC, 0x1FF3], [0x2126, [0x3A9, 0x3C9]], [0x212A, 0x4B], [0x212B, [0xC5, 0xE5]], [0x2C2F, 0x2C5F], [0x2C5F, 0x2C2F], [0xA64A, 0x1C88], [0xA7C0, 0xA7C1], [0xA7C1, 0xA7C0], [0xA7D0, 0xA7D1], [0xA7D1, 0xA7D0], [0xA7D6, 0xA7D7], [0xA7D7, 0xA7D6], [0xA7D8, 0xA7D9], [0xA7D9, 0xA7D8], [0x10400, 0x10428], [0x10401, 0x10429], [0x10402, 0x1042A], [0x10403, 0x1042B], [0x10404, 0x1042C], [0x10405, 0x1042D], [0x10406, 0x1042E], [0x10407, 0x1042F], [0x10408, 0x10430], [0x10409, 0x10431], [0x1040A, 0x10432], [0x1040B, 0x10433], [0x1040C, 0x10434], [0x1040D, 0x10435], [0x1040E, 0x10436], [0x1040F, 0x10437], [0x10410, 0x10438], [0x10411, 0x10439], [0x10412, 0x1043A], [0x10413, 0x1043B], [0x10414, 0x1043C], [0x10415, 0x1043D], [0x10416, 0x1043E], [0x10417, 0x1043F], [0x10418, 0x10440], [0x10419, 0x10441], [0x1041A, 0x10442], [0x1041B, 0x10443], [0x1041C, 0x10444], [0x1041D, 0x10445], [0x1041E, 0x10446], [0x1041F, 0x10447], [0x10420, 0x10448], [0x10421, 0x10449], [0x10422, 0x1044A], [0x10423, 0x1044B], [0x10424, 0x1044C], [0x10425, 0x1044D], [0x10426, 0x1044E], [0x10427, 0x1044F], [0x10428, 0x10400], [0x10429, 0x10401], [0x1042A, 0x10402], [0x1042B, 0x10403], [0x1042C, 0x10404], [0x1042D, 0x10405], [0x1042E, 0x10406], [0x1042F, 0x10407], [0x10430, 0x10408], [0x10431, 0x10409], [0x10432, 0x1040A], [0x10433, 0x1040B], [0x10434, 0x1040C], [0x10435, 0x1040D], [0x10436, 0x1040E], [0x10437, 0x1040F], [0x10438, 0x10410], [0x10439, 0x10411], [0x1043A, 0x10412], [0x1043B, 0x10413], [0x1043C, 0x10414], [0x1043D, 0x10415], [0x1043E, 0x10416], [0x1043F, 0x10417], [0x10440, 0x10418], [0x10441, 0x10419], [0x10442, 0x1041A], [0x10443, 0x1041B], [0x10444, 0x1041C], [0x10445, 0x1041D], [0x10446, 0x1041E], [0x10447, 0x1041F], [0x10448, 0x10420], [0x10449, 0x10421], [0x1044A, 0x10422], [0x1044B, 0x10423], [0x1044C, 0x10424], [0x1044D, 0x10425], [0x1044E, 0x10426], [0x1044F, 0x10427], [0x104B0, 0x104D8], [0x104B1, 0x104D9], [0x104B2, 0x104DA], [0x104B3, 0x104DB], [0x104B4, 0x104DC], [0x104B5, 0x104DD], [0x104B6, 0x104DE], [0x104B7, 0x104DF], [0x104B8, 0x104E0], [0x104B9, 0x104E1], [0x104BA, 0x104E2], [0x104BB, 0x104E3], [0x104BC, 0x104E4], [0x104BD, 0x104E5], [0x104BE, 0x104E6], [0x104BF, 0x104E7], [0x104C0, 0x104E8], [0x104C1, 0x104E9], [0x104C2, 0x104EA], [0x104C3, 0x104EB], [0x104C4, 0x104EC], [0x104C5, 0x104ED], [0x104C6, 0x104EE], [0x104C7, 0x104EF], [0x104C8, 0x104F0], [0x104C9, 0x104F1], [0x104CA, 0x104F2], [0x104CB, 0x104F3], [0x104CC, 0x104F4], [0x104CD, 0x104F5], [0x104CE, 0x104F6], [0x104CF, 0x104F7], [0x104D0, 0x104F8], [0x104D1, 0x104F9], [0x104D2, 0x104FA], [0x104D3, 0x104FB], [0x104D8, 0x104B0], [0x104D9, 0x104B1], [0x104DA, 0x104B2], [0x104DB, 0x104B3], [0x104DC, 0x104B4], [0x104DD, 0x104B5], [0x104DE, 0x104B6], [0x104DF, 0x104B7], [0x104E0, 0x104B8], [0x104E1, 0x104B9], [0x104E2, 0x104BA], [0x104E3, 0x104BB], [0x104E4, 0x104BC], [0x104E5, 0x104BD], [0x104E6, 0x104BE], [0x104E7, 0x104BF], [0x104E8, 0x104C0], [0x104E9, 0x104C1], [0x104EA, 0x104C2], [0x104EB, 0x104C3], [0x104EC, 0x104C4], [0x104ED, 0x104C5], [0x104EE, 0x104C6], [0x104EF, 0x104C7], [0x104F0, 0x104C8], [0x104F1, 0x104C9], [0x104F2, 0x104CA], [0x104F3, 0x104CB], [0x104F4, 0x104CC], [0x104F5, 0x104CD], [0x104F6, 0x104CE], [0x104F7, 0x104CF], [0x104F8, 0x104D0], [0x104F9, 0x104D1], [0x104FA, 0x104D2], [0x104FB, 0x104D3], [0x10570, 0x10597], [0x10571, 0x10598], [0x10572, 0x10599], [0x10573, 0x1059A], [0x10574, 0x1059B], [0x10575, 0x1059C], [0x10576, 0x1059D], [0x10577, 0x1059E], [0x10578, 0x1059F], [0x10579, 0x105A0], [0x1057A, 0x105A1], [0x1057C, 0x105A3], [0x1057D, 0x105A4], [0x1057E, 0x105A5], [0x1057F, 0x105A6], [0x10580, 0x105A7], [0x10581, 0x105A8], [0x10582, 0x105A9], [0x10583, 0x105AA], [0x10584, 0x105AB], [0x10585, 0x105AC], [0x10586, 0x105AD], [0x10587, 0x105AE], [0x10588, 0x105AF], [0x10589, 0x105B0], [0x1058A, 0x105B1], [0x1058C, 0x105B3], [0x1058D, 0x105B4], [0x1058E, 0x105B5], [0x1058F, 0x105B6], [0x10590, 0x105B7], [0x10591, 0x105B8], [0x10592, 0x105B9], [0x10594, 0x105BB], [0x10595, 0x105BC], [0x10597, 0x10570], [0x10598, 0x10571], [0x10599, 0x10572], [0x1059A, 0x10573], [0x1059B, 0x10574], [0x1059C, 0x10575], [0x1059D, 0x10576], [0x1059E, 0x10577], [0x1059F, 0x10578], [0x105A0, 0x10579], [0x105A1, 0x1057A], [0x105A3, 0x1057C], [0x105A4, 0x1057D], [0x105A5, 0x1057E], [0x105A6, 0x1057F], [0x105A7, 0x10580], [0x105A8, 0x10581], [0x105A9, 0x10582], [0x105AA, 0x10583], [0x105AB, 0x10584], [0x105AC, 0x10585], [0x105AD, 0x10586], [0x105AE, 0x10587], [0x105AF, 0x10588], [0x105B0, 0x10589], [0x105B1, 0x1058A], [0x105B3, 0x1058C], [0x105B4, 0x1058D], [0x105B5, 0x1058E], [0x105B6, 0x1058F], [0x105B7, 0x10590], [0x105B8, 0x10591], [0x105B9, 0x10592], [0x105BB, 0x10594], [0x105BC, 0x10595], [0x10C80, 0x10CC0], [0x10C81, 0x10CC1], [0x10C82, 0x10CC2], [0x10C83, 0x10CC3], [0x10C84, 0x10CC4], [0x10C85, 0x10CC5], [0x10C86, 0x10CC6], [0x10C87, 0x10CC7], [0x10C88, 0x10CC8], [0x10C89, 0x10CC9], [0x10C8A, 0x10CCA], [0x10C8B, 0x10CCB], [0x10C8C, 0x10CCC], [0x10C8D, 0x10CCD], [0x10C8E, 0x10CCE], [0x10C8F, 0x10CCF], [0x10C90, 0x10CD0], [0x10C91, 0x10CD1], [0x10C92, 0x10CD2], [0x10C93, 0x10CD3], [0x10C94, 0x10CD4], [0x10C95, 0x10CD5], [0x10C96, 0x10CD6], [0x10C97, 0x10CD7], [0x10C98, 0x10CD8], [0x10C99, 0x10CD9], [0x10C9A, 0x10CDA], [0x10C9B, 0x10CDB], [0x10C9C, 0x10CDC], [0x10C9D, 0x10CDD], [0x10C9E, 0x10CDE], [0x10C9F, 0x10CDF], [0x10CA0, 0x10CE0], [0x10CA1, 0x10CE1], [0x10CA2, 0x10CE2], [0x10CA3, 0x10CE3], [0x10CA4, 0x10CE4], [0x10CA5, 0x10CE5], [0x10CA6, 0x10CE6], [0x10CA7, 0x10CE7], [0x10CA8, 0x10CE8], [0x10CA9, 0x10CE9], [0x10CAA, 0x10CEA], [0x10CAB, 0x10CEB], [0x10CAC, 0x10CEC], [0x10CAD, 0x10CED], [0x10CAE, 0x10CEE], [0x10CAF, 0x10CEF], [0x10CB0, 0x10CF0], [0x10CB1, 0x10CF1], [0x10CB2, 0x10CF2], [0x10CC0, 0x10C80], [0x10CC1, 0x10C81], [0x10CC2, 0x10C82], [0x10CC3, 0x10C83], [0x10CC4, 0x10C84], [0x10CC5, 0x10C85], [0x10CC6, 0x10C86], [0x10CC7, 0x10C87], [0x10CC8, 0x10C88], [0x10CC9, 0x10C89], [0x10CCA, 0x10C8A], [0x10CCB, 0x10C8B], [0x10CCC, 0x10C8C], [0x10CCD, 0x10C8D], [0x10CCE, 0x10C8E], [0x10CCF, 0x10C8F], [0x10CD0, 0x10C90], [0x10CD1, 0x10C91], [0x10CD2, 0x10C92], [0x10CD3, 0x10C93], [0x10CD4, 0x10C94], [0x10CD5, 0x10C95], [0x10CD6, 0x10C96], [0x10CD7, 0x10C97], [0x10CD8, 0x10C98], [0x10CD9, 0x10C99], [0x10CDA, 0x10C9A], [0x10CDB, 0x10C9B], [0x10CDC, 0x10C9C], [0x10CDD, 0x10C9D], [0x10CDE, 0x10C9E], [0x10CDF, 0x10C9F], [0x10CE0, 0x10CA0], [0x10CE1, 0x10CA1], [0x10CE2, 0x10CA2], [0x10CE3, 0x10CA3], [0x10CE4, 0x10CA4], [0x10CE5, 0x10CA5], [0x10CE6, 0x10CA6], [0x10CE7, 0x10CA7], [0x10CE8, 0x10CA8], [0x10CE9, 0x10CA9], [0x10CEA, 0x10CAA], [0x10CEB, 0x10CAB], [0x10CEC, 0x10CAC], [0x10CED, 0x10CAD], [0x10CEE, 0x10CAE], [0x10CEF, 0x10CAF], [0x10CF0, 0x10CB0], [0x10CF1, 0x10CB1], [0x10CF2, 0x10CB2], [0x118A0, 0x118C0], [0x118A1, 0x118C1], [0x118A2, 0x118C2], [0x118A3, 0x118C3], [0x118A4, 0x118C4], [0x118A5, 0x118C5], [0x118A6, 0x118C6], [0x118A7, 0x118C7], [0x118A8, 0x118C8], [0x118A9, 0x118C9], [0x118AA, 0x118CA], [0x118AB, 0x118CB], [0x118AC, 0x118CC], [0x118AD, 0x118CD], [0x118AE, 0x118CE], [0x118AF, 0x118CF], [0x118B0, 0x118D0], [0x118B1, 0x118D1], [0x118B2, 0x118D2], [0x118B3, 0x118D3], [0x118B4, 0x118D4], [0x118B5, 0x118D5], [0x118B6, 0x118D6], [0x118B7, 0x118D7], [0x118B8, 0x118D8], [0x118B9, 0x118D9], [0x118BA, 0x118DA], [0x118BB, 0x118DB], [0x118BC, 0x118DC], [0x118BD, 0x118DD], [0x118BE, 0x118DE], [0x118BF, 0x118DF], [0x118C0, 0x118A0], [0x118C1, 0x118A1], [0x118C2, 0x118A2], [0x118C3, 0x118A3], [0x118C4, 0x118A4], [0x118C5, 0x118A5], [0x118C6, 0x118A6], [0x118C7, 0x118A7], [0x118C8, 0x118A8], [0x118C9, 0x118A9], [0x118CA, 0x118AA], [0x118CB, 0x118AB], [0x118CC, 0x118AC], [0x118CD, 0x118AD], [0x118CE, 0x118AE], [0x118CF, 0x118AF], [0x118D0, 0x118B0], [0x118D1, 0x118B1], [0x118D2, 0x118B2], [0x118D3, 0x118B3], [0x118D4, 0x118B4], [0x118D5, 0x118B5], [0x118D6, 0x118B6], [0x118D7, 0x118B7], [0x118D8, 0x118B8], [0x118D9, 0x118B9], [0x118DA, 0x118BA], [0x118DB, 0x118BB], [0x118DC, 0x118BC], [0x118DD, 0x118BD], [0x118DE, 0x118BE], [0x118DF, 0x118BF], [0x16E40, 0x16E60], [0x16E41, 0x16E61], [0x16E42, 0x16E62], [0x16E43, 0x16E63], [0x16E44, 0x16E64], [0x16E45, 0x16E65], [0x16E46, 0x16E66], [0x16E47, 0x16E67], [0x16E48, 0x16E68], [0x16E49, 0x16E69], [0x16E4A, 0x16E6A], [0x16E4B, 0x16E6B], [0x16E4C, 0x16E6C], [0x16E4D, 0x16E6D], [0x16E4E, 0x16E6E], [0x16E4F, 0x16E6F], [0x16E50, 0x16E70], [0x16E51, 0x16E71], [0x16E52, 0x16E72], [0x16E53, 0x16E73], [0x16E54, 0x16E74], [0x16E55, 0x16E75], [0x16E56, 0x16E76], [0x16E57, 0x16E77], [0x16E58, 0x16E78], [0x16E59, 0x16E79], [0x16E5A, 0x16E7A], [0x16E5B, 0x16E7B], [0x16E5C, 0x16E7C], [0x16E5D, 0x16E7D], [0x16E5E, 0x16E7E], [0x16E5F, 0x16E7F], [0x16E60, 0x16E40], [0x16E61, 0x16E41], [0x16E62, 0x16E42], [0x16E63, 0x16E43], [0x16E64, 0x16E44], [0x16E65, 0x16E45], [0x16E66, 0x16E46], [0x16E67, 0x16E47], [0x16E68, 0x16E48], [0x16E69, 0x16E49], [0x16E6A, 0x16E4A], [0x16E6B, 0x16E4B], [0x16E6C, 0x16E4C], [0x16E6D, 0x16E4D], [0x16E6E, 0x16E4E], [0x16E6F, 0x16E4F], [0x16E70, 0x16E50], [0x16E71, 0x16E51], [0x16E72, 0x16E52], [0x16E73, 0x16E53], [0x16E74, 0x16E54], [0x16E75, 0x16E55], [0x16E76, 0x16E56], [0x16E77, 0x16E57], [0x16E78, 0x16E58], [0x16E79, 0x16E59], [0x16E7A, 0x16E5A], [0x16E7B, 0x16E5B], [0x16E7C, 0x16E5C], [0x16E7D, 0x16E5D], [0x16E7E, 0x16E5E], [0x16E7F, 0x16E5F], [0x1E900, 0x1E922], [0x1E901, 0x1E923], [0x1E902, 0x1E924], [0x1E903, 0x1E925], [0x1E904, 0x1E926], [0x1E905, 0x1E927], [0x1E906, 0x1E928], [0x1E907, 0x1E929], [0x1E908, 0x1E92A], [0x1E909, 0x1E92B], [0x1E90A, 0x1E92C], [0x1E90B, 0x1E92D], [0x1E90C, 0x1E92E], [0x1E90D, 0x1E92F], [0x1E90E, 0x1E930], [0x1E90F, 0x1E931], [0x1E910, 0x1E932], [0x1E911, 0x1E933], [0x1E912, 0x1E934], [0x1E913, 0x1E935], [0x1E914, 0x1E936], [0x1E915, 0x1E937], [0x1E916, 0x1E938], [0x1E917, 0x1E939], [0x1E918, 0x1E93A], [0x1E919, 0x1E93B], [0x1E91A, 0x1E93C], [0x1E91B, 0x1E93D], [0x1E91C, 0x1E93E], [0x1E91D, 0x1E93F], [0x1E91E, 0x1E940], [0x1E91F, 0x1E941], [0x1E920, 0x1E942], [0x1E921, 0x1E943], [0x1E922, 0x1E900], [0x1E923, 0x1E901], [0x1E924, 0x1E902], [0x1E925, 0x1E903], [0x1E926, 0x1E904], [0x1E927, 0x1E905], [0x1E928, 0x1E906], [0x1E929, 0x1E907], [0x1E92A, 0x1E908], [0x1E92B, 0x1E909], [0x1E92C, 0x1E90A], [0x1E92D, 0x1E90B], [0x1E92E, 0x1E90C], [0x1E92F, 0x1E90D], [0x1E930, 0x1E90E], [0x1E931, 0x1E90F], [0x1E932, 0x1E910], [0x1E933, 0x1E911], [0x1E934, 0x1E912], [0x1E935, 0x1E913], [0x1E936, 0x1E914], [0x1E937, 0x1E915], [0x1E938, 0x1E916], [0x1E939, 0x1E917], [0x1E93A, 0x1E918], [0x1E93B, 0x1E919], [0x1E93C, 0x1E91A], [0x1E93D, 0x1E91B], [0x1E93E, 0x1E91C], [0x1E93F, 0x1E91D], [0x1E940, 0x1E91E], [0x1E941, 0x1E91F], [0x1E942, 0x1E920], [0x1E943, 0x1E921]]);

	var REGULAR = new Map([['d', regenerate().addRange(0x30, 0x39)], ['D', regenerate().addRange(0x0, 0x2F).addRange(0x3A, 0xFFFF)], ['s', regenerate(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000, 0xFEFF).addRange(0x9, 0xD).addRange(0x2000, 0x200A).addRange(0x2028, 0x2029)], ['S', regenerate().addRange(0x0, 0x8).addRange(0xE, 0x1F).addRange(0x21, 0x9F).addRange(0xA1, 0x167F).addRange(0x1681, 0x1FFF).addRange(0x200B, 0x2027).addRange(0x202A, 0x202E).addRange(0x2030, 0x205E).addRange(0x2060, 0x2FFF).addRange(0x3001, 0xFEFE).addRange(0xFF00, 0xFFFF)], ['w', regenerate(0x5F).addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A)], ['W', regenerate(0x60).addRange(0x0, 0x2F).addRange(0x3A, 0x40).addRange(0x5B, 0x5E).addRange(0x7B, 0xFFFF)]]);
	var UNICODE = new Map([['d', regenerate().addRange(0x30, 0x39)], ['D', regenerate().addRange(0x0, 0x2F).addRange(0x3A, 0x10FFFF)], ['s', regenerate(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000, 0xFEFF).addRange(0x9, 0xD).addRange(0x2000, 0x200A).addRange(0x2028, 0x2029)], ['S', regenerate().addRange(0x0, 0x8).addRange(0xE, 0x1F).addRange(0x21, 0x9F).addRange(0xA1, 0x167F).addRange(0x1681, 0x1FFF).addRange(0x200B, 0x2027).addRange(0x202A, 0x202E).addRange(0x2030, 0x205E).addRange(0x2060, 0x2FFF).addRange(0x3001, 0xFEFE).addRange(0xFF00, 0x10FFFF)], ['w', regenerate(0x5F).addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A)], ['W', regenerate(0x60).addRange(0x0, 0x2F).addRange(0x3A, 0x40).addRange(0x5B, 0x5E).addRange(0x7B, 0x10FFFF)]]);
	var UNICODE_IGNORE_CASE = new Map([['d', regenerate().addRange(0x30, 0x39)], ['D', regenerate().addRange(0x0, 0x2F).addRange(0x3A, 0x10FFFF)], ['s', regenerate(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000, 0xFEFF).addRange(0x9, 0xD).addRange(0x2000, 0x200A).addRange(0x2028, 0x2029)], ['S', regenerate().addRange(0x0, 0x8).addRange(0xE, 0x1F).addRange(0x21, 0x9F).addRange(0xA1, 0x167F).addRange(0x1681, 0x1FFF).addRange(0x200B, 0x2027).addRange(0x202A, 0x202E).addRange(0x2030, 0x205E).addRange(0x2060, 0x2FFF).addRange(0x3001, 0xFEFE).addRange(0xFF00, 0x10FFFF)], ['w', regenerate(0x5F, 0x17F, 0x212A).addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A)], ['W', regenerate(0x60).addRange(0x0, 0x2F).addRange(0x3A, 0x40).addRange(0x5B, 0x5E).addRange(0x7B, 0x17E).addRange(0x180, 0x2129).addRange(0x212B, 0x10FFFF)]]);
	var characterClassEscapeSets = {
	  REGULAR: REGULAR,
	  UNICODE: UNICODE,
	  UNICODE_IGNORE_CASE: UNICODE_IGNORE_CASE
	};

	const generate = regjsgen.generate;
	const parse = parser.parse;
	const UNICODE_SET = regenerate().addRange(0x0, 0x10FFFF);
	const DOT_SET_UNICODE = UNICODE_SET.clone().remove(0x000A, 0x000D, 0x2028, 0x2029);

	const getCharacterClassEscapeSet = (character, unicode, ignoreCase) => {
	  if (unicode) {
	    if (ignoreCase) {
	      return characterClassEscapeSets.UNICODE_IGNORE_CASE.get(character);
	    }

	    return characterClassEscapeSets.UNICODE.get(character);
	  }

	  return characterClassEscapeSets.REGULAR.get(character);
	};

	const getUnicodeDotSet = dotAll => {
	  return dotAll ? UNICODE_SET : DOT_SET_UNICODE;
	};

	const getUnicodePropertyValueSet = (property, value) => {
	  const path = value ? `${property}/${value}` : `Binary_Property/${property}`;

	  try {
	    return commonjsRequire(`regenerate-unicode-properties/${path}.js`, "/$$rollup_base$$/node_modules/regexpu-core");
	  } catch (exception) {
	    throw new Error(`Failed to recognize value \`${value}\` for property ` + `\`${property}\`.`);
	  }
	};

	const handleLoneUnicodePropertyNameOrValue = value => {
	  try {
	    const property = 'General_Category';
	    const category = unicodeMatchPropertyValueEcmascript(property, value);
	    return getUnicodePropertyValueSet(property, category);
	  } catch (exception) {}

	  try {
	    return getUnicodePropertyValueSet('Property_of_Strings', value);
	  } catch (exception) {}

	  const property = unicodeMatchPropertyEcmascript(value);
	  return getUnicodePropertyValueSet(property);
	};

	const getUnicodePropertyEscapeSet = (value, isNegative) => {
	  const parts = value.split('=');
	  const firstPart = parts[0];
	  let set;

	  if (parts.length == 1) {
	    set = handleLoneUnicodePropertyNameOrValue(firstPart);
	  } else {
	    const property = unicodeMatchPropertyEcmascript(firstPart);
	    const value = unicodeMatchPropertyValueEcmascript(property, parts[1]);
	    set = getUnicodePropertyValueSet(property, value);
	  }

	  if (isNegative) {
	    if (set.strings) {
	      throw new Error('Cannot negate Unicode property of strings');
	    }

	    return {
	      characters: UNICODE_SET.clone().remove(set.characters),
	      strings: new Set()
	    };
	  }

	  return {
	    characters: set.characters.clone(),
	    strings: new Set(set.strings || [])
	  };
	};

	const getUnicodePropertyEscapeCharacterClassData = (property, isNegative) => {
	  const set = getUnicodePropertyEscapeSet(property, isNegative);
	  const data = getCharacterClassEmptyData();
	  data.singleChars = set.characters;

	  if (set.strings.size > 0) {
	    data.longStrings = set.strings;
	    data.maybeIncludesStrings = true;
	  }

	  return data;
	};

	regenerate.prototype.iuAddRange = function (min, max) {
	  const $this = this;

	  do {
	    const folded = caseFold(min);

	    if (folded) {
	      $this.add(folded);
	    }
	  } while (++min <= max);

	  return $this;
	};

	regenerate.prototype.iuRemoveRange = function (min, max) {
	  const $this = this;

	  do {
	    const folded = caseFold(min);

	    if (folded) {
	      $this.remove(folded);
	    }
	  } while (++min <= max);

	  return $this;
	};

	const update = (item, pattern) => {
	  let tree = parse(pattern, config.useUnicodeFlag ? 'u' : '');

	  switch (tree.type) {
	    case 'characterClass':
	    case 'group':
	    case 'value':
	      break;

	    default:
	      tree = wrap(tree, pattern);
	  }

	  Object.assign(item, tree);
	};

	const wrap = (tree, pattern) => {
	  return {
	    'type': 'group',
	    'behavior': 'ignore',
	    'body': [tree],
	    'raw': `(?:${pattern})`
	  };
	};

	const caseFold = codePoint => {
	  return iuMappings.get(codePoint) || false;
	};

	const buildHandler = action => {
	  switch (action) {
	    case 'union':
	      return {
	        single: (data, cp) => {
	          data.singleChars.add(cp);
	        },
	        regSet: (data, set2) => {
	          data.singleChars.add(set2);
	        },
	        range: (data, start, end) => {
	          data.singleChars.addRange(start, end);
	        },
	        iuRange: (data, start, end) => {
	          data.singleChars.iuAddRange(start, end);
	        },
	        nested: (data, nestedData) => {
	          data.singleChars.add(nestedData.singleChars);

	          for (const str of nestedData.longStrings) data.longStrings.add(str);

	          if (nestedData.maybeIncludesStrings) data.maybeIncludesStrings = true;
	        }
	      };

	    case 'union-negative':
	      {
	        const regSet = (data, set2) => {
	          data.singleChars = UNICODE_SET.clone().remove(set2).add(data.singleChars);
	        };

	        return {
	          single: (data, cp) => {
	            const unicode = UNICODE_SET.clone();
	            data.singleChars = data.singleChars.contains(cp) ? unicode : unicode.remove(cp);
	          },
	          regSet: regSet,
	          range: (data, start, end) => {
	            data.singleChars = UNICODE_SET.clone().removeRange(start, end).add(data.singleChars);
	          },
	          iuRange: (data, start, end) => {
	            data.singleChars = UNICODE_SET.clone().iuRemoveRange(start, end).add(data.singleChars);
	          },
	          nested: (data, nestedData) => {
	            regSet(data, nestedData.singleChars);
	            if (nestedData.maybeIncludesStrings) throw new Error('ASSERTION ERROR');
	          }
	        };
	      }

	    case 'intersection':
	      {
	        const regSet = (data, set2) => {
	          if (data.first) data.singleChars = set2;else data.singleChars.intersection(set2);
	        };

	        return {
	          single: (data, cp) => {
	            data.singleChars = data.first || data.singleChars.contains(cp) ? regenerate(cp) : regenerate();
	            data.longStrings.clear();
	            data.maybeIncludesStrings = false;
	          },
	          regSet: (data, set) => {
	            regSet(data, set);
	            data.longStrings.clear();
	            data.maybeIncludesStrings = false;
	          },
	          range: (data, start, end) => {
	            if (data.first) data.singleChars.addRange(start, end);else data.singleChars.intersection(regenerate().addRange(start, end));
	            data.longStrings.clear();
	            data.maybeIncludesStrings = false;
	          },
	          iuRange: (data, start, end) => {
	            if (data.first) data.singleChars.iuAddRange(start, end);else data.singleChars.intersection(regenerate().iuAddRange(start, end));
	            data.longStrings.clear();
	            data.maybeIncludesStrings = false;
	          },
	          nested: (data, nestedData) => {
	            regSet(data, nestedData.singleChars);

	            if (data.first) {
	              data.longStrings = nestedData.longStrings;
	              data.maybeIncludesStrings = nestedData.maybeIncludesStrings;
	            } else {
	              for (const str of data.longStrings) {
	                if (!nestedData.longStrings.has(str)) data.longStrings.delete(str);
	              }

	              if (!nestedData.maybeIncludesStrings) data.maybeIncludesStrings = false;
	            }
	          }
	        };
	      }

	    case 'subtraction':
	      {
	        const regSet = (data, set2) => {
	          if (data.first) data.singleChars.add(set2);else data.singleChars.remove(set2);
	        };

	        return {
	          single: (data, cp) => {
	            if (data.first) data.singleChars.add(cp);else data.singleChars.remove(cp);
	          },
	          regSet: regSet,
	          range: (data, start, end) => {
	            if (data.first) data.singleChars.addRange(start, end);else data.singleChars.removeRange(start, end);
	          },
	          iuRange: (data, start, end) => {
	            if (data.first) data.singleChars.iuAddRange(start, end);else data.singleChars.iuRemoveRange(start, end);
	          },
	          nested: (data, nestedData) => {
	            regSet(data, nestedData.singleChars);

	            if (data.first) {
	              data.longStrings = nestedData.longStrings;
	              data.maybeIncludesStrings = nestedData.maybeIncludesStrings;
	            } else {
	              for (const str of data.longStrings) {
	                if (nestedData.longStrings.has(str)) data.longStrings.delete(str);
	              }
	            }
	          }
	        };
	      }

	    default:
	      throw new Error(`Unknown set action: ${characterClassItem.kind}`);
	  }
	};

	const getCharacterClassEmptyData = () => ({
	  transformed: config.transform.unicodeFlag,
	  singleChars: regenerate(),
	  longStrings: new Set(),
	  hasEmptyString: false,
	  first: true,
	  maybeIncludesStrings: false
	});

	const maybeFold = codePoint => {
	  if (config.flags.ignoreCase && config.transform.unicodeFlag) {
	    const folded = caseFold(codePoint);

	    if (folded) {
	      return [codePoint, folded];
	    }
	  }

	  return [codePoint];
	};

	const computeClassStrings = (classStrings, regenerateOptions) => {
	  let data = getCharacterClassEmptyData();

	  for (const string of classStrings.strings) {
	    if (string.characters.length === 1) {
	      maybeFold(string.characters[0].codePoint).forEach(cp => {
	        data.singleChars.add(cp);
	      });
	    } else {
	      let stringifiedString;

	      if (config.flags.ignoreCase && config.transform.unicodeFlag) {
	        stringifiedString = '';

	        for (const ch of string.characters) {
	          let set = regenerate(ch.codePoint);
	          const folded = caseFold(ch.codePoint);
	          if (folded) set.add(folded);
	          stringifiedString += set.toString(regenerateOptions);
	        }
	      } else {
	        stringifiedString = string.characters.map(ch => generate(ch)).join('');
	      }

	      data.longStrings.add(stringifiedString);
	      data.maybeIncludesStrings = true;
	    }
	  }

	  return data;
	};

	const computeCharacterClass = (characterClassItem, regenerateOptions) => {
	  let data = getCharacterClassEmptyData();
	  let handlePositive;
	  let handleNegative;

	  switch (characterClassItem.kind) {
	    case 'union':
	      handlePositive = buildHandler('union');
	      handleNegative = buildHandler('union-negative');
	      break;

	    case 'intersection':
	      handlePositive = buildHandler('intersection');
	      handleNegative = buildHandler('subtraction');
	      break;

	    case 'subtraction':
	      handlePositive = buildHandler('subtraction');
	      handleNegative = buildHandler('intersection');
	      break;

	    default:
	      throw new Error(`Unknown character class kind: ${characterClassItem.kind}`);
	  }

	  for (const item of characterClassItem.body) {
	    switch (item.type) {
	      case 'value':
	        maybeFold(item.codePoint).forEach(cp => {
	          handlePositive.single(data, cp);
	        });
	        break;

	      case 'characterClassRange':
	        const min = item.min.codePoint;
	        const max = item.max.codePoint;
	        handlePositive.range(data, min, max);

	        if (config.flags.ignoreCase && config.transform.unicodeFlag) {
	          handlePositive.iuRange(data, min, max);
	        }

	        break;

	      case 'characterClassEscape':
	        handlePositive.regSet(data, getCharacterClassEscapeSet(item.value, config.flags.unicode, config.flags.ignoreCase));
	        break;

	      case 'unicodePropertyEscape':
	        const nestedData = getUnicodePropertyEscapeCharacterClassData(item.value, item.negative);
	        handlePositive.nested(data, nestedData);
	        data.transformed = data.transformed || config.transform.unicodePropertyEscapes || config.transform.unicodeSetsFlag && nestedData.maybeIncludesStrings;
	        break;

	      case 'characterClass':
	        const handler = item.negative ? handleNegative : handlePositive;
	        const res = computeCharacterClass(item, regenerateOptions);
	        handler.nested(data, res);
	        data.transformed = true;
	        break;

	      case 'classStrings':
	        handlePositive.nested(data, computeClassStrings(item, regenerateOptions));
	        data.transformed = true;
	        break;

	      default:
	        throw new Error(`Unknown term type: ${item.type}`);
	    }

	    data.first = false;
	  }

	  if (characterClassItem.negative && data.maybeIncludesStrings) {
	    throw new SyntaxError('Cannot negate set containing strings');
	  }

	  return data;
	};

	const processCharacterClass = (characterClassItem, regenerateOptions, computed = computeCharacterClass(characterClassItem, regenerateOptions)) => {
	  const negative = characterClassItem.negative;
	  const {
	    singleChars,
	    transformed,
	    longStrings
	  } = computed;

	  if (transformed) {
	    const setStr = singleChars.toString(regenerateOptions);

	    if (negative) {
	      if (config.useUnicodeFlag) {
	        update(characterClassItem, `[^${setStr[0] === '[' ? setStr.slice(1, -1) : setStr}]`);
	      } else {
	        update(characterClassItem, `(?!${setStr})[\\s\\S]`);
	      }
	    } else {
	      const hasEmptyString = longStrings.has('');
	      const pieces = Array.from(longStrings).sort((a, b) => b.length - a.length);

	      if (setStr !== '[]' || longStrings.size === 0) {
	        pieces.splice(pieces.length - (hasEmptyString ? 1 : 0), 0, setStr);
	      }

	      update(characterClassItem, pieces.join('|'));
	    }
	  }

	  return characterClassItem;
	};

	const updateNamedReference = (item, index) => {
	  delete item.name;
	  item.matchIndex = index;
	};

	const assertNoUnmatchedReferences = groups => {
	  const unmatchedReferencesNames = Object.keys(groups.unmatchedReferences);

	  if (unmatchedReferencesNames.length > 0) {
	    throw new Error(`Unknown group names: ${unmatchedReferencesNames}`);
	  }
	};

	const processTerm = (item, regenerateOptions, groups) => {
	  switch (item.type) {
	    case 'dot':
	      if (config.transform.unicodeFlag) {
	        update(item, getUnicodeDotSet(config.flags.dotAll).toString(regenerateOptions));
	      } else if (config.transform.dotAllFlag) {
	        update(item, '[\\s\\S]');
	      }

	      break;

	    case 'characterClass':
	      item = processCharacterClass(item, regenerateOptions);
	      break;

	    case 'unicodePropertyEscape':
	      const data = getUnicodePropertyEscapeCharacterClassData(item.value, item.negative);

	      if (data.maybeIncludesStrings) {
	        if (!config.flags.unicodeSets) {
	          throw new Error('Properties of strings are only supported when using the unicodeSets (v) flag.');
	        }

	        if (config.transform.unicodeSetsFlag) {
	          data.transformed = true;
	          item = processCharacterClass(item, regenerateOptions, data);
	        }
	      } else if (config.transform.unicodePropertyEscapes) {
	        update(item, data.singleChars.toString(regenerateOptions));
	      }

	      break;

	    case 'characterClassEscape':
	      if (config.transform.unicodeFlag) {
	        update(item, getCharacterClassEscapeSet(item.value, true, config.flags.ignoreCase).toString(regenerateOptions));
	      }

	      break;

	    case 'group':
	      if (item.behavior == 'normal') {
	        groups.lastIndex++;
	      }

	      if (item.name && config.transform.namedGroups) {
	        const name = item.name.value;

	        if (groups.names[name]) {
	          throw new Error(`Multiple groups with the same name (${name}) are not allowed.`);
	        }

	        const index = groups.lastIndex;
	        delete item.name;
	        groups.names[name] = index;

	        if (groups.onNamedGroup) {
	          groups.onNamedGroup.call(null, name, index);
	        }

	        if (groups.unmatchedReferences[name]) {
	          groups.unmatchedReferences[name].forEach(reference => {
	            updateNamedReference(reference, index);
	          });
	          delete groups.unmatchedReferences[name];
	        }
	      }

	    case 'alternative':
	    case 'disjunction':
	    case 'quantifier':
	      item.body = item.body.map(term => {
	        return processTerm(term, regenerateOptions, groups);
	      });
	      break;

	    case 'value':
	      const codePoint = item.codePoint;
	      const set = regenerate(codePoint);

	      if (config.flags.ignoreCase && config.transform.unicodeFlag) {
	        const folded = caseFold(codePoint);

	        if (folded) {
	          set.add(folded);
	        }
	      }

	      update(item, set.toString(regenerateOptions));
	      break;

	    case 'reference':
	      if (item.name) {
	        const name = item.name.value;
	        const index = groups.names[name];

	        if (index) {
	          updateNamedReference(item, index);
	          break;
	        }

	        if (!groups.unmatchedReferences[name]) {
	          groups.unmatchedReferences[name] = [];
	        }

	        groups.unmatchedReferences[name].push(item);
	      }

	      break;

	    case 'anchor':
	    case 'empty':
	    case 'group':
	      break;

	    default:
	      throw new Error(`Unknown term type: ${item.type}`);
	  }

	  return item;
	};

	const config = {
	  'flags': {
	    'ignoreCase': false,
	    'unicode': false,
	    'unicodeSets': false,
	    'dotAll': false
	  },
	  'transform': {
	    'dotAllFlag': false,
	    'unicodeFlag': false,
	    'unicodeSetsFlag': false,
	    'unicodePropertyEscapes': false,
	    'namedGroups': false
	  },

	  get useUnicodeFlag() {
	    return (this.flags.unicode || this.flags.unicodeSets) && !this.transform.unicodeFlag;
	  }

	};

	const validateOptions = options => {
	  if (!options) return;

	  for (const key of Object.keys(options)) {
	    const value = options[key];

	    switch (key) {
	      case 'dotAllFlag':
	      case 'unicodeFlag':
	      case 'unicodePropertyEscapes':
	      case 'namedGroups':
	        if (value != null && value !== false && value !== 'transform') {
	          throw new Error(`.${key} must be false (default) or 'transform'.`);
	        }

	        break;

	      case 'unicodeSetsFlag':
	        if (value != null && value !== false && value !== 'parse' && value !== 'transform') {
	          throw new Error(`.${key} must be false (default), 'parse' or 'transform'.`);
	        }

	        break;

	      case 'onNamedGroup':
	        if (value != null && typeof value !== 'function') {
	          throw new Error('.onNamedGroup must be a function.');
	        }

	        break;

	      default:
	        throw new Error(`.${key} is not a valid regexpu-core option.`);
	    }
	  }
	};

	const hasFlag = (flags, flag) => flags ? flags.includes(flag) : false;

	const transform$1 = (options, name) => options ? options[name] === 'transform' : false;

	const rewritePattern = (pattern, flags, options) => {
	  validateOptions(options);
	  config.flags.unicode = hasFlag(flags, 'u');
	  config.flags.unicodeSets = hasFlag(flags, 'v');
	  config.flags.ignoreCase = hasFlag(flags, 'i');
	  config.flags.dotAll = hasFlag(flags, 's');
	  config.transform.dotAllFlag = config.flags.dotAll && transform$1(options, 'dotAllFlag');
	  config.transform.unicodeFlag = (config.flags.unicode || config.flags.unicodeSets) && transform$1(options, 'unicodeFlag');
	  config.transform.unicodeSetsFlag = config.flags.unicodeSets && transform$1(options, 'unicodeSetsFlag');
	  config.transform.unicodePropertyEscapes = config.flags.unicode && (transform$1(options, 'unicodeFlag') || transform$1(options, 'unicodePropertyEscapes'));
	  config.transform.namedGroups = transform$1(options, 'namedGroups');
	  const regjsparserFeatures = {
	    'unicodeSet': Boolean(options && options.unicodeSetsFlag),
	    'unicodePropertyEscape': true,
	    'namedGroups': true,
	    'lookbehind': true
	  };
	  const regenerateOptions = {
	    'hasUnicodeFlag': config.useUnicodeFlag,
	    'bmpOnly': !config.flags.unicode
	  };
	  const groups = {
	    'onNamedGroup': options && options.onNamedGroup,
	    'lastIndex': 0,
	    'names': Object.create(null),
	    'unmatchedReferences': Object.create(null)
	  };
	  const tree = parse(pattern, flags, regjsparserFeatures);
	  processTerm(tree, regenerateOptions, groups);
	  assertNoUnmatchedReferences(groups);
	  return generate(tree);
	};

	var rewritePattern_1 = rewritePattern;

	const FEATURES = Object.freeze({
	  unicodeFlag: 1 << 0,
	  dotAllFlag: 1 << 1,
	  unicodePropertyEscape: 1 << 2,
	  namedCaptureGroups: 1 << 3,
	  unicodeSetsFlag_syntax: 1 << 4,
	  unicodeSetsFlag: 1 << 5
	});
	const featuresKey = "@babel/plugin-regexp-features/featuresKey";
	const runtimeKey = "@babel/plugin-regexp-features/runtimeKey";
	function enableFeature(features, feature) {
	  return features | feature;
	}
	function hasFeature(features, feature) {
	  return !!(features & feature);
	}

	function generateRegexpuOptions(toTransform) {
	  const feat = (name, ok = "transform") => {
	    return hasFeature(toTransform, FEATURES[name]) ? ok : false;
	  };

	  return {
	    unicodeFlag: feat("unicodeFlag"),
	    unicodeSetsFlag: feat("unicodeSetsFlag") || feat("unicodeSetsFlag_syntax", "parse"),
	    dotAllFlag: feat("dotAllFlag"),
	    unicodePropertyEscapes: feat("unicodePropertyEscape"),
	    namedGroups: feat("namedCaptureGroups"),
	    onNamedGroup: () => {}
	  };
	}
	function canSkipRegexpu(node, options) {
	  const {
	    flags,
	    pattern
	  } = node;

	  if (flags.includes("v")) {
	    if (options.unicodeSetsFlag === "transform") return false;
	  }

	  if (flags.includes("u")) {
	    if (options.unicodeFlag === "transform") return false;

	    if (options.unicodePropertyEscapes === "transform" && /\\[pP]{/.test(pattern)) {
	      return false;
	    }
	  }

	  if (flags.includes("s")) {
	    if (options.dotAllFlag === "transform") return false;
	  }

	  if (options.namedGroups === "transform" && /\(\?<(?![=!])/.test(pattern)) {
	    return false;
	  }

	  return true;
	}
	function transformFlags(regexpuOptions, flags) {
	  if (regexpuOptions.unicodeSetsFlag === "transform") {
	    flags = flags.replace("v", "u");
	  }

	  if (regexpuOptions.unicodeFlag === "transform") {
	    flags = flags.replace("u", "");
	  }

	  if (regexpuOptions.dotAllFlag === "transform") {
	    flags = flags.replace("s", "");
	  }

	  return flags;
	}

	const version$1 = "7.17.0".split(".").reduce((v, x) => v * 1e5 + +x, 0);
	const versionKey = "@babel/plugin-regexp-features/version";
	function createRegExpFeaturePlugin({
	  name,
	  feature,
	  options = {},
	  manipulateOptions = () => {}
	}) {
	  return {
	    name,
	    manipulateOptions,

	    pre() {
	      const {
	        file
	      } = this;
	      const features = file.get(featuresKey) ?? 0;
	      let newFeatures = enableFeature(features, FEATURES[feature]);
	      const {
	        useUnicodeFlag,
	        runtime = true
	      } = options;

	      if (useUnicodeFlag === false) {
	        newFeatures = enableFeature(newFeatures, FEATURES.unicodeFlag);
	      }

	      if (newFeatures !== features) {
	        file.set(featuresKey, newFeatures);
	      }

	      if (!runtime) {
	        file.set(runtimeKey, false);
	      }

	      if (!file.has(versionKey) || file.get(versionKey) < version$1) {
	        file.set(versionKey, version$1);
	      }
	    },

	    visitor: {
	      RegExpLiteral(path) {
	        const {
	          node
	        } = path;
	        const {
	          file
	        } = this;
	        const features = file.get(featuresKey);
	        const runtime = file.get(runtimeKey) ?? true;
	        const regexpuOptions = generateRegexpuOptions(features);
	        if (canSkipRegexpu(node, regexpuOptions)) return;
	        const namedCaptureGroups = {};

	        if (regexpuOptions.namedGroups === "transform") {
	          regexpuOptions.onNamedGroup = (name, index) => {
	            namedCaptureGroups[name] = index;
	          };
	        }

	        node.pattern = rewritePattern_1(node.pattern, node.flags, regexpuOptions);

	        if (regexpuOptions.namedGroups === "transform" && Object.keys(namedCaptureGroups).length > 0 && runtime && !isRegExpTest(path)) {
	          const call = callExpression$8(this.addHelper("wrapRegExp"), [node, valueToNode(namedCaptureGroups)]);
	          annotateAsPure(call);
	          path.replaceWith(call);
	        }

	        node.flags = transformFlags(regexpuOptions, node.flags);
	      }

	    }
	  };
	}

	function isRegExpTest(path) {
	  return path.parentPath.isMemberExpression({
	    object: path.node,
	    computed: false
	  }) && path.parentPath.get("property").isIdentifier({
	    name: "test"
	  });
	}

	var proposalUnicodePropertyRegex = declare((api, options) => {
	  api.assertVersion(7);
	  const {
	    useUnicodeFlag = true
	  } = options;

	  if (typeof useUnicodeFlag !== "boolean") {
	    throw new Error(".useUnicodeFlag must be a boolean, or undefined");
	  }

	  return createRegExpFeaturePlugin({
	    name: "proposal-unicode-property-regex",
	    feature: "unicodePropertyEscape",
	    options: {
	      useUnicodeFlag
	    }
	  });
	});

	const all = {
	  "syntax-async-generators": lib$e,
	  "syntax-class-properties": lib$d,
	  "syntax-class-static-block": lib$c,
	  "syntax-decimal": syntaxDecimal,
	  "syntax-decorators": syntaxDecorators,
	  "syntax-destructuring-private": syntaxDestructuringPrivate,
	  "syntax-do-expressions": syntaxDoExpressions,
	  "syntax-export-default-from": syntaxExportDefaultFrom,
	  "syntax-function-bind": syntaxFunctionBind,
	  "syntax-function-sent": syntaxFunctionSent,
	  "syntax-module-blocks": syntaxModuleBlocks,
	  "syntax-import-meta": lib$b,
	  "syntax-import-assertions": syntaxImportAssertions,
	  "syntax-object-rest-spread": lib$a,
	  "syntax-optional-catch-binding": lib$9,
	  "syntax-pipeline-operator": syntaxPipelineOperator,
	  "syntax-record-and-tuple": syntaxRecordAndTuple,
	  "syntax-top-level-await": lib$8,
	  "proposal-dynamic-import": proposalDynamicImport,
	  "proposal-export-namespace-from": proposalExportNamespaceFrom,
	  "proposal-json-strings": proposalJsonStrings,
	  "proposal-logical-assignment-operators": proposalLogicalAssignmentOperators,
	  "proposal-nullish-coalescing-operator": proposalNullishCoalescingOperator,
	  "proposal-numeric-separator": proposalNumericSeparator,
	  "proposal-optional-chaining": proposalOptionalChaining,
	  "proposal-private-methods": proposalPrivateMethods,
	  "proposal-private-property-in-object": proposalPrivatePropertyInObject,
	  "proposal-throw-expressions": proposalThrowExpressions,
	  "proposal-unicode-property-regex": proposalUnicodePropertyRegex
	};

	const scriptTypes = ["text/jsx", "text/babel"];
	let headEl;
	let inlineScriptCount = 0;

	function transformCode(transformFn, script) {
	  let source;

	  if (script.url != null) {
	    source = script.url;
	  } else {
	    source = "Inline Babel script";
	    inlineScriptCount++;

	    if (inlineScriptCount > 1) {
	      source += " (" + inlineScriptCount + ")";
	    }
	  }

	  return transformFn(script.content, buildBabelOptions(script, source)).code;
	}

	function buildBabelOptions(script, filename) {
	  let presets = script.presets;

	  if (!presets) {
	    if (script.type === "module") {
	      presets = ["react", ["env", {
	        targets: {
	          esmodules: true
	        },
	        modules: false
	      }]];
	    } else {
	      presets = ["react", "env"];
	    }
	  }

	  return {
	    filename,
	    presets,
	    plugins: script.plugins || ["proposal-class-properties", "proposal-object-rest-spread", "transform-flow-strip-types"],
	    sourceMaps: "inline",
	    sourceFileName: filename
	  };
	}

	function run(transformFn, script) {
	  const scriptEl = document.createElement("script");

	  if (script.type) {
	    scriptEl.setAttribute("type", script.type);
	  }

	  scriptEl.text = transformCode(transformFn, script);
	  headEl.appendChild(scriptEl);
	}

	function load(url, successCallback, errorCallback) {
	  const xhr = new XMLHttpRequest();
	  xhr.open("GET", url, true);

	  if ("overrideMimeType" in xhr) {
	    xhr.overrideMimeType("text/plain");
	  }

	  xhr.onreadystatechange = function () {
	    if (xhr.readyState === 4) {
	      if (xhr.status === 0 || xhr.status === 200) {
	        successCallback(xhr.responseText);
	      } else {
	        errorCallback();
	        throw new Error("Could not load " + url);
	      }
	    }
	  };

	  return xhr.send(null);
	}

	function getPluginsOrPresetsFromScript(script, attributeName) {
	  const rawValue = script.getAttribute(attributeName);

	  if (rawValue === "") {
	    return [];
	  }

	  if (!rawValue) {
	    return null;
	  }

	  return rawValue.split(",").map(item => item.trim());
	}

	function loadScripts(transformFn, scripts) {
	  const result = [];
	  const count = scripts.length;

	  function check() {
	    let script, i;

	    for (i = 0; i < count; i++) {
	      script = result[i];

	      if (script.loaded && !script.executed) {
	        script.executed = true;
	        run(transformFn, script);
	      } else if (!script.loaded && !script.error && !script.async) {
	        break;
	      }
	    }
	  }

	  scripts.forEach((script, i) => {
	    const scriptData = {
	      async: script.hasAttribute("async"),
	      type: script.getAttribute("data-type"),
	      error: false,
	      executed: false,
	      plugins: getPluginsOrPresetsFromScript(script, "data-plugins"),
	      presets: getPluginsOrPresetsFromScript(script, "data-presets")
	    };

	    if (script.src) {
	      result[i] = { ...scriptData,
	        content: null,
	        loaded: false,
	        url: script.src
	      };
	      load(script.src, content => {
	        result[i].loaded = true;
	        result[i].content = content;
	        check();
	      }, () => {
	        result[i].error = true;
	        check();
	      });
	    } else {
	      result[i] = { ...scriptData,
	        content: script.innerHTML,
	        loaded: true,
	        url: script.getAttribute("data-module") || null
	      };
	    }
	  });
	  check();
	}

	function runScripts(transformFn, scripts) {
	  headEl = document.getElementsByTagName("head")[0];

	  if (!scripts) {
	    scripts = document.getElementsByTagName("script");
	  }

	  const jsxScripts = [];

	  for (let i = 0; i < scripts.length; i++) {
	    const script = scripts.item(i);
	    const type = script.type.split(";")[0];

	    if (scriptTypes.indexOf(type) !== -1) {
	      jsxScripts.push(script);
	    }
	  }

	  if (jsxScripts.length === 0) {
	    return;
	  }

	  console.warn("You are using the in-browser Babel transformer. Be sure to precompile " + "your scripts for production - https://babeljs.io/docs/setup/");
	  loadScripts(transformFn, jsxScripts);
	}

	const isArray = Array.isArray || (arg => Object.prototype.toString.call(arg) === "[object Array]");

	function loadBuiltin(builtinTable, name) {
	  if (isArray(name) && typeof name[0] === "string") {
	    if (Object.prototype.hasOwnProperty.call(builtinTable, name[0])) {
	      return [builtinTable[name[0]]].concat(name.slice(1));
	    }

	    return;
	  } else if (typeof name === "string") {
	    return builtinTable[name];
	  }

	  return name;
	}

	function processOptions(options) {
	  const presets = (options.presets || []).map(presetName => {
	    const preset = loadBuiltin(availablePresets, presetName);

	    if (preset) {
	      if (isArray(preset) && typeof preset[0] === "object" && Object.prototype.hasOwnProperty.call(preset[0], "buildPreset")) {
	        preset[0] = { ...preset[0],
	          buildPreset: preset[0].buildPreset
	        };
	      }
	    } else {
	      throw new Error(`Invalid preset specified in Babel options: "${presetName}"`);
	    }

	    return preset;
	  });
	  const plugins = (options.plugins || []).map(pluginName => {
	    const plugin = loadBuiltin(availablePlugins, pluginName);

	    if (!plugin) {
	      throw new Error(`Invalid plugin specified in Babel options: "${pluginName}"`);
	    }

	    return plugin;
	  });
	  return {
	    babelrc: false,
	    ...options,
	    presets,
	    plugins
	  };
	}

	function transform(code, options) {
	  return transform$3(code, processOptions(options));
	}
	function transformFromAst(ast, code, options) {
	  return transformFromAst$1(ast, code, processOptions(options));
	}
	const availablePlugins = {};
	const availablePresets = {};
	const buildExternalHelpers = babelBuildExternalHelpers;
	function registerPlugin(name, plugin) {
	  if (Object.prototype.hasOwnProperty.call(availablePlugins, name)) {
	    console.warn(`A plugin named "${name}" is already registered, it will be overridden`);
	  }

	  availablePlugins[name] = plugin;
	}
	function registerPlugins(newPlugins) {
	  Object.keys(newPlugins).forEach(name => registerPlugin(name, newPlugins[name]));
	}
	function registerPreset(name, preset) {
	  if (Object.prototype.hasOwnProperty.call(availablePresets, name)) {
	    if (name === "env") {
	      console.warn("@babel/preset-env is now included in @babel/standalone, please remove @babel/preset-env-standalone");
	    } else {
	      console.warn(`A preset named "${name}" is already registered, it will be overridden`);
	    }
	  }

	  availablePresets[name] = preset;
	}
	function registerPresets(newPresets) {
	  Object.keys(newPresets).forEach(name => registerPreset(name, newPresets[name]));
	}
	registerPlugins(all);
	registerPresets({});
	const version = "7.17.6";

	function onDOMContentLoaded() {
	  transformScriptTags();
	}

	if (typeof window !== "undefined" && window?.addEventListener) {
	  window.addEventListener("DOMContentLoaded", onDOMContentLoaded, false);
	}

	function transformScriptTags(scriptTags) {
	  runScripts(transform, scriptTags);
	}
	function disableScriptTags() {
	  window.removeEventListener("DOMContentLoaded", onDOMContentLoaded);
	}

	exports.availablePlugins = availablePlugins;
	exports.availablePresets = availablePresets;
	exports.buildExternalHelpers = buildExternalHelpers;
	exports.disableScriptTags = disableScriptTags;
	exports.registerPlugin = registerPlugin;
	exports.registerPlugins = registerPlugins;
	exports.registerPreset = registerPreset;
	exports.registerPresets = registerPresets;
	exports.transform = transform;
	exports.transformFromAst = transformFromAst;
	exports.transformScriptTags = transformScriptTags;
	exports.version = version;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
